/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
* Script de função PLPGSQL
*
* URBEM Soluções de Gestão Pública Ltda
* www.urbem.cnm.org.br
*
* $Revision: 3077 $
* $Name$
* $Author: pablo $
* $Date: 2005-11-29 14:53:37 -0200 (Ter, 29 Nov 2005) $
*
* Casos de uso: uc-01.03.91
*/

CREATE OR REPLACE FUNCTION busca_configuracao(varchar,varchar,integer) RETURNS VARCHAR AS '
DECLARE
    stExercicio         ALIAS FOR $1;
    stParametro         ALIAS FOR $2;
    inCodModulo         ALIAS FOR $3;
    stOut               VARCHAR;

BEGIN
    SELECT INTO 
               stOut
               administracao.configuracao.valor
          FROM administracao.configuracao 
         WHERE administracao.configuracao.cod_modulo = inCodModulo
           AND administracao.configuracao.parametro  = stParametro
           AND administracao.configuracao.exercicio  = stExercicio;

    IF NOT FOUND THEN
        stOut := NULL;
    END IF;
        
    RETURN stOut;
END;
'language 'plpgsql';
