/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
* Script de função PLPGSQL
*
* URBEM Soluções de Gestão Pública Ltda
* www.urbem.cnm.org.br
*
* $Revision: 3077 $
* $Name$
* $Author: pablo $
* $Date: 2005-11-29 14:53:37 -0200 (Ter, 29 Nov 2005) $
*
* Casos de uso: uc-01.01.00
*/

CREATE OR REPLACE FUNCTION publico.fn_codigo_superior(varchar) RETURNS varchar AS '
DECLARE
   stString        ALIAS FOR $1;
    stSuperior      varchar := '''';

BEGIN

    SELECT
        CASE WHEN publico.fn_strcount (cast(estrutural as varchar),''.'') > 1 THEN
            publico.fn_mascarareduzida( substr( estrutural, 1, publico.fn_lposition(estrutural,''.'')-1 ) )
        ELSE
            publico.fn_mascarareduzida(estrutural)
        END INTO stSuperior
    FROM (
        SELECT
            publico.fn_mascarareduzida(cast ( stString as varchar)) as estrutural
    ) as tabela;


RETURN stSuperior;
END;
' LANGUAGE 'plpgsql';
