/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
CREATE OR REPLACE FUNCTION empenhoanulacaoliquidacaorestosapagarexercicio(character varying, numeric, character varying, integer, character varying, integer, integer, character varying, character varying) RETURNS INTEGER AS $$ DECLARE
   EXERCICIO ALIAS FOR $1;
   VALOR ALIAS FOR $2;
   COMPLEMENTO ALIAS FOR $3;
   CODLOTE ALIAS FOR $4;
   TIPOLOTE ALIAS FOR $5;
   CODENTIDADE ALIAS FOR $6;
   CODNOTA ALIAS FOR $7;
   EXERCRP ALIAS FOR $8;
   EXERCLIQUIDACAO ALIAS FOR $9;

   RESTOS VARCHAR := '';
   SEQUENCIA INTEGER;
BEGIN
   RESTOS := PEGAEMPENHOLIQUIDACAORESTOS( EXERCLIQUIDACAO , CODNOTA , CODENTIDADE );
   IF RESTOS = 'Executivo' THEN
       IF EXERCRP = 1994 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020100', '212160202020100', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1995 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020200', '212160202020200', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1996 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020300', '212160202020300', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1997 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020400', '212160202020400', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1998 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020500', '212160202020500', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1999 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020600', '212160202020600', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2000 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020700', '212160202020700', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2001 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020800', '212160202020800', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2002 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200020900', '212160202020900', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2003 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021000', '212160202021000', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2004 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021100', '212160202021100', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2005 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021200', '212160202021200', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2006 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021300', '212160202021300', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2007 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021400', '212160202021400', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2008 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021500', '212160202021500', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2009 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021600', '212160202021600', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2010 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021700', '212160202021700', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2011 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200021800', '212160202021800', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;

   END IF;
   IF RESTOS = 'Legislativo' THEN
       IF EXERCRP = 1994 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030100', '212160202030100', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1995 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030200', '212160202030200', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1996 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030300', '212160202030300', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1997 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030400', '212160202030400', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1998 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030500', '212160202030500', 919, COMPLEMENTO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1999 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030600', '212160202030600', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2000 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030700', '212160202030700', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2001 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030800', '212160202030800', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2002 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200030900', '212160202030900', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2003 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031000', '212160202031000', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2004 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031100', '212160202031100', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2005 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031200', '212160202031200', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2006 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031300', '212160202031300', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2007 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031400', '212160202031400', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2008 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031500', '212160202031500', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2009 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031600', '212160202031600', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2010 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031700', '212160202031700', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2011 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200031800', '212160202031800', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;

   END IF;
   IF RESTOS = 'RPPS' THEN
       IF EXERCRP = 1994 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040100', '212160202040100', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1995 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040200', '212160202040200', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1996 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040300', '212160202040300', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1997 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040400', '212160202040400', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1998 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040500', '212160202040500', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 1999 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040600', '212160202040600', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2000 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040700', '212160202040700', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2001 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040800', '212160202040800', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2002 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200040900', '212160202040900', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2003 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041000', '212160202041000', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2004 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041100', '212160202041100', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2005 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041200', '212160202041200', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2006 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041300', '212160202041300', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2007 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041400', '212160202041400', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2008 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041500', '212160202041500', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2009 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041600', '212160202041600', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2010 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041700', '212160202041700', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
       IF EXERCRP = 2011 THEN
           SEQUENCIA := FAZERLANCAMENTO('212110200041800', '212160202041800', 919, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
       END IF;
	 
   END IF;

   RETURN SEQUENCIA;
END;

$$ LANGUAGE 'plpgsql';
