/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
CREATE OR REPLACE FUNCTION  empenhoanulacaopagamentorpliquidadoexercicio(character varying, numeric, character varying, integer, character varying, integer, integer, character varying, character varying) RETURNS INTEGER AS $$

   DECLARE
   EXERCICIO ALIAS FOR $1;
   VALOR ALIAS FOR $2;
   COMPLEMENTO ALIAS FOR $3;
   CODLOTE ALIAS FOR $4;
   TIPOLOTE ALIAS FOR $5;
   CODENTIDADE ALIAS FOR $6;
   CODNOTA ALIAS FOR $7;
   CONTAPG ALIAS FOR $8;
   EXERCRP ALIAS FOR $9;

   RESTOS VARCHAR := '';
   SEQUENCIA INTEGER;

BEGIN
    RESTOS := PEGAEMPENHOLIQUIDACAORESTOS( EXERCRP, CODNOTA, CODENTIDADE );
    IF RESTOS = 'Executivo' THEN
        IF EXERCRP = 1994 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020100', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1995 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020200', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1996 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020300', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1997 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020400', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1998 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020500', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1999 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020600', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2000 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020700', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2001 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020800', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2002 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200020900', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2003 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021000', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2004 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021100', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2005 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021200', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2006 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021300', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2007 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021400', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2008 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021500', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2009 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021600', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2010 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021700', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2011 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200021800', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
    END IF;
    IF RESTOS = 'Legislativo' THEN
        IF EXERCRP = 1994 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030100', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1995 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030200', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1996 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030300', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1997 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030400', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1998 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030500', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1999 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030600', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2000 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030700', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2001 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030800', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2002 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200030900', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2003 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031000', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2004 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031100', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2005 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031200', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2006 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031300', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2007 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031400', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2008 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031500', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2009 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031600', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2010 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031700', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2011 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200031800', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
    END IF;
    IF RESTOS = 'RPPS' THEN
        IF EXERCRP = 1994 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040100', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1995 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040200', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1996 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040300', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1997 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040400', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1998 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040500', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 1999 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040600', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2000 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040700', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2001 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040800', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2002 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200040900', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2003 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041000', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2004 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041100', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2005 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041200', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2006 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041300', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2007 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041400', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2008 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041500', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2009 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041600', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2010 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041700', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
        IF EXERCRP = 2011 THEN
            SEQUENCIA := FAZERLANCAMENTO( CONTAPG, '212110200041800', 920, EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE );
        END IF;
    END IF;
    RETURN SEQUENCIA;
END;
$$ LANGUAGE 'plpgsql';
