/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
CREATE OR REPLACE FUNCTION empenhoemissaomodalidadeslicitacao(character varying, numeric, character varying, integer, character varying, integer, integer) RETURNS INTEGER AS $$
DECLARE
    EXERCICIO       ALIAS FOR $1;
    VALOR           ALIAS FOR $2;
    COMPLEMENTO     ALIAS FOR $3;
    CODLOTE         ALIAS FOR $4;
    TIPOLOTE        ALIAS FOR $5;
    CODENTIDADE     ALIAS FOR $6;
    CODPREEMPENHO   ALIAS FOR $7;

    MODALIDADE VARCHAR := '';
    SEQUENCIA INTEGER;
BEGIN
    MODALIDADE := PEGAEMPENHOEMPENHOMODALIDADE(  EXERCICIO , CODPREEMPENHO  );
    MODALIDADE := sem_acentos(MODALIDADE);

    IF EXERCICIO::integer = 2013 THEN
        IF   MODALIDADE  =  'Concurso' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920401' , '622920401' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Convite' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920402' , '622920402' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Tomada' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920403' , '622920403' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Concorrencia' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920404' , '622920404' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Dispensa' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920406' , '622920406' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Inexigivel' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920407' , '622920407' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Nao Aplicavel' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920408' , '622920408' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Suprimentos' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920409' , '622920409' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Consulta' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920411' , '622920411' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Pregao Presencial' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920412' , '622920412' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Pregao Eletronico' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '522920412' , '622920412' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
    END IF;
    
    IF EXERCICIO::INTEGER <= 2012 THEN
        IF   MODALIDADE  =  'Concurso' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410201000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410201000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Convite' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410202000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410202000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Tomada' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410203000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410203000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Concorrencia' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410204000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410204000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Dispensa' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410206000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410206000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Inexigivel' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410207000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410207000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Nao Aplicavel' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410208000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410208000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Suprimentos' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410209000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410209000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Integracao' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410210000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410210000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Pregao' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410212000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410212000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Pregao Presencial' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410212000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410212000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Pregao Eletronico' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410212000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410212000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Chamada Publica' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410213000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410213000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
        IF   MODALIDADE  =  'Registro de Precos' THEN
           SEQUENCIA := FAZERLANCAMENTO(  '192410214000000' , '292410101000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
           SEQUENCIA := FAZERLANCAMENTO(  '292419900000000' , '292410214000000' , 901 , EXERCICIO , VALOR , COMPLEMENTO , CODLOTE , TIPOLOTE , CODENTIDADE  );
        END IF;
    END IF;

    RETURN SEQUENCIA;
END;
$$ LANGUAGE 'plpgsql';
