/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
CREATE OR REPLACE FUNCTION public.empenhoestornorestosapagarexercicio (character varying, numeric, character varying, integer, character varying, integer, integer, character varying ) returns integer as $$ 
DECLARE
   EXERCICIO     ALIAS FOR $1;
   VALOR         ALIAS FOR $2;
   COMPLEMENTO   ALIAS FOR $3;
   CODLOTE       ALIAS FOR $4;
   TIPOLOTE      ALIAS FOR $5;
   CODENTIDADE   ALIAS FOR $6;
   CODPREEMPENHO ALIAS FOR $7;
   EXERCRP       ALIAS FOR $8;

   RESTOS VARCHAR := '';
   SEQUENCIA INTEGER;
BEGIN
   RESTOS := PEGAEMPENHOEMPENHORESTOS( EXERCRP , CODPREEMPENHO );
   IF RESTOS = 'Executivo' THEN
      IF EXERCRP = 1994 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020100', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1995 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020200', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1996 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020300', '623310500000000', 918,EXERCICIO, VALOR ,COMPLEMENTO ,CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1997 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020400', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1998 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020500', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1999 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020600', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2000 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020700', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2001 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020800', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2002 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202020900', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2003 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021000', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2004 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021100', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2005 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021200', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2006 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021300', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2007 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021400', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2008 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021500', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2009 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021600', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2010 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021700', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2011 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202021800', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;

   END IF;

   IF RESTOS = 'Legislativo' THEN
      IF EXERCRP = 1994 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030100', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1995 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030200', '623310500000000', 918,'' || EXERCICIO || '', VALOR, '' || COMPLEMENTO || '', CODLOTE, '' || TIPOLOTE || '', CODENTIDADE);
      END IF;
      IF EXERCRP = 1996 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030300', '623310500000000', 918,'' || EXERCICIO || '', VALOR, '' || COMPLEMENTO || '', CODLOTE, '' || TIPOLOTE || '', CODENTIDADE);
      END IF;
      IF EXERCRP = 1997 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030400', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1998 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030500', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1999 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030600', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2000 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030700', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2001 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030800', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2002 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202030900', '623310500000000', 918,'' || EXERCICIO || '', VALOR, '' || COMPLEMENTO || '', CODLOTE, '' || TIPOLOTE || '', CODENTIDADE);
      END IF;
      IF EXERCRP = 2003 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031000', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2004 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031100', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2005 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031200', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2006 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031300', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2007 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031400', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2008 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031500', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2009 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031600', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2010 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031700', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2011 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202031800', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;


   END IF;

   IF RESTOS = 'RPPS' THEN
      IF EXERCRP = 1994 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040100', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1995 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040200', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1996 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040300', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1997 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040400', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1998 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040500', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 1999 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040600', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2000 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040700', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2001 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040800', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2002 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202040900', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2003 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041000', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2004 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041100', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2005 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041200', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2006 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041300', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2007 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041400', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2008 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041500', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2009 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041600', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2010 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041700', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;
      IF EXERCRP = 2011 THEN
         SEQUENCIA := FAZERLANCAMENTO('212160202041800', '623310500000000', 918,EXERCICIO, VALOR, COMPLEMENTO, CODLOTE, TIPOLOTE, CODENTIDADE);
      END IF;

   END IF;
   RETURN SEQUENCIA;
END;
$$ language 'plpgsql';
