/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.01.2
*
* Fabio Bertoldi - 20121109
*
*/

----------------
-- Ticket #19773
----------------

ALTER TABLE patrimonio.apolice ADD COLUMN dt_assinatura     DATE;
ALTER TABLE patrimonio.apolice ADD COLUMN inicio_vigencia   DATE;
ALTER TABLE patrimonio.apolice ADD COLUMN valor_apolice     NUMERIC(14,2);
ALTER TABLE patrimonio.apolice ADD COLUMN valor_franquia    NUMERIC(14,2);
ALTER TABLE patrimonio.apolice ADD COLUMN observacoes       TEXT;
ALTER TABLE patrimonio.apolice ADD COLUMN nome_arquivo      VARCHAR(80);


----------------
-- Ticket #19752
----------------

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo )
  VALUES
  ( 2848
  , 330
  , 'FLManterPenalidadeFornecedor.php'
  , 'excluir'
  , 7
  , ''
  , 'Excluir Penalidades de Fornecedor'
  , TRUE
  );


----------------
-- Ticket #19740
----------------

ALTER TABLE frota.veiculo ADD COLUMN num_passageiro    INTEGER;
ALTER TABLE frota.veiculo ADD COLUMN capacidade_tanque INTEGER;


----------------
-- Ticket #19746
----------------

INSERT
  INTO administracao.funcionalidade
  ( cod_funcionalidade
  , cod_modulo
  , nom_funcionalidade
  , nom_diretorio
  , ordem
  , ativo
  )
  VALUES
  ( 477
  , 7
  , 'Infração'
  , 'instancias/infracao/'
  , 20
  , TRUE
  );

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2855
  , 477
  , 'FMManterInfracao.php'
  , 'incluir'
  , 1
  , ''
  , 'Incluir Infração'
  , TRUE
  );

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2856
  , 477
  , 'FLManterInfracao.php'
  , 'alterar'
  , 2
  , ''
  , 'Alterar Infração'
  , TRUE
  );

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2857
  , 477
  , 'FLManterInfracao.php'
  , 'excluir'
  , 3
  , ''
  , 'Excluir Infração'
  , TRUE
  );

CREATE TABLE frota.motivo_infracao (
    cod_infracao        INTEGER         NOT NULL,
    descricao           VARCHAR(100)    NOT NULL,
    base_legal          VARCHAR(20)     NOT NULL,
    gravidade           VARCHAR(20)     NOT NULL,
    responsabilidade    VARCHAR(20)     NOT NULL,
    competencia         VARCHAR(20)     NOT NULL,
    pontos              INTEGER         NOT NULL,
    valor               NUMERIC(14,2)   NOT NULL,
    CONSTRAINT pk_motivo_infracao       PRIMARY KEY (cod_infracao)
);
GRANT ALL ON frota.motivo_infracao TO siamweb;

CREATE TABLE frota.infracao (
    id                  INTEGER         NOT NULL,
    auto_infracao       VARCHAR(15)     NOT NULL,
    data_infracao       DATE            NOT NULL,
    cod_veiculo         INTEGER         NOT NULL,
    cgm_motorista       INTEGER         NOT NULL,
    cod_infracao        INTEGER         NOT NULL,
    CONSTRAINT pk_infracao              PRIMARY KEY                     (id),
    CONSTRAINT fk_infracao_1            FOREIGN KEY                     (cod_veiculo)
                                        REFERENCES frota.veiculo        (cod_veiculo),
    CONSTRAINT fk_infracao_2            FOREIGN KEY                     (cgm_motorista)
                                        REFERENCES frota.motorista      (cgm_motorista),
    CONSTRAINT fk_infracao_3            FOREIGN KEY                     (cod_infracao)
                                        REFERENCES frota.motivo_infracao(cod_infracao)
);
GRANT ALL ON frota.infracao TO siamweb;


INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50100, RTRIM('Dirigir veiculo s/ possuir cnh ou permissao para dirigir         '), RTRIM('Art 162, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50290, RTRIM('Dirigir veiculo c/ cnh ou permissao p/ dirigir cassada           '), RTRIM('Art 162, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50370, RTRIM('Dirigir veic c/ cnh ou permissao p/dirigir categ diferente       '), RTRIM('Art 162, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50450, RTRIM('Dirigir veic c/ validade de cnh vencida ha mais de 30 dias       '), RTRIM('Art 162, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50530, RTRIM('Dirigir s/ usar lentes, apar, etc impostas pela licenca          '), RTRIM('Art 162, vi        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50610, RTRIM('Entregar direc veic pessoa s/ cnh/permissao p/ dirigir           '), RTRIM('Art 163            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50700, RTRIM('Entregar direc veic pessoa c/ cnh/permissao cassada              '), RTRIM('Art 163            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50880, RTRIM('Entregar direc veic pessoa cnh/permissao cat diferente           '), RTRIM('Art 163            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (50960, RTRIM('Entregar direc veic pessoa cnh/permissao vencida + 30dias        '), RTRIM('Art 163            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51000, RTRIM('Entregar direc veic pessoa s/ lentes,etc impostas licenca        '), RTRIM('Art 163            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51180, RTRIM('Permitir tome posse veic pessoa s/ cnh permissao p/dirigir       '), RTRIM('Art 164            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51260, RTRIM('Permitir tome posse veic pessoa c/ cnh/permissao cassada         '), RTRIM('Art 164            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51340, RTRIM('Permitir tome posse veic pessoa cnh/permissao cat diferent       '), RTRIM('Art 164            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51420, RTRIM('Permitir tome posse veic pessoa cnh/permissao venc + 30dia       '), RTRIM('Art 164            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51500, RTRIM('Permitir tome posse veic pessoa s/ lentes,etc impostas lic       '), RTRIM('Art 164            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51690, RTRIM('Dirigir sob influencia alcool nivel sup. ou entorpecente         '), RTRIM('Art 165            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51770, RTRIM('Entregar veic a pessoa nao estiver condicoes de dirigir          '), RTRIM('Art 166            '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51850, RTRIM('Deixar o condutor/passageiro de usar o cinto de seguranca        '), RTRIM('Art 167            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (51930, RTRIM('Transportar criancas em veic s/ observar normas                  '), RTRIM('Art 168            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52070, RTRIM('Dirigir sem os cuidados indispensaveis a seguranca               '), RTRIM('Art 169            '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52150, RTRIM('Dirigir ameacando pedestres estejam na via publica               '), RTRIM('Art 170            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52230, RTRIM('Usar veic para arremessar sobre pedestres agua, etc              '), RTRIM('Art 171            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52310, RTRIM('Atirar ou abandonar na via objetos ou substancias                '), RTRIM('Art 172            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52400, RTRIM('Disputar corrida por espirito de emulacao                        '), RTRIM('Art 173            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52580, RTRIM('Promover na via competicao, eventos, etc s/ permissao            '), RTRIM('Art 174            '), RTRIM('Gravíssima'), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52660, RTRIM('Participar na via como condutor de competicao, eventos           '), RTRIM('Art 174            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52740, RTRIM('Utilizar-se de veic p/ demonstrar manobra perigosa               '), RTRIM('Art 175font>       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52820, RTRIM('Em acidente, nao prestar socorro a vitima                        '), RTRIM('Art 176, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (52900, RTRIM('Em acidente, nao adotar providencias p/ evitar perigo            '), RTRIM('Art 176, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53040, RTRIM('Em acidente, nao preservar o local p/ facilitar trabalho         '), RTRIM('Art 176, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53120, RTRIM('Em acidente, nao adotar providencias p/ remover veic             '), RTRIM('Art 176, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53200, RTRIM('Em acidente, nao identificar-se ao policial                      '), RTRIM('Art 176, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53390, RTRIM('Deixar o condutor de prestar socorro a vitima qdo solic          '), RTRIM('Art 177            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53470, RTRIM('Deixar de remover veiculo envolvido em acidente sem vitima       '), RTRIM('Art 178            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53550, RTRIM('Reparar veic em rod e via trans rapido qdo poss remocao          '), RTRIM('Art 179, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53630, RTRIM('Reparar veiculo nas demais vias quando possivel remocao          '), RTRIM('Art 179, ii        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53710, RTRIM('veiculo imobilizado na via por falta de combustivel              '), RTRIM('Art 180            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53800, RTRIM('Estacionar a menos de 5m do alinhamento da via transversal       '), RTRIM('Art 181, i         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (53980, RTRIM('Estacionar afastado da guia de 50cm a 1m                         '), RTRIM('Art 181, ii        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54010, RTRIM('Estacionar afastado da guia a mais de 1m                         '), RTRIM('Art 181, iii       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54100, RTRIM('Estacionar em desacordo com o estabelecido pelo codigo           '), RTRIM('Art 181, iv        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54280, RTRIM('Estacionar na pista de rolamento das vias com acostamento        '), RTRIM('Art 181, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54360, RTRIM('Estacionar veic junto a hidrantes, registros, etc                '), RTRIM('Art 181, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54361, RTRIM('Estacionar junto/sobre hidrante                                  '), RTRIM('Art 181, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54362, RTRIM('Estacionar junto/sobre registro de agua                          '), RTRIM('Art 181, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54363, RTRIM('Estacionar junto/sobre tampa de pv de galeria subterranea        '), RTRIM('Art 181, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54440, RTRIM('Estacionar no acostamento                                        '), RTRIM('Art 181, vii       '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54520, RTRIM('Estacionar veic no passeio, faixa de pedestres, etc              '), RTRIM('Art 181, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54521, RTRIM('Estacionar no passeio                                            '), RTRIM('Art 181, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54522, RTRIM('Estacionar sobre faixa de pedestres                              '), RTRIM('Art 181, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54523, RTRIM('Estacionar sobre ciclovia ou ciclo faixa                         '), RTRIM('Art 181, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54524, RTRIM('Estacionar ao lado ou sobre canteiro central, ilhas,etc          '), RTRIM('Art 181, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54525, RTRIM('Estacionar sobre gramado ou jardim publico                       '), RTRIM('Art 181, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54600, RTRIM('Estacionar diante guia rebaixada entrada/saida veiculos          '), RTRIM('Art 181, ix        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54790, RTRIM('Estacionar impedindo movimentacao de outro veiculo               '), RTRIM('Art 181, x         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54870, RTRIM('Estacionar ao lado de outro veiculo(fila dupla)                  '), RTRIM('Art 181, xi        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (54950, RTRIM('Estacionar no cruzamento prejudicando circ veic/pedestres        '), RTRIM('Art 181, xii       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55090, RTRIM('Estacionar junto ponto emb/desemb transporte coletivo            '), RTRIM('Art 181, xiii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55170, RTRIM('Estacionar o veiculo nos viadutos, pontes e tuneis               '), RTRIM('Art 181, xiv       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55171, RTRIM('Estacionar veiculo em viaduto                                    '), RTRIM('Art 181, xiv       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55172, RTRIM('Estacionar veiculo em ponte                                      '), RTRIM('Art 181, xiv       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55173, RTRIM('Estacionar veiculo em tunel                                      '), RTRIM('Art 181, xiv       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55250, RTRIM('Estacionar o veiculo na contramao de direcao                     '), RTRIM('Art 181, xv        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55330, RTRIM('Estacionar em aclive/declive s/ calco (veic acima 3500kg)        '), RTRIM('Art 181, xvi       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55410, RTRIM('Estacionar em desacordo com a regulamentacao                     '), RTRIM('Art 181, xvii      '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55500, RTRIM('Estacionar em local/horario proibidos pela sinalizacao           '), RTRIM('Art 181, xviii     '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55680, RTRIM('Estacionar em local/hora com sinaliz proibido parada/estac       '), RTRIM('Art 181, xix       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55760, RTRIM('Parar a menos de 5m do alinhamento da via transversal            '), RTRIM('Art 182, i         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55840, RTRIM('Parar afastado da guia de 50cm a 1m                              '), RTRIM('Art 182, ii        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (55920, RTRIM('Parar afastado da guia a mais de 1m                              '), RTRIM('Art 182, iii       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56060, RTRIM('Parar em desacordo com estabelecido pelo codigo                  '), RTRIM('Art 182, iv        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56140, RTRIM('Parar na pista de rolamento das vias com acostamento             '), RTRIM('Art 182, v         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56220, RTRIM('Parar veic no passeio ou faixa de pedestres, etc                 '), RTRIM('Art 182, vi        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56221, RTRIM('Parar no passeio                                                 '), RTRIM('Art 182, vi        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56222, RTRIM('Parar sobre a faixa de pedestre                                  '), RTRIM('Art 182, vi        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56223, RTRIM('Parar em ilhas, canteiro central e marcas de canalizacao         '), RTRIM('Art 182, vi        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56300, RTRIM('Parar na area cruzamento prejud circ veiculos/pedestres          '), RTRIM('Art 182, vii       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56490, RTRIM('Parar veic nos viadutos, pontes e tuneis                         '), RTRIM('Art 182, viii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56491, RTRIM('Parar veiculo em viadutos                                        '), RTRIM('Art 182, viii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56492, RTRIM('Parar veiculo em pontes                                          '), RTRIM('Art 182, viii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56493, RTRIM('Parar veiculo em tuneis                                          '), RTRIM('Art 182, viii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56570, RTRIM('Parar veiculo na contramao de direcao                            '), RTRIM('Art 182, ix        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56650, RTRIM('Parar em local/hora proibido pela sinalizacao                    '), RTRIM('Art 182, x         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56730, RTRIM('Parar sobre faixa de pedestre na mudanca de semaforo(elet)       '), RTRIM('Art 183            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56731, RTRIM('Parar veic sobre fx de pedestre mudanca de semaforo              '), RTRIM('Art 183            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56810, RTRIM('Transitar c/ veic na faixa direita de circulacao exclusiva       '), RTRIM('Art 184, i         '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (56900, RTRIM('Transitar c/veic na faixa esquerda de circulacao exclusiva       '), RTRIM('Art 184, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57030, RTRIM('Qdo veic em mov deixar de conserva-lo faixa destinada            '), RTRIM('Art 185, i         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57110, RTRIM('Qdo veic lento deixar de conserva-lo nas faixas da direita       '), RTRIM('Art 185, ii        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57200, RTRIM('Transitar pela contramao em vias de duplo sentido                '), RTRIM('Art 186, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57380, RTRIM('Transitar pela contramao vias c/ sinaliz sentido unico           '), RTRIM('Art 186, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57460, RTRIM('Transitar local/horario nao permitido                            '), RTRIM('Art 187, i         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57540, RTRIM('Transitar local/horario nao permitido para caminhoes,onib        '), RTRIM('Art 187, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57620, RTRIM('Transitar ao lado de outro veic interrompendo o transito         '), RTRIM('Art 188            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57700, RTRIM('Deixar de dar passagem veic socorro, de incendio e salvam        '), RTRIM('Art 189            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57701, RTRIM('Não dar passagem a veiculo precedido batedores                   '), RTRIM('Art 189            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57702, RTRIM('Não dar passagem a veic de socorro incendio/salvamento           '), RTRIM('Art 189            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57703, RTRIM('Não dar passagem a veiculo de policia                            '), RTRIM('Art 189            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57704, RTRIM('Não dar passagem a veic oper e fiscal de transito                '), RTRIM('Art 189            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57705, RTRIM('Não dar passagem a ambulancias                                   '), RTRIM('Art 189            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57890, RTRIM('Seguir veic em servico de urgencia c/prioridade passagem         '), RTRIM('Art 190            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (57970, RTRIM('Forcar passagem entre veiculos trans sentido oposto              '), RTRIM('Art 191            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58000, RTRIM('Deixar de guardar dist lat e frontal entre veic ou bordo         '), RTRIM('Art 192            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58190, RTRIM('Transitar c/ o veic em calcadas, passeios, passarelas            '), RTRIM('Art 193            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58191, RTRIM('Transitar em calcadas, passeios e passarelas                     '), RTRIM('Art 193            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58192, RTRIM('Transitar em ciclovias/ciclofaixas                               '), RTRIM('Art 193            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58193, RTRIM('Transitar em ajardinamentos, gramados e jardins publicos         '), RTRIM('Art 193            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58194, RTRIM('Transitar em canteiro central/acostamento/marca canalizac        '), RTRIM('Art 193            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58270, RTRIM('Transitar em marcha a re salvo em pequenas manobras              '), RTRIM('Art 194            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58350, RTRIM('Desobedecer ordem da autoridade/agente de transito               '), RTRIM('Art 195            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58430, RTRIM('Deixar de indicar mediante gesto realizacao de manobra           '), RTRIM('Art 196            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58431, RTRIM('Não fazer sinal braco/luminoso antes de iniciar marcha           '), RTRIM('Art 196            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58432, RTRIM('Não fazer sinal braco/luminoso antes de parar veiculo            '), RTRIM('Art 196            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58433, RTRIM('Não fazer sinal braco/luminoso antes de mudar de direcao         '), RTRIM('Art 196            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58434, RTRIM('Não fazer sinal braco/luminoso antes de mudar de faixa           '), RTRIM('Art 196            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58510, RTRIM('Deixar de deslocar veic p/ mais esq ou dir qdo manobra           '), RTRIM('Art 197            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58511, RTRIM('Não deslocar veic c/ antecedencia p/ manobrar a esquerda         '), RTRIM('Art 197            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58512, RTRIM('Não deslocar veic c/ antecedencia p/ manobrar a direita          '), RTRIM('Art 197            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58600, RTRIM('Não dar passagem pela esquerda quando solicitado                 '), RTRIM('Art 198            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58780, RTRIM('Ultrapassar pela direita                                         '), RTRIM('Art 199            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58860, RTRIM('Ultrapassar p/dir veic transp col/esc parado p/ emb/desemb       '), RTRIM('Art 200            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (58940, RTRIM('Não guardar distancia lateral ao ultrapassar bicicleta           '), RTRIM('Art 201            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59080, RTRIM('Ultrapassar veiculo pelo acostamento                             '), RTRIM('Art 202, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59160, RTRIM('Ultrapassar veiculo em intersecoes e passagens de nivel          '), RTRIM('Art 202, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59240, RTRIM('Ultrapassar pela contramao veic nas curvas s/ visibilidade       '), RTRIM('Art 203, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59241, RTRIM('Ultrapassar pela contramao em curva sem visibilidade             '), RTRIM('Art 203, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59242, RTRIM('Ultrapassar p/contramao em aclive/declive s/visibilidade         '), RTRIM('Art 203, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59320, RTRIM('Ultrapassar pela contramao na faixa de pedestres                 '), RTRIM('Art 203, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59400, RTRIM('Ultrapassar pela contramao veic nas pontes, viadutos, etc        '), RTRIM('Art 203, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59401, RTRIM('Ultrapassar pela contramao em pontes                             '), RTRIM('Art 203, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59402, RTRIM('Ultrapassar pela contramao em viadutos                           '), RTRIM('Art 203, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59403, RTRIM('Ultrapassar pela contramao em tuneis                             '), RTRIM('Art 203, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59590, RTRIM('ultrap pela contramao veic parado em fila, junto a sinaliz       '), RTRIM('Art 203, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59591, RTRIM('Ultrapassar p/contramao veiculo parado junto a semaforo          '), RTRIM('Art 203, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59592, RTRIM('Ultrapassar p/contramao veiculo parado junto a porteira          '), RTRIM('Art 203, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59593, RTRIM('Ultrapassar p/contramao veiculo parado junto a cancela           '), RTRIM('Art 203, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59594, RTRIM('Ultrapassar p/contramao veiculo parado junto a cruzamento        '), RTRIM('Art 203, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59595, RTRIM('Ultrapassar p/contramao veiculo parado impedindo livre cir       '), RTRIM('Art 203, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59670, RTRIM('Ultrapassar sobre linha dupla/simples amarela continua           '), RTRIM('Art 203, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59750, RTRIM('Não parar no acostamento a dir p/cruzar a pista a esquerda       '), RTRIM('Art 204            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59830, RTRIM('Ultrapassar veiculo de cortejo/desfile/formacoes militares       '), RTRIM('Art 205            '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (59910, RTRIM('Executar retorno em local proibido pela sinalizacao              '), RTRIM('Art 206, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60090, RTRIM('Executar operacao de retorno nas curvas, aclives, etc            '), RTRIM('Art 206, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60091, RTRIM('Executar retorno em curva                                        '), RTRIM('Art 206, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60092, RTRIM('Executar retorno em aclive/declive                               '), RTRIM('Art 206, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60093, RTRIM('Executar retorno em pontes/viadutos/tuneis                       '), RTRIM('Art 206, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60170, RTRIM('Retornar sobre calcada/canteiro/jardim/faixa pedestre            '), RTRIM('Art 206, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60250, RTRIM('Retornar em intersecoes pela contramao da transversal            '), RTRIM('Art 206, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60330, RTRIM('Executar operacao de retorno c/ prejuizo da seguranca            '), RTRIM('Art 206, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60331, RTRIM('Executar retorno com prejuizo da livre circulacao                '), RTRIM('Art 206, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60332, RTRIM('Executar retorno com prejuizo da seguranca                       '), RTRIM('Art 206, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60410, RTRIM('Executar oper de conversao a dir ou a esq locais proibidos       '), RTRIM('Art 207            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60411, RTRIM('Executar conversao a direita em local proibido                   '), RTRIM('Art 207            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60412, RTRIM('Executar conversao a esquerda em local proibido                  '), RTRIM('Art 207            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60500, RTRIM('Avancar o sinal vermelho do semaforo ou de parada                '), RTRIM('Art 208            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60501, RTRIM('Avancar o sinal vermelho do semaforo(eletronico)                 '), RTRIM('Art 208            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60502, RTRIM('Avancar o sinal vermelho do semaforo                             '), RTRIM('Art 208            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60503, RTRIM('Avancar o sinal de parada obrigatoria                            '), RTRIM('Art 208            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60680, RTRIM('Transpor,s/ autorizacao, bloqueio viario c/ ou s/ sinaliz        '), RTRIM('Art 209            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60681, RTRIM('Transpor bloqueio viario                                         '), RTRIM('Art 209            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60682, RTRIM('Não adentrar area destinada a pesagem de veiculo                 '), RTRIM('Art 209            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60683, RTRIM('Evadir-se sem pagar pedagio                                      '), RTRIM('Art 209            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60760, RTRIM('Transpor,s/ autorizacao, bloqueio viario policial                '), RTRIM('Art 210            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60840, RTRIM('Ultrapassar veiculos parados em semaforo/cancela/bloqueio        '), RTRIM('Art 211            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal/Estadual              '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (60920, RTRIM('Não parar antes de transpor linha ferrea                         '), RTRIM('Art 212            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61060, RTRIM('Não parar quando interceptado por agrupamentos de pessoas        '), RTRIM('Art 213, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61140, RTRIM('Não parar quando interceptado por agrupamentos de veiculos       '), RTRIM('Art 213, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61220, RTRIM('Deixar de dar preferencia em faixa destinada a pedestre          '), RTRIM('Art 214, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61221, RTRIM('Não dar preferencia a pedestres na faixa destinada               '), RTRIM('Art 214, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61222, RTRIM('Não dar pref a veic nao motorizado na faixa destinada            '), RTRIM('Art 214, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61300, RTRIM('Deixar de dar pref a pedestre que nao concluiu travessia         '), RTRIM('Art 214, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61301, RTRIM('Não dar preferencia a pedestre que nao conclui travessia         '), RTRIM('Art 214, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61302, RTRIM('Não dar preferencia a veic nao motorizado nao concluiu tra       '), RTRIM('Art 214, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61490, RTRIM('Deixar de dar prefer a pedestre portador defic fisica            '), RTRIM('Art 214, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61491, RTRIM('Não dar preferencia a deficiente/crianca/idoso/gestante          '), RTRIM('Art 214, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61492, RTRIM('Não dar preferencia a veic nao motor c/def/crian/idos/gest       '), RTRIM('Art 214, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61570, RTRIM('Deixar de dar preferencia a pedestre iniciou travessia           '), RTRIM('Art 214, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61571, RTRIM('Não dar preferencia a pedestre qdo iniciada travessia            '), RTRIM('Art 214, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61572, RTRIM('Não dar pref a veic nao motor qdo iniciada travessia             '), RTRIM('Art 214, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61650, RTRIM('Deixar de dar preferencia a pedestre atravessando a via          '), RTRIM('Art 214, v         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61651, RTRIM('Não dar preferencia a pedestre atravessando a transversal        '), RTRIM('Art 214, v         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61652, RTRIM('Não dar pref a veic nao motor atravessando a transversal         '), RTRIM('Art 214, v         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61730, RTRIM('Deixar de dar pref em intersecao nao sinaliz.a veic circul       '), RTRIM('Art 215, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61731, RTRIM('Não dar preferencia a veic circ por rodovia/rotatoria            '), RTRIM('Art 215, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61732, RTRIM('Não dar preferencia a veic vindo da direita                      '), RTRIM('Art 215, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61810, RTRIM('Não dar pref sinalizada de preferencia                           '), RTRIM('Art 215, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (61900, RTRIM('Entrar sair de areas lindeiras s/preocupacao c/a seguranca       '), RTRIM('Art 216            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62030, RTRIM('Entrar/sair fila estac s/dar pref passagem                       '), RTRIM('Art 217            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62110, RTRIM('Trans veloc sup max perm p/rod tran rap/arterial ate 20%         '), RTRIM('Art 218, i a       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62200, RTRIM('Trans veloc sup max perm p/rod tran rap/arterial mais 20%        '), RTRIM('Art 218, i b       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62380, RTRIM('Trans veloc sup max perm p/via em ate 50%                        '), RTRIM('Art 218, ii a      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62460, RTRIM('Trans veloc sup max perm p/via em mais de 50%                    '), RTRIM('Art 218, ii b      '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62540, RTRIM('Transitar com veloc inferior a metade da max p/a via             '), RTRIM('Art 219            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62620, RTRIM('Velocidade incompativel prox passeatas, desfiles etcs            '), RTRIM('Art 220, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62700, RTRIM('Velocidade incompativel em local controlado por agente           '), RTRIM('Art 220, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62890, RTRIM('Velocidade incompativel prox da guia ou acostamento              '), RTRIM('Art 220, iii       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (62970, RTRIM('Velocidade incompativel em intersecao nao sinalizada             '), RTRIM('Art 220, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63000, RTRIM('Velocidade incompativel nas vias rurais                          '), RTRIM('Art 220, v         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63190, RTRIM('Velocidade incompativel em curvas de pequeno raio                '), RTRIM('Art 220, vi        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63270, RTRIM('Velocidade incompativel prox obra/trabalhador na pista           '), RTRIM('Art 220, vii       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63350, RTRIM('Velocidade incompativel sob chuva/neblina/vento forte            '), RTRIM('Art 220, viii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63430, RTRIM('Velocidade incompativel quando houver ma visibilidade            '), RTRIM('Art 220, ix        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63510, RTRIM('Velocidade incompativel qdo pav escorregadio/defeituoso          '), RTRIM('Art 220, x         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63600, RTRIM('Velocidade incompativel a aproximacao de animais na pista        '), RTRIM('Art 220, xi        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63780, RTRIM('Velocidade incompativel em declive                               '), RTRIM('Art 220, xii       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63860, RTRIM('Velocidade incompativel ao ultrapassar ciclista                  '), RTRIM('Art 220, xiii      '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63940, RTRIM('Deixar de reduzir veloc proximo a escolas, etc                   '), RTRIM('Art 220, xiv       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63941, RTRIM('Velocidade incompativel prox a escolas                           '), RTRIM('Art 220, xiv       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63942, RTRIM('Velocidade incompativel prox a hospitais                         '), RTRIM('Art 220, xiv       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63943, RTRIM('Velocidade incompativel prox estacao de emb/desemb passag        '), RTRIM('Art 220, xiv       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (63944, RTRIM('Velocidade incompativel a intensa movimentacao pedestre          '), RTRIM('Art 220, xiv       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64080, RTRIM('Portar no veic placas em desacordo c/ modelos contran            '), RTRIM('Art 221            '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64160, RTRIM('Confeccionar,distribuir placas em desacordo c/contran            '), RTRIM('Art 221 p. un      '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64240, RTRIM('Deixar manter ligado em situacoes emerg a iluminacao             '), RTRIM('Art 222            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64320, RTRIM('Transitar com luz alta perturbando visao de condutor             '), RTRIM('Art 223            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64400, RTRIM('Fazer uso de luz alta em vias providas de ilumin publica         '), RTRIM('Art 224            '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64590, RTRIM('Não sinalizar via veic p/remocao ou perm no acostamento          '), RTRIM('Art 225, i         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64670, RTRIM('Não sinalizar via veic p/remocao ou perm no acostamento          '), RTRIM('Art 225, ii        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64750, RTRIM('Não retirar objeto para sinalizacao temporaria da via            '), RTRIM('Art 226            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64830, RTRIM('Usar buzina prolongada/sucessivamente a qualquer pretexto        '), RTRIM('Art 227, i         '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (64910, RTRIM('Usar buzina nao como advertencia a pedestres/condutores          '), RTRIM('Art 227, ii        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65050, RTRIM('Usar buzina entre as 22h e 6h                                    '), RTRIM('Art 227, iii       '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65130, RTRIM('Usar buzina em local/hora proibidos pela sinalizacao             '), RTRIM('Art 227, iv        '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65210, RTRIM('Usar buzina em des c/padroes estabelecidos pelo contran          '), RTRIM('Art 227, v         '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65300, RTRIM('Usar no veic som em volume e frequencia nao autoriz              '), RTRIM('Art 228            '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65480, RTRIM('Usar indev no veic aparelho pertube sossego publico              '), RTRIM('Art 229            '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65560, RTRIM('Conduzir o veic c/ o lacre, etc ou outro elem violado            '), RTRIM('Art 230, i         '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65640, RTRIM('Conduzir o veic transp passageiros compart de carga              '), RTRIM('Art 230, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65720, RTRIM('Conduzir o veic com dispositivo anti-radar                       '), RTRIM('Art 230, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65800, RTRIM('Conduzir veic sem qualquer uma das placas de identificacao       '), RTRIM('Art 230, iv        '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (65990, RTRIM('Conduzir o veic nao registrado e devidam licenciado              '), RTRIM('Art 230, v         '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66020, RTRIM('Conduzir veic c/qualquer uma placa s/condicoes legibilidad       '), RTRIM('Art 230, vi        '), RTRIM('Gravíssima'), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66100, RTRIM('Conduzir o veic com a cor ou caracteristica alterada             '), RTRIM('Art 230, vii       '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66290, RTRIM('Conduzir o veic sem inspecao de seguranca veicular               '), RTRIM('Art 230, viii      '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66370, RTRIM('Conduzir o veic s/ equipamento obrigatorio ou ineficiente        '), RTRIM('Art 230, ix        '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66450, RTRIM('Conduzir o veic c/ equip obrigatorio em desacordo                '), RTRIM('Art 230, x         '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66530, RTRIM('Conduzir veic c/ descarga livre ou silenciador c/ defeito        '), RTRIM('Art 230, xi        '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66610, RTRIM('Conduzir o veic c/ equipamento ou acessorio proibido             '), RTRIM('Art 230, xii       '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66700, RTRIM('Conduzir o veic c/ equipam. iluminacao e sinaliz alterado        '), RTRIM('Art 230, xiii      '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66880, RTRIM('Conduzir o veic c/ registrador inalteravel velocidade            '), RTRIM('Art 230, xiv       '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (66960, RTRIM('Conduzir o veic c/ inscricoes, etc afixados no para-brisa        '), RTRIM('Art 230, xv        '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67000, RTRIM('Conduzir o veic c/ vidros cobertos por pinturas, paineis         '), RTRIM('Art 230, xvi       '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67180, RTRIM('Conduzir o veic c/ cortinas ou persianas fechadas                '), RTRIM('Art 230, xvii      '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67260, RTRIM('Conduzir o veic em mau estado de conservacao                     '), RTRIM('Art 230, xviii     '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67340, RTRIM('Conduzir o veic s/ acionar limpador sob chuva                    '), RTRIM('Art 230, xix       '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67420, RTRIM('Conduzir o veics/ autoriz p/ conducao de escolares               '), RTRIM('Art 230, xx        '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67500, RTRIM('Conduzir o veic de carga c/ falta de inscricao da tara           '), RTRIM('Art 230, xxi       '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67690, RTRIM('Conduzir o veic c/ defeito no sistema de iluminacao, etc         '), RTRIM('Art 230, xxii      '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67770, RTRIM('Transitar danificando a via, instalacoes, e equipamentos         '), RTRIM('Art 231, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67850, RTRIM('Trans derramando/lancando/arrastando carga transportada          '), RTRIM('Art 231, ii a      '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (67930, RTRIM('Trans derramando/lancando/arrastando combustivel                 '), RTRIM('Art 231, ii b      '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68070, RTRIM('Trans derramando/lancando/arrastando qualquer objeto             '), RTRIM('Art 231, ii c      '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68150, RTRIM('Transitar prod fumaca acima permitido pelo contran               '), RTRIM('Art 231, iii       '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68230, RTRIM('Transitar c/ veic c/ dimensoes ou carga sup a legislacao         '), RTRIM('Art 231, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68231, RTRIM('Trans c/veiculo c/altura acima da permitida                      '), RTRIM('Art 231, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68232, RTRIM('Trans c/veiculo c/largura superior a permitida                   '), RTRIM('Art 231, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68233, RTRIM('Trans c/veiculo de comprimento acima do permitido                '), RTRIM('Art 231, iv        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68310, RTRIM('Transitar c/ o veic c/ excesso de peso                           '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68311, RTRIM('Transitar com o veiculo com excesso de peso ate 600kg            '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68312, RTRIM('Trans com o veiculo com excesso de peso de 601 a 800kg           '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68313, RTRIM('Trans com o veiculo com excesso de peso de 801 a 1000kg          '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68314, RTRIM('Trans com o veiculo com excesso de peso de 1001 a 3000kg         '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68315, RTRIM('Trans com o veiculo com excesso de peso de 3001 a 5000kg         '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68316, RTRIM('Trans com o veiculo com excesso de peso acima de 5000kg          '), RTRIM('Art 231, v         '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68400, RTRIM('Transitar em desacordo c/ autorizacao especial superdimens       '), RTRIM('Art 231, vi        '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68580, RTRIM('Trans com lotacao excedente                                      '), RTRIM('Art 231, vii       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68660, RTRIM('Efetuar transp remunerado de pessoas/bens s/licenca              '), RTRIM('Art 231, viii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68740, RTRIM('Trans c/ veic desligado ou desengrenado em declive               '), RTRIM('Art 231, ix        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68820, RTRIM('Trans c/veic acima da capacidade max de tracao-media             '), RTRIM('Art 231, x         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (68900, RTRIM('Trans c/veic acima da capacidade max de tracao-grave             '), RTRIM('Art 231, x         '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69040, RTRIM('Trans c/veic acima da capacidade max de tracao-gravissima        '), RTRIM('Art 230, x         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69120, RTRIM('Conduzir o veic s/ os documentos de porte obrigatorio            '), RTRIM('Art 232            '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69200, RTRIM('Deixar de efetuar registro de veic no prazo de 30 dias           '), RTRIM('Art 233            '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69390, RTRIM('Falsificar ou adulterar doc. de habilitacao ou do veiculo        '), RTRIM('Art 234            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69470, RTRIM('Conduzir pessoas ou carga em partes externas do veic             '), RTRIM('Art 235            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69550, RTRIM('Rebocar outro veiculo com cabo flexivel ou corda                 '), RTRIM('Art 236            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69630, RTRIM('Transitar c/ veic desacordo c/ especife falta inscricao          '), RTRIM('Art 237            '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69710, RTRIM('Recusar-se entregar a autoridade os documentos                   '), RTRIM('Art 238            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69800, RTRIM('Retirar s/permissao veiculo retido p/autoridade/agente           '), RTRIM('Art 239            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (69980, RTRIM('Deixar de promover baixa registro veic irrecuperavel             '), RTRIM('Art 240            '), RTRIM('Grave     '), RTRIM('Proprietário     '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70050, RTRIM('Deixar de atualizar cadastro de habilitacao ou do veiculo        '), RTRIM('Art 241            '), RTRIM('Leve      '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 3   ,        53.20);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70130, RTRIM('Fazer falsa declaracao domicilio fins registro da cnh            '), RTRIM('Art 242            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Estadual                        '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70210, RTRIM('Deixar a seguradora de comunicar orgao trans perda total         '), RTRIM('Art 243            '), RTRIM('Grave     '), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70300, RTRIM('Conduzir motocicleta, etc s/ usar capacete seguranca             '), RTRIM('Art 244, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70301, RTRIM('Cond motocicleta, motoneta e ciclomotor sem usar capacete        '), RTRIM('Art 244, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70302, RTRIM('Cond moto/motoneta/ciclomotor sem vestuario de acordo            '), RTRIM('Art 244, i         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70480, RTRIM('Conduzir motocicleta, etc transportando passag s/ capacete       '), RTRIM('Art 244, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70481, RTRIM('Cond moto/motoneta/ciclomotor c/pass sem usar capacete           '), RTRIM('Art 244, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70482, RTRIM('Cond moto/motoneta/ciclomotor c/pass fora assento                '), RTRIM('Art 244, ii        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70560, RTRIM('Conduzir motocicleta, etc fazendo malabarismos                   '), RTRIM('Art 244, iii       '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70640, RTRIM('Conduzir motocicleta, etc com os farois apagados                 '), RTRIM('Art 244, iv        '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70720, RTRIM('Conduzir motocicleta, etc transp crianca menor 7 anos            '), RTRIM('Art 244, v         '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70800, RTRIM('Conduzir motocicleta, etc rebocando outro veiculo                '), RTRIM('Art 244, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (70990, RTRIM('Conduzir motocicleta, etc sem segurar o guidom                   '), RTRIM('Art 244, vii       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71020, RTRIM('Conduzir motocicleta, etc transp carga incompativel              '), RTRIM('Art 244, viii      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71100, RTRIM('P/ ciclos conduzir passageiro fora da garupa ou assento          '), RTRIM('Art 244, p. 1 a    '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71290, RTRIM('P/ ciclos transitar vias transito rapido/rodovias                '), RTRIM('Art 244, p. 1 b    '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71370, RTRIM('P/ ciclos transportar criancas nao tenham condicoes seg          '), RTRIM('Art 244, p. 1 c    '), RTRIM('Média     '), RTRIM('Proprietário     '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71450, RTRIM('Utilizar a via p/deposito de mercadorias/equipamentos            '), RTRIM('Art 245            '), RTRIM('Grave     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71530, RTRIM('Não sinalizar obstaculos a livre circulacao veic/pedestre        '), RTRIM('Art 246            '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71610, RTRIM('Não sinalizar obstaculos livre circ veic/pedestre 2x             '), RTRIM('Art 246            '), RTRIM('Gravíssima'), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 7   ,       383.07);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71700, RTRIM('Não sinalizar obstaculos livre circ veic/pedestre 3x             '), RTRIM('Art 246            '), RTRIM('Gravíssima'), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71880, RTRIM('Não sinalizar obstaculos livre circ veic/pedestre 4x             '), RTRIM('Art 246            '), RTRIM('Gravíssima'), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 7   ,       766.15);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (71960, RTRIM('Não sinalizar obstaculos livre circ veic/pedestre 5x             '), RTRIM('Art 246            '), RTRIM('Gravíssima'), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 7   ,       957.70);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72000, RTRIM('Não cond p/bordo da pista veic prop humana/tracao animal         '), RTRIM('Art 247            '), RTRIM('Média     '), RTRIM('pessoa juridica  '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72180, RTRIM('Transportar em veic de passageiros carga excedente               '), RTRIM('Art 248            '), RTRIM('Grave     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72260, RTRIM('Deixar de acender noite luzes qdo veicparado p/embarque          '), RTRIM('Art 249            '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72340, RTRIM('Qdo veic em movim nao acender luz baixa a noite                  '), RTRIM('Art 250, i a       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72420, RTRIM('Qdo veic em movim nao acender luz baixa de dia tuneis            '), RTRIM('Art 250, i b       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72500, RTRIM('Qdo veic transp coletivo em movim nao acender luz baixa          '), RTRIM('Art 250, i c       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72690, RTRIM('Qdo veic ciclomotores em movim nao acender luz baixa             '), RTRIM('Art 250, i d       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72770, RTRIM('Qdo veic em movimento, nao acender luzes sob chuva, etc          '), RTRIM('Art 250, ii        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72850, RTRIM('Deixar de manter acesa a placa traseira iluminada a noite        '), RTRIM('Art 250, iii       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (72930, RTRIM('Utilizar pisca-alerta, exceto imobilizacao ou emergencia         '), RTRIM('Art 251, i         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73070, RTRIM('Utilizar luzes do veic intermitente exceto p/ ultrapassar        '), RTRIM('Art 251, ii a      '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73150, RTRIM('Dirigir o veiculo com o braco do lado de fora                    '), RTRIM('Art 252, i         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73230, RTRIM('Dirigir veic transportando pessoas, animais a sua esq            '), RTRIM('Art 252, ii        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73310, RTRIM('Dirigir veic c/ incapacidade fisica ou mental temporaria         '), RTRIM('Art 252, iii       '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73400, RTRIM('Dirigir veic. usando calcado que comprometa utiliz pedais        '), RTRIM('Art 252, iv        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73580, RTRIM('Dirigir o veiculo com apenas uma das maos                        '), RTRIM('Art 252, v         '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Estadual                        '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73660, RTRIM('Dirigir o veiculo utilizando-se de fones, telefone celular       '), RTRIM('Art 252, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73661, RTRIM('Dirigir veiculo utilizando-se de fones nos ouvidos               '), RTRIM('Art 252, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73662, RTRIM('Dirigir veiculo utilizando-se de telefone celular                '), RTRIM('Art 252, vi        '), RTRIM('Média     '), RTRIM('Condutor         '), RTRIM('Municipal/estadual              '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73740, RTRIM('Bloquear a via com veiculo                                       '), RTRIM('Art 253            '), RTRIM('Gravíssima'), RTRIM('Condutor         '), RTRIM('Municipal                       '), 7   ,       191.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73820, RTRIM('Proibido ao pedestre permanecer/andar na pista                   '), RTRIM('Art 254, i         '), RTRIM('Leve      '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 3   ,        26.60);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (73900, RTRIM('Proibido ao pedestre cruzar pista em viaduto/ponte/tunel         '), RTRIM('Art 254, ii        '), RTRIM('Leve      '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 3   ,        26.60);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74040, RTRIM('Proibido ao pedestre atravessar via na area de cruzamento        '), RTRIM('Art 254, iii       '), RTRIM('Leve      '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 3   ,        26.60);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74120, RTRIM('Proibido ao pedestre utilizar a via p/perturbar o transito       '), RTRIM('Art 254, iv        '), RTRIM('Leve      '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 3   ,        26.60);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74200, RTRIM('Proibido pedestre andar fora faixa propria                       '), RTRIM('Art 254, v         '), RTRIM('Leve      '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 3   ,        26.60);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74390, RTRIM('Proibido pedestre desob sinalizacao de tran especifica           '), RTRIM('Art 254, vi        '), RTRIM('Leve      '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 3   ,        26.60);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74470, RTRIM('Conduzir bicicleta em local proibido ou forma agressiva          '), RTRIM('Art 255            '), RTRIM('Média     '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74550, RTRIM('Transitar veloc sup max permitida em ate 20%                     '), RTRIM('Art 218            '), RTRIM('Média     '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 4   ,        85.13);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (7463 , RTRIM('Transitar veloc sup max permitida em mais de 20% ate 50%         '), RTRIM('Art 218            '), RTRIM('Grave     '), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 5   ,       127.69);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (74710, RTRIM('Transitar veloc sup max permitida em mais de 50%                 '), RTRIM('Art 218            '), RTRIM('gravíssima'), RTRIM('pessoa fisica    '), RTRIM('Municipal                       '), 7   ,       574.62);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90160, RTRIM('Transp.pp cujo desloc.seja proibido pelo min.transportes         '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90240, RTRIM('Transp. pp a granel que nao conste no cipp                       '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90320, RTRIM('Transp. pp a granel em veiculo com cipp vencido                  '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90400, RTRIM('Transp pessoas,animais,alim,medic,juntamente c/prod.perig.       '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90401, RTRIM('Transportar pessoas com produtos perigosos                       '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90402, RTRIM('Transportar animais com produtos perigosos                       '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90403, RTRIM('Transp.alimentos destinado ao cons.humano/animal junt.c/pp       '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90404, RTRIM('Transp.medicamentos dest ao cons.humano/animal junt.c/pp         '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90590, RTRIM('Transp prod incompativeis entre si                               '), RTRIM('Dec 96044/88,45,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90670, RTRIM('Não dar manutencao ao veiculo e ao equipamento                   '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90671, RTRIM('Não dar manutencao ao veiculo                                    '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90672, RTRIM('Não dar manutencao ao equipamento                                '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90750, RTRIM('Estac. ou parar em desacordo com o artigo 14 do rtpp             '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90751, RTRIM('Estac. em desacordo com o artigo 14 do rtpp                      '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90752, RTRIM('Parar em desacordo com o artigo 14 do rtpp                       '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90830, RTRIM('Transp. pp cujas embalagens se encontrem em mas condicoes        '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90910, RTRIM('Não adotar em acid/avar. prov.da f.de emergenc/env.transp.       '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90911, RTRIM('Não adotar em caso de acid prov da f de emerg/env.transp         '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (90912, RTRIM('Não adotar em caso de avaria prov da f de emerg/env.transp       '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91050, RTRIM('Transp.pp a granel s/util.tacogr.ou c/irreg.ou nao apres.        '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91051, RTRIM('Transp.pp a granel s/util.tacografo ou este com irregular.       '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91052, RTRIM('Transp.pp a granel s/apres.o disco a autorid.ou c/irreg.         '), RTRIM('Dec 96044/88,45,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91130, RTRIM('Transportar carga mal estivada                                   '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91210, RTRIM('Transp.pp em veic.sem equip.p/emerg./epi ou incomp.              '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91211, RTRIM('Transp. pp em veic.sem equip.p/emerg. ou incomp.                 '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91212, RTRIM('Transp. pp em veic.sem epi, ou incomp.                           '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91300, RTRIM('Transp. pp a granel sem o cipp                                   '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91480, RTRIM('Transp. pp sem a declaracao de respons.do expedidor na nf        '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91560, RTRIM('Transp. pp sem a ficha de emerg.e o envelope para o transp       '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91561, RTRIM('Transp.pp s/a ficha de emerg.ou em desacordo c/o dec96044        '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91562, RTRIM('Transp.pp s/o env.p/o transp. ou em desacordo c/o dec96044       '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91640, RTRIM('Transp pp sem util rotulos de risco e paineis de seguranca       '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91641, RTRIM('Transp pp sem util r.de riscos e p.segur.nas embalagens          '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91642, RTRIM('Transp pp sem util r.de riscos e p.segur.no veiculo              '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91720, RTRIM('Circular em vias publ qdo nao permitido transp prod perig.       '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91800, RTRIM('Não com.imed.a imobiliz.do veic.em caso de emerg/acid/avar       '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91801, RTRIM('Não com.imed.a imobilizacao do veic.em caso de emergencia        '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91802, RTRIM('Não com.imed.a imobilizacao do veic.em caso de acidente          '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91803, RTRIM('Não com.imed.a imobilizacao do veic.em caso de avaria            '), RTRIM('Dec 96044/88,45,iii'), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       131.30);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (91990, RTRIM('Embarcar no veiculo pp incompativeis entre si                    '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92020, RTRIM('Emb.pp que nao conste no cipp do veic.e/ou equip.e/ou venc       '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92021, RTRIM('Emb.pp que nao conste no cipp do veic.ou c/o mesmo vencido       '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92022, RTRIM('Emb.pp que nao conste no cipp do equip.ou c/o mesmo vencid       '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92100, RTRIM('Exp. nf em desacordo c/art. 22, ii do decreto 96044              '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92290, RTRIM('Exp.pp sem acondicionam.correto e c/embalagens em mas cond       '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92291, RTRIM('Exp. pp sem acondicionamento correto                             '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92292, RTRIM('Exp. pp com embalagem em ma condicoes                            '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92370, RTRIM('Não comp.ao local do acidente qdo convocado pela autoridad       '), RTRIM('Dec 96044/88,46,i, '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       656.54);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92450, RTRIM('Emb.pp em veic. sem equip. p/sit.de emerg./epi ou incomp.        '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92451, RTRIM('Emb.pp em veic.sem equip.p/sit.de emerg.ou incomp.               '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92452, RTRIM('Emb.pp em veic.sem epi ou incomp.                                '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92530, RTRIM('Não forn.ao transp.a f.de emerg.e env.p/transp ou em desc.       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92531, RTRIM('Não forn.ao transp.a ficha de emerg.ou em desac.c/dec96044       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92532, RTRIM('Não forn.ao transp.o env.p/transp.ou em desac.c/dec 96044        '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92610, RTRIM('Emb prod perig em veic sem rot de risco e paineis de segur       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92700, RTRIM('Emb.carga fracion.c/embal.ext.s/rotulo de risco ou s/cons.       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92880, RTRIM('Embarcar pp em veic(ou equip) sem adequadas cond de manut.       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92960, RTRIM('Não esclarec.o sufic.em sit.de emerg ou acidente                 '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92961, RTRIM('Não esclarec.o sufic.em sit.de emerg.qdo solicit.p/autorid       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);
INSERT INTO frota.motivo_infracao (cod_infracao, descricao, base_legal, gravidade, responsabilidade, competencia, pontos, valor) VALUES (92962, RTRIM('Não esclarec.o sufic.em caso de acid.qdo solicit.p/autorid       '), RTRIM('Dec 96044/88,46,ii '), RTRIM('Gravíssima'), RTRIM('pessoa juridica  '), RTRIM('Estadual                        '), 0   ,       328.27);


----------------
-- Ticket #19748
----------------

CREATE TABLE licitacao.contrato_arquivo (
    num_contrato    INTEGER             NOT NULL,
    exercicio       CHAR(4)             NOT NULL,
    cod_entidade    INTEGER             NOT NULL,
    arquivo         VARCHAR(200)        NOT NULL,
    nom_arquivo     VARCHAR(120)        NOT NULL,
    CONSTRAINT pk_contrato_arquivo      PRIMARY KEY                     (num_contrato, exercicio, cod_entidade, arquivo),
    CONSTRAINT fk_contrato_arquivo_1    FOREIGN KEY                     (num_contrato, exercicio, cod_entidade)
                                        REFERENCES licitacao.contrato   (num_contrato, exercicio, cod_entidade)
);
GRANT ALL ON TABLE licitacao.contrato_arquivo TO siamweb;


----------------
-- Ticket #19769
----------------

CREATE TABLE patrimonio.arquivo_coletora (
    codigo      INTEGER                 NOT NULL,
    nome        VARCHAR(27)             NOT NULL,
    md5sum      VARCHAR(35)             NOT NULL,
    timestamp   TIMESTAMP               NOT NULL DEFAULT ('now'::text)::timestamp(3) WITH time zone,
    CONSTRAINT  pk_arquivo_coletora     PRIMARY KEY (codigo),
    CONSTRAINT  uk_arquivo_coletora     UNIQUE(nome)
);
GRANT ALL ON patrimonio.arquivo_coletora TO GROUP urbem;


CREATE TABLE patrimonio.arquivo_coletora_dados (
    cod_local   INTEGER                     NOT NULL,
    codigo      INTEGER                     NOT NULL,
    num_placa   VARCHAR(20)                 NOT NULL,
    CONSTRAINT  pk_arquivo_coletora_dados   PRIMARY KEY (codigo,num_placa),
    CONSTRAINT  fk_arquivo_coletora_dados_1 FOREIGN KEY (codigo)
                                            REFERENCES patrimonio.arquivo_coletora (codigo),
    CONSTRAINT  fk_arquivo_coletora_dados_2 FOREIGN KEY (cod_local)
                                            REFERENCES organograma.local (cod_local)
);
GRANT ALL ON patrimonio.arquivo_coletora_dados TO GROUP urbem;


CREATE TABLE patrimonio.arquivo_coletora_consistencia (
    codigo      INTEGER     NOT NULL,
    num_placa   VARCHAR(20) NOT NULL,
    status      VARCHAR(35) NOT NULL,
    orientacao  VARCHAR(70),
    CONSTRAINT  pk_arquivo_coletora_consistencia   PRIMARY KEY (codigo,num_placa),
    CONSTRAINT  fk_arquivo_coletora_consistencia_1 FOREIGN KEY (codigo,num_placa)
                                                   REFERENCES patrimonio.arquivo_coletora_dados (codigo,num_placa)
);
GRANT ALL ON patrimonio.arquivo_coletora_consistencia TO GROUP urbem;


INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo )
VALUES
     ( 2783
     , 447
     , 'FMImportarColetora.php'
     , 'importar'
     , 11
     , ''
     , 'Importar Arquivo Coletora'
     , TRUE
);

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo )
VALUES
     ( 2785
     , 447
     , 'FLExportarColetora.php'
     , 'exportar'
     , 10
     , ''
     , 'Exportar Arquivo Coletora'
     , TRUE
);

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo )
VALUES
     ( 2859
     , 447
     , 'FLExcluirArquivoColetora.php'
     , 'excluir'
     , 12
     , ''
     , 'Excluir Arquivo Coletora'
     , TRUE
);

INSERT
  INTO administracao.acao
     ( cod_acao
     , cod_funcionalidade
     , nom_arquivo
     , parametro
     , ordem
     , complemento_acao
     , nom_acao
     , ativo )
VALUES
     ( 2784
     , 28
     , 'FLRelatorioConsistenciaColetora.php'
     , 'imprimir'
     , 102
     , ''
     , 'Relatório de Consistência Arquivo Coletora' 
     , TRUE
);

INSERT
  INTO administracao.relatorio 
VALUES
     ( 3
     , 6
     , 18
     , 'Relatório de Consistência Arquivo Coletora'
     , 'relatorioConsistenciaColetora.rptdesign'
);

UPDATE administracao.acao SET cod_funcionalidade = 28 WHERE cod_acao = 2407;

