<?php
/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
?>
<?php
/**
    * Página de Include Oculta - Exportação Arquivos GF

    * Data de Criação   : 06/02/2099

    * @author Analista: Tonismar Bernardo
    * @author Desenvolvedor: André Machado

    * @ignore

    $Id: EstornoPagamento.inc.php 59612 2014-09-02 12:00:51Z gelson $
*/
    include_once( CAM_GPC_TPB_MAPEAMENTO."TCEPBEstornoPagamento.class.php" );

    $obTCEPBEstornoPagamento = new TCEPBEstornoPagamento();

    $arFiltro = sessao::read('filtroRelatorio');

    $ndias =  cal_days_in_month(CAL_GREGORIAN, $arFiltro['inMes'], Sessao::read('exercicio') );

    $obTCEPBEstornoPagamento->setDado('entidade' , $stEntidades);
    $obTCEPBEstornoPagamento->setDado('dtInicial', '01/'.$arFiltro['inMes'].'/'.Sessao::read('exercicio')  );
    $obTCEPBEstornoPagamento->setDado('dtFinal'  ,  $ndias.'/'.$arFiltro['inMes'].'/'.Sessao::read('exercicio'));

    $obTCEPBEstornoPagamento->recuperaTodos($rsRecordSet);

    //rotina para definir o numero da parcela agrupado por entidade e empenho
    $arDados  = $rsRecordSet->getElementos();
    $arFinal  = array();

    foreach ($arDados as $key=>$campo) {
        $arDados[$key]['liquidada'] = 'S';
        if (!$arDados[$key]['parcela']) {
        $parcela = 1;
        $arDados[$key]['parcela'] = $parcela;

        foreach ($arDados as $key2=>$campo2) {
            if ($arDados[$key]['entidade'] == $arDados[$key2]['entidade'] &&
                $arDados[$key]['empenho']  == $arDados[$key2]['empenho']) {
                if (!$arDados[$key2]['parcela']) {
                    $arDados[$key2]['parcela'] = $parcela;
                    $parcela = $parcela + 1;
                } else {
                    $parcela = $arDados[$key]['parcela'] +  1;
                }
            }
        }
        }
    }

    $rsRecordSet = new recordSet();
    $rsRecordSet->preenche($arDados);

    $obExportador->roUltimoArquivo->addBloco($rsRecordSet);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("reservado_tse");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(6);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("exercicio");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(4);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("cod_unidade");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(5);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("empenho");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(7);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("parcela");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(7);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("data_estorno");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("DATA_DDMMYYYY");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(8);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("descricao");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("CARACTER_ESPACOS_DIR");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(120);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("liquidada");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("CARACTER_ESPACOS_DIR");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(1);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("valor");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("VALOR_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(16);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("tipo_lancamento");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(1);
    $obExportador->roUltimoArquivo->roUltimoBloco->addColuna("reservado_tse");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTipoDado("NUMERICO_ZEROS_ESQ");
    $obExportador->roUltimoArquivo->roUltimoBloco->roUltimaColuna->setTamanhoFixo(6);

?>