/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
* Script de DDL e DML
*
* URBEM Soluções de Gestão Pública Ltda
* www.urbem.cnm.org.br
*
* $Id:$
*
* Versão 2.00.5
*/

----------------
-- Ticket #18238
----------------

CREATE TABLE tcmgo.modalidade(
    cod_modalidade      CHAR(2)         NOT NULL,
    descricao           VARCHAR(80)     NOT NULL,
    CONSTRAINT pk_tcmgo_modalidade      PRIMARY KEY (cod_modalidade)
);
GRANT ALL ON tcmgo.modalidade TO urbem;

INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('00', 'Não se Aplica'                                                  );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('01', 'Abaixo do limite de convite para compras e serviços'            );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('02', 'Abaixo do limite de convite para Obras e Serviços de Engenharia');
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('03', 'Convite para Compras e Serviços'                                );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('04', 'Convite para Obras e Serviços de Engenharia'                    );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('05', 'Tomada de Preço para Compras e Serviços'                        );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('06', 'Tomada de Preço para Obras e Serviços de Engenharia'            );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('07', 'Concorrência para Compras e Serviços'                           );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('08', 'Concorrência para Obras e Serviços de Engenharia'               );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('09', 'Leilão'                                                         );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('10', 'Dispensa de Licitação'                                          );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('11', 'Inexigibilidade de Licitação'                                   );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('12', 'Concurso'                                                       );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('13', 'Pregão'                                                         );
INSERT INTO tcmgo.modalidade (cod_modalidade, descricao ) VALUES ('99', 'Outros'                                                         );


CREATE TABLE tcmgo.fundamentacao_legal(
    cod_fundamentacao   CHAR(2)             NOT NULL,
    descricao           VARCHAR(600)        NOT NULL,
    CONSTRAINT pk_tcmgo_fundamentacao_legal PRIMARY KEY (cod_fundamentacao)
);
GRANT ALL ON tcmgo.fundamentacao_legal TO urbem;

INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (01, 'I - Para obras e serviços de engenharia de valor até 10% (dez por cento) do limite previsto na alínea "a", do inciso I do artigo 23 da Lei no 8.666/93, desde que não se refiram a parcelas de uma mesma obra ou serviço ou ainda para obras e serviços da mesma natureza e no mesmo local que possam ser realizadas conjunta e concomitantemente;'                                                                                                                                                                                                                                                 );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (02, 'II - para outros serviços e compras de valor até 10% (dez por cento) do limite previsto na alínea "a", do inciso II do artigo 23 da Lei no 8.666/93 e para alienações, nos casos previstos na Lei no 8.666/93, desde que não se refiram a parcelas de um mesmo serviço, compra ou alienação de maior vulto que possa ser realizada de uma só vez;'                                                                                                                                                                                                                                                  );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (03, 'III - nos casos de guerra ou grave perturbação da ordem;'                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (04, 'IV - nos casos de emergência ou de calamidade pública, quando caracterizada urgência de atendimento de situação que possa ocasionar prejuízo ou comprometer a segurança de pessoas, obras, serviços, equipamentos e outros bens, públicos ou particulares, e somente para os bens necessários ao atendimento da situação emergencial ou calamitosa e para as parcelas de obras e serviços que possam ser concluídas no prazo máximo de 180 (cento e oitenta) dias consecutivos e ininterruptos, contados da ocorrência da emergência ou calamidade, vedada a prorrogação dos respectivos contratos;');
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (05, 'V - quando não acudirem interessados à licitação anterior e esta, justificadamente, não puder ser repetida sem prejuízo para a Administração, mantidas, neste caso, todas as condições preestabelecidas;'                                                                                                                                                                                                                                                                                                                                                                                           );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (07, 'VII - quando as propostas apresentadas consignarem preços manifestamente superiores aos praticados no mercado nacional, ou forem incompatíveis com os fixados pelos órgãos oficiais competentes, casos em que, observado o parágrafo único do art. 48 da Lei no 8666/93 e, persistindo a situação, será admitida a adjudicação direta dos bens ou serviços, por valor não superior ao constante do registro de preços, ou dos serviços;'                                                                                                                                                            );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (08, 'VIII - para a aquisição, por pessoa jurídica de direito público interno, de bens produzidos ou serviços prestados por órgão ou entidade que integre a Administração Pública e que tenha sido criado para esse fim específico em data anterior à vigência desta Lei, desde que o preço contratado seja compatível com o praticado no mercado;'                                                                                                                                                                                                                                                       );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (10, 'X - para a compra ou locação de imóvel destinado ao atendimento das finalidades precípuas da administração, cujas necessidades de instalação e localização condicionem a sua escolha, desde que o preço seja compatível com o valor de mercado, segundo avaliação prévia;'                                                                                                                                                                                                                                                                                                                          );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (11, 'XI - na contratação de remanescente de obra, serviço ou fornecimento, em conseqüência de rescisão contratual, desde que atendida a ordem de classificação da licitação anterior e aceitas as mesmas condições oferecidas pelo licitante vencedor, inclusive quanto ao preço, devidamente corrigido;'                                                                                                                                                                                                                                                                                                );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (12, 'XII - nas compras de hortifrutigranjeiros, pão e outros gêneros perecíveis, no tempo necessário para a realização dos processos licitatórios correspondentes, realizadas diretamente com base no preço do dia;'                                                                                                                                                                                                                                                                                                                                                                                     );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (13, 'XIII - na contratação de instituição brasileira incumbida regimental ou estatutariamente da pesquisa, do ensino ou do desenvolvimento institucional, ou de instituição dedicada à recuperação social do preso, desde que a contratada detenha inquestionável reputação ético-profissional e não tenha fins lucrativos;'                                                                                                                                                                                                                                                                             );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (14, 'XIV - para a aquisição de bens ou serviços nos termos de acordo internacional específico aprovado pelo Congresso Nacional, quando as condições ofertadas forem manifestamente vantajosas para o Poder Público;'                                                                                                                                                                                                                                                                                                                                                                                     );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (15, 'XV - para a aquisição ou restauração de obras de arte e objetos históricos, de autenticidade certificada, desde que compatíveis ou inerentes às finalidades do órgão ou entidade.'                                                                                                                                                                                                                                                                                                                                                                                                                  );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (16, 'XVI - para a impressão dos diários oficiais, de formulários padronizados de uso da administração, e de edições técnicas oficiais, bem como para prestação de serviços de informática a pessoa jurídica de direito público interno, por órgãos ou entidades que integrem a Administração Pública, criados para esse fim específico'                                                                                                                                                                                                                                                                  );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (17, 'XVII - para a aquisição de componentes ou peças de origem nacional ou estrangeira, necessários à manutenção de equipamentos durante o período de garantia técnica, junto ao fornecedor original desses equipamentos, quando tal condição de exclusividade for indispensável para a vigência da garantia;'                                                                                                                                                                                                                                                                                           );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (18, 'XVIII - nas compras ou contratações de serviços para o abastecimento de navios, embarcações, unidades aéreas ou tropas e seus meios de deslocamento quando em estada eventual de curta duração em portos, aeroportos ou localidades diferentes de suas sedes, por motivo de movimentação operacional ou de adestramento, quando a exiguidade dos prazos legais puder comprometer a normalidade e os propósitos das operações e desde que seu valor não exceda ao limite previsto na alínea "a" do incico II do art. 23 da Lei no 8.666/93:'                                                         );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (20, 'XX - na contratação de associação de portadores de deficiência física, sem fins lucrativos e de comprovada idoneidade, por órgãos ou entidades da Admininistração Pública, para a prestação de serviços ou fornecimento de mão-de-obra, desde que o preço contratado seja compatível com o praticado no mercado.'                                                                                                                                                                                                                                                                                   );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (21, 'XXI - para a aquisição de bens e insumos destinados exclusivamente à pesquisa científica e tecnológica com recursos concedidos pela Capes, pela Finep, pelo CNPq ou por outras instituições de fomento a pesquisa credenciadas pelo CNPq para esse fim específico;'                                                                                                                                                                                                                                                                                                                                 );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (22, 'XXII - na contratação de fornecimento ou suprimento de energia elétrica e gás natural com concessionário, permissionário ou autorizado, segundo as normas da legislação específica;'                                                                                                                                                                                                                                                                                                                                                                                                                );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (23, 'XXIII - na contratação realizada por empresa pública ou sociedade de economia mista com suas subsidiárias e controladas, para a aquisição ou alienação de bens, prestação ou obtenção de serviços, desde que o preço contratado seja compatível com o praticado no mercado.'                                                                                                                                                                                                                                                                                                                        );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (24, 'XXIV - para a celebração de contratos de prestação de serviços com as organizações sociais, qualificadas no âmbito das respectivas esferas de governo, para atividades contempladas no contrato de gestão.'                                                                                                                                                                                                                                                                                                                                                                                         );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (25, 'XXV - na contratação realizada por Instituição Científica e Tecnológica - ICT ou por agência de fomento para a transferência de tecnologia e para o licenciamento de direito de uso ou de exploração de criação protegida.'                                                                                                                                                                                                                                                                                                                                                                         );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (26, 'XXVI - na celebração de contrato de programa com ente da Federação ou com entidade de sua administração indireta, para a prestação de serviços públicos de forma associada nos termos do autorizado em contrato de consórcio público ou em convênio de cooperação.'                                                                                                                                                                                                                                                                                                                                 );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (27, 'XXVII - na contratação da coleta, processamento e comercialização de resíduos sólidos urbanos recicláveis ou reutilizáveis, em áreas com sistema de coleta seletiva de lixo, efetuados por associações ou cooperativas formadas exclusivamente por pessoas físicas de baixa renda reconhecidas pelo poder público como catadores de materiais recicláveis, com o uso de equipamentos compatíveis com as normas técnicas, ambientais e de saúde pública.'                                                                                                                                            );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (30, 'XXX - na contratação de instituição ou organização, pública ou privada, com ou sem fins lucrativos, para a prestação de serviços de assistência técnica e extensão rural no âmbito do Programa Nacional de Assistência Técnica e Extensão Rural na Agricultura Familiar e na Reforma Agrária, instituído por lei federal.'                                                                                                                                                                                                                                                                          );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (31, 'XXXI - nas contratações visando ao cumprimento do disposto nos arts. 3o, 4o, 5o e 20 da Lei no 10.973, de 2 de dezembro de 2004, observados os princípios gerais de contratação dela constantes'                                                                                                                                                                                                                                                                                                                                                                                                    );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (71, 'I - para aquisição de materiais, equipamentos, ou gêneros que só possam ser fornecidos por produtor, empresa ou representante comercial exclusivo, vedada a preferência de marca, devendo a comprovação de exclusividade ser feita através de atestado fornecido pelo órgão de registro do comércio do local em que se realizaria a licitação ou a obra ou o serviço, pelo Sindicato, Federação ou Confederação Patronal, ou, ainda, pelas entidades equivalentes;'                                                                                                                                 );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (72, 'II - para a contratação de serviços técnicos enumerados no art. 13 da lei no 8.666/93, de natureza singular, com profissionais ou empresas de notória especialização, vedada a inexigibilidade para serviços de publicidade e divulgação;'                                                                                                                                                                                                                                                                                                                                                          );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (73, 'III - para contratação de profissional de qualquer setor artístico, diretamente ou através de empresário exclusivo, desde que consagrado pela crítica especializada ou pela opinião pública.'                                                                                                                                                                                                                                                                                                                                                                                                       );
INSERT INTO tcmgo.fundamentacao_legal (cod_fundamentacao, descricao) VALUES (79, 'Caput - Quando houver inviabilidade de competição, exceto nos casos previstos nos incisos I, II e III do artigo no 25 da Lei no 8.666/93.'                                                                                                                                                                                                                                                                                                                                                                                                                                                          );


CREATE TABLE tcmgo.empenho_modalidade(
    cod_modalidade      CHAR(2)         NOT NULL,
    cod_fundamentacao   CHAR(2)         NULL,
    exercicio           CHAR(4)         NOT NULL,
    cod_entidade        INTEGER         NOT NULL,
    cod_empenho         INTEGER         NOT NULL,
    justificativa       VARCHAR(250)    NULL,
    razao_escolha       VARCHAR(245)    NULL,
    CONSTRAINT pk_empenho_modalidade    PRIMARY KEY (cod_modalidade, exercicio, cod_entidade, cod_empenho),
    CONSTRAINT fk_empenho_modalidade_1  FOREIGN KEY (cod_modalidade)
                                        REFERENCES tcmgo.modalidade (cod_modalidade),
    CONSTRAINT fk_empenho_modalidade_2  FOREIGN KEY (cod_fundamentacao)
                                        REFERENCES tcmgo.fundamentacao_legal(cod_fundamentacao),
    CONSTRAINT fk_empenho_modalidade_3  FOREIGN KEY (exercicio, cod_entidade, cod_empenho)
                                        REFERENCES empenho.empenho (exercicio, cod_entidade, cod_empenho)
);
GRANT ALL ON tcmgo.empenho_modalidade TO urbem;


----------------
-- Ticket #17304
----------------

INSERT
  INTO administracao.configuracao
     ( cod_modulo
     , exercicio
     , parametro
     , valor
     )
VALUES
     ( 9
     , '2011'
     , 'nota_lancamento'
     , ''
     );

INSERT
  INTO administracao.configuracao
     ( cod_modulo
     , exercicio
     , parametro
     , valor
     )
VALUES
     ( 9
     , '2012'
     , 'nota_lancamento'
     , ''
     );

INSERT
  INTO administracao.relatorio
     ( cod_gestao
     , cod_modulo
     , cod_relatorio
     , nom_relatorio
     , arquivo )
     VALUES
     ( 2
     , 9
     , 9
     , 'Nota de lançamento'
     , 'notaLancamento.rptdesign'
     );


----------------
-- Ticket #18261
----------------

CREATE OR REPLACE FUNCTION tr_plano_conta_valida_indicador_superavit() RETURNS TRIGGER AS $$
DECLARE
BEGIN
    IF (NEW.indicador_superavit IS NOT NULL) AND (trim(NEW.indicador_superavit) != '') THEN
        PERFORM 1
           FROM contabilidade.sistema_contabil
          WHERE (    1 = ANY(string_to_array(grupos,','))
                  OR 2 = ANY(string_to_array(grupos,','))
                )
            AND NEW.cod_sistema = cod_sistema
              ;
        IF FOUND THEN
            RETURN NEW;
        ELSE
            RAISE EXCEPTION 'Indicador de Superávit (%) inválido para o Sistema Contábil utilizado (%)!',trim(NEW.indicador_superavit), NEW.cod_sistema;
            -- RETURN NULL;
        END IF;
    ELSE
        RETURN NEW;
    END IF;
END;
$$ LANGUAGE 'plpgsql';


CREATE OR REPLACE FUNCTION tr_plano_conta_valida_escrituracao() RETURNS TRIGGER AS $$
DECLARE
BEGIN
    IF (     NEW.natureza_info       IS NULL
         AND NEW.natureza_saldo      IS NULL
         AND NEW.indicador_superavit IS NULL
         AND NEW.escrituracao        = 'sintetica'
       )
       OR
       ( NEW.escrituracao        = 'analitica'
       )
    THEN
        RETURN NEW;
    ELSE
        RAISE EXCEPTION 'Erro ao especificar conta Sintética ou Analítica!';
        -- RETURN NULL;
    END IF;
END;
$$ LANGUAGE 'plpgsql';


CREATE OR REPLACE FUNCTION manutencao() RETURNS VOID AS $$
DECLARE
    stSQL               VARCHAR;
    reRecord            RECORD;
    inCountPlanoConta   INTEGER := 1;
    inCountAnalitica    INTEGER := 1;
BEGIN

    PERFORM 1
       FROM administracao.configuracao
      WHERE exercicio  = '2012'
        AND cod_modulo = 2
        AND parametro  = 'cnpj'
        AND valor      = '15424948000141'
          ;
    IF FOUND THEN


        CREATE TABLE contabilidade.configuracao_contabilidade (
            exercicio       CHAR(4)     NOT NULL,
            parametro       VARCHAR(40) NOT NULL,
            valor           TEXT        NOT NULL,
            fixo            BOOLEAN     NOT NULL DEFAULT FALSE,
            CONSTRAINT pk_configuracao_contabilidade    PRIMARY KEY (exercicio, parametro)
        );
        GRANT ALL ON contabilidade.configuracao_contabilidade TO urbem;

        INSERT INTO contabilidade.configuracao_contabilidade (exercicio, parametro, valor, fixo) VALUES ('2011', 'mascara_uniao'  , '9.9.9.9.9.99.99', TRUE );
        INSERT INTO contabilidade.configuracao_contabilidade (exercicio, parametro, valor, fixo) VALUES ('2011', 'mascara_sistema', '99.999'         , FALSE);

        DELETE FROM contabilidade.classificacao_plano    WHERE exercicio = '2012';
        DELETE FROM contabilidade.plano_recurso          WHERE exercicio = '2012';
        DELETE FROM contabilidade.plano_banco            WHERE exercicio = '2012';
        DELETE FROM contabilidade.plano_analitica        WHERE exercicio = '2012';
        DELETE FROM contabilidade.plano_conta            WHERE exercicio = '2012';
        DELETE FROM contabilidade.classificacao_contabil WHERE exercicio = '2012';
        DELETE FROM contabilidade.sistema_contabil       WHERE exercicio = '2012';
        INSERT INTO contabilidade.classificacao_contabil SELECT cod_classificacao, '2012' AS exercicio, nom_classificacao FROM contabilidade.classificacao_contabil WHERE exercicio = '2011';

        ALTER TABLE contabilidade.sistema_contabil ADD COLUMN grupos VARCHAR(20);
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (1, '2012', 'Patrimonial'  , '1,2,3,4');
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (2, '2012', 'Orçamentário' , '5,6'    );
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (3, '2012', 'Controle'     , '7,8'    );
        INSERT INTO contabilidade.sistema_contabil (cod_sistema, exercicio, nom_sistema, grupos) VALUES (4, '2012', 'Não Informado', '0'      );


        ALTER TABLE contabilidade.plano_conta ADD   COLUMN escrituracao         CHAR(9);
        ALTER TABLE contabilidade.plano_conta ADD   COLUMN natureza_saldo       CHAR(7);
        ALTER TABLE contabilidade.plano_conta ADD   COLUMN indicador_superavit  CHAR(12);
        ALTER TABLE contabilidade.plano_conta ADD   COLUMN funcao               TEXT;
        ALTER TABLE contabilidade.plano_conta ALTER COLUMN nom_conta       TYPE VARCHAR(200);

        ALTER TABLE contabilidade.plano_conta DROP CONSTRAINT uk_plano_conta_1;
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT ck_plano_conta_1  CHECK  (escrituracao        IN ('analitica','sintetica'));
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT ck_plano_conta_2  CHECK  (natureza_saldo      IN ('credor','devedor','S', 'misto',''));
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT ck_plano_conta_3  CHECK  (indicador_superavit IN ('permanente','financeiro','misto', ''));
        ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT uk_plano_conta_1  UNIQUE (cod_estrutural, indicador_superavit);

        DROP TRIGGER tr_monta_codigo_estrutural on contabilidade.plano_conta;
        CREATE TRIGGER tr_plano_conta_valida_indicador_funcional AFTER INSERT OR UPDATE ON contabilidade.plano_conta FOR EACH ROW EXECUTE PROCEDURE tr_plano_conta_valida_indicador_superavit();


        CREATE TABLE contabilidade.configuracao_lancamento_debito (
            cod_conta           INTEGER     NOT NULL,
            exercicio           CHAR(4)     NOT NULL,
            cod_conta_despesa   INTEGER     NOT NULL,
            estorno             BOOLEAN     NOT NULL,
            tipo                CHAR(20)    NOT NULL,
            rpps                BOOLEAN     NOT NULL,
            CONSTRAINT pk_configuracao_lancamento_debito    PRIMARY KEY                            (cod_conta, exercicio, cod_conta_despesa, estorno),
            CONSTRAINT fk_configuracao_lancamento_debito_1  FOREIGN KEY                            (cod_conta, exercicio)
                                                            REFERENCES contabilidade.plano_conta   (cod_conta, exercicio),
            CONSTRAINT fk_configuracao_lancamento_debito_2  FOREIGN KEY                            (exercicio, cod_conta_despesa)
                                                            REFERENCES orcamento.conta_despesa     (exercicio, cod_conta),
            CONSTRAINT ck_configuracao_lancamento_debito_1  CHECK (tipo IN ('almoxarifado','arrecadacao','empenho','implantacao_saldo','liquidacao','manual','pagamento','suplementacao','transferencia'))
        );
        GRANT ALL ON contabilidade.configuracao_lancamento_debito TO urbem;


        CREATE TABLE contabilidade.configuracao_lancamento_credito (
            cod_conta           INTEGER     NOT NULL,
            exercicio           CHAR(4)     NOT NULL,
            cod_conta_despesa   INTEGER     NOT NULL,
            estorno             BOOLEAN     NOT NULL,
            tipo                CHAR(20)    NOT NULL,
            rpps                BOOLEAN     NOT NULL,
            CONSTRAINT pk_configuracao_lancamento_credito   PRIMARY KEY                            (cod_conta, exercicio, cod_conta_despesa, estorno),
            CONSTRAINT fk_configuracao_lancamento_credito_1 FOREIGN KEY                            (cod_conta, exercicio)
                                                            REFERENCES contabilidade.plano_conta   (cod_conta, exercicio),
            CONSTRAINT fk_configuracao_lancamento_credito_2 FOREIGN KEY                            (exercicio, cod_conta_despesa)
                                                            REFERENCES orcamento.conta_despesa     (exercicio, cod_conta),
            CONSTRAINT ck_configuracao_lancamento_credito_1 CHECK (tipo IN ('almoxarifado', 'arrecadacao','empenho','implantacao_saldo','liquidacao','manual','pagamento','suplementacao','transferencia'))
        );
        GRANT ALL ON contabilidade.configuracao_lancamento_credito TO urbem;


        CREATE TABLE contabilidade.configuracao_lancamento_receita (
            cod_conta           INTEGER     NOT NULL,
            exercicio           CHAR(4)     NOT NULL,
            cod_conta_receita   INTEGER     NOT NULL,
            estorno             BOOLEAN     NOT NULL,
            CONSTRAINT pk_configuracao_lancamento_receita   PRIMARY KEY                            (cod_conta, exercicio, cod_conta_receita, estorno),
            CONSTRAINT fk_configuracao_lancamento_receita_1 FOREIGN KEY                            (cod_conta, exercicio)
                                                            REFERENCES contabilidade.plano_conta   (cod_conta, exercicio),
            CONSTRAINT fk_configuracao_lancamento_receita_2 FOREIGN KEY                            (exercicio, cod_conta_receita)
                                                            REFERENCES orcamento.conta_receita     (exercicio, cod_conta)
        );
        GRANT ALL ON contabilidade.configuracao_lancamento_receita TO urbem;


        INSERT
          INTO administracao.configuracao
        VALUES
             ( '2011'
             , 9
             , 'nova_contabiliade'
             ,'true'
             );

        INSERT
          INTO administracao.acao
             ( cod_acao
             , cod_funcionalidade
             , nom_arquivo
             , parametro
             , ordem
             , complemento_acao
             , nom_acao )
        VALUES
             ( 2805
             , 56
             , 'FMConfigurarLancamentosDespesa.php'
             , 'configurar'
             , 13
             , ''
             , 'Configurar Lançamentos de Despesa'
             );

        INSERT
          INTO administracao.acao
          ( cod_acao
          , cod_funcionalidade
          , nom_arquivo
          , parametro
          , ordem
          , complemento_acao
          , nom_acao )
          VALUES
          ( 2806
          , 63
          , 'FLRelatorioConfiguracaoLancamentoDespesa.php'
          , 'emitir'
          , 23
          , ''
          , 'Relatório de Configuração do Lançamento de Despesa'
          );

        INSERT
          INTO administracao.relatorio
          ( cod_gestao
          , cod_modulo
          , cod_relatorio
          , nom_relatorio
          , arquivo )
          VALUES
          ( 2
          , 9
          , 7
          , 'Relatório de Configuração do Lançamento de Despesa'
          , 'relatorioConfiguracaoLancamentoDespesa.rptdesign'
          );

        INSERT
          INTO administracao.acao
             ( cod_acao
             , cod_funcionalidade
             , nom_arquivo
             , parametro
             , ordem
             , complemento_acao
             , nom_acao )
        VALUES
             ( 2807
             , 56
             , 'FMConfigurarLancamentosReceita.php'
             , 'configurar'
             , 14
             , ''
             , 'Configurar Lançamentos de Receita'
             );

        INSERT
          INTO administracao.acao
          ( cod_acao
          , cod_funcionalidade
          , nom_arquivo
          , parametro
          , ordem
          , complemento_acao
          , nom_acao )
          VALUES
          ( 2808
          , 63
          , 'FLRelatorioConfiguracaoLancamentoReceita.php'
          , 'emitir'
          , 24
          , ''
          , 'Relatório de Configuração do Lançamento de Receita'
          );

        INSERT
          INTO administracao.relatorio
          ( cod_gestao
          , cod_modulo
          , cod_relatorio
          , nom_relatorio
          , arquivo )
          VALUES
          ( 2
          , 9
          , 8
          , 'Relatório de Configuração do Lançamento de Receita'
          , 'relatorioConfiguracaoLancamentoReceita.rptdesign'
          );



        CREATE TABLE insere_novo_plano(
            codigo_estrutural   VARCHAR(20),
            titulo              VARCHAR(200),
            funcao              TEXT,
            natureza_saldo      CHAR(1),
            escrituracao        CHAR(1),
            natureza_informacao CHAR(1),
            indicador_superavit CHAR(1)
        );

        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.0.0.0.0.00.00','ATIVO','COMPREENDE OS RECURSOS CONTROLADOS POR UMA ENTIDADE COMO CONSEQUENCIA DE EVENTOS PASSADOS E DOS QUAIS SE ESPERA QUE FLUAM BENEFICIOS ECONOMICOS OU POTENCIAL DE SERVICOS FUTUROS A UNIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.0.0.0.00.00','ATIVO CIRCULANTE','COMPREENDE OS ATIVOS QUE ATENDAM A QUALQUER UM DOS SEGUINTES CRITERIOS: SEJAM CAIXA OU EQUIVALENTE DE CAIXA; SEJAM REALIZAVEIS OU MANTIDOS PARA VENDA OU CONSUMO DENTRO DO CICLO OPERACIONAL DA ENTIDADE; SEJAM MANTIDOS PRIMARIAMENTE PARA NEGOCIACAO; SEJAM REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.0.0.00.00','CAIXA E EQUIVALENTES DE CAIXA','COMPREENDE O SOMATORIO DOS VALORES EM CAIXA E EM BANCOS, BEM COMO EQUIVALENTES, QUE REPRESENTAM RECURSOS COM LIVRE MOVIMENTACAO PARA APLICACAO NAS OPERACOES DA ENTIDADE E PARA OS QUAIS NAO HAJA RESTRICOES PARA USO IMEDIATO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - EXTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.01.00','CAIXA','REGISTRA O SOMATORIO DE NUMERARIOS EM ESPECIE E OUTROS VALORES EM TESOURARIA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.00','CONTA UNICA - SUBCONTA DO TESOURO NACIONAL','COMPREENDE OS VALORES DA CONTA UNICA DEPOSITADOS NO BANCO CENTRAL DO BRASIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.01','BANCO CENTRAL DO BRASIL','REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA ATRAVES DO AGENTE FINANCEIRO BANCO CENTRAL DO BRASIL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.02','BANCO DO BRASIL','REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA ATRAVES DO AGENTE FINANCEIRO BANCO DO BRASIL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.03','CONTA UNICA - RECURSOS DE GPS RECOLHIDOS A TRANSFERIR','REGISTRA A MOVIMENTACAO FINANCEIRA DA PREVIDENCIA SOCIAL JUNTO A CONTA UNICA, COMO O RECOLHIMENTO DE RECEITAS FEDERAIS ATRAVES DE GPS INTRA-SIAFI, GPS ELETRONICA E REDE BANCARIA PARA POSTERIOR TRANSFERENCIA A CONTA UNICA DO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.04','CONTA UNICA - RECURSOS VINCULADOS COM LIMITE PARA EMPENHO CONTRA ENTREGA','REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA DE RECURSOS VINCULADOS A PAGAMENTO ESPECIFICOS E PARA EMPENHO CONTRA ENTREGSA. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.05','CONTA UNICA - RECURSOS VINCULADOS COM LIMITE DE SAQUE ','REGISTRA A MOVIMENTACAO FINANCEIRA DA CONTA UNICA DE LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.02.06','CONTA UNICA - RECURSOS DA CONTA UNICA APLICADOS','REGISTRA A MOVIMENTACAO FINANCEIRA DE RECURSOS DA CONTA UNICA EM PROCESSO DE APLICACAO E RESGATE PELA PROPRIA UNIDADE GESTORA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.00','CONTA UNICA - SUBCONTA INSS','COMPREENDE A MOVIMENTACAO FINANCEIRA DO INSS JUNTO AO BANCO CENTRAL DO BRASIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.01','CONTA UNICA - INSS','REGISTRA A MOVIMENTACAO FINANCEIRA EM SUBCONTA DO INSS MANTIDA JUNTO AO BANCO CENTRAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.02','CONTA UNICA - CONTROLE DE OBS EMITIDAS (INSS)','REGISTRA O CONTROLE DE ORDENS BANCARIAS EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.03','CONTA UNICA - CONTROLE DE DARF EMITIDOS (INSS)','REGISTRA O CONTROLE DE DARF EMITIDOS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.04','CONTA UNICA - CONTROLE DE GPS EMITIDAS (INSS)','REGISTRA O CONTROLE DE GPS EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.05','CONTA UNICA - CONTROLE DE GRU EMITIDAS (INSS)','REGISTRA O CONTROLE DE GRU EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.06','CONTA UNICA - CONTROLE DE NL EMITIDAS DE FONTE PROPRIA (INSS)','REGISTRA O CONTROLE DE NL EMITIDAS, DECORRENTES DE CLASSIFICACAO DE RECEITAS PROPRIAS, PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.07','CONTA UNICA - CONTROLE DE NL EMITIDAS DE VALORES DE TERCEIROS (INSS)','REGISTRA O CONTROLE DE NL EMITIDAS, DECORRENTES DE CLASSIFICACAO DE VALORES DE TERCEIROS, PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.08','CONTA UNICA - CONTROLE DE DAR EMITIDOS (INSS)','REGISTRA O CONTROLE DE DAR EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.03.09','CONTA UNICA - CONTROLE DE GFIP EMITIDAS (INSS)','REGISTRA O CONTROLE DE GFIP EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.04.00','CONTA UNICA - SUBCONTA DIVIDA PUBLICA','COMPREENDE O VALOR DOS RECURSOS RESERVADOS NO BANCO CENTRAL A DISPOSICAO DA DIVIDA PUBLICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.04.01','CONTA UNICA - DIVIDA PUBLICA','REGISTRA A MOVIMENTACAO FINANCEIRA EM SUBCONTA DA DIVIDA PUBLICA MANTIDA JUNTO AO BANCO CENTRAL DO BRASIL COM A FINALIDADE DE ADMINISTRACAO DA DIVIDA PUBLICA. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.04.02','CONTA UNICA - CONTROLE DE OBS EMITIDAS (DIVIDA PUBLICA)','REGISTRA O CONTROLE DE ORDENS BANCARIAS EMITIDAS PARA POSTERIOR PROCESSO DE CONCILIACAO E RECOMPOSICAO DA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.04.03','CONTA UNICA - REMUNERACAO DAS DISPONIBILIDADES DA DIVIDA PUBLICA','REGISTRA A REMUNERACAO DAS DISPONIBILIDADES DA DIVIDA PUBLICA','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.05.00','BANCOS CONTA MOVIMENTO - RECURSOS DOS FUNDOS CONSTITUCIONAIS','REGISTRA A MOVIMENTACAO FINANCEIRA DO FUNDOS CONSTITUCIONAIS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','COMPREENDE O SOMATORIO DAS DISPONIBILIDADES EXISTENTES EM OUTRAS CONTAS BANCARIAS, QUE NAO SEJAM A CONTA UNICA, AGREGADAS PELOS SUBITENS IDENTIFICATIVOS DOS BANCOS CORRESPONDENTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.01','DEMAIS CONTAS - BANCO CENTRAL DO BRASIL','REGISTRA A MOVIMENTACAO FINANCEIRA DE OUTRA CONTA BANCARIA EXISTENTE NO BANCO CENTRAL DO BRASIL. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.02','DEMAIS CONTAS - BANCO DO BRASIL','REGISTRA A MOVIMENTACAO FINANCEIRA NO BANCO DO BRASIL EM CONTA BANCARIA QUE NAO SEJA A CONTA UNICA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.03','DEMAIS CONTAS - CAIXA ECONOMICA FEDERAL','REGISTRA OS VALORES ARRECADADOS OU RECEBIDOS PELA REDE DE AGENCIAS DA CAIXA ECONOMICA FEDERAL A CONTA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.04','DEMAIS CONTAS - BANCO DA AMAZONIA','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE, ARRECADADOS OU RECEBIDOS PELO BANCO DA AMAZONIA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.05','DEMAIS CONTAS - BANCO DO NORDESTE','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE, ARRECADADOS OU RECEBIDOS PELO BANCO DO NORDESTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.06','DEMAIS CONTAS - BANCO ABN AMRO REAL S/A','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO ABN AMRO REAL S/A.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.07','DEMAIS CONTAS - BANESPA','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANESPA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.08','DEMAIS CONTAS - BANCO DE BRASILIA','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DE BRASILIA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.09','DEMAIS CONTAS - BANCO DO ESTADO DE GOIAS','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DO ESTADO DE GOIAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.10','DEMAIS CONTAS - BANCO ITAU','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO ITAU.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.11','DEMAIS CONTAS - BANCO NOSSA CAIXA','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO NOSSA CAIXA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.12','DEMAIS CONTAS - BANCO DO ESTADO DE RIO GRANDE DO SUL','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DO RIO GRANDE SO SUL','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.13','DEMAIS CONTAS - BANCO DO ESTADO DE SANTA CATARINA','REGISTRA A MOVIMENTACAO DOS RECURSOS DA ENTIDADE ARRECADADOS OU RECEBIDOS PELO BANCO DE SANTA CATARINA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.19.99','DEMAIS CONTAS BANCARIAS','REGISTRA AS ARRECADACOES DE RECEITAS DA ENTIDADE E DE OUTROS VALORES DESTA SOB SUA GUARDA OU RESPONSABILIDADE, ESPECIFICAMENTE QUANDO O BANCO NAO SE ENCONTRA RELACIONADO NAS CONTAS ACIMA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.30.00','REDE BANCARIA - ARRECADACAO','COMPREENDE O SOMATORIO DOS RECURSOS REFERENTES A RECEITAS ARRECADADAS E NAO RECOLHIDAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.30.01','ARRECADACAO DIRETA','REGISTRA OS VALORES DAS RECEITAS ARRECADADAS DIRETAMENTE PELA ENTIDADE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.30.02','ARRECADACAO INDIRETA','REGISTRA OS VALORES DA RECEITA ARRECADADA PELOS AGENTES FINANCEIROS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','COMPREENDE AS APLICACOES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA NACIONAL, QUE SAO PRONTAMENTE CONVERSIVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTAO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANCA DE VALOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.01','LTN','REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES E UNIDADES APLICADAS EM LETRAS DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.02','CTN','REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES E UNIDADES APLICADAS EM CERTIFICADOS DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.03','LFT','REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS EM LETRAS FINANCEIRAS DO TESOURO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.04','CFT','REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES E UNIDADES APLICADOS EM CERTIFICADOS FINANCEIROS DO TESOURO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.05','POUPANCA','REGISTRA O VALOR DAS APLICACOES FINANCEIRAS EM POUPANCAS E SEU RENDIMENTOS (JUROS E ATUALIZACAO MONETARIA) POSTERIORES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.06','FUNDO DE APLICACAO FINANCEIRA','REGISTRA O VALOR DAS APLICACOES FINANCEIRAS EM FUNDO DE APLICACAO E SEUS RENDIMENTOS (JUROS E ATUALIZACAO) POSTERIORES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.07','DEPOSITOS ESPECIAIS REMUNERADOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS ESPECIAIS REMUNERADOS, DECORRENTES DA CONVERSAO DE CRUZADOS NOVOS ANTERIORMENTE BLOQUEADOS PARA CRUZEIROS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.08','FUNDO DE APLICACAO - EXTRAMERCADO','REGISTROS DOS VALORES RELATIVOS A FUNDO DE APLICACAO EXTRA MERCADO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.09','FUNDO DE APLICACAO - EXTRAMERCADO- FAT/FUNCAFE/FNDE','REGISTRAR O VALOR DAS APLICACOES DAS DISPONIBILIDADES FINANCEIRAS DO FAT/ FUNCAFE/FNDE MEDIANTE RECURSOS DOS CONDOMINOS EM CARTEIRA, DE ATIVOS FINANCEIROS DE RENDA FIXA, OBSERVADAS AS LIMITACOES LEGAIS E REGULAMENTARES EM VIGOR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.10','CDB','REGISTRA OS VALORES DAS DISPONIBILIDADES DAS INSTITUICOES, ENTIDADES OU UNIDADES APLICADAS CERTIFICADOS DE DEPOSITOS BANCARIOS.(CDB)','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.11','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA DOS RECURSOS DA CONTA UNICA','REGISTRA O VALOR DAS APLICACOES FINANCEIRAS DE RECURSOS DA CONTA UNICA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.1.50.99','OUTRAS APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','REGISTRA OUTRAS APLICACOES FINANCEIRAS, NAO CLASSIFICADAS EM ITENS ANTERIORE, DAS DISPONIBILIDADES FINANCEIRAS DAS ENTIDADES, INSTITUICOES OU UNIDADES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO..','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.00','RECURSOS LIBERADOS PELO TESOURO','COMPREENDE OS RECURSOS LIBERADOS PELO TESOURO NACIONAL, PARA ATENDER A DESPESAS DO EXERCICIO E DE EXERCICIO ANTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.01','LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DO ENTE FEDERATIVO OU DA CONTA UNICA INSTITUCIONAL DO INSS, ESTABELECIDO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA, PARA ATENDER A DESPESAS COM VINCULACAO DE PAGAMENTO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.02','LIMITE DE SAQUE PARA EMPENHO CONTRA ENTREGA','REGISTRA O VALOR DO LIMITE DE SAQUE DA CONTA UNICA DO ENTE FEDERATIVO OU DA CONTA UNICA INSTITUCIONAL DO INSS, ESTABELECIDO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA, PARA ATENDER A DESPESAS DE EMPENHO DE PAGAMENTO CONTRA ENTREGA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.03','RECURSOS DA PREVIDENCIA SOCIAL','REGISTRA O VALOR A RECEBER DO TESOURO DO ENTE FEDERATIVO REFERENTE A PREVIDENCIA SOCIAL E RECURSOS QUE O INSS TEM A REPASSAR AO TESOURO, RELATIVOS A ARRECADACAO DE BENEFICIOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.04','LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA','REGISTRA O VALOR DO LIMITE DE SAQUE DA SUBCONTA DA DIVIDA PUBLICA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.05','LIMITE DE SAQUE - ENTIDADES TCT','REGISTRA O VALOR DO LIMITE DE SAQUE POR PAGAMENTO A ENTIDADES QUE UTILIZAM A CONTA UNICA, EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.1.2.20.06','LIMITE DE SAQUE BACEN','REGISTRA O VALOR DO LIMITE FINANCEIRO DO BACEN.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - EXTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DE CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.1.01.00','CAIXA - MOEDA ESTRANGEIRA','REGISTRA O SOMATORIO DE NUMERARIOS EM ESPECIE E OUTROS VALORES EM TESOURARIA NO EXTERIOR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.1.02.00','BANCOS - MOEDA ESTRANGEIRA','REGISTRA A LIVRE MOVIMENTACAO DE RECURSOS FINANCEIROS EM MOEDA ESTRANGEIRA MANTIDOS EM CONTAS BANCARIAS NO EXTERIOR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.1.50.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA - MOEDA ESTRANGEIRA','REGISTRA AS APLICACOES FINANCEIRAS DE ALTA LIQUIDEZ EM MOEDA ESTRANGEIRA, QUE SAO PRONTAMENTE CONVERSIVEIS EM VALORES CONHECIDOS DE CAIXA E QUE ESTAO SUJEITAS A UM INSIGNIFICANTE RISCO DE MUDANCA DE VALOR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.1.51.00','APLICACOES FINANCEIRAS - FECHAMENTO DE CAMBIO','REGISTRA O VALOR DAS APLICACOES FINANCEIRAS REFERENTES A FECHAMENTO DE CAMBIO PARA AQUISICAO DE MOEDA ESTRANGEIRA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.1.2.1.52.00','APLICACOES EM DEPOSITOS REALIZAVEIS A CURTISSIMO PRAZO','REGISTRA O VALOR DAS APLICACOES DE DEPOSITOS COM JUROS EM MOEDA ESTRANGEIRA REALIZAVEIS NO CURTISSIMO PRAZO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.0.0.00.00','CREDITOS A CURTO PRAZO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIA E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.0.00.00','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORRAM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.00.00','CLIENTES-EXTRA OFSS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.00','FATURAS/DUPLICATAS A RECEBER ','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.01','FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.02','FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.03','FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO ','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.04','FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.05','FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.06','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.07','FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.08','FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.80','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.95','(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.96','(-) DUPLICATAS DESCONTADAS - EST. REGULADOR','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.97','(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.98','(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.01.99','(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.02.00','FATURAS/DUPLICATAS A FATURAR ','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.1.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS ','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.00.00','CLIENTES-INTRA OFSS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.00','FATURAS/DUPLICATAS A RECEBER ','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.01','FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.02','FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.03','FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO ','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.04','FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.05','FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.06','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.07','FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.08','FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.80','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.95','(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.96','(-) DUPLICATAS DESCONTADAS - EST. REGULADOR','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.97','(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.98','(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.01.99','(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.02.00','FATURAS/DUPLICATAS A FATURAR ','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.2.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS ','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.00.00','CLIENTES INTER-OFSS','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.00','FATURAS/DUPLICATAS A RECEBER ','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER JA FATURADAS DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE, EALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.01','FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.02','FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.03','FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO ','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.04','FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.05','FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.06','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.07','FATURAS/ DUPLICATAS A RECEBER - ESTQ. EM CONSIGNACAO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES EM CONSIGNACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.08','FATURAS/ DUPLICATAS A RECEBER - AGRICULTURA FAMILIAR ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES DA AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.80','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.95','(-) DUPLICATAS DESCONTADAS - EST. ESTRATEGICO','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.96','(-) DUPLICATAS DESCONTADAS - EST. REGULADOR','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADOR DO GOVERNO FEDERAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.97','(-) DUPLICATAS DESCONTADAS - EST. PROPRIOS','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PROPRIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.98','(-) DUPLICATAS DESCONTADAS - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.01.99','(-) DUPLICATAS DESCONTADAS - EST. POR ATACADO','REGISTRA OS VALORES RELATIVOS AS DUPLICATAS DESCONTADAS PROVENIENTES DO FATURAMENTO DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.02.00','FATURAS/DUPLICATAS A FATURAR ','REGISTRA OS VALORES DAS FATURAS/DUPLICATAS A FATURAR, GERALMENTE QUANDO PERTECEM A LOTES DE MERCADORIAS, MATERIAIS OU SERVICOS EM ELABORACAO OU REMETIDOS ANTECIPADAMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.1.3.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS ','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER, CUJOS PRAZOS JA VENCERAM, DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.2.0.00.00','CREDITOS TRIBUTARIOS A RECEBER','COMPREENDE OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.2.1.00.00','CREDITOS TRIBUTARIOS A RECEBER - EXTRA OFSS','REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.2.2.00.00','CREDITOS TRIBUTARIOS A RECEBER - INTRA OFSS','REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.2.3.00.00','CREDITOS TRIBUTARIOS A RECEBER - INTER OFSS','REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.0.00.00','DIVIDA ATIVA TRIBUTARIA','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.1.00.00','DIVIDA ATIVA TRIBUTARIA - EXTRA OFSS','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.1.01.00','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.1.02.00','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.2.00.00','DIVIDA ATIVA TRIBUTARIA - INTRA OFSS','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.2.01.00','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.2.02.00','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.3.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA INSCRITOS, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.3.01.00','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.3.3.02.00','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.4.0.00.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.4.1.00.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES - EXTRA OFSS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.4.2.00.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES - INTRA OFSS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.4.3.00.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES - INTER OFSS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, DERIVADOS DE CLIENTES, REALIZAVEIS NO CURSO DO EXERCICIO SOCIAL SUBSEQUENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.0.00.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.00.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS-EXTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.01.00','EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.02.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.02.01','FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.02.02','FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.03.00','OPERACOES ESPECIAIS','COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.03.01','CREDITOS DE OPERACOES ESPECIAIS A RECEBER','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.03.02','JUROS A RECEBER - OPERACOES ESPECIAIS','REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.03.03','OPERACOES ESPECIAIS SECURITIZADAS','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.03.04','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.03.05','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.04.00','ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.04.01','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.04.02','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.04.03','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.04.04','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.05.00','RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS','REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.06.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.07.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.07.01','EMPRESTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.07.02','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.08.00','EMPRESTIMO COMPULSORIO A RECEBER','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.09.00','EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS',' REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.1.10.00','FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS',' REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.00.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - INTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.01.00','EMPRESTIMOS CONCEDIDOS RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.02.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.02.01','FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.02.02','FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.03.00','OPERACOES ESPECIAIS','COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.03.01','CREDITOS DE OPERACOES ESPECIAIS A RECEBER','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.03.02','JUROS A RECEBER - OPERACOES ESPECIAIS','REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.03.03','OPERACOES ESPECIAIS SECURITIZADAS','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.03.04','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.03.05','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.04.00','ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.04.01','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.04.02','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.04.03','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.04.04','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.05.00','RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS','REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.06.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.07.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.07.01','EMPRESTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.07.02','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.08.00','EMPRESTIMO COMPULSORIO A RECEBER','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.09.00','EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS',' REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.2.10.00','FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS',' REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.00.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.01.00','EMPRESTIMOS CONCEDIDOS RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.02.00','FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.02.01','FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.02.02','FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.03.00','OPERACOES ESPECIAIS','COMPREENDE OS VALORES DAS OPERACOES ESPECIAIS EFETUADAS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A CURTO PRAZO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.03.01','CREDITOS DE OPERACOES ESPECIAIS A RECEBER','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.03.02','JUROS A RECEBER - OPERACOES ESPECIAIS','REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.03.03','OPERACOES ESPECIAIS SECURITIZADAS','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS SECURITIZADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.03.04','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.03.05','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.04.00','ENCARGOS SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','COMPREENDE OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.04.01','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.04.02','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.04.03','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.04.04','ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE FINANCIAMENTOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT,EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.05.00','RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS','REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.06.00','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM CURTO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.07.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIARIOS','COMPREENDE O SOMATORIO DOS DIREITOS A RECEBER A CURTO PRAZO, REFERENTES A CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS PELO RPPS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.07.01','EMPRESTIMOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A EMPRESTIMOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.07.02','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS DIREITOS A RECEBER RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.08.00','EMPRESTIMO COMPULSORIO A RECEBER','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.09.00','EMPRESTIMOS A CONCEDER PELOS AGENTES FINANCEIROS',' REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS A SEREM CONCEDIDOS PELOS AGENTES FINANCEIROS POR AUTORIZACOES LEGAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.6.3.10.00','FINANCIAMENTOS A CONCEDER PELOS AGENTES FINANCEIROS',' REGISTRA A APROPRIACAO DOS VALORES DOS FINANCIAMENTOS, A CURTO PRAZO, A CONCEDER PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.0.00.00','(-) PROVISOES DE CREDITOS A CURTO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.1.00.00','(-) PROVISOES DE CREDITOS A CURTO PRAZO-EXTRA OFSS','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.1.01.00','(-) PROVISAO PARA DEVEDORES DUVIDOSOS ','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.1.02.00','(-) PROVISAO PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.1.03.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS EM DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.1.04.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.2.00.00','(-) PROVISOES DE CREDITOS A CURTO PRAZO - INTRA OFSS','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.2.01.00','(-) PROVISAO PARA DEVEDORES DUVIDOSOS ','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.2.02.00','(-) PROVISAO PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.2.03.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.2.04.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.3.00.00','(-) PROVISOES DE CREDITOS A CURTO PRAZO - INTER OFSS','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.3.01.00','(-) PROVISAO PARA DEVEDORES DUVIDOSOS ','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.3.02.00','(-) PROVISAO PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.3.03.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.2.9.3.04.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.0.0.00.00','DEMAIS CREDITOS E VALORES A CURTO PRAZO','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.0.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - EXTRA OFSS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','COMPREENDE OS VALORES DAS ANTECIPACOES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E DE GRATIFICACOES NATALINAS, ENTRE OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.01','13 SALARIO - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AO 13 SALARIO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.02','1/3 DE FERIAS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A 1/3 DE FERIAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.03','VIAGENS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A VIAGENS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.04','ASSISTENCIA MEDICA - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A ASSISTENCIA MEDICA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.05','SALARIOS E ORDENADOS - ADIANTAMENTO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE A SALARIOS E ORDENADOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.06','BENEFICIOS ADMINISTRADOS P/INSS-ANTECIPACAO','REGISTRA O ADIANTAMENTO A PESSOAL REFERENTE AS DESPESAS ANTECIPADAS PELO INSS AOS SEGURADOS NA FORMA DISPOSTA NO DECRETO 7.223/2010.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.01.99','OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL','REGISTRA OUTROS ADIANTAMENTOS CONCEDIDOS A PESSOAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.02.00','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES DE SUPRIMENTO DE FUNDOS POR MEIO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.03.00','ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.03.01','ADIANTAMENTOS PARA OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.03.02','ADIANTAMENTOS CONCEDIDOS AO INSS','REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.03.03','ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES','REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.03.99','OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.04.00','ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS','REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.05.00','ADIANTAMENTOS A PRESTADORES DE SERVICOS','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.1.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - INTRA OFSS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.03.00','ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.03.01','ADIANTAMENTOS PARA OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.03.02','ADIANTAMENTOS CONCEDIDOS AO INSS','REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.03.03','ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES','REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.03.99','OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.04.00','ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS','REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.05.00','ADIANTAMENTOS A PRESTADORES DE SERVICOS','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.2.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - INTER OFSS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.03.00','ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.03.01','ADIANTAMENTOS PARA OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS ADIANTAMENTOS DE RECURSOS FINANCEIROS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE PELO MINISTERIO DAS RELACOES EXTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.03.02','ADIANTAMENTOS CONCEDIDOS AO INSS','REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA TRANSFERENCIA DE PASSIVOS PARA O INSS EM DECORRENCIA DE ARRECADACAO POR DARF. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.03.03','ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA A DEMAIS UNIDADES','REGISTRA OS RECURSOS A RECEBER DE ADIANTAMENTOS CONCEDIDOS PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA - COFIN/STN PARA OUTRAS UNIDADES, EXCETO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.03.99','OUTROS ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OUTROS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.04.00','ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS','REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.05.00','ADIANTAMENTOS A PRESTADORES DE SERVICOS','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.1.3.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.0.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR/ COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.00.00','TRIBUTOS A RECUPERAR / COMPENSAR - EXTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR /COMPENSAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.01.00','IPI A RECUPERAR/ COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.02.00','ICMS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.03.00','ICMS DIFERIDO','REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.04.00','IRRF A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.05.00','IR E CSLL A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.06.00','IR E CSLL DIFERIDOS','REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.07.00','ISS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.08.00','IPVA A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.09.00','IPTU A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.10.00','ITR A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.11.00','INSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.12.00','PSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.13.00','COFINS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.14.00','PIS/PASEP A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.1.99.00','OUTROS TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.00.00','TRIBUTOS A RECUPERAR / COMPENSAR - INTRA OFSS','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR/ COMPENSAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.01.00','IPI A RECUPERAR/ COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.04.00','IRRF A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.05.00','IR E CSLL A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.06.00','IR E CSLL DIFERIDOS','REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.10.00','ITR A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.11.00','INSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.12.00','PSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.13.00','COFINS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.14.00','PIS/PASEP A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.2.99.00','OUTROS TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.00.00','TRIBUTOS A RECUPERAR / COMPENSAR- INTER OFSS','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.02.00','ICMS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.03.00','ICMS DIFERIDO','REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.07.00','ISS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.08.00','IPVA A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.09.00','IPTU A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.10.00','ITR A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.2.3.99.00','OUTROS TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.0.00.00','CREDITOS A RECEBER POR DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS','COMPREENDE OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DE SERVICOS PUBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA COMO POR MEIO DE DELEGACAO, NAS FORMAS DE CONCESSAO, INCLUSIVE PARCERIAS PUBLICO-PRIVADAS -PPP, PERMISSAO OU AUTORIZACAO AO PARTICULAR DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.00.00','CREDITOS A RECEBER POR DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS - EXTRA OFSS','COMPREENDE OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DE SERVICOS PUBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA, COMO POR MEIO DE DELEGACAO, NAS FORMAS DE CONCESSAO, INCLUSIVE PARCERIAS PUBLICO-PRIVADAS -PPP, PERMISSAO OU AUTORIZACAO AO PARTICULAR DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.01.00','CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS DE TELECOMUNICACOES','COMPREENDE OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES, NAS FORMAS DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA , CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.01.01','TAXAS DE FISCALIZACAO DO FISTEL','REGISTRA OS VALORES A RECEBER REFERENTES AS TAXAS DE FISCALIZACAO DO FISTEL, TAIS COMO TAXAS DE INSTALACAO - TFI, TAXAS DE FUNCIONAMENTO - TFF, ACRESCIMOS MORATORIOS DAS TAXAS DE FISCALIZACAO DO FISTEL E OUTRAS CORRELATAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.01.02','CREDITOS POR DESCENTRALIZACAO DE SERVICOS DE TELECOMUNICACOES','REGISTRA OS VALORES A RECEBER REFERENTES A EXPLORACAO DE SERVICOS DE TELECOMUNICACOES, COMO COMUNICACAO DE MASSA, RADIODIFUSAO, DIREITOS DE USO DE RADIOFREQUENCIA, MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUNICACOES (LGT), JUROS DE TITULOS DE RENDA, CERTIFICACAO DE PRODUTOS, INFORMACOES CIENTIFICAS E TECNOLOGICAS, REGULACAO DA EXPLORACAO DOS SERVICOS E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.01.03','CONTRIBUICAO SOBRE RECEITA DE SERVICOS DE TELECOMUNICACOES','REGISTRA OS VALORES A RECEBER REFERENTES AOS VALORES DAS CONTRIBUICOES DEVIDAS PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.02.00','CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS DE TRANSPORTE PUBLICO','REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS DE TRANSPORTE PUBLICO NAS FORMAS DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA, CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR, O QUAL ESTA SUJEITO AO CONTROLE, FISCALIZACAO E REGULACAO DO PODER PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.3.1.99.00','OUTROS CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS PUBLICOS','REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS NAO CLASSIFICADOS NAS CONTAS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.0.00.00','CREDITOS POR DANOS AO PATRIMONIO','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO DE CONTAS, TOMADA DE CONTAS, PROCESSOS JUDICIAIS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.00.00','CREDITOS POR DANOS AO PATRIMONIO-EXTRA OFSS','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO DE CONTAS, TOMADA DE CONTAS, PROCESSOS JUDICIAIS E OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS ','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.01','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITOS ADMINISTRATIVOS DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.05','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELEIDO EM NORMAS LEGAIS OU DETERMINACAO ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.07','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.08','CREDITOS A RECEBER POR USO INDEVIDO DE COTA','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.09','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL ','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.01.99','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL ','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.02','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL - TOMADA DE CONTAS ESPECIAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANACAO ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.09','CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.10','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE .(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.13','CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.14','CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.15','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.02.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.1.03.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','REGISTRA OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.00.00','CREDITOS POR DANOS AO PATRIMONIO-INTRA OFSS','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO E TOMADA DE CONTAS E OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS ','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.01.99','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL ','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.09','CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.13','CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.02.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.2.03.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','REGISTRA OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.00.00','CREDITOS POR DANOS AO PATRIMONIO-INTER OFSS','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM SINDICANCIA, PRESTACAO E TOMADA DE CONTAS E OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS ','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.01.99','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL ','COMPREENDE OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.09','CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.13','CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.02.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.4.3.03.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','REGISTRA OS VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS JUDICIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.0.00.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.00.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS-EXTRA OFSS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.01.00','DEPOSITOS E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.02.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.03.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.04.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.05.00','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.06.00','DEPOSITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.07.00','DEMAIS DEPOSITOS DO INSS','REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.00','DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A','COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BANCO DO BRASIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.01','DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTES AO PROGRAMA PROGER URBANO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.02','DEPOSITOS ESPECIAIS DO FAT - PROGER RURALNO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTES AO PROGRAMA PROGER RURAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.03','DEPOSITOS ESPECIAIS DO FAT - PRONAF NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTES AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.04','DEPOSITOS ESPECIAIS DO FAT - BENS DE CONSUMO DURAVEIS NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, DESTINADOS AO FINANCIAMENTO DA LINHA DE CREDITO EMERGENCIAL E TEMPORARIA PARA AQUISICAO DE BENS DE CONSUMO DURAVEIS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.05','DEPOSITOS ESPECIAIS DO FAT - HABITACAO NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL CORRESPONDENTE A PROJETOS HABITACIONAIS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.06','DEPOSITOS ESPECIAIS DO FAT - INTEGRAR (FCO) NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, APLICADOS NO PROGRAMA FAT INTEGRAR (FCO).','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.07','DEPOSITOS ESPECIAIS DO FAT - EXPORTAR NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, REFERENTES AO PROGRAMA FAT EXPORTAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.08','DEPOSITOS ESPECIAIS DO FAT - INFRA- ESTRUTURA -BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, CORRESPONDENTE AO PROGRAMA FAT - INFRA-ESTRUTURA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.09','DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL, CORRESPONDENTE AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO-PNMPO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.10','DEPOSITOS ESPECIAIS DO FAT - GIRO -RURAL NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA GIRO-RURAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.11','DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA FAT - INCLUSAO -DIGITAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.12','DEPOSITOS ESPECIAIS DO FAT - FOMENTAR - MGE NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA FAT - FOMENTAR - MGE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.13','DEPOSITOS ESPECIAIS DO FAT - GIRO SETORIAL - MGE NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A., CORRESPONDENTES AO PROGRAMA FAT - GIRO SETORIAL - MGE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.14','DEPOSITOS ESPECIAIS DO FAT - GIRO COOPERATIVO - AGROPECUARIO NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A, CORRESPONDENTE AO PROGRAMA FAT - GIRO COOPERATIVO AGRO-PECUARIO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.09.15','DEPOSITOS ESPECIAIS DO FAT - TURISMO SENIOR NO BANCO DO BRASIL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO BRASIL S/A, CORRESPONDENTES AA LINHA DE CREDITO ESPECIAL FAT - TURISMO SENIOR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.00','DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE','COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BANCO DO NORDESTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.01','DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO DO NORDESTE S/A CORRESPONDENTES AO PROGRAMA PROGER URBANO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.02','DEPOSITOS ESPECIAIS DO FAT - PROGER RURAL NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A, CORRESPONDENTE AO PROGRAMA PROGER RURAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.03','DEPOSITOS ESPECIAIS DO FAT - PRONAF NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A CORRESPONDENTE AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.04','DEPOSITOS ESPECIAIS DO FAT - PROTRABALHO NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A CORRESPONDENTE AO PROGRAMA PROTRABALHO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.05','DEPOSITOS ESPECIAIS DO FAT - ESTIAGEM NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A PARA PROJETOS QUE VISEM ATENDIMENTO AS ESTIAGENS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.06','DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.07','DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE S/A, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.10.08','DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BANCO DO NORDESTE','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DO NORDESTE DO BRASIL, CORRESPONDENTES AO PROGRAMA FAT - INCLUSAO - DIGITAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.00','DEPOSITOS ESPECIAIS DO FAT NO BNDES','COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BNDES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.01','DEPOSITOS ESPECIAIS DO FAT - PROEMPREGO NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL CORRESPONDENTES AO PROGRAMA PROEMPREGO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.02','DEPOSITOS ESPECIAIS DO FAT- MICROCREDITO NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DE DESENVOLVIMENTO ECONOMICO E SOCIAL - BNDES, PARA A CONCESSAO DE CREDITO PARA NEGOCIOS DE PEQUENO PORTE','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.03','DEPOSITOS ESPECIAIS DO FAT-PRONAF - NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL - BNDES, CORRESPONDENTE AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.04','DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL- BNDES, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.05','DEPOSITOS ESPECIAIS DO FAT - FOMENTAR NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL CORRESPONDENTES AO PROGRAMA FAT FOMENTAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.06','DEPOSITOS ESPECIAIS DO FAT - EXPORTAR NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL CORRESPONDENTES AO PROGRAMA FAT EXPORTAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.07','DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL-BNDES, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.08','DEPOSITOS ESPECIAIS DO FAT - GIRO-RURAL NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL-BNDES, CORRESPONDENTES AO PROGRAMA GIRO-RURAIS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.11.09','DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BNDES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO NACIONAL DO DESENVOLVIMENTO ECONOMICO E SOCIAL-BNDES, CORRESPONDENTES AO PROGRAMA FAT - DIGITAL - INCLUSAO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.00','DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL','COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NA CAIXA ECONOMICA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.01','DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL - CEF - CORRESPONDENTE AO PROGRAMA PROGER URBANO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.02','DEPOSITOS ESPECIAIS DO FAT - HABITACAO NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL - CEF - CORRESPONDENTE A PROJETOS HABITACIONAIS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.03','DEPOSITOS ESPECIAIS DO FAT - BENS DE CONSUMO DURAVEIS NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, DESTINADOS AO FINANCIAMENTO DA LINHA DE CREDITO EMERGENCIAL E TEMPORARIA PARA AQUISICAO DE BENS DE CONSUMO DURAVEIS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.04','DEPOSITOS ESPECIAIS DO FAT - REVITALIZACAO NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, APLICADOS NO PROGRAMA FAT REVITALIZACAO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.05','DEPOSITOS ESPECIAIS DO FAT - EXPORTAR NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR -FAT, NA CAIXA ECONOMICA FEDERAL, REFERENTES AO PROGRAMA FAT EXPORTAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.06','DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.07','DEPOSITOS ESPECIAIS DO FAT - PNMPO NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.08','DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAR - INCLUSAO - DIGITAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.09','DEPOSITOS ESPECIAIS DO FAT - VILA-PANAMERICANA NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAR - VILA - PAN AMERICANA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.10','DEPOSITOS ESPECIAIS DO FAT - GIRO-SETORIAL NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES AO PROGRAMA FAT- GIRO - SETORIAL, DESTINADOS A FINANCIAR CAPITAL DE GIRO PARA EMPRESAS INDUSTRIAIS EXPORTADORAS, INTENSIVAS EM MAO-DE-OBRA, PROPORCIONANDO GERACAO OU MANUTENCAO DE EMPREGO E RENDA, CONFORME RESOLUCAO CODE FAT N. 493, DE 15/05/2006.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.12.11','DEPOSITOS ESPECIAIS DO FAT - TURISMO SENIOR NA CEF','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA CAIXA ECONOMICA FEDERAL, CORRESPONDENTES A LINHA DE CREDITO ESPECIAL FAT- TURISMO SENIOR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.13.00','DEPOSITOS ESPECIAIS DO FAT NA FINANCIADORA DE ESTUDOS E PROJETOS - FINEP','COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NA FINANCIADORA DE ESTUDOS E PROJETOS - FINEP.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.13.01','DEPOSITOS ESPECIAIS DO FAT - PMC NA FINANCIADORA DE ESTUDOS E PROJETOS ','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA FINEP - FINANCIADORA DE ESTUDOS E PROJETOS CORRESPONDENTES AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE (FAT - PMC).','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.13.02','DEPOSITOS ESPECIAIS DO FAT - PRO-INOVACAO NA FINANCIADORA DE ESTUDOS E PROJETOS ','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NA FINEP FINANCIADORA DE ESTUDOS E PROJETOS CORRESPONDENTES AO PROGRAMA FAT PRO- INOVACAO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.00','DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA','COMPREENDE OS VALORES DOS DEPOSITOS ESPECIAIS DO FUNDO DE AMPARO AO TRABALHADOR - FAT NO BANCO DA AMAZONIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.01','DEPOSITOS ESPECIAIS DO FAT - PROGER URBANO NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA PROGER URBANO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.02','DEPOSITOS ESPECIAIS DO FAT - PROGER TURISMO NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA PROGER TURISMO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.03','DEPOSITOS ESPECIAIS DO FAT - PROGER RURAL NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA PROGER RURAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.04','DEPOSITOS ESPECIAIS DO FAT - PRONAF - NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR DO MINISTERIO DO DESENVOLVIMENTO AGRARIO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.05','DEPOSITOS ESPECIAIS DO FAT - RURAL NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA, CORRESPONDENTES AO PROGRAMA FAT RURAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.06','DEPOSITOS ESPECIAIS DO FAT - INFRA-ESTRUTURA NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA FAT - INFRA-ESTRUTURA.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.07','DEPOSITOS ESPECIAIS DO FAT - PNMPO NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA NACIONAL DE MICROCREDITO PRODUTIVO ORIENTADO - PNMPO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.08','DEPOSITOS ESPECIAIS DO FAT - INTEGRAR-NORTE NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA INTEGRAR-NORTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.14.09','DEPOSITOS ESPECIAIS DO FAT - INCLUSAO-DIGITAL NO BANCO DA AMAZONIA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS ESPECIAIS DO FAT NO BANCO DA AMAZONIA - BASA, CORRESPONDENTES AO PROGRAMA FAT - INCLUSAO - DIGITAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.1.99.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS ATE TERMINO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.00.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS-INTRA OFSS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.01.00','DEPOSITOS E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.02.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.03.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.04.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.05.00','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.06.00','DEPOSITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.07.00','DEMAIS DEPOSITOS DO INSS','REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.2.99.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS ATE TERMINO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.00.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS-INTER OFSS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.01.00','DEPOSITOS E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.02.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.03.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.04.00','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.05.00','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.06.00','DEPOSITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.07.00','DEMAIS DEPOSITOS DO INSS','REGISTRA OS VALORES DE OUTROS DEPOSITOS DO INSS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.5.3.99.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS ATE TERMINO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.6.0.00.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.6.1.00.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - EXTRA OFSS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.6.2.00.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - INTRA OFSS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.6.3.00.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS - INTER OFSS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA INSCRITOS, EXCETO AS DERIVADAS DE CLIENTES, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.0.00.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.00.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO -EXTRA OFSS','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.01.00','ALUGUEIS A RECEBER','REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.02.00','CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.04.00','VALES, TICKETS E BILHETES','REGISTRA O VALOR DE VALES, TICKETS E BILHETES ADQUIRIDOS PARA FUTURA DISTRIBUICAO AOS SERVIDORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.00','VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO','COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.01','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.02','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.03','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.04','ORDENS BANCARIAS EMITIDAS A COMPENSAR','REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.05','RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR','REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.06','VALORES EM TRANSITO - UG EXTERIOR','REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.07','SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR','REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.06.99','OUTROS VALORES EM TRANSITO','REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.07.00','CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.08.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO','REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.09.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO','REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.10.00','AUXILIO NATALIDADE PAGO A RECUPERAR','REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.11.00','CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS','REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.12.00','CREDITOS A RECEBER POR CESSAO DE PESSOAL','REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.13.00','CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS','REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.14.00','CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.15.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.16.00','CREDITO A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX- SERVIDOR','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE ACERTOS FINANCEIROS COM SERVIDORES E EX-SERVIDORES DO ORGAO, CONFORME DISPOSTO NA LEI 8.112/90.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.17.00','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.18.00','DIVIDENDOS PROPOSTOS A RECEBER','REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.19.00','CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES','REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.20.00','REMUNERACAO DE DEBENTURES A RECEBER','REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.21.00','RECURSOS DA UNIAO','REGISTRA OS RECURSOS DA UNIAO A SEREM RECEBIDOS NA CONTA UNICA DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.22.00','CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.23.00','CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.24.00','TITULOS DO TESOURO NACIONAL A RECEBER','REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.25.00','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.26.00','CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO','REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.27.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.28.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.29.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.30.00','RESULTADO POSITIVO DO BACEN','COMPREENDE OS VALORES RELATIVOS AO RESULTADO POSITIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.30.01','RESULTADO POSITIVO DO BACEN - BALANCO APURADO ','REGISTRA OS VALORES RELATIVOS AO RESULTADO POSITIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31 DE DEZEMBRO DESTA INSTITUICAO A SER PAGO AO TESOURO NACIONAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.30.02','RESULTADO POSITIVO DO BACEN - CUSTOS DAS RESERVAS ','REGISTRA OS VALORES RELATIVOS AO RESULTADO POSITIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO AO TESOURO NACIONAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.31.00','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.32.00','TITULOS RECOMPRADOS A CANCELAR',' REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.1.99.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO','REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.00.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO-INTRA OFSS','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.01.00','ALUGUEIS A RECEBER','REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.02.00','CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.00','VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO','COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.01','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.02','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.03','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.04','ORDENS BANCARIAS EMITIDAS A COMPENSAR','REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.05','RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR','REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.06','VALORES EM TRANSITO - UG EXTERIOR','REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.07','SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR','REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.06.99','OUTROS VALORES EM TRANSITO','REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.07.00','CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.08.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO','REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.09.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO','REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.10.00','AUXILIO NATALIDADE PAGO A RECUPERAR','REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.11.00','CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS','REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.12.00','CREDITOS A RECEBER POR CESSAO DE PESSOAL','REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.13.00','CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS','REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.14.00','CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.15.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.18.00','DIVIDENDOS PROPOSTOS A RECEBER','REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.19.00','CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES','REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.20.00','REMUNERACAO DE DEBENTURES A RECEBER','REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.22.00','CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.23.00','CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.24.00','TITULOS DO TESOURO NACIONAL A RECEBER','REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.25.00','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.26.00','CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO','REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.27.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.28.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.29.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.31.00','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.32.00','TITULOS RECOMPRADOS A CANCELAR',' REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.33.00','RECURSOS FINANCEIROS DIFERIDOS','COMPREENDE O VALOR DO SALDO FINANCEIRO REMANESCENTE DO FINAL DO EXERCICIO QUE CONSTITUIRA ANTECIPACAO DE COTA, REPASSE OU SUB-REPASSE NO EXERCICIO SEGUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.33.01','COTA CONCEDIDA DIFERIDA','REGISTRA A PARCELA DE RECURSOS FINANCEIROS, NAO UTILIZADA DURANTE O EXERCICIO, TRANSFERIDOS DE UM OGAO SETORIAL DE PROGRAMACAO FINANCEIROA PARA OUTRO, MAIS O LIMITE DE RP CONCEDIDO, MENOS O LIMITE DE RP RECEBIDO, CONSTITUINDO O TOTAL EM ANTECIPACAO DE COTA DO EXERCICIO SEGUINTE.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.33.02','REPASSE CONCEDIDO DIFERIDO','REGISTRA A PARCELA DE RECURSOS FINANCEIROS LIBERADA PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO PELAS UNIDADES, CONSTITUINDO ANTECIPACAO DE REPASSE. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.33.03','SUB-REPASSE CONCEDIDO DIFERIDO','REGISTRA A PARCELA DE RECURSOS FINANCEIROS LIBERADA PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO PELAS UNIDADES, CONSTITUINDO ANTECIPACAO DE SUB-REPASSE. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.2.99.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO','REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.00.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO -INTER OFSS','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.01.00','ALUGUEIS A RECEBER','REGISTRA OS VALORES A RECEBER DECORRENTES DE CONTRATOS DE ALUGUEL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.02.00','CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS','REGISTRA OS VALORES A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR REFERENTES A INDENIZACOES PELO PAGAMENTO DE SINISTROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.00','VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO','COMPREENDE O SOMATORIO DOS VALORES CONTABILIZADOS INDEVIDAMENTE EM CONTA BANCARIA, GUIA DE RECEBIMENTO E ORDENS BANCARIAS EMITIDAS A COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.01','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS ESTORNADAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.02','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS A CONVENIO ESTORNADAS, CUJO FINANCEIRO NAO INGRESSOU NA CONTA UNICA DA UG.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.03','VALORES A RECEBER POR GRU DECORRENTES DE DESPESAS COM OBRIGACOES EXTERNAS','REGISTRA OS VALORES A RECEBER POR MEIO DE GRU DECORRENTES DE DESPESAS VINCULADAS COM OBRIGACOES EXTERNAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.04','ORDENS BANCARIAS EMITIDAS A COMPENSAR','REGISTRA OS VALORES RELATIVOS AS ORDENS BANCARIAS EMITIDAS, EM TRANSITO OU A COMPENSAR PELO AGENTE FINANCEIRO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.05','RESTITUICOES DE RECEITAS EFETUADAS POR GRU A CLASSIFICAR','REGISTRA OS VALORES RELATIVOS AS GUIAS DE RECEBIMENTO EMITIDAS, EM TRANSITO, A COMPENSAR PELO AGENTE FINANCEIRO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.06','VALORES EM TRANSITO - UG EXTERIOR','REGISTRA O VALOR EM TRANSITO CORRESPONDENTE A TRANSFERENCIAS FINANCEIRAS ENTRE UG DO PAIS E DO EXTERIOR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.07','SAQUES POR CARTAO DE PAGAMENTO A CLASSIFICAR','REGISTRA OS VALORES A CLASSIFICAR DE SAQUES NA CONTA UNICA POR AGENTES CREDENCIADOS PELA UNIDADE GESTORA PENDENTES DE CLASSIFICACAO. QUANDO DA OCORRENCIA DE SAQUE SEM A DEVIDA LIQUIDACAO DA DESPESA GERARA SALDO NESTA CONTA. PARA EVIDENCIAR ESSE FATO, DEVE SER REGISTRADA RESTRICAO CONTABIL N. 013.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.06.99','OUTROS VALORES EM TRANSITO','REGISTRA A TRANSFERENCIA DE SALDOS BANCARIOS ENTRE CONTAS DA UG, ENTRE UGS DE MESMA GESTAO OU ENTRE CONTA UNICA DO INSS E DO TESOURO NACIONAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.07.00','CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.08.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO','REGISTRA OS VALORES RELATIVOS AO SALARIO-FAMILIA, INCLUIDOS EM FOLHAS DE PAGAMENTO, PAGOS AOS EMPREGADOS (CLT), COM FILHOS MENORES, A COMPENSAR COM AS CONTRIBUICOES DEVIDAS PELO EMPREGADOR A PREVIDENCIA SOCIAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.09.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO','REGISTRA OS SALARIOS PAGOS AS SERVIDORAS GESTANTES, REGIDAS PELA CLT NO PERIODO QUE PERDURAR A LICENCA MATERNIDADE, PREVISTA EM LEI, A DEDUZIR DAS OBRIGACOES SOCIAIS DEVIDAS PELOS ORGAOS E ENTIDADES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.10.00','AUXILIO NATALIDADE PAGO A RECUPERAR','REGISTRA OS VALORES RELATIVOS A AUXILIO NATALIDADE, PAGOS AOS EMPREGADOS REGIDOS PELA CLY, QUANDO DO NASCIMENTO DE FILHOS DESTES, A RECUPERAR, POR SE TRATAR DE OBRIGACOES DA PREVIDENCIA SOCIAL.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.11.00','CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS','REGISTRA OS SALARIOS PAGOS AOS SERVIDORES, REGIDOS PELA CLT, A TITULO DE AUXILIO DOENCA/ACIDENTES, PREVISTO EM LEI, A SEREM REEMBOLSADOS PELO INSS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.12.00','CREDITOS A RECEBER POR CESSAO DE PESSOAL','REGISTRA OS VALORES DE CREDITOS A RECEBER TAIS COMO: FOLHA DE PAGAMENTO, DESPESA DE TRANSPORTE, ALIMENTACAO E OUTRAS RELATIVAS A CESSAO DE PESSOAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.13.00','CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS','REGISTRA OS VALORES A RECEBER DECORRENTES DA CESSAO DE AREAS PUBLICAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.14.00','CREDITOS A RECEBE DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS OU IMOVEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.15.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE PAGAMENTOS DE DESPESAS DE TERCEIROS DECORRENTES DE CLAUSULAS CONTRATUAIS, TAIS COMO: AGUA, LUZ, TELEFONE, INSTALACOES, TRANSPORTE E ALUGUEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.18.00','DIVIDENDOS PROPOSTOS A RECEBER','REGISTRA OS VALORES DOS DIVIDENDOS A QUE A EMPRESA TENHA DIREITO, EM FUNCAO DE PARTICIPACOES EM OUTRAS EMPRESAS, QUANDO TAIS EMPRESAS JA TENHAM REGISTRADO NA DEMONSTRACAO DE LUCROS OU PREJUIZOS ACUMULADOS A PARCELA DE DIVIDENDOS PROPOSTOS A DISTRIBUIR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.19.00','CREDITOS A RECEBER DECORRENTES DE VALORES ARRECADADOS POR OUTRAS ENTIDADES','REGISTRA OS CREDITOS A RECEBER REFERENTE A VALORES ARRECADADOS POR OUTRAS ENTIDADES DECORRENTES DE DESCENTRALIZACAO DE COBRANCA DE VALORES.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.20.00','REMUNERACAO DE DEBENTURES A RECEBER','REGISTRA OS VALORES DAS REMUNERACOES DE DEBENTURES A RECEBER.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.22.00','CREDITOS ORIUNDOS DOS ENCARGOS CAPACID. EMERGENCIAL ECE','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DOS MONTANTES ORIGINADOS DOS ENCARGOS CAPACID. EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.23.00','CREDITOS ORIUNDOS DA AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - EAE','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DE AQUISICAO DE ENERGIA ELETRICA EMERGENCIAL - ECE, REGULAMENTADO PELA RESOLUCAO ANEEL Nº 249/2000.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.24.00','TITULOS DO TESOURO NACIONAL A RECEBER','REGISTRA OS VALORES A RECEBER REFERENTES A TITULOS DO TESOURO NACIONAL A SEREM EMITIDOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.25.00','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES RELATIVOS A CREDITOS DA ENTIDADE ORIUNDOS DE CREDITOS EM LIQUIDACAO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.26.00','CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO','REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.27.00','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.28.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ENTIDADES FEDERAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.29.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','REGISTRA OS VALORES A RECEBER A CURTO PRAZO, DECORRENTES DE DIREITOS JUNTO A ESTADOS, DF E MUNICIPIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.31.00','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.32.00','TITULOS RECOMPRADOS A CANCELAR',' REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A TITULOS RESGATADOS E QUE ESTEJAM AGUARDANDO AUTORIZACAO PARA CANCELAMENTO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.8.3.99.00','OUTROS CREDITOS A RECEBER E VALORES A CURTO PRAZO','REGISTRA OUTROS CREDITOS RECEBER E VALORES A CURTO PRAZO, PARA OS QUAIS NAO TENHAM CONTAS ESPECIFICAS NESTE SUBGRUPO DE CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.0.00.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A CURTO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.00.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A CURTO PRAZO -EXTRA OFSS','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.01.00','(-) PROVISAO PARA PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.02.00','(-) PROVISOES PARA PERDAS EM CREDITOS POR DANOS AO PATRIMONIO','COMPREENDE OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.02.01','(-) PROVISAO PARA PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.02.02','(-) PROVISAO PARA PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.03.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.1.99.00','(-) OUTRAS PROVISOES DE DEMAIS CREDITOS E VALORES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.00.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A CURTO PRAZO-INTRA OFSS','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.01.00','(-) PROVISAO PARA PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.02.00','(-) PROVISOES PARA PERDAS EM CREDITOS POR DANOS AO PATRIMONIO','COMPREENDE OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.02.01','(-) PROVISAO PARA PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.02.02','(-) PROVISAO PARA PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.03.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.2.99.00','(-) OUTRAS PROVISOES DE DEMAIS CREDITOS E VALORES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.00.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A CURTO PRAZO-INTER OFSS','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS E VALORES A CURTO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.01.00','(-) PROVISAO PARA PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO CONCEDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.02.00','(-) PROVISOES PARA PERDAS EM CREDITOS POR DANOS AO PATRIMONIO','COMPREENDE OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS OU APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.02.01','(-) PROVISAO PARA PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.02.02','(-) PROVISAO PARA PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.03.00','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, EXCETO AS DERIVADAS DE CLIENTES DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.3.9.3.99.00','(-) OUTRAS PROVISOES DE DEMAIS CREDITOS E VALORES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE DEMAIS CREDITOS E VALORES A CURTO PRAZO, NAO CLASSIFICADAS ANTERIORMENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.0.0.00.00','INVESTIMENTOS E APLICACOES TEMPORARIAS','COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, ALEM DAS APLICACOES TEMPORARIAS EM METAIS PRECIOSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.0.00.00','TITULOS E VALORES MOBILIARIOS','COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.00.00','TITULOS E VALORES MOBILIARIOS-EXTRA OFSS','COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS ATE O FINAL DO EXERCICIO SEGUINTE.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.01.00','TITULOS DA DIVIDA AGRARIA - TDA','REGISTRA OS VALORES RELATIVOS AOS TITULOS DA DIVIDA AGRARIA, EMITIDOS E EM CIRCULACAO, PARA FINS DE INDENIZACOES DE PROPRIEDADES RURAIS, COM OBJETIVO DE REFORMA AGRARIA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.02.00','TITULOS DA DIVIDA - RESERVA BACEN','REGISTRA OS VALORES DE TITULOS DA RESERVA DO BACEN, EMITIDOS POR GOVERNOS OU ORGANISMOS INTERNACIONAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.03.00','TITULOS PUBLICOS - MERCADO ABERTO ','COMPREENDE O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.03.01','TITULOS PUBLICOS - MERCADO ABERTO (EXCETO FSB)','REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES, EXCETO AQUELES EM FAVOR DO FUNDO SOBERANO DO BRASIL (FSB). ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.03.02','TITULOS PUBLICOS - MERCADO ABERTO (FSB)','REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES, EM FAVOR DO FUNDO SOBERANO DO BRASIL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.04.00','ACOES','COMPREENDE OS VALORES DAS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.04.01','ACOES - FAD/FND','REGISTRA AS ACOES DEPOSITADAS NO FAD E/OU FND E AS ALIENAVEIS POR MEIO DE ADESAO A OFERTA PUBLICA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.04.02','DEMAIS ACOES','REGISTRA OS VALORES DAS DAS DEMAIS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.05.00','BONUS','REGISTRA OS BONUS, COMO CUPONS DE BONUS DA UNESCO, DESTINADOS A PAGAMENTO DE BOLSAS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.06.00','COTAS DO FUNDO NACIONAL DE DESENVOLVIMENTO (FND)','REGISTRA OS VALORES PERTINENTES AS COTAS DO FND, SUBSCRITAS PELA UNIAO OU PELA ADMINISTRACAO FEDERAL INDIRETA (DECRETO NR. 93.538, DE 06.11.86). ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.00','DERIVATIVOS','COMPREENDE OS CREDITOS RELATIVOS A OPERACOES COM DERIVATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.01','OPERACOES COM DERIVATIVOS - SWAP','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS SWAP. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.02','OPERACOES COM DERIVATIVOS - FORWARD','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS FORWARD .','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.03','OPERACOES COM DERIVATIVOS - FUTUROS','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS FUTUROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.04','OPERACOES COM DERIVATIVOS - TERMO','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS TERMO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.05','OPERACOES COM DERIVATIVOS - BACEN ','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.06','OPERACOES COM OPCOES DE COMPRA','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM OPCOES DE COMPRA (CALLS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.07.07','OPERACOES COM OPCOES DE VENDA','REGISTRA OS VALORES A RECEBER DECORRENTES DE OPERACOES COM OPCOES DE VENDA (PUTS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.08.00','TITULOS E VALORES MOBILIARIOS EM TRANSITO','REGISTRA OS TITULOS E VALORES MOBILIARIOS EM TRANSITO, DEVIDO A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.00','APLICACOES EM SEGMENTO DE RENDA FIXA','COMPREENDE O SOMATORIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, DA RESOLUCAO CMN N° 3.790/2009.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.01','TITULOS DE RESPONSABILIDADE DO TESOURO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO TESOURO NACIONAL, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO I, ALINEA A(INCLUI OPERACOES COMPROMISSADAS) DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.02','TITULOS DE RESPONSABILIDADE DO BANCO CENTRAL','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM TITULOS DE EMISSAO DO BANCO CENTRAL DO BRASIL; SALDOS REMANESCENTES PARA RESGATES, CONSIDERANDO QUE O BC NAO EMITE MAIS TITULOS DA DIVIDA PUBLICA- ART 34 LC 101/2000.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.03','FUNDOS DE INVESTIMENTO EM RENDA FIXA','APRESENTAR OS INVESTIMENTOS REALIZADOS PELOS RPPS, EM FUNDOS DE INVESTIMENTOS EM RENDA FIXA, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.04','FUNDOS DE INVESTIMENTOS PREVIDENCIARIOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO III, ALINEA B DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.05','FUNDOS DE INVESTIMENTOS REFERENCIADOS',' REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS REFERENCIADOS, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO III, ALINEA A, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.06','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS ','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM DIREITO CREDITORIO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO VI E VII, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.07','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO, EFETUADOS EM CONFORMIDADE COM O ART. 6º, INCISO I,ALINEA B DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.09.08','OPERACOES COMPROMISSADAS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM OPERACOES COMPROMISSADAS, EFETUADOS EM CONFORMIDADE COM O ART.6º , INCISO II, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.10.00','APLICACOES EM SEGMENTO DE RENDA VARIAVEL','COMPREENDE O SOMATORIO DOS INVESTIMENTOS REALIZADOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, DA RESOLUCAO CMN N° 3.790/2009.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.10.01','FUNDOS DE INVESTIMENTOS PREVIDENCIARIOS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS PREVIDENCIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO I, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.10.02','FUNDOS DE ACOES ','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE ACOES,EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO III, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.10.03','FUNDO MULTIMERCADO ','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE MULTIMERCADO, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO IV, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.10.04','FUNDOS DE INDICES REFERENCIADOS EM ACOES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INDICES REFERENCIADOS EM ACOES, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCI SO II, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.10.05','FUNDOS DE INVESTIMENTOS EM PARTICIPACOES','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDOS DE INVESTIMENTOS EM PARTICIPACOES, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO V, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.11.00','FUNDOS DE INVESTIMENTOS IMOBILIARIOS - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM FUNDO DE INVESTIMENTOS IMOBILIARIOS, EFETUADOS EM CONFORMIDADE COM O ART. 7º, INCISO VI, DA RESOLUCAO CMN N° 3.790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.12.00','TITULOS E VALORES EM ENQUADRAMENTO - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM DESACORDO COM AS REGRAS ESTABELECIDAS PELA RESOLUCAO CMN Nº 3790/2009, ARTIGO 25. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.13.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, EM ATIVOS NAO SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3790/2009. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.1.1.14.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','REGISTRA OS INVESTIMENTOS REALIZADOS PELO RPPS, COM RECURSOS DA TAXA DE ADMINISTRACAO, SUJEITOS AS REGRAS DA RESOLUCAO CMN Nº 3790/2009.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.2.0.00.00','APLICACAO TEMPORARIA EM METAIS PRECIOSOS','COMPREENDE AS APLICACOES DE RECURSOS EM METAIS PRECIOSOS, NAO DESTINADOS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.2.1.00.00','APLICACAO TEMPORARIA EM METAIS PRECIOSOS-EXTRA OFSS','COMPREENDE AS APLICACOES DE RECURSOS EM METAIS PRECIOSOS, NAO DESTINADOS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.2.1.01.00','APLICACAO TEMPORARIA EM OURO','REGISTRA AS APLICACOES DE RECURSOS EM OURO, DEPOSITADOS NO BANCO CENTRAL DO BRASIL,DE ACORDO COM A LEI Nº 4595/64.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.2.1.99.00','APLICACAO TEMPORARIA EM OUTROS METAIS PRECIOSOS','REGISTRA O VALOR REFERENTE AS APLICACOES EM DEMAIS METAIS PRECIOSOS, DEPOSITADOS NO BANCO CENTRAL DO BRASIL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.9.0.00.00','(-) PROVISOES DE INVESTIMENTOS E APLICACOES TEMPORARIAS','COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.9.1.00.00','(-) PROVISOES DE INVESTIMENTOS TEMPORARIOS E APLICACOES TEMPORARIAS -EXTRA OFSS','COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.9.1.01.00','(-) PROVISAO PARA PERDAS EM TITULOS E VALORES MOBILIARIOS','REGISTRA OS VALORES DE PROVISOES PARA PERDAS EM TITULOS E VALORES MOBILIARIOS A CURTO PRAZO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.4.9.1.02.00','(-) PROVISAO PARA PERDAS EM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE PROVISOES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.0.0.00.00','ESTOQUES','COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.0.00.00','MERCADORIAS PARA REVENDA','COMPREENDE TODAS AS MERCADORIAS ADQUIRIDAS DE TERCEIROS PARA REVENDA, QUE NAO SOFREM NENHUM PROCESSO DE TRANSFORMACAO NA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.00.00','MERCADORIAS PARA REVENDA - EXTRA OFSS','COMPREENDE TODOS OS PRODUTOS ADQUIRIDOS DE TERCEIROS PARA REVENDA, QUE NAO SOFREM NENHUM PROCESSO DE TRANSFORMACAO NA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.01.00','MERCADORIAS - ESTOQUES PROGRAMAS PROPRIOS','COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A PROGRAMAS PROPRIOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.01.01',' MERCADORIAS PARA VENDA OU REVENDA','REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOACOES RELATIVAS A ESTOQUES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.01.02','MERCADORIAS EM CONSIGNACOES PARA REVENDA','REGISTRA O VALOR DAS MERCADORIAS EM CONSIGNACAO PARA REVENDA - REDE SOMAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.01.03',' MERCADORIAS - ESTOQUE POR ATACADO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA - ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.02.00','MERCADORIAS - ESTOQUES PUBLICOS','COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDAS RELATIVAS A ESTOQUES PUBLICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.02.01','MERCADORIAS - ESTOQUES ESTRATEGICOS ','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.02.02','MERCADORIAS - ESTOQUE REGULADORES PGPM','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES- PGPM DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.02.03','MERCADORIAS - ESTOQUE EGF ESP. PGPM(DEP. JUDICIAL)','REGISTRA O VALOR DAS MERCADORIAS DE EGFS ESPECIAIS ORIUNDOS DO BANCO DO BRASIL, PARA REVENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.02.04','MERCADORIAS - ESTOQUES AGRICULTURA FAMILIAR','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.03.00','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES PUBLICOS ','COMPREENDE O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA, RELATIVAS A ESTOQUES PUBLICOS EM ARMAZENS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.03.01','MERCADORIAS EM ARMAZENS DE TERCEIROS PARA REVENDA','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES PROPRIOS EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.03.02','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES ESTRATEGICOS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.03.03','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES REGULADORES PGPM','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES - PGPM DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.03.04','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES POR ATACADO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES POR ATACADO MANTIDOS EM EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.1.1.03.05','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES AGRICULTURA FAMILIAR','REGISTRA O VALOR DAS MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR EM ARMAZENS DE TERCEIROS, ORIUNDAS DE AQUISICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.2.0.00.00','PRODUTOS E SERVICOS ACABADOS','COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO; E OS SERVICOS ACABADOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.2.1.00.00','PRODUTOS E SERVICOS ACABADOS - EXTRA OFSS','COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO; E OS SERVICOS ACABADOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.2.1.01.00','PRODUTOS ACABADOS','REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.2.1.02.00','SERVICOS ACABADOS','REGISTRA OS VALORES PERTINENTES A SERVICOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.3.0.00.00','PRODUTOS E SERVICOS EM ELABORACAO','COMPREENDE OS PRODUTOS E SERVICOS EM ANDAMENTO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.3.1.00.00','PRODUTOS E SERVICOS EM ELABORACAO - EXTRA OFSS','COMPREENDE OS PRODUTOS E SERVICOS EM ANDAMENTO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.3.1.01.00','PRODUTOS EM ELABORACAO ','REGISTRA A TOTALIDADE DAS MATERIAS-PRIMAS JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.3.1.02.00','SERVICOS EM ELABORACAO','REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVICOS EM ELABORACAO NAO CONCLUIDOS NA DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.4.0.00.00','MATERIAS-PRIMAS','COMPREENDE O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.4.1.00.00','MATERIAS-PRIMAS - EXTRA OFSS','COMPREENDE O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.4.1.01.00','MATERIAS-PRIMAS - ARMAZENS PROPRIOS','REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS PROPRIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.4.1.02.00','MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS','REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.0.00.00','MATERIAIS EM TRANSITO','COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERENCIA PARA OUTRAS UNIDADES DA ENTIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.00.00','MATERIAIS EM TRANSITO - EXTRA OFSS','COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERENCIA PARA OUTRAS UNIDADES DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.01.00','ESTOQUES MERCADORIAS PARA REVENDA EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS A ESTOQUES PROPRIOS DA ENTIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.02.00','ESTOQUES POR ATACADO EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DO ESTOQUE POR ATACADO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.03.00','ESTOQUES ESPECIAIS DE PRODUTOS EM PROCESSO DE AQUISICAO ','REGISTRA O VALOR DOS PRODUTOS EM PROCESSO DE AQUISICAO RELATIVOS A RESTOS A PAGAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.04.00','ESTOQUES PUBLICOS ESTRATEGICOS EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES ESTRATEGICOS DE NATUREZA PUBLICA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.05.00','ESTOQUES PUBLICOS REGULADORES-PGPM EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES REGULADORES - PGPM.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.06.00','ESTOQUES PUBLICOS AGRICULTURA FAMILIAR EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES DA AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.07.00','MERCADORIAS PARA DOACAO EM TRANSITO','REGISTRA O VALOR DAS MERCADARIAS PARA DOACAO, EM TRANSITO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.08.00','ESTOQUES AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO','REGISTRA O VALOR DE MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.09.00','PRODUTOS PARA PESQUISA EM TRANSITO','REGISTRA O VALOR DOS MATERIAIS EM TRANSITO RELATIVOS AS TRANSFERENCIAS ENTRE UG, DE PRODUTOS PARA PESQUISA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.10.00','MATERIAL DE CONSUMO EM TRANSITO','COMPREENDE OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.10.01','MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DO EXERCICIO','REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.5.1.10.02','MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO ANTERIOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.0.00.00','ALMOXARIFADO','COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.00.00','ALMOXARIFADO - EXTRA OFSS','COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.01.00','MATERIAL DE CONSUMO','REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.02.00','GENEROS ALIMENTICIOS','REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.03.00','MATERIAIS DE CONSTRUCAO','REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.04.00','MATERIAIS DE TELECOMUNICACOES','REGISTRA OS VALORES DOS MATERIAIS DE TELECOMUNICACOES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.05.00','AUTOPECAS','REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.06.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.07.00','MATERIAIS GRAFICOS','REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.08.00','MATERIAL DE EXPEDIENTE','REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.09.00','MATERIAIS A CLASSIFICAR','REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.10.00',' ESTOQUE SOBRESSALENTES A ALIENAR','REGISTRA OS VALORES DE BENS SOBRESSALENTES QUE ESTEJAM DISPONIVEIS PARA ALIENACAO SOB DIVERSAS FORMAS (VENDA, LEILA, ETC)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.11.00','ESTOQUE SOBRESSALENTES EM REPARO','REGISTRA OS VALORES DE PECAS EM FASE DE RECONDICIONAMENTO QUE FORAM SUBSTITUIDAS POR MANUTENCAO PERIODICA OU QUEBRA. APOS REVISAO, RETORNARAO AO ESTOQUE DE PECAS DE REPOSICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.6.1.12.00','ESTOQUE SOBRESSALENTES A REPARAR ','REGISTRA OS VALORES DE PECAS QUE FORAM SUBSTITUIDAS POR MANUTENCAO PERIODICA OU QUEBRA E AINDA NAO FORAM ENCAMINHADAS PARA REPARO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.7.0.00.00','ADIANTAMENTOS A FORNECEDORES','COMPREENDE OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.7.1.00.00','ADIANTAMENTOS A FORNECEDORES - EXTRA OFSS','REGISTRA OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.0.00.00','OUTROS ESTOQUES','COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.00.00','OUTROS ESTOQUES - EXTRA OFSS','COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.01.00','MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.02.00','ESTOQUES PARA DISTRIBUICAO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, DESTINADO A DISTRIBUICAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.02.01','MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.02.02','MATERIAL DE CONSUMO - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE ,MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.02.03','MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE, DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.02.04','MEDICAMENTOS - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES RELATIVOS A AQUISICOES E OU TRANSFERENCIAS DE MEDICAMENTOS, PARA A FORMACAO DE ESTOQUE, MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.02.05','ESTOQUE DE MATERIAIS PARA PREMIACOES','REGISTRA OS VALORES DAS PREMIACOES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.03.00','ESTOQUES PARA DOACAO E/OU PERMUTA','COMPREENDE O VALOR DAS MERCADORIAS EM ESTOQUES PARA DOACAO E/OU PERMUTA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.03.01','MERCADORIAS PARA DOACAO - ESTOQUE INTERNO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS PROPRIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.03.02','MERCADORIAS PARA DOACAO - ARMAZEM DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.03.03','MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ESTOQUE INTERNO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS PROPRIOS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.03.04','MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ARMAZEM DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS DE TERCEIROS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.03.05','MERCADORIAS PARA PERMUTA','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS COM A FINALIDADE DE PERMUTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.04.00','ESTOQUES DE PRODUTOS PARA PESQUISA E ENSINO','COMPREENDE O VALOR DO MATERIAL EM ESTOQUE, RELATIVO A ANIMAL, VEGETAL OU MINERAL, DESTINADO A PESQUISA E ENSINO DA UNIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.04.01','ANIMAIS','REGISTRA O VALOR DOS ANIMAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.04.02','VEGETAIS','REGISTRA O VALOR DO VEGETAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE, BEM COMO PRODUTOS INDUSTRIALIZADOS TAIS COMO: VINHOS, SUCOS , VINAGRES E PUBLICACOES TECNICAS DE PESQUISAS ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.04.03','MINERAIS','REGISTRA O VALOR DOS MINERAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.05.00','IMPORTACOES EM ANDAMENTO','COMPREENDE O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.05.01','IMPORTACOES EM ANDAMENTO DO EXERCICIO','REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.05.02','IMPORTACOES EM ANDAMENTO DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.06.00','CONSTRUCOES CIVIS','COMPREENDE OS VALORES DOS IMOVEIS QUE DEVAM SER COLOCADOS A VENDA OU QUE TENHAM SIDO ADQUIRIDOS PARA VENDA OU REVENDA, PODENDO A COMERCIALIZACAO SER OU NAO OBJETO PRINCIPAL DA EMPRESA, ENTIDADE, INSTITUICAO OU ORGAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.06.01','TERRENOS','REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.06.02','PROJETOS','REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOS DE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZACOES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.06.03','OBRAS EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.06.04','OBRAS CONCLUIDAS A COMERCIALIZAR','REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICACOES CONCLUIDAS QUE DEVERAO SER COLOCADAS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.06.05','CUSTOS ACESSORIOS DE CONSTRUCAO CIVIL','REGISTRA OS VALORES DE SEGUROS, REMUNERACOES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZACOES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.8.1.98.00','ESTOQUES DIVERSOS','REGISTRA OS ESTOQUES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.9.0.00.00','(-) PROVISAO PARA ESTOQUES','COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DA PROVISAO PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.9.1.00.00','(-) PROVISAO PARA ESTOQUES - EXTRA OFSS','COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DA PROVISAO PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.9.1.01.00','(-) PROVISAO PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.5.9.1.02.00','(-) PROVISAO PARA REDUCAO AO VALOR DE MERCADO','REGISTRA A PROVISAO PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.0.0.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO APOS O TERMINO DO EXERCICIO SEGUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.1.0.00.00','PREMIOS DE SEGUROS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE PREMIOS DE SEGURO A APROPRIAR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.1.1.00.00','PREMIOS DE SEGUROS A APROPRIAR - EXTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE PREMIOS DE SEGURO A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.2.0.00.00','VPD FINANCEIRAS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.2.1.00.00','VPD FINANCEIRAS A APROPRIAR - EXTRA OFSS','COMPREENDE OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.2.2.00.00','VPD FINANCEIRAS A APROPRIAR - INTRA OFSS','COMPREENDE OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.2.3.00.00','VPD FINANCEIRAS A APROPRIAR - INTER OFSS','COMPREENDE OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.3.0.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.3.1.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - EXTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.3.2.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - INTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.3.3.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - INTER OFSS','REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR. COMPREENDE REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.4.0.00.00','ALUGUEIS PAGOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.4.1.00.00','ALUGUEIS PAGOS A APROPRIAR - EXTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.4.2.00.00','ALUGUEIS PAGOS A APROPRIAR - INTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.4.3.00.00','ALUGUEIS PAGOS A APROPRIAR - INTER OFSS','REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR. COMPREENDE REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.5.0.00.00','TRIBUTOS PAGOS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.5.1.00.00','TRIBUTOS PAGOS A APROPRIAR - EXTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.5.2.00.00','TRIBUTOS PAGOS A APROPRIAR - INTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.5.3.00.00','TRIBUTOS PAGOS A APROPRIAR - INTER OFSS','REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.6.0.00.00','CONTRIBUICOES CONFEDERATIVAS A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE CONTRIBUICOES CONFEDERATIVAS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.6.1.00.00','CONTRIBUICOES CONFEDERATIVAS A APROPRIAR - EXTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE CONTRIBUICOES CONFEDERATIVAS A APROPRIAR.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.7.0.00.00','BENEFICIOS A PESSOAL A APROPRIAR','COMPREENDE OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.7.1.00.00','BENEFICIOS A PESSOAL A APROPRIAR - EXTRA OFSS','REGISTRA OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.0.00.00','DEMAIS VPD A APROPRIAR','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.1.00.00','DEMAIS VPD A APROPRIAR - EXTRA OFSS','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.1.01.00','DIREITOS AUTORAIS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.1.02.00','COMISSOES E PREMIOS PAGOS A APROPRIAR','REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.1.03.00','DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES','REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.1.99.00','OUTRAS VPD A APROPRIAR','REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.2.00.00','DEMAIS VPD A APROPRIAR - INTRA OFSS','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.2.03.00','DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES','REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.2.99.00','OUTRAS VPD A APROPRIAR','REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.3.00.00','DEMAIS VPD A APROPRIAR - INTER OFSS','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.3.03.00','DESPESA A APROPRIAR POR PENDENCIA DE INFORMACOES','REGISTRA OS VALORES PAGOS REFERENTES A DESPESAS REALIZADAS E NAO APROPRIADAS POR PENDENCIAS DE INFORMACOES OPERACIONAIS OU DETALHAMENTOS, CUJAS CONDICOES ESTEJAM LEGALMENTE AMPARADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.1.9.9.3.99.00','OUTRAS VPD A APROPRIAR','REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.0.0.0.00.00','ATIVO NAO-CIRCULANTE','COMPREENDE O ATIVO NAO-CIRCULANTE : O ATIVO REALIZAVEL A LONGO PRAZO, OS INVESTIMENTOS, O IMOBILIZADO E O INTANGIVEL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.0.0.00.00','ATIVO REALIZAVEL A LONGO PRAZO','COMPREENDE OS BENS, DIREITOS E DESPESAS ANTECIPADAS REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.0.00.00','CREDITOS A LONGO PRAZO','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.00.00','CREDITOS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.00','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE (COM VENCIMENTO APOS TERMINO DO EXERCICIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.01','FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.02','FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.03','FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO ','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.04','FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.05','FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.06','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.01.99','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.02.00','CREDITOS TRIBUTARIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO APOS TERMINO EXERCICIO SEGUINTE, ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.03.00','DIVIDA ATIVA TRIBUTARIA','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.03.01','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.03.02','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.04.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.01','EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.02','EMPRESTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.03','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER ','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.04','EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA','REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.05','EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS','REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.06','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.07','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.08','FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.09','FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.10','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS) ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.11','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.12','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.13','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.14','CREDITOS DE OPERACOES ESPECIAIS A RECEBER ','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.15','OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS','REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.16','JUROS A RECEBER - OPERACOES ESPECIAIS','REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.17','RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS','REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.18','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.05.19','EMPRESTIMO COMPULSORIO A RECEBER','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.99.00','(-) PROVISOES DE CREDITOS A LONGO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.99.01','(-) PROVISAO PARA DEVEDORES DUVIDOSOS ','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.99.02','(-) PROVISAO PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.99.03','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS PARA A DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.1.99.04','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.00.00','CREDITOS A LONGO PRAZO - INTRA OFSS','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.00','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE (COM VENCIMENTO APOS TERMINO DO EXERCICIO SEGUINTE), REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.01','FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.02','FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.03','FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO ','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.04','FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.05','FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.06','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.01.99','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.02.00','CREDITOS TRIBUTARIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO APOS TERMINO EXERCICIO SEGUINTE, ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.03.00','DIVIDA ATIVA TRIBUTARIA','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.03.01','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.03.02','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.04.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.01','EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.02','EMPRESTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.03','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER ','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.04','EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA','REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.05','EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS','REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.06','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.07','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.08','FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.09','FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.10','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS) ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.11','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.12','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.13','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.14','CREDITOS DE OPERACOES ESPECIAIS A RECEBER ','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.15','OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS','REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.16','JUROS A RECEBER - OPERACOES ESPECIAIS','REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.17','RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS','REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.18','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.05.19','EMPRESTIMO COMPULSORIO A RECEBER','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.99.00','(-) PROVISOES DE CREDITOS A LONGO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.99.01','(-) PROVISAO PARA DEVEDORES DUVIDOSOS ','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.99.02','(-) PROVISAO PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.99.03','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS PARA A DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.2.99.04','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.00.00','CREDITOS A LONGO PRAZO - INTER OFSS','COMPREENDE OS VALORES A RECEBER POR FORNECIMENTO DE BENS, SERVICOS, CREDITOS TRIBUTARIOS, DIVIDA ATIVA, TRANSFERENCIAS E EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.00','CLIENTES','COMPREENDE OS VALORES DAS FATURAS/DUPLICATAS A RECEBER DECORRENTES DAS VENDAS A PRAZO DE MERCADORIAS OU SERVICOS QUE OCORREM NO CURSO NORMAL DAS OPERACOES DA ENTIDADE, REPRESENTANDO UM DIREITO A COBRAR DE SEUS CLIENTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.01','FATURAS/ DUPLICATAS A RECEBER - ESTOQUES ESTRATEGICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.02','FATURAS/ DUPLICATAS A RECEBER - ESTQ. REGULADORES PGPM ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES REGULADORES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.03','FATURAS/ DUPLICATAS A RECEBER - ESTOQUE PROPRIO ','REGISTRA OS VALORES PROVENIENTES DOS FATURAMENTOS DA VENDA DE MERCADORIAS/PRODUTOS DO PROPRIO ESTOQUE DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.04','FATURAS/ DUPLICATAS A RECEBER - ABASTECIMENTO SOCIAL','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES PARA ABASTECIMENTO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.05','FATURAS/ DUPLICATAS A RECEBER - ESTQ. POR ATACADO ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE VENDA DE MERCADORIAS/PRODUTOS DOS ESTOQUES POR ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.06','FATURAS/ DUPLICATAS A RECEBER - PRESTACAO DE SERVICOS ','REGISTRA OS VALORES RELATIVOS AOS FATURAMENTOS PROVENIENTES DE PRESTACAO SERVICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.01.99','OUTRAS FATURA/ DUPLICATAS A RECEBER','REGISTRA OS VALORES PROVENIENTES DE DIVERSOS FATURAMENTOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.02.00','CREDITOS TRIBUTARIOS A RECEBER','REGISTRA OS VALORES RELATIVOS A CREDITOS A RECEBER COM VENCIMENTO APOS TERMINO EXERCICIO SEGUINTE, ORIUNDOS DA VARIACAO PATRIMONIAL AUMENTATIVA TRIBUTARIAS.OS TRIBUTOS SAO : IMPOSTOS, TAXAS , CONTRIBUICOES DE MELHORIA, CONTRIBUICOES E EMPRESTIMOS COMPULSORIO .','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.03.00','DIVIDA ATIVA TRIBUTARIA','COMPREENDE OS VALORES DOS CREDITOS DE DIVIDA ATIVA TRIBUTARIA, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.03.01','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA NAO PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.03.02','CREDITOS PREVIDENCIARIOS INSCRITOS','REGISTRA OS VALORES RELATIVOS A CREDITOS INSCRITOS DE DIVIDA ATIVA TRIBUTARIA PREVIDENCIARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.04.00','DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA DERIVADOS DE CLIENTES , EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.00','EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE O SOMATORIO DOS VALORES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.01','EMPRESTIMOS CONCEDIDOS A RECEBER','REGISTRA OS VALORES DOS CREDITOS POR EMPRESTIMOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.02','EMPRESTIMOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A EMPRESTIMOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.03','EMPRESTIMOS EM COBRANCA JUDICIAL A RECEBER ','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.04','EMPRESTIMOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA','REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.05','EMPRESTIMOS A SOCIEDADES COLIGADAS OU CONTROLADAS','REGISTRA O SOMATORIO DOS VALORES DE EMPRESTIMOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.06','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, EXCETO OS REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.07','ENCARGOS SOBRE EMPRESTIMOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS ENCARGOS A RECEBER SOBRE EMPRESTIMOS CONCEDIDOS, REFERENTES A RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT, EM QUE TAIS ENCARGOS NAO ESTEJAM EMBUTIDOS NO VALOR DO PRINCIPAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.08','FINANCIAMENTOS CONCEDIDOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, EXCETO OS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.09','FINANCIAMENTOS CONCEDIDOS A RECEBER - RECURSOS FAT','REGISTRA OS VALORES DOS FINANCIAMENTOS CONCEDIDOS PELA UNIAO, POR AUTORIZACAO LEGAL OU VINCULACAO A CONTRATO OU ACORDO, COM VENCIMENTO A LONGO PRAZO, REFERENTES AOS RECURSOS DO FUNDO DE AMPARO AO TRABALHADOR - FAT.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.10','FINANCIAMENTOS A RECEBER - RPPS','REGISTRA OS VALORES DOS ATIVOS RELATIVOS A FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS PELO RPPS COM RECURSOS PREVIDENCIARIOS, QUANDO NAO HAVIA IMPEDIMENTO LEGAL, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE (EXEMPLO: FINANCIAMENTOS IMOBILIARIOS) ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.11','FINANCIAMENTOS EM COBRANCA JUDICIAL A RECEBER','REGISTRA OS VALORES RELATIVOS A FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS, COM RETORNO A LONGO PRAZO E QUE ESTEJAM EM PROCESSO DE COBRANCA JUDICIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.12','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - EXCETO RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, EXCETO OS RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.13','JUROS PRO-RATA SOBRE FINANCIAMENTOS A RECEBER - RECURSOS FAT','REGISTRA O VALOR DE JUROS PRO-RATA REFERENTES A FINANCIAMENTOS, RELATIVOS AO FUNDO DE AMPARO AO TRABALHADOR - FAT. JUROS PRO-RATA SAO AQUELES DEFINIDOS POR UMA TAXA NOMINAL, MAS CONTADOS PROPORCIONALMENTE AO TEMPO DE VIGENCIA DO FINANCIAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.14','CREDITOS DE OPERACOES ESPECIAIS A RECEBER ','REGISTRA OS VALORES RELATIVOS A OPERACOES ESPECIAIS A RECEBER, INCLUSIVE JUROS E MULTAS, UTILIZADAS NORMALMENTE PELA COORDENACAO-GERAL DAS OPERACOES DE CREDITO DO TESOURO NACIONAL - COPEC.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.15','OPERACOES ESPECIAIS C/ PARTICIPACOES GOVERNAMENTAIS','REGISTRAR OS VALORES DAS OPERACOES DE CREDITO ENTRE A UNIAO E OS ESTADOS, RELATIVOS A PARTICIPACAO GOVERNAMENTAL OBRIGATORIA NAS MODALIDADES ROYALTIES, PARTICIPACOES ESPECIAIS E COMPENSACOES FINANCEIRAS, REFERENTES A MP 2.181-45 DE 24/08/01, COM ALTERACOES IMPLEMENTADAS PELA LEI N. 10.712/2003. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.16','JUROS A RECEBER - OPERACOES ESPECIAIS','REGISTRA OS JUROS RELATIVOS A OPERACOES ESPECIAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.17','RELACOES INTERFINANCEIRAS DE FUNDOS CONSTITUCIONAIS','REGISTRA OS VALORES DAS OPERACOES COM PERDAS IMPUTAVEIS AO PROAGRO E VALORES DE REPASSES BNB E OUTRAS INSTITUICOES','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.18','RESIDUO DE EMPRESTIMOS CONCEDIDOS','REGISTRA OS VALORES RELATIVOS A PRINCIPAL E/OU JUROS, DOS CREDITOS DOS EMPRESTIMOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, EXIGIVEIS EM LONGO PRAZO, RESULTANTES DA DIFERENCA ENTRE O VALOR DAS PRESTACOES VENCIDAS E O LIMITE MAXIMO PARA PAGAMENTO ESTABELECIDO EM CONTRATO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.05.19','EMPRESTIMO COMPULSORIO A RECEBER','REGISTRA O DIREITO A RECEBER DECORRENTE DE EMPRESTIMO COMPULSORIO PAGOS A UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.99.00','(-) PROVISOES DE CREDITOS A LONGO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.99.01','(-) PROVISAO PARA DEVEDORES DUVIDOSOS ','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NA COBRANCA DAS CONTAS A RECEBER DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.99.02','(-) PROVISAO PARA PERDAS DE CREDITOS TRIBUTARIOS','REGISTRA A PROVISAO PARA COBRIR AS PERDAS ESTIMADAS NOS CREDITOS TRIBUTARIOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.99.03','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS PARA A DIVIDA ATIVA TRIBUTARIA, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.1.3.99.04','(-) PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - CLIENTES','REGISTRA OS VALORES REFERENTES A CONSTITUICAO DE PROVISAO PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA, E DERIVADOS DE CLIENTES, DE ACORDO COM OS CRITERIOS DEFINIDOS NO MANUAL DE PROCEDIMENTOS DA DIVIDA ATIVA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.0.00.00','DEMAIS CREDITOS E VALORES A LONGO PRAZO','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.00.00','DEMAIS CREDITOS E VALORES A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.01','ADIANTAMENTOS CONCEDIDOS A PESSOAL','REGISTRA OS VALORES DAS ANTECIPACOES CONCEDIDAS A SERVIDORES E A DIRIGENTES DA UNIDADE.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.02','ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.03','ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS','REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI. ','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.04','ADIANTAMENTOS A PRESTADORES DE SERVICOS','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.05','ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA','REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.06','ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS','REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.00','TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.01','IPI A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.02','ICMS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.03','ICMS DIFERIDO','REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.04','IRRF A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.05','IR E CSLL A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.06','IR E CSLL DIFERIDOS','REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.07','ISS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ISS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.08','IPVA A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPVA A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.09','IPTU A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPTU A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.10','ITR A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ITR A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.11','INSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.12','PSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.13','COFINS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.14','PIS/PASEP A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSRAR','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.02.99','OUTROS TRIBUTOS RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.03.00','CREDITOS A RECEBER POR DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS','COMPREENDE OS CREDITOS A RECEBER COM REALIZACAO APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, DECORRENTES DA DESCENTRALIZACAO DE SERVICOS PUBLICOS, TANTO POR MEIO DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA COMO POR MEIO DE DELEGACAO, NAS FORMAS DE CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.03.01','TAXAS DE FISCALIZACAO DO FISTEL','REGISTRA OS VALORES A RECEBER REFERENTES AS TAXAS DE FISCALIZACAO DO FISTEL, TAIS COMO TAXAS DE INSTALACAO - TFI, TAXAS DE FUNCIONAMENTO - TFF, ACRESCIMOS MORATORIOS DAS TAXAS DE FISCALIZACAO DO FISTEL E OUTRAS CORRELATAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.03.02','CREDITOS POR DESCENTRALIZACAO DE SERVICOS DE TELECOMUNICACOES','REGISTRA OS VALORES A RECEBER REFERENTES A EXPLORACAO DE SERVICOS DE TELECOMUNICACOES, COMO COMUNICACAO DE MASSA, RADIODIFUSAO, DIREITOS DE USO DE RADIOFREQUENCIA, MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUNICACOES (LGT), JUROS DE TITULOS DE RENDA, CERTIFICACAO DE PRODUTOS, INFORMACOES CIENTIFICAS E TECNOLOGICAS, REGULACAO DA EXPLORACAO DOS SERVICOS E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.03.03','CONTRIBUICAO SOBRE RECEITA DE SERVICOS DE TELECOMUNICACOES','REGISTRA OS VALORES A RECEBER REFERENTES AOS VALORES DAS CONTRIBUICOES DEVIDAS PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.03.04','CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS DE TRANSPORTE PUBLICO','REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS DE TRANSPORTE PUBLICO NAS FORMAS DE OUTORGA A ENTIDADES DA ADMINISTRACAO INDIRETA QUE NAO PERTENCAM AO OFSS, CONCESSAO, PERMISSAO OU AUTORIZACAO AO PARTICULAR, O QUAL ESTA SUJEITO AO CONTROLE, FISCALIZACAO E REGULACAO DO PODER PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.03.99','OUTROS CREDITOS A RECEBER POR DESCENTRALIZACAO DE SERVICOS PUBLICOS','REGISTRA OS CREDITOS A RECEBER DECORRENTES DA DESCENTRALIZACAO DA PRESTACAO DE SERVICOS PUBLICOS NAO CLASSIFICADOS NAS CONTAS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.01','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITOS ADMINISTRATIVOS DECORRENTES DE FOLHA DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.05','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELEIDO EM NORMAS LEGAIS OU DETERMINACAO ADMINISTRATIVA OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.07','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.08','CREDITOS A RECEBER POR USO INDEVIDO DE COTA','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.09','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL ','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.04.99','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL','COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.02','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL - TOMADA DE CONTAS ESPECIAL','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES, NAO DEVOLVIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU DETERMIMANACAO ADMINISTRATIVA, OU SEJA, QUANDO O PRODUTO A ARRECADAR NAO TENHA SIDO RECOLHIDO NO PRAZO LEGAL.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.09','CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.10','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, POREM DE RESPONSABILIDADE DE SERVIDORES, QUE FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE .(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.13','CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.14','CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAO DE RECEBIMENTO INDEVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEAR GASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.15','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DE PARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PUDERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DE CONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DE OUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.05.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.01','DEPOSITOS E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.02','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.03','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.04','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.05','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.06','DEPOSITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.07','DEPOSITOS COMPULSORIOS - COMBUSTIVEIS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.08','DEPOSITOS COMPULSORIOS - VEICULOS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.09','DEPOSITOS COMPULSORIOS - ELETROBRAS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.06.99','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.07.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.01','CREDITOS A RECEBER DE ENTIDADES FEDERAIS ','REGISTRA OS VALORES REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.02','CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO','REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.03','CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS','REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.04','CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS','REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.05','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.06','CREDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX- SERVIDOR','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DE ACERTOS FINANCEIROS COM SERVIDORES E EX-SERVIDORES DO ORGAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.07','CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO','REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.08','CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES ','REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.09','RECURSOS DA UNIAO',' REGISTRA O VALOR DOS RECURSOS A RECEBER DA UNIAO EM DECORRENCIA DE DESPESAS REALIZADAS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.10','INCENTIVOS FISCAIS','REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.11','CREDITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.12','VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.13','INDENIZACOES A RECEBER','REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.14','CREDITOS A RECUPERAR','REGISTRA O VALOR DOS CREDITOS A RECUPERAR APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.15','DUPLICATAS E TITULOS EM CONTENCIOSO','REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.16','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.17','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.18','CREDITOS SUB-ROGADOS','REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.19','CREDITOS A RECEBER EM PODER DA JUSTICA','REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.20','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.21','CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO ','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.98.99','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO R','REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO , NAO CLASSIFICAVEIS EM OUTRAS CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.99.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A LONGO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.99.01','(-) PROVISAO PARA PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.99.02','(-) PROVISOES PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.99.03','(-) PROVISAO PARA PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.1.99.04','(-) PROVISAO PARA PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.00.00','DEMAIS CREDITOS E VALORES A LONGO PRAZO -INTRA OFSS','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.02','ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.03','ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS','REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI. ','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.04','ADIANTAMENTOS A PRESTADORES DE SERVICOS','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.05','ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA','REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.06','ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS','REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.00','TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.01','IPI A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPI A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.04','IRRF A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR RETIDO NA FONTE A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.05','IR E CSLL A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IR E DA CSLL A RECUPERAR/ COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.06','IR E CSLL DIFERIDOS','REGISTRA A PARCELA DO IR E CSLL QUE REPRESENTA A DIFERENCA ENTRE OS VALORES DE LUCRO APURADOS SEGUNDO AS NORMAS FISCAIS E O REGIME DE COMPETENCIA, QUANDO ESTES FOREM MENORES E AS DIFERENCAS FOREM TEMPORARIAS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.10','ITR A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ITR A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.11','INSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO INSS A COMPENSAR. ','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.12','PSS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PSS A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.13','COFINS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DA COFINS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.14','PIS/PASEP A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO PIS/PASEP A RECUPERAR / COMPENSRAR','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.02.99','OUTROS TRIBUTOS RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.04.99','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL','COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.09','CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.13','CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.05.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.01','DEPOSITOS E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.02','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.03','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.04','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.05','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.06','DEPOSITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.07','DEPOSITOS COMPULSORIOS - COMBUSTIVEIS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.08','DEPOSITOS COMPULSORIOS - VEICULOS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.09','DEPOSITOS COMPULSORIOS - ELETROBRAS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.06.99','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.07.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.01','CREDITOS A RECEBER DE ENTIDADES FEDERAIS ','REGISTRA OS VALORES REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.02','CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO','REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.03','CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS','REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.04','CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS','REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.05','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.07','CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO','REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.08','CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES ','REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.09','RECURSOS DA UNIAO',' REGISTRA O VALOR DOS RECURSOS A RECEBER DA UNIAO EM DECORRENCIA DE DESPESAS REALIZADAS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.10','INCENTIVOS FISCAIS','REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.11','CREDITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.12','VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.13','INDENIZACOES A RECEBER','REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.14','CREDITOS A RECUPERAR','REGISTRA O VALOR DOS CREDITOS A RECUPERAR APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.15','DUPLICATAS E TITULOS EM CONTENCIOSO','REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.16','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.17','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.18','CREDITOS SUB-ROGADOS','REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.19','CREDITOS A RECEBER EM PODER DA JUSTICA','REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.20','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.21','CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO ','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.98.99','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.99.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A LONGO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.99.01','(-) PROVISAO PARA PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.99.02','(-) PROVISOES PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.99.03','(-) PROVISAO PARA PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.2.99.04','(-) PROVISAO PARA PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.00.00','DEMAIS CREDITOS E VALORES A LONGO PRAZO -INTER OFSS','COMPREENDE OS VALORES A RECEBER POR DEMAIS TRANSACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','COMPREENDE AS ANTECIPACOES CONCEDIDAS A PESSOAL, TAIS COMO ANTECIPACOES DE SALARIOS E ORDENADOS, ADIANTAMENTOS DE 13º SALARIO, ADIANTAMENTOS DE FERIAS E OUTROS, ALEM DA ENTREGA DE NUMERARIO A TERCEIROS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS OU SERVICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.02','ADIANTAMENTOS A UNIDADES E ENTIDADES','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A UNIDADES E ENTIDADES DA ADMINISTRACAO, INCLUSIVE OUTRAS UNIDADES GESTORAS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.03','ADIANTAMENTOS DE TRANSFERENCIAS VOLUNTARIAS','REGISTRA OS VALORES RELATIVOS A ADIANTAMENTOS DE RECURSOS FINANCEIROS FORMALIZADOS POR TRANSFERENCIAS VOLUNTARIAS GERADAS A PARTIR DA INTEGRACAO DO PORTAL SICONV COM O SIAFI. ','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.04','ADIANTAMENTOS A PRESTADORES DE SERVICOS','REGISTRA OS VALORES DE ANTECIPACOES CONCEDIDAS A PRESTADORES DE SERVICOS, MAS SEM VINCULACAO ESPECIFICA AO FORNECIMENTO DE BENS, PRODUTOS OU SERVICOS PREDETERMINADOS, POIS NESTE CASO DEVERA SER CLASSIFICADO, POR EXEMPLO, EM ESTOQUES OU IMOBILIZADO.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.05','ADIANTAMENTOS A DIRETORES, ACIONISTAS OU PARTICIPANTES NO LUCRO DA COMPANHIA','REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A DIRETORES E ACIONISTAS OU OUTROS PARTICIPANTES NO LUCRO, TAIS COMO OS DETENTORES DE PARTES BENEFICIARIAS OU DEBENTURES, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.06','ADIANTAMENTOS A SOCIEDADES COLIGADAS OU CONTROLADAS','REGISTRA O SOMATORIO DOS VALORES DE ADIANTAMENTOS CONCEDIDOS A SOCIEDADES COLIGADAS E CONTROLADAS, QUANDO ISSO NAO FOR SEU OBJETO SOCIAL.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','REGISTRA OS OUTROS VALORES ENTREGUES ANTECIPADAMENTE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.00','TRIBUTOS A RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DOS TRIBUTOS A RECUPERAR / COMPENSAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.02','ICMS A RECUPERAR / COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DE ICMS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.03','ICMS DIFERIDO','REGISTRA O VALOR DO ICMS DIFERIDO DOS ESTOQUES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.07','ISS A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ISS A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.08','IPVA A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPVA A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.09','IPTU A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO IPTU A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.10','ITR A COMPENSAR','REGISTRA O SOMATORIO DOS VALORES DO ITR A COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.02.99','OUTROS TRIBUTOS RECUPERAR / COMPENSAR','COMPREENDE O SOMATORIO DOS VALORES DE OUTROS TRIBUTOS A RECUPERAR / COMPENSAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.00','CREDITOS POR DANOS AO PATRIMONIO PROVENIENTES DE CREDITOS ADMINISTRATIVOS','COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM PROCESSOS ADMINISTRATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DANOS AO PATRIMONIO PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE ERRO DA ADMINISTRACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A DEBITO ADMINISTRATIVO DECORRENTES DE DOLO, MA-FE OU FRAUDE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A ORGAOS PAGADORES POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS, POS-MORTE DO SEGURADO (CREDITOS RECONHECIDOS SEM NECESSIDADE DE INSTAURACAO DE TOMADA DE CONTAS ESPECIAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.04.99','OUTROS CREDITOS ADMINISTRATIVOS','REGISTRA O CREDITO DA UNIAO CORRESPONDENTE A OUTROS CREDITOS ADMINISTRATIVOS QUE NAO SE ENQUADRAM EM RUBRICAS ESPECIFICAS EXISTENTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM TOMADA DE CONTAS ESPECIAL','COMPREENDE OS VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS ORIUNDOS DE DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, INCLUSIVE EM CASOS DE SUPER FATURAMENTO. (QUANDO FOR INSTAURADA TOMADA DE CONTA ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS DESFALQUES, DESVIOS DE BENS E VALORES DA UNIAO OU DE ENTIDADES PUBLICAS, APURADAS EM PROCESSOS POR ACOES ADMINISTRATIVAS E POLICIAL OU JULGAMENTO JUDICIAL. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADES EM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS FORAM APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','REGISTRA AS RESPONSABILIDADES APURADAS EM INQUERITOS ADMINISTRATIVO OU POLICIAL CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDAS CAUSADOS AFAZENDA NACIONAL SENDO APURADOS COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO - TOMADA DE CONTAS ESPECIAL','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COMPORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSIFICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), APURADAS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS - TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTECIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE DOCUMENTACAO COMPROBATORIA DA EXECUCAO DA DESPESA, INCLUSIVE AS APRESENTACOES FORA DO PRAZO LEGAL, BEM COMO A INADIMPLENCIA NA COMPROVACAO DE INSTRUMENTOS DE TRANSFERENCIA OU AINDA IRREGULARIDADE NA DOCUMENTACAO APURADOS, COM IMPUTACAO DA RESPONSABILIDADE (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.09','CREDITOS A RECEBER DECORRENTES DE FALTA DE LICITACAO - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NECESSARIA LICITACAO ESPECIFICA, EM PROCESSOS MOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, APURADOS, COM IMPUTACAO DA RESPONSABILIDADE. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGAMENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS, NAO PAGAMENTO DE OBRIGACOES PARA COM A UNIAO. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS - TOMADA DE CONTAS ESPECIAL ','REGISTRA OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIA SOCIAL, COM A RESPONSABILIDADE DEVIDAMENTE APURADA E IMPUTADA A SERVIDORES OU TERCEIROS (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.13','CREDITOS A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE - TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES IMPUTADAS A GESTORES E OUTROS RESPONSAVEIS E CO-RESPONSAVEIS POR ADIANTAMENTOS CONCEDIDOS EM DESACORDO COM A LEGISLACAO PERTINENTE, TAIS COMO A FORNECEDORES E EMPREGADOS.(QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.05.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','REGISTRA AS RESPONSABILIDADES DIVERSAS CUJAS CLASSIFICACOES NAO ESTEJAM DEFINIDAS EM CONTAS PROPRIAS OU PARA AS QUAIS NAO HAJAM CONTAS ESPECIFICAS. (QUANDO FOR INSTAURADA TOMADA DE CONTAS ESPECIAL)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.00','DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','COMPREENDE OS VALORES DE DEPOSITOS E CAUCOES EFETUADOS E RECEBIDOS PELA ENTIDADE PARA GARANTIA DE CONTRATOS, BEM COMO PARA DIREITO DE USO, EXPLORACAO TEMPORARIA DE BENS OU DE NATUREZA JUDICIAL, DEPOSITOS COMPULSORIOS E DEMAIS RECURSOS VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.01','DEPOSITOS E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','REGISTRA OS VALORES RELATIVOS A DEPOSITOS E CAUCOES, EFETUADOS POR VINCULACOES A CONTRATOS OU CONVENCOES, PARA GARANTIAS DE OPERACOES ESPECIFICAS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.02','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES A RECEBER DECORRENTES DE DEPOSITOS EFETUADOS POR DETERMINACAO JUDICIAL, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.03','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS VINCULADOS, DECORRENTES DE INTERPOSICAO DE RECURSOS NA ESFERA JUDICIAL OU ADMINISTRATIVA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.04','DEPOSITOS ESPECIAIS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS EM CONTAS BANCARIAS, VINCULADOS A OBRIGACOES CONTRATUAIS, CONVENCOES, ACORDOS E AJUSTES.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.05','VALORES APREENDIDOS POR DECISAO JUDICIAL','REGISTRA OS VALORES APREENDIDOS POR DECISAO JUDICIAL ATRAVES DE PENHORA OU ARRESTO, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.06','DEPOSITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS A DEPOSITOS TRANSFERIDOS, PARA GARANTIA DE OPERACOES ESPECIFICAS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.07','DEPOSITOS COMPULSORIOS - COMBUSTIVEIS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE COMBUSTIVEIS, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.08','DEPOSITOS COMPULSORIOS - VEICULOS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS NAS AQUISICOES DE VEICULOS, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.09','DEPOSITOS COMPULSORIOS - ELETROBRAS','REGISTRA OS VALORES RELATIVOS A EMPRESTIMOS COMPULSORIOS PAGOS PELO CONSUMO DE ENERGIA ELETRICA, DE ACORDO COM A LEGISLACAO EM VIGOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.06.99','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','REGISTRA OS VALORES RELATIVOS A OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.07.00','DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA OS VALORES DOS CREDITOS DE DIVIDA ATIVA NAO TRIBUTARIA,EXCETO AS DERIVADAS DE CLIENTES, EM PROCESSO DE INSCRICAO E JA INSCRITOS, REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DOS DEMONSTRATIVOS CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','COMPREENDE OS OUTROS CREDITOS E VALORES REALIZAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS, PROVENIENTES DE DIREITOS OBTIDOS JUNTO A DIVERSOS DEVEDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.01','CREDITOS A RECEBER DE ENTIDADES FEDERAIS ','REGISTRA OS VALORES REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE DECORRENTES DE DEBITO DE ENTIDADES FEDERAIS COM A UNIAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.02','CREDITOS A RECEBER POR CESSAO DE CREDITOS - CEDIDOS PELA UNIAO','REGISTRA OS VALORES DOS CREDITOS A RECEBER CEDIDOS PELA UNIAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.03','CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS','REGISTRA O VALOR DOS CREDITOS ORIUNDOS DAS CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS DA UNIAO, PARA TERCEIROS OU PARA OUTRAS ENTIDADES GOVERNAMENTAIS, REALIZAVEIS A LONGO PRAZO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.04','CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS','REGISTRA OS VALORES ORIUNDOS DE CREDITOS DE CONVENIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.05','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','REGISTRA OS VALORES DOS CREDITOS A RECEBER DECORRENTES DA ALIENACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.07','CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO','REGISTRA O VALOR DOS CREDITOS ADMINISTRATIVOS ORIUNDOS DE AUTOS DE INFRACAO E OUTROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.08','CREDITOS A RECEBER EM PARCELAS/ LOTES ORIUNDOS DE DESAPROPRIACOES ','REGISTRA OS VALORES A RECEBER ORIUNDOS DE DESAPROPRIACOES DE IMOVEIS RURAIS PARA FINS DE REFORMA AGRARIA, TITULADOS EM PARCELAS/LOTES, COM PAGAMENTOS PREVISTOS A PARTIR DO SEGUNDO ANO DA EMISSAO DOS TITULOS DE PROPRIEDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.10','INCENTIVOS FISCAIS','REGISTRA O VALOR DAS COTAS RECOLHIDAS PELA ADMINISTRACAO INDIRETA, REFERENTE AO IRPJ POR OPCAO DE INCENTIVOS FISCAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.11','CREDITOS TRANSFERIDOS','REGISTRA OS VALORES RELATIVOS AOS CREDITOS TRANSFERIDOS DE TERCEIROS, PROVENIENTES DE TRIBUTOS, MULTAS E OUTROS CREDITOS DA FAZENDA NACIONAL LANCADOS POREM NAO ARRECADADOS OU NAO RECOLHIDOS NO EXERCICIO ORIGINAL, QUE CONSTITUI A DIVIDA ATIVA A PARTIR DA SUA INSCRICAO. REGISTRA AINDA OS RECURSOS A RECEBER CONSTANTES DO ORCAMENTO GERAL DA UNIAO PARA FINS DE OBRIGACOES CONTRATUAIS DECORRENTES DE EMPRESTIMOS E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.12','VALORES A RECUPERAR DECORRENTES DE INDENIZACAO DE SINISTROS PAGOS','REGISTRA OS VALORES A RECUPERAR DECORRENTES DE PAGAMENTOS DE INDENIZACOES DE SINISTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.13','INDENIZACOES A RECEBER','REGISTRA OS VALORES DAS INDENIZACOES A RECEBER A LONGO PRAZO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.14','CREDITOS A RECUPERAR','REGISTRA O VALOR DOS CREDITOS A RECUPERAR APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.15','DUPLICATAS E TITULOS EM CONTENCIOSO','REGISTRA O MONTANTE DOS VALORES ORIUNDOS DE DUPLICATAS E TITULOS EM CONTENCIOSO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.16','CREDITOS EM LIQUIDACAO','REGISTRA OS VALORES ORIUNDOS DE CREDITOS EM LIQUIDACAO DE DIFICIL REALIZACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.17','CREDITOS PARCELADOS','REGISTRA O VALOR DOS CREDITOS PARCELADOS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.18','CREDITOS SUB-ROGADOS','REGISTRA O VALOR DOS CREDITOS SUB-ROGADOS POR ASSUNCAO DE DIVIDA PELA UNIAO POR DETERMINACAO LEGAL, POR RENEGOCIACAO DE DIVIDAS OU POR PAGAMENTO DE GARANTIAS DE EMPRESTIMOS DADAS A TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.19','CREDITOS A RECEBER EM PODER DA JUSTICA','REGISTRA OS VALORES A RECEBER EM PODER DA JUSTICA, SEM PREVISAO DE RECEBIMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.20','TITULOS A RECEBER','COMPREENDE OS VALORES A RECEBER A CURTO PRAZO REPRESENTADOS POR NOTAS PROMISSORIAS, LETRAS DE CAMBIO E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.21','CREDITOS POR INFRACOES LEGAL/CONTR. L. PRAZO ','REGISTRA OS RECURSOS A RECEBER PROVENIENTES DA APLICACAO DE AUTOS DE INFRACAO, DA APLICACAO DE MULTAS POR DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS (VINCULADAS A CREDITOS TRIBUTARIOS) OU DECORRENTES DE QUEBRA DE CLAUSULAS CONTRATUAIS. OS CREDITOS DECORRENTES DA QUEBRA DE CLAUSULAS CONTRATUAIS PODEM SER PAGOS EM ESPECIE, GLOSA OU ATRAVES DE FORNECIMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.98.99','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','REGISTRA OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO, NAO CLASSIFICAVEIS EM OUTRAS CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.99.00','(-) PROVISOES PARA DEMAIS CREDITOS E VALORES A LONGO PRAZO','COMPREENDE AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DEMAIS CREDITOS A LONGO PRAZO, POR INADIMPLENCIA DE TERCEIROS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.99.01','(-) PROVISAO PARA PERDAS EM EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS RELATIVOS A EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO CONCEDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.99.02','(-) PROVISOES PARA PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','REGISTRA AS PERDAS COM O NAO RECEBIMENTO DE VALORES REFERENTES A DIVIDA ATIVA NAO TRIBUTARIA DE LONGO PRAZO, EXCETO AS DERIVADAS DE CLIENTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.99.03','(-) PROVISAO PARA PERDAS DE CREDITOS ADMINISTRATIVOS','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, VERIFICADOS EM PROCESSOS ADMINISTRATIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.2.3.99.04','(-) PROVISAO PARA PERDAS DE CREDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','REGISTRA OS VALORES DAS PROVISOES PARA PERDAS DE CREDITOS POR DANOS AO PATRIMONIO, APURADOS EM TOMADA DE CONTAS ESPECIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.0.00.00','INVESTIMENTOS E APLICACOES TEMPORARIAS A LONGO PRAZO','COMPREENDE AS APLICACOES DE RECURSOS EM TITULOS, VALORES MOBILIARIOS E IMOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.00.00','INVESTIMENTOS E APLICACOES TEMPORARIAS A LONGO PRAZO - EXTRA OFSS','COMPREENDE AS APLICACOES DE RECURSOS EM TITULOS, VALORES MOBILIARIOS E IMOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.00','TITULOS E VALORES MOBILIARIOS','COMPREENDEM AS APLICACOES DE RECURSOS EM TITULOS E VALORES MOBILIARIOS, NAO DESTINADAS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.01','TITULOS DA DIVIDA AGRARIA - TDA','REGISTRA OS VALORES RELATIVOS AOS TITULOS DA DIVIDA AGRARIA, PARA FINS DE INDENIZACOES DE PROPRIEDADES RURAIS, COM OBJETIVO DE REFORMA AGRARIA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.02','TITULOS PUBLICOS - LETRAS ESPECIAIS','REGISTRA O VALOR DAS LETRAS ESPECIAIS EM TITULOS PUBLICOS EMITIDOS NO MERCADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.03','TITULOS PUBLICOS DE PROPRIEDADE DO BACEN','REGISTRA OS TITULOS PUBLICOS DE PROPRIEDADE DO BACEN.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.04','TITULOS PUBLICOS - MERCADO ABERTO ','REGISTRA O VALOR RELATIVO A TITULOS PUBLICOS, EMITIDOS E EM CIRCULACAO NO MERCADO ABERTO PARA FINS DE NEGOCIACAO NO MERCADO DE ACOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.05','ACOES - FAD/FND','REGISTRA AS ACOES DEPOSITADAS NO FAD E/OU FND E AS ALIENAVEIS POR MEIO DE ADESAO A OFERTA PUBLICA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.06','DEMAIS ACOES','REGISTRA OS VALORES DAS DAS DEMAIS ACOES REPRESENTATIVAS DAS PARTICIPACOES DOS ORGAOS E ENTIDADES NO CAPITAL DAS SOCIEDADES POR ACOES HAVIDAS POR AQUISICOES, SUBSCRICOES, BONIFICACOES E DOACOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.07','FUNDO DE APLICACOES EM COTAS - RENDA VARIAVEL','REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICACOES EM COTAS - RENDA VARIAVEL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.08','FUNDO DE APLICACOES EM COTAS - RENDA VARIAVEL (FSB)','REGISTRA OS VALORES APLICADOS EM FUNDOS DE APLICACOES EM COTAS - RENDA VARIAVEL, RELATIVAS A OPERACIONALIZACAO DO FUNDO SOBERANO DO BRASIL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.09','APLICACOES EM ATIVOS EM ENQUADRAMENTO - TITULOS E VALORES','REGISTRA AS APLICACOES DE RECURSOS DO REGIME PROPRIO DA PREVIDENCIA SOCIAL - RPPS EM DESACORDO COM A LEGISLACAO E MANTIDAS EM CARTEIRA ATE O CORRESPONDENTE VENCIMENTO OU, NA INEXISTENCIA DESSE, ATE O PRAZO ESTIPULADO EM LEGISLACAO CORRESPONDENTE, CASO SEJAM RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.10','APLICACOES EM ATIVOS NAO SUJEITOS A RESOLUCAO DO CMN - TITULOS E VALORES','REGISTRA OS VALORES DOS ATIVOS - TITULOS E VALORES- NAO SUJEITOS AS REGRAS ESTABELECIDAS NA RESOLUCAO CMN Nº 3790/2009, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.01.99','OUTROS TITULOS E VALORES','REGISTRA OS OUTROS TITULOS E VALORES MOBILIARIOS A LONGO PRAZO, NAO CLASSIFICAVEIS NAS CONTAS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.02.00','APLICACAO TEMPORARIA EM METAIS PRECIOSOS','COMPREENDEM AS APLICACOES DE RECURSOS EM METAIS PRECIOSOS, NAO DESTINADOS A NEGOCIACAO E QUE NAO FACAM PARTE DAS ATIVIDADES OPERACIONAIS DA ENTIDADE, RESGATAVEIS APOS OS DOZE MESES SEGUINTES A DATA DA PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.02.01','APLICACAO TEMPORARIA EM OURO','REGISTRA AS APLICACOES DE RECURSOS EM OURO, DEPOSITADOS NO BANCO CENTRAL DO BRASIL,DE ACORDO COM A LEI Nº 4595/64.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.02.02','APLICACAO TEMPORARIA EM OUTROS METAIS PRECIOSOS','REGISTRA O VALOR REFERENTE AS APLICACOES EM DEMAIS METAIS PRECIOSOS, DEPOSITADOS NO BANCO CENTRAL DO BRASIL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.03.00','APLICACOES EM SEGMENTO DE IMOVEIS','REGISTRA OS INVESTIMENTOS DE LONGO PRAZO REALIZADOS EM SEGMENTO DE IMOVEIS, REALIZAVEIS APOS O TERMINO DO EXERCICIO SEGUINTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.99.00','(-) PROVISOES DE INVESTIMENTOS E APLICACOES TEMPORARIAS A LONGO PRAZO','COMPREENDE A DIFERENCA ENTRE O VALOR RECUPERAVEL DO ATIVO E SEU VALOR CONTABIL, QUANDO O PRIMEIRO FOR MENOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.99.01','(-) PROVISAO PARA PERDAS EM TITULOS, VALORES MOBILIARIOS E IMOVEIS','REGISTRA OS VALORES DE PROVISOES PARA PERDAS EM TITULOS , VALORES MOBILIARIOS E IMOVEIS A LONGO PRAZO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.3.1.99.02','(-) PROVISAO PARA PERDAS EM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','REGISTRA OS VALORES DE PROVISOES PARA PERDAS EM APLICACOES EM OURO E OUTROS METAIS PRECIOSOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.0.00.00','ESTOQUES','COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE PARA UTILIZACAO PROPRIA OU PARA VENDA, PREVISTOS PARA PERIODO POSTERIOR AO TERMINO DO EXERCICIO SEGUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.00.00','ESTOQUES - EXTRA OFSS','COMPREENDE O VALOR DOS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE PARA UTILIZACAO PROPRIA OU PARA VENDA, PREVISTOS PARA PERIODO POSTERIOR AO TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.00','MERCADORIAS PARA REVENDA','COMPREENDE TODAS AS MERCADORIAS ADQUIRIDAS DE TERCEIROS PARA REVENDA, QUE NAO SOFREM NENHUM PROCESSO DE TRANSFORMACAO NA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.01','MERCADORIAS PARA VENDA OU REVENDA- ESTOQUE PROGRAMAS PROPRIOS ','REGISTRA O VALOR DAS MERCADORIAS PARA VENDA OU REVENDA E DOACOES RELATIVAS A ESTOQUES DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.02','MERCADORIAS EM CONSIGNACAO PARA REVENDA - ESTOQUE PROGRAMAS PROPRIOS','REGISTRA O VALOR DAS MERCADORIAS EM CONSIGNACAO PARA REVENDA - REDE SOMAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.03','MERCADORIAS - ATACADO - ESTOQUE PROGRAMAS PROPRIOS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA - ATACADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.04','MERCADORIAS - ESTOQUES ESTRATEGICOS ','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.05','MERCADORIAS - ESTOQUE REGULADORES PGPM','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES- PGPM DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.06','MERCADORIAS - ESTOQUE EGF ESP. PGPM(DEP. JUDICIAL)','REGISTRA O VALOR DAS MERCADORIAS DE EGFS ESPECIAIS ORIUNDOS DO BANCO DO BRASIL, PARA REVENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.07','MERCADORIAS - ESTOQUES AGRICULTURA FAMILIAR','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.08','MERCADORIAS EM ARMAZENS DE TERCEIROS PARA REVENDA','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES PROPRIOS EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.09','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES ESTRATEGICOS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES ESTRATEGICOS DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.10','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES REGULADORES PGPM','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES REGULADORES - PGPM DO GOVERNO FEDERAL EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.11','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES POR ATACADO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA REVENDA RELATIVAS A ESTOQUES POR ATACADO MANTIDOS EM EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.01.12','MERCADORIAS EM ARMAZENS DE TERCEIROS - ESTOQUES AGRICULTURA FAMILIAR','REGISTRA O VALOR DAS MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR EM ARMAZENS DE TERCEIROS, ORIUNDAS DE AQUISICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.02.00','PRODUTOS E SERVICOS ACABADOS','COMPREENDE OS PRODUTOS JA TERMINADOS E ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO; E OS SERVICOS ACABADOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.02.01','PRODUTOS ACABADOS','REGISTRA O VALOR DE PRODUTOS MANUFATURADOS JA TERMINADOS, ORIUNDOS DA PROPRIA PRODUCAO DA ENTIDADE E DISPONIVEIS PARA VENDA, ESTOCADOS NA FABRICA, OU EM DEPOSITOS, OU EM FILIAIS, OU AINDA COM TERCEIROS EM CONSIGNACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.02.02','SERVICOS ACABADOS','REGISTRA OS VALORES PERTINENTES A SERVICOS ACABADOS QUE ESTAO PENDENTES DE FATURAMENTO OU DE TRANSFERENCIA PARA OUTRAS CONTAS DO ATIVO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.03.00','PRODUTOS E SERVICOS EM ELABORACAO','COMPREENDE OS PRODUTOS E SERVICOS EM ANDAMENTO QUE NAO SERAO CONCLUIDOS ATE O TERMINO DO EXERCICIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.03.01','PRODUTOS EM ELABORACAO ','REGISTRA A TOTALIDADE DAS MATERIAS-PRIMAS JA REQUISITADAS QUE ESTAO EM PROCESSO DE TRANSFORMACAO E O MONTANTE DE CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS PRODUTOS EM ELABORACAO QUE NAO SERAO CONCLUIDOS ATE O TERMINO DO EXERCICIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.03.02','SERVICOS EM ELABORACAO','REGISTRA OS CUSTOS DIRETOS E INDIRETOS RELATIVOS AOS SERVICOS EM ELABORACAO QUE NAO SERAO CONCLUIDOS ATE O TERMINO DO EXERCICIO SUBSEQUENTE A DATA DO BALANCO PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.04.00','MATERIAS-PRIMAS','COMPREENDE O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.04.01','MATERIAS-PRIMAS - ARMAZENS PROPRIOS','REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS PROPRIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.04.02','MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS','REGISTRA O ESTOQUE DE MATERIAS-PRIMAS QUE SERAO UTILIZADOS NO PROCESSO PRODUTIVO, GUARDADAS EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.00','MATERIAIS EM TRANSITO','COMPREENDE O VALOR DOS MATERIAIS EM PROCESSO DE TRANSFERENCIA PARA OUTRAS UNIDADES DA ENTIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.01','ESTOQUES MERCADORIAS PARA REVENDA EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS A ESTOQUES PROPRIOS DA ENTIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.02','ESTOQUES POR ATACADO EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DO ESTOQUE POR ATACADO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.03','ESTOQUES ESPECIAIS DE PRODUTOS EM PROCESSO DE AQUISICAO ','REGISTRA O VALOR DOS PRODUTOS EM PROCESSO DE AQUISICAO RELATIVOS A RESTOS A PAGAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.04','ESTOQUES PUBLICOS ESTRATEGICOS EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES ESTRATEGICOS DE NATUREZA PUBLICA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.05','ESTOQUES PUBLICOS REGULADORES-PGPM EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES REGULADORES - PGPM.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.06','ESTOQUES PUBLICOS AGRICULTURA FAMILIAR EM TRANSITO','REGISTRA O VALOR DAS MERCADORIAS EM TRANSITO RELATIVAS AS TRANSFERENCIAS DOS ESTOQUES DA AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.07','MERCADORIAS PARA DOACAO EM TRANSITO','REGISTRA O VALOR DAS MERCADARIAS PARA DOACAO, EM TRANSITO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.08','ESTOQUES AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO','REGISTRA O VALOR DE MERCADORIAS DO PROGRAMA NACIONAL DE COMPRA DA PRODUCAO DA AGRICULTURA FAMILIAR PARA DOACAO EM TRANSITO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.09','PRODUTOS PARA PESQUISA EM TRANSITO','REGISTRA O VALOR DOS MATERIAIS EM TRANSITO RELATIVOS AS TRANSFERENCIAS ENTRE UG, DE PRODUTOS PARA PESQUISA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.10','MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DO EXERCICIO','REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.05.11','MATERIAL DE CONSUMO EM TRANSITO - TRANSFERENCIAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO EM TRANSITO, RELATIVOS A TRANSFERENCIAS EFETUADAS ENTRE UNIDADES, NO EXERCICIO ANTERIOR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.00','ALMOXARIFADO','COMPREENDE O VALOR DOS MATERIAIS DESTINADOS AO CONSUMO INTERNO DA UNIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.01','MATERIAL DE CONSUMO','REGISTRA OS VALORES DOS MATERIAIS DE CONSUMO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.02','GENEROS ALIMENTICIOS','REGISTRA OS VALORES DOS GENEROS ALIMENTICIOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.03','MATERIAIS DE CONSTRUCAO','REGISTRA OS VALORES DOS MATERIAIS DE CONSTRUCAO ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.04','MATERIAIS DE TELECOMUNICACOES','REGISTRA OS VALORES DOS MATERIAIS DE TELECOMUNICACOES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.05','AUTOPECAS','REGISTRA OS VALORES DE AUTOPECAS ADQUIRIDAS E ESTOCADAS EM ALMOXARIFADOS, DESTINADAS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.06','MEDICAMENTOS E MATERIAIS HOSPITALARES','REGISTRA OS VALORES DOS MEDICAMENTOS E MATERIAS HOSPITALARES ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.07','MATERIAIS GRAFICOS','REGISTRA OS VALORES DOS MATERIAIS GRAFICOS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.08','MATERIAL DE EXPEDIENTE','REGISTRA OS VALORES DOS MATERIAIS DE EXPEDIENTE ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADOS, DESTINADOS A ATENDER AO CONSUMO INTERNO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.06.09','MATERIAIS A CLASSIFICAR','REGISTRA OS VALORES DOS MATERIAIS ESTOCADOS PENDENTES DE CLASSIFICACAO E IDENTIFICACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.07.00','ADIANTAMENTOS A FORNECEDORES','REGISTRA OS ADIANTAMENTOS EFETUADOS PELA ENTIDADE A FORNECEDORES, VINCULADOS A COMPRAS ESPECIFICAS DE MATERIAIS QUE SERAO INCORPORADOS AOS ESTOQUES QUANDO DE SEU EFETIVO RECEBIMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.00','OUTROS ESTOQUES','COMPREENDE O VALOR DOS OUTROS BENS ADQUIRIDOS, PRODUZIDOS OU EM PROCESSO DE ELABORACAO PELA ENTIDADE COM O OBJETIVO DE VENDA OU UTILIZACAO PROPRIA NO CURSO NORMAL DAS ATIVIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.01','MATERIAIS DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA OS VALORES DE ESTOQUE QUE SE DESTINAM A EMBALAGEM DO PRODUTO OU A SEU ACONDICIONAMENTO PARA REMESSA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.02','MATERIAL DE CONSUMO - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE INTERNO DESTINADO A DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.03','MATERIAL DE CONSUMO - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES RELATIVOS AS AQUISICOES E OU TRANSFERENCIAS DE MATERIAIS DE CONSUMO PARA A FORMACAO DE ESTOQUE ,MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.04','MEDICAMENTOS - ESTOQUE INTERNO - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES DOS MEDICAMENTOS E OUTROS PRODUTOS FARMACEUTICOS, ADQUIRIDOS OU FABRICADOS PELA UNIDADE, DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO PARA CONSUMO INTERNO OU REDISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.05','MEDICAMENTOS - ESTOQUE EM ARMAZEM DE TERCEIROS - DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES RELATIVOS A AQUISICOES E OU TRANSFERENCIAS DE MEDICAMENTOS, PARA A FORMACAO DE ESTOQUE, MANTIDO EM ARMAZEM DE TERCEIROS, DESTINADO A DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.06','ESTOQUE DE MATERIAIS PARA PREMIACOES DESTINADO A DISTRIBUICAO','REGISTRA OS VALORES DAS PREMIACOES COMO: MEDALHAS E PLACAS DESTINADOS A FORMACAO DE ESTOQUE DE DISTRIBUICAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.07','MERCADORIAS PARA DOACAO - ESTOQUE INTERNO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS PROPRIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.08','MERCADORIAS PARA DOACAO - ARMAZEM DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, MANTIDAS EM ARMAZENS DE TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.09','MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ESTOQUE INTERNO','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS PROPRIOS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.10','MERCADORIAS PARA DOACAO - AGRICULTURA FAMILIAR- ARMAZEM DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS PARA SEREM DOADAS, DEPOSITADAS EM ARMAZENS DE TERCEIROS, RELATIVAS AO PROGRAMA DE AGRICULTURA FAMILIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.11','MERCADORIAS PARA PERMUTA','REGISTRA O VALOR DAS MERCADORIAS ADQUIRIDAS COM A FINALIDADE DE PERMUTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.12',' PRODUTOS PARA PESQUISA E ENSINO - ANIMAIS ','REGISTRA O VALOR DOS ANIMAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.13','PRODUTOS PARA PESQUISA E ENSINO - VEGETAIS ','REGISTRA O VALOR DO VEGETAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE, BEM COMO PRODUTOS INDUSTRIALIZADOS TAIS COMO: VINHOS, SUCOS , VINAGRES E PUBLICACOES TECNICAS DE PESQUISAS ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.14','PRODUTOS PARA PESQUISA E ENSINO - MINERAIS ','REGISTRA O VALOR DOS MINERAIS ADQUIRIDOS E DESTINADOS A PESQUISA DA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.15','IMPORTACOES EM ANDAMENTO DO EXERCICIO','REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, DURANTE O EXERCICIO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.16','IMPORTACOES EM ANDAMENTO DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS IMPORTACOES EM ANDAMENTO DE BENS DE ESTOQUE, INICIADAS EM EXERCICIOS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.17','TERRENOS - CONSTRUCOES CIVIS','REGISTRA OS VALORES DE TERRENOS, INCLUINDO-SE OS CUSTOS DE FORMACAO OU DE URBANIZACAO E AJUSTES MONETARIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.18','PROJETOS - CONSTRUCOES CIVIS','REGISTRA OS VALORES DOS CUSTOS RELATIVOS AOS PROJETOS DE ARQUITETURA E URBANISMO PARA CONSTRUCOES E URBANIZACOES DE IMOVEIS QUE DEVERAO SER COLOCADOS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.19','OBRAS EM ANDAMENTO - CONSTRUCOES CIVIS','REGISTRA OS VALORES RELATIVOS A OBRAS EM ANDAMENTO, DESTINADAS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.20','OBRAS CONCLUIDAS A COMERCIALIZAR - CONSTRUCOES CIVIS','REGISTRA OS VALORES RELATIVOS AS CONSTRUCOES E AS EDIFICACOES CONCLUIDAS QUE DEVERAO SER COLOCADAS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.21','CUSTOS ACESSORIOS DE CONSTRUCAO CIVIL','REGISTRA OS VALORES DE SEGUROS, REMUNERACOES A AGENTES FINANCEIROS, IMPOSTOS E TAXAS, DESPESAS COM LEGALIZACOES E CARTORARIAS RELATIVOS A IMOVEIS DESTINADOS A VENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.98.99','ESTOQUES DIVERSOS','REGISTRA ESTOQUES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.99.00','(-) PROVISAO PARA ESTOQUES','COMPREENDE O REGISTRO DAS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS, BEM COMO O REGISTRO DA PROVISAO PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO. CONTA A SER UTILIZADA APENAS PARA OS ESTOQUES CLASSIFICADOS NO ATIVO REALIZAVEL A LONGO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.99.01','(-) PROVISAO PARA PERDAS EM ESTOQUES','REGISTRA AS PERDAS CONHECIDAS EM ESTOQUES E CALCULADAS POR ESTIMATIVA, RELATIVAS A ESTOQUES DETERIORADOS OU OBSOLETOS E PARA DAR COBERTURA A DIFERENCAS FISICAS, QUANDO TAIS PERDAS NAO PUDEREM SER BAIXADAS DAS PROPRIAS CONTAS, PELO FATO DE NAO ESTAREM IDENTIFICADOS OS ITENS ESPECIFICOS E POR CONSTITUIREM ESTIMATIVAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.4.1.99.02','(-) PROVISAO PARA REDUCAO AO VALOR DE MERCADO','REGISTRA A PROVISAO PARA OS ESTOQUE QUE TIVEREM O VALOR DE MERCADO INFERIOR AO SEU CUSTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.0.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO APOS O TERMINO DO EXERCICIO SEGUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- EXTRA OFSS','COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.01.00','PREMIOS DE SEGUROS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE PREMIOS DE SEGURO A APROPRIAR. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.02.00','VPD FINANCEIRAS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.04.00','ALUGUEIS PAGOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.05.00','TRIBUTOS PAGOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.06.00','CONTRIBUICOES CONFEDERATIVAS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE CONTRIBUICOES CONFEDERATIVAS A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.07.00','BENEFICIOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE BENEFICIO A PESSOAL A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.99.00','DEMAIS VPD A APROPRIAR','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.99.01','DIREITOS AUTORAIS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.99.02','COMISSOES E PREMIOS PAGOS A APROPRIAR','REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.1.99.99','OUTRAS VPD A APROPRIAR','REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- INTRA OFSS','COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.02.00','VPD FINANCEIRAS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.04.00','ALUGUEIS PAGOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.05.00','TRIBUTOS PAGOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.99.00','DEMAIS VPD A APROPRIAR','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.99.01','DIREITOS AUTORAIS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.99.02','COMISSOES E PREMIOS PAGOS A APROPRIAR','REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.2.99.99','OUTRAS VPD A APROPRIAR','REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- INTER OFSS','COMPREENDE PAGAMENTOS DE VARIACOES PATRIMONIAIS DIMINUTIVAS (VPD) ANTECIPADAS, CUJOS BENEFICIOS OU PRESTACAO DE SERVICO A ENTIDADE OCORRERAO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.02.00','VPD FINANCEIRAS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO VPD FINANCEIRAS A APROPRIAR.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE ASSINATURAS E ANUIDADES A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.04.00','ALUGUEIS PAGOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE ALUGUEL A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.05.00','TRIBUTOS PAGOS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE TRIBUTOS PAGOS A APROPRIAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.99.00','DEMAIS VPD A APROPRIAR','COMPREEENDE OS DEMAIS VALORES PAGOS A APROPRIAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.99.01','DIREITOS AUTORAIS A APROPRIAR','REGISTRA OS VALORES PAGOS A TITULO DE DIREITOS AUTORAIS A SEREM APROPRIADOS QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.99.02','COMISSOES E PREMIOS PAGOS A APROPRIAR','REGISTRA OS PAGAMENTOS NAO RESTITUIVEIS A VENDEDORES OU REPRESENTANTES POR CONTA DE COMISSOES OU DE PREMIOS POR VENDAS QUE A ENTIDADE AINDA NAO CONTABILIZOU COMO VARIACOES PATRIMONIAIS AUMENTATIVAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.1.9.3.99.99','OUTRAS VPD A APROPRIAR','REGISTRA OUTROS VALORES PAGOS A APROPRIAR QUANDO DA EFETIVACAO DA VPD.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.0.0.00.00','INVESTIMENTOS','COMPREENDE AS PARTICIPACOES PERMANENTES EM OUTRAS SOCIEDADES, BEM COMO OS BENS E DIREITOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DA ATIVIDADE DA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.0.00.00','PARTICIPACOES PERMANENTES','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.00.00','PARTICIPACOES PERMANENTES - EXTRA OFSS','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.00','PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.01','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.02','PARTICIPACOES EM FUNDOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.03','PARTICIPACOES EM CONSORCIOS PUBLICOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.04','ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL','REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.05','ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC','REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.95','OUTRAS PARTICIPACOES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.96','AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.97','(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.98','(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.01.99','AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.02.00','PARTICIPACOES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.02.01','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.02.02','PARTICIPACOES EM FUNDOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.02.03','PARTICIPACOES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.1.02.99','OUTRAS PARTICIPACOES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.00.00','PARTICIPACOES PERMANENTES - INTRA OFSS','COMPREENDE AS PARTICIPACOES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.00','PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.01','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.02','PARTICIPACOES EM FUNDOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.03','PARTICIPACOES EM CONSORCIOS PUBLICOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.04','ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL','REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.05','ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC','REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.95','OUTRAS PARTICIPACOES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.96','AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.97','(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.98','(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.01.99','AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.02.00','PARTICIPACOES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.02.01','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.02.02','PARTICIPACOES EM FUNDOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.02.03','PARTICIPACOES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.2.02.99','OUTRAS PARTICIPACOES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.00.00','PARTICIPACOES PERMANENTES - INTER OFSS','COMPREENDE AS PARTICIPACOES PERMANENTES DA ENTIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.00','PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS ENTIDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.01','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.02','PARTICIPACOES EM FUNDOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.03','PARTICIPACOES EM CONSORCIOS PUBLICOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM CONSORCIOS PUBLICOS, AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.04','ADIANTAMENTO PARA AUMENTO DE CAPITAL - PRINCIPAL','REGISTRA OS VALORES DO PRINCIPAL PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.05','ADIANTAMENTO PARA AUMENTO DE CAPITAL - CORRECAO SELIC','REGISTRA OS VALORES DA CORRECAO PELA TAXA SELIC PARA AUMENTO DE CAPITAL NAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.95','OUTRAS PARTICIPACOES - MEP','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.96','AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA O VALOR DO AGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA ENTRE O CUSTO DO INVESTIMENTO E A PARTE DO INVESTIDOR NO VALOR JUSTO LIQUIDO DOS ATIVOS E PASSIVOS IDENTIFICAVEIS NA INVESTIDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.97','(-) AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA A AMORTIZACAO DE AGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.98','(-) DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA O DESAGIO NA AQUISICAO DE PARTICIPACOES, OU SEJA, A DIFERENCA A MENOR PAGA POR UMA PARTICIPACAO EM RELACAO AO SEU VALOR PATRIMONIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.01.99','AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','REGISTRA A AMORTIZACAO DE DESAGIO NA AQUISICAO DE PARTICIPACOES AVALIADAS PELO MEP','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.02.00','PARTICIPACOES AVALIADAS PELO METODO DE CUSTO','COMPREENDE AS PARTICIPACOES PERMANENTES DA UNIDADE EM OUTRAS SOCIEDADES EM FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.02.01','PARTICIPACOES EM EMPRESAS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM EMPRESAS NA FORMA DE ACOES OU COTAS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.02.02','PARTICIPACOES EM FUNDOS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM FUNDOS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.02.03','PARTICIPACOES EM ORGANISMOS INTERNACIONAIS','REGISTRA AS PARTICIPACOES PERMANENTES DA UNIDADE EM ORGANISMOS INTERNACIONAIS, AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.1.3.02.99','OUTRAS PARTICIPACOES - METODO DE CUSTO','REGISTRA OS VALORES DE OUTRAS PARTICIPACOES AVALIADAS PELO METODO DE CUSTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.2.0.00.00','PROPRIEDADES PARA INVESTIMENTO','COMPREENDE A PROPRIEDADE (TERRENO OU EDIFÍCIO -OU PARTE DE EDIFÍCIO - OU AMBOS) MANTIDA (PELO PROPRIETÁRIO OU PELO ARRENDATÁRIO EM ARRENDAMENTO FINANCEIRO) PARA AUFERIR ALUGUEL OU PARA VALORIZAÇÃO DO CAPITAL OU PARA AMBAS, E NÃO PARA: (A) USO NA PRODUÇÃO OU FORNECIMENTO DE BENS OU SERVIÇOS OU PARA FINALIDADES ADMINISTRATIVAS; OU (B) VENDA NO CURSO ORDINÁRIO DO NEGÓCIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.2.1.00.00','PROPRIEDADES PARA INVESTIMENTO - EXTRA OFSS','COMPREENDE A PROPRIEDADE (TERRENO OU EDIFÍCIO -OU PARTE DE EDIFÍCIO - OU AMBOS) MANTIDA (PELO PROPRIETÁRIO OU PELO ARRENDATÁRIO EM ARRENDAMENTO FINANCEIRO) PARA AUFERIR ALUGUEL OU PARA VALORIZAÇÃO DO CAPITAL OU PARA AMBAS, E NÃO PARA: (A) USO NA PRODUÇÃO OU FORNECIMENTO DE BENS OU SERVIÇOS OU PARA FINALIDADES ADMINISTRATIVAS; OU (B) VENDA NO CURSO ORDINÁRIO DO NEGÓCIO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.2.1.01.00','TERRENOS E IMOVEIS PARA FUTURA UTILIZACAO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.2.1.02.00','BENS IMOVEIS NAO DESTINADOS A USO','REGISTRA OS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.0.00.00','DEMAIS INVESTIMENTOS PERMANENTES','COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.1.00.00','DEMAIS INVESTIMENTOS PERMANENTES - EXTRA OFSS','COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.1.01.00','OBRAS DE ARTE','REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.1.03.00','BENS MOVEIS NAO DESTINADOS A USO','REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.1.05.00','BENS INTANGIVEIS NAO DESTINADOS A USO','REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.1.06.00','TITULOS E VALORES MOBILIARIOS PERMANENTES','REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.1.99.00','DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.2.00.00','DEMAIS INVESTIMENTOS PERMANENTES - INTRA OFSS','COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.2.01.00','OBRAS DE ARTE','REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.2.03.00','BENS MOVEIS NAO DESTINADOS A USO','REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.2.05.00','BENS INTANGIVEIS NAO DESTINADOS A USO','REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.2.06.00','TITULOS E VALORES MOBILIARIOS PERMANENTES','REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.2.99.00','DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.3.00.00','DEMAIS INVESTIMENTOS PERMANENTES - INTER OFSS','COMPREENDE OS DEMAIS DIREITOS DE QUALQUER NATUREZA NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO E QUE NAO SE DESTINEM A MANUTENCAO DAS ATIVIDADES DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.3.01.00','OBRAS DE ARTE','REGISTRA OS VALORES REFERENTES A OBRAS DE ARTE DA UNIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.3.03.00','BENS MOVEIS NAO DESTINADOS A USO','REGISTRA OS VALORES DE MOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.3.05.00','BENS INTANGIVEIS NAO DESTINADOS A USO','REGISTRA O VALOR DE BENS INTANGIVEIS NAO DESTINADOS AO USO E QUE A UNIDADE NAO EXPLORA COMERCIALMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.3.06.00','TITULOS E VALORES MOBILIARIOS PERMANENTES','REGISTRA O VALOR DOS TITULOS E VALORES MOBILIARIOS NAO CLASSIFICAVEIS NO ATIVO CIRCULANTE NEM NO ATIVO REALIZAVEL A LONGO PRAZO, COMO POR EXEMPLO AS DEBENTURES (PERPETUAS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.8.3.99.00','DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA O VALOR DE INVESTIMENTOS PERMANENTES, NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.0.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.1.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS -EXTRA OFSS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.1.01.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.1.02.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.2.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTRA OFSS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.2.01.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.2.02.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.3.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS -INTER OFSS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.3.01.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - PARTICIPACOES PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE PARTICIPACOES PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.2.9.3.02.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DEMAIS INVESTIMENTOS PERMANENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.0.0.00.00','IMOBILIZADO','COMPREENDE OS DIREITOS QUE TENHAM POR OBJETO BENS CORPOREOS DESTINADOS A MANUTENCAO DAS ATIVIDADES DA ENTIDADE OU EXERCIDOS COM ESSA FINALIDADE, INCLUSIVE OS DECORRENTES DE OPERACOES QUE TRANSFIRAM A ELA OS BENEFICIOS, OS RISCOS E O CONTROLE DESSES BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.0.00.00','BENS MOVEIS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE BENS CORPOREOS, QUE TEM EXISTENCIA MATERIAL E QUE PODEM SER TRANSPORTADOS POR MOVIMENTO PROPRIO OU REMOVIDOS POR FORCA ALHEIA SEM ALTERACAO DA SUBSTANCIA OU DA DESTINACAO ECONOMICO-SOCIAL, QUE CONSTITUAM MEIO PARA A PRODUCAO DE OUTROS BENS OU SERVICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.00.00','BENS MOVEIS-EXTRA OFSS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE BENS CORPOREOS, QUE TEM EXISTENCIA MATERIAL E QUE PODEM SER TRANSPORTADOS POR MOVIMENTO PROPRIO OU REMOVIDOS POR FORCA ALHEIA SEM ALTERACAO DA SUBSTANCIA OU DA DESTINACAO ECONOMICO-SOCIAL, QUE CONSTITUAM MEIO PARA A PRODUCAO DE OUTROS BENS OU SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.00','MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MAQUINAS, FERRAMENTAS, APARELHOS, EQUIPAMENTOS, ACESSORIOS ETC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.01','APARELHOS DE MEDICAO E ORIENTACAO','REGISTRA OS APARELHOS UTILIZADOS PARA MEDICAO E ORIENTACAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.02','APARELHOS E EQUIPAMENTOS DE COMUNICACAO','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA COMUNICACAO','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.03','APARELHOS, EQUIPAMENTOS E UTENSILIOS MEDICOS, ODONTOLOGICOS, LABORATORIAIS E HOSPITALARES ','REGISTRA OS APARELHOS, EQUIPAMENTOS E UTENSILIOS PARA USO MEDICO, ODONTOLOGICO, LABORATORIAL E HOSPITALAR.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.04','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSOES','REGISTRA OS APARELHOS E EQUIPAMENTOS UTILIZADOS PARA MODALIDADES DE ESPORTES E DIVERSOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.05','EQUIPAMENTO DE PROTECAO, SEGURANCA E SOCORRO','REGISTRA OS EQUIPAMENTOS UTILIZACOES PARA PROTECAO, SEGURANCA E SOCORRO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.06','MAQUINAS E EQUIPAMENTOS INDUSTRIAIS','REGISTRA AS MAQUINAS E EQUIPAMENTOS DE NATUREZA INDUSTRIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.07','MAQUINAS E EQUIPAMENTOS ENERGETICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS ENERGETICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.08','MAQUINAS E EQUIPAMENTOS GRAFICOS','REGISTRA AS MAQUINAS E EQUIPAMENTOS EMPREGADOS NA INDUSTRIA GRAFICA OU NECESSARIOS PARA SUA INDUSTRIALIZACAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.09','MAQUINAS, FERRAMENTAS E UTENSILIOS DE OFICINA','REGISTRA AS MAQUINAS, FERRAMENTAS E UTENSILIOS UTILIZADOS EM OFICINAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.10','EQUIPAMENTOS DE MONTARIA','REGISTRA OS EQUIPAMENTOS UTILIZADOS EM MONTARIAS, BEM COMO OS SERVICOS CORRELACIONADOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.11','EQUIPAMENTOS E MATERIAL SIGILOSO E RESERVADO','REGISTRA OS EQUIPAMENTOS E MATERIAIS UTILIZADOS EM ATIVIDADES DE CARATER SIGILOSO OU RESERVADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.12','EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS PARA AUTOMOVEIS QUE PODEM SER DESINCORPORADOS, SEM PREJUIZO DOS MESMOS, PARA APLICACAO EM OUTRO VEICULO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.13','EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS MARITIMOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.14','EQUIPAMENTOS, PECAS E ACESSORIOS AERONAUTICOS','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS AERONAUTICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.15','EQUIPAMENTOS, PECAS E ACESSORIOS DE PROTECAO AO VOO','REGISTRA OS EQUIPAMENTOS, PECAS E ACESSORIOS DE PROTECAO AO VOO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.16','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','REGISTRA OS EQUIPAMENTOS DE MERGULHO E SALVAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.17','EQUIPAMENTOS SOBRESSALENTES DE MAQUINAS E MOTORES DE NAVIO DE ESQUADRA','REGISTRA OS EQUIPAMENTOS SOBRESSALENTES DE MAQUINAS E MOTORES DE NAVIOS DE ESQUADRA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.18','EQUIPAMENTOS DE MANOBRAS E PATRULHAMENTO','REGISTRA OS EQUIPAMENTOS DESTINADOS AO EXERCICIO MILITAR, SERVICOS DE BORDO, GUARNICOES, RONDAS OU VIGILANCIA UTILIZADOS PELA UNIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.19','EQUIPAMENTOS DE PROTECAO E VIGILANCIA AMBIENTAL','REGISTRA OS EQUIPAMENTOS UTILIZADOS EM SISTEMAS DE PROTECAO E VIGILANCIA AEREA E AMBIENTAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.20','MAQUINAS, EQUIPAMENTOS E UTENSILIOS AGROPECUARIOS E RODOVIARIOS ','REGISTRA OS VALORES RELATIVOS A MAQUINAS, EQUIPAMENTOS, FERRAMENTAS E UTENSILIOS AGROPECUARIOS E REDOVIARIOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.21','EQUIPAMENTOS HIDRAULICOS E ELETRICOS','REGISTRA OS EQUIPAMENTOS HIDRAULICOS E ELETRICOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.22','EQUIP E MAT PERMANENTES VINCULADOS A CONVENIO ','REGISTRA OS EQUIPAMENTOS E MATERIAIS PERMANENTES ADQUIRIDOS COM RECURSOS DO CONVENIO DURANTE SUA VIGENCIA ATE DESTINACAO DEFINITIVA CONFORME DISPOE O ARTIGO 28 DA PORTARIA INTERMINISTERIAL MP/MF/CGU 127/2008','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.01.99','OUTRAS MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','REGISTRA OS VALORES REFERENTES A MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.02.00','BENS DE INFORMATICA','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E SISTEMAS APLICATIVOS, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.02.01','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA OS EQUIPAMENTOS DE PROCESSAMENTO DE DADOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.02.02','EQUIPAMENTOS DE TECNOLOGIA DA INFORMACAO','REGISTRA OS EQUIPAMENTOS RELACIONADOS COM TECNOLOGIA DA INFORMACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.03.00','MOVEIS E UTENSILIOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MOBILIARIO EM GERAL E UTENSILIOS, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.03.01','APARELHOS E UTENSILIOS DOMESTICOS','REGISTRA OS OBJETOS OU PECAS DE USO CASEIRO OU NECESSARIOS A VIDA FAMILIAR. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.03.02','MAQUINAS E UTENSILIOS DE ESCRITORIO','REGISTRA AS MAQUINAS E UTENSILIOS DE ESCRITORIO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.03.03','MOBILIARIO EM GERAL','REGISTRA OS VALORES RELATIVOS AOS BENS MOVEIS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.03.04','UTENSILIOS EM GERAL','REGISTRA OS VALORES RELATIVOS A UTENSILIOS, DE CARATER GERAL, EM USO NA UNIDADE, NAO CLASSIFICADOS EM CONTAS ANTERIORES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MATERIAIS BIBLIOGRAFICOS, DISCOTECAS, FILMOTECAS, DE COMUNICACAO, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.01','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA OS VALORES RELATIVOS A BANDEIRAS, FLAMULAS E INSIGNIAS, GERALMENTE UTILIZADAS COMO DISTINTIVO DA NACAO E DE CORPORACOES, PEQUENAS CHAMAS, ADORNOS, SINAL DISTINTIVO, EMBLEMAS, ESTANDARTES E OUTROS SIMBOLOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.02','COLECOES E MATERIAIS BIBLIOGRAFICOS','REGISTRA OS VALORES RELATIVOS AOS OBJETOS E MATERIAIS BIBLIOGRAFICOS DESTINADOS A REUNIR, GERALMENTE, PARA FORMACAO DE BIBLIOTECAS DE USO DA UNIDADE OU CUMPRIR OBJETIVOS DESSA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.03','DISCOTECAS E FILMOTECAS','REGISTRA OS VALORES RELATIVOS A DISCOS, CDS E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO, CIENTIFICO E INFORMATIVO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.04','INSTRUMENTOS MUSICAIS E ARTISTICOS','REGISTRA OS VALORES RELATIVOS AOS INSTRUMENTOS MUSICAIS E ARTISTICOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.05','EQUIPAMENTOS PARA AUDIO, VIDEO E FOTO','REGISTRA OS VALORES DE EQUIPAMENTOS DE AUDIO, VIDEO E FOTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.06','OBRAS DE ARTE E PECAS PARA EXPOSICAO','REGISTRA OS VALORES RELATIVOS A OBRAS E OBJETOS DE ARTE E DE PECAS PARA DECORACAO OU EXPOSICAO EM GERAL EM MUSEUS, GALERIAS, HALLS, PREDIOS PUBLICOS E OUTROS, DESDE QUE SE DESTINEM A MANUTENCAO DE SUA ATIVIDADE, CASO CONTRARIO, DEVE SER CLASSIFICADO COMO INVESTIMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.04.99','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','REGISTRA OS VALORES REFERENTES A MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO NAO CLASSIFICADOS EM CONTAS ANTERIORES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.00','VEICULOS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DE MEIOS DE TRANSPORTES AEREOS, AQUATICOS E TERRESTRES, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.01','VEICULOS EM GERAL','REGISTRA OS VEICULOS DE DIVERSOS TIPOS, NAO MOTORIZADOS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS ESPECIFICAS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.02','VEICULOS FERROVIARIOS','REGISTRA OS VEICULOS DESTINADOS AO TRAFEGO POR VIA FERREA E PARA USOS DIVERSOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.03','VEICULOS DE TRACAO MECANICA','REGISTRA OS VEICULOS DE TRACAO MECANICA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.04','CARROS DE COMBATE','REGISTRA OS CARROS DE COMBATE, TAIS COMO CARRO-TANQUE, AUTO-CHOQUE E ASSEMELHADOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.05','AERONAVES','REGISTRA OS VEICULOS DESTINADOS AO TRAFEGO AEREO, GERALMENTE DE USO COMERCIAL, NO TRANSPORTE DE PASSAGEIROS E CARGAS OU PARA TREINAMENTO, DEFESA E ATAQUE MILITAR, BEM COMO OUTRAS ATIVIDADES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.05.06','EMBARCACOES','REGISTRA AS EMBARCACOES ADQUIRIDAS OU CONSTRUIDAS E DESTINADAS A NAVEGACAO POR VIAS MARITIMAS, FLUVIAIS E OUTRAS VIAS NAVEGAVEIS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.06.00','PECAS E CONJUNTOS DE REPOSICAO','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DE PECAS E CONJUNTOS DE REPOSICAO DESTINADOS A SUBSTITUICAO EM MAQUINAS E EQUIPAMENTOS, AERONAVES E EMBARCACOES, BENS DE SEGURANCA E SOCORRO, ENTRE OUTROS.','D','s','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.07.00','BENS MOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS MOVEIS EM ANDAMENTO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.07.01','BENS MOVEIS EM ELABORACAO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS OCORRIDOS COM BENS MOVEIS EM FASE DE ELABORACAO E ACABAMENTO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.07.02','IMPORTACOES EM ANDAMENTO','REGISTRA OS VALORES RELATIVOS A TODOS OS GASTOS COM IMPORTACOES EM ANDAMENTO DE EQUIPAMENTOS, MAQUINAS, APARELHOS E OUTROS BENS MOVEIS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.07.03','ADIANTAMENTOS PARA INVERSOES EM BENS MOVEIS','REGISTRA OS ADIANTAMENTOS A FORNECEDORES POR FORNECIMENTO SOB ENCOMENDA DE BENS MOVEIS, QUE REPRESENTAM PAGAMENTOS POR UM VALOR PREVIAMENTE CONTRATADO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.07.04','ALMOXARIFADO DE INVERSOES FIXAS','REGISTRA TODOS OS MATERIAIS E BENS DA EMPRESA DESTINADOS A APLICACAO NA ELABORACAO DE BENS MOVEIS EM ANDAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.08.00','BENS MOVEIS EM ALMOXARIFADO','COMPREENDE OS VALORES DE BENS PERMANENTES A SEREM ESTOCADOS EM ALMOXARIFADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.08.01','ESTOQUE INTERNO','REGISTRA OS VALORES DOS BENS MOVEIS ADQUIRIDOS E ESTOCADOS EM ALMOXARIFADO, DESTINADOS A ATENDER AS NECESSIDADES DOS ORGAOS ADQUIRENTES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.08.02','ESTOQUE DE DISTRIBUICAO','REGISTRA OS VALORES DE BENS MOVEIS PARA FORMACAO DE ESTOQUE DE DISTRIBUICAO INTERNA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.08.03','BENS MOVEIS A REPARAR','REGISTRA OS VALORES DOS BENS MOVEIS QUE NECESSITAM DE REPAROS OU REFORMAS, ESTOCADOS EM ALMOXARIFADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.08.04','BENS MOVEIS EM REPARO','REGISTRA OS VALORES DOS BENS MOVEIS QUE ENCONTRAM-SE EM REPAROS OU REFORMAS, ESTOCADOS EM ALMOXARIFADO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.09.00','ARMAMENTOS','REGISTRA OS VALORES DE ARMAS QUE CONSTITUEM OBJETOS DE DEFESA OU PREPARATIVOS DE GUERRA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.10.00','SEMOVENTES','REGISTRA OS VALORES RELATIVOS AOS ANIMAIS DESTINADOS A PRODUCAO, REPRODUCAO, ENGORDA E AOS SERVICOS UTILITARIOS EM GERAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.00','DEMAIS BENS MOVEIS','COMPREENDE O VALOR DA AQUISICAO OU INCORPORACAO DOS DEMAIS BENS MOVEIS NAO CLASSIFICADOS EM GRUPOS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.01','BENS MOVEIS A ALIENAR','REPRESENTA OS REGISTROS DOS VALORES RELATIVOS AOS BENS MOVEIS QUE, POR ALGUM MOTIVO, FORAM DESTINADOS A ALIENACAO, MEDIANTE VENDA, PERMUTA OU DOACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.02','BENS EM PODER DE OUTRA UNIDADE OU TERCEIROS ','REGISTRA OS VALORES DE BENS MOVEIS DE PROPRIEDADE DA UNIDADE CEDENTE, ENTREGUES A OUTRA UNIDADE OU TERCEIROS POR MEIO DE CONVENIO, COMODATO OU OUTRAS FORMAS DE EMPRESTIMO, DISTRIBUICAO OU TRANSFERENCIA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.03','ESTOQUES EM ARMAZENS DE TERCEIROS A DISTRIBUIR','REGISTRA OS VALORES DE BENS MOVEIS ADQUIRIDOS OU TRANSFERIDOS PARA FORMACAO DE ESTOQUE DE DISTRIBUICAO EM ARMAZENS DE TERCEIROS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.04','ARMAZENS ESTRUTURAIS - COBERTURAS DE LONA',' REGISTRA OS VALORES DE ARMAZENS ESTRUTURAIS DE COBERTURA DE LONA DESTINADOS A DEPOSITO DE MERCADORIAS, MUNICOES E DE OUTROS MATERIAIS, COM POSSIBILIDADE DE MUDANCA DE LOCAL DE INSTALACAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.05','BENS MOVEIS EM TRANSITO','REGISTRA OS VALORES DE BENS MOVEIS TRANSFERIDOS PARA OUTRAS UNIDADES, QUANDO EM TRANSITO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.06','BENS MOVEIS EM RECUPERACAO','REGISTRA OS VALORES DOS BENS EM PROCESSO DE RECUPERACAO MAIS OS GASTOS REFERENTES AS ADAPTACOES OU REMODELAGENS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.07','BENS NAO LOCALIZADOS','REGISTRA OS BENS NAO ENCONTRADOS NO PROCESSO DE INVENTARIO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.08','BENS MOVEIS A CLASSIFICAR','REGISTRA OS BENS MOVEIS PENDENTES DE CLASSIFICACAO E DE IDENTIFICACAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.1.1.99.99','OUTROS BENS MOVEIS','REGISTRA O VALOR DA AQUISICAO OU INCORPORACAO DOS OUTROS BENS MOVEIS NAO CLASSIFICADOS ANTERIORMENTE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.0.00.00','BENS IMOVEIS','COMPREENDE O VALOR DOS BENS IMOVEIS, OS QUAIS SAO BENS VINCULADOS AO SOLO E QUE NAO PODEM SER RETIRADOS SEM DESTRUICAO OU DANO, DESTINADOS AO USO E QUE A ENTIDADE NAO ESTEJA EXPLORANDO COMERCIALMENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.00.00','BENS IMOVEIS-EXTRA OFSS','COMPREENDE O VALOR DOS BENS IMOVEIS, OS QUAIS SAO BENS VINCULADOS AO SOLO E QUE NAO PODEM SER RETIRADOS SEM DESTRUICAO OU DANO, DESTINADOS AO USO E QUE A ENTIDADE NAO ESTEJA EXPLORANDO COMERCIALMENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.00','BENS DE USO ESPECIAL REGISTRADOS NO SPIUNET','COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO FEDERAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS, CADASTRADOS NO SPIUNET.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.01','IMOVEIS RESIDENCIAIS / COMERCIAIS','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS RESIDENCIAIS/COMERCIAIS DA UNIAO, CONFIRME O CODIGO DA TABELA SPIU, A SABER: 05-APARTAMENTOS; 10-CASAS; 50-RESIDENCIAS; 15-CONJUNTOS. OS IMOVEIS FUNCIONAIS, OS PROPRIOS NACIONAIS RESIDENCIAIS (PNR) E AS VILAS MILITARES DEVEM SER REGISTRADOS NESSA CONTA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.02','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 19- EDIFICIOS/PREDIOS; 17- CONVENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.03','TERRENOS/GLEBAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 53- TERRENOS; 34- GLEBAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.04','ARMAZENS/GALPOES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 06- ARMAZENS; 33- GALPOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.05','AQUARTELAMENTOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 08- BASES; 47- QUARTEIS; 31- FORTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.06','AEROPORTOS/ESTACOES/AERODROMOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 02- AERODROMO; 03- AEROPORTO; 23- ESTACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.07','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 22- ESCOLAS; 28- FACULDADES; 54- UNIVERSIDADES; 09- BIBLIOTECAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.08','REPRESAS/ACUDES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 01- ACUDES; 48- REPRESAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.09','FAZENDAS, PARQUES E RESERVAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 30- FAZENDAS; 43- PARQUES; 49- RESERVAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.10','IMOVEIS DE USO RECREATIVO','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 12- CLUBES; 25- ESTADIOS; 52- TEATROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.11','ILHAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 37- ILHAS(ILHOTAS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.12','FAROIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 29- FAROIS (FAROLETES). OS INSTRUMENTOS DE AUXILIO A NAVEGACAO AEREA TAMBEM DEVEM SER REGISTRADOS NESTA CONTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.13','EMBAIXADAS E CONSULADOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 16- CONSULADOS; 20- EMBAIXADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.14','MUSEUS/PALACIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 40- MUSEUS; 42- PALACIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.15','LABORATORIOS/OBSERVATORIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 38- LABORATORIOS; 41- OBSERVATORIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.16','HOSPITAIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 35- HOSPITAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.17','HOTEIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 36- HOTEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.18','PRESIDIOS/DELEGACIAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 46- PRESIDIOS; 18- DELEGACIAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.19','PORTOS/ESTALEIROS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 26- ESTALEIROS; 44- PORTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.20','COMPLEXOS/FABRICAS/USINAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 27- FABRICAS; 55- USINAS; 14- COMPLEXOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.21','CEMITERIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 11- CEMITERIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.22','ESTACIONAMENTOS E GARAGENS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 24- ESTACIONAMENTOS. TAMBEM DEVEM SER REGISTRADOS NESTA CONTA AS GARAGENS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.23','LOJAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 39- LOJAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.24','SALAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 51- SALAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.25','ALFANDEGAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 04- ALFANDEGAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.26','AUTARQUIAS/FUNDACOES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 07- AUTARQUIAS/FUNDACOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.27','POSTOS DE FISCALIZACAO','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU: 57-POSTOS POLICIAIS. TAMBEM DEVEM SER REGISTRADOS NESSA CONTA DOS DEMAIS POSTOS DE FISCALIZACAO, TAIS COMO OS DO IBAMA, FUNAI, ETC. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.01.98','OUTROS BENS IMOVEIS REGISTRADOS NO SPIUNET','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DA UNIAO, CONFORME O CODIGO DA TABELA SPIU:56- OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.00','BENS DE USO ESPECIAL NAO REGISTRADOS NO SPIUNET','COMPREENDE OS BENS, TAIS COMO EDIFICIOS OU TERRENOS DESTINADOS A SERVICO OU ESTABELECIMENTO DA ADMINISTRACAO FEDERAL, INCLUSIVE OS DE SUAS AUTARQUIAS E FUNDACOES PUBLICAS, NAO CADASTRADOS NO SPIUNET.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.01','IMOVEIS RESIDENCIAIS / COMERCIAIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 05-APARTAMENTOS; 10-CASAS; 50-RESIDENCIAS; 15-CONJUNTOS. OS IMOVEIS FUNCIONAIS, OS PROPRIOS NACIONAIS RESIDENCIAIS (PNR) E AS VILAS MILITARES DEVEM SER REGISTRADOS NESSA CONTA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.02','EDIFICIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 19- EDIFICIOS/PREDIOS; 17- CONVENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.03','TERRENOS/GLEBAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 53- TERRENOS; 34- GLEBAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.04','ARMAZENS/GALPOES/SILOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 06- ARMAZENS; 33- GALPOES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.05','AQUARTELAMENTOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 08- BASES; 47- QUARTEIS; 31- FORTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.06','AEROPORTOS/ESTACOES/AERODROMOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 02- AERODROMO; 03- AEROPORTO; 23- ESTACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.07','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 22- ESCOLAS; 28- FACULDADES; 54- UNIVERSIDADES; 09- BIBLIOTECAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.08','REPRESAS/ACUDES','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 01- ACUDES; 48- REPRESAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.09','FAZENDAS, PARQUES E RESERVAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 30- FAZENDAS; 43- PARQUES; 49- RESERVAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.10','IMOVEIS DE USO RECREATIVO','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 12- CLUBES; 25- ESTADIOS; 52- TEATROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.11','ILHAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 37- ILHAS(ILHOTAS).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.12','FAROIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 29- FAROIS (FAROLETES). OS INSTRUMENTOS DE AUXILIO A NAVEGACAO AEREA TAMBEM DEVEM SER REGISTRADOS NESTA CONTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.13','EMBAIXADAS E CONSULADOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 16- CONSULADOS; 20- EMBAIXADAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.14','MUSEUS/PALACIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 40- MUSEUS; 42- PALACIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.15','LABORATORIOS/OBSERVATORIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 38- LABORATORIOS; 41- OBSERVATORIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.16','HOSPITAIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 35- HOSPITAIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.17','HOTEIS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 36- HOTEIS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.18','PRESIDIOS/DELEGACIAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 46- PRESIDIOS; 18- DELEGACIAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.19','PORTOS/ESTALEIROS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 26- ESTALEIROS; 44- PORTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.20','COMPLEXOS/FABRICAS/USINAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 27- FABRICAS; 55- USINAS; 14- COMPLEXOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.21','CEMITERIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 11- CEMITERIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.22','ESTACIONAMENTOS E GARAGENS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 24- ESTACIONAMENTOS. TAMBEM DEVEM SER REGISTRADOS NESTA CONTA AS GARAGENS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.23','LOJAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 39- LOJAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.24','SALAS E ESCRITORIOS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 51- SALAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.25','ALFANDEGAS','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 04- ALFANDEGAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.26','POSTOS DE FISCALIZACAO','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 57-POSTOS POLICIAIS. TAMBEM DEVEM SER REGISTRADOS NESSA CONTA DOS DEMAIS POSTOS DE FISCALIZACAO, TAIS COMO OS DO IBAMA, FUNAI, ETC. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.27','ARMAZENS ESTRUTURAIS - COBERTURAS DE LONA','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS PARA USO ESPECIFICO DE DEPOSITOS DE MERCADORIAS, MUNICOES OU ESTABELECIMENTOS COMERCIAIS E INDUSTRIAIS DE COBERTURA DE LONA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.28','AUTARQUIAS/FUNDACOES ',' REGISTRA OS VALORES DOS IMOVEIS DA UNIAO QUE NAO SAO CONTABILIZADOS NO SISTEMA DE PATRIMONIO DA UNIAO - SPIU, CORRESPONDENTES AOS CODIGOS DA TABELA SPIU: - AUTARQUIAS/FUNDACOES ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.02.98','OUTROS BENS IMOVEIS NAO REGISTRADOS NO SPIUNET','REGISTRA OS BENS IMOVEIS DE USO ESPECIAL QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILARIO DA UNIAO (SPIUNET), CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 56- OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.03.00','BENS DOMINICAIS REGISTRADOS NO SIAPA','COMPREENDE OS BENS QUE CONSTITUEM O PATRIMONIO DAS PESSOAS JURIDICAS DE DIREITO PUBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES REGISTRADOS NO SIAPA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.00','BENS DOMINICAIS NAO REGISTRADOS NO SIAPA','COMPREENDE OS BENS NAO REGISTRADOS NO SIAPA QUE CONSTITUEM O PATRIMONIO DAS PESSOAS JURIDICAS DE DIREITO PUBLICO, COMO OBJETO DE DIREITO PESSOAL, OU REAL, DE CADA UMA DESSAS ENTIDADES. COMPREENDE AINDA, NAO DISPONDO A LEI EM CONTRARIO, OS BENS PERTENCENTES AS PESSOAS JURIDICAS DE DIREITO PUBLICO A QUE SE TENHA DADO ESTRUTURA DE DIREITO PRIVADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.01','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS DE USO ESPECIAL DA UNIAO QUE NAO SE ENCONTREM REGISTRADOS NO SISTEMA DE PATRIMONIO IMOBILIARIO DA UNIAO (SPIUNET) CORRESPONDENTES AOS SEGUINTES CODIGOS DA TABELA SPIU: 19- EDIFICIOS/PREDIOS; 17- CONVENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.02','APARTAMENTOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: APARTAMENTOS (CORRESPONDENTE AO CODIGO 05 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.03','ARMAZENS ','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: ARMAZENS (CORRESPONDENTE AO CODIGO 06 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.04','CASAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: CASAS (CORRESPONDENTE AO CODIGO 10 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.05','CEMITERIOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: CEMITERIOS (CORRESPONDENTE AO CODIGO 11 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.06','EDIFICIOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: EDIFICIOS (CORRESPONDENTE AO CODIGO 19 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.07','GARAGENS E ESTACIONAMENTOS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAISDA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGO-RIA: GARAGENS E ESTACIONAMENTOS (CORRESPONDENTE AO CODIGO 24 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.08','FAZENDAS ','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAISDA UNIAO NAO-REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGO-RIA: FAZENDAS (CORRESPONDENTE AO CODIGO 30 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.09','GALPOES','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GALPOES (CORRESPONDENTE AO CODIGO 33 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.10','GLEBAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS (CORRESPONDENTE AO CODIGO 34 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.11','LOJAS ','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: LOJAS (CORRESPONDENTE AO CODIGO 39 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.12','SALAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: SALAS (CORRESPONDENTE AO CODIGO 51 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.13','TERRENOS ','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: TERRENOS (CORRESPONDENTE AO CODIGO 53 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.14','LOTES','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: LOTES (CORRESPONDENTE AO CODIGO 57 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.15','LOTES INDUSTRIAIS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: LOTES INDUSTRIAIS (CORRESPONDENTE AO CODIGO 58 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.16','GLEBAS URBANAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS URBANAS (CORRESPONDENTE AO CODIGO 59 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.17','GLEBAS URBANIZADAS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS URBANIZADAS (CORRESPONDENTE AO CODIGO 60 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.18','GLEBAS RURAIS','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: GLEBAS RURAIS (CORRESPONDENTE AO CODIGO 60 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA)','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.19','BENS DESTINADOS A REFORMA AGRARIA','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: BENS IMOVEIS DESTINADOS A REFORMA AGRARIA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.04.99','OUTROS BENS DOMINICAIS NAO REGISTRADOS NO SIAPA','REGISTRA OS VALORES PATRIMONIAIS RELATIVOS AOS BENS IMOVEIS DOMINIDAIS DA UNIAO NAO REGISTRADOS NO SIAPA QUE SE ENQUADREM NA SEGUINTE CATEGORIA: OUTROS (CORRESPONDENTE AO CODIGO 56 DA "RELACAO DE TIPOS DE IMOVEL" DO SIAPA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.00','BENS DE USO COMUM DO POVO','COMPREENDE OS BENS DE USO COMUM DO POVO CONSTRUIDOS OU ADQUIRIDOS POR PESSOAS JURIDICAS DE DIREITO PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.01','RUAS','REGISTRA OS VALORES DE RUAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.02','PRACAS','REGISTRA OS VALORES DE PRACAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.03','ESTRADAS','REGISTRA OS VALORES DE ESTRADAS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.04','PONTES','REGISTRA OS VALORES DE PONTES QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.05','VIADUTOS','REGISTRA OS VALORES DE VIADUTOS QUE FORAM CONSTRUIDAS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.05.99','OUTROS BENS DE USO COMUM DO POVO','REGISTRA OS VALORES BENS DE USO COMUM, NAO CLASSIFICADOS ANTERIORMENTE NESTE PLANO DE CONTAS, QUE FORAM ADQUIRIDOS, PRODUZIDOS OU CONSTRUIDOS UTILIZANDO-SE RECURSOS PUBLICOS E QUE ESTEJAM SOB CONTROLE OU ADMINISTRACAO DA UNIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.00','BENS IMOVEIS EM ANDAMENTO','COMPREENDE OS VALORES DE BENS IMOVEIS EM ANDAMENTO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.01','OBRAS EM ANDAMENTO','REGISTRA OS VALORES PERTINENTES A OBRAS, DESDE SUA CONSTRUCAO ATE O TERMINO DA MESMA. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.02','OBRAS EM ANDAMENTO - REGIME DE EXECUCAO ESPECIAL','REGISTRA O VALOR TOTAL DE OBRAS EM ANDAMENTO EM REGIME DE EXECUCAO ESPECIAL','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.03','OBRAS EM ANDAMENTO - CONVENIOS','REGISTRA O VALOR TOTAL DE OBRAS EM ANDAMENTO VINCULADAS EXCLUSIVAMENTE A CONVENIOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.04','ADIANTAMENTOS PARA INVERSOES EM BENS IMOVEIS','REGISTRA OS ADIANTAMENTOS A FORNECEDORES POR ENCOMENDAS DE BENS IMOVEIS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.05','ESTUDOS E PROJETOS','REGISTRA OS VALORES RELATIVOS A ESTUDOS E PROJETOS, ENGLOBANDO LIMPEZA DO TERRENO, SERVICOS TOPOGRAFICOS, SONDAGENS DE RECONHECIMENTO, TERRAPLENAGEM, DRENAGENS, INSTALACOES PROVISORIAS COMO GALPOES, INSTALACOES ELETRICAS E HIDRAULICAS, UTILIZADAS DURANTE AS OBRAS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.06.06','ALMOXARIFADO DE INVERSOES FIXAS','REGISTRA TODOS OS MATERIAIS E BENS DA EMPRESA DESTINADOS A APLICACAO NA CONSTRUCAO DE BENS IMOVEIS EM ANDAMENTO. COMO, POR EXEMPLO, ALMOXARIFADO DE MATERIAS DE CONSTRUCAO PARA APLICAR EM UMA OBRA EM ANDAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.07.00','INSTALACOES','REGISTRA EQUIPAMENTOS, MATERIAIS E CUSTO DE IMPLANTACAO DE INSTALACOES QUE, NAO OBSTANTE INTEGRADAS AOS EDIFICIOS, DEVEM SER SEGREGADAS DAS OBRAS CIVIS, COMO, POR EXEMPLO, AS INSTALCOES ELETRICAS, HIDRAULICAS, SANITARIAS, DE VAPOR, DE AR COMPRIMIDO, FRIGORIFICAS, CONTRA INCENDIO, DE COMUNICACOES, DE CLIMATIZACAO, PARA COMBUSTIVEIS, GASES, DE ANTIPOLUICAO, PARA COZINHA, DENTRE OUTROS. E TAMBEM APLICAVEL A CONSTRUCAO DE TRECHOS FERROVIARIOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.08.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','REGISTRA CONSTRUCOES EM TERRENOS ARRENDADOS DE TERCERIOS E INSTALACOES E OUTRAS BENFEITORIAS EM PREDIOS ALUGADOS. SAO CONSIDERADOS SOMENTE OS GASTOS COM CONSTRUCAO E INSTALACAO QUE SE INCORPORAM AO IMOVEL E REVERTEM AO PROPRIETARIO DO IMOVEL AO FINAL DA LOCACAO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.00','DEMAIS BENS IMOVEIS','COMPREENDE OS DEMAIS BENS IMOVEIS NAO CLASSIFICADOS ANTERIORMENTE NESSE PLANO DE CONTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.01','BENS IMOVEIS LOCADOS PARA TERCEIROS','REGISTRA OS BENS IMOVEIS LOCADOS PARA TERCEIROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.02','IMOVEIS EM PODER DE TERCEIROS','REGISTRA OS IMOVEIS CONCEDIDOS A TERCEIROS A TITULO DE EMPRESTIMO GRATUITO COM PRAZO DE DEVOLUCAO CONVENCIONADO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.03','MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMOVEIS ','REGISTRA OS MATERIAIS PROVISORIAMENTE SEPARADOS DE UM IMOVEL, PARA NELE SE REEMPREGAREM.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.04','IMOVEIS - REGIME DE EXECUCAO ESPECIAL','REGISTRA O VALOR TOTAL DE IMOVEIS EM REGIME DE EXECUCAO EXPECIAL, ESTANDO A SUA REALIZACAO SUBORDINADA A APROVACAO DE PLANO DE APLICACAO QUE DISCRIMINE A DESPESA REALIZADA NOS TERMOS DA PORTARIA SOF NRO. 04, DE 21/02/90. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.05','BENS IMOVEIS A CLASSIFICAR','REGISTRA OS BENS IMOVEIS, CUJA CLASSIFCACAO ESTA PENDENTE POR ALGUM MOTIVO, GERALMENTE POR FALTA DE IDENTIFICACAO OU PENDENCIA DE LEGALIZACAO OU REGISTRO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.06','BENS IMOVEIS A ALIENAR','REGISTRA OS VALORES RELATIVOS AOS BENS IMOVEIS SEPARADOS PARA ALIENACAO, QUANDO CONSIDERADOS DESNECESSARIOS, INSERVIVEIS OU POR DECISAO ADMINISTRATIVA DA UNIDADE. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.2.1.99.99','OUTROS BENS IMOVEIS','REGISTRA OS VALORES RELATIVOS A OUTROS BENS IOVEIS, PARA OS QUAIS NAO TENHAM SIDO CRIADAS CONTAS PROPRIAS OU ESPECIFICAS NESTE PLANO DE CONTAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.0.00.00','(-) DEPRECIACAO, EXAUSTAO E AMORTIZACAO ACUMULADAS','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA, BEM COMO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO E A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.1.00.00','(-) DEPRECIACAO, EXAUSTAO E AMORTIZACAO ACUMULADAS -EXTRA OFSS','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA, BEM COMO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO E A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.1.01.00','(-) DEPRECIACAO ACUMULADA','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.1.01.01','(-) DEPRECIACAO ACUMULADA DE BENS MOVEIS','COMPREENDE A DIMINUICAO DO VALOR DE BENS MOVEIS DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.1.01.02','(-) DEPRECIACAO ACUMULADA DE BENS IMOVEIS','COMPREENDE A DIMINUICAO DO VALOR BENS IMOVEIS DEVIDO A DESGASTE PELO USO, ACAO DA NATUREZA OU OBSOLESCENCIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.1.02.00','(-) EXAUSTAO ACUMULADA','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A PERDA DO VALOR, DECORRENTE DE SUA EXPLORACAO, DE DIREITOS CUJO OBJETO SEJAM RECURSOS MINERAIS OU FLORESTAIS OU BENS APLICADOS NESSA EXPLORACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.8.1.03.00','(-) AMORTIZACAO ACUMULADA','COMPREENDE A DIMINUICAO DO VALOR DOS ELEMENTOS DO ATIVO IMOBILIZADO DEVIDO A PERDA DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.9.0.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.9.1.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO -EXTRA OFSS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.9.1.01.00','(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO - BENS MOVEIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL BENS MOVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.3.9.1.02.00','(-) REDUCAO AO VALOR RECUPERAVEL DE IMOBILIZADO - BENS IMOVEIS','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL BENS IMOVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.0.0.00.00','INTANGIVEL','COMPREENDE OS DIREITOS QUE TENHAM POR OBJETO BENS INCORPOREOS DESTINADOS A MANUTENCAO DA ENTIDADE OU EXERCIDOS COM ESSA FINALIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.1.0.00.00','SOFTWARES','COMPREENDE OS VALORES DOS SOFTWARES PERTENCENTES A ENTIDADE E NAO INTEGRANTES A UM HARDWARE, ENGLOBANDO OS VALORES REFERENTES A SUA CONSTRUCAO, IMPLEMENTACAO E INSTALACAO. APENAS DEVEM SER REGISTRADOS NESTA CONTA OS SOFTWARES PASSIVEIS DE COMERCIALIZACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.1.1.00.00','SOFTWARES-EXTRA OFSS','REGISTRA OS VALORES DOS SOFTWARES PERTENCENTES A ENTIDADE E NAO INTEGRANTES A UM HARDWARE, ENGLOBANDO OS VALORES REFERENTES A SUA CONSTRUCAO, IMPLEMENTACAO E INSTALACAO. APENAS DEVEM SER REGISTRADOS NESTA CONTA OS SOFTWARES PASSIVEIS DE COMERCIALIZACAO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.0.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, DIREITOS DE USO DE COMUNICACAO E DIREITOS AUTORAIS, ALEM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICACAO (TECNOLOGIA).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS-EXTRA OFSS','COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, DIREITOS DE USO DE COMUNICACAO, DIREITOS AUTORAIS E DIREITOS SOBRE RECURSOS NATURAIS, ALEM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICACAO (TECNOLOGIA). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.01.00','MARCAS E PATENTES INDUSTRIAIS','REGISTRA OS VALORES RELATIVOS A BENS INTANGIVEIS, ENGLOBANDO OS GASTOS COM REGISTRO DE MARCA, NOME, INVENCOES PROPRIAS, ALEM DE DESEMBOLSOS A TERCEIROS POR CONTRATOS DE USO DE MARCAS, PATENTES OU PROCESSOS DE FABRICACAO (TECNOLOGIA).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.02.00','CONCESSAO DE DIREITO DE USO DE COMUNICACAO','REGISTRA OS VALORES RELATIVOS A BENS INTANGIVEIS REPRESENTADO PELA CONCESSAO DE DIREITO DE USO DE COMUNICACAO E DIVULGACAO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.03.00','DIREITOS AUTORAIS ','REGISTRA OS VALORES RELATIVOS AOS DIREITOS AUTORAIS ADQUIRIDOS PELA ENTIDADE.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.04.00','DIREITOS SOBRE RECURSOS NATURAIS','REGISTRA OS VALORES RELATIVOS AOS DIREITOS OBTIDOS POR LEGISLACAO E/OU POR COMPRAS DE DIREITOS DE RESERVAS OU DE EXPLORACAO DE RECURSOS NATURAIS, TAIS COMO JAZIDAS E OUTROS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.05.00',' ADIANTAMENTOS P/TRANSFERENCIA DE TECNOLOGIA',' REGISTRA TODOS OS ADIANTAMENTOS A FORNECEDORES VINCULADOS A UM CONTRATO DE TRANSFERENCIA DE TECNOLOGIA. REPRESENTAM PAGAMENTOS POR CONTA DE UM VALOR PREVIAMENTE CONTRATADO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.2.1.99.00','OUTROS DIREITOS - BENS INTANGIVEIS','REGISTRA OS VALORES RELATIVOS A OUTROS DIREITOS, CLASSIFICADOS COMO BENS INTANGIVEIS, CUJA CLASSIFICACAO NAO ESTEJA DEFINIDA EM CONTAS ESPECIFICAS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.3.0.00.00','DIREITO DE USO DE IMOVEIS','COMPREENDE OS VALORES PERTINENTES A BENS INTANGIVEIS REPRESENTADOS PELA AQUISICAO DO DIREITO DE USO DE IMOVEIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.3.1.00.00','DIREITO DE USO DE IMOVEIS-EXTRA OFSS','REGISTRA OS VALORES PERTINENTES A BENS INTANGIVEIS REPRESENTADOS PELA AQUISICAO DE DIREITO DE USO DE IMOVEIS. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.8.0.00.00','(-) AMORTIZACAO ACUMULADA','COMPREENDE A DIMINUICAO DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DA PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.8.1.00.00','(-) AMORTIZACAO ACUMULADA-EXTRA OFSS','COMPREENDE A DIMINUICAO DO VALOR DO CAPITAL APLICADO NA AQUISICAO DE DIREITOS DA PROPRIEDADE INDUSTRIAL OU COMERCIAL E QUAISQUER OUTROS COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.8.1.01.00','(-) AMORTIZACAO ACUMULADA - SOFTWARES','REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM SOFTWARES, PERTENCENTES AO ATIVO INTANGIVEL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.8.1.02.00','(-) AMORTIZACAO ACUMULADA - MARCAS, DIREITOS E PATENTES','REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM MARCAS, DIREITOS E PATENTES, PERTENCENTES AO ATIVO INTANGIVEL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.8.1.03.00','(-) AMORTIZACAO ACUMULADA - DIREITO DE USO DE IMOVEIS','REGISTRA A DIMINUICAO DO VALOR DO CAPITAL APLICADO EM DIREITO DE USO DE IMOVEIS, PERTENCENTES AO ATIVO INTANGIVEL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.9.0.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.9.1.00.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL -EXTRA OFSS','COMPREENDE OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.9.1.01.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL - SOFTWARES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DO SOFTWARE PERTENCENTE AO ATIVO INTANGIVEL, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.9.1.02.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL - MARCAS, DIREITOS E PATENTES','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DAS MARCAS, DIREITOS E PATENTES, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('1.2.4.9.1.03.00','(-) REDUCAO AO VALOR RECUPERAVEL DE INTANGIVEL -DIREITO DE USO','REGISTRA OS VALORES DE AJUSTE AO VALOR RECUPERAVEL DE DIREITO DE USO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.0.0.0.0.00.00','PASSIVO E PATRIMONIO LIQUIDO','PASSIVO COMPREENDE AS OBRIGACOES EXISTENTES DA ENTIDADE ORIUNDAS DE EVENTOS PASSADOS DE CUJA LIQUIDACAO SE ESPERA QUE RESULTE EM FLUXO DE SAIDA DE RECURSOS QUE INCORPOREM BENEFICIOS ECONOMICOS OU SERVICOS EM POTENCIAL. PATRIMONIO LIQUIDO COMPREENDE A DIFERENCA ENTRE O ATIVO E O PASSIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.0.0.0.00.00','PASSIVO CIRCULANTE','COMPREENDE AS OBRIGACOES CONHECIDAS E ESTIMADAS QUE ATENDAM A QUALQUER UM DOS SEGUINTES CRITERIOS: TENHAM PRAZOS ESTABELECIDOS OU ESPERADOS DENTRO DO CICLO OPERACIONAL DA ENTIDADE; SEJAM MANTIDOS PRIMARIAMENTE PARA NEGOCIACAO; TENHAM PRAZOS ESTABELECIDOS OU ESPERADOS ATE O TERMINO DO EXERCICIO SEGUINTE; SEJAM VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.0.0.00.00','OBRIGACOES TRABALHISTAS, PREVIDENCIARIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, APOSENTADORIAS, REFORMAS, PENSOES, ENCARGOS A PAGAR, BENEFICIOS ASSISTENCIAIS, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.0.00.00','PESSOAL A PAGAR','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.00.00','PESSOAL A PAGAR - EXTRA OFSS','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.01.00','PESSOAL A PAGAR DO EXERCICIO','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.01.01','SALARIOS, REMUNERACOES E BENEFICIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS AO EXERCICIO ATUAL.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.01.02','DECIMO TERCEIRO SALARIO','REGISTRA AS OBRIGACOES REFERENTES AO DECIMO TERCEIRO SALARIO, GERALMENTE APROPRIADAS NA BASE DE 1/12 DO VALOR BRUTO DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.01.03','FERIAS','REGISTRA AS OBRIGACOES REFERENTES A FERIAS, GERALMENTE APROPRIADAS COMO PERCENTUAIS DA FOLHA DE PAGAMENTO DA UNIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.01.04','LICENCA- PREMIO','REGISTRA OS VALORES DAS OBRIGACOES CONSTITUIDAS COM BASE EM PERCENTUAIS DE SALARIOS, DESTINADOS AO PAGAMENTO DE LICENCA-PREMIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.01.05','PARTICIPACOES A EMPREGADOS','REGISTRA OS VALORES DAS OBRIGACOES DO EXERCICIO CONSTITUIDAS PARA PAGAMENTO DE PARTICIPACOES A EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.02.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.02.01','SALARIOS, REMUNERACOES E BENEFICIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.02.02','PARTICIPACOES A EMPREGADOS - EXERCICIOS ANTERIORES','REGISTRA OS VALORES DAS OBRIGACOES DE EXERCICIOS ANTERIORES CONSTITUIDAS PARA PAGAMENTO DE PARTICIPACOES A EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.03.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.03.01','PRECATORIOS DE PESSOAL DO EXERCICIO','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.03.02','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.1.03.03','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.2.00.00','PESSOAL A PAGAR - INTRA OFSS','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.1.3.00.00','PESSOAL A PAGAR-INTER OFSS','REGISTRA AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.0.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR-EXTRA OFSS','COMPREENDE AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.1.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.2.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR-INTRA OFSS','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.2.3.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR-INTER OFSS','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA REQUISITADO TENHA DIREITO, PARA POSTERIOR REPASSE A UNIDADE CEDENTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.3.0.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR','COMPREENDE AS OBRIGACOES A CURTO PRAZO RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.3.1.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR -EXTRA OFSS','COMPREENDE AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO','REGISTRA AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL LIQUIDADOS NO EXERCICIO E AINDA NAO PAGOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.3.1.02.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR ','COMPREENDE AS OBRIGACOES A CURTO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR-EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.01.00','INSS A PAGAR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.01.01','INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.01.02','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.01.03','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.01.04','INSS - FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.02.00','ENCARGOS PREVIDENCIARIOS DA UNIAO','REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.02.01','ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.02.02','ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR','REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.03.00','PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.04.01','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.04.02','CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.05.00','PREVIDENCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.06.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.07.00','SALARIO - EDUCACAO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.08.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.08.01','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.08.02','ENTIDADES DE PREVIDENCIA COMPLEMENTAR','REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.08.04','DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS','REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.09.00','RECURSOS PREVIDENCIARIOS - GPS A EMITIR','REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.10.00','RECURSOS DO SALARIO EDUCACAO','REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.11.00','RECURSOS DA GFIP','REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.12.00','ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA','REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.1.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.01.00','INSS A PAGAR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.01.01','INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.01.02','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.01.03','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.01.04','INSS - FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.02.00','ENCARGOS PREVIDENCIARIOS DA UNIAO','REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.02.01','ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.02.02','ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR','REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.03.00','PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.04.01','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.04.02','CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.05.00','PREVIDENCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.06.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.07.00','SALARIO - EDUCACAO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.08.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.08.01','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA.PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.08.02','ENTIDADES DE PREVIDENCIA COMPLEMENTAR','REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.08.04','DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS','REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.09.00','RECURSOS PREVIDENCIARIOS - GPS A EMITIR','REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.10.00','RECURSOS DO SALARIO EDUCACAO','REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.11.00','RECURSOS DA GFIP','REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.12.00','ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA','REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.2.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS','COMPREENDE AS OBRIGACOES DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.01.00','INSS A PAGAR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.01.01','INSS - CONTRIBUICAO SOBRE SALARIOS E REMUNERACOES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.01.02','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.01.03','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES INCIDENTES SOBRE SERVICOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.01.04','INSS - FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.02.00','ENCARGOS PREVIDENCIARIOS DA UNIAO','REGISTRA OS VALORES DAS OBRIGACOES A TITULO DE ENCARGOS PREVIDENCIARIOS DA UNIAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.02.01','ENCARGOS PREVIDENCIARIOS DA UNIAO - DO EXERCICIO','REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.02.02','ENCARGOS PREVIDENCIARIOS DA UNIAO - DE EXERCICIO ANTERIOR','REGISTRA OS VALORES DOS ENCARGOS PREVIDENCIARIOS DA UNIAO, INCORRIDOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.03.00','PSSS - CONTRIBUICAO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.04.01','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS) DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.04.02','CONTRIBUICAO AO RPPS - PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.05.00','PREVIDENCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.06.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.07.00','SALARIO - EDUCACAO','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DO SALARIO - EDUCACAO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.08.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.08.01','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA.PRIVADA E ASSISTENCIA MEDICO-ODONTOLOGICA','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA E DE ASSISTENCIA MEDICO - ODONTOLOGICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.08.02','ENTIDADES DE PREVIDENCIA COMPLEMENTAR','REGISTRA AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA COMPLEMENTAR.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.08.04','DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADAS','REGISTRA OS VALORES RELATIVOS AO DEFICIT JUNTO A ENTIDADES DE PREVIDENCIA FECHADA POR PARTE DA PATROCINADORA PARA SANEAMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, EM ATENDIMENTO A EMENDA CONSTITUCIONAL Nº 20, DE 15/12/98.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.09.00','RECURSOS PREVIDENCIARIOS - GPS A EMITIR','REGISTRA O VALOR DOS CREDITOS PREVIDENCIARIOS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO INSS, ATRAVES DE GPS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.10.00','RECURSOS DO SALARIO EDUCACAO','REGISTRA O VALOR DOS CREDITOS DE SALARIO - EDUCACAO, REALIZADOS POR GE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.11.00','RECURSOS DA GFIP','REGISTRA O VALOR DOS CREDITOS DA GUIA DE RECOLHIMENTO DO FGTS - GFIP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.12.00','ENCARGOS SOCIAIS - CONVENIO DE ARRECADACAO DIRETA','REGISTRA OS VALORES A SEREM RECOLHIDOS A OUTRAS ENTIDADES, EM FUNCAODE DISPOSIIVOS LEGAIS COM AS QUAIS A UNIDADE MANTENHA CONVENIO DE AR-RECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER,SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.1.4.3.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.0.0.00.00','EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO','COMPREENDE AS OBRIGACOES FINANCEIRAS DA ENTIDADE A TITULO DE EMPRESTIMOS, BEM COMO FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE DO FORNECEDOR, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.0.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS COM PRAZOS TOTAIS SEJA APOS O EXERCICIO SEGUINTE. MAIORES QUE UM ANO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS -EXTRA OFSS','COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS COM PRAZOS TOTAIS MAIORES QUE UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.01.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS','COMPREENDE AS PARCELAS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS. COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.01.01','CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.01.02','CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.01.03','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.02.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS','COMPREENDE AS PARCELAS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS. COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.02.01','CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.1.02.02','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS -INTRA OFSS','COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS COM PRAZOS TOTAIS MAIORES QUE UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.01.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS','COMPREENDE AS PARCELAS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS. COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.01.01','CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.01.02','CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.01.03','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.02.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS','COMPREENDE AS PARCELAS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS. COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.02.01','CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.2.02.02','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.00.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS -INTER OFSS','COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.01.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS','COMPREENDE AS PARCELAS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS. COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.01.01','CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.01.02','CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.01.03','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.02.00','PARCELA A CURTO PRAZO DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS','COMPREENDE AS PARCELAS DOS EMPRESTIMOS E FINANCIAMENTOS EXTERNOS, CUJOS PRAZOS TOTAIS SEJAM MAIORES QUE UM ANO, COM VENCIMENTOS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS. COMPREENDE AS PARCELAS A CURTO PRAZO, COM VENCIMENTOS ATE O TERMINO DO EXERCICIO SEGUINTE, RELATIVAS A EMPRESTIMOS E FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.02.01','CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.1.3.02.02','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DE EXERCICIOS ANTERIORES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.0.00.00','EMPRESTIMOS A CURTO PRAZO','COMPREENDE OS EMPRESTIMOS, A CURTO PRAZO, EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU DE RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, COM PRAZO TOTAL ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.00.00','EMPRESTIMOS A CURTO PRAZO-EXTRA OFSS','COMPREENDE OS EMPRESTIMOS, A CURTO PRAZO, EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU DE RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, COM PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.00','EMPRESTIMOS INTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.01','DIVIDA MOBILIARIA','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.02','TITULOS DA DIVIDA AGRARIA (TDA)','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.03','(-) DESAGIO DE TITULOS','REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.04','(-) TITULOS A APROPRIAR - RECEBIMENTO DE DIVIDENDOS','REGISTRA OS VALORES A SEREM DEDUZIDOS DA DIVIDA DE TITULOS, CUJOS VALORES FORAM RECEBIDOS QUANDO DO PAGAMENTO DE DIVIDENDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.05','TITULOS INTERNOS RESGATADOS E RECOMPRADOS (PRINC.,JUROS E ENCARGOS)','REGISTRA OS VALORES DOS TITULOS INTERNOS RESGATADOS E RECOMPRADOS, INCLUINDO PRINCIPAL, JUROS E ENCARGOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.01.98','OUTROS TITULOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.02.00','EMPRESTIMOS EXTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.02.01','BRAZIL INVESTMENT BOND (BIB)','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE BONUS DO GOVERNO BRASILEIRO (BRAZIL INVESTMENT BOND) COM O OBJETIVO DE REDUZIR PARTE DA DIVIDA EXTERNA DO PAIS JUNTO A BANCOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.02.02','TITULOS EXTERNOS RESGATADOS ( PRINC.,JUROS E ENCARGOS) E RECOMPRADOS (PRINCIPAL)','REGISTRA OS VALORES DO PRINCIPAL, JUROS E ENCARGOS DOS TITULOS EXTERNOS RESGATADOS E DO PRINCIPAL DOS RECOMPRADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.02.03','TITULOS EXTERNOS RECOMPRADOS (JUROS E ENCARGOS)','REGISTRA OS VALORES DOS JUROS E ENCARGOS DOS TITULOS EXTERNOS RECOMPRADOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.02.98','OUTROS TITULOS - EMPRESTIMOS EXTERNOS','REGISTRA VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.01','CREDITOS SECURITIZADOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.02','CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.03','CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.04','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.05','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.06','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.07','ANTECIPACAO DE RECEITA ORCAMENTARIA','REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.03.98','OUTROS CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.04.00','EMPRESTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.04.01','CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.04.02','CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.04.03','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.04.04','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.04.98','OUTROS CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.05.00','OPERACOES DO BACEN','REGISTRA OS VALORES DE OPERACOES DO BACEN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.05.01','MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.05.02','TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.05.03','OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.05.04',' DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR ','REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.06.00','OPERACOES COMPROMISSADAS - BACEN','REGISTRA VALORES DAS OPERACOES COMPROMISSADAS - BACEN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.06.01','OPERACOES COMPROMISSADAS INTERNAS - BACEN','REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS INTERNAS DO BACEN.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.06.02','OPERACOES COMPROMISSADAS EXTERNAS - BACEN','REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS EXTERNAS DO BACEN.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.07.00','OPERACOES ESPECIAIS','REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.07.01','DEBITOS DE OPERACOES ESPECIAIS','REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.1.08.00','DEBITOS A TRANSFERIR','REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.00.00','EMPRESTIMOS A CURTO PRAZO-INTRA OFSS','COMPREENDE OS EMPRESTIMOS, A CURTO PRAZO, EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU DE RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, CUJO PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.00','EMPRESTIMOS INTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.01','DIVIDA MOBILIARIA','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.02','TITULOS DA DIVIDA AGRARIA (TDA)','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.03','(-) DESAGIO DE TITULOS','REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.04','(-) TITULOS A APROPRIAR - RECEBIMENTO DE DIVIDENDOS','REGISTRA OS VALORES A SEREM DEDUZIDOS DA DIVIDA DE TITULOS, CUJOS VALORES FORAM RECEBIDOS QUANDO DO PAGAMENTO DE DIVIDENDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.05','TITULOS INTERNOS RESGATADOS E RECOMPRADOS (PRINC.,JUROS E ENCARGOS)','REGISTRA OS VALORES DOS TITULOS INTERNOS RESGATADOS E RECOMPRADOS, INCLUINDO PRINCIPAL, JUROS E ENCARGOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.01.98','OUTROS TITULOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.02.00',' EMPRESTIMOS EXTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.02.01','BRAZIL INVESTMENT BOND (BIB)','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE BONUS DO GOVERNO BRASILEIRO (BRAZIL INVESTMENT BOND) COM O OBJETIVO DE REDUZIR PARTE DA DIVIDA EXTERNA DO PAIS JUNTO A BANCOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.02.02','TITULOS EXTERNOS RESGATADOS ( PRINC.,JUROS E ENCARGOS) E RECOMPRADOS (PRINCIPAL)','REGISTRA OS VALORES DO PRINCIPAL, JUROS E ENCARGOS DOS TITULOS EXTERNOS RESGATADOS E DO PRINCIPAL DOS RECOMPRADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.02.03','TITULOS EXTERNOS RECOMPRADOS (JUROS E ENCARGOS)','REGISTRA OS VALORES DOS JUROS E ENCARGOS DOS TITULOS EXTERNOS RECOMPRADOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.02.98','OUTROS TITULOS - EMPRESTIMOS EXTERNOS','REGISTRA VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.00',' EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.01','CREDITOS SECURITIZADOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.02','CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.03','CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.04','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.05','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.06','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.07','ANTECIPACAO DE RECEITA ORCAMENTARIA','REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.03.98','OUTROS CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.04.00','EMPRESTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.04.01','CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.04.02','CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.04.03','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.04.04','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.04.98','OUTROS CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.05.00','OPERACOES DO BACEN','REGISTRA OS VALORES DE OPERACOES DO BACEN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.05.01','MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.05.02','TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.05.03','OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.05.04',' DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR ','REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.06.00','OPERACOES COMPROMISSADAS - BACEN','REGISTRA VALORES DAS OPERACOES COMPROMISSADAS - BACEN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.06.01','OPERACOES COMPROMISSADAS INTERNAS - BACEN','REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS INTERNAS DO BACEN.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.06.02','OPERACOES COMPROMISSADAS EXTERNAS - BACEN','REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS EXTERNAS DO BACEN.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.07.00','OPERACOES ESPECIAIS','REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.07.01','DEBITOS DE OPERACOES ESPECIAIS','REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.2.08.00','DEBITOS A TRANSFERIR','REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.00.00','EMPRESTIMOS A CURTO PRAZO-INTER OFSS','COMPREENDE OS EMPRESTIMOS, A CURTO PRAZO, EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU DE RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, CUJO PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.00','EMPRESTIMOS INTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.01','DIVIDA MOBILIARIA','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.02','TITULOS DA DIVIDA AGRARIA (TDA)','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.03','(-) DESAGIO DE TITULOS','REGISTRA OS VALORES RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.04','(-) TITULOS A APROPRIAR - RECEBIMENTO DE DIVIDENDOS','REGISTRA OS VALORES A SEREM DEDUZIDOS DA DIVIDA DE TITULOS, CUJOS VALORES FORAM RECEBIDOS QUANDO DO PAGAMENTO DE DIVIDENDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.05','TITULOS INTERNOS RESGATADOS E RECOMPRADOS (PRINC.,JUROS E ENCARGOS)','REGISTRA OS VALORES DOS TITULOS INTERNOS RESGATADOS E RECOMPRADOS, INCLUINDO PRINCIPAL, JUROS E ENCARGOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.01.98','OUTROS TITULOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.02.00','EMPRESTIMOS EXTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.02.01','BRAZIL INVESTMENT BOND (BIB)','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO NO MERCADO DE BONUS DO GOVERNO BRASILEIRO (BRAZIL INVESTMENT BOND) COM O OBJETIVO DE REDUZIR PARTE DA DIVIDA EXTERNA DO PAIS JUNTO A BANCOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.02.02','TITULOS EXTERNOS RESGATADOS ( PRINC.,JUROS E ENCARGOS) E RECOMPRADOS (PRINCIPAL)','REGISTRA OS VALORES DO PRINCIPAL, JUROS E ENCARGOS DOS TITULOS EXTERNOS RESGATADOS E DO PRINCIPAL DOS RECOMPRADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.02.03','TITULOS EXTERNOS RECOMPRADOS (JUROS E ENCARGOS)','REGISTRA OS VALORES DOS JUROS E ENCARGOS DOS TITULOS EXTERNOS RECOMPRADOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.02.98','OUTROS TITULOS - EMPRESTIMOS EXTERNOS','REGISTRA VALORES EXIGIVEIS, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.00',' EMPRESTIMOS INTERNOS - EM CONTRATOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.01','CREDITOS SECURITIZADOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.02','CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CREDITOS SECURITIZADOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.03','CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.04','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.05','CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.06','CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS INTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.07','ANTECIPACAO DE RECEITA ORCAMENTARIA','REGISTRA OS VALORES REFERENTES A OPERACOES DE CREDITO POR ANTECIPACAO DE RECEITA DESTINADA A ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO, DEVENDO CUMPRIR AS EXIGENCIAS MENCIONADAS NO ART. 32 DA LEI COMPLEMENTAR Nº 101, PUBLICADA EM 04/05/2000 E AQUELAS PREVISTAS NO ART. 38 DA REFERIDA LEI. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.03.98','OUTROS CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.04.00',' EMPRESTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.04.01','CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.04.02','CONTRATOS DE EMPRESTIMOS EXTERNOS DE EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS DE EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.04.03','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.04.04','CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO DO EXERCICIO ANTERIOR','REGISTRA OS VALORES EM LIQUIDACAO, DECORRENTES DE CONTRATOS DE EMPRESTIMOS EXTERNOS COM CONTROLE DE AMORTIZACAO, DO EXERCICIO ANTERIOR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.04.98','OUTROS CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS, PARA AS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.05.00','OPERACOES DO BACEN','REGISTRA OS VALORES DE OPERACOES DO BACEN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.05.01','MOEDAS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM MOEDA A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.05.02','TITULOS A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM TITULOS A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.05.03','OURO A ENTREGAR P/ LIQUID. OPER. CONTRATADAS','REGISTRA OS VALORES DE OPERACOES COM OURO A ENTREGAR POR LIQUIDACAO - OPERACOES CONTRATADAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.05.04',' DEPOSIT.A PRAZO EM MOEDA ESTRANG A CONSTITUIR ','REGISTRA OS VALORES REFERENTES A DEPOSITOS A PRAZO EM MOEDA ESTRANGEIRA A CONSTITUIR, DECORRENTES DE OPERACOES CONTRATADAS DE VENDA DEFINITIVA A LIQUIDAR CONTA ESPECIFICA DO BANCO CENTRAL DO BRASIL ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.06.00','OPERACOES COMPROMISSADAS - BACEN','REGISTRA VALORES DAS OPERACOES COMPROMISSADAS - BACEN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.06.01','OPERACOES COMPROMISSADAS INTERNAS - BACEN','REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS INTERNAS DO BACEN.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.06.02','OPERACOES COMPROMISSADAS EXTERNAS - BACEN','REGISTRA OS VALORES DAS OPERACOES COMPROMISSADAS EXTERNAS DO BACEN.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.07.00','OPERACOES ESPECIAIS','REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULADAS A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.07.01','DEBITOS DE OPERACOES ESPECIAIS','REGISTRA A APROPRIACAO DOS VALORES DAS OPERACOES ESPECIAIS A PAGAR, CONTRAIDAS PELA UNIAO, ENTIDADES E INSTITUICOES, VINCULADAS A CONTRATOS E ACORDOS OU POR AUTORIZACOES LEGAIS, INCLUSIVE OS JUROS E SANCOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.2.3.08.00','DEBITOS A TRANSFERIR','REGISTRA A APROPRIACAO DE VALORES DECORRENTES DE OPERACOES DE CREDITO EM LIQUIDACAO A SEREM TRANSFERIDOS PARA O ORCAMENTO GERAL DA UNIAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.0.00.00','FINANCIAMENTOS A CURTO PRAZO','COMPREENDE AS OBRIGACOES, A CURTO PRAZO, DECORRENTES DE FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE DO FORNECEDOR, CUJO PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.00.00','FINANCIAMENTOS A CURTO PRAZO-EXTRA OFSS','COMPREENDE AS OBRIGACOES, A CURTO PRAZO, DECORRENTES DE FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE DO FORNECEDOR, CUJO PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.01.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.02.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.02.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.02.02','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.1.02.98','OUTROS FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.00.00','FINANCIAMENTOS A CURTO PRAZO-INTRA OFSS','COMPREENDE AS OBRIGACOES, A CURTO PRAZO, DECORRENTES DE FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE DO FORNECEDOR, CUJO PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.01.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.01.02','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.01.98','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.02.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.02.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.02.02','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.2.02.98','OUTROS FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.00.00','FINANCIAMENTOS A CURTO PRAZO-INTER OFSS','COMPREENDE AS OBRIGACOES, A CURTO PRAZO, DECORRENTES DE FINANCIAMENTO DE AQUISICOES EFETUADAS DIRETAMENTE DO FORNECEDOR, CUJO PRAZO TOTAL SEJA ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.01.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.01.02','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.01.98','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.02.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.02.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.02.02','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.3.3.02.98','OUTROS FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.4.0.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTO POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.4.1.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO - EXTRA OFSS','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTO POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.4.2.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO - INTRA OFSS','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTO POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.4.3.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO - INTER OFSS','REGISTRA AS OBRIGACOES A CURTO PRAZO REFERENTES A FINANCIAMENTO POR ARRENDAMENTO FINANCEIRO, ONDE SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS, A CURTO PRAZO, RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO -EXTRA OFSS','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.01.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.01.01','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.01.02','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.01.03','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.02.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.02.01','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.02.02','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.03.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.03.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.03.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.04.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.04.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.04.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.05.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.05.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.05.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.05.03','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.06.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.06.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.06.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.07.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.07.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.07.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.08.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.08.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.1.08.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO-INTRA OFSS','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS, RECONHECIDOS PELO REGIME DE COMPETENCIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.01.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.01.01','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.01.02','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.01.03','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.02.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.02.01','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.02.02','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.03.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.03.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.03.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.04.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.04.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.04.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.05.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.05.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.05.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.05.03','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.06.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.06.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.06.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.07.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.07.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.07.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.08.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.08.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.2.08.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO-INTER OFSS','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.01.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.01.01','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.01.02','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.01.03','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.02.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.02.01','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.02.02','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.03.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.03.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.03.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.04.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.04.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.04.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.05.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.05.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.05.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.05.03','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.06.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.06.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.06.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.07.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.07.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.07.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.08.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.08.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.5.3.08.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR-EXTRA OFSS','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.2.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR-INTRA OFSS','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.2.01.00','(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.2.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.3.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR-INTER OFSS','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A CURTO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.3.01.00','(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A EMPRESTIMOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.2.9.3.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALORES PREFIXADOS, REFERENTES A FINANCIAMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.0.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - EXTRA OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.01.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.02.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.03.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.03.01','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.03.03','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.04.00','CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.04.01','OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL','REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.05.00','CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.06.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.06.01','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.1.06.02','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDDE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - INTRA OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.01.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.02.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.03.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.03.01','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.03.03','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.04.00','CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.04.01','OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL','REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.05.00','CONTAS A PAGAR NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.06.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.06.01','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.2.06.02','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - INTER OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.01.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.02.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.03.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.03.01','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.03.03','PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.04.00','CONTAS A PAGAR CREDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.04.01','OBRIGACOES PARA FATURAMENTO - CONTROLE ESCRITURAL','REGISTRA OS VALORES DAS OBRIGACOES A PAGAR DECORRENTES DO FATURAMENTO DE BENS E SERVICOS, CONTROLADOS ESCRITURALMENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.05.00','CONTAS A PAGAR CREDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES NACIONAIS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.06.00','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.06.01','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.1.3.06.02','PRECATORIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','COMPREENDE OS VALORES RELATIVOS A PRECATORIOS DE CONTAS A PAGAR A CREDORES NACIONAIS DE EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.2.0.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.2.1.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - EXTRA OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, BEM COMO AS OBRIGACOES DECORRENTES DO FORNECIMENTO DE UTILIDADES E DA PRESTACAO DE SERVICOS, TAIS COMO DE ENERGIA ELETRICA, AGUA, TELEFONE, PROPAGANDA, ALUGUEIS E TODAS AS OUTRAS CONTAS A PAGAR COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.2.1.01.00','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.2.1.02.00','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.2.1.03.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES AO EXERCICIO ATUAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.3.2.1.04.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS CREDORES ESTRANGEIROS DECORRENTES DO FORNECIMENTO DE BENS/MATERIAIS E DA PRESTACAO DE SERVICOS, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.0.0.00.00','OBRIGACOES FISCAIS A CURTO PRAZO','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.0.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO-EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.01.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.02.00','IRPJ A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.03.00','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IMPOSTO DE RENDA PESSOA JURIDICA (IRPJ) E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO (CSSL), BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.04.00','II A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO II).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.05.00','IOF A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.06.00','ITR A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADETERRITORIAL RURAL (ITR).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.07.00','CPMF A RECOLHER ','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA (CPMF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.09.00','CSSL A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.10.00','COFINS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO A RECOLHER RELATIVAS A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL (COFINS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.11.00','PIS/PASEP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.13.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER',' REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO - INTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.01.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.02.00','IRPJ A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.03.00','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IMPOSTO DE RENDA PESSOA JURIDICA (IRPJ) E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO (CSSL), BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.04.00','IMPOSTO DE IMPORTACAO A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO II).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.05.00','IOF A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.06.00','ITR A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADETERRITORIAL RURAL (ITR).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.07.00','CPMF A RECOLHER ','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA (CPMF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.09.00','CSSL A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.10.00','COFINS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO A RECOLHER RELATIVAS A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL (COFINS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.11.00','PIS/PASEP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS FEDERAIS QUE TENHAM SIDO RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.13.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER',' REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM A UNIAO - INTER OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.01.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS A RECOLHER REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.02.00','IRPJ A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO DE RENDA PESSOA JURIDICA.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.03.00','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IMPOSTO DE RENDA PESSOA JURIDICA (IRPJ) E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO (CSSL), BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.04.00','IMPOSTO DE IMPORTACAO A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO II).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.05.00','IOF A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.06.00','ITR A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADETERRITORIAL RURAL (ITR).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.07.00','CPMF A RECOLHER ','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA (CPMF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.09.00','CSSL A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.10.00','COFINS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO A RECOLHER RELATIVAS A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL (COFINS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.11.00','PIS/PASEP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES A RECOLHER RELATIVAS AO PROGRAMA DE INTEGRACAO SOCIAL (PIS) E PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO ( PASEP).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.13.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS POR MEIO DE DARF. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, POR MEIO DE DOCUMENTO DE ARRECADACAO DE RECEITAS FEDERAIS (DARF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER',' REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.0.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS-EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.01.00','ICMS A RECOLHER','COMPREENDE O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.01.01','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITAS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.01.02','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO ','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.02.00','IPVA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.04.00','TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTES A TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.05.00','TAXA CONTRA INCENDIO','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.07.00','RECURSOS FISCAIS ESTADUAIS','REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.01.00','ICMS A RECOLHER','COMPREENDE O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.01.01','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITAS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.01.02','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO ','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.02.00','IPVA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.04.00','TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTES A TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA (CDO).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.05.00','TAXA CONTRA INCENDIO','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.07.00','RECURSOS FISCAIS ESTADUAIS ','REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS ESTADOS - INTER OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA ESTADUAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.01.00','ICMS A RECOLHER','COMPREENDE O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO OU SOBRE MERCADORIAS DE TERCEIROS ENTREGUES PARA DEPOSITO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.01.01','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDA IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E PRESTACAO DE SERVICOS (ICMS), SUJEITAS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.01.02','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO ','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS EM FUNCAO DA ENTRADA DE MERCADORIAS DE TERCEIROS ENTREGUES A UNIDADE PARA DEPOSITO EM ARMAZEM.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.02.00','IPVA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES EXIGIVEIS RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES (IPVA).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.04.00','TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA - CDO','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTES A TAXA DE COOPERACAO E DEFESA DA ORIZICULTURA (CDO).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.05.00','TAXA CONTRA INCENDIO','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.07.00','RECURSOS FISCAIS ESTADUAIS ','REGISTRA O VALOR DOS CREDITOS FISCAIS ORIUNDOS DE RECEBIMENTOS DE TRIBUTOS ESTADUAIS CUJO RECOLHIMENTO E REALIZADO POR MEIO DE DAR. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.2.3.99.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS. REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO ESTADUAL, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.0.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS -EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.01.00','ISS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS) EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.02.00','IPTU/TLP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.04.00','CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.06.00','RECURSOS FISCAIS MUNICIPAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS -INTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.01.00','ISS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS) EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.02.00','IPTU/TLP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.04.00','CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.06.00','RECURSOS FISCAIS MUNICIPAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.00.00','OBRIGACOES FISCAIS A CURTO PRAZO COM OS MUNICIPIOS -INTER OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM OS TRIBUTOS DE COMPETENCIA MUNICIPAL COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.01.00','ISS A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA (ISS) EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.02.00','IPTU/TLP A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA (IPTU) E TAXA DE LIMPEZA PUBLICA (TLP).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.04.00','CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA CONSTITUICAO FEDERAL)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.06.00','RECURSOS FISCAIS MUNICIPAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO PROVENIENTES DA RETENCAO DE TRIBUTOS E CONTRIBUICOES PELAS ENTIDADES PARA POSTERIOR RECOLHIMENTO AO GOVERNO MUNICIPAL, POR MEIO DE DOCUMENTO DE ARRECADACAO (DAR).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO REFERENTES A TAXA DE LICENCIAMENTO AMBIENTAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.4.3.3.99.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.5.0.0.00.00','OBRIGACOES DE REPARTICAO A OUTROS ENTES','COMPREENDE OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.5.0.3.00.00','OBRIGACOES DE REPARTICAO A OUTROS ENTES - INTER OFSS','REGISTRA OS VALORES ARRECADADOS DE IMPOSTOS E OUTRAS RECEITAS A SEREM REPARTIDOS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.0.0.00.00','PROVISOES A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.1.0.00.00','PROVISAO PARA RISCOS TRABALHISTAS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.1.1.00.00','PROVISAO PARA RISCOS TRABALHISTAS A CURTO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS , COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.1.1.01.00','PROVISAO PARA INDENIZACOES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZACOES TRABALHISTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.1.1.02.00','PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.0.00.00','PROVISOES PARA RISCOS FISCAIS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.00.00','PROVISOES PARA RISCOS FISCAIS A CURTO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.01.00','PROVISAO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRACAO','COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS E QUE SE ENCONTRAM NA ESFERA ADMINISTRATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.01.01','PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO NAO RECORRIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE AINDA NAO APRESENTOU RECURSO ADMINISTRATIVO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.01.02','PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO RECORRIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE APRESENTOU RECURSO ADMINISTRATIVO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.02.00','PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS - ESFERA JUDICIAL','COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE JA SE ENCONTRAM NA ESFERA JUDICIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.02.01','PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL NAO RECORRIDAS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL E QUE NAO ESTAO EM FASE RECURSAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.3.1.02.02','PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL EM FASE RECURSAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.0.00.00','PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.1.00.00','PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.1.01.00','PROVISAO PARA INDENIZACOES CIVEIS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.1.02.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.1.03.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.1.04.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.2.00.00','PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO - INTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.2.01.00','PROVISAO PARA INDENIZACOES CIVEIS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.2.02.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.2.03.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.2.04.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.3.00.00','PROVISAO PARA RISCOS CIVEIS A CURTO PRAZO -INTER OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.3.01.00','PROVISAO PARA INDENIZACOES CIVEIS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.3.02.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.3.03.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.4.3.04.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.5.0.00.00','PROVISAO PARA REPARTICAO DE CREDITOS A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGACOES DE REPARTICAO A OUTROS ENTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.5.3.00.00','PROVISAO PARA REPARTICAO DE CREDITOS A CURTO PRAZO - INTER OFSS','REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGACOES DE REPARTICAO A OUTROS ENTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.6.0.00.00','PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.6.1.00.00','PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO -EXTRA OFSS','REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.0.00.00','OUTRAS PROVISOES A CURTO PRAZO','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.1.00.00','OUTRAS PROVISOES A CURTO PRAZO -EXTRA OFSS','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.1.01.00','PROVISAO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.1.02.00','PROVISAO PARA REESTRUTURACAO','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.1.99.00','OUTRAS PROVISOES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.2.00.00','OUTRAS PROVISOES A CURTO PRAZO - INTRA OFSS','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.2.01.00','PROVISAO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.2.02.00','PROVISAO PARA REESTRUTURACAO','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.2.99.00','OUTRAS PROVISOES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.3.00.00','OUTRAS PROVISOES A CURTO PRAZO - INTER OFSS','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL ATE O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.3.01.00','PROVISAO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.3.02.00','PROVISAO PARA REESTRUTURACAO','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.8.9.3.99.00','OUTRAS PROVISOES A CURTO PRAZO','REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.0.0.00.00','DEMAIS OBRIGACOES A CURTO PRAZO','COMPREENDE AS OBRIGACOES DA ENTIDADE JUNTO A TERCEIROS NAO INCLUSAS NOS SUBGRUPOS ANTERIORES,INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.1.0.00.00','ADIANTAMENTOS DE CLIENTES','COMPREENDE AS ANTECIPACOES RECEBIDAS PELO ENTE POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.1.1.00.00','ADIANTAMENTOS DE CLIENTES-EXTRA OFSS','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.1.2.00.00','ADIANTAMENTOS DE CLIENTES-INTRA OFSS','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.1.3.00.00','ADIANTAMENTOS DE CLIENTES - INTER OFSS','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.2.0.00.00','OBRIGACOES POR DANOS A TERCEIROS','COMPREENDE OS VALORES EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.2.1.00.00','OBRIGACOES POR DANOS A TERCEIROS - EXTRA OFSS','COMPREENDE OS VALORES EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.2.2.00.00','OBRIGACOES POR DANOS A TERCEIROS - INTRA OFSS','COMPREENDE OS VALORES EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.2.3.00.00','OBRIGACOES POR DANOS A TERCEIROS - INTER OFSS','COMPREENDE OS VALORES EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.3.0.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.3.1.00.00','ARRENDAMENTO OPERACIONAL A PAGAR-EXTRA OFSS','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.3.2.00.00','ARRENDAMENTO OPERACIONAL A PAGAR-INTRA OFSS','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.3.3.00.00','ARRENDAMENTO OPERACIONAL A PAGAR-INTER OFSS','COMPREENDE AS OBRIGACOES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NAO SAO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, NAO HAVENDO A POSSIBILIDADE DE OPCAO DE COMPRA DO BEM ARRENDADO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.0.00.00','DEBENTURES E OUTROS TITULOS DE DIVIDA A CURTO PRAZO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.00.00','DEBENTURES E OUTROS TITULOS DE DIVIDA A CURTO PRAZO-EXTRA OFSS','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.01.00','DEBENTURES CONVERSIVEIS EM ACOES NO CURTO PRAZO','REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.02.00','DEBENTURES NAO-CONVERSIVEIS EM ACOES NO CURTO PRAZO','REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE NAO SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.96.00','AGIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE AGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS QUE SUPERA O DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.97.00','(-) DESAGIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE DESAGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS INFERIORES AO VALOR DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.98.00','(-) CUSTO DA TRANSACAO A AMORTIZAR','REGISTRA OS CUSTOS DA TRANSACAO A AMORTIZAR, QUE SAO APENAS OS CUSTOS INCORRIDOS E DIRETAMENTE ATRIBUIVEIS AS ATIVIDADES NECESSARIAS EXCLUSIVAMENTE A CONSECUCAO DA TRANSACAO. POR EXEMPLO: TAXAS E COMISSOES. ENTRETANTO, NAO INCLUEM DESPESAS FINANCEIRAS, CUSTOS INTERNOS ADMINISTRATIVOS OU CUSTO DE CARREGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.4.1.99.00','OUTROS TITULOS','REGISTRA OUTROS TITULOS DE DIVIDA COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.0.00.00','DIVIDENDOS A PAGAR','COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.1.00.00','DIVIDENDOS A PAGAR-EXTRA OFSS','COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.1.01.00','DIVIDENDOS A PAGAR - TESOURO NACIONAL',' REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.1.02.00','DIVIDENDOS A PAGAR - TERCEIROS',' REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.2.00.00','DIVIDENDOS A PAGAR-INTRA OFSS','COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.2.01.00','DIVIDENDOS A PAGAR - TESOURO NACIONAL',' REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.2.02.00','DIVIDENDOS A PAGAR - TERCEIROS',' REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.3.00.00','DIVIDENDOS A PAGAR-INTER OFSS','COMPREENDE OS DIVIDENDOS APROVADOS PELA ASSEMBLEIA GERAL A SEREM PAGOS AOS ACIONISTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.3.01.00','DIVIDENDOS A PAGAR - TESOURO NACIONAL',' REGISTRA OS VALORES A SEREM PAGOS AO TESOURO NACIONAL A TITULO DE DIVIDENDOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.5.3.02.00','DIVIDENDOS A PAGAR - TERCEIROS',' REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.0.00.00','VALORES RESTITUIVEIS','COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.00.00','VALORES RESTITUIVEIS - EXTRA OFSS','COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.00','CONSIGNACOES ','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.01','PSSS - VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.02','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.03',' ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.05','INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.06','IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.07','OUTROS TRIBUTOS DO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.08',' ICMS ','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.09',' ISS ','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.11','IRRF/GDF',' REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.12','PSSS/GDF',' REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.13','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.14','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.15','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.16','ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.17','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.18','RETENCOES - SINDICATOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.19','RETENCOES - ASSOCIACOES','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.20','RETENCOES - COOPERATIVAS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.21','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.22','RETENCOES - EMPRESTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.23','RETENCAO A LOCADORES DE IMOVEIS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.24','RETENCAO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.25','RETENCAO RELATIVA A VALE ALIMENTACAO','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.26','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.01.99','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.02.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.03.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.00','DEPOSITOS NAO JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.01','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.02','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.03','DEPOSITOS RETIDOS DE FORNECEDORES','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.05','DEPOSITOS A TRANSFERIR','REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.06','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.07','DEPOSITOS A DISTRIBUIR','REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.08','DEPOSITOS DE ENTIDADES','REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.09','DEPOSITOS DE RENDIMENTOS DO PIS/PASEP','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.10','DEPOSITOS DO ITR E CONTRIBUICOES RURAIS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.11','CONTRIBUICOES RURAIS A DISTRIBUIR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.12','DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO','REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.13','DEPOSITOS DO FAT - PMC','REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.14','DEPOSITOS DO FAT PRO-INOVACAO','REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.15','DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.16','DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.17','DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS','REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.18','DEPOSITO DE IMPOSTOS DO SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.19','PROGRAMA DE RECUPERACAO FISCAL - REFIS','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.20','CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.21','DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP),Lei nº 10.833/2003','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.22','DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.23','DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.24','PARCELAMENTO ESPECIAL PAES','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.25','PARCELAMENTO MP Nº 303/2006 - PAEX ','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.26','PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL','REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.27','PARCELAMENTO TIMEMANIA','REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.28','PARCELAMENTO FIES - LEI Nº 10.260/2001','REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.29','PARCELAMENTO MP Nº 449/2008','REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.30','PARCELAMENTO DE ARREMATACAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.31','PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009','REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.32','DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS','REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.33','DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS','REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.34','DEPOSITOS DO IMPOSTO SIMPLES - INSS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.35','DEPOSITOS REFIS - INSS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.36','DEPOSITOS PAES INSS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.37','DEPOSITOS PAES ISS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.38','DEPOSITOS PAES ICMS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.39','DEPOSITOS INSS SIMPLES NACIONAL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.40','INSS - PARCELAMENTO LEI Nº 11.941/2009','REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.41','MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP','REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.42','DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.43','DEPOSITOS DE TRIBUTOS A CLASSIFICAR','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.44','DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS','REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.45','DEPOSITOS DE TITULOS DO FIES A RECOLHER','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.46','DEPOSITOS DE TERCEIROS - BACEN','REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.47','DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.48','REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.49','DEPOSITOS PARA SERVICOS DE PUBLICIDADE','REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.50','PAGAMENTO / PARCELAMENTO - MP Nº 470','REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.51','RECURSOS DEPOSITADOS NO BACEN','REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.52','DEPOSITO DE RESTITUICOES DE TRIBUTOS SIEF','REGISTRA OS VALORES DEVOLVIDOS PELO BANCO DO BRASIL AO TESOURO NACIONAL DAS RESTITUICOES, POR LOTE, DE RECEITAS TRIBUTARIAS NAO CREDITADAS AOS CONTRIBUINTES. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.53','DEPOSITO ITR','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.54','DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR',' REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.04.99','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.05.00','SUBVENCOES E DOACOES PARA INVESTIMENTOS','REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.06.00','DEPOSITOS COMPULSORIOS','COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.06.01','DEPOSITOS COMPULSORIOS - COMBUSTIVEIS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.06.02','DEPOSITOS COMPULSORIOS - VEICULOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.06.98','OUTROS DEPOSITOS COMPULSORIOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.07.00','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS','DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.07.01','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)','REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.07.02','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)','REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.1.99.00','OUTROS VALORES RESTITUIVEIS','OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.00.00','VALORES RESTITUIVEIS - INTRA OFSS','COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.00','CONSIGNACOES ','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.01','PSSS - VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.02','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.03','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.05','INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.06','IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.07','OUTROS TRIBUTOS DO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.08','ICMS ','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.09','ISS ','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.11','IRRF/GDF','REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.12','PSSS/GDF',' REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.13','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS',' REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.14','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.15','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.16','ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.17','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.18','RETENCOES - SINDICATOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.19','RETENCOES - ASSOCIACOES','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.20','RETENCOES - COOPERATIVAS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.21','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.22','RETENCOES - EMPRESTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.23','RETENCAO A LOCADORES DE IMOVEIS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.24','RETENCAO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.25','RETENCAO RELATIVA A VALE ALIMENTACAO','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.26','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.01.99','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.02.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.03.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.00','DEPOSITOS NAO JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.01','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.02','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.03','DEPOSITOS RETIDOS DE FORNECEDORES','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.05','DEPOSITOS A TRANSFERIR','REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.06','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.07','DEPOSITOS A DISTRIBUIR','REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.08','DEPOSITOS DE ENTIDADES','REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.09','DEPOSITOS DE RENDIMENTOS DO PIS/PASEP','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.10','DEPOSITOS DO ITR E CONTRIBUICOES RURAIS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.11','CONTRIBUICOES RURAIS A DISTRIBUIR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.12','DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO','REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.13','DEPOSITOS DO FAT - PMC','REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.14','DEPOSITOS DO FAT PRO-INOVACAO','REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.15','DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.16','DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.17','DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS','REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES. CUJOS VALORES SAO A CLASSIFICAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.18','DEPOSITO DE IMPOSTOS DO SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.19','PROGRAMA DE RECUPERACAO FISCAL - REFIS','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.20','CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.21','DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP), Lei nº 10.833/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.22','DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.23','DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES ASS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.24','PARCELAMENTO ESPECIAL PAES','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.25','PARCELAMENTO MP Nº 303/2006 - PAEX ','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.26','PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL','REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.27','PARCELAMENTO TIMEMANIA','REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.28','PARCELAMENTO FIES - LEI Nº 10.260/2001','REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.29','PARCELAMENTO MP Nº 449/2008','REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.30','PARCELAMENTO DE ARREMATACAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.31','PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009','REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.32','DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS','REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.33','DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS','REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.34','DEPOSITOS DO IMPOSTO SIMPLES - INSS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.35','DEPOSITOS REFIS - INSS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTE AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.36','DEPOSITOS PAES INSS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.37','DEPOSITOS PAES ISS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.38','DEPOSITOS PAES ICMS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.39','DEPOSITOS INSS SIMPLES NACIONAL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.40','INSS - PARCELAMENTO LEI Nº 11.941/2009','REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.41','MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP','REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.42','DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.43','DEPOSITOS DE TRIBUTOS A CLASSIFICAR','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.44','DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS','REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.45','DEPOSITOS DE TITULOS DO FIES A RECOLHER','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.46','DEPOSITOS DE TERCEIROS - BACEN','REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.47','DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.48','REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.49','DEPOSITOS PARA SERVICOS DE PUBLICIDADE','REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.50','PAGAMENTO / PARCELAMENTO - MP Nº 470','REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.51','RECURSOS DEPOSITADOS NO BACEN','REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.53','DEPOSITO ITR','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.54','DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR',' REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.04.99','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.05.00','SUBVENCOES E DOACOES PARA INVESTIMENTOS','REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.06.00','DEPOSITOS COMPULSORIOS','COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.06.01','DEPOSITOS COMPULSORIOS - COMBUSTIVEIS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.06.02','DEPOSITOS COMPULSORIOS - VEICULOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.06.98','OUTROS DEPOSITOS COMPULSORIOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.07.00','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS','DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.07.01','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)','REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.07.02','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)','REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.2.99.00','OUTROS VALORES RESTITUIVEIS','OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.00.00','VALORES RESTITUIVEIS - INTER OFSS','COMPREENDE OS VALORES DE TERCEIROS OU RETENCOES EM NOME DELES, QUANDO A ENTIDADE DO SETOR PUBLICO FOR FIEL DEPOSITARIA, INDEPENDENTEMENTE DO PRAZO DE EXIGIBILIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.00','CONSIGNACOES ','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.01','PSSS - VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES REGIDOS PELA LEI Nº 8.112/90 A TITULO DE SEGURIDADE SOCIAL A SER RECOLHIDO AO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.02','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVICOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.03',' ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF DEVIDO AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.05','INDENIZACOES E RESTITUICOES DEVIDAS AO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS AS INDENIZACOES E RESTITUICOES DE TRIBUTOS COM AUTORIZACOES CONCEDIDAS, POREM NAO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE. REGISTRA OS VALORES A SEREM RECOLHIDOS AO TESOURO NACIONAL, A TITULO DE INDENIZACOES E RESTITUICOES DE TRIBUTOS, PROVENIENTES DE DESCONTO EM FOLHA. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.06','IMPOSTOS E CONTRIBUICOES DIVERSOS DEVIDOS AO TESOURO NACIONAL','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUICOES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.07','OUTROS TRIBUTOS DO TESOURO NACIONAL','REGISTRA OS VALORES RELATIVOS A OUTROS TRIBUTOS DO TESOURO NACIONAL RETIDOS PELA ENTIDADE SOBRE VALORES PAGOS OU CREDITADOS E QUE, SOBRE OS QUAIS, INCIDA O REFERIDO TRIBUTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.08',' ICMS ','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVICOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.09',' ISS ','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVICOS RETIDOS EM CONSIGNACOES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUACOES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTARIA. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.11','IRRF/GDF',' REGISTRA OS VALORES DO IMPOSTO DE RENDA RETIDO EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.12','PSSS/GDF',' REGISTRA OS VALORES DO PSSS EM CONSIGNACOES POR FORCA DE LEGISLACAO/CONVENIOS, A SEREM REPASSADOS AO GOVERNO DO DISTRITO FEDERAL (GDF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.13','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS',' REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.14','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.15','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.16','ASSISTENCIA A SAUDE - ADMINISTRACAO PROPRIA','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.17','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.18','RETENCOES - SINDICATOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS AOS RESPECTIVOS SINDICATOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.19','RETENCOES - ASSOCIACOES','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A ASSOCIACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.20','RETENCOES - COOPERATIVAS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS A COOPERATIVAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.21','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUICOES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.22','RETENCOES - EMPRESTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.23','RETENCAO A LOCADORES DE IMOVEIS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, PARA RECOLHIMENTOS E OU PAGAMENTOS A LOCADORES DE IMOVEIS A TITULO DE UTILIZACAO DE IMOVEIS FUNCIONAIS RESIDENCIAIS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.24','RETENCAO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.25','RETENCAO RELATIVA A VALE ALIMENTACAO','REGISTRA OS VALORES DAS CONSIGNACOES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVICOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.26','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA O VALOR TOTAL DA ARRECADACAO DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VALORES DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.01.99','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNACOES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.02.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.03.00','DEPOSITOS JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.00','DEPOSITOS NAO JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.01','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.02','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.03','DEPOSITOS RETIDOS DE FORNECEDORES','REGISTRA OS VALORES DE OBRIGACOES DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE FORNECEDORES EM FUNCAO DE APLICACAO DE MULTAS E OUTRAS DETERMINACOES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERENCIAS DIVERSAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.05','DEPOSITOS A TRANSFERIR','REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.06','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.07','DEPOSITOS A DISTRIBUIR','REGISTRA OS DEPOSITOS DECORRENTES DA FITA 50, RELACIONADOS COM A FONTE 0150025074 QUE E DESTINADA 80% PARA O CODIGO 07401 E 20% PARA O CODIGO 07402 (DESVINCULACAO DE RRECEITAS DA UNIAO - DRU) E AINDA AS APROPRIACOES REFERENTES A DEVOLUCAO DO PSSS DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.08','DEPOSITOS DE ENTIDADES','REGISTRA O VALOR DAS CONTRIBUICOES COM ENTIDADES TERCEIRAS TAIS COMO: SESI, SENAI, SESC, ETC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.09','DEPOSITOS DE RENDIMENTOS DO PIS/PASEP','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RENDIMENTOS DO PIS/PASEP PARA CREDITO EM FOLHA DE PAGAMENTO AOS SERVIDORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.10','DEPOSITOS DO ITR E CONTRIBUICOES RURAIS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL (ITR) E OUTRAS CONTRIBUICOES RURAIS PARA DISTRIBUICAO AOS BENEFICIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.11','CONTRIBUICOES RURAIS A DISTRIBUIR','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES RURAIS CLASSIFICADAS E AINDA NAO DISTRIBUIDAS AOS BENEFICIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.12','DEPOSITOS A DISTRIBUIR DO SALARIO-EDUCACAO','REGISTRA OS DEPOSITOS DECORRENTES DA ARRECADACAO DO SALARIO-EDUCACAO, PROVENIENTES DO DOCUMENTO GUIA DO SALARIO-EDUCACAO (GSE).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.13','DEPOSITOS DO FAT - PMC','REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PARA MELHORIA DA COMPETITIVIDADE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.14','DEPOSITOS DO FAT PRO-INOVACAO','REGISTRA O VALOR DOS DEPOSITOS ESPECIAIS DO FAT RELATIVOS AO PROGRAMA PRO-INOVACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.15','DEPOSITOS PARA IMPORTACOES - PESQUISA CIENTIFICA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ENTIDADES SEM FINS LUCRATIVOS ATIVAS NO FOMENTO, NA COORDENACAO OU NA EXECUCAO DE PROGRAMAS DE PESQUISA CIENTIFICA E TECNOLOGICA OU DE ENSINO, PARA A REALIZACAO DE IMPORTACOES DE BENS DESTINADOS A PESQUISA CIENTIFICA E TECNOLOGICA. BASE LEGAL: LEI Nº 8.010/1990.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.16','DEPOSITOS ISS A DISTRIBUIR - DAR SUBSTITUICAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DO IMPOSTO SOBRE SERVICOS (ISS) - RECOLHIDOS POR DAR SUBSTITUICAO - A DISTRIBUIR PARA OS MUNICIPIOS PARTICIPANTES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.17','DEPOSITOS DAS RETENCOES DE IMPOSTOS DO SIMPLES PELOS ORGAOS PUBLICOS','REGISTRA OS VALORES A CLASSIFICAR RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES. CUJOS VALORES SAO A CLASSIFICAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.18','DEPOSITO DE IMPOSTOS DO SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTOS E CONTRIBUICOES PELO SISTEMA SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.19','PROGRAMA DE RECUPERACAO FISCAL - REFIS','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.20','CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO REGISTRADA PELA FITA 50 DA SECRETARIA DA RECEITA FEDERAL DO BRASIL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.21','DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTO A PESSOA JURIDICA','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE RETENCOES DE CONTRIBUICOES SOBRE PAGAMENTOS DE PESSOA JURIDICA A PESSOA JURIDICA DE DIREITO PRIVADO (CSLL, COFINS, PIS/PASEP), Lei nº 10.833/2003. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.22','DEPOSITOS DO REGIME ESPECIAL TRIBUTARIO DO PATRIMONIO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO DE AFETACAO DE INCORPORACOES IMOBILIARIAS , INSTITUIDO PELA LEI Nº 10.931/2004.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.23','DEPOSITOS DE RETENCOES DE CONTRIBUICOES S/PAGAMENTO DE ESTADOS/DF/MUNICIPIOS A PESSOAS JURIDICAS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES ASS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS, DE ACORDO COM ART. 31 E 33 DA LEI Nº 10.833/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.24','PARCELAMENTO ESPECIAL PAES','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DO SEGURO SOCIAL (INSS), INSTITUIDO PELA LEI Nº 10.684/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.25','PARCELAMENTO MP Nº 303/2006 - PAEX ','REGISTRA O VALOR DOS RECURSOS ORIGINARIOS DA RENEGOCIACAO DE DIVIDAS ADMINISTRADAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), SECRETARIA DA RECEITA FEDERAL DO BRASIL (RFB) E INSTITUTO NACIONAL DE SEGURIDADE SOCIAL - INSS, CONFORME MEDIDA PROVISORIA Nº Nº 303/2006.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.26','PARCELAMENTO PARA INGRESSO NO SIMPLES NACIONAL','REGISTRA O VALOR DOS RECURSOS DE PARCELAMENTO DE DEBITOS COM O INSS OU COM AS FAZENDAS PUBLICAS FEDERAL, ESTADUAL OU MUNICIPAL PARA INGRESSO NO PROGRAMA SIMPLES NACIONAL, CONFORME LEI COMPLEMENTAR Nº 123/2006 - ART. 79.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.27','PARCELAMENTO TIMEMANIA','REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DA RENEGOCIACAO DE DIVIDAS DE ENTIDADES DESPORTIVAS JUNTO A PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN), CONFORME LEI Nº 11.345/2006, ALTERADA PELA LEI Nº 11.505/2007.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.28','PARCELAMENTO FIES - LEI Nº 10.260/2001','REGISTRA O VALOR DAS RECEITAS ARRECADADAS DECORRENTES DE PARCELAMENTO DE TRIBUTOS ADMINISTRADOS PELA RECEITA FEDERAL DO BRASIL - RFB TENDO COMO SUJEITO PASSIVO AS PESSOAS JURIDICAS DE DIREITO PRIVADO MANTENEDORAS DE INSTITUICOES DE ENSINO SUPERIOR QUE POSSUEM OS CERTIFICADOS DE EMISSAO DO TESOURO NACIONAL E OPTARAM PELO PARCELAMENTO, DESDE QUE TODAS AS INSTITUICOES MANTIDAS TENHAM ADERIDO AO PROGRAMA UNIVERSIDADE PARA TODOS (PROUNI). BASE LEGAL: LEI 10.260/2001, ART. 10, §§ 3º E 5º (REDACAO DADA PELA LEI 11.552/2007).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.29','PARCELAMENTO MP Nº 449/2008','REGISTRA O VALOR DOS RECURSOS DECORRENTE DE PARCELAMENTO DE DIVIDAS DE PEQUENO VALOR COM A FAZENDA NACIONAL E DIVIDAS DECORRENTES DE APROVEITAMENTO INDEVIDO DE CREDITOS DE IPI, CONFORME DISPOE A A MEDIDA PROVISORIA Nº 449, DE 03 DE DEZEMBRO DE 2008 LEI Nº 11.941/2009','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.30','PARCELAMENTO DE ARREMATACAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TRIBUTOS A CLASSIFICAR PROVENIENTES DO PARCELAMENTO DE VALOR CORRESPONDENTE A ARREMATACAO DE BEM EM HASTA PUBLICA NAS EXECUCOES FISCAIS PROMOVIDAS PELA PROCURADORIA-GERAL DA FAZENDA NACIONAL (PGFN) (PORTARIA 262 DE 11/06/2002).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.31','PARCELAMENTO - DEMAIS DEBITOS - LEI Nº 11.941/2009','REGISTRA OS VALORES RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941/2009, EXCETO OS DECORRENTES DE DEBITOS PREVIDENCIARIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.32','DEPOSITOS DE ICMS A DISTRIBUIR A ESTADOS','REGISTRA OS VALORES A DISTRIBUIR AOS ESTADOS RELATIVOS AOS DEPOSITOS DE ICMS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.33','DEPOSITOS DE ISS A DISTRIBUIR A MUNICIPIOS','REGISTRA OS VALORES A DISTRIBUIR AOS MUNICIPIOS RELATIVOS AOS DEPOSITOS DE ISS IMPOSTO PELO SISTEMA SIMPLES. CUJOS OS VALORES SAO A DISTRIBUIR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.34','DEPOSITOS DO IMPOSTO SIMPLES - INSS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE IMPOSTO PELO SISTEMA SIMPLES, RELATIVOS AO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.35','DEPOSITOS REFIS - INSS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTE AO PROGRAMA DE RECUPERACAO FISCAL (REFIS) INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.36','DEPOSITOS PAES INSS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO INSS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.37','DEPOSITOS PAES ISS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) DO ISS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.38','DEPOSITOS PAES ICMS SIMPLES','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003)DO ICMS SIMPLES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.39','DEPOSITOS INSS SIMPLES NACIONAL','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES A ARRECADACAO DO INSS SIMPLES NACIONAL,CONFORME LEI COMPLEMENTAR Nº 123,DE 14 DE DEZEMBRO DE 2006.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.40','INSS - PARCELAMENTO LEI Nº 11.941/2009','REGISTRA OS VALORES DECORRENTES DE DEBITOS PREVIDENCIARIOS, RELATIVOS AOS PARCELAMENTOS DE QUE TRATA A LEI Nº 11.941, DE 27 DE MAIO DE 2009.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.41','MULTA POR FALTA/ATRASO/ERRO/OMISSAO - GFIP','REGISTRA OS VALORES RELATIVOS A MULTA POR ERRO, OMISSAO, FALTA OU ATRASO NA ENTREGA DA DECLARACAO GFIP DE QUE TRATA O ART. 32A DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.42','DEPOSITOS PAES PARCELAMENTO DE ARREMATACAO','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) SOBRE O PARCELAMENTO DE ARREMATACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.43','DEPOSITOS DE TRIBUTOS A CLASSIFICAR','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS REFERENTES AO PARCELAMENTO ESPECIAL - PAES(LEI Nº 10.684 DE 30/05/2003) NAO CLASSIFICADOS EM CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.44','DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS','REGISTRA OS DEPOSITOS POR DEVOLUCAO DE VALORES NAO RECLAMADOS EM DECORRENCIA DE CANCELAMENTO DE ORDEM BANCARIA, TAIS COMO: PAGAMENTO DE SERVIDOR ATIVO, INATIVO, PENSIONISTA OU DE FORNECEDORES. O VALOR DEVERA FICAR REGISTRADO ENQUANTO NAO FOR REALIZADO NOVO PAGAMENTO OU DEVERA SER CLASSIFICADO COMO RECEITA APOS DEFINICAO DA NAO REALIZACAO DO NOVO PAGAMENTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.45','DEPOSITOS DE TITULOS DO FIES A RECOLHER','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TITULOS DO FIES PARA RECOLHIMENTO DE TRIBUTOS FEDERAIS E CONTRIBUICOES PREVIDENCIARIAS DEVIDOS PELAS INSTITUICOES DE ENSINO, RECOLHIDOS PELO FNDE POR MEIO DO SIAFI.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.46','DEPOSITOS DE TERCEIROS - BACEN','REGISTRA OS VALORES RELATIVOS AOS DARF/GPS EMITIDOS PELO BACEN (UG 173057) A SEREM ENVIADOS PELA COFIN POR MEIO DE OBR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.47','DEPOSITOS NA CONTA ESPECIAL - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES RELATIVOS AOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.48','REMUNERACAO DEPOSITOS CONTA ESPECIAL -EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES RELATIVOS AS REMUNERACOES DOS EMPRESTIMOS EXTERNOS DEPOSITADOS EM CONTA ESPECIAL NO BANCO DO BRASIL - ROTINA DE CONTROLE DOS EMPRESTIMOS EXTERNOS ANTES DO REGISTRO NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.49','DEPOSITOS PARA SERVICOS DE PUBLICIDADE','REGISTRA OS DEPOSITOS DESTINADOS A VEICULOS DE COMUNICACAO, ORIGINARIOS DOS SERVICOS DE PUBLICIDADE CONTRATADOS POR MEIO DE AGENCIA DE PUBLICIDADE, CONFORME LEI Nº 4680, DE 18 DE JUNHO DE 1965, DECRETO Nº 57690, DE 1 DE FEVEREIRO DE 1966, DECRETO Nº 4563, DE 31 DE DEZEMBRO DE 2002 E NORMAS PADRAO DA ATIVIDADE PUBLICITARIA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.50','PAGAMENTO / PARCELAMENTO - MP Nº 470','REGISTRA, CONFORME DISPOE A MEDIDA PROVISORIA Nº 470, DE 13 DE OUTUBRO DE 2009, O VALOR DECORRENTE DE PAGAMENTOS OU PARCELAMENTOS DE DEBITOS DECORRENTES DO APROVEITAMENTO INDEVIDO DO INCENTIVO FISCAL SETORIAL, INSTITUIDO PELO ART. 1º DO DECRETO-LEI Nº 491, DE 5 DE MARCO DE 1969, E OS ORIUNDOS DA AQUISICAO DE MATERIAS-PRIMAS, MATERIAL DE EMBALAGEM E PRODUTOS INTERMEDIARIOS RELACIONADOS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - TIPI, APROVADA PELO DECRETO Nº 6.006, DE 28 DE DEZEMBRO DE 2006, COM INCIDENCIA DE ALIQUOTA ZERO OU COMO NAO TRIBUTADOS - NT.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.51','RECURSOS DEPOSITADOS NO BACEN','REGISTRA OS VALORES DEPOSITADOS NO BACEN CONFORME O ARTIGO 164 DA CONSTITUICAO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.53','DEPOSITO ITR','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE ITR. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.54','DEPOSITOS RETIDOS PESSOAL/BENEFICIO A PAGAR',' REGISTRA OS VALORES DE OBRIGACOES, EXIGIVEIS ATE O CURSO DO EXERCICIO SEGUINTE, DECORRENTES DE DEPOSITOS RECEBIDOS/RETIDOS DE PESSOAL OU BENEFICIOS A PAGAR PARA POSTERIOR DESTINACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.04.99','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.05.00','SUBVENCOES E DOACOES PARA INVESTIMENTOS','REGISTRA OS VALORES EXIGIVEIS REFERENTES A SUBVENCOES E DOACOES PARA INVESTIMENTOS CONDICIONAIS, OU SEJA, QUE DEPENDAM DE FATO OU EVENTO FUTURO PARA SUA EFETIVACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.06.00','DEPOSITOS COMPULSORIOS','COMPREENDE OS VALORES DE OBRIGACOES CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS COMPULSORIOS RELATIVOS A COMBUSTIVEIS, VEICULOS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.06.01','DEPOSITOS COMPULSORIOS - COMBUSTIVEIS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE COMBUSTIVEIS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.06.02','DEPOSITOS COMPULSORIOS - VEICULOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS REFERENTES AS AQUISICOES DE VEICULOS POR ORGAOS, ENTIDADES, EMPRESAS E INSTITUICOES, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.06.98','OUTROS DEPOSITOS COMPULSORIOS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS OU EMPRESTIMOS COMPULSORIOS, PARA OS QUAIS NAO EXISTAM CONTAS ESPECIFICAS, COM DEVOLUCAO PREVISTA ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.07.00','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - ESTADOS/MUNICIPIOS','DESTINADA A ACOLHER OS VALORES DEPOSITADOS POR BLOQUEIO DE TRANSFERENCIAS CONSTITUCIONAIS A ESTADOS E MUNICIPIOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.07.01','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FPM)','REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DE FPM, REPASSADOS AOS MUNICIPIOS E DEVOLVIDOS A UNIAO POR MEIO DE GRU. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.07.02','DEPOSITOS ORIUNDOS DE BLOQUEIOS DE TRANSFERENCIAS CONSTITUCIONAIS - MUNICIPIOS (FUNDEF/FUNDEB)','REGISTRA OS VALORES DE DEPOSITOS DE MUNICIPIOS, RELATIVOS A CREDITOS DE RECURSOS BLOQUEADOS DO FUNDEF/FUNDEB POR ACAO JUDICIAL E DEPOSITADOS PELO BANCO DO BRASIL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.8.3.99.00','OUTROS VALORES RESTITUIVEIS','OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.0.00.00','OUTRAS OBRIGACOES A CURTO PRAZO','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.00.00','OUTRAS OBRIGACOES A CURTO PRAZO-EXTRA OFSS','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.01.01','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.01.02','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.01.03','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.01.04','RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.02.00','DIARIAS A PAGAR','REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.04.00','REEMBOLSOS A SEREM EFETUADOS PELO INSS','COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.04.01','SALARIO-FAMILIA A PAGAR','REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.04.02','AUXILIO - NATALIDADE A PAGAR','REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.04.03','DEBITOS EM APURACAO - INSS ','REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.04.04','DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI Nº 4380/64.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.04.99','OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.05.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.05.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.05.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.06.00','CONVENIOS A PAGAR - PORTAL/SICONV','COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.06.01','CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.06.02','CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.07.00','CONTRATO DE PROGRAMA DE REPASSE A PAGAR','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.07.01','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.07.02','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.08.00','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.08.01','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.08.02','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.09.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.10.00','TERMOS DE PARCERIA A PAGAR- PORTAL SICONV','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3.100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.10.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.10.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.11.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.11.01','TERMO DE COMPROMISSO A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.11.02','TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.12.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL','COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.13.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.13.01','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.13.02','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.13.03','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.14.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3.112/1999.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.14.01','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.14.02','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.15.00','TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF','REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.16.00','OPERACOES COM DERIVATIVOS','REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.17.00','DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO','REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.18.00','DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM','REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.19.00','BOLSAS PARA ESTUDOS ','COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.19.01','BOLSAS DE ESTUDOS - EXERCICIO','REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.19.02','BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.20.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.21.00','SERVICOS EVENTUAIS - PESSOAL TECNICO','REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI Nº 8.745/93 CONFORME DECRETO Nº 4.748/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.22.00','CONTRATOS DE COOPERACAO TECNICA','COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.22.01','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO','REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.22.02','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR','REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.23.00','AUXILIOS FINANCEIROS A PESQUISADORES ','COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.23.01','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.23.02','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.24.00','RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS','REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.00','TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS','COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.01','MERENDA ESCOLAR - PNAE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.02','DINHEIRO DIRETO NA ESCOLA - PDDE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.03','TRANSPORTE ESCOLAR - PNTE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.04','FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.05','FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.06','QUOTA ESTADUAL - SALARIO EDUCACAO','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI Nº 9.766/98.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.07','EDUCACAO DE JOVENS E ADULTOS - EJA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE N.05/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.08','PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED','REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI Nº 10.845/2004.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.09','BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA','REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI Nº 10.219/2001.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.10','APOIO AO TRANSPORTE DO ESCOLAR - PNATE','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP Nº 173/2004, DOU 17/03/04','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.11','APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP Nº 173/2004, DOU 17/03/04.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.12','PROGRAMA BRASIL ALFABETIZADO - CONVENIOS','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.13','DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.14','DINHEIRO DIRETO NA ESCOLA - PDDEF/PME','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE MELHORIA DA ESCOLA DO FUNDESCOLA - PDDEF/PME.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.15','BOLSA ESCOLA DE FABRICA','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.16','FORMACAO DE PROFESSORES','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.17','PROINFANTIL','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.18','PROFORMACAO','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.19','PROLICENCIATURA','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.20','PROGRAMA UNIVERSIDADE ABERTA DO BRASIL','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.21','BOLSAS BRASIL ALFABETIZADO','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.22','PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.23','FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15FEV2007.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.24','PROJOVEM URBANO','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.25','PROJOVEM CAMPO - SABERES DA TERRA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.26','PROJOVEM TRABALHADOR','REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.27','TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE','REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.28','PROGRAMA PRIMEIRO EMPREGO - PNPE','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.29','PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO','REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.25.30','PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA','REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.26.00','ENTIDADES CREDORAS - FEDERAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.27.00','ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.29.00','RESULTADO NEGATIVO DO BANCO CENTRAL','COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.29.01','RESULTADO NEGATIVO DO BACEN - BALANCO APURADO','REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.29.02','RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS','REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.30.00','EMPRESTIMOS E FINANCIAMENTOS A LIBERAR','REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.31.00','INCENTIVOS A LIBERAR','REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.32.00','TRANSFERENCIAS CONSTITUCIONAIS A RECOLHER','REGISTRA O VALOR DAS TRANSFERENCIAS CONSTITUCIONAIS A RECOLHER NO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.33.00','ADIANTAMENTOS RECEBIDOS','COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.33.01','ADIANTAMENTOS DE OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.33.02','ADIANTAMENTOS DE UNIDADES E ENTIDADES','REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.33.03','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.34.00','DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO','REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.34.02','OPERACOES COM DERIVATIVOS - SWAP','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.34.03','OPERACOES COM DERIVATIVOS - FORWARD','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.34.04','OPERACOES COM DERIVATIVOS - FUTUROS','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.34.05','OPERACOES COM DERIVATIVOS - TERMO','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.35.00','INTERMEDIARIOS DE INVESTIMENTOS','COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.35.01','VALORES DE INVESTIMENTOS A PAGAR','REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.00','VALORES EM TRANSITO EXIGIVEIS','COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.01','GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA','REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.02','ORDENS BANCARIAS A EMITIR','REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.03','ORDENS BANCARIAS CANCELADAS','REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.04','GRU A CLASSIFICAR','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.05','SALDOS BANCARIOS EM UTILIZACAO','REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.06','DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.07','DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.09','SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.10','FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.11','TRANSFERENCIA AO BANCO DO BRASIL - OB SAQUE CARTAO','REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.36.12','ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)','REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.37.00','SUBVENCOES A PAGAR','COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.37.01','SUBVENCOES A PAGAR DO EXERCICIO','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.37.02','SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.38.00','RESTITUICOES DE RECEITAS A PAGAR','REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.39.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV','REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.01','RECURSOS A LIBERAR POR TRANSFERENCIA','REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.02','RECURSOS DE RESTOS A PAGAR A LIQUIDAR','REGISTRA OS VALORES REFERENTES A RECURSOS APROVADOS A SEREM LIBERADOS A TITULO DE TRANSFERENCIA PARA PAGAMENTO DE OBRIGACOES DE EXERCICIO ANTERIOR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.03','RESTOS A PAGAR NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTES DO ESTAGIO DA LIQUIDACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.04','RETIFICACAO DE RP NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTE DO ESTAGIO DE LIQUIDACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.05','TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.06','TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.07','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.08','RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS','REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.09','RECURSOS ORCAMENTARIOS A LIBERAR','REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.10','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.11','RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.12','RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.13','RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS','REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.14','RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS','REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.15','REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.16','LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA','REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.17','RECURSOS VINCULADOS - ENTIDADES TCT','REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.18','RECURSOS A LIBERAR PARA PAGAMENTO DE RP - INSCRICAO','REGISTRA O VALOR DO RECURSO A LIBERAR P/ PAGAMENTO DE RESTOS A PAGAR. CONTA UTILIZADA NO PROCESSO DE INSCRICAO DE RESTOS A PAGAR NO ENCERRAMENTO DO EXERCICIO, SENDO SEU SALDO TRANSFERIDO PARA O EXERCICIO POSTERIOR (TRANSAL), NA QUAL A EXECUCAO SERA REALIZADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.19','REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA','REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.40.20','(-) RECURSOS A LIBERAR PARA PAGAMENTO DE RP - RETIFICADORA','REGISTRA O VALOR DOS RECURSOS A LIBERAR P/PAGAMENTO DE RESTOS A PAGAR. CONTA RETIFICADORA PARA COMPENSAR O IMPACTO NO RESULTADO DAS UNIDADES QDO OCORRE O REGISTRO E/OU BAIXA DO LIMITE DE RECURSOS A RECEBER.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.41.00','PARTICIPACOES EM EMPRESAS COM PL NEGATIVO','COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.41.01','PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO','COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.41.99','PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES','REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.42.00','CONTRIBUICAO AO FUST A RECOLHER','REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.44.00','OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA',' REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.45.00','RECURSOS DA GRU','REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.46.00','RECURSOS FISCAIS','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.47.00','RESTITUICAO DE RECEITAS RECEBIDAS GRU','REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.98.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.98.01','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.1.98.02','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.00.00','OUTRAS OBRIGACOES A CURTO PRAZO-INTRA OFSS','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.01.01','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.01.02','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.01.03','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.01.04','RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.02.00','DIARIAS A PAGAR','REGISTRA OS VALORES RELATIVOS A DIARIAS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.04.00','REEMBOLSOS A SEREM EFETUADOS PELO INSS','COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.04.01','SALARIO-FAMILIA A PAGAR','REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.04.02','AUXILIO - NATALIDADE A PAGAR ','REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.04.03','DEBITOS EM APURACAO - INSS ','REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.04.04','DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI 4380/64.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.04.99','OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.05.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.05.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.05.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.06.00','CONVENIOS A PAGAR - PORTAL/SICONV','COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.06.01','CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.06.02','CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.07.00','CONTRATO DE PROGRAMA DE REPASSE A PAGAR','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.07.01','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.07.02','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.08.00','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.08.01','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.08.02','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.09.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.10.00','TERMOS DE PARCERIA A PAGAR- PORTAL SICONV','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.10.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.10.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.11.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.11.01','TERMO DE COMPROMISSO A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.11.02','TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.12.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL','COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.13.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.13.01','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.13.02','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.13.03','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.14.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.14.01','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.14.02','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.15.00','TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF','REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.16.00','OPERACOES COM DERIVATIVOS','REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.17.00','DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO','REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.18.00','DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM','REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.19.00','BOLSAS PARA ESTUDOS ','COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.19.01','BOLSAS DE ESTUDOS - EXERCICIO','REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.19.02','BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.20.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.21.00','SERVICOS EVENTUAIS - PESSOAL TECNICO','REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI 8745/93 CONFORME DECRETO Nº 4748/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.22.00','CONTRATOS DE COOPERACAO TECNICA','COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.22.01','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO','REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.22.02','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR','REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.23.00','AUXILIOS FINANCEIROS A PESQUISADORES ','COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.23.01','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.23.02','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.24.00','RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS','REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.00','TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS','COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.01','MERENDA ESCOLAR - PNAE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.02','DINHEIRO DIRETO NA ESCOLA - PDDE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.03','TRANSPORTE ESCOLAR - PNTE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.04','FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.05','FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.06','QUOTA ESTADUAL - SALARIO EDUCACAO','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI 9.766/98.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.07','EDUCACAO DE JOVENS E ADULTOS - EJA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE Nº 05/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.08','PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED','REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI Nº 10845, DE 08/MAR/04.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.09','BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA','REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI Nº 10.219, DE 11/04/2001.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.10','APOIO AO TRANSPORTE DO ESCOLAR - PNATE','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP 173/2004, DOU 17/03/04','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.11','APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP 173/2004, DOU 17/03/04.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.12','PROGRAMA BRASIL ALFABETIZADO - CONVENIOS','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.13','DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.14','DINHEIRO DIRETO NA ESCOLA - PDDEF/PME','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE MELHORIA DA ESCOLA DO FUNDESCOLA - PDDEF/PME.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.15','BOLSA ESCOLA DE FABRICA','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.16','FORMACAO DE PROFESSORES','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.17','PROINFANTIL','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.18','PROFORMACAO','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.19','PROLICENCIATURA','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.20','PROGRAMA UNIVERSIDADE ABERTA DO BRASIL','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.21','BOLSAS BRASIL ALFABETIZADO','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.22','PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.23','FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15FEV2007.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.24','PROJOVEM URBANO','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.25','PROJOVEM CAMPO - SABERES DA TERRA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.26','PROJOVEM TRABALHADOR','REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.27','TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE','REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.28','PROGRAMA PRIMEIRO EMPREGO - PNPE','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.29','PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO','REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.25.30','PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA','REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.26.00','ENTIDADES CREDORAS - FEDERAIS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.27.00','ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.29.00','RESULTADO NEGATIVO DO BANCO CENTRAL','COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.29.01','RESULTADO NEGATIVO DO BACEN - BALANCO APURADO','REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.29.02','RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS','REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.30.00','EMPRESTIMOS E FINANCIAMENTOS A LIBERAR','REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.31.00','INCENTIVOS A LIBERAR','REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.32.00','TRANSFERENCIAS CONSTITUCIONAIS A RECOLHER','REGISTRA O VALOR DAS TRANSFERENCIAS CONSTITUCIONAIS A RECOLHER NO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.33.00','ADIANTAMENTOS RECEBIDOS','COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.33.01','ADIANTAMENTOS DE OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.33.02','ADIANTAMENTOS DE UNIDADES E ENTIDADES','REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.33.03','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.34.00','DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO','REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.34.02','OPERACOES COM DERIVATIVOS - SWAP','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.34.03','OPERACOES COM DERIVATIVOS - FORWARD','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.34.04','OPERACOES COM DERIVATIVOS - FUTUROS','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.34.05','OPERACOES COM DERIVATIVOS - TERMO','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.35.00','INTERMEDIARIOS DE INVESTIMENTOS','COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.35.01','VALORES DE INVESTIMENTOS A PAGAR','REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.00','VALORES EM TRANSITO EXIGIVEIS','COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.01','GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA','REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.02','ORDENS BANCARIAS A EMITIR','REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.03','ORDENS BANCARIAS CANCELADAS','REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.04','GRU A CLASSIFICAR','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.05','SALDOS BANCARIOS EM UTILIZACAO','REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.06','DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.07','DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.09','SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.10','FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.11','TRANSFERENCIA AO BANCO DO BRASIL - OB SAQUE CARTAO','REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.36.12','ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)','REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.37.00','SUBVENCOES A PAGAR','COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.37.01','SUBVENCOES A PAGAR DO EXERCICIO','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.37.02','SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.38.00','RESTITUICOES DE RECEITAS A PAGAR','REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.39.00','VALORES DIFERIDOS','COMPREENDE O SALDO FINANCEIRO TOTAL DISPONIVEL NO FINAL DO EXERCICIOQUE SE CONSTITUIRA ANTECIPACAO DE COTA, REPASSE OU SUB-REPASSE DO EXERCICIO SEGUINTE (DECRETO-LEI Nº 1205/72).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.39.01','COTA RECEBIDA DIFERIDA','REGISTRA A PARCELA DE RECURSOS FINANCEIROS, NAO UTILIZADA DURANTE O E-XERCICIO, RECEBIDA POR UM ORGAO SETORIAL DE PROGRAMACAO FINANCEIRA,QUETRANSFERIRA PARA OUTRO, MAIS O LIMITE DE RP RECEBIDO, MENOS O LIMITEDE RP CONCEDIDO, CONSTITUINDO O TOTAL, DESSA FORMA, EM ANTECIPACAO DECOTA DO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.39.02','REPASSE RECEBIDO DIFERIDO','REGISTRA A PARCELA DE RECURSOS FINANCEIROS COLOCADOS A DISPOSICAO DAS UNIDADES, PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAO FOI UTILIZADA DURANTE O EXERCICIO E CONSTITUIRA ANTECIPACAO DE REPASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.39.03','SUB-REPASSE RECEBIDO DIFERIDO','REGISTRA A PARCELA DE RECURSOS FINANCEIROS COLOCADOS A DISPOSICAO DASUNIDADES, PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA, QUE NAOFOI UTILIZADA DURANTE O EXERCICIO E CONSTITUIRA ANTECIPACAO DE SUBRE-PASSE NO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.01','RECURSOS A LIBERAR POR TRANSFERENCIA','REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.02','RECURSOS DE RESTOS A PAGAR A LIQUIDAR','REGISTRA OS VALORES REFERENTES A RECURSOS APROVADOS A SEREM LIBERADOS A TITULO DE TRANSFERENCIA PARA PAGAMENTO DE OBRIGACOES DE EXERCICIO ANTERIOR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.03','RESTOS A PAGAR NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTES DO ESTAGIO DA LIQUIDACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.04','RETIFICACAO DE RP NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTE DO ESTAGIO DE LIQUIDACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.05','TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.06','TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.07','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.08','RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS','REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.09','RECURSOS ORCAMENTARIOS A LIBERAR','REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.10','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.11','RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.12','RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.13','RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS','REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.14','RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS','REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.15','REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.16','LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA','REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.17','RECURSOS VINCULADOS - ENTIDADES TCT','REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.18','RECURSOS A LIBERAR PARA PAGAMENTO DE RP -INSCRICAO','REGISTRA O VALOR DO RECURSO A LIBERAR P/ PAGAMENTO DE RESTOS A PAGAR. CONTA UTILIZADA NO PROCESSO DE INSCRICAO DE RESTOS A PAGAR NO ENCERRAMENTO DO EXERCICIO, SENDO SEU SALDO TRANSFERIDO PARA O EXERCICIO POSTERIOR (TRANSAL), NA QUAL A EXECUCAO SERA REALIZADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.19','REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA','REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.40.20','(-) RECURSOS A LIBERAR PARA PAGAMENTO DE RP -RETIFICADORA','REGISTRA O VALOR DOS RECURSOS A LIBERAR P/PAGAMENTO DE RESTOS A PAGAR. CONTA RETIFICADORA PARA COMPENSAR O IMPACTO NO RESULTADO DAS UNIDADES QDO OCORRE O REGISTRO E/OU BAIXA DO LIMITE DE RECURSOS A RECEBER.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.41.00','PARTICIPACOES EM EMPRESAS COM PL NEGATIVO','COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.41.01','PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO','COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.41.99','PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES','REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.42.00','CONTRIBUICAO AO FUST A RECOLHER','REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.43.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV','REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.44.00','OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA',' REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.45.00','RECURSOS DA GRU','REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.46.00','RECURSOS FISCAIS','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.47.00','RESTITUICAO DE RECEITAS RECEBIDAS GRU','REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.98.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.98.01','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.2.98.02','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.00.00','OUTRAS OBRIGACOES A CURTO PRAZO-INTER OFSS','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.01.01','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.01.02','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.01.03','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.01.04','RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.02.00','DIARIAS A PAGAR','REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.04.00','REEMBOLSOS A SEREM EFETUADOS PELO INSS','COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA E AUXILIO NATALIDADE A SEUS EMPREGADOS, BEM COMO EFETUARAM OUTROS PAGAMENTOS E ANTECIPACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.04.01','SALARIO-FAMILIA A PAGAR','REGISTRA OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM O DESEMBOLSO A TITULO DE SALARIO FAMILIA A SEUS EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.04.02','AUXILIO - NATALIDADE A PAGAR','REGISTRA OS VALORES A SEREM PAGOS PELO INSS, A TITULO DE REEMBOLSO DO AUXILIO-NATALIDADE PAGO PELAS ENTIDADES A SEUS EMPREGADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.04.03','DEBITOS EM APURACAO - INSS ','REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.04.04','DEBITOS POR PREMIOS DE SEGURO - COMPREENSIVO - INSS','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS AS COMPANHIAS SEGURADORAS, POR PREMIOS DE SEGURO PAGOS A MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO - LEI Nº 4380/64.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.04.99','OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES - INSS','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.05.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.05.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.05.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.06.00','CONVENIOS A PAGAR - PORTAL/SICONV','COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.06.01','CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.06.02','CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.07.00','CONTRATO DE PROGRAMA DE REPASSE A PAGAR','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.07.01','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.07.02','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.08.00','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.08.01','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.08.02','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.09.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.10.00','TERMOS DE PARCERIA A PAGAR - PORTAL SICONV','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.10.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.10.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.11.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.11.01','TERMO DE COMPROMISSO A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.11.02','TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.12.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS -PORTAL','COMPREENDE OS VALORES DEVOLVIDOS REFERENTES A TRANSFERENCIAS VOLUNTARIAS FIRMADAS - CONVENIOS E CONTRATOS DE REPASSE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.13.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.13.01','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.13.02','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.13.03','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.14.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.14.01','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.14.02','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.15.00','TAXA DE FISCALIZACAO DE FUNCIONAMENTO - TFF','REGISTRA AS OBRIGACOES REFERENTES A TAXA DE FISCALIZACAO DE FUNCIONAMENTO - (TFF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.16.00','OPERACOES COM DERIVATIVOS','REGISTRA AS OBRIGACOES DECORRENTES DE OPERACOES COM DERIVATIVOS REALIZADAS PELO BANCO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.17.00','DESPESAS ADMINISTRATIVAS - FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO','REGISTRA AS OBRIGACOES DECORRENTES DE DESPESAS ADMINISTRATIVAS DOS FUNDOS CONSTITUCIONAIS DE FINANCIAMENTO, TAIS COMO TAXAS DE ADMINISTRACAO PAGAS AS INSTITUICOES FINANCEIRAS, REMUNERACAO DE AGENTES ETC.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.18.00','DIVIDAS COM RESSARCIMENTO / COMISSOES - FMM','REGISTRA OS VALORES DAS OBRIGACOES COM DESPESAS DE RESSARCIMENTOS E COMISSOES DO FUNDO MARINHA MERCANTE, DEVIDAS AS EMPRESAS MARITIMAS E BNDES RESPECTIVAMENTE, MAS QUE AINDA NAO POSSUEM AUTORIZACAO LEGISLATIVA PARA EXECUCAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.19.00','BOLSAS PARA ESTUDOS ','COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.19.01','BOLSAS DE ESTUDOS - EXERCICIO','REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.19.02','BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.20.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.21.00','SERVICOS EVENTUAIS - PESSOAL TECNICO','REGISTRA AS OBRIGACOES COM PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO NOS TERMOS DA LEI 8745/93 CONFORME DECRETO Nº 4748/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.22.00','CONTRATOS DE COOPERACAO TECNICA','COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.22.01','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO','REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.22.02','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR','REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.23.00','AUXILIOS FINANCEIROS A PESQUISADORES ','COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.23.01','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.23.02','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.24.00','RESIDUOS DE CONTRATOS LIQUIDADOS - FCVS','REGISTRA AS OBRIGACOES DECORRENTES DA COBERTURA FINANCEIRA, PELO FCVS,DOS CONTRATOS LIQUIDADOS PELOS ADQUIRENTES POR DECURSO DE PRAZO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.00','TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS','COMPREENDE O VALOR A LIBERAR CONCERNENTE A TRANSFERENCIAS CONSTITUCIONAIS OU LEGAIS NAO ESPECIFICADAS EM OUTRAS CONTAS, A SABER: MERENDA ESCOLAR (PNAE), PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), FUNDEF, QUOTA ESTADUAL (SALARIO EDUCACAO), EJA, PTA, TRANSPORTE ESCOLAR - PNTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.01','MERENDA ESCOLAR - PNAE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ALIMENTACAO ESCOLAR - PNAE, COM OBJETIVO DE PRESTAR ASSISTENCIA FINANCEIRA, EM CARATER SUPLEMENTAR AS ESCOLAS PUBLICAS DE ENSINO FUNDAMENTAL DAS REDES ESTADUAIS, MUNICIPAIS E DO DISTRITO FEDERAL E AS ESCOLAS DE EDUCACAO ESPECIAL QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS. A ASSISTENCIA FINANCEIRA A SER CONCEDIDA A CADA ESTABELECIMENTO DE ENSINO BENEFICIARIO SERA DEFINIDA ANUALMENTE E TERA COMO BASE O NUMERO DE ALUNOS MATRICULADOS NO ENSINO FUNDAMENTAL E ESPECIAL, DE ACORDO COM DADOS EXTRAIDOS DO CENSO ESCOLAR REALIZADO PELO MINISTERIO DA EDUCACAO NO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.02','DINHEIRO DIRETO NA ESCOLA - PDDE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE), DESTINADOS AS ESCOLAS DE EDUCACAO ESPECIAL,QUALIFICADAS COMO ENTIDADES FILANTROPICAS OU POR ELAS MANTIDAS PARA COBERTURA DE DESPESA COM CUSTEIO, MANUTENCAO E PEQUENOS INVESTIMENTOS, CONFORME RESOLUCAO CD/FNDE N 04/2003. .','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.03','TRANSPORTE ESCOLAR - PNTE','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DE TRANSPORTE ESCOLAR (PNTE), CONFORME RESOLUCAO CD/FNDE Nº 09/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.04','FUNDO MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL - FUNDEF','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DO ENSINO FUNDAMENTAL E VALORIZACAO DO MAGISTERIO - FUNDEF, LEI 9.424/96','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.05','FUNDO DE FORTALECIMENTO DA ESCOLA- FUNDESCOLA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA FUNDO DE FORTALECIMENTO DA ESCOLA - FUNDESCOLA, PARA FINANCIAMENTO DE PROJETOS EDUCACIONAIS A ORGAOS OU ENTIDADES FEDERAIS, ESTADUAIS E MUNICIPAIS, CUJAS AS ACOES ESTEJAM VOLTADAS PARA O DESENVOLVIMENTO DO ENSINO PUBLICO FUNDAMENTAL REGULAR EM ZONAS DE ATENDIMENTO PRIORITARIO DOS ESTADOS DO NORTE, NORDESTE E CENTRO-OESTE. RESOLUCAO CD/FNDE Nº 10/2002','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.06','QUOTA ESTADUAL - SALARIO EDUCACAO','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO A QUOTA ESTADUAL DO SALARIO EDUCACAO, CONFORME LEI 9.766/98.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.07','EDUCACAO DE JOVENS E ADULTOS - EJA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS VISANDO ATENDER AO PROGRAMA DE EDUCACAO DE JOVENS E ADULTOS(EJA), OS QUAIS SERAO DESTINADOS A AMPLIACAO DA OFERTA DE VAGAS NA EDUCACAO FUNDAMENTAL CUJOS BENEFICIARIOS SAO ALUNOS DA ESCOLA PUBLICA ESTADUAL E MUNICIPAL DO ENSINO FUNDAMENTAL, MATRICULADOS NOS CURSOS DA MODALIDADE "SUPLETIVO PRESENCIAL COM AVALIACAO NO PROCESSO". RESOLUCAO CD/FNDE N.05/2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.08','PROGRAMA DE ATENDIMENTO EDUCACIONAL AS PESSOAS PORTADORES DE DEFICIENCIA - PAED','REGISTRA OS VALORES AS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DE ATENDIMENTO EDUCACIONAL ESPECIALIZADO AS PESSOAS PORTADORAS DE DEFICIENCIA - PAED - INSTITUIDA PELA LEI N 10.845/2004.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.09','BOLSA PROGRAMA FORMACAO INICIAL E CONTINUADA','REGISTRA OS VALORES REFERENTES A REPASSES DE BENEFICIOS DO PROGRAMA BOLSA ESCOLA, CONFORME LEI 10.219/2001.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.10','APOIO AO TRANSPORTE DO ESCOLAR - PNATE','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO TRANSPORTE DO ESCOLAR - PNATE CONFORME MP Nº 173/2004, DOU 17/03/04','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.11','APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO A EDUCACAO DE JOVENS E ADULTOS - PEJA - CONFORME MP Nº 173/2004, DOU 17/03/04.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.12','PROGRAMA BRASIL ALFABETIZADO - CONVENIOS','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). ESTA CONTA E UTILIZADA PARA CONVENIOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.13','DINHEIRO DIRETO NA ESCOLA - PDDEF/PAPE','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PAPE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.14','DINHEIRO DIRETO NA ESCOLA - PDDEF/PME','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA DINHEIRO DIRETO NA ESCOLA (PDDE) DO PROJETO DE ADEQUACAO DE PREDIOS ESCOLARES DO FUNDESCOLA - PDDEF/PME.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.15','BOLSA ESCOLA DE FABRICA','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA E A LEI Nº 11.273, DE 06 DE FEVEREIRO DE 2006, QUE ATUALIZA A CONCESSAO DE BOLSA DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.16','FORMACAO DE PROFESSORES','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA FORMACAO DE PROFESSORES (LEIS 11.180,23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.17','PROINFANTIL','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO RSCOLA DE GABRICA(PROINFANTIL) (LEIS 11.180, DE 23 /09/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.18','PROFORMACAO','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROFORMACAO) LEIS 11.180, DE 23/09/05, E A LEI 11.273, DE 06/02/06, QUE AUTORIZA A CONCESSAO DE BOLSA DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.19','PROLICENCIATURA','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROJETO ESCOLA DE FABRICA (PROLICENCIATURA) (LEIS 11.180, DE23/9/05, E A LEI 11.273, DE 06 DE FEVEREIRO DE 2006, QUE AUTORIZA A CONCESSAO DE BOLSAS DE ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.20','PROGRAMA UNIVERSIDADE ABERTA DO BRASIL','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA UNIVERSIDADE ABERTA DO BRASIL - CONFORME DECRETO Nº 5.800 DE 08JUN2006. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.21','BOLSAS BRASIL ALFABETIZADO','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI Nº 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA BOLSAS).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.22','PROGRAMA BRASIL ALFABETIZADO - TRANSF. AUTOMATICAS','REGISTRA OS VALORES REFERENTES A REPASSES DE APOIO AO PROGRAMA BRASIL ALFABETIZADO - CONFORME LEI 10.880, DE 09 DE JUNHO DE 2004. AS TRANSFERENCIAS FINANCEIRAS SERAO REALIZADAS AUTOMATICAMENTE DA UNIAO PARA OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS (TRANSFERENCIA DIRETA). (UTILIZADA PARA TRANSFERENCIAS AUTOMATICAS)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.23','FUNDO DE MANUTENCAO E DES. DA EDUCACAO BASICA - FUNDEB','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO AO PROGRAMA DO FUNDO DE MANUTENCAO E DESENVOLVIMENTO DA EDUCACAO BASICA - FUNDEB, RESOLUCAO MEC Nº. 01/2007 DE 15 DE FEVEREIRO DE 2007.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.24','PROJOVEM URBANO','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL,SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.25','PROJOVEM CAMPO - SABERES DA TERRA','REGISTRA OS VALORES DAS TRANSFERENCIAS DE RECURSOS FINANCEIROS AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, EFETUADOS PELO FUNDO NACIONAL DE DESENVOLVIMENTO DE EDUCACAO - FNDE PARA ATENDER JOVENS DE 15 A 29 ANOS COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. BASE LEGAL: MEDIDA PROVISORIA Nº Nº 411, DE 28 DE DEZEMBRO DE 2007. LEI Nº 11.129, DE 30 DE JUNHO DE 2005.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.26','PROJOVEM TRABALHADOR','REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO - MTEE OS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS, CUJO OBJETIVO E TRANSFE-RIR RECURSOS SEM A NECESSIDADE DE CONVENIO, ACORDO, CONTRATO, AJUSTE OU INSTRUMENTO CONGENERE, CONFORME DISPOE O ART.39 DO DECRETO Nº 6629/08, QUE REGULAMENTA A LEI 11692/2008 (DISPOE SOBRE O PROGRAMA NACIONAL DE INCLUSAO DE JOVENS AO MERCADO DE TRABALHO).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.27','TERMO DE CONCESSAO DE APOIO FINANCEIRO -ANCINE','REGISTRA OS VALORES A PAGAR DAS TRANSFERENCIAS LEGAIS DECORRENTES DE TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A ANCINE E AS ENTIDADES PRIVADAS COM FINS LUCRATIVOS (MP 2228-1/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.28','PROGRAMA PRIMEIRO EMPREGO - PNPE','REGISTRA OS VALORES DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO PARA OS JOVENS - PNPE, CONFORME LEI Nº 10.748, DE 22 DE OUTUBRO DE 2003.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.29','PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO','REGISTRA VALORES A LIBERAR DE TRANSFERENCIAS DE RECURSOS PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE FORTALECIMENTO DO ENSINO MEDIO, CONFORME MEDIDA PROVISORIA Nº Nº 484, DE 30 DE MARCO DE 2010.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.25.30','PROG.ESP. DE RECUP.REDE FISICA ESCOLA PUBLICA','REGISTRA VALORES DAS TRANSFERENCIAS DE RECURSOS A LIBERAR PARA ATENDIMENTO DO PROGRAMA ESPECIAL DE RECUPERACAO DAS REDES FISICAS ESCOLARES PUBLICAS ESTADUAIS E MUNICIPAIS AFETADAS POR DESASTRES NATURAIS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.26.00','ENTIDADES CREDORAS - ESTADOS, DF E MUNICIPIOS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DECORRENTES DE OBRIGACOES JUNTO A ESTADOS, DF E MUNICIPIOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.28.00','RESULTADO NEGATIVO DO BANCO CENTRAL','COMPREENDE OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL A SER REEMBOLSADO PELO TESOURO NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.28.01','RESULTADO NEGATIVO DO BACEN - BALANCO APURADO','REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO APURADO NO BALANCO DE 31/12/XX DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.28.02','RESULTADO NEGATIVO BACEN - CUSTO DAS RESERVAS','REGISTRA OS VALORES RELATIVOS AO RESULTADO NEGATIVO DO BANCO CENTRAL CORRESPONDENTE AO CUSTO DAS RESERVAS DESTA INSTITUICAO A SER PAGO PELO TESOURO NACIONAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.29.00','EMPRESTIMOS E FINANCIAMENTOS A LIBERAR','REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.30.00','INCENTIVOS A LIBERAR','REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.31.00','TRANSFERENCIAS CONSTITUCIONAIS A RECOLHER','REGISTRA O VALOR DAS TRANSFERENCIAS CONSTITUCIONAIS A RECOLHER NO EXERCICIO SEGUINTE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.32.00','ADIANTAMENTOS RECEBIDOS','COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.32.01','ADIANTAMENTOS DE OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.32.02','ADIANTAMENTOS DE UNIDADES E ENTIDADES','REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS CONCEDIDOS POR ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.32.03','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.33.00','DEBITOS COM OPERACOES TIPICAS DO SISTEMA FINANCEIRO','REGISTRA OS VALORES DEBITOS DECORRENTES DE OPERACOES TIPICAS DO SISTEMA FINANCEIRO, INCLUSIVE DE OPERACOES COM DERIVATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.33.02','OPERACOES COM DERIVATIVOS - SWAP','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - SWAP','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.33.03','OPERACOES COM DERIVATIVOS - FORWARD','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FORWARD','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.33.04','OPERACOES COM DERIVATIVOS - FUTUROS','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - FUTUROS','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.33.05','OPERACOES COM DERIVATIVOS - TERMO','REGISTRA OS VALORES DE OPERACOES COM DERIVATIVOS - TERMO','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.34.00','INTERMEDIARIOS DE INVESTIMENTOS','COMPREENDE OS VALORES DE OBRIGACOES A CURTO PRAZO COM INTERMEDIARIOS DE INVESTIMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.34.01','VALORES DE INVESTIMENTOS A PAGAR','REGISTRA OS VALORES DE INVESTIMENTOS REALIZADOS NO MERCADO FINANCEIRO E NAO LIQUIDADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.00','VALORES EM TRANSITO EXIGIVEIS','COMPREENDE O VALOR DA ORDEM BANCARIA OU OUTRO DOCUMENTO EMITIDO PARA SAQUE CONTRA ESTABELECIMENTO BANCARIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.01','GRU - VALORES EM TRANSITO PARA ESTORNO DESPESA','REGISTRA OS VALORES RECEBIDOS POR GRU A TITULO DE ESTORNO DE DESPESA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.02','ORDENS BANCARIAS A EMITIR','REGISTRA OS VALORES A LIBERAR A TITULO DE SUBREPASSE PARA AS UNIDADES GESTORAS DO EXTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.03','ORDENS BANCARIAS CANCELADAS','REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO ORDENADOR DE DESPESA APOS REMESSA DE RELACAO AO BANCO, OU POR ESTE NA FALTA DE AUTORIZACAO DE PAGAMENTO PELO ORDENADOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.04','GRU A CLASSIFICAR','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS POR MEIO DE GUIA DE RECOLHIMENTO DA UNIAO A CLASSIFICAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.05','SALDOS BANCARIOS EM UTILIZACAO','REGISTRA O VALOR DA APROPRIACAO DOS SALDOS BANCARIOS EM PROCESSO DE UTILIZACAO DE ACORDO COM CONTRATOS ASSINADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.06','DEPOSITO CONTA UNICA E INSTIT. A CLASSIFICAR','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA INSTITUCIONAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.07','DEPOSITO CTU A CLASSIFICAR CODIGO PADRAO','REGISTRA OS VALORES DOS DEPOSITOS EFETUADOS DIRETAMENTE NA CONTA UNICA REFERENTE AOS CODIGOS PADRAO CRIADOS PELA COORDENACAO-GERAL DE CONTABILIDADE DA UNIAO (CCONT).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.08','SAQUE - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE SAQUE COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.09','FATURA - CARTAO DE PAGAMENTO DO GOVERNO FEDERAL','REGISTRA OS VALORES REFERENTES AS DESPESAS COM SUPRIMENTO DE FUNDOS, PENDENTES DE PAGAMENTO DA FATURA COM USO DO CARTAO DE PAGAMENTO DO GOVERNO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.10','TRANSFERENCIA AO BB - OB SAQUE CARTAO','REGISTRA OS VALORES REFERENTES AS TRANSFERENCIAS DE RECURSOS AO BANCO DO BRASIL, RELATIVAS AOS SAQUES DE OB CARTAO EFETUADOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.35.11','ORDENS BANCARIAS CANCELADAS (CARTAO CREDITO)','REGISTRA OS VALORES DE ORDENS BANCARIAS CANCELADAS PELO AGENTE FINANCEIRO, REFERENTE AO CARTAO DE CREDITO CORPORATIVO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.36.00','SUBVENCOES A PAGAR','COMPREENDE O SOMATORIO DAS SUBVENCOES A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.36.01','SUBVENCOES A PAGAR DO EXERCICIO','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.36.02','SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.37.00','RESTITUICOES DE RECEITAS A PAGAR','REGISTRA O VALOR DAS RESTITUICOES DE RECEITAS A PAGAR APROPRIADAS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.38.00','TRANSFERENCIAS VOLUNTARIAS DEVOLVIDAS NAO EFETUADAS PELO PORTAL SICONV','REGISTRA OS VALORES DE DEVOLUCOES DE RECURSOS DE TRANSFERENCIAS VOLUNTARIAS, NAO GERADAS PELO PORTAL DE CONVENIOS, PARA POSTERIOR RECOLHIMENTO AO CONCEDENTE OU AO TESOURO NACIONAL POR MEIO DE GRU. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.00','RECURSOS ESPECIAIS A LIBERAR','COMPREENDE A DESPESA EMPENHADA E NAO PAGA, APURADA AO FINAL DO EXERCICIO E INSCRITA EM RESTOS A PAGAR, PROCESSADOS E NAO PROCESSADOS, BEM COMO OS RECURSOS APROVADOS E NAO LIBERADOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.01','RECURSOS A LIBERAR POR TRANSFERENCIA','REGISTRA OS VALORES A LIBERAR DA GESTAO TESOURO PARA A GESTAO FUNDO DA CAMARA E DO SENADO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.02','RECURSOS DE RESTOS A PAGAR A LIQUIDAR','REGISTRA OS VALORES REFERENTES A RECURSOS APROVADOS A SEREM LIBERADOS A TITULO DE TRANSFERENCIA PARA PAGAMENTO DE OBRIGACOES DE EXERCICIO ANTERIOR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.03','RESTOS A PAGAR NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTES DO ESTAGIO DA LIQUIDACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.04','RETIFICACAO DE RP NAO PROCESSADOS A LIQUIDAR','REGISTRA AS OBRIGACOES PROVENIENTES DA INSCRICAO DE RESTOS A PAGAR DEPENDENTE DO ESTAGIO DE LIQUIDACAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.05','TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA O DISTRITO FEDERAL','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DO DISTRITO FEDERAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.06','TRANSFERENCIAS ORCAMENTARIAS A LIBERAR PARA OS ESTADOS','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA A FAVOR DE ESTADOS. ','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.07','RECURSOS A LIBERAR POR VINCULACAO DE PAGAMENTO','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.08','RECURSOS A RESTITUIR - ADIANTAMENTOS RECEBIDOS PELO INSS','REGISTRA OS RECURSOS A RESTITUIR DE ADIANTAMENTOS RECEBIDOS PELO INSS EM DECORRENCIA DA ARRECADACAO DE PASSIVOS POR DARF E TRANSFERENCIA POR GPS PELA COFIN PARA O INSS. A CONTA SERA UTILIZADA QUANDO O VALOR A TRANSFERIR FOR MAIOR QUE O VALOR ARRECADADO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.09','RECURSOS ORCAMENTARIOS A LIBERAR','REGISTRA OS RECURSOS A LIBERAR REFERENTE AS PARCELAS NAO RECEBIDAS DO ORCAMENTO PARA A ENTIDADES DA ADMINISTRACAO INDIRETA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.10','RECURSOS A LIBERAR PARA PAGAMENTO DE RP','REGISTRA O VALOR DO RECURSO A LIBERAR PARA PAGAMENTO DE RESTOS A PAGAR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.11','RECURSOS A LIBERAR P/ VINCULACAO DE PAGAMENTO PARA O INSS','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE COM VINCULACAO DE PAGAMENTO PARA O INSS, ESTABELECIDO PELO ORGAO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.12','RECURSOS A LIBERAR PARA EMPENHO CONTRA ENTREGA','REGISTRA O VALOR DOS RECURSOS A LIBERAR PELAS UNIDADES CENTRAL OU SETORIAIS DE PROGRAMACAO FINANCEIRA, RELATIVOS AO LIMITE DE SAQUE PARA PAGAMENTO DE EMPENHO CONTRA ENTREGA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.13','RECURSOS DA PREVIDENCIA SOCIAL - BENEFICIOS','REGISTRA OS RECURSOS A LIBERAR REFERENTES AOS BENEFICIOS DA PREVIDENCIA SOCIAL','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.14','RECURSOS DA PREVIDENCIA SOCIAL - TERCEIROS','REGISTRA OS RECURSOS A LIBERAR REFERENTES A DEPOSITOS DE TERCEIROS PARA A PREVIDENCIA SOCIAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.15','REMUNERACAO DA DISPONIBILIDADE CONTA UNICA INSS - BACEN','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A REMUNERACAO DA DISPONIBILIDADE DA CTU INSS NO BACEN.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.16','LIMITE DE SAQUE RECURSOS DA DIVIDA PUBLICA','REGISTRA O VALOR DOS RECURSOS A LIBERAR DA SUB-CONTA DA DIVIDA PUBLICA NO BANCO CENTRAL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.17','RECURSOS VINCULADOS - ENTIDADES TCT','REGISTRA O VALOR DOS RECURSOS VINCULADO REFERENTE A ENTIDADES QUE UTILIZAM A CONTA UNICA EM CUMPRIMENTO AO TERMO DE COOPERACAO TECNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.18','RECURSOS A LIBERAR PARA PAGAMENTO DE RP -INSCRICAO','REGISTRA O VALOR DO RECURSO A LIBERAR P/ PAGAMENTO DE RESTOS A PAGAR. CONTA UTILIZADA NO PROCESSO DE INSCRICAO DE RESTOS A PAGAR NO ENCERRAMENTO DO EXERCICIO, SENDO SEU SALDO TRANSFERIDO PARA O EXERCICIO POSTERIOR (TRANSAL), NA QUAL A EXECUCAO SERA REALIZADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.19','REC. A COMPENSAR P/ PERDAS EM APLICACOES NA CONTA UNICA','REGISTRA O VALOR DE RECURSOS A COMPENSAR POR PERDAS EM APLICACOES FINANCEIRAS NA CONTA UNICA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.39.20','(-) RECURSOS A LIBERAR PARA PAGAMENTO DE RP -RETIFICADORA','REGISTRA O VALOR DOS RECURSOS A LIBERAR P/PAGAMENTO DE RESTOS A PAGAR. CONTA RETIFICADORA PARA COMPENSAR O IMPACTO NO RESULTADO DAS UNIDADES QDO OCORRE O REGISTRO E/OU BAIXA DO LIMITE DE RECURSOS A RECEBER.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.40.00','PARTICIPACOES EM EMPRESAS COM PL NEGATIVO','COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.40.01','PERDAS EM PARTICIPACAO EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO','COMPREENDE OS VALORES REFERENTES A PARTICIPACOES PELO METODO DA EQUIVALENCIA PATRIMONIAL EM EMPRESAS COM PATRIMONIO LIQUIDO NEGATIVO (PASSIVO A DESCOBERTO).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.40.99','PERDAS EM PARTICIPACAO - EMPRESAS DEPENDENTES','REGISTRA OS VALORES DAS PARTICIPACOES DA UNIAO NO PL NEGATIVO DAS EMPRESAS CONTROLADAS DEPENDENTES, PARA QUE OS REFERIDOS VALORES SEJAM EXPURGADOS NA CONSOLIDACAO DAS DEMONSTRACOES CONTABEIS DA UNIAO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.41.00','CONTRIBUICAO AO FUST A RECOLHER','REGISTRA OS VALORES DEVIDOS PELA UNIDADE EM FUNCAO DA RECEITA OPERACIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICO E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.44.00','OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA',' REGISTRA OS VALORES DAS OBRIGACOES A PAGAR EM MOEDA ESTRANGEIRA, INCLUSIVE AS DESPESAS COM ADMINISTRACAO TERCEIRIZADA DE RECURSOS EM MOEDA ESTRANGEIRA. CONTA EXCLUSIVA DO BANCO CENTRAL DO BRASIL','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.45.00','RECURSOS DA GRU','REGISTRA O VALOR DOS CREDITOS DE GUIA DE RECOLHIMENTO DA UNIAO - GRU INTRA SIAFI.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.46.00','RECURSOS FISCAIS','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELO TESOURO NACIONAL A SEREM POSTERIORMENTE CLASSIFICADOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.47.00','RESTITUICAO DE RECEITAS RECEBIDAS GRU','REGISTRA OS VALORES RELATIVOS A RESTITUICAO DE RECEITAS RECEBIDAS POR GRU. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.98.00','OUTROS CREDORES A CURTO PRAZO','COMPREENDE OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.98.01','OUTROS CREDORES DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES NO EXERCICIO, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.1.9.9.3.98.02','OUTROS CREDORES DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES EM EXERCICIOS ANTERIORES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.0.0.0.00.00','PASSIVO NAO-CIRCULANTE','COMPREENDE AS OBRIGACOES CONHECIDAS E ESTIMADAS QUE NAO ATENDAM A NENHUM DOS CRITERIOS PARA SEREM CLASSIFICADAS NO PASSIVO CIRCULANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.0.0.00.00','OBRIGACOES TRABALHISTAS, PREVIDENCIARIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','COMPREENDE AS OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, APOSENTADORIAS, REFORMAS, PENSOES, ENCARGOS A PAGAR, BENEFICIOS ASSISTENCIAIS, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.1.0.00.00','PESSOAL A PAGAR','COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.1.1.00.00','PESSOAL A PAGAR-EXTRA OFSS','COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.1.1.01.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS A VENCIMENTOS E VANTAGENS FIXAS E VARIAVEIS DEVIDAS AO SERVIDORES CIVIS E MILITARES, BEM COMO AS APOSENTADORIAS, REFORMAS E PENSOES, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.1.1.02.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.1.1.02.01','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES AO ANTERIOR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.1.1.02.03','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGACOES REFERENTES A SALARIOS OU REMUNERACOES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.2.0.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.2.1.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR - EXTRA OFSS','COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES AOS QUAIS O APOSENTADO, REFORMADO OU PENSIONISTA TENHA DIREITO, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.2.1.01.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.2.1.01.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.3.0.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR','COMPREENDE AS OBRIGACOES A LONGO PRAZO RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.3.1.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR - EXTRA OFSS','COMPREENDE AS OBRIGACOES A LONGO PRAZO RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, QUANDO PAGOS EM DATA POSTERIOR A QUAL FOREM INCORRIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR-EXTRA OFSS','COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.01.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.01.01','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.02.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.02.01','RGPS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.03.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.03.01','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA ','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.03.02','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.1.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.01.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.01.01','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.02.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.02.01','RGPS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.03.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.03.01','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA ','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.03.02','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.2.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS','COMPREENDE AS OBRIGACOES A LONGO PRAZO DAS UNIDADES RELATIVAS A DESPESAS INCORRIDAS E NAO PAGAS, EM BENEFICIO DE SEUS SERVIDORES, EMPREGADOS E FAMILIARES, COMPULSORIAMENTE OU NAO, INCLUINDO AQUELAS QUE SE DESTINAM AO FINANCIAMENTO DA SEGURIDADE SOCIAL DE RESPONSABILIDADE DO PODER PUBLICO E AS DEMAIS CONTRIBUICOES SOCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.01.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUICOES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALARIOS E REMUNERACOES PAGOS E SOBRE SERVICOS DE TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.01.01','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NAO RECOLHIMENTO DE OBRIGACOES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.02.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.02.01','RGPS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.03.00','ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','COMPREENDE AS OBRIGACOES RELATIVAS AS ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.03.01','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA ','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES FECHADAS DE PREVIDENCIA PRIVADA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.03.02','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA COMPLEMENTAR','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER REPRESENTADOS PELA CONTRIBUICAO PATRONAL A ENTIDADES DE PREVIDENCIA COMPLEMENTAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.1.4.3.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.0.0.00.00','EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO','COMPREENDE AS OBRIGACOES FINANCEIRAS DA ENTIDADE A TITULO DE EMPRESTIMOS, BEM COMO AS AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, COM VENCIMENTOS APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.0.00.00','EMPRESTIMOS A LONGO PRAZO','COMPREENDE OS EMPRESTIMOS EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU A RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.00.00','EMPRESTIMOS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS EMPRESTIMOS EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU A RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.01.00','EMPRESTIMOS INTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.01.01','DIVIDA MOBILIARIA','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.01.02','TITULOS DA DIVIDA AGRARIA - (TDA)','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.01.03','(-) DESAGIO DE TITULOS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.01.98','OUTROS TITULOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.02.00','EMPRESTIMOS EXTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.02.01','TITULOS DO TESOURO NACIONAL','REGISTRA OS TITULOS EXIGIVEIS A LONGO PRAZO, EMITIDOS PELO TESOURO NACIONAL NO MERCADO INTERNACIONAL (BIB, BEA, BRADY, BONUS SOBERANOS E OUTROS).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.02.98','OUTROS TITULOS - EMPRESTIMOS EXTERNOS','REGISTRA VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.03.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.04.00','EMPRESTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.1.05.00','BACEN - MEIO CIRCULANTE - OPERACAO DE CREDITO INTERNA','REGISTRA O VALOR DAS OBRIGACOES REFERENTES A OPERACOES DE CREDITO INTERNA REALIZADAS PELO BACEN - MEIO CIRCULANTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.00.00','EMPRESTIMOS A LONGO PRAZO - INTRA OFSS','COMPREENDE OS EMPRESTIMOS EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU A RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.01.00','EMPRESTIMOS INTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.01.01','DIVIDA MOBILIARIA','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.01.02','TITULOS DA DIVIDA AGRARIA - (TDA)','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.01.03','(-) DESAGIO DE TITULOS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.01.98','OUTROS TITULOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.02.00',' EMPRESTIMOS EXTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.02.01','TITULOS DO TESOURO NACIONAL','REGISTRA OS TITULOS EXIGIVEIS A LONGO PRAZO, EMITIDOS PELO TESOURO NACIONAL NO MERCADO INTERNACIONAL (BIB, BEA, BRADY, BONUS SOBERANOS E OUTROS).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.02.98','OUTROS TITULOS - EMPRESTIMOS EXTERNOS','REGISTRA VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.03.00',' EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.04.00',' EMPRESTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.2.05.00','BACEN - MEIO CIRCULANTE - OPERACAO DE CREDITO INTERNA','REGISTRA O VALOR DAS OBRIGACAO REFERENTES A OPERACOES DE CREDITO INTERNA REALIZADAS PELO BACEN - MEIO CIRCULANTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.00.00','EMPRESTIMOS A LONGO PRAZO - INTER OFSS','COMPREENDE OS EMPRESTIMOS EFETUADOS JUNTO A INSTITUICOES FINANCEIRAS OU A RECURSOS CAPTADOS POR MEIO DE EMISSAO DE TITULOS PUBLICOS, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.01.00',' EMPRESTIMOS INTERNOS - EM TITULOS ','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS INTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.01.01','DIVIDA MOBILIARIA','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA EMISSAO DE TITULOS DA DIVIDA MOBILIARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.01.02','TITULOS DA DIVIDA AGRARIA - (TDA)','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS DA DIVIDA AGRARIA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.01.03','(-) DESAGIO DE TITULOS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO RELATIVOS A DESAGIO OCORRIDOS EM TITULOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.01.98','OUTROS TITULOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO DECORRENTES DA COLOCACAO NO MERCADO DE TITULOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.02.00',' EMPRESTIMOS EXTERNOS - EM TITULOS','COMPREENDE OS VALORES DAS OPERACOES DE CREDITOS EXTERNAS DECORRENTES DA EMISSAO DE TITULOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.02.01','TITULOS DO TESOURO NACIONAL','REGISTRA OS TITULOS EXIGIVEIS A LONGO PRAZO, EMITIDOS PELO TESOURO NACIONAL NO MERCADO INTERNACIONAL (BIB, BEA, BRADY, BONUS SOBERANOS E OUTROS).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.02.98','OUTROS TITULOS - EMPRESTIMOS EXTERNOS','REGISTRA VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DA COLOCACAO DE TITULOS NO EXTERIOR, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.03.00',' EMPRESTIMOS INTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO INTERNAS EM CONTRATOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.04.00',' EMPRESTIMOS EXTERNOS - EM CONTRATOS','REGISTRA OS VALORES DAS OPERACOES DE CREDITO EXTERNAS EM CONTRATOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.1.3.05.00','BACEN - MEIO CIRCULANTE - OPERACAO DE CREDITO INTERNA','REGISTRA O VALOR DAS OBRIGACAO REFERENTES A OPERACOES DE CREDITO INTERNA REALIZADAS PELO BACEN - MEIO CIRCULANTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.0.00.00','FINANCIAMENTOS A LONGO PRAZO','COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.00.00','FINANCIAMENTOS A LONGO PRAZO - EXTRA OFSS','COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.01.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.01.02','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.01.03','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO NAO CLASSIFICAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.02.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.02.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.02.02','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.00','EFEITOS INFLACIONARIOS SOBRE OPERACOES ESPECIAIS','COMPREENDE AS VARIACOES ATIVAS DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS E DA CONTA ESPECIAL DE BANCOS QUANDO VARIACAO DEVEDORA E AINDA VARIACAO DAS OPERACOES DA BOLSA DE MOEDAS QUANDO DEVEDORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.01','CORRECAO MONETARIA FINANCEIRA','REGISTRA A CORRECAO MONETARIA DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.02','CORRECAO MONETARIA NAO FINANCEIRA','REGISTRA A CORRECAO MONETARIA DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.03','VARIACAO CAMBIAL FINANCEIRA','REGISTRA A VARIACAO CAMBIAL DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.04','VARIACAO CAMBIAL NAO FINANCEIRA','REGISTRA A VARIACAO CAMBIAL DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.05','AJUSTE BOLSA DE MOEDAS FINANCEIRA','REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.1.03.06','AJUSTE BOLSA DE MOEDAS NAO FINANCEIRA','REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.00.00','FINANCIAMENTOS A LONGO PRAZO - INTRA OFSS','COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.01.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.01.02','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.01.03','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.01.98','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO NAO CLASSIFICAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.02.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.02.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.02.02','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.00','EFEITOS INFLACIONARIOS SOBRE OPERACOES ESPECIAIS','COMPREENDE AS VARIACOES ATIVAS DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS E DA CONTA ESPECIAL DE BANCOS QUANDO VARIACAO DEVEDORA E AINDA VARIACAO DAS OPERACOES DA BOLSA DE MOEDAS QUANDO DEVEDORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.01','CORRECAO MONETARIA FINANCEIRA','REGISTRA A CORRECAO MONETARIA DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.02','CORRECAO MONETARIA NAO FINANCEIRA','REGISTRA A CORRECAO MONETARIA DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.03','VARIACAO CAMBIAL FINANCEIRA','REGISTRA A VARIACAO CAMBIAL DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.04','VARIACAO CAMBIAL NAO FINANCEIRA','REGISTRA A VARIACAO CAMBIAL DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.05','AJUSTE BOLSA DE MOEDAS FINANCEIRA','REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.2.03.06','AJUSTE BOLSA DE MOEDAS NAO FINANCEIRA','REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.00.00','FINANCIAMENTOS A LONGO PRAZO - INTER OFSS','COMPREENDE AS OBRIGACOES DECORRENTES DE AQUISICOES EFETUADAS DIRETAMENTE COM O FORNECEDOR, CUJO PRAZO TOTAL SEJA SUPERIOR A UM ANO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.01.00','FINANCIAMENTOS INTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.01.02','FINANCIAMENTOS PARA CONSTRUCAO DE IMOVEIS HABITACIONAIS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA CONSTRUCAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.01.03','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.01.98','OUTROS FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS INTERNOS A LONGO PRAZO NAO CLASSIFICAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.02.00','FINANCIAMENTOS EXTERNOS','COMPREENDE OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A CURTO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.02.01','FINANCIAMENTOS DO ATIVO PERMANENTE','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO, CONTRAIDOS PARA AQUISICAO DE BENS DO ATIVO PERMANENTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.02.02','FINANCIAMENTOS DE CAPITAL DE GIRO','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE FINANCIAMENTOS EXTERNOS A LONGO PRAZO CONTRAIDOS PARA O CAPITAL DE GIRO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.00','EFEITOS INFLACIONARIOS SOBRE OPERACOES ESPECIAIS','COMPREENDE AS VARIACOES ATIVAS DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS E DA CONTA ESPECIAL DE BANCOS QUANDO VARIACAO DEVEDORA E AINDA VARIACAO DAS OPERACOES DA BOLSA DE MOEDAS QUANDO DEVEDORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.01','CORRECAO MONETARIA FINANCEIRA','REGISTRA A CORRECAO MONETARIA DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.02','CORRECAO MONETARIA NAO FINANCEIRA','REGISTRA A CORRECAO MONETARIA DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.03','VARIACAO CAMBIAL FINANCEIRA','REGISTRA A VARIACAO CAMBIAL DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.04','VARIACAO CAMBIAL NAO FINANCEIRA','REGISTRA A VARIACAO CAMBIAL DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.05','AJUSTE BOLSA DE MOEDAS FINANCEIRA','REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DA CONTA ESPECIAL DE BANCOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.2.3.03.06','AJUSTE BOLSA DE MOEDAS NAO FINANCEIRA','REGISTRA O AJUSTE, COM BASE NA VARIACAO DA BOLSA DE MOEDAS, DAS CONTAS DE EXECUCAO DE PROJETOS VINCULADOS A FINANCIAMENTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.3.0.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','COMPREENDE AS OBRIGACOES A LONGO PRAZO REFERENTES A ARRENDAMENTOS FINANCEIROS, NOS QUAIS SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSILIDADE A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.3.1.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO - EXTRA OFSS','REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A ARRENDAMENTOS FINANCEIROS, NOS QUAIS SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSILIDADE A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.3.2.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO - INTRA OFSS','REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A ARRENDAMENTOS FINANCEIROS, NOS QUAIS SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSILIDADE A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.3.3.00.00','FINANCIAMENTOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO - INTER OFSS','REGISTRA AS OBRIGACOES A LONGO PRAZO REFERENTES A ARRENDAMENTOS FINANCEIROS, NOS QUAIS SAO TRANSFERIDOS SUBSTANCIALMENTE AO ARRENDADOR TODOS OS RISCOS E BENEFICIOS INERENTES A PROPRIEDADE, HAVENDO A POSSILIDADE A POSSIBILIDADE DE COMPRA DO BEM ARRENDADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.01.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.01.01','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.01.02','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.01.03','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.02.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.02.01','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.02.02','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.03.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.03.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.03.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.04.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.04.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.04.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.05.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.05.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.05.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.05.03','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.06.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.06.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.06.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.07.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.07.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.07.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.08.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.08.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.1.08.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTRA OFSS','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.01.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.01.01','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.01.02','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.01.03','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.02.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.02.01','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.02.02','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.03.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.03.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.03.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.04.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.04.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.04.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.05.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.05.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.05.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.05.03','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.06.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.06.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.06.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.07.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.07.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.07.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.08.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.08.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.2.08.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRESTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTER OFSS','COMPREENDE OS JUROS E ENCARGOS FINANCEIROS REFERENTES A EMPRESTIMOS E FINANCIAMENTOS , RECONHECIDOS PELO REGIME DE COMPETENCIA E PAGAVEIS A LONGO PRAZO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.01.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.01.01','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.01.02','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.01.03','JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE EMPRESTIMOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.02.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.02.01','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.02.02','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.03.00','ENCARGOS - EMPRESTIMOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.03.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.03.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.04.00','ENCARGOS - EMPRESTIMOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.04.01','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.04.02','ENCARGOS DE CONTRATOS - EMPRESTIMOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE EMPRESTIMOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.05.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.05.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.05.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.05.03','JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS','REGISTRA OS VALORES EXIGIVEIS, DECORRENTES DE JUROS PRO-RATA SOBRE FINANCIAMENTOS INTERNOS CONTRAIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.06.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.06.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.06.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS JUROS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.07.00','ENCARGOS - FINANCIAMENTOS INTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.07.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.07.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS INTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.08.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.08.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCICIO','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.4.3.08.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DOS ENCARGOS DE CONTRATOS DE FINANCIAMENTOS EXTERNOS DO EXERCICIO ANTERIOR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.1.00.00','(-)ENCARGOS FINANCEIROS A APROPRIAR - EXTRA OFSS','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALOR PREFIXADO, REFERENTES A EMPRESTIMOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALOR PREFIXADO, REFERENTES A FINANCIAMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.2.00.00','(-)ENCARGOS FINANCEIROS A APROPRIAR - INTRA OFSS','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.2.01.00','(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALOR PREFIXADO, REFERENTES A EMPRESTIMOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.2.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALOR PREFIXADO, REFERENTES A FINANCIAMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.3.00.00','(-)ENCARGOS FINANCEIROS A APROPRIAR - INTER OFSS','COMPREENDE OS ENCARGOS FINANCEIROS ESTABELECIDOS EM VALORES PREFIXADOS, INCLUSOS COMO CONTRAPARTIDA NAS CONTAS DE EMPRESTIMO E DE FINANCIAMENTO A LONGO PRAZO, MAS QUE AINDA NAO TRANSCORRERAM POR NAO TER OCORRIDO AINDA O FATO GERADOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.3.01.00','(-) ENCARGOS PREFIXADOS DE EMPRESTIMOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALOR PREFIXADO, REFERENTES A EMPRESTIMOS.','D','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.2.9.3.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS','REGISTRA O VALOR DOS ENCARGOS FINANCEIROS PRE-ESTABELECIDOS EM VALOR PREFIXADO, REFERENTES A FINANCIAMENTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.0.0.00.00','FORNECEDORES A LONGO PRAZO','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE,INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.0.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.1.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - EXTRA OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.1.01.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.1.02.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.1.03.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.1.03.01','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.2.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - INTRA OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.2.01.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.2.02.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.2.03.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.2.03.01','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.3.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - INTER OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES NACIONAIS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.3.01.00','FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.3.02.00','FORNECEDORES NACIONAIS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES NACIONAIS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.3.03.00','PRECATORIOS DE FORNECEDORES NACIONAIS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.1.3.03.01','PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE FORNECEDORES NACIONAIS DO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.2.0.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.2.1.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - EXTRA OFSS','COMPREENDE AS OBRIGACOES JUNTO A FORNECEDORES ESTRANGEIROS DE MATERIAS-PRIMAS, MERCADORIAS E OUTROS MATERIAIS UTILIZADOS NAS ATIVIDADES OPERACIONAIS DA ENTIDADE, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.2.1.01.00','FORNECEDORES ESTRANGEIROS DO EXERCICIO','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES AO EXERCICIO ATUAL.','C','S','P','p');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.3.2.1.02.00','FORNECEDORES ESTRANGEIROS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR AOS FORNECEDORES ESTRANGEIROS DE BENS, MATERIAIS E SERVICOS ENVOLVIDOS COM AS ATIVIDADES OPERACIONAIS DA ENTIDADE, REFERENTES A EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.0.0.00.00','OBRIGACOES FISCAIS A LONGO PRAZO','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.0.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO - EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.01.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.02.00','IRPJ A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES A PAGAR RELATIVAS AO IRPJ, APURADAS NA DECLARACAO DE RENDIMENTOS DA ENTIDADE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.03.00','PASSIVO FISCAL DIFERIDO','REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.04.00','IMPOSTO DE IMPORTACAO A RECOLHER','REGISTRA AS OBRIGACOES EXIGIVEIS A CURTO PRAZO JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.05.00','IOF A RECOLHER','REGISTRA OS VALORES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.06.00','ITR A RECOLHER','REGISTRA OS VALORES A RECOLHER RELATIVAS AO ITR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.07.00','CPMF A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA - CPMF.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE (LEI Nº 10.168 DE 2000).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.09.00','CONTRIBUICAO SOCIAL S/ LUCRO PESSOAS JURIDICAS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.10.00','COFINS A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A COFINS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.11.00','PIS/PASEP A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO PIS/ PASEP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS ','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.13.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS ATRAVES DE DARF.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO - INTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.01.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.02.00','IRPJ A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES A PAGAR RELATIVAS AO IRPJ, APURADAS NA DECLARACAO DE RENDIMENTOS DA ENTIDADE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.03.00','PASSIVO FISCAL DIFERIDO - TRIBUTOS FEDERAIS','REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.04.00','IMPOSTO DE IMPORTACAO A RECOLHER','REGISTRA AS OBRIGACOES EXIGIVEIS A CURTO PRAZO JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.05.00','IOF A RECOLHER','REGISTRA OS VALORES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.06.00','ITR A RECOLHER','REGISTRA OS VALORES A RECOLHER RELATIVAS AO ITR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.07.00','CPMF A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA - CPMF.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE (LEI Nº 10.168 DE 2000).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.09.00','CONTRIBUICAO SOCIAL S/ LUCRO PESSOAS JURIDICAS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.10.00','COFINS A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A COFINS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.11.00','PIS/PASEP A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO PIS/ PASEP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.13.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS ATRAVES DE DARF.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.2.99.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM A UNIAO - INTER OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO FEDERAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.01.00','IPI A RECOLHER','REGISTRA O VALOR DAS OBRIGACOES TRIBUTARIAS DAS UNIDADES INDUSTRIAIS OU COM CARACTERISTICAS DESSAS, GERADAS PELAS VENDAS DE PRODUTOS INDUSTRIAIS E SUJEITAS A COMPENSACAO COM OS CREDITOS ADQUIRIDOS POR COMPRAS DE MATERIAS-PRIMAS, EM CONFORMIDADE COM A SISTEMATICA DE APURACAO DESSE IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.02.00','IRPJ A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES A PAGAR RELATIVAS AO IRPJ, APURADAS NA DECLARACAO DE RENDIMENTOS DA ENTIDADE.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.03.00','PASSIVO FISCAL DIFERIDO - TRIBUTOS FEDERAIS','REGISTRA OS VALORES DE DEBITOS FISCAIS DE CURTO PRAZO RELATIVOS A DIFERENCAS INTERTEMPORAIS (DELIBERACAO DA CVM Nº 273, DE 20/08/98),CORRESPONDENTES AO IRPJ E CSSL, BEM COMO PIS/PASEP E COFINS (LEI Nº 9.718 DE 27/11/1998).','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.04.00','IMPOSTO DE IMPORTACAO A RECOLHER','REGISTRA AS OBRIGACOES EXIGIVEIS A CURTO PRAZO JUNTO AO GOVERNO FEDERAL, RELATIVAS AO IMPOSTO DE IMPORTACAO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.05.00','IOF A RECOLHER','REGISTRA OS VALORES A RECOLHER RELATIVAS AO IMPOSTO SOBRE OPERACOES FINANCEIRAS (IOF).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.06.00','ITR A RECOLHER','REGISTRA OS VALORES A RECOLHER RELATIVAS AO ITR.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.07.00','CPMF A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO PROVISORIA SOBRE MOVIMENTACAO OU TRANSMISSAO DE VALORES E DE CREDITOS DE NATUREZA FINANCEIRA - CPMF.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE (LEI Nº 10.168 DE 2000).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.09.00','CONTRIBUICAO SOCIAL S/ LUCRO PESSOAS JURIDICAS','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS (CSSL).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.10.00','COFINS A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A COFINS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.11.00','PIS/PASEP A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO PIS/ PASEP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA ENTIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.13.00','RECURSOS FISCAIS - DARF A EMITIR','REGISTRA O VALOR DOS CREDITOS FISCAIS RECEBIDOS PELAS REPARTICOES PUBLICAS PARA POSTERIOR RECOLHIMENTO AO TESOURO NACIONAL, OU SEJA, VALORES A SEREM RECOLHIDOS ATRAVES DE DARF.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.0.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS - EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.01.00','ICMS A RECOLHER','REGISTRA OS VALORES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDAM ICMS, SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.02.00','IPVA A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO IPVA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.04.00','TAXA CONTRA INCENDIO','REGISTRA AS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.05.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA AS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.01.00','ICMS A RECOLHER','REGISTRA OS VALORES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDAM ICMS, SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.02.00','IPVA A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO IPVA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.04.00','TAXA CONTRA INCENDIO','REGISTRA AS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.05.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA AS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTER OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO ESTADUAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.01.00','ICMS A RECOLHER','REGISTRA OS VALORES EXIGIVEIS EM FUNCAO DAS VENDAS DE MERCADORIAS E SERVICOS SOBRE OS QUAIS INCIDAM ICMS, SUJEITOS A COMPENSACOES COM OS CREDITOS OBTIDOS EM COMPRAS DE MERCADORIAS E SERVICOS, CONFORME SISTEMATICA DE APURACAO DESTE IMPOSTO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.02.00','IPVA A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO IPVA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.04.00','TAXA CONTRA INCENDIO','REGISTRA AS OBRIGACOES REFERENTES A TAXA CONTRA INCENDIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.05.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','REGISTRA AS OBRIGACOES JUNTO AO GOVERNO ESTADUAL, REFERENTE AO PAGAMENTO DA TAXA DE LICENCIAMENTO ANUAL DE VEICULOS, DECORRENTE DO SERVICO DE LICENCIAMENTO DE VEICULOS AUTOMOTORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.2.3.99.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS A CURTO PRAZO, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.0.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.1.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS - EXTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.1.01.00','ISS A RECOLHER','REGISTRA AS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE OS SERVICOS PRESTADOS EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.1.02.00','IPTU/TLP A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO IPTU/TLP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.1.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.1.04.00','CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA C.F.)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.2.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS -INTRA OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.2.01.00','ISS A RECOLHER','REGISTRA AS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE OS SERVICOS PRESTADOS EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.2.02.00','IPTU/TLP A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO IPTU/TLP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.2.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.2.04.00','CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA C.F.)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.3.00.00','OBRIGACOES FISCAIS A LONGO PRAZO COM OS MUNICIPIOS -INTER OFSS','COMPREENDE AS OBRIGACOES DAS ENTIDADES COM O GOVERNO MUNICIPAL RELATIVAS A IMPOSTOS, TAXAS E CONTRIBUICOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.3.01.00','ISS A RECOLHER','REGISTRA AS OBRIGACOES JUNTO AO GOVERNO MUNICIPAL, RELATIVAS AO IMPOSTO SOBRE OS SERVICOS PRESTADOS EM QUE A PROPRIA UNIDADE SEJA A PRESTADORA DO SERVICO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.3.02.00','IPTU/TLP A RECOLHER','REGISTRA AS OBRIGACOES RELATIVAS AO IPTU/TLP.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.3.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','REGISTRA OS VALORES DEVIDOS PELA UNIDADE RELATIVOS A TRIBUTOS QUE FORAM RENEGOCIADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.3.04.00','CONTRIBUICAO P/ CUSTEIO DE ILUM. PUBLICA A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES REFERENTES A CONTRIBUICAO PARA CUSTEIO DE ILUMINACAO PUBLICA.(ART.149-A DA C.F.)','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.4.3.3.99.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','REGISTRA OS COMPROMISSOS EXIGIVEIS, DECORRENTES DA INCIDENCIA DE TRIBUTOS PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.0.0.00.00','PROVISOES A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.1.0.00.00','PROVISAO PARA RISCOS TRABALHISTAS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.1.1.00.00','PROVISAO PARA RISCOS TRABALHISTAS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE RECLAMACOES TRABALHISTAS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.1.1.01.00','PROVISAO PARA INDENIZACOES TRABALHISTAS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE INDENIZACOES TRABALHISTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.1.1.02.00','PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS VISANDO O PAGAMENTO DE DISSIDIOS COLETIVOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.0.00.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFICIOS PREVIDENCIARIOS A SEREM PAGOS AOS CONTRIBUINTES, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.00.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A FUTUROS BENEFICIOS PREVIDENCIARIOS A SEREM PAGOS AOS CONTRIBUINTES, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.01','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.02','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.03','(-) CONTRIBUICOES DO INATIVO PARA O PLANO FINANCEIRO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.04','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.05','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS ','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.06','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO FUNDO SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.01.07','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS DO PLANO FINANCEIRO CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER ','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS A CONCEDER PARA A GERACAO ATUAL (SERVIDORES ATIVOS).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.01','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.02','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.03','(-) CONTRIBUICOES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.04','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.05','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DOS VALORES NAO RECOLHIDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.02.06','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS INSUFICIENCIAS FINANCEIRAS FUTURAS DO PLANO FINANCEIRO, CONSIDERANDO O § 1º DO ARTIGO 2º DA LEI 9717/98','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS ','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.01','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS PRESTACOES FUTURAS DOS BENEFICIOS JA CONCEDIDOS AOS ASSISTIDOS E BENEFICIARIOS EM GOZO DE BENEFICIO DE PRESTACAO CONTINUADA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.02','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.03','(-) CONTRIBUICOES DO INATIVO PARA O PLANO PREVIDENCIARIO DO RPPS ','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS INATIVOS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.04','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS PENSIONISTAS, POR PRAZO DE VIGENCIA INDETERMINADO, PARA FINANCIAR OS BENEFICIOS JA EM FASE DE PAGAMENTO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.05','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS ','REGISTRAR, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11 DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.03.06','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS DO PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, CONSIDERANDO O PARCELAMENTO DE VALORES NAO RECOLHIDOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.04.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER ','COMPREENDE, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, A PROVISAO MATEMATICA CORRESPONDENTE AO VALOR PRESENTE LIQUIDO DAS PRESTACOES FUTURAS DOS BENEFICIOS A CONCEDER PARA A GERACAO ATUAL (SERVIDORES ATIVOS).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.04.01','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DOS BENEFICIOS A SEREM CONCEDIDOS AOS INTEGRANTES DA GERACAO ATUAL QUE AINDA NAO ESTEJAM EM GOZO DE BENEFICIOS DE PRESTACAO CONTINUADA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.04.02','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES (NORMAL, SUPLEMENTAR OU APORTES PERIODICOS) FUTURAS DO ENTE, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.04.03','(-) CONTRIBUICOES DO ATIVO PARA O PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O SOMATORIO DO VALOR PRESENTE DAS CONTRIBUICOES FUTURAS DOS SERVIDORES ATIVOS, INCIDENTES SOBRE AS REMUNERACOES DA GERACAO ATUAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.04.04','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DA COMPENSACAO PREVIDENCIARIA CONFORME EXPRESSA O ARTIGO 11, DA PORTARIA MPS Nº 403/2008.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.04.05','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE DAS CONTRIBUICOES NAO VERTIDAS AO PLANO, SOB O REGIME DE PARCELAMENTO DE DEBITOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.05.00',' PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO ','COMPREENDE, DE ACORDO COM RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLACAO ESPECIFICA, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZACAO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTACAO DE UMA NOVA REAVALIACAO ATUARIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.05.98','(-) OUTROS CREDITOS DO PLANO DE AMORTIZACAO ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, O VALOR PRESENTE LIQUIDO DOS DIREITOS INCORPORADOS AO PATRIMONIO DO RPPS COM BASE EM LEGISLACAO ESPECIFICA, COMO EXEMPLO: DIREITOS SOBRE ROYALTIES, BEM COMO REGISTRO TEMPESTIVO DO PLANO DE AMORTIZACAO IMPLEMENTADO EM LEI DO ENTE FEDERATIVO, CONSIDERANDO QUE O AJUSTE CONTABIL DAS RESERVAS MATEMATICAS SOMENTE OCORRERA NA APRESENTACAO DE UMA NOVA REAVALIACAO ATUARIAL.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.06.00',' PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO ','COMPREENDE O SOMATORIO DAS PROVISOES ATUARIAIS CONSTITUIDAS PARA AJUSTES DO PLANO FINANCEIRO, CONFORME O RESULTADO DA AVALIACAO ATUARIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.06.01','PROVISAO ATUARIAL PARA OSCILACAO DE RISCOS ','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, A PROVISAO ATUARIAL CORRESPONDENTE A EVENTUAIS DESVIOS DOS COMPROMISSOS ESPERADOS OU PELA ADOCAO DE BASES TECNICAS QUE NAO SE ADAPTAM AO PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.07.00',' PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO ','COMPREENDE O SOMATORIO DAS PROVISOES ATUARIAIS CONSTITUIDAS PARA AJUSTES DO PLANO PREVIDENCIARIO, CONFORME O RESULTADO DA AVALIACAO ATUARIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.2.1.07.01','AJUSTE DE RESULTADO ATUARIAL SUPERAVITARIO ','REGISTRA, DE ACORDO COM O RESULTADO DA AVALIACAO ATUARIAL, PROVISAO ATUARIAL PARA AJUSTE DO PLANO PREVIDENCIARIO QUANDO O PLANO APRESENTAR RESULTADO SUPERAVITARIO, CONSIDERANDO O ARTIGO 25, DA PORTARIA MPS 403/2008. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.0.00.00','PROVISAO PARA RISCOS FISCAIS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.00.00','PROVISAO PARA RISCOS FISCAIS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS AO PAGAMENTO DE AUTUACOES FISCAIS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.01.00','PROVISAO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRACAO','COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS E QUE SE ENCONTRAM NA ESFERA ADMINISTRATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.01.01','PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO NAO RECORRIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE AINDA NAO APRESENTOU RECURSO ADMINISTRATIVO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.01.02','PROVISAO PARA PAGAMENTO DE AUTOS DE INFRACAO RECORRIDOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTOS DE INFRACAO JA LAVRADOS, PARA OS QUAIS A UNIDADE APRESENTOU RECURSO ADMINISTRATIVO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.02.00','PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS - ESFERA JUDICIAL','COMPREENDE OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE JA SE ENCONTRAM NA ESFERA JUDICIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.02.01','PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL NAO RECORRIDAS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL E QUE NAO ESTAO EM FASE RECURSAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.3.1.02.02','PROVISAO PARA PAGAMENTOS DE AUTUACOES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE AUTUACOES FISCAIS QUE SE ENCONTRAM NA ESFERA JUDICIAL EM FASE RECURSAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.0.00.00','PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.1.00.00','PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.1.01.00','PROVISAO PARA INDENIZACOES CIVEIS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.1.02.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.1.03.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.1.04.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.2.00.00','PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - INTRA OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.2.01.00','PROVISAO PARA INDENIZACOES CIVEIS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.2.02.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.2.03.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.2.04.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.3.00.00','PROVISAO PARA RISCOS CIVEIS A LONGO PRAZO - INTER OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, RELACIONADOS A PAGAMENTO DE INDENIZACOES A FORNECEDORES E CLIENTES, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.3.01.00','PROVISAO PARA INDENIZACOES CIVEIS','REGISTRA OS VALORES DAS PROVISOES CONSTITUIDAS PARA O PAGAMENTO DE INDENIZACOES CIVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.3.02.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS A LIQUIDAR.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.3.03.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS REFERENTES A SINISTROS JA CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.4.3.04.00','PROVISAO PARA PAGAMENTO DE SEGUROS - SINISTROS NAO CIENTIFICADOS','REGISTRA OS VALORES DAS PROVISOES PARA PAGAMENTO DE SEGUROS, REFERENTES A SINISTROS NAO CIENTIFICADOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.5.0.00.00','PROVISAO PARA REPARTICAO DE CREDITOS A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGACOES DE REPARTICAO A OUTROS ENTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.5.3.00.00','PROVISAO PARA REPARTICAO DE CREDITOS A LONGO PRAZO - INTER OFSS','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS CREDITOS TRIBUTARIOS E NAO TRIBUTARIOS RECONHECIDOS NO LANCAMENTO POR PARTE DO AGENTE ARRECADADOR, A SEREM REPARTIDOS COM OUTROS ENTES DA FEDERACAO, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE. NA ARRECADACAO, ESTA PROVISAO SERA REVERTIDA EM CONTA DE PASSIVO REFERENTE A OBRIGACOES DE REPARTICAO A OUTROS ENTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.6.0.00.00','PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','COMPREENDE OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.6.1.00.00','PROVISAO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO -EXTRA OFSS','REGISTRA OS PASSIVOS DE PRAZO OU DE VALORES INCERTOS RELACIONADOS AOS RISCOS DE DEMANDA, CONSTRUCAO, DISPONIBILIDADE OU OUTROS RISCOS DECORRENTES DE CONTRATOS DE PPP. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.0.00.00','OUTRAS PROVISOES A LONGO PRAZO','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.00.00','OUTRAS PROVISOES A LONGO PRAZO - EXTRA OFSS','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.01.00','PROVISAO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.02.00','PROVISAO PARA REESTRUTURACAO','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.03.00','PROVISOES DO FCVS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.03.01','PROVISOES DO FCVS - RISCOS EXPIRADOS','REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.03.02','PROVISOES DO FCVS - RISCOS NAO EXPIRADOS','REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.1.99.00','OUTRAS PROVISOES A LONGO PRAZO','REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.00.00','OUTRAS PROVISOES A LONGO PRAZO - INTRA OFSS','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.01.00','PROVISAO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.02.00','PROVISAO PARA REESTRUTURACAO','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.03.00','PROVISOES DO FCVS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.03.01','PROVISOES DO FCVS - RISCOS EXPIRADOS','REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.03.02','PROVISOES DO FCVS - RISCOS NAO EXPIRADOS','REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.2.99.00','OUTRAS PROVISOES A LONGO PRAZO','REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.00.00','OUTRAS PROVISOES A LONGO PRAZO - INTER OFSS','COMPREENDE OS DEMAIS PASSIVOS DE PRAZO OU DE VALOR INCERTOS, COM PRAZO PROVAVEL APOS O TERMINO DO EXERCICIO SEGUINTE, NAO CLASSIFICADAS ANTERIORMENTE NESTE PLANO DE CONTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.01.00','PROVISAO PARA GARANTIAS','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR DESPESAS COM A PRESTACAO DE GARANTIA RELATIVAS A PRODUTOS VENDIDOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.02.00','PROVISAO PARA REESTRUTURACAO','REGISTRA OS VALORES DAS PROVISOES DESTINADAS A COBRIR OBRIGACOES ORIUNDAS DA VENDA OU EXTINCAO DE UMA LINHA DE NEGOCIOS, FECHAMENTO DE FABRICAS OU LOCAIS DE NEGOCIOS, MUDANCAS NA ESTRUTURA DA ADMINISTRACAO E REORGANIZACOES COM EFEITO RELEVANTE NA NATUREZA E FOCO DAS OPERACOES DA ENTIDADE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.03.00','PROVISOES DO FCVS','REGISTRA, DE ACORDO COM A NOTA TECNICA ATUARIAL, OS VALORES ATUARIAIS DOS PASSIVOS DO FUNDO DE COMPENSACAO E VARIACOES SALARIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.03.01','PROVISOES DO FCVS - RISCOS EXPIRADOS','REGISTRA OS RESIDUOS DE CONTRATOS LIQUIDADOS PELO MUTUARIO COM COBERTURA DO FCVS, DE ACORDO COM A AVALIACAO ATUARIAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.03.02','PROVISOES DO FCVS - RISCOS NAO EXPIRADOS','REGISTRA O MONTANTE DE CONTRATOS COM COBERTURA DO FCVS EM FASE DE PAGAMENTO PELOS MUTUARIOS, DE ACORDO COM A AVALIACAO ATUARIAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.7.9.3.99.00','OUTRAS PROVISOES A LONGO PRAZO','REGISTRA OS VALORES DAS PROVISOES NAO CLASSIFICAVEIS NAS DEMAIS CONTAS DESTE PLANO DE CONTAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.0.0.00.00','DEMAIS OBRIGACOES A LONGO PRAZO','COMPREENDE AS OBRIGACOES DA ENTIDADE JUNTO A TERCEIROS NAO INCLUSAS NOS SUBGRUPOS ANTERIORES, INCLUSIVE OS PRECATORIOS DECORRENTES DESTAS OBRIGACOES, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO-EXTRA OFSS','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.1.2.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO-INTRA OFSS','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.1.3.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO-INTER OFSS','COMPREENDE AS ANTECIPACOES RECEBIDAS POR OPERACOES DE FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS E QUE ENSEJEM A DEVOLUCAO DA QUANTIA RECEBIDA, CASO A OPERACAO NAO OCORRA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.2.0.00.00','OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO','COMPREENDE OS VALORES EXIGIVEIS APOS O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.2.1.00.00','OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO -EXTRA OFSS','COMPREENDE OS VALORES EXIGIVEIS APOS O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.2.2.00.00','OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO -INTRA OFSS','COMPREENDE OS VALORES EXIGIVEIS APOS O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.2.3.00.00','OBRIGACOES POR DANOS A TERCEIROS A LONGO PRAZO -INTER OFSS','COMPREENDE OS VALORES EXIGIVEIS APOS O TERMINO DO EXERCICIO SEGUINTE, PROVENIENTES DE DANOS A TERCEIROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.3.0.00.00','DEBENTURES E OUTROS TITULOS DE DIVIDA A LONGO PRAZO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.3.1.00.00','DEBENTURES E OUTROS TITULOS DE DIVIDA A LONGO PRAZO-EXTRA OFSS','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.3.1.01.00','DEBENTURES CONVERSIVEIS EM ACOES NO LONGO PRAZO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.3.1.02.00','DEBENTURES NAO CONVERSIVEIS EM ACOES NO LONGO PRAZO','COMPREENDE OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE NAO SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO APOS OS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.4.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','COMPREENDE OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.4.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL -EXTRA OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.4.2.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL -INTRA OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.4.3.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL -INTER OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.0.00.00','OUTRAS OBRIGACOES A LONGO PRAZO','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.00.00','OUTRAS OBRIGACOES A LONGO PRAZO-EXTRA OFSS','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.01.01','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.01.02','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.01.03','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.01.04','RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.02.00','REEMBOLSOS A SEREM EFETUADOS PELO INSS','COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.02.01','DEBITOS EM APURACAO ','REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.02.99','OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.03.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.03.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.03.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.04.00','CONVENIOS A PAGAR - PORTAL/SICONV','COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.04.01','CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.04.02','CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.05.00','CONTRATO DE PROGRAMA DE REPASSE A PAGAR','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.05.01','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.05.02','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.06.00','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.06.01','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.06.02','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.07.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.07.01','TERMOS DE PARCERIA DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.07.02','TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.08.00','TERMOS DE PARCERIA A PAGAR- PORTAL SICONV','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.08.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.08.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.09.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.09.01','TERMO DE COMPROMISSO A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.09.02','TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.10.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.10.01','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.10.02','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.10.03','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.11.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.11.01','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.11.02','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.12.00','BOLSAS PARA ESTUDOS ','COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.12.01','BOLSAS DE ESTUDOS - EXERCICIO','REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.12.02','BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.13.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.14.00','CONTRATOS DE COOPERACAO TECNICA','COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.14.01','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO','REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.14.02','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR','REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.15.00','AUXILIOS FINANCEIROS A PESQUISADORES ','COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.15.01','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.15.02','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.16.00','OBRIGACOES JUNTO A ENTIDADES FEDERAIS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.17.00','ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA','REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS APOS O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.18.00','EMPRESTIMOS E FINANCIAMENTOS A LIBERAR','REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.19.00','INCENTIVOS A LIBERAR','REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.20.00','ADIANTAMENTOS RECEBIDOS','COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.20.01','ADIANTAMENTOS DE OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.20.02',' ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG','REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.20.03','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.1.99.00','OUTROS CREDORES A LONGO PRAZO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.00.00','OUTRAS OBRIGACOES A LONGO PRAZO-INTRA OFSS','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.01.01','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.01.02','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.01.03','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.01.04','RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.02.00','REEMBOLSOS A SEREM EFETUADOS PELO INSS','COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.02.01','DEBITOS EM APURACAO ','REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.02.99','OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.03.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.03.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.03.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.04.00','CONVENIOS A PAGAR - PORTAL/SICONV','COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.04.01','CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.04.02','CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.05.00','CONTRATO DE PROGRAMA DE REPASSE A PAGAR','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.05.01','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.05.02','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.06.00','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.06.01','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.06.02','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.07.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.07.01','TERMOS DE PARCERIA DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.07.02','TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.08.00','TERMOS DE PARCERIA A PAGAR- PORTAL SICONV','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.08.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.08.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.09.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.09.01','TERMO DE COMPROMISSO A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.09.02','TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.10.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.10.01','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.10.02','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.10.03','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.11.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.11.01','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.11.02','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.12.00','BOLSAS PARA ESTUDOS ','COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.12.01','BOLSAS DE ESTUDOS - EXERCICIO','REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.12.02','BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.13.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.14.00','CONTRATOS DE COOPERACAO TECNICA','COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.14.01','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO','REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.14.02','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR','REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.15.00','AUXILIOS FINANCEIROS A PESQUISADORES ','COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.15.01','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.15.02','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.16.00','OBRIGACOES JUNTO A ENTIDADES FEDERAIS','REGISTRA OS VALORES EXIGIVEIS A LONGO PRAZO, DECORRENTES DE OBRIGACOES JUNTO A ENTIDADES FEDERAIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.17.00','ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA','REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS APOS O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.18.00','EMPRESTIMOS E FINANCIAMENTOS A LIBERAR','REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.19.00','INCENTIVOS A LIBERAR','REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.20.00','ADIANTAMENTOS RECEBIDOS','COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.20.01','ADIANTAMENTOS DE OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.20.02',' ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG','REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.20.03','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.2.99.00','OUTROS CREDORES A LONGO PRAZO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.00.00','OUTRAS OBRIGACOES A LONGO PRAZO-INTER OFSS','COMPREENDE OUTRAS OBRIGACOES NAO CLASSIFICAVEIS EM GRUPOS ESPECIFICOS DESTE PLANO DE CONTAS, COM VENCIMENTO APOS O TERMINO DO EXERCICIO SEGUINTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.01.01','INDENIZACOES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXILIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.01.02','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.01.03','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZACOES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.01.04','RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS','REGISTRA O VALOR DAS RESTITUICOES DE CONTRIBUICOES PREVIDENCIARIAS A SEREM EFETIVADAS PELAS UNIDADES DO INSS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.02.00','REEMBOLSOS A SEREM EFETUADOS PELO INSS','COMPREENDE OS VALORES A SEREM PAGOS PELO INSS AS ENTIDADES QUE EFETUARAM PAGAMENTOS E ANTECIPACOES AOS SEUS EMPREGADOS OU SERVIDORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.02.01','DEBITOS EM APURACAO ','REGISTRA OS VALORES EM APURACAO A SEREM RESSARCIDOS PELO INSS A ENTIDADES, DECORRENTES DE PAGAMENTOS OU ANTECIPACOES EFETUADAS POR ESTAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.02.99','OUTROS DEBITOS POR INDENIZACAO E ANTECIPACOES','REGISTRA OS VALORES A SEREM RESSARCIDOS PELO INSS POR PAGAMENTOS OU ANTECIPACOES REALIZADAS POR ENTIDADES, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.03.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.03.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.03.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.04.00','CONVENIOS A PAGAR - PORTAL/SICONV','COMPREENDE OS VALORES A PAGAR REFERENTES A CONVENIOS REGISTRADOS PELO PORTAL / SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.04.01','CONVENIOS A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DO EXERCICIO, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.04.02','CONVENIOS A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS DE EXERCICIOS ANTERIORES, REGISTRADOS PELO PORTAL / SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.05.00','CONTRATO DE PROGRAMA DE REPASSE A PAGAR','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.05.01','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.05.02','CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.06.00','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV','COMPREENDE O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR, REGISTRADOS NO PORTAL SICONV.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.06.01','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DO EXERCICIO','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DO EXERCICIO, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.06.02','CONTRATO DE REPASSE A PAGAR - PORTAL/SICONV DE EXERCICIOS ANTERIORES','REGISTRA O SOMATORIO DOS VALORES A PAGAR RETIDOS A TITULO DE CONTRATO DE PROGRAMA DE REPASSE A PAGAR DE EXERCICIOS ANTERIORES, REGISTRADOS NO PORTAL SICONV.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.07.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.07.01','TERMOS DE PARCERIA DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.07.02','TERMOS DE PARCERIA DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.08.00','TERMOS DE PARCERIA A PAGAR- PORTAL SICONV','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV. O TERMO DE PARCERIA E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.08.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.08.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES - PORTAL SICONV ','REGISTRA OS VALORES A PAGAR REFERENTES A TERMO DE PARCERIA REGISTRADO NO PORTAL SICONV FIRMADO EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.09.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.09.01','TERMO DE COMPROMISSO A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS NO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.09.02','TERMO DE COMPROMISSO A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE COMPROMISSOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.10.00','PRECATORIOS DE TERCEIROS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.10.01','PRECATORIOS DE TERCEIROS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS NO EXERCICIO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.10.02','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS, EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES, INCORRIDAS EM EXERCICIOS ANTERIORES, ANTES DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.10.03','PRECATORIOS DE TERCEIROS DE EXERCICIOS ANTERIORES- A PARTIR DE 05/05/2000 ','REGISTRA OS VALORES RELATIVOS A PRECATORIOS , EXCETO PRECATORIOS DE PESSOAL, DE BENEFICIOS E DE FORNECEDORES DE BENS, MATERIAIS, SERVICOS E UTILIDADES., INCORRIDAS EM EXERCICIOS ANTERIORES, A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.11.00','COMPENSACAO PREVIDENCIARIA','COMPREENDE O VALOR DAS OBRIGACOES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS NR. 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.11.01','COMPENSACAO PREVIDENCIARIA DO EXERCICIO','REGISTRA O VALOR DAS OBRIGACOES DO EXERCICIO COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL -RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.11.02','COMPENSACAO PREVIDENCIARIA DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DAS OBRIGACOES DE EXERCICIOS ANTERIORES COM COMPENSACAO PREVIDENCIARIA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL - RGPS E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL, CONFORME DISPOE A PORTARIA MPS Nº 98, BEM COMO A LEI 9796/1999, REGULAMENTADA PELO DECRETO Nº 3112/1999.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.12.00','BOLSAS PARA ESTUDOS ','COMPREENDE AS OBRIGACOES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.12.01','BOLSAS DE ESTUDOS - EXERCICIO','REGISTRA AS OBRIGACOES DO EXERCICIO RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.12.02','BOLSAS DE ESTUDOS - EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES DE EXERCICIOS ANTERIORES RELATIVAS A BOLSAS PARA CURSOS DE ESPECIALIZACAO, MESTRADO, DOUTORADO, BEM COMO PARA ESTAGIARIOS E DEMAIS BOLSAS RELACIONADAS A ESTUDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.13.00','CONTRATOS DE GESTAO','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.14.00','CONTRATOS DE COOPERACAO TECNICA','COMPREENDE OS VALORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001) DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.14.01','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO','REGISTRA OS VALORES DO EXERCICIO EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.14.02','CONTRATOS DE COOPERACAO TECNICA - EXERCICIO ANTERIOR','REGISTRA OS VALORES DE EXERCICIOS ANTERIORES EXIGIVEIS PARA REALIZACAO DE PROGRAMAS, PROJETOS OU ATIVIDADES QUE REQUEIRAM A CONTRATACAO DE SERVICOS TECNICOS ESPECIALIZADOS, CUJOS OBJETIVOS GERAIS E ESPECIFICOS, ESTEJAM REGISTRADOS EM INSTRUMENTOS QUE DEFINAM A COOPERACAO TECNICA (DECRETO Nº 3.751/2001).','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.15.00','AUXILIOS FINANCEIROS A PESQUISADORES ','COMPREENDE AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.15.01','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DO EXERCICIO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.15.02','AUXILIOS FINANCEIROS A PESQUISADORES - EXERCICIO ANTERIOR','REGISTRA AS OBRIGACOES A PAGAR RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES, DE EXERCICIOS ANTERIORES.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.16.00','ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA','REGISTRA OS VALORES PARCELADOS DE DEBITOS JUNTO A ENTIDADES PRIVADAS, EXCETO AS DE PREVIDENCIA PRIVADA, A SEREM PAGOS APOS O TERMINO DO EXERCICIO SEGUINTE.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.17.00','EMPRESTIMOS E FINANCIAMENTOS A LIBERAR','REGISTRA A APROPRIACAO DE VALORES A SEREM LIBERADOS, DECORRENTES DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.18.00','INCENTIVOS A LIBERAR','REGISTRA O VALOR DOS INCENTIVOS FISCAIS A LIBERAR POR OCASIAO DA CLASSIFICACAO DA RECEITA ARRECADADA.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.19.00','ADIANTAMENTOS RECEBIDOS','COMPREENDE OS VALORES EXIGIVEIS DENTRO DOS DOZE MESES SEGUINTES A DATA DE PUBLICACAO DAS DEMONSTRACOES CONTABEIS, A TITULO DE ADIANTAMENTOS RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.19.01','ADIANTAMENTOS DE OPERACOES ESPECIAIS','REGISTRA OS VALORES RELATIVOS AOS RECURSOS FINANCEIROS RECEBIDOS PARA ATENDER OPERACOES TIPICAS DE EXECUCAO ORCAMENTARIA, REALIZADAS POR UNIDADES COM CARACTERISTICAS PECULIARES, PRINCIPALMENTE O MINISTERIO DAS RELACOES EXTERIORES E OUTRAS.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.19.02',' ADIANTAMENTOS RECEBIDOS DE ORGAOS, ENTIDADES E UG','REGISTRA OS VALORES EXIGIVEIS RELATIVOS A ADIANTAMENTOS RECEBIDOS DE ORGAOS E ENTIDADES, INCLUSIVE UNIDADES GESTORAS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.19.03','ADIANTAMENTOS DIVERSOS RECEBIDOS','REGISTRA OS VALORES EXIGIVEIS DECORRENTES DE DIVERSOS ADIANTAMENTOS RECEBIDOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','F');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.8.9.3.99.00','OUTROS CREDORES A LONGO PRAZO','REGISTRA OS VALORES EXIGIVEIS A CURTO PRAZO, DECORRENTES DE RECURSOS OBTIDOS JUNTO A DIVERSOS CREDORES PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS NESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.0.0.00.00','RESULTADO DIFERIDO','COMPREENDE O SALDO EXISTENTE NA ANTIGA CONTA RESULTADO DE EXERCICIOS FUTUROS EM 31 DE DEZEMBRO DE 2008, COMPOSTO DE VARIACAO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA E O RESPECTIVO CUSTO DIFERIDO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.1.0.00.00','VARIACAO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.1.1.00.00','VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - EXTRA OFSS','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.1.2.00.00','VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - INTRA OFSS','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.1.3.00.00','VARIACAO PATRIMONIAL AUMENTATIVA DIFERIDA - INTER OFSS','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS JA RECEBIDAS QUE EFETIVAMENTE DEVEM SER RECONHECIDAS EM RESULTADOS EM ANOS FUTUROS E QUE NAO HAJA QUALQUER TIPO DE OBRIGACAO DE DEVOLUCAO POR PARTE DA ENTIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.2.0.00.00','(-) CUSTO DIFERIDO','COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.2.1.00.00','(-) CUSTO DIFERIDO - EXTRA OFSS','COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.2.2.00.00','(-) CUSTO DIFERIDO - INTRA OFSS','COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.2.9.2.3.00.00','(-) CUSTO DIFERIDO - INTER OFSS','COMPREENDE O CUSTO RELACIONADO AS VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA) DIFERIDAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.0.0.0.00.00','PATRIMONIO LIQUIDO','COMPREENDE O VALOR RESIDUAL DOS ATIVOS DEPOIS DE DEDUZIDOS TODOS OS PASSIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.0.0.00.00','PATRIMONIO SOCIAL E CAPITAL SOCIAL','COMPREENDE O PATRIMONIO SOCIAL DAS AUTARQUIAS, FUNDACOES E FUNDOS E O CAPITAL SOCIAL DAS DEMAIS ENTIDADES DA ADMINISTRACAO INDIRETA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.1.0.00.00','PATRIMONIO SOCIAL','COMPREENDE O PATRIMONIO DAS AUTARQUIAS, FUNDACOES E FUNDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.1.1.00.00','PATRIMONIO SOCIAL - EXTRA OFSS','REGISTRA O PATRIMONIO DAS AUTARQUIAS, FUNDACOES E FUNDOS, PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.0.00.00','CAPITAL SOCIAL REALIZADO','COMPREENDE O CAPITAL SOCIAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA, DEDUZIDO DA PARCELA AINDA NAO REALIZADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.1.00.00','CAPITAL SOCIAL REALIZADO - EXTRA OFSS','COMPREENDE O CAPITAL SOCIAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA, DEDUZIDO DA PARCELA AINDA NAO REALIZADA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.1.01.00','CAPITAL SOCIAL SUBSCRITO ','REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.1.02.00','(-) CAPITAL SOCIAL A REALIZAR ','REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.1.03.00','(-) GASTOS COM EMISSAO DE ACOES','REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.2.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NAO REALIZADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.2.01.00','CAPITAL SOCIAL SUBSCRITO ','REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.2.02.00','(-) CAPITAL SOCIAL A REALIZAR ','REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.2.03.00','(-) GASTOS COM EMISSAO DE ACOES','REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.3.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS','COMPREENDE O CAPITAL SOCIAL SUBSCRITO, DEDUZIDO DA PARCELA AINDA NAO REALIZADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.3.01.00','CAPITAL SOCIAL SUBSCRITO ','REGISTRA O VALOR DO CAPITAL SUBSCRITO DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.3.02.00','(-) CAPITAL SOCIAL A REALIZAR ','REGISTRA O VALOR DO CAPITAL SUBSCRITO A REALIZAR DAS EMPRESAS PUBLICAS E SOCIEDADES DE ECONOMIA MISTA.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.1.2.3.03.00','(-) GASTOS COM EMISSAO DE ACOES','REGISTRA TODOS OS GASTOS COM CAPTACAO DE RECURSOS POR EMISSAO DE ACOES OU OUTROS VALORES MOBILIARIOS PERTENCENTES AO PATRIMONIO LIQUIDO.','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.2.0.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','COMPREENDE OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.2.0.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - EXTRA OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS..COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.2.0.2.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.2.0.3.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS','REGISTRA OS RECURSOS RECEBIDOS PELA ENTIDADE DE SEUS ACIONISTAS OU QUOTISTAS DESTINADOS A SEREM UTILIZADOS PARA AUMENTO DE CAPITAL, QUANDO NAO HAJA A POSSIBILIDADE DE DEVOLUCAO DESTES RECURSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.0.0.00.00','RESERVAS DE CAPITAL','COMPREENDE OS VALORES ACRESCIDOS AO PATRIMONIO QUE NAO TRANSITARAM PELO RESULTADO COMO VARIACOES PATRIMONIAIS AUMENTATIVAS (VPA).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.1.0.00.00','AGIO NA EMISSAO DE ACOES','COMPREENDE A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.1.1.00.00','AGIO NA EMISSAO DE ACOES - EXTRA OFSS','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.1.2.00.00','AGIO NA EMISSAO DE ACOES - INTRA OFSS','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS  DO MESMO ENTE PUBLICO','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.1.3.00.00','AGIO NA EMISSAO DE ACOES - INTER OFSS','REGISTRA A CONTRIBUICAO DO SUBSCRITOR DE ACOES QUE ULTRAPASSAR O VALOR NOMINAL E A PARTE DO PRECO DE EMISSAO DAS ACOES SEM VALOR NOMINAL QUE ULTRAPASSAR A IMPORTANCIA DESTINADA A FORMACAO DO CAPITAL SOCIAL, INCLUSIVE NOS CASOS DE CONVERSAO EM ACOES DE DEBENTURES OU PARTES BENEFICIARIAS. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.2.0.00.00','ALIENACAO DE PARTES BENEFICIARIAS','COMPREENDE O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.2.1.00.00','ALIENACAO DE PARTES BENEFICIARIAS - EXTRA OFSS','REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.2.2.00.00','ALIENACAO DE PARTES BENEFICIARIAS - INTRA OFSS','REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.2.3.00.00','ALIENACAO DE PARTES BENEFICIARIAS - INTER OFSS','REGISTRA O PRODUTO DA ALIENACAO DE PARTES BENEFICIARIAS.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.3.0.00.00','ALIENACAO DE BONUS DE SUBSCRICAO','COMPREENDE O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.3.1.00.00','ALIENACAO DE BONUS DE SUBSCRICAO - EXTRA OFSS','REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.3.2.00.00','ALIENACAO DE BONUS DE SUBSCRICAO - INTRA OFSS','REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.3.3.00.00','ALIENACAO DE BONUS DE SUBSCRICAO - INTER OFSS','REGISTRA O PRODUTO DA ALIENACAO DE BONUS DE SUBSCRICAO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.4.0.00.00','CORRECAO MONETARIA DO CAPITAL REALIZADO','COMPREENDE O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO-CAPITALIZADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.4.1.00.00','CORRECAO MONETARIA DO CAPITAL REALIZADO - EXTRA OFSS','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO-CAPITALIZADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.4.2.00.00','CORRECAO MONETARIA DO CAPITAL REALIZADO - INTRA OFSS','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO-CAPITALIZADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.4.3.00.00','CORRECAO MONETARIA DO CAPITAL REALIZADO - INTER OFSS','REGISTRA O RESULTADO DA CORRECAO MONETARIA DO CAPITAL REALIZADO, ENQUANTO NAO-CAPITALIZADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.0.00.00','OUTRAS RESERVAS DE CAPITAL','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.1.00.00','OUTRAS RESERVAS DE CAPITAL - EXTRA OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.1.01.00','PREMIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.1.02.00','RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS','REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.1.03.00','RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77','REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.1.98.00','DEMAIS RESERVAS DE CAPITAL','REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.2.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.2.01.00','PREMIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.2.02.00','RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS','REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.2.03.00','RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77','REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.2.98.00','DEMAIS RESERVAS DE CAPITAL','REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.3.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.3.01.00','PREMIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE PREMIO NA EMISSAO DE DEBENTURES, QUE OCORREM QUANDO O PRECO DA EMISSAO DE DEBENTURES FOR SUPERIOR A SEU VALOR NOMINAL. ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.3.02.00','RESERVAS DE DOACOES E SUBVENCOES PARA INVESTIMENTOS','REGISTRA OS VALORES DE DOACOES E SUBVENCOES PARA INVESTIMENTOS.ESTA CONTA NAO CONSTA MAIS DENTRE AS RUBRICAS DE RESERVAS DE CAPITAL E ASSIM DEVE SER UTILIZADA APENAS DURANTE O PERIODO NECESSARIO PARA UTLIZACAO DOS SALDOS REMANESCENTES NELA .','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.3.03.00','RESERVA DE CORRECAO MONETARIA ESPECIAL DEC. LEI 1.598/77','REGISTRA OS VALORES DO RESULTADO DA CORRECAO MONETARIA ESPECIAL, CONFORME O DECRETO-LEI Nº 1.598/77.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.3.9.3.98.00','DEMAIS RESERVAS DE CAPITAL','REGISTRA OS VALORES DAS DEMAIS RESERVAS DE CAPITAL, NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.4.0.0.00.00','AJUSTES DE AVALIACAO PATRIMONIAL','COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO E DO PASSIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO EM OBEDIENCIA AO REGIME DE COMPETENCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.4.1.0.00.00','AJUSTES DE AVALIACAO PATRIMONIAL DE ATIVOS','COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.4.1.1.00.00','AJUSTES DE AVALIACAO PATRIMONIAL DE ATIVOS - EXTRA OFSS','REGISTRA AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.4.2.0.00.00','AJUSTES DE AVALIACAO PATRIMONIAL DE PASSIVOS','COMPREENDE AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO PASSIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.4.2.1.00.00','AJUSTES DE AVALIACAO PATRIMONIAL DE PASSIVOS - EXTRA OFSS','REGISTRA AS CONTRAPARTIDAS DE AUMENTOS OU DIMINUICOES DE VALOR ATRIBUIDOS A ELEMENTOS DO PASSIVO EM DECORRENCIA DA SUA AVALIACAO A VALOR JUSTO, NOS CASOS PREVISTOS PELA LEI Nº 6.404/76 OU EM NORMAS EXPEDIDAS PELA COMISSAO DE VALORES MOBILIARIOS, ENQUANTO NAO COMPUTADAS NO RESULTADO DO EXERCICIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.0.0.00.00','RESERVAS DE LUCROS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DAS ENTIDADES PARA FINALIDADES ESPECIFICAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.1.0.00.00','RESERVA LEGAL','COMPREENDE OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.1.1.00.00','RESERVA LEGAL- EXTRA OFSS','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.1.2.00.00','RESERVA LEGAL- INTRA OFSS','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.1.3.00.00','RESERVA LEGAL- INTER OFSS','REGISTRA OS VALORES DAS RESERVAS OBRIGATORIAMENTE CONSTITUIDAS COM 5% DO LUCRO LIQUIDO DO EXERCICIO, ATE ATINGIR O LIMITE DE 20% DO CAPITAL SOCIAL REALIZADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.2.0.00.00','RESERVAS ESTATUTARIAS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.2.1.00.00','RESERVAS ESTATUTARIAS - EXTRA OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.2.2.00.00','RESERVAS ESTATUTARIAS - INTRA OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.2.3.00.00','RESERVAS ESTATUTARIAS - INTER OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A ATENDER FINALIDADES DETERMINADAS NO ESTATUTO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.3.0.00.00','RESERVA PARA CONTINGENCIAS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.3.1.00.00','RESERVA PARA CONTINGENCIAS - EXTRA OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.3.2.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.3.3.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS','REGISTRA AS RESERVAS CONSTITUIDAS COM PARCELAS DO LUCRO LIQUIDO DESTINADAS A COMPENSAR, EM EXERCICIO FUTURO, A DIMINUICAO DO LUCRO DECORRENTE DE PERDA JULGADA PROVAVEL, CUJO VALOR POSSA SER ESTIMADO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.4.0.00.00','RESERVA DE INCENTIVOS FISCAIS','COMPREENDE A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.4.1.00.00','RESERVA DE INCENTIVOS FISCAIS - EXTRA OFSS','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.4.2.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.4.3.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS','REGISTRA A RESERVA CONSTITUIDA COM PARCELA DO LUCRO LIQUIDO DECORRENTE DE DOACOES OU SUBVENCOES GOVERNAMENTAIS PARA INVESTIMENTOS, QUE PODERA SER EXCLUIDA DA BASE DE CALCULO DO DIVIDENDO OBRIGATORIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.0.00.00','RESERVAS DE LUCROS PARA EXPANSAO','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.1.00.00','RESERVAS DE LUCROS PARA EXPANSAO - EXTRA OFSS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.1.01.00','RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.1.02.00','RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.2.00.00','RESERVAS DE LUCROS PARA EXPANSAO - INTRA OFSS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.2.01.00','RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.2.02.00','RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.3.00.00','RESERVAS DE LUCROS PARA EXPANSAO - INTER OFSS','COMPREENDE AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO , COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.3.01.00','RESERVAS DE LUCROS PARA EXPANSAO - DO EXERCICIO','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DO EXERCICIO, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.5.3.02.00','RESERVAS DE LUCROS PARA EXPANSAO - DE EXERCICIOS ANTERIORES','REGISTRA AS RESERVAS CONSTITUIDAS COM PARTE DO LUCRO LIQUIDO DE EXERCICIOS ANTERIORES, COM O OBJETIVO DE ATENDER A PROJETOS DE INVESTIMENTO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.6.0.00.00','RESERVA DE LUCROS A REALIZAR','COMPREENDE A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.6.1.00.00','RESERVA DE LUCROS A REALIZAR- EXTRA OFSS','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.6.2.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.6.3.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS','REGISTRA A RESERVA CONSTITUIDA COM O EXCESSO ENTRE O MONTANTE DO DIVIDENDO OBRIGATORIO E A PARCELA REALIZADA DO LUCRO LIQUIDO DO EXERCICIO. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.7.0.00.00','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.7.1.00.00','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- EXTRA OFSS','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.7.2.00.00','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTRA OFSS','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.7.3.00.00','RESERVA DE RETENCAO DE PREMIO NA EMISSAO DE DEBENTURES- INTER OFSS','COMPREENDE A PARCELA DO LUCRO LIQUIDO DO EXERCICIO DECORRENTE DO PREMIO NA EMISSAO DE DEBENTURES. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.0.00.00','OUTRAS RESERVAS DE LUCRO','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.1.00.00','OUTRAS RESERVAS DE LUCRO - EXTRA OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.1.01.00','CREDITOS FISCAIS DIFERIDOS','REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.1.98.00','DEMAIS RESERVAS DE LUCRO','REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.2.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.2.01.00','CREDITOS FISCAIS DIFERIDOS','REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.2.98.00','DEMAIS RESERVAS DE LUCRO','REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.3.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS','COMPREENDE OS VALORES DAS DEMAIS RESERVAS DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR HAVEREM SIDO EXTINTAS PELA LEGISLACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.3.01.00','CREDITOS FISCAIS DIFERIDOS','REGISTRA AS PARCELAS DO LUCRO AINDA NAO REALIZADAS FINANCEIRAMENTE, RESULTANTE DE CREDITOS FISCAIS DIFERIDOS, DE ACORDO COM A DELIBERACAO DA CVM Nº 273, DE 20/08/98. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.5.9.3.98.00','DEMAIS RESERVAS DE LUCRO','REGISTRA AS DEMAIS RESERVAS DE LUCRO NAO CONTABILIZAVEIS EM OUTRAS CONTAS DESTE PLANO.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.0.0.00.00','DEMAIS RESERVAS','COMPREENDE AS DEMAIS RESERVAS, NAO CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO, INCLUSIVE AQUELAS QUE TERAO SEUS SALDOS REALIZADOS POR TEREM SIDO EXTINTAS PELA LEGISLACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.0.00.00','RESERVA DE REAVALIACAO','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.00.00','RESERVA DE REAVALIACAO - EXTRA OFSS','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.01.00','REAVALIACAO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.02.00','REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.03.00','REAVALIACAO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.04.00','REAVALIACAO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.05.00','REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.98.00','OUTRAS RESERVAS DE REAVALIACAO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.1.99.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO','REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.00.00','RESERVA DE REAVALIACAO - INTRA OFSS','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.01.00','REAVALIACAO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.02.00','REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.03.00','REAVALIACAO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.04.00','REAVALIACAO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.05.00','REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.98.00','OUTRAS RESERVAS DE REAVALIACAO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.2.99.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO','REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.00.00','RESERVA DE REAVALIACAO - INTER OFSS','COMPREENDE A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A ELEMENTOS DO ATIVO, APURADOS PELA DIFERENCA ENTRE O VALOR DO LAUDO E O VALOR ANTERIOR (CUSTO ORIGINAL MAIS EVENTUAIS REAVALIACOES ANTERIORES). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.01.00','REAVALIACAO DE BENS IMOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR INSCRICAO GENERICA DO TIPO INDIVIDUALIZACAO DE IMOVEIS.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.02.00','REAVALIACAO DE BENS IMOVEIS - POR NUMERO DO RIP','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS IMOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR NUMERO REGISTRO IMOBILIARIO PATRIMONIAL (RIP) DE IMOVEL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.03.00','REAVALIACAO DE BENS MOVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS MOVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.04.00','REAVALIACAO DE BENS INTANGIVEIS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, ATRIBUIDOS AOS BENS INTANGIVEIS DA ENTIDADE, DECORRENTES DE REAVALIACOES, QUANDO O CONTROLE FOR POR CGC, CPF, IG OU UG.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.05.00','REAVALIACAO DE ATIVOS DE COLIGADAS E CONTROLADAS','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR, DAS REAVALIACOES EFETUADAS NOS ATIVOS DAS COLIGADAS E CONTROLADAS AVALIADAS PELO METODO DE EQUIVALENCIA PATRIMONIAL.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.98.00','OUTRAS RESERVAS DE REAVALIACAO','REGISTRA A CONTRAPARTIDA DOS ACRESCIMOS DE VALOR ATRIBUIDOS A OUTROS BENS DA ENTIDADE, DECORRENTES DE REAVALIACOES.','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.1.3.99.00','(-) TRIBUTOS SOBRE A RESERVA DE REAVALIACAO','REGISTRA O VALOR DA CARGA TRIBUTARIA (IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL) DEVIDA SOBRE A FUTURA REALIZACAO DE ATIVO QUE A GERARAM (PARA EFEITO DE CONTROLE FISCAL).','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.9.0.00.00','OUTRAS RESERVAS','COMPREENDE OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.9.1.00.00','OUTRAS RESERVAS - EXTRA OFSS','REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.9.2.00.00','OUTRAS RESERVAS - INTRA OFSS','REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.6.9.3.00.00','OUTRAS RESERVAS - INTER OFSS','REGISTRA OUTRAS RESERVAS QUE NAO FOREM CLASSIFICADAS COMO RESERVAS DE CAPITAL OU DE LUCRO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.0.0.00.00','RESULTADOS ACUMULADOS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS E OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.0.00.00','SUPERAVITS OU DEFICITS ACUMULADOS','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.1.00.00','SUPERAVITS OU DEFICITS ACUMULADOS - EXTRA OFSS','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.1.01.00','SUPERAVITS OU DEFICITS DO EXERCICIO','REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.1.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES E AJUSTES DE EXERCICIOS ANTERIORES','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES E OS AJUSTES DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.1.02.01','SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES','REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.1.02.02','AJUSTES DE EXERCICIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.1.03.00','SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.','X','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.2.00.00','SUPERAVITS OU DEFICITS ACUMULADOS - INTRA OFSS','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.2.01.00','SUPERAVITS OU DEFICITS DO EXERCICIO','REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.2.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES E AJUSTES DE EXERCICIOS ANTERIORES','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES E OS AJUSTES DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.2.02.01','SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES','REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.2.02.02','AJUSTES DE EXERCICIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.2.03.00','SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.','X','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.3.00.00','SUPERAVITS OU DEFICITS ACUMULADOS - INTER OFSS','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.3.01.00','SUPERAVITS OU DEFICITS DO EXERCICIO','REGISTRA OS SUPERAVITS OU DEFICITS DO EXERCICIO DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.3.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES E AJUSTES DE EXERCICIOS ANTERIORES','COMPREENDE OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES E OS AJUSTES DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.3.02.01','SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES','REGISTRA OS SUPERAVITS OU DEFICITS ACUMULADOS DE EXERCICIOS ANTERIORES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.3.02.02','AJUSTES DE EXERCICIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES. SERAO REGISTRADOS NESTA CONTA OS AJUSTES DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.1.3.03.00','SUPERAVITS OU DEFICITS RESULTANTES DE EXTINCAO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE UNIDADE DA ADMINISTRACAO DIRETA, AUTARQUIAS, FUNDACOES E FUNDOS, OCORRIDA DURANTE O EXERCICIO.','X','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.0.00.00','LUCROS E PREJUIZOS ACUMULADOS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.00.00','LUCROS E PREJUIZOS ACUMULADOS - EXTRA OFSS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.01.00','LUCROS E PREJUIZOS DO EXERCICIO','REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.02.00','LUCROS/PREJUIZOS ACUMULADOS E AJUSTES DE EXERCICIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCICIOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.02.01','LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES','REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.02.02','AJUSTES DE EXERCICIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.03.00','LUCROS A DESTINAR DO EXERCICIO','REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.04.00','LUCROS A DESTINAR DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.1.05.00','RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO','COMPREENDE O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.','X','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.00.00','LUCROS E PREJUIZOS ACUMULADOS - INTRA OFSS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.01.00','LUCROS E PREJUIZOS DO EXERCICIO','REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.02.00','LUCROS/PREJUIZOS ACUMULADOS E AJUSTES DE EXERCICIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCICIOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.02.01','LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES','REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.02.02','AJUSTES DE EXERCICIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.03.00','LUCROS A DESTINAR DO EXERCICIO','REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.04.00','LUCROS A DESTINAR DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.2.05.00','RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO','REGISTRA O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.','X','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.00.00','LUCROS E PREJUIZOS ACUMULADOS - INTER OFSS','COMPREENDE O SALDO REMANESCENTE DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.01.00','LUCROS E PREJUIZOS DO EXERCICIO','REGISTRA O SALDO DOS LUCROS OU PREJUIZOS LIQUIDOS DAS EMPRESAS NO EXERCICIO.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.02.00','LUCROS/PREJUIZOS ACUMULADOS E AJUSTES DE EXERCICIOS ANTERIORES','COMPREENDE O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS E OS AJUSTES DE EXERCICIOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.02.01','LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES','REGISTRA O SALDO DOS LUCROS E PREJUIZOS ACUMULADOS NOS EXERCICIOS ANTERIORES DAS EMPRESAS.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.02.02','AJUSTES DE EXERCICIOS ANTERIORES','REGISTRA O SALDO DECORRENTE DE EFEITOS DA MUDANCA DE CRITERIO CONTABIL OU DA RETIFICACAO DE ERRO IMPUTAVEL A DETERMINADO EXERCICIO ANTERIOR, E QUE NAO POSSAM SER ATRIBUIDOS A FATOS SUBSEQUENTES.','X','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.03.00','LUCROS A DESTINAR DO EXERCICIO','REGISTRA O VALOR DOS LUCROS DO EXERCICIO PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.04.00','LUCROS A DESTINAR DE EXERCICIOS ANTERIORES','REGISTRA O VALOR DOS LUCROS DE EXERCICIOS ANTERIORES PENDENTES DE DESTINACAO, ATE A APROVACAO DA PROPOSTA PELA ASSEMBLEIA GERAL. ','C','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.7.2.3.05.00','RESULTADOS APURADOS POR EXTINCAO, FUSAO E CISAO','COMPREENDE O RESULTADO APURADO POR EXTINCAO, CISAO OU FUSAO DE EMPRESAS DURANTE O EXERCICIO.','X','S','P','X');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.0.0.00.00','(-) ACOES / COTAS EM TESOURARIA','COMPREENDE O VALOR DAS ACOES OU COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.1.0.00.00','(-) ACOES EM TESOURARIA','COMPREENDE O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.1.1.00.00','(-) ACOES EM TESOURARIA - EXTRA OFSS','REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.1.2.00.00','(-) ACOES EM TESOURARIA - INTRA OFSS','REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.1.3.00.00','(-) ACOES EM TESOURARIA - INTER OFSS','REGISTRA O VALOR DAS ACOES DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.2.0.00.00','(-) COTAS EM TESOURARIA','COMPREENDE O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.2.1.00.00','(-) COTAS EM TESOURARIA - EXTRA OFSS','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.2.2.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE.REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('2.3.9.2.3.00.00','(-) COTAS EM TESOURARIA - INTER OFSS','REGISTRA O VALOR DAS COTAS DA ENTIDADE QUE FORAM ADQUIRIDAS PELA PROPRIA ENTIDADE. REGISTRA OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','D','S','P','P');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.0.0.0.0.00.00','VARIACAO PATRIMONIAL DIMINUTIVA','COMPREENDE O DECRESCIMO NO BENEFICIO ECONOMICO DURANTE O PERIODO CONTABIL SOB A FORMA DE SAIDA DE RECURSO OU REDUCAO DE ATIVO OU INCREMENTO EM PASSIVO, QUE RESULTE EM DECRESCIMO DO PATRIMONIO LIQUIDO E QUE NAO SEJA PROVENIENTE DE DISTRIBUICAO AOS PROPRIETARIOS DA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.0.0.0.00.00','PESSOAL E ENCARGOS','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL OU MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS, SOLDOS E VANTAGENS PECUNIARIAS FIXAS OU VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO, EMPREGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO, BEM COMO AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATOS DE TERCEIRIZACAO DE MAO-DE-OBRA QUE SE REFIRAM A SUBSTITUICAO DE SERVIDORES E EMPREGADOS PUBLICOS. COMPREENDE AINDA, OBRIGACOES TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA E BENEFICIOS EVENTUAIS A PESSOAL CIVIL E MILITAR , DESTACADOS OS CUSTOS DE PESSOAL E ENCARGOS INERENTES AS MERCADORIAS E PRODUTOS VENDIDOS E SERVICOS PRESTADOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.0.0.00.00','REMUNERACAO A PESSOAL','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL OU MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS, SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO, EMPREGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO, BEM COMO AS COM CONTRATOS DE TERCEIRIZACAO DE MAO-DE-OBRA QUE SE REFIRAM A SUBSTITUICAO DE SERVIDORES E EMPREGADOS PUBLICOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.0.00.00','REMUNERACAO A PESSOAL - RPPS','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RPPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.00.00','REMUNERACAO A PESSOAL - RPPS - EXTRA OFSS','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RPPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SUBSIDIOS, VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.01','VENCIMENTOS E SALARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REGIDOS PELO REGIME PROPRIO DE PREVIDENCIA SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.02','ADICIONAL NOTURNO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACOES A SERVIDORES EM ATIVIDADE NOTURNA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.03','INCORPORACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORACOES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.04','ABONO DE PERMANENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DO ABONO DE PERMANENCIA, DEVIDO AOS SERVIDORES QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. (EMENDA CONSTITUCIONAL NR.41 DE 19/12/2003 E ORIENTACAO NORMATIVA DA SECRETARIA DE PREVIDENCIA SOCIAL NR.01 DE 06/01/2004). DE ACORDO COM A MEDIDA PROVISORIA 167, DE 19 DE FEVEREIRO DE 2004. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.05','ADICIONAL DE PERICULOSIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM ATIVIDADES PERIGOSAS, CONFORME ART.68 DA LEI 8112/90. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.06','ADICIONAL DE INSALUBRIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES EM ATIVIDADE EM LOCAIS INSALUBRES, CONF. ART. 68 DA LEI 8112/90. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.07','ADICIONAL DE ATIVIDADES PENOSAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM ATIVIDADES PENOSAS, CONFORME ART.71 DA LEI 8112/90. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.08','INCENTIVO A QUALIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM, EM AREAS DE INTERESSE DO ORGAO, CONFORME ESTABELECIDO NA LEI Nº 11.091/2005 E NA LEI Nº 11.416/06. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.09','REMUNERACAO DE PESSOAL EM DISPONIBILIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS FIXAS A PESSOAL CIVIL EM DISPONIBILIDADE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.10','RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE RETRIBUICAO ADICIONAL VARIAVEL E PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGOS TERCEIRO E QUINTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.12','VANTAGEM PECUNIARIA INDIVIDUAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL (INCLUSIVE DA LEI 10698, DE 02/07/03). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.13','ABONO PROVISORIO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.14','GRATIFICACAO POR EXERCICIO DE CARGOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS, COMO DAS, GAJ, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.15','INCREMENTO PLANO DE CARGOS E SALARIOS JUDIC.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A DIFERENCA DE REMUNERACAO DOS CARGOS RESULTANTES DA TRANSFORMACAO SOBRE A DOS TRANSFORMADOS PELO PLANO DE CARGOS E SALARIOS DO PODER JUDICIARIO, CONFOR- ME DISPOSTO NO PARAGRAFO 2º DO ARTIGO 4 DA LEI 9.421/96. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.16','GRATIFICACAO POR EXERCICIO DE FUNCOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE FUNCOES, DE COORDENACAO OU ENCARGO DE ATIVIDADES ESPECIFICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.17','INDENIZACAO DE LOCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE LOCALIZACAO ESPECIFICA DETERMINADA POR LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.18','GRATIFICACAO DE TEMPO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.19','GRATIFICACOES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICACAO ESPECIAL DE LOCALIZACAO, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.20','GRATIFICACAO POR ATIVIDADES EXPOSTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES, QUANDO PELO EXERCICIO, EXPOE O SERVIDOR A RISCOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.21','FERIAS VENCIDAS E PROPORCIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU EXONERACAO DO SERVIDOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.22','13. SALARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE NATAL (13 SALARIO) DO PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.23','FERIAS - ABONO PECUNIARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERACAO DEVIDA AO SERVIDOR NO PERIODO DE FERIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.24','FERIAS - ABONO CONSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS E SERVIDORES COMO REMUNERACAO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALARIO NORMAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.25','LICENCA-PREMIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.26','LICENCA CAPACITACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITACAO. ARTIGO 81, DA LEI 8112/90 - ALTERADO PELA MP 1537- 10/97. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.27','ADIANTAMENTO PECUNIARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINACAO LEGAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.28','REPRESENTACAO MENSAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTACAO MENSAL, POR EXEMPLO DO "DAS" E ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.29','COMPLEMENTACAO SALARIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL CIVIL - ART 40 - PARAGRAFO UNICO, DA LEI 8112/90 E O PARAGRAFO SEGUNDO, ART.15, DA LEI Nº 11.091, 12/01/2005. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.30','ADICIONAL - TETO PARLAMENTAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA AJUDA DE CUSTO CONCEDIDA AOS PARLAMENTARES NOS MESES DE FEVEREIRO, JUNHO E DEZEMBRO SOBRE A REMUNERACAO DOS SERVIDORES ATIVOS E INATIVOS DA CAMARA DOS DEPUTADOS E DO SENADO FEDERAL, AMPARADAS POR RESOLUCOES INTERNAS DESSAS CASAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.31','SUBSIDIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SUBSIDIOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.32','GRATIFICACAO P/EXERCICIO DE CARGO EM COMISSAO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS EM COMISSAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.33','VENCIM. E SAL.- PROR. SALARIO MATERNIDADE','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.98','INTEGRACAO DE DADOS ENT. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS FIXAS-PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','COMPREENDE O VALOR DAS APROPRIACOES DAS DESPESAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME PROPRIO, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO SERVIDOR E CUJO PAGAMENTO SO SE REALIZA EM CIRCUSTANCIAS ESPECIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.01','SUBSTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SUBSTITUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.02','ADICIONAL VARIAVEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL VARIAVEL SUJEITOS A INCIDENCIA DE TRIBUTOS E CONTRIBUICOES DE ACORDO COM A LEI 10.973/04 - DISTRIBUICAO DE ROYALTIES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.03','SERVICOS EXTRAORDINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO HORA EXTRA E OUTROS DE CARATER EVENTUAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.04','GRATIFICACAO POR EMBARQUE FLUVIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE GRATIFICACAO POR EMBARQUE FLUVIAL PAGA AOS CAPITAES, PILOTOS FLUVIAIS, SUPERVISORES MAQUINISTAS, TAIFEIROS FLUVIAIS, CONTRAMESTRES, CONDUTORES, COZINHEIROS E MARINHEIROS CONFORME TABELA DE GRATIFICACAO MENSAL POR EMBARQUE EM ANEXO A RESOLUCAO N 002/98 DO CONSELHO DE ADMINISTRACAO DA COMPANHIA DE NAVEGACAO DO SAO FRANCISCO - FRANAVE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.05','GRATIFICACAO ELEITORAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE GRATIFICACAO ELEITORAL PARA JUIZES E PROMOTORES DESIGNADOS PARA APRECIACAO DAS RECLAMACOES OU REPRESENTACOES DIRIGIDAS AOS TRIBUNAIS ELEITORAIS (LEI Nº 9504, DE 30/09/97). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.06','LICENCA SEM REMUNERACAO INCENTIVADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SERVIDORES QUE SOLICITARAM LICENCA SEM REMUNERACAO INCENTIVADA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.07','ADICIONAL POR PLANTAO HOSPITALAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL POR PLANTAO HOSPITALAR - APH DEVIDO AOS SERVIDORES EM EFETIVO EXERCICIO DE ATIVIDADES HOSPITALARES, DESEMPENHADAS EM REGIME DE PLANTAO, NAS AREAS INDISPENSAVEIS AO FUNCIONAMENTO ININTERRUPTO DOS HOSPITAIS CONSTANTES NO ARTIGO 298 DA LEI 12.155, DE 2009, QUE ALTERA A LEI 11.907, DE 02 DE FEVEREIRO DE 2009. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.08','CONVOCACAO EXTRAORDINARIA LEGISLATIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONVOCACOES EXTRAORDINARIAS DO CONGRESSO NACIONAL, CONFORME INCISO II, DO PARAGRAFO 6, DO ARTIGO 57, DA CONSTITUICAO FEDERAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.98','INTEGRACAO DADOS ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.02.99','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.1.1.03.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.0.00.00','REMUNERACAO A PESSOAL - RGPS','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RGPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO EMPREGO, INCLUSIVE OS OCUPANTES DE CARGOS EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO, NO SETOR PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.00.00','REMUNERACAO A PESSOAL - RGPS - EXTRA OFSS','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO CIVIL ABRANGIDOS PELO RGPS, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VENCIMENTOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO EMPREGO, INCLUSIVE OS OCUPANTES DE CARGOS EM COMISSAO NAO INVESTIDOS EM CARGO EFETIVO, NO SETOR PUBLICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.01','VENCIMENTOS E SALARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.02','ADICIONAL NOTURNO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACOES A EMPREGADOS EM ATIVIDADE NOTURNA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.03','INCORPORACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORACOES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.04','ABONO DE PERMANENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DO ABONO DE PERMANENCIA, DEVIDO AOS EMPREGADOS QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. (EMENDA CONSTITUCIONAL NR.41 DE 19/12/2003 E ORIENTACAO NORMATIVA DA SECRETARIA DE PREVIDENCIA SOCIAL NR.01 DE 06/01/2004). DE ACORDO COM A MEDIDA PROVISORIA 167, DE 19 DE FEVEREIRO DE 2004. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.05','ADICIONAL DE PERICULOSIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE EMPREGADOS QUE EXERCEM ATIVIDADES PERIGOSAS, CONFORME O § 1º , DO ARTIGO 193, DO DECRETO-LEI N.º 5.452, DE 1º DE MAIO DE 1943 (CLT).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.06','ADICIONAL DE INSALUBRIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE EMPREGADOS EM ATIVIDADE EM LOCAIS INSALUBRES, CONFORME ARTIGO 192, DO DECRETO-LEI N.º 5.452, DE 1º DE MAIO DE 1943 (CLT). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.07','REMUNERACAO PARTICIPANTES DE ORGAO DE DELIBERACAO COLETIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHO CONSULTIVO, CONSELHO DE ADMINISTRACAO, CONSELHO FISCAL OU OUTROS ORGAOS COLEGIADOS), OBSERVADO O DISPOSTO NA LEI N. 7733, DE 14/02/89. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.08','INCENTIVO A QUALIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM INCENTIVO A QUALIFICACAO DE EMPREGADOS QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELO EMPREGO/CARGO QUE OCUPAM, EM AREAS DE INTERESSE DO ORGAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.09','ADICIONAL DE TRANSFERENCIA - ART. 469/CLT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM FORAM TRANSFERIDOS CONFORME ART.469 DA CLT. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.10','RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE RETRIBUICAO ADICIONAL VARIAVEL E PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGOS TERCEIRO E QUINTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.11','REMUNERACAO DE DIRETORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE DIRETORES DE EMPRESAS PUBLICAS E DE ECONOMIA MISTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.12','VANTAGEM PECUNIARIA INDIVIDUAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.13','ABONO PROVISORIO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.14','GRATIFICACAO POR EXERCICIO DE CARGOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS, COMO DAS, GAJ, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.15','INDENIZACAO A ANISTIADO POLITICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE ANISTIADOS POLITICOS CONFORME A LEI 10.559/2002 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.16','GRATIFICACAO POR EXERCICIO DE FUNCOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE FUNCOES, DE COORDENACAO OU ENCARGO DE ATIVIDADES ESPECIFICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.17','INDENIZACAO DE LOCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE LOCALIZACAO ESPECIFICA DETERMINADA POR LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.18','GRATIFICACAO DE TEMPO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.19','GRATIFICACOES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICACAO ESPECIAL DE LOCALIZACAO, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.20','GRATIFICACAO POR ATIVIDADES EXPOSTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES, QUANDO PELO EXERCICIO, EXPOE O SERVIDOR A RISCOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.21','FERIAS VENCIDAS E PROPORCIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU DEMISSAO DO EMPREGADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.22','13. SALARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE NATAL (13 SALARIO) DO PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.23','FERIAS - ABONO PECUNIARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERACAO DEVIDA AO EMPREGADO NO PERIODO DE FERIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.24','FERIAS - ABONO CONSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS COMO REMUNERACAO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALARIO NORMAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.25','LICENCA-PREMIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.26','LICENCA CAPACITACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.27','ADIANTAMENTO PECUNIARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINACAO LEGAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.28','REPRESENTACAO MENSAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTACAO MENSAL, POR EXEMPLO DO "DAS" E ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.29','COMPLEMENTACAO SALARIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.98','INTEGRACAO PARCIAL DE DADOS ORGAOS ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS FIXAS-PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','COMPREENDE O VALOR DAS APROPRIACOES DAS DESPESAS COM OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL ABRANGIDOS PELO REGIME GERAL, RELACIONADAS AS ATIVIDADES DO CARGO OU FUNCAO DO EMPREGADO E CUJO PAGAMENTO SO SE REALIZA EM CIRCUSTANCIAS ESPECIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.01','SUBSTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SUBSTITUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.02','ADICIONAL VARIAVEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE ADICIONAL VARIAVEL SUJEITOS A INCIDENCIA DE TRIBUTOS E CONTRIBUICOES DE ACORDO COM A LEI 10.973/04 - DISTRIBUICAO DE ROYALTIES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.03','SERVICOS EXTRAORDINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO HORA EXTRA E OUTROS DE CARATER EVENTUAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.04','GRATIFICACAO POR EMBARQUE FLUVIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE GRATIFICACAO POR EMBARQUE FLUVIAL PAGA AOS CAPITAES, PILOTOS FLUVIAIS, SUPERVISORES MAQUINISTAS, TAIFEIROS FLUVIAIS, CONTRAMESTRES, CONDUTORES, COZINHEIROS E MARINHEIROS CONFORME TABELA DE GRATIFICACAO MENSAL POR EMBARQUE EM ANEXO A RESOLUCAO N 002/98 DO CONSELHO DE ADMINISTRACAO DA COMPANHIA DE NAVEGACAO DO SAO FRANCISCO - FRANAVE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.05','AVISO PREVIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AVISO PREVIO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.06','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE PARTICIPACAO A EMPREGADOS OU ADMINISTRADORES DE ACORDO COM O CONSTANTE DO ESTATUTO SOCIAL DA EMPRESA DISTRIBUIDORA. A PARTICIPACAO DOS EMPREGADOS NO LUCRO - PL, TEM RESPALDO NO QUE CONSTA DO INCISO VI DO ART. 187 DA LEI Nº 6.404/76. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.98','INTEGRACAO DADOS ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.02.99','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.03.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.00','CONTRATACAO POR TEMPO DETERMINADO','COMPREENDE O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONTRATACAO DE PESSOAL POR TEMPO DETERMINADO PARA ATENDER A NECESSIDADE TEMPORARIA DE EXCEPCIONAL INTERESSE PUBLICO, DE ACORDO COM LEGISLACAO ESPECIFICA DE CADA ENTE DA FEDERACAO, INCLUSIVE OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUAND0 FOR O CASO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.01','PROFESSORES SUBSTITUTOS/VISITANTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE PROFESSORES VISITANTES, SUBSTITUTOS OU PARTICIPANTES DE BANCA EXAMINADORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.02','SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXTERIOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.03','SERVICOS TEMPORARIOS DE AGENTES DE PESQUISA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE AGENTES DE PESQUISA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.04','SERVICOS TEMPORARIOS DE TECNICOS DA ANTT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL TECNICO DA AGENCIA NACIONAL DE TRANSPORTES TERRESTRES, PREVISTO NA LEI 10.233, DE 05/06/2001. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.05','SERVICOS TEMPORARIOS DE TECNICOS DA ANTAQ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL TECNICO DA AGENCIA NACIONAL DE TRANSPORTES AQUAVIARIOS, PREVISAO: LEI 10.233, DE 05/06/2001. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.06','SERVICOS TEMPORARIOS DE TECNICOS DA ANEEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL TECNICO DA ANEEL CONFORME PREVISAO LEGAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.07','SERVICOS TEMPORARIOS DE VIGILANCIA E INSPECAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL DE VIGILANCIA E INSPECAO CONFORME PREVISTO NA LEI 9849 DE 26/10/1999. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.08','SERVICOS TEMPORARIOS DE TECNICOS DA ANP','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL TECNICO DA AGENCIA NACIONAL DO PETROLEO, CONFORME DISPOSTO NA LEI 9.478/97 ARTIGO 76 PARAGRAFO UNICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.09','SERVICOS TEMPORARIOS ADMINISTRATIVO (CEASA)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL TECNICO NA AREA ADMINISTRATIVA, REFERENTE A PESSOAL DA LIQUIDANDA CEASA/AM, CONFORME DECRETO 3785, ART. 3, PARAGRAFO 4. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.10','SERVICOS TEMPORARIOS DE TECNICOS DA ANATEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS TEMPORARIOS DE PESSOAL TECNICO DA ANATEL CONFORME PREVISAO LEGAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.11','SERV.EVENTUAIS DE PESSOAL TECNICO LEI 8745/93','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE PESSOAL TECNICO POR TEMPO DETERMINADO PARA DESEMPENHO DE TECNICAS ESPECIALIZADAS EM AMBITO DE PROJETOS DE COOPERACAO, NOS TERMOS DA LEI 8745/93, COM AS ALTERACOES INTRODUZIDAS PELA LEI 10667/2003, ALINEA "H", ART 2, PARA OS CASOS DA CONTRATACAO REFERIR A CATEGORIAS FUNCIONAIS ABRANGIDAS PELO RESPECTIVO PLANO DE CARGOS DO QUADRO DE PESSOAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.12','SERVICOS EVENTUAIS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS EVENTUAIS DE ASSISTENCIA SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.13','SERV. EVENT. ENFERMAG. FISIOT. TERAPIA OCUPAC','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS EVENTUAIS DE ENFERMAGEM, FISIOTERAPIA E TERAPIA OCUPACIONAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.14','SERV. EVENT. SUS - DECRETO 5392/05.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS EVENTUAIS DE PESSOAL TECNICO NO SETOR HOSPITALAR, PREVISTO NO ART. 5 DO DEC. 3.592, DE 10 DE MARCO DE 2005, PARA OS CASOS DA CONTRATACAO SE REFERIR A CATEGORIAS FUNCIONAIS ABRIGADAS PELO RESPECTIVO PLANO DE CARGOS DO QUADRO DE PESSOAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.15','SERVICOS EVENTUAIS DE AGENTES DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE AGENTES DE SAUDE PARA COMBATER SURTOS ENDEMICOS, INCLUSIVE AS OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUANDO FOR O CASO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.16','SERVICOS EVENTUAIS DE NATUREZA INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS EVENTUAIS PARA ATENDER A AREA INDUSTRIAL OU ENCARGOS TEMPORARIOS DE OBRAS E SERVICOS DE ENGENHARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.17','SERVICOS EVENTUAIS DE AGENTES CENSITARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE AGENTES TEMPORARIOS PARA A EXECUCAO DE TRABALHOS RELACIONADOS A REALIZACAO DE RECENSEAMENTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.18','SERV.EVENT. DE PESSOAL QUALIFICADO-LEI8997/95','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE PESSOAL QUALIFICADO AO FUNCIONAMENTO DA ATIVIDADE EDUCACIONAL, NOS TERMOS DA LEI 8.997, DE 24 DE FEVEREIRO DE 1995, INCLUSIVE AS OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUANDO FOR O CASO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.19','SERVICOS EVENTUAIS DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS ESPECIAIS PARA ATENDER ENCARGOS TEMPORARIOS DE OBRAS E SERVICOS DE ENGENHARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.20',' SERVICOS EVENTUAIS DE MEDICOS RESIDENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE BOLSA DE ESTUDO A MEDICOS RESIDENTES, INCLUSIVE AS OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUANDO FOR O CASO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.21',' SERV. EVENTUAIS DE PESSOAL TECNICO-LEI9032/95','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE PESSOAL TECNICO NECESSARIO A REALIZACAO DO PROG. DE REVISAO DA CONCESSAO E DA MANUTENCAO DOS BENEFICIOS DA PREVIDENCIA SOCIAL, NOS TERMOS DA LEI 9.032/95, INCLUSIVE AS OBRIG. PATRONAIS E DESPESAS VARIAVEIS, QUANDO FOR O CASO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.22',' SERVICOS EVENTUAIS DE DENTISTAS E PSICOLOGOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE SERVICOS EVENTUAIS DE DENTISTAS E PSICOLOGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.23','SERVICOS EVENTUAIS DE MULTIPROFISSIONAIS - RESIDENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BOLSA DE ESTUDO A RESIDENTES MULTIPROFISSIONAIS EM SAUDE (BIOMEDICINA, CIENCIAS BIOLOGICAS, EDUCACAO FISICA, ENFERMAGEM, FARMACIA, FISIOTERAPIA, FONAUDIOLOGIA, MEDICINA VETERINARIA, NUTRICAO, ODONTOLOGIA, PSICOLOGIA, SERVICO SOCIAL E TERAPIA OCUPACIONAL), INCLUSIVE AS OBRIGACOES PATRONAIS E OUTRAS DESPESAS VARIAVEIS, QUANDO FOR O CASO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.24','ADICIONAL NOTURNO CONTRATO TEMPORARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO EM ATIVIDADE NOTURNA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.25','ADICIONAL DE PERICULOSIDADE CONT. TEMPORARIO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO QUE EXERCEM ATIVIDADES PERIGOSAS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.26','ADICIONAL DE INSALUBRIDADE CONT. TEMPORARIO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO QUE EXERCEM ATIVIDADES EM LOCAIS INSALUBRES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.27','ADICIONAL DE ATIVIDADES PENOSAS CONT. TEMP.','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO QUE EXERCEM ATIVIDADES PENOSAS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.28','ADICIONAL DE IRRADIACAO IONIZANTE CONT. TEMP.',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO TEMPORARIO QUE EXERCEM ATIVIDADES COM IRRADIACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.29','GRATIFICACAO DE RAIO-X CONTRATO TEMPORARIO','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO  TEMPORARIO QUE EXERCEM ATIVIDADES COM RAIO-X.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.30','SERVICOS EXTRAORDINARIOS CONTRATO TEMPORARIO','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRATACAO DE PESSOAL POR TEMPO DETERMINADO REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO: HORA EXTRA E OUTROS DE CARATER EVENTUAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.31','SERVICOS EXTRAORDINARIOS NOTURNO CONT. TEMP.',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO DE PESSOAL COM CONTRATO  TEMPORARIO EM ATIVIDADE NOTURNA REALIZADAS A TITULO DE SERVICOS EXTRAORDINARIOS, TAIS COMO: HORA EXTRA E OUTROS DE CARATER EVENTUAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.32','FERIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS DE PESSOAL CONTRATADO TEMPORARIAMENTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.33','13º SALARIO CONTRATO TEMPORARIO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13º SALARIO COM PESSOAL  CONTRATADO POR TEMPO DETERMINADO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.34','FERIAS - ABONO CONSTITUCIONAL',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONCESSAO DE ABONO PELO  PERIODO DE FERIAS ANUAIS-UM TERCO A MAIS DO QUE O SALARIO NORMAL-COM PESSOAL CONTRATADO POR TEMPO DETERMINADO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.35','FERIAS - PAGAMENTO ANTECIPADO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FERIAS PAGAS ANTECIPADAMENTE COM PESSOAL CONTRADADO POR TEMPO DETERMINADO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.2.1.04.99','OUTRAS VANTAGENS CONTRATOS TEMPORARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DE OUTRAS VANTAGENS DE PESSOAL DE CONTRATO TEMPORARIOS, TAIS COMO: GRATIFICACAO NATALINA, FERIAS, ADICIONAL NOTURNO, ADICIONAL INSALUBRIDADE, ADICIONAL DE PERICULOSIDADE, ADICIONAL PARA SERVICOS EXTRAORDINARIOS, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.0.00.00','REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.00.00','REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES - EXTRA OFSS','COMPREENDE A REMUNERACAO DO PESSOAL ATIVO MILITAR, CORRESPONDENTE AO SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SOLDOS E VANTAGENS PECUNIARIAS FIXAS E VARIAVEIS ESTABELECIDAS EM LEI DECORRENTES DO PAGAMENTO PELO EFETIVO EXERCICIO DO CARGO OU FUNCAO DE CONFIANCA NO SETOR PUBLICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR','COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL MILITAR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.01','SOLDO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS DOS MILITARES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.02','ADICIONAL DE PERMANENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE PERMANENCIA DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.03','ADICIONAL DE TEMPO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE TEMPO DE SERVICO DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.04','ADICIONAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL MILITAR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.05','ADICIONAL DE COMPENSACAO ORGANICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE COMPENSACAO ORGANICA DE MILITARES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.06','ADICIONAL DE HABILITACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL DE HABILITACAO DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.07','GRATIFICACAO DE LOCALIDADE ESPECIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE LOCALIDADE ESPECIAL DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.08','GRATIFICACAO DE REPRESENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE REPRESENTACAO DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.09','GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL (BASE LEGAL: LEI Nº 10.486/02, ART.3, INSICO VII) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.10','GRATIFICACAO DE SERVICO VOLUNTARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE SERVICO VOLUNTARIO (BASE LEGAL: LEI Nº 10.486/02, ART.3, INSICO VIII). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.11','VANTAGEM PECUNIARIA ESPECIAL - VPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VANTAGEM PECUNIARIA ESPECIAL - VPE (BASE LEGAL: LEI Nº 11.134/05, ART.1). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.12','INDENIZACAO DE REPRESENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM INDENIZACAO DE REPRESENTACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.13','GRATIFICACAO DE EXERCICIOS DE CARGOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE EXERCICIO DE CARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.14','FERIAS VENCIDAS E PROPORCIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS DEVIDAS A MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.15','ADICIONAL NATALINO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL NATALINO (13 SALARIO) DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.16','FERIAS - ABONO CONSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AO GOZO DE FERIAS ANUAIS REMUNERADAS PROVENIENTE DE UM TERCO DO SALARIO NORMAL - PAGO A MAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.17','COMPLEMENTACAO SALARIAL - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL MILITAR - LEI NR. 5.594/87. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.98','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.01.99','OUTRAS VPD FIXAS - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS FIXAS - PESSOAL MILITAR, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR','COMPREENDE AS DESPESAS ORCAMENTARIAS EVENTUAIS, DE NATUREZA REMUNERATORIA, DEVIDAS EM VIRTUDE DO EXERCICIO DA ATIVIDADE MILITAR, EXCETO AQUELAS CLASSIFICADAS EM ELEMENTO DE DESPESAS ESPECIFICOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.02.01','INDENIZACOES/MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM INDENIZACOES PAGAS AOS MILITARES DAS FORCAS ARMADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.02.02','ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS CONCEDIDAS A TITULO DE ADICIONAL AO MILITAR DA RESERVA REMUNERADA, E EXCEPCIONALMENTE O REFORMADO, QUE TENHA MODIFICADA SUA SITUACAO NA INATIVIDADE PARA AQUELA PREVISTA PARA A PRESTACAO DE TAREFA POR TEMPO CERTO CORRESPONDENTE A TRES DECIMOS DOS PROVENTOS QUE ESTIVER PERCEBENDO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.02.98','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.02.99','OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.1.3.1.03.00','SENTENCAS JUDICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SENTENCAS JUDICIAIS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.0.0.00.00','ENCARGOS PATRONAIS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES E EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA E AINDA OUTRAS CONTRIBUICOES PATRONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.0.00.00','ENCARGOS PATRONAIS - RPPS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.2.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.2.01.00','CONTRIBUICAO PATRONAL PARA O RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.2.02.00','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.2.06.00','CONTRIBUICAO PARA O PASEP S/ FOLHA PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PASEP, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.2.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.2.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.3.00.00','ENCARGOS PATRONAIS - RPPS - INTER OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS SERVIDORES PUBLICOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.3.01.00','CONTRIBUICAO PATRONAL PARA O RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.3.02.00','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.3.06.00','CONTRIBUICAO PARA O PASEP S/ FOLHA PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PASEP, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.3.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.1.3.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.0.00.00','ENCARGOS PATRONAIS - RGPS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDO EM CARGO EFETIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.00.00','ENCARGOS PATRONAIS - RGPS - EXTRA OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.01.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.02.00','CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.03.00','SEGURO DE ACIDENTE NO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.04.00','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.05.00','CONTRIB PREVID-INSS_PRORR.SAL.MATERNIDADE','  REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS_REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.06.00','CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.1.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.01.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.02.00','CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.03.00','SEGURO DE ACIDENTE NO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.04.00','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.06.00','CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.2.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS','COMPREENDE OS ENCARGOS TRABALHISTAS DE RESPONSABILIDADE DO EMPREGADOR, INCIDENTES SOBRE A FOLHA DE PAGAMENTO DOS EMPREGADOS ATIVOS, PERTENCENTES AOS ORGAOS E DEMAIS ENTIDADES DO SETOR PUBLICO, BEM COMO OCUPANTES DE CARGO EM COMISSAO NAO INVESTIDO EM CARGO EFETIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.01.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES QUE NAO PERTENCAM AOS ORCAMENTOS FISCAL E DA SEGURIDADE SOCIAL, RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS AO INSS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.02.00','CONTRIBUICOES PREVIDENCIARIAS NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS POR ORGAOS, FUNDOS OU ENTIDADES RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS REALIZADAS AOS AUXILIARES LOCAIS DOS POSTOS NO EXTERIOR. A LEI 7.501/1986, ALTERADA PELA LEI 8.745/1993, ESTABELECE, EM SEU ARTIGO 67, QUE AS RELACOES TRABALHISTAS E PREVIDENCIARIAS CONCERNENTES A ESSES AUXILIARES SERAO REGIDAS PELA LEGISLACAO VIGENTE NO PAIS EM QUE ESTIVER SEDIADA A REPARTICAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.03.00','SEGURO DE ACIDENTE NO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS RELATIVAS A CONTRIBUICOES PREVIDENCIARIAS DE SEGURO DE ACIDENTES DO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.04.00','ENCARGOS DE PESSOAL REQUISIT. DE OUTROS ENTES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.06.00','CONTRIBUICAO PARA O PIS S/ FOLHA PAGAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO PARA O PIS, DETERMINADA COM BASE NA FOLHA DE PAGAMENTO, A ALIQUOTA DE 1%, PELAS FUNDACOES PUBLICAS INSTITUIDAS OU MANTIDAS PELO PODER PUBLICO (MP 2.158-35/2001).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.2.3.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS OBRIGACOES PATRONAIS AO RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.3.0.00.00','ENCARGOS PATRONAIS - FGTS','COMPREENDE OS VALORES RECOLHIDOS MENSALMENTE PELOS EMPREGADORES, EM CONTA BANCARIA VINCULADA DO TRABALHADOR NO FGTS, CORRESPONDENTE A PERCENTUAL DEFINIDO EM LEI SOBRE A REMUNERACAO PAGA OU DEVIDA, NO MES ANTERIOR, A CADA TRABALHADOR, INCLUIDAS NA REMUNERACAO AS PARCELAS DE QUE TRATAM OS ARTS. 457 E 458 DA CLT E A GRATIFICACAO DE NATAL A QUE SE REFERE A LEI Nº 4.090, DE 13 DE JULHO DE 1962, COM AS MODIFICACOES DA LEI Nº 4.749, DE 12 DE AGOSTO DE 1965. ENTENDE-SE POR EMPREGADOR A PESSOA FISICA OU A PESSOA JURIDICA DE DIREITO PRIVADO OU DE DIREITO PUBLICO, DA ADMINISTRACAO PUBLICA DIRETA, INDIRETA OU FUNDACIONAL DE QUALQUER DOS PODERES, DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, QUE ADMITIR TRABALHADORES A SEU SERVICO, BEM ASSIM AQUELE QUE, REGIDO POR LEGISLACAO ESPECIAL, ENCONTRAR-SE NESSA CONDICAO OU FIGURAR COMO FORNECEDOR OU TOMADOR DE MAO-DE-OBRA, INDEPENDENTE DA RESPONSABILIDADE SOLIDARIA E/OU SUBSIDIARIA A QUE EVENTUALMENTE VENHA OBRIGAR-SE. CONSIDERA-SE TRABALHADOR TODA PESSOA FISICA QUE PRESTAR SERVICOS A EMPREGADOR, A LOCADOR OU TOMADOR DE MAO-DE-OBRA, EXCLUIDOS OS EVENTUAIS, OS AUTONOMOS E OS SERVIDORES PUBLICOS CIVIS E MILITARES SUJEITOS A REGIME JURIDICO PROPRIO. O RECOLHIMENTO DO FGTS E OBRIGATORIO TAMBEM NOS CASOS DE AFASTAMENTO PARA PRESTACAO DO SERVICO MILITAR OBRIGATORIO E LICENCA POR ACIDENTE DO TRABALHO. NAO SE INCLUEM NA REMUNERACAO, PARA OS FINS DESTA LEI, AS PARCELAS ELENCADAS NO § 9º DO ART. 28 DA LEI Nº 8.212, DE 24 DE JULHO DE 1991.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.3.1.00.00','ENCARGOS PATRONAIS - FGTS - EXTRA OFSS','COMPREENDE OS VALORES RECOLHIDOS MENSALMENTE PELOS EMPREGADORES, EM CONTA BANCARIA VINCULADA DO TRABALHADOR NO FGTS, CORRESPONDENTE A PERCENTUAL DEFINIDO EM LEI SOBRE A REMUNERACAO PAGA OU DEVIDA, NO MES ANTERIOR, A CADA TRABALHADOR, INCLUIDAS NA REMUNERACAO AS PARCELAS DE QUE TRATAM OS ARTS. 457 E 458 DA CLT E A GRATIFICACAO DE NATAL A QUE SE REFERE A LEI Nº 4.090, DE 13 DE JULHO DE 1962, COM AS MODIFICACOES DA LEI Nº 4.749, DE 12 DE AGOSTO DE 1965. ENTENDE-SE POR EMPREGADOR A PESSOA FISICA OU A PESSOA JURIDICA DE DIREITO PRIVADO OU DE DIREITO PUBLICO, DA ADMINISTRACAO PUBLICA DIRETA, INDIRETA OU FUNDACIONAL DE QUALQUER DOS PODERES, DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, QUE ADMITIR TRABALHADORES A SEU SERVICO, BEM ASSIM AQUELE QUE, REGIDO POR LEGISLACAO ESPECIAL, ENCONTRAR-SE NESSA CONDICAO OU FIGURAR COMO FORNECEDOR OU TOMADOR DE MAO-DE-OBRA, INDEPENDENTE DA RESPONSABILIDADE SOLIDARIA E/OU SUBSIDIARIA A QUE EVENTUALMENTE VENHA OBRIGAR-SE. CONSIDERA-SE TRABALHADOR TODA PESSOA FISICA QUE PRESTAR SERVICOS A EMPREGADOR, A LOCADOR OU TOMADOR DE MAO-DE-OBRA, EXCLUIDOS OS EVENTUAIS, OS AUTONOMOS E OS SERVIDORES PUBLICOS CIVIS E MILITARES SUJEITOS A REGIME JURIDICO PROPRIO. O RECOLHIMENTO DO FGTS E OBRIGATORIO TAMBEM NOS CASOS DE AFASTAMENTO PARA PRESTACAO DO SERVICO MILITAR OBRIGATORIO E LICENCA POR ACIDENTE DO TRABALHO. NAO SE INCLUEM NA REMUNERACAO, PARA OS FINS DESTA LEI, AS PARCELAS ELENCADAS NO § 9º DO ART. 28 DA LEI Nº 8.212, DE 24 DE JULHO DE 1991. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.3.1.01.00','FGTS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGACOES RELATIVAS AO RECOLHIMENTO DO FGTS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.3.1.02.00','FGTS - PDV','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FGTS DE SERVIDORES QUE OPTARAM PELO PLANO DE DEMISSAO VOLUNTARIA - PDV. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.3.1.03.00','FGTS-PRORROGACAO DO SALARIO MATERNIDADE',' REGISTRA OS VALORES DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OBRIGACOES RELATIVAS  AO RECOLHIMENTO DO FGTS REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.4.0.00.00','CONTRIBUICOES SOCIAIS GERAIS','COMPREENDE OS ENCARGOS PATRONAIS RELATIVAS AO SALARIO EDUCACAO E AS CONTRIBUICOES COMPULSORIAS DOS EMPREGADORES SOBRE A FOLHA DE SALARIOS, DESTINADOS AS ENTIDADES PRIVADAS DE SERVICO SOCIAL E DE FORMACAO PROFISSIONAL, VINCULADAS AO SISTEMA SINDICAL, TAIS COMO SESI, SENAI, SESC E SENAC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.4.1.00.00','CONTRIBUICOES SOCIAIS GERAIS - EXTRA OFSS','COMPREENDE OS ENCARGOS PATRONAIS RELATIVAS AO SALARIO EDUCACAO E AS CONTRIBUICOES COMPULSORIAS DOS EMPREGADORES SOBRE A FOLHA DE SALARIOS, DESTINADOS AS ENTIDADES PRIVADAS DE SERVICO SOCIAL E DE FORMACAO PROFISSIONAL, VINCULADAS AO SISTEMA SINDICAL, TAIS COMO SESI, SENAI, SESC E SENAC. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.4.1.01.00','SESI/SENAI ATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONTRIBUICOES PATRONAIS PARA O SESI/SENAI - ATIVO CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.4.1.02.00','CONTRIBUICAO DE SALARIO EDUCACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO DE SALARIO-EDUCACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.4.1.03.00','CONTRIB DE SALAR-EDUC PRORRO SALAR MATERN.','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE CONTRIBUICAO DE SALARIO-EDUCACAO REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.0.00.00','CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELACIONADAS AO REGIME DE PREVIDENCIA PRIVADA, DE CARATER COMPLEMENTAR, ORGANIZADO DE FORMA AUTONOMA EM RELACAO AO REGIME GERAL DE PREVIDENCIA SOCIAL, DE CARATER FACULTATIVO, BASEADO NA CONSTITUICAO DE RESERVAS QUE GARANTAM O BENEFICIO, NOS TERMOS DO CAPUT DO ART. 202 DA CONSTITUICAO FEDERAL. ENTENDE-SE POR ENTIDADES FECHADAS AQUELAS ACESSIVEIS, NA FORMA REGULAMENTADA PELO ORGAO REGULADOR E FISCALIZADOR, EXCLUSIVAMENTE AOS EMPREGADOS DE UMA EMPRESA OU GRUPO DE EMPRESAS E AOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, ENTES DENOMINADOS PATROCINADORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.00.00','CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA - EXTRA OFSS','COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELACIONADAS AO REGIME DE PREVIDENCIA PRIVADA, DE CARATER COMPLEMENTAR, ORGANIZADO DE FORMA AUTONOMA EM RELACAO AO REGIME GERAL DE PREVIDENCIA SOCIAL, DE CARATER FACULTATIVO, BASEADO NA CONSTITUICAO DE RESERVAS QUE GARANTAM O BENEFICIO, NOS TERMOS DO CAPUT DO ART. 202 DA CONSTITUICAO FEDERAL. ENTENDE-SE POR ENTIDADES FECHADAS AQUELAS ACESSIVEIS, NA FORMA REGULAMENTADA PELO ORGAO REGULADOR E FISCALIZADOR, EXCLUSIVAMENTE AOS EMPREGADOS DE UMA EMPRESA OU GRUPO DE EMPRESAS E AOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS, ENTES DENOMINADOS PATROCINADORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.01.00','COMPLEMENTACAO DE PREVIDENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS PARA ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.02.00','SEGUROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES A ENTIDADES DE PREVIDENCIA FECHADA, SOB A MODALIDADE DE SEGUROS, TAIS COMO: SEGURO DE VIDA-PAC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.03.00','CONT. PATRONAL PREVIDENCIA PRIVADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICAO PATRONAL, DEVIDA A ENTIDADES DE PREVIDENCIA PRIVADA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.04.00',' COMPLEM DE PREVID PRORROG SALARIO MATERNIDADE  ',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES DE RESPONSABILIDADE DAS ENTIDADES PATROCINADORAS P/ ATENDER PLANO DE PREVIDENCIA COMPLEMENTAR, ADMINISTRADO POR SUAS INSTITUICOES DE SEGURIDADE SOCIAL REFERENTE A PRORROGACAO DO SALARIO MATERNIDADE.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.5.1.99.00','OUTRAS CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES A ENTIDADES PRIVADAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES. E AS DE ORGAOS NAO INTEGRANTES OU PARCIALMENTE INTEGRANTES NO SIAFI, DECORRENTE DA INCORPORACAO DE SEUS BALANCETES AO SISTEMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.9.0.00.00','OUTROS ENCARGOS PATRONAIS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.9.1.00.00','OUTROS ENCARGOS PATRONAIS - EXTRA OFSS','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.9.2.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.2.9.3.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADOS AOS ENCARGOS PATRONAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.0.0.00.00','BENEFICIOS A PESSOAL','COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS DEVIDOS A PESSOAL CIVIL E MILITAR , TAIS COMO PARA O PESSOAL CIVIL: AJUDA-DE-CUSTO, INDENIZACAO DE TRANSPORTE, AUXILIO-MORADIA, AUXILIO-ALIMENTACAO,AUXILIO-TRANSPORTE BEM COMO OUTROS DECORRENTES DE ACORDO OU CONVENCAO COLETIVA NO QUE SE REFERE AOS EMPREGADOS PUBLICOS. PARA OS MILITARES: ADICIONAL DE COMPENSACAO ORGANICA NAO INCORPORADA, GRATIFICACAO DE LOCALIDADE ESPECIAL, GRATIFICACAO DE REPRESENTACAO, TRANSPORTE, AJUDA-DE-CUSTO, AUXILIO-FARDAMENTO, AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO AS DESPESAS COM VENCIMENTOS, SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS, BEM COMO AS DESPESAS RELACIONADAS AOS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.0.00.00','BENEFICIOS A PESSOAL - RPPS','COMPREENDE O VALOR TOTAL DAS V VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS A SERVIDOR PUBLICO, TAIS COMO: AJUDA-DE-CUSTO, INDENIZACAO DE TRANSPORTE, AUXILIO-MORADIA, AUXILIO-TRANSPORTE,AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.00.00','BENEFICIOS A PESSOAL - RPPS - EXTRA OFSS','COMPREENDE O VALOR TOTAL DAS V VARIACOES PATRIMONIAIS DIMINUTIVAS COM BENEFICIOS A SERVIDOR PUBLICO, TAIS COMO: AJUDA-DE-CUSTO, INDENIZACAO DE TRANSPORTE, AUXILIO-MORADIA, AUXILIO-TRANSPORTE,AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.01.00','AUXILIO ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXILIO ALIMENTACAO EM PECUNIA AO SERVIDOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.02.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS SERVIDORES, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE CARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.03.00','AUXILIO MORADIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO DE MORADIA AO SERVIDOR, NOS TERMOS DOS ARTIGOS 60-A A 60-E, DA LEI Nº 8.112/90. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.04.00','AJUDA DE CUSTO ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.05.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO SERVIDOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.06.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO A SERVIDOR PUBLICO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.1.1.99.00','OUTROS BENEFICIOS A PESSOAL - RPPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RPPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.0.00.00','BENEFICIOS A PESSOAL - RGPS','COMPREENDE O VALOR TOTAL DAS VARIACAO PATRIMONIAL DIMINUTIVA COM BENEFICIOS DEVIDOS AOS EMPREGADOS PUBLICOS, E AINDA OUTROS RELATIVOS A ACORDO OU CONVENCAO COLETIVA. ESTAO EXCLUIDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS , BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.00.00','BENEFICIOS A PESSOAL - RGPS - EXTRA OFSS','COMPREENDE O VALOR TOTAL DAS VARIACAO PATRIMONIAL DIMINUTIVA COM BENEFICIOS DEVIDOS AOS EMPREGADOS PUBLICOS, E AINDA OUTROS RELATIVOS A ACORDO OU CONVENCAO COLETIVA. ESTAO EXCLUIDAS DESTE GRUPO OS VENCIMENTOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS , BEM COMO OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. ESTAO EXCLUIDAS AINDA AS INDENIZACOES E RESTITUICOES TRABALHISTAS DECORRENTES DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, TAIS COMO FERIAS, AVISO PREVIO INDENIZADOS E OUTRAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.01.00','AUXILIO ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXILIO ALIMENTACAO EM PECUNIA AO EMPREGADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.02.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-TRANSPORTE PAGAS EM FORMA DE PECUNIA DIRETAMENTE AOS EMPREGADOS, DESTINADO AO CUSTEIO PARCIAL DAS DESPESAS REALIZADAS COM TRANSPORTE COLETIVO MUNICIPAL INTERMUNICIPAL OU INTERESTADUAL NOS DESLOCAMENTOS DE SUAS RESIDENCIAS PARA OS LOCAIS DE TRABALHO E VICE-VERSA, OU TRABALHO-TRABALHO NOS CASOS DE ACUMULACAO LICITA DE EMPREGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.03.00','AUXILIO MORADIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO DE MORADIA AO EMPREGADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.04.00','AJUDA DE CUSTO ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AJUDA DE CUSTO DE PESSOAL CIVIL - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.05.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO EMPREGADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.06.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO AO EMPREGADO, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.2.1.99.00','OUTROS BENEFICIOS A PESSOAL - RGPS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - RGPS, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.0.00.00','BENEFICIOS A PESSOAL - MILITAR','COMPREENDE O VALOR TOTAL DAS VARIACAO PATRIMONIAL DIMINUTIVA COM BENEFICIOS DEVIDOS A PESSOAL MILITAR, TAIS COMO: ADICIONAL DE COMPENSACAO ORGANICA NAO INCORPORADA, GRATIFICACAO DE LOCALIDADE ESPECIAL, GRATIFICACAO DE REPRESENTACAO, TRANSPORTE, AJUDA-DE-CUSTO, AUXILIO-FARDAMENTO, AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO AS OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.00.00','BENEFICIOS A PESSOAL - MILITAR - EXTRA OFSS','COMPREENDE O VALOR TOTAL DAS VARIACAO PATRIMONIAL DIMINUTIVA COM BENEFICIOS DEVIDOS A PESSOAL MILITAR, TAIS COMO: ADICIONAL DE COMPENSACAO ORGANICA NAO INCORPORADA, GRATIFICACAO DE LOCALIDADE ESPECIAL, GRATIFICACAO DE REPRESENTACAO, TRANSPORTE, AJUDA-DE-CUSTO, AUXILIO-FARDAMENTO, AUXILIO-ALIMENTACAO E OUTROS BENEFICIOS EVENTUAIS RELATIVOS AO LOCAL OU A NATUREZA DO TRABALHO. ESTAO EXCLUIDAS DESTE GRUPO OS SOLDOS E QUAISQUER OUTRAS VANTAGENS PECUNIARIAS PERMANENTES, BEM COMO AS OS BENEFICIOS PREVIDENCIARIOS OU ASSISTENCIAIS, TAIS COMO: APOSENTADORIA, AUXILIO-NATALIDADE, SALARIO-FAMILIA, LICENCA PARA TRATAMENTO DE SAUDE, LICENCA A GESTANTE, A ADOTANTE E LICENCA-PATERNIDADE, LICENCA POR ACIDENTE EM SERVICO, ASSISTENCIA A SAUDE, GARANTIA DE CONDICOES INDIVIDUAIS E AMBIENTAIS DE TRABALHO SATISFATORIAS, PENSAO VITALICIA E TEMPORARIA, AUXILIO-FUNERAL, AUXILIO-RECLUSAO, AUXILIO-INVALIDEZ, ASSISTENCIA A SAUDE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.01.00','ETAPA ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ETAPA DE ALIMENTACAO RELATIVA AO DIREITO REMUNERATORIO DOS MILITARES DAS FORCAS ARMADAS, CONFORME MP 2.215-10 DE 31/08/2001. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.02.00','AUXILIO TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM TRANSPORTE RELATIVO AO DIREITO REMUNERATORIO DOS MILITARES DAS FORCAS ARMADAS, CONFORME MP 2.215-10 DE 31/08/2001. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.03.00','AUXILIO MORADIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO DE MORADIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.04.00','AJUDA DE CUSTO ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AJUDA DE CUSTO RELATIVA AO DIREITO REMUNERATORIO DOS MILITARES DAS FORCAS ARMADAS, CONFORME MP 2.215-10 DE 31/08/2001. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.05.00','PLANO DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PLANO DE SAUDE AO MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.06.00','AUXILIO CRECHE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-CRECHE, DEVIDO AO MILITAR, DECORRENTE DE RESSARCIMENTO DE GASTOS COM A EDUCACAO PRE-ESCOLAR DE SEUS DEPENDENTES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.07.00','AUXILIO FARDAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM AUXILIO FARDAMENTO EM PECUNIA AO MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.08.00','AUXILIO FAMILIAR - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-FAMILIAR, PREVISTO NO DECRETO Nº 71.733, DE 18 DE JANEIRO DE 1973.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.3.3.1.99.00','OUTROS BENEFICIOS A PESSOAL - MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTROS BENEFICIOS A PESSOAL - MILITAR, NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.0.0.00.00','CUSTO DE PESSOAL E ENCARGOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA A PESSOAL E ENCARGOS UTILIZADOS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.01.00','CMV - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.02.00','CMV - REMUNERACAO A PESSOAL -RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.03.00','CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.04.00','CMV - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.05.00','CMV - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.06.00','CMV - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.07.00','CMV - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.08.00','CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.09.00','CMV - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.10.00','CMV - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.11.00','CMV - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.12.00','CMV - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.13.00','CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.1.14.00','CMV - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.01.00','CMV - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.02.00','CMV - REMUNERACAO A PESSOAL -RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.03.00','CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.04.00','CMV - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.05.00','CMV - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.06.00','CMV - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.07.00','CMV - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.08.00','CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.09.00','CMV - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.10.00','CMV - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.11.00','CMV - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.12.00','CMV - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.13.00','CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.2.14.00','CMV - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.00.00','CUSTO DE MERCADORIAS VENDIDAS - PESSOAL E ENCARGOS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.01.00','CMV - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.02.00','CMV - REMUNERACAO A PESSOAL -RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.03.00','CMV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.04.00','CMV - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.05.00','CMV - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.06.00','CMV - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.07.00','CMV - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.08.00','CMV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.09.00','CMV - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.10.00','CMV - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.11.00','CMV - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.12.00','CMV - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.13.00','CMV - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.1.3.14.00','CMV - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DAS MERCADORIAS VENDIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.01.00','CPV - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.02.00','CPV - REMUNERACAO A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.03.00','CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.04.00','CPV - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.05.00','CPV - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.06.00','CPV - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.07.00','CPV - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.08.00','CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.09.00','CPV - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.10.00','CPV - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.11.00','CPV - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.12.00','CPV - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.13.00','CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.1.14.00','CPV - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.01.00','CPV - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.02.00','CPV - REMUNERACAO A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.03.00','CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.04.00','CPV - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.05.00','CPV - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.06.00','CPV - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.07.00','CPV - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.08.00','CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.09.00','CPV - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.10.00','CPV - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.11.00','CPV - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.12.00','CPV - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.13.00','CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.2.14.00','CPV - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.00.00','CUSTO DE PRODUTOS VENDIDOS - PESSOAL E ENCARGOS - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.01.00','CPV - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.02.00','CPV - REMUNERACAO A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.03.00','CPV - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.04.00','CPV - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.05.00','CPV - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.06.00','CPV - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.07.00','CPV - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.08.00','CPV - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.09.00','CPV - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.10.00','CPV - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.11.00','CPV - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.12.00','CPV - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.13.00','CPV - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.2.3.14.00','CPV - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DOS PRODUTOS VENDIDOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.0.00.00','CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.00.00','CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.01.00','CSP - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.02.00','CSP - REMUNERACAO A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.03.00','CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.04.00','CSP - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.05.00','CSP - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.06.00','CSP - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.07.00','CSP - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.08.00','CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.09.00','CSP - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.10.00','CSP - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.11.00','CSP - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.12.00','CSP - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.13.00','CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.1.14.00','CSP - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.00.00','CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.01.00','CSP - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.02.00','CSP - REMUNERACAO A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.03.00','CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.04.00','CSP - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.05.00','CSP - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.06.00','CSP - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.07.00','CSP - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.08.00','CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.09.00','CSP - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.10.00','CSP - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.11.00','CSP - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.12.00','CSP - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.13.00','CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.2.14.00','CSP - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.00.00','CUSTO DE SERVICOS PRESTADOS - PESSOAL E ENCARGOS - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A PESSOAL E ENCARGOS UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.01.00','CSP - REMUNERACAO A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.02.00','CSP - REMUNERACAO A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.03.00','CSP - REMUNERACAO A PESSOAL - REGIME PROPRIO DOS MILITARES','REGISTRA A APROPRIACAO DE REMUNERACAO A PESSOAL ABRANGIDOS PELO REGIME PROPRIO DOS MILITARES NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.04.00','CSP - ENCARGOS PATRONAIS - RPPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.05.00','CSP - ENCARGOS PATRONAIS - RGPS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.06.00','CSP - ENCARGOS PATRONAIS - FGTS','REGISTRA A APROPRIACAO DE ENCARGOS PATRONAIS - FGTS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.07.00','CSP - CONTRIBUICOES SOCIAIS GERAIS','REGISTRA A APROPRIACAO DE CONTRIBUICOES SOCIAIS GERAIS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.08.00','CSP - CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA','REGISTRA A APROPRIACAO DE CONTRIBUICOES A ENTIDADES FECHADAS DE PREVIDENCIA NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.09.00','CSP - OUTROS ENCARGOS PATRONAIS','REGISTRA A APROPRIACAO DE OUTROS ENCARGOS PATRONAIS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.10.00','CSP - BENEFICIOS A PESSOAL - RPPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RPPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.11.00','CSP - BENEFICIOS A PESSOAL - RGPS','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - RGPS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.12.00','CSP - BENEFICIOS A PESSOAL - MILITAR','REGISTRA A APROPRIACAO DE BENEFICIOS A PESSOAL - MILITAR NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.13.00','CSP - INDENIZACOES E RESTITUICOES TRABALHISTAS','REGISTRA A APROPRIACAO DE INDENIZACOES E RESTITUICOES TRABALHISTAS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.8.3.3.14.00','CSP - OUTRAS VPD DE PESSOAL E ENCARGOS','REGISTRA A APROPRIACAO DE OUTRAS VPD DE PESSOAL E ENCARGOS NO CUSTO DE SERVICOS PRESTADOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.0.0.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES, TAIS COMO AS INDENIZACOES E RESTITUICOES TRABALHISTAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.0.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS','COMPREENDE O VALOR TOTAL COM VARIACOES PATRIMONIAIS DIMINUTIVAS RESULTANTE DO PAGAMENTO EFETUADO A SERVIDORES PUBLICOS CIVIS E EMPREGADOS DE ENTIDADES INTEGRANTES DA ADMINISTRACAO PUBLICA, INCLUSIVE FERIAS E AVISO PREVIO INDENIZADOS, MULTAS E CONTRIBUICOES INCIDENTES SOBRE OS DEPOSITOS DO FUNDO DE GARANTIA POR TEMPO DE SERVICO, ETC, EM FUNCAO DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, PODENDO SER EM DECORRENCIA DA PARTICIPACAO EM PROGRAMA DE DESLIGAMENTO VOLUNTARIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - EXTRA OFSS','COMPREENDE O VALOR TOTAL COM VARIACOES PATRIMONIAIS DIMINUTIVAS RESULTANTE DO PAGAMENTO EFETUADO A SERVIDORES PUBLICOS CIVIS E EMPREGADOS DE ENTIDADES INTEGRANTES DA ADMINISTRACAO PUBLICA, INCLUSIVE FERIAS E AVISO PREVIO INDENIZADOS, MULTAS E CONTRIBUICOES INCIDENTES SOBRE OS DEPOSITOS DO FUNDO DE GARANTIA POR TEMPO DE SERVICO, ETC, EM FUNCAO DA PERDA DA CONDICAO DE SERVIDOR OU EMPREGADO, PODENDO SER EM DECORRENCIA DA PARTICIPACAO EM PROGRAMA DE DESLIGAMENTO VOLUNTARIO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.01.00','INDENIZACOES E RESTITUICOES TRAB. ATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL ATIVO CIVIL, INCLUSIVE AS DESPESAS COM PROGRAMA DE DESLIGAMENTO VOLUNTARIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.02.00','INDENIZACOES E RESTITUICOES TRAB. ATIVO MIL.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZACOES E RESTITUCOES TRABALHISTAS DO PESSOAL ATIVO MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.03.00','INDENIZACOES E RESTITUICOES TRAB. INAT. CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL INATIVO CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.04.00','INDENIZACOES E RESTITUICOES TRAB. INAT. MIL.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL INATIVO MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.05.00','INDENIZACOES E RESTITUICOES TRAB.-PENS. MIL.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL PENSIONISTA MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.06.00','INDENIZACOES E RESTITUICOES TRAB.-PENS. CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESDE DESPESAS REFERENTE A INDENIZACOES E RESTITUICOES TRABALHISTAS DO PESSOAL PENSIONISTA CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.07.00',' INDENIZACAO § 2º ART.12 LEI 8.745/93  ','  REGISTRA AS DESPESAS COM INDENIZACAO REFERENTE A EXTINCAO DE CONTRATO,POR INICIATIVA DO ORGAO OU ENTIDADE CONTRATANTE, DE PESSOAL TECNICO  CONTRATADO POR TEMPO DETERMINADO NOS TERMOS DA LEI 8.745/93. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.1.1.99.00','DIVERSAS INDENIZACOES TRABALHISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE INDENIZACOES TRABALHISTA QUE NAO SE PROCESSARAM NA EPOCA PROPRIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.0.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.1.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.1.01.00','AUXILIO A PARTICIPANTES DE CURSO DE FORMACAO',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONCESSAO DE AUXILIO FINANCEIRO A CANDIDATOS PARTICIPANTES DE CURSO DE FORMACAO PARA O EXERCICIO DE  CARGO DECORRENTE DE CONCURSO PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.1.02.00','AUXILIO DE AVALIACAO EDUCACIONAL - AAE',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM A CONCESSAO DO AUXILIO DE AVALIACAO EDUCACIONAL - AAE, DEVIDO AO SERVIDOR QUE, EM DECORRENCIA DO EXERCICIO DA DOCENCIA OU PESQUISA NO ENSINO SUPERIOR PUBLICO OU PRIVADO, PARTICIPE, EM CARATER EVENTUAL, DE PROCESSO DE AVALIACAO EDUCACIONAL DE INSTITUICOES, CURSOS, PROJETOS OU DESEMPENHO DE ESTUDANTES REALIZADO POR INICIATIVA DO INSTITUTO NACIONAL DE PESQUISAS EDUCACIONAIS ANISIO TEXEIRA - INEP OU DA FUNDACAO COORDENACAO DE APERFEICOAMENTO DE PESSOAL DE NIVEL SUPERIOR - CAPES. (ART.1º DA LEI N 11.507, DE 20 DE JULHO/07). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.1.03.00','BOLSA-FORMACAO PRONASCI - MP 416/2008',' REGISTRA O VALOR DOS RECURSOS DESTINADOS AA QUALIFICACAO PROFISSIONAL DOS INTEGRANTES DAS POLICIAS MILITAR E CIVIL, DO CORPO DE BOMBEIROS, DOS AGENTES PENITENCIARIOS, DOS AGENTES CARCERARIOS E DOS PERITOS, NO AMBITO DO PROGRAMA NACIONAL DE SEGURANCA PUBLICA COM CIDADANIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.2.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.1.9.9.3.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM PESSOAL E ENCARGOS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.0.0.0.00.00','BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','COMPREENDEM AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AS APOSENTADORIAS, PENSOES, REFORMAS, RESERVA REMUNERADA E OUTROS BENEFICIOS PREVIDENCIARIOS DE CARATER CONTRIBUTIVO,DO REGIME PROPRIO DA PREVIDENCIA SOCIAL - RPPS E DO REGIME GERAL DA PREVIDENCIA SOCIAL - RGPS, BEM COMO AS ACOES DE ASSISTENCIA SOCIAL, QUE SAO POLITICAS DE SEGURIDADE SOCIAL NAO CONTRIBUTIVA, VISANDO AO ENFRENTAMENTO DA POBREZA, A GARANTIA DOS MINIMOS SOCIAIS, AO PROVIMENTO DE CONDICOES PARA ATENDER CONTINGENCIAS SOCIAIS E A UNIVERSALIZACAO DOS DIREITOS SOCIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.0.0.00.00','APOSENTADORIAS E REFORMAS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.0.00.00','APOSENTADORIAS - RPPS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RPPS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.00.00','APOSENTADORIAS - RPPS - EXTRA OFSS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RPPS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.01.00','PROVENTOS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS DE APOSENTADORIAS PESSOAL CIVIL REGIDOS PELO RPPS APROVADA PELO TRIBUNAL DE CONTAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.03.00','APOSENTADORIAS PENDENTES DE APROVACAO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM APOSENTADORIAS DE PESSOAL CIVIL CONCEDIDAS, MAS QUE SE ENCONTRAM EM FASE DE TRAMITACAO PARA APROVACAO PELO TRIBUNAL DE CONTAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.04.00','PROVENTOS ORIG. DE INCENTIVO/ADIC.A QUALIFICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM. BASE LEGAL: LEI Nº 11.416/2006, BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.05.00','VANTAGEM PESSOAL - LEI 8.216/91','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES RELATIVOS A VANTAGENS PESSOAIS CONCEDIDAS AOS APOSENTADOS CIVIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.06.00','13 SALARIO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - RPPS (APOSENTADORIAS JA APROVADAS PELO TCU). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.07.00','GRATIFICACAO TEMPO DE SERVICO - ANUENIO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM O PAGAMENTO DA GRATIFICACAO DE TEMPO DE SERVICO (ANUENIO) DE SERVIDORES CIVIS - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.08.00','LICENCA PREMIO PARA INATIVO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PAGAMENTO DE LICENCA PREMIO PARA INATIVOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.09.00','PRO-LABORE (LEI 7711/88 ARTIGO 3)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGO TERCEIRO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.10.00','VANTAGENS INCORPORADAS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VANTAGENS INCORPORADAS DE PESSOAL CIVIL, INCLUSIVE A VANTAGEM PECUNIARIA INDIVIDUAL, INSTITUIDA PELA LEI 10698, DE 2/7/2003. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.11.00','PROVENTOS ORIGINARIAS DE GRAT.P/EXERC/FUNCOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS ORIGINARIOS DE GRATIFICACOES POR EXERCICIO DE FUNCOES E CARGOS COMISSIONADOS, BEM COMO DA OPCAO PREVISTA EM LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.12.00','PROVENTOS ORIGINARIAS DE GRAT.P/EXERC. CARGO.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS ORIGINARIOS DE GRATIFICACOES POR EXERCICIO DE CARGOS, TAIS COMO GAJ, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.13.00','INCREMENTO PLANO DE CARGOS E SALARIOS JUDIC.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A DIFERENCA DE REMUNERACAO DOS CARGOS RESULTANTES DA TRANSFORMACAO SOBRE A DOS TRANSFORMADOS PELO PLANO DE CARGOS E SALARIOS DO PODER JUDICIARIO, CONFORME DISPOSTO NO PARAGRAFO 2°, DO ART. 4°, DA LEI 9421/96. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.14.00','GRATIFICACAO DE ATIVIDADES EXTERNAS - GAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DO EXERCICIO DE ATIVIDADES EXTERNAS, A EXEMPLO DA ATIVIDADE EXERCIDA POR OFICIAIS DE JUSTICA, CONFORME ESTABELECIDO NO ART.16, DA LEI Nº 11.416/06 E ARTIGO 4°, DA PROTARIA STF N° 01, DE 07 DE MARCO DE 2007.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.15.00','GRATIFICACOES ESPECIAIS A APOSENTADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL - RPPS (APOSENTADO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.16.00','COMPLEMENTACAO DE APOSENTADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES PERTINENTES AS DESPESAS COM COMPLEMENTACAO DE APOSENTADORIAS DEVIDAS AO PESSOAL CIVIL INATIVOS - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.17.00','APOSENTADORIAS ORIGINARIAS DE SUBSIDIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM APOSENTADORIAS ORIGINARIAS DE SUBSIDIOS, APROVADAS OU PENDENTES DE APROVACAO PELO TRIBUNAL DE CONTAS DA UNIAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.18.00','ADICIONAL TETO PARLAMENTAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA AJUDA DE CUSTO CONCEDIDA AOS PARLAMENTARES NOS MESES DE FEVEREIRO, JUNHO E DEZEMBRO SOBRE A REMUNERACAO DOS SERVIDORES ATIVOS E INATIVOS DA CAMARA DOS DEPUTADOS E DO SENADO FEDERAL, AMPARADAS POR RESOLUCOES INTERNAS DESSAS CASAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.19.00','FERIAS VENCIDAS E PROPORCIONAIS APOSENTADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS A APOSENTADOS.(CASO NAO RECEBIDO NO ATO DA APOSENTADORIA SEGUNDO ACORDAO TCU 1646/2003). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.1.1.99.00','OUTRAS APOSENTADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU VALORES RELATIVOS A INTEGRACAO DE BALANCENTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.0.00.00','APOSENTADORIAS - RGPS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RGPS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.00.00','APOSENTADORIAS - RGPS - EXTRA OFSS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA ASSEGURADOS PELA PREVIDENCIA SOCIAL COM O OBJETIVO DE GARANTIR MEIOS INDISPENSAVEIS DE MANUTENCAO, POR MOTIVO DE INCAPACIDADE, IDADE AVANCADA E TEMPO DE SERVICO, ABRANGIDAS PELO RGPS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.01.00','APOSENTADORIA POR INVALIDEZ','REGISTRA AS DESPESAS COM APOSENTADORIAS POR INVALIDEZ, DEVIDAS AOS SEGURADOS CONSIDERADOS INCAPAZES PARA EXERCER SUAS ATIVIDADES PROFISSIONAIS E INSUSCEPTIVEIS DE REABILITACAO PARA OUTRAS ATIVIDADES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.02.00','APOSENTADORIA POR VELHICE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS POR VELHICE, DEVIDAS AOS SEGURADOS QUE TENHAM COMPLETADO A IDADE PREVISTA EM LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.03.00','APOSENTADORIA POR TEMPO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS POR TEMPO DE SERVICO, DEVIDAS AOS SEGURADOS QUE TENHAM COMPLETADO O TEMPO PREVISTO EM LEI, DE ACORDO COM A SUA CATEGORIA PROFISSIONAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.04.00','APOSENTADORIA ESPECIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIA ESPECIAL, DEVIDA AO SEGURADO QUE TENHA COMPLETADO O TEMPO PREVISTO EM LEI E QUE TRABALHOU EM SERVICOS CONSIDERADOS PENOSOS, INSALUBRES OU PERIGOSOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.05.00','APOSENTADORIA - ECONOMIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS DE ECONOMIARIOS, DEVIDAS AOS SEGURADOS SUJEITOS AO REGIME DO ANTIGO SASSE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.06.00','APOSENTADORIA POR INVALIDEZ - ACIDENTE DE TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM APOSENTADORIAS POR INVALIDEZ, DECORRENTES DE ACIDENTES DE TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.07.00','ABONO PROVISORIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.08.00','APOSENTADORIAS PENDENTES DE APROVACAO - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM APOSENTADORIAS CONCEDIDAS DE PESSOAL CIVIL REGIDOS PELO RGPS, MAS QUE SE ENCONTRAM EM FASE DE TRAMITACAO PARA APROVACAO PELO TRIBUNAL DE CONTAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.09.00','PROVENTOS ORIG. DE INCENTIVO/ADIC.A QUALIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVO A QUALIFICACAO DE EMPREGADOS QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM. BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.10.00','13 SALARIO ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - RGPS (APOSENTADORIAS JA APROVADAS PELO TCU). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.11.00','GRATIFICACAO TEMPO DE SERVICO - ANUENIO CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM O PAGAMENTO DA GRATIFICACAO DE TEMPO DE SERVICO (ANUENIO) DE SERVIDORES CIVIS - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.12.00','GRATIFICACOES ESPECIAIS A APOSENTADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL - RGPS (APOSENTADO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.13.00','COMPLEMENTACAO DE APOSENTADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES PERTINENTES AS DESPESAS COM COMPLEMENTACAO DE APOSENTADORIAS DEVIDAS AO PESSOAL CIVIL INATIVOS - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.14.00','FERIAS VENCIDAS E PROPORCIONAIS APOSENTADOS','REGISTRA AS DESPESAS COM APOSENTADORIAS POR INVALIDEZ, DEVIDAS AOS SEGURADOS CONSIDERADOS INCAPAZES PARA EXERCER SUAS ATIVIDADES PROFISSIONAIS E INSUSCEPTIVEIS DE REABILITACAO PARA OUTRAS ATIVIDADES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.15.00','INDENIZACAO A ANISTIADO POLITICO','REGISTRA O VALOR DAS DESPESAS REALIZADAS A TITULO DE REPARACAO ECONOMICA, DE CARATER INDENIZATORIO, CONFORME ESTABELECEM O ART.8º DO ATO DAS DISPOSICOES CONSTITUCIONAIS TRANSITORIAS E AS LEIS QUE A REGULAMENTAM (LEIS 10559/2002 E 11354/2006). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.2.1.99.00','OUTRAS APOSENTADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS APOSENTADORIAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU VALORES RELATIVOS A INTEGRACAO DE BALANCENTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.0.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESERVA REMUNERADA E REFORMAS DOS MILITARES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESERVA REMUNERADA E REFORMAS DOS MILITARES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.01.00','PROVENTOS - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PROVENTOS DE PESSOAL MILITAR.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.02.00','GRATIFICACAO TEMPO DE SERVICO-ANUENIO MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM O PAGAMENTO DA GRATIFICACAO DE TEMPO DE SERVICO (ANUENIO) DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.03.00','COMPENSACAO PECUNIARIA (LEI 7.963/89)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM COMPENSACOES PECUNIARIAS DEVIDAS EM VIRTUDE DE NORMATIVO LEGAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.04.00','AJUDA DE CUSTO (TRANSF. P/ RESERVA REM.)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AJUDA DE CUSTO DEVIDAS A PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.05.00','ADICIONAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ADICIONAL MILITAR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.06.00','COMPL. APOSENTADORIA - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM COMPLEMENTACAO DE APOSENTADORIA DE PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.07.00','VANTAGENS INCORPORADAS - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VANTAGENS INCORPORADAS DE PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.08.00','AUXILIO-INVALIDEZ - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM AUXILIO-INVALIDEZ DO PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.09.00','13 SALARIO - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.10.00','VANTAGEM PECUNIARIA ESPECIAL - VPE','REGISTRA O VALOR DAS DESPESAS REALIZADAS COM VANTAGEM PECUNIARIA ESPECIAL - VPE (BASE LEGAL: LEI N 11.134/05, ART. 1° - PARA INATIVOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.3.1.99.00','OUTRAS REFORMAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS REFORMAS NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.9.0.00.00','OUTRAS APOSENTADORIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS APOSENTADORIAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.1.9.1.00.00','OUTRAS APOSENTADORIAS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS APOSENTADORIAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.0.0.00.00','PENSOES','COMPREENDEM OS BENEFICIOS DA PREVIDENCIA SOCIAL QUE GARANTE UMA RENDA AOS DEPENDENTES DO SEGURADO FALECIDO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.0.00.00','PENSOES - RPPS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL -RPPS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.00.00','PENSOES - RPPS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, PELO REGIME PROPRIO DA PREVIDENCIA SOCIAL -RPPS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.01.00','PENSOES CIVIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE PESSOAL CIVIL - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.02.00','13 SALARIO - PESSOAL CIVIL - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR - PENSIONISTAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.03.00','PENSOES ESPECIAIS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS EM FUNCAO DE LEIS ESPECIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.04.00','LICENCA-PREMIO PARA PENSIONISTA CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCAO-PREMIO PARA PENSIONISTA CIVIL - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.05.00','PENSOES ORIG. DE INCENTIVO/ADIC.A QUALIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE PENSOES COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM BASE LEGAL: LEI Nº 11.416/2006, BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.06.00','PENSOES ORIGINARIAS DE GRATIF.P/EXERC. FUNCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE GRATIFICACAO POR EXERCICIO DE FUNCOES E CARGOS COMISSIONADOS, BEM COMO DA OPCAO PREVISTA EM LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.07.00','PENSOES ORIGINARIAS DE GRATIF.P/EXERC.DE CARG','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE GRATIFICACAO POR EXERCICIO DE CARGOS, TAIS COMO GAJ, ETC ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.08.00','VANTAGENS INCORPORADAS - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL (INCLUSIVE DA LEI 10698, DE 02/07/03). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.09.00','ABONO PROVISORIO - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO ABONO PROVISORIO PARA PENSIONISTAS - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.10.00','INCREMENTO PLANO DE CARGOS E SALARIOS JUDIC.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A DIFERENCA DE REMUNERACAO DOS CARGOS RESULTANTES DA TRANSFORMACAO SOBRE A DOS TRANSFORMADOS PELO PLANO DE CARGOS E SALARIOS DO PODER JUDICIARIO, CONFORME DISPOSTO NO PARAGRAFO 2°, DO ARTIGO 4°, DA LEI 9421/96. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.11.00','GRATIFICACAO DE ATIVIDADES EXTERNAS - GAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DO EXERCICIO DE ATIVIDADES EXTERNAS, A EXEMPLO DA ATIVIDADE EXERCIDA POR OFICIAIS DE JUSTICA, CONFORME ESTABELECIDO NO ARTIGO 16, DA LEI Nº 11.416/06 E ARTIGO 4°, DA PROTARIA STF N° 01, DE 07 DE MARCO DE 2007.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.12.00','GRATIFICACOES ESPECIAIS A PENSIONISTA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL (PENSONISTAS) - RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.13.00','COMPLEMENTACAO DE PENSOES - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE COMPLEMENTACAO DE PENSOES DE PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.14.00','PENSOES ORIGINARIAS DE SUBSIDIOS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE SUBSIDIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.15.00','ADICIONAL TETO PARLAMENTAR','REGISTRA AS DESPESAS DECORRENTES DA AJUDA DE CUSTO CONCEDIDA AOS PARLAMENTARES NOS MESES DE FEVEREIRO, JUNHO E DEZEMBRO SOBRE A REMUNERACAO DOS SERVIDORES ATIVOS E INATIVOS DA CAMARA DOS DEPUTADOS E DO SENADO FEDERAL, AMPARADAS POR RESOLUCOES INTERNAS DESSAS CASAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.1.1.99.00','OUTRAS PENSOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS PENSOES NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.0.00.00','PENSOES - RGPS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL -RGPS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.00.00','PENSOES - RGPS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AO DEPENDENTES DOS SEGURADOS, APOS SEU OBITO, REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL -RGPS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.01.00','PENSOES CIVIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM PENSOES ORIGINARIAS DE PESSOAL CIVIL - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.02.00','13 SALARIO - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL CIVIL - PENSIONISTAS - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.03.00','PENSOES ESPECIAIS - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS EM FUNCAO DE LEIS ESPECIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.04.00','PENSOES ORIG. DE INCENTIVO/ADIC.A QUALIFICACAO','DESTINADA AO REGISTRO DAS PENSOES COM INCENTIVO A QUALIFICACAO DE SERVIDORES QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELOS CARGOS QUE OCUPAM. BASE LEGAL: LEI Nº 11.416/2006, BEM COMO CONHECIMENTOS ADICIONAIS ADQUIRIDOS EM AREA DE INTERESSE DE OUTROS ORGAOS, A SEREM ESTABELECIDOS EM REGULAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.05.00','VANTAGENS INCORPORADAS - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.06.00','ABONO PROVISORIO - PENSIONISTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO ABONO PROVISORIO PARA PENSIONISTAS - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.07.00','GRATIFICACOES ESPECIAIS A PENSIONISTA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL (PENSONISTAS) - RGPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.08.00','COMPLEMENTACAO DE PENSOES - PESSOAL CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DOS VALORES RELATIVOS AS COMPLEMENTACOES DE PENSOES PAGAS A PENSIONISTAS DE EMPREGADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.09.00','PENSOES A ANISTIADOS POLITICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS A ANISTIADOS POLITICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.10.00','INDENIZACAO A ANISTIADO POLITICO','REGISTRA O VALOR DAS DESPESAS REALIZADAS A TITULO DE REPARACAO ECONOMICA, DE CARATER INDENIZATORIO, CONFORME ESTABELECEM O ART.8º DO ATODAS DISPOSICOES CONSTITUCIONAIS TRANSITORIAS E AS LEIS QUE A REGULAMENTAM (LEIS 10559/2002 E 11354/2006). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.11.00','PENSOES INDENIZATORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS A ANISTIADOS POLITICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.12.00','PENSOES ACIDENTARIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES, DEVIDAS AOS DEPENDENTES, POR MORTE DO SEGURADO, QUANDO A APOSENTADORIA OU MORTE FOR DECORRENTE DE ACIDENTE DE TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.13.00','PENSOES VITALICIAS DA SINDROME DA TALIDOMIDA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES VITALICIAS, DEVIDAS AOS DEPENDENTES DE SEGURADOS, POR MORTE DECORRENTE DA SINDROME DA TALIDOMIDA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.14.00','PENSOES VITALICIAS DE SERINGUEIRO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES VITALICIAS DEVIDAS AOS DEPENDENTES DE SERINGUEIROS, POR MOTIVO DE MORTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.15.00','PENSOES ESPECIAIS DAS VITIMAS DA HEMODIALISE','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES ESPECIAIS, DEVIDAS AOS DEPENDENTES DE SEGURADOS, POR MORTE DECORRENTE DAS VITIMAS FATAIS DE HEPATITE TOXICA, POR CONTAMINACAO EM PROCESSO DE HEMODIALISE NO INSTITUTO DE DOENCAS RENAIS, COM SEDE NA CIDADE DE CARUARU NO ESTADO DE PERNAMBUCO, CONFORME DISPOE A LEI Nº 9.422, DE 24 DE DEZEMBRO DE 1996. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.16.00','PENSOES ESPECIAIS DAS VITIMAS DA HANSENIASE','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSAO ESPECIAL, MENSAL, VITALICIA E INTRANSFERIVEL, AS PESSOAS ATINGIDAS PELA HASENIASE E QUE FORAM SUBMETIDAS A ISOLAMENTO E INTERNACAO COMPULSORIOS EM HOSPITAIS-COLONIA, ATE 31/12/1986, CONFORME DISPOE A LEI Nº 11.520, DE 18/09/2007. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.2.1.99.00','OUTRAS PENSOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM OUTRAS PENSOES NAO CLASSIFICAVEIS NOS SUBITENS ANTERIORES, E/OU OS VALORES RELATIVOS A INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.0.00.00','PENSOES - MILITAR','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AO DEPENDENTES DOS MILITARES, APOS SEU OBITO, REGIDOS PELO REGIME PROPRIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.00.00','PENSOES - MILITAR - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE PENSOES AO DEPENDENTES DOS MILITARES, APOS SEU OBITO, REGIDOS PELO REGIME PROPRIO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.01.00','PENSOES MILITARES','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DE ORIGEM MILITAR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.02.00','13 SALARIO - PESSOAL MILITAR - PENSIONISTAS','REGISTRA O VALOR DAS DESPESAS REALIZADAS A TITULO DE 13 SALARIO - PESSOAL MILITAR.. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.03.00','COMPL. PENSOES - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AS COMPLEMENTACOES DE PENSOES PAGAS A PENSIONISTAS DE MILITARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.04.00','PENSOES ESPECIAIS - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES DEVIDAS EM FUNCAO DE LEIS ESPECIAIS A MILITARES, TAIS COMO: LEIS 4.242/63, 6.592/78, 7.424/85 E 8.059/90 QUE TRATAM DE PENSIONISTAS DA FEB. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.05.00','PENSOES ORIGINARIAS DE GRATIF.P/EXERC.DE CARG','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PENSOES ORIGINARIAS DE GRATIFICACAO POR EXERCICIO DE FUNCOES E CARGOS COMISSIONADOS, BEM COMO DA OPCAO PREVISTA EM LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.06.00','ABONO PROVISORIO - PENSIONISTAS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS A TITULO ABONO PROVISORIO PARA PENSIONISTAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.07.00','VANTAGENS INCORPORADAS - PESSOAL MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VANTAGENS INCORPORADAS DE PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.08.00','VANTAGEM PECUNIARIA ESPECIAL - VPE',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM VANTAGEM PECUNIARIA ESPECIAL - VPE','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.3.1.99.00','OUTRAS PENSOES - MILITARES','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS PENSOES PARA SERVIDORES MILITARES NAO CLSSIFICAVEIS NOS SUBITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.9.0.00.00','OUTRAS PENSOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS PENSOES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.2.9.1.00.00','OUTRAS PENSOES - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTRAS PENSOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.0.0.00.00','BENEFICIOS DE PRESTACAO CONTINUADA','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.1.0.00.00','BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO E RENDA MENSAL VITALICIA IDADE','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.1.1.00.00','BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO - EXTRA OFSS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA E RENDA MENSAL VITALICIA IDADE .COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.1.1.01.00','BENEFICIOS DE PRESTACAO CONTINUADA AO IDOSO','REGISTRA O BENEFICIO DE PRESTACAO CONTINUADA QUE GARANTE 1 (UM) SALARIO MINIMO MENSAL AO IDOSO , QUE COMPROVE NAO POSSUIR MEIOS DE PROVER A PROPRIA MANUTENCAO E NEM DE TE - LA PROVIDA POR SUA FAMILIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.1.1.02.00','RENDA MENSAL VITALICIA - IDADE','REGISTRA AS DESPESAS COM RENDA MENSAL VITALICIA DE IDOSOS, DEVIDA A SEGURADOS MAIORES DE 70 ANOS DE IDADE, NA FORMA DA LEI 6.179/74. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.2.0.00.00','BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA E RENDA MENSAL VITALICIA - INVALIDEZ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.2.1.00.00','BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA - EXTRA OFSS','COMPREENDEM OS BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA E RENDA MENSAL VITALICIA - INVALIDEZ.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.2.1.01.00','BENEFICIOS DE PRESTACAO CONTINUADA AO PORTADOR DE DEFICIENCIA','REGISTRA O BENEFICIO DE PRESTACAO CONTINUADA QUE GARANTE 1 (UM) SALARIO MINIMO MENSAL A PESSOA PORTADORA DE DEFICIENCIA, QUE COMPROVE NAO POSSUIR MEIOS DE PROVER A PROPRIA MANUTENCAO E NEM DE TE - LA PROVIDA POR SUA FAMILIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.2.1.02.00','RENDA MENSAL VITALICIA - INVALIDEZ','REGISTRA AS VPD COM RENDA MENSAL VITALICIA DE INVALIDOS, DEVIDA AOS SEGURADOS CONSIDERADOS DEFINITIVAMENTE INCAPAZES PARA O TRABALHO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.9.0.00.00','OUTROS BENEFICIOS DE PRESTACAO CONTINUADA','COMPREENDEM OUTROS BENEFICIOS DE PRESTACAO CONTINUADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.3.9.1.00.00','OUTROS BENEFICIOS DE PRESTACAO CONTINUADA - EXTRA OFSS','REGISTRA OUTROS BENEFICIOS DE PRESTACAO CONTINUADA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.0.0.00.00','BENEFICIOS EVENTUAIS','COMPREENDEM AS PROVISOES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE NASCIMENTO, MORTE, SITUACOES DE VULNERABILIDADE TEMPORARIA E DE CALAMIDADE PUBLICA.AS PROVISOES RELATIVAS A PROGRAMAS, PROJETOS, SERVICOS E BENEFICIOS DIRETAMENTE VINCULADOS AO CAMPO DA SAUDE, EDUCACAO, INTEGRACAO NACIONAL E DAS DEMAIS POLITICAS SETORIAIS NAO SE INCLUEM NA MODALIDADE DE BENEFICIOS EVENTUAIS DA ASSISTENCIA SOCIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.1.0.00.00','AUXILIO POR NATALIDADE','COMPREENDE O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR NATALIDADE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.1.1.00.00','AUXILIO POR NATALIDADE EXTRA OFSS','REGISTRA O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR NATALIDADE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.2.0.00.00','AUXILIO POR MORTE','COMPREENDE O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR MORTE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.2.1.00.00','AUXILIO POR MORTE EXTRA OFSS','REGISTRA O BENEFICIO EVENTUAL QUE VISA O PAGAMENTO DE AUXILIO POR MORTE AS FAMILIAS CUJA RENDA MENSAL PER CAPITA SEJA INFERIOR A 1/4 (UM QUARTO) DO SALARIO MINIMO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.3.0.00.00','BENEFICIOS EVENTUAIS POR SITUACOES DE VULNERABILIDADE TEMPORARIA','COMPREENDE AS PROVISOES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE SITUACOES DE VULNERABILIDADE TEMPORARIA, COM PRIORIDADE PARA A CRIANCA, A FAMILIA, O IDOSO, A PESSOA PORTADORA DE DEFICIENCIA, A GESTANTE E A NUTRIZ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.3.1.00.00','BENEFICIOS EVENTUAIS POR SITUACOES DE VULNERABILIDADE TEMPORARIA EXTRA OFSS','REGISTRA AS PROVISOES SUPLEMENTARES E PROVISORIAS, PRESTADAS AOS CIDADAOS E AS FAMILIAS EM VIRTUDE DE SITUACOES DE VULNERABILIDADE TEMPORARIA, COM PRIORIDADE PARA A CRIANCA, A FAMILIA, O IDOSO, A PESSOA PORTADORA DE DEFICIENCIA, A GESTANTE E A NUTRIZ.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.0.00.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA','COMPREENDEM OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.ENTENDE SE POR ESTADO DE CALAMIDADE PUBLICA O RECONHECIMENTO PELO PODER PUBLICO DE SITUACAO ANORMAL, ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, TEMPESTADES, ENCHENTES, INVERSAO TERMICA, DESABAMENTOS, INCENDIOS, EPIDEMIAS, CAUSANDO SERIOS DANOS A COMUNIDADE AFETADA, INCLUSIVE A INCOLUMIDADE OU A VIDA DE SEUS INTEGRANTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.00.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA EXTRA OFSS','COMPREENDEM OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA, DE MODO A ASSEGURAR - LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA.ENTENDE SE POR ESTADO DE CALAMIDADE PUBLICA O RECONHECIMENTO PELO PODER PUBLICO DE SITUACAO ANORMAL, ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, TEMPESTADES, ENCHENTES, INVERSAO TERMICA, DESABAMENTOS, INCENDIOS, EPIDEMIAS, CAUSANDO SERIOS DANOS A COMUNIDADE AFETADA, INCLUSIVE A INCOLUMIDADE OU A VIDA DE SEUS INTEGRANTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.01.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA BAIXAS E ALTAS TEMPERATURAS','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE BAIXAS OU ALTAS TEMPERATURAS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.02.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA TEMPESTADES','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE TEMPESTADE, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.03.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA ENCHENTES','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE ENCHENTE, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.04.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA INVERSOES TERMICAS','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE INVERSOES TERMICAS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.05.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA DESABAMENTOS','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE DESABAMENTOS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.06.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA DESABAMENTOS','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE INCENDIOS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.07.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA EPIDEMIAS','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE CALAMIDADE PUBLICA ,ADVINDA DE EPIDEMIAS, DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.4.1.99.00','BENEFICIOS EVENTUAIS EM CASO DE CALAMIDADE PUBLICA OUTRAS','REGISTRA OS BENEFICIOS PARA ATENDIMENTO DE VITIMAS DE OUTROS TIPOS CALAMIDADE PUBLICA , DE MODO A ASSEGURAR LHES A SOBREVIVENCIA E A RECONSTRUCAO DE SUA AUTONOMIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.9.0.00.00','OUTROS BENEFICIOS EVENTUAIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE OUTROS BENEFICIOS EVENTUAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.4.9.1.00.00','OUTROS BENEFICIOS EVENTUAIS - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE OUTROS BENEFICIOS EVENTUAIS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.5.0.0.00.00','POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA','COMPREENDE AS POLITICAS PUBLICAS QUE VISEM CONTRIBUIR PARA A REDUCAO DA FOME, DA POBREZA, DA DESIGUALDADE E DE OUTRAS FORMAS DE PRIVACAO VIVIDAS PELAS FAMILIAS MAIS EXCLUIDAS, CONSIDERANDO TRES DIMENSOES: O ALIVIO IMEDIATO DA POBREZA, POR MEIO DA TRANSFERENCIA DE RENDA DIRETAMENTE AS FAMILIAS POBRES E EXTREMAMENTE POBRES; A CONTRIBUICAO PARA A REDUCAO DA POBREZA DA GERACAO SEGUINTE, POR MEIO DO REFORCO DO DIREITO DE ACESSO AOS SERVICOS DE SAUDE E DE EDUCACAO, COM O CUMPRIMENTO DAS CONDICIONALIDADES NESTAS AREAS; E A ARTICULACAO DE ACOES COMPLEMENTARES, DE FORMA A DESENVOLVER AS CAPACIDADES DAS FAMILIAS BENEFICIARIAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.5.0.1.00.00','POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA EXTRA OFSS','COMPREENDE AS POLITICAS PUBLICAS QUE VISEM CONTRIBUIR PARA A REDUCAO DA FOME, DA POBREZA, DA DESIGUALDADE E DE OUTRAS FORMAS DE PRIVACAO VIVIDAS PELAS FAMILIAS MAIS EXCLUIDAS, CONSIDERANDO TRES DIMENSOES: O ALIVIO IMEDIATO DA POBREZA, POR MEIO DA TRANSFERENCIA DE RENDA DIRETAMENTE AS FAMILIAS POBRES E EXTREMAMENTE POBRES; A CONTRIBUICAO PARA A REDUCAO DA POBREZA DA GERACAO SEGUINTE, POR MEIO DO REFORCO DO DIREITO DE ACESSO AOS SERVICOS DE SAUDE E DE EDUCACAO, COM O CUMPRIMENTO DAS CONDICIONALIDADES NESTAS AREAS; E A ARTICULACAO DE ACOES COMPLEMENTARES, DE FORMA A DESENVOLVER AS CAPACIDADES DAS FAMILIAS BENEFICIARIAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.5.0.1.01.00','BOLSA FAMILIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA BOLSA FAMILIA (PBF), QUE E UM PROGRAMA DE TRANSFERENCIA DIRETA DE RENDA COM CONDICIONALIDADES, QUE BENEFICIA FAMILIAS EM SITUACAO DE POBREZA E EXTREMA POBREZA, DE ACORDO COM A LEI 10.836, DE 09 DE JANEIRO DE 2004 E O DECRETO Nº 5.209, DE 17 DE SETEMBRO DE 2004.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.5.0.1.02.00','PRO JOVEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO FINANCEIRO DADO AOS BENEFICIARIOS DO PROGRAMA NACIONAL DE INCLUSAO DE JOVENS PRO JOVEM,QUE E DESTINADO A JOVENS DE 15 (QUINZE) A 29 (VINTE E NOVE) ANOS, COM O OBJETIVO DE PROMOVER SUA REINTEGRACAO AO PROCESSO EDUCACIONAL, SUA QUALIFICACAO PROFISSIONAL E SEU DESENVOLVIMENTO HUMANO. ESTE AUXILIO FINANCEIRO SERA CONCEDIDO NAS MODALIDADES: A) PRO JOVEM URBANO; B) PRO JOVEM CAMPO SABERES DA TERRA; E C) PRO JOVEM TRABALHADOR','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.5.0.1.03.00','PROGRAMA DE ERRADICACAO DO TRABALHO INFANTIL (PETI)','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRANSFERENCIA DE RENDA DO PROGRAMA DE ERRADICACAO DO TRABALHO INFANTIL PETI, QUE TEM COMO OBJETIVO CONTRIBUIR PARA A ERRADICACAO DE TODAS AS FORMAS DE TRABALHO INFANTIL NO PAIS, ATENDENDO FAMILIAS CUJAS CRIANCAS E ADOLESCENTES COM IDADE INFERIOR A 16 ANOS FORAM RETIRADAS DAS DIVERSAS SITUACOES DE TRABALHO. O PROGRAMA ESTA INSERIDO EM UM PROCESSO DE RESGATE DA CIDADANIA E PROMOCAO DE DIREITOS DE SEUS USUARIOS, BEM COMO DE INCLUSAO SOCIAL DE SUAS FAMILIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.5.0.1.99.00','OUTRAS POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS POLITICAS PUBLICAS DE TRANSFERENCIA DE RENDA','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.0.0.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS OU ASSITENCIAIS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.0.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS - RPPS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RPPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS - RPPS - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RPPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.01.00','AUXILIO FUNERAL ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL FALECIDO, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO SERVIDOR. TAMBEM SERA DEVIDO AUXILIO FUNERAL, EM CASO DE FALECIMENTO DE SERVIDOR EM SERVICO FORA DO LOCAL DE TRABALHO, INCLUSIVE NO EXTERIOR E AS DESPESAS DE TRANSPORTE DO CORPO (TRASLADO) CORRERAO A CONTA DOS RECURSOS DA UNIAO, AUTARQUIA OU FUNDACAO PUBLICA (ART. 228, LEI 8112/90) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.02.00','AUXILIO FUNERAL INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO INATIVO CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.03.00','AUXILIO NATALIDADE ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.04.00','AUXILIO NATALIDADE INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO CIVIL,DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.05.00','AUXILIO RECLUSAO ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.06.00','AUXILIO RECLUSAO INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.07.00','AUXILIO FUNERAL PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.08.00','AUXILIO RECLUSAO PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.09.00','AUXILIO NATALIDADE PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE A PENSIONISTA CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.10.00','AUXILIO-DOENCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DEVIDO AO SEGURADO QUE FICAR INCAPACITADO PARA O TRABALHO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.11.00','SALARIO MATERNIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI 6.136/74, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.12.00','SALARIO-FAMILIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.12.01','SALARIO FAMILIA - ATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA - ATIVO PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.12.02','SALARIO FAMILIA-INATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDOS A INATIVOS PESSOAL CIVIL ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.12.03','SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.1.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.0.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS - RGPS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RGPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS - RGPS - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO RGPS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.01.00','AUXILIO RECLUSAO ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.02.00','AUXILIO RECLUSAO INATIVO CIVIL','REGISTRA O VALOR DAS DESPESAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.03.00','AUXILIO RECLUSAO PENSIONISTA CIVIL','REGISTRA O VALOR DAS DESPESAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA CIVIL AFASTADO POR MOTIVO DE PRISAO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.04.00','AUXILIO DOENCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE AUXILIO-DOENCA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.05.00','AUXILIO ACIDENTE','REGISTRA AS DESPESAS COM AUXILIO-ACIDENTE PREVIDENCIARIO CONCEDIDO, COMO INDENIZACAO, AO SEGURADO QUANDO APOS A CONSOLIDACAO DAS LESOES DECORRENTES DE ACIDENTES DE QUALQUER NATUREZA RESULTAR SEQUELAS QUE IMPLIQUEM REDUCAO DA CAPACIDADE FUNCIONAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.06.00','SALARIO MATERNIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI 6.136/74, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.07.00','PECULIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PECULIO, DEVIDO AOS SEGURADOS APOSENTADOS FILIADOS A PREVIDENCIA E A SEGURADOS FILIADOS A PREVIDENCIA, COM MAIS DE 60 ANOS DE IDADE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.08.00','ABONO DE PERMANENCIA DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ABONO DE PERMANENCIA EM SERVICO, DEVIDO AOS SEGURADOS QUE PERMANECEM EM ATIVIDADE APOS COMPLETADO O PERIODO DE CARENCIA MINIMO PARA O REQUERIMENTO DE SUA APOSENTADORIA POR TEMPO DE SERVICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.09.00','ABONO ANUAL 13. SALARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ABONO ANUAL - 13 SALARIO, DEVIDO AOS SEGURADOS BENEFICIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.10.00','AUXILIO DOENCA - ACIDENTE DO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DECORRENTE DE ACIDENTE DO TRABALHO, DEVIDO AO SEGURADO ACIDENTADO NO TRABALHO, A PARTIR DO 16. DIA APOS O ACIDENTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.11.00','AUXILIO - ACIDENTE DO TRABALHO','REGISTRA AS DESPESAS COM AUXILIO-ACIDENTE DO TRABALHO, DEVIDO AO SEGURADO ACIDENTADO QUE SOFRA REDUCAO PARCIAL PERMANENTE DE SUA CAPACIDADE PARA O TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.12.00','AUXILIO SUPLEMENTAR ACIDENTE DO TRABALHO','REGISTRA AS DESPESAS COM AUXILIO SUPLEMENTAR-ACIDENTE DO TRABALHO, DEVIDO AO SEGURADO ACIDENTADO QUE, APOS A CONSOLIDACAO DAS LESOES DECORRENTES, APRESENTAR PERDAS ANATOMICAS OU REDUCAO DA CAPACIDADE FUNCIONAL DEFINITIVA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.13.00','AUXILIO PARA EXAMES FORA DO DOMICILIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA EXAMES FORA DO DOMICILIO, DEVIDO AOS BENEFICIARIOS QUE SE DESLOCAM, POR DETERMINACAO DO INSS, PARA EXAMES OU TRATAMENTO EM PROCESSO DE REABILITACAO PROFISSIONAL, EM LOCALIDADE DIVERSA DE SEU DOMICILIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.15.00','AUXILIO PARA EXAMES FORA DO DOMICILIO - ACIDENTE DO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA EXAMES FORA DO DOMICILIO, DEVIDO AOS BENEFICIARIOS QUE SE DESLOCAM, POR DETERMINACAO DO INSS, PARA EXAMES OU TRATAMENTO EM PROCESSO DE REABILITACAO PROFISSIONAL, EM LOCALIDADE DIVERSA DE SEU DOMICILIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.16.00','AUXILIO - PROGRAMA DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, PARA CUSTEAR DESPESAS COMO ALIMENTACAO E TRANSPORTE DO SEGURADO DURANTE A PARTICIPACAO EM CURSO DE REABILITACAO PROFISSIONAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.17.00','SEGURO DESEMPREGO - FAT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SEGURO DESEMPREGO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.18.00','ABONO SALARIAL - PASEP - FAT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO SALARIAL-PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.19.00','ABONO SALARIAL - PIS - FAT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO SALARIAL-PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.20.00','SALARIO-FAMILIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.20.01','SALARIO FAMILIA - ATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA-ATIVO PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.20.02','SALARIO FAMILIA-INATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A INATIVOS PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.20.03','SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.20.04','SALARIO FAMILIA LEI 8.745/93 ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA DE PESSOAL TECNICO CONTRATADO POR TEMPO DETERMINADO NOS TERMOS DA LEI 8.745/93.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.21.00',' AUXILIO COM DESLOC.P/EXAME FORA DO DOMICILIO  ','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO PARA EXAMES FORA DO DOMICILIO DEVIDO AOS BENEFICIARIOS QUE SE DESLOCAM,POR DETERMINACAO DO INSS,PARA EXAMES OU TRATAMENTO EM PROCESSO DE REABILITACAO PROFISSIONAL,EM LOCALIDADE DIVERSA DE SEU DOMICILIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.2.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.0.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS - MILITAR','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO REGIME PROPRIO DOS MILITARES, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS - MILITAR - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS, RELACIONADAS COM BENEFICIOS PREVIDENCIARIOS DO REGIME PROPRIO DOS MILITARES, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.01.00','AUXILIO FUNERAL ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO EX-SERVIDOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.02.00','AUXILIO FUNERAL INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUITIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO INATIVO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.03.00','AUXILIO NATALIDADE ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO MILITAR DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.04.00','AUXILIO NATALIDADE INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO MILITAR DEVIDO A SERVIDORA,CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.05.00','AUXILIO RECLUSAO ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.06.00','AUXILIO RECLUSAO INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.07.00','AUXILIO FUNERAL PENSIONISTA MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.08.00','AUXILIO RECLUSAO PENSIONISTA MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA MILITAR EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS DEVIDO TAMBEM A TERCEIRO E CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO PENSIONISTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.09.00','AUXILIO NATALIDADE PENSIONISTA MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE PENSIONISTA MILITAR DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO DO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.10.00','SALARIO-FAMILIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.10.01','SALARIO FAMILIA-ATIVO PESSOAL MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA-ATIVO PESSOAL MILITAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.10.02','SALARIO FAMILIA - INATIVO PESSOAL MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVASCOM SALARIO FAMILIA A INATIVOS MILITARES, QUANDO O PAGAMENTO FOR EFETUADO PELA ENTIDADE CONSTITUIDA PARA ADMINISTRAR O RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.10.03','SALARIO FAMILIA - PENSIONIOSTA PESS. MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA A PENSIONISTAS MILITARES, QUANDO O PAGAMENTO FOR EFETUADO PELA ENTIDADE CONSTITUIDA PARA ADMINISTRAR O RPPS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.3.1.98.00','INTEGRACAO DE DADOS DE ORGAOS E ENTIDADES PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.9.0.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.2.9.9.1.00.00','OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OUTROS BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.0.0.0.00.00','USO DE BENS, SERVICOS E CONSUMO DE CAPITAL FIXO','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM MANUTENCAO E OPERACAO DA MAQUINA PUBLICA, EXCETO DESPESAS COM PESSOAL E ENCARGOS QUE SERAO REGISTRADAS EM GRUPO ESPECIFICO (DESPESAS DE PESSOAL E ENCARGOS). COMPREENDE: DIARIAS, MATERIAL DE CONSUMO,MATERIAL DE DISTRIBUICAO GRATUITA, PASSAGENS E DESPESAS COM LOCOMOCAO, SERVICOS DE TERCEIROS, ARRENDAMENTO MERCANTIL OPERACIONAL, ALUGUEL, DEPRECIACAO AMORTIZACAO, EXAUSTAO, ENTRE OUTRAS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.0.0.00.00','USO DE MATERIAL DE CONSUMO',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DO MATERIAL DE CONSUMO. UM MATERIAL E CONSIDERADO DE CONSUMO QUANDO FOR DE DURACAO INFERIOR A DOIS ANOS, FRAGIL, PERECIVEL, INCORPORAVEL, TRANSFORMAVEL OU CUJA FINALIDADE SEJA PARA CONSUMO IMEDIATO OU PARA REPOSICAO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.0.00.00','CONSUMO DE MATERIAL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE REQUISICAO DE MATERIAL DE CONSUMO PARA USO INTERNO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.00.00','CONSUMO DE MATERIAL - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE REQUISICAO DE MATERIAL DE CONSUMO PARA USO INTERNO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PARTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.01.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVEIS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS PARA MOTORES A COMBUSTAO INTERNA DE VEICULOS RODOVIARIOS, TRATORES EM GERAL, EMBARCACOES DIVERSAS E GRUPOS GERADORES ESTACIONADOS OU TRANSPORTAVEIS, E TODOS OS OLEOS LUBRIFICANTES DESTINADOS AOS SISTEMAS HIDRAULICOS, HIDRAMATICOS, DE CAIXA DE TRANSMISSAO DE FORCA E GRAXAS GRAFITADAS PARA ALTAS E BAIXAS TEMPERATURAS.  ADITIVOS - ALCOOL HIDRATADO - FLUIDO PARA AMORTECEDOR - FLUIDO PARA TRANSMISSAO HIDRAULICA - GASOLINA - GRAXAS - OLEO DIESEL - OLEO PARA CARTER - OLEO PARA FREIO HIDRAULICO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.02.00','COMBUSTIVEIS E LUBRIFICANTES DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES DESTINADOS A QUALQUER TIPO DE AERONAVE.  ADITIVOS - GASOLINA - GRAXAS - OLEOS E FLUIDOS EM GERAL - QUEROSENE E OUTROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.03.00','COMBUSTIVEIS E LUBRIF. P/ OUTRAS FINALIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMBUSTIVEIS E LUBRIFICANTES PARA OUTRAS FINALIDADES QUE NAO SE ENQUADRAM EM ITENS ANTERIORES. CARBURETO - CARVAO MINERAL - CARVAO VEGETAL - LENHA - QUEROSENE COMUM - COMBUSTIVEIS E LUBRIFICANTES DE USO FERROVIARIO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.04.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GAS DE USO INDUSTRIAL, DE TRATAMENTO DE AGUA, DE ILUMINACAO, DE USO MEDICO, BEM COMO GASES NOBRES PARA USO EM LABORATORIO CIENTIFICO, TAIS COMO: ACETILENO - CARBONICO FREON - HELIO - HIDROGENIO - LIQUEFEITO DE PETROLEO - NITROGENIO - OXIGENIO E OUTROS. REGISTRA, AINDA, O VALOR DAS DESPESAS COM GAS, PO QUIMICO, AGUA PRESSURIZADA E OUTROS MATERIAIS UTILIZADOS NA RECARGA DE EXTINTORES DE INCENDIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.05.00',' EXPLOSIVOS E MUNICOES',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE CARGAS DE PROJECAO EM PECAS DE ARTILHARIA, MISSEIS GUIADOS E NAO GUIADOS, CAPSULAS OU ESTOJOS PARA RECARGA E EXPLOSIVOS DE USO MILITAR E PARAMILITAR. BALAS E SIMILARES - ESTOPIM - EXPLOSIVOS, TAIS COMO: ARTEFATOS EXPLOSIVOS - ARTIGOS PIROTECNICOS - CAPSULAS DE DETONACAO - DINAMITE - ESPOLETA - FOGOS DE ARTIFICIO - GRANADA - POLVORA E OUTROS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.06.00',' ALIMENTOS PARA ANIMAIS','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ALIMENTOS DESTINADOS A GADO BOVINO, EQUINO, MUAR E BUFALINO, CAPRINOS, SUINOS, OVINOS, AVES DE QUALQUER ESPECIE, COMO TAMBEM PARA ANIMAIS SILVESTRES EM CATIVEIRO (JARDINS ZOOLOGICOS OU LABORATORIOS) E OUTROS. ALFAFA - ALPISTE - CAPIM VERDE - FARELO - FARINHAS EM GERAL - FUBA GROSSO - MILHO EM GRAO - RACAO BALANCEADA - SAL MINERAL - SUPLEMENTOS VITAMINICOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.07.00','GENEROS DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE GENEROS DE ALIMENTACAO AO NATURAL, BENEFICIADOS OU CONSERVADOS. ACUCAR - ADOCANTE - AGUA MINERAL - BEBIDAS - CAFE - CARNES EM GERAL - CEREAIS - CHAS - CONDIMENTOS - FRUTAS - GELO - LEGUMES - REFRIGERANTES - SUCOS - TEMPEROS - VERDURAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.08.00','ANIMAIS PARA PESQUISA E ABATE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ANIMAIS PARA PESQUISA E ABATE. INCLUEM-SE NESTA CLASSIFICACAO OS PEIXES E MARISCOS, TODAS AS ESPECIES DE MAMIFEROS, ABELHAS PARA ESTUDOS, PESQUISA E PRODUCAO DE MEL, BEM ASSIM QUALQUER OUTRO ANIMAL DESTINADO A ESTUDO GENETICO OU ALIMENTACAO. BOI - CABRITO - COBAIAS EM GERAL - MACACO - RATO - RA E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.09.00','MATERIAL FARMACOLOGICO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MEDICAMENTOS OU COMPONENTES DESTINADOS A MANIPULACAO DE DROGAS MEDICAMENTOSAS. MEDICAMENTOS - SORO - VACINAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.10.00','MATERIAL ODONTOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PACIENTES DA AREA ODONTOLOGICA, BEM COMO OS UTILIZADOS INDIRETAMENTE PELOS PROTETICOS NA CONFECCAO DE PROTESES DIVERSAS. AGULHAS - AMALGAMA - ANESTESICOS - BROCA - CIMENTO ODONTOLOGICO -ESPATULA ODONTOLOGICA - FILMES PARA RAIO X - PLATINA - RESINAS ODONTOLOGICAS - SERINGAS - SUGADOR E OUTROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.11.00',' MATERIAL QUIMICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS ELEMENTOS OU COMPOSTOS QUIMICOS DESTINADOS AO FABRICO DE PRODUTOS QUIMICOS, ANALISES LABORATORIAIS, BEM COMO AQUELES DESTINADOS AO COMBATE DE PRAGAS OU EPIZOOTIAS. ACIDOS - INSETICIDAS - PRODUTOS QUIMICOS PARA TRATAMENTO DE AGUA -REAGENTES QUIMICOS - SAIS - SOLVENTES - SUBSTANCIAS UTILIZADAS PARA COMBATER INSETOS, FUNGOS E BACTERIAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.12.00',' MATERIAL DE COUDELARIA OU DE USO ZOOTECNICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS NO ARREAMENTO DE ANIMAIS DESTINADOS A MONTARIA, COM EXCECAO DA SELA, COMO TAMBEM AQUELES DESTINADOS AO ADESTRAMENTO DE CAES DE GUARDA OU OUTRO ANIMAL DOMESTICO. ARGOLAS DE METAL - ARREAMENTO - BARRIGUEIRAS - BRIDOES - CABRESTOS - CINCHAS - CRAVOS - ESCOVAS PARA ANIMAIS - ESTRIBOS - FERRADURAS - MANTAS DE PANO - MATERIAL PARA APICULTURA - MATERIAL DE FERRAGEM E CONTENCAO DE ANIMAIS - PEITORAIS -RASPADEIRAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.13.00','MATERIAL DE CACA E PESCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA CACA E PESCA DE ANIMAIS. ANZOIS - CORDOALHAS PARA REDES CHUMBADAS - ISCAS - LINHAS DE NYLON - MASCARAS PARA VISAO SUBMARINA - MOLINETES - NADADEIRAS DE BORRACHA - REDES - ROUPAS E ACESSORIOS PARA MERGULHO -VARAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.14.00','MATERIAL EDUCATIVO E ESPORTIVO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS CONSUMIDOS DIRETAMENTE NAS ATIVIDADES EDUCATIVAS E ESPORTIVAS DE CRIANCAS E ADULTOS. APITOS - BOLAS - BONES - BOTAS ESPECIAIS - BRINQUEDOS EDUCATIVOS - CALCOES - CAMISAS DE MALHA - CHUTEIRAS - CORDAS - ESTEIRAS -JOELHEIRAS - LUVAS - MATERIAIS PEDAGOGICOS - MEIAS - OCULOS PARA MOTOCICLISTAS - PATINS - QUIMONOS - RAQUETES - REDES PARA PRATICA DE ESPORTES - TENIS E SAPATILHAS - TORNOZELEIRAS - TOUCA PARA NATACAO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.15.00',' MATERIAL P/ FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS EM FESTIVIDADES E HOMENAGENS, INCLUINDO ARTIGOS PARA DECORACAO E BUFFET. ARRANJOS E COROAS DE FLORES - BEBIDAS - DOCES - SALGADOS - PLACAS COMEMORATIVAS (EXCETO AS PLACAS PARA DISTRIBUICAO GRATUITA) E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.16.00',' MATERIAL DE EXPEDIENTE',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS DIRETAMENTE NOS TRABALHOS ADMINISTRATIVOS, NOS ESCRITORIOS PUBLICOS, NOS CENTROS DE ESTUDOS E PESQUISAS, NAS ESCOLAS, NAS UNIVERSIDADES ETC. AGENDA - ALFINETE DE ACO - ALMOFADA P/ CARIMBOS - APAGADOR - APONTADOR DE LAPIS - ARQUIVO P/ DISQUETE - BANDEJA PARA PAPEIS - BLOCO P/ RASCU-NHO - BOBINA PAPEL P/ CALCULADORAS - BORRACHA - CADERNO - CANETA -CAPA DE PROCESSO - CARIMBOS EM GERAL - CARTOLINA - CLASSIFICADOR -CLIPE - COLA - COLCHETE - CORRETIVO - ENVELOPE - ESPATULA - ESTENCIL -ESTILETE - EXTRATOR DE GRAMPOS - FITA ADESIVA - FITA P/ MAQUINA DE ES-CREVER E CALCULAR - GIZ - GOMA ELASTICA - GRAFITE - GRAMPEADOR -GRAMPOS - GUIA P/ ARQUIVO - GUIA DE ENDERECAMENTO POSTAL - IMPRESSOS E FORMULARIOS EM GERAL - INTERCALADOR P/ FICHARIO - LACRE - LAPIS -LAPISEIRA - LIMPA TIPOS - LIVROS DE ATA, DE PONTO E DE PROTOCOLO -PAPEIS - PASTAS EM GERAL - PERCEVEJO - PERFURADOR - PINCA - PLACAS DE ACRILICO - PLASTICOS - PORTA-LAPIS - REGISTRADOR - REGUA - SELOS P/ CORRESPONDENCIA - TESOURA - TINTAS - TONER - TRANSPARENCIAS - ETIQUETAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.17.00','MATERIAL DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SUPRIMENTOS DE TI, INCLUSIVE PECAS PARA REPOSICAO. CARTUCHOS DE TINTA - CAPAS PLASTICAS PROTETORAS PARA MICROS E IMPRES- SORAS - CD-ROM VIRGEM - DISQUETES - ETIQUETAS EM FORMULARIOS-CONTINUOS -LEITORA/SMARTCARD - MOUSE E TECLADO (REPOSICAO) - MOUSE PAD - PECAS E ACESSORIOS PARA COMPUTADORES E PERIFERICOS - RECARGA DE CARTUCHOS DE TINTA - TONER PARA IMPRESORAS A LASER - CARTOES MAGNETICOS - REPOSICAO DE LEITORA/TOKEN PEN-DRIVE/OUTROS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.18.00','MATERIAIS E MEDICAMENTOS P/ USO VETERINARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS E MEDICAMENTOS PARA USO VETERINARIO. VACINAS - MEDICAMENTOS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.19.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS APLICADOS DIRETAMENTE NAS PRESERVACOES, ACOMODACOES OU EMBALAGENS DE QUALQUER PRODUTO. ARAME - BARBANTE - CAIXAS PLASTICAS, DE MADEIRA, PAPELAO E ISOPOR -CORDAS - ENGRADADOS - FITAS DE ACO OU METALICAS - FITAS GOMADORAS -GARRAFAS E POTES - LINHA - PAPEL DE EMBRULHO - PAPELAO - SACOLAS -SACOS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.20.00','MATERIAL DE CAMA, MESA E BANHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS EM DORMITORIOS COLETIVOS, RESIDENCIAIS, HOTEIS, RESTAURANTES ETC. COBERTORES - COLCHAS - COLCHONETES - FRONHAS - GUARDANAPOS - LENCOIS -TOALHAS - TRAVESSEIROS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.21.00','MATERIAL DE COPA E COZINHA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REFEITORIOS DE QUALQUER TIPO, COZINHAS RESIDENCIAIS, DE HOTEIS, DE HOSPITAIS, DEESCOLAS, DE UNIVERSIDADES, DE FABRICAS ETC. ABRIDOR DE GARRAFA - ACUCAREIROS - ARTIGOS DE VIDRO E PLASTICO -BANDEJAS - COADORES - COLHERES - COPOS - EBULIDORES - FACAS -FARINHEIROS - FOSFOROS - FRIGIDEIRAS - GARFOS - GARRAFAS TERMICAS -PALITEIROS - PANELAS - PANOS DE COZINHA - PAPEL ALUMINIO - PRATOS -RECIPIENTES PARA AGUA - SUPORTES DE COPOS P/ CAFEZINHO - TIGELAS -VELAS - XICARAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.22.00','MATERIAL DE LIMPEZA E PROD. DE HIGIENIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DESTINADOS A HIGIENIZACAO PESSOAL, DE AMBIENTES DE TRABALHO, DE HOSPITAIS ETC. ALCOOL ETILICO - ANTICORROSIVO - APARELHO DE BARBEAR DESCARTAVEL -BALDE PLASTICO - BOMBA P/ INSETICIDA - CAPACHO - CERA - CESTO P/ LIXO- CREME DENTAL - DESINFETANTE - DESODORIZANTE - DETERGENTE - ESCOVA DEDENTES - ESCOVA P/ ROUPAS E SAPATOS - ESPANADOR - ESPONJA - ESTOPA -FLANELA - INSETICIDA - LUSTRA-MOVEIS - MANGUEIRA - NAFTALINA - PA PARALIXO - PALHA DE ACO - PANOS P/ LIMPEZA - PAPEL HIGIENICO - PASTA PARALIMPEZA DE UTENSILIOS - PORTA-SABAO - REMOVEDOR - RODO - SABAO -SABONETE - SACO P/ LIXO - SAPONACEO - SODA CAUSTICA - TOALHA DE PAPEL- VASSOURA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.23.00','UNIFORMES, TECIDOS E AVIAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE UNIFORMES OU QUALQUER TECIDO OU MATERIAL SINTETICO QUE SE DESTINE A CONFECCAO DE ROUPAS, COM LINHAS DE QUALQUER ESPECIE DESTINADAS A COSTURAS E OUTROS MATERIAIS DE CONSUMO EMPREGADOS DIRETA OU INDIRETAMENTE NA CONFECCAO DE ROUPAS. AGASALHOS - ARTIGOS DE COSTURA - AVENTAIS - BLUSAS - BOTOES - CADARCOS- CALCADOS - CALCAS - CAMISAS - CAPAS - CHAPEUS - CINTOS - ELASTICOS -GRAVATAS - GUARDA-POS - LINHAS - MACACOES - MEIAS - TECIDOS EM GERAL -UNIFORMES MILITARES OU DE USO CIVIL - ZIPERES - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.24.00',' MATERIAL P/ MANUT.DE BENS IMOVEIS/INSTALACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DE QUALQUER BEM PUBLICO. AMIANTO - APARELHOS SANITARIOS - ARAMES LISO E FARPADO - AREIA -BASCULANTE - BOCA DE LOBO - BOIA - BRITA - BROCHA - CABO METALICO -CAL - CANO - CERAMICA - CIMENTO - COLA - CONDUTORES DE FIOS - CONEXOES- CURVAS - ESQUADRIAS - FECHADURAS - FERRO - GAXETAS - GRADES -IMPERMEABILIZANTES - ISOLANTES ACUSTICOS E TERMICOS - JANELAS -JOELHOS - LADRILHOS - LAVATORIOS - LIXAS - MADEIRA - MARCOS DECONCRETO - MASSA CORRIDA - NIPLE - PAPEL DE PAREDE - PARAFUSOS - - PECAS P/ELEVADORES,PORTOES ELETRICOS, AR CONDICIONADO CENTRAL, ETC- PIAS- PIGMENTOS - PORTAS E PORTAIS - PREGOS - ROLOS SOLVENTES - SIFAO -TACOS - TAMPA P/ VASO - TAMPAO DE FERRO - TANQUE - TELA DE ESTUQUE -TELHA - TIJOLO - TINTA - TORNEIRA - TRINCHA - TUBO DE CONCRETO -VALVULAS - VERNIZ - VIDRO - AQUECEDORES A GAS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.25.00','MATERIAL P/ MANUTENCAO DE BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COMPONENTES, PECAS, ACESSORIOS E SOBRESSALENTES PARA APLICACAO, MANUTENCAO E REPOSICAO EM BENS MOVEIS EM GERAL. CABOS - CHAVES - CILINDROS P/ MAQUINAS COPIADORAS - COMPRESSOR P/ AR CONDICIONADO - MANGUEIRA P/ FOGAO - PECAS DE REPOSICAO DE APARELHOS E MAQUINAS EM GERAL -MATERIAIS DE REPOSICAO PARA INSTRUMENTOS MUSICAIS - VIDRO DE MESA E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.26.00','MATERIAL ELETRICO E ELETRONICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA APLICACAO,MANUTENCAO E REPOSICAO DOS SISTEMAS, APARELHOS E EQUIPAMENTOS ELETRICOS E ELETRONICOS. BENJAMINS - BOCAIS - CALHAS - CAPACITORES E RESISTORES - CHAVES DE LIGACAO - CIRCUITOS ELETRONICOS - CONDUTORES - COMPONENTES DE APARELHOELETRONICO - DIODOS - DISJUNTORES - ELETRODOS - ELIMINADOR DE PILHAS -ESPELHOS PARA INTERRUPTORES - FIOS E CABOS - FITA ISOLANTE - FUSIVEIS- INTERRUPTORES - LAMPADAS E LUMINARIAS - PILHAS E BATERIAS - PINOS E PLUGS - PLACAS DE BAQUELITE - REATORES - RECEPTACULOS - RESISTENCIAS -STARTS - SUPORTES - TOMADA DE CORRENTE - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.27.00',' MATERIAL DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS EM CAMPANHA MILITAR OU PARAMILITAR, EM MANOBRAS DE TROPAS, EM TREINAMENTOOU EM ACAO EM PATRULLHAMENTO OSTENSIVO OU RODOVIARIO, EM CAMPANHA DE SAUDE PUBLICA ETC. BINOCULO - CARTA NAUTICA - CANTIL - CORDAS - FLAMULAS E BANDEIRAS DESINALIZACAO - LANTERNAS - MEDICAMENTOS DE PRONTO-SOCORRO - MOCHILAS -PIQUETES - SACOLAS - SACOS DE DORMIR - SINALEIROS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.28.00','MATERIAL DE PROTECAO E SEGURANCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO UTILIZADOS DIRETAMENTE NA PROTECAO DE PESSOAS OU BENS PUBLICOS, PARA SOCORRO DE PESSOAS E ANIMAIS OU PARA SOCORRO DE VEICULOS, AERONAVES E EMBARCACOES, ASSIM COMO QUALQUER OUTRO ITEM APLICADO DIRETAMENTE NAS ATIVIDADES DE SOBREVIVENCIA DE PESSOAS, NA SELVA, NO MAR OU EM SINISTROS DIVERSOS. BOTAS - CADEADOS - CALCADOS ESPECIAIS - CAPACETES - CHAVES - CINTOS -COLETES - DEDAIS - GUARDA-CHUVAS - LONA - LUVAS - MANGUEIRA DE LONA -MASCARAS - PASSADEIRA ANTIDERRAPANTE - OCULOS - CABINA DE PAPELAO E OUTROS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.29.00','MATERIAL P/ AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO DE EMPREGO DIRETO EM FILMAGEM E REVELACAO, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. AETZE ESPECIAL P/ CHAPA DE PAPEL - ALBUNS P/ RETRATOS - ALTO-FALANTES- ANTENAS - ARTIGOS PARA GRAVACAO EM ACETATO - FILMES VIRGENS - FITASVIRGENS DE AUDIO E VIDEO - LAMPADAS ESPECIAIS - MATERIAL P/ RADIOGRA-FIA, MICROFILMAGEM E CINEMATOGRAFIA - MOLDURAS - PAPEL P/ REVELACAO DEFOTOGRAFIAS - PEGADORES - REVELADORES - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.30.00',' MATERIAL PARA COMUNICACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA COMUNICACOES, ASSIM COMO OS COMPONENTES, CIRCUITOS IMPRESSOS OU INTEGRADOS, PECAS OU ACESSORIOS DE REPOSICAO, CHIPS, E PARTES DE EQUIPAMENTOS DE COMUNIC.MATERIAIS PARA INSTALACOES: RADIOFONICAS, RADIOTELEGRAFICAS, TELEGRAFICAS E OUTROS. - BATERIA PARA TELEFONE CELULAR- BLOQUEADOR TELEFONICO - CHAVE COMUTADORA PARA TELEFONE - FIO PARA TELEFONE - TOMADA PARA TELEFONE - MATERIAIS PARA INSTALACOES RADIOFONICAS - RADIOTELEGRAFICAS - TELEGRAFICAS - OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.31.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE QUALQUER TIPO DE SEMENTE DESTINADA AAO PLANTIO E MUDAS DE PLANTAS FRUTIFERAS OU ORNAMENTAIS, ASSIM COMO TODOS OS INSUMOS UTILIZADOS PARA FERTILIZACAO. ADUBOS - ARGILA - PLANTAS ORNAMENTAIS - BORBULHAS - BULBOS - ENXERTOS- FERTILIZANTES - MUDAS ENVASADAS OU COM RAIZES NUAS - SEMENTES -TERRA - TUBERCULOS - XAXIM - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.32.00','SUPRIMENTO DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS EMPREGADOS NA MANUTENCAO E REPARO DE AERONAVES. ACESSORIOS - PECAS DE REPOSICAO DE AERONAVES - SOBRESSALENTES -E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.33.00','MATERIAL P/ PRODUCAO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAS-PRIMAS UTILIZADAS NA TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE UM PRODUTO FINAL. BORRACHA - COURO - MATERIAS-PRIMAS EM GERAL - MINERIOS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.34.00','SUPRIMENTOS PARA MAQ.E MOTORES NAVIOS E EMBARCACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE MAQUINAS E MOTORES DE NAVIOS, INCLUSIVE DA ESQUADRA, E DE EMBARCACOES EM GERAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.35.00','MATERIAL LABORATORIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS UTENSILIOS USADOS EM ANALISES LABORATORIAIS. ALMOFARIZES - BASTOES - BICO DE GAS - CALICES - CORANTES - FILTROS DEPAPEL - FIXADORAS - FRASCOS - FUNIS - GARRA METALICA - LAMINAS DEVIDRO P/ MICROSCOPIO - LAMPADAS ESPECIAIS - LUVAS DE BORRACHA - METAISE MATALOIDES P/ ANALISE - PINCAS - ROLHAS - VIDRARIA: BALAO VOLUMETRI-CO - BECKER - CONTA-GOTAS - ERLEMEYER - PIPETA - PROVETA - TERMOMETRO- TUBO DE ENSAIO - MATERIAL DE LABORATORIO DIDATICO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.36.00','MATERIAL HOSPITALAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CONSUMO PARA AREA HOSPITALAR OU AMBULATORIAL. AGULHAS HIPODERMICAS - ALGODAO - CANULAS - CATETERES - COMPRESSA DEGAZE - DRENOS - ESPARADRAPO - FIOS CIRURGICOS - LAMINAS P/ BISTURI -LUVAS - SERINGAS - TERMOMETRO CLINICO - E OUTROS. . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.37.00','SUPRIMENTOS DE ARMAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA MANUTENCAO E REPARO DE ARMAMENTO. MATERIAL DE MANUTENCAO E ARMAMENTO - PECAS DE REPOSICAO - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.38.00','SUPRIMENTO DE PROTECAO AO VOO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PECAS DE REPOSICAO DE RADARES E SISTEMAS DE COMUNICACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.39.00','MATERIAL P/ MANUTENCAO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA APLICACAO E MANUTENCAO DE VEICULOS RODOVIARIOS, VIATURAS BLINDADAS E TRATORES EM GERAL. AGUA DESTILADA - AMORTECEDORES - BATERIAS - BORRACHAS - BUZINA - CABOSDE ACELERADOR - CABOS DE EMBREAGEM - CAMARA DE AR - CARBURADOR COMPLETO - CIFA - COLAR DE EMBREAGEM - CONDENSADOR E PLATINADO - CORREIAS- DISCO DE EMBREAGEM - IGNICAO - JUNTA HOMOCINETICA - LAMPADAS E LANTERNAS P/ VEICULOS - LONAS E PASTILHAS DE FREIO - MANGUEIRAS -MATERIAL UTILIZADO EM LANTERNAGEM E PINTURA - MOTOR DE REPOSICAO -PARA-BRISA - PARA-CHOQUE - PLATO - PNEUS - REPAROS - RETENTORES -RETROVISORES - ROLAMENTOS - TAPETES - VALVULA DA MARCHA-LENTA E TERMOSTATICA - VELAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.40.00','MATERIAL BIOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE AMOSTRAS E OUTROS ITENS DE MATERIAIS BIOLOGICOS UTILIZADOS EM ESTUDOS E PESQUISAS CIENTIFICAS EM SERES VIVOS E INSEMINACAO ARTIFICIAL. MEIOS DE CULTURA - SEMEN - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.41.00','MATERIAL P/ UTILIZACAO EM GRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS MATERIAIS DE CONSUMO DE USO GRAFICO, TAIS COMO: CHAPAS DE OFF-SET - CLICHES - COLA - ESPIRAIS - FOTOLITOS - LOGOTIPOS - PAPEL - SOLVENTES - TINTA - TIPOS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.42.00','FERRAMENTAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE TODOS OS TIPOS DE FERRAMENTAS UTILIZADAS EM OFICINAS, CARPINTARIAS, JARDINS ETC. ALICATE - BROCA - CAIXA P/ FERRAMENTAS - CANIVETE - CHAVES EM GERAL -ENXADA - ESPATULAS - FERRO DE SOLDA - FOICE - LAMINA DE SERRA - LIMA -MACHADO - MARTELO - PA - PICARETA - PONTEIRA - PRUMO - SERROTE -TESOURA DE PODAR - TRENA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.43.00','MATERIAL P/ REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA PROGRAMAS DE REABILITACAO PROFISSIONAL. BASTOES - BENGALAS - JOELHEIRAS - MEIAS ELASTICAS E ASSEMELHADOS -OCULOS - ORTESES - PESOS - PROTESES, INSTRUMENTOS DE TRABALHO E IMPLEMENTOS PROFISSIONAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.44.00','MATERIAL DE SINALIZACAO VISUAL E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA IDENTIFICACAO, SINALIZACAO VISUAL, ENDERECAMENTO E OUTROS. PLACAS DE SINALIZACAO EM GERAL, TAIS COMO, PLACAS INDICATIVAS PARA O SETORES E SECOES, PLACAS PARA VEICULOS, PLAQUETAS PARA TOMBAMENTO DE MATERIAL, PLACAS SINALIZADORAS DE TRANSITO, CONES SINALIZADORES DE TRANSITO, CRACHAS, BOTONS IDENTIFICADORES PARA SERVIDORES E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.45.00','MATERIAL TECNICO P/ SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS TECNICOS UTILIZADOS EM PROCESSOS DE SELECAO E TREINAMENTO PELA PROPRIA UNIDADE GESTORA OU PARA DISTRIBUICAO NAO GRATUITA, TAIS COMO: APOSTILAS E SIMILARES - FOLHETOS DE ORIENTACAO - LIVROS - MANUAIS EXPLICATIVOS PARA CANDIDATOS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.46.00','MATERIAL BIBLIOGRAFICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL BIBLIOGRAFICO TAIS COMO: JORNAIS - REVISTAS - PERIODICOS EM GERAL - ANUARIOS MEDICOS - ANUARIO ESTATISCO - LIVROS EM GERAL E OUTROS, PODENDO ESTAR NA FORMA DE CD-ROM E OS MATERIAIS BIBLIOGRAFICOS PARA BIBLIOTECAS PUBLICAS, CONFORME MANUAL SIAFI CODIGO 02.11.35. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.48.00','BENS MOVEIS NAO ATIVAVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE BENS MOVEIS DE NATUREZA PERMANENTE NAO ATIVAVEIS, OU SEJA, AQUELES CONSIDERADOS COMO DESPESA OPERACIONAL, PARA FINS DE DEDUCAO DE IMPOSTO DE RENDA, DESDE QUE ATENDA AS ESPECIFICACOES CONTIDAS NO ARTIGO 301 DO RIR (REGULAMENTO DE IMPOSTO DE RENDA). ESTA CONTA EH UTILIZADA EXCLUSIVAMENTE PELAS UNIDADES REGIDAS PELA LEI 6404/76. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.49.00',' BILHETES DE PASSAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BILHETES DE PASSAGEM PARA GUARDA EM ESTOQUE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.50.00','BANDEIRAS, FLAMULAS E INSIGNIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE BANDEIRAS, FLAMULAS E INSIGNIAS, A SABER: BRASOES, ESCUDOS, ARMAS DA REPUBLICA, SELO NACIONAL E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.51.00','DISCOTECAS E FILMOTECAS NAO IMOBILIZAVEL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA AQUISICAO DE DISCOS, CD E COLECOES DE FITAS GRAVADAS COM MUSICAS E FITAS CINEMATOGRAFICAS DE CARATER EDUCATIVO,CIENTIFICO E INFORMATIVO, CUJA DEFASAGEM CONTABIL OCORRE EM UM PRAZO MAXIMO DE DOIS ANOS E QUE ATENDA OS PARAMETROS EXCLUDENTES DE MATERIAL PERMANENTE, CONFORME MANUAL DE CONTABILIDADE APLICADO AO SETOR PUBLICO - MACASP, VOLUME I - PROCEDIMENTOS CONTABEIS ORCAMENTARIOS, TAIS COMO: - DISCO EDUCATIVO - FITA DE AUDIO E VIDEO COM AULA DE CARATER EDUCATIVO, MICROFILME E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.52.00','MATERIAL DE CARATER SECRETO OU RESERVADO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.53.00','MATERIAL METEOROLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL METEOROLOGICO, TAIS COMO: RADIOSSONDAS, BALAO DE LATEX, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.54.00','MATERIAL P/MANUT.CONSERV.DE ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.55.00','SELOS PARA CONTROLE FISCAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL. (SELOS DE CONTROLE DE CIGARROS, DE BEBIDAS, ETC.) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.56.00','MATERIAL DE MARCACAO DA FAUNA SILVESTRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA USO NA IDENTIFICACAO INDIVIDUAL (MARCACAO) DOS ESPECIMES DE ESPECIES SILVESTRES EM CRIADORES, MANTENEDORES E JARDINS ZOOLOGICOS.  MAMIFERES: TATUAGENS,BRINCOS, MICROCHIP;  AVES: ANILHAS, BRACADEIRA/BRINCO DE ASA, MICROCHIP;  REPTEIS: LACRES E MICROCHIP. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.57.00','MATERIAL DE CONSUMO - REPARTICOES NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL DE CONSUMO PARA MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPARTICOES SEDIADAS NO EXTERIOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.58.00','SOBRESS.PARA MAQ.E EQP.PARA PRODU.INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL UTILIZADO NA MANUTENCAO E REPARO DE MAQUINAS E EQUIPAMENTOS INDUSTRIAIS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.1.1.99.00','OUTROS MATERIAIS DE CONSUMO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS MATERIAIS DE CONSUMO QUE NAO SE ENQUADREM NAS RUBRICAS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.0.00.00','DISTRIBUICAO DE MATERIAL GRATUITO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.00.00','DISTRIBUICAO DE MATERIAL GRATUITO - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.01.00','MERCADORIAS DOADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.02.00','MATERIAL DESTINADO A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.03.00','MATERIAL EDUCACIONAL E CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.04.00','MATERIAL PARA CERIMONIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.05.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.06.00','MATERIAL PARA DIVULGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, ETC, COM LOGOMARCAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.07.00','MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.08.00','MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.09.00','MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.10.00','MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.11.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.12.00','MATERIAL DESTINADO A CONTRIBUINTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.13.00','MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.1.99.00','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.00.00','DISTRIBUICAO DE MATERIAL GRATUITO - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.01.00','MERCADORIAS DOADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.02.00','MATERIAL DESTINADO A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.03.00','MATERIAL EDUCACIONAL E CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.04.00','MATERIAL PARA CERIMONIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.05.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.06.00','MATERIAL PARA DIVULGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, ETC, COM LOGOMARCAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.07.00','MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.08.00','MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.09.00','MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.10.00','MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.11.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.12.00','MATERIAL DESTINADO A CONTRIBUINTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.13.00','MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.2.99.00','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.00.00','DISTRIBUICAO DE MATERIAL GRATUITO - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA DISTRIBUICAO DE MATERIAL GRATUITO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.01.00','MERCADORIAS DOADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.02.00','MATERIAL DESTINADO A ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MAT.DE SAUDE(FARMACOLOGICO,ODONTOLOGICO,HOSPITALAR,MEDICAMENTOS,ORTESE E PROTESE),GENEROS ALIMENTICIOS,MATER.DE CAMA,MESA,COPA,COZINHA,LIMPEZA,HIGIENIZACAO, UNIFORMES, TECIDOS, AVIAMENTOS,MANUT.MOV/IMOV.,FERRAMENTAS E OUTROS DISTINADOS A ASSISTENCIA SOCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.03.00','MATERIAL EDUCACIONAL E CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL EDUCACIONAL,(MATERIAL ESCOLAR, DIDATICO, TECNICO, MATERIAL P/AUDIO, VIDEO E FOTO)E MATERIAL CULTURAL (MATERIAL RELIGIOSO E ESPORTIVO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.04.00','MATERIAL PARA CERIMONIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OFERECIDOS A AUTORIDADES ESTRANGEIRAS PELAS AUTORIDADES BRASILEIRAS A TITULO DE HOMENAGEM. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.05.00','MATERIAL PARA REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL OU BEM DESTINADO A SEGURADO INSCRITO EM PROGRAMA DE REABILITACAO PROFISSIONAL, INDISPENSAVEIS AO DESENVOLVIMENTO DO PROCESSO DE REABILITACAO CONFORME LEIS 8212/91 E 8213/91, TAIS COMO: - PROTESES (APARELHOS DE SUBSTITUICAO) - ORTESES (APARELHOS DE CORRECAO OU COMPLEMENTACAO) - IMPLEMENTO PROFISSIONAL (INSTRUMENTOS TECNICOS E EQUIPAMENTOS DE PROTECAO INDIVIDUAL) - MAQUINAS ACESSORIOS E FERRAMENTAS INDISPENSAVEIS PARA O DESENVOLVIMENTO DE UMA FUNCAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.06.00','MATERIAL PARA DIVULGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL PARA PUBLICIDADE E DIVULGACAO DE PROGRAMAS DO GOVERNO, PARA CONSCIENTIZACAO SOCIAL EX: CAMISETAS, BONES, CHAVEIROS, CANETAS, BOTONS, ETC, COM LOGOMARCAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.07.00','MERC. DOADAS -AGRIC.FAMILIAR-PF-COMPRA DIRETA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA FISICA, REFERENTE A AGRICULTURA FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.08.00','MERC. DOADAS -AGRIC.FAMILIAR-PJ-COMPRA DIRETA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS ADQUIRIDOS COM A FINALIDADE DE DOACAO A PESSOA JURIDICA, REFERENTE A AGRICULTURA FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.09.00','MERC. DOADAS -- AGRIC.FAMILIAR - CPR ESPECIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PRODUTOS AGROPECUARIOS COMPRADOS ANTECIPADAMENTE, COM A FINALIDADE DE DOACAO, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL" - "CPR ESPECIAL". (LEI 10.696, DE 02/07/03, ART. 19) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.10.00','MERC. DOADAS -AGRIC.FAMILIAR - CPR ALIMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DA PRODUCAO AGROPECUARIA DE PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, COMPRADOS ANTECIPADAMENTE, FORMALIZADA COM BASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.11.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM DESTINADOS AOS PRODUTORES ENQUADRADOS NO PROGRAMA NACIONAL DE FORTALECIMENTO DA AGRICULTURA FAMILIAR - PRONAF, FORMALIZADA COMBASE NA "CEDULA DE PRODUTO RURAL - CPR - ALIMENTO" (LEI N. 10.696,DE 02/07/2003, ART. 19). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.12.00','MATERIAL DESTINADO A CONTRIBUINTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAL (CD-ROM, FORMULARIOS, ETC.) PARA DISTRIBUICAO AOS CONTRIBUINTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.13.00','MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS UTILIZADOS PARA IDENTIFICACAO DE BENEFICIARIOS E OUTROS, TAIS COMO: AQUISICAO DE CARTOES PARA DISTRIBUICAO A USUARIOS, INDIVIDUALIZADO POR BENEFICIARIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS DE DISTRIBUICAO GRATUITA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.1.2.3.99.00','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NAO CONTEMPLADOS EM RUBRICAS ESPECIFICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.0.0.00.00','SERVICOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS FORNECIDA A ENTIDADE GOVERNAMENTAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.0.00.00','DIARIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS AOS SERVIDORES, EMPREGADOS PUBLICOS E COLABORADORES EVENTUAIS, PARA FAZER FACE A DESPESAS COM POUSADA, ALIMENTACAO E LOCOMOCAO URBANA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.00.00','DIARIAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS AOS SERVIDORES, EMPREGADOS PUBLICOS E COLABORADORES EVENTUAIS, PARA FAZER FACE A DESPESAS COM POUSADA, ALIMENTACAO E LOCOMOCAO URBANA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.01.00',' DIARIAS PESSOAL CIVIL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.01.01',' DIARIAS - PESSOAL CIVIL - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL NO PAIS,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.01.02',' DIARIAS - PESSOAL CIVIL - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL NO EXTERIOR,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.01.03',' DIARIAS - PESSOAL CIVIL - DIARIAS NAO COMPENSAVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE EMPREGADOS OU DIRETORES QUANDO EM VIAGEM A SERVICO DA EMPRESA, INDEPENDENTEMENTE DE COMPROVACAO, EM VALOR SUPERIOR AO LIMITE DEDUTIVEL PARA FINS DE DETERMINACAO DO LUCRO REAL ESTABELECIDO PELA LEGISL. ESPECIFICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.01.98',' DIARIAS - PESSOAL CIVIL - INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PESSOAL CIVIL DECORRENTES DA INTEGRACAO DOS BALANCETESDOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.01.99',' DIARIAS - PESSOAL CIVIL - OUTRAS','REGISTRA O VALOR DAS DESPESAS REALIZADAS COM OUTRAS DIARIAS - PESSOAL CIVIL NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.02.00',' DIARIAS - PESSOAL MILITAR','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DECORRENTES DO DESLOCAMENTO DO MILITAR DA SEDE DE SUA UNIDADE POR MOTIVO DE SERVICO, DESTINADAS AA INDENIZACAO DAS DESPESAS DE ALIMENTACAO E POUSADA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.02.01',' DIARIAS - PESSOAL MILITAR - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL MILITAR NO PAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.02.02',' DIARIAS - PESSOAL MILITAR - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PESSOAL MILITAR NO EXTERIOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.02.98',' DIARIAS - PESSOAL MILITAR - INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PESSOAL MILITAR DECORRENTES DA INTEGRACAO DOS BALANCETESDOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.02.99',' DIARIAS - PESSOAL MILITAR - OUTRAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTRAS DIARIAS - PESSOAL MILITAR NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.03.00',' DIARIAS - COLABORADORES EVENTUAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.03.01',' DIARIAS - COLABORADORES EVENTUAIS - NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS PARA A ADMINISTRACAO PUBLICA, EXCETO A SERVIDORES PUBLICOS OU CELETISTAS. (NO PAIS) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.03.02',' DIARIAS - COLABORADORES EVENTUAIS - NO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA (NOEXTERIOR). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.03.98',' DIARIAS - COLABORADORES EVENTUAIS - INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A COLABORADORES EVENTUAIS, DECORRENTES DA INTEGRACAO DOS BALANCETESDOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.03.99',' DIARIAS - COLABORADORES EVENTUAIS - OUTRAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTRAS DIARIAS A COLABORADORES EVENTUAIS NAO CLASSIFICAVEIS NAS RUBRICAS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.1.1.04.00','DIARIAS A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.0.00.00','SERVICOS TERCEIROS - PF','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA FISICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.00.00','SERVICOS TERCEIROS - PF - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA FISICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.01.00','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.01.01','CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.01.02','CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.01.99','OUTROS SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.02.00','PERICIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.02.01','PERICIAS TECNICAS - JUSTICA GRATUITA','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS PARA A JUSTICA GRATUITA, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA -ENGENHARIA - ESTATISTICA - INFORMATICA - E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.02.02','PERICIAS MEDICA POR BENEFICIOS','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM SERVICOS DE PERICIAS MEDICAS POR BENEFICIOS DEVIDOS AOS MEDICOS CREDENCIADOS, PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.02.99','OUTROS SERVICOS DE PERICIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.03.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE AUDITORIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.04.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.05.00','SERVICOS MEDICOS E ODONTOLOGICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MEDICOS E ODONTOLOGICOS PRESTADOS POR PESSOA FISICA, SEM VINCULO EMPREGATICIO. CONSULTAS - RAIO X - TRATAMENTO ODONTOLOGICO - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.06.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL E TREINAMENTO, POR PESSOA FISICA, INCLUSIVE A GRATIFICACAO POR ENCARGO DE CURSO OU CONCURSO, NORMATIZADA PELO ART. 76-A, DA LEI 8112/90 E O DECRETO 6114/2007. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.07.00','COMUNICACAO EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COMUNICACAO GERAL PRESTADOS POR PESSOA FISICA, TAIS COMO: CONFECCAO DE MATERIAL P/ COMUNICACAO VISUAL; GERACAO DE MATERIAS PARA DIVULGACAO POR MEIO DOS VEICULOS DE COMUNICACAO; E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.08.00','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO DE BENS IMOVEIS. DEDETIZACAO - FAXINA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.09.00','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.10.00','VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.00','MANUTENCAO E CONSERVACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.01','MANUTENCAO E CONSERVACAO DE ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.02','MANUTENCAO E CONSERVACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PEDREIRO, CARPINTEIRO E SERRALHEIRO - PINTURA - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.03','MANUTENCAO E CONSERVACAO DE REPARTICOES - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS UTILIZADOS NA MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPARTICOES SEDIADAS NO EXTERIOR ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.04','MANUTENCAO E CONSERVACAO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS E REVISOES DE VEICULOS. ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA- PINTURA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.05','MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.06','MANUTENCAO E CONSERVACAO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE: MAQUINAS E EQUIPAMENTOS GRAFICOS - APARELHOS DE FAX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES ELABORATORIAIS - CALCULADORAS - ELETRODOMESTICOS - MAQUINAS DE ESCREVER- E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.07','MANUTENCAO E CONSERVACAO DE OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE OUTROS BENS MOVEIS NAO ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.11.99','OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS NAO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.12.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS CONDOMINIAIS A CONTA DO LOCATORIO, QUANDO PREVISTAS NO CONTRATO DE LOCACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.13.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR: CORRETORES - DESPACHANTES - LEILOEIROS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.14.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE DIREITOS AUTORAIS DE PROPRIEDADE DE TERCEIROS SOBRE OBRAS CIENTIFICAS, LITERARIAS, ETC, EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO. REGISTRA O VALOR REFERENTE A UTILIZACAO DE SERVICOS DECORRENTES DE INCENTIVOS AOS AUTORES A TITULO DE ROYALTIES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.15.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA -ENGENHARIA - ESTATISTICA E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.16.00','ESTAGIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ESTUDANTES NA CONDICAO DE ESTAGIARIOS OU MONITORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.17.00','SALARIOS DE INTERNOS EM PENITENCIARIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PRESOS E INTERNOS, DE ACORDO COM A LEI NR. 3.274, DE 02/10/57. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.18.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NA MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.19.00','CONFERENCIAS, EXPOSICOES E ESPETACULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR CONFERENCISTAS, EXPOSITORES E ARTISTAS PELOS SERVICOS PRESTADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.20.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEL DE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, OS DISPENDIOS DE GARANTIA DOS ESTOQUES ARMAZENADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.21.00','LOCACOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS E IMOVEIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.21.01','LOCACAO DE IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEL DE PREDIOS, SALAS E OUTROS IMOVEIS DE PROPRIEDADE DE PESSOA FISICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.21.02','LOCACAO DE BENS MOVEIS E INTANGIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEIS DE MAQUINAS,EQUIPAMENTOS, TELEFONE FIXO E CELULAR E OUTROS BENS MOVEIS DE PROPRIEDADE DE PESSOA FISICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.21.03','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.22.00','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE REFEICOES PREPARADAS,INCLUSIVE LANCHES E SIMILARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.23.00','SERVICOS DE CARATER SECRETO OU RESERVADO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.24.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, COMO OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE) OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE PROFISSIONAL PARA MINISTRAR CURSO PROFISSIONALIZANTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.25.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES,TAIS COMO AJUDA DE CUSTO SUPLETIVA, GENEROS ALIMENTICIOS, DOCUMENTACAO, TRANSPORTE E SEPULTAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.26.00','SERV. DE APOIO ADMIN., TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA, TAIS COMO: ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.27.00','SERV. DE CONSERV. E REBENEFIC. DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA NA CONSERVACAO E REBENEFICIAMENTO DE MERCADORIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.28.00','CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA FISICA NA CONFECCAO DE: BOLSAS - CAIXAS - MOCHILAS - SACOLAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.29.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COSTUREIRAS, ALFAIATES E AFINS UTILIZADOS NA CONFECCAO DE UNIFORMES, BANDEIRAS, FLAMULAS, BRA-SOES E ESTANDARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.30.00','FRETES E TRANSPORTES DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA FISICA EM: FRETES E CARRETOS - REMESSA DE ENCOMENDAS - TRANSPORTE DE MERCADORIASE PRODUTOS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.31.00','JETONS E GRATIFICACOES A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA PARTICIPACAO EM ORGAOS DE DELIBERACOES COLETIVAS(CONSELHOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.34.00','SERVICOS DE AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES E FOTOGRAFIAS, PRESTADOS POR PESSOA FISICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.35.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E SERVICOS DE CARTORIO, QUANDO A NOTA E EMITIDA EM NOME DO TABELIAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.36.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.37.00','HOSPEDAGENS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS, A LOCAIS ONDE NAO EXISTEM ESBELECIMENTOS COMERCIAIS HABILITADOS EM PRESTAR ESSE TIPO DE SERVICOS, PAGOS DIRETAMENTE A PESSOAS FISICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.00','DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES AEREOS,TERRESTRES, FLUVIAIS OU MARITIMAS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.01','LOCACAO DE MEIOS DE TRANSPORTE',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.02','MUDANCAS EM OBJETO DE SERVICO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.03','LOCOMOCAO URBANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIO DE TRANSPORTE URBANO, COMO: ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.04','PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIO DE TRANSPORTE NA SUPERVISAO DE VENDAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.05','TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.38.99','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES NAO ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.39.00','SERVICOS GRAFICOS E EDITORIAIS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA FISICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TERCEIROS - PESSOA FISICA DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS, NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.2.1.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS SERVICOS PRESTADOS POR PESSOA FISICA, NAO CONTEMPLADOS EM ITENS ESPECIFICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.0.00.00','SERVICOS TERCEIROS - PJ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.00.00','SERVICOS TERCEIROS - PJ - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.01.00','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.01.01','CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.01.02','CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.01.99','OUTROS SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.02.00','PERICIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.02.01','PERICIAS TECNICAS - JUSTICA GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES_AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.02.02','PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.02.99','OUTROS SERVICOS DE PERICIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.03.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.04.00','COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.04.01','TELECOMUNICACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.04.02','CORRESPONDENCIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.04.03','COMUNICACAO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.04.99','OUTROS SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.05.00','PUBLICIDADE','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.05.01','PUBLICIDADE LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.05.02','PUBLICIDADE DE UTILIDADE PUBLICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.05.03','PUBLICIDADE INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.05.04','PUBLICIDADE MERCADOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.05.99','OUTROS SERVICOS DE PUBLICIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.00','MANUTENCAO E CONSERVACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.01','MANUT. CONSERV. ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.02','MANUT. CONSERV. BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.03','MANUT. CONSERV. REPARTICOES - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.04','MANUT. CONSERV. VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.05','MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.06','MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.07','MANUT. CONSERV. SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.08','MANUT. CONSERV. OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.06.99','OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.00','SERVICOS DE APOIO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.01','APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.02','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.03','VIGILANCIA OSTENSIVA/ MONITORADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.04','SERVICOS DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.05','SERVICOS DE SOCORRO E SALVAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.06','SERVICOS DE ESTACIONAMENTO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.07','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.07.99','OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.08.00','SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.08.01','SERVICOS DE AGUA E ESGOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.08.02','SERVICOS DE ENERGIA ELETRICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.08.03','SERVICOS DE GAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.09.00','SERVICOS DE ALIMENTACAO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.09.01','PROGRAMA DE ALIMENTACAO DO TRABALHADOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.09.02','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.00','LOCACOES','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.01','LOCACAO DE IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.02','LOCACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.03','LOCACAO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.04','LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.05','LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.10.06','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.11.00','SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.11.01','DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, COM ACRESCIMO DE FUNCOES (EVOLUTIVAS)','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.11.02','SUPORTE DE INFRAESTRUTURA DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.11.03','SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.11.04','HOSPEDAGEM DE SISTEMAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.11.05','SERVICOS TECNICOS PROFISSIONAIS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.12.00','SERVICOS DE TRANSPORTE','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.12.01','VALE- TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.12.02','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.12.03','FRETE E TRANSPORTE DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.13.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.14.00','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.15.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.16.00','CLASSIFICACAO DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.17.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.18.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.19.00','CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.20.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.21.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.22.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.23.00','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.24.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.25.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.26.00','PATROCINIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.27.00','PRODUCOES JORNALISTICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.28.00','PROMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.29.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.30.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.31.00','SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.32.00','SERVICOS BANCARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS E OUTRAS INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.33.00','SERVICOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.34.00','SERVICOS DE APOIO DO ENSINO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.35.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.36.00','SERVICOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.37.00','SERVICOS DE CARATER SECRETO OU RESERVADO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.38.00','SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.39.00','SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.40.00','SERVICOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.41.00','SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.42.00','SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.43.00','SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.44.00','SERVICOS DE PRODUCAO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.45.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.46.00','SERVICOS DE ITENS REPARAVEIS DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.47.00','SERVICOS FUNERARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.48.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.49.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.50.00','SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.51.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.52.00','TAXA DE ADMINISTRACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.53.00','VISTOS CONSULARES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.00','LOCACAO DE MAO-DE-OBRA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.01','LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.02','LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.03','LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.04','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.05','LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.06','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.07','LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.08','LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.09','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.10','LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.11','LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.54.99','OUTRAS LOCACOES DE MAO DE OBRA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.01','ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.02','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.03','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.04','ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.05','ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.55.99','OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.00','PASSAGENS E DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.01','PASSAGENS PARA O PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.02','PASSAGENS PARA O EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.03','LOCACAO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.04','MUDANCAS EM OBJETO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.05','LOCOMOCAO URBANA','REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.06','PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS','REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.07','DESPESAS COM EXCESSO DE BAGAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.08','PEDAGIOS','REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.09','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.10','TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.56.99','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.1.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.00.00','SERVICOS TERCEIROS - PJ - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.01.00','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.01.01','CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.01.02','CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.01.99','OUTROS SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.02.00','PERICIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.02.01','PERICIAS TECNICAS - JUSTICA GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES_AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.02.02','PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.02.99','OUTROS SERVICOS DE PERICIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.03.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.04.00','COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.04.01','TELECOMUNICACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.04.02','CORRESPONDENCIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.04.03','COMUNICACAO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.04.99','OUTROS SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.05.00','PUBLICIDADE','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.05.01','PUBLICIDADE LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.05.02','PUBLICIDADE DE UTILIDADE PUBLICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.05.03','PUBLICIDADE INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.05.04','PUBLICIDADE MERCADOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.05.99','OUTROS SERVICOS DE PUBLICIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.00','MANUTENCAO E CONSERVACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.01','MANUT. CONSERV. ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.02','MANUT. CONSERV. BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.03','MANUT. CONSERV. REPARTICOES - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.04','MANUT. CONSERV. VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.05','MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.06','MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.07','MANUT. CONSERV. SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.08','MANUT. CONSERV. OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.06.99','OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.00','SERVICOS DE APOIO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.01','APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.02','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.03','VIGILANCIA OSTENSIVA/ MONITORADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.04','SERVICOS DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.05','SERVICOS DE SOCORRO E SALVAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.06','SERVICOS DE ESTACIONAMENTO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.07','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.07.99','OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.08.00','SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.08.01','SERVICOS DE AGUA E ESGOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.08.02','SERVICOS DE ENERGIA ELETRICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.08.03','SERVICOS DE GAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.09.00','SERVICOS DE ALIMENTACAO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.09.01','PROGRAMA DE ALIMENTACAO DO TRABALHADOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.09.02','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.00','LOCACOES','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.01','LOCACAO DE IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.02','LOCACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.03','LOCACAO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.04','LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.05','LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.10.06','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.11.00','SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.11.01','DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, COM ACRESCIMO DE FUNCOES (EVOLUTIVAS)','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.11.02','SUPORTE DE INFRAESTRUTURA DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.11.03','SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.11.04','HOSPEDAGEM DE SISTEMAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.11.05','SERVICOS TECNICOS PROFISSIONAIS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.12.00','SERVICOS DE TRANSPORTE','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.12.01','VALE- TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.12.02','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.12.03','FRETE E TRANSPORTE DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.13.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.14.00','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.15.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.16.00','CLASSIFICACAO DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.17.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.18.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.19.00','CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.20.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.21.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.22.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.23.00','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.24.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.25.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.26.00','PATROCINIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.27.00','PRODUCOES JORNALISTICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.28.00','PROMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.29.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.30.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.31.00','SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.32.00','SERVICOS BANCARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS E OUTRAS INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.33.00','SERVICOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.34.00','SERVICOS DE APOIO DO ENSINO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.35.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.36.00','SERVICOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.37.00','SERVICOS DE CARATER SECRETO OU RESERVADO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.38.00','SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.39.00','SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.40.00','SERVICOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.41.00','SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.42.00','SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.43.00','SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.44.00','SERVICOS DE PRODUCAO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.45.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.46.00','SERVICOS DE ITENS REPARAVEIS DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.47.00','SERVICOS FUNERARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.48.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.49.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.50.00','SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.51.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.52.00','TAXA DE ADMINISTRACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.53.00','VISTOS CONSULARES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.00','LOCACAO DE MAO-DE-OBRA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.01','LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.02','LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.03','LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.04','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.05','LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.06','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.07','LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.08','LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.09','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.10','LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.11','LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.54.99','OUTRAS LOCACOES DE MAO DE OBRA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.01','ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.02','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.03','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.04','ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.05','ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.55.99','OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.00','PASSAGENS E DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.01','PASSAGENS PARA O PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.02','PASSAGENS PARA O EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.03','LOCACAO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.04','MUDANCAS EM OBJETO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.05','LOCOMOCAO URBANA','REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.06','PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS','REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.07','DESPESAS COM EXCESSO DE BAGAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.08','PEDAGIOS','REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.09','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.10','TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.56.99','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.57.00','TAXA SOBRE TERRENO DE MARINHA','REGISTRA O VALOR PAGO SOBRE A VENDA DE TERRENOS DE MARINHA, TAIS COMO FORO, LAUDEMIO E TAXA DE OCUPACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.2.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.00.00','SERVICOS TERCEIROS - PJ - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POR PESSOA JURIDICA FORNECIDA A ENTIDADE GOVERNAMENTAL. NA CLASSIFICACAO DA DESPESA DE MATERIAL POR ENCOMENDA, A VARIACAO PATRIMONIAL DIMINUTIVA SO DEVERA SER CLASSIFICADA COM SERVICOS DE TERCEIROS SE O PROPRIO ORGAO OU ENTIDADE FORNECER A MATERIA-PRIMA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.01.00','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.01.01','CONSULTORIA E ASSESSORIA - JURIDICA E TECNICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.01.02','CONSULTORIA E ASSESSORIA - TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONSULTORIA OU ASSESSORIA NA AREA DE TECNOLOGIA DA INFORMACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.01.99','OUTROS SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.02.00','PERICIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.02.01','PERICIAS TECNICAS - JUSTICA GRATUITA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS PARA A JUSTICA GRATUITA, NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA ESTATISTICA - MEDICINA - VARAS JUDICIAIS DO TRABALHO E OUTRAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.02.02','PERICIAS MEDICA, ODONTOLOGICA POR BENEFICIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTESS DA UTILIZACAO DE SERVICOS DE PERICIAS MEDICAS/ODONTO.POR BENEFICIO, DEVIDAS A ENTIDADES MEDICAS/ODONTOLOGICAS CREDENCIADAS,PARA EXAMES REALIZADOS EM SEGURADOS E/OU SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.02.99','OUTROS SERVICOS DE PERICIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS, NAO CONTEMPLADAS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.03.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AUDITORIA EXTERNA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.04.00','COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.04.01','TELECOMUNICACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TELECOMUNICACAO, INCLUSIVE TELEFONIA CELULAR, CENTREX 2000, TARIFA DE HABILITACAO E CARTOES TELEFONICOS PARA APARELHOS DE CELULAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.04.02','CORRESPONDENCIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CORRESPONDECIAS, PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - CORREIOS E TELEGRAFOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.04.03','COMUNICACAO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO DE DADOS: - LOCACAO DE CIRCUITO DE DADOS LOCAIS OU INTERURBANOS PARA ATENDIMENTO DE NOS DE COMUTACAO - CONCENTRACAO E NOS DE ACESSO DA REDE DE COMUNICACAO - SERVICOS DE REDE PRIVATIVA VIRTUAL - SLDD - TOPNET - DATASATPLUS - DATASAT-BI - ATMNET - INTERNET - IP DIRETO - STM400 - FASTNET -REMAV - FRAME-RELAY - SDH. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.04.99','OUTROS SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.05.00','PUBLICIDADE','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.05.01','PUBLICIDADE LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE LEGAL, QUE SE REALIZA EM OBEDIENCIA A PRESCRICAO DE LEIS, DECRETOS, PORTARIAS, INSTRUCOES, ESTATUTOS, REGIMENTOS OU REGULAMENTOS INTERNOS DOS INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL - SICOM, PRESTADOS POR PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.05.02','PUBLICIDADE DE UTILIDADE PUBLICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE REFERENTES A DIVULGACAO DE ACOES DESTINADAS A INFORMAR, ESCLARECER, ORIENTAR, MOBILIZAR, PREVINIR OU ALERTAR A POPULACAO COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE E DE ESTIMULAR A ADOCAO DE COMPORTAMENTOS QUE PERMITAM MELHORAR SUA QUALIDADE DE VIDA ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.05.03','PUBLICIDADE INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, PESQUISAS,ASSESSORIA DE IMPRENSA, RELACOES PUBLICAS E COMUNICACAO DIGITAL REFERENTES AA DIVULGACAO DE ATOS, ACOES, PROGRAMAS, OBRAS, SERVICOS, CAMPANHAS METAS E RESULTADOS DOS ORGAOS E ENTIDADES GOVERNAMENTAIS, COM O OBJETIVO DE PROPICIAR O ATENDIMENTO AO PRINCIPIO CONSTITUCIONAL DA PUBLICIDADE, VALORIZAR E FORTALECER AS INSTITUICOES, ESTIMULAR A PARTICIPACAO SOCIAL NO DEBATE, NO CONTROLE E NA FORMULACAO DE POLITICAS PUBLICAS E PROMOVER O BRASIL NO EXTERIOR, CONFORME DISPOE O DECRETO 6555/2008 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.05.04','PUBLICIDADE MERCADOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE MERCADOLOGICA, QUE SE DESTINA A LANCAR, MODIFICAR, REPOSICIONAR OU PROMOVER PRODUTOS E SERVICOS DE INTEGRANTES DO SISTEMA DE COMUNICACAO DE GOVERNO DO PODER EXECUTIVO FEDERAL (SICOM), QUE ATUEM NUMA RELACAO DE CONCORRENCIA NO MERCADO, PRESTADOS POR PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.05.99','OUTROS SERVICOS DE PUBLICIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PUBLICIDADE, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.00','MANUTENCAO E CONSERVACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.01','MANUT. CONSERV. ESTRADAS E VIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, RECUPERACOES E ADAPTACOES DE ESTRADAS, FERROVIAS E RODOVIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.02','MANUT. CONSERV. BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE BENS IMOVEIS. PINTURA - REPAROS E REFORMAS DE IMOVEIS EM GERAL - REPAROS EM INSTALACOES ELETRICAS E HIDRAULICAS - REPAROS, RECUPERACOES E ADAPTACOES DE BIOMBOS, CARPETES, DIVISORIAS E LAMBRIS - MANUTENCAO DE ELEVADORES -LIMPEZA DE FOSSA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.03','MANUT. CONSERV. REPARTICOES - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PARA A MANUTENCAO DE EMBAIXADAS, CONSULADOS, VICE-CONSULADOS, MISSOES DIPLOMATICAS E OUTRAS REPATICOES SEDIADAS NO EXTERIOR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.04','MANUT. CONSERV. VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, MANUTENCAO, CONSERTOS, CONSERVACAO E REVISOES DE VEICULOS, TAIS COMO: ALINHAMENTO E BALANCEAMENTO - ESTOFAMENTO - FUNILARIA - INSTALACAO ELETRICA - LANTERNAGEM - MECANICA - PINTURA - FRANQUIA E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.05','MANUT. CONSERV. EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS - HARDWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.06','MANUT. CONSERV. MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE COM SERVICOS DE REPAROS, CONSERTOS, REVISOES E ADAPTACOES DE MAQUINAS E EQUIPAMENTOS. APARELHOS DE FAX E TELEX - APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - CALCULADORAS -ELETRODOMESTICOS - EQUIPAMENTOS DE PROTECAO E SEGURANCA - EQUIPAMENTOS GRAFICOS - EQUIPAMENTOS AGRICOLAS - MAQUINAS DE ESCREVER - TURBINAS EOUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.07','MANUT. CONSERV. SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.08','MANUT. CONSERV. OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE REPAROS, CONSERTOS, REVISOES, INSPECOES E ADAPTACOES DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.06.99','OUTROS SERVICOS DE MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS, NAO COMTEMPLADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.00','SERVICOS DE APOIO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.01','APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. - ASSISTENCIA TECNICA - COMISSARIA AEREA E APOIO SOLO - JARDINAGEM- OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - INSTALACOES DE EQUIPAMENTOS DE SEGURANCA - DA REDE ELETRICA - REDE HIDRAULICA - TELEFONIA - COMUNICACAO E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.02','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERV. DE LIMPEZA,HIGIENIZACAO, COLETA DE LIXO, RETIRADA DE ENTULHO,CONSERV.DEDETIZACAO E ASSEIO DOS ORGAOS PUBLICOS (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVOFISICO DO PESSOAL A SER UTILIZADO). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.03','VIGILANCIA OSTENSIVA/ MONITORADA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE VIGILANCIA E SEGURANCA DE REPARTICOES PUBLICAS, DE AUTORIDADES (NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO),DESPESA COM MONITORAMENTO ELETRONICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.04','SERVICOS DE MANOBRA E PATRULHAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE DAR SUPORTE AS OPERACOES ESPECIAIS REALIZADAS POR ORGAOS DAS FORCAS ARMADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.05','SERVICOS DE SOCORRO E SALVAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS PARA PROTECAO,SOCORRO E SALVAMENTO DE PESSOAS E BENS PUBLICOS. SERVICOS PRESTADOS POR: - AMBULANCIAS PARTICULARES - U.T.I MOVEIS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.06','SERVICOS DE ESTACIONAMENTO DE VEICULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ESTACIONAMENTO DE VEICULOS, TAIS COMO: ALUGUEIS DE VAGAS, MANOBRISTAS, ETC. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.07','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA JURIDICA, SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.07.99','OUTROS SERVICOS DE APOIO ADM, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PUBLICOS, NOS CASOS EM QUE O CONTRATO NAO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO, NAO COMTEMPLADOS EM ITENS ANTERIORES..','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.08.00','SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.08.01','SERVICOS DE AGUA E ESGOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE AGUA E ESGOTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.08.02','SERVICOS DE ENERGIA ELETRICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ENERGIA ELETRICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.08.03','SERVICOS DE GAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE GAS CANALIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.09.00','SERVICOS DE ALIMENTACAO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FORNECIMENTO DE ALIMENTACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.09.01','PROGRAMA DE ALIMENTACAO DO TRABALHADOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE ALIMENTACAO A TRABALHADORES, EM QUE A PESSOA JURIDICA POSSUA PROGRAMA DE ALIMENTACAO APROVADO PELO MINISTERIO DO TRABALHO E POSSA USUFRUIR DE BENEFICIO FISCAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.09.02','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICO DE FORNECIMENTO DE REFEICOES PREPARADAS, INCLUSIVE LANCHES E SIMILARES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.00','LOCACOES','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.01','LOCACAO DE IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PREDIOS, SALAS E OUTROS IMOVEIS DE INTERESSE DA ADMINISTRACAO PUBLICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.02','LOCACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE PROGRAMAS DE PROCESSAMENTO DE DADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.03','LOCACAO DE MAQUINAS E EQUIPAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM ALUGUEIS DE MAQUINAS E EQUIPAMENTOS, TAIS COMO: APARELHOS DE MEDICAO E AFERICAO - APARELHOS MEDICOS, ODONTOLOGICOS, HOSPITALARES E LABORATORIAIS - APARELHOS TELEFONICOS, TELES E FAX -CALCULADORAS - ELETRODOMESTICOS - EQUIPAMENTOS GRAFICOS - MAQUINAS DE ESCREVER -TURBINAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.04','LOCACAO DE BENS MOVEIS DE OUTRAS NATUREZAS E INTANGIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE BENS MOVEIS NAO CONTEMPLADOS EM ITENS ESPECIFICOS E BENS INTANGIVEIS. LOCACAO DE LINHA TELEFONICA - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.05','LOCACAO DE EQUIPAMENTOS DE PROC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ALUGUEIS DE EQUIPAMENTOS DE PROCESSAMENTO DE DADOS E PERIFERICOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.10.06','TRIBUTOS A CONTA DO LOCATARIO OU CESSIONARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS TRIBUTOS A CONTA DO LOCATARIO OU DO CESSIONARIO, QUANDO PREVISTOS NO CONTRATO DE LOCACAO OU CESSAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.11.00','SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.11.01','DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATUALIZACAO E ADAPTACAO DE SOFTWARE, COM ACRESCIMO DE FUNCOES (EVOLUTIVAS)','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.11.02','SUPORTE DE INFRAESTRUTURA DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.11.03','SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS AO ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.11.04','HOSPEDAGEM DE SISTEMAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE DATACENTER POR MODELOS COMO HOSTING OU COLOCATION.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.11.05','SERVICOS TECNICOS PROFISSIONAIS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS NA AREA DE TECNOLOGIA DA INFORMACAO, EXCETO QUANDO FOREM CLASSIFICADO EM UMA DAS SEGUINTES CONTAS: DESENVOLVIMENTO DE SOFTWARE; SUPORTE DE INFRAESTRUTURA DE T.I.; SUPORTE A USUARIOS DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.12.00','SERVICOS DE TRANSPORTE','COMPRENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.12.01','VALE- TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS DEVIDO AO FORNECIMENTO DE VALE-TRANSPORTE PARA OS TRABALHADORES DE UMA ENTIDADE, TAIS COMO, SERVIDORES, EMPREGADOS,ESTAGIARIOS, ENTRE OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.12.02','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.12.03','FRETE E TRANSPORTE DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE TRANSPORTE DE MERCADORIAS E PRODUTOS DIVERSOS, PRESTADOS POR PESSOA JURIDICA. - FRETES E CARRETOS - REMESSA DE ENCOMENDAS E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.13.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIACOES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.14.00','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICACOES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NAO SE DESTINEM A COLECOES OU BIBLIOTECAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.15.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.16.00','CLASSIFICACAO DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.17.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVICOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.18.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.19.00','CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.20.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXILIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.21.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.22.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.23.00','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.24.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.25.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NAO HOUVER PAGAMENTO DE DIARIAS). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.26.00','PATROCINIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, ACOES, BENS OU SERVICOS. NAO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALACOES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NAO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.27.00','PRODUCOES JORNALISTICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.28.00','PROMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NAO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PUBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVICOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.29.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.30.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.31.00','SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.32.00','SERVICOS BANCARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERACOES DECORRENTES DE SERVICOS PRESTADOS POR BANCOS E OUTRAS INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.33.00','SERVICOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NAO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.34.00','SERVICOS DE APOIO DO ENSINO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.35.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTICIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.36.00','SERVICOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES, REVELACOES, AMPLIACOES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.37.00','SERVICOS DE CARATER SECRETO OU RESERVADO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.38.00','SERVICOS DE CONFECCAO SELOS CONTROLE FISCAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.39.00','SERVICOS DE CONSERV. E REBENEF. DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.40.00','SERVICOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE CONTROLE AMBIENTAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.41.00','SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRAFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICACOES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.42.00','SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.43.00','SERVICOS DE INCINERACAO/DESTRUICAO DE MATERIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.44.00','SERVICOS DE PRODUCAO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATERIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVICOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.45.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.46.00','SERVICOS DE ITENS REPARAVEIS DE AVIACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVASCOM A CONTRATACAO DE SERVICOS ESPECIFICOS PARA A MANUTENCAO DE ITENS REPARAVEIS DE AVIACAO: ASAS, MOTORES, FUSELAGEM, EQUIPAMENTO DE BORDO, ETC E AINDA, NA RECUPERACAO DE MATERIAL DE AVIACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.47.00','SERVICOS FUNERARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REMOCOES, SEPULTAMENTOS E TRANSLADACOES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.48.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.49.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVICOS DE CARTORIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.50.00','SERVICOS RELACIONADOS A INDUSTRIA AEROESPACIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LANCAMENTO E COLOCACAO EM ORBITA DE SATELITES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.51.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVICOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.52.00','TAXA DE ADMINISTRACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVICOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUICOES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.53.00','VISTOS CONSULARES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE VISTOS CONSULARES JUNTO A EMBAIXADAS E CONSULADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.00','LOCACAO DE MAO-DE-OBRA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PUBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.01','LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINA - MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES E OUTROS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.02','LOCACAO DE MAO-DE-OBRA DE LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO EM GERAL, TAIS COMO: LIMPEZA E CONSERVACAO DE IMOVEIS, LAVAGEM DE VEICULOS, LAVAGEM E HIGIENIZACAO DE ROUPAS E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.03','LOCACAO DE MAO-DE-OBRA DE VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.04','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR REPAROS E REFORMAS DE IMOVEIS EM GERAL, INSTAL. ELETRICAS, HIDRAUL. E CORRELATAS DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DE PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.05','LOCACAO DE MAO-DE-OBRA DE SERVICOS DE COPA E COZINHA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE MAO-DE-OBRA PARA EFETUAR SERVICOS INERENTES A COPA E COZINHA, TAIS COMO: PREPARO DE ALIMENTACAO, LANCHES, CAFE E OUTROS, DESDE QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO DE PESSOAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.06','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO DE BENS MOVEIS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.07','LOCACAO DE MAO-DE-OBRA DE SERVICOS DE BRIGADA DE INCENDIO.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE BRIGADA DE INCENDIO EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.08','LOCACAO DE MAO-DE-OBRA DE APOIO ADMINISTRATIVO - MENORES-APRENDIZES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE APOIO ADMINISTRATIVO, OPERACIONAL E ASSISTENCIA TECNICA NECESSARIOS A MANUTENCAO DAS ATIVIDADES DO ORGAO, COM A CONTRATACAO DE MAO-DE-OBRA DE MENORES APRENDIZES. (BASE LEGAL - LEI N. 10.097 DE 19/12/2000). NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.09','LOCACAO DE MAO-DE-OBRA DE MANUTENCAO DE SOFTWARE','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS, ATUALIZACAO E ADAPTACAO DE SOFTWARE, SUPORTE, MANUTENCAO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS, MANUTENCAO DE SUSTENTACAO (CORRETIVA, PREVENTIVA E ADAPTATIVA) DE SOFTWARE E RENOVACAO DE LICENCA DE USO DE SOFTWARE ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.10','LOCACAO DE MAO-DE-OBRA DE SUPORTE DE INFRAESTRUTURA DE T.I.',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE OPERACAO E MONITORAMENTO PARA SUPORTE A INFRAESTRUTURA DA REDE, MAINFRAME, HIGHEND E OUTRAS PLATAFORMAS DE TI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.11','LOCACAO DE MAO-DE-OBRA DE SUPORTE A USUARIOS DE T.I.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS DE ATENDIMENTO DE USUARIOS FINAIS DE TI, ENGLOBANDO SERVICOS REMOTOS DE ATENDIMENTO TELEFONICO E SERVICOS DE ATENDIMENTO LOCAL. NO CASO DE CONTRATOS DE CALLCENTER DEVEM SER REGISTRADOS NESTA CONTA SOMENTE OS CONTRATOS CUJO ATENDIMENTO DIRECIONA-SE PREDOMINANTEMENTE A SERVICOS DE T.I. OU SE GESTAO DO CONTRATO FOR DE RESPONSABILIDADE DA AREA DE T.I. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.54.99','OUTRAS LOCACOES DE MAO DE OBRA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE OUTROS SERVICOS DE LOCACOES DE MAO-DE-OBRA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.01','ARRENDAMENTO MERCANTIL OPERACIONAL DE MAQUINAS E APARELHOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE MAQUINAS E APARELHOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.02','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS FERROVIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS FERROVIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.03','ARRENDAMENTO MERCANTIL OPERACIONAL DE VEICULOS RODOVIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE VEICULOS RODOVIARIOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.04','ARRENDAMENTO MERCANTIL OPERACIONAL DE OUTROS BENS MOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE OUTROS BENS MOVEIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.05','ARRENDAMENTO MERCANTIL OPERACIONAL DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL DE BENS IMOVEIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.55.99','OUTROS ARRENDAMENTOS MERCANTIS OPERACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL, NAO ESPECIFICADOS EM ITENS ANTERIORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.00','PASSAGENS E DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.01','PASSAGENS PARA O PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO PAIS EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.02','PASSAGENS PARA O EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS, TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EM-BARQUE,SEGUROS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS NO EXTERIOR EM DECORRENCIA DE MUDANCAS DE DOMICILIOS NO INTERESSE DA ADMINISTRACAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.03','LOCACAO DE MEIOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO DE MEIOS DE TRANSPORTE, TAIS COMO: VEICULOS, AERONAVES, EMBARCACOES E ASSEMELHADOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.04','MUDANCAS EM OBJETO DE SERVICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DA LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.05','LOCOMOCAO URBANA','REGISTRA AS APROPRIACOES DE DESPESAS COM LOCOMOCAO URBANA REALIZADA POR MEIO DE ONIBUS, TAXI E OUTROS VEICULOS DE TRANSPORTES URBANOS,PARA ATENDER NECESSIDADE DO SERVICO, COMPREENDENDO, TAMBEM, DESLOCAMENTOS PARA REALIZACAO DE PESQUISAS E REEMBOLSO COM TRANSPORTE. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.06','PASSAGENS E LOCOMOCAO NA SUPERVISAO DE VENDAS','REGISTRA O VALOR DAS APROPR.DAS DESPESAS COM PASSAGENS E LOCOMOCOES URBANAS NA SUPERVISAO DE VENDAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.07','DESPESAS COM EXCESSO DE BAGAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACOES DE DESPESAS COM EXCESSO DE BAGAGEM ATINENTES AOS VOLUMES E MATERIAIS INDISPENSAVEL A EXECUCAO DO TRABALHO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.08','PEDAGIOS','REGISTRA O VALOR DAS DESPESAS COM TARIFAS DE PEDAGIO, TAXA MENSAL PELA UTILIZACAO DO SISTEMA E ADESAO AO SISTEMA DE IDENTIFICACAO DO VEICULO SEM A NECESSIDADE DE PARA-LO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.09','TRANSPORTE DE SERVIDORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR EMPRESAS,PARA TRANSPORTAR SERVIDORES, SEJA NO PERCURSO RESIDENCIA-LOCAL DE TRABALHO, SEJA NA EXECUCAO DE TAREFAS PELOS SERVIDORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.10','TAXA DE SERV. EMISSAO BILHETES NAO UTILIZADOS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS C/ TAXA DE SERVICO PAGA PELA AQUISICAO DE PASSAGENS NAO UTILIZADAS, CANCELADAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.56.99','OUTRAS DESPESAS COM LOCOMOCAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS E MEIOS DE TRANSPORTE NAO ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.3.3.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA JURIDICA, QUE NAO ESTEJA ESPECIFICADOS EM ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.4.0.00.00','CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA - ART. 18 § 1, LC 101/00','COMPREENDE A APROPRIACAO DAS DESPESAS RELATIVAS A MAO-DE-OBRA, CONSTANTES DOS CONTRATOS DE TERCEIRIZACAO, CLASSIFICAVEIS NO GRUPO DE DESPESA COM PESSOAL E ENCARGOS EM OBEDIENCIA AO DISPOSTO NO ARTIGO 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.2.4.1.00.00','CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA - ART. 18 § 1, LC 101/00 - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MAO-DE-OBRA, CONSTANTES DOS CONTRATOS DE TERCEIRIZACAO, CLASSIFICAVEIS NO GRUPO DE DESPESA COM PESSOAL E ENCARGOS EM OBEDIENCIA AO DISPOSTO NO ARTIGO 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.0.0.00.00','DEPRECIACAO, AMORTIZACAO E EXAUSTAO','COMPREENDE O DECRESCIMO NO BENEFICIO DE UM BEM DURANTE O PERIODO CONTABIL DECORRENTE DE DEPRECIACAO, AMORTIZACAO E EXAUSTAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.1.0.00.00','DEPRECIACAO','COMPREENDE A REDUCAO DO VALOR DOS BENS TANGIVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.1.1.00.00','DEPRECIACAO - EXTRA OFSS','COMPREENDE A REDUCAO DO VALOR DOS BENS TANGIVEIS PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.1.1.01.00','DEPRECIACAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR DOS BENS TANGIVEIS ,DO ATIVO IMOBILIZADO, PELO DESGASTE OU PERDA DE UTILIDADE POR USO, ACAO DA NATUREZA OU OBSOLESCENCIA','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.2.0.00.00','AMORTIZACAO','COMPREENDE A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.2.1.00.00','AMORTIZACAO - EXTRA OFSS','COMPREENDE A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.2.1.01.00','AMORTIZACAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS, DO ATIVO IMOBILIZADO, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.2.1.02.00','AMORTIZACAO DE INTANGIVEL','REGISTRA A REDUCAO DO VALOR APLICADO NA AQUISICAO DE DIREITOS DE PROPRIEDADE E QUAISQUER OUTROS, INCLUSIVE ATIVOS INTANGIVEIS, COM EXISTENCIA OU EXERCICIO DE DURACAO LIMITADA, OU CUJO OBJETO SEJAM BENS DE UTILIZACAO POR PRAZO LEGAL OU CONTRATUALMENTE LIMITADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.3.0.00.00','EXAUSTAO','COMPREENDE A REDUCAO DO VALOR, DECORRENTE DA EXPLORACAO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.3.1.00.00','EXAUSTAO - EXTRA OFSS','COMPREENDE A REDUCAO DO VALOR, DECORRENTE DA EXPLORACAO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.3.3.1.01.00','EXAUSTAO DE IMOBILIZADO','REGISTRA A REDUCAO DO VALOR, DECORRENTE DA EXPLORACAO, DOS RECURSOS MINERAIS, FLORESTAIS E OUTROS RECURSOS NATURAIS ESGOTAVEIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.0.0.00.00','CUSTO DE MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADOS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.01.00','CMV - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.02.00','CMV - MERCADORIAS PARA VENDA','REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.03.00','CMV -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.04.00','CMV -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.05.00','CMV -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.06.00','CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.07.00','CMV -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.08.00','CMV -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.1.09.00','CMV -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.01.00','CMV - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.02.00','CMV - MERCADORIAS PARA VENDA','REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.03.00','CMV -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.04.00','CMV -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.05.00','CMV -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.06.00','CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.07.00','CMV -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.08.00','CMV -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.2.09.00','CMV -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.00.00','CUSTO DE MERCADORIAS VENDIDAS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.01.00','CMV - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.02.00','CMV - MERCADORIAS PARA VENDA','REGISTRA A APROPRIACAO DE MERCADORIAS PARA VENDA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.03.00','CMV -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.04.00','CMV -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.05.00','CMV -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.06.00','CMV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.07.00','CMV -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.08.00','CMV -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.1.3.09.00','CMV -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.01.00','CPV - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.02.00','CPV -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.03.00','CPV -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.04.00','CPV -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.05.00','CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.06.00','CPV -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.07.00','CPV -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.1.08.00','CPV -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.00.00','CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.01.00','CPV - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.02.00','CPV -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.03.00','CPV -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.04.00','CPV -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.05.00','CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.06.00','CPV -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.07.00','CPV -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.2.08.00','CPV -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.00.00','CUSTO DE PRODUTOS VENDIDOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.01.00','CPV - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.02.00','CPV -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.03.00','CPV -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.04.00','CPV -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.05.00','CPV - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.06.00','CPV -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.07.00','CPV -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.2.3.08.00','CPV -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.0.00.00','CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.00.00','CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.01.00','CSP - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.02.00','CSP -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.03.00','CSP -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.04.00','CSP -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.05.00','CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.06.00','CSP -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.07.00','CSP -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.1.08.00','CSP -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.00.00','CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.01.00','CSP - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.02.00','CSP -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.03.00','CSP -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.04.00','CSP -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.05.00','CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.06.00','CSP -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.07.00','CSP -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.2.08.00','CSP -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.00.00','CUSTO DE SERVICOS PRESTADOS - MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MATERIAIS, SERVICOS E CONSUMO DE CAPITAL FIXO UTILIZADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.01.00','CSP - CONSUMO DE MATERIAL','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.02.00','CSP -DIARIAS','REGISTRA A APROPRIACAO DE DIARIAS NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.03.00','CSP -SERVICOS TERCEIROS - PF','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PF NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.04.00','CSP -SERVICOS TERCEIROS - PJ','REGISTRA A APROPRIACAO DE SERVICOS DE TERCEIROS DE PJ NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.05.00','CSP - CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA','REGISTRA A APROPRIACAO DE CONTRATO DE TERCEIRIZACAO POR SUBSTITUICAO DE MAO DE OBRA NO CUSTO DE SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.06.00','CSP -DEPRECIACAO','REGISTRA A APROPRIACAO DE DEPRECIACAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.07.00','CSP -AMORTIZACAO','REGISTRA A APROPRIACAO DE AMORTIZACAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.3.8.3.3.08.00','CSP -EXAUSTAO','REGISTRA A APROPRIACAO DE EXAUSTAO NO CUSTO DOS SERVICOS PRESTADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.0.0.0.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES FINANCEIRAS, TAIS COMO: JUROS INCORRIDOS, DESCONTOS CONCEDIDOS, COMISSOES, DESPESAS BANCARIAS E CORRECOES MONETARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS OBTIDOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.0.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.01.00','JUROS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.02.00','JUROS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.03.00','ENCARGOS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.04.00','ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.98.00','INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.1.99.00','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.2.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.2.05.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.2.06.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.2.98.00','INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.3.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.3.05.00','JUROS DA DIVIDA CONTRATADA COM GOVERNOS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS JUROS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.3.06.00','ENCARGOS DA DIVIDA CONTRATADA COM GOVERNOS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS ENCARGIOS DECORRENTES DA DIVIDA CONTRATADA JUNTO A GOVERNOS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.1.3.98.00','INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.2.0.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA REPRESENTADA POR TITULOS EMITIDOS PELO GOVERNO. SAO CONSIDERADOS ENCARGOS DA DIVIDA MOBILIARIA: COMISSOES, CORRETAGENS, SEGUROS, DESAGIO E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.2.1.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS DA DIVIDA PUBLICA REPRESENTADA POR TITULOS EMITIDOS PELO GOVERNO. SAO CONSIDERADOS ENCARGOS DA DIVIDA MOBILIARIA: COMISSOES, CORRETAGENS, SEGUROS, DESAGIO E OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.2.1.01.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.2.1.02.00','DESAGIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE DESAGIOS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.2.1.03.00','ENCARGOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS DA DIVIDA PUBLICA MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.2.1.98.00','INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.3.0.00.00','JUROS E ENCARGOS DE EMPRESTIMOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS SOBRE EMPRESTIMOS CONTRAIDOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA PARA ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.3.1.00.00','JUROS E ENCARGOS DE EMPRESTIMOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS SOBRE EMPRESTIMOS CONTRAIDOS POR ANTECIPACAO DE RECEITA ORCAMENTARIA PARA ATENDER INSUFICIENCIA DE CAIXA DURANTE O EXERCICIO FINANCEIRO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.3.1.01.00','JUROS S/ ADIANTAMENTOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS INCIDENTES SOBRE ANTECIPACOES DE CREDITOS CONTRATADAS COM BANCOS E OUTROS AGENTES FINANCEIROS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.3.1.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.9.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.9.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.9.2.00.00','OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS - INTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.1.9.3.00.00','OUTROS JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS - INTER OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS QUE NAO SEJAM REFERENTES A DIVIDA CONTRATUAL, A DIVIDA MOBILIARIA E A POR ANTECIPACAO DE RECEITA ORCAMENTARIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','COMPREENDE O MONTANTE DE VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS OBTIDOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS OBTIDOS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.1.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.1.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.2.00.00','JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS OBTIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.2.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.2.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA DE EMPRESTIMOS E FINANCIAMENTOS OBTIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.3.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.1.3.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.01.00','JUROS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.01.01','JUROS DE SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.01.02','JUROS DE SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.02.00','MULTAS DEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.02.01','MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.02.02','MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.02.03','MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.03.00','MULTAS INDEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.03.01','MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.03.02','MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.03.03','MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.99.00','OUTROS ENCARGOS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.99.01','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS FISICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.99.02','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.1.99.03','OUTROS ENCARGOS S/ FONECIMENTO DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.00.00','JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.01.00','JUROS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.01.02','JUROS DE OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.02.00','MULTAS DEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.02.02','MULTAS DEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.02.03','MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.03.00','MULTAS INDEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.03.02','MULTAS INDEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.03.03','MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.99.00','OUTROS ENCARGOS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.99.02','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.2.99.03','OUTROS ENCARGOS S/ FONECIMENTO DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.00.00','JUROS E ENCARGOS DE MORA DE AQUISICAO DE BENS E SERVICOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.01.00','JUROS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.01.02','JUROS DE OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.02.00','MULTAS DEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.02.02','MULTAS DEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.02.03','MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.03.00','MULTAS INDEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.03.02','MULTAS INDEDUTIVEIS OUTROS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.03.03','MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.99.00','OUTROS ENCARGOS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.99.02','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.2.3.99.03','OUTROS ENCARGOS S/ FONECIMENTO DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.1.01.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.1.02.00','MULTAS DEDUTIVEIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.1.03.00','MULTAS INDEDUTIVEIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.2.00.00','JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.2.01.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.2.02.00','MULTAS DEDUTIVEIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.2.03.00','MULTAS INDEDUTIVEIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.3.00.00','JUROS E ENCARGOS DE MORA DE OBRIGACOES TRIBUTARIAS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.3.01.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.3.02.00','MULTAS DEDUTIVEIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS, COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.3.3.03.00','MULTAS INDEDUTIVEIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.9.2.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.2.9.3.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.0.0.00.00','VARIACOES MONETARIAS E CAMBIAIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.0.00.00','VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.1.00.00','VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.1.01.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.1.02.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.2.00.00','VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.2.01.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.2.02.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.3.00.00','VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA CONTRATUAL - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.3.01.00','VARIACOES MONETARIAS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA CONTRATUAL. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.1.3.02.00','VARIACOES CAMBIAIS DE DIVIDA CONTRATUAL','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA CONTRATUAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.2.0.00.00','VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA MOBILIARIA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.2.1.00.00','VARIACOES MONETARIAS E CAMBIAIS DE DIVIDA MOBILIARIA - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.2.1.01.00','VARIACOES MONETARIAS DE DIVIDA MOBILIARIA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES A DIVIDA MOBILIARIA. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.2.1.02.00','VARIACOES CAMBIAIS DE DIVIDA MOBILIARIA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES A DIVIDA MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.0.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.1.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.1.01.00','OUTRAS VARIACOES MONETARIAS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.1.01.01','ENCARGOS FINANCEIROS DEDUTIVEIS','REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.1.01.02','ENCARGOS FINANCEIROS INDEDUTIVEIS','REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.1.02.00','OUTRAS VARIACOES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.2.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.2.01.00','OUTRAS VARIACOES MONETARIAS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.2.01.01','ENCARGOS FINANCEIROS DEDUTIVEIS',' REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.2.01.02','ENCARGOS FINANCEIROS INDEDUTIVEIS',' REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.2.02.00','OUTRAS VARIACOES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.3.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.3.01.00','OUTRAS VARIACOES MONETARIAS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.3.01.01','ENCARGOS FINANCEIROS DEDUTIVEIS','REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTES SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS (CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.3.01.02','ENCARGOS FINANCEIROS INDEDUTIVEIS','REGISTRA O VALOR DAS DESPESAS COM CORRECAO MONETARIA/VARIACAO CAMBIAL INCIDENTE SOBRE OBRIGACOES DEVIDAS A PESSOAS FISICAS E JURIDICAS ( NAO CONSIDERADA COMO DESPESA OPERACIONAL PARA EFEITO DE APURACAO DO LUCRO TRIBUTAVEL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.3.9.3.02.00','OUTRAS VARIACOES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO A DIVIDA CONTRATUAL E MOBILIARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.4.0.0.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.4.0.1.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - EXTRA OFSS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.4.0.2.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - INTRA OFSS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.4.0.3.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - INTER OFSS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM DESCONTOS FINANCEIROS CONCEDIDOS A CLIENTES POR PAGAMENTOS ANTECIPADOS DE DUPLICATAS E OUTROS TITULOS.NAO SE CONFUNDEM COM DESCONTOS NOS PRECOS DE VENDA CONCEDIDOS INCONDICIONALMENTE, OU ABATIMENTOS DE PRECOS, QUE SAO DEDUCOES DA RECEITA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.0.0.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS, NAO ABRANGIDAS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.0.00.00','JUROS E ENCARGOS EM SENTENCAS JUDICIAIS','COMPREENDE OS JUROS E ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.1.00.00','JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - EXTRA OFSS','COMPREENDE OS JUROS E ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.1.01.00','JUROS EM SENTENCAS JUDICIAIS','REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.1.02.00','ENCARGOS EM SENTECAS JUDICIAIS','REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.1.98.00','INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.2.00.00','JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - INTRA OFSS','COMPREENDE OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.2.01.00','JUROS EM SENTENCAS JUDICIAIS','REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.2.02.00','ENCARGOS EM SENTECAS JUDICIAIS','REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.2.98.00','INTEGRACAO DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.3.00.00','JUROS E ENCARGOS EM SENTENCAS JUDICIAIS - INTER OFSS','COMPREENDE OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.3.01.00','JUROS EM SENTENCAS JUDICIAIS','REGISTRA OS JUROS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.3.02.00','ENCARGOS EM SENTECAS JUDICIAIS','REGISTRA OS ENCARGOS RESULTANTES DE PAGAMENTO DE PRECATORIOS E DE SENTENCAS JUDICIAIS TRANSITADAS EM JULGADO','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.1.3.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.0.00.00','JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.1.00.00','JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.1.01.00','JUROS E ENCARGOS EM INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.1.02.00','JUROS E ENCARGOS EM RESTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.2.00.00','JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.2.01.00','JUROS E ENCARGOS EM INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.2.02.00','JUROS E ENCARGOS EM RESTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.3.00.00','JUROS E ENCARGOS EM INDENIZACOES E RESTITUICOES - INTER OFSS','CCOMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES E RESTITUICOES REFERENTES A JUROS E ENCARGOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.3.01.00','JUROS E ENCARGOS EM INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INDENIZACOES REFERENTES A JUROS E ENCARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.2.3.02.00','JUROS E ENCARGOS EM RESTITUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM RESTITUICOES REFERENTES A JUROS E ENCARGOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.9.0.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.9.1.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDE TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.9.2.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.4.9.9.3.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NAS CONTAS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.0.0.0.00.00','TRANSFERENCIAS CONCEDIDAS','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRANSFERENCIAS INTER GOVERNAMENTAIS, TRANSFERENCIAS INTRAGOVERNAMENTAIS, TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, TRANSFERENCIAS A INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS, TRANSFERERENCIAS A CONVENIOS E TRANSFERENCIAS AO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.0.00.00','TRANSFERENCIAS INTRAGOVERNAMENTAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.1.00.00','TRANSFERENCIAS INTRAGOVERNAMENTAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. POR EXEMPLO, EMPRESA INDEPENDENTE RECEBENDO TRANSFERENCIA DA UNIAO, ESTADOS, DF, E/OU MUNICIPIOS (A EMPRESA INDEPENDENTE NAO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE INTRA GOVERNAMENTAL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.00.00','TRANSFERENCIAS INTRAGOVERNAMENTAIS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.00','TRANSFERENCIAS CONCEDIDAS - COM EXECUCAO ORCAMENTARIA',' COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS CONCEDIDAS E CORRESPONDENCIA DE CREDITOS EM VIRTUDE DA EXECUCAO ORCAMENTARIA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.01','COTA CONCEDIDA ',' REGISTRA VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DA CONCESSAO DE COTA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA ORGAO SETORIAL CORRESPONDENTE AO ORCAMENTO ANUAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.02','REPASSE CONCEDIDO ',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DOS RECURSOS CONCEDIDOS A TITULO DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DIFERENTES DA ADMINISTRACAO DIRETA OU INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.03','SUB-REPASSE CONCEDIDO',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR TOTAL DOS SUB-REPASSES CONCEDIDOS POR TRANSFERENCIAS FINANCEIRAS ENTRE UG DE UM MESMO ORGAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.04','RECURSOS ARRECADADOS - CONCEDIDOS ','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR CONCEDIDO PARA OUTRA UG, REFERENTE A RECURSOS QUE FORAM ARRECADADOS (CLASSIFICADOS COMO RECEITA), PARA PAGAMENTO DE VARIACAO PATRIMONIAL DIMINUTIVA NA UG RECEBEDORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.05','VALORES DIFERIDOS - BAIXA - COTA DIFERIDA ','  REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO E BAIXA DOS RECURSOS DIFERIDOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.06','VALORES DIFERIDOS - BAIXA - REPASSE DIFERIDO ',' REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PRO-CESSO DE INSCRICAO/BAIXA DE RECURSOS DIFERIDOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.07','VALORES DIFERIDOS - BAIXA - SUB-REPASSE DIFERIDO ','  REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.08','VALORES DIFERIDOS - INSCRICAO - COTA DIFERIDA - INSCRICAO ','  REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.09','VALORES DIFERIDOS - INSCRICAO - REPASSE DIFERIDO - INSCRICAO ','  REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.10','VALORES DIFERIDOS - INSCRICAO - SUB-REPASSE DIFERIDO - INSCRICAO ','  REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA POR OCASIAO DA INSCRICAO DOS VALORES DIRERIDOS  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.11','CORRESPONDENCIA DE CREDITOS -INCORPORACAO DE VARIACAO PATRIMONIAL AUMENTATIVA',' REGISTRA A APROPRIACAO DE VARIACAO PATRIMONIAL AUMENTATIVA INCORPORADA POR TRANSFERENCIA DE OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.12','CORRESPONDENCIA DE CREDITOS -DESINCORPORACAO DE VARIACAO PATRIMONIAL DIMINUTIVA','  REGISTRA A APROPRIACAO DA DESINCORPORACAO DE VARIACAO PATRIMONIAL DIMINUTIVA TRANSFERIDAS PARA OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.01.13','CORRESPONDENCIA DE CREDITOS -CORRESPONDENCIA DE CREDITOS - SALDOS FINANC.','  REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS COM SALDOS FINANCEIRAS EM ROTINAS CONTABEIS ORCAMENTARIAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTE DE EXECUCAO ORCAMENTARIA','COMPREENDE AS TRANSFERENCIAS FINANCEIRAS PARA RESTOS A PAGAR E OUTROS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.01','ORDEM DE TRANSFERENCIAS CONCEDIDAS ',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO TOTAL DAS TRANSFERENCIAS NAO VINCULADAS AO ORCAMENTO, INCLUSIVE TRANSFERENCIAS PARA ATENDER RESTOS A PAGAR E OUTROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.02','DEVOLUCAO DE TRANSFERENCIAS RECEBIDAS ',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AO VALOR DAS DEVOLUCOES REFERENTES A RESTOS A PAGAR RECEBIDO E NAO UTILIZADO OU UTILIZADO PARCIALMENTE, SEM O RESTABELECIMENTO DO DIREITO CORRESPONDENTE AO LIMITE DE RP. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.03',' REGISTRO DE RESTITUICAO DE RECEITAS FEDERAIS',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA QUE PERMITE IDENTIFICAR OS REGISTROS DE RESTITUICAO DE RECEITAS FEDERAIS EFETIVADOS PELAS DELEGACIAS DA RECEITA FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.04',' CLASSIFICACAO DA RESTITUICAO DE RECEITAS FEDERAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA QUE PERMITE IDENTIFICAR A CLASSIFICACAO DE RESTITUICAO DE RECEITAS, REFERENTE A FITA DE ARRECADACAO DECENCIAL DE RECEITA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.05','TRANSF CONC P/ PAGTO RESTITUICOES RECEITAS FEDERAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVAS AS LIBERACOES DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.06','RESTITUICOES DE RECEITAS FEDERAIS - GRU','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVAS AS LIBERACOES DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS ARRECADADAS POR GRU PELAS UNIDADES RESPONSAVEIS PELO RECOLHIMENTO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.07','TRANSFERENCIAS CONCEDIDAS ARREC/TERC. INSS ',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVAS AS TRANSFERENCIAS PELO TESOURO NACIONAL PARA O INSS REFERENTE A ARRECADACAO DE RECEITAS PROPRIAS E VALORES DE TERCEIROS POR MEIO DE GPS REDE BANCARIA E INTRA-SIAFI. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.08','TRANSF.CONC.RECURSOS PREVIDENC.ARRECADADOS ',' REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA AOS RECURSOS PREVIDENCIARIOS ARRECADADOS PELO INSS POR MEIO DAS GPS ELETRONICA E DA REDE BANCARIA, CENTRALIZADOS NO TESOURO NACIONAL, SUBCONTA DA CONTA UNICA INSS, PARA POSTERIOR REPASSE POR MEIO DE PROGRAMACAO FINANCEIRA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.09','TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO - NO EXERCICIO ','  REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA CONCEDIDAS NO EXERCICIO CORRENTE.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.10','TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO-INSCRICAO DIFERIDO','  REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA CONCEDIDAS REFERENTE A INSCRICAO DE RECURSOS DIFERIDOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.11','TRANSFERENCIAS CONCEDIDAS ENTRE UG/ORGAO - BAIXA DE DIFERIDO ','  REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS REFERENTE A BAIXA DA INSCRICAO DOS RECURSOS DIFERIDOS PELO PROCESSO DE ENCERRAMENTO DO EXERCICIO  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.12','MOVIMENTO DE FUNDOS A CREDITO - CORRESPONDENCIA DE CREDITOS - SALDOS NAO FIN.','  REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS NAO FINANCEIRAS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.13','MOVIMENTO DE FUNDOS A CREDITO - CORRESPONDENCIA DE CREDITOS - SALDOS FINANC.','  REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE ORGAOS CORREPONDENTES A SALDOS FINANCEIROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.14','MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - INCORP/DESINCORP. DE SALDOS NAO FINANCEIROS',' REGISTRA O VALOR DE SALDOS PATRIMONIAIS CREDORES INCORPORADOS E DEVEDORES DESINCORPORADOS POR INTEGRACAO,TRANSFERENCIA,FUSAO,CISAO OU MUDANCA DA MODAL.USO PARCIAL P/ TOTAL DE ORGAOS OU UNIDADE GEST./GESTAO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.15','MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - INCORP./DESINCORP. SALDO FINANC./DISP./LIMITE','  REGISTRA O VALOR DE SALDOS FINANCEIROS CREDORES INCORPORADOS, E DEVEDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DA MODALIDADE DE USO PARCIAL PARA TOTAL, RELATIVOS AO DISPONIVEL E AO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.16','MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - INCORP./DESINCORP. DEMAIS SALDOS FINANCEIROS','  REGISTRA O VALOR DE SALDOS FINANCEIROS CREDORES INCORPORADOS, E DEVEDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DE MODALIDADE DE USO PARCIAL PARA TOTAL, COM EXCECAO OS DO DISPONIVEL E OS DO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.17','MOVIMENTO DE FUNDOS A CREDITOS - PROPRIOS - APURACAO RESULTADO INC/DESINC. SALDOS FINANC.','  REGISTRA O VALOR DA APURACAO DE RESULTADO FINANCEIRO, QUANDO CREDOR, PELA INCORPORACAO DE SALDOS DEVEDORES E/OU DESINCORPORACAO DE SALDOS CREDORES, PELO PROCESSO DE TRANSFERENCIA, INTEGRACAO E FUSAO DE SALDOS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.18','OUTROS MOVIMENTOS DE FUNDOS A CREDITO-S.FIN.',' REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES FINANCEIROS COM SALDO DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A CREDITO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.19','OUTROS MOVIMENTOS DE FUNDOS A CREDITO-S.PATR.','  REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES PATRIMONIAIS COM SALDO  DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A CREDITO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.20','TRANSFERENCIAS CONCEDIDAS DE BENS IMOVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES DO MESMO ORGAO .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.21','DOACOES CONCEDIDAS DE BENS IMOVEIS','REGISTRA O VALOR DE DOACOES DE BENS IMOVEIS ENTRE UNIDADES DE ORGAOS DIFERENTES','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.22','TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO PAIS',' REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO PAIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.23','TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA DO EXTERIOR',' REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO EXTERIOR PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.24','DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA NO PAIS',' REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO PAIS PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.25','DOACOES CONCEDIDAS DE BENS MOVEIS POR UNIDADE LOCALIZADA DO EXTERIOR',' REGISTRA O VALOR DOS BENS MOVEIS CONCEDIDOS POR UNIDADE LOCALIZADA NO EXTERIOR PARA OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.26','TRANSFERENCIAS CONCEDIDAS DE TITULOS E VALORES ',' REGISTRA O TOTAL DOS TITULOS E VALORES EM CIRCULACAO CONCEDIDOS POR UNIDADE DECORRENTE DE TRANSFERENCIA A OUTRA UNIDADE DE MESMA GESTAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.1.0.2.02.27','TRANSFERENCIAS CONCEDIDAS DE TITULOS DA DIVIDA ATIVA','REGISTRA A TRANSFERENCIA DE TITULOS DA DIVIDA ATIVA DE UMA UG PARA A PGFN OU ORGAO EQUIVALENTE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.0.00.00','TRANSFERENCIAS INTER GOVERNAMENTAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.1.00.00','TRANSFERENCIAS INTER GOVERNAMENTAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERENCIA DE OUTRO ENTE.(A EMPRESA INDEPENDENTE NAO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.00.00','TRANSFERENCIAS INTER GOVERNAMENTAIS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.01.00','TRANSFERENCIAS A UNIAO','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS PELOS ESTADOS, MUNICIPIOS OU PELO DISTRITO FEDERAL, MEDIANTE TRANSFERENCIA DE RECURSOS FINANCEIROS A UNIAO, INCLUSIVE PARA SUAS ENTIDADES DA ADMINISTRACAO INDIRETA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - CONTRIBUICOES P/ PESSOAL E ENCARGOS SOCIAIS','COMPREENDE O SOMATORIO DAS TRANSFERENCIAS EFETUADAS AOS ESTADOS E AO DISTRITO FEDERAL PELA UNIAO PARA REALIZACOES DE VPD COM PESSOAL E ENCARGOS SOCIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.01','ACRE','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ACRE P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.02','ALAGOAS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ALAGOAS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.03','AMAPA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAPA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.04','AMAZONAS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAZONAS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.05','BAHIA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO BAHIA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.06','CEARA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO CEARA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.07','DISTRITO FEDERAL','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO DISTRITO FEDERAL P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.08','ESPIRITO SANTO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ESPIRITO SANTO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.09','GOIAS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO GOIAS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.10','MARANHAO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MARANHAO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.11','MATO GROSSO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.12','MATO GROSSO DO SUL','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO DO SUL P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.13','MINAS GERAIS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MINAS GERAIS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.14','PARA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.15','PARAIBA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARAIBA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.16','PARANA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARANA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.17','PERNAMBUCO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PERNAMBUCO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.18','PIAUI','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PIAUI P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.19','RIO DE JANEIRO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO DE JANEIRO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.20','RIO GRANDE DO NORTE','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO NORTE P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.21','RIO GRANDE DO SUL','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO SUL P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.22','RONDONIA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RONDONIA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.23','RORAIMA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RORAIMA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.24','SANTA CATARINA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SANTA CATARINA P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.25','SAO PAULO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SAO PAULO P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.26','SERGIPE','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SERGIPE P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.27','TOCANTINS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO TOCANTINS P/ REALIZACAO DE VARIACAO PATRIMONIAL DIMINUTIVA C/ PESSOAL E ENCARGOS SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.02.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - DIARIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE ALAGOAS RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA BAHIA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE GOIAS RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE MINAS GERAIS RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.14','PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA PARAIBA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARANA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE PERNAMBUCO RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RONDONIA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RORAIMA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SANTA CATARINA RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SAO PAULO RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SERGIPE RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE TOCANTINS RELATIVAS A DIARIAS PAGAS A PESSOAL CIVIL, NO PAIS E NO EXTERIOR . ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.03.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL -AUXILIO FINANCEIRO A ESTUDANTES','COMPREENDE AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ALAGOAS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO BAHIA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO GOIAS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MINAS GERAIS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.14','PARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARAIBA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARANA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RONDONIA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RORAIMA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SANTA CATARINA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SAO PAULO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SERGIPE RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO TOCANTINS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.04.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - AUXILIO FINANCEIRO A PESQUISADORES','COMPREENDE AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ALAGOAS RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO BAHIA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ESPIIRITO SANTO RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO GOIAS RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MINAS GERAIS RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.14','PARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARAIBA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RONDONIA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RORAIMA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SANTA CATARINA RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SAO PAULO RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SERGIPE RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO TOCANTINS RELATIVAS A AUXILIO FINANCEIRO A PESQUISADORES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.05.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - MATERIAL DE CONSUMO','COMPREENDE AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL RELATIVAS A MATERIAL DE CONSUMO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ALAGOAS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO BAHIA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO GOIAS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MINAS GERAIS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.14','PARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARAIBA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARANA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RONDONIA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RORAIMA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SANTA CATARINA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SAO PAULO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SERGIPE RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO TOCANTINS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.06.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - SERVICOS TERCEIROS - PF','COMPREENDE AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ALAGOAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO BAHIA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO GOIAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO MINAS GERAIS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.14','PARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARAIBA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PARANA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RONDONIA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO RORAIMA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SANTA CATARINA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SAO PAULO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SERGIPE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO TOCANTINS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.07.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - SERVICOS TERCEIROS - PJ','COMPREENDE AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL RELATIVAS A SERVICOS DE CONSULTORIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO ACRE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO ALAGOAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO AMAPA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO AMAZONAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO BAHIA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO CERA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO ESPIRITO SANTO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO GOIAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO MARANHAO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO MATO GROSSO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO MATO GROSSO DO SUL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO MINAS GERAIS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.14','PARA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO PARA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO PARAIBA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO PARANA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO PERNAMBUCO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO PIAUI RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO RIO DE JANEIRO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO RIO GRANDE DO NORTE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO RIO GRANDE DO SUL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO RONDONIA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO RORAIMA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO SANTA CATARINA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO SAO PAULO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO DO SERGIPE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFENTES AS TRANSFERENCIAS AO ESTADO TOCANTINS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.08.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL -CONTRIBUICOES P/ OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS.','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ESTADOS E DISTRITO FEDERAL PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE ALAGOAS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA BAHIA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO CEARA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE GOIAS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE MINAS GERAIS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.14','PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA PARAIBA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARANA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RONDONIA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RORAIMA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SANTA CATARINA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SAO PAULO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SERGIPE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE TOCANTINS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.10.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - SUBVENCOES SOCIAIS','COMPREENDE AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AOS ESTADOS E DISTRITO FEDERAL , RELATIVAS A SUBVENCOES SOCIAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.01','ACRE',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.02','ALAGOAS',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE ALAGOAS RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.03','AMAPA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.04','AMAZONAS',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.05','BAHIA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA BAHIA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.06','CEARA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.07','DISTRITO FEDERAL',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.08','ESPIRITO SANTO',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.09','GOIAS',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE GOIAS RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.10','MARANHAO',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.11','MATO GROSSO',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.12','MATO GROSSO DO SUL',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.13','MINAS GERAIS',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE MINAS GERAIS RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.14','PARA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.15','PARAIBA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DA PARAIBA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.16','PARANA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PARANA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.17','PERNAMBUCO',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE PERNAMBUCO RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.18','PIAUI',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO PIAUI RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.19','RIO DE JANEIRO',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.20','RIO GRANDE DO NORTE',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.21','RIO GRANDE DO SUL',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.22','RONDONIA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RONDONIA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.23','RORAIMA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE RORAIMA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.24','SANTA CATARINA',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SANTA CATARINA RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.25','SAO PAULO',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SAO PAULO RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.26','SERGIPE',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DE SERGIPE RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.27','TOCANTINS',' REGISTRA AS VARIACOES PATRIMONIAS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO ESTADO DO TOCANTINS RELATIVAS A SUBVENCOES SOCIAIS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.11.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.00','TRANSF. A ESTADOS E AO DISTRITO FEDERAL - OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A ESTADOS E AO DISTRITO FEDERAL RELATIVA AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.01','ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO ACRE RELATIVO AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.02','ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE ALAGOAS RELATIVO AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.03','AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO AMAPA RELATIVO AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.04','AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO AMAZONAS RELATIVO AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.05','BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.06','CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO CEARA RELATIVO AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.07','DISTRITO FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO DISTRITO FEDERAL RELATIVO AS APROPRIACOES DAS VPD DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.08','ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO ESPIRITO SANTO RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.09','GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE GOIAS RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.10','MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO MARANHAO RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.11','MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.12','MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO MATO GROSSO DO SUL RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.13','MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE MINAS GERAIS RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.14','PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO PARA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.15','PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DA PARAIBA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.16','PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO PARANA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.17','PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO PERNAMBUCO RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.18','PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO PIAUI RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.19','RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO RIO DE JANEIRO RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.20','RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO NORTE RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.21','RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO RIO GRANDE DO SUL RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.22','RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE RONDONIA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.23','RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE RORAIMA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.24','SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE SANTA CATARINA RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.25','SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE SAO PAULO RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.26','SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DE SERGIPE RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.27','TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AO ESTADO DO TOCATINS RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.12.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.00','TRANSFERENCIAS A MUNICIPIOS - DIARIAS ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE ALAGOAS RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE PERNAMBUCO RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA ACRE RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.13.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DE ESTADO DE TOCANTINS RELATIVAS A DIARIAS DE PESSOAL CIVIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.00','TRANSFERENCIAS A MUNICIPIOS - AUXILIO FINANCEIRO A ESTUDANTES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE ALAGOAS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE PERNAMBUCO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.14.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE TOCANTINS RELATIVAS A AUXILIO FINANCEIRO A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.00','TRANSFERENCIAS A MUNICIPIOS - AUXILIO FINANCEIRO A PESQUISADORES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS RELATIVAS A MATERIAL DE CONSUMO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE ALAGOAS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE PERNAMBUCO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.15.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE TOCANTINS RELATIVAS A MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.00','TRANSFERENCIAS A MUNICIPIOS - MATERIAL DE CONSUMO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE ALAGOAS RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE PERNAMBUCO RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE ACRE RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.16.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO TOCANTINS RELATIVAS A PASSAGENS E VARIACAO PATRIMONIAL DIMINUTIVA COM LOCOMOCAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.00','TRANSFERENCIAS A MUNICIPIOS - SERVICOS TERCEIROS - PF','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE ALAGOAS RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE PERNAMBUCO RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO TOCANTINS RELATIVAS A MUNICIPIOS RELATIVAS A SERVICOS TERCEIROS - PF','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.17.98','SERVICOS DE CONSULTORIA-INTEGR.ORGAO PARCIAIS',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.00','TRANSFERENCIAS A MUNICIPIOS - SERVICOS TERCEIROS - PJ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ALAGOAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA ACRE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE TOCANTINS RELATIVAS A SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.18.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.00','TRANSFERENCIAS A MUNICIPIOS - CONTRIBUICOES P/ OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ACRE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO AMAPA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO AMAZONAS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DA BAHIA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO CEARA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE GOIAS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MARANHAO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MATO GROSSO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PARA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DA PARAIBA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PARANA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PIAUI PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE RONDONIA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE RORAIMA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SAO PAULO PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SERGIPE PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE TOCANTINS PARA REALIZACAO DE OUTRAS VARIACAO PATRIMONIAL DIMINUTIVA .','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.20.99','OUTRAS CONTRIBUICOES',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZ.ADAS PELOS ORGAOS NAO INTEGRANTES, OU INTEGRANTES PARCIALMENTE DO SIAFI, CUJO REGISTRO SERA EFETUADO POR INTEGRACAO DE BALANCETES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.00','TRANSFERENCIAS A MUNICIPIOS - SUBVENCOES SOCIAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS A TITULO DE SUBVENCOES SOCIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ACRE A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE ALAGOAS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO AMAPA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO AMAZONAS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DA BAHIA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO CEARA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO ESPIRITO SANTO A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE GOIAS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MARANHAO A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MATO GROSSO A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE MINAS GERAIS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PARA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DA PARAIBA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PARANA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE PERNAMBUCO A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO PIAUI A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO DE JANEIRO A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE RONDONIA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE RORAIMA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SANTA CATARINA A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SAO PAULO A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE SERGIPE A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS AOS MUNICIPIOS DO ESTADO DE TOCANTINS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.21.98','SUBVENCOES SOCIAIS - INTEGR. ORGAOS PARCIAIS',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.00','TRANSFERENCIAS A MUNICIPIOS - OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS DE A MUNICIPIOS RELATIVO AS APROPRIACOES DAS VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTES DO PAGAMENTO DE TRIBUTOS E CONTRIBUICOES SOCIAIS E ECONOMICAS, EXCETO AS INCIDENTES SOBRE A FOLHA DE SALARIOS, CLASSIFICADAS COMO OBRIGACOES PATRONAIS, BEM COMO OS ENCARGOS RESULTANTES DO PAGAMENTO COM ATRASO DESSAS OBRIGACOES. APLICA-SE TAMBEM PARA O PAGAMENTO DE CONTRIBUICAO PREVIDENCIARIA INCIDENTE SOBRE SERVICO DE TERCEIRO PESSOA FISICA, CONTRATADAS PARA A EXECUCAO DE SERVICOS TECNICOS PROFISSIONAIS, SEM VINCULO A ADMINISTRACAO CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ACRE PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE ALAGOAS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAPA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO AMAZONAS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA BAHIA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO CEARA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE GOIAS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MARANHAO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE MINAS GERAIS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DA PARAIBA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PARANA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE PERNAMBUCO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO PIAUI PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RONDONIA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE RORAIMA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SANTA CATARINA PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SAO PAULO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE SERGIPE PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.22.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTE AS TRANSFERENCIAS A MUNICIPIOS DO ESTADO DE TOCANTINS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.00','TRANSFER. A ESTADOS E AO DF - FUNDO A FUNDO - CONTRIBUICOES','COMPREENDE O SOMATORIO DAS TRANSFERENCIAS A ESTADOS E D.F. A TITULO DE CONTRIBUICOES P/REALIZ.DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.01','ACRE','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ACRE P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.02','ALAGOAS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ALAGOAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.03','AMAPA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAPA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.04','AMAZONAS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO AMAZONAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.05','BAHIA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO BAHIA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.06','CEARA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO CEARA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.07','DISTRITO FEDERAL','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO DISTRITO FEDERAL P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.08','ESPIRITO SANTO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO ESPIRITO SANTO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.09','GOIAS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO GOIAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.10','MARANHAO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MARANHAO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.11','MATO GROSSO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.12','MATO GROSSO DO SUL','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MATO GROSSO DO SUL P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.13','MINAS GERAIS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO MINAS GERAIS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.14','PARA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.15','PARAIBA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARAIBA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.16','PARANA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PARANA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.17','PERNAMBUCO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PERNAMBUCO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.18','PIAUI','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO PIAUI P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.19','RIO DE JANEIRO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO DE JANEIRO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.20','RIO GRANDE DO NORTE','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO NORTE P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.21','RIO GRANDE DO SUL','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RIO GRANDE DO SUL P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.22','RONDONIA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RONDONIA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.23','RORAIMA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO RORAIMA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.24','SANTA CATARINA','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SANTA CATARINA P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.25','SAO PAULO','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SAO PAULO P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.26','SERGIPE','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO SERGIPE P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.27','TOCANTINS','REGISTRA O VALOR DAS CONTRIBUICOES EFETUADAS AO ESTADO DO TOCANTINS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.23.99','OUTRAS CONTRIBUICOES ','REGISTRA O VALOR DE OUTRAS CONTRIBUICOES EFETUADAS P/ REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADAS POR MEIO DA PORTARIA CONJUNTA SOF/STN 1 DE 2010. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.00',' TRANSFERENCIAS A MUNICIPIOS - FUNDO A FUNDO - CONTRIBUICOES','COMPREENDE O SOMATORIO DAS TRANSFERENCIAS EFETUADAS AOS MUNICIPIOS PARA REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.01','A MUNICIPIOS DO ESTADO DO ACRE','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.02','A MUNICIPIOS DO ESTADO DE ALAGOAS','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.03','A MUNICIPIOS DO ESTADO DO AMAPA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.04','A MUNICIPIOS DO ESTADO DO AMAZONAS','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.05','A MUNICIPIOS DO ESTADO DA BAHIA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.06','A MUNICIPIOS DO ESTADO DO CEARA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.07','A MUNICIPIOS DO ESTADO DO ESPIRITO SANTO','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.08','A MUNICIPIOS DO ESTADO DE GOIAS','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.09','A MUNICIPIOS DO ESTADO DO MARANHAO','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.10','A MUNICIPIOS DO ESTADO DO MATO GROSSO','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.11','A MUNICIPIOS DO ESTADO DO MATO GROSSO DO SUL','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.12','A MUNICIPIOS DO ESTADO DE MINAS GERAIS','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.13','A MUNICIPIOS DO ESTADO DO PARA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.14','A MUNICIPIOS DO ESTADO DA PARAIBA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.15','A MUNICIPIOS DO ESTADO DO PARANA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.16','A MUNICIPIOS DO ESTADO DE PERNAMBUCO','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.17','A MUNICIPIOS DO ESTADO DO PIAUI','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.18','A MUNICIPIOS DO ESTADO DO RIO DE JANEIRO','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.19','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO NORTE','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.20','A MUNICIPIOS DO ESTADO DO RIO GRANDE DO SUL','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.21','A MUNICIPIOS DO ESTADO DE RONDONIA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.22','A MUNICIPIOS DO ESTADO DE RORAIMA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.23','A MUNICIPIOS DO ESTADO DE SANTA CATARINA','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.24','A MUNICIPIOS DO ESTADO DE SAO PAULO','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.25','A MUNICIPIOS DO ESTADO DE SERGIPE','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.26','A MUNICIPIOS DO ESTADO DE TOCANTINS','REGISTRA OS VALORES DAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.2.0.3.24.99','OUTRAS CONTRIBUICOES','REGISTRA OS VALORES DE OUTRAS CONTRIBUICOES A MUNICIPIOS DESTINADAS A REALIZACAO DE OUTRAS DESPESAS CORRENTES - TRANSFERENCIAS FUNDO A FUNDO CRIADA POR MEIO DA PORTARIA CONJUNTA SOF/STN 01/2010 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.0.0.00.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS A INSTITUICOES PRIVADAS, INCLUSIVE DE BENS E VALORES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.0.00.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS QUE NAO TENHAM VINCULO COM A ADMINISTRACAO PUBLICA, EXEMPLO: ONGS,OSCIPS E OS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.00.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS QUE NAO TENHAM VINCULO COM A ADMINISTRACAO PUBLICA, EXEMPLO: ONGS,OSCIPS E OS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - DIARIAS ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS DE PESSOAL CIVIL NO PAIS E NO EXTERIOR, COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO ESTATUTARIO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO, ENTENDIDO COMO SEDE O MUNICIPIO ONDE A REPARTICAO ESTIVER INSTALADA E ONDE O SERVIDOR TIVER EXERCICIO EM CARATER PERMANENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.01','SEBRAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO SEBRAE PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.02','FUNDACAO ARTUR BERNADES - FUNARBE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A FUNDACAO ARTUR BERNARDES PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.03','INSTITUICOES DE CARATER ASSIST., CULT E EDUC.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.04','INSTITUICOES DE PESQ. E DESENV. INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO INSTITUCIONAL PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.05','INSTITUICOES DE CARATER AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTIUTICOES DE CARATER AMBIENTAL PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.06','INSTITUICOES DE CARATER AGROPECUARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AGROPECUARIO PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.07','ENTIDADES REPRESENTATIVAS DE CLASSE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES REPRESENTATIVAS DE CLASSE PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.01.08','INSTITUICOES DE DESENVOLVIMENTO RURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTIUTICOES DE DESENVOLVIMENTO RURAL PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.02.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - AUXILIO FINANCEIRO A ESTUDANTES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE AUXILIO FINANCEIRO A ESTUDANTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.02.01','BOLSA NO PAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS NO PAIS A TITULO DE AUXILIO FINANCEIRO A ESTUDANTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.03.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - AUXILIO FINANCEIRO A PESQUISADORES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE VARIACAO PATRIMONIAL DIMINUTIVA COM AUXILIO FINANCEIRO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTES, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS NAS SUAS DIVERSAS MODALIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.03.01','BOLSA DE ENSINO, PESQUISA E EXTENSAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE PAGAMENTO DE BOLSAS DE ENSINO, PESQUISA E EXTENSAO A PESQUISADORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - MATERIAL DE CONSUMO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE MATERIAL DE CONSUMO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.01','SEBRAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO SEBRAE A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.02','FUNDACAO ARTUR BERNADES - FUNARBE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A FUNDACAO ARTUR BERNARDES A TITULO DEMATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.03','INSTITUICOES DE CARATER ASSIST., CULT E EDUC.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL A TIITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.04','INSTITUICOES DE PESQ. E DESENV. INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO INSTITUCIONAL A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.05','INSTITUICOES DE CARATER AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AMBIENTAL A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.06','INSTITUICOES DE CARATER AGROPECUARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AGROPECUARIO A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.07','ENTIDADES REPRESENTATIVAS DE CLASSE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES REPRESENTATIVAS DE CLASSE A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.08','ORG. PRODUTORES DE PERIMETROS PUBL. IRRIGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACAO DE PRODUTORES DE PERIMETROS PUBLICOS DE IRRIGACAO A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.04.09','INSTITUICOES DE DESENVOLVIMENTO RURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE DESENVOLVIMENTO RURAL A TITULO DE MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - SERVICOS DE TERCEIROS - PF','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.01','SEBRAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO SEBRAE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.02','FUNDACAO ARTUR BERNADES - FUNARBE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A FUNDACAO ARTUR BERNARDES A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.03','INSTITUICOES DE CARATER ASSIST., CULT E EDUC.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.04','INSTITUICOES DE PESQ. E DESENV. INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO INSTITUCIONAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.05','INSTITUICOES DE CARATER AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AMBIENTAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.06','INSTITUICOES DE CARATER AGROPECUARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AGROPECUARIO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.07','ENTIDADES REPRESENTATIVAS DE CLASSE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES REPRESENTATIVAS DE CLASSE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.08','ORG. PRODUTORES DE PERIMETROS PUBL. IRRIGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACAO DE PRODUTORES DE PERIMETROS PUBLICOS DE IRRIGACAO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.09','INSTITUICOES DE DESENVOLVIMENTO RURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE DESENVOLVIMENTO RURAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.05.10','ASSESSORIA E CONSULTORIA TECNICA OU JURIDICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM ASSESSORIA, CONSULTORIA TECNICA OU JURIDICA OU ASSEMELHADA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - SERVICOS TERCEIROS - PJ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.01','INST.DE CARATER ASSIST.CULT.E EDUCACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL CULTURAL E EDUCACIONAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.02','SEBRAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO SEBRAE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.03','FUNDACAO ARTUR BERNADES - FUNARBE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A FUNDACAO ARTUR BERNARDES A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.04','INSTITUICOES DE PESQUISA E DES. INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO INSTITUCIONAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.05','INSTITUICOES DE PREVIDENCIA E SEGURIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PREVIDENCIA E SEGURIDADE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.06','INSTITUICOES DE CARATER AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AMBIENTAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.07','INSTITUICOES DE CARATER AGROPECUARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AGROPECUARIO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.08','ENTIDADES REPRESENTATIVAS DE CLASSE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES REPRESENTATIVAS DE CLASSE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.09','ORG. PRODUTORES DE PERIMETROS PUBL. IRRIGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACAO DE PRODUTORES DE PERIMETROS PUBLICOS DE IRRIGACAO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.10','INSTITUICOES DE DESENVOLVIMENTO RURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE DESENVOLVIMENTO RURAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.11','INSTITUICOES DE DESENVOLVIMENTO DO TURISMO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE DESENVOLVIMENTO DO TURISMO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.12','SERVICO DE ASSISTENCIA A SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS OBJETIVANDO ASSISTENCIA A SAUDE, PRESTADO AO SERVIDOR ATIVO OU INATIVO, ATRAVES DE CONVENIO FIRMADOS COM ENTIDADES FECHADAS DE AUTOGESTAO, SEM FINS LUCRATIVOS. (LEI 8.112 DE 11/12/1990 E DECRETO 4.978 DE 03/02/2004). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.06.99','OUTRAS INSTITUICOES PRIVADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - CONTRIBUICOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES - VPD AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A VARIACAO PATRIMONIAL DIMINUTIVA DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO OU PRIVADO, OBSERVADO O DISPOSTO NA LEGISLACAO VIGENTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.01','INST.DE CARATER ASSIST.CULT.E EDUCACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL, CULTURAL E EDUCACIONAL RELATIVOS A OUTRAS TRANSF.CORRENTES CONCEDIDAS EM VIRTUDE LEI ESPECIAL P/ATENDER ONUS OU ENC.ASSUM.P/UNIAO DE INSTIT.PRIV.DE CARATER ASSIST.,CULTURAL E EDUCACIONAL, SEM FINALIDADE LUCRATIVA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.02','ASSESSORIA JURIDICA ORGAN. POPULARES - GAJOP','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS RELATIVO A ASSESSORIA JURIDICA AS ORGANIZACOES POPULARES - GAJOP CONFORME CONVENIO 016/99. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.03','INSTITUICOES DE PESQ. E DESENVOLV.TECNOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO TECNOLOGICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.04','ENTIDADES DE INTERCAMBIO LEGISLATIVO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS , COMO CONTRIBUICAO, EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM PROMOCAO E INTERCAMBIO ENTRE PARLAMENTARES DE DIVERSOS PAISES, TAIS COMO FORTALECIMENTO DE INST. DEMOCRATICAS E PREGAR A PAZ E A UNIAO ENTRE OS POVOS; DESENVOLVER E HARMONIZARA LEGISLACAO DE TURISMO; E INTERCAMBIO DOS PAISES LATINO-AMERICANOS ATRAVES DE COMISOES PERMANENTES (EDUCACAO, SAUDE, NARCOTRAFICO, ECONOMIA, ETC).','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.05','INSTITUICOES DE CARATER AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AMBIENTAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.06','INSTITUICOES DE CARATER AGROPECUARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AGROPECUARIO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.07','ENTIDADES REPRESENTATIVAS DE CLASSE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES SINDICAIS, ASSOCIACOES E CONSELHOS DE CLASSE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.08','INSTIT.DE ENSINO AERONAUTICO/AVIACAO REGIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE ENSINO AERONAUTICO E AVALIACAO REGIONAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.09','INSTITUICOES ASSISTENCIAIS DE REFORMA AGRARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES ASSISTENCIAIS DE REFORMA AGRARIA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.10','ORGANIZACOES DE SOC. CIVIL DE INTERESSE PUB.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACOES DE SOCIEDADE CIVIL DE INTERESSE PUBLICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.11','INSTITUICOES DE DESENVOLVIMENTO RURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE DESENVOLVIMENTO RURAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.07.99','OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.08.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - SUBVENCOES SOCIAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE SUBVENCOES SOCIAIS - COBERTURA DE VARIACAO PATRIMONIAL DIMINUTIVA DE INSTITUICOES PRIVADAS DE CARATER ASSISTENCIAL OU CULTURAL, SEM FINALIDADE LUCRATIVA, DE ACORDO COM OS ARTS. 16, PARAGRAFO UNICO, E 17 DA LEI N. 4.320, DE 1964, OBSERVADO O DISPOSTO NO ART. 26 DA LEI COMPLEMENTAR N. 101, DE 2000. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.08.01','INST.DE CARATER ASSIST.CULT.E EDUCACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL CULTURAL E EDUCACIONAL A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.08.02','PARTIDOS POLITICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A PARTIDOS POLITICOS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.08.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.08.99','OUTRAS INSTITUICOES PRIVADAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A OUTRAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE SUBVENCOES SOCIAIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.01','SEBRAE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO SEBRAE A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.02','FUNDACAO ARTUR BERNADES - FUNARBE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A FUNDACAO ARTUR BERNARDES A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.03','INSTITUICOES DE PESQ. E DESENV. INSTITUCIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AINSTITUICOES DE PESQUISA E DESENVOLVIMENTO INSTITUCIONAL A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.04','INSTITUICOES DE CARATER AMBIENTAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER AMBIENTAL A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.05','ENTIDADES REPRESENTATIVAS DE CLASSE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ENTIDADES REPRESENTATIVAS DE CLASSE A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.06','ORG. PRODUTORES DE PERIMETROS PUBL. IRRIGACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACAO DE PRODUTORES DE PERIMETROS PUBLICOS DE IRRIGACAO A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.1.1.09.07','INST.DE CARATER ASSIST.CULT.E EDUCACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER ASSISTENCIAL CULTURAL E EDUCACIONAL A TITULO DE OBRIGACOES TRIBUTARIAS E CONTRIBUTIVAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.0.00.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS QUE NAO TENHAM VINCULOS COM ADMINISTRACAO PUBLICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.00.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS DE BENS E VALORES A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS, QUE NAO TENHAM VINCULOS COM A ADMINISTRACAO PUBLICA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.00','TRANSFERENCIAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS - CONTRIBUICOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.01','INSTITUICOES DE CARATER INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER INDUSTRIAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.02','INSTITUICOES DE PESQUISA E DESENV.TECNOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE PESQUISA E DESENVOLVIMENTO TECNOLOGICO A TITULO DE CONTRIBUICOES..','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.03','TRANSFERENCIAS A INSTITUICOES FINANCEIRAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES FINANCEIRAS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.04','INSTITUICOES DE CARATER COMERCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES DE CARATER COMERCIAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.05','PNPE - PROGR.NAC.DE ESTIMULO AO PRIMEIRO EMPREGO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A INSTITUICOES PRIVADAS COM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES PARA O PROGRAMA NACIONAL DE ESTIMULO AO PRIMEIRO EMPREGO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.98','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.3.2.1.01.99','OUTRAS CONTRIBUICOES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A OUTRAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS A TITULO DE CONTRIBUICOES..','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.4.0.0.00.00','TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.4.0.1.00.00','TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','S','N','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.4.0.3.00.00','TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.4.0.3.01.00','TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS - CONTRIBUICOES','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, INCLUSIVE AS DESTINADAS A ATENDER A DESPESAS DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO E PRIVADO, OBSERVADO O DISPOSTO NA LEGISLACAO VIGENTE.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.4.0.3.01.01','CONSORCIOS PUBLICOS INTERMUNICIPAIS.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A CONSORCIOS PUBLICOS INTERMUNICIPAIS NAO INTEGRADOS PELA UNIAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.4.0.3.01.02','ENTIDADES BINACIONAIS',' REGISTRA O VALOR DAS CONTRIBUICOES CONCEDIDAS A ENTIDADES BINACIONAIS, CRIADAS E MANTIDAS POR DOIS OU MAIS PAISES, INCLUSIVE O BRASIL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.5.0.0.00.00','TRANSFERENCIAS A CONSORCIOS PUBLICOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.5.0.1.00.00','TRANSFERENCIAS A CONSORCIOS PUBLICOS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.5.0.2.00.00','TRANSFERENCIAS A CONSORCIOS PUBLICOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.5.0.3.00.00','TRANSFERENCIAS A CONSORCIOS PUBLICOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DAS TRANSFERENCIAS A CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.0.00.00','TRANSFERENCIAS AO EXTERIOR','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.00.00','TRANSFERENCIAS AO EXTERIOR - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE TRANSFERENCIAS A ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.01.00','TRANSFERENCIAS AO EXTERIOR - DIARIAS ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR PARA ATENDER VARIACAO PATRIMONIAL DIMINUTIVA COM DIARIAS DE PESSOAL CIVIL NO PAIS E NO EXTERIOR, COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO ESTATUTARIO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.01.01','OPAS - ORGANIZACAO PANAMERICANA DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.01.02','PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS EFETUADAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE DIARIAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.02.00','TRANSFERENCIAS AO EXTERIOR -MATERIAL DE CONSUMO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR PARA ATENDER VPD COM MATERIAL DE CONSUMO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.02.01','IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO DE COOPERACAO PARA AGRICULTURA PARA ATENDER VPD COM MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.02.02','OPAS - ORGANIZACAO PANAMERICANA DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE PARA ATENDER VPD COM MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.02.03','PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO PARA ATENDER VPD COM MATERIAL DE CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.02.04','UNICEF - FUNDACAO DAS NACOES UNIDAS P/INFANCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A FUNDACAO DAS NACOES UNIDAS P/INFANCIA (UNICEF) PARA ATENDER VPD COM MATERIAL DE CONSUMO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.03.00','TRANSFERENCIAS AO EXTERIOR - SERVICOS DE TERCEIROS ­ PF','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.03.01','IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO COOPERACAO PARA AGRICULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.03.02','OPAS - ORGANIZACAO PANAMERICANA DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.03.03','PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA FISICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.00','TRANSFERENCIAS AO EXTERIOR - SERVICOS DE TERCEIROS-PJ','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.01','INSTITUICOES DE CARATER ASSIST. OU CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER ASSISTENCIAL OU CULTURAL A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.02','FAO - ORGAN.DAS NACOES UNIDAS P/ ALIM. E AGR.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA ALIMENTACAO E AGRICULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.03','IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO DE COOPERACAO PARA AGRICULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.04','OEI-ORGANIZACAO DOS ESTADOS IBERO-AMERICANOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANICAO DOS ESTADOS IBERO-AMERICANOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.05','OEA - ORGANIZACAO DOS ESTADOS AMERICANOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS ESTADOS AMERICANOS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.06','OIT - ORGANIZACAO INTERNACIONAL DO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DO TRABALHO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.07','OPAS - ORGANIZACAO PANAMERICANA DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.08','PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.09','UNESCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA EDUCACAO, CIENCIA E CULTURA A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.10','UNODC- PROG. NACOES UNIDAS P/ PREV. AO CRIME','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA PREVENCAO AO CRIME A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.11','UNICRI-INST,DE INVEST.INTER-REG.DO CRI.JUSTICA DAS NACOES UNIDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO DE INVESTIGACAO INTER-REGIONAL DO CRIME E DA JUSTICA DAS NACOES UNIDAS A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.04.12','IFC - INTERNATIONAL FINANCE CORPORATION','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INTERNACIONAL FINANCE CORPORATION A TITULO DE OUTROS SERVICOS DE TERCEIROS - PESSOA JURIDICA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.00','TRANSFERENCIAS AO EXTERIOR - CONTRIBUICOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO EXTERIOR AS QUAIS NAO CORRESPONDA CONTRAPRESTACAO DIRETA EM BENS E SERVICOS E NAO SEJA REEMBOLSAVEL PELO RECEBEDOR, BEM COMO AS DESTINADAS A ATENDER A VARIACAO PATRIMONIAL DIMINUTIVA DE MANUTENCAO DE OUTRAS ENTIDADES DE DIREITO PUBLICO OU PRIVADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.01','INSTITUICOES DE CARATER ASSIST. OU CULTURAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER ASSISTENCIAL OU CULTURAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.02','INSTITUICOES DE CARATER TECNICO OU CIENTIFICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER TECNICO OU CIENTIFICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.03','OMT - ORGANIZACAO MUNDIAL DO TURISMO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO MUNDIAL DO TURISMO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.04','ICCA - CONGRESSOS E CONVENCOES INTERNACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INTERNATIONAL CONGRESS AND CONVENTION ASSOCIATION A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.05','AISS - ASSOC. INTERNACIONAL SEGURIDADE SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ASSOCIACAO INTERNACIONAL DE SEGURIDADE SOCIAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.06','ENTIDADES DE INTERCAMBIO LEGISLATIVO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS ENTIDADES DE INTERCAMBIO LEGISLATIVO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.07','PROG.DAS NACOES UNIDAS P/MEIO AMBIENTE-PUNMA.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O MEIO-AMBIENTE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.08','FAO - ORGAN.DAS NACOES UNIDAS P/ ALIM. E AGR.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA A ALIMENTACAO E AGRICULTURA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.09','ICID - COMISSAO INTERN. IRRIGACAO E DRENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMISSAO INTERNACIONAL DE IRRIGACAO E DRENAGEM A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.10','CEPAL - COMISSAO ECOMOMICA P/ AMER. E CARIBE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMISSAO ECONOMICA PARA AMERICA E CARIBE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.11','SISTEMA DAS NACOES UNIDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO SISTEMA DAS NACOES UNIDAS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.12','MERCOSUL - MERCADO COMUM DO SUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO MERCADO COMUM DO SUL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.13','IICA - INSTIT. INTERAM. COOP. P/ AGRICULTURA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO INTERAMERICANO DE COOPERACAO PARA AGRICULTURA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.14','CPLP - COMUNIDADE P/ PAISES DE LINGUA PORTUG.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMUNIDADE PARA PAISES DE LINGUA PORTUGUESA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.15','OCDE - ORG. DE COOPERACAO E DESENV. ECONOMICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DE COOPERACAO E DESENVOLVIMENTO ECONOMICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.16','OEI - ORGANIZ.DOS ESTADOS IBERO-AMERICANOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS ESTADOS IBERO-AMERICANOS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.17','OEA - ORGANIZACAO DOS ESTADOS AMERICANOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS ESTADOS AMERICANOS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.18','OIT - ORGANIZACAO INTERNACIONAL DO TRABALHO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DO TRABALHO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.19','OMS - ORGANIZACAO MUNDIAL DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO MUNDIAL DE SAUDE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.20','OPAS - ORGANIZACAO PANAMERICANA DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO PANAMERICANA DE SAUDE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.21','PNUD - PROGRAMA DAS NACOES UNIDAS P/ O DESENV','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O DESENVOLVIMENTO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.22','OTCA - ORG. DOS TRATADOS DE COOPERACAO ECON.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DOS TRATADOS DE COOPERACAO ECONOMICA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.23','UNESCO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO DAS NACOES UNIDAS PARA EDUCACAO, CIENCIA E CULTURA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.24','OMC - ORGANIZACAO MUNDIAL DO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO MUNDIAL DO COMERCIO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.25','AIEA - AGENCIA INTERN. DE ENERGIA ATOMICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A AGENCIA INTERAMERICANA DE ENERGIA ATOMICA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.26','INSTITUICOES DE CARATER SOCIAL OU HUMANITARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER SOCIAL OU HUMANITARIO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.27','ILANUD-INST.LAT.AMER.PREV.DELITO TRAT.DELINQ.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO INSTITUTO LATINO-AMERICANO DAS NACOES UNIDAS PARA PREVENCAO DO DELITO E O TRATAMENTO DO DELINQUENTE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.28','UNODC-ESCITORIO UNIDAS CONTRA DROGAS E CRIME.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO PROGRAMA DAS NACOES UNIDAS PARA O CONTROLE INTERNACIONAL DE DROGAS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.29','CDES - CONSELHO DE DESENVOL.ECONOMICO E SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO CONSELHO DE DESENVOLVIMENTO ECONOMICO E SOCIAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.30','CPCM-COMISSAO PARLAM. CONJUNTA DO MERCOSUL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A COMISSAO PARLAMENTAR CONJUNTA DO MERCOSUL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.31','INSTIT. DE CARATER COMERCIAL OU ECONOMICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER COMERCIAL OU ECONOMICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.32','ORGANIZACAO INTERNACIONAL DO CAFE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DO CAFE A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.33','INSTITUICOES DE CARATER JURIDICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER JURIDICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.34','INSTIT. DE CARATER AMBIENTAL OU ECOLOGICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER AMBIENTAL OU ECOLOGICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.35','UNICEF- FUNDO DAS NACOES UNIDAS P/ A INFANCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO FUNDO DAS NACOES UNIDAS PARA A INFANCIA A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.36','UNIFEM - FUNDO DESENV NACOES UNIDAS P/MULHER','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO FUNDO DE DESENVOLVIMENTO DAS NACOES UNIDAS PARA A MULHER A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.37','CAF - CORPORACAO ANDINA DE FOMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A CORPORACAO ANDINA DE FOMENTO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.38','FLACSO - FAC. LATINO-AMERICANA CIENC. SOCIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A FACULDADE LATINO-AMERICANA DE CIENCIAS SOCIAIS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.39','FUNAP - FUNDO DE POPULACAO DA NACOES UNIDAS.','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AO FUNDO DE POPULACAO DAS NACOES UNIDAS A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.40','INSTITUICOES DE CARATER POLITICO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS AS INSTITUICOES DE CARATER POLITICO A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.05.41','ORGANIZACAO INTER. DE MADEIRA TROPICAL-ITTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES AS TRANSFERENCIAS A ORGANIZACAO INTERNACIONAL DE MADEIRA TROPICAL A TITULO DE CONTRIBUICOES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.5.6.0.1.06.00','VPD DE PESSOAL - TERCEIRIZACAO ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A MAO-DE-OBRA CONSTANTES DOS CONTRATOS DE TERCEIRIZACAO, DE ACORDO COM O ART. 18, § 1º, DA LEI COMPLEMENTAR Nº 101, DE 2000, COMPUTADAS PARA FINS DE LIMITES DA DESPESA TOTAL  COM PESSOAL PREVISTOS NO ART. 19 DESSA LEI.(NR)  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.0.0.0.00.00','DESVALORIZACAO E PERDA DE ATIVOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM DESVALORIZACAO E PERDAS DE ATIVOS, COM REDUCAO A VALOR RECUPERAVEL, COM PROVISOES PARA PERDAS, PERDAS COM ALIENACAO E PERDAS INVOLUNTARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.0.0.00.00','REDUCAO A VALOR RECUPERAVEL E PROVISAO PARA PERDAS','COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE OS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA E TAMBEM REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PROVISOES PARA PERDAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.1.0.00.00','REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS','COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.1.1.00.00','REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - EXTRA OFSS','REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO. ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.1.2.00.00','REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - INTRA OFSS','REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.1.3.00.00','REDUCAO A VALOR RECUPERAVEL DE INVESTIMENTOS - INTER OFSS','REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA INVESTIMENTOS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.2.0.00.00','REDUCAO A VALOR RECUPERAVEL DE IMOBILIZADO','COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.2.1.00.00','REDUCAO A VALOR RECUPERAVEL DE IMOBILIZADO - EXTRA OFSS','REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ITENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO. ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.3.0.00.00','REDUCAO A VALOR RECUPERAVEL DE INTANGIVEIS','COMPREENDE O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.3.1.00.00','REDUCAO A VALOR RECUPERAVEL DE INTANGIVEIS - EXTRA OFSS','REGISTRA O AJUSTE AO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR INFERIOR AO VALOR LIQUIDO CONTABIL, VISANDO A ASSEGURAR QUE TAIS ATIVOS NAO ESTEJAM REGISTRADOS CONTABILMENTE POR UM VALOR SUPERIOR AQUELE PASSIVEL DE SER RECUPERADO POR USO OU POR VENDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO. ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.0.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. POR EXEMPLO, A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA CREDITOS DE LIQUIDACAO DUVIDOSA E PROVISAO PARA CREDITOS DA DIVIDA ATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO. ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - DIVIDA ATIVA TRIBUTARIA','COMPREENDE VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS DA DIVIDA ATIVA TRIBUTARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.01','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.02','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA',' REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.03','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','  REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.04','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','  REGISTRA OS VALORES RELATIVOS AO CANCELAMENTO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MENETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.05','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL',' REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.06','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA',' REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.07','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','  REGISTRA OS VALORES RELATIVOS A ANISTIA/REMISSAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.08','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA',' REGISTRA OS VALORES RELATIVOS AS ANISTIAS/REMISSOES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MOMETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.09','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS A ADJUDICACAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.10','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','  REGISTRA OS VALORES RELATIVOS A ADJUDICACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.11','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS',' REGISTRA OS VALORES RELATIVOS AS ADJUDICACOES DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.12','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','  REGISTRA OS VALORES RELATIVOS A ADJUDICACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MENETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.13','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL',' REGISTRA OS VALORES RELATIVOS A ANULACAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.14','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','  REGISTRA OS VALORES RELATIVOS A ANULACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.15','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','  REGISTRA OS VALORES RELATIVOS AS ANULACOES DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.16','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA',' REGISTRA OS VALORES RELATIVOS A ANULACAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MENETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.17','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL',' REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.18','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA',' REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.19','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','  REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.20','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARI',' REGISTRA OS VALORES RELATIVOS A PRESCRICAO INTERCORRENTE DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.21','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS A EXTINCAO DE CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.22','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','  REGISTRA OS VALORES RELATIVOS A EXTINCAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - MULTA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.23','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS',' REGISTRA OS VALORES RELATIVOS AS EXTINCOES DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.24','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','  REGISTRA OS VALORES RELATIVOS A EXTINCAO DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.25','DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.26','DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO - MULTA','  REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.27','DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO - JUROS','  REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.28','DIVIDA ATIVA TRIBUTARIA -DESMEMBRAMENTO DE INSCRICAO-ATUAL. MONETARIA','REGISTRA OS VALORES RELATIVOS AO DESMEMBRAMENTO DE INSCRICAO DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.29','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - PRINCIPAL',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.30','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - MULTA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.31','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - JUROS',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.32','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAES - ATUALIZ. MONETARIA',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAES DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.33','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - PRINCIPAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.34','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS - MULTA',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS EM DIVIDA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.35','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS - JUROS','REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.36','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO REFIS-ATUALIZ. MONETARIA',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO REFIS DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.37','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.38','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - MULTA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.39','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - JUROS',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.40','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO PAEX - ATUALIZ. MONETARIA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO PAEX DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.41','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA - PRINCIPAL','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.42','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA - MULTA',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.43','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA - JUROS',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.44','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO TIMEMANIA-ATUAL.MONETARIA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO TIMEMANIA DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.45','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCON. SIMPLES NACIONAL-PRINCIPAL',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.46','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO SIMPLES NACIONAL - MULTA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL  DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.47','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO SIMPLES NACIONAL - JUROS','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL  DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.48','DIVIDA ATIVA TRIBUTARIA -ABATIME./DESCO. SIMPLES NACIONAL-ATUA. MONETA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO SIMPLES NACIONAL DO CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.49','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCON. CREDITO RURAL-PRINCIPAL','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - PRINCIPAL.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.50','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO CREDITO RURAL - MULTA','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - MULTA.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.51','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO CREDITO RURAL - JUROS','  REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - JUROS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.02.52','DIVIDA ATIVA TRIBUTARIA -ABATIME./DESCO. CREDITO RURAL-ATUA. MONETA',' REGISTRA OS VALORES RELATIVOS AO ABATIMENTO/DESCONTO CREDITO RURAL DOS CREDITOS INSCRITOS NA DIVIDA ATIVA TRIBUTARIA - ATUALIZACAO MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.1.99.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE OUTROS CREDITOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE OUTROS CREDITOS, NAO ESPECIFICADOS ACIMA,POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. POR EXEMPLO, A PROVISAO PARA CREDITOS DE LIQUIDACAO DUVIDOSA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.2.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.4.3.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA PERDAS DE CREDITOS POR INADIMPLENCIA OU OUTROS FATORES QUE IMPOSSIBILITAM O RECEBIMENTO DE CREDITOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE  DUAS UNIDADES  PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)  DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.5.0.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA REDUCAO A VALOR DE MERCADO DE ESTOQUES','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA REDUCAO A VALOR DE MERCADO DE ESTOQUES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.1.5.1.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA REDUCAO A VALOR DE MERCADO DE ESTOQUES - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM PROVISAO PARA REDUCAO A VALOR DE MERCADO DE ESTOQUES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.0.0.00.00','PERDAS COM ALIENACAO','COMPREENDE A PERDA COM ALIENACAO DE ATIVOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.1.0.00.00','PERDAS COM ALIENACAO DE INVESTIMENTOS','COMPREENDE A PERDA COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.1.1.00.00','PERDAS COM ALIENACAO DE INVESTIMENTOS - EXTRA OFSS','REGISTRA A PERDA COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.2.0.00.00','PERDAS COM ALIENACAO DE IMOBILIZADO','COMPREENDE A PERDA COM ALIENACAO DE ATIVOS IMOBILIZADOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.2.1.00.00','PERDAS COM ALIENACAO DE IMOBILIZADO - EXTRA OFSS','REGISTRA A PERDA COM ALIENACAO DE ATIVOS IMOBILIZADOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.3.0.00.00','PERDAS COM ALIENACAO DE INTANGIVEIS','COMPREENDE A PERDA COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.2.3.1.00.00','PERDAS COM ALIENACAO DE INTANGIVEIS - EXTRA OFSS','REGISTRA A PERDA COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MENOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE A PERDA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.0.0.00.00','PERDAS INVOLUNTARIAS','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DO BEM, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.1.0.00.00','PERDAS INVOLUNTARIAS COM IMOBILIZADO','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO IMOBILIZADO, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.1.1.00.00','PERDAS INVOLUNTARIAS COM IMOBILIZADO - EXTRA OFSS','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO IMOBILIZADO, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.2.0.00.00','PERDAS INVOLUNTARIAS COM INTANGIVEIS','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO INTANGIVEL, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.2.1.00.00','PERDAS INVOLUNTARIAS COM INTANGIVEIS - EXTRA OFSS','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ATIVO INTANGIVEL, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.3.0.00.00','PERDAS INVOLUNTARIAS COM ESTOQUES','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ESTOQUE, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.3.1.00.00','PERDAS INVOLUNTARIAS COM ESTOQUES - EXTRA OFSS','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE BEM DO ESTOQUE, COMO O QUE RESULTA DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.9.0.00.00','OUTRAS PERDAS INVOLUNTARIAS','COMPREENDEM O DESFAZIMENTO FISICO INVOLUNTARIO DE OUTROS BENS, COMO AS QUE RESULTAM DE SINISTROS COMO INCENDIO E INUNDACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.6.3.9.1.00.00','OUTRAS PERDAS INVOLUNTARIAS - EXTRA OFSS','REGISTRA O DESFAZIMENTO FISICO INVOLUNTARIO DE OUTROS BENS, COMO AS QUE RESULTAM DE SINISTROS COMO INCENDIO E INUNDACOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.0.0.0.00.00','TRIBUTARIAS','COMPREENDEM AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AOS IMPOSTOS, TAXAS, CONTRIBUICOES DE MELHORIA, CONTRIBUICOES SOCIAIS, CONTRIBUICOES ECONOMICAS E CONTRIBUICOES ESPECIAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUICOES DE MELHORIA','COMPREENDEM AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS AS OBRIGACOES RELATIVAS AS PRESTACOES PECUNIARIAS COMPULSORIAS, EM MOEDA OU CUJO VALOR NELA POSSA SE EXPRIMIR, QUE NAO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE VINCULADA. COMO: IMPOSTOS, TAXAS E CONTRIBUICOES DE MELHORIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.0.00.00','IMPOSTOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS, APURADOS NO PERIODO DE COMPETENCIA, E VINCULADOS A ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.00.00','IMPOSTOS EXTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS, APURADOS NO PERIODO DE COMPETENCIA E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDE TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.02.00','IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.03.00','IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.04.00','ADICIONAL DO IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.05.00','IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.06.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.07.00','IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS','REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.08.00','IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA',' REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.09.00','IMPOSTO S/ OPERACOES FINANCEIRAS','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.10.00','IMPOSTO S/ IMPORTACAO','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.11.00','IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS',' REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.1.99.00','OUTROS IMPOSTOS','REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.00.00','IMPOSTOS INTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS APURADOS NO PERIODO DE COMPETENCIA E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.02.00','IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.03.00','IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.04.00','ADICIONAL DO IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.05.00','IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.06.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.07.00','IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS','REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.08.00','IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA',' REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.09.00','IMPOSTO S/ OPERACOES FINANCEIRAS','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.10.00','IMPOSTO S/ IMPORTACAO','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.11.00','IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS',' REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.2.99.00','OUTROS IMPOSTOS','REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.00.00','IMPOSTOS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM IMPOSTOS APURADOS NO PERIODO DE COMPETENCIA, E VINCULADOS ATIVIDADE ADMINISTRATIVA DO CONTRIBUINTE, DEFINIDOS NO CTN. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE PROPRIEDADE TERRITORIAL RURAL DE COMPETENCIA DA UNIAO RELATIVO A PROPRIEDADE, O DOMINIO UTIL OU POSSE DE IMOVEL POR NATUREZA LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO EM 01 DE JANEIRO DE CADA ANO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.02.00','IMPOSTO S/ PROPRIEDADE PREDIAL E TERRITORIAL URBANA','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DOS MUNICIPIOS E DISTRITO FEDERAL, SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE BEM IMOVEL POR NATUREZA OU POR ACESSAO FISICA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO NA ZONA URBANA DO MUNICIPIO E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.03.00','IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.04.00','ADICIONAL DO IMPOSTO DE RENDA','REGISTRA O VALOR DA VPD COM O ADICIONAL AO IRPJ.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.05.00','IMPOSTO S/ PROPRIEDADE DE VEICULOS AUTOMOTORES','REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.06.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','REGISTRA O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO.PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.07.00','IMPOSTO S/ CIRCULACAO DE MERCADORIAS E SERVICOS','REGISTRA O VALOR DA VPD COM IMPOSTO INCIDENTE SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTE INTERESTADUAL, INTERMUNICIPAL E DE COMUNICACAO, E E DE COMPETENCIA DOS ESTADOS E DO DISTRITO FEDERAL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.08.00','IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA',' REGISTRA O VALOR DA VPD COM O IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA, DE COMPETENCIA DOS MUNICIPIOS E DO DISTRITO FEDERAL, TEM COMO FATO GERADOR A PRESTACAO DE SERVICOS CONSTANTES DA LISTA ANEXA DA LC 116/2003, AINDA QUE ESSES NAO SE CONSTITUAM COMO ATIVIDADE PREPONDERANTE DO PRESTADOR. PODE SER RECOLHIDO PELO SUBSTITUTO TRIBUTARIO CONFORME LC 116/2003.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.09.00','IMPOSTO S/ OPERACOES FINANCEIRAS','REGISTRA O VALOR DA VPD COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.10.00','IMPOSTO S/ IMPORTACAO','REGISTRA O VALOR DA VPD COM IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS TEM COMO FATO GERADOR A ENTRADA DESTES NO TERRITORIO NACIONAL','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.11.00','IMPOSTO S/ TRANSMISSAO DE IMOVEL INTER VIVOS',' REGISTRA O VALOR DA VPD COM IMPOSTO SOBRE A TRANSMISSAO "INTER VIVOS", A QUALQUER TITULO, POR ATO ONEROSO, DE BENS IMOVEIS, POR NATUREZA OU ACESSAO FISICA, E DE DIREITOS REAIS SOBRE IMOVEIS, EXCETO OS DE GARANTIA, BEM COMO CESSAO DE DIREITOS A SUA AQUISICAO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.1.3.99.00','OUTROS IMPOSTOS','REGISTRA O VALOR DE VPDS COM OUTROS IMPOSTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.2.0.00.00','TAXAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES, DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.2.1.00.00','TAXAS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO,ESTADOS,DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES,DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDE TRANSACOES ENTRE PARTES ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.2.2.00.00','TAXAS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO,ESTADOS,DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES,DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.2.3.00.00','TAXAS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TAXAS COBRADAS PELA UNIAO, ESTADOS, DISTRITO FEDERAL OU MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS CONTRIBUICOES, DECORRENTES DA CONTRAPRESTACAO DE SERVICOS PUBLICOS AO CONTRIBUINTE POSTOS A SUA DISPOSICAO, INCLUSIVE O EXERCICIO DE PODER DE POLICIA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.3.0.00.00','CONTRIBUICOES DE MELHORIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU , AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.3.1.00.00','CONTRIBUICOES DE MELHORIA - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TITULO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIM ONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS, DISTRITO FEDERAL OU, AMPARADAS EM LEI E LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.3.2.00.00','CONTRIBUICOES DE MELHORIA - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO,ESTADOS,DISTRITO FEDERAL OU, AMPARADAS EM LEI I LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS)DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.1.3.3.00.00','CONTRIBUICOES DE MELHORIA - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM TRIBUTO CUJA OBRIGACAO TEM POR FATO GERADOR UM BENEFICIO ESPECIAL AUFERIDO PELO CONTRIBUINTE QUE POR CONSEQUENCIA PROMOVE UMA VALORIZACAO IMOBILIARIA E PATRIMONIAL DECORRENTE DE OBRA PUBLICA DE COMPETENCIA DA UNIAO, ESTADOS,DISTRITO FEDERAL OU, AMPARADAS EM LEI LIMITADAS AO TOTAL DA DESPESA PUBLICA REALIZADA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.0.0.00.00','CONTRIBUICOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICOES SOCIAIS, ECONOMICAS E OUTRAS, DECORRENTES DA INTERVENCAO DO ESTADO ( UNIAO, ESTADOS, DISTRITO FEDERAL E MUNICIPIOS) NO DOMINIO ECONOMICO E DE INTERESSE DA CATEGORIA DE PROFISSIONAIS ECONOMICO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.0.00.00','CONTRIBUICOES SOCIAIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO, ENTRE ELAS O PIS/PASEP, CSLL E COFINS, ETC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.00.00','CONTRIBUICOES SOCIAIS - EXTRA OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PIS/PASEP,CSLL E COFINS, ETC.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTECENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PETENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.01.00','CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.02.00','PIS/PASEP','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.03.00','CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.04.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.05.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.1.99.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.00.00','CONTRIBUICOES SOCIAIS - INTRA OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PSI/PASEP, CSLL E COFINS, ETC.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.01.00','CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.02.00','PIS/PASEP','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.03.00','CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.04.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.05.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.2.99.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.00.00','CONTRIBUICOES SOCIAIS - INTER OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES SOCIAIS CONSTITUIDAS POR ORDEM SOCIAL E PROFISSIONAL, INSTITUIDAS PELO ESTADO,ENTRE ELAS O PIS/PSASEP,CSLL E COFINS, ETC.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) E ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.01.00','CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.02.00','PIS/PASEP','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO(PASEP)','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.03.00','CONTRIBUICAO SOCIAL S/ LUCRO LIQUIDO - CSLL','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.04.00','OBRIGACOES PATRONAIS S/ SERVICOS DE FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUICOES PREVIDENCIARIAS SOBRE SERVICOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVICOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.05.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVICOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99) ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.1.3.99.00','OUTRAS CONTRIBUICOES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUICOES SOCIAIS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.0.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.1.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - EXTRA OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.1.01.00','CONTRIBUICAO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.1.99.00','OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.2.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.2.01.00','CONTRIBUICAO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.2.99.00','OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.3.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTER OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMUNITIVA COM CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO. .COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.3.01.00','CONTRIBUICAO SINDICAL','REGISTRA O VALOR DA DESPESA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.2.3.99.00','OUTRAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS CONTRIBUICOES ECONOMICAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.3.0.00.00','CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF)','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.3.1.00.00','CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP - EXTRA OFSS','REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF).COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.3.2.00.00','CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP- INTRA OFSS','REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF).COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.3.3.00.00','CONTRIBUICAO PARA O CUSTEIO DO SERVICO DE ILUMINACAO PUBLICA - COSIP - INTER OFSS','REGISTRA O VALOR DA VARIACAO PATRIMONIAL DIMINUTIVA COM A CONTRIBUICAO PARA CUSTEIO DA ILUMINACAO PUBLICA ( ART.149-A DA CF).COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.0.00.00','OUTRAS CONTRIBUICOES','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.1.00.00','OUTRAS CONTRIBUICOES - EXTRA OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.1.01.00','CONTRIBUICAO DE CARATER EMERGENCIAL','REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.1.02.00','CONTRIBUICAO P/ O FUST- FUNDO DE UNIVERSALIZACAO DOS SERVICOS DE TELECOMUNICACOES','  REGISTRA O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DO PAGAMENTO DA CONTRIBUICAO AO FUST, A ALIQUOTA DE UM POR CENTO SOBRE A RECEITA OPERACCIONAL BRUTA, DECORRENTE DA PRESTACAO DE SERVICOS DE TELECOMUNICACOES NOS REGIMES PUBLICOS E PRIVADO, EXCLUINDO-SE O ICMS, O PIS E A COFINS INCIDENTES SOBRE A MESMA BASE DE CALCULO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.2.00.00','OUTRAS CONTRIBUICOES - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.2.01.00','CONTRIBUICAO DE CARATER EMERGENCIAL','REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.2.03.00','CONTRIBUICAO FOMENTO DA RADIODIFUSAO PUBLICA',' REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CONTRIBUICAO PARA O FOMENTO DA RADIO-DIFUSAO PUBLICA, INSTITUIDA PELA LEI 11.652, DE 07 DE ABRIL DE 2008,  ARTIGO 32.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.3.00.00','OUTRAS CONTRIBUICOES - INTER OFSS',' COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM CONTRIBUICOES QUE NAO SE ENQUADRAM NA CONDICAO DE SOCIAIS E ECONOMICAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTE PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.2.9.3.01.00','CONTRIBUICAO DE CARATER EMERGENCIAL','REGISTRA O VALOR DA VPD COM CONTRIBUICOES DE CARATER EMERGENCIAL DE SERVICOS PRESTADOS PELAS CONCESSIONARIAS, PERMISSIONARIAS E AUTORIZADAS DE GERACAO E DE DISTRIBUICAO DE ENERGIA ELETRICA, REGULAMENTADA PELA LEI FEDERAL 10.438 DE 26 DE ABRIL DE 2002.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.0.0.00.00','CUSTO COM TRIBUTOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA RELATIVA A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - EXTRA OFSS','COMPREENDE AS VARIACOES DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.01.00','CMV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.02.00','CMV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.03.00','CMV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.04.00','CMV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.05.00','CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.06.00','CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.1.07.00','CMV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.01.00','CMV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.02.00','CMV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.03.00','CMV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.04.00','CMV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.05.00','CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.06.00','CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.2.07.00','CMV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS APROPRIADOS AS MERCADORIAS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.01.00','CMV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.02.00','CMV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.03.00','CMV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.04.00','CMV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.05.00','CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.06.00','CMV - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.1.3.07.00','CMV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - EXTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.01.00','CPV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.02.00','CPV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.03.00','CPV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.04.00','CPV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.05.00','CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.06.00','CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.1.07.00','CPV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.01.00','CPV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.02.00','CPV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.03.00','CPV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.04.00','CPV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.05.00','CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.06.00','CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.2.07.00','CPV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE BENS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.01.00','CPV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.02.00','CPV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.03.00','CPV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.04.00','CPV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.05.00','CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.06.00','CPV - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.2.3.07.00','CPV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.0.00.00','CUSTO DE SERVICOS PRESTADOS-TRIBUTOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.00.00','CUSTO DE SERVICOS PRESTADOS -TRIBUTOS - EXTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PARTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.01.00','CSP - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.02.00','CSP - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.03.00','CSP - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.04.00','CSP - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.05.00','CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.06.00','CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.1.07.00','CSP - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.00.00','CUSTO DE SERVICOS PRESTADOS -TRIBUTOS -INTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.01.00','CSP - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.02.00','CSP - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.03.00','CSP - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.04.00','CSP - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.05.00','CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.06.00','CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.2.07.00','CSP - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.00.00','CUSTO DE SERVICOS PRESTADOS-TRIBUTOS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS RELATIVAS A TRIBUTOS UTILIZADOS NA PRODUCAO DE SERVICOS,SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.01.00','CSP - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.02.00','CSP - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.03.00','CSP - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.04.00','CSP - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.05.00','CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.06.00','CSP - ContribuiCOes de IntervenCAo no DomInio EconOmico','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.7.8.3.3.07.00','CSP - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.0.0.0.00.00','OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS DIMINUTIVAS NAO INCLUIDAS NOS GRUPOS ANTERIORES. COMPREENDE: PREMIACOES, INCENTIVOS, EQUALIZACOES DE PRECOS E TAXAS, PARTICIPACOES E CONTRIBUICOES, RESULTADO NEGATIVO COM PARTICIPACOES, DENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.0.0.00.00','PREMIACOES','COMPREENDE AS AQUISICAO DE PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC., BEM COMO COM O PAGAMENTO DE PREMIOS EM PECUNIA, INCLUSIVE DECORRENTES DE SORTEIOS LOTERICOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.1.0.00.00','PREMIACOES CULTURAIS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.1.1.00.00','PREMIACOES CULTURAIS - EXTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.1.2.00.00','PREMIACOES CULTURAIS - INTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.1.3.00.00','PREMIACOES CULTURAIS - INTER OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CULTURAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.2.0.00.00','PREMIACOES ARTISTICAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.2.1.00.00','PREMIACOES ARTISTICAS - EXTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.2.2.00.00','PREMIACOES ARTISTICAS - INTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.2.3.00.00','PREMIACOES ARTISTICAS - INTER OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER ARTISTICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.3.0.00.00','PREMIACOES CIENTIFICAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.3.1.00.00','PREMIACOES CIENTIFICAS - EXTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.3.2.00.00','PREMIACOES CIENTIFICAS - INTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.3.3.00.00','PREMIACOES CIENTIFICAS - INTER OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER CIENTIFICO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.4.0.00.00','PREMIACOES DESPORTIVAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.4.1.00.00','PREMIACOES DESPORTIVAS - EXTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.4.2.00.00','PREMIACOES DESPORTIVAS - INTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.4.3.00.00','PREMIACOES DESPORTIVAS - INTER OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, DE CARATER DESPORTIVO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.5.0.00.00','ORDENS HONORIFICAS','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.5.1.00.00','ORDENS HONORIFICAS - EXTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.5.2.00.00','ORDENS HONORIFICAS - INTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.5.3.00.00','ORDENS HONORIFICAS - INTER OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, INSIGNIAS ETC, RELATIVO A ORDENS HONORIFICAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.9.0.00.00','OUTRAS PREMIACOES','COMPREENDE O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.9.1.00.00','OUTRAS PREMIACOES - EXTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.9.1.01.00','BONUS ESPECIAL DE DESEMPENHO INSTITUCIONAL - BESP/DNIT','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM BONUS ESPECIAL DE DESEMPENHO INSTITUCIONAL - BESP/DNIT AOS SERVIDORES DO DEPARTAMENTO DE INFRA-ESTRUTURA DE TRANSPORTE - DNIT - LEI Nº 12.155, DE 23/12/2009.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.9.2.00.00','OUTRAS PREMIACOES - INTRA OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.1.9.3.00.00','OUTRAS PREMIACOES - INTER OFSS','REGISTRA O VALOR GASTO COM PREMIOS, CONDECORACOES, MEDALHAS, TROFEUS, ETC, PARA FINALIDADES DIFERENTES DAS PREVISTAS NOS DETALHAMENTOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.2.0.0.00.00','RESULTADO NEGATIVO DE PARTICIPACOES','COMPREENDE A APROPRIACAO DO RESULTADO NEGATIVO DE PARTICIPACOES, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.2.1.0.00.00','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.2.1.1.00.00','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - EXTRA OFSS','REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.2.1.2.00.00','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTRA OFSS','REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.2.1.3.00.00','RESULTADO NEGATIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS','REGISTRA A APROPRIACAO DO RESULTADO NEGATIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE PREJUIZOS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.0.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.00','VPD COM OPERACOES DE AUTORIDADE MONETARIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.01','VPD COM OPERACOES COM TITULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.02','VPD COM OPERACOES DA AREA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.03','VPD COM OPERACOES DA AREA BANCARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.04','VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.05','VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.01.99','VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.00','VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.01','VPD DE CAPTACAO','REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.02','VPD DE OBRIGACOES EMPRESTIMOS E REPASSES','REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.03','VPD COM RESULTADO DE CAMBIO','REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.04','RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS','REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.05','VPD DE PARTICIPACOES','REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.06','VPD ADMINISTRATIVAS','REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.07','APROVISIONAMENTO E AJUSTES PATRIMONIAIS','REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.02.99','OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.03.00','VPD NAO OPERACIONAIS','REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.1.04.00','RATEIO DE RESULTADOS INTERNOS','REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.00','VPD COM OPERACOES DE AUTORIDADE MONETARIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.01','VPD COM OPERACOES COM TITULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.02','VPD COM OPERACOES DA AREA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.03','VPD COM OPERACOES DA AREA BANCARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.04','VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.05','VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.01.99','VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.00','VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.01','VPD DE CAPTACAO','REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.02','VPD DE OBRIGACOES EMPRESTIMOS E REPASSES','REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.03','VPD COM RESULTADO DE CAMBIO','REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.04','RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS','REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.05','VPD DE PARTICIPACOES','REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.06','VPD ADMINISTRATIVAS','REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.07','APROVISIONAMENTO E AJUSTES PATRIMONIAIS','REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.02.99','OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.03.00','VPD NAO OPERACIONAIS','REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.2.04.00','RATEIO DE RESULTADOS INTERNOS','REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DE INSTITUICOES FINANCEIRAS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.00','VPD COM OPERACOES DE AUTORIDADE MONETARIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OPERACOES DA AUTORIDADE MONETARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.01','VPD COM OPERACOES COM TITULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES DA AUTORIDADES MONETARIA COM TITULOS DE MERCADO E DE OUTRAS NATUREZAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.02','VPD COM OPERACOES DA AREA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.03','VPD COM OPERACOES DA AREA BANCARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.04','VPD COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.05','VPD COM TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -OPERACOES COM DERIVATIVOS ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS OCORRIDAS EM OPERACOES COM DERIVATIVOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.01.99','VPD COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.00','VPD OPERACIONAIS DE INSTITUICOES FINANCEIRAS',' COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS REFERENTES A TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.01','VPD DE CAPTACAO','REGISTRA O VALOR REFERENTE A VPD DE CAPTACAO DE RECURSOS PELAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.02','VPD DE OBRIGACOES EMPRESTIMOS E REPASSES','REGISTRA O VALOR REFERENTE A VPD DE OBRIGACOES COM EMPRESTIMOS E REPASSES DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.03','VPD COM RESULTADO DE CAMBIO','REGISTRA O VALOR DA VPD REFERENTE AO RESULTADO NEGATIVO DE CAMBIO DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.04','RES.DE TRANSACOES C/TIT.DE VAL.MOBILIARIOS','REGISTRA O VALOR DA VPD REFERENTES AO RESULTADO NEGATIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS REALIZADOS PELAS INSTITUICOES FINANCEIRAS ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.05','VPD DE PARTICIPACOES','REGISTRA O VALOR DA VPD DE INSTITUICAO FINANCEIRA COM O RESULTADO NEGATIVO DAS PARTICIPACOES SOCIETARIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.06','VPD ADMINISTRATIVAS','REGISTRA O VALOR DA VPD QUE VISEM A DIRECAO OU GESTAO DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.07','APROVISIONAMENTO E AJUSTES PATRIMONIAIS','REGISTRA O VALOR DA VPD REFERENTE A APROVISIONAMENTO E AJUSTES PATRIMONIAIS REALIZADAS PELAS INSTITUICOES FINANCEIRAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.02.99','OUTRAS DESPESAS OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA O VALOR REFERENTE A OUTRAS DESPESAS DE NATUREZA EVENTUAL VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.03.00','VPD NAO OPERACIONAIS','REGISTRA O VALOR DA VPD COM TRANSACOES REALIZADAS NO PERIODO, NAO VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.3.0.3.04.00','RATEIO DE RESULTADOS INTERNOS','REGISTRA O VALOR DA VPD DE INSTITUICOES FINANCEIRAS COM DISTRIBUICAO DE RESULTADOS INTERNOS NEGATIVOS DO EXERCICIO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.0.0.00.00','INCENTIVOS','COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS RELATIVOS A EDUCACAO, A CIENCIA E A CULTURA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.0.00.00','INCENTIVOS A EDUCACAO','COMPREENDE A AJUDA FINANCEIRA CONCEDIDA PELO ESTADO A ESTUDANTES COMPROVADAMENTE CARENTES, E CONCESSAO DE AUXILIO PARA O DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA, REALIZADAS POR PESSOAS FISICAS NA CONDICAO DE ESTUDANTE','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.1.00.00','INCENTIVOS A EDUCACAO - EXTRA OFSS','COMPREENDE A AJUDA FINANCEIRA CONCEDIDA PELO ESTADO A ESTUDANTES COMPROVADAMENTE CARENTES, E CONCESSAO DE AUXILIO PARA O DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA, REALIZADAS POR PESSOAS FISICAS NA CONDICAO DE ESTUDANTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.1.01.00','BOLSA DE ESTUDOS NO PAIS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO NO PAIS, A QUALQUER TITULO, E DEMAIS AUXILIOS FINANCEIROS A ESTUDANTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.1.02.00','BOLSA DE ESTUDOS NO EXTERIOR',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM BOLSAS DE ESTUDO NO EXTERIOR, A QUALQUER TITULO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.1.03.00','AUXILIOS PARA DESENV. DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM CONCESSAO DE AUXILIOS FINANCEIROS A ESTUDANTES PARA DESENVOLVIMENTO DE ESTUDOS E PESQUISAS DE NATUREZA CIENTIFICA, OBSERVADO O DISPOSTO NO ART. 26 DA LEI COMPLEMENTAR N.101, DE 2000. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.1.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.1.1.99.00','OUTROS INCENTIVOS A EDUCACAO','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A EDUCACAO NAO CONTEMPLADOS NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.2.0.00.00','INCENTIVOS A CIENCIA','COMPREENDE O APOIO FINANCEIRO CONCEDIDO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS MAIS DIVERSAS MODALIDADES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.2.1.00.00','INCENTIVOS A CIENCIA - EXTRA OFSS','COMPREENDE O APOIO FINANCEIRO CONCEDIDO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS MAIS DIVERSAS MODALIDADES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.2.1.01.00','AUXILIO A PESQUISADORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO FINANCEIRO A PESQUISADORES, INDIVIDUAL OU COLETIVAMENTE, EXCETO NA CONDICAO DE ESTUDANTE, NO DESENVOLVIMENTO DE PESQUISAS CIENTIFICAS E TECNOLOGICAS, NAS SUAS DIVERSAS MODALIDADES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.2.1.02.00','AUXILIO AS ATIVIDADES AUXILIARES DE PESQUISA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO FINANC.A PESQUISADOR RELAT.AO APOIO AAS ATIVIDADES AUXILIARES DE PESQUISA, EM ATENDIMENTO AA RESOLUCAO N° 08/06-COPLAD, EDITADA PELO CONSELHO DE PLANEJAMENTO E ADMINISTRACAO DA UNIVERSIDADE FEDERAL DO PARANA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.2.1.99.00','OUTROS INCENTIVOS A CIENCIA','REGISTRA OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM INCENTIVOS A CULTURA CONTEMPLADOS NOS ITENS ANTERIORES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.3.0.00.00','INCENTIVOS A CULTURA','COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.3.1.00.00','INCENTIVOS A CULTURA - EXTRA OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.3.2.00.00','INCENTIVOS A CULTURA - INTRA OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.3.3.00.00','INCENTIVOS A CULTURA - INTER OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DA CULTURA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.4.0.00.00','INCENTIVOS AO ESPORTE','COMPREENDE OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.4.1.00.00','INCENTIVOS AO ESPORTE - EXTRA OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.4.2.00.00','INCENTIVOS AO ESPORTE - INTRA OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.4.3.00.00','INCENTIVOS AO ESPORTE - INTER OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS, VISANDO A PROMOCAO DO ESPORTE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.9.0.00.00','OUTROS INCENTIVOS','COMPREENDE OUTROS INCENTIVOS FINANCEIROS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.9.1.00.00','OUTROS INCENTIVOS - EXTRA OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.9.2.00.00','OUTROS INCENTIVOS - INTRA OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.4.9.3.00.00','OUTROS INCENTIVOS - INTER OFSS','REGISTRA OS INCENTIVOS FINANCEIROS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.0.00.00','SUBVENCOES ECONOMICAS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM O PAGAMENTO DE SUBVENCOES ECONOMICAS, A QUALQUER TITULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICACOES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVICOS EM GERAL; E, AINDA, OUTRAS OPERACOES COM CARACTERISTICAS SEMELHANTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.00.00','SUBVENCOES ECONOMICAS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM O PAGAMENTO DE SUBVENCOES ECONOMICAS, A QUALQUER TITULO, AUTORIZADAS EM LEIS ESPECIFICAS, TAIS COMO: AJUDA FINANCEIRA A ENTIDADES PRIVADAS COM FINS LUCRATIVOS; CONCESSAO DE BONIFICACOES A PRODUTORES, DISTRIBUIDORES E VENDEDORES; COBERTURA, DIRETA OU INDIRETA, DE PARCELA DE ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS E DOS CUSTOS DE AQUISICAO, DE PRODUCAO, DE ESCOAMENTO, DE DISTRIBUICAO, DE VENDA E DE MANUTENCAO DE BENS, PRODUTOS E SERVICOS EM GERAL; E, AINDA, OUTRAS OPERACOES COM CARACTERISTICAS SEMELHANTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.01.00','CORRECAO MONETARIA',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CORRECAO MONETARIA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.02.00','DIFERENCIAL DE JUROS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES COM DIFERENCIAL DE TAXAS DE JUROS, PREVISTO EM CONTRATO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.03.00','PROGRAMA ESPECIAL DE SANEAMENTO ATIVOS - PESA',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA ESPECIAL DE SANEAMENTO DE ATIVOS - PESA. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.04.00','PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.05.00','INCENTIVOS - FORNECIMENTO DE OLEO DIESEL',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE PRECOS REFERENTES A INCENTIVOS COM FORNECIMENTO DE OLEO DIESEL A EMBARCACOES PESQUEIRAS NACIONAIS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.06.00','GARANTIA E SUSTENTACAO DE PRECOS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GARANTIA E SUSTENTACAO DE PRECOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.07.00','PROGRAMA DE SUBS.A HABIT.DE INTER.SOCIAL-PSH',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE SUBISIDIO A HABITACAO DE INTERESSE SOCIAL - PSH ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.08.00','CUSTOS ADMINISTRATIVOS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO PREVISTO EM CONTRATO. DECISAO TCU 498/2002, 15/03/02 ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.09.00','CUSTEIO AGROPECUARIO',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DO CUSTO DE CAPTCAO E APLICACAO DE RECURSOS NO PROGRAMA DE ASSENTAMENTO.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.10.00','EMPRESTIMOS DO GOVERNO FEDERAL','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O DIFERENCIAL DE PRECO  ENTRE A CAPTCAO E APLICACAO DE RECURSOS EM PROGRAMAS DE EMPRESTIMOS DO GOVERNO FEDERAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.11.00','AQUISICOES DO GOVERNO FEDERAL','  REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O DIFERENCIAL DE PRECO  NAS AQUISICOES DE PRODUTOS PARA O ESTOQUE REGULADOR DO GOVERNO FEDERAL ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.12.00','PROG. NAC. FORTALEC. AGRIC. FAMILIAR',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PRONAF, SUBSIDIO PARA ASSENTAMENTO FAMILIAR. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.13.00','SUBVENCAO ECONOMICA AO PREMIO DO SEGURO RURAL',' REGISTRA A SUBVENCAO ECONOMICA AO PREMIO DO SEGURO RURAL. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.14.00','PARCELA NAO RECUPERAVEL-UNIVERSALIZACAO/FUST',' REGISTRA AS APLICACOES DE RECURSOS DO FUNDO DE UNIVERSALIZACAO DAS TELECOMUNICACOES - FUST, NO AMBITO DO PROJETO DE "ATENDIMENTO AAS INSTITUICOES DE ASSISTENCIA AAS PESSOAS COM DEFICIENCIA AUDITIVA", MEDI- ANTE SUBVENCAO AOS PRECOS COBRADOS PELAS OPERADORAS DO SISTEMA DE TELEFONIA, CORRESPONDENTE AOS CUSTOS NAO RECUPERAVEIS DAS CONCESSIONARIAS COM A EXECUCAO DO REFERIDO PROJETO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.15.00','REVITALIZACAO-REESTRUT.PRODUT.E EXPORT- JUROS',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE JUROS EM FINANCIAMENTOS DESTINADOS A REESTRUTURACAO PRODUTIVA E AS EXPORTACOES.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.16.00','PROGRAMA DE FARMACIA POPULAR DO BRASIL',' REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE SUBSIDIOS DE PRECOS DE MEDICAMENTOS DISPONIBILIZADOS POR INTERMEDIO DA REDE PRIVADA DE FARMACIAS E DROGARIAS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.17.00','PROGRAMA MINHA CASA, MINHA VIDA - PMCMV',' REGISTRA O VALOR DAS APROPRIACOES DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA MINHA CASA, MINHA VIDA - PMCMV - REGULAMENTADO PELA LEI NR. 11977/2009  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.18.00','SUBVENCAO ECONOMICA S/ PREMIO SEGURO GARANTIA','  REGISTRA A SUBVENCAO ECONOMICA AO PREMIO DO SEGURO GARANTIA.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.19.00','AQUISICAO E PRODUCAO DE BENS DE CAPITAL',' REGISTRA O VALOR DE APROPRIACAO DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE TAXAS DE JUROS NAS OPERACOES DE FINANCIAMENTO DESTINADOS A AQUISICAO E PRODUCAO DE BENS DE CAPITAL E A INOVACAO TECNOLOGICA (MP 465, DE 2009). ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.98.00','INTEGR. DADOS ORGAOS E ENTID. PARCIAIS SIAFI',' REGISTRA O VALOR DAS DESPESAS DECORRENTES DA INTEGRACAO DOS BALANCETES DOS ORGAOS E ENTIDADES PARCIAIS NO SIAFI ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.5.0.1.99.00','OUTRAS EQUALIZACOES DE PRECOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM OUTRAS EQUALIZACOES DE PRECOS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.0.0.00.00','PARTICIPACOES E CONTRIBUICOES','COMPREENDE AS PARTICIPACOES DE TERCEIROS NOS LUCROS, NAO RELATIVAS AO INVESTIMENTO DOS ACIONISTAS, TAIS COMO: PARTICIPACOES DE DEBENTURES, EMPREGADOS, ADMINISTRADORES E PARTES BENEFICIARIAS, MESMO NA FORMA DE INSTRUMENTOS FINANCEIROS. ALEM DA CONTRIBUICAO A INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.1.0.00.00','PARTICIPACOES DE DEBENTURES','COMPREENDE AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.1.1.00.00','PARTICIPACOES DE DEBENTURES - EXTRA OFSS','REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.1.2.00.00','PARTICIPACOES DE DEBENTURES - INTRA OFSS','REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.1.3.00.00','PARTICIPACOES DE DEBENTURES - INTER OFSS','REGISTRA AS PARTICIPACOES DE DEBENTURES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.2.0.00.00','PARTICIPACOES DE EMPREGADOS','COMPREENDE AS PARTICIPACOES DE EMPREGADOS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.2.1.00.00','PARTICIPACOES DE EMPREGADOS - EXTRA OFSS','REGISTRA AS PARTICIPACOES DE EMPREGADOS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.3.0.00.00','PARTICIPACOES DE ADMINISTRADORES','COMPREENDE AS PARTICIPACOES DE ADMINISTRADORES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.3.1.00.00','PARTICIPACOES DE ADMINISTRADORES - EXTRA OFSS','REGISTRA AS PARTICIPACOES DE ADMINISTRADORES INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.4.0.00.00','PARTICIPACOES DE PARTES BENEFICIARIAS','COMPREENDE AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.4.1.00.00','PARTICIPACOES DE PARTES BENEFICIARIAS - EXTRA OFSS','REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.4.2.00.00','PARTICIPACOES DE PARTES BENEFICIARIAS - INTRA OFSS','REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.4.3.00.00','PARTICIPACOES DE PARTES BENEFICIARIAS - INTER OFSS','REGISTRA AS PARTICIPACOES DE PARTES BENEFICIARIAS INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.5.0.00.00','PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS','COMPREENDE AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.5.1.00.00','PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS - EXTRA OFSS','REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.5.2.00.00','PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS - INTRA OFSS','REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.6.5.3.00.00','PARTICIPACOES DE INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS INTER OFSS','REGISTRA AS CONTRIBUICOES DA EMPRESA, INCIDENTES SOBRE O LUCRO APOS IMPOSTO DE RENDA E CONTRIBUICAO SOCIAL SOBRE O LUCRO LIQUIDO, PARA INSTITUICOES OU FUNDOS DE ASSISTENCIA OU PREVIDENCIA DE EMPREGADOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.0.0.00.00','CUSTO DE OUTRAS VPD','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS OU SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.1.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.1.3.00.00','CUSTO DE MERCADORIAS VENDIDAS - OUTRAS VPD - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS AS MERCADORIAS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.2.2.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE MESMOS ENTES PUBLICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.2.3.00.00','CUSTO DE PRODUTOS VENDIDOS - OUTRAS VPD - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE BENS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.3.0.00.00','CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.3.1.00.00','CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - EXTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.3.2.00.00','CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - INTRA OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE MESMOS ENTES PUBLICOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.8.3.3.00.00','CUSTO DE SERVICOS PRESTADOS - OUTRAS VPD - INTER OFSS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS APROPRIADAS NA PRODUCAO DE SERVICOS, SENDO REGISTRADO APENAS NO MOMENTO DA VENDA DESTES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.0.0.00.00','DIVERSAS VARIACOES PATRIMONIAIS DIMINUTIVAS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS DIMINUTIVAS NAO CLASSIFICADAS EM ITENS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.1.0.00.00','COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.1.2.00.00','COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.1.3.00.00','COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.2.0.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.2.1.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.2.2.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS . COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.2.3.00.00','VARIACAO PATRIMONIAL DIMINUTIVA COM BONIFICACOES - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE BONIFICACOES CONCEDIDAS NA VENDA DE MERCADORIAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.3.0.00.00','AMORTIZACAO DE AGIO EM INVESTIMENTOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.3.1.00.00','AMORTIZACAO DE AGIO EM INVESTIMENTOS -EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.3.2.00.00','AMORTIZACAO DE AGIO EM INVESTIMENTOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.3.3.00.00','AMORTIZACAO DE AGIO EM INVESTIMENTOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE AMORTIZACAO DE AGIO EM INVESTIMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.0.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.1.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORESS DIVERSOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.1.01.00','PROVISAO MATEMATICAS PREVIDENCIARIAS',' REGISTRA O VALOR DAS CONSTITUICOES DAS PROVISOES MATEMATICAS PREVIDENCIARIAS. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.1.02.00','HONRA DE AVAIS','REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.2.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.2.02.00','HONRA DE AVAIS','REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.3.00.00','VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('3.9.9.9.3.02.00','HONRA DE AVAIS','REGISTRA OS VALORES QUE A ADMINISTRACAO E COMPELIDA A REALIZAR EM DECORRENCIA DE HONRA DE AVAIS.  ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.0.0.0.0.00.00','VARIACAO PATRIMONIAL AUMENTATIVA','COMPREENDE O AUMENTO NO BENEFICIO ECONOMICO DURANTE O PERIODO CONTABIL SOB A FORMA DE ENTRADA DE RECURSO OU AUMENTO DE ATIVO OU DIMINUICAO DE PASSIVO, QUE RESULTE EM AUMENTO DO PATRIMONIO LIQUIDO E QUE NAO SEJAM PROVENIENTES DE APORTE DOS PROPRIETARIOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.0.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUICOES DE MELHORIA','COMPREENDE TODA PRESTACAO PECUNIARIA COMPULSORIA, EM MOEDA OU CUJO VALOR NELA SE POSSA EXPRIMIR, QUE NAO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE ADMINISTRATIVA PLENAMENTE VINCULADA. COMO : IMPOSTOS , TAXAS E CONTRIBUICOES DE MELHORIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.0.0.00.00','IMPOSTOS','COMPREENDE OS TRIBUTOS CUJA OBRIGACAO TEM POR FATO GERADOR UMA SITUACAO INDEPENDENTE DE QUALQUER ATIVIDADE ESTATAL ESPECIFICA, RELATIVA AO CONTRIBUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.0.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.1.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - EXTRA OFSS','COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR,COMO EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTOS SOBRE A EXPORTACAO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.1.01.00',' IMPOSTO S/ IMPORTACAO','REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.1.02.00',' IMPOSTO S/ EXPORTACAO','REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COMO FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.2.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - INTRA OFSS',' COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.2.01.00',' IMPOSTO S/ IMPORTACAO','REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.2.02.00',' IMPOSTO S/ EXPORTACAO','REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.2.97.00','(-)DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.3.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - INTER OFSS',' COMPREENDE OS IMPOSTOS SOBRE OPERACOES DE COMERCIO EXTERIOR, COMO POR EXEMPLO: IMPOSTOS SOBRE A IMPORTACAO E IMPOSTO SOBRE A EXPORTACAO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.3.01.00',' IMPOSTO S/ IMPORTACAO','REGISTRA VPA COM O IMPOSTO SOBRE IMPORTACAO, DE COMPETENCIA DA UNIAO, QUE INCIDE SOBRE A IMPORTACAO DE PRODUTOS ESTRANGEIROS E TEM COMO FATO GERADOR A ENTRADA DESSES PRODUTOS NO TERRITORIO NACIONAL, POR QUALQUER VIA DE ACESSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.3.02.00',' IMPOSTO S/ EXPORTACAO','REGISTRA VPA COM O IMPOSTO SOBRE A EXPORTACAO, DE COMPETENCIA DA UNIAO. INCIDE SOBRE A EXPORTACAO, PARA O ESTRANGEIRO, DE PRODUTOS NACIONAIS OU NACIONALIZADOS E TEM COMO FATO GERADOR A SAIDA DESSES PRODUTOS DO TERRITORIO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.1.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.0.00.00','IMPOSTOS SOBRE PATRIMONIO E A RENDA','COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA, COMO POR EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.00.00','IMPOSTOS SOBRE PATRIMONIO E A RENDA - EXTRA OFSS','  COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COMO EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL,IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA,IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.01.01','ITR - MUNICIPIOS CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.01.02','ITR - MUNICIPIOS NAO CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.01','IR - PESSOAS FISICAS','REGISTRA O VALOR TOTAL QUE INCIDE SOBRE OS RENDIMENTOS E GANHOS DE CAPITAL PERCEBIDOS PELAS PESSOAS FISICAS RESIDENTES OU DOMICILIADAS NO BRASIL. INTEGRAM O RENDIMENTO BRUTO SUJEITO A INCIDENCIA DESSE IMPOSTO O GANHO DE CAPITAL DECORRENTE DA ALIENACAO DE BENS E DIREITOS E OS GANHOS LIQUIDOS AUFERIDOS EM OPERACOES REALIZADAS NAS BOLSAS DE VALORES E ASSEMELHADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.02','IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS','REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.03','IR RETIDO NAS FONTES - TRABALHO','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - TRABALHO ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.04','IR RETIDO NAS FONTES - CAPITAL','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.05','IR RETIDO NAS FONTES - REMESSA AO EXTERIOR','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.06','IR RETIDO NAS FONTES - OUTROS RENDIMENTOS','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.02.07','IRPJ - SIMPLES FEDERAL E NACIONAL','  REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSO A JURIDICA - SIMPLES FEDERAL E NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.07','(-) ITR',' REGISTRA A DEDUCAO CONFORME ART. 158 DA CF/88 : " ART. 158. PERTENCEM AOS MUNICIPIOS: (...) II - CINQUENTA POR CENTO DO PRODUTO DA ARRECADACAO DO IMPOSTO DA UNIAO SOBRE A PROPRIEDADE TERRITORIAL RURAL, RELATIVAMENTE AOS IMOVEIS NELES SITUADOS, CABENDO A TOTALIDADE NA HIPOTESE DA OPCAO A QUE SE REFERE O ART. 153, § 4º, III"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.00.00','IMPOSTOS SOBRE PATRIMONIO E A RENDA - INTRA OFSS','COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COMO POR EXEMPLO: IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL, IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.01.01','ITR - MUNICIPIOS CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.01.02','ITR - MUNICIPIOS NAO CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.02.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.02.02','IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS','REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.02.04','IR RETIDO NAS FONTES - CAPITAL','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.02.05','IR RETIDO NAS FONTES - REMESSA AO EXTERIOR','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.02.06','IR RETIDO NAS FONTES - OUTROS RENDIMENTOS','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.02.07','IRPJ - SIMPLES FEDERAL E NACIONAL','  REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSO A JURIDICA - SIMPLES FEDERAL E NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.07','(-) ITR',' REGISTRA A DEDUCAO CONFORME ART. 158 DA CF/88 : " ART. 158. PERTENCEM AOS MUNICIPIOS: (...) II - CINQUENTA POR CENTO DO PRODUTO DA ARRECADACAO DO IMPOSTO DA UNIAO SOBRE A PROPRIEDADE TERRITORIAL RURAL, RELATIVAMENTE AOS IMOVEIS NELES SITUADOS, CABENDO A TOTALIDADE NA HIPOTESE DA OPCAO A QUE SE REFERE O ART. 153, § 4º, III"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.00.00','IMPOSTOS SOBRE PATRIMONIO E A RENDA - INTER OFSS',' COMPREENDE OS IMPOSTOS SOBRE PATRIMONIO E A RENDA,COM POR EXEMPLO:IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA, IMPOSTO SOBRE A TRANSMISSAO DE BENS IMOVEIS E DE DIREITOS A ELES RELATIVOS E IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','COMPREENDE A VPA COM O IMPOSTO S/PROPRIEDADE TERRITORIAL RURAL, DE COMPETENCIA DA UNIAO. TEM COMO FATO GERADOR A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL POR NATUREZA, COMO DEFINIDO NA LEI CIVIL, LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.01.01','ITR - MUNICIPIOS CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO, CONFORME CONVENIO COM A UNIAO PARA FISCALIZACAO DO REFERIDO IMPOSTO; - DESTINACAO LEGAL: O MUNICIPIO OU O DISTRITO FEDERAL OPTANTE FARA JUS A TOTALIDADE DO PRODUTO DA ARRECADACAO DO ITR REFERENTE AOS IMOVEIS RURAIS NELE SITUADOS, A PARTIR DO MOMENTO DISCIPLINADO NO CONVENIO; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III B)LEI 5172/1966 ART 29 A 31 C) EC 42/2003 D) LEI 9393/1996 E) LEI 11250/2005 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.01.02','ITR - MUNICIPIOS NAO CONVENIADOS','REGISTRA O VALOR TOTAL DA VPA COM O IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO-CONVENIADOS. - FATO GERADOR: A PROPRIEDADE, O DOMINIO UTIL OU A POSSE DE IMOVEL LOCALIZADO FORA DA ZONA URBANA DO MUNICIPIO NAO-CONVENIADO; _ 50% PERTENCEM A UNIAO E 50% PERTENCEM AOS MUNICIPIOS ONDE OS IMOVEIS ESTIVEREM SITUADOS, CONFORME ART 158, II DA CF/1988; - AMPARO LEGAL: A)CF, ART 153, VI E § 4º, III; B)LEI 5172/1966 ART 29 A 31; C) EC 42/2003; D) LEI 9393/1996; C) EC 42/2003. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.02.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA TEM COMO FATO GERADOR A AQUISICAO DA DISPONIBILIDADE ECONOMICA OU JURIDICA: I - DE RENDA, ASSIM ENTENDIDO O PRODUTO DO CAPITAL, DO TRABALHO OU DA COMBINACAO DE AMBOS; II - DE PROVENTOS DE QUALQUER NATUREZA, ASSIM ENTENDIDOS OS ACRESCIMOS PATRIMONIAIS NAO COMPREENDIDOS NO ITEM ANTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.02.02','IR - PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS','REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS - LIQUIDA DE INCENTIVOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.02.04','IR RETIDO NAS FONTES - CAPITAL','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - CAPITAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.02.05','IR RETIDO NAS FONTES - REMESSA AO EXTERIOR','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - REMESSA AO EXTERIOR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.02.06','IR RETIDO NAS FONTES - OUTROS RENDIMENTOS','REGISTRA A VPA COM IMPOSTO DE RENDA RETIDO NAS FONTES - OUTROS RENDIMENTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.02.07','IRPJ - SIMPLES FEDERAL E NACIONAL','  REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE IMPOSTO DE RENDA PESSOA JURIDICA - SIMPLES FEDERAL E NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA:A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.07','(-) ITR',' REGISTRA A DEDUCAO CONFORME ART. 158 DA CF/88 : " ART. 158. PERTENCEM AOS MUNICIPIOS: (...) II - CINQUENTA POR CENTO DO PRODUTO DA ARRECADACAO DO IMPOSTO DA UNIAO SOBRE A PROPRIEDADE TERRITORIAL RURAL, RELATIVAMENTE AOS IMOVEIS NELES SITUADOS, CABENDO A TOTALIDADE NA HIPOTESE DA OPCAO A QUE SE REFERE O ART. 153, § 4º, III"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.2.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.0.00.00','IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO','COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS;IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA;','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.00.00','IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO -EXTRA OFSS',' COMPRENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO,COMO POR EXEMPLO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS;IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.01','IPI -PRODUTOS DO FUMO','REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.02','IPI - BEBIDAS','REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.03','IPI - VEICULOS','REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.04','IPI - VINCULADOS A IMPORTACAO','REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.05','IPI - SIMPLES FEDERAL E NACIONAL','REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.01.99','IPI - OUTROS PRODUTOS','REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.02.00','IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS','COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.02.01','IOF - COMERCIALIZACAO DO OURO','REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.02.99','IOF - DEMAIS OPERACOES','REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.08','(-) IPI EXPORTACAO',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : "A UNIAO ENTREGARA: (...) II - DO PRODUTO DA ARRECADACAO DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS, DEZ POR CENTO AOS ESTADOS E AO DISTRITO FEDERAL, PROPORCIONALMENTE AO VALOR DAS RESPECTIVAS EXPORTACOES DE PRODUTOS INDUSTRIALIZADOS."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.09','(-) IOF OURO','REGISTRA A DEDUCAO CONFORME ART 153 DA CF /88 : "(...) § 5º - O OURO, QUANDO DEFINIDO EM LEI COMO ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, SUJEITA-SE EXCLUSIVAMENTE A INCIDENCIA DO IMPOSTO DE QUE TRATA O INCISO V DO "CAPUT" DESTE ARTIGO, DEVIDO NA OPERACAO DE ORIGEM; A ALIQUOTA MINIMA SERA DE UM POR CENTO, ASSEGURADA A TRANSFERENCIA DO MONTANTE DA ARRECADACAO NOS SEGUINTES TERMOS: I - TRINTA POR CENTO PARA O ESTADO, O DISTRITO FEDERAL OU O TERRITORIO, CONFORME A ORIGEM; II - SETENTA POR CENTO PARA O MUNICIPIO DE ORIGEM."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.00.00','IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO -INTRA OFSS',' COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, COMO POR EXEMPLO: IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS; IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS; IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.01','IPI -PRODUTOS DO FUMO','REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.02','IPI - BEBIDAS','REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.03','IPI - VEICULOS','REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.04','IPI - VINCULADOS A IMPORTACAO','REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.05','IPI - SIMPLES FEDERAL E NACIONAL','REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.01.99','IPI - OUTROS PRODUTOS','REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.02.00','IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS','COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR:  I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.02.01','IOF - COMERCIALIZACAO DO OURO','REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.02.99','IOF - DEMAIS OPERACOES','REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.08','(-) IPI EXPORTACAO',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : "A UNIAO ENTREGARA: (...) II - DO PRODUTO DA ARRECADACAO DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS, DEZ POR CENTO AOS ESTADOS E AO DISTRITO FEDERAL, PROPORCIONALMENTE AO VALOR DAS RESPECTIVAS EXPORTACOES DE PRODUTOS INDUSTRIALIZADOS."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.09','(-) IOF OURO','REGISTRA A DEDUCAO CONFORME ART 153 DA CF /88 : "(...) § 5º - O OURO, QUANDO DEFINIDO EM LEI COMO ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, SUJEITA-SE EXCLUSIVAMENTE A INCIDENCIA DO IMPOSTO DE QUE TRATA O INCISO V DO "CAPUT" DESTE ARTIGO, DEVIDO NA OPERACAO DE ORIGEM; A ALIQUOTA MINIMA SERA DE UM POR CENTO, ASSEGURADA A TRANSFERENCIA DO MONTANTE DA ARRECADACAO NOS SEGUINTES TERMOS: I - TRINTA POR CENTO PARA O ESTADO, O DISTRITO FEDERAL OU O TERRITORIO, CONFORME A ORIGEM; II - SETENTA POR CENTO PARA O MUNICIPIO DE ORIGEM."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.00.00','IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO -INTER OFSS','  COMPREENDE OS IMPOSTOS SOBRE A PRODUCAO E A CIRCULACAO, POR EXEMPLO:  IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS;IMPOSTO SOBRE OPERACOES DE CREDITO;CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS; IMPOSTO SOBRE SERVICOS DE QUALQUER NATUREZA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) E ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS','COMPREENDE O VALOR DO IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE PRODUTOS INDUSTRIALIZADOS TEM COMO FATO GERADOR: I - O SEU DESEMBARACO ADUANEIRO, QUANDO DE PROCEDENCIA ESTRANGEIRA; II - A SUA SAIDA DOS ESTABELECIMENTOS A QUE SE REFERE O PARAGRAFO UNICO DO ARTIGO 51 DO CTN; III - A SUA ARREMATACAO, QUANDO APREENDIDO OU ABANDONADO E LEVADO A LEILAO. PARA OS EFEITOS DESTE IMPOSTO, CONSIDERA-SE INDUSTRIALIZADO O PRODUTO QUE TENHA SIDO SUBMETIDO A QUALQUER OPERACAO QUE LHE MODIFIQUE A NATUREZA OU A FINALIDADE, OU O APERFEICOE PARA O CONSUMO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.01','IPI -PRODUTOS DO FUMO','REGISTRA A VPA COM O IPI - PRODUTOS DO FUMO. INCIDENTE SOBRE O FUMO (TABACO) NAO MANUFATURADO, CHARUTOS, CIGARRILHAS E CIGARROS DE FUMO E SOBRE OUTROS PRODUTOS DO FUMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.02','IPI - BEBIDAS','REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE BEBIDAS ALCOOLICAS, REFRIGERANTES, REFRESCOS, AGUA MINERAL OU GASEIFICADA, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.03','IPI - VEICULOS','REGISTRA A VPA COM O IPI SOBRE VEICULOS AUTOMOTORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.04','IPI - VINCULADOS A IMPORTACAO','REGISTRA A VPA COM O IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS INCIDENTE SOBRE PRODUTOS INDUSTRIALIZADOS DE PROCEDENCIA ESTRANGEIRA, O FATO GERADOR E O DESEMBARACO ADUANEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.05','IPI - SIMPLES FEDERAL E NACIONAL','REGISTRA A VPA DECORRENTE DE IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS - SIMPLES FEDERAL E NACIONAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.01.99','IPI - OUTROS PRODUTOS','REGISTRA A VPA COM O IPI RELATIVA AS DEMAIS MERCADORIAS AS QUAIS INCIDE O IPI, TAIS COMO FERRO FUNDIDO, FERRO E ACO, MAQUINAS, APARELHOS E MATERIAIS ELETRICOS E OUTRAS RELACIONADAS NA TABELA DE INCIDENCIA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.02.00','IMPOSTOS S/ OPERACAO DE CREDITO, CAMBIO, SEGUROS OU RELATIVOS A TITULOS E VALORES MOBILIARIOS','COMPREENDE O VALOR DA VPA COM O IMPOSTO, DE COMPETENCIA DA UNIAO, SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, E SOBRE OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS TEM COMO FATO GERADOR: I - QUANTO AS OPERACOES DE CREDITO, A SUA EFETIVACAO PELA ENTREGA TOTAL OU PARCIAL DO MONTANTE OU DO VALOR QUE CONSTITUA O OBJETO DA OBRIGACAO, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; II - QUANTO AS OPERACOES DE CAMBIO, A SUA EFETIVACAO PELA ENTREGA DE MOEDA NACIONAL OU ESTRANGEIRA, OU DE DOCUMENTO QUE A REPRESENTE, OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO EM MONTANTE EQUIVALENTE A MOEDA ESTRANGEIRA OU NACIONAL ENTREGUE OU POSTA A DISPOSICAO POR ESTE; III - QUANTO AS OPERACOES DE SEGURO, A SUA EFETIVACAO PELA EMISSAO DA APOLICE OU DO DOCUMENTO EQUIVALENTE, OU RECEBIMENTO DO PREMIO, NA FORMA DA LEI APLICAVEL; IV - QUANTO AS OPERACOES RELATIVAS A TITULOS E VALORES MOBILIARIOS, A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES, NA FORMA DA LEI APLICAVEL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.02.01','IOF - COMERCIALIZACAO DO OURO','REGISTRA A VPA COM O IOF QUE INCIDE SOBRE A PRIMEIRA AQUISICAO DO OURO, ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, EFETUADA POR INSTITUICAO INTEGRANTE DO SISTEMA FINANCEIRO NACIONAL. NO CASO DE OURO FISICO ORIUNDO DO EXTERIOR, INGRESSADO NO PAIS, O FATO GERADOR E O SEU DESEMBARACO ADUANEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.02.99','IOF - DEMAIS OPERACOES','REGISTRA A VPA COM O IOF INCIDENTE SOBRE AS DEMAIS OPERACOES: DE CREDITO - A ENTREGA DOS RECURSOS OU SUA COLOCACAO A DISPOSICAO DO INTERESSADO; DE CAMBIO RELATIVAS A IMPORTACAO DE SERVICOS - A LIQUIDACAO DO CONTRATO DE CAMBIO; DE SEGURO - O RECEBIMENTO DO PREMIO; COM TITULOS E VALORES MOBILIARIOS - A EMISSAO, TRANSMISSAO, PAGAMENTO OU RESGATE DESTES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.08','(-) IPI EXPORTACAO',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : "A UNIAO ENTREGARA: (...) II - DO PRODUTO DA ARRECADACAO DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS, DEZ POR CENTO AOS ESTADOS E AO DISTRITO FEDERAL, PROPORCIONALMENTE AO VALOR DAS RESPECTIVAS EXPORTACOES DE PRODUTOS INDUSTRIALIZADOS."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.09','(-) IOF OURO','REGISTRA A DEDUCAO CONFORME ART 153 DA CF /88 : "(...) § 5º - O OURO, QUANDO DEFINIDO EM LEI COMO ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, SUJEITA-SE EXCLUSIVAMENTE A INCIDENCIA DO IMPOSTO DE QUE TRATA O INCISO V DO "CAPUT" DESTE ARTIGO, DEVIDO NA OPERACAO DE ORIGEM; A ALIQUOTA MINIMA SERA DE UM POR CENTO, ASSEGURADA A TRANSFERENCIA DO MONTANTE DA ARRECADACAO NOS SEGUINTES TERMOS: I - TRINTA POR CENTO PARA O ESTADO, O DISTRITO FEDERAL OU O TERRITORIO, CONFORME A ORIGEM; II - SETENTA POR CENTO PARA O MUNICIPIO DE ORIGEM."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.3.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.4.0.00.00','IMPOSTOS EXTRAORDINARIOS','COMPREENDE OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS, GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRACAO DA PAZ.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.4.1.00.00','IMPOSTOS EXTRAORDINARIOS - EXTRA OFSS','REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS,GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRACAO DA PAZ.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.4.2.00.00','IMPOSTOS EXTRAORDINARIOS - INTRA OFSS','REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS,GRADATIVAMENTE, NO PRAZO MAXIMO DE CINCO ANOS, CONTADOS DA CELEBRACAO DA PAZ.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO OR CAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.4.3.00.00','IMPOSTOS EXTRAORDINARIOS - INTER OFSS','REGISTRA OS IMPOSTOS INSTITUIDOS PELA UNIAO, TEMPORARIAMENTE, NA IMINENCIA OU NO CASO DE GUERRA EXTERNA, SUPRIMIDOS, GRADATIVAMENTE,NO PRAZO MAXIMO DE CINCO ANOS,CONTADOS DA CELEBRACAO DA PAZ.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.9.0.00.00','OUTROS IMPOSTOS',' COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.9.1.00.00','OUTROS IMPOSTOS - EXTRA OFSS',' COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTECENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS)COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.9.2.00.00','OUTROS IMPOSTOS - INTRA OFSS',' COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.1.9.3.00.00','OUTROS IMPOSTOS - INTER OFSS',' COMPREENDE OS DEMAIS IMPOSTOS NAO CLASSIFICADOS NOS GRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.0.0.00.00','TAXAS','COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES. TEM COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.0.00.00','TAXAS PELO EXERCICIO DO PODER DE POLICIA','COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE, LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO, EM RAZAO DE INTERESSE PUBLICO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.00.00','TAXAS PELO EXERCICIO DO PODER DE POLICIA - EXTRA OFSS',' COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE, LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO EM RAZAO DE INTERESSE PUBLICO.COMPREENDE OS VALORES DE OPERACOES ETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.01.00','TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA','REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPERACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.02.00','TAXA DE FISCALIZACAO DAS TELECOMUNICACOES','COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.02.01','TAXA DE FISCALIZACAO DE INSTALACAO','REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.02.02','TAXA DE FISCALIZACAO DE FUNCIONAMENTO','REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.03.00','TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS','REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.04.00','TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL','REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.05.00','TAXAS DE MIGRACAO','REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.06.00','TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL','REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.07.00','TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO','REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.08.00','TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS','REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.09.00','TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA','REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.10.00','TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA','REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.11.00','TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA','REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.12.00','TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO',' REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.00','TAXA DE SAUDE SUPLEMENTAR','COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RECURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.01','TAXA POR PLANO DE ASSISTENCIA A SAUDE','REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.02','TAXA POR REGISTRO DE PRODUTO','REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.03','TAXA POR ALTERACAO DE DADOS DE PRODUTO','REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.04','TAXA POR REGISTRO DE OPERADORA','REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.05','TAXA POR ALTERACAO DE DADOS DE OPERADORA','REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.13.06','TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR','REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.14.00','TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL','REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.15.00','TAXA DE SERVICOS ADMINISTRATIVOS - TSA','REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.16.00',' TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC','REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.00.00','TAXAS PELO EXERCICIO DO PODER DE POLICIA - INTRA OFSS',' COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE,LIMITANDO OU DISCIPLINANDO DIREITO,INTERESSE OU LIBERDADE, REGULA A PRATICA DE ATO OU ABSTEMCAO DE FATO, EM RAZAO DE INTERESSE PUBLICO.COMPREENDE OS VALORES DE OPERACAOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.01.00','TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA','REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPERACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.02.00','TAXA DE FISCALIZACAO DAS TELECOMUNICACOES','COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.02.01','TAXA DE FISCALIZACAO DE INSTALACAO','REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.02.02','TAXA DE FISCALIZACAO DE FUNCIONAMENTO','REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.03.00','TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS','REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.04.00','TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL','REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.05.00','TAXAS DE MIGRACAO','REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.06.00','TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL','REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.07.00','TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO','REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.08.00','TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS','REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.09.00','TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA','REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.10.00','TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA','REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.11.00','TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA','REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.12.00','TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO',' REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.00','TAXA DE SAUDE SUPLEMENTAR','COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RECURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.01','TAXA POR PLANO DE ASSISTENCIA A SAUDE','REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.02','TAXA POR REGISTRO DE PRODUTO','REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.03','TAXA POR ALTERACAO DE DADOS DE PRODUTO','REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.04','TAXA POR REGISTRO DE OPERADORA','REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.05','TAXA POR ALTERACAO DE DADOS DE OPERADORA','REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.13.06','TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR','REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.14.00','TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL','REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.15.00','TAXA DE SERVICOS ADMINISTRATIVOS - TSA','REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.16.00',' TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC','REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.00.00','TAXAS PELO EXERCICIO DO PODER DE POLICIA - INTER OFSS',' COMPREENDE AS TAXAS PELO PODER DE POLICIA AQUELAS DECORRENTES DAS ATIVIDADES DA ADMINISTRACAO PUBLICA QUE,LIMITANDO OU DISCIPLINANDO DIREITO, INTERESSE OU LIBERDADE,REGULA A PRATICA DE ATO OU ABSTENCAO DE FATO,EM RAZAO DE INTERESSE PUBLICO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.01.00','TAXA FISC SERV IRRIGACAO E OPERACAO ADUCAO AGUA','REGISTRA A VPA COM TAXA DECORRENTE DO EXERCICIO DO PODER DE POLICIA PELA AGENCIA NACIONAL DE AGUAS - ANA, COMPREENDIDO NA FISCALIZACAO DA PRESTACAO DOS SERVICOS PUBLICOS DE IRRIGACAO E OPERACAO DE ADUCAO DE AGUA BRUTA. DESTINACAO LEGAL: AGENCIA NACIONAL DE AGUAS - ANA, DESTINADOS AO CUSTEIO DAS DESPESAS DECORRENTES DAS ATIVIDADES DE FISCALIZACAO E REGULACAO REFERIDAS; AMPARO LEGAL: LEI 9984/2000 E MP 437/2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.02.00','TAXA DE FISCALIZACAO DAS TELECOMUNICACOES','COMPREENDE A VPA COM TAXA QUANDO DA FISCALIZACAO SERVICOS DE TELECOMUNICACOES PELO PODER PUBLICO, NO EXERCICIO REGULAR DO PODER DE POLICIA. TAXAS DEVIDAS PELAS CONCESSIONARIAS E PERMISSIONARIAS DE SERVICOS DE TELECOMUNICACOES, COMPREENDENDO: A TAXA DE FISCALIZACAO DE INSTALACAO, DEVIDA NO MOMENTO EM QUE E OUTORGADA AUTORIZACAO PARA A EXECUCAO DO SERVICO E A TAXA DE FISCALIZACAO DO FUNCIONAMENTO, DEVIDA PELA FISCALIZACAO DA EXECUCAO DOS SERVICOS. RECEITA VINCULADA AO FUNDO DE FISCALIZACAO DAS TELECOMUNICACOES - FISTEL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.02.01','TAXA DE FISCALIZACAO DE INSTALACAO','REGISTRA O VALOR TOTAL DA TAXA PAGA NO MOMENTO DA EMISSAO DO CERTIFICADO DE LICENCA PARA O FUNCIONAMENTO DAS ESTACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.02.02','TAXA DE FISCALIZACAO DE FUNCIONAMENTO','REGISTRA O VALOR DA TAXA PAGA ANUALMENTE, ATE O DIA 31 DE MARCO, PELA FISCALIZACAO DO FUNCIONAMENTO DAS ESTACOES. SEUS VALORES CORRESPONDEM A 45% DOS FIXADOS PARA A TAXA DE FISCALIZACAO DE INSTALACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.03.00','TAXA DE CONTROLE E FISCALIZ. DE PROD.QUIMICOS','REGISTRA O VALOR DA VPA ADVINDA DO PAGAMENTO DA TAXA DE CONTROLE E FISCALIZACAO SOBRE PRODUTOS QUIMICOS QUE DIRETA OU INDIRETAMENTE POSSAM SER DESTINADOS A ELABORACAO ILICITA DE SUBSTANCIAS ENTORPECENTES, PSICOTROPICAS OU QUE DETERMINEM DEPENDENCIA FISICA OU PSIQUICA. OS RECURSOS CONSTITUEM RECEITA DO FUNDO NACIONAL ANTIDROGAS ­ FUNAD, DOS QUAIS SERAO DESTINADOS 80% AO DEPARTAMENTO DE POLICIA FEDERAL, PARA O REAPARELHAMENTO E CUSTEIO DAS ATIVIDADES DE CONTROLE E FISCALIZACAO DE PRODUTOS QUIMICOS E DE REPRESSAO AO TRAFICO ILICITO DE DROGAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.04.00','TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL','REGISTRA A VPA COM TAXAS DO DEPARTAMENTO DE POLICIA FEDERAL, AUFERIDA PELA PRESTACAO DE SERVICOS RELATIVOS A FISCALIZACAO DE EMPRESAS DE SEGURANCAO PRIVADA, SEGURANCA PROPRIA, DE TRANSPORTE DE VALORES, DE ESTABELECIMENTOS FINANCEIROS E DE ESTABELECIMENTOS DE FORMACAO DE VIGILANTES. OS VALORES ARRECADADOS DESTINAM-SE AO CUSTEIO E MANUTENCAO DE ATIVIDADES-FIM DO DEPARTAMENTO DE POLICIA FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.05.00','TAXAS DE MIGRACAO','REGISTRA A VPA COM TAXAS DE MIGRACAO, PELO PODER NO SEU EXERCICIO REGULAR DO PODER DE POLICIA. CONSTITUEM-SE EM TAXAS COBRADAS PELA CONCESSAO DE VISTO DE SAIDA, PEDIDO DE AUTORIZACAO DE PERMANENCIA, PEDIDO DE PRORROGACAO DE PRAZO DE ESTADA, PEDIDO DE PASSAPORTE PARA O ESTRANGEIRO. RECEITA VINCULADA A SECRETARIA DE POLICIA FEDERAL DO MINISTERIO DA JUSTICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.06.00','TAXA LIC.,CONTR, FISC.MAT NUC.RADIOATIVO INSTAL','REGISTRA A VPA COM TAXA DE LICENCIAMENTO, CONTROLE E FISCALIZACAO, PESQUISA E DESENVOLVIMENTO, APOIO TECNICO OPERACIONAL E APOIO AO DESENVOLVIMENTO E APLICACAO DE MATERIAIS DIDATICOS E PEDAGOGICOS RELACIONADOS COM MATERIAIS NUCLEARES E RADIOATIVOS E SUAS INSTALACOES. AMPARO LEGAL: LEI NR. 9765, DE 17 DE DEZEMBRO DE 1998 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.07.00','TAXA DE FISCALIZACAO PROD.CONTR.MIN.EXERCITO','REGISTRA A VPA COM TAXA QUE TEM COMO FATO GERADOR A FISCALIZACAO DE PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO TAIS COMO: CONCESSAO PARA O COMERCIO, PARA ARMEIROS, CLUBES DE CACA E PESCA; CADASTRAMENTO DE EMPRESA DE VIGILANCIA; REVENDA DE ARMAS E MUNICOES. RECEITA VINCULADA AO MINISTERIO DO EXERCITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.08.00','TAXA FISCAL.MERC.TITULOS E VAL. MOBILIARIOS','REGISTRA A VPA COM TAXA, DE COMPETENCIA DA UNIAO DECORRENTE DA FISCALIZACAO EXERCIDA PELA COMISSAO DE VALORES MOBILIARIOS, AS COMPANHIAS ABERTAS, SOCIEDADES BENEFICIARIAS DE INCENTIVOS FISCAIS, CORRETORAS, BANCOS DE INVESTIMENTO, BOLSAS DE VALORES E DE FUTUROS, DISTRIBUIDORAS E BANCOS MULTIPLOS COM CARTEIRA DE INVESTIMENTO, FUNDOS MUTUOS DE ACOES, FUNDOS DE CONVERSAO, FUNDOS DE INVESTIMENTO E CARTEIRAS DE TITULOS E VALORES MOBILIARIOS - CAPITAL ESTRANGEIRO. OS RECURSOS SAO VINCULADOS A CVM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.09.00','TAXA FISCAL.MERC.SEG.CAP.PREVID.PRIV.ABERTA','REGISTRA A VPA COM TAXA PELA FISCALIZACAO DOS MERCADOS DE SEGURO, DE CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA PELO SERVICO PUBLICO, TENDO COMO FATO GERADOR O EXERCICIO DO PODER DE POLICIA LEGALMENTE ATRIBUIDO A SUPERINTENDENCIA DE SEGUROS PRIVADOS ­ SUSEP, SENDO RECOLHIDA PELOS ESTABELECIMENTOS DE SEGURO, DE CAPITALIZACAO E DE PREVIDENCIA PRIVADA ABERTA COM OU SEM FINS LUCRATIVOS. OS RECURSOS SAO VINCULADOS A SUSEP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.10.00','TAXA FISCAL. DOS SERVICOS DE ENERGIA ELETRICA','REGISTRA A VPA COM TAXA DECORRENTE DA PRESTACAO DO SERVICO PUBLICO DE FISCALIZACAO E REGULACAO DO SETOR DE ENERGIA ELETRICA NACIONAL PELA ANEEL - AGENCIA NACIONAL DE ENERGIA ELETRICA, RECOLHIDA EM DUODECIMOS DIRETAMENTE A AUTARQUIA, COM BASE NO BENEFICIO ECONOMICO ANUAL, AUFERIDO PELAS ENTIDADES DO SETOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.11.00','TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA','REGISTRA A VPA COM TAXA PELA FISCALIZACAO DE VIGILANCIA SANITARIA EXERCIDA PELA AGENCIA NACIONAL DE VIGILANCIA SANITARIA SOBRE AS PESSOAS FISICAS E JURIDICAS QUE EXERCAM ATIVIDADES DE FABRICACAO, DISTRIBUICAO E VENDA DE PRODUTOS E A PRESTACAO DE SERVICOS MENCIONADOS NO ARTIGO 8. DA LEI 9782/99. OS RECURSOS SAO VINCULADOS A AGENCIA NACIONAL DE VIGILANCIA SANITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.12.00','TAXA DE FISCALIZ.S/ DISTRIB. GRAT.PREM. SORTEIO',' REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO E DISTRIBUICAO GRATUITA DE PREMIOS E SORTEIOS. OS VALORES CONSTANTES DA TABELA DO ANEXO II DA MEDIDA PROVISORIA 2113/27, DE 26JAN2001, OS QUAIS DEVERAO SER RETIDOS PELA CAIXA ECONOMICA A TITULO DE REMUNERACAO. DARF''S A SEREM REPASSADOS A SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA, QUANDO FOREM EMITIDOS PARA REPASSE DA DIFERENCA ENTRE O VALOR PAGO A TITULO DE REMUNERACAO A CAIXA ECONOMICA FEDERAL E O VALOR DA TAXA COBRADA. AMPARO LEGAL MP 2113/27, DE 26JAN01, PORTARIA MF 15, DE 12JAN01 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.00','TAXA DE SAUDE SUPLEMENTAR','COMPREENDE A VPA PROVENIENTE DA TAXA DE SAUDE SUPLEMENTAR, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO, QUE OPEREM O PRODUTO, SERVICOS OU CONTRATO DE COM A FINALIDADE DE GARANTIR A ASSISTENCIA A SAUDE VISANDO A ASSISTENCIA MEDICA HOSPITALAR OU ODONTOLOGICA. OS RECURSOS SERAO VINCULADOS A AGENCIA NACIONAL DE SAUDE - ANS (LEI 9961 DE 28/01/2000). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.01','TAXA POR PLANO DE ASSISTENCIA A SAUDE','REGISTRA A VPA PROVENIENTE DA TAXA POR PLANO DE ASSISTENCIA A SAUDE, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.02','TAXA POR REGISTRO DE PRODUTO','REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.03','TAXA POR ALTERACAO DE DADOS DE PRODUTO','REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE PRODUTO, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.04','TAXA POR REGISTRO DE OPERADORA','REGISTRA A VPA PROVENIENTE DA TAXA POR REGISTRO DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS,CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.05','TAXA POR ALTERACAO DE DADOS DE OPERADORA','REGISTRA A VPA PROVENIENTE DA TAXA POR ALTERACAO DE DADOS DE OPERADORA, DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.13.06','TAXA POR PEDIDO DE REAJ.DE CONTRAPR.PENCUNIAR','REGISTRA A VPA PROVENIENTE DA TAXA POR PEDIDO DE REAJUSTE DE CONTRAPRESTACAO PECUNIARIA DEVIDA POR PESSOAS JURIDICAS, CONDOMINIOS OU CONSORCIOS CONSTITUIDOS SOB A MODALIDADE DE SOCIEDADE CIVIL OU COMERCIAL, COOPERATIVA OU ENTIDADE DE AUTOGESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.14.00','TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL','REGISTRA A VPA PROVENIENTE DA TAXA DE FISCALIZACAO AMBIENTAL, DEVIDA POR PESSOAS FISICAS OU JURIDICAS OBRIGADAS AO REGISTRO NO CADASTRO TECNICO FEDERAL DE ATIVIDADES POTENCIALMENTE POLUIDORAS OU UTILIZADORAS DE RECURSOS AMBIENTAIS O RECOLHIMENTO SERA EFETUADO EM CONTA BANCARIA VINCULADA AO IBAMA, POR INTERMEDIO DE DOCUMENTO PROPRIO DE ARRECADACAO DAQUELE INSTITUTO LEI 9960/2000 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.15.00','TAXA DE SERVICOS ADMINISTRATIVOS - TSA','REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS ADMINISTRATIVOS, TENDO COMO FATO GERADOR O EXERCICIO REGULAR DO PODER DE POLICIA, OU A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO OU POSTO A SUA DISPOSICAO PELA SUPERINTENDENCIA DA ZONA FRANCA DE MANAUS - SUFRAMA. OS RECURSOS ARRECADADOS SERAO DESTINADOS EXCLUSIVAMENTE AO CUSTEIO E AS ATIVIDADES FINS DA SUFRAMA (LEI 9960 DE 28 DE JANEIRO DE 2000). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.16.00',' TX.FISCALIZ. E CONTR. DA PREV.COMPL - TAFIC','REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE TAXA DE FISCALIZACAO E CONTROLE DA PREVIDENCIA COMPLEMENTAR - TAFIC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.1.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.0.00.00','TAXAS PELA PRESTACAO DE SERVICOS','COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES, TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.00.00','TAXAS PELA PRESTACAO DE SERVICOS - EXTRA OFSS',' COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.01.00','EMOLUMENTOS CONSULARES','REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO. SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOS E OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.02.00','TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO','REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.03.00','TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.','REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.04.00','TAXA DE AVALIACAO DO ENSINO SUPERIOR','REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.05.00','TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL','REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.06.00','EMOLUMENTOS E CUSTAS DA JUSTICA DO DF','REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.08.00','TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX','REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.','REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.10.00','TAXA MILITAR','REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.11.00','TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.12.00','TAXAS DE SERVICOS CADASTRAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.13.00','TAXA DE SERVICOS AQUICOLAS','REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.1.99.00','OUTRAS TAXAS PELA PRESTACAO DE SERVICOS','REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.00.00','TAXAS PELA PRESTACAO DE SERVICOS - INTRA OFSS','COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PIBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.01.00','EMOLUMENTOS CONSULARES','REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO, SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOSE OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.02.00','TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO','REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.03.00','TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.','REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.04.00','TAXA DE AVALIACAO DO ENSINO SUPERIOR','REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.05.00','TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL','REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.06.00','EMOLUMENTOS E CUSTAS DA JUSTICA DO DF','REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.08.00','TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX','REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.','REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.10.00','TAXA MILITAR','REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.11.00','TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.12.00','TAXAS DE SERVICOS CADASTRAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.13.00','TAXA DE SERVICOS AQUICOLAS','REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.2.99.00','OUTRAS TAXAS PELA PRESTACAO DE SERVICOS','REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.00.00','TAXAS PELA PRESTACAO DE SERVICOS - INTER OFSS',' COMPREENDE AS TAXAS COBRADAS PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES TEM COMO FATO GERADOR A UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.01.00','EMOLUMENTOS CONSULARES','REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS CONSULARES. DE COMPETENCIA DA UNIAO, SAO TAXAS COBRADAS PELOS CONSULADOS E VICE-CONSULADOS BRASILEIROS NO EXTERIOR, PELA EXPEDICAO OU LEGALIZACAO DE DOCUMENTOSE OUTRAS TAXAS RELATIVAS AS ATIVIDADES CONSULARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.02.00','TAXA PEDIDO VISTO EM CONTRATO TRAB. ESTRANGEIRO','REGISTRA A VPA PROVENIENTE DA TAXA DE PEDIDO DE VISTO EM CONTRATO DE TRABALHO DE ESTRANGEIRO, DESTINADA AO MINISTERIO DO TRABALHO E EMPREGO, DE ACORDO COM A LEI Nº 6815/80. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.03.00','TAXA SIST.CONTR. ARREC.ADIC.FRETE REN.MAR.MERC.','REGISTRA A VPA PROVENIENTE DA TAXA DE UTILIZACAO DO SISTEMA ELETRONICO DE CONTROLE DE ARRECADACAO DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.04.00','TAXA DE AVALIACAO DO ENSINO SUPERIOR','REGISTRA A VPA PROVENIENTE DA TAXA DE AVALIACAO DO ENSINO SUPERIOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.05.00','TAXA JUDICIARIA DA JUSTICA DO DISTR. FEDERAL','REGISTRA A VPA PROVENIENTE DE TAXA JUDICIARIA DA JUSTICA DO DISTRITO FEDERAL. TRIBUTO QUE TEM COMO FATO GERADOR A ADMINISTRACAO DA JUSTICA PELOS MAGISTRADOS ATRAVES DO PROCESSAMENTO, JULGAMENTO E EXECUCAO DOS FEITOS SUBMETIDOS A SEU EXAME, INCLUSIVE QUANDO SE TRATE DE PROCESSO DE JURISDICAO VOLUNTARIA. INCIDE SOBRE O VALOR DA CAUSA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.06.00','EMOLUMENTOS E CUSTAS DA JUSTICA DO DF','REGISTRA A VPA PROVENIENTE DE CUSTAS E EMOLUMENTOS DEVIDOS A JUSTICA DO DISTRITO FEDERAL, PELA EXPEDICAO, PREPARO E EXECUCAO DE TODOS OS FEITOS JUDICIAIS, DOS ATOS NOTARIAIS, JUDICIAIS E EXTRAJUDICIAIS, COBRADOS DE ACORDO COM O REGIMENTO ESTABELECIDO PELO DECRETO-LEI N° 115, DE 25/01/1967, E ALTERACOES POSTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','REGISTRA A VPA PROVENIENTE DA TAXA DE SERVICOS JUDICIAIS REFERENTES AOS ATOS PRATICADOS EM RAZAO DE OFICIO, TAIS COMO: A) SERVENTIAS JUDICIAIS: DESPESAS COM DILIGENCIAS FORA DO CARTORIO, PERICIAIS E AVALIACOES, PUBLICACOES DE EDITAIS NA IMPRENSA, EXPEDICOES DE CARTAS DE ORDEM E DE SENTENCAS, DENTRE OUTRAS; B) EXPEDICAO, MOVIMENTACAO E CERTIFICACAO DOS FEITOS, BEM COMO CUSTAS DEVIDAS POR ATOS DE DILIGENCIAS, EM PRIMEIRA INSTANCIA, COM BASE NO VALOR DAS CAUSAS EM GERAL, MANDADO DE SEGURANCA, PROCESSOS CRIMINAIS, RECURSOS E CARTAS TESTEMUNHAVEIS CRIMINAIS, DESPESA COM TRANSLADO E OUTRAS RELACIONADAS NAS TABELAS DE CUSTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.08.00','TAXA UTIL. SISTEMA INT.COM.EXTER.-SISCOMEX','REGISTRA A VPA PROVENIENTE DA TAXA COBRADA PELA UTILIZACAO DOS SERVICOS DO SISTEMA INTEGRADO DE COMERCIO EXTERIOR - SISCOMEX, PAGA AO REGISTRO DA DECLARACAO DE IMPORTACAO E POR ADICAO DE MERCADORIAS A DECLARACAO DE IMPORTACAO. O PRODUTO DA ARRECADACAO DA TAXA E VINCULADO AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRAT.','REGISTRA A VPA PROVENIENTE DA TAXA INCIDENTE SOBRE OS PROCESSOS DE COMPETENCIA DO CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE, COMO ATOS E CONTRATOS QUE POSSAM LIMITAR OU DE QUALQUER FORMA PREJUDICAR A LIVRE CONCORRENCIA, OU RESULTAR NA DOMINACAO DE MERCADOS RELEVANTES DE BENS OU SERVICOS; E DE CONSULTAS AO CADE. DESTINACAO LEGAL: CONSELHO ADMINISTRATIVO DE DEFESA ECONOMICA - CADE; SECRETARIA DE DIREITO ECONOMICO DO MINISTERIO DA JUSTICA E SECRETARIA DE ACOMPANHAMENTO ECONOMICO DO MINISTERIO DA FAZENDA. AMPARO LEGAL: LEI 8.884/1994; LEI 9.781/1999; DECRETO 2.978/1999 E LEI 10.149/2000. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.10.00','TAXA MILITAR','REGISTRA A VPA PROVENIENTE DE TAXA COBRADA A TODO CIDADAO QUE POR QUALQUER MOTIVO OBTIVER ISENCAO TEMPORARIA OU DEFINITIVA DE INCORPORACAO NO EXERCITO, MARINHA E AERONAUTICA. RECEITA VINCULADA AO EMFA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.11.00','TAXA DE CLASSIFICACAO DE PRODUTOS VEGETAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS PARA CLASSIFICACAO DE PRODUTOS VEGETAIS. DE COMPETENCIA DA UNIAO, TEM COMO FATO GERADOR A CLASSIFICACAO DE PRODUTOS VEGETAIS PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO, BEM COMO O REGULAR EXERCICIO DO PODER DE POLICIA. RECURSO VINCULADO AO FUNDO FEDERAL AGROPECUARIO, DO MINISTERIO SUPRACITADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.12.00','TAXAS DE SERVICOS CADASTRAIS','REGISTRA A VPA PROVENIENTE DAS TAXAS DE SERVICOS CADASTRAIS, TENDO COMO FATO GERADOR A APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA, DA TAXA DE SERVICOS CADASTRAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.13.00','TAXA DE SERVICOS AQUICOLAS','REGISTRA A VPA PROVENIENTE DAS TAXAS PELA PRESTACAO DE SERVICOS AQUICOLAS, ORIGINARIAS DOS REGISTROS ANUAIS DE INDUSTRIA DE PESCA, DE EMPRESAS QUE COMERCIALIZAM ANIMAIS AQUATICOS VIVOS, DE PESQUE E PAGUE E DE ARMADOR DE PESCA E AINDA DE EXPEDICAO DE CARTEIRA DE PESCADOR PROFISSIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.2.2.3.99.00','OUTRAS TAXAS PELA PRESTACAO DE SERVICOS','REGISTRA A VPA PROVENIENTE DE OUTRAS TAXAS PELA UTILIZACAO, EFETIVA OU POTENCIAL, DE SERVICO PUBLICO ESPECIFICO E DIVISIVEL, PRESTADO AO CONTRIBUINTE OU POSTO A SUA DISPOSICAO, QUE NAO ESTEJAM REFERENCIADAS NAS NATUREZAS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.0.0.00.00','CONTRIBUICOES DE MELHORIA','COMPREENDE O TRIBUTO COBRADO PELA UNIAO, PELOS ESTADOS, PELO DISTRITO FEDERAL OU PELOS MUNICIPIOS, NO AMBITO DE SUAS RESPECTIVAS ATRIBUICOES, SENDO INSTITUIDA PARA FAZER FACE AO CUSTO DE OBRAS PUBLICAS DE QUE DECORRA VALORIZACAO IMOBILIARIA, TENDO COMO LIMITE TOTAL A DESPESA REALIZADA E COMO LIMITE INDIVIDUAL O ACRESCIMO DE VALOR QUE DA OBRA RESULTAR PARA CADA IMOVEL BENEFICIADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.1.0.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO','COMPREENDE O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.1.1.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - EXTRA OFSS','REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE D VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTECENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.1.2.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - INTRA OFSS','REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.1.3.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE AGUA POTAVEL E ESGOTO SANITARIO - INTER OFSS','REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADE EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.2.0.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE','COMPREENDE O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.2.1.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - EXTRA OFSS',' REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.2.2.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - INTRA OFSS',' REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.2.3.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE - INTER OFSS',' REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA NA CIDADE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.3.0.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL','COMPREENDE O VALOR DA ARRECADACAO DE RECEITA SOBRE A COBRANCA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.3.1.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL -EXTRA OFSS','REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.3.2.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL -INTRA OFSS','REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.3.3.00.00','CONTRIBUICAO DE MELHORIA PELA EXPANSAO DE REDE DE ILUMINACAO PUBLICA RURAL -INTER OFSS','REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA EXPANSAO DA REDE DE ILUMINACAO PUBLICA RURAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.4.0.00.00','CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES','COMPREENDE O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.4.1.00.00','CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - EXTRA OFSS',' REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.4.2.00.00','CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - INTRA OFSS',' REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.4.3.00.00','CONTRIBUICAO DE MELHORIA PELA PAVIMENTACAO E OBRAS COMPLEMENTARES - INTER OFSS',' REGISTRA O VALOR DA ARRECADACAO DE RECEITA DE CONTRIBUICAO DE MELHORIA DECORRENTE DE VALORIZACAO DE PROPRIEDADES EM FUNCAO DA PAVIMENTACAO ASFALTICA, BEM COMO PELA COLOCACAO DE GUIAS, SARJETAS E CALCAMENTO.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.9.0.00.00','OUTRAS CONTRIBUICOES DE MELHORIA','COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.9.1.00.00','OUTRAS CONTRIBUICOES DE MELHORIA - EXTRA OFSS','REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.9.2.00.00','OUTRAS CONTRIBUICOES DE MELHORIA - INTRA OFSS','REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.1.3.9.3.00.00','OUTRAS CONTRIBUICOES DE MELHORIA - INTER OFSS','REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.0.0.0.00.00','CONTRIBUICOES','COMPREENDE TODA PRESTACAO PECUNIARIA COMPULSORIA, EM MOEDA OU CUJO VALOR NELA SE POSSA EXPRIMIR, QUE NAO CONSTITUA SANCAO DE ATO ILICITO, INSTITUIDA EM LEI E COBRADA MEDIANTE ATIVIDADE ADMINISTRATIVA PLENAMENTE VINCULADA. COMO : CONTRIBUICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.0.0.00.00','CONTRIBUICOES SOCIAIS','COMPREENDEM COMO CONTRIBUICOES SOCIAIS: A) AS DAS EMPRESAS, INCIDENTES SOBRE A REMUNERACAO PAGA OU CREDITADA AOS SEGURADOS A SEU SERVICO; B) AS DOS EMPREGADORES DOMESTICOS; C) AS DOS TRABALHADORES, INCIDENTES SOBRE O SEU SALARIO-DE-CONTRIBUICAO; D) AS SOBRE A RECEITA E FATURAMENTO; E) AS SOBRE O LUCRO; F ) DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR G) E OUTROS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.0.00.00','CONTRIBUICOES SOCIAIS - RPPS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.00.00','CONTRIBUICOES SOCIAIS - RPPS -EXTRA OFSS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.01.00','CONTRIBUICOES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.00','CONTRIBUICAO DO SEGURADO AO RPPS','COMPREENDE A CONTRIBUICAO AO RPPS DOS SEGURADOS SERVIDOR ATIVO, SERVIDOR INATIVO E PENSIONISTA SOBRE A SUA REMUNERACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.01','CONTRIBUICAO DO SERVIDOR ATIVO CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR ATIVO CIVIL SOBRE SUA REMUNERACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.02','CONTRIBUICAO DO SERVIDOR INATIVO CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR INATIVO CIVIL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.03','CONTRIBUICAO DE PENSIONISTA CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO PENSIONISTA CIVIL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.04','CONTR.SERV.ATIVO CIVIL-PAGTO SENT. JUDICIAIS','REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR CIVIL ATIVO, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.05','CONTR.SERV.INAT.CIVIL - PAGTO SENT. JUDICIAIS','REGISTRA AVPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR INATIVO CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.02.06','CONTR.PENSIONISTA CIVIL-PAGTO SENT. JUDICIAIS','REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DE PENSIONISTA CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.03.00','CONTR. PREVID. P/AMORTIZ. DO DEFICIT ATUARIAL','REGISTRA A VPA ORIUNDA DE CONTRIBUICOES PREVIDENCIARIAS PARA AMORTIZACAO DO DEFICIT ATUARIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.04.00','CONTRIBUICOES PARA CUSTEIO DAS PENSOES MILITARES','REGISTRA A VPA PROVENIENTES DE CONTRIBUICAO PARA CUSTEIO DAS PENSOES MILITARES, EFETIVADAS POR TODOS OS MILITARES, COM VALOR CORRESPONDENTE A SEU POSTO OU GRADUACAO, OBSERVANDO AS EXCECOES PREVISTAS NA LEI ESPECIFICA. DE COMPETENCIA DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.1.99.00','OUTRAS CONTRIBUICOES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO EN-QUADRADAS NOS SUBITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.00.00','CONTRIBUICOES SOCIAIS - RPPS - INTRA OFSS','  COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DEST. AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.01.00','CONTRIBUICOES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.2.99.00','OUTRAS CONTRIBUICOES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO EN-QUADRADAS NOS SUBITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.00.00','CONTRIBUICOES SOCIAIS - RPPS - INTER OFSS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DEST. AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.01.00','CONTRIBUICOES PATRONAIS AO RPPS','COMPREENDE A CONTRIBUICAO PATRONAL DESTINADA AO CUSTEIO DO REGIME PROPRIO DE PREVIDENCIA SOCIAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA UNIAO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA UNIAO, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.1.3.99.00','OUTRAS CONTRIBUICOES SOCIAIS - RPPS','REGISTRA O VALOR DAS VPA ORIUNDAS DE CONTRIBUICOES PREVIDENCIARIAS NAO EN-QUADRADAS NOS SUBITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.0.00.00','CONTRIBUICOES SOCIAIS - RGPS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DESTINADA AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.00.00','CONTRIBUICOES SOCIAIS - RGPS -EXTRA OFSS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DEST. AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.00','CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS','COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.01','CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS','REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.02','CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO',' REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.03','CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS',' REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.04','SIMPLES','REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.05','EMPRESAS - ESPETACULOS ESPORTIVOS','REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.06','CONTRIBUICAO SOBRE PRODUCAO RURAL','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.07','SEGURO DE ACIDENTE DO TRABALHO','REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.08','CONTRIB.PREV.-RET. S/ NOTA FISCAL- SUBROGACAO','REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.09','CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA','REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.01.10','CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR','REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.02.00','CONTRIBUICOES DO SEGURADO AO RGPS','COMPREENDE AS CONTRIBUICOES DOS SEGURADOS AO RGPS INCIDENTES SOBRE O SALARIO DE CONTRIBUICAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.02.01','CONTRIB. PREV. SEGURADO - CONTRIBUINTE INDIVIDUAL','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO CONTRIBUINTE INDIVIDUAL AO RGPS. DE ACORDO COM A LEI Nº 8212/91.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.02.02','CONTRIB. PREV. SEGURADO - EMPREGADO E TRABALHADOR AVULSO','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO EMPREGADO, EXCETO DOMESTICO, E DO TRABALHADOR AVULSO AO RGPS.DE ACORDO COM A LEI Nº 8212/91.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.02.03','CONTRIB. PREV. SEGURADO - SEG. ESPECIAL','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO ESPECIAL AO RGPS.DE ACORDO COM A LEI Nº 8212/91.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.02.04','CONTRIB. PREV. SEGURADO - EMPREGADO DOMESTICO','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO EMPREGADO DOMESTICO AO RGPS. CONSIDERA-SE EMPREGADO DOMESTICO AQUELE QUE PRESTA SERVICO DE NATUREZA CONTINUA A PESSOA OU FAMILIA, NO AMBITO RESIDENCIAL DESTA, EM ATIVIDADES SEM FINS LUCRATIVOS.DE ACORDO COM A LEI Nº 8212/91.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.02.05','CONTRIB. PREV. SEGURADO FACULTATIVO','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO FACULTATIVO AO RGPS.DE ACORDO COM A LEI Nº 8212/91.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.03.00','RECLAMATORIA TRABALHISTA','REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.04.00','ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.','REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.05.00','ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.','REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.06.00','CERTIFICADOS DA DIVIDA PUBLICA - CDP','REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.07.00','CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS','REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.1.99.00','OUTRAS CONTRIBUICOES SOCIAIS AO RGPS','REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.00.00','CONTRIBUICOES SOCIAIS - RGPS - INTRA OFSS','  COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DEST. AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.00','CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS','COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.01','CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS','REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.02','CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO',' REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.03','CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS',' REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.04','SIMPLES','REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.05','EMPRESAS - ESPETACULOS ESPORTIVOS','REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.06','CONTRIBUICAO SOBRE PRODUCAO RURAL','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.07','SEGURO DE ACIDENTE DO TRABALHO','REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.08','CONTRIB.PREV.-RET. S/ NOTA FISCAL- SUBROGACAO','REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.09','CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA','REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.01.10','CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR','REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.03.00','RECLAMATORIA TRABALHISTA','REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.04.00','ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.','REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEI-ROS DO TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.05.00','ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.','REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.06.00','CERTIFICADOS DA DIVIDA PUBLICA - CDP','REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.07.00','CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS','REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.2.99.00','OUTRAS CONTRIBUICOES SOCIAIS AO RGPS','REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.00.00','CONTRIBUICOES SOCIAIS - RGPS - INTER OFSS','COMPREENDE A CONTRIBUICAO PATRONAL E A CONTRIBUICAO DO SEGURADO DEST. AO CUSTEIO DO REGIME GERAL DE PREVIDENCIA SOCIAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.00','CONTRIBUICOES PATRONAIS E DA EMPRESA AO RGPS','COMPREENDE A VPA DECORRENTE DAS CONTRIBUICOES PATRONAIS, DAS EMPRESAS E EQUIPADAS PARA O REGIME GERAL DA PREVIDENCIA SOCIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.01','CONTRIB. DE EMPRESAS S/SEGURADOS ASSALARIADOS','REGISTRA A CONTRIBUICAO A CARGO DA EMPRESA, PARA A SEGURIDADE SOCIAL, SOBRE O TOTAL DAS REMUNERACOES PAGAS OU CREDITADAS NO DECORRER DO MES AOS SEGURADOS EMPREGADOS, EMPRESARIOS, TRABALHADORES AVULSOS, AUTONOMOS E EQUIPARADOS QUE LHE PRESTEM SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.02','CONTRIB. PREV. DOS ORGAOS DO PODER PUBLICO',' REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.03','CONTRIB. PREV. DAS ENTIDADES FILANTROPICAS',' REGISTRA AS VPA DE CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.04','SIMPLES','REGISTRA AS RECEITAS DECORRENTES DE CONTRIBUICOES DAS MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE, ARRECADADAS DE ACORDO COM A LEI 9317, DE 05/12/96. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.05','EMPRESAS - ESPETACULOS ESPORTIVOS','REGISTRA AS CONTRIBUICOES ARRECADADAS SOBRE A RECEITA BRUTA DO ESPETACULO DE FUTEBOL PROFISSIONAL, DEVIDA PELOS CLUBES DE FUTEBOL E RECOLHIDA PELA ENTIDADE PROMOTORA DO EVENTO (FEDERACAO/CONFEDERACAO).(CAMPO 16 DA GRPS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.06','CONTRIBUICAO SOBRE PRODUCAO RURAL','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DO EMPREGADOR RURAL PARA SEGURIDADE SOCIAL PROVENIENTE DA RECEITA BRUTA DA COMERCIALIZACAO DOS PRODUTOS_RURAIS ART.25 DA LEI 8.212 ALTERADA PELA LEI 8.540 DE 22/12/92. ( CAMPO16 DA GRPS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.07','SEGURO DE ACIDENTE DO TRABALHO','REGISTRA A CONTRIBUICAO PARA SEGURO DE ACIDENTE DE TRABALHO URBANO QUE REPRESENTA CONTRIBUICAO DA EMPRESA, DESTINADA AO FINANCIAMENTO DA COMPLEMENTACAO DAS PRESTACOES POR ACIDENTE DE TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.08','CONTRIB.PREV.-RET. S/ NOTA FISCAL- SUBROGACAO','REGISTRA AS VPA ORIUNDAS DE CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.09','CONTRIBUICAO RELATIVA A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA','REGISTRA A CONTRIBUICAO DEVIDA PELOS EMPREGADORES EM CASO DE DESPEDIDA SEM JUSTA CAUSA, RECOLHIDA NA REDE BANCARIA E REPASSADA A CAIXA ECONOMICA, SENDO INCORPORADA AO FGTS. ESTA CONTRIBUICAO TEM COMO FATO GERADOR A DESPEDIDA DE EMPREGADO SEM JUSTA CAUSA, INCINDINDO ALIQUOTA DE 10% ( DEZ POR CENTO) SOBRE O MONTANTE DE TODOS OS DEPOSITOS DEVIDOS, REFERENTES AO FGTS, DURANTE A VIGENCIA DO CONTRATO DE TRABALHO. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.01.10','CONTRIBUICAO SOBRE A REMUNERACAO DEVIDA AO TRABALHADOR','REGISTRA ADICIONAL A CONTRIBUICAO SOCIAL DE 8%, DEVIDA PELO EMPREGADOR, DETERMINADA PELA APLICACAO DE ALIQUOTA 0,5% SOBRE REMUNERACAO PAGA OU DEVIDA A CADA TRABALHADOR, REFERENTE AO MES ANTERIOR, PERFAZENDO UMA ALIQUOTA DE 8,5% . A CONTRIBUICAO SERA RECOLHIDA NA REDE BANCARIA E REPASSADA E A CAIXA ECONOMICA FEDERAL. DESTINACAO LEGAL: PARA FAZER FACE AS DESPESAS COM A REPOSICAO DA CORRECAO MONETARIA DOS SALDOS NAS CONTAS DO FGTS. AMPARO LEGAL: LEI COMPLEMENTAR NO 110, DE 20 DE JUNHO DE 2001; LEI NO 8.036, DE 11 DE MAIO DE 1990; LEI NO 8.844, DE 20 DE JANEIRO DE 1994; E DECRETO NO 3.914, DE 11 DE SETEMBRO DE 2001.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.03.00','RECLAMATORIA TRABALHISTA','REGISTRA O TOTAL DAS VPA DECORRENTES DE RECLAMATORIAS TRABALHISTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.04.00','ARRECADACAO FIES-CERTIFICADOS FINANC.TES.NAC.','REGISTRA AS VPA DE ARRECADACAO P/ O FIES - CERTIFICADOS FINANCEI-ROS DO TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.05.00','ARRECADACAO FNS-CERTIFICADOS FINANC.TES.NAC.','REGISTRA AS VPA DE ARRECADACAO P/ O FNS - CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.06.00','CERTIFICADOS DA DIVIDA PUBLICA - CDP','REGISTRA AS VPA DE CERTIFICADOS DA DIVIDA PUBLICA - CDP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.07.00','CONTR.PREV.NA FORMA DE DEP.JUD.,REC. E CUSTAS','REGISTRA AS VPA DE CONTRIBUICOES PREVIDENCIARIAS NA FORMA DE DEPOSITOS JUDICIAIS, RECURSAIS E CUSTAS JUDICIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.2.3.99.00','OUTRAS CONTRIBUICOES SOCIAIS AO RGPS','REGISTRA O VALOR DAS VPA DE CONTRIBUICOES PREVIDENCIARIAS NAO ENQUADRADAS NOS SUBITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.0.00.00','CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO ','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.1.00.00','CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - EXTRA OFSS ','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.1.01.00',' CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RECEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMONIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.1.02.00',' CONTRIBUICOES P/ O PIS/PASEP','REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.2.00.00','CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - INTRA OFSS ','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.2.01.00',' CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RECEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMONIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.2.02.00',' CONTRIBUICOES P/ O PIS/PASEP','REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.3.00.00','CONTRIBUICAO SOBRE A RECEITA OU O FATURAMENTO - INTER OFSS ','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE A RECEITA OU O FATURAMENTO, COMO POR EXEMPLO: COFINS, PIS/PASEP. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.3.01.01','PRINCIPAL DA CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS','REGISTRA O PRINCIPAL DA VPA DECORRENTE DE CONTRIBUICOES PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. TEM POR FATO GERADOR A VENDA DE MERCADORIAS E/OU SERVICOS DE QUALQUER NATUREZA E A PERCEPCAO DE RENDAS OU RE-CEITAS OPERACIONAIS E NAO OPERACIONAIS, E RENDAS OU RECEITAS PATRIMO-NIAIS (LEI COMPLEMENTAR NUM. 70, DE 07/09/70). INTEGRA O ORCAMENTO DASEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.3.02.01',' PRINCIPAL DAS CONTRIBUICOES P/ O PIS/PASEP','REGISTRA A VPA DECORRENTE DE CONTRIBUICOES PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOS PUBLICO - PIS/PASEP. INCIDE SOBRE A RECEITA OPERACIONAL BRUTA DE EMPRESASPUBLICAS E PRIVADAS, SOBRE A FOLHA DE PAGAMENTO DAS ENTIDADES SEM FINSLUCRATIVOS, E SOBRE A RECEITA CORRENTE LIQUIDA DE TRANSFERENCIAS DA U-NIAO, ESTADOS, MUNICIPIOS, DF E AUTARQUIAS. DESTINA-SE AO FUNDO DE AM-PARO AO TRABALHADOR - FAT, PARA O CUSTEIO DO PROGRAMA DE SEGURO DESEMPREGO E CONCESSAO DE ABONOS SALARIAIS. PELO MENOS 40% (QUARENTA PORCENTO) SERAO REPASSADOS AO BNDES PARA APLICACAO EM PROGRAMAS DE DESEN-VOLVIMENTO ECONOMICO. INTEGRA O ORCAMENTO DA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.3.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.0.00.00','CONTRIBUICAO SOBRE O LUCRO','COMPREENDE A CONTRIBUICAO DO EMPREGADOR, DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: CSLL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.1.00.00','CONTRIBUICAO SOBRE O LUCRO - EXTRA OFSS','REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.1.01.00','CONTRIBUICAO SOBRE O LUCRO ','REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.2.00.00','CONTRIBUICAO SOBRE O LUCRO - INTRA OFSS',' REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.2.01.00','CONTRIBUICAO SOBRE O LUCRO ',' REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.3.00.00','CONTRIBUICAO SOBRE O LUCRO - INTER OFSS',' REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.3.01.00','CONTRIBUICAO SOBRE O LUCRO ',' REGISTRA A CONTRIBUICAO DO EMPREGADOR,DA EMPRESA E DA ENTIDADE A ELA EQUIPARADA NA FORMA DA LEI, INCIDENTES SOBRE O LUCRO, COMO POR EXEMPLO: O CSLL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.4.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.0.00.00','CONTRIBUICAO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','COMPREENDE A CONTRIBUICAO SOBRE A RECEITA DE CONCURSOS DE PROGNOSTICOS, QUE SAO TODOS E QUAISQUER CONCURSOS DE SORTEIOS DE NUMEROS, LOTERIAS, APOSTAS, INCLUSIVE AS REALIZADAS EM REUNIOES HIPICAS, NOS AMBITOS FEDERAL, ESTADUAL, DO DISTRITO FEDERAL E MUNICIPAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.00.00','CONTRIBUICAO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - EXTRA OFSS','COMPREENDE A CONTRIBUICAO SOBRE A RECEITA DE CONCURSOS DE PROGNOSTICOS,QUE SAO TODOS E QUAISQUER CONCURSOS DE SORTEIOS DE NUMEROS,LOTERIAIS, APOSTAS, INCLUSIVE AS REALIZADAS EM REUNIOES HIPICAS, NOS AMBITOS FEDERAL, ESTADUAL, DO DISTRITO FEDERAL E MUNICIPAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.01.00','CONTRIBUICAO S/RECEITA DA LOTERIAL FEDERAL','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIA FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.02.00','CONTRIBUICAO S/RECEITA LOTERIA ESPORTIVA','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIA ESPORTIVA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.03.00','CONTRIBUICAO S/RECEITA LOTERIAS DE NUMEROS','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIAS DE NUMEROS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.04.00','CONTRIBUICAO S/RECEITA LOTERIA INSTANTANEA','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE CONCURSOS DE PROGNOSTICOS - LOTERIA INSTANTANEA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.05.00','PREMIOS PRESCRITOS DE LOTERIAS FEDERAIS','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO S/ RECEITA DE PREMIOS PRESCRITOS DE LOTERIAS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.06.00','CONTR.S/REC.CONC.PROG.DEST.PRAT.DESP-MOD.FUTE','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO SOBRE A RECEITA DE OUTROS CONCURSOS DE PROGNOSTICOS PARA O DESENVOLVIMENTO DA PRATICA ESPORTIVA - MODALIDADE FUTEBOL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.07.00','CONTRIBUICAO S/ RECEITAS SORTEIOS REALIZADOS P/ ENT. FILANTROPICAS','REGISTRA O A VPA DE CONTRIBUICAO SOBRE A RECEITA DE SORTEIOS REALIZADOS POR ENTIDADES FILANTROPICAS. CORRESPONDE A 8% (OITO POR CENTO) DA RECEITA BRUTA AUFERIDA NOS SORTE-IOS REALIZADOS POR ENTIDADES FILANTROPICAS A SEREM RATEADOS DA SEGUIN-TE FORMA: - 3% (TRES POR CENTO) DA RECEITA BRUTA AUFERIDA NO SORTEIO SERA DESTI-NADA AO FUNPEN; - 3% (TRES POR CENTO) DA RECEITA BRUTA AUFERIDA NO SORTEIO SERA DESTI-NADA PARA O FUNDO NACIONAL DE CULTURA - FNC; - 1% (UM POR CENTO) DA RECEITA BRUTA AUFERIDA NO SORTEIO PARA O FUNDO DA CRIANCA E DO ADOLESCENTE; - 1% (UM POR CENTO) DA RECEITA BRUTA PARA O FUNDO DE DEFESA DOS DIREI-TOS DIFUSOS - FDD. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.08.00','CONTRIBUICOES SOBRE JOGOS DE BINGOS','REGISTRA A VPA DECORRENTE DE CONTRIBUICAO SOBRE A RECEITA DE OUTROS JOGOS E BINGOS EM CASA DE JOGOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.5.1.99.00','CONTRIBUICAO S/RECEITA OUTROS CONC. PROGNOST.','REGISTRA A VPA DECORRENTE DA CONTRIBUICAO SOBRE A RECEITA DE OUTROS CONCURSOS DE PROGNOSTICOS. (NATUREZA 1210.18.07 INCLUIDA PELA PORTARIA SOF Nº 28, DE 13 DE SETEM-BRO DE 2006.) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.0.00.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR','COMPREENDE A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.1.00.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - EXTRA OFSS','REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.1.01.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - ','REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.2.00.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - INTRA OFSS','REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.2.01.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR - ','REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.3.00.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR -INTER OFSS',' REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.3.01.00','CONTRIBUICAO DO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR -',' REGISTRA A CONTRIBUICAO SOCIAL PAGA PELO IMPORTADOR DE BENS OU SERVICOS DO EXTERIOR, OU DE QUEM A LEI A ELE EQUIPARAR.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.6.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.0.00.00','OUTRAS CONTRIBUICOES SOCIAIS','COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.00.00','OUTRAS CONTRIBUICOES SOCIAIS - EXTRA OFSS','COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS,NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.01.00','CONTRIBUICAO DO SALARIO-EDUCACAO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.02.00','COTA-PARTE DA CONTRIBUICAO SINDICAL','REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.03.00','CONTRIBUICAO PARA O ENSINO AEROVIARIO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.04.00','CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.05.00','CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.06.00','CONTRIBUICOES RURAIS','COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.06.01','CONTRIBUICAO INDUSTRIAL RURAL','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.06.02','ADICIONAL A CONTRIBUICAO PREVIDENCIARIA','REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.07.00','CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF',' REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.08.00','CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF','REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.00.00','OUTRAS CONTRIBUICOES SOCIAIS - INTRA OFSS','COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS,NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.01.00','CONTRIBUICAO DO SALARIO-EDUCACAO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.02.00','COTA-PARTE DA CONTRIBUICAO SINDICAL','REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.03.00','CONTRIBUICAO PARA O ENSINO AEROVIARIO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.04.00','CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.05.00','CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.06.00','CONTRIBUICOES RURAIS','COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.06.01','CONTRIBUICAO INDUSTRIAL RURAL','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.06.02','ADICIONAL A CONTRIBUICAO PREVIDENCIARIA','REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.07.00','CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF',' REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.08.00','CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF','REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.00.00','OUTRAS CONTRIBUICOES SOCIAIS - INTER OFSS','COMPREENDE O VALOR DE OUTRAS CONTRIBUICOES SOCIAIS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.01.00','CONTRIBUICAO DO SALARIO-EDUCACAO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO DESTINADA AO SALARIO-EDUCACAO. CONSTITUI-SE NA OBRIGACAO POR PARTE DAS EMPRESAS COMERCIAIS, INDUSTRIAIS E AGRICOLAS DE MANTER O ENSINO PRIMARIO GRATUITODE SEUS EMPREGADOS E O ENSINO DOS FILHOS DESTES, ENTRE OS 7 (SETE) E14 (QUATORZE) AOS, OU A CONCORRER PARA AQUELE FIM MEDIANTE A CONTRIBU-ICAO DO SALARIO-EDUCACAO (LEI NUM. 4.440, DE 27/10/64). CALCULADA SO-BRE O VALOR DA FOLHA DO SALARIO DE CONTRIBUICAO, NO CASO DAS EMPRESASVINCULADAS A PREVIDENCIA SOCIAL URBANA, E SOBRE O VALOR COMERCIAL DOSPRODUTOS AGRICOLAS, NO CASO DAS EMPRESAS VINCULADAS A PREVIDENCIA SOCIAL RURAL. A ARRECADACAO E DESTINADA 2/3 EM FAVOR DA UNIDADE DA FEDE-RACAO ONDE HOUVER SIDO EFETUADA A ARRECADACAO, DESTINANDO-SE OS RECUR-SOS AS RESPECTIVAS SECRETARIAS DE EDUCACAO; 1/3 EM FAVOR DA UNIAO COMORECEITA VINCULADA AO FUNDO NACIONAL DE DESENVOLVIMENTO DA EDUCACAO -FNDE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.02.00','COTA-PARTE DA CONTRIBUICAO SINDICAL','REGISTRA A VPA PROVENIENTE DA COTA-PARTE DA CONTRIBUICAOSINDICAL. CORRESPONDE A 20% DA ARRECADACAO DA CONTRIBUICAO SINDICAL(NO CASO DA CONTRIBUICAO RURAL, O PERCENTUAL E DE 10%). CONSTITUI-SEEM UMA CONTRIBUICAO PARAFISCAL EQUIVALENTE A UM DIA DE REMUNERACAO DETODO O TRABALHADOR DO MERCADO FORMAL DE TRABALHO. INTEGRA O ORCAMENTODA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.03.00','CONTRIBUICAO PARA O ENSINO AEROVIARIO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO P/ENSINO AEROVIARIO. CONTRIBUICAO PELOS SERVICOS DE AVIACAO CIVIL, DEVIDA PELAS EMPRE-SAS DE: TRANSPORTE E SERVICOS AEREOS; TELECOMUNICACOES AERONAUTICAS;ATIVIDADES RELACIONADAS A INFRA-ESTRUTURA AEROPORTUARIA; FABRICACAO,REPARO E MANUTENCAO, OU REPRESENTACAO, DE AERONAVES E EQUIPAMENTOS A-ERONAUTICOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOSSUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCU-LADA AO FUNDO AEROVIARIO, PARA APLICACAO NO DESENVOLVIMENTO DO ENSINOPROFISSIONAL AERONAUTICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.04.00','CONTRIBUICAO PARA DESENV.ENS.PROFIS.MARITIMO','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO PARA CUSTEAR O DESENVOLVIMENTO DO ENSINO DO PROSSIONAL MARITIMO. CONTRIBUICAO PELA PRESTACAO DE SERVICOS DE NAVEGACAO, DEVIDA PELAS EMPRESAS DE NAVEGACAO MARITIMA, FLUVIAL OU LACUSTRE, DE SERVICOS PORTUARIOS, DE DRAGAGEM E DE ADMINISTRACAO E DE EXPLORACAO DE PORTOS. CALCULADA SOBRE O SALARIO DE CONTRIBUICAO DOS EMPREGADOS, SUBSTITUI A CONTRIBUICAO DEVIDA AO SENAI, SENAC, SESI E SESC. E VINCULADA AO FUNDO DE DESENVOLVIMENTO DOENSINO PROFISSIONAL MARITIMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.05.00','CONTRIBUICAO S/ARREC.FUNDOS INVEST.REGIONAIS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AOS FUNDOS DE INVESTIMENTOS REGIONAIS. CONTRIBUICAO ORIUNDA DA DEDUCAO DE 1% (UM PORCENTO) DA ARRECADACAO DOS FUNDOS DE INVESTIMENTOS REGIONAIS ( FINAM,FINOR E FUNRES), OBEDECIDA NA APLICACAO A RESPECTIVA ORIGEM GEOGRAFICAREGIONAL. DESTINA-SE AO FUNDO NACIONAL DA CULTURA - FNC, GERIDO PELOMINISTERIO DA CULTURA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.06.00','CONTRIBUICOES RURAIS','COMPREENDE A VPA PROVENIENTE DE CONTRIBUICOES RURAIS, TAIS COMO A INDUSTRIAL, CONTRIBUICAO SOBRE A PROPRIEDADE RURAL, O ADICIONA DA CONTRIBUICAO PREVIDENCIARIA E OUTRAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.06.01','CONTRIBUICAO INDUSTRIAL RURAL','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO INDUSTRIAL RURAL. CONTRIBUICAO DE 2,5% (DOIS E MEIO POR CENTO) INCIDENTE SOBRE AFOLHA DE SALARIOS DE CONTRIBUICAO DE PESSOAS NATURAIS E JURIDICAS, IN-CLUSIVE COOPERATIVAS, QUE EXERCAM AS SEGUINTES ATIVIDADES AGRO-INDUS-TRIAIS: INDUSTRIA DE CANA-DE-ACUCAR, DE LATICINIOS, DE BENEFICIAMENTODE CHA E DE MATE, INDUSTRIA DA UVA, DE EXTRACA E BENEFICIAMENTO DE FI-BRAS VEGETAIS E DE DESCAROCAMENTO DE ALGODAO, DE BENEFICIAMENTO DE CA-FE, DE EXTRACAO DE MADEIRA PARA SERRARIA, DE RESINA, LENHA E CARVAOVEGETAL, E MATADOUROS OU ABATEDOUROS DE ANIMAIS DE QUAISQUER ESPECIESE CHARQUEADAS. DO PRODUTO DA ARRECADACAO DESSA RECEITA, 85% (OITENTA ECINCO POR CENTO) SAO DESTINADOS AO INCRA E 15% (QUINZE POR CENTO) AOMINISTERIO DA AGRICULTURA E ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.06.02','ADICIONAL A CONTRIBUICAO PREVIDENCIARIA','REGISTRA A VPA PROVENIENTE DO ADICIONAL A CONTRIBUICAO PREVIDENCIARIA. ADICIONAL DE 0,4% ( ZERO VIRGULA QUATRO POR CENTO) SOBREA FOLHA MENSAL TOTAL DE SALARIOS DE CONTRIBUICAO PREVIDENCIARIA DOSEMPREGADOS DAS EMPRESAS EM GERAL. E ARRECADADA PELO INSTITUTO NACIONALDE SEGURIDADE SOCIAL - INSS. DO PRODUTO DA ARRECADACAO, 50% SAO DESTI-NADOS AO INSTITUTO NACIONAL DE COLONIZACAO E REFORMA AGRARIA - INCRA EO RESTANTE AO INSS. DA PARCELA DO INCRA, 15% (QUINZE POR CENTO) SAOREPASSADOS AO MINISTERIO DA AGRICULTURA E ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.07.00','CONTRIBUICOES P/O FUNDO DE SAUDE - PMDF',' REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS POLICIAIS MILITARES DO DISTRITO FEDERAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.08.00','CONTRIBUICOES P/O FUNDO DE SAUDE - BMDF','REGISTRA AS VPA DE CONTRIBUICAO PARA O FUNDO DE SAUDE DOS BOMBEIROS MILITARES DO DISTRITO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.1.9.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.0.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - EXTRA OFSS','COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.01.00','CONTRIBUICAO PARA O PIN','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLI-CACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAOA APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.02.00','CONTRIBUICAO PARA O PROTERRA','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGRO-INDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCEN-TIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUN-DOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VIN-TE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.03.00','CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.','COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.03.01','SELO ESPECIAL DE CONTROLE','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.03.02','LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.04.00','CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO ABASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.05.00','CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOL-VIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PE-LOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUERTITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS EN-TIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVI-SUAL NACIONAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.05.01','CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS','REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDI-TO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.05.02','CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS','REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DES- TINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFO- NOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.06.00','ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.07.00','COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE','REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MERCANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRUIDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.08.00','CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFICA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJETOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELETRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.09.00','CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAO ALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.10.00','CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.',' REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE  DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS.  OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES.  LEI 9998, DE 17/08/2000.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.10.01','CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM','REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.10.02','CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM','REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.11.00','CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96 ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.11.01','CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.11.02','CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES','REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.12.00','CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.12.01','CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB','REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.12.02','CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB','REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.13.00','CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB','REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTEA UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.14.00','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA','COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.14.01','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.14.02','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.14.03','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.14.04','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.15.00','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES','COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.15.01','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991.INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.15.02','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991.§ 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.15.03','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.15.04','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.97.06','(-) CIDE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: (...) III - DO PRODUTO DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO PREVISTA NO ART. 177, § 4º, 29% (VINTE E NOVE POR CENTO) PARA OS ESTADOS E O DISTRITO FEDERAL, DISTRIBUIDOS NA FORMA DA LEI, OBSERVADA A DESTINACAO A QUE SE REFERE O INCISO II, C, DO REFERIDO PARAGRAFO"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.1.99.00','OUTRAS CONTRIBUICOES ECONOMICAS','COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTRA OFSS','COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL .  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.01.00','CONTRIBUICAO PARA O PIN','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLI-CACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAOA APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.02.00','CONTRIBUICAO PARA O PROTERRA','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGRO-INDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCEN-TIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUN-DOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VIN-TE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.03.00','CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.','COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.03.01','SELO ESPECIAL DE CONTROLE','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.03.02','LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.04.00','CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO A-BASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.05.00','CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOL-VIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PE-LOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUERTITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS EN-TIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVI-SUAL NACIONAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.05.01','CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS','REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDI-TO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.05.02','CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS','REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DES- TINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFO- NOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.06.00','ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.07.00','COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE','REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MER-CANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRU-IDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.08.00','CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFI±CA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJE±TOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELE±TRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.09.00','CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAOALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.10.00','CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.',' REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS.  OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES.  LEI 9998, DE 17/08/2000.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.10.01','CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM','REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.10.02','CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM','REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.11.00','CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96 ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.11.01','CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.11.02','CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES','REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.12.00','CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.12.01','CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB','REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.12.02','CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB','REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.13.00','CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB','REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTEA UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.14.00','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA','COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.14.01','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.14.02','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.14.03','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.14.04','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.15.00','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES','COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.15.01','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.15.02','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE','  REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.15.03','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.15.04','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.97.06','(-) CIDE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: (...) III - DO PRODUTO DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO PREVISTA NO ART. 177, § 4º, 29% (VINTE E NOVE POR CENTO) PARA OS ESTADOS E O DISTRITO FEDERAL, DISTRIBUIDOS NA FORMA DA LEI, OBSERVADA A DESTINACAO A QUE SE REFERE O INCISO II, C, DO REFERIDO PARAGRAFO"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.2.99.00','OUTRAS CONTRIBUICOES ECONOMICAS','COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.00.00','CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO - INTER OFSS','COMPREENDEM AS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO, COMO POR EXEMPLO, A CIDE-COMBUSTIVEL   COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.01.00','CONTRIBUICAO PARA O PIN','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE INTEGRACAO NACIONAL. DA PARCELA DO IMPOSTO DERENDA - PESSOAS JURIDICAS, QUE SERVIR DE BASE DE CALCULO PARA A APLICACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CEN-TO) PODERA SER DEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELA DEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAOA APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NOR-DESTE (FINOR); 24% (VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PINE 16% (DEZESSEIS POR CENTO) AO PROTERRA. O PIN TEM COMO OBJETIVO PRO-MOVER A MAIOR INTEGRACAO A ECONOMIA NACIONAL DAS REGIOES COMPREENDIDASNAS AREAS DE ATUACAO DA SUDAM E DA SUDENE. OS RECURSOS SERAO APLICADOSEM PROGRAMAS E PROJETOS CONSIDERADOS PRIORITARIOS PELA SUDAM E SUDENE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.02.00','CONTRIBUICAO PARA O PROTERRA','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES ECONOMICAS DES-TINADAS AO PROGRAMA DE REDISTRIBUICAO DE TERRAS E DE ESTIMULO A AGROINDUSTRIA DO NORTE E DO NORDESTE. DA PARCELA DO IMPOSTO DE RENDA- PES-SOAS JURIDICAS QUE SERVIR DE BASE DE CALCULO PARA APLICACAO EM INCENTIVOS FISCAIS, PERCENTUAL DE ATE 40% (QUARENTA POR CENTO) PODERA SERDEDUZIDO PARA APLICACAO NO GRUPO FINOR/FINAM/PIN/PROTERRA. DA PARCELADEDUZIDA, 60% (SESSENTA POR CENTO) CORRESPONDERAO A APLICACAO NOS FUNDOS DE INVESTIMENTO DA AMAZONIA (FINAM) E DO NORDESTE (FINOR); 24(VINTE E QUATRO POR CENTO) SERAO DESTINADOS AO PIN E 16% AO PROTERRA. OPROTERRA TEM COMO OBJETIVO PROMOVER O MAIS FACIL ACESSO DO HOMEM ATERRA, CRIAR MELHORES CONDICOES DE EMPREGO DE MAO-DE-OBRA E FOMENTAR AAGRO-INDUSTRIA NAS REGIOES COMPREENDIDAS NAS AREAS DE ATUACAO DA SUDAME DA SUDENE. OS RECURSOS SAO APLICADOS EM PROGRAMAS E PROJETOS CONSI-DERADOS PRIORITARIOS PELA SUDAM E SUDENE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.03.00','CONTRIBUICOES DESENV.APERF.ATIVID.FISCALIZ.','COMPREENDE A VPA PROVENIENTE DAS CONTRIBUICOES DESTINADAS AODESENVOLVIMENTO E APERFEICOAMENTO DE ATIVIDADES DE FISCALIZACAO. DES-TINAM-SE A FORNECER RECURSOS PARA FINANCIAR O REAPARELHAMENTO E O REE-QUIPAMENTO DA SECRETARIA DA RECEITA FEDERAL - SRF, E A ATENDER AOS DE-MAIS ENCARGOS ESPECIFICOS INERENTES AO DESENVOLVIMENTO E APERFEICOA-MENTO DAS ATIVIDADES DE FISCALIZACAO DOS TRIBUTOS FEDERAIS. VINCULADASAO FUNDO DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCA-LIZACAO - FUNDAF. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.03.01','SELO ESPECIAL DE CONTROLE','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FIS-CAIS PELO SELO DE CONTROLE. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DESELOS DE CONTROLE DESTINADOS A CIGARROS, CHAMPANHE DE PROCEDENCIA ES-TRANGEIRA, RUM, VODCA, UISQUE, LICORES, AGUARDENTES, BATIDAS, GIM, RE-LOGIOS DE BOLSO E DE PULSO, ETC. VINCULADO AO FUNDO DE DESENVOLVIMENTOE APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.03.02','LOJAS FRANCAS ENTREP.ADUAN. DEP.ALFANDEGADOS','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES FISCAIS ARRECADADAS PELAS LOJAS FRANCAS, PELOS ENTREPOSTOS ADUANEIROS E DEPOSITOS ALFANDEGADOS. CONTRIBUICAO DEVIDA PELO RESSARCIMENTO DAS DESPESAS ADMINISTRATI-VAS DECORRENTES DAS ATIVIDADES EXTRAORDINARIAS DE FISCALIZACAO, DEVIDAPOR: - PERMISSIONARIOS DE REGIME DE ENTREPOSTO ADUANEIRO NA IMPORTACAO DEUSO PUBLICO; - CONCESSIONARIO DE LOJAS FRANCA; - BENEFICIARIOS DE DEPOSITO ESPECIAL ALFANDEGADO; - PERMISSIONARIOS DE LOCAL ALFANDEGADO DE USO PUBLICO; - ANALISE E LAUDOS LABORATORIAIS REALIZADOS NA IMPORTACAO DE PRODUTOSDAS INDUSTRIAS QUIMICAS E PARAQUIMICAS E ALIMENTICIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.04.00','CONTRIBUICAO S/ APOSTAS EM COMPET. HIPICAS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE APOSTAS EM COMPETICOES HIPICAS. INCIDE SOBRE O VALOR TOTAL DO MOVIMENTO GERAL DEAPOSTAS DE CADA ENTIDADE TURFISTICA, A CADA MES. DESTINA-SE A SECRETA-RIA DE DESENVOLVIMENTO RURAL. A APLICACAO DESSES RECURSOS SERA FEITAMEDIANTE PLANO ANUAL, APROVADO PELO MINISTERIO DA AGRICULTURA E DO A-BASTECIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.05.00','CONTRIB.P/DESENV.DA IND.CINEMATOGRAF.NACIONAL','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO PARA O DESENVOLVIMENTO DA INDUSTRIA CINEMATOGRAFICA NACIONAL. CONTRIBUICAO DEVIDA PELOS PRODUTORES OU DISTRIBUIDORES DE FILMES, OU POR QUEM, A QUALQUER TITULO, PROMOVER A IMPORTACAO DE FILMES, E SERA CALCULADA, POR TITULODE FILME, SEGUNDO A IMPORTANCIA A SER CALCULADA PELO PODER EXECUTIVO.OS RECURSOS DEVEM SER APLICADOS PELO MINISTERIO DA CULTURA E PELAS ENTIDADES A ELA VINCULADAS, EM PROGRAMAS RELATIVOS A ATIVIDADE AUDIOVISUAL NACIONAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.05.01','CONTR.P/O DESENV. IND. CINEMAT.NAC. -REMESSAS','REGISTRA O VALOR DA CONTRIBUICAO INCIDENTE SOBRE O PAGAMENTO, O CREDITO, O EMPREGO, A REMESSA OU A ENTREGA, AOS PRODUTORES, DISTRIBUIDORES OU INTERMEDIARIOS NO EXTERIOR, DE IMPORTANCIAS RELATIVAS A RENDIMENTO DECORRENTE DA EXPLORACAO DE OBRAS CINEMATOGRAFICAS E VIDEOFONOGRAFICASOU POR SUA AQUISICAO OU IMPORTACAO, A PRECO FIXO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.05.02','CONTR.P/O DESENV. IND. CINEMAT.NAC. - TITULOS','REGISTRA O VALOR DA CONTRIBUICAO DEVIDA UMA UNICA VEZ A CADA CINCO ANOS, PARA CADA SEGMENTO DE MERCADO POR: - TITULO OU CAPITULO DE OBRA CINEMATOGRAFICA OU VIDEOFONOGRAFICA DESTINADA AOS SEGUINTES SEGMENTOS DE MERCADO: SALA DE EXIBICAO; VIDEO DOMESTICO, EM QUALQUER SUPORTE; SERVICO DE RADIODIFUSAO DE SONS E IMAGENS; SERVICO DE COMUNICACAO ELETRONICA DE MASSA POR ASSINATURA; OUTROS SERVICOS. - TITULO DE OBRA PUBLICITARIA CINEMATOGRAFICA OU VIDEOFONOGRAFICA, PA-RA CADA SEGMENTO DE MERCADO A QUE SE DESTINAR. A CONTRIBUICAO REFERENTE AAS OBRAS CINEMATOGRAFICAS OU VIDEOFONOGRAFICAS PUBLICITARIAS SERA DEVIDA UMA UNICA VEZ A CADA DOZE MESES PARA CADA UM DOS SEGMENTOS DE MERCADO EM QUE A OBRA SEJA EFETIVAMENTE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.06.00','ADICIONAL S/TARIFAS DE PASS.AEREAS DOMESTICAS','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICOES COM O ADICIONALSOBRE TARIFAS DE PASSAGENS AEREAS DE VOO DOMESTICO. CONSTITUI-SE EM UMA DICIONAL DE ATE 3% (TRES POR CENTO) A INCIDIR SOBRE AS TARIFAS DEPASSAGENS AEREAS DAS LINHAS DOMESTICAS, OPERADAS PELAS EMPRESAS DETRANSPORTE AEREO REGULAR, INCLUSIVE AS DE TRANSPORTE AEREO REGIONAL EOS TRECHOS DE CABOTAGEM. O PRODUTO DA ARRECADACAO E VINCULADA AO FUNDOAERONAUTICO PARA APLICACAO EM SISTEMAS INTEGRADOS DE TRANSPORTE AEREOREGIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.07.00','COTA-PARTE ADIC.FRETE P/ RENOV.MARIN.MERCANTE','REGISTRA A VPA PROVENIENTE DAS COTA-PARTE DO ADICIONAL DE FRETE PARA RENOVACAO DA MARINHA MERCANTE. CONTRIBUICAO INCIDENTE SOBREO VALOR DO FRETE NO TRANSPORTE DE QUALQUER CARGA, POR VIA MARITIMA FLUVIAL OU LACUSTRE. OS RECURSOS SE DESTINAM AO FUNDO DE MARINHA MER-CANTE - FMM; A EMPRESA BRASILEIRA DE NAVEGACAO, OPERANDO EMBARCACAOPROPRIA OU AFRETADA DE REGISTRO BRASILEIRO; E, A UMA CONTA ESPECIAL,36% (TRINTA E SEIS POR CENTO) DO AFMM GERADO NA NAVEGACAO DE LONGOCURSO, POR EMPRESA BRASILEIRA OPERANDO EMBARCACAO DE REGISTRO BRASI-LEIRO. ESSA CONTRIBUICAO E APLICADA PRIORITARIAMENTE NA AQUISICAO DEEMBARCACOES NOVAS, PARA USO PROPRIO DAS EMPRESS DE NAVEGACAO, CONSTRU-IDAS EM ESTALEIROS BRASILEIROS; NO REPARO, MANUTENCAO E MODERNIZACAODE EMBARCACOES, REALIZADAS POR EMPRESAS NACIONAIS; E EM PAGAMENTOS DEAMORTIZACOES E ENCARGOS CONCEDIDOS COM RECURSOS DO FUNDO DA MARINHAMERCANTE. PODE TAMBEM SER APLICADA A FUNDO PERDIDO, NOS CASOS PREVISTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.08.00','CONTRIBUICAO S/REC.CONCESS.PERMISS.ENERG.ELET','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA, ONDE: 50% DOS RECURSOS RESULTANTES DE APLICACAO ANUAL DO MONTANTE DE NO MINIMO 1% DE SUA RECEITA OPERACIONAL LIQUIDA DAS CONCESSIONARIAS E PERMISSIONARIAS DE ENERGIA ELETRICA EM P & D DO SETOR ELETRICO. PARA ESSES RECURSOS SERA CRIADA UMA CATEGORIA DE PROGRAMACAO ESPECIFI±CA NO AMBITO DO FUNDO NACIONAL DE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO FNDCT, PARA APLICACAO NO FINANCIAMENTO DE PROGRAMAS E PROJE±TOS DE PESQUISA CIENTIFICA E DESENVOLVIMENTO TECNOLOGICO DO SETOR ELE±TRICO, BEM COMO NA EFICIENCIA ENERGETICA NO USO FINAL. LEI 9991 DE 24/07/2000 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.09.00','CONTRIBUICAO P/ LIC.USO,AQUIS.OU TRANSF.TECN.','REGISTRA A VPA PROVENIENTE DAS CONTRIBUICAO PELA LICENCA DE USO, AQUISICAO OU TRANSFERENCIA DE TECNOLOGIA, REFERENTE A INTERVENCAO NO DOMINIO ECONOMICO DE EMPRESA DETENTORA DE LICENCA DE USO OU ADQUIRENTE DE CONHECIMENTOS TECNOLOGICOS, BEM COMO AQUELA SIGNATARIA DE CONTRATOS QUE IMPLIQUEM TRANSFERENCIA DE TECNOLOGIA, FIRMADOSCOM RESIDENTES OU DOMICILIADOS NO EXTERIOR (ALIQUOTA DE 10 POR CENTO SOBRE OS VALORES PAGOS, CREDITADOS, ENTREGUES, EMPREGADOS OU REMETIDOS, A CADA MES, A RESIDENTES OU DOMICILIADOS NO EXTERIOR). A CONTRIBUICAO SERA RECOLHIDA AO TESOURO NACIONAL E DESTINADA AO FUNDO NACIONALDE DESENVOLVIMENTO CIENTIFICO E TECNOLOGICO - FNDCT. OS RECURSOS SERAOALOCADOS EM CATEGORIA DE PROGRAMACAO ESPECIFICA E ADMINISTRADOS CON-FORME O DISPOSTO NO REGULAMENTO. (PL NUM. 2978/2000). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.10.00','CONTRIB. REC. EMPR. PREST. SERV. TELECOMUNIC.',' REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO SOBRE A RECEITA DAS EMPRESAS PRESTADORAS DE SERVICOS DE TELECOMUNICACOES REFERENTES A UM POR CENTO SOBRE A RECEITA OPERACIONAL BRUTA, DECORRENTE DE PRESTACAO DE SERVICOS DE TELECOMUNICACOES, EXCLUINDO-SE O ICMS, O PIS, E O COFINS.  OS RECURSOS DO FUST SERAO APLICADOS EM PROGRAMAS, PROJETOS E ATIVIDADES QUE ESTEJAM EM CONSONANCIA COM O PLANO GERAL DE METAS PARA UNIVERSALIZACAO DE SERVICO DE TELECOMUNICACOES OU SUAS AMPLIACOES.  LEI 9998, DE 17/08/2000.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.10.01','CON. S/REC.OPER.BRUTA DECOR.PRES.SERV.TELECOM','REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOS DE TELECOMUNICACOES, A ALIQUOTA DE UM POR CENTO SOBRE O VALOR DA RECEITA OPERACIONAL BRUTA EXCLUINDO-SE PARA DETERMINACAO DA BASE DE CALCULO AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, O IMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNIPAIS E DE COMUNICACOES -ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAO SOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL COFINS. OS RECURSOS DESTINADOS AO FUST QUANDO TENHAM A FINALIDADE DE COBRIR APARCELA DE CUSTO, EXCLUSIVOS DAS OBRIGACOES DE UNIVERSALIZACAO DE SERVICOS DE TELECOMUNICACOES QUE NAO POSSA SER RECUPERADA COM A EXPLORARACAO EFICIENTE DO SERVICO NOS TERMOS DO DISPOSTO NA LEI 9472 DEDE 16JUL1997 AMPARO LEGAL LEI 9989 DE 17AGO2000 E DECRETO 3624 DE 05OUT200 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.10.02','CON. S/REC.OPER.BRUTA EMPR.PREST.SERV.TELECOM','REGISTRA A CONTRIBUICAO DEVIDA PELAS EMPRESAS QUE PRESTAM SERVICOSDE TELECOMUNICACOES NO REGIME PUBLICO E PRIVADO, AA ALIQUOTA DE MEIOPOR CENTO SOBRE A RECEITA BRUTA, EXCLUINDO-SE PARA DETERMINACAO DA BA-SE DE CALCULO: AS VENDAS CANCELADAS, OS DESCONTOS CONCEDIDOS, OIMPOSTO SOBRE OPERACOES RELATIVAS A CIRCULACAO DE MERCADORIAS E SOBRE A PRESTACOES DE SERVICOS DE TRANSPORTES INTERESTADUAIS, INTERMUNICI- PAL E DE COMUNICACOES - ICMS, A CONTRIBUICAO AO PROGRAMA DE INTEGRACAOSOCIAL - PIS E A CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADESOCIAL - COFINS OS RECURSOS DESTINADOS A FUNTTEL, PARA APLICACAO NO SETOR DE TELECOMU-NICACOES AMPARO LEGAL: LEI 10 052 DE 28NOV2000 E DECRETO 3 737 DE 30JAN2001 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.11.00','CONTRIB. S/ FATURAMENTO EMPRESAS INFORMATICA','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA, CORRESPONDENTE A 0,5 DOS RECURSOS RESULTANTES DA OBRIGACAO DAS EMPRESAS DE DESENVOLVIMENTO OUPRODUCAO DE BENS E SERVICOS DE INFORMATICA E AUTOMACAO, INVESTIREM NO MINIMO 5 DO SEU FATURAMENTO BRUTO EM P & D PARA FAZER JUS A REDUCAO DE 95 DO IMPOSTO DEVIDO SOBRE PRODUTOS INDUSTRIALIZADOS - IPI. PL N 2514/96 ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.11.01','CONTR. DAS EMPRESAS INSTALADAS NA AMAZONIA',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.11.02','CONTR. EMPRESAS INSTALADAS NAS DEMAIS REGIOES','REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.12.00','CONT.REL.AT.IMP.COM.PETR.DER.GAS NAT.ALC.CARB','COMPREENDE A VPA PROVENIENTE DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.12.01','CONTR.REL.ATIV.IMP.PETR.DER. GAS NAT.ALC.CARB','REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.12.02','CONTR.REL.ATIV.COM.PETR.DER. GAS NAT.ALC.CARB','REGISTRA O VALOR DA CONTRIBUICAO RELATIVA AS ATIVIDADES DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.13.00','CONTRIBUICAO PARA FOMENTO DA RADIODIFUSAO PUB','REGISTRA A VPA DECORRENTE DA PRESTACAO DE SERVICOS DA RADIODIFUSAO PUBLICA, EXPLORADOS DIRETAMENTE PELO PODER EXECUTIVO OU OU-TORGADOS POR ESTE A ENTIDADES DE SUA ADMINISTRACAO INDIRETA. DESTINACAO LEGAL: OS RECURSOS SAO DESTINADOS AA EMPRESA BRASIL DE COMUNICACAO S/A - EBC,VINCULADA AA SECRETARIA DE COMUNICACAO SOCIAL DA PRESIDENCIA DA REPU-BLICA, COM O OBJETIVO DE PROPICIAR MEIOS PARA A MELHORIA DOS SERVICOSDE RADIODIFUSAO PUBLICA E PARA A AMPLIACAO DE SUA PENETRACAO MEDIANTEA UTILIZACAO DE SERVICOS DE TELECOMUNICACOES. AMPARO LEGAL: LEI Nº 11.652, DE 07 DE ABRIL DE 2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.14.00','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA','COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NA ZONA FRANCA DE MANUAUS, QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS NA AMAZONIA. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006','','N','','' );
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.14.01','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.14.02','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.14.03','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL','  REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.14.04','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO','  REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NA AMAZONIA - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT.  AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.15.00','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES','COMPREENDE A CONTRIBUICAO QUE TEM COMO FATO GERADOR A VENDA DE BENS E SERVICOS DE INFORMATICA PELAS EMPRESAS, QUE INDUSTRIALIZAM BENS DE INFORMATICA NAS DEMAIS REGIOES DO PAIS ( COM EXCECAO DA ZONA FRANCA DE MANAUS), QUE OPTAREM POR INVESTIR EM PESQUISA E DESENVOLVIMENTO A SEREM REALIZADAS EM DIVERSAS REGIOES. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.15.01','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL','  REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PRINCIPAL. ESTA PARCELA DEVE SER APLICADA EM DIVERSAS AREAS ( COMO INSTITUTOS E CENTROS DE PESQUISA, UNIVERSIDADES, FACULDADES, FNDCT, DENTRE OUTROS). AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. INCISO III, § 1º, DO ART. 8º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.15.02','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE','  REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - EXCEDENTE. O RESTANTE DA CONTRIBUICAO PODERA SER APLICADO AO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIAS DA INFORMACAO -PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. § 3º, DO ART.10º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.15.03','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL','  REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - RESIDUAL. ESTA PARCELA RESIDUAL OCORRE NA EVENTUALIDADE DE OS INVESTIMENTOS EM ATIVIDADES DE PESQUISA E DESENVOLVIMENTO NAO ATINGIREM AQUELE MINIMO FIXADO ( 5% DO FATURAMENTO BRUTO, DESCONTADO TRIBUTOS), OS RECURSOS FINANCEIROS RESIDUAIS, ATUALIZADOS E ACRESCIDOS DE DOZE POR CENTO, DEVERAO SER APLICADOS NO PROGRAMA DE APOIO AO DESENVOLVIMENTO DO SETOR DE TECNOLOGIA DA INFORMACAO - PADSTI. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991 ART. 35º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.15.04','CONTRIBUICAO S/ FATURAMENTO DE EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO',' REGISTRA A PARCELA DA CONTRIBUICAO SOBRE O FATURAMENTO DAS EMPRESAS DE INFORMATICA INSTALADAS NAS DEMAIS REGIOES - PARCELAMENTO DE DEBITO. ESTA PARCELA REFERE-SE AOS DEBITOS DECORRENTES DA NAO REALIZACAO, TOTAL OU PARCIAL, A QUALQUER TITULO, ATE O PERIODO ENCERRADO EM 31 DE DEZEMBRO DE 2003, DE APLICACOES RELATIVAS AO INVESTIMENTO COMPULSORIO ANUAL EM PESQUISA E DESENVOLVIMENTO TECNOLOGICO, PODERAO SER OBJETO DE PARCELAMENTO (DEBITOS DE INVESTIMENTO) E SERAO DESTINADAS AO FNDCT. AMPARO LEGAL: LEI Nº 8.248, DE 23 DE OUTUBRO DE 1991. LEI Nº 8.387, DE 30 DE DEZEMBRO DE 1991. ART. 37º, DO DECRETO Nº 5.906, DE 26 DE SETEMBRO DE 2006.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.97.06','(-) CIDE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: (...) III - DO PRODUTO DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO PREVISTA NO ART. 177, § 4º, 29% (VINTE E NOVE POR CENTO) PARA OS ESTADOS E O DISTRITO FEDERAL, DISTRIBUIDOS NA FORMA DA LEI, OBSERVADA A DESTINACAO A QUE SE REFERE O INCISO II, C, DO REFERIDO PARAGRAFO"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.2.0.3.99.00','OUTRAS CONTRIBUICOES ECONOMICAS','COMPREENDE A VPA PROVENIENTE DAS OUTRAS CONTRIBUICOES ECONOMICAS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTA ESPECIFICA,INCLUSIVE RECURSOS ORIUNDOS DO PROGRAMA DE RECUPERACAO FISCAL E DO PARCELAMENTO ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.3.0.0.00.00','CONTRIBUICAO DE ILUMINACAO PUBLICA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES COBRADAS POR MUNICIPIO E PELO DISTRITO FEDERAL PARA CUSTEAR O SERVICO DE ILUMINACAO PUBLICA, CONFORME DISPOE O ARTIGO 149-A DA CONSTITUICAO FEDERAL DE 1988.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.3.0.1.00.00','CONTRIBUICAO DE ILUMINACAO PUBLICA - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES PARA CUSTEIO DOS SERVICOS DE ILUMINACAO PUBLICA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.3.0.2.00.00','CONTRIBUICAO DE ILUMINACAO PUBLICA - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES PARA CUSTEIO DOS SERVICOS DE ILUMINACAO PUBLICA.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.3.0.3.00.00','CONTRIBUICAO DE ILUMINACAO PUBLICA - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES PARA CUSTEIO DOS SERVICOS DE ILUMINACAO PUBLICA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.4.0.0.00.00','CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.4.0.1.00.00','CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO,ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.4.0.2.00.00','CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL(OFSS) DO MESMO ENTE PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.2.4.0.3.00.00','CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENINTES DE CONTRIBUICOES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS.OMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.0.0.0.00.00','EXPLORACAO E VENDA DE BENS, SERVICOS E DIREITOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A EXPLORACAO DE BENS E SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.0.0.00.00','VENDA DE MERCADORIAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.0.00.00','VENDA BRUTA DE MERCADORIAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.00.00','VENDA BRUTA DE MERCADORIAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE MERCADORIAS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.   ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.01.00','VENDA DE ESTOQUE PROPRIO - PAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.02.00','VENDA DE ESTOQUE PROPRIO - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.03.00','VENDA DE ESTOQUES ESTRATEGICOS','REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.04.00','VENDA DE ESTOQUES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.05.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.06.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.07.00','VENDA DE ESTOQUES REGULADORES - PGPM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.08.00','VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.09.00','VENDA DE ESTOQUES EM CONSIGNACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.10.00','VENDA DE ESTOQUES POR ATACADO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.11.00','VENDA DE ESTOQUE DE PRODUCAO VEGETAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.12.00','VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE:  A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.13.00','VENDA DE MEDICAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.14.00','VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.15.00','VENDA DE PRODUTOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.1.16.00','VENDA DE FARDAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.00.00','VENDA BRUTA DE MERCADORIAS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE MERCADORIAS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.01.00','VENDA DE ESTOQUE PROPRIO - PAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.02.00','VENDA DE ESTOQUE PROPRIO - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.03.00','VENDA DE ESTOQUES ESTRATEGICOS','REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.04.00','VENDA DE ESTOQUES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.05.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.06.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.07.00','VENDA DE ESTOQUES REGULADORES - PGPM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.08.00','VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.09.00','VENDA DE ESTOQUES EM CONSIGNACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.10.00','VENDA DE ESTOQUES POR ATACADO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.11.00','VENDA DE ESTOQUE DE PRODUCAO VEGETAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.12.00','VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE:  A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.13.00','VENDA DE MEDICAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.14.00','VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.15.00','VENDA DE PRODUTOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.2.16.00','VENDA DE FARDAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.00.00','VENDA BRUTA DE MERCADORIAS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE MERCADORIAS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.  COMPREENDE OS VALORES DE OPERACOS EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.01.00','VENDA DE ESTOQUE PROPRIO - PAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO PAIS. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.02.00','VENDA DE ESTOQUE PROPRIO - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE PROPRIO - NO EXTERIOR. SERA REGISTRADA NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.03.00','VENDA DE ESTOQUES ESTRATEGICOS','REGISTRA O VALOR DA VPA DAS ENTIDADES COMERCIAIS COM A VENDA DE MERCADORIAS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.04.00','VENDA DE ESTOQUES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUE DE PROGRAMAS ESPECIAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.05.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.06.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.07.00','VENDA DE ESTOQUES REGULADORES - PGPM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.08.00','VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.09.00','VENDA DE ESTOQUES EM CONSIGNACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS EM CONSIGNACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.10.00','VENDA DE ESTOQUES POR ATACADO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE MERCADORIAS DE ESTOQUES POR ATACADO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.11.00','VENDA DE ESTOQUE DE PRODUCAO VEGETAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.12.00','VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE:  A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.13.00','VENDA DE MEDICAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIO VAREJISTA E ATACADISTA DE MEDICAMENTOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.14.00','VENDA DE LIVROS PERIOD.MAT.ESC.E PUBLICID.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DE LIVROS, PERIODICOS, MATERIAL ESCOLAR E DE PUBLICIDADE, VAREJISTA OU ATACADISTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.15.00','VENDA DE PRODUTOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIO VAREJISTA E ATACADISTA DE PRODUTOS AGROPECUARIOS. ESTAO INCLUIDAS NESSE ITEM AS VPA DECORRENTES DA COMERCIALIZACAO DE PRODUTOS ADQUIRIDOS COM GARANTIA DE PRECO MINIMO E PARA A FORMACAO DE ESTOQUES REGULADORES E DISTRIBUICAO DE GENEROS ALIMENTICIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.1.3.16.00','VENDA DE FARDAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMERCIALIZACAO DE PRODUTOS DESTINADOS A VESTIMENTAS, UNIFORMES E /OU FARDAS A DETERMINADAS CATEGORIAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.0.00.00','(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS','COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.00.00','(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - EXTRA OFSS','COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.1.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.00.00','(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - INTRA OFSS','COMPREENDE AS DEDUCOES DAS VENDAS DE MERCADORIAS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.09.00','(-) CONFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.2.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.00.00','(-) DEDUCOES DA VENDA BRUTA DE MERCADORIAS - INTER OFSS','REGISTRA O VALOR DE OUTRAS CONTRIBUICOES DE MELHORIAS, NAO CLASSIFICADAS EM ITENS ESPECIFICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL ( OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE MERCADORIAS DE ENTIDADES COMERCIAIS REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS MERCADORIAS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.09.00','(-) CONFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE MERCADORIAS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.1.9.3.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE MERCADORIAS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.0.0.00.00','VENDA DE PRODUTOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.0.00.00','VENDA BRUTA DE PRODUTOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.00.00','VENDA BRUTA DE PRODUTOS - EXTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE PRODUTOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.01.00','VENDA DE ESTOQUE PROPRIO - PAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.02.00','VENDA DE ESTOQUE PROPRIO - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.03.00','VENDA DE ESTOQUES ESTRATEGICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.04.00','VENDA DE ESTOQUES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.05.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.06.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.07.00','VENDA DE ESTOQUES REGULADORES - PGPM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.08.00','VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.09.00','VENDA DE ESTOQUES EM CONSIGNACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.10.00','VENDA DE ESTOQUES POR ATACADO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.11.00','VENDA DE ESTOQUE DE PRODUCAO VEGETAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.12.00','VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE:  A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.13.00','VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.00','VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.01','VENDA DE PRODUTOS DA INDUSTRIA MECANICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.02','VENDA DE PRODUTOS DA INDUSTRIA QUIMICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.03','VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS AA INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.04','VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.05','VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.06','VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.07','VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.1.14.08','VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.00.00','VENDA BRUTA DE PRODUTOS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE PRODUTOS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.   ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.01.00','VENDA DE ESTOQUE PROPRIO - PAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.02.00','VENDA DE ESTOQUE PROPRIO - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.03.00','VENDA DE ESTOQUES ESTRATEGICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.04.00','VENDA DE ESTOQUES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.05.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.06.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.07.00','VENDA DE ESTOQUES REGULADORES - PGPM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.08.00','VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.09.00','VENDA DE ESTOQUES EM CONSIGNACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.10.00','VENDA DE ESTOQUES POR ATACADO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.11.00','VENDA DE ESTOQUE DE PRODUCAO VEGETAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.12.00','VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE:  A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.13.00','VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.00','VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.01','VENDA DE PRODUTOS DA INDUSTRIA MECANICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.02','VENDA DE PRODUTOS DA INDUSTRIA QUIMICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.03','VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS AA INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.04','VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.05','VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.06','VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.07','VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.2.14.08','VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.00.00','VENDA BRUTA DE PRODUTOS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A VENDA BRUTA DE PRODUTOS,QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.   ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.01.00','VENDA DE ESTOQUE PROPRIO - PAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO PAIS.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.02.00','VENDA DE ESTOQUE PROPRIO - EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE PROPRIO - NO EXTERIOR.NESTA CONTA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS QUE NAO ESTEJAM ESPECIFICADAS EM NENHUMA RUBRICA ESPECIFICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.03.00','VENDA DE ESTOQUES ESTRATEGICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE ESTRATEGICO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.04.00','VENDA DE ESTOQUES ESPECIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUE DE PROGRAMAS ESPECIAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.05.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.06.00','VENDA DE ESTOQUES PROG. AGRICULTURA FAMILIAR - MDA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES DO PROGRAMA AGRICULTURA FAMILIAR, ADQUIRIDOS COM RECURSOS DO MDA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.07.00','VENDA DE ESTOQUES REGULADORES - PGPM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES REGULADORES DO PROGRAMA DE GARANTIA DE PRECO MINIMO DO GOVERNO FEDERAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.08.00','VENDA DE ESTOQUES - ABASTECIMENTO SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES PARA ABASTECIMENTO SOCIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.09.00','VENDA DE ESTOQUES EM CONSIGNACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS EM CONSIGNACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.10.00','VENDA DE ESTOQUES POR ATACADO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA VENDA DE PRODUTOS DE ESTOQUES POR ATACADO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.11.00','VENDA DE ESTOQUE DE PRODUCAO VEGETAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LAVOURAS PERMANENTES, TEMPORARIAS E ESPONTANEAS (OU NATIVAS), SILVICULTURA E EXTRACAO DE PRODUTOS VEGETAIS, VENDA DE SEMENTES, MUDAS OU ASSEMELHADOS, DESDE QUE REALIZADAS DIRETAMENTE PELO PRODUTOR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.12.00','VENDA DE ESTOQUE DE PRODUCAO ANIMAL E DERIVADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRODUCAO ANIMAL E DERIVADOS,DECORRENTES DE ATIVIDADES DE EXPLORACAO ECONOMICA DE:  A) PECUARIA DE GRANDE PORTE - BOVINOS, BUFALINOS, EQUINOS E OUTROS(INCLUSIVE LEITE, CARNE E COURO); B) PECUARIA DE MEDIO PORTE - OVINOS, CAPRINOS, SUINOS E OUTROS (INCLUSIVE LA, CARNE E PELES); C) AVES E ANIMAIS DE PEQUENO PORTE (INCLUSIVE OVOS, MEL, CERA E CASULOS DO BICHO DA SEDA); D) CACA E PESCA. ESTAO INCLUIDAS NESSES TITULOS APENAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DE ATIVIDADES DE BE-NEFICIAMENTO OU TRANSFORMACAO OCORRIDAS EM INSTALACOES NOS PROPRIOSESTABELECIMENTOS. AS VARIACOES PATRIMONIAIS AUMENTATIVAS ORIUNDAS DE ATIVIDADES INDUSTRIAIS DEDICADAS A PRODUCAO DE ALIMENTOS (MATADOUROS, FABRICA DE LATICINIOS,ETC.)SAO CLASSIFICADAS EM RECEITA DA INDUSTRIA DE TRANSFORMACAO, BEM COMO SECAGEM, CURTIMENTO, OUTRAS PREPARACOES DE COUROS E PELES, ETC.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.13.00','VENDA DE PRODUTOS DA INDUSTRIA EXTRATIVA MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXTRACAO MINERAL, PROVENIENTES DAS ATIVIDADES INDUSTRIAIS ASSIM DEFINIDAS PELA FUNDACAO INSTITUTO BRASILEIRO DE GEOGRAFIA E ESTATISTICA - IBGE. FATO GERADOR: ATIVIDADES LIGADAS AA INDUSTRIA EXTRATIVA MINERAL, CONF.CLASSIFICACAO DO IBGE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.00','VENDA DE PRODUTOS DA INDUSTRIA DE TRANSFORMACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES LIGADAS A INDUSTRIA DE TRANSFORMACAO, BASEADAS NA CLASSIFICACAO DA FUNDACAO IBGE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.01','VENDA DE PRODUTOS DA INDUSTRIA MECANICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES INDUSTRIA MECANICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.02','VENDA DE PRODUTOS DA INDUSTRIA QUIMICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DA INDUSTRIA QUIMICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.03','VENDA DE PRODUTOS DA INDUSTRIA DE PROD. FARMOQUIMICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS ORIGINARIOS DA INDUSTRIA DE PRODUTOS FARMOQUIMICOS. FATO GERADOR: ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS AA INDUSTRIA DE PRODUTOS FARMOQUIMICOS, CONFORME CLASSIFICACAO DO IBGE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.04','VENDA DE PRODUTOS DA INDUSTRIA DE PRODUTOS ALIMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE PRODUTOS ALIMENTARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.05','VENDA DE PRODUTOS DA INDUSTRIA DE BEBIDAS E DESTILADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA DE BEBIDAS E DESTILADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.06','VENDA DE PRODUTOS DA INDUSTRIA EDITORIAL E GRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DA INDUSTRIA EDITORIAL E GRAFICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.07','VENDA DE PRODUTOS DA INDUSTRIA VETERINARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS VETERINARIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.1.3.14.08','VENDA DE PRODUTOS DA INDUSTRIA FARMACEUTICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DE COMERCIALIZACAO DOS PRODUTOS RELACIONADOS A INDUSTRIA DE PRODUTOS FARMACEUTICOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.0.00.00','(-) DEDUCOES DE VENDA BRUTA DE PRODUTOS','COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.00.00','(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - EXTRA OFSS','COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.04.00','(-) IPI','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.1.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.00.00','(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - INTRA OFSS','  COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO  ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.04.00','(-) IPI','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.09.00','(-) CONFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.2.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.00.00','(-) DEDUCOES DA VENDA BRUTA DE PRODUTOS - INTER OFSS','COMPREENDE AS DEDUCOES DAS VENDAS DE PRODUTOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE PRODUTOS REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NAS PRODUTOS ENTREGUES OU DEFEITOS ORIUNDOS DO TRANSPORTE OU DESEMBARQUE.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.04.00','(-) IPI','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO IPI.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ISS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE PRODUTOS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.2.9.3.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE PRODUTOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.0.0.00.00','EXPLORACAO DE BENS E DIREITOS E PRESTACAO DE SERVICOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, SEGREGANDO-SE A VENDA BRUTA DAS DEDUCOES COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.0.00.00','VALOR BRUTO DE EXPLORACAO DE BENS E DIREITOS E PRESTACAO DE SERVICOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.00.00','VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - EXTRA OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO INDEPENDENTEMENTE DE INGRESSO.  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.01.00','PRESTACAO DE SERVICOS POSTAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.02.00','PRESTACAO DE SERVICOS DE TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.01','ALUGUEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.02','ARRENDAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.03','FOROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.04','LAUDEMIOS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.05','TAXA DE OCUPACAO DE TERRENOS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.06','TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.07','TAXA DE OCUPACAO DE OUTROS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.03.99','OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.04.00','PRESTACAO DE SERVICOS DE LOCACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.05.00','PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.06.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.07.00','PRESTACAO DE SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.08.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.08.01','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.08.02','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.09.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.09.01','PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.09.02','PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.09.03','PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.09.04','PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.09.05','PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.10.00','PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.11.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC.. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.12.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.13.00','PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.14.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR:  A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.15.00','SERVICOS DE COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.15.01','SERVICOS DE PUBLICIDADE LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.15.02','SERVICOS DE RADIODIFUSAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.15.03','PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE','REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.15.99','OUTROS SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.16.00','PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.16.01','PRESTACAO DE SERVICOS DE ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.16.02','PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.17.00','PRESTACAO DE SERVICOS COMPLEMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.18.00','PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.18.01','PRESTACAO DE SERVICOS EXPURGO DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.18.02','PRESTACAO DE SERVICOS SECAGEM DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.18.03','PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.19.00','PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.20.00','PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.21.00','FORNECIMENTO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.22.00','PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.23.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.24.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.24.01','OUTORGA DOS SERV. TRANSP. FERROV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.24.02','OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.24.99','OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.00','CONCESSAO E PERMISSAO - SERV. DE COMUNIC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.01','OUTORGA DOS SERV. TELECOMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.02','OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.03','OUTORGA DIREITO DE USO RADIOFREQUENCIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.04','TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.05','TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.06','OUTORGA UTILIZACAO POSICOES ORBITAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.07','OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.25.99','OUTRAS VPA CONC. PERM. - SERV. COMUNIC','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.26.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.26.01','BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.26.02','PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.27.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.28.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.29.00',' CONCESSAO FLORESTAL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.29.01','VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.29.02','CONTRATOS TRANSICAO CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.30.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.30.01','CONCESS. DE DIREITO REAL USO AREA PUBLIC','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.30.02','CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.30.03','PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO','REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.30.04','RECEITA DA CESSAO DE USO DE BENS DA UNIAO','REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.30.99','OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.00','COMPENSACOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO". ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.01','UTIL.RECURSO HIDRICOS - ITAIPU','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.02','UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.03','EXPLORACAO DE RECURSOS MINERAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.04','ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.05','ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.06','ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.07','ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO  ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS  ONDE OCORRER A PRODUCAO; B) 15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C) 7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO  A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.08','PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMA-ZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.31.09','SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS',' REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.32.00','SERVICOS DE TRANSPORTE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.32.01','SERVICOS DE TRANSPORTE RODOVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.32.02','SERVICOS DE TRANSPORTE FERROVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.32.03','SERVICOS DE TRANSPORTE HIDROVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.32.04','SERVICOS DE TRANSPORTE AEREO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.32.99','OUTROS SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.33.00','SERVICOS PORTUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC.... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.34.00','SERVICOS DE SOCORRO MARITIMO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.35.00','SERVICOS DE SAUDE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC... ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.35.01','SERVICOS HOSPITALARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.35.02','SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.35.03','SERVICOS RADIOLOGICOS E LABORATORIAIS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.35.04','SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.35.99','OUTROS SERVICOS DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.36.00','CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.37.00','SERVICOS DE METROLOGIA E CERTIFICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC.. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.37.01','METROLOGIA LEGAL E CERTIFICATORIA DELEGADA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.37.02','METROLOGIA CIENTIFICA E INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.37.03','METROLOGIA LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.37.04','CERTIFICACAO DE PRODUTOS E SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.37.05','INFORMACAO TECNOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.38.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.39.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.40.00','SERVICOS DE METEOROLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.41.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.42.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.43.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.44.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.00','SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.01','SERVICOS DE PATENTES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.02','SERVICOS DE REGISTRO DE MARCAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.03','SERVICOS DE TRANSFERENCIA DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.04','SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.05','SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.06','SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.07','SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.08','SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.45.99','OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC','REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.46.00','SERVICOS DE REGISTRO DO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.47.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.48.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.49.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.50.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.51.00','TARIFA DE UTILIZACAO DE FAROIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.52.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.52.01','TARIFA AEROPORTUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.52.02','ADICIONAL SOBRE TARIFA AEROPORTUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.52.03','PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.53.00','SERVICOS DE CADASTRO DA ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.54.00','TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.54.01','TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.54.02','ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.55.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.56.00','SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.57.00','PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.57.01','TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.57.02','TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.58.00','GARANTIAS E AVAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.58.01','CONCESSAO DE AVAL DO TESOURO NACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.58.02','CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.58.03','COMISSOES PELA PRESTACAO DE GARANTIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.58.04','GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.58.05','RECEITA DE SEGURO DE CREDITO AA EXPORTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.59.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.60.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.61.00','CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.62.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.62.01','SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.62.02','SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.63.00','SERVICOS FINANCEIROS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.63.01','SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.63.02','SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.63.03','COMISSOES PELA PREST. DE GARANTIA',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.63.99','OUTROS SERVICOS FINANCEIROS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.64.00','SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.64.01','SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.64.02','SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.65.00','VPA DE UTILIZACAO DE POSICOES ORBITAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.66.00','VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.67.00','VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.68.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.69.00','REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO ','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL  AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.70.00','ROYALTIES E PARTICIPACOES - EXPLORACAO PATRIMONIO GENETICO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE ROYALTIES E PARTICIPACOES PELA EXPLORACAO DO  PATRIMONIO GENETICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.70.01','ROYALTIES - EXPLORACAO PATRIMONIO GENETICO - AREA DOMINIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE ROYALTIES PELA EXPLORACAO DO PATRIMONIO GENETICO EM AREA DE DOMINIO PUBLICO. (PORTARIA SOF Nº 132, DE 08/10/10)  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.70.02','ROYALTIES - EXPLORACAO PATRIMONIO GENETICO - MAR TERRITORIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE ROYALTIES PELA EXPLORACAO DO PATRIMONIO GENETICO NO MAR TERRITORIAL, ZONA ECONOMICA EXCLUSIVA OU PLATAFORMA CONTINENTAL.(PORTARIA SOF Nº 132, DE 08/10/10)  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.70.03','PARTICIPACAO - EXPLORACAO PATRIMONIO GENETICO - AREA DOMINIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE PARTICIPACOES PELA EXPLORACAO DO PATRIMONIO GENETICO EM AREAS DE DOMINIO DA UNIAO. (PORTARIA SOF Nº 132, DE 08/10/10)  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.70.04','PARTICIPACAO - EXPLORACAO PATRIMONIO GENETICO - MAR TERRITORIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE PARTICIPACOES PELA EXPLORACAO DO PATRIMONIO GENETICO NO MAR TERRITORIAL, ZONA ECONOMICA EXCLUSIVA OU PLATAFORMA CONTINENTAL.(PORTARIA SOF Nº 132, DE 08/10/10)  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.71.00','VPA OUTORGA A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA/LAVRA JAZIDAS PETROLEO E OUTROS','REGISTRA AS VARIACOES PATRIMONAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.1.99.00','OUTROS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.00.00','VALOR BRUTO EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.01.00','PRESTACAO DE SERVICOS POSTAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.02.00','PRESTACAO DE SERVICOS DE TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.01','ALUGUEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.02','ARRENDAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.03','FOROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.04','LAUDEMIOS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.05','TAXA DE OCUPACAO DE TERRENOS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.06','TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.07','TAXA DE OCUPACAO DE OUTROS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.03.99','OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.04.00','PRESTACAO DE SERVICOS DE LOCACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.05.00','PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.06.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.07.00','PRESTACAO DE SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.08.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.08.01','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.08.02','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.09.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.09.01','PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.09.02','PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.09.03','PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.09.04','PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.09.05','PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.10.00','PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.11.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC.. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.12.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.13.00','PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.14.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR:  A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.15.00','SERVICOS DE COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.15.01','SERVICOS DE PUBLICIDADE LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.15.02','SERVICOS DE RADIODIFUSAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.15.03','PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE','REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.15.99','OUTROS SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.16.00','PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.16.01','PRESTACAO DE SERVICOS DE ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.16.02','PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.17.00','PRESTACAO DE SERVICOS COMPLEMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.18.00','PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.18.01','PRESTACAO DE SERVICOS EXPURGO DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.18.02','PRESTACAO DE SERVICOS SECAGEM DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.18.03','PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.19.00','PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.20.00','PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.21.00','FORNECIMENTO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.22.00','PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.23.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.24.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.24.01','OUTORGA DOS SERV. TRANSP. FERROV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.24.02','OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.24.99','OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.00','CONCESSAO E PERMISSAO - SERV. DE COMUNIC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.01','OUTORGA DOS SERV. TELECOMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.02','OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.03','OUTORGA DIREITO DE USO RADIOFREQUENCIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.04','TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.05','TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.06','OUTORGA UTILIZACAO POSICOES ORBITAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.07','OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.25.99','OUTRAS VPA CONC. PERM. - SERV. COMUNIC','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.26.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.26.01','BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.26.02','PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.27.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.28.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.29.00',' CONCESSAO FLORESTAL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.29.01','VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.29.02','CONTRATOS TRANSICAO CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.30.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.30.01','CONCESS. DE DIREITO REAL USO AREA PUBLIC','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.30.02','CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.30.03','PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO','REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.30.04','RECEITA DA CESSAO DE USO DE BENS DA UNIAO','REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.30.99','OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.00','COMPENSACOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO". ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.01','UTIL.RECURSO HIDRICOS - ITAIPU','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.02','UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.03','EXPLORACAO DE RECURSOS MINERAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.04','ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.05','ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.06','ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.07','ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO  ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I  QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS ONDE OCORRER A PRODUCAO; B)15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.08','PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMA-ZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.31.09','SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS',' REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.32.00','SERVICOS DE TRANSPORTE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.32.01','SERVICOS DE TRANSPORTE RODOVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.32.02','SERVICOS DE TRANSPORTE FERROVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.32.03','SERVICOS DE TRANSPORTE HIDROVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.32.04','SERVICOS DE TRANSPORTE AEREO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.32.99','OUTROS SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.33.00','SERVICOS PORTUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC.... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.34.00','SERVICOS DE SOCORRO MARITIMO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.35.00','SERVICOS DE SAUDE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC... ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.35.01','SERVICOS HOSPITALARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.35.02','SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.35.03','SERVICOS RADIOLOGICOS E LABORATORIAIS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.35.04','SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.35.99','OUTROS SERVICOS DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.36.00','CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.37.00','SERVICOS DE METROLOGIA E CERTIFICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC.. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.37.01','METROLOGIA LEGAL E CERTIFICATORIA DELEGADA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.37.02','METROLOGIA CIENTIFICA E INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.37.03','METROLOGIA LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.37.04','CERTIFICACAO DE PRODUTOS E SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.37.05','INFORMACAO TECNOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.38.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.39.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.40.00','SERVICOS DE METEOROLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.41.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.42.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.43.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.44.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.00','SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.01','SERVICOS DE PATENTES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.02','SERVICOS DE REGISTRO DE MARCAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.03','SERVICOS DE TRANSFERENCIA DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.04','SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.05','SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.06','SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.07','SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.08','SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.45.99','OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC','REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.46.00','SERVICOS DE REGISTRO DO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.47.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.48.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.49.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.50.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.51.00','TARIFA DE UTILIZACAO DE FAROIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.52.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.52.01','TARIFA AEROPORTUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.52.02','ADICIONAL SOBRE TARIFA AEROPORTUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.52.03','PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.53.00','SERVICOS DE CADASTRO DA ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.54.00','TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.54.01','TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.54.02','ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.55.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.56.00','SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.57.00','PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.57.01','TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.57.02','TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.58.00','GARANTIAS E AVAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.58.01','CONCESSAO DE AVAL DO TESOURO NACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.58.02','CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.58.03','COMISSOES PELA PRESTACAO DE GARANTIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.58.04','GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.58.05','RECEITA DE SEGURO DE CREDITO AA EXPORTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.59.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.60.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.61.00','CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.62.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.62.01','SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.62.02','SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.63.00','SERVICOS FINANCEIROS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.63.01','SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.63.02','SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.63.03','COMISSOES PELA PREST. DE GARANTIA',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.63.99','OUTROS SERVICOS FINANCEIROS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.64.00','SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.64.01','SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.64.02','SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.65.00','VPA DE UTILIZACAO DE POSICOES ORBITAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.66.00','VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.67.00','VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.68.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.69.00','REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO ','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL  AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.2.99.00','OUTROS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.00.00','VALOR BRUTO EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTER OFSS',' COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS AUFERIDAS, COM A PRESTACAO DE SERVICOS, QUE RESULTEM EM AUMENTO DO PATRIMONIO LIQUIDO, INDEPENDENTEMENTE DE INGRESSO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.01.00','PRESTACAO DE SERVICOS POSTAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS POSTAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.02.00','PRESTACAO DE SERVICOS DE TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.01','ALUGUEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS PELA UTILIZACAO DE TERCEIROS DE IMOVEIS PROPRIOS DO PODER PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.02','ARRENDAMENTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRATO PELO QUAL O PODER PUBLICO CEDE A TERCEIROS, POR CERTO TEMPO E PRECO, O USO E GOZO DE DE TERMINADA AREA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.03','FOROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PAGAS PELA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO UTIL DE UM IMOVEL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.04','LAUDEMIOS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENSAO OU PREMIO QUE O FOREIRO PAGA, QUANDO HA ALIENACAO DO RESPECTIVO PREDIO POR PARTE DA PESSOA QUE RECEBE POR ENFITEUSE O DOMINIO DO IMOVEL, EXCETO NOS CASOS DE SUCESSAO HEREDITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.05','TAXA DE OCUPACAO DE TERRENOS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE TERRENOS DE MARINHA E DEMAIS TERRENOS DE PROPRIEDADE DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.06','TAXA OCUPACAO IMOVEIS FUN. PROP. NAC. RESID.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE IMOVEIS FUNCIONAIS E PROPRIOS NACIONAIS RESIDENCIAIS DA UNIAO, AGENTES POLITICOS E SERVIDORES PUBLICOS FEDERAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.07','TAXA DE OCUPACAO DE OUTROS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE OCUPACAO, DEVIDA PELOS OCUPANTES DE OUTROS BENS IMOVEIS DE PROPRIEDADE DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.03.99','OUTRAS VPA DE EXPLORACAO DE BENS IMOVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS ORIGENS NA FRUICAO DO PATRIMONIO IMOBILIARIO, NAO ENQUADRADAS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.04.00','PRESTACAO DE SERVICOS DE LOCACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.05.00','PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.06.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.07.00','PRESTACAO DE SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.08.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.08.01','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES LIVRES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 2% DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES LIVRES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.08.02','SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS - APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONSULTORIAS TECNICO - FINACEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO, PERICIAS CONTABEIS, ANALISE DE PROJETOS, ASSISTENCIA TECNICA E EXTENSAO RURAL, ETC. REDIRECIONAMENTO DE 1,5 % DAS LIBERACOES EFETIVADAS PELOS RESPECTIVOS FUNDOS, PARA APLICACOES VINCULADAS A ATIVIDADES DE PESQUISA E DESENVOLVIMENTO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.09.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.09.01','PRESTACAO DE SERVICOS DE DESENVOLVIMENTO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ANALISE E DESENVOLVIMENTO DE SISTEMAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.09.02','PRESTACAO DE SERV. LICENC/CESSAO DE DIREITO USO PROGRAMAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE LICENCIAMENTO OU CESSAO DE DIREITO DE USO DE PROGRAMAS DE COMPUTADOR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.09.03','PRESTACAO DE SERVICOS DE MANUT. E ATUALIZACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE MANUTENCAO E ATUALIZACAO DE SOFTWARE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.09.04','PRESTACAO DE SERVICOS DE INSTAL.E CONFIGURACAO DE SOFTWARE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE INSTALACAO E CONFIGURACAO DE SOFTWARE','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.09.05','PRESTACAO DE SERVICOS DE PAGINAS ELETRONICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE PLANEJAMENTO, CONFECCAO, MANUTENCAO E ATUALIZACAO DE PAGINAS ELETRONICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.10.00','PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.11.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC.. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.12.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.13.00','PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.14.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR:  A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.15.00','SERVICOS DE COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.15.01','SERVICOS DE PUBLICIDADE LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE AGENCIAMENTO DE PUBLICIDADE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.15.02','SERVICOS DE RADIODIFUSAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE RADIODIFUSAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.15.03','PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE','REGISTRA O VALOR DE VPA AUFERIDAS PELA PRESTACAO DE SERVICOS DE AGENCIAMENTO DE PUBLICIDADE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.15.99','OUTROS SERVICOS DE COMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS DE COMUNICACAO, TAIS COMO: SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.16.00','PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.16.01','PRESTACAO DE SERVICOS DE ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE ARMAZENAGEM.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.16.02','PRESTACAO DE SERVICOS DE GARANTIA DE PRODUTOS ARMAZENADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE GARANTIA DE PRODUTOS ARMAZENADOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.17.00','PRESTACAO DE SERVICOS COMPLEMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.18.00','PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.18.01','PRESTACAO DE SERVICOS EXPURGO DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO INSETICIDAS LIQUIDOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.18.02','PRESTACAO DE SERVICOS SECAGEM DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO LENHA, OLEO DIESEL,ETC.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.18.03','PRESTACAO DE SERVICOS LIMPEZA DOS GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PRESERVACAO E CONSERVACAO DAS MERCADORIAS ESTOCADAS UTILIZANDO MAQUINARIOS, COMO PENEIRA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.19.00','PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.20.00','PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.21.00','FORNECIMENTO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.22.00','PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.23.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.24.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.24.01','OUTORGA DOS SERV. TRANSP. FERROV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE FERROVIARIO A INICIATIVA PRIVADA, PROVENIENTE DA FISCALIZACAO, NORMATIZACAO E CONTROLE DOS SERVICOS CONCEDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.24.02','OUTORGA SERV.TRANSP.ROD.INTEREST.INTERNAC.PAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A CONCESSAO PELO PODER PUBLICO AO PARTICULAR DO DIREITO DE EXPLORACAO DOS SERVICOS DE TRANSPORTES RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.24.99','OUTRAS VPA DE CONC. PERMISS. SERV DE TRANSPORTE','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.00','CONCESSAO E PERMISSAO - SERV. DE COMUNIC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE COMUNICACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.01','OUTORGA DOS SERV. TELECOMUNICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE TELECOMUNICACOES, INCLUINDO O SERVICO MOVEL CELULAR E O SERVICO DE TRANSPORTE DE SINAIS DE TELECOMUNICACOES POR SATELITE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.02','OUTORGA SERV.RADIODIFUSAO SONORA SONS IMAGENS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICOS DE RADIODIFUSAO SONORA E DE SONS E IMAGENS, INCLUINDO O USO DE RADIOFREQUENCIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.03','OUTORGA DIREITO DE USO RADIOFREQUENCIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO ESTABELECIDA PELO PODER PUBLICO_AO PARTICULAR DO DIREITO DE USO DE RADIOFREQUENCIA PARA QUALQUER FIM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.04','TRANS.CONC.PERM.AUT.TELECOM.USO RADIOFREQ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTE DE PRECO PUBLICO COBRADO PELA AGENCIA NACIONAL DE TELECOMUNICACOES - ANATEL, COMO CONDICAO PARA TRANSFERENCIA DE CONCESSAO, DE PERMISSAO OU DE AUTORIZACAO DE SERVICO DE TELECOMUNICACOES OU DE USO DE RADIOFREQUENCIA, A SER PAGO PELA CESSIONARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.05','TRANSF.CONC/PERM/AUTOR-RODOVIAS OU OBRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RATEIO DA VERBA DE FISCALIZACAO A SER COBRADA PELOS ESTADOS E DISTRITO FEDERAL (OU CONSORCIO ENTRE ELES), COM O MINISTERIO DOS TRANSPORTES - MT, NA PROPORCAO DE 5% SOBRE O VALOR PAGO MENSALMENTE, PELAS CONCESSIONARIAS, EM FUNCAO DE CONVENIOS FIRMADOS ENTRE A UNIAO E OS RESPECTIVOS ESTADOS, PARA DELEGACAO DE TRECHOS DE RODOVIAS FEDERAIS (OU OBRAS RODOVIARIAS FEDERAIS), CUJA EXPLORACAO, MEDIANTE CONTRATOS DE CONCESSAO, FOI ENTREGUE PELA UNIAO AOS ESTADOS PARA ADMINISTRACAO E EXPLORACAO. (EMENTARIO - PORTARIA Nº 39, DE 15 DE JUNHO DE 2009)','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.06','OUTORGA UTILIZACAO POSICOES ORBITAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA PARA A UTILIZACAO DE POSICOES ORBITAIS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.07','OUTORGA LICENCA E AUTORIZ.AG.ESPAC.BRASILEIRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA DE LICENCAS E AUTORIZACOES DA AGENCIA ESPACIAL BRASILEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.25.99','OUTRAS VPA CONC. PERM. - SERV. COMUNIC','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA OUTORGA PELO PODER PUBLICO DO DIREITO DE EXPLORACAO DE SERVICOS PUBLICO DE COMUNICACAO ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.26.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.26.01','BONUS DE ASSINATURA DE CONTRATO DE CONCESSAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO OFERECIDO NA PROPOSTA PARA OBTENCAO DA CONCESSAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.26.02','PAGAMENTO P/ RETENCAO AREA EXPLORACAO OU PROD','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO ANUAL PELA RETENCAO DE AREA PARA EXPLORACAO, DESENVOLVIMENTO OU PRODUCAO DE PETROLEO E GAS NATURAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.27.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.28.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.29.00',' CONCESSAO FLORESTAL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.29.01','VPA DE CUSTOS DE EDITAL DE CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO CALCULADO SOBRE OS CUSTOS DE REALIZACAO DO EDITAL DE LICITACAO DA CONCESSAO FLORESTAL DA UNIDADE DE MANEJO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.29.02','CONTRATOS TRANSICAO CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PRECO DECORRENTE DE CONTRATOS DE TRANSICAO DE CONCESSAO FLORESTAL PARA EXPLORACAO E GESTAO DE FLORESTAS PUBLICAS E RECURSOS FLORESTAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.30.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.30.01','CONCESS. DE DIREITO REAL USO AREA PUBLIC','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE AREA PUBLICA POR TERCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.30.02','CONCESSAO DE USO DO POTENCIAL DE ENERGIA HIDR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA AUTORIZACAO OU CONCESSAO, POR PARTE DA UNIAO, DAEXPLORACAO E APROVEITAMENTO DOS POTENCIAIS DE ENERGIA HIDRAULICA. DESTINACAO LEGAL: MINISTERIO DE MINAS E ENERGIA;AMPARO LEGAL: - CONSTITUICAO FEDERAL (ART.20, VIII E 176, ÷1º) - LEI 8987/1995; LEI 9074/1995; - LEI 427/1996; - LEI 10438/2002; LEI 10762/2003; - LEI 10848/2004; - LEI 11488/2007. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.30.03','PERMISSAO DE USO AREA DA UNIAO CURTA DURACAO','REGISTRA VPA DECORRENTE DA PERMISSAO DE USO DE AREA DA UNIAO DE CURTA DURACAO  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.30.04','RECEITA DA CESSAO DE USO DE BENS DA UNIAO','REGISTRA VPA DECORRENTE DA CESSAO DE USO DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.30.99','OUTRAS VPA CONC. PERM. - DIR. USO BENS PUBL.','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.00','COMPENSACOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA UNIAO, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO". ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.01','UTIL.RECURSO HIDRICOS - ITAIPU','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS POR ITAPU BINACIONAL DO BRASIL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.02','UTIL.RECURSO HIDRICOS - DEMAIS EMPRESAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMPENSACAO FINANCEIRA RELATIVA AOS ROYALTIES DEVIDOS PELA UTILIZACAO DE RECURSOS HIDRICOS PARA GERACAO DE ENERGIA ELETRICA POR OUTRAS EMPRESAS, EXCETO ITAIPU. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.03','EXPLORACAO DE RECURSOS MINERAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONTRIBUICOES ECONOMICAS A TITULO DE COTA-PARTE DE COMPENSACOES FINANCEIRAS SOBRE A EXPLORACAO DE RECURSOS MINERAIS. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELAEXPLORACAO DE RECURSOS SAO DESTINADOS: A) 23% (VINTE E TRES POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; B) 65% (SESSENTA E CINCO POR CENTO) AOS MUNICIPIOS; C) 12% (DOZE POR CENTO) PARA O DEPARTAMENTO NACIONAL DE PRODUCAO MINE-RAL - DNPM. OS RECURSOS DA COTA-PARTE DESTINADOS AO DEPARTAMENTO NACIONAL DA PRO-DUCAO MINERAL - DNPM, QUE REPASSARA 2% (DOIS POR CENTO) AO IBAMA COM AFINALIDADE DE PROTECAO AMBIENTAL NAS REGIOES MINERADORAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.04','ROYALTIES PRODUCAO PETROLEO GAS.NAT.-EM TERRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA EXTRACAO DO OLEO BRUTO XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM PORCENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOSONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OUDESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERALE MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOSDA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OUTERRESTRES DE EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.05','ROYALTIES PROD. PETR. GAS.NAT.-EM PLATAFORMA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A EXTRACAO DO OLEO BRUTO, XISTO BETUMINOSO E GAS NATURAL. O PRODUTO DA ARRECADACAO DA COMPENSACAO FINANCEIRA PELA EXTRACAO, TEM A SEGUINTE DESTINACAO: - 3,5% (TRES E MEIO POR CENTO) AOS ESTADOS EXPORTADORES; 1% (UM POR CENTO) AOS MUNICIPIOS PRODUTORES;0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES DE EMBARQUE OU DESEMBARQUE DE OLEO OU GAS. E TAMBEM DEVIDA A COMPENSACAO FINANCEIRA AOS ESTADOS, DISTRITO FEDERAL E MUNICIPIOS CONFRONTANTES, QUANDO O OLEO, XISTO E GAS FOREM EXTRAIDOS DA PLATAFORMA CONTINENTAL, NOS MESMOS 5% (CINCO POR CENTO) SENDO: POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIOPOR CENTO) - 1,5% (UM E MEIO POR CENTO) AOS ESTADOS E DISTRITO FEDERAL; 0,5%(MEIO POR CENTO) AOS MUNICIPIOS ONDE SE LOCALIZAREM INSTALACOES MARITIMAS OU TERRESTRES E EMBARQUE E DESEMBARQUE DE OLEO OU GAS; 1,5% (UM E MEIO POR CENTO) AS MUNICIPIOS CONFRONTANTES E SUAS RESPECTIVAS AREAS GEOECONOMICAS; 0,5%(MEIO POR CENTO) PARA CONSTITUIR UM FUNDO ESPECIAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.06','ROYALT.EXCED.PROD.PETR.OU GAS.NAT.-EM TERRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES COM A PARCELA DO VALOR DO ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OUGAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I - QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAISE LACUSTRES: A) 52,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ES-TAODS ONDE OCORRER A PRODUCAO; B)15,0% (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUESEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO EGAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE E CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO).','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.07','ROYALTIES EXCED.PROD.PETR.GAS.NAT.-PLATAFORMA',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM A PARCELA DO VALOR DO  ROYALTY QUE EXCEDER A 5% (CINCO POR CENTO) DA PRODUCAO DE PETROLEO OU GAS NATURAL TENDO A SEGUINTE DISTRIBUICAO: I QUANDO A LAVRA OCORRER EM TERRA OU EM LAGOS, RIOS, ILHAS FLUVIAIS E LACUSTRES: A) 5,5% (CINQUENTA E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS ESTADOS ONDE OCORRER A PRODUCAO; B)15,0 (QUINZE POR CENTO) AOS MUNICIPIOS ONDE OCORRER A PRODUCAO; C)7,5% (SETE INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS QUE SEJAM AFETADOS PELAS OPERACOES DE EMBARQUE E DESEMBARQUE DE PETROLEO E GAS NATURAL, NA FORMA E CRITERIO ESTABELECIDOS PELA ANP; D)25%(VINTE CINCO POR CENTO) AO MINISTERIO DA CIENCIA E TECNOLOGIA; II - QUANDO A LAVRA OCORRER NA PLATAFORMA CONTINENTAL: A) 22,5%(VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO) AOS MUNICIPIOS PRODUTORES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.08','PARTICIP.ESPEC.PROD.PETROLEO OU GAS NATURAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO PAGAMENTO DE PARTICIPACAO ESPECIAL NOS CASOS DE GRANDE VOLUME DE PRODUCAO DE PETROLEO, OU GRANDE RENTABILIDADE. OS RECURSOS DA PARTICIPACAO ESPECIAL SERAO DISTRIBUIDOS NAS SEGUINTESPROPORCOES: - 40% AO MINISTERIO DAS MINAS E ENERGIA, PARA O FINANCIAMENTO DE ESTU-DOS E SERVICOS DE GEOLOGIA E GEOFISICA APLICADOS A PROSPECAO DE PETRO-LEO E GAS NATURAL, A SEREM PROMOVIDOS PELA ANP; - 10% AO MINISTERIO DO MEIO AMBIENTE, DOS RECURSOS HIDRICOS E DA AMA-ZONIA LEGAL, DESTINADOS AO DESENVOLVIMENTO DE ESTUDOS E PROJETOS RELA-CIONADOS COM A PRESERVACAO DO MEIO AMBIENTE E RECUPERACAO DE DANOS AM-BIENTAIS CAUSADOS PELA INDUSTRIA DO PETROLEO; - 40% QUARENTA POR CENTO PARA O ESTADO ONDE OCORRER A PRODUCAO EM TER-RA, OU CONFRONTANTE COM A PLATAFORMA CONTINENTE ONDE SE REALIZAR.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.31.09','SUPRESSAO VEGETAL NAS FLORESTAS NACIONAIS',' REGISTRA O VALOR DA VPA DA SUPRESSAO VEGETAL NO INTERIOR DAS FLORESTAS NACIONAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.32.00','SERVICOS DE TRANSPORTE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.32.01','SERVICOS DE TRANSPORTE RODOVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS COM TRANSPORTE RODOVIARIO, TRANSPORTE RODOVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE ESCOLARES, TAXI, DE ENCOMENDAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.32.02','SERVICOS DE TRANSPORTE FERROVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE FERROVIARIO. VPA AUFERIDA NO TRANSPORTE FERROVIARIO DE PASSAGEIROS E DE CARGA, INCLUSIVE METROPOLITANO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.32.03','SERVICOS DE TRANSPORTE HIDROVIARIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE HIDROVIARIO. VPA DE SERVICOS DE TRANSPORTE HIDROVIARIO DE PASSAGEIROS, DE CARGA OU MISTO, DE LONGO CURSO, DE CABOTAGEM E POR VIAS INTERNAS (RIOS, LAGOS, ETC...) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.32.04','SERVICOS DE TRANSPORTE AEREO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS COM TRANSPORTE AEREO. VPA DE SERVICOS DE TRANSPORTE AEREO DE PASSAGEIROS, DE CARGA OU MISTO, TRANSPORTE AEREO REGULAR,TRANSPORTE AEREO REGIONAL, TAXI AEREO, AERONAVES FRETADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.32.99','OUTROS SERVICOS DE TRANSPORTE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE TRANSPORTE, NAO CLASSIFICADOS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.33.00','SERVICOS PORTUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC.... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.34.00','SERVICOS DE SOCORRO MARITIMO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.35.00','SERVICOS DE SAUDE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC... ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.35.01','SERVICOS HOSPITALARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE HOSPITAL EM GERAL OU ESPECIALIZADO, MATERNIDADE, CENTRO DE REABILITACAO, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.35.02','SERV.REG.AN.CONTR.PROD.SUJ.A NORM.VIGIL.SANIT','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE ANALISE E DE CONTROLE DE PRODUTOS SUJEITOS A NORMAS DE VIGILANCIA SANITARIA E O REGISTRO DE TODOS OS MEDICAMENTOS, DROGAS, INSUMOS FARMACEUTICOS E CORRELATOS, SANEANTES E OUTROS PRODUTOS, INCLUSIVE OS IMPORTADOS, OS EXPOSTOS A VENDA OU ENTREGUE AO CONSUMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.35.03','SERVICOS RADIOLOGICOS E LABORATORIAIS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RADIOLOGICOS E LABORATORIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.35.04','SERV ASSIST SAUDE SUPLEMENTAR SERVIDOR CIVIL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARTICIPACAO DA UNIAO, SUAS AUTARQUIAS E FUNDACOES PUBLICAS E DE RECURSOS PROVENIENTES DA CONTRIBUICAO DOS SERVIDORES PUBLICOS CIVIS ATIVOS, INATIVOS E PENSIONISTAS, DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL, NO CASO DE PRESTACAO DIRETA PELOS ORGAOS (GESTAO PROPRIA). AMPARO LEGAL: LEI 8.112/90, ART. 230 LEI 11.302/2006, ART. 9º PORTARIA SRH/MP 1983/2006 DESTINACAO LEGAL: INTEGRALMENTE DESTINADA AO CUSTEIO DA ASSISTENCIA AA SAUDE SUPLEMENTAR DO SERVIDOR CIVIL DA ADMINISTRACAO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.35.99','OUTROS SERVICOS DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTROS SERVICOS DE SAUDE, E NAO ENQUADRADOS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.36.00','CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.37.00','SERVICOS DE METROLOGIA E CERTIFICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC.. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.37.01','METROLOGIA LEGAL E CERTIFICATORIA DELEGADA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA LEGAL E CERTIFICATORIA DELEGADA, ORIUNDAS DE ENTIDADES PUBLICAS OU PRIVADAS CREDENCIADAS. ESTA VPA ESTA AMPARADA PELA LEI NUM 5966DE 11 DE DEZEMBRO DE 1973. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.37.02','METROLOGIA CIENTIFICA E INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA CIENTIFICA E INDUSTRIAL, NO TOCANTE A AFERICAO DE INSTRUMENTOS DE MEDICOES, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC...ESTA VPA ESTA AMPARADA PELA LEI NUM 5966 DE 11 DE DEZEMBRO DE 1973 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.37.03','METROLOGIA LEGAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METRO-LOGIA LEGAL, ORIUNDA DE SERVICOS METROLOGICOS LEGAIS. BASICAMENTE,CONSISTE EM ASSEGURAR A UNIFORMIDADE E A RACIONALIZACAO DAS UNIDADESEM TODO O TERRITORIO NACIONAL, AFERICAO DE INSTRUMENTOS DE MEDICOES,ETC. ESTA VPA ESTA AMPARADA PELA LEI 5966 DE 11/12/1973. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.37.04','CERTIFICACAO DE PRODUTOS E SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CERTIFICACAO DA QUALIDADE DE MATERIAIS, PRODUTOS E SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.37.05','INFORMACAO TECNOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES TECNOLOGICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.38.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.39.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.40.00','SERVICOS DE METEOROLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.41.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.42.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.43.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.44.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.00','SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.01','SERVICOS DE PATENTES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PETICOES, PEDIDOS DE PRIVILEGIO, ANUIDADES DE PEDIDOS, REGISTROS DE DESENHO INDUSTRIAL,ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.02','SERVICOS DE REGISTRO DE MARCAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PEDIDOS DE REGISTRO DE MARCAS, VIGENCIAS DE MARCAS, PETICOES, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.03','SERVICOS DE TRANSFERENCIA DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE AVERBACOES DE CONTRATOS, PETICOES, RECURSOS, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.04','SERVICOS DE REGISTRO INDICACOES GEOGRAFICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE EXPEDICOES DE CERTIFICADOS DE REGISTRO, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.05','SERVICOS DE REGISTRO PROGRAMA DE COMPUTADOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE PROGRAMAS DE COMPUTADOR, ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.06','SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE DESENHO INDUSTRIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.07','SERV. PROTECAO TOPOGRAFIAS CIRCUITOS INTEGRAD','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROTECAO DAS TOPOGRAFIAS DE CIRCUITOS INTEGRADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.08','SERVICOS DE REMESSA DE DEPOSITOS OFICIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REMESSA DE DEPOSITOOFICIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.45.99','OUTROS SERV.REGIST.MARCAS,PATENTES,TRANSF.TEC','REGISTRA AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE REGISTRO DE MARCAS,PATENTES,TRANSFERENCIA DE TECNOLOGIA, NAO CLASSIFICADOS NOS ITENS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.46.00','SERVICOS DE REGISTRO DO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.47.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.48.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.49.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.50.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.51.00','TARIFA DE UTILIZACAO DE FAROIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.52.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.52.01','TARIFA AEROPORTUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA COBRADA POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPA-TAZIA). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.52.02','ADICIONAL SOBRE TARIFA AEROPORTUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL SOBRE TARIFA AEROPORTUARIA. VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL SOBRE A TARIFA COBRADAPOR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AE-ROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTILIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIASEM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.52.03','PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PARCELA DA TARIFA DE EMBARQUE INTERNACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.53.00','SERVICOS DE CADASTRO DA ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.54.00','TARIFAS USO COMUN.AUX.A NAVEG.AEREA EM ROTA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE USO DAS COMUNICACOES E DOS AUXILIOS AA NAVEGACAO AEREA EM ROTA. VPA PROVENIENTE DE TARIFAS COBRADAS PELA UTILIZACAO DOS SERVICOS DE INFORMACOES AERONAUTICAS, TRAFEGO AEREO, METEOROLOGIA, AUXILIOS A NAVEGACAO AEREA, FACILIDADES DE COMUNICACOES, E OUTROS SERVICOS AUXILIARES DE PROTECAO AO VOO, PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA E POR EMPRESA ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. ESSAS TARIFAS SAO FORMADAS: - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS A NAVEGACAO AEREA(TAN); - PELA TARIFA DE USO DAS COMUNICACOES E DOS AUXILIOS DE RADIO E VISU-AIS EM AREA DE TERMINAL AEREO (TAT). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.54.01','TARIF USO COMUN E AUX.NAVEGACAO AEREA EM ROTA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIA-LIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA. AMPARO LEGAL: DECRETO-LEI 1896/1981 E DECRETO 86.864/1982. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.54.02','ADICIONAL S/ TARIFA USO COM E AUX NAVEG AEREA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO ADICIONAL DE 50% SOBRE AS TARIFAS DE UTILIZACAO DE INSTALACOES E SERVICOS DESTINADOS A APOIAR E TORNAR SEGURA A NAVEGACAO AEREA,PROPORCIONADOS PELO MINISTERIO DA AERONAUTICA OU POR ENTIDADE ESPECIALIZADA DA ADMINISTRACAO FEDERAL INDIRETA, A ELE VINCULADA. FATO GERADOR: ADICIONAL SOBRE AS TARIFAS RELATIVAS AO USO DOS AUXILIOSAA NAVEGACAO AEREA E DAS TELECOMUNICACOES. DESTINACAO LEGAL: MINISTERIO DA AERONAUTICA OU ENTIDADE DA ADMINISTRA-CAO INDIRETA RESPONSAVEL PELA PRESTACAO DOS SERVICOS. AMPARO LEGAL: LEI 7920/1989 - ART 1. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.55.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.56.00','SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.57.00','PREST. DE SERV. PELO BANCO CENTRAL DO BRASIL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE DA PRESTACAO DE SERVICOS DE AUTORIDADE MONETARIA AO SETOR BANCARIO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.57.01','TARIFA PELO USO DO SISTEMA DE INFORM.DO BACEN','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE INFORMACOES DO BACEN. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.57.02','TARIFA PELO USO DO SIST.DE TRANSF. RES. BACEN','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO USO DO SISTEMA DE TRANSFERENCIA DE RESERVA DO BACEN. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.58.00','GARANTIAS E AVAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.58.01','CONCESSAO DE AVAL DO TESOURO NACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE AVAL DO TESOURO NACIONAL, COBRADA A TITULO DE COMISSAO, EXECUCAO OU FISCALIZACAO PELA CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. FATO GERADOR: A CONCESSAO DE GARANTIA DO TESOURO NACIONAL A CREDITOS OBTIDOS NO EXTERIOR. AMPARO LEGAL: LEI 5.000, DE 24 DE MAIO DE 1966. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.58.02','CONCESSAO GARANTIA DA ATIVIDADE AGROPECUARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ADICIONAL COBRADO SOBRE EMPRESTIMOS RURAIS DE CUSTEIO. TEM COMO FINALIDADE EXIMIR O PRODUTOR RURAL DE POSSIVEIS OBRIGACOES RELATIVAS A OPERACOES DE CREDITO CUJA LIQUIDACAO SEJA DIFICULTADA POR FENOMENOS NATURAIS, DOENCAS OUPRAGAS. FATO GERADOR: A REALIZACAO DE EMPRESTIMOS RURAIS DE CUSTEIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.58.03','COMISSOES PELA PRESTACAO DE GARANTIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMISSOES COBRADAS POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO PARA AUMENTO DA COMPETITIVIDAD EE DA PRODUCAO DESTINADA AA EXPORTACAO. FATO GERADOR: COBRANCA DE COMISSOES, POR CONTA DA GARANTIA DE OPERACOES DE FINANCIAMENTO, PARA AUMENTO DA COMPETITIVIDADE E DA PRODUCAODESTINADA AA EXPORTACAO. DESTINACAO LEGAL: - MICROEMPRESAS E EMPRESAS DE PEQUENO PORTE; - MEDIAS EMPRESAS QUE SEJAM EXPORTADORAS OU FABRICANTES DE INSUMOS QUEINTEGREM O PROCESSO PRODUTIVO, OU DE MONTAGEM E DE EMBALAGEM DE MERCA-DORIAS DESTINADAS AA EXPORTACAO. AMPARO LEGAL: LEI 9531, DE 10 DE DEZEMBRO DE 1997, ÷ 1º, 2º E 3º. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.58.04','GARANTIA DOS FINANC.AA ESTOC.ALCOOL ETIL.COMB','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CONCESSAO DE GARANTIAS E AVAIS NOS FINANCIAMENTOS A ESTOCAGEM DE ALCOOL ETILICO COMBUSTIVEL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.58.05','RECEITA DE SEGURO DE CREDITO AA EXPORTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA GARANTIA DAS OPERACOES DE CREDITO AA EXPORTACAO CONTRA OS RISCOS COMERCIAIS, POLITICOS E EXTRAORDINARIOS QUE POSSAM AFETAR A PRODUCAO DE BENS E A PRESTACAO DE SERVICOS DESTINADOS AA EXPORTACAO OU AS EXPORTACOES BRASILEIRAS DE BENS E SERVICOS. AMPARO LEGAL: - LEI 9.818, DE 23 DE AGOSTO DE 1999 - LEI 6.704, DE 26 DE OUTUBRO DE 1979, ART.1º ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.59.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.60.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.61.00','CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.62.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.62.01','SERV.PREST.DIRET. POR INST.CIENT.TECNOLOGICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DIRETAMENTE POR INSTITUICOES CIENTIFICAS E TECNOLOGICAS, VOLTADOS A INOVACAO E A PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.62.02','SERV.DECORREN.PARCEIR.C/OUTRAS INST.PUB.PRIV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA CELEBRACAO DE ACORDOS DE PARCERIA PARA REALIZACAO DE ATIVI-DADES CONJUNTAS DE PESQUISA CIENTIFICA E TECNOLOGICA E DESENVOLVIMENTODE TECNOLOGIA, PRODUTO OU PROCESSO, COM INSTITUICOES PUBLICAS E PRIVA-DAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.63.00','SERVICOS FINANCEIROS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.63.01','SERV.FINANC.DE COMPENS.DE VARIACOES SALARIAIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS FINANCEIROS DE COMPENSACAO DE VARIACOES SALARIAIS. VPA PROVENIENTE DE ADICIONAL COBRADO SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DA HABITACAO. TEM COMO FINALIDADE EXIMIR OS ADQUIRENTES DE CASA PROPRIA DO PAGAMENTO DE POSSIVEIS RESIDUOS DO SALDO DEVEDOR DO FINANCIAMENTO IMOBILIARIO EXISTENTES AO FINAL DO PRAZO CONTRATADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.63.02','SERVICOS DE REMUNERACAO REP. PROG.DES.ECONOM.',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM SERVICOS DE REMUNERACAO DE REPASSES DE PROGRAMA DE DESENVOLVIMENTO ECONOMOMICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.63.03','COMISSOES PELA PREST. DE GARANTIA',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM COMISSOES PELA PREST. DE GARANTIA ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.63.99','OUTROS SERVICOS FINANCEIROS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM OUTROS SERVICOS FINANCEIROS, NAO ENQUADRADOS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.64.00','SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM E DE EMISSAO DE LICENCA DE EXPORTACAO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.64.01','SERVICO DE EMISSAO DE CERTIFICADOS DE ORIGEM','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE CERTIFICADOS DE ORIGEM  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.64.02','SERVICO DE EMISSAO DE LICENCA DE EXPORTACAO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA EMISSAO DE LICENCA DE EXPORTACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.65.00','VPA DE UTILIZACAO DE POSICOES ORBITAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE UTILIZACAO DE POSICOES ORBITAIS, CUJOS RECURSOS SAO PROVENIENTES DE: 25 POR CENTO DA VPA QUE SE REFEREM O ARTIGO 2 DA LEI 5070/96,PROVENIENTES DA UTILIZACAO DE POSICOES ORBITAIS 25 POR CENTO DA VPA DA UNIAO, PROVENIENTES DE LANCAMENTOS, EM CARATER COMERCIAL, DE SATELITES E FOGUETES DE SONDAGEM A PARTIR DO TERRITORIO BRASILEIRO 25 POR CENTO DA VPA AUFERIDAS PELA UNIAO, PROVENIENTES DA COMERCIALIZACAO DOS DADOS E IMAGENS OBTIDOS POR MEIOS DE RASTREAMENTO, TELEMEDIDAS E CONTROLE DE FOGUETES E SATELITES TOTAL DA VPA AUFERIDA PELA AGENCIA ESPACIAL BRASILEIRA - AEB, DECORRENTES DA CONCESSAO DE LICENCAS E AUTORIZACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.66.00','VPA COM.DADOS/IMAGENS UTIL.POSICOES ORBITAIS',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE COMERCIALIZACAO DOS DADOS E IMAGENS ORIUNDOS DA UTILIZACAO DE POSICOES ORBITAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.67.00','VPA LANCAM.SATELITES E FOGUETES DE SONDAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LANCAMENTOS DE SATELITES E FOGUETES DE SONDAGEM, A PARTIR DO TERRITORIO BRASILEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.68.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.69.00','REC.OUTORGA TIT ONEROSO ATIV PESQ/LAVRA-PETRO ','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CESSAO A TITULO ONEROSO DAS ATIVIDADES DE PESQUISA E LAVRA DAS JAZIDAS DE PETROLEO E GAS NATURAL E OUTROS HIDROCARBONETOS FLUIDOS, BEM COMO O SEU REFINO E TRANSPORTE MARITIMO. DESTINACAO LEGAL: TESOURO NACIONAL  AMPARO LEGAL: ART 177 DA CONSTITUICAO FEDERAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.1.3.99.00','OUTROS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.0.00.00','(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS','COMPREENDE AS DEDUCOES DAS PRESTACOESDE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.00.00','(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - EXTRA OFSS','COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.1.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.00.00','(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS - INTRA OFSS','COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.2.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.00.00','(-) DEDUCOES DO VALOR BRUTO DE EXPLORACAO DE BENS, DIREITOS E PRESTACAO DE SERVICOS- INTER OFSS','COMPREENDE AS DEDUCOES DAS PRESTACOES DE SERVICOS, COMO DEVOLUCOES, ABATIMENTOS E DESCONTOS COMERCIAIS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.3.3.9.3.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.0.0.0.00.00','VARIACOES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM OPERACOES FINANCEIRAS. COMPREENDE: DESCONTOS OBTIDOS, JUROS AUFERIDOS, PREMIO DE RESGATE DE TITULOS E DEBENTURES, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE JUROS E ENCARGOS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.1.0.00.00','JUROS E ENCARGOS DE EMPRESTIMOS CONCEDIDOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS CONCEDIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.1.1.00.00','JUROS E ENCARGOS DE EMPRESTIMOS CONCEDIDOS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.1.2.00.00','JUROS E ENCARGOS DE EMPRESTIMOS CONCEDIDOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.1.3.00.00','JUROS E ENCARGOS DE EMPRESTIMOS CONCEDIDOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A APLICACAO DAS TAXAS DE JUROS APLICADAS A EMPRESTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.2.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS CONCEDIDOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.2.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS CONCEDIDOS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.2.2.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS CONCEDIDOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.1.2.3.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS CONCEDIDOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A JUROS SOBRE OS VALORES DE FINANCIAMENTOS CONCEDIDOS PELA UNIAO, ENTIDADES E INSTITUICOES, POR AUTORIZACOES LEGAIS OU VINCULACOES A CONTRATOS E ACORDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO REPRESENTANDO O RESULTADO DAS APLICACOES IMPOSTAS AO CONTRIBUINTE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS ','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.1.2.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.01.00','MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.02.00','MULTAS E JUROS DE MORA DE ALUGUEIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.03.00','MULTAS E JUROS DE MORA DE ARRENDAMENTOS','  REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.04.00','MULTAS E JUROS DE MORA DE LAUDEMIOS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN.DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.05.00','MULTAS E JUROS DE MORA DE FOROS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA  LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.06.00','MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO  COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.07.00','MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.08.00','MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS  DE EXPLORACAO E PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.1.99.00','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.01.00','MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.02.00','MULTAS E JUROS DE MORA DE ALUGUEIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.03.00','MULTAS E JUROS DE MORA DE ARRENDAMENTOS','  REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.04.00','MULTAS E JUROS DE MORA DE LAUDEMIOS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN. DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.05.00','MULTAS E JUROS DE MORA DE FOROS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.06.00','MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.07.00','MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.   ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.08.00','MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS  DE EXPLORACAO E PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.2.99.00','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVICOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO RELATIVA A FORNECIMENTO DE BENS E SERVICOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.01.00','MULT.J.MORA DIV.AT.OUTOR.DIR.EXPL.E PESQ.MIN.',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA DE OUTORGA DE DIREITOS DE EXPLORACAO E PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.02.00','MULTAS E JUROS DE MORA DE ALUGUEIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUR. MORA APLIC. ATRAS. PAGAMEN. DE ALUGUEIS DEVIDOS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.03.00','MULTAS E JUROS DE MORA DE ARRENDAMENTOS','  REGISTRAA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC.P/ ATRAS. NO PAGAMENTO DE RENDAS DEVIDAS POR USO DO PATRIMONIO IMOBILIARIO DA UNIAO SOB A FORMA DE ARRENDAMENTO, DECORRENTES DE CLAUSULAS CONTRATUAIS PACTUADAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.04.00','MULTAS E JUROS DE MORA DE LAUDEMIOS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA ATRASOS NOS RECOLHIMEN.DAS DIFERENCAS DE LAUDEMIOS, GERADAS ANTES DA EDICAO DA M.P NUM 1647 - 14, DE 24 DE MARCO DE 1998, DE ACORDO COM O PREVISTO NO ART. 5. DO DECRETO NUM. 95.760, DE 01 DE MARCO DE 1988.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.05.00','MULTAS E JUROS DE MORA DE FOROS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR. MORA APLIC. ATRASOS NO RECOLHIMENTO DE DEBITOS DE FORO PARA COM A UNIAO, DE ACORDO COM ART. 61 DA  LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996 E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JULHO DE 1995.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.06.00','MULTAS E JUROS DE MORA DE TAXAS DE OCUPACAO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MUL.JUR MORA APLIC. P/ ATRASOS RECOLHIMENTO DE DEBITOS DE TAXA DE OCUPACAO PARA COM A UNIAO, DE ACORDO COM O ART. 61 DA LEI 9430, DE 27 DE DEZEMBRO DE 1996, E O PARAGRAFO 4 DO ART. 36 DA LEI NUM. 9069, DE 29 DE JUNHO DE 1995. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.07.00','MULT.J.MORA REC. EXPLORACAO RECURSOS MINERAIS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE EXPLORACAO DE RECURSOS MINERAIS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.08.00','MULT.J.MORA OUTORG.DIR.EXPLOR.E PESQU.MINERAL','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA APLICADOS POR ATRASOS NO PAGAMENTO DA RECEITA DE OUTORGA DE DIREITOS  DE EXPLORACAO E PESQUISA MINERAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.2.3.99.00','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA SOBRE CREDITOS TRIBUTARIOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE CREDITOS TRIBUTARIOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA SOBRE CREDITOS TRIBUTARIOS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE CREDITOS TRIBUTARIOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.01.00','MULTAS E JUROS DE MORA- IMP. IMPORTACAO',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTESAO IMPOSTO SOBRE IMPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.02.00','MULTAS E JUROS DE MORA- IR','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.02.01','MULTAS E JUROS DE MORA - IRPF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS FISICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.02.02','MULTA E JUROS DE MORA - IRPJ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS JURIDICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.02.03','MULTA E JUROS DE MORA - IRRF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO DE RENDA RETIDO NA FONTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.02.04','MULTA E JUROS DE MORA SIMPLES FED. E NAC-IRPJ','  REGISTRA VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA SIMPLES FEDERAL E NACIONAL - IRPJ. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.03.00','MULTAS E JUROS DE MORA - IPI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.04.00','MULTAS E JUROS DE MORA DO IOF',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, OU RELATIVAS A TITULOS E VALORES MOBILIARIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.05.00','MULTAS E JUROS DE MORA - IMP. EXPORTACAO',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE EXPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.06.00','MULTAS E JUROS DE MORA IMP. PROP.TERRIT.RURAL','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE RURAL.- FATO GERADOR: NAO PAGAMENTO NOS PRAZOS PREVISTOS NA LEGISLACAO DESTE TRIBUTO; AMPARO LEGAL: A) LEI 9430/1996; B) LEI 9393/1996; C) DECRETO 4382/2002; D) LEI 8383/1991, ART 69; E) LEI 9069/1995; F) LEI 5172/1966, ART 161. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.06.01','MULTA E JUROS DE MORA DO ITR MUNICIPIOS CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.06.02','MULTA E JUROS DE MORA DO ITR - MUNIC NAO CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTESAO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO CONVENIADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.07.00','MULTAS E JUROS MORA TX.FISC.TELECOMUNICACAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTESA TAXA DE FISCALIZACAO DAS TELECOMUNICACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.08.00','MULTAS E JUROS DE MORA TAXA FISC. PROD. MEX','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTA AOS CONTRIBUINTES REFERENTES A TAXA DE FISCALIZACAO DOS PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.09.00','MUL.JUR.MORA TX FISC.MERC.SEG.CAPIT.PREV.ABER','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE SEGURO, DA CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.10.00','MUL.JUR.MORA TX FISC.VIGILANCIA SANITARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.11.00','MUL.JUR.MORA TAXA DE SAUDE SUPLEMENTAR','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE SAUDE SUPLEMENTAR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.12.00','MUL.JUR.MORA TX FISC.MERC.TIT. E VAL. MOBILI.','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.13.00','MULTAS E JUROS DE MORA DA CONTRIB. PREVIDENC. - COFINS','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA COM MULTAS E JUROS DE MORA REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.14.00','MULTAS E JUROS DE MORA CONT.SALARIO-EDUCACAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DE NORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO DO SALARIO-EDUCACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.15.00','MULTA E JUROS DE MORA DA CIDE- COMBUSTIVEL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA SOBRE A CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.16.00','MULTA/JUROS MORA CONTR.REG.PROP. PREV. SERV.','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS ORIGINADAS DE MULTAS E JUROS DE MORA DAS CONTRIBUICOES PARA O REGIME PROPRIO DE PREVIDENCIADO SERVIDOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.16.01','MULTAS/JUROS CONTR.PATRONAL REGIME PROP.PREV','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO PATRONAL PARA O REGIME PROPRIO DE PREVIDENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.16.02','MULTAS/JUROS CONTR.SERVIDOR REGIME PROP.PREV','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO DO SERVIDOR PARA O REGIME PROPRIO DE PREVIDENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.00','MULTAS E JUROS DE MORA CONT.PARA O RGPS','COMPREENDE O VALOR DAS PENALIDADES PECUNIARIAS INCIDENTES SOBRE AS CONTRIBUICOES DEVIDAS A SEGURIDADE SOCIAL E NAO RECOLHIDAS ATE A DATA DO SEU VENCIMENTO, COM BASE NO ART. 58, INCISO III, DO DECRETO NO 2.173, DE 06 DE MARCO DE 1997. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.01','MULTAS/J.MORA CONTR.PREV.SEG.OBRIGAT.C.INDIV.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.02','MULTAS/J.MORA CONTR.PREV.SEGURADO EMPREGADO E TRABALHADOR AVULSO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.03','MULTAS/J.MORA CONTR.PREV.EMPRESA S/SEG.ASSAL.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE O SEGURADO ASSALARIADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.04','MULTAS/J.MORA CONTR.PREV.S/ ESPET. DESPORTIVO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULOS DESPORTIVOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.05','MULTAS/J.MORA CONTR.PREV.S/ PRODUCAO RURAL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA SOBRE A PRODUCAO RURAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.06','MULTAS/J.MORA CONTR.PREV.P/SEG.ACIDENTE TRAB.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO ACIDENTE DE TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.07','MULTAS/J.MORA CONTR.PREV.S/ RECLAM. TRABALH.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE RECLAMATORIA TRABALHISTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.08','MULTAS/J.MORA CONTR.PREV.DO SEG. FACULTATIVO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO FACULTATIVO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.09','MULTAS/J.MORA CONTR.PREV.DO SEGURADO ESPECIAL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.10','MULTAS/J.MORA CONTR.PREV. SEG.OBRIG.-EMPR.DOMESTICO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.11','MULTAS/J.MORA CONTR.PREV. ORGAOS PODER PUBL.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.12','MULTAS/J.MORA CONTR.PREV. ENTIDADES FILANTROPICO','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.13','MULTAS/J.MORA CONTR.PREV. RET.S/ NF-SUBROGACAO','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.14','MULTAS/J.MORA ARREC. FIES - CERT.FIN. TESOURO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA ARRECADACAO DO FIES- CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.15','MULTAS/J.MORA DA CONTR.PREV. DEP.JUD/REC/CUST','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PE-CUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA NA FORMA DE DEPOSITO JUDICIAL, RECURSAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.17.16','MULTAS/J.MORA CONTR.PREV.EM REG. PARCEL. DEB.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA EM REGIME DE PARCELAMENTO DE DEBITOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.18.00','MULTAS E JUROS DE MORA CONTRIB. DO PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO PARA O PIS/PASEP.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.19.00','MULTAS E JUROS S/CONTR.SOCIAL S/LUCRO DE PJ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DE PESS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.20.00','MULTA E JUROS DE MORA S/CONT.DOS CONC.E PROG.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DE MULTA E JUROS DE MORA S/ CONTRIBUICOES DOS CONCURSOS DE PROGNOSTICOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.21.00','MUL.JUR.MORA CONT.REC.CONCES.ENERGIA ELETRICA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RE-COLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.22.00','MUL.JUR.MORA DA COTA-PARTE DA CONTR.SINDICAL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA COTA-PARTE DA CONTRIBUICAO SINDICAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.23.00','MUL.JUR.MORA CONTR.S/REC.SORTEIOS ENT.FILANTR','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DE SORTEIOS REALIZADOS POR ENTIDADES FILANTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.24.00','MUL.JU.MORA COTA-PARTE FRETE REN.MAR.MERCANTE','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA COTA-PARTE DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.25.00','MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.26.00','MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB.','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB..','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.27.00','JUROS DE MORA DO FUNDAF - REC. DE CONTRIB.','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.27.01','JUROS MORA DO FUNDAF - CONTR. FIN. SEG.SOCIAL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.27.02','JUROS MORA DO FUNDAF - CONTR. P/ PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.27.03','JUROS MORA DO FUNDAF - CONTR.SOC. S/LUCRO PJ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.28.00','MULTA/JUROS DE COMPENS. FINANCEIRAS RG/RPPS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICOES NAO RECOLHIDAS ATE O VENCIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.29.00','MULTAS JUR. MORA DIV.ATIVA IMPOSTO IMPORTACAO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.30.00','MUL. JUR.MORA DIV.ATIVA IR S/PROV.QQ.NATUREZA','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM O RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA, DE NATUREZA TRIBUTARIA, NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA DO IMPOSTO SOBRE A RENDA E PROVENTES DE QUALQUER NATUREZA.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.30.01','MULTAS JUR. MORA DIV.ATIVA IR-PESSOA FISICA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA FISICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.30.02','MULTAS JUR. MORA DIV.ATIVA IR-PESSOA JURIDICA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA JURIDICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.30.03','MULTAS JUR. MORA DIV.ATIVA IR-RETIDO NA FONTE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.31.00','MULTAS JUR. MORA DIV.ATIVA IMP. PROD.INDUSTR.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.32.00','MUL.JUR.MORA DIV.AT.IMP.OP.CR.CAM.SEG.VAL.MOB','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.33.00','MULTAS JUR. MORA DIV.ATIVA IMPOSTO EXPORTACAO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A EXPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.34.00','MULTAS JUR. MORA DIV.ATIVA IMP.PROP.TER.RURAL','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.35.00','MULTAS JUR. MORA DIV.ATIVA TX FISC.TELECOMUN.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DE TAXA DE FISCALIZACAO DE TELECOMUNICACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.36.00',' MULTAS J.MORA DIV.ATIVA-CONTR. FIN.SEG.SOCIAL  ','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.00','MULTAS JUR.MORA DIV.ATIVA DO RGPS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS CONTRIBUICOES DOS EMPREGADORES E TRABALHADORES PARA A SEGURIDADE SOCIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.01','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.OB.C.I.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.02','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.EMPREGADO E TRABALHADOR AVULSO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.03','MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR.SEG.AS','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE SEGURADO ASSALARIADO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.04','MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR-SIMPLE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA OPTANTE PELO SIMPLES   ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.05','MULTAS JUR.MORA DIV.AT.CONTR.PREV.ESPET.DESPO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULO DESPORTIVO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.06','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ACI.TRA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO DE ACIDENTE DO TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.07','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ESPECIA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO -ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.08','MULTAS J.M.DIV.AT.CONTR.PREV.SEG.OBR.-EMP.DOM','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.37.09','MULTAS J.M.DIV.AT.CONTR.PREV.SEG.ORG.POD.PUBL','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.38.00','MULTAS J.MORA DIV.ATIVA-CONTR. P/ PIS/PASEP','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.39.00','MULTAS JUR.MORA DIV.ATIVA CONTR.SOC.LUCRO PJ.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTES SOBRE A DIVIDA ATIVA DA CONTRIBUICAO SOCIAL SOBRE O LUCRO  DAS PESSOAS JURIDICAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.40.00','MULT.J.MORA DIV.AT.COTA ADIC.FR.MARINHA MERC.','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA COTA-PARTE DO ADICIONAL AO FRETE PARA RENOVACAO DA MARINHA MERCANTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.41.00','MULTAS JUR.MORA DIV.ATIVA CIDE - COMBUSTIVEL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO RELATIVA A ATIVIDADE DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.42.00','JUROS DE MORA DO FUNDAF - DIV.ATIVA DAS CONTR','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.42.01','JUROS MORA DO FUNDAF - DIV. ATIVA DA COFINS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIALBASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.42.02','JUROS MORA DO FUNDAF - DIV. ATIVA PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.42.03','JUROS MORA DO FUNDAF - DIV. ATIVA CSLL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO SOCIAL S/ O LUCRO DAS PESSOAS JURIDICAS BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.43.00',' MULTA E JUROS DE MORA-SIMPLES FED. E NAC.-IPI ',' REGISTRA A VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA DO SIMPLES FEDERAL E NACIONAL - IPI.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.44.00','MULTAS/JUROS DAS CONTRIB. S/ SERV. TELECOMUN.','REGISTRA O SOMATORIO DA VPA COM MULTAS E JUROS DE MORA DAS CONTRIBUICOES SOBRE A PRESTACAO DOS SERVICOS DE TELECOMUNICACOES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.45.00','MULTAS E JUROS DE MORA DIVIDA ATIVA - TX FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA TAXA DE FISCALIZACAO - TAFIC. PORTARIA SOF Nº 144 DE 27/10/10).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.06','(-) CIDE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: (...) III - DO PRODUTO DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO PREVISTA NO ART. 177, § 4º, 29% (VINTE E NOVE POR CENTO) PARA OS ESTADOS E O DISTRITO FEDERAL, DISTRIBUIDOS NA FORMA DA LEI, OBSERVADA A DESTINACAO A QUE SE REFERE O INCISO II, C, DO REFERIDO PARAGRAFO"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.07','(-) ITR',' REGISTRA A DEDUCAO CONFORME ART. 158 DA CF/88 : " ART. 158. PERTENCEM AOS MUNICIPIOS: (...) II - CINQUENTA POR CENTO DO PRODUTO DA ARRECADACAO DO IMPOSTO DA UNIAO SOBRE A PROPRIEDADE TERRITORIAL RURAL, RELATIVAMENTE AOS IMOVEIS NELES SITUADOS, CABENDO A TOTALIDADE NA HIPOTESE DA OPCAO A QUE SE REFERE O ART. 153, § 4º, III"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.08','(-) IPI EXPORTACAO',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : "A UNIAO ENTREGARA: (...) II - DO PRODUTO DA ARRECADACAO DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS, DEZ POR CENTO AOS ESTADOS E AO DISTRITO FEDERAL, PROPORCIONALMENTE AO VALOR DAS RESPECTIVAS EXPORTACOES DE PRODUTOS INDUSTRIALIZADOS."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.09','(-) IOF OURO','REGISTRA A DEDUCAO CONFORME ART 153 DA CF /88 : "(...) § 5º - O OURO, QUANDO DEFINIDO EM LEI COMO ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, SUJEITA-SE EXCLUSIVAMENTE A INCIDENCIA DO IMPOSTO DE QUE TRATA O INCISO V DO "CAPUT" DESTE ARTIGO, DEVIDO NA OPERACAO DE ORIGEM; A ALIQUOTA MINIMA SERA DE UM POR CENTO, ASSEGURADA A TRANSFERENCIA DO MONTANTE DA ARRECADACAO NOS SEGUINTES TERMOS: I - TRINTA POR CENTO PARA O ESTADO, O DISTRITO FEDERAL OU O TERRITORIO, CONFORME A ORIGEM; II - SETENTA POR CENTO PARA O MUNICIPIO DE ORIGEM." ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CREDITOS TRIBUTARIOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.99.01','JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.1.99.02','JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.00.00','JUROS E ENCARGOS DE MORA SOBRE CREDITOS TRIBUTARIOS -INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE CREDITOS TRIBUTARIOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.01.00','MULTAS E JUROS DE MORA- IMP. IMPORTACAO',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTESAO IMPOSTO SOBRE IMPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.02.00','MULTAS E JUROS DE MORA- IR','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.02.01','MULTAS E JUROS DE MORA - IRPF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS FISICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.02.02','MULTA E JUROS DE MORA - IRPJ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS JURIDICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.02.03','MULTA E JUROS DE MORA - IRRF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO DE RENDA RETIDO NA FONTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.02.04','MULTA E JUROS DE MORA SIMPLES FED. E NAC-IRPJ','  REGISTRA VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA SIMPLES FEDERAL E NACIONAL - IRPJ. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.03.00','MULTAS E JUROS DE MORA - IPI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.04.00','MULTAS E JUROS DE MORA DO IOF',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, OU RELATIVAS A TITULOS E VALORES MOBILIARIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.05.00','MULTAS E JUROS DE MORA - IMP. EXPORTACAO',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE EXPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.06.00','MULTAS E JUROS DE MORA IMP. PROP.TERRIT.RURAL','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE RURAL.- FATO GERADOR: NAO PAGAMENTO NOS PRAZOS PREVISTOS NA LEGISLACAO DESTE TRIBUTO; AMPARO LEGAL: A) LEI 9430/1996; B) LEI 9393/1996; C) DECRETO 4382/2002; D) LEI 8383/1991, ART 69; E) LEI 9069/1995; F) LEI 5172/1966, ART 161. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.06.01','MULTA E JUROS DE MORA DO ITR MUNICIPIOS CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.06.02','MULTA E JUROS DE MORA DO ITR - MUNIC NAO CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTESAO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO CONVENIADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.07.00','MULTAS E JUROS MORA TX.FISC.TELECOMUNICACAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTESA TAXA DE FISCALIZACAO DAS TELECOMUNICACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.08.00','MULTAS E JUROS DE MORA TAXA FISC. PROD. MEX','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTA AOS CONTRIBUINTES REFERENTES A TAXA DE FISCALIZACAO DOS PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.09.00','MUL.JUR.MORA TX FISC.MERC.SEG.CAPIT.PREV.ABER','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE SEGURO, DA CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.10.00','MUL.JUR.MORA TX FISC.VIGILANCIA SANITARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.11.00','MUL.JUR.MORA TAXA DE SAUDE SUPLEMENTAR','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE SAUDE SUPLEMENTAR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.12.00','MUL.JUR.MORA TX FISC.MERC.TIT. E VAL. MOBILI.','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.13.00','MULTAS E JUROS DE MORA DA CONTRIB. PREVIDENC.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA COM MULTAS E JUROS DE MORA REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA FINANCIAMENTO DA SEGURIDADE SOCIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.14.00','MULTAS E JUROS DE MORA CONT.SALARIO-EDUCACAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DE NORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO DO SALARIO-EDUCACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.15.00','MULTA E JUROS DE MORA DA CIDE- COMBUSTIVEL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA SOBRE A CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.16.00','MULTA/JUROS MORA CONTR.REG.PROP. PREV. SERV.','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS ORIGINADAS DE MULTAS E JUROS DE MORA DAS CONTRIBUICOES PARA O REGIME PROPRIO DE PREVIDENCIADO SERVIDOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.16.01','MULTAS/JUROS CONTR.PATRONAL REGIME PROP.PREV','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO PATRONAL PARA O REGIME PROPRIO DE PREVIDENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.16.02','MULTAS/JUROS CONTR.SERVIDOR REGIME PROP.PREV','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO DO SERVIDOR PARA O REGIME PROPRIO DE PREVIDENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.00','MULTAS E JUROS DE MORA CONT.PARA O RGPS','COMPREENDE O VALOR DAS PENALIDADES PECUNIARIAS INCIDENTES SOBRE AS CONTRIBUICOES DEVIDAS A SEGURIDADE SOCIAL E NAO RECOLHIDAS ATE A DATA DO SEU VENCIMENTO, COM BASE NO ART. 58, INCISO III, DO DECRETO NO 2.173, DE 06 DE MARCO DE 1997. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.01','MULTAS/J.MORA CONTR.PREV.SEG.OBRIGAT.C.INDIV.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.02','MULTAS/J.MORA CONTR.PREV.SEGURADO EMPREGADO E TRABALHADOR AVULSO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.03','MULTAS/J.MORA CONTR.PREV.EMPRESA S/SEG.ASSAL.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE O SEGURADO ASSALARIADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.04','MULTAS/J.MORA CONTR.PREV.S/ ESPET. DESPORTIVO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULOS DESPORTIVOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.05','MULTAS/J.MORA CONTR.PREV.S/ PRODUCAO RURAL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA SOBRE A PRODUCAO RURAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.06','MULTAS/J.MORA CONTR.PREV.P/SEG.ACIDENTE TRAB.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO ACIDENTE DE TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.07','MULTAS/J.MORA CONTR.PREV.S/ RECLAM. TRABALH.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE RECLAMATORIA TRABALHISTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.08','MULTAS/J.MORA CONTR.PREV.DO SEG. FACULTATIVO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO FACULTATIVO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.09','MULTAS/J.MORA CONTR.PREV.DO SEGURADO ESPECIAL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.10','MULTAS/J.MORA CONTR.PREV. SEG.OBRIG.-EMPR.DOMESTICO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.11','MULTAS/J.MORA CONTR.PREV. ORGAOS PODER PUBL.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.12','MULTAS/J.MORA CONTR.PREV. ENTIDADES FILANTROPICO','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.13','MULTAS/J.MORA CONTR.PREV. RET.S/ NF-SUBROGACAO','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.14','MULTAS/J.MORA ARREC. FIES - CERT.FIN. TESOURO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA ARRECADACAO DO FIES- CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.15','MULTAS/J.MORA DA CONTR.PREV. DEP.JUD/REC/CUST','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PE-CUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA NA FORMA DE DEPOSITO JUDICIAL, RECURSAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.17.16','MULTAS/J.MORA CONTR.PREV.EM REG. PARCEL. DEB.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA EM REGIME DE PARCELAMENTO DE DEBITOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.18.00','MULTAS E JUROS DE MORA CONTRIB. DO PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO PARA O PIS/PASEP.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.19.00','MULTAS E JUROS S/CONTR.SOCIAL S/LUCRO DE PJ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DE PESS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.20.00','MULTA E JUROS DE MORA S/CONT.DOS CONC.E PROG.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DE MULTA E JUROS DE MORA S/ CONTRIBUICOES DOS CONCURSOS DE PROGNOSTICOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.21.00','MUL.JUR.MORA CONT.REC.CONCES.ENERGIA ELETRICA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RE-COLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.22.00','MUL.JUR.MORA DA COTA-PARTE DA CONTR.SINDICAL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA COTA-PARTE DA CONTRIBUICAO SINDICAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.23.00','MUL.JUR.MORA CONTR.S/REC.SORTEIOS ENT.FILANTR','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DE SORTEIOS REALIZADOS POR ENTIDADES FILANTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.24.00','MUL.JU.MORA COTA-PARTE FRETE REN.MAR.MERCANTE','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA COTA-PARTE DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.25.00','MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.26.00','MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB.','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB..','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.27.00','JUROS DE MORA DO FUNDAF - REC. DE CONTRIB.','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.27.01','JUROS MORA DO FUNDAF - CONTR. FIN. SEG.SOCIAL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.27.02','JUROS MORA DO FUNDAF - CONTR. P/ PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.27.03','JUROS MORA DO FUNDAF - CONTR.SOC. S/LUCRO PJ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.28.00','MULTA/JUROS DE COMPENS. FINANCEIRAS RG/RPPS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICOES NAO RECOLHIDAS ATE O VENCIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.29.00','MULTAS JUR. MORA DIV.ATIVA IMPOSTO IMPORTACAO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.30.00','MUL. JUR.MORA DIV.ATIVA IR S/PROV.QQ.NATUREZA','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM O RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA, DE NATUREZA TRIBUTARIA, NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA DO IMPOSTO SOBRE A RENDA E PROVENTES DE QUALQUER NATUREZA.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.30.01','MULTAS JUR. MORA DIV.ATIVA IR-PESSOA FISICA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA FISICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.30.02','MULTAS JUR. MORA DIV.ATIVA IR-PESSOA JURIDICA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA JURIDICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.30.03','MULTAS JUR. MORA DIV.ATIVA IR-RETIDO NA FONTE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.31.00','MULTAS JUR. MORA DIV.ATIVA IMP. PROD.INDUSTR.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.32.00','MUL.JUR.MORA DIV.AT.IMP.OP.CR.CAM.SEG.VAL.MOB','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.33.00','MULTAS JUR. MORA DIV.ATIVA IMPOSTO EXPORTACAO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A EXPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.34.00','MULTAS JUR. MORA DIV.ATIVA IMP.PROP.TER.RURAL','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.35.00','MULTAS JUR. MORA DIV.ATIVA TX FISC.TELECOMUN.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DE TAXA DE FISCALIZACAO DE TELECOMUNICACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.36.00',' MULTAS J.MORA DIV.ATIVA-CONTR. FIN.SEG.SOCIAL  ','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.00','MULTAS JUR.MORA DIV.ATIVA DO RGPS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS CONTRIBUICOES DOS EMPREGADORES E TRABALHADORES PARA A SEGURIDADE SOCIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.01','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.OB.C.I.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.02','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.EMPREGADO E TRABALHADOR AVULSO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.03','MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR.SEG.AS','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE SEGURADO ASSALARIADO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.04','MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR-SIMPLE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA OPTANTE PELO SIMPLES  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.05','MULTAS JUR.MORA DIV.AT.CONTR.PREV.ESPET.DESPO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULO DESPORTIVO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.06','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ACI.TRA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO DE ACIDENTE DO TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.07','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ESPECIA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO -ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.08','MULTAS J.M.DIV.AT.CONTR.PREV.SEG.OBR.-EMP.DOM','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.37.09','MULTAS J.M.DIV.AT.CONTR.PREV.SEG.ORG.POD.PUBL','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.38.00','MULTAS J.MORA DIV.ATIVA-CONTR. P/ PIS/PASEP','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.39.00','MULTAS JUR.MORA DIV.ATIVA CONTR.SOC.LUCRO PJ.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTES SOBRE A DIVIDA ATIVA DA CONTRIBUICAO SOCIAL SOBRE O LUCRO  DAS PESSOAS JURIDICAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.40.00','MULT.J.MORA DIV.AT.COTA ADIC.FR.MARINHA MERC.','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA COTA-PARTE DO ADICIONAL AO FRETE PARA RENOVACAO DA MARINHA MERCANTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.41.00','MULTAS JUR.MORA DIV.ATIVA CIDE - COMBUSTIVEL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO RELATIVA A ATIVIDADE DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.42.00','JUROS DE MORA DO FUNDAF - DIV.ATIVA DAS CONTR','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.42.01','JUROS MORA DO FUNDAF - DIV. ATIVA DA COFINS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIALBASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.42.02','JUROS MORA DO FUNDAF - DIV. ATIVA PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.42.03','JUROS MORA DO FUNDAF - DIV. ATIVA CSLL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO SOCIAL S/ O LUCRO DAS PESSOAS JURIDICAS BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.43.00',' MULTA E JUROS DE MORA-SIMPLES FED. E NAC.-IPI ',' REGISTRA A VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA DO SIMPLES FEDERAL E NACIONAL - IPI.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.44.00','MULTAS/JUROS DAS CONTRIB. S/ SERV. TELECOMUN.','REGISTRA O SOMATORIO DA VPA COM MULTAS E JUROS DE MORA DAS CONTRIBUICOES SOBRE A PRESTACAO DOS SERVICOS DE TELECOMUNICACOES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.45.00','MULTAS E JUROS DE MORA DIVIDA ATIVA - TX FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA TAXA DE FISCALIZACAO - TAFIC. PORTARIA SOF Nº 144 DE 27/10/10).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; " ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.06','(-) CIDE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: (...) III - DO PRODUTO DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO PREVISTA NO ART. 177, § 4º, 29% (VINTE E NOVE POR CENTO) PARA OS ESTADOS E O DISTRITO FEDERAL, DISTRIBUIDOS NA FORMA DA LEI, OBSERVADA A DESTINACAO A QUE SE REFERE O INCISO II, C, DO REFERIDO PARAGRAFO"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.07','(-) ITR',' REGISTRA A DEDUCAO CONFORME ART. 158 DA CF/88 : " ART. 158. PERTENCEM AOS MUNICIPIOS: (...) II - CINQUENTA POR CENTO DO PRODUTO DA ARRECADACAO DO IMPOSTO DA UNIAO SOBRE A PROPRIEDADE TERRITORIAL RURAL, RELATIVAMENTE AOS IMOVEIS NELES SITUADOS, CABENDO A TOTALIDADE NA HIPOTESE DA OPCAO A QUE SE REFERE O ART. 153, § 4º, III" ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.08','(-) IPI EXPORTACAO',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : "A UNIAO ENTREGARA: (...) II - DO PRODUTO DA ARRECADACAO DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS, DEZ POR CENTO AOS ESTADOS E AO DISTRITO FEDERAL, PROPORCIONALMENTE AO VALOR DAS RESPECTIVAS EXPORTACOES DE PRODUTOS INDUSTRIALIZADOS." ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.09','(-) IOF OURO','REGISTRA A DEDUCAO CONFORME ART 153 DA CF /88 : "(...) § 5º - O OURO, QUANDO DEFINIDO EM LEI COMO ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, SUJEITA-SE EXCLUSIVAMENTE A INCIDENCIA DO IMPOSTO DE QUE TRATA O INCISO V DO "CAPUT" DESTE ARTIGO, DEVIDO NA OPERACAO DE ORIGEM; A ALIQUOTA MINIMA SERA DE UM POR CENTO, ASSEGURADA A TRANSFERENCIA DO MONTANTE DA ARRECADACAO NOS SEGUINTES TERMOS: I - TRINTA POR CENTO PARA O ESTADO, O DISTRITO FEDERAL OU O TERRITORIO, CONFORME A ORIGEM; II - SETENTA POR CENTO PARA O MUNICIPIO DE ORIGEM." ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.99.01','JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.2.99.02','JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.00.00','JUROS E ENCARGOS DE MORA SOBRE CREDITOS TRIBUTARIOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE APLICADA EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE CREDITOS TRIBUTARIOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.01.00','MULTAS E JUROS DE MORA- IMP. IMPORTACAO',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTESAO IMPOSTO SOBRE IMPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.02.00','MULTAS E JUROS DE MORA- IR','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRITUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.02.01','MULTAS E JUROS DE MORA - IRPF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS FISICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.02.02','MULTA E JUROS DE MORA - IRPJ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO SOBRE A RENDA DAS PESSOAS JURIDICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.02.03','MULTA E JUROS DE MORA - IRRF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS E JUROS DE MORA REFERENTES AO IMPOSTO DE RENDA RETIDO NA FONTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.02.04','MULTA E JUROS DE MORA SIMPLES FED. E NAC-IRPJ','  REGISTRA VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA SIMPLES FEDERAL E NACIONAL - IRPJ. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.03.00','MULTAS E JUROS DE MORA - IPI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.04.00','MULTAS E JUROS DE MORA DO IOF',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS RELATIVAS A MULTAS DECORRENTES DA INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO, OU RELATIVAS A TITULOS E VALORES MOBILIARIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.05.00','MULTAS E JUROS DE MORA - IMP. EXPORTACAO',' REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS REFERENTES A MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE EXPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.06.00','MULTAS E JUROS DE MORA IMP. PROP.TERRIT.RURAL','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE RURAL.- FATO GERADOR: NAO PAGAMENTO NOS PRAZOS PREVISTOS NA LEGISLACAO DESTE TRIBUTO; AMPARO LEGAL: A) LEI 9430/1996; B) LEI 9393/1996; C) DECRETO 4382/2002; D) LEI 8383/1991, ART 69; E) LEI 9069/1995; F) LEI 5172/1966, ART 161. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.06.01','MULTA E JUROS DE MORA DO ITR MUNICIPIOS CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTES AO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS CONVENIADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.06.02','MULTA E JUROS DE MORA DO ITR - MUNIC NAO CONVENIADOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AO CONTRIBUINTE REFERENTESAO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL - MUNICIPIOS NAO CONVENIADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.07.00','MULTAS E JUROS MORA TX.FISC.TELECOMUNICACAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTAS AOS CONTRIBUINTES REFERENTESA TAXA DE FISCALIZACAO DAS TELECOMUNICACOES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.08.00','MULTAS E JUROS DE MORA TAXA FISC. PROD. MEX','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTA DECORRENTE DE INOBSERVANCIA DE NORMA TRIBUTARIA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO TRIBUTARIA IMPOSTA AOS CONTRIBUINTES REFERENTES A TAXA DE FISCALIZACAO DOS PRODUTOS CONTROLADOS PELO MINISTERIO DO EXERCITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.09.00','MUL.JUR.MORA TX FISC.MERC.SEG.CAPIT.PREV.ABER','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE SEGURO, DA CAPITALIZACAO E DA PREVIDENCIA PRIVADA ABERTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.10.00','MUL.JUR.MORA TX FISC.VIGILANCIA SANITARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.11.00','MUL.JUR.MORA TAXA DE SAUDE SUPLEMENTAR','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE SAUDE SUPLEMENTAR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.12.00','MUL.JUR.MORA TX FISC.MERC.TIT. E VAL. MOBILI.','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA TAXA DE FISCALIZACAO DOS MERCADOS DE TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.13.00','MULTAS E JUROS DE MORA DA CONTRIB. PREVIDENC. - COFINS','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA COM MULTAS E JUROS DE MORA REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.14.00','MULTAS E JUROS DE MORA CONT.SALARIO-EDUCACAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DE NORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO DO SALARIO-EDUCACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.15.00','MULTA E JUROS DE MORA DA CIDE- COMBUSTIVEL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA SOBRE A CONTRIBUICAO RELATIVA AS ATIVIDADES DE IMPORTACAO E COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.16.00','MULTA/JUROS MORA CONTR.REG.PROP. PREV. SERV.','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS ORIGINADAS DE MULTAS E JUROS DE MORA DAS CONTRIBUICOES PARA O REGIME PROPRIO DE PREVIDENCIADO SERVIDOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.16.01','MULTAS/JUROS CONTR.PATRONAL REGIME PROP.PREV','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO PATRONAL PARA O REGIME PROPRIO DE PREVIDENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.16.02','MULTAS/JUROS CONTR.SERVIDOR REGIME PROP.PREV','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS DE MORA DA CONTRIBUICAO DO SERVIDOR PARA O REGIME PROPRIO DE PREVIDENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.00','MULTAS E JUROS DE MORA CONT.PARA O RGPS','COMPREENDE O VALOR DAS PENALIDADES PECUNIARIAS INCIDENTES SOBRE AS CONTRIBUICOES DEVIDAS A SEGURIDADE SOCIAL E NAO RECOLHIDAS ATE A DATA DO SEU VENCIMENTO, COM BASE NO ART. 58, INCISO III, DO DECRETO NO 2.173, DE 06 DE MARCO DE 1997. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.01','MULTAS/J.MORA CONTR.PREV.SEG.OBRIGAT.C.INDIV.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.02','MULTAS/J.MORA CONTR.PREV.SEGURADO EMPREGADO E TRABALHADOR AVULSO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.03','MULTAS/J.MORA CONTR.PREV.EMPRESA S/SEG.ASSAL.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE O SEGURADO ASSALARIADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.04','MULTAS/J.MORA CONTR.PREV.S/ ESPET. DESPORTIVO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULOS DESPORTIVOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.05','MULTAS/J.MORA CONTR.PREV.S/ PRODUCAO RURAL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA SOBRE A PRODUCAO RURAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.06','MULTAS/J.MORA CONTR.PREV.P/SEG.ACIDENTE TRAB.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO ACIDENTE DE TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.07','MULTAS/J.MORA CONTR.PREV.S/ RECLAM. TRABALH.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA SOBRE RECLAMATORIA TRABALHISTA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.08','MULTAS/J.MORA CONTR.PREV.DO SEG. FACULTATIVO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO FACULTATIVO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.09','MULTAS/J.MORA CONTR.PREV.DO SEGURADO ESPECIAL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICAO PREVIDENCIARIA DO SEGURADO ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.10','MULTAS/J.MORA CONTR.PREV. SEG.OBRIG.-EMPR.DOMESTICO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.11','MULTAS/J.MORA CONTR.PREV. ORGAOS PODER PUBL.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.12','MULTAS/J.MORA CONTR.PREV. ENTIDADES FILANTROPICO','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS ENTIDADES FILANTROPICAS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.13','MULTAS/J.MORA CONTR.PREV. RET.S/ NF-SUBROGACAO','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA DAS RETENCOES SOBRE NOTAS FISCAIS - SUBROGACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.14','MULTAS/J.MORA ARREC. FIES - CERT.FIN. TESOURO','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA ARRECADACAO DO FIES- CERTIFICADOS FINANCEIROS DO TESOURO NACIONAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.15','MULTAS/J.MORA DA CONTR.PREV. DEP.JUD/REC/CUST','REPRESENTA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PE-CUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA NA FORMA DE DEPOSITO JUDICIAL, RECURSAL','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.17.16','MULTAS/J.MORA CONTR.PREV.EM REG. PARCEL. DEB.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DA APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES AA CONTRIBUICAO PREVIDENCIARIA EM REGIME DE PARCELAMENTO DE DEBITOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.18.00','MULTAS E JUROS DE MORA CONTRIB. DO PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO PARA O PIS/PASEP.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.19.00','MULTAS E JUROS S/CONTR.SOCIAL S/LUCRO DE PJ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA DECORRENTE DE INOBSERVANCIA DENORMA ESPECIFICA E JUROS DESTINADOS A INDENIZACAO PELO ATRASO NO PAGAMENTO DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DE PESS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.20.00','MULTA E JUROS DE MORA S/CONT.DOS CONC.E PROG.','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTANTE DE MULTA E JUROS DE MORA S/ CONTRIBUICOES DOS CONCURSOS DE PROGNOSTICOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.21.00','MUL.JUR.MORA CONT.REC.CONCES.ENERGIA ELETRICA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RE-COLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DAS CONCESSIONARIAS DE ENERGIA ELETRICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.22.00','MUL.JUR.MORA DA COTA-PARTE DA CONTR.SINDICAL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA COTA-PARTE DA CONTRIBUICAO SINDICAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.23.00','MUL.JUR.MORA CONTR.S/REC.SORTEIOS ENT.FILANTR','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE PENALIDADES PECUNIARIAS PELO NAO RECOLHIMENTO, NO PRAZO ESTABELECIDO, DA CONTRIBUICAO SOBRE A RECEITA DE SORTEIOS REALIZADOS POR ENTIDADES FILANTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.24.00','MUL.JU.MORA COTA-PARTE FRETE REN.MAR.MERCANTE','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM MULTA E JUROS DE MORA DA COTA-PARTE DO ADICIONAL AO FRETE PARA A RENOVACAO DA MARINHA MERCANTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.25.00','MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR.REL.DESP.EMP. S/ J.CAUSA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.26.00','MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB.','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA MULT. J.MORA CONTR. S/ REMUN. DEVIDA AO TRAB..','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.27.00','JUROS DE MORA DO FUNDAF - REC. DE CONTRIB.','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.27.01','JUROS MORA DO FUNDAF - CONTR. FIN. SEG.SOCIAL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.27.02','JUROS MORA DO FUNDAF - CONTR. P/ PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.27.03','JUROS MORA DO FUNDAF - CONTR.SOC. S/LUCRO PJ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.28.00','MULTA/JUROS DE COMPENS. FINANCEIRAS RG/RPPS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA COM APLICACAO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES REFERENTES A CONTRIBUICOES NAO RECOLHIDAS ATE O VENCIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.29.00','MULTAS JUR. MORA DIV.ATIVA IMPOSTO IMPORTACAO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.30.00','MUL. JUR.MORA DIV.ATIVA IR S/PROV.QQ.NATUREZA','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA COM O RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA, DE NATUREZA TRIBUTARIA, NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA DO IMPOSTO SOBRE A RENDA E PROVENTES DE QUALQUER NATUREZA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.30.01','MULTAS JUR. MORA DIV.ATIVA IR-PESSOA FISICA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA FISICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.30.02','MULTAS JUR. MORA DIV.ATIVA IR-PESSOA JURIDICA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - PESSOA JURIDICA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.30.03','MULTAS JUR. MORA DIV.ATIVA IR-RETIDO NA FONTE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A RENDA - RETIDO NAS FONTES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.31.00','MULTAS JUR. MORA DIV.ATIVA IMP. PROD.INDUSTR.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.32.00','MUL.JUR.MORA DIV.AT.IMP.OP.CR.CAM.SEG.VAL.MOB','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE OPERACOES DE CREDITO, CAMBIO E SEGURO OU RELATIVAS A TITULOS OU VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.33.00','MULTAS JUR. MORA DIV.ATIVA IMPOSTO EXPORTACAO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COM A FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A EXPORTACAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.34.00','MULTAS JUR. MORA DIV.ATIVA IMP.PROP.TER.RURAL','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.35.00','MULTAS JUR. MORA DIV.ATIVA TX FISC.TELECOMUN.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DE TAXA DE FISCALIZACAO DE TELECOMUNICACAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.36.00',' MULTAS J.MORA DIV.ATIVA-CONTR. FIN.SEG.SOCIAL  ','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL,INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.00','MULTAS JUR.MORA DIV.ATIVA DO RGPS','COMPREENDE O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS CONTRIBUICOES DOS EMPREGADORES E TRABALHADORES PARA A SEGURIDADE SOCIAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.01','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.OB.C.I.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - CONTRIBUINTE INDIVIDUAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.02','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.EMPREGADO E TRABALHADOR AVULSO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO EMPREGADO E TRABALHADOR AVULSO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.03','MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR.SEG.AS','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASI MPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA SOBRE SEGURADO ASSALARIADO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.04','MULTAS JUR.MORA DIV.AT.CONTR.PREV.EMPR-SIMPLE','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DA EMPRESA OPTANTE PELO SIMPLES   ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.05','MULTAS JUR.MORA DIV.AT.CONTR.PREV.ESPET.DESPO','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA SOBRE ESPETACULO DESPORTIVO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.06','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ACI.TRA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA PARA O SEGURO DE ACIDENTE DO TRABALHO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.07','MULTAS JUR.MORA DIV.AT.CONTR.PREV.SEG.ESPECIA','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO -ESPECIAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.08','MULTAS J.M.DIV.AT.CONTR.PREV.SEG.OBR.-EMP.DOM','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DO SEGURADO OBRIGATORIO - EMPREGADO DOMESTICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.37.09','MULTAS J.M.DIV.AT.CONTR.PREV.SEG.ORG.POD.PUBL','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PREVIDENCIARIA DOS ORGAOS DO PODER PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.38.00','MULTAS J.MORA DIV.ATIVA-CONTR. P/ PIS/PASEP','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS DE INTEGRACAO SOCIAL E DE FORMACAO DO PATRIMONIO DO SERVIDOR PUBLICO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.39.00','MULTAS JUR.MORA DIV.ATIVA CONTR.SOC.LUCRO PJ.','REGISTRA O VALOR DA VARIACAO PATRIMONIAL AUMENTATIVA RESULTADO DE PENAS PECUNIARIASIMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTES SOBRE A DIVIDA ATIVA DA CONTRIBUICAO SOCIAL SOBRE O LUCRO DAS PESSOAS JURIDICAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.40.00','MULT.J.MORA DIV.AT.COTA ADIC.FR.MARINHA MERC.','REGISTRA O VALOR TOTAL DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA COTA-PARTE DO ADICIONAL AO FRETE PARA RENOVACAO DA MARINHA MERCANTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.41.00','MULTAS JUR.MORA DIV.ATIVA CIDE - COMBUSTIVEL','REGISTRA O SOMATORIO DA VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES PELO NAO CUMPRIMENTO DE OBRIGACOES PARA COMA FAZENDA PUBLICA NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA CONTRIBUICAO RELATIVA A ATIVIDADE DE COMERCIALIZACAO DE PETROLEO E SEUS DERIVADOS, GAS NATURAL E ALCOOL CARBURANTE.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.42.00','JUROS DE MORA DO FUNDAF - DIV.ATIVA DAS CONTR','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA RESPECTIVA CONTRIBUICAO. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.42.01','JUROS MORA DO FUNDAF - DIV. ATIVA DA COFINS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA O FINANCIAMENTO DA SEGURIDADE SOCIALBASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.42.02','JUROS MORA DO FUNDAF - DIV. ATIVA PIS/PASEP','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO PARA OS PROGRAMAS PIS/PASEP. BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.42.03','JUROS MORA DO FUNDAF - DIV. ATIVA CSLL','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS DE MORA DO FUNDAF - ATE O LIMITE DE 1% DA DIVIDA ATIVA DA CONTRIBUICAO SOCIAL S/ O LUCRO DAS PESSOAS JURIDICAS BASE LEGAL: ART. 4º DA LEI Nº 7.711/88; ART. 69 DA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.43.00',' MULTA E JUROS DE MORA-SIMPLES FED. E NAC.-IPI ',' REGISTRA A VPA ARRECADADA DECORRENTE DE MULTA E JUROS DE MORA DO SIMPLES FEDERAL E NACIONAL - IPI.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.44.00','MULTAS/JUROS DAS CONTRIB. S/ SERV. TELECOMUN.','REGISTRA O SOMATORIO DA VPA COM MULTAS E JUROS DE MORA DAS CONTRIBUICOES SOBRE A PRESTACAO DOS SERVICOS DE TELECOMUNICACOES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.45.00','MULTAS E JUROS DE MORA DIVIDA ATIVA - TX FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTE DE MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA TAXA DE FISCALIZACAO - TAFIC. PORTARIA SOF Nº 144 DE 27/10/10).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.00','(-) DEDUCOES','COMPREENDEM AS DEDUCOES DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM FPE , FPM, FNO, FNE, FCO, CIDE , ITR, IPI EXPORTACAO, IOF OURO E RENUNCIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.01','(-) FPE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: A) VINTE E UM INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS ESTADOS E DO DISTRITO FEDERAL; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.02','(-) FPM',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: I - DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS QUARENTA E OITO POR CENTO NA SEGUINTE FORMA: (...) B) VINTE E DOIS INTEIROS E CINCO DECIMOS POR CENTO AO FUNDO DE PARTICIPACAO DOS MUNICIPIOS; "','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.03','(-) FNO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.04','(-) FNE',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO NORDESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.05','(-) FCO',' REGISTRA A DEDUCAO DO PRODUTO DA ARRECADACAO DOS IMPOSTOS SOBRE RENDA E PROVENTOS DE QUALQUER NATUREZA E SOBRE PRODUTOS INDUSTRIALIZADOS PARA APLICACAO EM PROGRAMAS DE FINANCIAMENTO AO SETOR PRODUTIVO DA REGIAO CENTRO - OESTE, CONFORME ART. 159 DA CF/88. ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.06','(-) CIDE',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : " A UNIAO ENTREGARA: (...) III - DO PRODUTO DA ARRECADACAO DA CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO PREVISTA NO ART. 177, § 4º, 29% (VINTE E NOVE POR CENTO) PARA OS ESTADOS E O DISTRITO FEDERAL, DISTRIBUIDOS NA FORMA DA LEI, OBSERVADA A DESTINACAO A QUE SE REFERE O INCISO II, C, DO REFERIDO PARAGRAFO"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.07','(-) ITR',' REGISTRA A DEDUCAO CONFORME ART. 158 DA CF/88 : " ART. 158. PERTENCEM AOS MUNICIPIOS: (...) II - CINQUENTA POR CENTO DO PRODUTO DA ARRECADACAO DO IMPOSTO DA UNIAO SOBRE A PROPRIEDADE TERRITORIAL RURAL, RELATIVAMENTE AOS IMOVEIS NELES SITUADOS, CABENDO A TOTALIDADE NA HIPOTESE DA OPCAO A QUE SE REFERE O ART. 153, § 4º, III"','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.08','(-) IPI EXPORTACAO',' REGISTRA A DEDUCAO CONFORME ART. 159 DA CF/88 : "A UNIAO ENTREGARA: (...) II - DO PRODUTO DA ARRECADACAO DO IMPOSTO SOBRE PRODUTOS INDUSTRIALIZADOS, DEZ POR CENTO AOS ESTADOS E AO DISTRITO FEDERAL, PROPORCIONALMENTE AO VALOR DAS RESPECTIVAS EXPORTACOES DE PRODUTOS INDUSTRIALIZADOS."','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.09','(-) IOF OURO','REGISTRA A DEDUCAO CONFORME ART 153 DA CF /88 : "(...) § 5º - O OURO, QUANDO DEFINIDO EM LEI COMO ATIVO FINANCEIRO OU INSTRUMENTO CAMBIAL, SUJEITA-SE EXCLUSIVAMENTE A INCIDENCIA DO IMPOSTO DE QUE TRATA O INCISO V DO "CAPUT" DESTE ARTIGO, DEVIDO NA OPERACAO DE ORIGEM; A ALIQUOTA MINIMA SERA DE UM POR CENTO, ASSEGURADA A TRANSFERENCIA DO MONTANTE DA ARRECADACAO NOS SEGUINTES TERMOS: I - TRINTA POR CENTO PARA O ESTADO, O DISTRITO FEDERAL OU O TERRITORIO, CONFORME A ORIGEM; II - SETENTA POR CENTO PARA O MUNICIPIO DE ORIGEM." ','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.97.10','(-) RENUNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTRAS CREDITOS TRIBUTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.99.01','JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE OUTROS TRIBUTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.3.3.99.02','JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DE JUROS E ENCARGOS DE MORA SOBRE DIVIDA ATIVA DE OUTROS TRIBUTOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - EXTRA OFSS','COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.01.00','MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL',' COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.01.01','MULTA ALIEN.BENS IMOVEIS DOM.UNIAO ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMÍNIO DA UNIAO- DOMÍNIO PLENO, UTIL E DIRETO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.01.02','JUROS ALIEN.BENS IMOVEIS DOM.UNIAO',' REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMÍNIO DA UNIAO- DOMÍNIO PLENO, UTIL E DIRETO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.02.00','MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.03.00','MULTAS E JUROS DE MORA DE PARCELAMENTO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996  E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.04.00','MULTAS E JUROS DE MORA DE DIVIDENDOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.05.00','MULTAS E JUROS DE MORA DE PARTICIPACOES',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.06.00','MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATORIOS EM ATRASO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.07.00','MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.08.00','MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.09.00','MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.10.00','MULTA MORA PELA CESSAO DE USO DE BENS UNIAO','  REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.11.00','JUROS MORA PELA CESSAO DE USO DE BENS UNIAO','  REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.12.00','MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO',' REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.13.00','JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO','  REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.14.00','MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR','REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.15.00','MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR','REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.  (PORTARIA SOF Nº 144 DE 27/10/2010) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.99.00','OUTROS JUROS E ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.99.01','OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATORIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.1.99.02','OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS','COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.01.00','MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL',' COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.01.01','MULTA ALIEN.BENS IMOVEIS DOM.UNIAO ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMÍNIO DA UNIAO- DOMÍNIO PLENO, UTIL E DIRETO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.01.02','JUROS ALIEN.BENS IMOVEIS DOM.UNIAO',' REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMÍNIO DA UNIAO- DOMÍNIO PLENO, UTIL E DIRETO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.02.00','MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.03.00','MULTAS E JUROS DE MORA DE PARCELAMENTO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996  E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.04.00','MULTAS E JUROS DE MORA DE DIVIDENDOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.05.00','MULTAS E JUROS DE MORA DE PARTICIPACOES',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.06.00','MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATORIOS EM ATRASO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.07.00','MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.08.00','MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.09.00','MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.10.00','MULTA MORA PELA CESSAO DE USO DE BENS UNIAO','  REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.11.00','JUROS MORA PELA CESSAO DE USO DE BENS UNIAO','  REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.12.00','MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO',' REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.13.00','JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO','  REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.14.00','MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR','REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.15.00','MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR','REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.  (PORTARIA SOF Nº 144 DE 27/10/2010) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.99.00','OUTROS JUROS E ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.99.01','OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATORIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.   ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.2.99.02','OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS','COMPREENDE AS OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE JUROS E MULTAS COM PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.01.00','MULTAS JUR.MORA ALIENACAO DE DOMINIO UTIL',' COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS JUROS DE MORA ALIEN. DOM.UTIL. MULTAS APLICADAS POR ATRASOS NO RECOLHIMENTO DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL DE TERRENOS DA UNIAO, DE ACORDO COM O PREVISTO NO ARTIGO 4 DO DECRETO-LEI NUM 1561, DE 13 DE JULHO DE 1977 E ARTIGOS 25 A 27 DA MP NUM. 1647-14, DE 24 DE FEVEREIRO DE 1998.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.01.01','MULTA ALIEN.BENS IMOVEIS DOM.UNIAO ','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE MULTA DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMÍNIO DA UNIAO- DOMÍNIO PLENO, UTIL E DIRETO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.01.02','JUROS ALIEN.BENS IMOVEIS DOM.UNIAO',' REGISTRA A A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE JUROS DE MORA DA ALIENACAO DE BENS IMOVEIS DO DOMÍNIO DA UNIAO- DOMÍNIO PLENO, UTIL E DIRETO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.02.00','MUL.JUR. MORA ALIEN. DE OUTROS BENS IMOVEIS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE ALIEN. DE OUTROS BENS IMOVEIS. MULTAS APLICADAS POR ATRASOS NOS RECOLHIMENTOS DE PARCELAS REFERENTES A AQUISICAO DE DOMINIO UTIL OU PLENO DE IMOVEIS DA UNIAO, DE ACORDO COM O PREVISTO NOS ARTIGOS 25 A 27 DA MP NUM. 1647-14 DE 24 DE MARCO DE 1998.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.03.00','MULTAS E JUROS DE MORA DE PARCELAMENTO','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS E JUROS DE MORA DE PARCELAMENTOS, APLICADAS POR ATRASOS NO RECOLHIMENTO DE DEBITOS PARA COM A UNIAO DE ACORDO COM O ARTIGO 61 DA LEI NUM. 9430, DE 27 DE DEZEMBRO DE 1996  E O PARAGRAFO QUARTO DO ART. 36 DA LEI NUM 9069, DE 29 DE JULHO DE 1995.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.04.00','MULTAS E JUROS DE MORA DE DIVIDENDOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE DIVIDENDOS DEVIDOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.05.00','MULTAS E JUROS DE MORA DE PARTICIPACOES',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE OS VALORES DE PARTICIPACOES DEVIDAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.06.00','MULT.JUROS MORA REC.DIR.ANTIDUMPING DIR.COMP','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE MULTAS INCIDENTES SOBRE RECEITAS DOS DIREITOS "ANTIDUMPING" E DOS DIREITOS COMPENSATORIOS EM ATRASO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.07.00','MULT. JUROS MORA REC.DECORR. BENS APREENDIDOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO RESULTADO DA APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS RECEITAS DECORRENTES DE BENS APREENDIDOS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.08.00','MULT.J.MORA DIV.AT. MULTAS INFR.A LEG. TRAB.','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE PENAS PECUNIARIAS IMPOSTAS AOS CONTRIBUINTES POR INFRACAO A LEGISLACAO TRABALHISTA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.09.00','MULT.J.MORA DIV.AT.MULT.PREV.LEGIS.MINERARIA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE CREDITO DA FAZENDA PUBLICA, PELO NAO PAGAMENTO DOS CONTRIBUINTES NO TRANSCURSO DO PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DA RECEITA PREVISTA NA LEGISTACAO MINERARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.10.00','MULTA MORA PELA CESSAO DE USO DE BENS UNIAO','  REGISTRA O VALOR DA VPA DE MULTA DE MORA PELA CESSAO DE USO DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.11.00','JUROS MORA PELA CESSAO DE USO DE BENS UNIAO','  REGISTRA O VALOR DA VPA DE JUROS DE MORA PELA CESSAO DE USO DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.12.00','MULTA INDEN.POSSE OU OCUP.ILICITA BENS UNIAO','  REGISTRA O VALOR DA VPA DE MULTA DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.13.00','JUROS INDEN.POSSE OU OCUP.ILICITA BENS UNIAO','  REGISTRA O VALOR DA VPA DE JUROS DE MORA NA ARRECADACAO DA RECEITA DE INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.14.00','MULTAS E JUROS DE MORA DIVIDA ATIVA - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR','REGISTRA O VALOR DA VPA DECORRENTE DE MULTAS E JUROS DE MORA DA RECEITA DA DIVIDA ATIVA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.(PORTARIA SOF Nº 144 DE 27/10/10). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.15.00','MULTAS E JUROS - AUTO DE INFRACAO PREVIDENCIA COMPLEMENTAR','REGISTRA O VALOR DA VPA PROVENIENTE DE MULTAS E JUROS DE MORA DO AUTO DE INFRACAO NO AMBITO DO REGIME DE PREVIDENCIA COMPLEMENTAR FECHADA.  (PORTARIA SOF Nº 144 DE 27/10/2010) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.99.00','OUTROS JUROS E ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE OUTROS JUROS E ENCARGOS DE MORA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.99.01','OUTRAS MULTAS E JUROS DE MORA DE OUTRAS RECEITAS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS DE CARATER PUNITIVO OU MORATORIO E DE JUROS DESTINADOS A INDENIZACAO PELO PAGAMENTO EM ATRASO DE OUTRAS RECEITAS NAO CLASSIFICADAS NOS ITENS ANTERIORES.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.2.9.3.99.02','OUTRAS MULT.JUR.MORA DIV.ATIV.OUTR.RECEITAS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE OUTRAS MULTAS E JUROS DE MORA DA DIVIDA ATIVA DE OUTRAS RECEITAS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.0.0.00.00','VARIACOES MONETARIAS E CAMBIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A A CORRECAO MONETARIA POS-FIXADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.0.00.00','VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS CONCEDIDOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.1.00.00','VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS CONCEDIDOS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.1.01.00','VARIACOES MONETARIAS DE EMPRESTIMOS CONCEDIDOS ','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.1.02.00','VARIACOES CAMBIAIS DE EMPRESTIMOS CONCEDIDOS ','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.2.00.00','VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS CONCEDIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.2.01.00','VARIACOES MONETARIAS DE EMPRESTIMOS CONCEDIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.2.02.00','VARIACOES CAMBIAIS DE EMPRESTIMOS CONCEDIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.3.00.00','VARIACOES MONETARIAS E CAMBIAIS DE EMPRESTIMOS CONCEDIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.3.01.00','VARIACOES MONETARIAS DE EMPRESTIMOS CONCEDIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.1.3.02.00','VARIACOES CAMBIAIS DE EMPRESTIMOS CONCEDIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO EMPRESTIMOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.0.00.00','VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.1.00.00','VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.1.01.00','VARIACOES MONETARIAS DE FINANCIAMENTOS CONCEDIDOS ','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.1.02.00','VARIACOES CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS ','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.2.00.00','VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.2.01.00','VARIACOES MONETARIAS DE FINANCIAMENTOS CONCEDIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.2.02.00','VARIACOES CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.3.00.00','VARIACOES MONETARIAS E CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AOS FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.3.01.00','VARIACOES MONETARIAS DE FINANCIAMENTOS CONCEDIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL REFERENTES AO FINANCIAMENTOS CONCEDIDOS. RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.2.3.02.00','VARIACOES CAMBIAIS DE FINANCIAMENTOS CONCEDIDOS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS REFERENTES AO FINANCIAMENTOS CONCEDIDOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.0.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.1.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS - EXTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.1.01.00','OUTRAS VARIACOES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.1.02.00','OUTRAS VARIACOES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.2.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTRA OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.2.01.00','OUTRAS VARIACOES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.2.02.00','OUTRAS VARIACOES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.3.00.00','OUTRAS VARIACOES MONETARIAS E CAMBIAIS - INTER OFSS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL E A VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.3.01.00','OUTRAS VARIACOES MONETARIAS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACOES DA NOSSA PROPRIA MOEDA EM RELACAO AOS INDICES OU COEFICIENTES APLICAVEIS POR DISPOSITIVO LEGAL OU CONTRATUAL , COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.RESSALTE-SE SERA TRATADA COMO VARIACAO MONETARIA APENAS A CORRECAO MONETARIA POS-FIXADA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.3.9.3.02.00','OUTRAS VARIACOES CAMBIAIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE VARIACAO DO VALOR DA NOSSSA MOEDA EM RELACAO AS MOEDAS ESTRANGEIRAS, COM EXCECAO DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.4.0.0.00.00','DESCONTOS FINANCEIROS OBTIDOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.4.0.1.00.00','DESCONTOS FINANCEIROS OBTIDOS - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.4.0.2.00.00','DESCONTOS FINANCEIROS OBTIDOS - INTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.4.0.3.00.00','DESCONTOS FINANCEIROS OBTIDOS - INTER OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE DESCONTOS FINANCEIROS OBTIDOS EM VIRTUDE DE LIQUIDACAO ANTECIPADA DE OBRIGACOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.5.0.0.00.00','REMUNERACAO DE DEPOSITOS BANCARIOS E APLICACOES FINANCEIRAS','COMPREENDE O VALOR TOTAL DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DA REMUNERACAO DO SALDO DIARIO DOS DEPOSITO DA UNIAO EXISTENTES NO BANCO CENTRAL, BEM COMO APLICACAO DE RECURSOS DA CONTA UNICA DE ACORDO COM A RENTABILIDADE MEDIA INTRINSECA DOS TITULOS DO TESOURO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.5.1.0.00.00','REMUNERACAO DE DEPOSITOS BANCARIOS ','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DOS DEPOSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.5.1.1.00.00','REMUNERACAO DE DEPOSITOS BANCARIOS - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DA REMUNERACAO DOS DEPOSITOS BANCARIOS DO ENTE EXISTENTES NO AGENTE FINANCEIRO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.5.2.0.00.00','REMUNERACAO DE APLICACOES FINANCEIRAS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA REMUNERACAO DE DEPOSITOS BANCARIOS, RECURSOS ORIUNDOS DE APLICACOES DE ENTIDADES DA ADMINISTRACAO PUBLICA NO MERCADO FINANCEIRO, AUTORIZADAS POR LEI, EM CADERNETA DE POUPANCA, FUNDO DE INVESTIMENTO, CONTAS REMUNERADAS E OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.5.2.1.00.00','REMUNERACAO DE APLICACOES FINANCEIRAS - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA REMUNERACAO DE DEPOSITOS BANCARIOS, RECURSOS ORIUNDOS DE APLICACOES DE ENTIDADES DA ADMINISTRACAO PUBLICA NO MERCADO FINANCEIRO, AUTORIZADAS POR LEI, EM CADERNETA DE POUPANCA, FUNDO DE INVESTIMENTO, CONTAS REMUNERADAS E OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.9.0.0.00.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.9.0.1.00.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.9.0.2.00.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.4.9.0.3.00.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS - FINANCEIRAS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES FINANCEIRAS NAO COMPREENDIDAS NOS SUBGRUPOS ANTERIORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.0.0.0.00.00','TRANSFERENCIAS RECEBIDAS','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS COM TRANSFERENCIAS INTER GOVERNAMENTAIS, TRANSFERENCIAS INTRAGOVERNAMENTAIS, TRANSFERENCIAS A INSTITUICOES MULTIGOVERNAMENTAIS, TRANSFERENCIAS A INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS, TRANSFERERENCIAS A CONVENIOS E TRANSFERENCIAS AO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.0.00.00','TRANSFERENCIAS INTRA GOVERNAMENTAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.1.00.00','TRANSFERENCIAS INTRA GOVERNAMENTAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. POR EXEMPLO, EMPRESA INDEPENDENTE CONCEDENDO TRANSFERENCIA A UNIAO, ESTADOS, DF, E/OU MUNICIPIOS (A EMPRESA INDEPENDENTE NAO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE INTRA GOVERNAMENTAL).','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.00.00','TRANSFERENCIAS INTRA GOVERNAMENTAIS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS RELATIVAS A EXECUCAO ORCAMENTARIA, E DE BENS E VALORES, REFERENTES AS TRANSACOES INTRA GOVERNAMENTAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.00','TRANSFERENCIAS RECEBIDAS - COM EXECUCAO ORCAMENTARIA','COMPREENDE O VALOR DAS TRANSFERENCIAS FINANCEIRAS RECEBIDAS E CORRESPONDENCIA DE DEBITOS EM VIRTUDE DA EXECUCAO ORCAMENTARIA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.01','COTA RECEBIDA ',' REGISTRA O VALOR DOS RECURSOS RECEBIDOS PELA ADMINISTRACAO DIRETA DECORRENTES DA PROGRAMACAO FINANCEIRA CORRESPONDENTE AO ORCAMENTO ANUAL.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.02','REPASSE RECEBIDO ','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.03','SUB-REPASSE RECEBIDO',' REGISTRA O VALOR DOS SUB-REPASSES RECEBIDOS NO EXERCICIO, DECORRENTES DE TRANSFERENCIAS ENTRE UG´S DO MESMO ORGAO, CORRESPONDENTE AO ORCAMENTO ANUAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.04','RECURSOS ARRECADADOS - RECEBIDOS ','  REGISTRA O VALOR RECEBIDO DE OUTRA UG REFERENTE AO RECURSOS QUE FORAM ARRECADADOS (CLASSIFICADOS COMO RECEITA) PARA PAGAMENTO DE DESPESAS NA UG RECEBEDORA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.05','VALORES DIFERIDOS - BAIXA - COTA DIFERIDA ','  REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO E BAIXA DOS RECURSOS DIFERIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.06','VALORES DIFERIDOS - BAIXA - REPASSE DIFERIDO ',' REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO/BAIXA DE RECURSOS DIFERIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.07','VALORES DIFERIDOS - BAIXA - SUB-REPASSE DIFERIDO ','  REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.08','VALORES DIFERIDOS - INSCRICAO - COTA DIFERIDA - INSCRICAO ','  REGISTRA O VALOR DA COTA DIFERIDA NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.09','VALORES DIFERIDOS - INSCRICAO - REPASSE DIFERIDO - INSCRICAO ','  REGISTRA O VALOR DOS RECURSOS DE REPASSE DIFERIDO DECORRENTES DO PROCESSO DE INSCRICAO DE RECURSOS DIFERIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.10','VALORES DIFERIDOS - INSCRICAO - SUB-REPASSE DIFERIDO - INSCRICAO ','  REGISTRA A APROPRIACAO DO VALOR REFERENTE AO SUB-REPASSE CONCEDIDO ENTRE AS UGS DA ADMINISTRACAO DIRETA OU INDIRETA POR OCASIAO DA INSCRICAO DOS VALORES DIRERIDOS  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.11','CORRESPONDENCIA DE DEBITO -DESINCORPORACAO DE VARIACAO PATRIMONIAL AUMENTATIVA','  REGISTRA A APROPRIACAO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS DESINCORPORADAS PARA TRANSFERENCIA A OUTRA UG DE MESMA GESTAO, PARA APURACAO DE CUSTO E RESULTADO DE GESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.12','CORRESPONDENCIA DE DEBITO -INCORPORACAO DE VARIACAO PATRIMONIAL DIMINUTIVA','  REGISTRA A APROPRIACAO DA INCORPORACAO DE VARIACOES PATRIMONIAIS DIMINUTIVAS TRANSFERIDAS DE OUTRA UG DA MESMA GESTAO PARA APURACAO DE CUSTO E RESULTADO DE GESTAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.13','CORRESPONDENCIA DE DEBITO -CORRESPONDENCIA DE DEBITOS - SALDOS FINANC.','  REGISTRA A APROPRIACAO DA TRANSFERENCIA DE DEBITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS COM SALDOS FINANCEIROS EM ROTINAS CONTABEIS ORCAMENTARIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.14','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE P/ COBERTURA DE INSUFICIENCIAS FINANCEIRAS',' REGISTRA OS RECURSOS ORCAMENTARIOS EFETIVAMENTE UTILIZADOS PARA COBERTURA DE INSUFICIENCIAS FINANCEIRAS ENTRE AS RECEITAS E DESPESAS PREVIDENCIARIAS, NO EXERCICIO DE REFERENCIA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.15','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - REPASSE PREVIDENCIARIO P/ FORMACAO DE RESERVA ',' REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE PARA FORMACAO DE RESERVA ESPONTANEA PARA FUTUROS PAGAMENTOS DE BENEFICIOS DO PLANO FINANCEIRO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.16','APORTE DE RECURSOS PARA O RPPS - PLANO FINANCEIRO - OUTROS APORTES PARA O RPPS ','  REGISTRA O SOMATORIO DOS RECEBIMENTOS DE EVENTUAIS APORTES DE RECURSOS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR - RPPS, PARA OUTRAS NECESSIDADES FINANCEIRAS QUE NAO A COBERTURA DE INSUFICIENCIAS FINANCEIRAS E FORMACAO DE RESERVA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.17','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - REPASSE PARA COBERTURA DE DEFICIT FINANCEIRO ',' REGISTRA O MONTANTE DOS RECURSOS RECEBIDOS DO PROPRIO ENTE, NECESSARIOS AO EQUILIBRIO FINANCEIRO DO PLANO PREVIDENCIARIO, OU SEJA, AA COBERTURA DE DEFICIT ENTRE AS RECEITAS E AS DESPESAS PREVIDENCIARIAS, REFERENTES AO EXERCICIO ATUAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.18','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - REPASSE PARA COBERTURA DE DEFICIT ATUARIAL ',' REGISTRA O MONTANTE DOS RECURSOS ORCAMENTARIOS ALOCADOS P/ COBERTURA DE DEFICIT ATUARIAL NO EXERCICIO DE REFERENCIA, CUJO OBJETIVO E GARANTIR A EQUIVALENCIA, A VALOR PRESENTE, ENTRE O FLUXO DE RECEITAS ESTIMADAS E DAS OBRIGACOES PROJETADAS, APURADAS ATUARIALMENTE, EM LONGO PRAZO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.01.19','APORTE DE RECURSOS PARA O RPPS - PLANO PREVIDENCIARIO - OUTROS APORTES PARA O RPPS ',' REGISTRA OUTROS APORTES FINANCEIROS PARA O REGIME PROPRIO DE PREVIDENCIA DO SERVIDOR PUBLICO - RPPS, TAIS COMO CAPITALIZACOES DO REGIME. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.00','TRANSFERENCIAS RECEBIDAS - INDEPENDENTE DE EXECUCAO ORCAMENTARIA','COMPREENDE AS TRANSFERENCIAS FINANCEIRAS PARA RESTOS A PAGAR E OUTROS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.01','ORDEM TRANSFERENCIAS RECEBIDAS ',' REGISTRA O VALOR DA TRANSFERENCIA DE OTR`S LIBERADAS PELAS SETORIAIS DE PROGRAMACAO FINANCEIRA DE CADA ORGAO PARA SUAS SUBORDINADAS, NAO VINCULADAS AO ORCAMENTO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.02','RECEBIMENTO DE TRANSFERENCIAS CONCEDIDAS',' REGISTRA O VALOR DOS RECEBIMENTOS REFERENTES A RESTOS A PAGAR, QUE FORAM DEVOLVIDOS PELAS UG BENEFICIARIAS, QUE NAO FORAM UTILIZADOS OU UTILIZADOS PARCIALMENTE, SEM O RESTABELECIMENTO DA OBRIGACAO CORRESPONDENTE AO LIMITE DE RP .','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.03',' REGISTRO DE RESTITUICAO DE RECEITA S FEDERAIS',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE PERMITE IDENTIFICAR OS REGISTROS DE RESTITUICAO DE RECEITAS FEDERAIS EFETIVADOS PELAS DELEGACIAS DA RECEITA FEDERAL.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.04',' CLASSIFICACAO DA RESTITUICAO DE RECEITAS FEDERAIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE PERMITE IDENTIFICAR A CLASSIFICACAO DE RESTITUICAO DE RECEITAS, REFERENTE A FITA DE ARRECADACAO DECENDIAL DE RECEITA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.05','TRANSF RECEBIDA P/ PAGTO RESTITUICOES RECEITAS FEDERAIS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVAS A RECEBIMENTO DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS PELAS UNIDADES GESTORAS DA SECRETARIA DA RECEITA FEDERAL  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.06','RESTITUICOES DE RECEITAS FEDERAIS ',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVAS PROVENIENTES DE RECEBIMENTOS DE RECURSOS EXTRA-ORCAMENTARIOS PARA RESTITUICOES DE RECEITAS FEDERAIS PELAS UNIDADES GESTORAS RESPONSAVEIS PELO RECOLHIMENTO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.07','TRANSFERENCIAS RECEBIDAS ARREC/TERC. INSS ',' REGISTRA O VALOR REFERENTE AS TRANSFERENCIAS RECEBIDAS PELO INSS REFERENTES AS ARRECADACOES DE RECEITAS PROPRIAS E VALORES DE TERCEIROS POR MEIO DE GPS REDE BANCARIA E INTRA-SIAFI. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.08','TRANSF.RECEBIDA RECURSOS PREVIDENC.ARRECADADOS ',' REGISTRA O VALOR REFERENTE AOS RECURSOS PREVIDENCIARIOS ARRECADADOS PELO INSS POR MEIO DAS GPS ELETRONICA E DA REDE BANCARIA, CENTRALIZADOS NO TESOURO NACIONAL, SUBCONTA DA CONTA UNICA INSS, PARA POSTERIOR REPASSE POR MEIO DE PROGRAMACAO FINANCEIRA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.09','TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO - NO EXERCICIO ','  REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS NO EXERCICIO CORRENTE.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.10','TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO - INSCRICAO DIFERIDO','  REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS REFERENTE A INSCRICAO DE RECURSOS DIFERIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.11','TRANSFERENCIAS RECEBIDAS ENTRE UG/ORGAO -BAIXA DE DIFERIDO ','  REGISTRA A TRANSFERENCIA DE RECURSOS ENTRE UG DE MESMO ORGAO OU DE ORGAOS DIFERENTES QUE NAO ESTEJA RELACIONADA A EXECUCAO ORCAMENTARIA RECEBIDAS REFERENTE A BAIXA DA INSCRICAO DOS RECURSOS DIFERIDOS PELO PROCESSO DE ENCERRAMENTO DO EXERCICIO  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.12','MOVIMENTO DE FUNDOS A DEBITO - CORRESPONDENCIA DE DEBITOS - SALDOS NAO FIN.','  REGISTRA A APROPRIACAO DA TRANSFERENCIA DE DEBITOS INTERNOS ENTRE UG DE MESMA GESTAO REFERENTES A CONTAS DE SALDOS NAO FINANCEIROS.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.13','MOVIMENTO DE FUNDOS A DEBITO - CORRESPONDENCIA DE DEBITOS - SALDOS FINANC.','  REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE ORGAOS CORREPONDENTES A SALDOS FINANCEIROS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.14','MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - INCORP/DESINCORP. DE SALDOS NAO FINANCEIROS','  REGISTRA O VALOR DE SALDOS PATRIMONIAIS DEVEDORES INCORPORADOS E CREDORES DESINCORPORADOS POR INTEGRACAO,TRANSFERENCIA,FUSAO,CISAO OU MUDANCA DA MODALIDADE USO PARCIAL PARA TOTAL DE ORGAO OU UNIDADE GESTORA ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.15','MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - INCORP./DESINCORP. SALDO FINANC./DISP./LIMITE','  REGISTRA O VALOR DOS SALDOS FINANCEIROS DEVEDORES INCORPORADOS, E CREDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DA MODALIDADE DE USO PARCIAL PARA TOTAL, RELATIVOS AO DISPONIVEL E AO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.16','MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - INCORP./DESINCORP. DEMAIS SALDOS FINANCEIROS','  REGISTRA O VALOR DE SALDOS FINANCEIROS DEVEDORES INCORPORADOS, E CREDORES DESINCORPORADOS, POR INTEGRACAO, TRANSFERENCIA, FUSAO, CISAO OU MUDANCA DA MODALIDADE DE USO PARCIAL PARA TOTAL, COM EXCECAO OS DO DISPONIVEL E OS DO LIMITE DE PESSOAL, DE ORGAO OU UNIDADE GESTORA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.17','MOVIMENTO DE FUNDOS A DEBITO - PROPRIOS - APURACAO RESULTADO INC/DESINC. SALDO FINANC.','  REGISTRA A APURACAO DO RESULTADO FINANCEIRO, QUANDO DEVEDOR, PELO INCORPORACAO DE SALDOS CREDORES OU DESINCORPORACAO DE SALDOS DEVEDORES, EM FUNCAO DA TRANSFERENCIA, INTEGRACAO, FUSAO E CISAO DE SALDOS CONTABEIS  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.18','OUTROS MOVIMENTOS DE FUNDOS A DEBITO-S.FIN.','  REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES FINANCEIROS COM SALDO DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A DEDITO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.19','OUTROS MOVIMENTOS DE FUNDOS A DEBITO-S.PATR.','  REGISTRA O VALOR DA TRANSFERENCIA DE AJUSTES PATRIMONIAIS COM SALDO  DEVEDOR OU CREDOR ENTRE UG DE EMPRESAS INTEGRANTES DO SIAFI E OUTROS MOVIMENTOS A DEBITO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.20','TRANSFERENCIAS RECEBIDAS DE BENS IMOVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES DO MESMO ORGAO .','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.21','DOACOES RECEBIDAS DE BENS IMOVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES ENTRE UG DE ORGAOS DIFERENTES','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.22','TRANFERENCIAS RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO PAIS',' REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO PAIS POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.23','TRANFERENCIAS RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO EXTERIOR',' REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO EXTERIOR POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DO MESMO ORGAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.24','DOACOES RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO PAIS',' REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO PAIS POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.25','DOACOES RECEBIDAS DE BENS MOVEIS DE UNIDADE LOCALIZADA NO EXTERIOR',' REGISTRA O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO EXTERIOR POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.26','TRANSFERENCIAS RECEBIDAS DE TITULOS E VALORES ',' REGISTRA O TOTAL DOS TITULOS E VALORES EM CIRCULACAO RECEBIDOS POR UNIDADE DECORRENTE DE TRANSFERENCIA DE OUTRA UNIDADE DE MESMA GESTAO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.1.0.2.02.27','TRANSFERENCIAS RECEBIDAS DE TITULOS DA DIVIDA ATIVA','REGISTRA O RECEBIMENTO DE TITULOS DA DIVIDA ATIVA DE UMA UG PARA A PGFN OU ORGAO EQUIVALENTE.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.0.00.00','TRANSFERENCIAS INTER GOVERNAMENTAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DA UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.1.00.00','TRANSFERENCIAS INTER GOVERNAMENTAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. POR EXEMPLO, EMPRESA INDEPENDENTE DE UM ENTE RECEBENDO TRANSFERENCIA DE OUTRO ENTE.(A EMPRESA INDEPENDENTE NAO PERTENCE AO OFSS MAS PERTENCE AO CONCEITO DE GOVERNAMENTAL).','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.00.00','TRANSFERENCIAS INTER GOVERNAMENTAIS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS A UNIAO, ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/OU VALORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.01.00','TRANSFERENCIAS DA UNIAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DA UNIAO AOS ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.01.01','TRANSFERENCIAS DA UNIAO E ENTIDADES PARA CONVENIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DA UNIAO E SUAS ENTIDADES PARA CONVENIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.01.99','OUTRAS TRANSFERENCIAS DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DA UNIAO AOS ESTADOS, DISTRITO FEDERAL, MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.02.00','TRANSFERENCIAS DOS ESTADOS E DO DF','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO E AOS MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.02.01','TRANSFERENCIA DOS ESTADOS, DF E SUAS ENTIDADES PARA CONVENIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DOS ESTADOS, DISTRITO FEDERAL E SUAS ENTIDADES PARA CONVENIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.02.99','OUTRAS TRANSFERENCIAS DOS ESTADOS E DF','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DOS ESTADOS E DISTRITO FEDERAL A UNIAO E AOS MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.03.00','TRANSFERENCIAS DOS MUNICIPIOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DOS MUNCICIPIOS A UNIAO, ESTADOS E DISTRITO FEDERAL, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.03.01','TRANSFERENCIA DOS MUNICIPIOS E SUAS ENTIDADES PARA CONVENIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DOS MUNICIPIOS E SUAS ENTIDADES PARA CONVENIOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.2.0.3.03.99','OUTRAS TRANSFERENCIAS DOS MUNICIPIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DOS MUNICIPIOS, INCLUSIVE AS ENTIDADES VINCULADAS, DE BENS E/ OU VALORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.0.0.00.00','TRANSFERENCIAS DAS INSTITUICOES PRIVADAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INSTITUICOES PRIVADAS, INCLUSIVE DE BENS E VALORES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.1.0.00.00','TRANSFERENCIAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES. EXEMPLO: ONGS,OSCIPS E OS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.1.1.00.00','TRANSFERENCIAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS SEM FINS LUCRATIVOS, INCLUSIVE DE BENS E VALORES. EXEMPLO: ONGS,OSCIPS E OS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.1.1.01.00','TRANSFERENCIA DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA CONVENIOS',' REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVENIOS FIRMADOS, COM OU SEM CONTRAPRESTACOES DE SERVICOS, COM INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS, PARA PARA REALIZACAO DE OBJETIVOS DE INTERESSE COMUM DOS PARTICIPES DESTINADOS A CUSTEAR VARIACOES PATRIMONIAIS DIMINUTIVAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.1.1.02.00','TRANSFERENCIA DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','REGISTRA O VALOR TOTAL DOS RECURSOS RECEBIDOS ATRAVES DE TRANSFERENCIAS DE INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS PARA O FUNDO DE COMBATE E ERRADICACAO DA POBREZA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.1.1.99.00','OUTRAS TRANSFERENCIAS DAS INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','REGISTRA OUTRAS TRANSFERENCIAS DE INSTITUICOES PRIVADAS SEM FINS LUCRATIVOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.2.0.00.00','TRANSFERENCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS COM FINS LUCRATIVAS, INCLUSIVE DE BENS E VALORES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.2.1.00.00','TRANSFERENCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS FINANCEIRAS DAS INTITUICOES PRIVADAS COM FINS LUCRATIVAS, INCLUSIVE DE BENS E VALORES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.2.1.01.00','TRANSFERENCIA DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS PARA CONVENIOS',' REGISTRA O VALOR TOTAL DOS RECURSOS ORIUNDOS DE CONVENIOS FIRMADOS, COM OU SEM CONTRAPRESTACOES DE SERVICOS, COM INSTITUICOES PRIVADAS COM FINS LUCRATIVOS, PARA PARA REALIZACAO DE OBJETIVOS DE INTERESSE COMUM DOS PARTICIPES DESTINADOS A CUSTEAR VARIACOES PATRIMONIAIS DIMINUTIVAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.2.1.02.00','TRANSFERENCIA DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS PARA COMBATE A FOME','REGISTRA O VALOR TOTAL DOS RECURSOS RECEBIDOS ATRAVES DE TRANSFERENCIAS DE INSTITUICOES PRIVADAS COM FINS LUCRATIVOS PARA O FUNDO DE COMBATE E ERRADICACAO DA POBREZA.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.3.2.1.99.00','OUTRAS TRANSFERENCIAS DAS INSTITUICOES PRIVADAS COM FINS LUCRATIVOS','REGISTRA OUTRAS TRANSFERENCIAS DE INSTITUICOES PRIVADAS COM FINS LUCRATIVOS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.4.0.0.00.00','TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.4.0.1.00.00','TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.4.0.3.00.00','TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DAS INSTITUICOES MULTIGOVERNAMENTAIS, DO QUAL O ENTE TRANSFERIDOR NAO PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.5.0.0.00.00','TRANSFERENCIAS DE CONSORCIOS PUBLICOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.5.0.1.00.00','TRANSFERENCIAS DE CONSORCIOS PUBLICOS - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.5.0.2.00.00','TRANSFERENCIAS DE CONSORCIOS PUBLICOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.5.0.3.00.00','TRANSFERENCIAS DE CONSORCIOS PUBLICOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE CONSORCIOS PUBLICOS, DO QUAL O ENTE TRANSFERIDOR PARTICIPE. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.6.0.0.00.00','TRANSFERENCIAS DO EXTERIOR','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DE ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.6.0.1.00.00','TRANSFERENCIAS DO EXTERIOR - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE TRANSFERENCIAS DE ORGANISMOS E FUNDOS INTERNACIONAIS, DE GOVERNOS ESTRANGEIROS E INSTITUICOES PRIVADAS COM OU SEM FINS LUCRATIVOS NO EXTERIOR. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.6.0.1.01.00','TRANSFERENCIA DO EXTERIOR PARA O COMBATE A FOME','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE VALORES RECEBIDOS DO EXTERIOR PARA O FUNDO DE COMBATE A FOME.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.6.0.1.99.00','OUTRAS TRANSFERENCIAS DO EXTERIOR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DE VALORES RECEBIDOS DO EXTERIOR','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.7.0.0.00.00','TRANSFERENCIAS DE PESSOAS FISICAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUICOES E DOACOES A GOVERNOS E ENTIDADES DA ADMINISTRACAO DESCENTRALIZADA REALIZADAS POR PESSOAS FISICAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.7.0.1.00.00','TRANSFERENCIAS DE PESSOAS FISICAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE CONTRIBUICOES E DOACOES A GOVERNOS E ENTIDADES DA ADMINISTRACAO DESCENTRALIZADA REALIZADAS POR PESSOAS FISICAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.7.0.1.01.00','TRANSFERENCIA DE PESSOAS FISICAS PARA COMBATE A FOME','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DAS TRANSFERENCIAS DE VALORES RECEBIDOS DE PESSOAS FISICAS PARA O FUNDO DE COMBATE A FOME.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.5.7.0.1.99.00','OUTRAS TRANSFERENCIA DE PESSOAS FISICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE OUTRAS TRANSFERENCIAS DE VALORES RECEBIDOS DE PESSOAS FISICAS','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.0.0.0.00.00','VALORIZACAO E GANHOS COM ATIVOS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM REAVALIACAO E GANHOS DE ATIVOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.0.0.00.00','REAVALIACAO DE ATIVOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.1.0.00.00','REAVALIACAO DE IMOBILIZADO','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.1.1.00.00','REAVALIACAO DE IMOBILIZADO - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA BENS DO ATIVO IMOBILIZADO, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.2.0.00.00','REAVALIACAO DE INTANGIVEIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.2.1.00.00','REAVALIACAO DE INTANGIVEIS -EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA ATIVOS INTANGIVEIS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.9.0.00.00','REAVALIACAO DE OUTROS ATIVOS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.1.9.1.00.00','REAVALIACAO DE OUTROS ATIVOS - EXTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA RELATIVA A ADOCAO DO VALOR DE MERCADO OU DE CONSENSO ENTRE AS PARTES PARA OUTROS ATIVOS, QUANDO ESSE FOR SUPERIOR AO VALOR LIQUIDO CONTABIL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.0.0.00.00','GANHOS COM ALIENACAO','COMPREENDE O GANHO COM ALIENACAO DE ATIVOS, OU SEJA, QUANDO O VALOR ALIENADO DO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.1.0.00.00','GANHOS COM ALIENACAO DE INVESTIMENTOS','COMPREENDE O GANHO COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.1.1.00.00','GANHOS COM ALIENACAO DE INVESTIMENTOS - EXTRA OFSS','REGISTRA O GANHO COM ALIENACAO DE INVESTIMENTOS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.2.0.00.00','GANHOS COM ALIENACAO DE IMOBILIZADO','COMPREENDE O GANHO COM ALIENACAO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.2.1.00.00','GANHOS COM ALIENACAO DE IMOBILIZADO - EXTRA OFSS','REGISTRA O GANHO COM ALIENACAO DE ATIVO IMOBILIZADO, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.3.0.00.00','GANHOS COM ALIENACAO DE INTANGIVEIS','COMPREENDE O GANHO COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.2.3.1.00.00','GANHOS COM ALIENACAO DE INTANGIVEIS - EXTRA OFSS','REGISTRA O GANHO COM ALIENACAO DE ATIVOS INTANGIVEIS, OU SEJA, QUANDO O VALOR ALIENADO DO REFERIDO ATIVO E MAIOR QUE O SEU VALOR CONTABIL, DE MANEIRA QUE A DIFERENCA COMPREENDE O GANHO. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.0.0.00.00','GANHOS COM INCORPORACAO DE ATIVOS','COMPREENDE A CONTRAPARTIDA DA INCORPORACAO DE NOVOS ATIVOS DESCOBERTOS, A CONTRAPARTIDA DA INCORPORACAO DE ATIVOS SEMOVENTES NASCIDOS, POR EXEMPLO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.1.0.00.00','GANHOS COM INCORPORACAO DE ATIVOS POR DESCOBERTAS','COMPREENDE OS GANHOS COM A INCORPORACAO DE NOVOS ATIVOS DESCOBERTOS, COMO POR EXEMPLO, DESCOBERTA DE JAZIDAS DE RECURSOS NATURAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.1.1.00.00','GANHOS COM INCORPORACAO DE ATIVOS POR DESCOBERTAS - EXTRA OFSS','REGISTRA OS GANHOS COM A INCORPORACAO DE NOVOS ATIVOS DESCOBERTOS, COMO POR EXEMPLO, DESCOBERTA DE JAZIDAS DE RECURSOS NATURAIS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.2.0.00.00','GANHOS COM INCORPORACAO DE ATIVOS POR NASCIMENTOS','COMPREENDE OS GANHOS COM A INCORPORACAO DE SEMOVENTES NASCIDOS, COMO POR EXEMPLO, NASCIMENTO DE BOVINOS E AVES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.2.1.00.00','GANHOS COM INCORPORACAO DE ATIVOS POR NASCIMENTOS - EXTRA OFSS','REGISTRA OS GANHOS COM A INCORPORACAO DE SEMOVENTES NASCIDOS, COMO POR EXEMPLO, NASCIMENTO DE BOVINOS E AVES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.3.0.00.00','GANHOS COM INCORPORACAO DE VALORES APREENDIDOS','COMPREENDE OS GANHOS COM A INCORPORACAO DE VALORES APREENDIDOS, COMO POR EXEMPLO, OS VALORES APREENDIDOS ASSOCIADOS AO TRAFICO ILICITO DE ENTORPENCENTES E DROGAS AFINS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.6.3.3.1.00.00','GANHOS COM INCORPORACAO DE VALORES APREENDIDOS - EXTRA OFSS','REGISTRA OS GANHOS COM A INCORPORACAO DE VALORES APREENDIDOS, COMO POR EXEMPLO, OS VALORES APREENDIDOS ASSOCIADOS AO TRAFICO ILICITO DE ENTORPENCENTES E DROGAS AFINS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.0.0.0.00.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS','COMPREENDE O SOMATORIO DAS DEMAIS VARIACOES PATRIMONIAIS AUMENTATIVAS NAO INCLUIDAS NOS GRUPOS ANTERIORES,TAIS COMO: RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, DIVIDENDOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.0.00.00','VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.1.00.00','VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - EXTRA OFSS','COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO.ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.1.01.00','VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.1.99.00','(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVA DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.2.00.00','VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - INTRA OFSS','COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.2.01.00','VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.2.99.00','(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.3.00.00','VARIACAO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - INTER OFSS','COMPREENDE OS RECURSOS REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVA RECEBIDAS E NAO CLASSIFICADAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.3.01.00','VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.1.0.3.99.00','(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS','D','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.0.0.00.00',' RESULTADO POSITIVO DE PARTICIPACOES ','COMPREENDE O RESULTADO POSITIVO DAS PARTICIPACOES DE CARATER PERMANENTE NO CAPITAL SOCIAL DE SOCIEDADES INVESTIDAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.1.0.00.00',' RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL','COMPREENDE A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.1.1.00.00',' RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - EXTRA OFSS','REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.1.2.00.00',' RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTRA OFSS','REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.1.3.00.00',' RESULTADO POSITIVO DE EQUIVALENCIA PATRIMONIAL - INTER OFSS','REGISTRA A APROPRIACAO DO RESULTADO POSITIVO DA EQUIVALENCIA PATRIMONIAL, ORIUNDO DE LUCROS APURADOS NAS EMPRESAS CONTROLADAS E COLIGADAS, DENTRE OUTROS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.2.0.00.00',' DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','COMPREENDE AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.2.1.00.00',' DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - EXTRA OFSS','REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.2.2.00.00',' DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - INTRA OFSS','REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.2.2.3.00.00',' DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - INTER OFSS','REGISTRA AS VARIACOES AUMENTATIVAS ORIUNDAS DE LUCROS APURADOS EM OUTROS INVESTIMENTOS NAO AVALIADOS PELO METODO DA EQUIVALENCIA PATRIMONIAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.0.00.00','VARIACOES PATRIMONIAIS AUMENTATIVAS DE INSTITUICOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.00.00','VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.00','VPA COM OPERACOES DE AUTORIDADE MONETARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.01','VPA COM OPERACOES COM TITULOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS . ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.02','VPA COM OPERACOES NA AREA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.03','VPA COM OPERACOES NA AREA BANCARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.04','VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.05','TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.01.99','VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.00','VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.01','VPA DE OPERACOES DE CREDITOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.02','VPA COM RESULTADO DE CAMBIO',' REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.03','RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.04','RENDAS DE TITULOS E VALORES MOBILIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.05','RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.06','RENDAS DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.07','RENDAS DE PARTICIPACOES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.02.99','OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.1.03.00','VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.00.00','VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.00','VPA COM OPERACOES DE AUTORIDADE MONETARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.01','VPA COM OPERACOES COM TITULOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS . ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.02','VPA COM OPERACOES NA AREA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.03','VPA COM OPERACOES NA AREA BANCARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.04','VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.05','TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.01.99','VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.00','VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.01','VPA DE OPERACOES DE CREDITOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.02','VPA COM RESULTADO DE CAMBIO',' REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.03','RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.04','RENDAS DE TITULOS E VALORES MOBILIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.05','RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.06','RENDAS DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.07','RENDAS DE PARTICIPACOES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.02.99','OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.2.05.00','VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.00.00','VARIACAO PATRIMONIAL AUMENTATIVA DE INSTITUICOES FINANCEIRAS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS APURADAS PELAS INSTITUICOES FINANCEIRAS, VINCULADAS OU NAO AO SEU OBJETO PRINCIPAL. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.00','VPA COM OPERACOES DE AUTORIDADE MONETARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DE AUTORIDADE MONETARIA .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.01','VPA COM OPERACOES COM TITULOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES DA AUTORIDADE MONETARIA COM TITULOS . ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.02','VPA COM OPERACOES NA AREA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA EXTERNA REALIZADAS PELA AUTORIDADE MONETARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.03','VPA COM OPERACOES NA AREA BANCARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES NA AREA BANCARIA REALIZADAS PELA AUTORIDADE MONETARIA','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.04','VPA COM REMUNERACAO SOBRE DEP.A ORDEM DO GOV.FEDERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS A TITULO DE REMUNERACAO SOBRE DEPOSITOS A ORDEM DO GOVERNO FEDERAL EFETUADOS PELA AUTORIDADE MONETARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.05','TITULOS/VALORES OPERACOES C/DERIVATIVOS(SWAP) -RENDAS DE OPERACOES COM DERIVATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OPERACOES COM DERIVATIVOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.01.99','VPA COM OUTRAS OPERACOES DE AUTORIDADE MONETARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS OPERACOES DE NATUREZA EVENTUAL REALIZADAS PELA AUTORIDADE MONETARIA.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.00','VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TRANSACOES REALIZADAS NO PERIODO, VINCULADAS AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.01','VPA DE OPERACOES DE CREDITOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE OPERACOES DE CREDITO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.02','VPA COM RESULTADO DE CAMBIO',' REGISTRA OS VALORES RELATIVOS A DIFERENCAS POSITIVAS DE CAMBIO DECORRENTES DE DEPOSITOS BANCARIOS OU DE TRANSFERENCIA DE RESULTADOS FINANCEIROS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.03','RENDAS DE APLIC. INTERFINANCEIRA DE LIQUIDEZ','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE APLICACAO INTERFINANCEIRA DE LIQUIDEZ. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.04','RENDAS DE TITULOS E VALORES MOBILIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.05','RESULT. DE TRANSACOES C/TIT.E VAL.MOBILIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RESULTADO POSITIVO DE TRANSACOES COM TITULOS E VALORES MOBILIARIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.06','RENDAS DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PRESTACAO DE SERVICOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.07','RENDAS DE PARTICIPACOES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES OPERACIONAIS ,DAS INSTITUICOES FINANCEIRAS, A TITULO DE RENDAS DE PARTICIPACOES SOCIETARIAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.02.99','OUTRAS VPA OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS DE NATUREZA EVENTUAL VINCULADAS DIRETAMENTE AO OBJETO PRINCIPAL DAS INSTITUICOES FINANCEIRAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.3.0.3.03.00','VPA NAO OPERACIONAIS DE INSTITUICOES FINANCEIRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES COM TRANSACOES REALIZADAS NO PERIODO,NAO VINCULADAS A EXPLORACAO DO OBJETO DAS INSTITUICOES FINANCEIRAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.0.0.00.00',' DIVERSAS VARIACOES PATRIMONIAIS AUMENTATIVAS','COMPREENDE OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS NAO CLASSIFICADAS EM ITENS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.1.0.00.00','COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.1.2.00.00','COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.1.3.00.00','COMPENSACAO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA ENTRE O REGIME GERAL DE PREVIDENCIA SOCIAL E OS REGIMES PROPRIOS DE PREVIDENCIA SOCIAL DOS SERVIDORES DA UNIAO, DOS ESTADOS, DO DISTRITO FEDERAL E DOS MUNICIPIOS NA HIPOTESE DE CONTAGEM RECIPROCA DE TEMPO DE CONTRIBUICAO (NAO CONCOMITANTE). COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.2.0.00.00','VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.2.1.00.00','VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.2.2.00.00','VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.2.3.00.00','VARIACAO PATRIMONIAL AUMENTATIVA COM BONIFICACOES - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE BONIFICACOES RECEBIDAS NAS AQUISICOES DE MERCADORIAS COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.3.0.00.00','AMORTIZACAO DE DESAGIO EM INVESTIMENTOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.3.1.00.00','AMORTIZACAO DE DESAGIO EM INVESTIMENTOS -EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.3.2.00.00','AMORTIZACAO DE DESAGIO EM INVESTIMENTOS - INTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.3.3.00.00','AMORTIZACAO DE DESAGIO EM INVESTIMENTOS - INTER OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE AMORTIZACAO DE DESAGIO EM INVESTIMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.0.00.00','MULTAS ADMINISTRATIVAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTANDO O RESULTADO DAS APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) E NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.00.00','MULTAS ADMINISTRATIVAS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS A INDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO. REPRESENTANDO O RESULTADO DAS APLICACOES IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) E NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.01.00','MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.02.00','MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.03.00','MULTA DE POLUICAO DE AGUAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.04.00','MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.05.00','MULTAS PREVISTAS NA LEI DO SERVICO MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOS PARA PRESTAR SERVICO MILITAR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.06.00','MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.07.00','MULTAS PREVISTAS NA LEGISL. SANITARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.08.00','MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.09.00','MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.10.00','MULTAS POR INFRACAO A LEGIS. TRABALHISTA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGA-DO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.11.00','MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.12.00','MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.13.00','MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.13.01','MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.13.02','MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.14.00','MULTAS E JUROS PREVISTOS EM CONTRATOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.15.00','MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.16.00','MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSOES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.17.00','MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.18.00','MULTA DE TARIFA PEDAGIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.19.00','MULTA DECOR.DE SENT.PENAL CONDENATORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.20.00','MULTA DE QUEBRA DE FIANCA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.21.00','MULTAS POR DANOS AO MEIO AMBIENTE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.22.00','MULTA E DE SEGURANCA PRIVADA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.23.00','MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.24.00','MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.25.00','MUL.APLIC.PELOS TRIBUNAIS DE CONTAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.26.00','MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.27.00','MULTAS POR AUTOS DE INFRACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.28.00','MULTAS PREVISTAS NA LEGISLACAO MINERARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.29.00','MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP','  REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE  TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.30.00','MULTAS/INDENIZACOES - EXPLORACAO DO PATRIMONIO GENETICO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTE DE MULTAS E INDENIZACOES PELA EXPLORACAO DO PATRIMONIO GENETICO.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.30.01','MULTAS/INDENIZACOES - EXPLORACAO DO PATRIMONIO GENETICO - AREA DE DOMINIO DA UNIAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE MULTAS E INDENIZACOES PELA EXPLORACAO DO PATRIMONIO GENETICO EM AREAS DE DOMINIO DA UNIAO.(PORTARIA SOF Nº 132, DE 08/10/10) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.30.02','MULTAS/INDENIZACOES - EXPLORACAO DO PATRIMONIO GENETICO - MAR TERRITORIAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE MULTAS E INDENIZACOES PELA EXPLORACAO DO PATRIMONIO GENETICO NO MAR TERRITORIAL, ZONA ECONOMICA EXCLUSIVA OU PLATAFORMA CONTINENTAL.(PORTARIA SOF Nº 132, DE 08/10/10)  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.1.99.00','OUTRAS MULTAS ADMINISTRATIVAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.00.00','MULTAS ADMINISTRATIVAS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS AINDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO REPRESENTANDO ORESULTADO DA APLICACOS IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.01.00','MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.02.00','MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.03.00','MULTA DE POLUICAO DE AGUAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.04.00','MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.05.00','MULTAS PREVISTAS NA LEI DO SERVICO MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOS PARA PRESTAR SERVICO MILITAR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.06.00','MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.07.00','MULTAS PREVISTAS NA LEGISL. SANITARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.08.00','MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.09.00','MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.10.00','MULTAS POR INFRACAO A LEGIS. TRABALHISTA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGA-DO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.11.00','MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.12.00','MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.13.00','MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.13.01','MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.13.02','MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.14.00','MULTAS E JUROS PREVISTOS EM CONTRATOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.15.00','MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.16.00','MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSOES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.17.00','MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.18.00','MULTA DE TARIFA PEDAGIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.19.00','MULTA DECOR.DE SENT.PENAL CONDENATORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.20.00','MULTA DE QUEBRA DE FIANCA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.21.00','MULTAS POR DANOS AO MEIO AMBIENTE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.22.00','MULTA E DE SEGURANCA PRIVADA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.23.00','MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.24.00','MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.25.00','MUL.APLIC.PELOS TRIBUNAIS DE CONTAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.26.00','MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.27.00','MULTAS POR AUTOS DE INFRACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.28.00','MULTAS PREVISTAS NA LEGISLACAO MINERARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.29.00','MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP','  REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE  TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.2.99.00','OUTRAS MULTAS ADMINISTRATIVAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.00.00','MULTAS ADMINISTRATIVAS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DECORRENTES DA INOBSERVANCIA DE NORMAS, E COM RENDIMENTOS DESTINADOS AINDENIZACAO PELO ATRASO NO CUMPRIMENTO DA OBRIGACAO REPRESENTANDO ORESULTADO DA APLICACOS IMPOSTAS AO CONTRIBUINTE FALTOSO, COMO SANCAO LEGAL NO CAMPO TRIBUTARIO (IMPOSTOS, TAXAS E CONTRIBUICAO DE MELHORIA) NAO-TRIBUTARIO (CONTRIBUICOES SOCIAIS E ECONOMICAS, PATRIMONIAIS, INDUSTRIAIS, SERVICOS E DIVERSAS) E DE NATUREZA ADMINISTRATIVA, POR INFRACOES A REGULAMENTOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.01.00','MULTAS PREVISTA NA LEGISLACAO DE METROLOGIA','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLIC. P/ PUNIR QUEM INFRIGE AO DISPOSTO NA LEGISLACAO DE METROLOGIA, DA NORMALIZACAO INDUSTRIAL E DA CERTIFICACAO DE QUALIDADE DE PRODUTOS INDUSTRIAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.02.00','MULTAS DO REGULAMENTO P/ O TRAFEGO MARITIMO','REGISTRAS AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS C/FIM DE PUNIR QUEM INFRINGE O REGULAMENTO PARA O TRAFEGO MARITIMO. MULTAS DEVIDAS POR EMBARCACOESBRASILEIRAS, SALVO AS PERTENCENTES A MARINHA, QUANDO EM AGUAS SOBJURISDICAO NACIONAL OU EM ALTO-MAR; POR EMBARCACOES ESTRANGEIRAS EMAGUAS TERRITORIAIS, NAVIOS DE GUERRA ESTRANGEIROS E OUTRAS EMBARCACOESQUE VIOLEM AS NORMAS EXPRESSAS NO REGULAMENTO PARA O TRAFEGO MARITIMO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.03.00','MULTA DE POLUICAO DE AGUAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PENALIDADES PECUNIARIAS DESTINADAS A PUNIR O INFRATOR PELA POLUICAO DE AGUAS. MULTAS DEV. LANCAMENTO OLEOS,PRODUTOS OLEOSOS E SUBSTANCIAS QUIMICAS TOXICAS NAS AGUAS PUBLICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.04.00','MULTAS DO CODIGO ELEITORAL E LEIS CONEXAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE O CODIGO ELEITORAL E LEIS CONEXAS. COMPREENDE A MULTA DEVIDA PELOS ELEITORES QUE NAO COMPARECEREM E NAO JUSTIFICAREMSUA AUSENCIA PERANTE O JUIZ ELEITORAL ATE 30 DIAS APOS A REALIZACAO DAELEICAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.05.00','MULTAS PREVISTAS NA LEI DO SERVICO MILITAR','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR O MILITAR POR INOBSERVANCIA DE LEIS ESPECIFICAS. DEVIDAS PELOCIDADAO BRASILEIRO DO SEXO MASCULINO QUE NAO SE ALISTAR ATE OS 19 ANOSPARA PRESTAR SERVICO MILITAR. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.06.00','MULTAS PREVISTAS NA LEI GERAL DAS TELECOMUN.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INFRACOES COMETIDAS POR CONCESSIONARIOS DE SERVICOS DE TELECOMUNICACOES E DE RADIOFUSAO, SEJA NO REGIME PUBLICO OU PRIVADO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.07.00','MULTAS PREVISTAS NA LEGISL. SANITARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE O DISPOSTO NA LEGISLACAO SANITARIA. DEVIDASQUANDO DA INFRACAO, FRAUDE, FALSIFICACAO E ADULTERACAO DAS MATERIAS-PRIMAS E PRODUTOS FARMACEUTICOS, BEM COMO QUAISQUER PRODUTOS OU INSUMOS QUE INTERESSEM A SAUDE PUBLICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.08.00','MULTAS PREVISTAS LEGIS.DE REGISTRO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE AS LEIS OU REGULAMENTOS QUE DISCIPLINAM AS ATIVIDADES DE AGENTES AUXILIARES DO COMERCIO, DE ARMAZENS GERAIS E OUTROS SUJEITOS AO CONTROLE E FISCALIZACAO DOS ORGAOS DE REGISTRO DO COMERCIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.09.00','MUL. PREVISTAS NA LEGIS LUBRIF.E COMBUSTIVEIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A COMBUSTIVEIS E LUBRIFICANTES. AS MULTAS SAO IMPOSTAS PELA AGENCIA NACIONAL DO PETROLEO-ANP. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.10.00','MULTAS POR INFRACAO A LEGIS. TRABALHISTA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO TRABALHISTA, TAIS COMO: EXTRAVIO OU INUTILIZACAO DE CARTEIRA DE TRABALHO, FALTA DE REGISTRO DE EMPREGADO, PRORROGACAO DE JORNADA DE TRABALHO SEM ACORDO, PAGAMENTO DE SALARIO ATRASADO, INFRACOES AS NORMAS DE SEGURANCA E MEDICINA DO TRABALHO,ETC... ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.11.00','MULTAS PREVISTAS NA LEGISLAC. DE TRANSITO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM TRANSGRIDE A LEGISLACAO REFERENTE A TRANSITO. CONSTITUEM VPA VINCULADA AO MINISTERIO DA JUSTICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.12.00','MUL. PREVISTAS NA LEG.SEG.DESEMP.AB. SALAR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS COM O FIM DE PUNIR A QUEM INFRINGE A LEGISLACAO REFERENTE AO SEGURO-DESEMPREGO E AO ABONO SALARIAL. VPA CONSTITUIDA DO PRODUTO DOS ENCARGOS DEVIDO SPELOS CONTRIBUINTES, EM DECORRENCIA DE SUAS OBRIGACOES JUNTO AO PIS E AO PASEP. CONSTITUI RECURSO DO FUNDO DE AMPARO AO TRABALHADOR - FAT,VINCULADO AO MINISTERIO DO TRABALHO, SENDO DESTINADO AO CUSTEIO DO PROGRAMA DE SEGURO-DESEMPREGO, AO PAGAMENTO DO ABONO SALARIAL E AO FINANCIAMENTO DE PROGRAMAS DE DESENVOLVIMENTO ECONOMICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.13.00','MULTAS PREVISTAS NA LEGIS.DEFESA DIR. DIFUSOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.13.01','MUL.PREV.LEGISL.S/DIREITOS DIFUSOS TRABALHIST','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE DIREITOS DIFUSOS TRABALHISTAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.13.02','MUL.PREV.LEGISL.S/DIREITOS DIFUSOS - OUTROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS REFERENTES AS INFRACOES PREVISTAS EM LEGISLACOES SOBRE DEFESA DE OUTROS DIREITOS DIFUSOS NAO ABRANGIDOS PELOS ITENS ANTERIORES. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.14.00','MULTAS E JUROS PREVISTOS EM CONTRATOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS E JUROS PREVISTOS EM CONTRATOS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.15.00','MULTAS DEC.OP.TRANSP.ROD.PASSAGEIROS E CARGAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES DAS LEGISLACOES DE OPERACAO DO TRANSPORTE RODOVIARIO DE PASSAGEIROS E CARGAS, BEM COMO DOS CONTRATOS DE CONCESSAO DE SERVICOS DE TRANSPORTE RODOVIARIO INTERESTADUAL E INTERNACIONAL DE PASSAGEIROS E CARGAS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.16.00','MUL.PREVISTAS POR.INFR.LEGIS.TRANSP. FERROV.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO RECOLHIMENTO PELO MINISTERIO DOS TRANSPORTES DE MULTAS POR INFRACOES A DISPOSICOES PREVISTAS NO REGULAMENTO DE TRANSPORTE FERROVIARIOS E CONTRATOS DE CONCESSO-ES DE SERVICOS DE TRANSPORTE FERROVIARIO DE PASSAGEIROS E CARGAS. AMPARO LEGAL: DECRETO 04/96, DECRETO 1832/96. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.17.00','MULTAS PREVISTAS NO COD.BRAS. DE AERONAUTICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS POR INFRACOES PREVISTAS NO CODIGO BRASILEIRO DE AERONAUTICA (LEI 7565, DE19/12/86; LEI NUM. 9614, DE 05/03/98). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.18.00','MULTA DE TARIFA PEDAGIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBREA TARIFA DE PEDAGIO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.19.00','MULTA DECOR.DE SENT.PENAL CONDENATORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS COBRADAS SOBRE SENTENCAS PENAIS CONDENATORIAS COM TRANSITO EM JULGADO. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.20.00','MULTA DE QUEBRA DE FIANCA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PROVENIENTES DE MULTAS DECORRENTES DE FIANCA QUEBRADA OU PERDIDA, EM CONFORMIDADE COM O DISPOSTO NA LEI PROCESSUAL PENAL. OS RECURSOS DESTINAM-SE AO FUNPEN PARA FINANCIAR E APOIAR AS ATIVIDADES E PROGRAMAS DE MODERNIZACAO E APRIMORAMENTO DO SISTEMA PENITENCIARIO BRASILEIRO. DECRETO LEI NUM.79N DE 07/01/94. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.21.00','MULTAS POR DANOS AO MEIO AMBIENTE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS POR DANOS AO MEIO AMBIENTE. AMPARO LEGAL: LEI 9 605 DE 12FEV1998 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.22.00','MULTA E DE SEGURANCA PRIVADA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS APLICADAS POR INFRACOES PRATICADAS POR EMPRESAS PARTICULARES QUE EXPLOREM SERVICOS DE VIGILANCIA E DE TRANSPORTE DE VALORES (LEI 9017 DE 30/03/95). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.23.00','MULTA POR ATO ATENTATORIO AO EXERC JURISDICAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS QUE TEM COMO FATO GERADOR O NAO CUMPRIMENTO COM EXATIDAO DOS PROVIMENTOS MANDAMENTAIS OU A CRIACAO DE EMBARACOS A EFETIVACAO DE PROVIMENTOS JUDICIAIS DE NATUREZA ANTECIPATORIA OU FINAL. FUNDAMENTO LEGAL: LEI 5869/1973; LEI 5925/1973; LEI 8953/1994; LEI 10358/2001; LEI 11382/2006. DESTINACAO LEGAL: RECURSOS LIVRES PARA O TESOURO NACIONAL. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.24.00','MULTAS POR INFRACOES A LEG. CINEMATOGRAFICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE NAO-PAGAMENTO NO TRANSCURSO DE PRAZO EXIGIVEL, INCIDENTE SOBRE A DIVIDA ATIVA DAS MULTAS POR INFRACOES A LEGISLACAO CINEMATOGRAFICA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.25.00','MUL.APLIC.PELOS TRIBUNAIS DE CONTAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE APLICACAO DE PENAS PECUNIARIAS INCIDENTES SOBRE AS MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS, PELO NAO CUMPRIMENTO A DECISAO DOS MESMOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.26.00','MULT.PREV. LEG. S/ REG. PREV. PRIV. COMPLEM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PREVISTAS NA LEGISLACAO REG. PREV. PRIV. COMPLEM. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.27.00','MULTAS POR AUTOS DE INFRACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS PUNITIVAS APLICADAS PELO NAO CUMPRIMENTO NOS CASOS PREVISTOS NOS REGULAMENTOS OU NOS CONTRATOS, OU PELA REINCIDENCIA EM FATOS QUE TENHAM GERADO ADVERTENCIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.28.00','MULTAS PREVISTAS NA LEGISLACAO MINERARIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE MULTAS EXERCIDAS PELO PODER DE POLICIA PREVISTAS NA LEGISLACAO MINERARIA. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.29.00','MULTA POR FALTA/ATRASO NA APRESENTACAO GFIP','  REGISTRA O VALOR DA VPA DECORRENTE DE MULTA POR FALTA OU ATRASO NA APRESENTACAO DA GUIA DE RECOLHIMENTO DO FUNDO DE GARANTIA DE  TEMPO DE SERVICO E DE INFORMACOES A PREVIDENCIA SOCIAL - GFIP. PORTARIA Nº 09, DE 26/02/2010 ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.4.3.99.00','OUTRAS MULTAS ADMINISTRATIVAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTRAS MULTAS ADMINISTRATIVAS NAO ENQUADRADAS NAS CONTAS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.0.00.00','INDENIZACOES','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.1.00.00','INDENIZACOES - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.1.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.1.02.00','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.1.03.00','INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO','  REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.1.99.00','OUTRAS INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.2.00.00','INDENIZACOES - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.2.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.2.02.00','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS . ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.2.03.00','INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO','  REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.2.99.00','OUTRAS INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.3.00.00','INDENIZACOES - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES DIVERSAS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.3.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR DANOS CAUSADOS AO PATRIMONIO PUBLICO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.3.02.00','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.3.03.00','INDENIZ. POSSE OU OCUPACAO ILIC. BENS UNIAO','  REGISTRA O VALOR DOS RECURSOS RECEBIDOS COMO INDENIZACAO POR POSSE OU OCUPACAO ILICITA DE BENS DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.5.3.99.00','OUTRAS INDENIZACOES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE INDENIZACOES QUE NAO SE ENQUADRAM NOS ITENS ANTERIORES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.6.0.00.00','VPA DECORRENTE ALIENACAO BENS APREENDIDOS','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENACAO DE MERCADORIAS, OBJETO DA PENA DE PERDIMENTO. O PRODUTO DA ARRECADACAO TEM A SEGUINTE DESTINACAO: 60% AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF E 40% AO FUNDO NACIONAL DE ASSISTENCIA SOCIAL - MINISTERIO DA PREVIDENCIA E ASSISTENCIA SOCIAL. AO FUNDO NACIONAL ANTIDROGA ­ FUNAD, PARA APLICACAO CONFORME LEGISLACAO EM VIGOR, QUANDO DA APREENSAO DE BENS, DIREITOS E VALORES OBJETO DO CRIME DE TRAFICO ILICITO DE SUBSTANCIAS INTORPECENTES OU DROGAS AFINS. (LEI 6368 DE 21/10/76) LEI 7460 DE 19/12/86, LEI 9804 DE 30/06/99 ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.6.1.00.00','VPA DECORRENTE ALIENACAO BENS APREENDIDOS - EXTRA OFSS','COMPREENDE O SOMATORIO DAS VARIACOES PATRIMONIAIS AUMENTATIVAS GERADAS PELA ALIENACAO DE MERCADORIAS, OBJETO DA PENA DE PERDIMENTO. O PRODUTO DA ARRECADACAO TEM A SEGUINTE DESTINACAO: 60% AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO - FUNDAF E 40% AO FUNDO NACIONAL DE ASSISTENCIA SOCIAL - MINISTERIO DA PREVIDENCIA E ASSISTENCIA SOCIAL. AO FUNDO NACIONAL ANTIDROGA ­ FUNAD, PARA APLICACAO CONFORME LEGISLACAO EM VIGOR, QUANDO DA APREENSAO DE BENS, DIREITOS E VALORES OBJETO DO CRIME DE TRAFICO ILICITO DE SUBSTANCIAS INTORPECENTES OU DROGAS AFINS. (LEI 6368 DE 21/10/76) LEI 7460 DE 19/12/86, LEI 9804 DE 30/06/99  COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.6.1.01.00','VPA DE LEILOES DE MERCADORIAS APREENDIDAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE LEILOES DE MERCADORIAS APREENDIDAS ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.6.1.02.00','VPA DE ALIENACAO DE BENS APREENDIDOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALIENACAO DE BENS APREENDIDOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.6.1.03.00','VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA ALIENACAO DE BENS E VALORES QUE TENHAM SIDO OBJETO DE PERDIMENTO EM FAVOR DA UNIAO, ASSOCIADOS AO TRAFICO ILICITO DE ENTORPECENTES E DROGAS AFINS, INCLUSIVE AS GLEBAS DE QUALQUER REGIAO DO PAIS ONDE FOREM LOCALIZADAS CULTURAS ILEGAIS DE PLANTAS PSICOTROPICAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.7.0.00.00','REVERSAO DE PROVISOES','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES DE PROVISOES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.7.1.00.00','REVERSAO DE PROVISOES - EXTRA OFSS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE REVERSOES  DE PROVISOES. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.0.00.00','VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.00.00','VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - EXTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS.COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE UMA UNIDADE PERTENCENTE AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) COM PESSOA OU UNIDADE QUE NAO PERTENCA AO OFSS DE ENTE PUBLICO, ALEM DOS DEMAIS FATOS QUE NAO COMPREENDEM TRANSACOES ENTRE PARTES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.01.00','VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O  PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO  FUNDAF.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.01.01','VPA DE HONORARIOS DE ADVOGADOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.01.02','VPA DE ONUS DE SUCUMBENCIA ','REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.02.00','PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.03.00','VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.04.00','VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.05.00','VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSAT','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA.  FATO GERADOR:  APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA.  DESTINACAO LEGAL:  MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA APLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECIDAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX.  AMPARO LEGAL:  LEI 9.019/1995 E SUAS ALTERACOES;  MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.06.00','VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM  QUALQUER RETENCAO, DA SEGUINTE FORMA:  A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA ASSISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991;  B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPARTAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOURO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVENCAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE.  O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR  VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.07.00','RESERVA GLOBAL DE REVERSAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.08.00','COTA-PARTE DO SERV.NO FUNDO DE SAUDE MILITAR',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE INCIDE SOBRE A REMUNERACAO DOS MILITARES E DESTINA-SE A CONSTITUICAO DE FUNDOS DE SAUDE, EM CADA UMA DAS FORCAS ARMADAS, QUE VISEM AO CUSTEIO DO ATENDIMENTO MEDICO-HOSPITALAR DE MILITARES E DE SEUS DEPENDENTES ( MP Nº 2.215-10, DE 31/08/01).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.09.00','CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.10.00','VPA DECORRENTE DA INDENIZACAO POR SINISTRO',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.11.00','TERCEIRIZACAO DA FOPAG DOS AGENTES PUBLICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA TERCEIRIZACAO DA FOLHA DE PAGAMENTO DOS AGENTES PUBLICOS COMO CONTRAPARTIDA DA PRESTACAO DE SERVICOS DE DISPONIBILIZACAO DE CREDITOS EM CONTAS CORRENTES E DA CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS COM AMORTIZACAO CONSIGNADA EM FOLHA DE PAGAMENTO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.12.00','VPA DECORRENTE DE LEILAO PARA PAGAM.DA FOLHA DE BENEFICIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO PARA PAGAMENTO DA FOLHA DE BENEFICIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.13.00','VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.14.00','RECUPERACAO DE SINISTROS',' REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DO PAGAMENTO DE PRESTACAO INADIMPLIDA QUE JA FOI OBJETO DE INDENIZACAO NAS OPERACOES AMPARADAS PELO SEGURO DECREDITO AA EXPORTACAO, COM RECURSOS ORCAMENTARIOS E FINANCEIROS ALOCADOS NO FUNDO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.15.00',' PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL  ',' COMPREENDE O VALOR RECURSOS DECORRENTES DA PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.15.01',' PRESTACAO DE CONTAS - FONTES VEDADAS','REGISTRA OS RECURSOS DECORRENTES DA PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL - FONTES VEDADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.1.15.02',' PRESTACAO DE CONTAS-FONTES NAO IDENTIFICADAS  ','REGISTRA OS RECURSOS DECORRENTES DA PRESTACAO DE CONTAS DE CAMPANHA ELEITORAL - FONTES NAO IDENTIFICADAS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.00.00','VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTRA OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO MESMO ENTE PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.01.00','VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.01.01','VPA DE HONORARIOS DE ADVOGADOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.01.02','VPA DE ONUS DE SUCUMBENCIA ','REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.02.00','PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.03.00','VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.04.00','VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.05.00','VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSAT','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA.  FATO GERADOR:  APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA.  DESTINACAO LEGAL:  MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA APLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECIDAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX.  AMPARO LEGAL:  LEI 9.019/1995 E SUAS ALTERACOES;  MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.06.00','VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM  QUALQUER RETENCAO, DA SEGUINTE FORMA:  A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA ASSISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991;  B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPARTAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOURO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVENCAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE.  O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR  VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.07.00','RESERVA GLOBAL DE REVERSAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.09.00','CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE  NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.10.00','VPA DECORRENTE DA INDENIZACAO POR SINISTRO',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.11.00','TERCEIRIZACAO DA FOPAG DOS AGENTES PUBLICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA TERCEIRIZACAO DA FOLHA DE PAGAMENTO DOS AGENTES PUBLICOS COMO CONTRAPARTIDA DA PRESTACAO DE SERVICOS DE DISPONIBILIZACAO DE CREDITOS EM CONTAS CORRENTES E DA CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS COM AMORTIZACAO CONSIGNADA EM FOLHA DE PAGAMENTO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.12.00','VPA DECORRENTE DE LEILAO PARA PAGAM.DA FOLHA DE BENEFICIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO PARA PAGAMENTO DA FOLHA DE BENEFICIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.2.13.00','VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.00.00','VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - INTER OFSS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS. COMPREENDE OS VALORES DE OPERACOES EFETUADAS ENTRE DUAS UNIDADES PERTENCENTES AO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.01.00','VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS','COMPREENDE A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.01.01','VPA DE HONORARIOS DE ADVOGADOS','  REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA DECORRENTE DE CUSTAS DO PROCESSO DE APURACAO, INSCRICAO E COBRANCA DA DIVIDA ATIVA DA UNIAO, BEM COMO PELA DEFESA JUDICIAL DA FAZENDA NACIONAL, PAGA PELO DEVEDOR DA ACAO. O PRODUTO DESTA ARRECADACAO CONSTITUI RECEITA VINCULADA AO FUNDO ESPECIAL DE DESENVOLVIMENTO E APERFEICOAMENTO DAS ATIVIDADES DE FISCALIZACAO FUNDAF. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.01.02','VPA DE ONUS DE SUCUMBENCIA ','REGISTRA VARIACAO PATRIMONIAL AUMENTATIVA ADVINDA DE SENTENCA CONDENATORIA PAGA PELO VENCIDO AO VENCEDOR,AS DESPESAS QUE ANTECIPOU E OS HONORARIOS ADVOCATICIOS. (LEI N. 5.869,DE 11/01/73, ART. 20).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.02.00','PRODUTO DEPOSITO ABANDONADO(DINHEIRO/OBJETO VALOR)','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO PRODUTO DE DEPOSITOS ABANDONADOS (DINHEIRO E/OU OBJETOS DE VALOR) SENDO ORIGINARIA DA EXTINCAO DE CONTRATOS DE DEPOSITO REGULAR E VOLUNTARIO DE BENS DE QUALQUER ESPECIE POR RESCISAO DE PRAZO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.03.00','VPA DE BENS E VALORES PERDIDOS EM FAVOR UNIAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE BENS OU VALORES EM QUE SE TENHA DECRETADO PERDIMENTO EM FAVOR DA UNIAO. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.04.00','VPA DECORRENTE NAO APLICACAO INCENTIVO FISCAL PROJ.CULT.IND.CIN','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA NAO APLICACAO OU NAO COMPROMETIMENTO INTEGRAL DE INCENTIVOS FISCAIS POR CONTRIBUINTES DA INDUSTRIA CINEMATOGRAFICA NACIONAL E EM PROJETOS CULTURAIS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.05.00','VPA DECORRENTE DE DIREITOS ANTIDUMPING E DIREITOS COMPENSATORIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA IMPOSICAO DE DIREITOS ANTIDUMPING E DE DIREITOS COMPENSATORIOS, COBRADA MEDIANTE A APLICACAO DE PERCENTUAL DA MARGEM DE DUMPING OU DO MONTANTE DE SUBSIDIOS SUFICIENTE PARA SANAR O DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA BRASILEIRA.  FATO GERADOR:  APURACAO DE PRATICA DE DUMPING OU DE SUBSIDIOS ASSOCIADA AA EXISTENCIA  DE DANO OU AMEACA DE DANO AA INDUSTRIA DOMESTICA.  DESTINACAO LEGAL:  MINISTERIO DO DESENVOLVIMENTO, INDUSTRIA E COMERCIO EXTERIOR, PARA APLICACAO NA AREA DE COMERCIO EXTERIOR, CONFORME DIRETRIZES ESTABELECIDAS PELA CAMARA DE COMERCIO EXTERIOR - CAMEX.  AMPARO LEGAL:  LEI 9.019/1995 E SUAS ALTERACOES;  MP 2.158, DE 24 DE AGOSTO DE 2001; LEI 10.833, DE 29 DE DEZEMBRO DE 2003. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.06.00','VPA PART. SEGURO-DPVAT-SIST.NAC. TRANSITO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIA TERRESTRE - DPVAT. ARRECADADOS PELA REDE BANCARIA E REPASSADOS DIRETAMENTE E SEM QUALQUER RETENCAO, DA SEGUINTE FORMA:  A) 45% (QUARENTA E CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A CREDITO DIRETO DO FUNDO NACIONAL DE SAUDE, PARA CUSTEIO DA ASSISTENCIA MEDICO-HOSPITALAR DOS SEGURADOS VITIMADOS EM ACIDENTE DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 27 DA LEI 8.212, DE 24 DE JULHO DE 1991;  B) 5% (CINCO POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO AO DEPARTAMENTO DE TRANSITO, POR MEIO DE CREDITO DIRETO A CONTA UNICA DO TESOURO NACIONAL, PARA APLICACAO EXCLUSIVA EM PROGRAMAS DESTINADOS A PREVENCAO DE ACIDENTES DE TRANSITO, NOS TERMOS DO PARAGRAFO UNICO DO ART. 78 DA LEI Nº9.503, DE 23 DE SETEMBRO DE 1997; C) 50% (CINQUENTA POR CENTO) DO VALOR BRUTO RECOLHIDO DO SEGURADO A COMPANHIA SEGURADORA, NA FORMA DA REGULAMENTACAO VIGENTE.  O PREMIO DO SEGURO OBRIGATORIO DE DANOS PESSOAIS CAUSADOS POR VEICULOS AUTOMOTORES DE VIAS TERRESTRES - DPVAT, SERA PAGO JUNTO COM A COTA UNICA, OU COM A PRIMEIRA PARCELA, DO IMPOSTO SOBRE A PROPRIEDADE DE VEICULOS AUTOMOTORES - IPVA (DECRETO Nº 2.867, DE 8 DE DEZEMBRO DE 1998.) ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.07.00','RESERVA GLOBAL DE REVERSAO','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA REFERENTE A RESERVA GLOBAL DE REVERSAO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.08.00','COTA-PARTE DO SERV.NO FUNDO DE SAUDE MILITAR',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA QUE INCIDE SOBRE A REMUNERACAO DOS MILITARES E DESTINA-SE A CONSTITUICAO DE FUNDOS DE SAUDE, EM CADA UMA DAS FORCAS ARMADAS, QUE VISEM AO CUSTEIO DO ATENDIMENTO MEDICO-HOSPITALAR DE MILITARES E DE SEUS DEPENDENTES ( MP Nº 2.215-10, DE 31/08/01).  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.09.00','CONTRIBUICAO VOLUNTARIA - MONTEPIO CIVIL',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTES DE COTAS ARRECADADAS DE CADA MEMBRO ADQUIRENTE DO DIREITO DE, POR MORTE, DEIXAR PENSAO PAGAVEL A ALGUEM DE SUA ESCOLHA. DE COMPETENCIA DA UNIAO. CONTRIBUICAO EFETUADA POR FUNCIONARIOS PUBLICOS FEDERAIS (CIVIS) INSCRITOS NO MONTEPIO. CALCULADA COM BASE NOS VENCIMENTOS E ACRESCIMOS PERCEBIDOS MENSALMENTE PELO SERVIDOR.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.10.00','VPA DECORRENTE DA INDENIZACAO POR SINISTRO',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA OCORRENCIA DE SINISTRO NAS OPERACOES GARANTIDAS POR MEIO DE SEGUROS, NOS CONTRATOS JUNTO A ENTIDADES LEGALMENTE CONSTITUIDAS COMO SEGURADORAS, NAS QUAIS O PODER PUBLICO FIGURE COMO SEGURADO - PAGAMENTO DO PREMIO. AMPARO LEGAL: LEI 10.406, DE 10 DE JANEIRO DE 2002 - CODIGO CIVIL (ARTS. 757 A 802). ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.11.00','TERCEIRIZACAO DA FOPAG DOS AGENTES PUBLICOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DA TERCEIRIZACAO DA FOLHA DE PAGAMENTO DOS AGENTES PUBLICOS COMO CONTRAPARTIDA DA PRESTACAO DE SERVICOS DE DISPONIBILIZACAO DE CREDITOS EM CONTAS CORRENTES E DA CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS COM AMORTIZACAO CONSIGNADA EM FOLHA DE PAGAMENTO.  ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.12.00','VPA DECORRENTE DE LEILAO PARA PAGAM.DA FOLHA DE BENEFICIOS','REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO PARA PAGAMENTO DA FOLHA DE BENEFICIOS. ','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('4.9.9.9.3.13.00','VPA DECORRENTE DE LEILAO DE COTAS DE IMPORTACAO',' REGISTRA A VARIACAO PATRIMONIAL AUMENTATIVA PROVENIENTE DE LEILAO DE COTAS DE IMPORTACAO','C','S','P','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.0.0.0.0.00.00','CONTROLES DA APROVACAO DO PLANEJAMENTO E ORCAMENTO','COMPREENDE AS CONTAS COM FUNCAO DE REGISTRA OS ATOS E FATOS LIGADOS A EXECUCAO ORCAMENTARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.0.0.0.00.00','PLANEJAMENTO APROVADO','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS PREVISTOS PARA EXECUCAO DOS PROGRAMAS E ACOES (PROJETOS, ATIVIDADES E OPERACOES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL E PROJETO DE LEI ORCAMENTARIA ANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.1.0.0.00.00','PPA - APROVADO','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS PREVISTOS PARA A EXECUCAO DOS PROGRAMAS E ACOES (PROJETOS, ATIVIDADES E OPERACOES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.1.1.0.00.00','PPA POR PROGRAMA DE TRABALHO ','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO PARA O PERIODO DE QUATRO ANOS, DETALHADO POR PROGRAMA DE TRABALHO .','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.1.2.0.00.00','REVISAO DO PPA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS REVISOES ANUAIS AUTORIZADAS DURANTE O PERIODO DE VIGENCIA DO PLANO PLURIANUAL, DETALHADO POR PROGRAMA DE TRABALHO.','X','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.0.0.00.00','PLOA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS PREVISTOS PARA A EXECUCAO DOS PROGRAMAS E ACOES (PROJETOS, ATIVIDADES E OPERACOES ESPECIAIS) ESTABELECIDOS NO PROJETO DE LEI ORCAMENTARIA ANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.1.0.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.1.1.00.00','PLOA INICIAL DA RECEITA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA PREVISAO DE RECEITA CONSTANTE DO PLOA INICIAL.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.1.2.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - RECEITA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A RECEITA.','X','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.2.0.00.00','PROJETO INICIAL DA LOA - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.2.1.00.00','PLOA INICIAL DA DESPESA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA FIXACAO DA DESPESA CONSTANTE DO PLOA INICIAL.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.1.2.2.2.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A DESPESA.','X','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.0.0.0.00.00','ORCAMENTO APROVADO','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A PREVISAO DA RECEITA, FIXACAO DA DESPESA E SUAS ALTERACOES NO ORCAMENTO GERAL DA UNIAO DURANTE O EXERCICIO FINANCEIRO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.1.0.0.00.00','PREVISAO DA RECEITA ','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A PREVISAO DA RECEITA PUBLICA APROVADA PELA LEI ORCAMENTARIA ANUAL E SUAS ALTERACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.1.1.0.00.00','PREVISAO INICIAL DA RECEITA ','REGISTRA O VALOR DA RECEITA PREVISAO INICIAL DA RECEITA APROVADO NA LOA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.1.2.0.00.00','ALTERACAO DA PREVISAO DA RECEITA','REGISTRA O VALOR DOS CREDITOS PREVISTOS APOS A APROVACAO DO ORCAMENTO INDEPENDENTE DA AUTORIZACAO JA CONCEDIDA NA LEI ORCAMENTARIA PARA ABERTURA DE CREDITO SUPLEMENTAR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.1.2.1.00.00','PREVISAO ADICIONAL DA RECEITA','REGISTRA O VALOR ADICIONAL DA RECEITA PARA ABERTURA DE CREDITOS ADICIONAIS.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.1.2.9.00.00','(-) ANULACAO DA PREVISAO DA RECEITA ','REGISTRA O VALOR DA ANULACAO DA RECEITA PREVISTA NO ORCAMENTO, NA GESTAO FUNDOS E NAS ADMINISTRACOES DIRETA E INDIRETA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.0.0.00.00','FIXACAO DA DESPESA','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A FIXACAO DA DESPESA PUBLICA APROVADA PELA LEI ORCAMENTARIA E SUAS ALTERACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.0.00.00','DOTACAO ORCAMENTARIA ','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DA DOTACAO ORCAMENTARIA INICIAL, ADICIONAL E SEUS CANCELAMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.00.00','DOTACAO INICIAL','COMPREENDE A DOTACAO INICIAL AUTORIZADA NA LEI ORCAMENTARIA ANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.01.00','CREDITO INICIAL','COMPREENDE OS VALORES PERTINENTES AOS CREDITOS INICIALMENTE APROVADOS PARA DAR SUPORTE A EXECUCAO ORCAMENTARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.01.01','ORIGINARIO DO OGU','REGISTRA OS VALORES PERTINENTES AOS CREDITOS INICIAIS APROVADOS PELA LEI ORCAMENTARIA, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES INTEGRANTES DO OGU REFERENTES AO OFSS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.01.02','NAO ORIGINARIO DO OGU','REGISTRA OS VALORES PERTINENTES AOS CREDITOS INICIAIS APROVADOS PELA LEI ORCAMENTARIA, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES NAO INTEGRANTES DO OGU REFERENTES AO OFSS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.02.00','CREDITOS ANTECIPADOS - LDO ','COMPREENDE OS VALORES RELATIVOS AS ANTECIPACOES DE CREDITOS DETERMINADOS PELA LEI DE DIRETRIZES ORCAMENTARIAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.02.01','ANTECIPACAO - LDO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ANTECIPADOS PELA LEI DE DIRETRIZES ORCAMENTARIAS ATE QUE O ORCAMENTO SEJA APROVADO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.1.02.09','(-) ANULACAO DA ANTECIPACAO - LDO ','REGISTRA O VALOR REFERENTE AO CANCELAMENTO DE DOTACAO ANTECIPADA PREVISTA NA LEI DE DIRETRIZES ORCAMENTARIAS - LDO, APOS APROVACAO DO ORCAMENTO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.00.00','DOTACAO ADICIONAL POR TIPO DE CREDITO','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DA DOTACAO ORCAMENTARIA DECORENTES DA ABERTURA DE CREDITOS ADICIONAIS E SEUS CANCELAMENTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.01.00','CREDITO ADICIONAL - SUPLEMENTAR','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS AOS CREDITOS ADICIONAIS SUPLEMENTARES COM VISTA AO REFORCO DA DOTACAO ORCAMENTARIA CONSTANTE DA LEI ORCAMENTARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.01.01','ORIGINARIO DO OGU ',' REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES DESTINADOS AO REFORCO DE DOTACAO ORCAMENTARIA JA EXISTENTE NO ORCAMENTO EM VIGOR, PARA A REALIZACAO DE DESPESAS, AUTORIZADOS EM LEI E ABERTOS POR DECRETO, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES INTEGRANTES DO OGU, REFERENTES AO OFSS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.01.02','NAO ORIGINARIO DO OGU','REGISTRA OS VALORES PERTINENTES AOS CREDITOS SUPLEMENTARES DESTINADOS A REFORCO DE DOTACAO ORCAMENTARIA JA EXISTENTE NO ORCAMENTO EM VIGOR, PARA A REALIZACAO DE DESPESAS, AUTORIZADOS EM LEI E ABERTOS POR DECRETO, PARA EXECUCAO DO ORCAMENTO PROPRIO, NAO ORGINARIO DO OGU, REFERENTE AO OFSS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.01.03','ORIGINARIO DO OGU - SUPLEMENTACAO AUTOMATICA','REGISTRA OS VALORES REFERENTES A SUPLEMENTACOES AUTOMATICAS AUTORIZADAS NA LEI ORCAMENTARIA ANUAL E ABERTOS POR DECRETO, PARA EXECUCAO DO ORCAMENTO DOS ORGAOS/ENTIDADES INTEGRANTES DO OGU, REFERENTES AO OFSS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.02.00','CREDITO ADICIONAL - ESPECIAL ','COMPREENDE O SOMATORIO DOS VALORES DOS CREDITOS ADICIONAIS ESPECIAIS DESTINADOS A ATENDER PROGRAMAS NAO CONTEMPLADOS NA LEI ORCAMENTARIA ANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.02.01','CREDITOS ESPECIAIS ABERTOS ','REGISTRA OS VALORES REFERENTES A ABERTURA DE CREDITOS ESPECIAIS AUTORIZADOS EM LEI ESPECIFICA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.02.02','CREDITOS ESPECIAIS REABERTOS','REGISTRA OS VALORES REFERENTES A REABERTURA DE CREDITOS ESPECIAIS CUJO ATO DE AUTORIZACAO FOI PROMULGADO NOS ULTIMOS QUATRO MESES DO EXERCICIO ANTERIOR. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.02.03','CREDITOS ESPECIAIS REABERTOS - SUPLEMENTACAO ','REGISTRA OS VALORES REFERENTES A SUPLEMENTACAO DE CREDITOS ESPECIAIS REABERTOS NOS TERMOS DO § 2º DO ART. 167 DA CF/88. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.03.00','CREDITO ADICIONAL - EXTRAORDINARIO','COMPREENDE O SOMATORIO DOS VALORES REFERENTES A ABERTURA DE CREDITOS ADICIONAIS EXTRAORDINARIOS DESTINADOS A DESPESAS IMPREVISIVEIS E URGENTES COMO AS DECORRENTES DE GUERRA, COMOCAO INTERNA OU CALAMIDADE PUBLICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.03.01','CREDITOS EXTRAORDINARIOS ABERTOS ','REGISTRA OS VALORES REFERENTES AOS CREDITOS EXTRAORDINARIOS ABERTOS POR AUTORIZACAO DO PODER EXECUTIVO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.03.02','CREDITOS EXTRAORDINARIOS REABERTOS','REGISTRA OS VALORES REFERENTES A REABERTURA DE CREDITOS EXTRAORDINARIOS CUJO ATO DE AUTORIZACAO FOI PROMULGADO NOS ULTIMOS QUATRO MESES DO EXERCICIO ANTERIOR. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.2.03.03','CREDITOS EXTRAORDINARIOS REABERTOS - SUPLEMENTACAO','REGISTRA OS VALORES REFERENTES A SUPLEMENTACAO DE CREDITOS EXTRAORDINARIOS REABERTOS NOS TERMOS DO § 2º DO ART. 168 DA CF/88. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.00.00','DOTACAO ADICIONAL POR FONTE','COMPREENDE O SOMATORIO DOS VALORES DA DOTACAO ADICIONAL POR FONTE DE RECURSOS PARA ABERTURA DO CREDITO ADICIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.01.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR ','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.02.00',' EXCESSO DE ARRECADACAO. ','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.03.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.04.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.05.00','RESERVA DE CONTINGENCIA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA A RESERVA DE CONTINGENCIA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.06.00','DOTACAO TRANSFERIDA','REGISTRA OS VALORES DE ALTERACOES DA LEI ORCAMENTARIA COM CONTROLE POR ORIGEM DE CREDITO.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.07.00','RECURSOS SEM DESPESAS CORRESPONDENTES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA OS RECURSOS QUE, EM DECORRENCIA DE VETO, EMENDA OU REJEICAO DO PROJETO DE LEI ORCAMENTARIA ANUAL, FICAREM SEM DESPESAS CORRESPONDENTES.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.09.00','(-) CANCELAMENTO DE DOTACOES','REGISTRA O CANCELAMENTO / REMANEJAMENTO DE DOTACOES PARA ABERTURA DE CREDITOS ADICIONAIS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.3.99.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','REGISTRA O VALOR DA CONTRAPARTIDA DOS LANCAMENTOS DAS DOTACOES ADICIONAIS POR ORIGEM DE CREDITO.','X','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTACAO ','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS AOS CREDITOS INICIAL, SUPLEMENTAR, ESPECIAL E EXTRAORDINARIO CANCELADOS OU REMANEJADOS, EM CASOS REGULARMENTE PREVISTOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.01.00','ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA ','REGISTRA A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.01.01','ACRESCIMO','REGISTRA A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.01.09','(-)REDUCAO','REGISTRA A MOVIMENTACAO DOS CREDITOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.02.00','ALTERACAO DA LEI ORCAMENTARIA ','REGISTRA OS VALORES DOS CREDITOS ORCAMENTARIOS INDISPONIVEIS PARA EXECUCAO DA DESPESA, POR MEDIDA DE VETO, CONTINGENCIAMENTO OU CONTENCAO, E POSTERIORMENTE CANCELADAS, NOS CASOS REGULARMENTE PREVISTOS.  ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.02.01','ACRESCIMO','REGISTRA OS VALORES DOS ACRESCIMOS RESULTANTES DE ALTERACOES DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.02.09','(-)REDUCAO',' REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.03.00','DOTACAO TRANSFERIDA','REGISTRA O VALOR REFERENTE A OUTROS ACRESCIMOS OU REDUCOES DAS DOTACOES ORCAMENTARIAS PROVOCANDO A SUA POSTERIOR ALTERACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.03.01','ACRESCIMO ','REGISTRA OS VALORES DOS ACRESCIMOS RESULTANTES DE TRANSFERENCIAS DE OUTROS ORGAOS E ENTIDADES. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.03.09','(-)REDUCAO','REGISTRA A REDUCAO DA DOTACAO POR TRANSFERENCIA DE ORGAOS OU ENTIDADES','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.1.9.04.00','(-)CANCELAMENTO DE DOTACOES',' REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI ORCAMENTARIA EM VIRTUDE DE CANCELAMENTO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.0.00.00','MOVIMENTACAO DE CREDITOS RECEBIDOS ','COMPREENDE O SOMATORIO DOS VALORES DOS RECEBIMENTOS DE CREDITOS ORCAMENTARIOS ATRAVES DE DESTAQUE, PROVISAO OU POR FUSAO, CISAO OU EXTINCAO DE UNIDADES.','','N','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.00.00','DESCENTRALIZACAO INTERNA DE CREDITOS - PROVISAO','COMPREENDE OS VALORES DOS CREDITOS DESCENTRALIZADOS DAS UNIDADES ORCAMENTARIAS PARA AS UNIDADES ADMINISTRATIVAS SOB SUA JURISDICAO OU ENTRE ESTAS, NO AMBITO DO PROPRIO MINISTERIO, SECRETARIA OU ORGAO EQUIVALENTE, RECEBIDOS AO LONGO DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.01.00','PROVISAO RECEBIDA ','REGISTRA A PARCELA DE CREDITO RECEBIDA POR UMA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO CREDITO ORCAMENTARIO OU ADICIONAL, DENTRO DO PROPRIO MINISTERIO OU ORGAO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.02.00','PROVISAO RECEBIDA - BLOQUEADA','REGISTRA A PARCELA DE CREDITOS ORCAMENTARIOS RECEBIDOS MEDIANTE PROVISAO E POSTERIORMENTE BLOQUEADOS, EM HIPOTESES ESPECIAIS, PELA UNIDADE CONCEDENTE. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.03.00','ALTERACAO DE CREDITOS MOVIMENTADOS ','COMPREENDE O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.03.01','ACRESCIMO ','REGISTRA O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.03.09','(-) REDUCAO ','REGISTRA O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.1.04.00','AJUSTE POR VARIACAO CAMBIAL - INTERNA ','COMPREENDE VALOR DO CREDITO REFERENTE A AJUSTE POR VARIACAO DA TAXA CAMBIAL NA DESCENTRALIZACAO INTERNA (PROVISAO).','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.00.00','DESCENTRALIZACAO EXTERNA DE CREDITOS - DESTAQUE','COMPREENDE A DESCENTRALIZACAO DO CREDITO INICIAL OU ADICIONAL RECEBIDO DE UNIDADES OU ORGAOS PERTENCENTES A MINISTERIOS, SECRETARIAS E ORGAOS EQUIVALENTES DISTINTOS OU ENTRE ESTES E ENTIDADES DA ADMINISTRACAO INDIRETA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.01.00','ADMINISTRACAO DIRETA ','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE IGUALOU DE DIFERENTE UNIDADE ORCAMENTARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.01.01','CREDITOS RECEBIDOS ','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO DIRETA DE OUTROS ORGAOS E ENTIDADES.  ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.01.09','(-) CREDITOS TRANSFERIDOS ','REGISTRA A MOVIMENTACAO DE CREDITOS DE ENTIDADES DA ADMINISTRACAO INDIRETA OU ENTRE ORGAOS DA ADMINISTRACAO DIRETA DE UNIDADE ORCAMENTARIA DIFERENTE.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.02.00','ADMINISTRACAO INDIRETA ','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE IGUALOU DE DIFERENTE UNIDADE ORCAMENTARIA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.02.01','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA DO ORGAO EMITENTE. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.02.09','(-) CREDITOS TRANSFERIDOS ','REGISTRA A MOVIMENTACAO DE CREDITOS DE ORGAOS DA ADMINISTRACAO DIRETA OU ENTRE ENTIDADES DA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA, NAO FORMALIZADA A TERMO DE CONTRATO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.03.00','ALTERACAO DE CREDITOS MOVIMENTADOS ','COMPREENDE O VALOR DA ALTERACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.03.01','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA-QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.03.02','(-) REDUCAO ','REGISTRA O VALOR DA REDUCAO DO CREDITO DISPONIVEL POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA-QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.2.04.00','AJUSTE POR VARIACAO CAMBIAL- EXTERNA ','COMPREENDE VALOR DO CREDITO REFERENTE A AJUSTE POR VARIACAO DA TAXA CAMBIAL NA DESCENTRALIZACAO EXTERNA (DESTAQUE).','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.00.00','OUTRAS DESCENTRALIZACOES DE CREDITOS ','COMPREENDE AS MOVIMENTACOES DE CREDITOS RECEBIDOS POR CISAO, FUSAO, EXTINCAO, COMPENSACAO E OUTRAS TRANSACOES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.01.00','CREDITOS EXT. RECEB. POR FUSAO/CISAO/EXTINCAO ','REGISTRA O VALOR DOS CREDITOS RECEBIDOS POR DESCENTRALIZACAO EXTERNA DECORRENTES DE FUSAO, CISAO OU EXTINCAO DE ORGAOS, ENTIDADES OU UG''S DURANTE O EXERCICIO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.02.00','CREDITOS INT. RECEB. POR FUSAO/CISAO/EXTINCAO ','REGISTRA O VALOR DOS CREDITOS RECEBIDOS POR DESCENTRALIZACAO INTERNA DECORRENTES DE FUSAO, CISAO OU EXTINCAO DE ORGAOS, ENTIDADES OU UG''S DURANTE O EXERCICIO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.03.00','MOVIMENTACAO DE CREDITO-PLANO DE ACAO INICIAL ','COMPREENDE O VALOR DE TRANSFERENCIAS DE CREDITOS ORIGINARIOS DO PLANO DE ACAO INICIAL-PAI. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.03.01','PROVISAO RECEBIDA REF. DOTACAO DO P.A.I ','REGISTRA O VALOR DA PROVISAO RECEBIDA REFERENTE A DOTACAO DECORRENTE DO PLANO DE ACAO INICIAL-P.A.I DO COMANDO DA MARINHA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.03.02','PROVISAO RECEBIDA CONTIDA REF. DOTACAO P.A.I ','REGISTRA O VALOR DA PROVISAO RECEBIDA CONTIDA REFERENTE A DOTACAO DECORRENTE DO PLANO DE ACAO INICIAL-P.A.I DO COMANDO DA MARINHA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.03.03','PROVISAO RECEBIDA INDISPON. REF.DOTACAO P.A.I','REGISTRA O VALOR DA PROVISAO RECEBIDA INDISPONIBILIZADA REFERENTE A DOTACAO DECORRENTE DO PLANO DE ACAO INICIAL-P.A.I DO COMANDO DA MARINHA ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.03.09','(-) OUTRAS PROVISOES RECEBIDA REF.DOTACAO P.A.I ','REGISTRA O VALOR DA CONTRAPARTIDA REFERENTES AS CONTAS 522290300.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.2.9.04.00','AJUSTE POR VARIACAO CAMBIAL- OUTRAS DESCENTRALIZACOES ','COMPREENDE VALOR DO CREDITO REFERENTE A AJUSTE POR VARIACAO DA TAXA CAMBIAL EM OUTRAS DESCENTRALIZACOES','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.3.0.00.00','DETALHAMENTO DE CREDITO ','COMPREENDE O SOMATORIO RELATIVOS AS DOTACOES DETALHADAS RELATIVAS A CADA ACAO ORCAMENTARIA (PROJETO, ATIVIDADE OU OPERACOES ESPECIAIS). ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.3.1.00.00','CREDITOS A DETALHAR','COMPREENDE O VALOR DOS CREDITOS A DETALHAR POR PLANO INTERNO, FONTE DE RECURSOS, UG RESPONSAVEL E NATUREZA DE DESPESA (ELEMENTO DE DESPESA E / OU MODALIDADE DE APLICACAO), EFETIVADOS POR MEIO DA TRANSACAO DETAORC ESPECIES 1 E 2, NA UG EMITENTE DO DOCUMENTO - ND.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORCAMENTARIA','COMPREENDE O SOMATORIO DOS VALORES DAS DESPESAS PRE-EMPENHADAS E EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.00.00','PRE-EMPENHOS DA DESPESA ','COMPREENDE O CREDITO ORCAMENTARIO PRE-EMPENHADO, PARA ATENDER OBJETIVO ESPECIFICO, NOS CASOS EM QUE A DESPESA A SER REALIZADA, POR SUAS CARACTERISTICAS, EXIGE UM INTERVALO DE TEMPO DESDE A DECISAO DA REALIZACAO DA DESPESA ATE A EFETIVACAO DA EMISSAO DE NE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.01.00','PRE-EMPENHOS EMITIDOS','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS PELA PROPRIA UNIDADE GESTORA DETENTORA PELO CREDITO DISPONIVEL. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.02.00','REFORCO DE PRE-EMPENHO','REGISTRA O REFORCO DOS PRE-EMPENHOS EMITIDOS PELA PROPRIA UNIDADE GESTORA DETENTORA PELO CREDITO DISPONIVEL. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.03.00','PRE-EMPENHOS TRANSFERIDOS','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS E TRANSFERIDOS, COM A TRANSFERENCIA DO CREDITO ORCAMENTARIO PARA OUTRA UNIDADE GESTORA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.04.00','REFORCO DE PRE-EMPENHOS TRANSFERIDOS','REGISTRA O REFORCO DOS PRE-EMPENHOS EMITIDOS COM A TRANSFERENCIA DO CREDITO ORCAMENTARIO PARA OUTRA UNIDADE GESTORA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.05.00','PRE-EMPENHOS RECEBIDOS POR TRANSFERENCIA ','REGISTRA OS VALORES DOS PRE-EMPENHOS RECEBIDOS POR TRANSFERENCIA DE OUTRA UNIDADE GESTORA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.1.06.00','REFORCO DE PRE-EMPENHOS RECEBIDOS POR TRANSFERENCIA','REGISTRA O REFORCO DOS PRE-EMPENHOS RECEBIDOS POR TRANSFERENCIA DE OUTRA UNIDADE GESTORA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.00.00','EMPENHOS POR EMISSAO ','COMPREENDE O SOMATORIO DOS VALORES EMPENHADOS POR DETALHAMENTO ESPECIFICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.01.00','EMPENHOS POR NOTA DE EMPENHO + SUBITEM ','COMPREENDE O CONTROLE DOS EMPENHOS EMITIDOS, REFORCADOS E TRANSFERIDOS, QUE ENVOLVAM DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.01.01','EMISSAO DE EMPENHOS ','REGISTRA O VALOR DA EMISSAO DE EMPENHO DA DESPESA, INCLUSIVE AQUELAS QUE FORAM OBJETO DE PRE-EMPENHO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.01.02','REFORCO DE EMPENHOS ','REGISTRA O VALOR DA EMISSAO DE EMPENHO DE DESPESA VISANDO A SUPLEMENTAR O EMPENHO ORIGINAL. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.01.03','EMPENHOS POR TRANSFERENCIA','REGISTRA O VALOR DAS TRANSFERENCIAS DE EMPENHO EM VIRTUDE DE FUSAO, CISAO E EXTINCAO DE ORGAOS, ENTIDADES OU UG E OUTROS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.01.04','EMPENHOS LIQUIDADOS - CONTROLE DA UO','REGISTRA O VALOR DA CONTRAPARTIDA DA CONTA CONTABIL QUE REGISTRA O VALOR DA DESPESA LIQUIDADA EXECUTADA POR UG DIFERENTE DA UO EM DECORRENCIA DE DESCENTRALIZACAO DE CREDITO.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.00','EMPENHOS POR MODALIDADE DE LICITACAO ','COMPREENDE O SOMATORIO DOS VALORES DA EMISSAO DE EMPENHOS DE DESPESAS COM LICITACOES PARA OBRAS, SERVICOS, FORNECIMENTOS OU ALIENACOES, BEM COMO SUAS DISPENSAS E INEXIGIBILIDADES. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.01','CONCORRENCIA ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCORRENCIA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.02','TOMADA DE PRECOS ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO TOMADA DE PRECOS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.03','CONVITE ',' REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONVITE. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.04','CONCURSO ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE LICITACAO CONCURSO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.05','PREGAO ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE PREGAO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.06','CONSULTA ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS NA MODALIDADE DE CONSULTA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.07','DISPENSAVEL POR LIMITE ','REGISTRA O VALOR DO EMPENHOS EMITIDOS POR DISPENSA DE LICITACAO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.08','OUTRAS DISPENSAS DE LICITACAO','REGISTRA O VALOR DO EMPENHOS EMITIDOS POR DISPENSA DE LICITACAO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.02.09','LICITACAO INEXIGIVEL ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PELA REALIZACAO DE DESPESAS EM QUE E INEXIGIVEL A LICITACAO QUANDO HOUVER INVIABILIDADE DE COMPETICAO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.00',' NAO APLICAVEL ','COMPREENDE O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.01','SUPRIMENTO DE FUNDOS - ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS RELATIVOS A SUPRIMENTOS DE FUNDOS PARA ATENDER DESPESAS EVENTUAIS, INCLUSIVE EM VIAGENS E COM SERVICOS ESPECIAIS, DESPESA DE CARATER SIGILOSO OU PARA ATENDER DESPESAS DE PEQUENO VULTO, DE ACORDO COM A LEGISLACAO VIGENTE. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.02','PESSOAL E ENCARGOS SOCIAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO, REFERENTES A PESSOAL E ENCARGOS SOCIAIS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.03','TRANSFERENCIAS CONSTITUCIONAIS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO, REFERENTES A TRANSFERENCIAS CONSTITUCIONAIS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.04','TRANSFERENCIAS VOLUNTARIAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO, REFERENTES A TRANSFERENCIAS VOLUNTARIAS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.05','AMORTIZACAO DA DIVIDA','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO, REFERENTES A AMORTIZACAO DA DIVIDA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.06','RESSARCIMENTOS E RESTITUICOES','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO, REFERENTES A RESSARCIMENTOS E RESTITUICOES. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.03.09','NAO APLICAVEL - OUTRAS DESPESAS','REGISTRA O VALOR DOS EMPENHOS EMITIDOS PARA REALIZACAO DE DESPESAS EM QUE NAO SE APLICA A LICITACAO, REFERENTES A OUTRAS DESPESAS. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.06.00','EMPENHOS POR CREDOR ','COMPREENDE O SOMATARIO DOS VALORES DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIOS DO EMPENHO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.06.01','VALORES COMPROMETIDOS ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIO DO EMPENHO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.06.02','VALORES TRANSFERIDOS ','REGISTRA O VALOR DOS EMPENHOS EMITIDOS CONTROLADOS POR BENEFICIARIO DO EMPENHO E TRANSFERIDOS PARA OUTRA UNIDADE GESTORA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.2.06.04','VALORES LIQUIDADOS TRANSFERIDOS ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS TRANSFERIDOS COM CONTROLE DE EMPENHO ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.3.00.00','GASTOS REALIZADOS ','COMPREENDE O VALOR DO CONTROLE DE GASTOS POR UGR E POR CELULA DA DESPESA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.4.00.00','EXECUCAO FISICA DA DESPESA ','COMPREENDE O VALOR DA DESPESA A APROPRIAR NO MODULO DA PROGRAMACAOO ORCAMENTARIA - PROGORCAM. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.2.2.9.4.01.00','EMPENHOS A APROPRIAR ','REGISTRA O VALOR DOS EMPENHOS A APROPRIAR NO MODULO DA PROGRAMACAO ORCAMENTARIA-PROGORCAM, PARA FUTURA EXECUCAO FISICA DA DESPESA. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.0.0.0.00.00','INSCRICAO DE RESTOS A PAGAR','COMPREENDE O SOMATORIO RELATIVO AO VALOR DA INSCRICAO DAS DESPESAS EMPENHADAS E NAO PAGAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.1.0.0.00.00','INSCRICAO DE RP NAO PROCESSADOS','COMPREENDE O SOMATORIO DOS VALORES INSCRITOS EM RESTOS A PAGAR NAO-PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS E NAO LIQUIDADAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.1.1.0.00.00','RP NAO PROCESSADOS INSCRITOS','REGISTRA OS VALORES INSCRITOS EM RESTOS A PAGAR NAO-PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS E NAO LIQUIDADAS ATE O ULTIMO DIA DO EXERCICIO FINANCEIRO.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.1.2.0.00.00','RP NAO PROCESSADOS - EXERCICIOS ANTERIORES','REGISTRA O VALOR DE RESTOS A PAGAR NAO PROCESSADOS RELATIVO A EXERCICIOS ANTERIORES QUE NAO FORAM CANCELADOS PORQUE TIVERAM SEU PRAZO DE VALIDADE PRORROGADO.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.1.3.0.00.00','RP NAO PROCESSADOS RESTABELECIDOS','REGISTRA O VALOR POR RESTABELECIMENTO DE EMPENHO DE RESTOS A PAGAR JA CANCELADOS EM EXERCICIOS ANTERIORES COM BASE EM ATO NORMATIVO ESPECIFICO. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.1.6.0.00.00','RP NAO PROCESSADOS RECEBIDOS POR TRANSFERENCIA','REGISTRA O VALOR DA TRANSFERENCIA DE RESTOS A PAGAR NAO PROCESSADOS DECORRENTE DE TRANSFORMACAO, CISAO, FUSAO E EXTINCAO DE ORGAOS OU UG.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.1.7.0.00.00','RP NAO PROCESSADOS - INSCRICAO NO EXERCICIO ','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 531100000. ','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.2.0.0.00.00','INSCRICAO DE RP PROCESSADOS ','COMPREENDE O SOMATORIO DOS VALORES INSCRITOS EM RESTOS A PAGAR PROCESSADOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.2.1.0.00.00','RP PROCESSADOS - INSCRITOS','REGISTRA O SOMATORIO DOS VALORES INSCRITOS EM RESTOS A PAGAR PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS, LIQUIDADAS E NAO PAGAS NO EXERCICIO FINANCEIRO EM QUE FOI EMPENHADO.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.2.2.0.00.00','RP PROCESSADOS - EXERCICIOS ANTERIORES','REGISTRA OS VALORES DE RESTOS A PAGAR PROCESSADOS RELATIVOS AS DESPESAS EMPENHADAS, LIQUIDADAS E NAO PAGAS NO EXERCICIO FINANCEIRO SUBSEQUENTE.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('5.3.2.6.0.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERENCIA','REGISTRA O VALOR DA TRANSFERENCIA DE RESTOS A PAGAR PROCESSADOS DECORRENTE DE TRANSFORMACAO, CISAO, FUSAO E EXTINCAO DE ORGAOS OU UG.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.0.0.0.0.00.00','CONTROLES DA EXECUCAO DO PLANEJAMENTO E ORCAMENTO','COMPREENDE AS CONTAS COM FUNCAO DE REGISTRA OS ATOS E FATOS LIGADOS A EXECUCAO ORCAMENTARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.0.0.0.00.00','EXECUCAO DO PLANEJAMENTO','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS RELATIVOS A EXECUCAO DOS PROGRAMAS E ACOES (PROJETOS, ATIVIDADES E OPERACOES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL E PROJETO DE LEI ORCAMENTARIA ANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.1.0.0.00.00','EXECUCAO DO PPA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS RELATIVOS A EXECUCAO DOS PROGRAMAS E ACOES (PROJETOS, ATIVIDADES E OPERACOES ESPECIAIS) ESTABELECIDOS NO PLANO PLURIANUAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.1.1.0.00.00','PPA A ALOCAR NO PLOA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL DURANTE O SEU PERIODO DE VIGENCIA DETALHADO POR PROGRAMAS DE TRABALHO A SEREM SELECIONADOS NA ELABORACAO DO PLOA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.1.2.0.00.00','PPA ALOCADO NA LOA ','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL APROVADO, DETALHADO POR PROGRAMA DE TRABALHO ALOCADO NA LOA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.1.3.0.00.00','PPA EXECUTADO ','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DO PLANO PLURIANUAL EXECUTADO NO SEU PERIODO DE VIGENCIA, DETALHADO POR PROGRAMA DE TRABALHO AUTORIZADO NAS LEIS ORCAMENTARIAS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.0.0.00.00','EXECUCAO DO PLOA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DE RECEITAS E DESPESAS PREVISTOS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.0.00.00','PROCESSAMENTO DO PLOA -RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.1.00.00','PLOA COM INDICADOR DE RESULTADO - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO DE LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.1.01.00','PROJ.INICIAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO INICIAL DE LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.1.02.00','PROJ.FINAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO FINAL DA LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.2.00.00','PLOA SEM INDICADOR DE RESULTADO - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS PREVISTOS NO PROJETO DE LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO - RECEITA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.2.01.00','PROJ.INICIAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS DA RECEITA PREVISTOS NO PROJETO INICIAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.1.2.02.00','PROJ.FINAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES MONETARIOS PREVISTOS NO PROJETO FINAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.0.00.00','PROCESSAMENTO DO PLOA -DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.1.00.00','PLOA COM INDICADOR DE RESULTADO - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA A DESPESA NO PROJETO DE LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.1.01.00','PROJ.INICIAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO INICIAL DA LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.1.02.00','PROJ.FINAL DA LEI ORCAMENT.C/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO FINAL DA LEI ORCAMENTARIA COM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.2.00.00','PLOA SEM INDICADOR DE RESULTADO - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA A DESPESA NO PROJETO DE LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.2.01.00','PROJ.INICIAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO INICIAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.1.2.2.2.02.00','PROJ.FINAL DA LEI ORCAMENT.S/ INDIC.RESULT.','REGISTRA OS VALORES PERTINENTES AOS CREDITOS DO PROJETO FINAL DA LEI ORCAMENTARIA SEM INDICADOR DE RESULTADO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.0.0.0.00.00','EXECUCAO DO ORCAMENTO ','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A REALIZACAO DA RECEITA, EXECUCAO DA DESPESA E SUAS ALTERACOES NO ORCAMENTO GERAL DA UNIAO DURANTE O EXERCICIO FINANCEIRO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.0.0.00.00','EXECUCAO DA RECEITA','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A REALIZACAO DA RECEITA PUBLICA APROVADA PELA LEI ORCAMENTARIA ANUAL E SUAS ALTERACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.1.0.00.00','RECEITA A REALIZAR','REGISTRA O SOMATORIO DOS VALORES RELATIVOS A RECEITA PUBLICA APROVADA PELA LEI ORCAMENTARIA ANUAL E SUAS ALTERACOES, DETALHADA POR NATUREZA DA RECEITA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.2.0.00.00','RECEITA REALIZADA ','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS RECEITAS REALIZADAS, DETALHADA POR NATUREZA DE RECEITA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.3.0.00.00','(-) DEDUCOES DA RECEITA ORCAMENTARIA','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS (TRANSFERENCIA, RESTITUICOES,RENUNCIAS E OUTRAS ....), DETALHADA POR NATUREZA DE RECEITA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.3.1.00.00','(-) DEDUCOES DA RECEITA ORCAMENTARIA POR TRANSFERENCIA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERENCIA, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.3.2.00.00','(-) DEDUCOES DA RECEITA ORCAMENTARIA POR RESTITUICAO','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR RESTITUICAO, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.3.3.00.00','(-) DEDUCOES DA RECEITA ORCAMENTARIA POR RENUNCIA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR RENUNCIA, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.1.3.4.00.00','(-) OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS OUTRAS DEDUCOES DE RECEITAS REALIZADAS, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.0.0.00.00','EXECUCAO DA DESPESA ','COMPREENDE O SOMATORIO DA DISPONIBILIDADE DE CREDITO ORCAMENTARIO E DA EXECUCAO DA DESPESA EM SUAS DIVERSAS ETAPAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.0.00.00','DISPONIBILIDADES DE CREDITO ','COMPREENDE O SOMATORIO DA DISPONIBILIDADE DE CREDITO ORCAMENTARIO E SUAS ALTERACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.1.00.00','CREDITO DISPONIVEL','REGISTRA O VALOR DA DISPONIBILIDADE DE CREDITO REFERENTE A DOTACAO INICIAL E ADICIONAL APROVADA NO ORCAMENTO GERAL DA UNIAO NA LOA OU LEI ESPECIFICA OU ANTECIPADA PELA LEI DE DIRETRIZES ORCAMENTARIAS - LDO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.00.00','CREDITO INDISPONIVEL ','COMPREENDE O VALOR DA INDISPONIBILIDADE DE CREDITO ORCAMENTARIO PELO SEU CONTINGENCIAMENTO OU LIBERACAO PENDENTES DE AUTORIZACAO LEGISLATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.00','BLOQUEIO DE CREDITO ','COMPREENDE O VALOR DA DISPONIBILIDADE DE CREDITOS ORCAMENTARIOS POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.01','CREDITO BLOQUEADO PARA REMANEJAMENTO ','REGISTRA O VALOR DA INDISPONIBILIDADE DE CREDITOS ORCAMENTARIOS PELA SETORIAIS DE ORCAMENTO PARA REMANEJAMENTO DE FONTE OU GRUPO DE DESPESA','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.02','CREDITO BLOQUEADO PARA CONTROLE INTERNO ','REGISTRA OS VALORES DE CREDITOS INDISPONIBILIZADOS INTERNAMENTE PELOS ORGAOS PARA CONTROLE.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.03','CRED.DE PROJETOS BLOQUEADO P/CONTROLE INTERNO ','REGISTRA OS VALORES DE CREDITOS DESTINADOS A PROJETOS INDISPONIBILIZADOS INTERNAMENTE PELOS ORGAOS PARA SEU CONTROLE. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.04','CREDITO CONTIDO PELA SOF - PAC','REGISTRA O VALOR DO CREDITO ORCAMENTARIO CONTIDO PELA SECRETARIA DE ORCAMENTO FEDERAL- SOF INCLUSIVE POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD, REFERENTE AO PROGRAMA DE ACELERACAO DO CRESCIMENTO - PAC.  ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.05','CREDITO CONTIDO PELA SOF - EXCETO PAC','REGISTRA O VALOR DO CREDITO ORCAMENTARIO BLOQUEADO (EXCETO OS CREDITOS DO PROGRAMA DE ACELERACAO DO CRESCIMENTO-PAC)P/SECRETARIA DE ORCAMENTO FEDERAL- SOF - PARA POSTERIOR AJUSTE PELAS UNIDADES ORCAMENTARIAS E A EFETIVACAO DO BLOQUEIO DEFINITIVO PELA SOF. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.01.06','CREDITO BLOQUEADO PARA REMANEJAMENTO PELA SOF',' REGISTRA O VALOR DE CREDITO BLOQUEADO PARA REMANEJAMENTO EFETIVADO PELA SECRETARIA DE ORCAMENTO FEDERAL APOS OCORRER O REGISTRO DE BLOQUEIO DE CREDITO PELA SETORIAL ORCAMENTARIA DO ORGAO.  ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.02.00','CREDITO PRE-EMPENHADO ','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS PELA UNIDADE OU POR OUTRA UNIDADE GESTORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.2.99.00','OUTRAS INDISPONIBILIDADES','REGISTRA O VALOR DAS INDISPONIBILIDADES DE CREDITOS ORCAMENTARIOS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.3.00.00','CREDITO UTILIZADO','COMPREENDE O SOMATORIO DOS VALORES REFERENTES AOS CREDITOS ORCAMENTARIOS EMPENHADOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.3.01.00','CREDITO EMPENHADO A LIQUIDAR','REGISTRA O VALOR DA DESPESA EMPENHADA A SER LIQUIDADA','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.3.02.00','CREDITO EMPENHADO EM LIQUIDACAO','REGISTRA O VALOR DA DESPESA CUJO FATO GERADOR JA OCORREU, MAS QUE AINDA NAO FORAM CONFERIDOS O OBJETO, O CREDOR E O VALOR, OU SEJA, NAO HOUVE A LIQUIDACAO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.3.03.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','REGISTRA O VALOR DA APROPRIACAO DAS DESPESAS EMPENHADAS COM POSTERIOR VERIFICACAO DE SUA REGULARIDADE POR CONSTITUICAO DO DIRETO DO CREDOR.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.3.04.00','CREDITO EMPENHADO - PAGO','DEMONSTRA VALOR DA DESPESA EMPENHADA PAGA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.1.3.99.00','(-) OUTROS CREDITOS UTILIZADOS','REGISTRA A CONTRAPARTIDA DE DESPESAS REALIZADAS PELAS ENTIDADES OU ORGAO DA ADM. DIRETA/INDIRETA QUE UTILIZAM O SIAFI NO MODULO PARCIAL. REGISTRA A CONTRAPARTIDA DE DESPESAS LIQUIDADAS NA ROTINA DE SUPRIMENTO DE FUNDOS PARA EVITAR A EMISSAO DE LISTA DE ITEM (LI) PARA RECLASSIFICACAO DA DESPESA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.0.00.00','MOVIMENTACAO DE CREDITOS CONCEDIDOS ','REGISTRA O SOMATORIO DOS VALORES DOS CREDITOS ORCAMENTARIOS CONCEDIDOS ATRAVES DE DESTAQUE, PROVISAO OU POR FUSAO, CISAO OU EXTINCAO DE UNIDADES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.00.00','DESCENTRALIZACAO INTERNA DE CREDITOS - PROVISAO ','COMPREENDE OS VALORES DOS CREDITOS DESCENTRALIZADOS DAS UNIDADES ORCAMENTARIAS PARA AS UNIDADES ADMINISTRATIVAS SOB SUA JURISDICAO OU ENTRE ESTAS, NO AMBITO DO PROPRIO MINISTERIO, SECRETARIA OU ORGAO EQUIVALENTE, CONCEDIDOS AO LONGO DO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.01.00','PROVISAO CONCEDIDA ','REGISTRA O CREDITO CONCEDIDO PELA UNIDADE ORCAMENTARIA A PARTIR DE SUA PROPRIA DOTACAO OU DE UM DESTAQUE A SEU FAVOR, PARA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, NO AMBITO DO PROPRIO MINISTERIO OU ORGAO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.02.00','PROVISAO CONCEDIDA - BLOQUEADA ','REGISTRA O BLOQUEIO DOS CREDITOS ORCAMENTARIOS CONCEDIDOS MEDIANTE PROVISAO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.03.00','PROVISAO CONCEDIDA - VARIACAO CAMBIAL','REGISTRA A PARCELA DE CREDITO CONCEDIDO POR UMA UNIDADE ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO CREDITO ORCAMENTARIO OU ADICIONAL REFERENTE A VARIACAO CAMBIAL, DENTRO DO MESMO ORGAO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS ','REGISTRA O VALOR DA VARIACAO DE CREDITOS ORCAMENTARIOS DISPONIVEIS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.09.01','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.1.09.09','(-) REDUCAO ','REGISTRA O VALOR DA REDUCAO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.00.00','DESCENTRALIZACAO EXTERNA DE CREDITOS - DESTAQUE ','COMPREENDE A DESCENTRALIZACAO DO CREDITO INICIAL OU ADICIONAL CONCEDIDO DE UNIDADES OU ORGAOS PERTENCENTES A MINISTERIOS, SECRETARIAS E ORGAOS EQUIVALENTES DISTINTOS OU ENTRE ESTES E ENTIDADES DA ADMINISTRACAO INDIRETA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.01.00','ADMINISTRACAO DIRETA ','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.01.01','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.02.00','ADMINISTRACAO INDIRETA ','REGISTRA O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DA ENTIDADE DA ADMINISTRACAO INDIRETA TRANSFERIDORA. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.02.01','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE SUA CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO INDIRETA TRANSFERIDORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.03.00','DESTAQUE CONCEDIDO - VARIACAO CAMBIAL ','REGISTRA A PARCELA DE CREDITO CONCEDIDO POR UMA UNIDADE ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO CREDITO ORCAMENTARIO OU ADICIONAL REFERENTE A VARIACAO CAMBIAL, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS ','REGISTRA O VALOR DA VARIACAO DE CREDITOS ORCAMENTARIOS DISPONIVEIS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.09.01','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.2.09.09','(-) REDUCAO ','REGISTRA O VALOR DA REDUCAO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.3.00.00','AJUSTE POR VARIACAO CAMBIAL - INTERNA','REGISTRA O VALOR DOS AJUSTES DECORRENTES DA VARIACAO DA TAXA CAMBIAL NA DESCENTRALIZACAO INTERNA (PROVISAO).','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.4.00.00','AJUSTE POR VARIACAO CAMBIAL - EXTERNA ','REGISTRA O VALOR DOS AJUSTES DECORRENTES DA VARIACAO DA TAXA CAMBIAL NA DESCENTRALIZACAO EXTERNA (DESTAQUE).','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.2.9.00.00','OUTRAS DESCENTRALIZACOES DE CREDITOS ','COMPREENDE AS MOVIMENTACOES DE CREDITOS CONCEDIDOS POR CISAO, FUSAO, EXTINCAO, COMPENSACAO E OUTRAS TRANSACOES. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','REGISTRA O DETALHAMENTO DAS DOTACOES ORCAMENTARIAS RELATIVAS A CADA PROGRAMA DE TRABALHO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.3.1.00.00','CREDITOS DETALHADOS','REGISTRA O VALOR DOS CREDITOS DETALHADOS POR PLANO INTERNO, FONTE DE RECURSOS, UG RESPONSAVEL E NATUREZA DE DESPESA (ELEMENTO DE DESPESA E / OU MODALIDADE DE APLICACAO), EFETIVADOS POR MEIO DA TRANSACAO DETAORC, ESPECIES 1 E 2, NA UG EMITENTE DO DOCUMENTO - ND.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORCAMENTARIA','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS PRE-EMPENHADAS E EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.00.00','DESPESA PRE-EMPENHADA ','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS PRE-EMPENHADAS PELA PROPRIA UNIDADE GESTORA, TRANSFERIDOS OU RECEBIDOS POR TRANSFERENCIA, POR DETALHAMENTO ESPECIFICO E SUAS RESPECTIVAS ANULACOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.01.00','PRE-EMPENHOS A EMPENHAR ','REGISTRA OS VALORES DOS PRE-EMPENHOS E/OU SEUS RESPECTIVOS REFORCOS, EMITIDOS PELA PROPRIA UNIDADE GESTORA DETENTORA DO CREDITO DISPONIVEL. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.02.00','PRE-EMPENHOS EMPENHADOS ','REGISTRA OS VALORES DOS PRE-EMPENHOS E/OU SEUS RESPECTIVOS REFORCOS, EMITIDOS E EMPENHADOS PELA PROPRIA UNIDADE GESTORA DETENTORA DO CREDITO DISPONIVEL. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.03.00','PRE-EMPENHOS TRANSFERIDOS A EMPENHAR','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS E TRANSFERIDOS PELA UNIDADE GESTORA CONCEDENTE COM A TRANSFERENCIA DE CREDITOS ORCAMENTARIOS. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.04.00','PRE-EMPENHOS TRANSFERIDOS EMPENHADOS','REGISTRA O CONTROLE DOS PRE-EMPENHOS EMITIDOS E TRANSFERIDOS PELA UNIDADE CONCEDENTE, CUJO EMPENHO FOI EMITIDO PELA UNIDADE GESTORA RECEBEDORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.05.00','PRE-EMPENHOS RECEBIDOS A EMPENHAR','REGISTRA OS VALORES DOS PRE-EMPENHOS A EMPENHAR RECEBIDOS POR TRANFERENCIA DE OUTRA UNIDADE GESTORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.06.00','PRE-EMPENHOS RECEBIDOS EMPENHADOS','REGISTRA O CONTROLE DOS PRE-EMPENHOS RECEBIDOS POR TRANSFERENCIA E EMPENHADOS PELA UNIDADE GESTORA RECEBEDORA DO CREDITO ORCAMENTARIO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.09.00','ANULACAO DE PRE-EMPENHOS ','COMPREENDE OS VALORES DOS PRE-EMPENHOS ANULADOS PELA PROPRIA UG E/OU DE PRE-EMPENHOS TRANSFERIDOS E RECEBIDOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.09.01','ANULACAO DE PRE-EMPENHOS - PROPRIA UG','REGISTRA OS VALORES DOS PRE-EMPENHOS ANULADOS PELA PROPRIA UG.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.09.02','ANULACAO DE PRE-EMPENHOS TRANSFERIDOS','REGISTRA OS VALORES DOS PRE-EMPENHOS ANULADOS PELA UG TRANSFERIDORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.1.09.03','ANULACAO DE PRE-EMPENHOS RECEBIDOS','REGISTRA OS VALORES DOS PRE-EMPENHOS ANULADOS PELA UG RECEBEDORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.00.00','EMISSAO DE EMPENHO','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS EMPENHADAS POR DETALHAMENTO ESPECIFICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.00','EMPENHOS POR NOTA DE EMPENHO + SUBITEM','COMPREENDE O VALOR DA EMISSAO DE DOCUMENTOS ATRAVES DOS QUAIS SAO REGISTRADOS OS ESTAGIOS DAS DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.01','EMPENHOS A LIQUIDAR ','REGISTRA O VALOR DOS EMPENHOS DE DESPESAS PENDENTES DE LIQUIDACAO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.02','EMPENHOS EM LIQUIDACAO','REGISTRA O SOMATORIO DAS DESPESAS CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.03','EMPENHOS LIQUIDADOS ','REGISTRA O VALOR DOS EMPENHOS APOS VERIFICACAO DO DIREITO ADQUIRIDO PELO CREDOR OU ENTIDADE BENEFICIARIA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.04','EMPENHOS TRANSFERIDOS','REGISTRA O VALOR DOS EMPENHOS TRANSFERIDOS PARA OUTRA UNIDADE GESTORA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.05','EMPENHOS LIQUIDADOS - CONTROLE DA UO','REGISTRA O VALOR DA DESPESA LIQUIDADA EXECUTADA POR UG DIFERENTE DA UO EM DECORRENCIA DE DESCENTRALIZACAO DE CREDITO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.06','AJUSTE POR VARIACAO CAMBIAL - EMP LIQ UO ','REGISTRA O VALOR POR AJUSTE DA TAXA CAMBIAL NA CONTA DE EMPENHO LIQUIDADO - CONTROLE DA UO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.07','ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA A DOTACAO CORRESPONDENTE.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.01.08','CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','REGISTRA O VALOR REFERENTE A REVERSAO TOTAL OU PARCIAL DE DESPESA ORCAMENTARIA A DOTACAO CORRESPONDENTE POR FALTA DE DISPONIBILIDADE DE CAIXA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.00','EMPENHOS P/ MOD. DE LICITACAO - A LIQUIDAR ','COMPREENDE O VALOR DOS EMPENHOS A LIQUIDAR, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.01','CONCORRENCIA ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCORRENCIA','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.02','TOMADA DE PRECOS ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-TOMADA DE PRECOS','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.03','CONVITE ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.04','CONCURSO ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.05','PREGAO ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE PREGAO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.06','CONSULTA ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, CONTROLADOS NA MODALIDADE DE CONSULTA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.07','DISPENSAVEL POR LIMITE ','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITACAO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.08','OUTRAS DISPENSAS DE LICITACAO','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR DISPENSA DE LICITACAO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.09','LICITACAO INEXIGIVEL ','REGISTRA O VALOR DO EMPENHOS A LIQUIDAR, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.10','NAO APLICAVEL ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.02.11','SUPRIMENTOS DE FUNDOS ','REGISTRA O VALOR DOS EMPENHOS A LIQUIDAR DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.00','EMPENHO P/ MODALID. DE LICITACAO - LIQUIDADO ','COMPREENDE O VALOR DOS EMPENHOS LIQUIDADOS, COM CONTROLE POR MODALIDADE DE LICITACAO OU POR SUA DISPENSA OU INEXIGIBILIDADE. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.01','CONCORRENCIA ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCORRENCIA','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.02','TOMADA DE PRECOS ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-TOMADA DE PRECOS','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.03','CONVITE ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONVITE.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.04','CONCURSO ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONCURSO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.05','PREGAO ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-PREGAO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.06','CONSULTA','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR MODALIDADE DE LICITACAO-CONSULTA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.07','DISPENSAVEL POR LIMITE ','REGISTRA O VALOR DO EMPENHOS A LIQUIDADOS, CONTROLADOS POR DISPENSA DE LICITACAO NO ASPECTO RELACIONADO AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.08','OUTRAS DISPENSAS DE LICITACAO','REGISTRA O VALOR DO EMPENHOS A LIQUIDADOS, CONTROLADOS POR DISPENSA DE LICITACAO EXCETO AQUELES RELACIONADOS AOS LIMITES MONETARIOS DE DISPENSA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.09','LICITACAO INEXIGIVEL ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, CONTROLADOS POR INEXIGIBILIDADE DE LICITACAO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.10','NAO APLICAVEL ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS, ONDE NAO SE APLICA A LICITACAO, DENTRE OS QUAIS CABE DESTACAR: PESSOAL E ENCARGOS SOCIAIS, TRANSFERENCIAS CONSTITUCIONAIS, TRANSFERENCIAS VOLUNTARIAS, AMORTIZACAO DA DIVIDA E RESSARCIMENTO E RESTITUICOES.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.04.11','SUPRIMENTOS DE FUNDOS ','REGISTRA O VALOR DOS EMPENHOS LIQUIDADOS DESTINADOS A ATENDER SUPRIMENTOS DE FUNDOS, NA FORMA DA LEGISLACAO EM VIGOR.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.00','EMPENHOS POR CREDOR ','COMPREENDE O SOMATORIO DA EXECUCAO DE CREDITOS ORCAMENTARIOS, CONTROLADOS POR BENEFICIARIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.01','VALORES A LIQUIDAR ','REGISTRA O MONTANTE DOS VALORES A LIQUIDAR, A SEREM PAGOS, POR BENEFICIARIOS. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.02','VALORES EM LIQUIDACAO ','REGISTRA O SOMATORIO DAS DESPESAS CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA, CONTROLADOS POR BENEFICIARIO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.03','VALORES LIQUIDADOS A PAGAR ','REGISTRA O MONTANTE DOS VALORES LIQUIDADOS, A SEREM PAGOS, POR BENEFICIARIOS. O SALDO DESTA CONTA EM 31 DE DEZEMEBRO SERA TRANSFERIDO PARA A CONTA 532110000 - RP PROCESSADO INSCRITO EM 01 DE JANEIRO DO EXERCICIO SUBSEQUENTE. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.04','VALORES PAGOS ','REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR BENEFICIARIOS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.05','EMPENHOS INSCRITOS EM RESTOS A PAGAR','REGISTRA O MONTANTE DOS VALORES DOS EMPENHOS INSCRITOS EM RESTOS A PAGAR, CONTROLADOS POR BENEFICIARIO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.2.06.08','VALORES LIQUIDADOS - TRANSFERENCIAS ','REGISTRA O VALOR DE EMPENHOS LIQUIDADOS TRANSFERIDOS PARA PAGAMENTO EM OUTRA UG, CONTROLADOS POR BENEFICIARIO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.3.00.00','GASTOS REALIZADOS ','COMPREENDE O VALOR DA CONTRAPARTIDA DO CONTROLE DE GASTOS POR UGR E POR CELULA DA DESPESA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.4.00.00','EXECUCAO FISICA DA DESPESA ','REGISTRA O VALOR DAS DESPESAS EMPENHADAS A APROPRIAR NO MODULO DA PROGRAMACAO ORCAMENTARIA PROGORCAM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.2.2.9.4.01.00','EMPENHOS A APROPRIAR ','REGISTRA O VALOR DA CONTRAPARTIDA DOS EMPENHOS A APROPRIAR NO MODULO DA PROGRAMACAO ORCAMENTARIA-PROGORCAM, PARA FUTURA EXECUCAO FISICA DA DESPESA. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.0.0.0.00.00','EXECUCAO DE RESTOS A PAGAR','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A TRANSFERENCIA, LIQUIDACAO E PAGAMENTO DAS DESPESAS EMPENHADAS E NAO PAGAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.0.0.00.00','EXECUCAO DE RP NAO PROCESSADOS','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A TRANSFERENCIA, LIQUIDACAO E PAGAMENTO DAS DESPESAS EMPENHADAS, NAO LIQUIDADAS NO EXERCICIO FINANCEIRO DE SUA INSCRICAO E NAO PAGAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.1.0.00.00','RP NAO PROCESSADOS A LIQUIDAR','REGISTRA O VALOR DOS RP NAO-PROCESSADOS AINDA NAO LIQUIDADOS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.2.0.00.00','RP NAO PROCESSADOS EM LIQUIDACAO','REGISTRA O VALOR DOS RP NAO-PROCESSADOS AINDA NAO LIQUIDADOS CUJO FATO GERADOR JA OCORREU.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.3.0.00.00','RP NAO PROCESSADOS LIQUIDADOS A PAGAR ','REGISTRA O VALOR DOS RP NAO-PROCESSADOS, LIQUIDADOS APOS SUA INSCRICAO E AINDA NAO PAGOS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.4.0.00.00','RP NAO PROCESSADOS PAGOS','REGISTRA O VALOR DOS RP NAO-PROCESSADOS, LIQUIDADOS APOS SUA INSCRICAO E PAGOS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.5.0.00.00','RP NAO PROCESSADOS A LIQUIDAR BLOQUEADOS ','REGISTRA O VALOR DE RESTOS A PAGAR NAO PROCESSADOS A LIQUIDAR, BLOQUEADO POR DECRETO. ','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.6.0.00.00','RP NAO PROCESSADOS TRANSFERIDOS','REGISTRA O VALOR DA TRANSFERENCIA DE RESTOS A PAGAR NAO PROCESSADOS PELA DESINCORPORACAO DE SALDOS CREDORES DECORRENTES DE TRANSFORMACAO, CISAO, FUSAO E EXTINCAO DE ORGAOS OU UG.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.7.0.00.00','RP NAO PROCESSADOS - INSCRICAO NO EXERCICIO ','REGISTRA O VALOR DAS DESPESAS EMPENHADAS INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631100000 e 631200000.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.9.0.00.00','RP NAO PROCESSADOS CANCELADOS','COMPREENDE O CANCELAMENTO DE RESTOS A PAGAR NAO PROCESSADOS POR INSUFICIENCIA DE RECURSOS, DE FONTE PROPRIAS, PELA INSCRICAO INDEVIDA OU PARA ATENDER DISPOSITIVO LEGAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.9.1.00.00',' POR INSUFICIENCIA DE RECURSOS','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.1.9.9.00.00','OUTROS CANCELAMENTOS DE RP ','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.0.0.00.00','EXECUCAO DE RP PROCESSADOS','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS A TRANSFERENCIA, LIQUIDACAO E PAGAMENTO DAS DESPESAS EMPENHADAS, LIQUIDADAS NO EXERCICIO FINANCEIRO DE SUA INSCRICAO E NAO PAGAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.1.0.00.00','RP PROCESSADOS A PAGAR ','REGISTRA O VALOR DOS RP PROCESSADOS E NAO PAGOS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.2.0.00.00','RP PROCESSADOS PAGOS ','REGISTRA O VALOR DOS RP PROCESSADOS PAGOS.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.6.0.00.00','RP PROCESSADOS TRANSFERIDOS','REGISTRA O VALOR DA TRANSFERENCIA DE RESTOS A PAGAR PELA DESINCORPORACAO DE SALDOS CREDORES DECORRENTE DE TRANSFORMACAO, CISAO, FUSAO E EXTINCAO DE ORGAOS OU UG.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.9.0.00.00','RP PROCESSADOS CANCELADOS','COMPREENDE O CANCELAMENTO DE RESTOS A PAGAR PROCESSADOS POR INSUFICIENCIA DE RECURSOS, PELA INSCRICAO INDEVIDA OU PARA ATENDER DISPOSITIVO LEGAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.9.1.00.00','POR VALORES E/OU INSCRICOES INDEVIDAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR VALORES E/OU INSCRICOES.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.9.1.01.00','CANCELAMENTO DE RP PROCESSADOS - NE','REGISTRA O VALOR DE RESTOS A PAGAR PROCESSADOS CANCELADOS NO EXERCICIO SEGUINTE, CONTROLADOS POR NOTA DE EMPENHO, COM A RESPECTIVA BAIXA NO PASSIVO FINANCEIRO.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.9.1.02.00',' AJUSTE DE CONTROLE RP DE EXERC ANTERIORES','REGISTRA O VALOR DO AJUSTE DE RESTOS A PAGAR PROCESSADOS CANCELADOS SEM PASSIVO CORRESPONDENTE.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('6.3.2.9.9.00.00','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS OU POR INSCRICAO INDEVIDA.','C','S','O','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.0.0.0.0.00.00','CONTROLES DEVEDORES','COMPREENDE AS CONTAS EM QUE SAO REGISTRADOS ATOS POTENCIAIS E CONTROLES ESPECIFICOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.0.0.0.00.00','ATOS POTENCIAIS','COMPREENDE CONTAS RELACIONADAS AS SITUACOES NAO COMPREENDIDAS NO PATRIMONIO, MAS QUE, DIRETA OU INDIRETAMENTE, POSSAM VIR A AFETA-LO, EXCLUSIVE AS QUE DIZEM RESPEITO A ATOS E FATOS LIGADOS A EXECUCAO ORCAMENTARIA E FINANCEIRA E AS CONTAS COM FUNCAO PRECIPUA DE CONTROLE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.0.0.00.00','ATOS POTENCIAIS ATIVOS','REGISTRA OS ATOS E FATOS QUE POSSAM VIR A AUMENTAR O ATIVO DA ENTIDADE GOVERNAMENTAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.0.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.00','GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.19','GARANTIAS DA DIVIDA PUBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.22','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.01.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.19','GARANTIAS DA DIVIDA PUBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.22','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.02.25','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.03.00','CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.03.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.03.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.04.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.04.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.1.04.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.00','GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.19','GARANTIAS DA DIVIDA PUBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.22','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.01.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.19','GARANTIAS DA DIVIDA PUBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.22','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.02.25','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.03.00','CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.03.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.03.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.04.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.04.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.2.04.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.00','GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO PAIS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAIS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAIS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.19','GARANTIAS DA DIVIDA PUBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.22','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.01.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLENCIA DE OBRIGACAO FINANCEIRA OU CONTRATUAL ASSUMIDO POR ENTE DA FEDERACAO OU ENTIDADE A ELE VINCULADA, NO EXTERIOR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERACOES REALIZADAS NO AMBITO DE FUNDOS, PROGRAMAS E OPERACOES ESPECIAIS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.19','GARANTIAS DA DIVIDA PUBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DIVIDA DE MEDIO E LONGO PRAZOS-DMLP, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.22','APOLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.02.25','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES, SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.03.00','CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.03.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.03.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.04.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.04.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.1.3.04.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.0.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - EXTRA OFSS','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.01.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - EXTRA OFSS','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.01.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.02.00','TERMO DE COOPERACAO - EXTRA OFSS','COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.02.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.03.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV ','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.1.03.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.01.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.01.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.02.00','TERMO DE COOPERACAO - INTRA OFSS','COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.02.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.03.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.2.03.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.01.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.01.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.02.00','TERMO DE COOPERACAO - INTER OFSS','COMPREENDEO VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.02.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERACAO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.03.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES- PORTAL / SICONV','COMPREENDE O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.2.3.03.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.0.00.00','DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.00.00','DIREITOS CONTRATUAIS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.02.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.03.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.06.00','CONTRATOS DE OBRIGACOES INTERNAS','REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.07.00','CONTRATOS DE OBRIGACOES EXTERNAS','REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.1.08.00','TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.','REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCAMENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTOCONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADEPARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.00.00','DIREITOS CONTRATUAIS - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.02.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.03.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.06.00','CONTRATOS DE OBRIGACOES INTERNAS','REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.07.00','CONTRATOS DE OBRIGACOES EXTERNAS','REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.2.08.00','TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.','REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCAMENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTOCONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADEPARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.00.00','DIREITOS CONTRATUAIS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.02.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.03.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGACAO DA ENTEDADE PUBLICA COM TERCEIROS REFEREN-E A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.06.00','CONTRATOS DE OBRIGACOES INTERNAS','REGISTRA O VALOR DO CONTRATO REFERENTE A OBRIGACAO INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.07.00','CONTRATOS DE OBRIGACOES EXTERNAS','REGISTRA O VALOR DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.3.3.08.00','TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.','REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCAMENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTOCONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADEPARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.9.0.00.00','OUTROS ATOS POTENCIAIS ATIVO','COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.9.1.00.00','OUTROS ATOS POTENCIAIS ATIVO - EXTRA OFSS','COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.9.2.00.00','OUTROS ATOS POTENCIAIS ATIVO - INTRA OFSS','COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.1.9.3.00.00','OUTROS ATOS POTENCIAIS ATIVO - INTER OFSS','COMPREENDE OS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.0.0.00.00','ATOS POTENCIAIS PASSIVO','REGISTRA OS ATOS E FATOS QUE POSSAM VIR A AUMENTAR O PASSIVO OU DIMINUIR O ATIVO DA ENTIDADE GOVERNAMENTAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.0.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.00','GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.01.19','OUTRAS GARANTIAS CONCEDIDAS','REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.02.19','OUTRAS GARANTIAS CONCEDIDAS','REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.03.01','CONTRAGARANTIAS SOBRE AVAIS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.03.04','CONTRAGARANTIAS SOBRE FIANCAS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA ','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.04.01','CONTRAGARANTIAS SOBRE AVAIS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.04.04','CONTRAGARANTIAS SOBRE FIANCAS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA ','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.1.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.00','GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.01.19','OUTRAS GARANTIAS CONCEDIDAS','REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.02.19','OUTRAS GARANTIAS CONCEDIDAS','REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.03.01','CONTRAGARANTIAS SOBRE AVAIS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.03.04','CONTRAGARANTIAS SOBRE FIANCAS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA ','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.04.01','CONTRAGARANTIAS SOBRE AVAIS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.04.04','CONTRAGARANTIAS SOBRE FIANCAS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA ','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.2.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.00','GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.01.19','OUTRAS GARANTIAS CONCEDIDAS','REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CREDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA A TERCEIROS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.04','FIANCAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NAO CUMPRA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.07','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.10','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.13','CAUCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS CONCEDIDOS EM CAUCAO, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECIFICA, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.02.19','OUTRAS GARANTIAS CONCEDIDAS','REGISTRA O VALOR REFERENTE A OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.03.01','CONTRAGARANTIAS SOBRE AVAIS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.03.04','CONTRAGARANTIAS SOBRE FIANCAS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA ','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.04.01','CONTRAGARANTIAS SOBRE AVAIS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.04.04','CONTRAGARANTIAS SOBRE FIANCAS ','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA ','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.1.3.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.0.00.00','OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.00.00','OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.01.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.01.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.02.00','CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.02.01','VALORES FIRMADOS','REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.03.00','TRANSFERENCIAS LEGAIS','COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.03.01','VALORES FIRMADOS','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.04.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV','COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.1.04.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.00.00','OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.01.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.01.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.02.00','CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.02.01','VALORES FIRMADOS','REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.03.00','TRANSFERENCIAS LEGAIS','COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.03.01','VALORES FIRMADOS','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.04.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV','COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.2.04.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.00.00','OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.01.00','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.01.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.02.00','CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.02.01','VALORES FIRMADOS','REGISTRA O VALOR FIRMADO DOS CONTRATOS DE REPASSES DE PROGRAMAS ESPECIFICOS, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.03.00','TRANSFERENCIAS LEGAIS','COMPREENDE O VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.03.01','VALORES FIRMADOS','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO FIRMADOS NO AMBITO DA AGENCIA NACIONAL DE CINEMA - ANCINE E DO MINISTERIO DO TRABALHO E EMPREGO - MTE, RESPECTIVAMENTE.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.04.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV','COMPREENDE OS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.2.3.04.01','VALORES FIRMADOS','REGISTRA O VALOR TOTAL DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADOS NO PORTAL/SICONV, MANTENDO-O ORIGINALMENTE MESMO APOS A SUA FASE DE APROVACAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.0.00.00','OBRIGACOES CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.00.00','OBRIGACOES CONTRATUAIS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.02.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.03.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.06.00','CONTRATOS DE EMPRESTIMOS DO OOOC','REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.07.00','OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC','REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.08.00','CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE SEGUROS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.09.00','CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.10.00','CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONROLE POR PC OU RC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.11.00','CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.12.00','CONTRATO DE GESTAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.13.00','ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS','COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.13.01','VALOR FIRMADO','REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.1.14.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.00.00','OBRIGACOES CONTRATUAIS - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.02.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.03.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.06.00','CONTRATOS DE EMPRESTIMOS DO OOOC','REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.07.00','OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC','REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.08.00','CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE SEGUROS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.09.00','CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.10.00','CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.11.00','CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.12.00','CONTRATO DE GESTAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.13.00','ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS','COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.13.01','VALOR FIRMADO','REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.2.14.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.00.00','OBRIGACOES CONTRATUAIS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.02.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO ASSINADO ENTRE A ADMINISTRACAO PUBLICA E O PRESTADOR DE SERVICOS A TITULO DE OBRAS E INSTALACAO E DEMAIS SERVICOS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.03.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE LOCACAO DE BENS MOVEIS E IMOVEIS ENTRE A ADMINISTRACAO E TERCEIROS LOCADORES DE TAIS BENS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS ENTRE A ADMINISTRACAO E O FORNECEDOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA A APROPRIACAO DE AJUSTE OU ASSINATURA DE CONTRATOS DE CONCESSAO DE EMPRESTIMOS E FINANCIAMENTOS A CURTO PRAZO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.06.00','CONTRATOS DE EMPRESTIMOS DO OOOC','REGISTRA O SOMATORIO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR ELIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.07.00','OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC','REGISTRA O VALOR DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.08.00','CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE SEGUROS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.09.00','CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.10.00','CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.11.00','CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','REGISTRA O VALOR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.12.00','CONTRATO DE GESTAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTRATOS DE GESTAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.13.00','ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS','COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.13.01','VALOR FIRMADO','REGISTRO DO VALOR TOTAL DO ACORDO FIRMADO COM ORGANISMOS INTERNACIONAIS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.3.3.14.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.9.0.00.00','OUTROS ATOS POTENCIAIS PASSIVO','COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.9.1.00.00','OUTROS ATOS POTENCIAIS PASSIVO - EXTRA OFSS','COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.9.2.00.00','OUTROS ATOS POTENCIAIS PASSIVO - INTRA OFSS','COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.1.2.9.3.00.00','OUTROS ATOS POTENCIAIS PASSIVO - INTER OFSS','COMPREENDE OS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.0.0.0.00.00','ADMINISTRACAO FINANCEIRA','COMPREENDE AS CONTAS DE REGISTRO DA PROGRAMACAO FINANCEIRA E DE CONTROLE DAS DISPONIBILIDADES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.0.0.00.00','DISPONIBILIDADES POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM OS CONTROLES SOBRE AS DISPONIBILIDADES POR DESTINACAO DE RECURSOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.1.0.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','COMPREENDE AS CONTAS QUE REGISTRAM AS DISPONIBILIDADES DE RECURSOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.1.1.00.00','DISPONIBILIDADE DE RECURSOS','REGISTRA O TOTAL DE RECURSOS DISPONIBILIZADOS, JA COMPROMETIDOS OU NAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.2.0.00.00','LIMITE DE RESTOS A PAGAR POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.2.1.00.00','INSCRICAO DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S RESPONSAVEIS EM ENVIAR RECURSOS FINANCEIROS DESTINADOS AO PAGAMENTO DE RESTOS A PAGAR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.2.2.00.00','INSCRICAO DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS, NAS UG''S CUJOS RECURSOS FINANCEIROS SAO INSUFICIENTES PARA HONRAREM TODOS OS COMPROMISSOS INSCRITOS EM RESTOS A PAGAR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.0.00.00','RECURSO DIFERIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DOS RECURSOS DIFERIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.1.00.00','CONCESSAO DE RECURSO DIFERIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE RECURSOS DIFERIDOS QUE SERAO CONCEDIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.1.01.00','INSCRICAO DE COTA DIFERIDA','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE COTAS DIFERIDAS QUE SERAO CONCEDIDAS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.1.02.00','INSCRICAO DE REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE REPASSES DIFERIDOS QUE SERAO CONCEDIDOS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.1.03.00','INSCRICAO DE SUB-REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE SUB-REPASSES DIFERIDOS QUE SERAO CONCEDIDOS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.2.00.00','RECEBIMENTO DE RECURSO DIFERIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE RECURSOS DIFERIDOS QUE SERAO RECEBIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.2.01.00','INSCRICAO DE COTA DIFERIDA','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE COTAS DIFERIDAS QUE SERAO RECEBIDAS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.2.02.00','INSCRICAO DE REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE REPASSES DIFERIDOS QUE SERAO RECEBIDOS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.1.3.2.03.00','INSCRICAO DE SUB-REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A INSCRICAO DE SUB-REPASSES DIFERIDOS QUE SERAO RECEBIDOS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.0.0.00.00','PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE REGISTRAM AS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.0.00.00','CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.1.00.00','COTAS DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DAS COTAS, CONCEDIDAS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.2.00.00','COTAS NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DAS COTAS, CONCEDIDAS OU NAO, NAO DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.3.00.00','COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS LIBERADOS PELA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.4.00.00','REPASSES DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DOS REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.5.00.00','REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS REPASSES, CONCEDIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.6.00.00','REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES, CONCEDIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.7.00.00','SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, CONCEDIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.8.00.00','SUB-REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, CONCEDIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.1.9.00.00','SUB-REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES CONCEDIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.0.00.00','RECEBIMENTO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.1.00.00','COTAS DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.2.00.00','COTAS NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, NAO DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.3.00.00','COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS RECEBIDOS DA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.4.00.00','REPASSES DECORRENTES DO ORCAMENTO','REGISTRAM O VALOR TOTAL DOS REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.5.00.00','REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS REPASSES, RECEBIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.6.00.00','REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES RECEBIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.7.00.00','SUB-REPASSES DECORRENTES DO ORCAMENTO','REGISTRA O VALOR TOTAL DOS SUB-REPASSES, RECEBIDOS OU NAO, DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.8.00.00','SUB-REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR TOTAL DOS SUB-REPASSES, RECEBIDOS OU NAO, NAO DECORRENTES DO ORCAMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.2.2.9.00.00','SUB-REPASSE DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES, RECEBIDOS OU NAO, PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.0.0.00.00','INSCRICAO DO LIMITE ORCAMENTARIO','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.1.0.00.00','CONTROLE DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NO OCPF','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.1.1.00.00','LIMITE ORCAMENTARIO ESTABELECIDO','REGISTRA A INSCRICAO DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PUBLICO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.2.0.00.00','CONTROLE DAS OUTRAS UNIDADES GESTORAS','COMPREENDE AS CONTAS QUE CONTROLAM O LIMITE ORCAMENTARIO NAS OUTRAS UNIDADES GESTORAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.2.1.00.00','LIMITE ORCAMENTARIO AUTORIZADO','REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS AUTORIZADO PARA UTILIZACAO PELA SETORIAIS DE PROGRAMACAO FINANCEIRA, PARA POSSIBILITAR A EMISSAO DE NOTAS DE EMPENHO E DESCENTRALIZACAO DE CREDITOS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.2.2.00.00','LIMITE ORCAMENTARIO RECEBIDO POR TRANSFERENCIA','REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS TRANSFERIDO PELO ORGAO SETORIAL DE PROGRAMACAO FINANCEIRA PARA AS UNIDADES ORCAMENTARIAS PARA POSSIBILITAR A EMISSAO DE NOTAS DE EMPENHO E DESCENTRALIZACAO DE CREDITOS. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.2.3.00.00','COTA LIMITE ORCAMENTARIO P/ INSCRICAO RP','REGISTRA O VALOR DAS COTAS DE LIMITE ORCAMENTARIO DISPONIBILIZADA PARAAS UG, PARA VIABILIZAR A INSCRICAO DOS EMPENHOS EM RESTOS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.3.2.4.00.00','COTA LIMITE ORCAMENTARIO TRANSF. P/ INSC.RP','REGISTRA O VALOR DAS COTAS DE DESPESAS ORCAMENTARIAS RECEBIDO PORTRANSFERENCIA PARA INSCRICAO DOS EMPENHOS EM RESTOS A PAGAR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.0.0.00.00','CONTROLES DA ARRECADACAO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADACAO COMO DARF, GRU, DAR, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.0.00.00','CONTROLES DE DARF`S','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.1.00.00','CONTROLES DE DARF`S POR CODIGO DE RECEITA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE RECEITA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.1.01.00','ARRECADACAO LIQUIDA POR CODIGO DE RECEITA (DARF''S)','REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE RECEITA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.2.00.00','CONTROLES DE DARF`S POR CODIGO DE DESTINACAO PRIMARIA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.2.01.00','ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO PRIMARIA (DARF''S)','REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.3.00.00','CONTROLES DE DARF`S POR CODIGO DE DESTINACAO VINCULADA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO VINCULADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.1.3.01.00','ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO VINCULADA (DARF''S)','REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.0.00.00','CONTROLES DE GRU`S','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.1.00.00','CONTROLES DE GRU`S POR CODIGO DE RECOLHIMENTO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.1.01.00','ARRECADACAO LIQUIDA POR CODIGO DE RECOLHIMENTO (GRU''S)','REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.2.00.00','CONTROLES DE GRU`S POR CODIGO DE DESTINACAO PRIMARIA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.2.01.00','ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO PRIMARIA (GRU''S)','REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.3.00.00','CONTROLES DE GRU`S POR CODIGO DE DESTINACAO SECUNDARIA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.2.3.01.00','ARRECADACAO LIQUIDA POR CODIGO DE DESTINACAO SECUNDARIA (GRU''S)','REGISTRA O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE GRU, CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.3.0.00.00','CONTROLES DE DAR''S','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA DE ESTADOS E MUNICIPIOS, RETIDA PELA UG, DE PAGAMENTOS REALIZADOS A EMPRESAS PRESTADORAS DE SERVICOS ENQUADRADAS PELA LC 116.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.2.4.3.1.00.00','ISS SUBSTITUICAO A DISTRIBUIR','REGISTRA A TRANSFERENCIA DE ISS A DISTRIBUIR AOS MUNICIPIOS, PARA CONTROLE DA COFIN.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.3.0.0.0.00.00','DIVIDA ATIVA','REGISTRA O CONTROLE DOS CREDITOS A SEREM INSCRITOS EM DIVIDA ATIVA, DOS QUE SE ENCONTRAM EM PROCESSAMENTO. COMPREENDE AS CONTAS QUE CONTROLAM OS CREDITOS PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA O DE INSCRICAO E A TRAMITACAO DOS CREDITOS INSCRITOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.3.1.0.0.00.00','CONTROLE DO ENCAMINHAMENTO DE CREDITOS PARA INSCRICAO EM DIVIDA ATIVA','REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.3.1.1.0.00.00','ENCAMINHAMENTO DE CREDITOS ','REGISTRA OS VALORES PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.3.2.0.0.00.00','CONTROLE DA INSCRICAO DE CREDITOS EM DIVIDA ATIVA','COMPREENDE AS CONTAS QUE CONTROLAM OS CREDITOS PASSIVEIS DE SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO RESPONSAVEL PELA INSCRICAO EM DIVIDA ATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.3.2.1.0.00.00','INSCRICAO DE CREDITOS ','REGISTRA OS VALORES DOS CREDITOS PASSIVEIS DE SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO RESPONSAVEL PELA INSCRICAO EM DIVIDA ATIVA. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.4.0.0.0.00.00','RISCOS FISCAIS','COMPREENDE AS CONTAS QUE CONTROLAM OS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.4.1.0.0.00.00','CONTROLE DE PASSIVOS CONTINGENTES','COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.4.1.1.0.00.00','PASSIVOS CONTINGENTES','REGISTRA OS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.4.2.0.0.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','COMPREENDE AS CONTAS QUE REGISTRAM OS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS ','REGISTRA OS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.8.0.0.0.00.00','CUSTOS','COMPREENDE AS CONTAS QUE CONTROLAM OS CUSTOS DE BENS E SERVICOS PRODUZIDOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.0.0.0.00.00','OUTROS CONTROLES','COMPREENDE DE CONTROLES NAO ESPECIFICADOS ANTERIORMENTE NOS GRUPOS DESSA CLASSE','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.0.0.00.00','OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.1.0.00.00','REMANEJAMENTO DE COTA','COMPREENDE AS CONTAS QUE CONTROLAM REMANEJAMENTO DE COTA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.1.1.00.00','REMANEJAMENTO DE COTA - SETORIAL FINANCEIRA','REGISTRA NA SETORIAL FINANCEIRA O REMANEJAMENTO DE COTA','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.1.2.00.00','REMANEJAMENTO DE COTA - UG BENEFICIADA','REGISTRA NA UG BENEFICIADA O REMANEJAMENTO DE COTA','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.0.00.00','COTA DE EMPENHO PARA PAGAMENTO CONTRA-ENTREGA','COMPREENDE AS CONTAS QUE CONTROLAM COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.1.00.00','CONCESSAO DE EMPENHO CONTRA-ENTREGA','COMPREENDE AS CONTAS QUE REGISTRAM A CONCESSAO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.1.01.00','COTA DE EMPENHOS','REGISTRA A CONCESSAO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.1.06.00','RETENCAO DE TRIBUTOS DE PAGAMENTOS DE EMPENHOS CONTRA-ENTREGA','COMPRENDE AS CONTAS QUE REGISTRAM O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.1.06.01','RETENCAO DE TRIBUTOS','REGISTRA O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.2.00.00','RECEBIMENTO DE PF DE EMPENHO CONTRA-ENTREGA','COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.2.01.00','COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA DIRETAMENTE','REGISTRA O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.2.02.00','COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA POR TRANSFERENCIA','REGISTRA O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DE OUTRA UG ANTERIORMENTE BENEFICIADA','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.2.06.00','RETENCAO DE TRIBUTOS DE PAGAMENTOS DE EMPENHOS CONTRA-ENTREGA','COMPRENDE AS CONTAS QUE REGISTRAM O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.1.2.2.06.01','RETENCAO DE TRIBUTOS','REGISTRA O VALOR DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.0.0.00.00','OUTROS CONTROLES DE DISPONIBILIDADES','COMPREENDE AS CONTAS QUE CONTROLAM OUTROS CONTROLES DE DISPONIBILIDADES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.0.00.00','DISPONIBILIDADES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A EMISSAO DE DOCUMENTOS DE ARRECADACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.1.00.00','EMISSAO DE DARF','REGISTRA O CONTROLE DA EMISSAO DE DARF´S.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.2.00.00','EMISSAO DE GPS','REGISTRA O CONTROLE DA EMISSAO DE GPS´S.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.3.00.00','EMISSAO DE DAR','REGISTRA O CONTROLE DA EMISSAO DE DAR´S.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.4.00.00','EMISSAO DE GFIP','REGISTRA O CONTROLE DA EMISSAO DE GFIP´S.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.5.00.00','EMISSAO DE GRU','REGISTRA O CONTROLE DA EMISSAO DE GRU´S.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.1.6.00.00','PAGAMENTOS EFETUADOS','REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COM BASE NO LIMITE DE SAQUE DA CONTA UNICA DA SECRETARIA DO TESOURO NACIONAL OU DA CONTA UNICA INSTITUCIONAL.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.2.0.00.00','DISPONIBILIDADES DA CONTA ESPECIAL','COMPREENDE AS CONTAS QUE REGISTRAM A MOVIMENTACAO FINANCEIRA VINCULADA AOS EMPRESTIMOS EXTERNOS RECEBIDOS (ANTES DE REGISTRAR NA CONTA UNICA)','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.2.1.00.00','INGRESSOS','REGISTRA O VALOR DE INGRESSOS DE CAIXA DO TESOURO NACIONAL ORIUNDOS DE EMPRESTIMOS EXTERNOS, ANTES DA ETAPA DO REEMBOLSO (REGISTRO NACONTA UNICA).','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.2.2.2.00.00','DISPONIBILIDADES DE RECURSO POR DESTINACAO','REGISTRA A MOVIMENTACAO FINANCEIRA VINCULADA AOS INGRESSOS DOS RECURSOS EXTERNOS BEM COMO A APROVACAO DE REEMBOLSO DOS RECURSOS APLICADOS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.0.0.00.00','OUTROS CONTROLES DE BENEFICIOS PAGOS','COMPREENDE AS CONTAS QUE REGISTRAM O PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.1.0.00.00','BENEFICIOS PAGOS PELA REDE BANCARIA','COMPREENDE AS CONTAS QUE REGISTRAM OS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.1.1.00.00','BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO','REGISTRAM OS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ATUAL','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.1.2.00.00','BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO ANTERIOR','REGISTRA OS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ANTERIOR','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.2.0.00.00','BENEFICIOS PAGOS POR EMPRESAS CONVENENTES','COMPREENDE AS CONTAS QUE REGISTRAM OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.2.1.00.00','BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO','REGISTRAM OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.3.2.2.00.00','BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO ANTERIOR','REGISTRA OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.0.0.00.00','OUTROS CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A CONTA UNICA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.1.0.00.00','CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A CONCILIACAO DA CONTA UNICA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.1.1.00.00','REMANEJAMENTO DE FONTE DE RECURSOS','REGISTRA OS VALORES RELATIVOS AO REMANEJAMENTO DE SALDO NA CONTA DE DISPONIBILIDADE POR FONTE DE RECURSOS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.1.2.00.00','CONTROLE FR - CANCELAMENTO OBRIG. EXERC. ANT','REGISTRA O CONTROLE POR FONTE DE RECURSOS NO CANCELAMENTO DE OBRIGA-COES DE EXERCICIOS ANTERIORES QUE NAO TENHAM CONTAS DE CONTROLE DE EMPENHO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.1.3.00.00','INCORPORACAO/DESINCORPORACAO SALDOS','REGISTRA OS VALORES RELATIVOS A INCORPORACAO OU DESINCORPORACAO DE SALDOS DA DISPONIBILIDADE POR FONTE DE RECURSOSO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.1.4.00.00','CONTROLE FR - RESTITUICAO DE RECEITAS','REGISTRA O CONTROLE POR FONTE DE RECURSOS NAS ROTINAS DE RESTITUICAOO DE RECEITAS, ONDE NAO HA CONTAS DE CONTROLE DE EMPENHO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.2.0.00.00','CONTROLE DE CAIXA DO TESOURO NACIONAL','COMPREENDE AS CONTAS QUE CONTROLAM O SALDO DA CONTA UNICA DO TESOURO NACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.2.1.00.00','CONTROLE DE INGRESSOS E SAIDAS DA CONTA UNICA','REGISTRA O VALOR DE INGRESSOS E SAIDAS FISCAIS DE CAIXA DA SECRETARIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DOTESOURO NACIONAL.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.2.2.00.00','CONTROLE DE INGRESSOS E SAIDAS DO INSS','REGISTRA O VALOR DE INGRESSOS E SAIDAS DE FINANCIAMENTO PELA SECRETAIRA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAOFINANCEIRA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.2.3.00.00','CONTROLE DE INGRESSOS E SAIDAS DA CONTA ESPECIAL','REGISTRA O VALOR DE INGRESSOS E SAIDAS DOS RECURSOS DE EMPRESTIMOS EX-TERNOS DA CONTA ESPECIAL','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.3.0.00.00','CONTROLE DE TRANSFERENCIAS ENTRE CONTAS UNICAS (INSS E TESOURO NACIONAL)','REGISTRA O VALOR DA TRANSFERENCIA DE LIMITES DA CONTA UNICA DO INSSPARA O TESOURO NACIONAL E VICE-VERSA DENTRO DE UMA UG OU ENTRE UGSDIFERENTES, BEM COMO TRANSFERENCIAS DE LIMITES DA CONTA UNICA ENTREUGS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.4.4.0.00.00','CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','REGISTRA OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA NA PLICACAO FINANCEIRA NA CTU','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.5.0.0.00.00','OUTROS CONTROLES DE RA''S','COMPREENDEM AS CONTAS QUE CONTROLAM RA''S','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.0.0.00.00','OUTROS CONTROLES DE OPERACOES DE CREDITOS','COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.1.0.00.00','OPERACOES EM TITULOS','COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO RESULTANTES DE TITULOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.1.1.00.00','EMISSOES DE TITULOS','COMPREENDE AS CONTAS QUE CONTROLAM OPERACOES DE CREDITO RESULTANTES DE EMISSOES DE TITULOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.1.1.01.00','LIMITE DE EMISSAO ORCAMENTARIA','REGISTRA O VALOR DA EMISSAO DE TITULO DA DIVIDA PUBLICA ATE O LIMITEPREVISTO NA EXECUCAO ORCAMENTARIA A FIM DE ATENDER SUAS DESPESAS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.1.1.02.00','LIMITE DE EMISSAO - CREDITOS ADICIONAIS','REGISTRA O VALOR DA EMISSAO DE TITULOS ATE O LIMITE DOS CREDITOS ADI-CIONAIS SOLICITADOS PELO EXECUTIVO E QUE PASSARAO A INTEGRAR O ORCA-MENTO EM VIGOR.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.1.1.03.00','LIMITE DE EMISSAO - GIRO DA DIVIDA','REGISTRA O VALOR DO LIMITE DE EMISSOES DE TITULOS PARA FINS DE GIRO DADIVIDA PUBLICA, PREVISTOS NA PROGRAMACAO FINANCEIRA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.2.0.00.00','MOVIMENTACAO DE RECEITAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS MOVIMENTACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.2.1.00.00','INCORPORACOES DE RECEITAS','REGISTRA OS VALORES REFERENTES AS INCORPORACOES DE RECEITAS PERTENCEN-TES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.2.2.00.00','DESICORPORACOES DE RECEITAS','REGISTRA OS VALORES REFERENTES AS DESINCORPORACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.3.0.00.00','OPERACOES COM EMPRESTIMOS EXTERNOS','COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DAS OPERACOES COM EMPRESTIMOS EXTERNOS CUJOS RECURSOS SAO DEPOSITADOS EM CONTA ESPECIAL DO TESOURO NACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.3.1.00.00','ADIANTAMENTOS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.3.2.00.00','REEMBOLSOS/RESSARCIMENTOS','COMPREENDE AS CONTAS QUE REGISTRAM A SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.0.00.00','OPERACOES DE CREDITO EXTERNAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.1.00.00','OPERACOES DE CREDITO EXTERNAS CONCEDIDAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS CONCEDIDAS LIBERADOS PELA COFIN/STN','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.2.00.00','OPERACOES DE CREDITO EXTERNAS RECEBIDAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS RECEBIDAS LIBERADOS PELA COFIN/STN','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.3.00.00','CONTROLE DE REEMBOLSOS','COMPREENDE AS CONTAS QUE REGISTRAM A SOCILITACAO DE REEMBOLSOS A SEREM EFETUADOS PARA A CONTAUNICA DO TESOURO NACIONAL','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.4.00.00','CONTROLE DE DESEMBOLSOS','COMPREENDE AS CONTAS QUE REGISTRAM A SOLICITACAO DE DESEMBOLSO A SEREM EFETUADOSPARA A CONTA ESPECIAL DO TESOURO NACIONAL','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.5.00.00','CONTROLE DA COMPROVACAO DE VALORES','COMPREENDE AS CONTAS QUE CONTROLAM A COMPROVACAO DE VALORES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.5.01.00','CONTROLE DA COFIN','REGISTRA NA COFIN OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.4.5.02.00','CONTROLE DA UG','REGISTRA NA UG OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.5.0.00.00','OPERACOES DE CREDITO EXTERNAS SEM ANTECIPACAO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.5.1.00.00','CONTROLE DA COFIN','REGISTRA NA COFIN OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.5.2.00.00','CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.6.0.00.00','OPERACOES DE CREDITO EXTERNAS COM ANTECIPACAO E FUNDO ROTATIVO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E FUNDO ROTATIVO, EX-CLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.6.1.00.00','CONTROLE DA COFIN','REGISTRA NA COFIN OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E FUNDO ROTATIVO, EX-CLUSIVE RECURSOS DE CONTRAPARTIDA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.6.2.00.00','CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E FUNDO ROTATIVO, EX-CLUSIVE RECURSOS DE CONTRAPARTIDA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.7.0.00.00','OPERACOES DE CREDITO EXTERNAS COM ANTECIPACAO E SEM FUNDO ROTATIVO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E SEM FUNDO ROTATIVO,EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.7.1.00.00','CONTROLE DA COFIN','REGISTRA NA COFIN OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E SEM FUNDO ROTATIVO,EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.7.2.00.00','CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E SEM FUNDO ROTATIVO,EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.8.0.00.00','OPERACOES DE CREDITO EXTERNAS COM SWAP / OPERACOES DE AJUSTE','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS DE SWAP/OPERACOES DE AJUSTE COM ORGANISMOS INTERNACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.8.1.00.00','CONTROLE DA COFIN','REGISTRA NA COFIN OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS DE SWAP/OPERACOES DE AJUSTE COM ORGANISMOS INTERNACIONAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.6.8.2.00.00','CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO OS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS DE SWAP/OPERACOES DE AJUSTE COM ORGANISMOS INTERNACIONAIS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.7.0.0.00.00','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.7.1.0.00.00','RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.7.1.1.00.00','RESPONSABILIDADES DE TERCEIROS ','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.7.2.0.00.00','RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.7.2.1.00.00','RESPONSABILIDADE COM TERCEIROS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('7.9.7.3.0.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.0.0.0.0.00.00','CONTROLES CREDORES','COMPREENDE AS CONTAS EM QUE SAO REGISTRADAS A EXECUCAO DE ATOS POTENCIAIS E CONTROLES ESPECIFICOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.0.0.0.00.00','EXECUCAO DOS ATOS POTENCIAIS','COMPREENDE CONTAS RELACIONADAS A EXECUCAO DE SITUACOES NAO COMPREENDIDAS NO PATRIMONIO, MAS QUE, DIRETA OU INDIRETAMENTE, POSSAM VIR A AFETA-LO, EXCLUSIVE AS QUE DIZEM RESPEITO A ATOS E FATOS LIGADOS A EXECUCAO ORCAMENTARIA E FINANCEIRA E AS CONTAS COM FUNCAO PRECIPUA DE CONTROLE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.0.0.00.00','EXECUCAO DOS ATOS POTENCIAIS ATIVOS','REGISTRA A EXECUCAO DOS ATOS E FATOS QUE POSSA VIR A AFETAR O ATIVO DA ENTIDADE GOVERNAMENTAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.0.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - EXTRA OFSS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.00','EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.02','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.06','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.15','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.19','GARANTIAS DA DIVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.20','GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.21','GARANTIAS DA DIVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.22','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.23','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.24','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.26','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.01.27','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.00','EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.02','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.06','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.15','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.19','GARANTIAS DA DIVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.20','GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.21','GARANTIAS DA DIVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.22','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.23','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.24','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.26','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.02.27','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.01','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.02','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.03','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.04','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.05','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.06','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.11','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.03.12','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.01','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.02','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.03','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.04','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.05','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.06','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.11','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.1.04.12','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTRA OFSS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.00','EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.02','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.06','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.15','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.19','GARANTIAS DA DIVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.20','GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.21','GARANTIAS DA DIVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.22','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.23','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.24','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.26','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.01.27','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.00','EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.02','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.06','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.15','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.19','GARANTIAS DA DIVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.20','GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.21','GARANTIAS DA DIVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.22','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.23','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.24','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.26','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.02.27','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.01','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.02','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.03','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.04','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.05','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.06','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.11','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.03.12','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.01','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.02','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.03','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.04','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.05','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.06','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.11','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.2.04.12','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - INTER OFSS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDOS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.00','EXECUCAO DE GARANTIAS RECEBIDAS NO PAIS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEDIDOS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.02','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS RECEBIDAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANCAS, PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO, DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.06','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.15','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.19','GARANTIAS DA DIVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS DA DIVIDA PUBLICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.20','GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.21','GARANTIAS DA DIVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DIVIDA PUBLICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.22','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.23','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.24','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.26','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.01.27','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.00','EXECUCAO DE GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.02','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.06','FIANCAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.15','CAUCAO EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.19','GARANTIAS DA DIVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.20','GARANTIAS DA DIVIDA PUBLICA EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.21','GARANTIAS DA DIVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.22','APOLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APOLICES DE SEGUROS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.23','APOLICES DE SEGUROS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DAS APOLICES DE SEGUROS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.24','APOLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APOLICES DE SEGUROS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.25','OUTRAS GARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.26','OUTRAS GARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR NAO RECEBIDO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.02.27','OUTRAS GARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS RECEBIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.01','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.02','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.03','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.04','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.05','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.06','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.11','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.03.12','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.00','EXECUCAO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.01','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.02','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.03','CONTRAGARANTIAS SOBRE AVAIS CONCEDIDOS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.04','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.05','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.06','CONTRAGARANTIAS SOBRE FIANCAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.11','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.1.3.04.12','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.0.00.00','EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.00.00','EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.00','EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES - EXTRA OFSS','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.01','CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.02','CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.03','CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.04','CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.05','CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.06','CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.07','CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.08','CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.09','CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.10','CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.11','CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.01.12','CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.00','TERMO DE COOPERACAO - EXTRA OFSS','COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.01','TERMO DE COOPERACAO A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.02','TERMO DE COOPERACAO A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.03','TERMO DE COOPERACAO A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.04','TERMO DE COOPERACAO APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.05','TERMO DE COOPERACAO IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.06','TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.07','TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.08','TERMO DE COOPERACAO CANCELADOS','REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.09','TERMO DE COOPERACAO NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.02.10','TERMO DE COOPERACAO CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV - EXTRA OFSS','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR','REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER','REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.13','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.14','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.1.03.15','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.00.00','EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.00','EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES - INTRA OFSS','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.01','CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.02','CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.03','CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.04','CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.05','CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.06','CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.07','CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.08','CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.09','CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.10','CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.11','CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.01.12','CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.00','TERMO DE COOPERACAO - INTRA OFSS','COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.01','TERMO DE COOPERACAO A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.02','TERMO DE COOPERACAO A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.03','TERMO DE COOPERACAO A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.04','TERMO DE COOPERACAO APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.05','TERMO DE COOPERACAO IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.06','TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.07','TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.08','TERMO DE COOPERACAO CANCELADOS','REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.09','TERMO DE COOPERACAO NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.02.10','TERMO DE COOPERACAO CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV - INTRA OFSS','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR','REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER','REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.13','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.14','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.2.03.15','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.00.00','EXECUCAO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUCAO DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.00','EXECUCAO DE CONVENIOS E INSTRUMENTOS CONGENERES - INTER OFSS','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.01','CONVENIOS E INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.02','CONVENIOS E INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.03','CONVENIOS E INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.04','CONVENIOS E INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.05','CONVENIOS E INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.06','CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.07','CONVENIOS E INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.08','CONVENIOS E INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.09','CONVENIOS E INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.10','CONVENIOS E INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.11','CONVENIOS E INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ENTRADA DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.01.12','CONVENIOS E INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.00','TERMO DE COOPERACAO - INTER OFSS','COMPREENDE A EXECUCAO DOS VALORES DE TERMO DE COOPERACAO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.01','TERMO DE COOPERACAO A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.02','TERMO DE COOPERACAO A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE TERMOS DE COOPERACAO PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.03','TERMO DE COOPERACAO A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.04','TERMO DE COOPERACAO APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.05','TERMO DE COOPERACAO IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERACAO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.06','TERMO DE COOPERACAO EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO TERMOS DE COOPERACAO FIRMADOS, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.07','TERMO DE COOPERACAO EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERACAO FIRMADOS, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.08','TERMO DE COOPERACAO CANCELADOS','REGISTRA O VALOR CANCELADO DO TERMOS DE COOPERACAO FIRMADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.09','TERMO DE COOPERACAO NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADOS DO TERMOS DE COOPERACAO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.02.10','TERMO DE COOPERACAO CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE TERMOS DE COOPERACAO FIRMADOS , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV - INTER OFSS','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS - PORTAL/SICONV','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR','REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A RECEBER','REGISTRA OS VALORES LIQUIDADOS A RECEBER PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A RECEBER','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A RECEBER DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.13','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO RECEBIDOS','REGISTRA O VALOR NAO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVENIO. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.14','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.2.3.03.15','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.0.00.00','EXECUCAO DE DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.00.00','EXECUCAO DE DIREITOS CONTRATUAIS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.01.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.02.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.02.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.03.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.03.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.04.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.05.01','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.00','CONTRATOS DE OBRIGACOES INTERNAS','REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.01','CONTRATOS A RECEBER','REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.02','CONTRATOS RECEBIDOS','REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.03','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.04','JUROS APROPRIADOS','REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.05','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.06','ENCARGOS APROPRIADOS','REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.07','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.06.99','OUTROS CONTRATOS A RECEBER???','REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.00','CONTRATOS DE OBRIGACOES EXTERNAS','COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.01','CONTRATOS A RECEBER','REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.02','CONTRATOS RECEBIDOS','REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.03','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.04','JUROS APROPRIADOS','REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.05','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.06','ENCARGOS APROPRIADOS','REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.07','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.08','CONTRATOS TRANSFERIDOS','REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.07.99','OUTROS CONTRATOS A RECEBER???','REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.08.00','TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.','REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.1.08.01','TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.','REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.00.00','EXECUCAO DE DIREITOS CONTRATUAIS INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.01.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.02.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.02.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.03.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.03.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.04.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.05.01','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.00','CONTRATOS DE OBRIGACOES INTERNAS','REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.01','CONTRATOS A RECEBER','REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.02','CONTRATOS RECEBIDOS','REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.03','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.04','JUROS APROPRIADOS','REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.05','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.06','ENCARGOS APROPRIADOS','REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.07','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.06.99','OUTROS CONTRATOS A RECEBER???','REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.00','CONTRATOS DE OBRIGACOES EXTERNAS','COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.01','CONTRATOS A RECEBER','REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.02','CONTRATOS RECEBIDOS','REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.03','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.04','JUROS APROPRIADOS','REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.05','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.06','ENCARGOS APROPRIADOS','REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.07','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.08','CONTRATOS TRANSFERIDOS','REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.07.99','OUTROS CONTRATOS A RECEBER???','REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.08.00','TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.','REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.2.08.01','TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.','REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.00.00','EXECUCAO DE DIREITOS CONTRATUAIS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.01.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES APROPRIADOS RELATIVOS AOS SERVICOS DE SEGUROS , CONFORME PREVISAO CONTRATUAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.02.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.02.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVICOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.03.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.03.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.04.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.05.01','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.00','CONTRATOS DE OBRIGACOES INTERNAS','REGISTRA A APROPRIACAO DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.01','CONTRATOS A RECEBER','REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.02','CONTRATOS RECEBIDOS','REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.03','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETARIA E CAMBIAL REFERENTE A CONTRATOS DE OBRIGACOES INTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.04','JUROS APROPRIADOS','REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.05','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.06','ENCARGOS APROPRIADOS','REGISTRA A APROPRIACAO DOS ENCARGOS REFERENTES A CONTRATOS DE OBRIGA COES INTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.07','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES INTER-NAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.06.99','OUTROS CONTRATOS A RECEBER???','REGISTRA A APROPRIACAO OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES INTERNAS CONSTANTES DO ORCAMENTO CORRENTE, NAO CONTEMPLADOS EM CONTA ESPECIFICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.00','CONTRATOS DE OBRIGACOES EXTERNAS','COMPREENDE VALORES RELACIONADOA A EXECUCAO DE CONTRATO REFERENTE A OBRIGACOES DA DIVIDA E DAS OPERACOES DE CREDITO EXTERNAS CONTRATADAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.01','CONTRATOS A RECEBER','REGISTRA A APROPRIACAO DOS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS CONSTANTES DO ORCAMENTO DO EXERCICIO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.02','CONTRATOS RECEBIDOS','REGISTRA A APROPRIACAO DOS VALORES RECEBIDOS DE CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.03','CONTRATOS AMORTIZADOS','REGISTRA A APROPRIACAO DO PAGAMENTO DO PRINCIPAL E DA CORRECAO MONETA-RIA E CAMBIAL REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.04','JUROS APROPRIADOS','REGISTRA A APROPRIACAO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTER NAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.05','JUROS PAGOS','REGISTRA O PAGAMENTO DOS JUROS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.06','ENCARGOS APROPRIADOS','REGISTRA A APROPRIACAO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.07','ENCARGOS PAGOS','REGISTRA O PAGAMENTO DOS ENCARGOS SOBRE CONTRATOS DE OBRIGACOES EXTERNAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.08','CONTRATOS TRANSFERIDOS','REGISTRA A APROPRIACAO DOS VALORES TRANSFERIDOS REFERENTES A CONTRATOS DE OBRIGACOES EXTERNAS E DE DIVIDAS EXTERNAS CONSTANTES DO ORCAMENTO CORRENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.07.99','OUTROS CONTRATOS A RECEBER???','REGISTRA A APROPRIACAO DE OUTROS VALORES A RECEBER DE CONTRATOS DE OBRIGACOES EXTERNAS, NAO CONTEMPLADOS EM CONTA ESPECIFICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.08.00','TERMOS/ACORDOS DE COOPERACAO S/EXEC. ORCAMEN.','REGISTRA O VALOR DE TERMOS E ACORDO DE COOPERACAO SEM EXECUCAO ORCA-MENTARIA EM QUE A ADMINISTRACAO PUBLICA SEJA CONTRATADA DO INSTRUMENTO CONTRATUAL COM TERCEIROS. CADA ENTIDADE DEVERA VERIFICAR A LEGALIDADE PARA SUPORTE DO PROCEDIMENTO ADMINISTRATIVO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.3.3.08.01','TERMOS/ACORDOS P/FORNECIM. DE BENS S/ORCAM.','REGISTRA O VALOR DE TERMOS E ACORDOS COM FORNECIMENTO DE BENS SEM SUPORTE ORCAMENTARIO. COMPENSACAO PATRIMONIAL COM PERMUTA DE SERVICOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.9.0.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.9.1.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - EXTRA OFSS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.9.2.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - INTRA OFSS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.1.9.3.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS ATIVOS - INTER OFSS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS ATIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.0.0.00.00','EXECUCAO DOS ATOS POTENCIAIS PASSIVOS','REGISTRA A EXECUCAO DOS ATOS E FATOS QUE POSSA VIR A AFETAR O PASSIVO DA ENTIDADE GOVERNAMENTAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.0.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.02','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.06','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.12','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.15','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.19','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.20','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.01.21','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.02','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.06','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.12','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.15','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.19','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.20','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.02.21','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.02','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.03','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.05','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.06','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.11','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.02','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.03','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.05','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.06','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.11','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.1.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.02','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.06','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.12','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.15','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.19','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.20','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.01.21','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.02','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.06','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.12','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.15','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.19','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.20','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.02.21','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.02','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.03','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.05','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.06','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.11','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.02','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.03','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.05','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.06','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.11','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.2.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.00.00','EXECUCAO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO PAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO PAIS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.02','AVAIS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS GARANTIAS POR AVAL EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.06','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.12','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.15','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.19','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.20','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.01.21','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.00','EXECUCAO DE GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DE AVAIS, FIANCAS E HIPOTECAS CONCEDIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.02','AVAIS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR AVAL EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR PAGO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.04','FIANCAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.05','FIANCAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.06','FIANCAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR FIANCAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.08','HIPOTECAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR HIPOTECA EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR PAGO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUCAO , NO EXTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.11','SEGUROS-GARANTIA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DOS SEGUROS-GARANTIA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.12','SEGUROS-GARANTIA EXECUTADOS','REGISTRA O VALOR PAGO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.13','CAUCAO A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUCAO PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.14','CAUCAO EM EXECUCAO','REGISTRA O VALOR NAO PAGO DAS GARANTIAS POR CAUCAO EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.15','CAUCAO EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS POR CAUCAO NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.16','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.17','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.18','GARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADA','REGISTRA O VALOR PAGO DAS GARANTIAS INSTITUIDAS POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.19','OUTRAS GARANTIAS CONCEDIDAS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.20','OUTRAS GARANTIAS CONCEDIDAS EM EXECUCAO','REGISTRA O VALOR NAO PAGO DE OUTRAS GARANTIAS EM EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.02.21','OUTRAS GARANTIAS CONCEDIDAS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO PAIS','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.02','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.03','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE FIANCAS PENDENTES DE EXECUCAO, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.05','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGOS DAS CONTRAGARANTIAS SOBRE FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.06','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS PEDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.11','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.00','EXECUCAO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE A EXECUCAO DAS CONTRAGARANTIAS OFERECIDAS REFERENTES AS GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.01','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS SOBRE AVAIS PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.02','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS SOBRE AVAIS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.03','CONTRAGARANTIAS SOBRE AVAIS RECEBIDOS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS SOBRE AVAIS NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.04','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS POR FIANCAS PENDENTES DE EXECUCAO , NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.05','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DAS CONTRAGARANTIAS POR FIANCAS EM PROCEDIMENTO DE COBRANCA, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.06','CONTRAGARANTIAS SOBRE FIANCAS RECEBIDAS EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS POR FIANCAS, NO PAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.07','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA PENDENTES DE EXECUCAO , NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.08','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EM EXECUCAO','REGISTRA O VALOR, AINDA, NAO PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.09','CONTRAGARANTIAS INSTITUIDAS POR LEI ESPECIFICA EXECUTADAS','REGISTRA O VALOR PAGO DAS CONTRAGARANTIAS INSTITUIDA POR LEI ESPECIFICA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS DE EXECUCAO, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.11','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EM EXECUCAO','REGISTRA O VALOR AINDA NAO PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS EM PROCEDIMENTO DE COBRANCA, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.1.3.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR PAGO DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NO EXTERIOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.0.00.00','EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.00.00','EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.01.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.00','EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.01','CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.02','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.03','CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.04','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.05','CONTR.REPASSE DE PROGR. A APROVAR ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.06','CONTR.REPASSE DE PROGR. APROVADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.07','CONTR.REPASSE DE PROGR. HOMOLOGADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.08','CONTR.REPASSE DE PROGR. IMPUGNADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.09','CONTR.REPASSE DE PROGR. INADIMPLENTE ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.10','CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.11','CONTR.REPASSE DE PROGR. APROVADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.12','CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.13','CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.14','CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.02.15','CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.','REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.00','TRANSFERENCIAS LEGAIS','COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.01','TRANSFERENCIAS LEGAIS A LIBERAR ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.02','TRANSFERENCIAS LEGAIS A COMPROVAR','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.03','TRANSFERENCIAS LEGAIS A APROVAR','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.04','TRANSFERENCIAS LEGAIS APROVADO','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.05','TRANSFERENCIAS LEGAIS IMPUGNADO ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.06','TRANSFERENCIAS LEGAIS INADIMPLENCIA ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.03.07','TRANSFERENCIAS LEGAIS CONCLUIDO ','REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR','REGISTRA A EXECUCAO DOS VALORES A LIQUIDAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR','REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR','REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.13','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.14','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.1.04.15','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.00.00','EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.01.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.00','EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.01','CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.02','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.03','CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.04','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.05','CONTR.REPASSE DE PROGR. A APROVAR ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.06','CONTR.REPASSE DE PROGR. APROVADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.07','CONTR.REPASSE DE PROGR. HOMOLOGADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.08','CONTR.REPASSE DE PROGR. IMPUGNADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.09','CONTR.REPASSE DE PROGR. INADIMPLENTE ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.10','CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.11','CONTR.REPASSE DE PROGR. APROVADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.12','CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.13','CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.14','CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.02.15','CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.','REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.00','TRANSFERENCIAS LEGAIS','COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.01','TRANSFERENCIAS LEGAIS A LIBERAR ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.02','TRANSFERENCIAS LEGAIS A COMPROVAR','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.03','TRANSFERENCIAS LEGAIS A APROVAR','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.04','TRANSFERENCIAS LEGAIS APROVADO','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.05','TRANSFERENCIAS LEGAIS IMPUGNADO ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.06','TRANSFERENCIAS LEGAIS INADIMPLENCIA ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.03.07','TRANSFERENCIAS LEGAIS CONCLUIDO ','REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR','REGISTRA OS VALORES A LIQUIDAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR','REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR','REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.13','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.14','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.2.04.15','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.00.00','EXECUCAO DE OBRIGACOES CONVENIADAS E OUTROS INSTRUMENTOS CONGENERES - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONCEDENTE, DA EXECUCAO DO VALOR DOS CONVENIOS E OUTROS INSTRUMENTOS CONGENERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.01.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.00','EXECUCAO DE CONTRATOS DE REPASSE DE PROGRAMAS ESPECIFICOS','COMPREENDE O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.01','CONTRATOS DE REPASSE DE PROGRAMAS A LIBERAR','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.02','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.03','CONTRATOS DE REPASSE DE PROGRAMAS POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS A LIBERAR, COM CONTROLE POR CNPJ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.04','CONTRATOS DE REPASSE DE PROGRAMAS LIBERADOS POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS LIBERADOS, COM CONTROLE POR CNPJ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.05','CONTR.REPASSE DE PROGR. A APROVAR ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.06','CONTR.REPASSE DE PROGR. APROVADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.07','CONTR.REPASSE DE PROGR. HOMOLOGADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.08','CONTR.REPASSE DE PROGR. IMPUGNADO ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.09','CONTR.REPASSE DE PROGR. INADIMPLENTE ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.10','CONTR.REPASSE DE PROGR. A APROVAR POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELO CONTRATANTE, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.11','CONTR.REPASSE DE PROGR. APROVADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.12','CONTR.REPASSE DE PROGR. HOMOLOGADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA HOMOLOGACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.13','CONTR.REPASSE DE PROGR. IMPUGNADO POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.14','CONTR.REPASSE DE PROGR. INADIMPLENTE POR CNPJ','REGISTRA O VALOR DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS PELO GESTOR, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.02.15','CONTR.REPASSE DE PROGR. NAO LIBERADO POR CNPJ.','REGISTRA OS VALORES NAO LIBERADOS DOS CONTRATOS DE REPASSE DE CONTRATOS DE PROGRAMAS ESPECIFICOS, COM CONTROLE POR CNPJ.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.00','TRANSFERENCIAS LEGAIS','COMPREENDE A EXECUCAO DO VALOR DAS TRANSFERENCIAS LEGAIS ABAIXO ESPECIFICADAS: - TERMO DE CONCESSAO DE APOIO FINANCEIRO FIRMADO ENTRE A AGENCIA NACIONAL DE CINEMA - ANCINE E AS ENTIDADES COM FINS LUCRATIVOS, CUJO OBJETIVO E FOMENTAR PROJETOS VOLTADOS AO DESENVOLVIMENTO DO SETOR AUDIOVISUAL BRASILEIRO (MP 2.228-1/2001 E PARECER 393 - TERMO DE ADESAO ASSINADO ENTRE O MINISTERIO DO TRABALHO E EMPREGO E OS ESTADOS, DF E MUNICIPIOS, CUJO OBJETIVO E PREPARAR JOVEM PARA OCUPACOES COM VINCULO EMPREGATICIO OU PARA OUTRAS ATIVIDADES PRODUTIVAS ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.01','TRANSFERENCIAS LEGAIS A LIBERAR ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A LIBERAR CELEBRADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.02','TRANSFERENCIAS LEGAIS A COMPROVAR','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO A COMPROVAR, FIRMADOS NO AMBITO DA ANCINE E DO MTE, RESPECTIVAMENTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.03','TRANSFERENCIAS LEGAIS A APROVAR','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA ENTREGA DA PRESTACAO DE CONTAS PELAS ENTIDADES COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.04','TRANSFERENCIAS LEGAIS APROVADO','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, QUANDO DA APROVACAO DA PRESTACAO DE CONTAS PELO CONCEDENTE, ANCINE E MTE, RESPECTIVAMENTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.05','TRANSFERENCIAS LEGAIS IMPUGNADO ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO QUANDO DA IMPUGNACAO DA PRESTACAO DE CONTAS PELO CONTROLE INTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.06','TRANSFERENCIAS LEGAIS INADIMPLENCIA ','REGISTRA O VALOR DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADE SAO QUANDO DA INADIMPLENCIA DA PRESTACAO DE CONTAS A SER REALIZADA PE LAS ENTIDADES PRIVADAS COM FINS LUCRATIVOS E PELOS ESTADOS, DF E MUNICIPIOS, RESPECTIVAMENTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.03.07','TRANSFERENCIAS LEGAIS CONCLUIDO ','REGISTRA O VALOR CONCLUIDO DOS TERMOS DE CONCESSAO DE APOIO FINANCEIRO E DE ADESAO, APOS APROVACAO TOTAL DA PRESTACAO DE CONTAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.00','EXECUCAO DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES - PORTAL/SICONV','COMPREENDE A EXECUCAO DOS VALORES DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.01','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIQUIDAR','REGISTRA OS VALORES A LIQUIDAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.02','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EXECUTADO POR INSCRICAO DE RESTOS A PAGAR','REGISTRA OS VALORES EXECUTADOS POR RESTOS A PAGAR PROVENIENTES DE TRANSFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO- PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.03','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES LIQUIDADO A LIBERAR','REGISTRA OS VALORES LIQUIDADOS A LIBERAR PROVENIENTES DE TRANSAFERENCIAS VOLUNTARIAS FIRMADAS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS NOS TERMOS DESCRITOS NO INSTRUMENTO - PORTAL/SICONV.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.04','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A LIBERAR','REGISTRA A EXECUCAO DOS VALORES DAS PARCELAS A LIBERAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.05','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A COMPROVAR','REGISTRA A EXECUCAO DOS VALORES A COMPROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A LIBERACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.06','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES A APROVAR','REGISTRA A EXECUCAO DOS VALORES A APROVAR DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.07','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES APROVADOS','REGISTRA A EXECUCAO DOS VALORES APROVADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.08','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES IMPUGNADOS','REGISTRA A EXECUCAO DOS VALORES IMPUGNADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A COMPROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.09','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVENIO FIRMADO E OUTROS INSTRUMENTOS CONGENERES, ANTES DA PRESTACAO DE CONTAS DAS PARCELAS DE RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.10','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES EM INADIMPLENCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVENIOE OUTROS INSTRUMENTOS CONGENERES FIRMADO, APOS A DECISAO JUDICIAL OU ADMINISTRATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.11','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES HOMOLOGADOS','REGISTRA A EXECUCAO DOS VALORES HOMOLOGADOS DE CONVENIOS E OUTROS INSTRUMENTOS CONGENERES PARA SAIDA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APOS A APROVACAO DAS PARCELAS DE RECURSOS .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.12','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.13','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES NAO LIBERADOS','REGISTRA O VALOR NAO LIBERADO RELATIVO AO TOTAL FIRMADO DO CONVENIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUCAO NR. 13.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.14','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVENIOS DE ACORDO COM O ARTIGO 17 DO DECRETO 6170/2007, REGISTRADA PELA TRANSACAO EXECCONV, EXECUCAO 16 E 17.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.2.3.04.15','CONVENIOS E OUTROS INSTRUMENTOS CONGENERES CONCLUIDOS','REGISTRA O VALOR CONCLUIDO DE CONVENIO E OUTROS INSTRUMENTOS CONGENERES FIRMADO , APOS A APROVACAO TOTAL DA PRESTACAO DE CONTAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.0.00.00','EXECUCAO DE OBRIGACOES CONTRATUAIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.00.00','EXECUCAO DE OBRIGACOES CONTRATUAIS - EXTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.01.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.02.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.02.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.03.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.03.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.04.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.05.01','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.00','CONTRATOS DE EMPRESTIMOS DO OOOC','COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.01','CONTRATOS A LIBERAR','REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.02','EMPRESTIMOS LIBERADOS','REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.03','EMPRESTIMOS LIBERADOS - RP','REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.04','EMPRESTIMOS REEMBOLSADOS - PRINCIPAL','REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.05','EMPRESTIMOS REEMBOLSADOS - JUROS','REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.06','EMPRESTIMOS REEMBOLSADOS - SANCOES','REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.07','OPERACOES EQUALIZADAS','REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.08','OPERACOES EQUALIZADAS - RP','REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.09','ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF','REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.10','REMUNERACAO - CUSTOS ADMINISTRATIVOS','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.11','REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.12','RESTITUICAO','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.06.13','RESTITUICAO - RP','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.07.00','OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.07.01','EM EXECUCAO','REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.07.02','EXECUTADOS','REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.08.00','CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.08.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.08.02','EXECUTADOS','REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.09.00','CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.09.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.09.02','EXECUTADOS','REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.10.00','CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC','COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.10.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.10.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.11.00','CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.11.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.11.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.12.00','EXECUCAO DE CONTRATO DE GESTAO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.12.01','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.12.02','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.13.00','ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS','COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.13.01','A LIBERAR','REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.13.02','A COMPROVAR','REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.13.03','COMPROVADO','REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.13.04','CONCLUIDO',' REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.14.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.14.01','EM EXECUCAO','REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.1.14.02','EXECUTADOS','REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.00.00','EXECUCAO DE OBRIGACOES CONTRATUAIS - INTRA OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.01.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.02.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.02.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.03.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.03.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.04.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.05.01','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.00','CONTRATOS DE EMPRESTIMOS DO OOOC','COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.01','CONTRATOS A LIBERAR','REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.02','EMPRESTIMOS LIBERADOS','REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.03','EMPRESTIMOS LIBERADOS - RP','REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.04','EMPRESTIMOS REEMBOLSADOS - PRINCIPAL','REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.05','EMPRESTIMOS REEMBOLSADOS - JUROS','REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.06','EMPRESTIMOS REEMBOLSADOS - SANCOES','REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.07','OPERACOES EQUALIZADAS','REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.08','OPERACOES EQUALIZADAS - RP','REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.09','ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF','REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.10','REMUNERACAO - CUSTOS ADMINISTRATIVOS','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.11','REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.12','RESTITUICAO','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.06.13','RESTITUICAO - RP','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.07.00','OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.07.01','EM EXECUCAO','REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.07.02','EXECUTADOS','REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.08.00','CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.08.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.08.02','EXECUTADOS','REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.09.00','CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.09.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.09.02','EXECUTADOS','REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.10.00','CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC','COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.10.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.10.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.11.00','CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.11.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.11.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.12.00','EXECUCAO DE CONTRATO DE GESTAO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.12.01','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.12.02','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.13.00','ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS','COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.13.01','A LIBERAR','REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.13.02','A COMPROVAR','REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.13.03','COMPROVADO','REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.13.04','CONCLUIDO',' REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.14.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.14.01','EM EXECUCAO','REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.2.14.02','EXECUTADOS','REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.00.00','EXECUCAO DE OBRIGACOES CONTRATUAIS - INTER OFSS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.01.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.02.00','CONTRATOS DE SERVICOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.02.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.03.00','CONTRATOS DE ALUGUEIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.03.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.04.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.05.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.05.01','EM EXECUCAO','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.00','CONTRATOS DE EMPRESTIMOS DO OOOC','COMPREENDE A CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DOS CONTRATOS ASSINADOS, A LIBERAR E LIBERADOS PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO - OOOC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.01','CONTRATOS A LIBERAR','REGISTRA A EXECUCAO DOS VALORES A LIBERAR DOS CONTRATOS DE EMPRESTIMO CONCEDIDO PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO COM OS BANCOS PRIVADOS E OFICIAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.02','EMPRESTIMOS LIBERADOS','REGISTRA A EXECUCAO DOS VALORES LIBERADOS DE EMPRESTIMOS VINCULADO A CONTRATO COM BANCOS PRIVADOS, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.03','EMPRESTIMOS LIBERADOS - RP','REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DECREDITO (PRINCIPAL).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.04','EMPRESTIMOS REEMBOLSADOS - PRINCIPAL','REGISTRA A EXECUCAO DOS VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (JUROS).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.05','EMPRESTIMOS REEMBOLSADOS - JUROS','REGISTRA A EXECUCAO DOS O VALORES DA RECEITA DE AMORTIZACAO DE EMPRESTIMOS VINCULADOS A CONTRATO COM BANCOS PRIVADOS, DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (SANCOES).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.06','EMPRESTIMOS REEMBOLSADOS - SANCOES','REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS DECORRENTES DE CONTRATOS DEFINANCIAMENTO DE O2C.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.07','OPERACOES EQUALIZADAS','REGISTRA A EXECUCAO DOS VALORES DAS OPERACOES EQUALIZADAS REFERENTE A RESTOS A PAGAR,DO ORCAMENTO DAS OPERACOES ESPECIAIS DE CREDITO (PRINCIPAL).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.08','OPERACOES EQUALIZADAS - RP','REGISTRA A EXECUCAO DOS VALORES DOS EMPRESTIMOS LIBERADOS - REFERENTES A RESTOS APAGAR, PELO ORCAMENTO DAS OPERACOES OFICIAIS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.09','ALIENACAO ESTOQUES EST./REG./INDENIZ. - AGF','REGISTRA A EXECUCAO DOS VALORES DAS RECEITAS DECORRENTES DE ALINACOES DE ESTOQUES REGULADORES/ESTRATEGICOS E INDENIZACOES VINCULADOS A POLITICA DE GARANTIA DE PRECOS MINIMOS - PGPM - REALIZADAS PELA CONAB.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.10','REMUNERACAO - CUSTOS ADMINISTRATIVOS','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498/2002, DE 15 DE MARCO DE 2002.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.11','REMUNERACAO - CUSTOS ADMINISTRATIVOS - RAP','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTOS A PAGAR DE CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO, CONFORME PREVISTO EM CONTRATO. DECISAO TCU 498, DE 15 DE MARCO DE 2002.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.12','RESTITUICAO','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.06.13','RESTITUICAO - RP','REGISTRA A EXECUCAO DOS VALORES DAS APROPRIACOES DAS DESPESAS REFERENTES A RESTITUICOES DEVIDAS POR ORGAOS E ENTIDADES (RESTOS A PAGAR).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.07.00','OPERACOES C/ BENS E SERVICOS NO EXTERIOR COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DAS OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.07.01','EM EXECUCAO','REGISTRA A EXECUCAOS DOS VALORES A LIBERAR RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.07.02','EXECUTADOS','REGISTRA A EXECUCAOS DOS VALORES LIBERADOS RELATIVOS A OPERACOES COM BENS E SERVICOS REALIZADAS NO EXTERIOR COM CONTROLE POR PC OU RC, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.08.00','CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORESDOS CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.08.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.08.02','EXECUTADOS','REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SEGUROS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.09.00','CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC','COMPREENDE AS CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.09.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS SERVICOS A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.09.02','EXECUTADOS','REGISTRA A EXECUCAO DOS SERVICOS REALIZADOS RELATIVOS A CONTRATOS DE SERVICOS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.10.00','CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC','COMPREENDE CONTAS RELACIONADOS A EXECUCAO DOS VALORES DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.10.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL A APROPRIAR DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.10.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES RELATIVOS A ALUGUEL APROPRIADO DOS CONTRATOS DE ALUGUEIS COM CONTROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.11.00','CONTRATOS DE FORNECIMENTO DE BENS COM CONTROLE POR PC OU RC','COMPREENDE CONTAS RELACIONADAS A EXECUCAO DOS VALORES DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.11.01','EM EXECUCAO','REGISTRA A EXECUCAO DOS VALORES A EXECUTAR DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.11.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A EXECUTADOS DOS CONTRATOS DE FORNECIMENTO DE BENS COM CONROLE POR PC OU RC.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.12.00','EXECUCAO DE CONTRATO DE GESTAO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.12.01','CONTRATOS DE GESTAO A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.12.02','CONTRATOS DE GESTAO LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.13.00','ACORDO TRANSF.RECURSOS P/ORG. INTERNACIONAIS','COMPREENDE OS VALORES DE ACORDOS PARA SAIDA DE RECURSOS FIRMADOS COMORGANISMOS INTERNACIONAIS, CONTROLANDO A EFETIVA UTILIZACAO DOS MESMOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.13.01','A LIBERAR','REGISTRO DO VALOR TOTAL DO ACORDO A LIBERAR, BAIXANDO A MEDIDA DA TRANSFERENCIA DOS RECURSOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.13.02','A COMPROVAR','REGISTRO DO VALOR TOTAL DO ACORDO LIBERADO E PENDENTE DE COMPROVACAO DA SUA EFETIVA UTILIZACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.13.03','COMPROVADO','REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO COMPROVADA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.13.04','CONCLUIDO',' REGISTRO O VALOR DOS RECURSOS LIBERADOS E QUE TIVERAM SUA EFETIVA UTILIZACAO CONCLUIDA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.14.00','CONTRATOS DE OPERACOES DE CREDITO','COMPREENDE A EXECUCAO DAS CONTAS QUE REGISTRAM O VALOR DO CONTRATO DECORRENTE DE OPERACOES DE CREDITO ENTRE ORGAO OU ENTIDADE CONTRATANTE E TERCEIROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.14.01','EM EXECUCAO','REGISTRA A EXECUCAO DO VALOR DO CONTRATO A LIBERAR DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.3.3.14.02','EXECUTADOS','REGISTRA A EXECUCAO DO VALOR DO CONTRATO LIBERADO DECORRENTE DE OPERACOES DE CREDITO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.9.0.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.9.1.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - EXTRA OFSS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.9.2.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - INTRA OFSS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.1.2.9.3.00.00','EXECUCAO DE OUTROS ATOS POTENCIAIS PASSIVOS - INTER OFSS','COMPREENDE A EXECUCAO DOS ATOS POTENCIAIS PASSIVOS NAO CONTEMPLADOS EM CONTAS ESPECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.0.0.0.00.00','EXECUCAO DA ADMINISTRACAO FINANCEIRA','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA PROGRAMACAO FINANCEIRA E DE CONTROLE DAS DISPONIBILIDADES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.0.0.00.00','EXECUCAO DAS DISPONIBILIDADES POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS CONTROLES DAS DISPONIBILIDADES POR DESTINACAO DE RECURSOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.1.0.00.00','EXECUCAO DA DISPONIBILIDADE DE RECURSOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS DISPONIBILIDADES DE RECURSOS A UTILIZAR, COMPROMETIDAS E UTILIZADAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.1.1.00.00','DISPONIBILIDADE POR DESTINACAO DE RECURSOS','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS A UTILIZAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.1.2.00.00','DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA POR EMPENHO','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DO EMPENHO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.1.3.00.00','DISPONIBILIDADE POR DESTINACAO DE RECURSOS COMPROMETIDA POR LIQUIDACAO E ENTRADAS COMPENSATORIAS','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS COMPROMETIDAS POR OCASIAO DA LIQUIDACAO E DE ENTRADAS COMPENSATORIAS. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.1.4.00.00','DISPONIBILIDADE POR DESTINACAO DE RECURSOS UTILIZADA','REGISTRA O VALOR DAS DISPONIBILIDADES DE RECURSOS UTILIZADAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.0.00.00','EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR ','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.1.00.00','EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR CONCEDIDO POR DESTINACAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.1.01.00','VALORES DE LIMITE DE RP A CONCEDER','REGISTRA O VALORES A CONCEDER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.1.02.00','VALORES DE LIMITE DE RP CONCEDIDO','REGISTRA O VALORES CONCEDIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.2.00.00','EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO FINANCEIRA DO LIMITE DE RESTOS A PAGAR RECEBIDO POR DESTINACAO. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.2.01.00','VALORES DE LIMITE DE RP A RECEBER','REGISTRA O VALORES A RECEBER, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.2.2.02.00','VALORES DE LIMITE DE RP RECEBIDO','REGISTRA O VALORES RECEBIDOS, REFERENTES AO LIMITE DE RESTOS A PAGAR, CLASSIFICADOS POR DESTINACAO DE RECURSOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.0.00.00','EXECUCAO DO RECURSO DIFERIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RECURSOS DIFERIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.00.00','EXECUCAO DE CONCESSAO DE RECURSO DIFERIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE RECURSOS DIFERIDOS QUE SERAO CONCEDIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.01.00','EXECUCAO DE COTA DIFERIDA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE COTAS DIFERIDAS QUE SERAO CONCEDIDAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.01.01','COTA DIFERIDA A CONCEDER','REGISTRA AS COTAS DIFERIDAS A CONCEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.01.02','COTA DIFERIDA CONCEDIDA','REGISTRA AS COTAS DIFERIDAS CONCEDIDAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.01.03','CANCELAMENTO DE COTA DIFERIDA A CONCEDER','REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE COTAS DIFERIDAS INSCRITAS A CONCEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.02.00','EXECUCAO DE REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE REPASSES DIFERIDOS QUE SERAO CONCEDIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.02.01','REPASSE DIFERIDO A CONCEDER','REGISTRA OS REPASSES DIFERIDOS A CONCEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.02.02','REPASSE DIFERIDO CONCEDIDO','REGISTRA OS REPASSES DIFERIDOS CONCEDIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.02.03','CANCELAMENTO DE REPASSE DIFERIDO A CONCEDER','REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE REPASSES DIFERIDOS INSCRITOS A CONCEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.03.00','EXECUCAO DE SUB-REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE SUB-REPASSES DIFERIDOS QUE SERAO CONCEDIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.03.01','SUB-REPASSE DIFERIDO A CONCEDER','REGISTRA OS SUB-REPASSES DIFERIDOS A CONCEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.03.02','SUB-REPASSE DIFERIDO CONCEDIDO','REGISTRA OS SUB-REPASSES DIFERIDOS CONCEDIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.1.03.03','CANCELAMENTO DE SUB-REPASSE DIFERIDO A CONCEDER','REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE SUB-REPASSES DIFERIDOS INSCRITOS A CONCEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.00.00','EXECUCAO DE RECEBIMENTO DE RECURSO DIFERIDO POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE RECURSOS DIFERIDOS QUE SERAO RECEBIDOS. RECURSOS DIFERIDOS SAO AS SOBRAS DE RECURSOS FINANCEIROS AO FINAL DO EXERCICIO (RECURSO DIFERIDO), QUE DEVERIAM SER DEVOLVIDAS A CONTA UNICA, POREM, AO INVES DISSO, ESSAS SOBRAS SAO LIBERADAS PARA USO (APENAS NO EXERCICIO SEGUINTE) ATRAVES DE DESCONTOS DAS TRANSFERENCIAS FINANCEIRAS (COTA, REPASSE E SUB-REPASSE) DO EXERCICIO SEGUINTE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.01.00','EXECUCAO DE COTA DIFERIDA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE COTAS DIFERIDAS QUE SERAO RECEBIDAS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.01.01','COTA DIFERIDA A RECEBER','REGISTRA AS COTAS DIFERIDAS A RECEBER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.01.02','COTA DIFERIDA RECEBIDA','REGISTRA AS COTAS DIFERIDAS RECEBIDAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.01.03','CANCELAMENTO DE COTA DIFERIDA A RECEBER','REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE COTAS DIFERIDAS INSCRITAS A RECEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.02.00','EXECUCAO DE REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE REPASSES DIFERIDOS QUE SERAO RECEBIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.02.01','REPASSE DIFERIDO A RECEBER','REGISTRA OS REPASSES DIFERIDOS A RECEBER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.02.02','REPASSE DIFERIDO RECEBIDO','REGISTRA OS REPASSES DIFERIDOS RECEBIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.02.03','CANCELAMENTO DE REPASSE DIFERIDO A RECEBER','REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE REPASSES DIFERIDOS INSCRITOS A RECEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.03.00','EXECUCAO DE SUB-REPASSE DIFERIDO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE SUB-REPASSES DIFERIDOS QUE SERAO RECEBIDOS. ','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.03.01','SUB-REPASSE DIFERIDO A RECEBER','REGISTRA OS SUB-REPASSES DIFERIDOS A RECEBER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.03.02','SUB-REPASSE DIFERIDO RECEBIDO','REGISTRA OS SUB-REPASSES DIFERIDOS RECEBIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.1.3.2.03.03','CANCELAMENTO DE SUB-REPASSE DIFERIDO A RECEBER','REGISTRAM O CANCELAMENTO DAS DISPONIBILIDADES DE SUB-REPASSES DIFERIDOS INSCRITOS A RECEDER.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.0.0.00.00','EXECUCAO DA PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.0.00.00','EXECUCAO DE CONCESSAO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DAS COTAS, REPASSES E SUB-REPASSES A CONCEDER PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.00.00','CONCESSAO DE COTAS DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DAS COTAS DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.01.00','COTA INDISPONIVEL','REGISTRA AS COTAS A SEREM CONCEDIDAS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.02.00','COTA A PROGRAMAR','REGISTRA AS COTAS A SEREM CONCEDIDAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.03.00','COTA SOLICITADA A APROVAR','REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.04.00','COTA SOLICITADA APROVADA A LIBERAR','REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.05.00','COTA SOLICITADA APROVADA LIBERADA','REGISTRA AS COTAS CONCEDIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.06.00','COTA TRANSFERIDA','REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.07.00','COTA PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.08.00','COTA PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.09.00','COTA PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.10.00','COTA PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.11.00','COTA PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.12.00','COTA DIRETAMENTE ARRECADADA','REGISTRA OS VALORES DE COTAS CONCEDIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.1.13.00','COTA DE RESTOS A PAGAR LIBERADA','REGISTRA O VALOR DAS COTAS DE RESTOS A PAGAR LIBERADAS PELAS SETORIAS DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.00.00','CONCESSAO DE COTAS NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DAS COTAS NAO DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.01.00','COTA DE LIMITE DE RESTOS A PAGAR AUTORIZADO','REGISTRA O VALOR DOS LIMITES DE COTAS A SEREM CONCEDIDAS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.02.00','COTA NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR','REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.03.00','COTA NAO DECORRENTE DO ORCAMENTO APROVADA A LIBERAR','REGISTRA AS COTAS A SEREM CONCEDIDAS, JA SOLICITADAS E APROVADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.04.00','COTA NAO DECORRENTE DO ORCAMENTO APROVADA LIBERADA','REGISTRA AS COTAS CONCEDIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.05.00','COTA TRANSFERIDA','REGISTRA AS COTAS NAO DECORRENTES DO ORCAMENTO TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.06.00','COTA PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.07.00','COTA PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.08.00','COTA PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.09.00','COTA PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.10.00','COTA PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.2.11.00','COTA DIRETAMENTE ARRECADADA','REGISTRA OS VALORES DE COTAS CONCEDIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.00.00','CONCESSAO DE COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS LIBERADOS PELA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.01.00','COTA DE RESTITUICAO ','COMPREENDE OS VALORES DE COTAS PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.01.01','COTA DE RESTITUICAO SOLICITADA A LIBERAR','REGISTRA OS VALORES DE COTAS SOLICITADAS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.01.02','COTA DE RESTITUICAO A LIBERAR','REGISTRA OS VALORES DE COTAS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.01.03','COTA DE RESTITUICAO LIBERADA','REGISTRA OS VALORES DE COTAS LIBERADAS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.01.04','COTA DE RESTITUICAO UTILIZADA','REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.01.05','COTA DE RESTITUICAO UTILIZADA - GRU','REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL, POR MEIO DE GRU.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.02.00','COTA DE COMPENSACAO UTILIZADA','REGISTRA OS VALORES DE COTAS A SEREM CONCEDIDAS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.03.00','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS','COMPREENDE O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.03.01','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADA A LIBERAR','REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.03.02','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A LIBERAR','REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A LIBERAR DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.3.03.03','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS LIBERADA','REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS LIBERADAS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.00.00','CONCESSAO DE REPASSES DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS REPASSES DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.01.00','REPASSE INDISPONIVEL','REGISTRA OS REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.02.00','REPASSE A PROGRAMAR','REGISTRA OS REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.03.00','REPASSE SOLICITADO A APROVAR','REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.04.00','REPASSE SOLICITADO APROVADO A LIBERAR','REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.05.00','REPASSE SOLICITADO APROVADO LIBERADO','REGISTRA OS REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.06.00','REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.07.00','REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.08.00','REPASSE SOLICITADO APROVADO A LIBERAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.09.00','REPASSE SOLICITADO APROVADO LIBERADO POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.10.00','REPASSE TRANSFERIDO','REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.11.00','REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.12.00','REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.13.00','REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.14.00','REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.15.00','REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.4.16.00','REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.00.00','CONCESSAO DE REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS REPASSES NAO DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.01.00','REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO','REGISTRA O VALOR DOS LIMITES DE REPASSES A SEREM CONCEDIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.02.00','REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR','REGISTRA AS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.03.00','REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR','REGISTRA AS REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.04.00','REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO','REGISTRA AS REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.05.00','REPASSE TRANSFERIDO','REGISTRA AS REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.06.00','REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.07.00','REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.08.00','REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.09.00','REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.10.00','REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.5.11.00','REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.00.00','CONCESSAO DE REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES CONCEDIDOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.01.00','REPASSE DE RESTITUICAO ','REGISTRA OS VALORES DE REPASSES PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.01.01','REPASSE DE RESTITUICAO SOLICITADO A LIBERAR','REGISTRA OS VALORES DE REPASSES SOLICITADOS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.01.02','REPASSE DE RESTITUICAO A LIBERAR','REGISTRA OS VALORES DE REPASSES A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.01.03','REPASSE DE RESTITUICAO LIBERADO','REGISTRA OS VALORES DE REPASSES LIBERADOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.01.04','REPASSE DE RESTITUICAO UTILIZADO','REGISTRA OS VALORES DE REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.02.00','REPASSE DE COMPENSACAO UTILIZADA','REGISTRA OS VALORES DE REPASSES A SEREM CONCEDIDOS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.03.00','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.03.01','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A LIBERAR','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.03.02','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A LIBERAR','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A LIBERAR DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.6.03.03','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS LIBERADO','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS LIBERADOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.00.00','CONCESSAO DE SUB-REPASSES DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.01.00','SUB-REPASSE INDISPONIVEL','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.02.00','SUB-REPASSE A PROGRAMAR','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.03.00','SUB-REPASSE SOLICITADO A APROVAR','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.04.00','SUB-REPASSE SOLICITADO APROVADO A LIBERAR','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.05.00','SUB-REPASSE SOLICITADO APROVADO LIBERADO','REGISTRA OS SUB-REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.06.00','SUB-REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.07.00','SUB-REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.08.00','SUB-REPASSE SOLICITADO APROVADO A LIBERAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.09.00','SUB-REPASSE SOLICITADO APROVADO LIBERADO POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.10.00','SUB-REPASSE TRANSFERIDO','REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.11.00','SUB-REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.12.00','SUB-REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.13.00','SUB-REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.14.00','SUB-REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.15.00','SUB-REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.7.16.00','SUB-REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.00.00','CONCESSAO DE SUB-REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA CONCESSAO DOS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.01.00','SUB-REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO','REGISTRA O VALOR DOS LIMITES DE SUB-REPASSES A SEREM CONCEDIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.02.00','SUB-REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR','REGISTRA AS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.03.00','SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR','REGISTRA AS SUB-REPASSES A SEREM CONCEDIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.04.00','SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO','REGISTRA AS SUB-REPASSES CONCEDIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.05.00','SUB-REPASSE TRANSFERIDO','REGISTRA AS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.06.00','SUB-REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.07.00','SUB-REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.08.00','SUB-REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.09.00','SUB-REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.10.00','SUB-REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.8.11.00','SUB-REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE SUB-REPASSES CONCEDIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.00.00','CONCESSAO DE SUB-REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES LIBERADOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.01.00','SUB-REPASSE DE RESTITUICAO ','REGISTRA OS VALORES DE SUB-REPASSES A SEREM LIBERADOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.01.01','SUB-REPASSE DE RESTITUICAO SOLICITADO A LIBERAR','REGISTRA OS VALORES DE SUB-REPASSES SOLICITADOS A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.01.02','SUB-REPASSE DE RESTITUICAO A LIBERAR','REGISTRA OS VALORES DE SUB-REPASSES A LIBERAR, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.01.03','SUB-REPASSE DE RESTITUICAO LIBERADO','REGISTRA OS VALORES DE SUB-REPASSES LIBERADOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.01.04','SUB-REPASSE DE RESTITUICAO UTILIZADO','REGISTRA OS VALORES DE SUB-REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.02.00','SUB-REPASSE DE COMPENSACAO UTILIZADA','REGISTRA OS VALORES DE SUB-REPASSES A SEREM CONCEDIDOS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.03.00','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.03.01','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A LIBERAR','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.03.02','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A LIBERAR','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A LIBERAR DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.1.9.03.03','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS LIBERADO','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS LIBERADOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.0.00.00','EXECUCAO DO RECEBIMENTO DE RECURSOS FINANCEIROS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.00.00','RECEBIMENTO DE COTAS DECORRENTES DO ORCAMENTO','COMPREENDE O VALOR TOTAL DAS COTAS, RECEBIDAS OU NAO, DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.01.00','COTA INDISPONIVEL','REGISTRA AS COTAS A SEREM RECEBIDAS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.02.00','COTA A PROGRAMAR','REGISTRA AS COTAS A SEREM RECEBIDAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.03.00','COTA SOLICITADA A APROVAR','REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.04.00','COTA SOLICITADA APROVADA A RECEBER','REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.05.00','COTA SOLICITADA APROVADA RECEBIDA','REGISTRA AS COTAS RECEBIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.06.00','COTA TRANSFERIDA','REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.07.00','COTA PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.08.00','COTA PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.09.00','COTA PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.10.00','COTA PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.11.00','COTA PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.12.00','COTA DIRETAMENTE ARRECADADA','REGISTRA OS VALORES DE COTAS RECEBIDAS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.1.13.00','COTA FINANCEIRA DE RESTOS A PAGAR - RECEBIDAS ','REGISTRA O VALOR DAS COTAS DE RESTOS A PAGAR RECEBIDAS UNIDADES GESTORAS BENEFICIARIAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.00.00','RECEBIMENTO DE COTAS NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DAS COTAS NAO DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.01.00','COTA DE LIMITE DE RESTOS A PAGAR AUTORIZADO','REGISTRA O VALOR DOS LIMITES DE COTAS A SEREM RECEBIDAS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.02.00','COTA NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR','REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.03.00','COTA NAO DECORRENTE DO ORCAMENTO APROVADA A RECEBER','REGISTRA AS COTAS A SEREM RECEBIDAS, JA SOLICITADAS E APROVADAS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.04.00','COTA NAO DECORRENTE DO ORCAMENTO APROVADA RECEBIDA','REGISTRA AS COTAS RECEBIDAS, SOLICITADAS E APROVADAS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.05.00','COTA TRANSFERIDA','REGISTRA AS COTAS NAO DECORRENTES DO ORCAMENTO TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.06.00','COTA PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.07.00','COTA PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.08.00','COTA PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.09.00','COTA PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.10.00','COTA PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.2.11.00','COTA DIRETAMENTE ARRECADADA','REGISTRA OS VALORES DE COTAS RECEBIDAS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADAS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA (OCPF).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.00.00','RECEBIMENTO DE COTAS DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS RECURSOS RECEBIDOS PELA STN PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.01.00','COTA DE RESTITUICAO ','COMPREENDE OS VALORES DE COTAS PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.01.01','COTA DE RESTITUICAO SOLICITADA A RECEBER','REGISTRA OS VALORES DE COTAS SOLICITADAS A SEREM RECEBIDAS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.01.02','COTA DE RESTITUICAO A RECEBER','REGISTRA OS VALORES DE COTAS A SEREM RECEBIDAS , PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.01.03','COTA DE RESTITUICAO RRECEBIDA','REGISTRA OS VALORES DE COTAS RECEBIDA, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.01.04','COTA DE RESTITUICAO UTILIZADA','REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.01.05','COTA DE RESTITUICAO UTILIZADA - GRU','REGISTRA OS VALORES DE COTAS UTILIZADAS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL, POR MEIO DE GRU.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.02.00','COTA DE COMPENSACAO UTILIZADA','REGISTRA OS VALORES DE COTAS A SEREM RECEBIDAS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.03.00','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS','COMPREENDE O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.03.01','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADA A RECEBER','REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADAS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.03.02','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A RECEBER','REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A RECEBER DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.3.03.03','COTA DE DEVOLUCAO DE DEPOSITOS JUDICIAIS RECEBIDAS ','REGISTRA O VALOR DE COTAS PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS RECEBIDAS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.00.00','RECEBIMENTO DE REPASSES DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS REPASSES DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.01.00','REPASSE INDISPONIVEL','REGISTRA OS REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.02.00','REPASSE A PROGRAMAR','REGISTRA OS REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.03.00','REPASSE SOLICITADO A APROVAR','REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.04.00','REPASSE SOLICITADO APROVADO A RECEBER','REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.05.00','REPASSE SOLICITADO APROVADO RECEBIDO','REGISTRA OS REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.06.00','REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.07.00','REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.08.00','REPASSE SOLICITADO APROVADO A RECEBER POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.09.00','REPASSE SOLICITADO APROVADO RECEBIDO POR DESCENTRALIZACAO EXTERNA','REGISTRA OS REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.10.00','REPASSE TRANSFERIDO','REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.11.00','REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.12.00','REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.13.00','REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.14.00','REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.15.00','REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.4.16.00','REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.00.00','RECEBIMENTO DE REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS REPASSES NAO DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.01.00','REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO','REGISTRA O VALOR DOS LIMITES DE REPASSES A SEREM RECEBIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.02.00','REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR','REGISTRA AS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.03.00','REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR','REGISTRA AS REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.04.00','REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO','REGISTRA AS REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.05.00','REPASSE TRANSFERIDO','REGISTRA AS REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.06.00','REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.07.00','REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.08.00','REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.09.00','REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.10.00','REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.5.11.00','REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.00.00','RECEBIMENTO DE REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS REPASSES RECEBIDOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.01.00','REPASSE DE RESTITUICAO ','REGISTRA OS VALORES DE REPASSES PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.01.01','REPASSE DE RESTITUICAO SOLICITADO A RECEBER','REGISTRA OS VALORES DE REPASSES SOLICITADOS A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.01.02','REPASSE DE RESTITUICAO A RECEBER','REGISTRA OS VALORES DE REPASSES A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.01.03','REPASSE DE RESTITUICAO RECEBIDO','REGISTRA OS VALORES DE REPASSES RECEBIDOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.01.04','REPASSE DE RESTITUICAO UTILIZADO','REGISTRA OS VALORES DE REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.02.00','REPASSE DE COMPENSACAO UTILIZADA','REGISTRA OS VALORES DE REPASSES A RECEBER, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.03.00','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.03.01','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A RECEBER','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADOS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.03.02','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A RECEBER','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A RECEBER DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.6.03.03','REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS RECEBER','REGISTRA O VALOR DE REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS RECEBIDOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.00.00','RECEBIMENTO DE SUB-REPASSES DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS SUB-REPASSES DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.01.00','SUB-REPASSE INDISPONIVEL','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM INDISPONIVEIS EM VIRTUDE DE LEIS, DECRETOS E PORTARIAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.02.00','SUB-REPASSE A PROGRAMAR','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.03.00','SUB-REPASSE SOLICITADO A APROVAR','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.04.00','SUB-REPASSE SOLICITADO APROVADO A RECEBER','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.05.00','SUB-REPASSE SOLICITADO APROVADO RECEBIDO','REGISTRA OS SUB-REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.06.00','SUB-REPASSE A PROGRAMAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A PROGRAMACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.07.00','SUB-REPASSE SOLICITADO A APROVAR POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.08.00','SUB-REPASSE SOLICITADO APROVADO A RECEBER POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.09.00','SUB-REPASSE SOLICITADO APROVADO RECEBIDO POR DESCENTRALIZACAO EXTERNA','REGISTRA OS SUB-REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, POREM NAO DETERMINADOS PELA LEI ORCAMENTARIA ANUAL E SIM PELAS RELACOES DE DESPESAS ENTRE DOIS ORGAOS (EX: DOIS ORGAO PERTENCENTES A ESTRUTURAS DE MINISTERIOS DIFERENTES QUE DIVIDEM O VALOR DE ALUGUEL DO PREDIO ONDE AMBOS TEM ESCRITORIOS), CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.10.00','SUB-REPASSE TRANSFERIDO','REGISTRA AS COTAS, DECORRENTES DO ORCAMENTO, TRANSFERIDAS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.11.00','SUB-REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.12.00','SUB-REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.13.00','SUB-REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.14.00','SUB-REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.15.00','SUB-REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.7.16.00','SUB-REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.00.00','RECEBIMENTO DE SUB-REPASSES NAO DECORRENTES DO ORCAMENTO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DA RECEBIMENTO DOS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.01.00','SUB-REPASSE DE LIMITE DE RESTOS A PAGAR AUTORIZADO','REGISTRA O VALOR DOS LIMITES DE SUB-REPASSES A SEREM RECEBIDOS, AUTORIZADAS PELO MINISTERIO DA FAZENDA E PELAS COORDENACOES DE ORCAMENTO E FINANCAS DE CADA ORGAO PARA ATENDER DESPESAS COM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.02.00','SUB-REPASSE NAO DECORRENTE DO ORCAMENTO SOLICITADA A APROVAR','REGISTRA AS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A APROVACAO DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.03.00','SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO A LIBERAR','REGISTRA AS SUB-REPASSES A SEREM RECEBIDOS, JA SOLICITADOS E APROVADOS, NAO DECORRENTES DO ORCAMENTO, AGUARDANDO A LIBERACAO FINANCEIRA DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.04.00','SUB-REPASSE NAO DECORRENTE DO ORCAMENTO APROVADO LIBERADO','REGISTRA AS SUB-REPASSES RECEBIDOS, SOLICITADOS E APROVADOS, DECORRENTES DO ORCAMENTO, CUJO FINANCEIRO JA FOI LIBERADO PELO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.05.00','SUB-REPASSE TRANSFERIDO','REGISTRA AS SUB-REPASSES NAO DECORRENTES DO ORCAMENTO TRANSFERIDOS PARA OUTRO ORGAO DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.06.00','SUB-REPASSE PROVENIENTE DE DARF EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DARF ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.07.00','SUB-REPASSE PROVENIENTE DE GPS EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GPS ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.08.00','SUB-REPASSE PROVENIENTE DE DAR EMITIDO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE DAR ELETRONICO, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.09.00','SUB-REPASSE PROVENIENTE DE GFIP EMITIDA','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GFIP ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.10.00','SUB-REPASSE PROVENIENTE DE GRU EMITIDA.','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS ATRAVES DE GRU ELETRONICA, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.8.11.00','SUB-REPASSE DIRETAMENTE ARRECADADO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, NAO DECORRENTES DO ORCAMENTO, DIRETAMENTE ARRECADADOS PELAS UNIDADES GESTORAS POR OUTROS MEIOS QUE NAO DARF, GPS, DAR, GFIP OU GRU, SEM TRANSFERENCIA DE RECURSOS DO ORGAO RESPONSAVEL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.00.00','RECEBIMENTO DE SUB-REPASSES DE RESTITUICAO DE RECEITAS E DEPOSITOS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DOS SUB-REPASSES RECEBIDOS PARA DEVOLUCAO DE RECEITAS E DEPOSITOS DE DIVERSAS ORIGENS E JUDICIAIS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.01.00','SUB-REPASSE DE RESTITUICAO','REGISTRA OS VALORES DE SUB-REPASSES A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.01.01','SUB-REPASSE DE RESTITUICAO SOLICITADO A RECEBER','REGISTRA OS VALORES DE SUB-REPASSES SOLICITADOS A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.01.02','SUB-REPASSE DE RESTITUICAO A RECEBER','REGISTRA OS VALORES DE SUB-REPASSES A RECEBER, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.01.03','SUB-REPASSE DE RESTITUICAO RECEBIDO','REGISTRA OS VALORES DE SUB-REPASSES RECEBIDOS, PARA UTILIZACAO NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.01.04','SUB-REPASSE DE RESTITUICAO UTILIZADO','REGISTRA OS VALORES DE SUB-REPASSES UTILIZADOS NAS RESTITUICOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.02.00','SUB-REPASSE DE COMPENSACAO UTILIZADA','REGISTRA OS VALORES DE SUB-REPASSES A SEREM RECEBIDOS, PARA UTILIZACAO NAS COMPENSACOES DE RECEITAS PELAS UG´S DA SECRETARIA DA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.03.00','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRFE DO INSS PARA A UNIDADE GESTORA DA CAIXA ECONOMICA FEDERAL (CEF).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.03.01','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS SOLICITADO A RECEBER','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS SOLICITADOS AO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.03.02','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS A RECEBER','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS A RECEBER DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.2.2.9.03.03','SUB-REPASSE DE DEVOLUCAO DE DEPOSITOS JUDICIAIS RECEBIDO','REGISTRA O VALOR DE SUB-REPASSES PARA DEVOLUCAO DE DEPOSITOS JUDICIAIS DA SRF E DO INSS RECEBIDOS DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.0.0.00.00','EXECUCAO DO LIMITE ORCAMENTARIO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS ORCAMENTARIOS, CONFORME ESTABELECIDOS EM ATO PROPRIO DOS PODERES E MINISTERIO PUBLICO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.1.0.00.00','EXECUCAO DO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE ORCAMENTARIO NO OCPF','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.1.1.00.00','LIMITE ORCAMENTARIO A DISPONIBILIZAR','REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS A SER DISPONIBILIZADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA OS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.1.2.00.00','LIMITE ORCAMENTARIO DISPONIBILIZADO','REGISTRA O VALOR DO LIMITE DE EMPENHO E MOVIMENTACAO DE CREDITOS DISPONIBILIZADO PELO ORGAO CENTRAL DE PROGRAMACAO FINANCEIRA PARA OS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.0.00.00','EXECUCAO DAS OUTRAS UNIDADES GESTORAS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DO LIMITE ORCAMENTARIO NAS OUTRAS UNIDADES GESTORAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.1.00.00','LIMITE ORCAMENTARIO A UTILIZAR','REGISTRA O VALOR DO LIMITE ORCAMENTARIO A SER UTILIZADO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA PARA MOVIMENTACAO DE CREDITOS E EMPENHO DA DESPESA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.2.00.00','LIMITE ORCAMENTARIO DE PRE-EMPENHO A UTILIZAR','REGISTRA O VALOR DO LIMITE ORCAMENTARIO PRE-EMPENHADO A SER UTILIZADO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA PARA MOVIMENTACAO DE CREDITOS E EMPENHO DA DESPESA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.3.00.00','LIMITE ORCAMENTARIO UTILIZADO','REGISTRA O VALOR DO LIMITE ORCAMENTARIO UTILIZADO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA POR MOVIMENTACAO DE CREDITOS OU EMPENHO DA DESPESA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.4.00.00','LIMITE ORCAMENTARIO TRANSFERIDO','REGISTRA O VALOR DO LIMITE ORCAMENTARIO TRANSFERIDO PELOS ORGAOS SETORIAIS DE PROGRAMACAO FINANCEIRA PARA OS FUNDOS E ENTIDADES VINCULADAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.5.00.00','LIMITE ORCAMENTARIO DESCENTRALIZADO','REGISTRA O VALOR DO LIMITE ORCAMENTARIO DESCENTRALIZADO POR PROVISAO OU DESTAQUE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.6.00.00','LIMITE ORCAMENTARIO POR DESCENTRALIZACAO INTERNA','REGISTRA O VALOR DO LIMITE ORCAMENTARIO UTILIZADO RECEBIDO POR PROVISAO DE CREDITOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.7.00.00','LIMITE ORCAMENTARIO POR DESCENTRALIZACAO EXTERNA','REGISTRA O VALOR DO LIMITE ORCAMENTARIO UTILIZADO POR DESTAQUE DE CREDITOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.3.2.8.00.00','LIMITE ORCAMENTARIO TRANSFERIDO PARA INSCRICAO EM RESTOS A PAGAR','REGISTRA O VALOR DO LIMITE ORCAMENTARIO TRANSFERIDO PARA INSCRICAO EM RESTOS A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.0.0.00.00','CONTROLES DA ARRECADACAO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADACAO COMO DARF, GRU, DAR, ENTRE OUTROS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.0.00.00','CONTROLES DE DARF`S','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.00.00','CONTROLES DE DARF`S POR CODIGO DE RECEITA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.01.00','ARRECADACAO BRUTA POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.02.00','ARRECADACAO BRUTA POR RETIFICACAO POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, RESULTANTE DE RETIFICACOES POSITIVAS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.03.00','EQUALIZACOES???? POR CODIGO DE RECEITA','REGISTRA O VALOR DAS APROPRIACOES DAS EQUALIZACOES POR CODIGO DE RECEITA. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.04.00','PROGRAMA DE RECUPERACAO FISCAL - REFIS POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA DE ARRECADACAO FISCAL - REFIS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.05.00','CONTRIB. INTERV. DOMINIO ECONOMICO - CIDE POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.06.00','RETENCAO DE PGTO DE PJ POR PJ POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A RETENCAO DE PAGAMENTO DE PESSOA JURIDICA POR PESSOA JURIDICA (CONFORME IN SRF 459, DE 18/10/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.07.00','DEPOS.REGIME ESPECIAL TRIBUTACAO PATRIMONIO???? POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO (INSTITUIDO PELA LEI 10.931, DE 02/08/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.08.00','DEP.RET.DE CONTRIB. S/PAGTO ESTAD/MUNIC. A PJ POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AOS DEPOSITOS RELATIVOS AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS (DE ACORDO COM OS ARTIGOS 31 E 33 DA LEI 10.833, DE 29/12/2003), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.09.00','PROGRAMA ESPECIAL - PAES POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA ESPECIAL - PAES, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.10.00','RETENCAO DE ORGAOS PUBLICOS - ROP POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE RETENCOES DE ORGAOS PUBLICOS - ROP, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.11.00','PROGRAMA EXCEPCIONAL - PAEX POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.12.00','SIMPLES NACIONAL POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO SIMPLES NACIONAL (CONFORME LEI COMPLEMENTAR Nº 123, DE 14/12/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.13.00','PROGRAMA EXCEPCIONAL - PAEX 2 POR CODIGO DE RECEITA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006, REFERENTE A DECOMPOSICAO DO CODIGO DE RECEITA 1927 - PARCELAMENTO MP 303/2006, ART. 8, PJ SIMPLES), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.14.00','(-) RESTITUICOES POR CODIGO DE RECEITA','REGISTRA AS RESTITUICOES, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.15.00','(-) INCENTIVOS FISCAIS POR CODIGO DE RECEITA','REGISTRA OS INCENTIVOS FISCAIS, CLASSIFICADOS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.16.00','(-) COMPENSACOES POR CODIGO DE RECEITA','REGISTRA AS COMPENSACOES, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.17.00','(-) RETIFICACOES POR CODIGO DE RECEITA','REGISTRA AS RETIFICACOES NEGATIVAS, CLASSIFICADAS POR CODIGO DE RECEITA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.1.18.00','ITR ARRECADACAO POR CODIGO DE RECEITA',' REGISTRA A ARRECADACAO DA RECEITA DE ITR POR CODIGO DE RECEITA COM O OBJETIVO DE PERMITIR O CONTROLE E REGISTROS CONTIDOS NO ARQUIVO DA SECRETARIA DA RECEITA FEDERAL.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.00.00','CONTROLES DE DARF`S POR CODIGO DE DESTINACAO PRIMARIA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.01.00','ARRECADACAO BRUTA POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.02.00','ARRECADACAO BRUTA POR RETIFICACAO POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, RESULTANTE DE RETIFICACOES POSITIVAS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.03.00','EQUALIZACOES???? POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA O VALOR DAS APROPRIACOES DAS EQUALIZACOES POR CODIGO DE DESTINACAO PRIMARIA. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.04.00','PROGRAMA DE RECUPERACAO FISCAL - REFIS POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA DE ARRECADACAO FISCAL - REFIS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.05.00','CONTRIB. INTERV. DOMINIO ECONOMICO - CIDE POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.06.00','RETENCAO DE PGTO DE PJ POR PJ POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A RETENCAO DE PAGAMENTO DE PESSOA JURIDICA POR PESSOA JURIDICA (CONFORME IN SRF 459, DE 18/10/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.07.00','DEPOS.REGIME ESPECIAL TRIBUTACAO PATRIMONIO???? POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO (INSTITUIDO PELA LEI 10.931, DE 02/08/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.08.00','DEP.RET.DE CONTRIB. S/PAGTO ESTAD/MUNIC. A PJ POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AOS DEPOSITOS RELATIVOS AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS (DE ACORDO COM OS ARTIGOS 31 E 33 DA LEI 10.833, DE 29/12/2003), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.09.00','PROGRAMA ESPECIAL - PAES POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA ESPECIAL - PAES, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.10.00','RETENCAO DE ORGAOS PUBLICOS - ROP POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE RETENCOES DE ORGAOS PUBLICOS - ROP, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.11.00','PROGRAMA EXCEPCIONAL - PAEX POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.12.00','SIMPLES NACIONAL POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO SIMPLES NACIONAL (CONFORME LEI COMPLEMENTAR Nº 123, DE 14/12/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.13.00','PROGRAMA EXCEPCIONAL - PAEX 2 POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006, REFERENTE A DECOMPOSICAO DO CODIGO DE DESTINACAO PRIMARIA 1927 - PARCELAMENTO MP 303/2006, ART. 8, PJ SIMPLES), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.14.00','(-) RESTITUICOES POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA AS RESTITUICOES, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.15.00','(-) INCENTIVOS FISCAIS POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA OS INCENTIVOS FISCAIS, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.16.00','(-) COMPENSACOES POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA AS COMPENSACOES, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.17.00','(-) RETIFICACOES POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA AS RETIFICACOES NEGATIVAS, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.2.18.00','ITR ARRECADACAO POR CODIGO DE DESTINACAO','REGISTRA A ARRECADACAO DA RECEITA DE ITR POR CODIGO DE DESTINACAO DA RECEITA COM O OBJETIVO DE CONTROLE E REGISTROS DOS DADOS CONTIDOS NOS ARQUIVOS DA SECRETARIA DA RECEITA FEDERAL.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.00.00','CONTROLES DE DARF`S POR CODIGO DE DESTINACAO VINCULADA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.01.00','ARRECADACAO BRUTA POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.02.00','ARRECADACAO BRUTA POR RETIFICACAO POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, RESULTANTE DE RETIFICACOES POSITIVAS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.03.00','EQUALIZACOES???? POR CODIGO DE DESTINACAO VINCULADA','REGISTRA O VALOR DAS APROPRIACOES DAS EQUALIZACOES POR CODIGO DE DESTINACAO VINCULADA. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.04.00','PROGRAMA DE RECUPERACAO FISCAL - REFIS POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA DE ARRECADACAO FISCAL - REFIS, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.05.00','CONTRIB. INTERV. DOMINIO ECONOMICO - CIDE POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO - CIDE, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.06.00','RETENCAO DE PGTO DE PJ POR PJ POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE A RETENCAO DE PAGAMENTO DE PESSOA JURIDICA POR PESSOA JURIDICA (CONFORME IN SRF 459, DE 18/10/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.07.00','DEPOS.REGIME ESPECIAL TRIBUTACAO PATRIMONIO???? POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO REGIME ESPECIAL DE TRIBUTACAO DO PATRIMONIO (INSTITUIDO PELA LEI 10.931, DE 02/08/2004), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.08.00','DEP.RET.DE CONTRIB. S/PAGTO ESTAD/MUNIC. A PJ POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AOS DEPOSITOS RELATIVOS AS RETENCOES DE CONTRIBUICOES (CSLL, COFINS, PIS/PASEP) SOBRE PAGAMENTOS A PESSOA JURIDICA DE DIREITO PRIVADO PELOS ESTADOS OU MUNICIPIOS (DE ACORDO COM OS ARTIGOS 31 E 33 DA LEI 10.833, DE 29/12/2003), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.09.00','PROGRAMA ESPECIAL - PAES POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA ESPECIAL - PAES, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.10.00','RETENCAO DE ORGAOS PUBLICOS - ROP POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE RETENCOES DE ORGAOS PUBLICOS - ROP, ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.11.00','PROGRAMA EXCEPCIONAL - PAEX POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.12.00','SIMPLES NACIONAL POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO SIMPLES NACIONAL (CONFORME LEI COMPLEMENTAR Nº 123, DE 14/12/2006), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.13.00','PROGRAMA EXCEPCIONAL - PAEX 2 POR CODIGO DE DESTINACAO VINCULADA','REGISTRA A ARRECADACAO BRUTA DA RECEITA ORCAMENTARIA, REFERENTE AO PROGRAMA EXCEPCIONAL - PAEX (OCORRIDAS NA VIGENCIA DA MEDIDA PROVISORIA Nº 303/2006, REFERENTE A DECOMPOSICAO DO CODIGO DE DESTINACAO VINCULADA 1927 - PARCELAMENTO MP 303/2006, ART. 8, PJ SIMPLES), ARRECADADA POR MEIO DE DARF, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.14.00','(-) RESTITUICOES POR CODIGO DE DESTINACAO VINCULADA','REGISTRA AS RESTITUICOES, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.15.00','(-) INCENTIVOS FISCAIS POR CODIGO DE DESTINACAO VINCULADA','REGISTRA OS INCENTIVOS FISCAIS, CLASSIFICADOS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.16.00','(-) COMPENSACOES POR CODIGO DE DESTINACAO VINCULADA','REGISTRA AS COMPENSACOES, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.1.3.17.00','(-) RETIFICACOES POR CODIGO DE DESTINACAO VINCULADA','REGISTRA AS RETIFICACOES NEGATIVAS, CLASSIFICADAS POR CODIGO DE DESTINACAO VINCULADA, CONFORME FITA 50, PROVENIENTE DA RECEITA FEDERAL. ','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.0.00.00','CONTROLES DE GRU`S','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES).','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.00.00','CONTROLES DE GRU`S POR CODIGO DE RECOLHIMENTO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES), CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.00','GRU POR CODIGO DE RECOLHIMENTO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU, CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.01','RECOLHIMENTO DO PRINCIPAL P/ COD.RECOLHIMENTO','REGISTRA A ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.02','RECOLHIMENTO DE MULTA/MORA/JUROS','REGISTRA A ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.03','RECOLHIMENTO OUTROS ACRESCIMOS','REGISTRA A ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.04','RECOLHIMENTO JUROS E ENCARGOS','REGISTRA A ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.05','(-) DESCONTOS E ABATIMENTOS DO RECOLHIMENTO','REGISTRA DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.01.06','(-) OUTRAS DEDUCOES DO RECOLHIMENTO','REGISTRA OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.00','GRU POR CODIGO DE RECOLHIMENTO - RETIFICACOES','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RETIFICADAS, CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.01','RETIFICACOES DO PRINCIPAL','REGISTRA A RETIFICACAO DA ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.02','RETIFICACOES DE MULTA/MORA/JUROS','REGISTRA A RETIFICACAO DA ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.03','RETIFICACOES DE OUTROS ACRESCIMOS','REGISTRA A RETIFICACAO DA ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.04','RETIFICACOES JUROS/ENCARGOS','REGISTRA A RETIFICACAO DA ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.05','RETIFICACAO DE DESCONTOS E ABATIMENTOS','REGISTRA A RETIFICACAO DE DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.02.06','RETIFICACAO DE OUTRAS DEDUCOES RECOLHIMENTO','REGISTRA A RETIFICACAO DE OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.03.00','GRU POR CODIGO DE RECOLHIMENTO - RESTITUICOES','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RESTITUIDAS, CLASSIFICADAS POR CODIGO DE RECOLHIMENTO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.1.03.01','GRU''S RESTITUIDAS POR CODIGO DE RECOLHIMENTO','REGISTRA A RESTITUICAO DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE RECOLHIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.00.00','CONTROLES DE GRU`S POR CODIGO DE DESTINACAO PRIMARIA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES), CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.00','GRU POR CODIGO DE DESTINACAO PRIMARIA - NORMAIS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.01','RECOLHIMENTO DO PRINCIPAL P/ COD. DEST. PRIM.','REGISTRA A ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.02','RECOLHIMENTO DE MULTA/MORA/JUROS','REGISTRA A ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.03','RECOLHIMENTO OUTROS ACRESCIMOS','REGISTRA A ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.04','RECOLHIMENTO JUROS E ENCARGOS','REGISTRA A ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.05','(-) DESCONTOS E ABATIMENTOS DO RECOLHIMENTO','REGISTRA DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.01.06','(-) OUTRAS DEDUCOES DO RECOLHIMENTO','REGISTRA OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.00','GRU POR CODIGO DE DESTINACAO PRIMARIA - RETIFICACOES','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RETIFICADAS, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.01','RETIFICACOES DO PRINCIPAL','REGISTRA A RETIFICACAO DA ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.02','RETIFICACOES DE MULTA/MORA/JUROS','REGISTRA A RETIFICACAO DA ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.03','RETIFICACOES DE OUTROS ACRESCIMOS','REGISTRA A RETIFICACAO DA ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.04','RETIFICACOES JUROS/ENCARGOS','REGISTRA A RETIFICACAO DA ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.05','RETIFICACAO DE DESCONTOS E ABATIMENTOS','REGISTRA A RETIFICACAO DE DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.02.06','RETIFICACAO DE OUTRAS DEDUCOES RECOLHIMENTO','REGISTRA A RETIFICACAO DE OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.03.00','GRU POR CODIGO DE DESTINACAO PRIMARIA - RESTITUICOES','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RESTITUIDAS, CLASSIFICADAS POR CODIGO DE DESTINACAO PRIMARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.2.03.01','GRU''S RESTITUIDAS POR CODIGO DE DESTINACAO PRIMARIA','REGISTRA A RESTITUICAO DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO PRIMARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.00.00','CONTROLES DE GRU`S POR CODIGO DE DESTINACAO SECUNDARIA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU (INCLUSIVE SUAS RETIFICACOES), CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.00','GRU POR CODIGO DE DESTINACAO SECUNDARIA- NORMAIS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU, CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.01','RECOLHIMENTO DO PRINCIPAL P/ COD. DEST. SEC.','REGISTRA A ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.02','RECOLHIMENTO DE MULTA/MORA/JUROS','REGISTRA A ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.03','RECOLHIMENTO OUTROS ACRESCIMOS','REGISTRA A ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.04','RECOLHIMENTO JUROS E ENCARGOS','REGISTRA A ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.05','(-) DESCONTOS E ABATIMENTOS DO RECOLHIMENTO','REGISTRA DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.01.06','(-) OUTRAS DEDUCOES DO RECOLHIMENTO','REGISTRA OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.','D','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.00','GRU POR CODIGO DE DESTINACAO SECUNDARIA- RETIFICACÒES','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DISCRIMINADOS DA ARRECADACAO DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RETIFICADAS, CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.01','RETIFICACOES DO PRINCIPAL','REGISTRA A RETIFICACAO DA ARRECADACAO DO PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.02','RETIFICACOES DE MULTA/MORA/JUROS','REGISTRA A RETIFICACAO DA ARRECADACAO DE MULTA/MORA SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA. NA GR COBRANCA TAMBEM SAO REGISTRADOS OS JUROS NESSA CONTA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.03','RETIFICACOES DE OUTROS ACRESCIMOS','REGISTRA A RETIFICACAO DA ARRECADACAO DE OUTROS ACRESCIMOS DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.04','RETIFICACOES JUROS/ENCARGOS','REGISTRA A RETIFICACAO DA ARRECADACAO DE JUROS E ENCARGOS SOBRE O PRINCIPAL DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.05','RETIFICACAO DE DESCONTOS E ABATIMENTOS','REGISTRA A RETIFICACAO DE DESCONTOS E ABATIMENTOS DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.02.06','RETIFICACAO DE OUTRAS DEDUCOES RECOLHIMENTO','REGISTRA A RETIFICACAO DE OUTRAS DEDUCOES DA RECEITA ORCAMENTARIA, CONSTANTES NA GRU, CLASSIFICADOS POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.03.00','GRU POR CODIGO DE DESTINACAO SECUNDARIA - RESTITUICOES','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E QUE POSTERIORMENTE FORAM RESTITUIDAS, CLASSIFICADAS POR CODIGO DE DESTINACAO SECUNDARIA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.2.3.03.01','GRU''S RESTITUIDAS POR CODIGO DE DESTINACAO SECUNDARIA','REGISTRA A RESTITUICAO DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, ARRECADADA POR MEIO DE GRU E CLASSIFICADA POR CODIGO DE DESTINACAO SECUNDARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.3.0.00.00','CONTROLES DE DAR''S','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA DE ESTADOS E MUNICIPIOS, RETIDA PELA UG, DE PAGAMENTOS REALIZADOS A EMPRESAS PRESTADORAS DE SERVICOS ENQUADRADAS PELA LC 116.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.2.4.3.1.00.00','ISS SUBSTITUICAO A DISTRIBUIR','REGISTRA A TRANSFERENCIA DE ISS A DISTRIBUIR AOS MUNICIPIOS, PARA CONTROLE DA COFIN.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.0.0.0.00.00','EXECUCAO DA DIVIDA ATIVA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS CREDITOS PASSIVEIS DE SEREM ENCAMINHADOS E INSCRITOS EM DIVIDA ATIVA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.1.0.0.00.00','EXECUCAO DO ENCAMINHAMENTO DE CREDITOS PARA INSCRICAO EM DIVIDA ATIVA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES A SEREM ENCAMINHADOS E OS JA ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.1.1.0.00.00','CREDITOS A ENCAMINHAR PARA A DIVIDA ATIVA','REGISTRA OS VALORES A SEREM ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.1.2.0.00.00','CREDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','REGISTRA OS VALORES ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.1.3.0.00.00','CANCELAMENTO DE CREDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','REGISTRA O CANCELAMENTO DOS VALORES INDEVIDAMENTE ENCAMINHADOS PARA O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.2.0.0.00.00','EXECUCAO DA INSCRICAO DE CREDITOS EM DIVIDA ATIVA','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES A SEREM INSCRITOS EM DIVIDA ATIVA PELO ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.2.1.0.00.00','CREDITOS A INSCREVER EM DIVIDA ATIVA','REGISTRA OS VALORES A SEREM INSCRITOS EM DIVIDA ATIVA PELO O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.2.2.0.00.00','CREDITOS A INSCREVER EM DIVIDA ATIVA DEVOLVIDOS','REGISTRA OS VALORES A SEREM INSCRITOS EM DIVIDA ATIVA QUE FORAM DEVOLVIDOS PELO ORGAO COMPETENTE, POR INCORRECOES NA FORMALIZACAO DO PROCESSO DE ENCAMINHAMENTO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.2.3.0.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA A RECEBER','REGISTRA OS VALORES INSCRITOS EM DIVIDA ATIVA PELO O ORGAO COMPETENTE EM INSCREVER EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.2.4.0.00.00','CREDITOS INSCRITOS EM DIVIDA ATIVA RECEBIDOS','REGISTRA OS VALORES RECEBIDOS RELATIVOS AOS CREDITOS ANTERIORMENTE INSCRITOS EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.3.2.5.0.00.00','BAIXA DE CREDITOS INSCRITOS EM DIVIDA ATIVA','REGISTRA OS VALORES RELATIVOS AS BAIXAS DE CREDITOS INSCRITOS EM DIVIDA ATIVA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.0.0.0.00.00','EXECUCAO DOS RISCOS FISCAIS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.1.0.0.00.00','EXECUCAO DE PASSIVOS CONTINGENTES','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.1.1.0.00.00','PASSIVOS CONTINGENTES PREVISTOS','REGISTRA A PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.1.2.0.00.00','PASSIVOS CONTINGENTES CONFIRMADOS ','REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS CLASSIFICADOS COMO PASSIVOS CONTINGENTES ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.2.0.0.00.00','EXECUCAO DOS DEMAIS RISCOS FISCAIS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS RISCOS FISCAIS QUE NAO PREENCHAM OS REQUISITOS PARA RECONHECIMENTO COMO PASSIVO, NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES, CONFORME IDENTIFICADOS NO ANEXO DE RISCOS FISCAIS DA LEI DE DIRETRIZES ORCAMENTARIAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS PREVISTOS ','REGISTRA A PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.4.2.2.0.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','REGISTRA A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES ','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.8.0.0.0.00.00','APURACAO DE CUSTOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS CUSTOS DOS BENS E SERVICOS PRODUZIDOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.0.0.0.00.00','OUTROS CONTROLES','COMPREENDE AS CONTAS DE CONTROLES DA EXECUCAO NAO ESPECIFICADOS ANTERIORMENTE NOS GRUPOS DESSA CLASSE','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.0.0.00.00','EXECUCAO DE OUTROS CONTROLES DE PROGRAMACAO FINANCEIRA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTRAS PECULIARIDADES DA PROGRAMACAO FINANCEIRA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.0.00.00','EXECUCAO DE REMANEJAMENTO DE COTA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE REMANEJAMENTO DE COTA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.1.00.00','EXECUCAO DE REMANEJAMENTO DE COTA - SETORIAL FINANCEIRA','REGISTRA NA SETORIAL FINANCEIRA A EXECUCAO DO REMANEJAMENTO DE COTA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.1.01.00','COTA FINANCEIRA A REMANEJAR','REGISTRA O VALOR SOLICITADO PARA REMANEJAMENTO DE RECURSO/FONTE/VINCULACAO/CATEGORIA DE GASTO DE COTA FINANCEIRA JA LIBERADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.1.02.00','COTA FINANCEIRA REMANEJADA','REGISTRA O VALOR DAS COTAS FINANCEIRAS REMANEJADAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.2.00.00','EXECUCAO DE REMANEJAMENTO DE COTA - UG BENEFICIADA','REGISTRA NA UG BENEFICIADA A EXECUCAO DO REMANEJAMENTO DE COTA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.2.01.00','COTA FINANCEIRA A REMANEJAR','REGISTRA O VALOR SOLICITADO PARA REMANEJAMENTO DE RECURSO/FONTE/VINCULACAO/CATEGORIA DE GASTO DE COTA FINANCEIRA JA LIBERADA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.1.2.02.00','COTA FINANCEIRA REMANEJADA','REGISTRA O VALOR DAS COTAS FINANCEIRAS REMANEJADAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.0.00.00','EXECUCAO DE PF DE EMPENHO PARA PAGAMENTO CONTRA-ENTREGA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.1.00.00','EXECUCAO DA CONCESSAO DE PF DE EMPENHO CONTRA-ENTREGA','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DA CONCESSAO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.1.01.00','COTA DE EMPENHO CONTRA-ENTREGA CONCEDIDA','REGISTRA A COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA CONCEDIDA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.1.06.00','EXECUCAO DE RETENCAO DE TRIBUTOS PARA RECOLHIMENTO','COMPRENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.1.06.01','TRIBUTO RETIDO A RECOLHER','REGISTRA O VALOR RETIDO, POREM NAO RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.1.06.02','TRIBUTO RETIDO RECOLHIDO','REGISTRA O VALOR RETIDO E RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG 170500, ESSA RETENCAO FEITA POR UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. E UM MERO REFLEXO DA CONTA 7.9.1.2.2.11','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.00.00','EXECUCAO DO RECEBIMENTO DE PF DE EMPENHO CONTRA-ENTREGA','COMPREENDE AS CONTAS QUE REGISTRAM O RECEBIMENTO DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.01.00','COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA A EMPENHAR','REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA A EMPENHAR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.02.00','COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA EMPENHADA A LIQUIDAR','REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA EMPENHADOS A LIQUIDAR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.03.00','COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA LIQUIDADA','REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA LIQUIDADOS A PAGAR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.04.00','COTA DE EMPENHO CONTRA-ENTREGA RECEBIDA PAGA','REGISTRA A DE COTA DESTINADA A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA DIRETAMENTE DA SETORIAL FINANCEIRA LIQUIDADOS PAGOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.05.00','COTA DE EMPENHO CONTRA-ENTREGA TRANSFERIDA','REGISTRA O VALOR QUE ERA DESTINADO A EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, POREM QUE FOI DESTINADO A OUTRA UG, PARA O MESMO FIM (EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA)','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.06.00','EXECUCAO DE RETENCAO DE TRIBUTOS PARA RECOLHIMENTO','COMPRENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.06.01','TRIBUTO RETIDO A RECOLHER','REGISTRA O VALOR RETIDO, POREM NAO RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.1.2.2.06.02','TRIBUTO RETIDO RECOLHIDO','REGISTRA O VALOR RETIDO E RECOLHIDO, DA RETENCAO OCORRIDA, PARA RECOLHIMENTO DE TRIBUTO, NO ATO DO PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA. ESTA CONTA PRESTA-SE A CONTROLAR, NA UG BENEFICIADA PELA COTA DESTINADA A PAGAMENTO DE EMPENHOS COM CARACTERISTICA DE CONTRA-ENTREGA, ESSA RETENCAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.0.0.00.00','EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OUTROS CONTROLES DE DISPONIBILIDADES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.0.00.00','EXECUCAO DE DOCUMENTOS DE ARRECADACAO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE DOCUMENTOS DE ARRECADACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.1.00.00','EXECUCAO DE EMISSAO DE DARF','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE DARF´S.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.1.01.00','DARF A EMITIR','REGISTRA OS DARF´S QUE SERAO EMITIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.1.02.00','DARF EMITIDO','REGISTRA OS DARF´S EMITIDOS CORRESPONDENTES AO RECOLHIMENTO DE RECURSOS PELA RECEITA FEDERAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.1.03.00','DARF EMITIDO POR COMPENSACAO DE TRIBUTO','REGISTRA OS DARF´S EMITIDOS, SEM TRANSFERENCIA DE RECURSOS, DEVIDO A COMPENSACAO DE TRIBUTOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.1.04.00','DARF EMITIDO POR COMPENSACAO - ATUFOLHA','REGISTRA OS DARF´S EMITIDOS, SEM TRANSFERENCIA DE RECURSOS, DEVIDO A COMPENSACAO DE IRRF DECORRIDOS DO PAGAMENTO DA FOLHA .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.2.00.00','EXECUCAO DE EMISSAO DE GPS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE GPS´S.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.2.01.00','GPS A EMITIR','REGISTRA AS GPS´S QUE SERAO EMITIDAS, CLASSIFICADAS POR CODIGO DE PAGAMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.2.02.00','GPS EMITIDA - CONTROLE DO INSS','REGISTRA AS GPS´S ELETRONICAS EMITIDAS NO SISTEMA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.2.03.00','GPS EMITIDA','REGISTRA AS GPS´S EMITIDAS, CLASSIFICADAS POR CODIGO DE PAGAMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.2.04.00','GPS EMITIDA POR COMPENSACAO - ATUFOLHA','REGISTRA AS GPS´S EMITIDAS, SEM TRANSFERENCIA DE RECURSOS, DEVIDO A COMPENSACAO DE CONTRIBUICOES, DECORRIDAS DO PAGAMENTO DA FOLHA .','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.3.00.00','EXECUCAO DE EMISSAO DE DAR','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE DAR´S.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.3.01.00','DAR A EMITIR','REGISTRA OS DAR´S QUE SERAO EMITIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.3.02.00','DAR EMITIDO','REGISTRA OS DAR´S EMITIDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.4.00.00','EXECUCAO DE EMISSAO DE GFIP','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE GFIP´S.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.4.01.00','GFIP A EMITIR','REGISTRA AS GFIP´S QUE SERAO EMITIDAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.4.02.00','GFIP EMITIDA','REGISTRA AS GFIP´S EMITIDAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.5.00.00','EXECUCAO DE EMISSAO DE GRU','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA EMISSAO DE GRU´S.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.5.01.00','GRU A EMITIR','REGISTRA AS GRU´S QUE SERAO EMITIDAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.5.02.00','GRU EMITIDA','REGISTRA AS GRU´S EMITIDAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.1.6.00.00','EXECUCAO DE PAGAMENTOS EFETUADOS','REGISTRA O VALOR DOS PAGAMENTOS EFETUADOS PELAS UNIDADES GESTORAS COM BASE NO LIMITE DE SAQUE DA CONTA UNICA DA SECRETARIA DO TESOURO NACIONAL OU DA CONTA UNICA INSTITUCIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.2.0.00.00','EXECUCAO DE DISPONIBILIDADES DA CONTA ESPECIAL','COMPREENDE AS CONTAS QUE REGISTRAM A MOVIMENTACAO FINANCEIRA VINCULADA AOS EMPRESTIMOS EXTERNOS RECEBIDOS (ANTES DE REGISTRAR NA CONTA UNICA)','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.2.1.00.00','INGRESSOS','REGISTRA O VALOR DE INGRESSOS DE CAIXA DO TESOURO NACIONAL ORIUNDOS DE EMPRESTIMOS EXTERNOS, ANTES DA ETAPA DO REEMBOLSO (REGISTRO NA CONTA UNICA).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.2.2.2.00.00','DISPONIBILIDADES DE RECURSO POR DESTINACAO','REGISTRA A MOVIMENTACAO FINANCEIRA VINCULADA AOS INGRESSOS DOS RECURSOS EXTERNOS BEM COMO A APROVACAO DE REEMBOLSO DOS RECURSOS APLICADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.0.0.00.00','EXECUCAO DE CONTROLES DE BENEFICIOS PAGOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO PAGAMENTO DE BENEFICIOS PREVIDENCIARIOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.0.00.00','EXECUCAO DE BENEFICIOS PAGOS PELA REDE BANCARIA','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.1.00.00','EXECUCAO DE BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ATUAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.1.01.00','APOSENTADORIAS','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM APOSENTADORIAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.1.02.00','PENSOES','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM PENSOES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.1.03.00','OUTROS BENEFICIOS PREVIDENCIARIOS','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM OUTROS BENEFICIOSPREVIDENCIARIOS NAO DISCRIMINADOS NOS ITENS ANTERIORES, PAGOS PELA RE-DE BANCARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.1.04.00','AUXILIO A PESSOAS FISICAS','REGISTRA O VALOR DAS DESPESAS COM A CONCESSAO DE AUXILIO FINANCEIRODIRETAMENTE A PESSOAS FISICAS, SOB AS MAIS DIVERSAS MODALIDADES, TAISCOMO AJUDA OU APOIO FINANCEIRO E SUBSIDIO OU COMPLEMENTACAO NA AQUISI-CAO DE BENS, NAO CLASSIFICADOS EXPLICITA OU IMPLICITAMENTE EM OUTROSELEMENTOS DE DESPESAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.1.05.00','SENTENCAS JUDICIAIS','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM SENTENCAS JUDICIAIS RELATIVAS A BENEFICIOS DA PREVIDENCIA SOCIAL PAGOS PELA REDE BANCARIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.1.2.00.00','EXECUCAO DE BENEFICIOS PAGOS PELA REDE BANCARIA DO EXERCICIO ANTERIOR','REGISTRA A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS PAGOS DIRETAMENTE PELA REDE BANCARIA NO EXERCICIO ANTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.0.00.00','EXECUCAO DE BENEFICIOS PAGOS POR EMPRESAS CONVENENTES','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.1.00.00','EXECUCAO DE BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO','COMPREENDE AS CONTAS QUE REGISTRAM OS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.1.01.00','APOSENTADORIAS','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM APOSENTADORIAS REEM-BOLSADAS AS EMPRESAS SOB REGIME DE CONVENIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.1.02.00','PENSOES','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM PENSOES PAGAS POREMPRESAS CONVENENTES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.1.03.00','OUTROS BENEFICIOS PREVIDENCIARIOS','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM OUTROS BENEFICIOSPREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.1.04.00','BENEFICIO MENSAL AO DEFICIENTE E AO IDOSO','REGISTRA O VALOR DAS APROPRIACOES DE DESPESAS COM OS BENEFICIOS PREVI-DENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO, A TITULODE BENEFICIO AO DEFICIENTE E AO IDOSO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.3.2.2.00.00','EXECUCAO DE BENEFICIOS PAGOS POR EMPRESAS CONVENENTES DO EXERCICIO ANTERIOR','REGISTRA A EXECUCAO DOS BENEFICIOS PREVIDENCIARIOS REEMBOLSADOS AS EMPRESAS SOB REGIME DE CONVENIO NO EXERCICIO ANTERIOR','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.0.0.00.00','EXECUCAO DE CONTROLES DA CONTA UNICA','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA CONTA UNICA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.0.00.00','EXECUCAO DA CONCILIACAO DA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA CONCILIACAO DA CONTA UNICA','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.1.00.00','EXECUCAO DE REMANEJAMENTO DE FONTE DE RECURSOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES RELATIVOS AO REMANEJAMENTO DE SALDO NA CONTA DE DISPONIBILIDADE POR FONTE DE RECURSOS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.1.01.00','ACRESCIMO POR REMANEJAMENTO FONTE RECURSOS','REGISTRA OS ACRESCIMOS POR REMANEJAMENTO DE FONTE DE RECURSOS COM USO DOS EVENTOS 540698 E 540699.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.1.02.00','REDUCAO POR REMANEJAMENTO FONTE RECURSOS','REGISTRA DAS REDUCOES POR REMANEJAMENTO DE FONTE DE RECURSOS COM USO DOS EVENTOS 540698 E 540699.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.2.00.00','EXECUCAO DE CONTROLE FR - CANCELAMENTO OBRIG. EXERC. ANT','REGISTRA A EXECUCAO DO CONTROLE POR FONTE DE RECURSOS NO CANCELAMENTO DE OBRIGA-COES DE EXERCICIOS ANTERIORES QUE NAO TENHAM CONTAS DE CONTROLE DE EMPENHO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.3.00.00','EXECUCAO DE INCORPORACAO/DESINCORPORACAO SALDOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES RELATIVOS A INCORPORACAO OU DESINCORPORACAO DE SALDOS DA DISPONIBILIDADE POR FONTE DE RECURSOSO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.3.01.00','ACRESCIMO DE SALDO (CISAO/FUSAO/EXTINCAO)','REGISTRA OS ACRESCIMOS PELA INCORPORACAO DE SALDOS DA DISPONIBILIDADE POR FONTE DE RECURSOS NA ROTINA DE NSSALDO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.3.02.00','REDUCAO DE SALDO (CISAO/FUSAO/EXTINCAO)','REGISTRA O VALOR DAS REDUCOES POR DESINCORPORACAO DE SALDOS DA CONTA DE DISPONIBILIDADE POR FONTE DE RECURSOS NA ROTINA DE NSSALDO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.3.03.00','ACRESCIMO DE SALDO -TRANSF OBRIG PGTO OUTR UG','REGISTRA O CONTROLE DA RECOMPOSICAO DO SALDO DA DISPONIBILIDADE POR FONTE DE RECURSOS, OCASIONADO PELA TRANSFERENCIA DE OBRIGACAO A PAGAR PARA OUTRA UG.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.3.04.00','REDUCAO DE SALDO - TRANSF OBRIG PGTO OUTR UG','REGISTRA O CONTROLE DA REDUCAO DO SALDO DA DISPONIBILIDADE POR FONTE RECURSOS, OCASIONADO PELA TRANSFERENCIA RECEBIDA DE OUTRA UG DE OBRIGACAO A PAGAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.1.4.00.00','EXECUCAO DE CONTROLE FR - RESTITUICAO DE RECEITAS','REGISTRA A EXECUCAO DO CONTROLE POR FONTE DE RECURSOS NAS ROTINAS DE RESTITUICAOO DE RECEITAS, ONDE NAO HA CONTAS DE CONTROLE DE EMPENHO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.0.00.00','EXECUCAO DO CONTROLE DE CAIXA DO TESOURO NACIONAL','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DOS INGRESSOS E SAIDAS DA CONTA UNICA DO TESOURO NACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.1.00.00','CONTROLE DA EXECUCAO DE INGRESSOS E SAIDAS DA CONTA UNICA','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DE INGRESSOS E SAIDAS FISCAIS DE CAIXA DA SECRETARIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DOTESOURO NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.1.01.00','INGRESSOS','REGISTRA O VALOR DE INGRESSOS FISCAIS DE CAIXA DA SECRETARIA DOTESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DOTESOURO NACIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.1.02.00','SAIDAS','REGISTRA O VALOR DE SAIDAS FISCAIS DE CAIXA DA SECRETARIA DO TESOURONACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DO TESOSURONACIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.1.03.00','INGRESSO DA GR','REGISTRA O VALOR DE INGRESSOS DE CAIXA DA SECRETARIA DO TESOURO NACIO-NAL PROVENIENTES DA GUIA DE RECOLHIMENTO DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.2.00.00','CONTROLE DA EXECUCAO DE INGRESSOS E SAIDAS DO INSS','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DE INGRESSOS E SAIDAS DE FINANCIAMENTO PELA SECRETAIRA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAOFINANCEIRA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.2.01.00','INGRESSOS','REGISTRA O VALOR DE INGRESSOS DE FINANCEIRAMENTO DE CAIXA DA SECRETA-RIA DO TESOURO NACIONAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMA-CAO FINANCEIRA DO TESOURO NACIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.2.02.00','SAIDAS','REGISTRA O VALOR DE SAIDAS DE FINANCAIMENTO DE CAIXA DO TESOURO NACIO-NAL EFETUADOS PELA COORDENACAO-GERAL DE PROGRAMACAO DO TESOURO NACIO-NAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.3.00.00','CONTROLE DA EXECUCAO DE INGRESSOS E SAIDAS DA CONTA ESPECIAL','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DE INGRESSOS E SAIDAS DOS RECURSOS DE EMPRESTIMOS EX-TERNOS DA CONTA ESPECIAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.3.01.00','INGRESSOS NA CONTA ESPECIAL','REGISTRA O VALOR DE INGRESSOS NA CONTA ESPECIAL REFERENTE AOS RECUR-SOS DE EMPRESTIMOS EXTERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.2.3.02.00','SAIDAS DA CONTA ESPECIAL','REGISTRA O VALOR DE SAIDAS DA CONTA ESPECIAL REFERENTE AOS RECURSOS DE EMPRESTIMOS EXTERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.3.0.00.00','EXECUCAO DO CONTROLE DE TRANSFERENCIAS ENTRE CONTAS UNICAS (INSS E TESOURO NACIONAL)','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DO VALOR DA TRANSFERENCIA DE LIMITES DA CONTA UNICA DO INSSPARA O TESOURO NACIONAL E VICE-VERSA DENTRO DE UMA UG OU ENTRE UGSDIFERENTES, BEM COMO TRANSFERENCIAS DE LIMITES DA CONTA UNICA ENTREUGS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.3.1.00.00','SALDOS DEVEDORES','REGISTRA O VALOR DE DISPONIBILIDADES FINANCEIRAS REFERENTE A TRANSFE-RENCIAS DE CONTAS COM SALDOS DEVEDORES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.3.2.00.00','SALDOS CREDORES','REGISTRA O VALOR DE DISPONIBILIDADES FINANCEIRAS REFERENTE A TRANSFE-RENCIAS DE CONTAS COM SALDOS CREDORES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.4.0.00.00','EXECUCAO DE CONTROLE DE APLICACAO FINANCEIRA NA CONTA UNICA POR DISPONIBILIDADE POR DESTINACAO','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTE AO CONTROLE DE FONTE DE RECURSOS NA NA PLICACAO FINANCEIRA NA CTU','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.4.1.00.00','CONTROLE FONTE APLIC.RECURSOS DO TESOURO NAC.','REGISTRA O VALOR REFERENTE AO CONTROLE POR FONTE DE RECURSOS NA APLI- ACAO FINANCEIRA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.4.4.2.00.00','CONTROLE APLICACAO FINANCEIRA CTU (FTE+VINC)','REGISTRA O VALOR REFERENTE AO CONTROLE DOS RECURSOS APLICADOS NA CONTAUNICOS, POR FONTE DE RECURSOS E VINCULACAO DE PAGAMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.5.0.0.00.00','EXECUCAO DE RA''S','COMPREENDEM AS CONTAS QUE CONTROLAM A EXECUCAO DE RA''S','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.5.1.0.00.00','EXECUCAO DE RETIFICACAO DE RA''S','COMPREENDEM AS CONTAS QUE REGISTRAM AS RETIFICACOES DE RA''S','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.5.1.1.00.00','RA A RETIFICAR (NUMERO DA RA)','REGISTRA OS VALORES DAS RETIFICACOES POR NUMERO DE RA (REGISTRO DE AR-RECADACAO).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.5.1.2.00.00','RA RETIFICADAS (NUMERO DA RA)','REGISTRA OS VALORES DAS RETIFICACOES POR NUMERO DE RA (REGISTRO DE AR-RECADACAO).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.0.0.00.00','CONTROLES DE OPERACOES DE CREDITOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.1.0.00.00','EXECUCAO DE OPERACOES EM TITULOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO RESULTANTES DE TITULOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.1.1.00.00','EXECUCAO DE EMISSAO DE TITULOS','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DE OPERACOES DE CREDITO RESULTANTES DE EMISSOES DE TITULOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.1.1.01.00','TITULOS A EMITIR','REGISTRA O VALOR REFERENTE A APROPRIACAO DE TITULOS DA DIVIDA PUBLICA A EMITIR SOB A RESPONSABILIDADE DO TESOURO NACIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.1.1.02.00','TITULOS EMITIDOS','REGISTRA O VALOR REFERENTE A APROPRIACAO DE OBRIGACOES RELATIVAS A E-MISSAO DE TITULOS DA DIVIDA PUBLICA SOB A RESPONSABILIDADE DO TESOURO NACIONAL, PREVISTA NA PROGRAMACAO FINANCEIRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.2.0.00.00','EXECUCAO DE MOVIMENTACOES DE RECEITAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES REFERENTES AS MOVIMENTACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.2.1.00.00','INCORPORACOES DE RECEITAS','REGISTRA OS VALORES REFERENTES AS INCORPORACOES DE RECEITAS PERTENCEN-TES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.2.2.00.00','DESICORPORACOES DE RECEITAS','REGISTRA OS VALORES REFERENTES AS DESINCORPORACOES DE RECEITAS PERTENCENTES A OUTRA UNIDADE GESTORA DO MESMO ORGAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.0.00.00','EXECUCAO DE OPERACOES COM EMPRESTIMOS EXTERNOS','COMPREENDE AS CONTAS QUE REGISTRAM O CONTROLE DA EXECUCAO DAS OPERACOES COM EMPRESTIMOS EXTERNOS CUJOS RECURSOS SAO DEPOSITADOS EM CONTA ESPECIAL DO TESOURO NACIONAL','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.00.00','EXECUCAO DE ADIANTAMENTOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.01.00','ADIANTAMENTOS A COMPROVAR','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO PENDENTE DE COMPROVACAO','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.01.01','DE RECURSOS EXTERNOS','REGISTRA OS VALORES DOS ADIANTAMENTOS DA CONTA UNICA DO TESOURO NACIO-NAL CORRESPONDETES AOS RECURSOS DE EMPRESTIMOS EXTERNOS PARA A UNIDADEGESTORA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.01.02','DE RECURSOS DE CONTRA-PARTIDA','REGISTRA OS VALORES DOS ADIANTAMENTOS DA CONTA UNICA DO TESOURO NACIO-NAL CORRESPONDETES AOS RECURSOS DE CONTRA-PARTIDA DE EMPRESTIMOS EX-TERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.02.00','ADIANTAMENTOS COMPROVADOS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA PARA A UNIDADE GESTORA CONTRATANTE DE EMPRESTIMO CUJA UTILIZACAO FOI COM- PROVADA PELA UG.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.02.01','DE RECURSOS EXTERNOS','REGISTRA OS VALORES DOS ADIANTAMENTOS DE RECURSOS DA CONTA UNICA DOTESOURO NACIONAL PARA A UNIDADE GESTORA CONTRATANTE REFERENTES A EM-PRESTIMOS EXTERNOS QUE FORAM COMPRAVADOS/UTILIZADOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.1.02.02','DE RECURSOS DE CONTRA-PARTIDA','REGISTRA OS VALORES DOS RECURSOS COMPROVADOS REFERENTES AOS ADIANTA-METOS DA CONTA UNICA DO TESOURO NACIONAL PARA A UNIDADE GESTORA CON-TRATANTE RELATIVOS A CONTRAPARTIDA','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.2.00.00','EXECUCAO DE REEMBOLSOS/RESSARCIMENTOS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DA SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.2.01.00','REEMBOLSOS/RESSARCIMENTOS SOLICITADOS','REGISTRA A SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS A SEREM EFETUADOSPARA A CONTA UNICA DO TESOURO NACIONAL, APOS A APLICACAO E COMPROVACAODE RECURSOS ADIANTADOS A UNIDADE GESTORA CONTRATANTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.2.02.00','REEMBOLSOS/RESSARCIMENTOS APROVADOS','REGISTRA A APROVACAO DA SOCILITACAO DE REEMBOLSOS/RESSARCIMENTOS A SE-REM EFETUADOS PARA A CONTA UNICA DO TESOURO NACIONAL, APOS A APLICACAOE COMPROVACAO DE RECURSOS EXTERNOS ADIANTADOS A UNIDADE GESTORA CON-TRATANTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.3.2.03.00','REEMBOLSOS/RESSARCIMENTOS EFETUADOS','REGISTRA O REEMBOLSO/RESSARCIMENTO EFETUADOS NA CONTA UNICA DO TESOU-RO NACIONAL, APOS A APLICACAO E COMPROVACAO DE RECURSOS EXTERNOS ADI-ANTADOS A UNIDADE GESTORA CONTRATANTE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.0.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS CONCEDIDAS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS CONCEDIDAS LIBERADOS PELA COFIN/STN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.01.00','OPERACOES DE CREDITO EXTERNAS CONCEDIDAS A EXECUTAR','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN, PENDENTES DE EXECUCAO (PAGAMENTO) PE-LAS UNIDADES GESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.01.01','CONCEDIDAS A EXECUTAR-RECURSO EXTERNO','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO (PAGAMENTO) PELAS UNIDADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.01.02','CONCEDIDAS A EXECUTAR-CONTRAPARTIDA','REGISTRA OS VALORES DOS RECURSOS ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO(PAGAMENTO) PELAS UNI-DADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.02.00','OPERACOES DE CREDITO EXTERNAS CONCEDIDAS EXECUTADAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADESGESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.02.01','CONCEDIDAS EXECUTADAS-RECURSO EXTERNO','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.1.02.02','CONCEDIDAS EXECUTADAS-CONTRAPARTIDA','REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS RECEBIDAS','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS RECEBIDAS LIBERADOS PELA COFIN/STN','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.01.00','OPERACOES DE CREDITO EXTERNAS RECEBIDAS A EXECUTAR','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN, PENDENTES DE EXECUCAO (PAGAMENTO) PE-LAS UNIDADES GESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.01.01','RECEBIDAS A EXECUTAR-RECURSO EXTERNO','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO (PAGAMENTO) PELAS UNIDADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.01.02','RECEBIDAS A EXECUTAR-CONTRAPARTIDA','REGISTRA OS VALORES DOS RECURSOS ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E PENDENTES DE EXECUCAO(PAGAMENTO) PELAS UNI-DADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.02.00','OPERACOES DE CREDITO EXTERNAS RECEBIDAS EXECUTADAS','COMPREENDE AS CONTAS QUE REGISTRAM OS VALORES DOS RECURSOS ORIUNDOS DE OPERACOES DE CREDITO EX-TERNAS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADESGESTORAS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.02.01','RECEBIDAS EXECUTADAS-RECURSO EXTERNO','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.2.02.02','RECEBIDAS EXECUTADAS-CONTRAPARTIDA','REGISTRA OS VALORES ORIUNDOS DE CONTRAPARTIDA NACIONAL LIBERADOS PELA COFIN/STN E EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.3.00.00','EXECUCAO DO CONTROLE DE REEMBOLSOS','REGISTRA A EXECUCAO DAS CONTAS DE SOLICITACAO DE REEMBOLSOS A SEREM EFETUADOS PARA A CONTA UNICA DO TESOURO NACIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.4.00.00','EXECUCAO DO CONTROLE DE DESEMBOLSOS','REGISTRA A EXECUCAO DAS CONTAS DE SOLICITACAO DE DESEMBOLSOS A SEREM EFETUADOS PARA A CONTA UNICA DO TESOURO NACIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.00.00','CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES','COMPREENDE AS CONTAS QUE CONTROLAM A EXECUCAO DA COMPROVACAO DE VALORES','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.01.00','CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADO PELA COFIN','COMPREENDE AS CONTAS QUE REGISTRAM NA COFIN OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.01.01','OPER.CRED.EXTENAS EXECUTADAS A COMPROVAR','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E PENDENTES DE COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.01.02','OPER.CRED.EXTENAS EXECUTADAS COMPROVADAS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.01.03','VALORES NAO COMPROVADOS DEVOLVIDOS','REGISTRA VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.02.00','CONTROLE DA EXECUCAO DA COMPROVACAO DE VALORES REALIZADO PELA UG','COMPREENDE AS CONTAS QUE REGISTRAM NA UG OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.02.01','OPER.CRED.EXTENAS EXECUTADAS A COMPROVAR','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E PENDENTES DE COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.02.02','OPER.CRED.EXTENAS EXECUTADAS COMPROVADAS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.4.5.02.03','VALORES NAO COMPROVADOS DEVOLVIDOS','REGISTRA VALOR DE ADIANTAMENTO DO TESOURO, MAS NAO REEMBOLSADO PELO CREDOR EM RAZAO DA NAO COMPROVACAO DENTRO DO PRAZO CONTRATUAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.0.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS SEM ANTECIPACAO','COMPREEDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.00.00','EXECUCAO DO CONTROLE DA COFIN','REGISTRA NA COFIN A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS CREDORES EXTERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO"> CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APO PRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACA DO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.05.00','VALORES EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSCREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.11.00','DEVOLUCAO AO ORG.INTERNACIONAL EFETUADA','REGISTRA A ORDEM DE DEVOLUCAO DOS RECURSOS EXTERNOS EXPEDIDA PELACOFIN/STN AO AGENTE FINANCEIRO DA UNIAO EM FAVOR DO ORGANISMO INTERNA-CIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.12.00','VALORES CONTRATADOS CANCELADOS - FINAL','REGISTRA O TOTAL DE RECURSOS QUE FORAM CONTRATADOS E CANCELADOS DEVIDOAO TERMINO DA VIGENCIA CONTRATUAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.13.00','COMISSOES E TAXAS PAGAS AOS CREDORES EXTERNOS','REGISTRA OS VALORES DE COMISSOES E TAXAS (FEF E FIV) PAGAS AOS CREDO- RES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.14.00','ACRESCIMO AO VALOR DO CONTRATO','REGISTRA ACRESCIMOS AO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.1.15.00','CANCELAMENTO DE VALOR CONTRATUAL NA VIGENCIA','REGISTRA CANCELAMENTOS DO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.00.00','EXECUCAO DO CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS SEM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL, EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS ORGANISMOS INTERNACIONAIS, JA DESCONTADAS A TAXAINICIAL DE CONTRATACAO DESSAS OPERACOES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO">CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.05.00','EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS ORGANISMOS IN-TERNACIONAIS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.5.2.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.0.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS COM ANTECIPACAO E FUNDO ROTATIVO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E FUNDO ROTATIVO, EX-CLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.00.00','EXECUCAO DO CONTROLE DA COFIN','REGISTRA NA COFIN A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E FUNDO ROTATIVO, EX-CLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS CREDORES EXTERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO"> CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APO PRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACA DO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.05.00','VALORES EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSCREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.11.00','DEVOLUCAO AO ORG.INTERNACIONAL EFETUADA','REGISTRA A ORDEM DE DEVOLUCAO DOS RECURSOS EXTERNOS EXPEDIDA PELACOFIN/STN AO AGENTE FINANCEIRO DA UNIAO EM FAVOR DO ORGANISMO INTERNA-CIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.12.00','VALORES CONTRATADOS CANCELADOS - FINAL','REGISTRA O TOTAL DE RECURSOS QUE FORAM CONTRATADOS E CANCELADOS DEVIDOAO TERMINO DA VIGENCIA CONTRATUAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.13.00','COMISSOES E TAXAS PAGAS AOS CREDORES EXTERNOS','REGISTRA OS VALORES DE COMISSOES E TAXAS (FEF E FIV) PAGAS AOS CREDO- RES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.14.00','ACRESCIMO AO VALOR DO CONTRATO','REGISTRA ACRESCIMOS AO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.1.15.00','CANCELAMENTO DE VALOR CONTRATUAL NA VIGENCIA','REGISTRA CANCELAMENTOS DO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.00.00','EXECUCAO DO CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E FUNDO ROTATIVO, EX-CLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS ORGANISMOS INTERNACIONAIS, JA DESCONTADAS A TAXAINICIAL DE CONTRATACAO DESSAS OPERACOES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO">CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.05.00','EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS ORGANISMOS IN-TERNACIONAIS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.6.2.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.0.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS COM ANTECIPACAO E SEM FUNDO ROTATIVO','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E SEM FUNDO ROTATIVO,EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.00.00','EXECUCAO DO CONTROLE DA COFIN','REGISTRA NA COFIN A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E SEM FUNDO ROTATIVO,EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS CREDORES EXTERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO"> CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APO PRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACA DO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.05.00','VALORES EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSCREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.11.00','DEVOLUCAO AO ORG.INTERNACIONAL EFETUADA','REGISTRA A ORDEM DE DEVOLUCAO DOS RECURSOS EXTERNOS EXPEDIDA PELACOFIN/STN AO AGENTE FINANCEIRO DA UNIAO EM FAVOR DO ORGANISMO INTERNA-CIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.12.00','VALORES CONTRATADOS CANCELADOS - FINAL','REGISTRA O TOTAL DE RECURSOS QUE FORAM CONTRATADOS E CANCELADOS DEVIDOAO TERMINO DA VIGENCIA CONTRATUAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.13.00','COMISSOES E TAXAS PAGAS AOS CREDORES EXTERNOS','REGISTRA OS VALORES DE COMISSOES E TAXAS (FEF E FIV) PAGAS AOS CREDO- RES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.14.00','ACRESCIMO AO VALOR DO CONTRATO','REGISTRA ACRESCIMOS AO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.1.15.00','CANCELAMENTO DE VALOR CONTRATUAL NA VIGENCIA','REGISTRA CANCELAMENTOS DO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.00.00','EXECUCAO DO CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS COM ANTECIPACAO POR PARTE DO ORGANISMO INTERNACIONAL E SEM FUNDO ROTATIVO,EXCLUSIVE RECURSOS DE CONTRAPARTIDA.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS ORGANISMOS INTERNACIONAIS, JA DESCONTADAS A TAXAINICIAL DE CONTRATACAO DESSAS OPERACOES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO">CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.05.00','EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS ORGANISMOS IN-TERNACIONAIS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.7.2.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.0.00.00','EXECUCAO DE OPERACOES DE CREDITO EXTERNAS COM SWAP / OPERACOES DE AJUSTE','COMPREENDE AS CONTAS QUE REGISTRAM A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS DE SWAP/OPERACOES DE AJUSTE COM ORGANISMOS INTERNACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.00.00','EXECUCAO DO CONTROLE DA COFIN','REGISTRA NA COFIN A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS DE SWAP/OPERACOES DE AJUSTE COM ORGANISMOS INTERNACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS CREDORES EXTERNOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO"> CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APO PRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACA DO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.05.00','VALORES EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSCREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS CREDORES EXTERNOS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.11.00','DEVOLUCAO AO ORG.INTERNACIONAL EFETUADA','REGISTRA A ORDEM DE DEVOLUCAO DOS RECURSOS EXTERNOS EXPEDIDA PELACOFIN/STN AO AGENTE FINANCEIRO DA UNIAO EM FAVOR DO ORGANISMO INTERNA-CIONAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.12.00','VALORES CONTRATADOS CANCELADOS - FINAL','REGISTRA O TOTAL DE RECURSOS QUE FORAM CONTRATADOS E CANCELADOS DEVIDOAO TERMINO DA VIGENCIA CONTRATUAL.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.13.00','COMISSOES E TAXAS PAGAS AOS CREDORES EXTERNOS','REGISTRA OS VALORES DE COMISSOES E TAXAS (FEF E FIV) PAGAS AOS CREDO- RES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.14.00','ACRESCIMO AO VALOR DO CONTRATO','REGISTRA ACRESCIMOS AO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.1.15.00','CANCELAMENTO DE VALOR CONTRATUAL NA VIGENCIA','REGISTRA CANCELAMENTOS DO VALOR VIGENTE DOS CONTRATOS DE OPERACOES DE CREDITO EXTERNO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.00.00','EXECUCAO DO CONTROLE DA UG RESPONSAVEL PELO PROJETO','REGISTRA NA UG RESPONSAVEL PELO PROJETO A EXECUCAO DOS VALORES REFERENTES AS OPERACOES COM RECURSOS EXTERNOS DE SWAP/OPERACOES DE AJUSTE COM ORGANISMOS INTERNACIONAIS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.01.00','VALORES CONTRATADOS A RECEBER','REGISTRA OS VALORES ORIUNDOS DAS OPERACOES DE CREDITO EXTERNAS CONTRA-TADAS A RECEBER DOS ORGANISMOS INTERNACIONAIS, JA DESCONTADAS A TAXAINICIAL DE CONTRATACAO DESSAS OPERACOES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.02.00','VALORES LIBERADOS','REGISTRA O TOTAL DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN EM MOE-DA ESTRANGEIRA UTILIZANDO A TAXA DE CAMBIO APRESENTADA NA TRANSACAO">CONCAMBIO".','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.03.00','SAQUE DA CONTA ESPECIAL SOLICITADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.04.00','SAQUE DA CONTA ESPECIAL EFETUADO','REGISTRA A COMPROVACAO DE ADIANTAMENTOS CONCEDIDOS E EXECUTADOS, APOSPRESTACAO DE CONTAS PELA UNIDADE GESTORA DO PROJETO PARA SOLICITACAODO RESSARCIMENTO POR DESEMBOLSO A INSTITUICAO FINANCIADORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.05.00','EXECUTADOS COMPROVADOS','REGISTRA OS VALORES ORIUNDOS DE RECURSOS EXTERNOS LIBERADOS PELA COFIN/STN, EXECUTADOS (PAGOS) PELAS UNIDADES GESTORAS E COMPROVADOS AOSORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.06.00','VALORES CONTRATADOS SOLICITADOS','REGISTRA A SOLICITACAO DE RECURSOS EXTERNOS CONTRATADOS NO ATO DA COM-PROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.07.00','VALORES CONTRATADOS RECEBIDOS','REGISTRA O RECEBIMENTO DOS RECURSOS EXTERNOS CONTRATADOS E SOLICITA- DOS NO ATO DA COMPROVACAO AOS ORGANISMOS INTERNACIONAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.08.00','VALORES GLOSADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS GLOSADOS PELOS ORGANISMOS IN-TERNACIONAIS NO ATO DA COMPROVACAO DOS DISPENDIOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.09.00','VALORES IMPUGNADOS','REGISTRA OS VALORES DE RECURSOS EXTERNOS IMPUGNADOS PELOS ORGAOS DECONTROLE, APOS O RECEBIMENTO POR PARTE DO TESOURO NACIONAL DOS VALORESCONTRATADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.6.8.2.10.00','DEVOLUCAO AO ORG.INTERNACIONAL SOLICITADA','REGISTRA A SOLICITACAO PELAS UNIDADES GESTORAS DE DEVOLUCAO DE RECUR-SOS EXTERNOS AOS CREDORES EXTERNOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.0.0.00.00','OUTROS CONTROLES DE RESPONSABILIDADES POR VALORES, TITULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.0.00.00','EXECUCAO DE RESPONSABILIDADES DE TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.00.00','RESPONSABILIDADES DE TERCEIROS','COMPREENDE A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES E BENS CONCEDIDOS PELA UNIDADE GESTORA QUE EFETUA O REGISTRO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.01.00','EM CAUCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR TITULOS, VALORES E BENS OFERECIDOS EM CAUCAO PELA UNIDADE GESTORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.02.00','CONCEDIDOS EM CUSTODIA','REGISTRA O CONTROLE DOS BENS, TITULOS E VALORES EM PODER DE TERCEIROSSOB CUSTODIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.03.00','DESPESAS MEDICAS','REGISTRA O VALOR DAS DESPESAS MEDICAS PAGAS A HOSPITAIS E CLINICASTENDO COMO USUARIO OS SENHORES PARLAMENTARES E SERVIDORES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.04.00','EM COBRANCA - A RECEBER','REGISTRA O MONTANTE DA RESPONSABILIDADE DE TERCEIROS POR VALORES, TI-TULOS E BENS EM FASE DE COBRANCA PELA UNIDADE GESTORA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.05.00','SUPRIMENTO DE FUNDOS','REGISTRA OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDERDESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATEH A SUA PRESTACAO DE CONTAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.06.00','CONCEDIDOS EM CONSIGNACAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR VALORES, TITULOS E BENSCONCEDIDOS A TITULO DE CONSIGNACAO PELA UNIDADE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.07.00','DIARIAS','REGISTRA O VALOR DAS DIARIAS CONCEDIDAS, COM REGISTRO DA RESPONSABILI-DADE MEDIANTE CONTROLE INDIVIDUALIZADO POR TITULAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.08.00','TITULOS DE CREDITO','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES DE TERCEIROS PORTITULOS DE CREDITO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.09.00','CESSAO DE USO - BENS CEDIDOS','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS CEDIDOS PELA UNIDADEA TITULO DE CESSAO DE USO, FORMALIZADA MEDIANTE TERMO, NO QUAL DEVERAOCONSTAR A FINALIDADE DA SUA REALIZACAO E O PRAZO PARA SEU CUMPRIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.10.00','COMODATO DE BENS - CONCEDIDOS','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS NAO FUNGIVEIS CONCE-DIDOS PELA UNIDADE, A TITULO DE EMPRESTIMO GRATUITO, OS QUAIS DEVEMSER RESTITUIDOS NO TEMPO CONVENCIONADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.11.00','MERCADORIAS E BENS EM PODER DE TERCEIROS','REGISTRA O VALOR DAS MERCADORIAS E DOS BENS DAS UNIDADES GESTORAS QUEESTAO EM PODER DE TERCEIROS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.12.00','CONCEDIDOS EM DEPOSITO','REGISTRA O VALOR DOS BENS CONCEDIDOS DECORRENTE DE CONTRATO DE DEPOSI-TO (ART.1265 DO CODIGO CIVIL BRASILEIRO).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.13.00','BENS EM MANUTENCAO','REGISTRA A RESPONSABILIDADE DE TERCEIROS POR BENS MOVEIS CONCEDIDOSPELA UNIDADE EM CARATER PROVISORIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.14.00','PERMISSAO DE USO - BENS CONCEDIDOS','REGISTRA O VALOR DOS BENS CONCEDIDOS A PARTICULAR MEDIANTE PERMISSAODE USO, POR ATO NEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA AD-MINISTRACAO PUBLICA, E CUJA UTILIZACAO SEJA DE INTERESSE DA COLETIVI-DADE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.15.00','AUTORIZACAO DE USO','REGISTRA O CONTROLE DOS BENS PERTENCENTES A ADMINISTRACAO PUBLICA,SOBRE OS QUAIS FOI A AUTORIZADA A PRATICA DE ATIVIDADE INDIVIDUAL,TRANSITORIA E IRRELEVANTE PARA O PODER PUBLICO, POR ATO UNILATERAL,DISCRICIONARIO E PRECARIO, DISPENSANDO LEI AUTORIZATIVA E LICITACAOPARA SEU DEFERIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.00','IMOVEIS DE INTERESSE DA UNIAO','REGISTRA O CONTROLE DE IMOVEIS DE TERCEIROS QUE ESTAO SENDO ADMINISTRADOS PELA ENTIDADE.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.01','IMOVEIS RESIDENCIAL/COMERCIAL','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS RESIDENCIAIS/COMERCIAIS DETERCEIROS ADMINISTRADOS PELA ENTIDADE','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.02','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS EDIFICIOS/PREDIOS E CONVEN-TOS COM TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.03','TERRENOS/GLEBAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME O CODIGO DA TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.04','ARMAZENS/GALPOES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.05','AQUARTELAMENTOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU: BASES','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.06','AEROPORTOS/ESTACOES/AERODROMOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.07','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.08','REPRESAS/ACUDES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.09','AREAS DE PRESERVACAO AMBIENTAL','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.10','IMOVEIS DE USO RECREATIVO','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.11','ILHAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.12','FAROIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.13','EMBAIXADAS E CONSULADOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.14','MUSEUS/PALACIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.15','LABORATORIOS/OBSERVATORIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.16','HOSPITAIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.17','HOTEIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.18','PRESIDIOS/DELEGACIAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.19','PORTOS/ESTALEIROS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.20','COMPLEXOS/FABRICAS/USINAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.21','CEMITERIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.22','ESTACIONAMENTOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.23','LOJAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.24','SALAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CON-FOME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.25','ALFANDEGAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.26','AUTARQUIAS/FUNDACOES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS COM TERCEIROS,CONFORME A TABELA SPIU','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.16.98','BENS LOCADOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS BENS LOCADOS PARA TERCEIROS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.17.00','CONCESSAO DE USO','REGISTRA A DELEGACAO DE SERVICO PUBLICO FEITA PELO PODER CEDENTE,MEDIANTE CONTRATO, PARA SUA EXPLORACAO SEGUNDO DESTINACAO ESPECIFICADE ACORDO COM A LEI 8987 DE 13/02/1995.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.18.00','ENCARGOS EM ATRASO - OPERACOES BANCARIAS','REGISTRA OS VALORES RELATIVOS A ENCARGOS EM ATRASO RELATIVOS A OPERA-COES BANCARIAS, TAIS COMO OS DECORRENTES DE EMPRESTIMOS, FINANCIAMEN-TOS, TITULOS DESCONTADOS E OUTROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.19.00','BENS DE REFORMA AGRARIA SUJEITOS A REVERSAO','REGISTRA O VALOR DOS BENS IMOVEIS OBJETO DE REFORMA AGRARIA JA TRANS-FERIDOS AOS ASSENTADOS, MAS QUE PODEM SER REVERTIDOS AO DOMINIO DOINCRA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.20.00','RESSARCIMENTO DE VERBA INDENIZATORIA',' REGISTRA AS DESPESAS COM OS RESSARCIMENTOS REALIZADOS AOS PARLAMENTARES, A TITULO DE VERBA INDENIZATORIA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.1.1.99.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZAEVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ES-PECIFICAS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.0.00.00','EXECUCAO DE RESPONSABILIDADES COM TERCEIROS POR VALORES, TITULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.00.00','EXECUCAO DE RESPONSABILIDADES COM TERCEIROS ','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.01.00','RECEBIDOS EM CAUCAO ','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TITULOS, VALORES E BENS RECEBIDOS EM CAUCAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.02.00','RECEBIDOS EM CUSTODIA','REGISTRA O TOTAL DA RESPONSABILIDADE DA UNIDADE GESTORA COM TERCEIROSPELO RECEBIMENTO DE VALORES, TITULOS E BENS PARA GUARDA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.03.00','A COLOCAR','REGISTRA O VALOR DAS COMPENSACOES ATIVAS DIVERSAS REFERENTE A RESPONSABILIDADE POR VALORES, TITULOS E BENS COM TERCEIROS A COLOCAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.04.00','A ENTREGAR','REGISTRA O MONTANTE DA RESPONSABILIDADE POR TITULOS, VALORES E BENS DEORGAOS E ENTIDADES COM TERCEIROS, A SEREM ENTREGUES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.05.00','EM COBRANCA','REGISTRA O MONTANTE DA RESPONSABILIDADE DA UNIDADE GESTORA COM TERCEI-ROS POR VALORES, TITULOS E BENS EM FASE DE COBRANCA PELOS BENEFICIA-DOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.06.00','SUPRIMENTO DE FUNDOS','REGISTRA A RESPONSABILIDADE COM TERCEIROS REFERENTE A APROPRIACAO DEDESPESAS DE CONCESSAO DE SUPRIMENTO DE FUNDOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.07.00','RECEBIDOS EM CONSIGNACAO','REGISTRA A RESPONSABILIDADE DA UNIDADE COM TERCEIROS POR VALORES, TI-TULOS E BENS RECEBIDOS EM CONSIGNACAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.08.00','FIANCA BANCARIA','REGISTRA A RESPONSABILIDADE DA UNIDADE COM TERCEIROS POR TITULOS, VALORES E BENS AFIANCADOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.09.00','AUXILIOS A PESQUISA A COMPROVAR','REGISTRA A RESPONSABILIDADE DA UNIDADE COM AUXILIOS DE PESQUISA A COM-PROVAR PELA UTILIZACAO DE RECURSOS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.10.00','SELOS CONSULARES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR SELOS CONSULARES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.11.00','SELOS DE CONTROLE','REGISTRA A RESPONSABILIDADE DA UNIDADE POR SELOS DE CONTROLES.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.12.00','BENEFICIOS TRABALHISTAS A LIQUIDAR','REGISTRA OS VALORES CONCEDIDOS A TITULO DE BENEFICIOS COM O SEGURO-DE-SEMPREGO E ABONO SALARIAL DO PIS/PASEP - FAT, A SEREM LIQUIDADOS ATRA-VES DE PRESTACAO DE CONTAS PELOS AGENTES PAGADORES','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.13.00','CESSAO DE USO - BENS RECEBIDOS','REGISTRA A RESPONSABILIDADE DA UNIDADE JUNTO A TERCEIROS POR BENS RE-CEBIDOS A TITULO DE CESSAO DE USO FORMALIZADA MEDIANTE TERMO, DO QUALDEVERAH CONSTAR A FINALIDADE DA SUA REALIZACAO E O PRAZO PARA SEU CUM-PRIMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.14.00','DEPOSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EMCONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOSPOR ESTA PARA TERCEIROS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.15.00','DEPOSITOS PARA RECURSOS','REGISTRA OS DEPOSITOS PARA RECURSOS EFETUADOS POR TERCEIROS, EM TITU-LOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.16.00','COMODATO DE BENS - RECEBIDOS','REGISTRA A RESPONSABILIDADE DA UNIDADE JUNTO A TERCEIROS POR BENS NAOFUNGIVEIS RECEBIDOS A TITULO DE EMPRESTIMO GRATUITO, DEVENDO SER RES-TITUIDOS NO TEMPO CONVENCIONADO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.17.00','BENS E PRODUTOS APREENDIDOS','REGISTRA O VALOR DE BENS E PRODUTOS APREENDIDOS SOB A RESPONSABILIDA-DE DA UNIDADE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.18.00','MERCADORIAS DE TERCEIROS EM DEPOSITO','REGISTRA O VALOR DAS MERCADORIAS DE TERCEIROS EM DEPOSITOS DA UNIDADE.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.19.00','RECEBIDOS EM DEPOSITO','REGISTRA O VALOR DOS BENS RECEBIDOS EM DECORRENCIA DE CONTRATO DEDEPOSITO (ART. 1265 DO CODIGO CIVIL BRASILEIRO).','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.20.00','BENS RECEBIDOS PARA MANUTENCAO','REGISTRA A RESPONSABILIDADE DA UNIDADE JUNTO A TERCEIROS POR BENS MO-VEIS RECEBIDOS EM CARATER PROVISORIO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.21.00','OBRIG.CONTRATUAIS/CONCESSOES ANTERIORES A 9','REGISTRA O VALOR DE OUTRAS OBRIGACOES CONTRATUAIS (CONVENIOS, ACORDOSE AJUSTES) E CONCESSOES DE AUXILIOS, SUBVENCOES E CONTRIBUICOES COMCONTA-CORRENTE DO TIPO 02, EXISTENTES NAS CONTAS RESPECTIVAS AO FINALDO ANO DE 1995, QUANDO FORAM DESATIVADAS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.22.00','PERMISSAO DE USO - BENS RECEBIDOS','REGISTRA O VALOR DOS BENS RECEBIDOS MEDIANTE PERMISSAO DE USO, POR ATONEGOCIAL, UNILATERAL, DISCRICIONARIO E PRECARIO DA ADMINISTRACAO PU-BLICA.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.23.00','DEPOSITOS FGTS - NAO OPTANTES','REGISTRA OS DEPOSITOS EFETUADOS PELA UNIDADE PARA EMPREGADOS NAOOPTANTES PELO FGTS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.00','IMOVEIS DE INTERESSE DA UNIAO','REGISTRA O CONTROLE DE IMOVEIS DE TERCEIROS QUE ESTAO EM FASE DE RE-GULARIZACAO/REGISTRO EM NOME DA UNIAO.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.01','IMOVEIS RESIDENCIAL/COMERCIAL','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS RESIDENCIAIS/COMERCIAIS DETERCEIROS EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.02','EDIFICIOS','REGISTRA OS VALORES RELATIVOS AOS IMOVEIS EDIFICIOS/PREDIOS E CONVEN-TOS DE TERCEIROS EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.03','TERRENOS/GLEBAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME O CODIGO DA TABELA SPIU: 53- TERRENOS; 34- GLEBASQUE ESTEJA EMFASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.04','ARMAZENS/GALPOES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ARMAZENS E GALPOES, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.05','AQUARTELAMENTOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: BASES; QUARTEIS; FORTES, QUE ESTEJAM EM FASE DEREGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.06','AEROPORTOS/ESTACOES/AERODROMOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: AERODROMO; AEROPORTO; ESTACAO, QUE ESTEJAM EM FA-SE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.07','IMOVEIS DE USO EDUCACIONAL','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ESCOLAS; FACULDADES; UNIVERSIDADES; E BIBLIOTECASQUE ESTEJAM EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.08','REPRESAS/ACUDES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ACUDES; E REPRESAS, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.09','AREAS DE PRESERVACAO AMBIENTAL','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: FAZENDAS; PARQUES; E RESERVAS, QUE ESTEJAM EM FA-SE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.10','IMOVEIS DE USO RECREATIVO','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: CLUBES; ESTADIOS; E TEATROS, QUE ESTEJAM EM FASEDE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.11','ILHAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS CONFORME A TABELA SPIU: ILHAS(ILHOTAS), QUE ESTEJAM EM FASE DE REGULARI-ZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.12','FAROIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: FAROIS (FAROLETES), QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.13','EMBAIXADAS E CONSULADOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: CONSULADOS; E EMBAIXADAS, QUE ESTEJAM EM FASE DEREGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.14','MUSEUS/PALACIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU, MUSEUS E PALACIOS, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.15','LABORATORIOS/OBSERVATORIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU, LABORATORIOS E OBSERVATORIOS, QUE ESTEJAM EM FASEDE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.16','HOSPITAIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: HOSPITAIS, QUE ESTEJAM EM FASE DE REGULARIZACAO//REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.17','HOTEIS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: HOTEIS, QUE ESTEJAM EM FASE DE REGULARIZACAO/RE-GISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.18','PRESIDIOS/DELEGACIAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: PRESIDIOS E DELEGACIAS, QUE ESTEJAM EM FASE DEREGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.19','PORTOS/ESTALEIROS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: ESTALEIROS E PORTOS, QUE ESTEJAM EM FASE DE REGU-LARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.20','COMPLEXOS/FABRICAS/USINAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: FABRICAS, USINAS E COMPLEXOS, QUE ESTEJAM EM FASEDE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.21','CEMITERIOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: CEMITERIOS, QUE ESTEJAM EM FASE DE REGULARIZACO//REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.22','ESTACIONAMENTOS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: ESTACIONAMENTOS, QUE ESTEJAM EM FASE DE REGULARI-ZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.23','LOJAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: LOJAS, QUE ESTEJAM EM FASE DE REGULARIZACAO/RE-GISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.24','SALAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CON-FOME A TABELA SPIU: SALAS, QUE ESTEJAM EM FASE DE REGULARIZACAO/REGIS-TRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.25','ALFANDEGAS','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: ALFANDEGAS, QUE ESTEJAM EM FASE DE REGULARIZACAO//REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.26','AUTARQUIAS/FUNDACOES','REGISTRA OS VALORES RELATIVOS AOS SEGUINTES IMOVEIS DE TERCEIROS, CONFORME A TABELA SPIU: AUTARQUIAS/FUNDACOES, QUE ESTEJAM EM FASE DE RE-GULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.24.98','BENS LOCADOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS BENS LOCADOS DE TERCEIROS QUE ESTE-JAM EM FASE DE REGULARIZACAO/REGISTRO EM NOME DA UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.2.1.99.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OU-TRAS CONTAS DESSE GRUPO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.0.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.00.00','DIVERSOS RESPONSAVEIS EM APURACAO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','','N','','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.01.00','PAGAMENTOS INDEVIDOS','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, IN-CLUSIVE EM CASOS DE SUPERFATURAMENTO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.02.00','SALDOS NAO RECOLHIDOS','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.03.00','DESFALQUES OU DESVIOS','REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE EN-TIDADES PUBLICAS, EM APURACAO,DECORRENTES DE PROCESSOS POR ACOES ADMI-NINISTRATIVAS, POLICIAIS OU JUDICIAIS.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.04.00','DEBITOS DE TERCEIROS EM PREST. SERVICOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADESEM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FA-SE DE APURACAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.05.00','RESPONSAVEIS POR DANOS OU PERDAS','DESTINADA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS ADMINISTRA-TIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDASCAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURACAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.06.00','PAGAMENTOS SEM RESPALDO ORCAMENTARIO','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSI-FICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASEDE APURACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.07.00','CREDITOS ANTECIPADOS','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTE-CIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, EM FASE DE APU-RACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.08.00','FALTA OU IRREGULARIDADE DE COMPROVACAO','REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTACAO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.09.00','FALTA DE LICITACAO','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NE-CESSARIA LICITACAO, INFRINGINDO A LEGISLACAO ESPECIFICA, EM PROCESSOSMOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, EM FASEDE APURACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.10.00','MULTAS E JUROS','REGISTRA OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, PO-REM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE APURA-CAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.11.00','FALTA DE RECOLHIMENTO OBRIGACOES PECUNIARIA','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGA-MENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS,NAO PAGAMENTO DE OBRIGAC. PARA COM A UNIAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.12.00','FRAUDES EM BENEFICIOS','REGISTRAR OS DEBITOS RELATIVOS A FRAUDES EM BENEFICIOS DA PREVIDENCIASOCIAL QUE SE ENCONTRAM EM FASE DE APURACAO','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.13.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR CONCESSAO DE ADIANTAMENTOS EM DESACORDOCOM A LEGISLACAO PERTINENTE, TAIS COMO ADIANTAMENTOS A FORNECEDORES OUA EMPREGADOS','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.14.00','DEBITOS DECOR. DE UTILIZACAO INDEVIDA DE CO','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) DE PARLAMENTARES EM RAZAODE RECEBIMENTO ENDIVIDO DE VALOR RELACIONADO A COTA DESTINA A CUSTEARGASTOS VINCULADOS AO EXERCICIO DE ATIVIDADE PARLAMENTAR.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.15.00','DEBITOS ORIUNDOS DE USO OU ALUGUEL DE IMOVE','REGISTRA OS DEBITOS (APURADOS E EM APURACAO) REFERENTES A DEBITOS DEPARLAMENTARES CONHECIDOS APOS SEU AFASTAMENTO DO MANDADO E QUE NAO PU-DERAM SER DESCONTADOS EM FOLHA DE PAGAMENTO. EXEMPLOS: REMANESCENTE DECONTA DE ENERGIA ELETRICA, GAS, TAXA DE LIMPEZA PUBLICA E ALUGUEIS DEOUTROS BENS IMOVEIS PERTENCENTE AO ORGAO.','C','S','C','');
        INSERT INTO insere_novo_plano (codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES ('8.9.7.3.1.99.00','OUTRAS RESPONSABILIDADES EM APURACAO','REGISTRA RESPONSABILIDADES EM APURACAO NAO INDIVIDUALIZADAS NAS OUTRASCONTAS DESSE GRUPO.','C','S','C','');

        UPDATE insere_novo_plano SET escrituracao = 'S' WHERE escrituracao = 's';


        stSQL := '
                    SELECT codigo_estrutural
                         , titulo
                         , funcao
                         , CASE
                                WHEN natureza_saldo = \'C\' THEN \'credor\'
                                WHEN natureza_saldo = \'D\' THEN \'devedor\'
                                WHEN natureza_saldo = \'S\' THEN NULL
                                WHEN natureza_saldo = \'X\' THEN \'misto\'
                                ELSE                             NULL
                           END AS natureza_saldo
                         , CASE
                                WHEN natureza_saldo = \'C\' THEN \'C\'
                                WHEN natureza_saldo = \'D\' THEN \'D\'
                                WHEN natureza_saldo = \'S\' THEN \'\'
                                WHEN natureza_saldo = \'X\' THEN \'M\'
                                ELSE                             \'\'
                           END AS natureza_saldo_analitica
                         , CASE
                                WHEN escrituracao = \'N\' THEN \'sintetica\'
                                WHEN escrituracao = \'S\' THEN \'analitica\'
                           END AS escrituracao
                         , CASE
                                WHEN natureza_informacao = \'C\' THEN 3
                                WHEN natureza_informacao = \'O\' THEN 2
                                WHEN natureza_informacao = \'P\' THEN 1
                                ELSE                                  4
                           END AS cod_sistema -- natureza_informacao
                         , CASE
                                WHEN indicador_superavit = \'F\' THEN \'financeiro\'
                                WHEN indicador_superavit = \'P\' THEN \'permanente\'
                                WHEN indicador_superavit = \'X\' THEN \'misto\'
                                ELSE                                  NULL
                           END AS indicador_superavit
                      FROM insere_novo_plano
                         ;
                 ';
        FOR reRecord IN EXECUTE stSQL LOOP
            INSERT
              INTO contabilidade.plano_conta
                 ( cod_conta
                 , exercicio
                 , nom_conta
                 , cod_classificacao
                 , cod_sistema
                 , cod_estrutural
                 , escrituracao
                 , natureza_saldo
                 , indicador_superavit
                 , funcao
                 )
            VALUES
                 ( inCountPlanoConta
                 , '2012'
                 , reRecord.titulo
                 , 1
                 , reRecord.cod_sistema
                 , reRecord.codigo_estrutural
                 , reRecord.escrituracao
                 , reRecord.natureza_saldo
                 , reRecord.indicador_superavit
                 , reRecord.funcao
                 );

            IF reRecord.escrituracao = 'analitica' THEN
                INSERT
                  INTO contabilidade.plano_analitica
                     ( cod_plano
                     , exercicio
                     , cod_conta
                     , natureza_saldo
                     )
                VALUES
                     ( inCountAnalitica
                     , '2012'
                         , inCountPlanoConta
                     , reRecord.natureza_saldo_analitica
                     );
                inCountAnalitica := inCountAnalitica + 1;
            END IF;
            inCountPlanoConta := inCountPlanoConta + 1;

        END LOOP;

        DROP TABLE insere_novo_plano;

    END IF;

END;
$$ LANGUAGE 'plpgsql';

SELECT        manutencao();
DROP FUNCTION manutencao();


----------------
-- Ticket #18280
----------------

DROP FUNCTION realizacaoreceitafixa(VARCHAR, NUMERIC, VARCHAR, INTEGER, VARCHAR, INTEGER, NUMERIC, NUMERIC, INTEGER);
DROP FUNCTION realizacaoreceitavariavel(VARCHAR, VARCHAR, VARCHAR, NUMERIC, VARCHAR, INTEGER, VARCHAR, INTEGER, INTEGER, INTEGER);


