/*
    **********************************************************************************
    *                                                                                *
    * @package URBEM CNM - Soluções em Gestão Pública                                *
    * @copyright (c) 2013 Confederação Nacional de Municípos                         *
    * @author Confederação Nacional de Municípios                                    *
    *                                                                                *
    * O URBEM CNM é um software livre; você pode redistribuí-lo e/ou modificá-lo sob *
    * os  termos  da Licença Pública Geral GNU conforme  publicada  pela Fundação do *
    * Software Livre (FSF - Free Software Foundation); na versão 2 da Licença.       *
    *                                                                                *
    * Este  programa  é  distribuído  na  expectativa  de  que  seja  útil,   porém, *
    * SEM NENHUMA GARANTIA; nem mesmo a garantia implícita  de  COMERCIABILIDADE  OU *
    * ADEQUAÇÃO A UMA FINALIDADE ESPECÍFICA. Consulte a Licença Pública Geral do GNU *
    * para mais detalhes.                                                            *
    *                                                                                *
    * Você deve ter recebido uma cópia da Licença Pública Geral do GNU "LICENCA.txt" *
    * com  este  programa; se não, escreva para  a  Free  Software Foundation  Inc., *
    * no endereço 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.       *
    *                                                                                *
    **********************************************************************************
*/
/*
*
* Script de DDL e DML
*
* Versao 2.02.0
*
* Fabio Bertoldi - 20130731
*
*/

----------------
-- Ticket #19763
----------------

INSERT
  INTO administracao.modulo
     ( cod_modulo
     , cod_responsavel
     , nom_modulo
     , nom_diretorio
     , ordem
     , cod_gestao
     , ativo
     )
VALUES
     ( 61
     , 0
     , 'SIOPE/SIOPS'
     , 'SIOPE_SIOPS/'
     , 95
     , 6
     , TRUE
     );
  
INSERT
  INTO administracao.funcionalidade
     ( cod_funcionalidade
     , cod_modulo
     , nom_funcionalidade
     , nom_diretorio
     , ordem
     , ativo
     )
VALUES
     ( 479
     , 61
     , 'Relatórios'
     , 'instancias/relatorio/'
     , 10
     , TRUE
     );

UPDATE administracao.acao SET cod_funcionalidade = 479 WHERE cod_acao = 2237;
UPDATE administracao.acao SET cod_funcionalidade = 479 WHERE cod_acao = 2235;

UPDATE administracao.relatorio SET cod_gestao = 6, cod_modulo = 61, cod_relatorio = 1 WHERE cod_gestao = 2 AND cod_modulo = 8 AND cod_relatorio = 4;
UPDATE administracao.relatorio SET cod_gestao = 6, cod_modulo = 61, cod_relatorio = 2 WHERE cod_gestao = 2 AND cod_modulo = 8 AND cod_relatorio = 1;


----------------
-- Ticket #20595
----------------

ALTER TABLE administracao.auditoria_detalhe ALTER COLUMN timestamp TYPE timestamp;


----------------
-- Ticket #20528
----------------

INSERT INTO administracao.configuracao VALUES ('2014', 8, 'unidade_medida_metas_receita', '');
INSERT INTO administracao.configuracao VALUES ('2014', 8, 'unidade_medida_metas_despesa', '');


----------------
-- Ticket #19030
----------------

DROP FUNCTION tesouraria.fn_relatorio_demostrativo_saldos(varchar, integer, varchar, varchar, varchar, varchar, varchar, varchar, varchar);
DROP FUNCTION tesouraria.fn_relatorio_demostrativo_saldos(varchar, integer, varchar, varchar, varchar, varchar, varchar, varchar, varchar, varchar);
DROP FUNCTION tesouraria.fn_relatorio_demostrativo_saldos(varchar, integer, varchar, varchar, varchar, varchar, varchar, varchar, varchar, varchar, varchar, varchar);


----------------
-- Ticket #20195
----------------

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2897
  , 63
  , 'FLDemoVariacoesPatrimoniais.php'
  , 'imprimir'
  , 29
  , ''
  , 'Demonstração das Variações Patrimoniais'
  , TRUE
  );

INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 14
  , 'Demonstração das Variações Patrimoniais'
  , 'demonstrarVariacoesPatrimoniais.rptdesign'
  );


----------------
-- Ticket #20196
----------------

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2896
  , 63
  , 'FLBalancoFinanceiro.php'
  , 'emitir'
  , 28
  , ''
  , 'Balanço Financeiro'
  , TRUE
  );

INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 15
  , 'Relatório Balanço Financeiro'
  , 'relatorioBalancoFinanceiro.rptdesign'
  );


----------------
-- Ticket #20197
----------------

UPDATE administracao.acao SET ativo = FALSE WHERE cod_acao = 1709;

ALTER TABLE empenho.empenho ADD COLUMN restos_pagar VARCHAR(50);
ALTER TABLE empenho.empenho ADD CONSTRAINT ck_empenho_1 CHECK (restos_pagar IN ('Não Processados a Liquidar', 'Processado', 'Não Processados Liquidado'));


----------------
-- Ticket #20207
----------------

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2894
  , 63
  , 'FLBalancoPatrimonial.php'
  , 'gerar'
  , 27
  , ''
  , 'Balanço Patrimonial'
  , TRUE
  );

INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 12
  , 'Balanço Patrimonial'
  , 'balancoPatrimonial.rptdesign'
  );


----------------
-- Ticket #20465
----------------

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2898
  , 61
  , 'FMAberturaOrcamentoAnual.php'
  , 'incluir'
  , 8
  , ''
  , 'Abertura do Orçamento Anual'
  , TRUE
  );

DELETE
  FROM contabilidade.historico_contabil
 WHERE cod_historico = 820
   AND exercicio = '2014'
     ;
INSERT
  INTO contabilidade.historico_contabil
     ( cod_historico
     , exercicio
     , nom_historico
     , complemento
     , historico_interno
     )
VALUES
     ( 820
     , '2014'
     , 'Vlr. Ref. Estimativa Receita Exercício'
     , TRUE
     , FALSE
     );

DELETE
  FROM contabilidade.historico_contabil
 WHERE cod_historico = 821
   AND exercicio = '2014'
     ;
INSERT
  INTO contabilidade.historico_contabil
     ( cod_historico
     , exercicio
     , nom_historico
     , complemento
     , historico_interno
     )
VALUES
     ( 821
     , '2014'
     , 'Vlr. Ref. Fixação da Despesa Exercício'
     , TRUE
     , FALSE
     );

DELETE
  FROM contabilidade.historico_contabil
 WHERE cod_historico = 822
   AND exercicio = '2014'
     ;
INSERT
  INTO contabilidade.historico_contabil
     ( cod_historico
     , exercicio
     , nom_historico
     , complemento
     , historico_interno
     )
VALUES
     ( 822
     , '2014'
     , 'Vlr. Ref. Estimativa Receita Dedutora Exercício'
     , TRUE
     , FALSE
     );

DELETE
  FROM contabilidade.historico_contabil
 WHERE cod_historico = 823
   AND exercicio = '2014'
     ;
INSERT
  INTO contabilidade.historico_contabil
     ( cod_historico
     , exercicio
     , nom_historico
     , complemento
     , historico_interno
     )
VALUES
     ( 823
     , '2014'
     , 'Vlr. Ref. Lançamentos de Abertura dos Recursos/Fontes'
     , TRUE
     , FALSE
     );

DELETE
  FROM contabilidade.historico_contabil
 WHERE cod_historico = 824
   AND exercicio = '2014'
     ;
INSERT
  INTO contabilidade.historico_contabil
     ( cod_historico
     , exercicio
     , nom_historico
     , complemento
     , historico_interno
     )
VALUES
     ( 824
     , '2014'
     , 'Vlr. Ref. Lançamentos Abertura do Exercício Restos a Pagar'
     , TRUE
     , FALSE
     );


----------------
-- Ticket #20396
----------------

UPDATE administracao.acao
   SET ordem = ordem + 1
 WHERE cod_funcionalidade = 63
   AND ordem > 22
     ;

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2892
  , 63
  , 'FLDemoMutPatrimonioLiquido.php'
  , 'imprimir'
  , 23
  , ''
  , 'Demonst. Mutações do Patrimônio Líquido'
  , TRUE
  );

INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 11
  , 'Demonstração das Mutações do Patrimônio Líquido'
  , 'mutacoesPatrimonioLiquido.rptdesign'
  );


----------------
-- Ticket #20395
----------------

UPDATE administracao.acao
   SET ordem = ordem + 1
 WHERE cod_funcionalidade = 63
   AND ordem > 23
     ;

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2893
  , 63
  , 'FLDemostrativoFluxoCaixa.php'
  , 'emitir'
  , 24
  , ''
  , 'Demost. Fluxo de Caixa'
  , TRUE
  );

INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 13
  , 'Relatório Demostrativo de Fluxo Caixa'
  , 'relatorioFluxoCaixa.rptdesign'
  );


----------------
-- Ticket #20937
----------------

ALTER TABLE contabilidade.plano_conta DROP CONSTRAINT uk_plano_conta_1;
ALTER TABLE contabilidade.plano_conta ADD  CONSTRAINT uk_plano_conta_1 UNIQUE (cod_estrutural, indicador_superavit, exercicio);

----------------------------------------------------------------------------------------
-- CORRECAO DE RELACIONENTO ENTRE orcamento.entidade E contabilidade.conta_lancamento_rp
----------------------------------------------------------------------------------------

ALTER TABLE contabilidade.conta_lancamento_rp ADD CONSTRAINT fk_conta_lancamento_rp_3 FOREIGN KEY (cod_entidade, exercicio) REFERENCES orcamento.entidade (cod_entidade, exercicio);


-------------------------------------------------
-- CORRECAO DE RELACIONAMENTO - Schema tesouraria
-------------------------------------------------

-- ALTER TABLE tesouraria.cheque_emissao_anulada DROP          CONSTRAINT fk_cheque_emissao_anulada;
-- ALTER TABLE tesouraria.cheque_emissao_anulada ADD           CONSTRAINT fk_cheque_emissao_anulada        FOREIGN KEY                                (cod_banco, cod_agencia, cod_conta_corrente, num_cheque, timestamp_emissao)
--                                                                                                         REFERENCES tesouraria.cheque_emissao       (cod_banco, cod_agencia, cod_conta_corrente, num_cheque, timestamp_emissao);
-- 
-- ALTER TABLE tesouraria.cheque_emissao_baixa   DROP          CONSTRAINT fk_cheque_emissao_baixa;
-- ALTER TABLE tesouraria.cheque_emissao_baixa   ADD           CONSTRAINT fk_cheque_emissao_baixa          FOREIGN KEY                                (cod_banco, cod_agencia, cod_conta_corrente, num_cheque, timestamp_emissao)
--                                                                                                         REFERENCES tesouraria.cheque_emissao       (cod_banco, cod_agencia, cod_conta_corrente, num_cheque, timestamp_emissao);
-- 
-- ALTER TABLE tesouraria.cheque_emissao_baixa_anulada   DROP  CONSTRAINT fk_cheque_emissao_baixa_anulada;
-- ALTER TABLE tesouraria.cheque_emissao_baixa_anulada   ADD   CONSTRAINT fk_cheque_emissao_baixa_anulada  FOREIGN KEY                                (cod_banco, cod_agencia, cod_conta_corrente, num_cheque, timestamp_emissao, timestamp_baixa)
--                                                                                                         REFERENCES tesouraria.cheque_emissao_baixa (cod_banco, cod_agencia, cod_conta_corrente, num_cheque, timestamp_emissao, timestamp_baixa);


----------------
-- Ticket #20623
----------------

UPDATE administracao.acao SET ativo = FALSE where cod_acao = 1629;


----------------
-- Ticket #20397
----------------

UPDATE administracao.funcionalidade SET ativo = TRUE where cod_funcionalidade = 310;

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2910
  , 63
  , 'FLConsistenciaPCASP.php'
  , 'gerar'
  , 31
  , ''
  , 'Consistência PCASP'
  , TRUE
  );
  
INSERT
  INTO administracao.relatorio
  ( cod_gestao
  , cod_modulo
  , cod_relatorio
  , nom_relatorio
  , arquivo )
  VALUES
  ( 2
  , 9
  , 16
  , 'Consistência PCASP'
  , 'consistenciaPCASP.rptdesign'
  );

----------------
-- Ticket #20356
----------------

ALTER TABLE contabilidade.plano_conta_geral ALTER COLUMN versao TYPE VARCHAR(30);

INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0)+1, 1), '99 - PCASP FEDERAÇÃO', '2013-06-01');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.0.0.0.0.00.00','ATIVO','Compreende os recursos controlados por uma entidade como consequência de eventos passados e dos quais se espera que fluam benefícios econômicos ou potencial de serviços futuros a unidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.0.0.0.00.00','ATIVO CIRCULANTE','Compreende os ativos que atendam a qualquer um dos seguintes critérios: sejam caixa ou equivalente de caixa; sejam realizáveis ou mantidos para venda ou consumo dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; sejam realizáveis no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.0.0.00.00','CAIXA E EQUIVALENTES DE CAIXA','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.01.00','CAIXA','Registra o somatório de numerários em espécie e outros valores em tesouraria.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.02.00','CONTA ÚNICA','Registra os valores da Conta Única, exceto RPPS.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.00','CONTA ÚNICA RPPS','Compreende os valores disponíveis na Conta Única do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.01','BANCOS CONTA MOVIMENTO – RPPS','Registra o somatório das disponibilidades bancarias agregadas nos itens conta única da previdência social e outras contas, agregadas nos agentes financeiros autorizados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.02','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','Registra a movimentação financeira dos recursos nas contas movimento do plano financeiro do RPPS através dos agentes financeiros credenciados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.03','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','Registra a movimentação financeira dos recursos nas contas movimento do plano previdenciário do RPPS através dos agentes financeiros credenciados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.06.04','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','Registra a movimentação financeira dos recursos nas contas movimento da taxa de administração do RPPS através dos agentes financeiros credenciados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.19.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','Compreende o somatório das disponibilidades existentes em outras contas bancárias, que não sejam a Conta Única, agregadas pelos subitens identificativos dos bancos correspondentes.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.30.00','REDE BANCARIA - ARRECADACAO','Registra o somatório dos recursos referentes a receitas arrecadadas e não recolhidas.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Compreende as aplicações financeiras de alta liquidez em moeda nacional, que são prontamente conversíveis em valores conhecidos de caixa e que estão sujeitas a um insignificante risco de mudança de valor.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.01','TÍTULOS PÚBLICOS','Registra os valores das disponibildiades das instituições, entidades e unidades aplicadas em títulos públicos.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.02','POUPANÇA','Registra o valor das aplicações financeiras em poupanças e seus rendimentos (juros e atualização moentária) posteriores.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.03','FUNDOS DE INVESTIMENTO','Registra o valor das aplicações financeiras em fundo de investimento e seus rendimentos (juros e atualização) posteriores, conforme instrução CVM 409/2004.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.04','CDB','Registra os valores das disponibilidades das instituições, entidades ou unidades aplicadas em certificados de depósitos bancários (CDB).','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.1.50.99','OUTRAS APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Registra outras aplicações financeiras, não classificadas em itens anteriores, das disponibilidades financeiras das entidades, instituições ou unidades.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.00','CONTA ÚNICA RPPS','Compreende os valores disponíveis na Conta Única do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.01','BANCOS CONTA MOVIMENTO – RPPS','Registra o somatório das disponibilidades bancarias agregadas nos itens conta única da previdência social e outras contas, agregadas nos agentes financeiros autorizados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.02','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','Registra a movimentação financeira dos recursos nas contas movimento do plano financeiro do RPPS através dos agentes financeiros credenciados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.03','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','Registra a movimentação financeira dos recursos nas contas movimento do plano previdenciário do RPPS através dos agentes financeiros credenciados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.1.2.06.04','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','Registra a movimentação financeira dos recursos nas contas movimento da taxa de administração do RPPS através dos agentes financeiros credenciados.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.0.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.01.00','CAIXA','Registra o somatório de numerários em espécie e outros valores em tesouraria no exterior','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.02.00','BANCOS','Registra a livre movimentação de recursos financeiros em moeda extrangeira mantidos em contas bancárias no exterior.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.1.2.1.03.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Registra as aplicações financeiras de alta liquidez em moeda estrangeira, que são prontamente conversíveis em valores conhecidos de caixa e que estão sujeitas a um insignificante risco de mudança de valor, inclusive as aplicações referentes ao fechamento de câmbio para aquisição de moeda estrangeira e as aplicações de depósitos com juros em moeda estrangeira realizadas no curtíssimo prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.0.0.00.00','CRÉDITOS A CURTO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos realizáveis no curso do exercício social subsequente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.0.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.02','IPVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.03','ITCMD','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.04','ICMS','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.1.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTRA OFSS','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.02','IPVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.03','ITCMD','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.04','ICMS','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.2.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. .','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.02','IPVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.03','ITCMD','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.04','ICMS','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto à sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.3.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS – ESTADO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.02','IPVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.03','ITCMD','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.04','ICMS','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.4.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.01','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.02','IPVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.03','ITCMD','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.04','ICMS','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.05','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.06','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.07','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.01.08','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.02.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.02.01','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.02.02','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.03.00','CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.03.01','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.04.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.04.01','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.1.5.70.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.0.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorram no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.1.00.00','CLIENTES - CONSOLIDAÇÃO','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.1.01.00','FATURAS/DUPLICATAS A RECEBER','Compreende os valores das faturas/duplicatas a receber não vencidas decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.1.02.00','(-) FATURAS/DUPLICATAS A RECEBER - DESCONTADAS ','Compreende a apropriação e movimentação das duplicatas descontadas provenientes do faturamento de vendas de mercadorias ou serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.1.03.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS ','Compreende os valores duplicatas a receber decorrentes de Faturas Vencidas que ocorrem no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.2.1.04.00','(-) FATURAS/DUPLICATAS A RECEBER VENCIDAS - DESCONTADAS ','Compreende a apropriação e movimentação das duplicatas descontadas vencidas provenientes do faturamento de vendas de mercadorias ou serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.0.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.1.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.1.01.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE INSTITUIÇÕES PRIVADAS','Registra os recursos a receber pelo Ente decorrentes de transferência de instituições privadas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.1.02.00','CRÉDITOS DE CONSÓRCIOS PÚBLICOS DECORRENTES DE CONTRATO DE RATEIO','Registra os recursos a receber pelo consórcio decorrente do contrato de rateio.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS – UNIÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DA UNIÃO','Compreende os recursos a receber pelo Estado por sua participação constitucional e legal em receitas arrecadadas pela União.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.01.01','COTA-PARTE DO FPE','Registra a participação dos Estados e do Distrito Federal no produto da arrecadação dos Impostos sobre a Renda e sobre Produtos Industrializados, conforme coeficientes fixados pelo Tribunal de contas da União, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.01.02','COTA-PARTE DO FPM','Registra a participação dos Municípios no produto da arrecadação dos Impostos sobre a Renda e sobre Produtos Industrializados, conforme coeficientes fixados pelo Tribunal de contas da União, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.01.03','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL','Registra a participação dos Municípios no produto da arrecadação do Imposto sobre a Propriedade Territorial Rural, transferido pela União aos Municípios onde estejam localizados os imóveis sobre os quais incida o imposto.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.01.04','COTA-PARTE DO IPI - ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS','Registra a parcela do Imposto sobre Produtos Industrializados destinada aos Estados exportadores de produtos industrializados, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.01.05','COTA-PARTE DA CIDE','Registra a parcela da Cota-Parte da Contribuição de Intervenção no Domínio Econômico, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.02.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Compreende os recursos a receber pelo estado ou município decorrentes da exploração de recursos naturais.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.02.01','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECUROS HÍDRICOS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos hídricos, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.02.02','COTA-PARTE CA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos minerais, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.02.03','COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL','Registra a parcela da cota-parte do valor do petróleo bruto de produção nacional, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.03.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO SUS','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Sistema Único de Saúde','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.04.00','CRÉDITOS DECORRENTES DO FNAS','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo Nacional de Assistência Social.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.05.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO FNDE','Compreende os recursos a receber pelo estado ou município decorrentes das transferências do Fundo Nacional de Desenvolvimento da Educação.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.05.01','COTA-PARTE DO SALÁRIO-EDUCAÇÃO ','Registra a parcela do produto arrecadado da contribuição do salário-educação, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.06.00','CRÉDITOS DECORRENTES DAS TRANSFERÊNCIAS DO ICMS - DESONERAÇÃO - LC 87/96','Compreende os recursos a receber pelo estado ou município decorrentes das transferências financeiras pela desoneração de ICMS, prevista na Lei complementar 87/96.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.06.01','TRANSFERÊNCIA FINANCEIRA DO ICMS - DESONERAÇÃO - LC 87/96','Registra as transferências financeiras do ICMS - Desoneração - Lei Complementar 87/96, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.07.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','Compreende os recursos a receber pelo estado ou município decorrentes de transferência multigovernamentais.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.07.01','FUNDEB','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação (FUNDEB).','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.08.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE CONVÊNIOS','Registra os recursos a receber pelo estado ou município decorrentes de convênios firmados com outro ente.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.3.09.00','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','Compreende os recursos a receber pelo estado ou municío decorrentes de transferências não especificadas nos itens acima.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.01.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DOS ESTADOS ','Compreende os recursos a receber pelos Municípios por sua participação constitucional e legal em receitas arrecadadas pelos Estados.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.01.01','COTA-PARTE DO ICMS','Registra a parcela pertencente aos Municípios, do Imposto sobre Operações Relativas à Circulação de Mercadorias e sobre Prestações de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.4.01.02','COTA-PARTE DO IPVA','Registra a parcela pertencente aos Municípios, do Imposto sobre a Propriedade de Veículos Automotores, a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.3.5.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS ','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.1.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS ','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.3.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS ','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.4.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.01.00','EMPRÉSTIMOS CONCEDIDOS','Compreende o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.01.01','DEVEDORES POR EMPRÉSTIMOS CONCEDIDOS','Registra ao créditos a receber provenientes de empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.02.00','FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.02.01','DEVEDORES POR FINANCIAMENTOS CONCEDIDOS ','Registra ao créditos a receber provenientes de financiamentos por autorizações legais ou vinculações a contratos e acordos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.03.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos Juros e Encargos sobre Empréstimos e Financiamentos Concedidos a Receber.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.03.01','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.03.02','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.07.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.07.01','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.07.02','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.07.03','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.4.5.07.04','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.0.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.00.00','DIVIDA ATIVA TRIBUTARIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.02','DÍVIDA ATIVA DO IPVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.03','DÍVIDA ATIVA DO ITCMD','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.04','DÍVIDA ATIVA DO ICMS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.02.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.1.05.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.00.00','DIVIDA ATIVA TRIBUTARIA - INTRA OFSS ','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.02','DÍVIDA ATIVA DO IPVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.03','DÍVIDA ATIVA DO ITCMD','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.04','DÍVIDA ATIVA DO ICMS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.02.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.2.05.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - UNIÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.02','DÍVIDA ATIVA DO IPVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.03','DÍVIDA ATIVA DO ITCMD','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.04','DÍVIDA ATIVA DO ICMS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.02.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.3.05.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - ESTADO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.02','DÍVIDA ATIVA DO IPVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.03','DÍVIDA ATIVA DO ITCMD','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.04','DÍVIDA ATIVA DO ICMS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.02.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.4.05.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - MUNICÍPIO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.01','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.02','DÍVIDA ATIVA DO IPVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.03','DÍVIDA ATIVA DO ITCMD','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.04','DÍVIDA ATIVA DO ICMS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.05','DÍVIDA ATIVA DO IPTU','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.06','DÍVIDA ATIVA DO ITBI','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.07','DÍVIDA ATIVA DO ISS','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do Imposto Sobre Serviços de Qualquer Natureza.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.01.08','DÍVIDA ATIVA DO ITR','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.02.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.02.01','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.02.02','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.03.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.03.01','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.04.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.04.01','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.5.5.05.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.0.00.00','DIVIDA ATIVA NÃO TRIBUTARIA ','Compreende os valores dos créditos de divida ativa não tributaria inscritos, derivados de clientes, realizáveis no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.00.00','DIVIDA ATIVA NÃO TRIBUTARIA  - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa não tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.6.1.01.00','DIVIDA ATIVA NÃO TRIBUTARIA','Compreende os valores dos créditos de divida ativa não tributaria tais como os provenientes de empréstimos compulsórios, contribuições estabelecidas em lei, multas de qualquer origem ou natureza (exceto as tributárias), foros, laudêmios, aluguéis, taxas de ocupação, custas processuais, preços de serviços prestados por estabelecimentos públicos e outros, exigíveis por transcurso de prazo para pagamento, inscritos na forma de legislação própria, após apurada sua liquidez e certeza.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.0.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','N','P ');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.1.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','N','P ');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.2.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','N','P ');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.3.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','N','P ');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.4.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.01','(-) PERDAS ESTIMADAS EM IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.02','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.03','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.04','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.01.70','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.02.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.02.01','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','N','P ');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.03.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.03.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.03.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.04.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.04.01','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.04.02','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.04.03','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.04.04','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.2.9.5.05.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.0.0.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende os valores a receber por demais transações realizáveis no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.0.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','Compreende os valores das antecipações concedidas a servidores e a dirigentes da unidade, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de férias e de gratificações natalinas,entre outras.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.01','SALÁRIOS E ORDENADOS - ADIANTAMENTOS','Registra o adiantamento a pessoal referente a salários e ordenados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.02','13  SALÁRIO - ADIANTAMENTO','Registra o adiantamento a pessoal referente ao 13 salário.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.03','FÉRIAS - ADIANTAMENTO','Registra o adiantamento a pessoal referente às férias, exceto o 1/3 de férias.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.04','1/3 DE FÉRIAS - ADIANTAMENTO','Registra o adiantamento a pessoal referente a 1/3 de férias.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.05','VIAGENS - ADIANTAMENTO','Registra o adiantamento a pessoal referente a viagens.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.01.99','OUTROS ADIANTAMENTOS A PESSOAL','Registra outros adiantamentos concedidos a pessoal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.02.00','SUPRIMENTO DE FUNDOS','Registra o adiantamento a servidor para despesas sujeitas a prestação de contas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.03.00','ADIANTAMENTOS DE TRANSFERÊNCIAS VOLUNTÁRIAS','Registra os valores relativos a adiantamentos de recursos financeiros formalizados por transferências voluntárias.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.1.1.99.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','Registra os outros valores entregues antecipadamente, não classificados em contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.0.00.00','TRIBUTOS A RECUPERAR/COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/compensar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.00.00','TRIBUTOS A RECUPERAR/COMPENSAR - CONSOLIDAÇÃO','Compreende o somatório dos valores dos tributos a recuperar/compensar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.01.00','IPI A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IPI a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.02.00','ICMS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de ICMS a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.03.00','ICMS DIFERIDO','Registra os valores do ICMS diferido dos estoques.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.04.00','IRRF A  COMPENSAR','Registra o somatório dos valores do IR retido na fonte a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.05.00','IR E CSLL A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IR e da CSLL a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.06.00','IR E CSLL DIFERIDOS','Registra a parcela do IR e CSLL que representa a diferença entre os valores de lucro apurados seguindo as normas fiscais e seguindo o regime de competência, quando estes forem menores e as diferenças temporárias.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.07.00','ISS A  COMPENSAR','Registra o somatório dos valores do ISS a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.08.00','IPVA A  COMPENSAR','Registra o somatório dos valores do IPVA a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.09.00','IPTU A  COMPENSAR','Registra o somatório dos valores do IPTU a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.10.00','ITR A  COMPENSAR','Registra o somatório dos valores do ITR a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.11.00','INSS A  COMPENSAR','Registra o somatório dos valores do INSS a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.12.00','COFINS A RECUPERAR/COMPENSAR','Registra o somatório dos valores da COFINS a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.13.00','PIS/PASEP A RECUPERAR/COMPENSAR','Registra o somatório dos valores do PIS/PASEP a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.14.00','CIP A RECUPERAR/COMPENSAR','Registra o somatório dos valores da Contribuição de Iluminação Pública a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.2.1.99.00','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de outros tributos a recuperar/compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.0.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.3.1.01.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.0.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.00.00','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.01.00','CRÉDITOS POR DANOS AO PATRIMONIO DECORRENTES DE CRÉDITOS ADMINISTRATIVOS','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos .','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.02.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM  TOMADA DE CONTAS ESPECIAL','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em Tomada de Contas Especial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.4.1.03.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS  ','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos judiciais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.0.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS - CONSOLIDAÇÃO','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.02.00','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados, decorrentes de interposição de recursos na esfera judicial ou administrativa.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.04.00','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.06.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do tribunal de justiça relacionado ao pagamento de precatórios.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.1.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.02.00','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados, decorrentes de interposição de recursos na esfera judicial ou administrativa.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.04.00','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.06.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do tribunal de justiça relacionado ao pagamento de precatórios.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.2.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.02.00','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados, decorrentes de interposição de recursos na esfera judicial ou administrativa.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.04.00','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.06.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do tribunal de justiça relacionado ao pagamento de precatórios.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.3.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.02.00','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados, decorrentes de interposição de recursos na esfera judicial ou administrativa.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.04.00','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.06.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do tribunal de justiça relacionado ao pagamento de precatórios.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.4.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.01.00','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.02.00','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.03.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados, decorrentes de interposição de recursos na esfera judicial ou administrativa.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.04.00','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.05.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.06.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do tribunal de justiça relacionado ao pagamento de precatórios.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.5.5.99.00','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados, realizáveis no curto prazo.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.0.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.01.00','ALUGUÉIS A RECEBER','Registra os valores a receber decorrentes de contratos de aluguel.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.02.00','CRÉDITOS A RECEBER DECORRENTES DE PERMISSÃO DE USO DE BENS PÚBLICOS','Registra os valores a receber decorrentes de permissão de uso de bens públicos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.03.00','VALORES A RECUPERAR DECORRENTES DE INDENIZAÇÕES POR SINISTROS PAGOS','Registra os valores a recuperar referentes a indefinições pelo pagamento de sinistros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.04.00','VALES, TICKETS E BILHETES','Registra o valor dos vales, tickets e bilhetes adquiridos para futura distribuição aos servidores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.06.00','VALORES EM TRÂNSITO REALIZÁVEIS A CURTO PRAZO','Compreende o somatório dos valores contabilizados indevidamente em conta bancária, guia de recebimento e ordens bancárias emitidas a compensar.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.07.00','CRÉDITOS A RECEBER DECORRENTES DE INFRAÇÕES LEGAIS E CONTRATUAIS','Registra os recursos a receber provenientes da aplicação de autos de infração ou decorrentes de quebra de cláusulas contratuais. Os créditos decorrentes da quebra de cláusulas contratuais podem ser pagos em espécie, glosa ou através de fornecimentos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.08.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO FAMÍLIA PAGO','Registra os valores relativos ao salário-família, incluídos em folhas de pagamento, pagos aos empregados (CLT), com filhos menores, a compensar com as contribuições devidas pelo empregador a Previdência Social.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.09.00','CRÉDITOS A RECEBER POR REEMBOLSO DE SALÁRIO MATERNIDADE PAGO','Registra os salários pagos as servidoras gestantes, regidas pela CLT no período que perdurar a licença maternidade, prevista em lei, a deduzir das obrigações sociais devidas pelos órgãos e entidades.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.10.00','AUXÍLIO NATALIDADE PAGO A RECUPERAR','Registra os valores relativos à auxilio natalidade, pagos aos empregados regidos pela CLY, quando do nascimento de filhos destes, a recuperar, por se tratar de obrigações da Previdência Social.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.11.00','CRÉDITOS A RECEBER POR REEMBOLSO DE AUXÍLIO DOENÇA E ACIDENTES PAGOS','Registra os salários pagos aos servidores, regidos pela CLT, a título de auxilio doença/acidentes, previsto em lei, a serem reembolsados pelo INSS.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.12.00','CRÉDITOS A RECEBER POR CESSÃO DE PESSOAL','Registra os valores de créditos a receber tais como: folha de pagamento, despesa de transporte, alimentação e outras relativas à cessão de pessoal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.13.00','CRÉDITOS A RECEBER DECORRENTES DE CESSÃO DE ÁREAS PÚBLICAS','Registra os valores dos créditos a receber decorrentes da cessão de áreas públicas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.14.00','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','Registra os valores dos créditos a receber decorrentes da alienação de bens móveis ou imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.15.00','CRÉDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESA DE TERCEIROS','Registra os recursos a receber provenientes de pagamentos de despesas de terceiros decorrentes de cláusulas contratuais, tais como: água, luz, telefone, instalações, transporte e aluguéis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.16.00','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDORES E EX-SERVIDORES','Registra os valores dos créditos a receber decorrentes de acertos financeiros com servidores e ex-servidores do órgão, conforme disposto na lei 8.112/90.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.17.00','CRÉDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','Registra os valores dos créditos a receber decorrentes de folha de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.18.00','DIVIDENDOS PROPOSTOS A RECEBER','Registra os valores dos dividendos a que a empresa tenha direito, em função de participações em outras empresas, quando tais empresas já tenham registrado na demonstração de lucros ou prejuízos acumulados a parcela de dividendos propostos a distribuir.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.20.00','REMUNERAÇÃO DE DEBÊNTURES A RECEBER','Registra os valores das remunerações de debêntures a receber.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.27.00','TÍTULOS A RECEBER','Compreende os valores a receber a curto prazo representados por notas promissórias, letras de câmbio e outros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.28.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','Registra os valores a receber a curto prazo, decorrentes de direitos junto a entidades federais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.29.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','Registra os valores a receber a curto prazo, decorrentes de direitos junto a estados, DF e municípios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.31.00','CRÉDITOS A RECEBER DE PARCELAMENTOS','Registra o crédito de origem fiscal ou não, se autorizado o parcelamento, excluídos os créditos tributários e previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.8.1.99.00','OUTROS CRÉDITOS A RECEBER E VALORES DE  CURTO PRAZO','Registra os valores de outros créditos a receber, para os quais não tenham contas especificas neste subgrupo de contas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.0.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.03.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os valores dos ajustes para perdas em créditos a receber por descentralizações da prestação de serviços públicos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.04.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores das provisões para perdas de créditos por danos ao patrimônio, verificados em processos administrativos ou apurados em Tomada de Contas Especial.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.04.01','(-) AJUSTE  PARA PERDAS EM CRÉDITOS ADMINISTRATIVOS','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, verificados em processos administrativos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.04.02','(-) AJUSTE  PARA PERDAS EM CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, apurados em Tomada de Contas Especial.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.04.03','(-) AJUSTE  PARA PERDAS EM CRÉDITOS APURADOS EM PROCESSOS JUDICIAIS','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, apurados em processos judiciais.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.06.00','(-) AJUSTE  PARA PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIAS - DEMAIS CRÉDITOS','Registra os valores referentes à constituição de provisão para perdas de dívida ativa não tributária, exceto as derivadas de clientes de acordo com os critérios definidos no Manual de Procedimentos da Dívida Ativa.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.3.9.1.99.00','(-) AJUSTE  PARA PERDAS DE DEMAIS CRÉDITOS E  VALORES A CURTO PRAZO','Registra os valores das provisões para perdas de demais créditos a curto prazo, não classificadas anteriormente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.0.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo, alem das aplicações temporárias em metais preciosos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.0.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.00.00','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis até o final do exercício seguinte. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.01.00','TÍTULOS PÚBLICOS','Compreendem os valores relativos aos titulos públicos, emitidos e em circulacao, de posse da entidade pública.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.02.00','AÇÕES','Compreende os valores das acoes representativas das participacoes dos orgaos e entidades no capital das sociedades por acoes havidas por aquisicoes, subscricoes, bonificacoes e doações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.03.00','DERIVATIVOS','Compreende os créditos relativos a operações com derivativos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.00','APLICAÇÕES EM SEGMENTO DE RENDA FIXA - RPPS','Compreende o somatório dos investimentos realizados pelo RPPS com recursos previdenciários, efetuados em conformidade com a legislação específica.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.01','TÍTULOS DE RESPONSABILIDADE DO TESOURO','Registra os investimentos realizados pelo rpps, em títulos de emissao do tesouro nacional, efetuados em conformidade com o art. 6º, inciso i, alinea a(inclui operações compromissadas) da resolucao CMN n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.02','TÍTULOS DE RESPONSABILIDADE DO BANCO CENTRAL','Registra os investimentos realizados pelo rpps, em títulos de emissao do banco central do brasil; saldos remanescentes para resgates, considerando que o bc não emite mais títulos da divida publica- art 34 lc 101/2000.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.03','POUPANÇA','Registra os investimentos realizados pelo RPPS, em poupança e seus rendimentos (juros e atualização monetária) posteriores.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.04','FUNDOS DE INVESTIMENTO EM RENDA FIXA','Apresentar os investimentos realizados pelos rpps, em fundos de investimentos em renda fixa, efetuados em conformidade com o art. 6º, inciso v, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.05','FUNDOS DE INVESTIMENTO EM RENDA FIXA - CRÉDITO PRIVADO','Apresentar os investimentos realizados pelos rpps, em fundos de investimentos em renda fixa - crédito privdo.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.06','FUNDOS DE INVESTIMENTOS REFERENCIADOS','Registra os investimentos realizados pelo rpps, em fundos de investimentos referenciados, efetuados em conformidade com o art. 6º, inciso iii, alinea a, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.07','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS ','Registra os investimentos realizados pelo rpps, em fundos de investimentos em direito creditorio, efetuados em conformidade com o art. 6º, inciso vi e vii, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.08','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','Registra os investimentos realizados pelo rpps, em fundos de investimentos em titulos do tesouro, efetuados em conformidade com o art. 6º, inciso i,alinea b da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.09.09','OPERACOES COMPROMISSADAS','Registra os investimentos realizados pelo rpps, em operacoes compromissadas, efetuados em conformidade com o art.6º , inciso ii, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.00','APLICACOES EM SEGMENTO DE RENDA VARIAVEL - RPPS','Compreende o somatorio dos investimentos realizados pelo rpps com recursos previdenciarios, efetuados em conformidade com o art. 7º, da resolucao cmn n° 3.790/2009.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.01','FUNDO DE AÇÕES REFERENCIADOS','Registra os investimentos realizados pelo rpps, em operacoes compromissadas, efetuados em conformidade com o art.6º , inciso ii, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.02','FUNDOS DE ACOES  ','Registra os investimentos realizados pelo rpps, em fundo de acoes, efetuados em conformidade com o art. 7º, inciso iii, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.03','FUNDO MULTIMERCADO ','Registra os investimentos realizados pelo rpps, em fundo de multimercado, efetuados em conformidade com o art. 7º, inciso iv, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.04','FUNDOS DE INDICES REFERENCIADOS EM ACOES','Registra os investimentos realizados pelo rpps, em fundos de indices referenciados em acoes, efetuados em conformidade com o art. 7º, inci so ii, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.05','FUNDOS DE INVESTIMENTOS EM PARTICIPACOES','Registra os investimentos realizados pelo rpps, em fundos de investimentos em participacoes, efetuados em conformidade com o art. 7º, inciso v, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.10.06','FUNDOS DE INVESTIMENTOS IMOBILIARIOS','Registra os investimentos realizados pelo rpps, em fundo de investimentos imobiliarios, efetuados em conformidade com o art. 7º, inciso vi, da resolucao cmn n° 3.790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.11.00','APLICACOES EM SEGMENTO IMOBILIARIO - RPPS','Compreende o somatório dos investimentos realizados pelo RPPS com recursos previdenciários em segmento imobiliário.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.11.01','FUNDOS DE INVESTIMENTO IMOBILIÁRIOS','Registra o somatório dos investimentos realizados pelo RPPS com recursos previdenciários em fundos de investimento imobiliários.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.12.00','APLICACOES EM ENQUADRAMENTO - RPPS','Compreende os investimentos realizados pelo rpps, em desacordo com as regras estabelecidas pela resolucao cmn nº 3790/2009, artigo 25.','D','N','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.12.01','TITULOS E VALORES EM ENQUADRAMENTO','Registra os investimentos realizados pelo RPPS, em desacordo com as regras estabelecidas pela resolução CMN nº 3790/2009, artigo 25.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.13.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS','Compreende os investimentos realizados pelo rpps, em ativos nao sujeitos as regras da resolucao cmn nº 3790/2009.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.13.01','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','Registra os investimentos realizados pelo RPPS, em ativos não sujeitos as regras da resolução CMN nº 3790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.14.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','Compreende os investimentos realizados pelo rpps, com recursos da taxa de administracao, sujeitos as regras da resolucao cmn nº 3790/2009.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.1.1.14.01','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','Registra os investimentos realizados pelo RPPS, com recursos da taxa de administração, sujeitos as regras da resolução CMN nº 3790/2009.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.2.0.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.2.1.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.0.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.1.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS TEMPORÁRIOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.1.01.00','(-) AJUSTE DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS','Registra a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor, referente a títulos e valores mobiliários.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.4.9.1.02.00','(-) AJUSTE DE PERDAS COM APLICAÇÕES TEMPORÁRIAS EM METAIS PRECIOSOS','Registra a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor, referente a aplicações temporárias em metais preciosos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.0.0.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.0.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.01.00','MERCADORIAS PARA VENDA OU REVENDA','Registra o valor das mercadorias para venda ou revenda e doações relativas a estoques da entidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.02.00','MERCADORIAS ESTOQUES REGULATÓRIOS','Registra o valor das mercadorias adquiridas para revenda relativas a estoques públicos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.1.1.99.00','OUTRAS MERCADORIAS PARA REVENDA','Registra o valor das demais mercadorias adquiridas para revenda.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.0.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.1.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','Compreende os produtos já terminados oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.1.01.00','PRODUTOS ACABADOS','Registra o valor de produtos manufaturados já terminados, oriundos da própria produção da entidade e disponíveis para venda, estocados na fábrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.2.1.02.00','SERVICOS ACABADOS','Registra os valores pertinentes a serviços acabados que estão pendentes de faturamento ou de transferência para outras contas do ativo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.0.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.1.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.1.01.00','PRODUTOS EM ELABORACAO  ','Registra a totalidade das matérias-primas já requisitadas que estão em processo de transformação e o montante de custos diretos e indiretos relativos aos produtos em elaboração não concluídos na data do balanço patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.3.1.02.00','SERVICOS EM ELABORACAO','Registra os custos diretos e indiretos relativos aos serviços em elaboração não concluídos na data do balanço patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.0.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.1.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.1.01.00','MATERIAS-PRIMAS - ARMAZENS PROPRIOS','Registra o estoque de matérias-primas que serão utilizados no processo produtivo, guardadas em armazéns próprios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.4.1.02.00','MATERIAS-PRIMAS - ARMAZENS DE TERCEIROS','Registra o estoque de matérias-primas que serão utilizados no processo produtivo, guardadas em armazéns de terceiros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.0.00.00','MATERIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.00.00','MATERIAIS EM TRANSITO - CONSOLIDAÇÃO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.5.1.01.00','MATERIAL EM TRANSITO','Compreende os valores dos materiais em trânsito relativos a transferências efetuadas entre unidades.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.0.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','Compreende o valor dos materiais destinados ao consumo interno da unidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.01.00','MATERIAL DE CONSUMO','Registra os valores dos materiais de consumo adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.02.00','GÊNEROS ALIMENTÍCIOS','Registra os valores dos gêneros alimentícios adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.03.00','MATERIAIS DE CONSTRUCAO','Registra os valores dos materiais de construção adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.04.00','AUTOPEÇAS','Registra os valores de autopeças adquiridas e estocadas em almoxarifados, destinadas a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.05.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','Registra os valores dos medicamentos e materias hospitalares adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.06.00','MATERIAIS GRÁFICOS','Registra os valores dos materiais gráficos adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.08.00','MATERIAL DE EXPEDIENTE','Registra os valores dos materiais de expediente adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.09.00','MATERIAIS A CLASSIFICAR','Registra os valores dos materiais estocados pendentes de classificação e identificação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.6.1.10.00','ESTOQUE SOBRESSALENTES A ALIENAR','Registra os valores de bens sobressalentes que estejam disponíveis para alienação sob diversas formas (venda, leilão, etc)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.7.0.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.7.1.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.0.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.8.1.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.0.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.1.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.1.01.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Registra as perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.5.9.1.02.00','(-) AJUSTE DE PERDAS PARA REDUCAO AO VALOR DE MERCADO','Registra o ajuste de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no curto prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.1.0.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.1.1.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de prêmios de seguro a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.0.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos, a título de VPD financeiras a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.2.1.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos, a título de VPD financeiras a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.0.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.3.1.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.0.00.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.4.1.00.00','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de aluguel a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.0.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.5.1.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de tributos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.6.0.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.6.1.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de contribuições confederativas a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.7.0.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.7.1.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.0.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.1.9.8.1.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','Compreende os demais valores pagos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.0.0.0.00.00','ATIVO NÃO CIRCULANTE','Compreende o ativo não circulante: o ativo realizável a longo prazo, os investimentos, o imobilizado e o intangível.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.0.0.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','Compreende os bens, direitos e despesas antecipadas realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.0.00.00','CRÉDITOS A LONGO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos e com vencimento no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento após o término do exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.01','IMPOSTOS','Registra os créditos tributários a receber provenientes de impostos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.02','TAXAS','Registra os créditos tributários a receber provenientes de taxas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.03','CONTRIBUIÇÕES DE MELHORIA','Registra os créditos tributários a receber provenientes de contribuições de melhoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.04','DEMAIS CONTRIBUIÇÕES','Registra os créditos tributários a receber provenientes de contribuições especiais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.01.70','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.02.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.02.01',' FATURAS/DUPLICATAS A RECEBER ','Registra os valores provenientes dos faturamentos da venda de mercadorias/produtos e serviços do estoque da entidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.01','EMPRÉSTIMOS CONCEDIDOS A RECEBER ','Registra os valores dos créditos por empréstimos concedidos pelo Ente, por autorização legal ou vinculação a contrato ou acordo, com vencimento a longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.02','FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra os valores dos créditos por financiamentos concedidos pelo Ente, por autorizaão legal ou vinculação a contrato ou acordo, com vencimento a longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.03.03','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.04.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.04.01','CRÉDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','Registra os valores relativos a créditos inscritos de Dívida Ativa tributária não previdenciária.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.04.02','CRÉDITOS PREVIDENCIÁRIOS INSCRITOS','Registra os valores relativos a créditos inscritos de Dívida Ativa tributária previdenciária.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.05.00','DIVIDA ATIVA NÃO TRIBUTARIA','Compreende os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.01','(-) AJUSTE DE PERDAS DE CRÉDITOS TRIBUTÁRIOS','Registra o ajuste para cobertura de perdas estimadas na cobrança de créditos tributários.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.02','(-) AJUSTE DE PERDAS DE CLIENTES','Registra o ajuste para cobertura de perdas estimadas na cobrança das contas a receber de clientes.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.03','(-) AJUSTE DE PERDAS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para cobertura de perdas estimadas na cobrança de empréstimos e financiamentos concedidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.04','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra o ajuste para cobertura de perdas estimadas na cobrança de dívida ativa tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.1.99.05','(-) AJUSTE DE PERDAS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o ajuste para cobertura de perdas estimadas na cobrança de dívida ativa não tributária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos daw variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.02.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.04.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.05.00','DIVIDA ATIVA NÃO TRIBUTARIA','Compreende os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.2.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos da variação patrimonial aumentativa tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsório.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.02.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.04.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.05.00','DIVIDA ATIVA NÃO TRIBUTARIA','Compreende os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.3.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento após o término do exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.02.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.04.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.05.00','DIVIDA ATIVA NÃO TRIBUTARIA ','Compreende os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.4.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.01.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento após o término do exercício seguinte, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.02.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.03.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.04.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.05.00','DIVIDA ATIVA NÃO TRIBUTARIA','Compreende os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.1.5.99.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.0.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende os valores a receber por demais transações, com vencimento no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por demais transações, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.01','ADIANTAMENTOS CONCEDIDOS A PESSOAL','Registra os valores das antecipações concedidas a servidores e a dirigentes da unidade, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de férias e de gratificações natalinas,entre outras.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.01.99','ADIANTAMENTOS DIVERSOS CONCEDIDOS','Registra os outros valores entregues antecipadamente, não classificados em contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.00','TRIBUTOS A RECUPERAR/COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/compensar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.01','IPI A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IPI a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.02','ICMS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de ICMS a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.03','ICMS DIFERIDO','Registra os valores do ICMS diferido dos estoques.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.04','IRRF A  COMPENSAR','Registra o somatório dos valores do IR retido na fonte a compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.05','IR E CSLL A RECUPERAR/COMPENSAR','Registra o somatório dos valores do IR e da CSLL a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.06','IR E CSLL DIFERIDOS','Registra a parcela do IR e CSLL que representa a diferença entre os valores de lucro apurados seguindo as normas fiscais e seguindo o regime de competência, quando estes forem menores e as diferenças temporárias.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.07','ISS A  COMPENSAR','Registra o somatório dos valores do ISS a compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.08','IPVA A  COMPENSAR','Registra o somatório dos valores do IPVA a compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.09','IPTU A  COMPENSAR','Registra o somatório dos valores do IPTU a compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.10','ITR A  COMPENSAR','Registra o somatório dos valores do ITR a compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.11','INSS A  COMPENSAR','Registra o somatório dos valores do INSS a compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.12','COFINS A RECUPERAR/COMPENSAR','Registra o somatório dos valores da COFINS a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.13','PIS/PASEP A RECUPERAR/COMPENSAR','Registra o somatório dos valores do PIS/PASEP a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.14','CIP A RECUPERAR/COMPENSAR','Registra o somatório dos valores da Contribuição de Iluminação Pública a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.02.99','OUTROS TRIBUTOS A RECUPERAR/COMPENSAR','Registra o somatório dos valores de outros tributos a recuperar/compensar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.03.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber com realização após os doze meses seguintes a data de publicação das demonstrações contábeis, decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','Compreende os valores realizáveis após os doze meses seguintes a data de publicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.01','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','Registra o crédito do ente correspondente a débitos administrativos decorrentes de folha de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.02','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','Registra o crédito do ente correspondente a débito administrativo decorrentes de danos ao patrimônio público.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.03','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','Registra o crédito do ente correspondente a débito administrativo decorrentes de erro da administração.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.04','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','Registra o crédito do ente correspondente a débito administrativo decorrentes de dolo, má-fé ou fraude.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.05','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','Registra os saldos dos valores entregues a funcionários ou servidores, não devolvidos dentro dos prazos estabelecidos em normas legais ou determinação administrativa ou seja, quando o produto a arrecadar não tenha sido recolhido no prazo legal.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.06','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','Registra os valores relativos as responsabilidades por irregularidades em prestação de serviços por terceiros, cujos processos foram apurados, com imputação da responsabilidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.07','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','Registra os valores referentes a multas e juros pagos pelo órgão, porém de responsabilidade de servidores, que foram apurados, com imputação da responsabilidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.08','CREDITOS A RECEBER POR USO INDEVIDO DE COTA','Registra os débitos (apurados e em apuração) de parlamentares em razão de recebimento indevido de valor relacionado a cota destina a custear gastos vinculados ao exercício de atividade parlamentar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.09','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL ','Registra os débitos (apurados e em apuração) referentes a débitos de parlamentares conhecidos após seu afastamento do mandado e que não puderam ser descontados em folha de pagamento. exemplos: remanescente de conta de energia elétrica, gás, taxa de limpeza pública e aluguéis de outros bens imóveis pertencente ao órgão.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.10','CREDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFICIOS PREVIDENCIARIOS  ','Registra as responsabilidades imputadas a órgãos pagadores por pagamentos indevidos de benefícios previdenciários, pós-morte do segurado (créditos reconhecidos sem necessidade de instauração de tomada de contas especial).','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.04.99','OUTROS CREDITOS ADMINISTRATIVOS','Registra o crédito do ente correspondente a outros créditos administrativos que não se enquadram em rubricas específicas existentes.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','Compreende os valores realizáveis após os doze meses seguintes a data de publicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em tomada de contas especial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.01','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades imputadas a gestores e outros responsáveis e co-responsáveis por pagamentos efetuados indevidamente, inclusive em casos de super faturamento. (quando for instaurada tomada de conta especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.02','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL  - TOMADA DE CONTAS ESPECIAL','Registra os saldos dos valores entregues a funcionários ou servidores, não devolvidos dentro dos prazos estabelecidos em normas legais ou determimanação administrativa, ou seja, quando o produto a arrecadar não tenha sido recolhido no prazo legal.(quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.03','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS  - TOMADA DE CONTAS ESPECIAL','Registra os desfalques, desvios de bens e valores da ente público ou de entidades publicas, apuradas em processos por ações administrativas e policial ou julgamento judicial. (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.04','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','Registra os valores relativos às responsabilidades por irregularidades em prestação de serviços por terceiros, cujos processos foram apurados, com imputação da responsabilidade. (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.05','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades apuradas em inquéritos administrativo ou policial contra servidores ou terceiros, por danos e perdas causados afazenda nacional sendo apurados com imputação da responsabilidade. (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.06','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO  - TOMADA DE CONTAS ESPECIAL','Registra as despesas realizadas sem existência de crédito que as comporte, resultando em pagamento sem prévio empenho ou ainda com classificação imprópria (diferente daquela prevista no orçamento), apuradas, com imputação da responsabilidade (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.07','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS  - TOMADA DE CONTAS ESPECIAL','Registra os valores pagos sobre dotações decorrentes de créditos antecipados não realizados até o fechamento do exercicio, apurados, com imputacao da responsabilidade (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.08','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO  - TOMADA DE CONTAS ESPECIAL ','Registra os valores correspondentes à falta de documentação comprobatória da execução da despesa, inclusive as apresentações fora do prazo legal, bem como a inadimplência na comprovação de instrumentos de transferência ou ainda irregularidade na documentação apurados, com imputação da responsabilidade (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.09','CREDITOS  A RECEBER DECORRENTES DE FALTA DE LICITACAO  - TOMADA DE CONTAS ESPECIAL ','Registra os valores relativos a bens e serviços adquiridos sem a necessária licitação específica, em processos motivados, por determinações administrativas e ou inquéritos, apurados, com imputação da responsabilidade. (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.10','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL ','Registra os valores referentes a multas e juros pagos pelo órgão, porém de responsabilidade de servidores, que foram apurados, com imputação da responsabilidade .(quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.11','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS  - TOMADA DE CONTAS ESPECIAL ','Registra os valores correspondentes à falta de recolhimento ou pagamento de obrigações pecuniárias, tais como: parte de obrigações patronais do empregador , valores descontados de terceiros e não recolhidos, não pagamento de obrigações para com o ente. (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.12','CREDITOS A RECEBER DECORRENTES DE FRAUDES EM BENEFICIOS  - TOMADA DE CONTAS ESPECIAL ','Registra os débitos relativos a fraudes em benefícios da previdência social, com a responsabilidade devidamente apurada e imputada a servidores ou terceiros (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.13','CREDITOS  A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE   - TOMADA DE CONTAS ESPECIAL ','Registra as responsabilidades imputadas a gestores e outros responsáveis e co-responsáveis por adiantamentos concedidos em desacordo com a legislação pertinente, tais como a fornecedores e empregados.(quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.14','CREDITOS A RECEBER POR USO INDEVIDO DE COTA - TOMADA DE CONTAS ESPECIAL ','Registra os debitos (apurados e em apuração) de parlamentares em razão de recebimento indevido de valor relacionado a cota destinada a custear gastos vinculados ao exercício de atividade parlamentar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.15','CREDITOS A RECEBER ORIUNDOS DE USO OU ALUGUEL - TOMADA DE CONTAS ESPECIAL ','Registra os débitos (apurados e em apuração) referentes a débitos de parlamentares conhecidos após seu afastamento do mandado e que não puderam ser descontados em folha de pagamento. exemplos: remanescente de conta de energia elétrica, gás, taxa de limpeza pública e aluguéis de outros bens imóveis pertencente ao órgão.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.05.99','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','Registra as responsabilidades diversas cujas classificações não estejam definidas em contas próprias ou para as quais não hajam contas específicas. (quando for instaurada tomada de contas especial)','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis após os doze meses seguintes a data de publicação das demonstrações contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.01','DEPÓSITOS E CAUÇÕES RELATIVOS A CONTRATOS OU CONVENÇÕES','Registra os valores relativos a depósitos e cauções, efetuados por vinculações a contratos ou convenções, para garantias de operações específicas, realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.02','DEPÓSITOS JUDICIAIS','Registra os valores a receber decorrentes de depósitos efetuados por determinação judicial, realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.03','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depósitos vinculados decorrentes da interposição de recursos na esfera judicial ou administrativa.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.04','DEPÓSITOS ESPECIAIS','Registra os valores relativos a outros depósitos em contas bancárias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.05','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.06','DEPÓSITOS TRANSFERIDOS','Registra os valores relativos a depósitos transferidos, para garantia de operações específicas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.07','DEPÓSITOS COMPULSÓRIOS','Registra os valores relativos a depósitos compulsórios, de acordo com a legislação em vigor.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.06.99','OUTROS DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depósitos restituíveis e valores vinculados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.00','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','Compreende os outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.01','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS','Registra os valores realizáveis após o término do exercício seguinte decorrentes de débito de entidades federais com o estado/município.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.02','CRÉDITOS A RECEBER POR CESSÃO DE CRÉDITOS','Registra os valores dos créditos a receber cedidos pelo estado/município realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.03','CRÉDITOS ORIUNDOS DE CONCESSÕES DE DIREITOS DE USO E DE EXPLORAÇÃO DE BENS','Registra o valor dos créditos oriundos das concessões de direitos de uso e de exploração de bens do estado/município, para terceiros ou para outras entidades governamentais realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.04','CRÉDITOS A RECEBER DE DEVEDORES DE CONVÊNIOS','Registra os valores, realizáveis após o término do exercício seguinte, oriundos de créditos de convênios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.05','CRÉDITOS A RECEBER DECORRENTES DE ALIENAÇÃO DE BENS MÓVEIS E IMÓVEIS','Registra os valores, realizáveis após o término do exercício seguinte, dos créditos a receber decorrentes da alienação de bens móveis e imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.06','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EX-SERVIDOR','Registra os valores, realizáveis após o término do exercício seguinte, dos créditos a receber decorrentes de acertos financeiros com servidores e ex-servidores do órgão.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.07','CRÉDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRAÇÃO','Registra o valor dos créditos administrativos oriundos de autos de infração e outros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.08','INDENIZAÇÕES A RECEBER','Registra o valor de indenizações a receber realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.98.99','OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','Registra o valor de outros créditos a receber e valores realizáveis no longo prazo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.01','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','Registra o ajuste para perdas estimadas com o não recebimento de valores referentes a dívida ativa não tributária de longo prazo, exceto as derivadas de clientes.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.02','(-) AJUSTE DE PERDAS DE CRÉDITOS ADMINISTRATIVOS','Registra os valores, realizáveis após o término do exercício seguinte, dos ajustes para perdas estimadas de créditos por danos ao patrimônio, verificados em processos administrativos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.03','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra os valores dos ajustes para perdas estimadas de créditos por danos ao patrimônio, apurados em tomada de contas especial, e realizáveis no longo prazo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.07','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS','Registra os valores dos ajustes para perdas estimadas de créditos de divida ativa não tributaria, exceto as derivadas de clientes, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.2.1.99.98','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM OUTROS CRÉDITOS A RECEBER E VALORES A LONGO PRAZO','Registra os valores dos ajustes para perdas estimadas de outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.0.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.01','TÍTULOS PÚBLICOS - MERCADO ABERTO','Registra os valores, realizáveis após o término do exercício seguinte, de títulos públicos - mercado aberto.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.02','AÇÕES','Registra os valores, realizáveis após o término do exercício seguinte, de ações representativas das participações dos órgãos e entidades no capital das sociedades por ações havidas por aquisições, subscrições, bonificações e doações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.03','FUNDO DE APLICAÇÕES EM COTAS - RENDA VARIÁVEL','Registra os valores, realizáveis após o término do exercício seguinte, aplicados em fundos de aplicações em cotas - renda variável.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.01.99','OUTROS TÍTULOS E VALORES MOBILIÁRIOS','Registra os valores, realizáveis após o término do exercício seguinte, de outros títulos e valores mobiliários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.02.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreendem as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.02.01','APLICAÇÃO TEMPORÁRIA EM OURO','Registra as aplicações temporárias em ouro, realizáveis no longo prazo.','D','S ','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.02.02','APLICAÇÃO TEMPORÁRIA EM OUTROS METAIS PRECIOSOS','Registra as aplicações temporárias em outros metais preciosos, realizáveis no longo prazo.','D','S ','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.03.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Compreende os investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.01','(-) AJUSTE DE PERDAS COM TITULOS E VALORES MOBILIARIOS ','Registra os valores de ajustes para perdas em títulos e valores mobiliários a longo prazo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.02','(-) AJUSTE DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','Registra os valores de ajustes para perdas em aplicações em ouro e outros metais preciosos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.3.1.99.03','(-) AJUSTE DE PERDAS COM APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Registra os valores de ajustes para perdas em investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.0.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade para utilização própria ou para venda, previstos para período posterior ao término do exercício seguinte.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.00.00','ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.01.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.02.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.03.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento que não serão concluídos até o término do exercício subsequente a data do balanço patrimonial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.04.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas que será utilizado no processo produtivo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.05.00','MATÉRIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.06.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.07.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.98.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.4.1.99.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro de perdas estimadas para os estoque que tiverem o valor de mercado inferior ao seu custo. Conta a ser utilizada apenas para os estoques classificados no ativo realizável a longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço à entidade ocorrerão no longo prazo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.01.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.02.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos a título de VPD financeiras a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.03.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.04.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.05.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.06.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.07.00','BENEFÍCIOS A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.1.9.1.99.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.0.0.00.00','INVESTIMENTOS','Compreende as participações permanentes em outras sociedades, bem como os bens e direitos não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção da atividade da entidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.0.00.00','PARTICIPAÇÕES PERMANENTES','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS ','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na Aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.1.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS ','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.2.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS ','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.3.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS ','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.4.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.01','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS','Registra as participações permanentes do ente em sociedades controladas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.02','PARTICIPAÇÕES EM SOCIEDADES CONTROLADAS EM CONJUNTO','Registra as participações permanentes do ente em sociedades controladas em conjunto, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.03','PARTICIPAÇÕES EM SOCIEDADES COLIGADAS','Registra as participações permanentes do ente em sociedades coligadas, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.04','MAIS-VALIA SOBRE OS ATIVOS DAS INVESTIDAS','Registra a diferença entre o valor do percentual adquirido do valor justo dos ativos líquidos da investida e o valor do percentual adquirido do valor do patrimônio líquido da investida.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.05','ÁGIO SOBRE OS INVESTIMENTOS','Registra a diferença entre o valor pago pela participação adquirida e o valor do percentual adquirido do valor justo dos ativos líquidos da investida','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.06','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Registra os valores repassados pelo ente, destinados a serem utilizados para aumento de capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.07','PARTICIPAÇÃO EM CONSÓRCIOS PÚBLICOS ','Registra as participações permanentes do ente em consórcios públicos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.08','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.09','PARTICIPAÇÃO EM OUTRAS SOCIEDADES AVALIDAS POR EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes do ente em outras sociedades, avaliadas por equivalência patrimonial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.95','OUTRAS PARTICIPAÇÕES - MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.96','ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Ágio na Aquisição de Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.97','(-) AMORTIZAÇÃO DE ÁGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de Ágio na Aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.98','(-) DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.01.99','AMORTIZAÇÃO DE DESAGIO NA AQUISIÇÃO DE PARTICIPAÇÕES AVALIADAS PELO MEP','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial - Amortização de deságio na aquisição de Participações.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Compreende as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.01','PARTICIPAÇÕES EM OUTRAS SOCIEDADES','Registra as participações permanentes do ente em outras sociedades em forma de ações ou cotas, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.03','PARTICIPAÇÃO EM FUNDOS','Registra as participações permanentes do ente em fundos, avaliadas pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.05','PARTICIPAÇÕES EM ORGANISMOS INTERNACIONAIS','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Participação em Organismos Internacionais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.06','ADIANTAMENTO PARA AUMENTO DE CAPITAL','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Adiantamento para aumento de Capital.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.1.5.02.99','OUTRAS PARTICICAÇÕES','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo - Outras Participações.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.0.00.00','PROPRIEDADES PARA INVESTIMENTO','Compreende a propriedade (terreno ou edifício – ou parte de edifício – ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','Compreende a propriedade (terreno ou edifício – ou parte de edifício – ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.01.00','BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','Compreende os valores de imóveis da unidade mantidos para futura utilização.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.01.01','TERRENOS','Registra os terrenos de propriedade do ente não destinados ao uso do mesmo nas suas atividades fins, avaliados pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.01.02','EDIFÍCIOS','Registra os edifícios ou parte deles, ou casas, de propriedade do ente não destinados ao uso do mesmo nas suas atividades fins, avaliados pelo custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.02.00','BENS IMOVEIS NÃO DESTINADOS A USO','Compreende os valores de imóveis da unidade mantidos para geração de renda.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.02.01','TERRENOS','Registra os valores de terrenos da unidade mantidos para geração de renda.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.02.02','EDIFÍCIOS','Registra os valores de edifícios da unidade mantidos para geração de renda.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.2.1.99.00','OUTRAS PROPRIEDADES PARA INVESTIMENTOS','Registra as outras propriedades para investimentos não abrangidas nas contas anteriores, avaliadas pelo método do custo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.0.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.01.00','TITULOS E VALORES MOBILIÁRIOS - RPPS','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social em títulos e valores mobiliários .','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.01.01','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO - TÍTULOS E VALORES','Registra os investimentos realizados pelo Regime Próprio da Previdência Social em títulos e valores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.01.02','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN - TÍTULOS E VALORES','Registra os investimentos realizados pelo Regime Próprio da Previdência Social em aplicações em ativos não sujeitos à Resolução do CMN-Títulos e Valores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.02.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS - RPPS','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social em aplicações em segmentos de imóveis.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.3.1.02.01','IMÓVEIS – RPPS','Registra os investimentos realizados pelo Regime Próprio da Previdência Social em imóveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.0.00.00','DEMAIS INVESTIMENTOS PERMANENTES','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.01.00','OBRAS DE ARTE E OUTROS BENS SINGULARES','Registra os valores provenientes de Obras de Arte e outros bens singulares, tais como jóias, antiguidades, moedas sem valor liberatório e etc.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.02.00','TÍTULOS E VALORES MOBILIÁRIOS PERMANENTE','Registra o valor dos Títulos e Valores Mobiliários não classificáveis no Ativo Circulante nem no Ativo Realizável a Longo Prazo, com por exemplo as Debêntures (Perpetuas).','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.03.00','BENS MOVEIS NÃO DESTINADOS A USO','Registra os valores de Bens Moveis da Unidade mantidos para geração de renda.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.04.00','BENS INTANGIVEIS NÃO DESTINADOS A USO','Registra o valor de Bens Intangíveis não destinados ao Uso e que a Unidade não explore comercialmente.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.7.1.99.00','DEMAIS INVESTIMENTOS PERMANENTES','Registra o valor de Investimentos Permanentes, não classificáveis nas demais contas deste Plano.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.0.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS – CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das propriedades mantidas para investimento.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.01.01','DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, dOS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA FUTURA UTILIZACAO.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.01.02','DEPRECIAÇÃO ACUMULADA DE BENS IMOVEIS NÃO DESTINADOS A USO','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, dOS VALORES DE IMOVEIS DA UNIDADE MANTIDOS PARA GERACAO DE RENDA.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.8.1.01.99','DEPRECIAÇÃO ACUMULADA OUTRAS PROPRIEDADES PARA INVESTIMENTOS','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das outras propriedades mantidas para investimento.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Compreende os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.01.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra o valor da redução ao valor recuperável das participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.01.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra o valor da redução ao valor recuperável das participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Compreende os valores de ajuste ao valor recuperável de propriedades para investimento, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.02.01','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMÓVEIS PARA FUTURA UTILIZAÇÃO','Registra o valor da redução ao valor recuperável de imóveis da unidade mantidos para futura utilização.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.02.02','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE BENS IMOVEIS NÃO DESTINADOS A USO','Registra o valor da redução ao valor recuperável de imóveis da unidade mantidos para geração de renda.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','Compreende os valores de ajuste ao valor recuperável de investimentos do RPPS, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.1.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Compreende os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.2.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.2.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Compreende os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.2.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Compreende os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.3.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.3.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Compreende os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.3.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Compreende os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.4.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.4.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Compreende os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.4.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.5.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.5.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Compreende os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.2.9.5.04.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Compreende os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.0.0.00.00','IMOBILIZADO','Compreende os direitos que tenham por objeto bens corpóreos destinados a manutenção das atividades da entidade ou exercidos com essa finalidade, inclusive os decorrentes de operações que transfiram a ela os benefícios, os riscos e o controle desses bens.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.0.00.00','BENS MOVEIS','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.00.00','BENS MOVEIS- CONSOLIDAÇÃO','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.00','MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Compreende o valor da aquisição ou incorporação de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.01','APARELHOS DE MEDIÇÃO E ORIENTAÇÃO','Registra os aparelhos utilizados para medição e orientação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.02','APARELHOS E EQUIPAMENTOS DE COMUNICAÇÃO','Registra os aparelhos e equipamentos utilizados para comunicação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.03','APARELHOS, EQUIPAMENTOS E UTENSÍLIOS MÉDICOS, ODONTOLÓGICOS, LABORATORIAIS E HOSPITALARES ','Registra os aparelhos, equipamentos e utensílios para uso médico, odontológico, laboratorial e hospitalar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.04','APARELHOS E EQUIPAMENTOS PARA ESPORTES E DIVERSÕES','Registra os aparelhos e equipamentos utilizados para modalidades de esportes e diversões.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.05','EQUIPAMENTO DE PROTEÇÃO, SEGURANÇA E SOCORRO','Registra os equipamentos utilizados para proteção, segurança e socorro.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.06','MÁQUINAS E EQUIPAMENTOS INDUSTRIAIS','Registra as máquinas e equipamentos de natureza industrial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.07','MÁQUINAS E EQUIPAMENTOS ENERGÉTICOS','Registra as máquinas e equipamentos energéticos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.08','MÁQUINAS E EQUIPAMENTOS GRÁFICOS','Registra as máquinas e equipamentos empregados na indústria gráfica ou necessários para sua industrialização.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.09','MÁQUINAS, FERRAMENTAS E UTENSÍLIOS DE OFICINA','Registra as máquinas, ferramentas ou utensílios utilizados em oficinas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.10','EQUIPAMENTOS DE MONTARIA','Registra os equipamentos utilizados em montarias, bem como os serviços correlacionados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.11','EQUIPAMENTOS E MATERIAL SIGILOSO E RESERVADO','Registra os equipamentos e materiais utilizados em atividades de caráter sigiloso ou reservado.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.12','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS PARA AUTOMÓVEIS','Registra os equipamentos, peças e acessórios para automóveis que podem ser desincorporados, sem prejuízo dos mesmos, para aplicação em outros veículos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.13','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS MARÍTIMOS','Registra os equipamentos, peças e acessórios marítimos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.14','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS AERONÁUTICOS','Registra os equipamentos, peças e acessórios aeronáuticos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.15','EQUIPAMENTOS, PEÇAS E ACESSÓRIOS DE PROTEÇÃO AO VOO','Registra os equipamentos, peças e acessórios de proteção de voo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.16','EQUIPAMENTOS DE MERGULHO E SALVAMENTO','Registra os equipamentos de mergulho e salvamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.17','EQUIPAMENTOS DE MANOBRAS E PATRULHAMENTO','Registra os equipamentos destinados ao exercício militar, serviço de bordo, guarnições, rondas ou vigilância utilizados pela unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.18','EQUIPAMENTOS DE PROTEÇÃO E VIGILÂNCIA AMBIENTAL','Registra os equipamentos utilizados em sistemas de proteção e vigilância aérea e ambiental.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.19','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS AGROPECUÁRIOS ','Registra os valores relativos a máquinas, equipamentos, ferramentas e utensílios agropecuários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.20','MÁQUINAS, EQUIPAMENTOS E UTENSÍLIOS RODOVIÁRIOS ','Registra os valores relativos a máquinas, equipamentos, ferramentas e utensílios rodoviários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.21','EQUIPAMENTOS HIDRÁULICOS E ELÉTRICOS','Registra os equipamentos hidráulicos e elétricos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.01.99','OUTRAS MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra os valores referentes a máquinas, aparelhos, equipamentos e ferramentas não classificados em contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.00','BENS DE INFORMÁTICA','Compreende o valor da aquisição ou incorporação de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.01','EQUIPAMENTOS DE PROCESSAMENTO DE DADOS','Registra os equipamentos de centro de processamento de dados/data center, como servidores e equipamentos de armazenamento e rede.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.02','EQUIPAMENTOS DE TECNOLOGIA DA INFORMAÇÃO','Registra os equipamentos relacionados com tecnologia da informação, como estações de trabalho, impressoras e periféricos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.02.03','SISTEMAS APLICATIVOS - SOFTWARES','Registra o valor dos softwares adquiridos ou desenvolvidos pela empresa que seja inerente e essencial para o funcionamento do computador e que não sejam classificados juntos a esse.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.00','MÓVEIS E UTENSÍLIOS','Compreende o valor da aquisição ou incorporação de mobiliário em geral e utensílios, entre outros.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.01','APARELHOS E UTENSÍLIOS DOMÉSTICOS','Registra os objetos ou peças de uso caseiro ou necessários a vida familiar.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.02','MÁQUINAS E UTENSÍLIOS DE ESCRITÓRIO','Registra as máquinas e utensílios de escritório.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.03','MOBILIÁRIO EM GERAL','Registra os valores relativos aos bens móveis, de caráter geral, em uso na unidade, não classificados em contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.03.04','UTENSÍLIOS EM GERAL','Registra os valores relativos a utensílios, de caráter geral, em uso na unidade, não classificados em contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Compreende o valor da aquisição ou incorporação de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.01','BANDEIRAS, FLÂMULAS E INSÍGNIAS','Registra os valores relativos a bandeiras, flâmulas e insígnias, geralmente utilizadas como distintivo da nação e de corporações, pequenas chamas, adornos, sinal distintivo, emblemas, estandartes e outros símbolos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.02','COLEÇÕES E MATERIAIS BIBLIOGRÁFICOS','Registra os valores relativos aos objetos e materiais bibliográficos destinados a reunir, geralmente, para formação de bibliotecas de uso da unidade ou cumprir objetivos dessa.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.03','DISCOTECAS E FILMOTECAS','Registra os valores relativos a discos, CDs e coleções de fitas gravadas com músicas e fitas cinematográficas de caráter educativo, científico e informativo.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.04','INSTRUMENTOS MUSICAIS E ARTÍSTICOS','Registra os valores relativos aos instrumentos musicais e artísticos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.05','EQUIPAMENTOS PARA ÁUDIO, VÍDEO E FOTO','Registra os valores de equipamentos de áudio, vídeo e foto.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.06','OBRAS DE ARTE E PEÇAS PARA EXPOSIÇÃO','Registra os valores relativos a obras e objetos de arte e de peças para decoração ou exposição em geral em museus, galerias, halls, prédios públicos e outros, desde que se destinem a manutenção de sua atividade, caso contrário, deve ser classificado como investimentos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.04.99','OUTROS MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra os valores referentes a materiais culturais, educacionais e de comunicação não classificados em contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.00','VEÍCULOS','Compreende o valor da aquisição ou incorporação de meios de transportes aéreos, aquáticos e terrestres, entre outros.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.01','VEÍCULOS EM GERAL','Registra os veículos de diversos tipos, não motorizados, para os quais não tenham sido criadas contas específicas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.02','VEÍCULOS FERROVIÁRIOS','Registra os veículos destinados ao tráfego por via férrea e para usos diversos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.03','VEÍCULOS DE TRAÇÃO MECÂNICA','Registra os veículos de tração mecânica.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.04','CARROS DE COMBATE','Registra os carros de combate, tais como carro-tanque, auto-choque e assemelhados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.05','AERONAVES','Registra os veículos destinados ao tráfego aéreo, geralmente de uso comercial, no transporte de passageiros e cargas ou para treinamento, defesa e ataque militar, bem como outras atividades.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.05.06','EMBARCAÇÕES','Registra as embarcações adquiridas ou construídas e destinadas a navegação por vias marítimas, fluviais e outras vias navegáveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.06.00','PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra o valor da aquisição ou incorporação de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.00','BENS MÓVEIS EM ANDAMENTO','Compreende os valores de bens móveis em andamento.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.01','BENS MÓVEIS EM ELABORACÃO','Registra os valores relativos a todos os gastos ocorridos com bens móveis em fase de elaboração e acabamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.02','IMPORTAÇÕES EM ANDAMENTO','Registra os valores relativos a todos os gastos com importações em andamento de equipamentos, máquinas, aparelhos e outros bens móveis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.07.04','ALMOXARIFADO DE MATERIAIS A SEREM APLICADOS EM BENS EM ANDAMENTO','Registra todos os materiais e bens da empresa destinados a aplicação na elaboração de bens móveis em andamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.00','BENS MÓVEIS EM ALMOXARIFADO','Compreende os valores de bens permanentes a serem estocados em almoxarifado.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.01','ESTOQUE INTERNO','Registra os valores dos bens móveis adquiridos e estocados em almoxarifado, destinados a atender as necessidades dos órgãos adquirentes.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.03','BENS MÓVEIS A REPARAR','Registra os valores dos bens móveis que necessitam de reparos ou reformas, estocados em almoxarifado.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.08.05','BENS MÓVEIS INSERVÍVEIS','Registra os valores dos bens móveis inservíveis em almoxarifado, que dependem de parecer da comissão e homologação da autoridade competente para serem descarregados.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.09.00','ARMAMENTOS','Registra os valores de armas que constituem objetos de defesa ou preparativos de guerra.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.10.00','SEMOVENTES','Registra os valores relativos aos animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.00','DEMAIS BENS MÓVEIS','Compreende o valor da aquisição ou incorporação dos demais bens móveis não classificados em grupos específicos.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.01','BENS MÓVEIS A ALIENAR','Representa os registros dos valores relativos aos bens móveis que, por algum motivo, foram destinados a alienação, mediante venda, permuta ou doação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.02','BENS EM PODER DE OUTRA UNIDADE OU TERCEIROS ','Registra os valores de bens móveis de propriedade da unidade cedente, entregues a outra unidade ou terceiros por meio de convênio, comodato ou outras formas de empréstimo, distribuição ou transferência.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.08','BENS MÓVEIS A CLASSIFICAR','Registra os bens móveis pendentes de classificação e de identificação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.1.1.99.99','OUTROS BENS MÓVEIS','Registra o valor da aquisição ou incorporação dos outros bens móveis não podem classificados nas contas anteriores.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.0.00.00','BENS IMÓVEIS','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.00.00','BENS IMOVEIS- CONSOLIDAÇÃO','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.00','BENS DE USO ESPECIAL','Compreende os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.01','IMÓVEIS RESIDENCIAIS','Registra os valores relativos aos imóveis residenciais dos estados ou municípios, como apartamentos; casas; residenciais; conjuntos. Os imóveis funcionais, os próprios residenciais e as vilas militares devem ser registrados nessa conta.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.02','IMÓVEIS COMERCIAIS','Registra os valores relativos aos imóveis comerciais dos estados ou municípios, como conjuntos; salas; e lojas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.03','EDIFÍCIOS','Registra os valores relativos aos seguintes imóveis dos estados ou municípios nas seguintes categorias: edifícios, prédios; conventos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.04','TERRENOS/GLEBAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: terrenos e glebas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.05','ARMAZÉNS/GALPÕES','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: armazéns e galpões.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.06','AQUARTELAMENTOS','Registra os valores relativos aos seguintes imóveis da união, estados e municípios nas seguintes categorias: bases; quartéis; fortes.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.07','AEROPORTOS/ESTAÇÕES/AERÓDROMOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: aeródromo; aeroporto; estação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.08','IMÓVEIS DE USO EDUCACIONAL','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: escolas; faculdades; universidades; bibliotecas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.09','REPRESAS/AÇUDES','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: açudes; represas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.10','FAZENDAS, PARQUES E RESERVAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: fazendas; parques; reservas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.11','IMÓVEIS DE USO RECREATIVO','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem nas seguintes categorias: clubes; estádios; teatros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.12','FARÓIS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: faróis (faroletes). Os instrumentos de auxílio a navegação aérea também devem ser registrados nesta conta.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.13','MUSEUS/PALÁCIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: museus; palácios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.14','LABORATÓRIOS/OBSERVATÓRIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem nas seguintes categorias: laboratórios; observatórios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.15','HOSPITAIS E UNIDADES DE SAÚDE','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: hospitais e unidades de saúde.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.16','HOTÉIS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: hotéis.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.17','PRESÍDIOS/DELEGACIAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: presídios; delegacias.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.18','PORTOS/ESTALEIROS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: estaleiros; portos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.19','COMPLEXOS/FÁBRICAS/USINAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: fábricas; usinas; complexos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.20','CEMITÉRIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: cemitérios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.21','ESTACIONAMENTOS E GARAGENS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: estacionamentos. Também devem ser registrados nesta conta as garagens.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.22','POSTOS DE FISCALIZAÇÃO','Registra os valores relativos aos seguintes imóveis dos estados e municípios: postos policiais. Também devem ser registrados nessa conta os demais postos de fiscalização.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.01.98','OUTROS BENS IMÓVEIS DE USO ESPECIAL','Registra os valores relativos aos seguintes imóveis dos estados e municípios que não se enquadrem em nenhuma outra categoria.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.00','BENS DOMINICAIS','Compreende os bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.01','EDIFÍCIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem nas seguintes categorias: edifícios; prédios; conventos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.02','APARTAMENTOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: apartamentos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.03','ARMAZÉNS ','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: armazéns.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.04','CASAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: casas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.05','CEMITÉRIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: cemitérios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.06','EDIFÍCIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: edifícios.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.07','GARAGENS E ESTACIONAMENTOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: garagens e estacionamentos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.08','FAZENDAS ','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: fazendas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.09','GALPÕES','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: galpões.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.10','GLEBAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.11','LOJAS ','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lojas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.12','SALAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: salas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.13','TERRENOS ','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: terrenos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.14','LOTES','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lotes.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.15','LOTES INDUSTRIAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lotes industriais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.16','GLEBAS URBANAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas urbanas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.17','GLEBAS URBANIZADAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas urbanizadas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.18','GLEBAS RURAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas rurais.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.04.99','OUTROS BENS DOMINICAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que não se enquadrem em outras categorias.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.00','BENS DE USO COMUM DO POVO','Compreende os bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.01','RUAS','Registra os valores de ruas que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.02','PRAÇAS','Registra os valores de praças que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.03','ESTRADAS','Registra os valores de estradas que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.04','PONTES','Registra os valores de pontes que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.05','VIADUTOS','Registra os valores de viadutos que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.06','SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA','Registra os valores de SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.07','SISTEMAS DE ABASTECIMETNO DE ENERGIA','Registra os valores de SISTEMAS DE ABASTECIMETNO DE ENERGIA que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.08','REDES DE TELECOMUNICAÇÕES','Registra os valores de REDES DE TELECOMUNICAÇÕES que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.09','BENS DO PATRIMONIO CULTURAL','Bens com significancia histórica, cultural ou ambiental tais como monumentos e prédios históricos, sítios arqueológicos, área de conservação e reservas naturais e obras de arte, quando passíveis de mensuração e avaliação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.05.99','OUTROS BENS DE USO COMUM DO POVO','Registra os valores bens de uso comum, não classificados anteriormente neste plano de contas, que foram adquiridos, produzidos ou construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.00','BENS IMÓVEIS EM ANDAMENTO','Compreende os valores de bens imóveis em andamento.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.01','OBRAS EM ANDAMENTO','Registra os valores pertinentes a obras, desde sua construção até o término da mesma.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.06.05','ESTUDOS E PROJETOS','Registra os valores relativos a estudos e projetos, englobando limpeza do terreno, serviços topográficos, sondagens de reconhecimento, terraplenagem, drenagens, instalações provisórias como galpões, instalações elétricas e hidráulicas, utilizadas durante as obras.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.07.00','INSTALAÇÕES','Registra equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.08.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.00','DEMAIS BENS IMÓVEIS','Compreende os demais bens imóveis não classificados anteriormente nesse plano de contas.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.01','BENS IMÓVEIS LOCADOS PARA TERCEIROS','Registra os bens imóveis locados para terceiros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.02','IMÓVEIS EM PODER DE TERCEIROS','Registra os imóveis concedidos a terceiros a título de empréstimo gratuito com prazo de devolução convencionado.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.03','MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMÓVEIS ','Registra os materiais provisoriamente separados de um imóvel, para nele se reempregarem.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.05','BENS IMÓVEIS A CLASSIFICAR','Registra os bens imóveis, cuja classificação esteja pendente por algum motivo, geralmente por falta de identificação ou pendência de legalização ou registro.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.06','BENS IMÓVEIS A ALIENAR','Registra os valores relativos aos bens imóveis separados para alienação, quando considerados desnecessários, inservíveis ou por decisão administrativa da unidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.2.1.99.99','OUTROS BENS IMÓVEIS','Registra os valores relativos a outros bens imóveis, para os quais não tenham sido criadas contas próprias ou específicas neste plano de contas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.0.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.00','(-) DEPRECIAÇÃO ACUMULADA – BENS MÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.01','DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a depreciação acumulada de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.02','DEPRECIAÇÃO ACUMULADA DE BENS DE INFORMÁTICA','Registra a depreciação acumulada de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.03','DEPRECIAÇÃO ACUMULADA DE MÓVEIS E UTENSÍLIOS','Registra a depreciação acumulada de mobiliário em geral e utensílios, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.04','DEPRECIAÇÃO ACUMULADA DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a depreciação acumulada de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.05','DEPRECIAÇÃO ACUMULADA DE VEÍCULOS','Registra a depreciação acumulada de transportes aéreos, aquáticos e terrestres, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.06','DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a depreciação acumulada de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.07','DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO','Registra a depreciação acumulada de bens móveis em andamento.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.08','DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ALMOXARIFADO','Registra a depreciação acumulada de bens permanentes a serem estocados em almoxarifado.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.09','DEPRECIAÇÃO ACUMULADA DE ARMAMENTOS','Registra a depreciação acumulada de armas que constituem objetos de defesa ou preparativos de guerra.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.10','DEPRECIAÇÃO ACUMULADA DE SEMOVENTES','Registra a depreciação acumulada de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.01.99','DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS','Registra a depreciação acumulada de demais bens móveis não classificados em grupos específicos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.00','(-) DEPRECIAÇÃO ACUMULADA – BENS IMÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.01','DEPRECIAÇÃO ACUMULADA DE BENS DE USO ESPECIAL','Registra a depreciação acumulada de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.02','DEPRECIAÇÃO ACUMULADA DE BENS DOMINICAIS','Registra a depreciação acumulada de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.03','DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO','Registra a depreciação acumulada de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.04','DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS EM ANDAMENTO','Registra a depreciação acumulada de valores de bens imóveis em andamento.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.05','DEPRECIAÇÃO ACUMULADA DE INSTALAÇÕES','Registra a depreciação acumulada de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.06','DEPRECIAÇÃO ACUMULADA DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a depreciação acumulada de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.02.99','DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS IMÓVEIS','Registra a depreciação acumulada de os demais bens imóveis não classificados anteriormente nesse plano de contas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.03.00','(-) EXAUSTÃO ACUMULADA – BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.04.00','(-) EXAUSTÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.05.00','(-) AMORTIZAÇÃO ACUMULADA – BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.8.1.06.00','(-) AMORTIZAÇÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens Imóveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MOVEIS','Compreende os valores de ajuste ao valor recuperável de bens moveis, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.01','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra os valores de ajuste ao valor recuperável de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','Registra os valores de ajuste ao valor recuperável de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.03','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','Registra os valores de ajuste ao valor recuperável de mobiliário em geral e utensílios, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.04','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra os valores de ajuste ao valor recuperável de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.05','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','Registra os valores de ajuste ao valor recuperável de transportes aéreos, aquáticos e terrestres, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.06','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra os valores de ajuste ao valor recuperável de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.07','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','Registra os valores de ajuste ao valor recuperável de bens móveis em andamento.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.08','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','Registra os valores de ajuste ao valor recuperável de bens permanentes a serem estocados em almoxarifado.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.09','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','Registra os valores de ajuste ao valor recuperável de armas que constituem objetos de defesa ou preparativos de guerra.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.10','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','Registra os valores de ajuste ao valor recuperável de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.01.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','Registra os valores de ajuste ao valor recuperável de demais bens móveis não classificados em grupos específicos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','Compreende os valores de ajuste ao valor recuperável de bens imóveis, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.01','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','Registra os valores de ajuste ao valor recuperável de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','Registra os valores de ajuste ao valor recuperável de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.03','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','Registra os valores de ajuste ao valor recuperável de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.04','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','Registra os valores de ajuste ao valor recuperável de valores de bens imóveis em andamento.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.05','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','Registra os valores de ajuste ao valor recuperável de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.06','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra os valores de ajuste ao valor recuperável de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.3.9.1.02.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','Registra os valores de ajuste ao valor recuperável de os demais bens imóveis não classificados anteriormente nesse plano de contas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.0.0.00.00','INTANGÍVEL','Compreende os direitos que tenham por objeto bens incorpóreos destinados a manutenção da entidade ou exercidos com essa finalidade.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.1.0.00.00','SOFTWARES','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.1.1.00.00','SOFTWARES- CONSOLIDAÇÃO','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.1.1.01.00','SOFTWARES','Registra os valores dos softwares pertencentes ao órgão, englobando os valores referentes à construção, implementação e instalação do programa.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.1.1.02.00','SOFTWARES EM DESENVOLVIMENTO','Registra os valores apropriados na fase de desenvolvimento do software, de acordo com a nota técnica específica para o tema.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.0.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação e direitos autorais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.00.00','MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS- CONSOLIDAÇÃO','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação, direitos autorais e direitos sobre recursos naturais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.01.00','MARCAS E PATENTES INDUSTRIAIS','Registra os valores relativos a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, além de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fábricação (tecnologia).','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.02.00','CONCESSÃO DE DIREITO DE USO DE COMUNICAÇÃO','Registra os valores relativos a bens intangíveis representados pela concessão de direito de uso de comunicação e divulgação.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.03.00','DIREITOS AUTORAIS ','Registra os valores relativos aos direitos autorais adquiridos pela entidade.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.04.00','DIREITOS SOBRE RECURSOS NATURAIS','Registra os valores relativos aos direitos obtidos por legislação e/ou por compras de direitos de reservas ou de exploração de recursos naturais, tais como jazidas e outros.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.05.00','ADIANTAMENTO PARA TRANFERÊNCIA DE TECNOLOGIA','Registra todos os adiantamentos a fornecedores vinculados a um contrato de transferencia de tecnologia. Representam pagamentos por conta de um valor previamente contratado.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.2.1.99.00','OUTROS DIREITOS - BENS INTANGÍVEIS','Registra os valores relativos a outros direitos, classificados como bens intangíveis, cuja classificação não esteja definida em contas específicas.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.3.0.00.00','DIREITO DE USO DE IMÓVEIS','Compreende os valores pertinentes a bens intangíveis representados pela aquisição do direito de uso de imóveis.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.3.1.00.00','DIREITO DE USO DE IMOVEIS- CONSOLIDAÇÃO','Compreende os valores pertinentes a bens intangíveis representados pela aquisição de direito de uso de imóveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.0.00.00','(-) AMORTIZAÇÃO ACUMULADA','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.01.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','Registra a diminuição do valor do capital aplicado em softwares, pertencentes ao ativo intangível.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.02.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATÉNTES','Registra a diminuição do valor do capital aplicado em marcas, direitos e patentes, pertencentes ao ativo intangível.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.8.1.03.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','Registra a diminuição do valor do capital aplicado em direito de uso de imóveis, pertencentes ao ativo intangível.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.0.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.01.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','Registra os valores de ajuste ao valor recuperável do software pertencente ao ativo intangível, quando esse for inferior ao valor liquido contábil.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.02.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATÉNTES','Registra os valores de ajuste ao valor recuperável das marcas, direitos e patentes, quando esse for inferior ao valor liquido contábil.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '1.2.4.9.1.03.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','Registra os valores de ajuste ao valor recuperável de direito de uso, quando esse for inferior ao valor liquido contábil.','C','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.0.0.0.0.00.00','PASSIVO E PATRIMÔNIO LIQUIDO','Passivo compreende as obrigações existentes da entidade oriundas de eventos passados de cuja liquidação se espera que resulte em fluxo de saída de recursos que incorporem benefícios econômicos ou serviços em potencial. Patrimônio liquido compreende a diferença entre o ativo e o passivo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.0.0.0.00.00','PASSIVO CIRCULANTE','Compreende as obrigações conhecidas e estimadas que atendam a qualquer um dos seguintes critérios: tenham prazos estabelecidos ou esperados dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; tenham prazos estabelecidos ou esperados no curto prazo; sejam valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar, benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações , com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.0.00.00','PESSOAL A PAGAR','Compreende as obrigações a curto prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.00','PESSOAL A PAGAR DO EXERCÍCIO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas ao exercício atual.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.01','SALÁRIOS, REMUNERACOES E BENEFÍCIOS DO EXERCÍCIO','Registra as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas ao exercício atual.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.02','DÉCIMO TERCEIRO SALÁRIO','Registra as obrigações referentes ao décimo terceiro salário, geralmente apropriadas na base de 1/12 do valor bruto da folha de pagamento da unidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.03','FÉRIAS','Registra as obrigações referentes a férias, geralmente apropriadas como percentuais da folha de pagamento da unidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.04','LICENÇA- PRÊMIO','Registra os valores das obrigações constituídas com base em percentuais de salários, destinados ao pagamento de licença-prêmio.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.01.05','PARTICIPAÇÕES A EMPREGADOS','Registra os valores das obrigações do exercício constituídas para pagamento de participações a empregados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.02.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas a exercícios anteriores.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.02.01','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERC. ANTERIORES','Registra as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, relativas a exercicios anteriores.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.02.02','PARTICIPAÇÕES A EMPREGADOS - EXERC. ANTERIORES','Registra os valores das obrigações de exercícios anteriores constituídas para pagamento de participações a empregados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.00','PRECATORIOS DE PESSOAL','Compreende os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.01','PRECATORIOS DE PESSOAL DO EXERCÍCIO','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, do exercício.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.02','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - ANTES DE 05/05/2000','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, anteriores a 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.03','PRECATÓRIOS DE PESSOAL DE EXERC. ANTERIORES - A PARTIR DE 05/05/2000 ','Registra os valores de precatórios de obrigações referentes a salários ou remunerações, bem como a benefícios aos quais o empregado ou servidor tenha direito, de exercícios anteriores e a partir de 05/05/2000 (Lei de Responsabilidade Fiscal).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.1.1.03.04','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de pessoal do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a curto prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.1.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTRA OFSS','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.2.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.3.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - ESTADO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.4.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- INTER OFSS - MUNICÍPIO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.01.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS NO EXERCICIO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.02.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','REGISTRA AS OBRIGACOES REFERENTES A PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, INCORRIDAS EM EXERCICIOS ANTERIORES.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.03.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','COMPREENDE AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.03.01','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, DO EXERCICIO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.03.02','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES, ANTERIORES A 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.2.5.03.03','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGACOES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a curto prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO','REGISTRA AS OBRIGACOES RELATIVAS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL LIQUIDADOS NO EXERCICIO E AINDA NAO PAGOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.3.1.02.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a curto prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.07.00','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','Registra as obrigações relativas à entidades de previdência privada e complementar, inclusive à entidades de previdência privada e assitência médico-odontologica.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.08.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.1.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.04.01','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA DO ENTE','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA DE PESSOAL DO ENTE.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.05.00','PREVIDÊNCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.07.00','SALÁRIO EDUCAÇÃO','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES DAS EMPRESAS OU INSTITUIÇÕES, RESULTANTES DO CALCULO DO SALÁRIO EDUCAÇÃO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALÁRIOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.2.08.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.00','INSS A PAGAR','Compreende OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.02','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.04.02','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.05.00','PREVIDÊNCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.06.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.08.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.3.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.00','INSS A PAGAR','Compreende OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.02','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.04.02','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.05.00','PREVIDÊNCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.06.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.08.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.4.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.00','INSS A PAGAR','Compreende OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.01','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.02','INSS - DEBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.03','INSS - CONTRIBUIÇÃO SOBRE SERVIÇOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUIÇÕES INCIDENTES SOBRE SERVIÇOS PRESTADOS POR TERCEIROS OU CONTRIBUINTES AVULSOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.01.04','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.03.00','PSSS- CONTRIBUIÇÃO SOBRE VENCIMENTOS E VANTAGENS','REGISTRA OS VALORES RELATIVOS AS CONTRIBUICOES PATRONAIS PARA CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, CONFORME ARTS. 3 E 4 DA LEI Nº. 8.688 DE 21/07/93.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.04.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, NAO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.04.02','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.05.00','PREVIDÊNCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.06.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.08.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.1.4.5.98.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','Compreende as obrigações financeiras externas e internas da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS ','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS ','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.3.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS ','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.4.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.01','CONTRATOS DE EMPRÉSTIMOS INTERNOS ','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.05','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.1.5.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.0.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','Compreende os valores das operações de crédito externas decorrentes da emissão de títulos.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS  - EM CONTRATOS','Compreende os valores das operações de crédito externas decorrentes da emissão em contratos.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos a curto prazo - externo - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.0.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.3.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.4.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.3.5.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.0.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes de financiamentos externos a curto prazo.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos externos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos externos a curto prazo contraídos para o capital de giro.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos externos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.3.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.3.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.3.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.3.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.4.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos externos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos externos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.3.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.3.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFFS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.4.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.4.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APRORIAR – INTERNO – INTER OFSS – MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos externos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos externos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.0.0.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.0.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.01.00','FORNECEDORES NACIONAIS','Compreende os valores a pagar aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','Compreende as obrigações referentes a precatórios de fornecedores nacionais.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de fornecedores nacionais do exercicio.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – ANTERIORES A 05/5/2000','Registra os valores relativos a precatórios de contas a pagar a fornecedores nacionais de exercícios anteriores, anteriores a 05/05/2000 (lei de responsabilidde fiscal).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.02.03','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – A PARTIR DE 05/5/2000','Registra os valores relativos a precatórios de contas a pagar a fornecedores nacionais de exercícios anteriores, a partir de 05/05/2000 (lei de responsabilidde fiscal).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.02.04','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de fornecedores a pagar do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.00','CONTAS A PAGAR CREDORES NACIONAIS','Compreende os valores a pagar aos credores nacionais decorrentes do fornecimento de bens/materiais e da prestação de contas.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.01','CONTAS NÃO FINANCIADAS A PAGAR','Registra os valores não financiados, ou seja, em uma única parcela, de contas a pagar','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.02','CONTAS FINANCIADS A PAGAR','Registra os valores financiados de contas a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.03','PARCELAMENTO DE CONTAS A PAGAR','Registra o parcelamento de dívidas com contas a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.03.99','DEMAIS CONTAS A PAGAR','Registra os valores de demais contas a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','Compreende as obrigações referentes a precatórios de contas a pagar - credores nacionais.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.01','PRECATÓRIOS DE  CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','Registra as obrigações referentes a precatórios de contas a pagar a credores nacionais do exercício.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.02','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000 ','Registra os valores relativos a precatórios de contas a pagar a credores nacionais de exercícios anteriores, anteriores a 05/05/2000 (lei de responsabilidde fiscal).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.03','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','Registra os valores relativos a precatórios de contas a pagar a credores nacionais de exercícios anteriores, a partir de 05/05/2000 (lei de responsabilidde fiscal).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.1.1.04.04','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de contas a pagar do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.0.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos fornecedores estrangeiros de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.02.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos credores estrangeiros decorrentes do fornecimento de bens/materiais e da prestação de contas.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.02.01','CONTAS NÃO FINANCIADAS A PAGAR','Registra os valores não financiados, ou seja, em uma única parcela, de contas a pagar','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.02.02','CONTAS FINANCIADS A PAGAR','Registra os valores financiados de contas a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.02.03','PARCELAMENTO DE CONTAS A PAGAR','Registra o parcelamento de dívidas com contas a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.3.2.1.02.99','DEMAIS CONTAS A PAGAR','Registra os valores de demais contas a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.0.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.01.00','IPI A RECOLHER','Registra o valor das Obrigações Tributárias a Recolher referentes ao Imposto sobre Produtos Industrializados das Unidades Industriais ou com características dessas, geradas pelas vendas de produtos industriais e sujeiras a compensação com os créditos adquiridos por compras de matérias primas, em conformidade com a sistemática de apuração deste imposto.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.02.00','IRPJ A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Renda pessoa Jurídica.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.03.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de curto prazo relativos a diferenças intertemporais (Deliberação da CVM nº 273, de 20/08/98), correspondentes ao Imposto de Renda Pessoa Jurídica (IRPJ) e Contribuição Social sobre o Lucro Líquido (CSSL), bem como PIS/PASEP e Confins (Lei nº 9718 de 27/11/1998).J1402','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.04.00','IMPOSTO DE IMPORTAÇÃO A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto de Importação a Recolher.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.05.00','IOF A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre Operações Financeiras a Recolher.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.06.00','ITR A RECOLHER','Registra o valor das obrigações a recolher relativas ao Imposto sobre a Propriedade Territorial Rural (ITR).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.08.00','CIDE A RECOLHER','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS A CURTO PRAZO RELATIVAS A CONTRIBUICAO DE INTERVENCAO NO DOMINIO ECONOMICO (CIDE) (LEI Nº 10.168/2000).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.09.00','CSSL A RECOLHER','Registra o valor das Obrigações exigíveis a Curto Prazo relativas a Contribuição Social sobre o Lucro das Pessoas Jurídicas (CSSL).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.10.00','COFINS A RECOLHER','Registra o valor das obrigações exigíveis a curto prazo a recolher relativas à Contribuição para Financiamento da Seguridade Social (COFINS).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.11.00','PIS/PASEP A RECOLHER','Registra o valor das obrigações a recolher relativas ao Programa de Integração Social (PIS) e ao Programa de Formação do Servidor Público (PASEP).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.12.00','TRIBUTOS FEDERAIS RENEGOCIADOS ','Registra os valores exigíveis a curto prazo devidos pela entidade relativos a tributos federais que tenham sido renegociados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.13.00','RECURSOS FISCAIS - DARF A EMITIR','Registra o valor das Obrigações exigíveis a Curto Prazo a recolher relativas a Recursos Fiscais - DARF a Emitir.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os valores exigíveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao Tesouro Nacional, para os quais não haja conta específica.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.01.00','ICMS A RECOLHER','Compreende o valor das Obrigações exigíveis em Função das vendas de Mercadorias e Serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e prestação de Serviços (ICMS), Sujeitos a Compensações com os Créditos obtidos em Compras de Mercadorias e Serviços, Conforme sistemática de apuração deste Imposto ou sobre Mercadorias de Terceiros entregues para Depósito.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','Registra o valor das obrigações exigíveis em função das vendas de mercadorias e serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e Prestação de Serviços (ICMS), Sujeitas a Compensações com os créditos obtidos em compras de mercadorias e Serviços, conforme sistemática de apuração deste imposto.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','Registra o valor das Obrigações exigíveis em função da entrada de Mercadorias de Terceiros entregues a Unidade para deposito em Armazém.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.02.00','IPVA A RECOLHER','Registra o valor das obrigações exigíveis relativas ao Imposto sobre a Propriedade de Veículos Automotores (IPVA).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos relativos a Tributos que foram renegociados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','Registra o valor das obrigações junto ao Governo Estadual, referentes a taxa de cooperação e defesa da orizicultura - CDO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Atendimento Contra Incêndio.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Licenciamento Anual de Veículos, decorrente do serviço de licenciamento de veículos automotores.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.07.00','RECURSOS FISCAIS ESTADUAIS','Registra o valor das Obrigações junto ao Governo Estadual, referente a Recursos Fiscais Estaduais.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra o valor das Obrigações junto ao Governo Estadual, referente a Taxa de Licenciamento Ambiental.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a Curto prazo, decorrentes da incidência de tributos para os quais não haja contas especificas. Registra os valores exigíveis a Curto Prazo provenientes da Retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Estadual, para os quais não haja contas especificas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.01.00','ICMS A RECOLHER','Compreende o valor das Obrigações exigíveis em Função das vendas de Mercadorias e Serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e prestação de Serviços (ICMS), Sujeitos a Compensações com os Créditos obtidos em Compras de Mercadorias e Serviços, Conforme sistemática de apuração deste Imposto ou sobre Mercadorias de Terceiros entregues para Depósito.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.01.01','ICMS A RECOLHER – SOBRE MERCADORIAS PARA REVENDA','Registra o valor das obrigações exigíveis em função das vendas de mercadorias e serviços sobre os quais incida Imposto sobre a Circulação de Mercadorias e Prestação de Serviços (ICMS), Sujeitas a Compensações com os créditos obtidos em compras de mercadorias e Serviços, conforme sistemática de apuração deste imposto.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.01.02','ICMS A RECOLHER – SOBRE MERCADORIAS DE TERCEIROS PARA DEPÓSITO','Registra o valor das Obrigações exigíveis em função da entrada de Mercadorias de Terceiros entregues a Unidade para deposito em Armazém.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.02.00','IPVA A RECOLHER','Registra o valor das obrigações exigíveis relativas ao Imposto sobre a Propriedade de Veículos Automotores (IPVA).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.03.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos relativos a Tributos que foram renegociados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.04.00','TAXA DE COOPERAÇÃO E DEFESA DA ORIZICULTURA - CDO','Registra o valor das obrigações junto ao Governo Estadual, referentes a taxa de cooperação e defesa da orizicultura - CDO.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.05.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Atendimento Contra Incêndio.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.06.00','TAXA DE LICENCIAMENTO ANUAL DE VEÍCULOS','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Licenciamento Anual de Veículos, decorrente do serviço de licenciamento de veículos automotores.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.07.00','RECURSOS FISCAIS ESTADUAIS','Registra o valor das Obrigações junto ao Governo Estadual, referente a Recursos Fiscais Estaduais.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.08.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra o valor das Obrigações junto ao Governo Estadual, referente a Taxa de Licenciamento Ambiental.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.2.4.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a Curto prazo, decorrentes da incidência de tributos para os quais não haja contas especificas. Registra os valores exigíveis a Curto Prazo provenientes da Retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Estadual, para os quais não haja contas especificas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.0.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.01.00','ISS A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre Serviços de Qualquer Natureza (ISS) em que a própria Unidade seja a prestadora de serviço.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.02.00','IPTU/TLP A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre a Propriedade Predial e Territorial Urbana (IPTU) e Taxa de Limpeza Pública (TLP).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela unidade relativos a Tributos que foram renegociados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal referentes a Contribuição para Custeio de Iluminação Pública.(ART.149-A da Constituição Federal)','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.06.00','RECURSOS FISCAIS MUNICIPAIS','Registra os valores exigíveis a Curto Prazo provenientes de retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Municipal, por meio de documento de arrecadação (DAR).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Licenciamento Ambiental.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.08.00','TAXA DE INSPEÇÃO VEICULAR','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Inspeção Veicular.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a Curto Prazo, decorrentes da incidência de tributos para os quais não haja contas especificas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.01.00','ISS A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre Serviços de Qualquer Natureza (ISS) em que a própria Unidade seja a prestadora de serviço.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.02.00','IPTU/TLP A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal, relativas ao Imposto sobre a Propriedade Predial e Territorial Urbana (IPTU) e Taxa de Limpeza Pública (TLP).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.03.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela unidade relativos a Tributos que foram renegociados.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.04.00','CONTRIBUIÇÃO P/CUSTEIO DE ILUM. PUBLICA A RECOLHER','Registra o valor das Obrigações junto ao Governo Municipal referentes a Contribuição para Custeio de Iluminação Pública.(ART.149-A da Constituição Federal)','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.06.00','RECURSOS FISCAIS MUNICIPAIS','Registra os valores exigíveis a Curto Prazo provenientes de retenção de Tributos e Contribuições pelas entidades para posterior recolhimento ao Governo Municipal, por meio de documento de arrecadação (DAR).','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.07.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Licenciamento Ambiental.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.08.00','TAXA DE INSPEÇÃO VEICULAR','Registra os compromissos exigíveis a Curto Prazo, decorrentes da Taxa de Inspeção Veicular.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.4.3.5.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a Curto Prazo, decorrentes da incidência de tributos para os quais não haja contas especificas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.0.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.3.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.4.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.5.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.5.01.00','REPARTIÇÃO DA COTA DE ICMS ','Registra o valor da cota de ICMS arrecadado devida aos municípios.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.5.02.00','REPARTIÇÃO DA COTA DE IPVA','Registra o valor da cota de IPVA arrecadado devida aos municípios.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.5.03.00','REPARTIÇÃO DA COTA-PARTE DO IPI','Registra o valor da cota-parte do IPI que o estado recebe da União e deve repassar 25% aos respectivos municípios.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.5.0.5.99.00','REPARTIÇÃO DA COTA DE OUTROS TRIBUTOS/RECEITAS','Registra o valor da cota de outros tributos arrecadados ou de outras receitas devida aos municípios.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.0.0.00.00','PROVISÕES A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','Registra os valores das provisões constituídas visando o pagamento de indenizações trabalhistas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','Registra os valores das provisões constituídas visando o pagamento de dissídios coletivos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.0.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','Compreende os valores das provisões para pagamento de autos de infração já lavrados e que se encontram na esfera administrativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade ainda não apresentou recurso administrativo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade apresentou recurso administrativo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','Compreende os valores das provisões para pagamento de autuações fiscais que já se encontram na esfera judicial.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera juducial e que não estão em fase recursal.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera juducial em fase recursal.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','Registra os valores das provisões constituídas para o pagamento de indenizações cíveis.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','Registra os valores das provisões para pagamento de seguros referentes a sinistros a liquidar.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','Registra os valores das provisões para pagamento de seguros referentes a sinistros já cientificados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','Registra os valores das provisões para pagamento de seguros referentes a sinistros não cientificados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreente os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.5.01.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE ICMS ','Registra o valor da provisão para repartição da cota de ICMS reconhecida no lançamento por parte do agente arrecadador, a se repartido com os municípios. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a municípios.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.5.02.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE IPVA','Registra o valor da provisão para repartição da cota de IPVA reconhecida no lançamento por parte do agente arrecadador, a se repartido com os municípios. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a municípios.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.5.03.00','PROVISÃO PARA REPARTIÇÃO DA COTA-PARTE DO IPI','Registra o valor da provisão para repartição da cota parte do IPI reconhecida no lançamento por parte do agente arrecadador, a se repartido com os municípios. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a municípios.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.5.5.99.00','PROVISÃO PARA REPARTIÇÃO DA COTA DE OUTROS TRIBUTOS/RECEITAS','Registra o valor da provisão para repartição da cota parte de outros tributos reconhecida no lançamento por parte do agente arrecadador, a se repartido com os municípios. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a municípios.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.0.00.00','OUTRAS PROVISÕES A CURTO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo, não classificadas anteriormente neste plano de contas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.01.00','PROVISÃO PARA GARANTIAS','Registra os valores das provisões destinadas a cobrir despesas com a prestação de garantia relativas a produtos vendidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','Registra os valores das provisões destinadas a cobrir obrigações oriundas da venda ou extinção de uma linha de negócios, fechamento de fábricas ou locais de negócios, mudanças na estrututa da administração e reorganizações com efeito relevante na natureza e foco das operações da entidade.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.7.9.1.99.00','OUTRAS PROVISÕES A CURTO PRAZO','Registra os valores das provisões não classificáveis nas demais contas deste plano de contas.','C','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.0.0.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, com vencimento no curto prazo, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.0.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.1.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.3.1.XX.XX','ARRENDAMENTO OPERACIONAL A PAGAR','REGISTRA AS OBRIGAÇÕES A CURTO PRAZO REFERENTES A ARRENDAMENTOS MERCANTIS, NOS QUAIS NÃO SÃO TRANSFERIDOS AO ARRENDADOR OS RISCOS E BENEFÍCIOS INERENTES A PROPRIEDADE, NÃO HAVENDO A POSSIBILIDADE DE OPÇÃO DE COMPRA DO BEM ARRENDADO.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.01.00','DEBENTURES CONVERSIVEIS EM ACOES NO CURTO PRAZO','REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.02.00','DEBENTURES NAO-CONVERSIVEIS EM ACOES NO CURTO PRAZO','REGISTRA OS TITULOS EMITIDOS PELA ENTIDADE QUE CONFERIRAO AOS SEUS TITULARES DIREITO DE CREDITO CONTRA ELA, NAS CONDICOES CONSTANTES DA ESCRITURA DE EMISSAO DO TITULO E QUE NAO SAO CONVERSIVEIS EM ACOES, COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.96.00','AGIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE AGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS QUE SUPERA O DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.97.00','(-) DESAGIO NA EMISSAO DE DEBENTURES','REGISTRA OS VALORES DE DESAGIO NA EMISSAO DE DEBENTURES, QUE SAO OS VALORES RECEBIDOS INFERIORES AO VALOR DE RESGATE DESSES TITULOS NA DATA DO PROPRIO RECEBIMENTO OU DO VALOR FORMALMENTE ATRIBUIDO AS DEBENTURES.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.98.00','(-) CUSTO DA TRANSACAO A AMORTIZAR','REGISTRA OS CUSTOS DA TRANSACAO A AMORTIZAR, QUE SAO APENAS OS CUSTOS INCORRIDOS E DIRETAMENTE ATRIBUIVEIS AS ATIVIDADES NECESSARIAS EXCLUSIVAMENTE A CONSECUCAO DA TRANSACAO. POR EXEMPLO: TAXAS E COMISSOES. ENTRETANTO, NAO INCLUEM DESPESAS FINANCEIRAS, CUSTOS INTERNOS ADMINISTRATIVOS OU CUSTO DE CARREGAMENTO.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.4.1.99.00','OUTROS TITULOS','REGISTRA OUTROS TITULOS DE DIVIDA COM VENCIMENTO ATE O TERMINO DO EXERCICIO SEGUINTE.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.0.00.00','DIVIDENDOS A PAGAR','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.1.00.00','DIVIDENDOS A PAGAR- CONSOLIDAÇÃO','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.1.01.00','DIVIDENDOS A PAGAR - TESOURO ESTADUAL/MUNICIPAL','REGISTRA OS VALORES A SEREM PAGOS AO TESOURO ESTADUAL/MUNICIPAL A TITULO DE DIVIDENDOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.5.1.02.00','DIVIDENDOS A PAGAR - TERCEIROS','REGISTRA OS VALORES A SEREM PAGOS A TERCEIROS A TITULO DE DIVIDENDOS.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.0.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.00','CONSIGNACOES ','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES A SER RECOLHIDO AO RPPS DO SERVIDOR.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.02','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVIÇOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.03',' ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.05','INDENIZAÇÕES E RESTITUICOES','REGISTRA OS VALORES RELATIVOS AS INDENIZAÇÕES E RESTITUICOES DE TRIBUTOS COM AUTORIZAÇÕES CONCEDIDAS, POREM NÃO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUIÇÕES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.07',' ICMS ','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVIÇOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNAÇÕES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.08',' ISS ','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVIÇOS RETIDOS EM CONSIGNAÇÕES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUAÇÕES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.10','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.11','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.12','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.13','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.14','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUIÇÕES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.15','RETENCOES - EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERAÇÕES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.01.99','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.02.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.00','DEPOSITOS JUDICIAIS','COMPREENDE OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.00','DEPOSITOS NAO JUDICIAIS','COMPREENDE OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.01','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.02','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.03','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NÃO RECLAMADOS PELOS CREDORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERÊNCIAS DIVERSAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.05','DEPOSITOS A TRANSFERIR','REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.06','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.04.99','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.8.1.99.00','OUTROS VALORES RESTITUIVEIS','COMPREENDE OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.0.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.00','INDENIZACOES E RESTITUICOES','COMPREENDE AS OBRIGACOES RELATIVAS A INDENIZACOES E RESTITUICOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.01','INDENIZAÇÕES A SERVIDORES','REGISTRA O VALOR DAS DESPESAS A SEREM INDENIZADAS DECORRENTES DE LIQUIDACAO DE PAGAMENTOS EFETUADOS COM AUXÍLIO - ALIMENTACAO BEM COMO REEMBOLSOS DE GASTOS REALIZADOS PELOS SERVIDORES CUSTEADOS PELO PROGRAMA DE ASSISTENCIA A SAUDE E BENEFICIOS SOCIAIS DO ORGAO RESPONSAVEL.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.02','INDENIZAÇÕES E RESTITUICOES DIVERSAS DO EXERCICIO','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZAÇÕES E RESTITUICOES NO EXERCICIO.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.01.03','INDENIZAÇÕES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AS DIVERSAS INDENIZAÇÕES E RESTITUICOES DE EXERCICIOS ANTERIORES.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.02.00','DIARIAS A PAGAR','REGISTRA OS VALORES RELATIVOS AS DIARIAS A PAGAR.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.03.00','SUPRIMENTOS DE FUNDOS A PAGAR','REGISTRA OS VALORES RELATIVOS AOS SUPRIMENTOS DE FUNDOS A PAGAR.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.05.00','CONVENIOS A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE CONVENIO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.05.01','CONVENIOS A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS NO EXERCICIO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.05.02','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A CONVENIOS FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.09.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.09.01','TERMOS DE PARCERIA A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.09.02','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.10.00','TERMO DE COMPROMISSO A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.11.00','CONTRATOS DE GESTAO A PAGAR','REGISTRA AS OBRIGACOES RELATIVAS AOS CONTRATOS ENTRE A ADMINISTRACAO PUBLICA E A INICIATIVA PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.12.00','SUBVENCOES A PAGAR','REGISTRA O SOMATORIO DAS SUBVENCOES A PAGAR DE EXERCICIOS ANTERIORES.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.13.00','TRANSFERÊNCIAS ORCAMENTARIAS A LIBERAR ','REGISTRA OS COMPROMISSOS EXIGIVEIS PROVENIENTES DA APROPRIACAO DA DESPESA DE TRANSFERENCIA','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.1.14.00','CONSÓRCIOS A PAGAR','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DOS VALORES A REPASSAR A CONSÓRCIOS, EM ATENDIMENTO AO DISPOSTO NA PORTARIA STN 72/2012.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.1.8.9.2.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.0.0.0.00.00','PASSIVO NAO-CIRCULANTE','Compreende as obrigações conhecidas e estimadas que não atendam a nenhum dos critérios para serem classificadas no passivo circulante.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.0.0.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar, benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.0.00.00','PESSOAL A PAGAR','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.01.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS A VENCIMENTOS E VANTAGENS FIXAS E VARIAVEIS DEVIDAS AO SERVIDORES CIVIS E MILITARES, BEM COMO AS APOSENTADORIAS, REFORMAS E PENSOES, RELATIVAS A EXERCICIOS ANTERIORES.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.00','PRECATORIOS DE PESSOAL','COMPREENDE OS VALORES DE PRECATORIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.01','PRECATORIOS DE PESSOAL - REGIME ORDINÁRIO','REGISTRA OS VALORES DOS PRECATÓRIOS JUDICIAIS RELATIVOS AO REGIME ORDINÁRIO DE NATUREZA ALIMENTAR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.02','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  ANTERIORES  05/05/2000','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DE PRECATÓRIOS DE PESSOAL A PAGAR - ANTERIORES A 05/05/2000, EXIGÍVEIS A LONGO PRAZO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.03','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','REGISTRA OS VALORES DE PRECATORIOS DE OBRIGAÇÕES REFERENTES A SALÁRIOS OU REMUNERAÇÕES, BEM COMO A BENEFICIOS AOS QUAIS O EMPREGADO OU SERVIDOR TENHA DIREITO, DE EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.04','PRECATORIOS DE PESSOAL - REGIME ESPECIAL','REGISTRA OS VALORES DOS PRECATÓRIOS JUDICIAIS RELATIVOS AO REGIME ESPECIAL DE NATUREZA ALIMENTAR , INSTITUÍDO PELA EMENDA CONSTITUCIONAL 62/ 2009.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.1.1.02.05','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de pessoal do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.00','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS','COMPREENDE AS OBRIGAÇÕES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.01','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','REGISTRA OS VALORES DOS PRECATÓRIOS JUDICIAIS RELATIVOS AO REGIME ORDINÁRIO DE NATUREZA ALIMENTAR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.02','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS DE EXERCICIOS ANTERIORES -  ANTERIORES A 05/05/2000 ','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DE PRECATÓRIOS DE BENEFÍCIOS A PAGAR - ANTERIORES A 05/05/2000, EXIGÍVEIS A LONGO PRAZO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.03','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','REGISTRA AS OBRIGAÇÕES REFERENTES A PRECATORIOS DE PROVENTOS DE APOSENTADORIA, REFORMAS OU PENSOES E EXERCICIOS ANTERIORES E A PARTIR DE 05/05/2000 (LEI DE RESPONSABILIDADE FISCAL).','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.04','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','REGISTRA OS VALORES DOS PRECATÓRIOS JUDICIAIS RELATIVOS AO REGIME ESPECIAL DE NATUREZA ALIMENTAR , INSTITUÍDO PELA EMENDA CONSTITUCIONAL 62/ 2009.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.2.1.01.05','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de benefícios previdenciários do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.3.0.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.3.1.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.3.1.01.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES RELATIVOS AOS BENEFICIOS ASSISTENCIAIS ADMINISTRADOS PELA PREVIDENCIA SOCIAL, DE EXERCICIOS ANTERIORES.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.0.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.01.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.02.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','COMPREENREGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE CONTRIBUIÇÕES SOCIAIS','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.03.00','FGTS - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR DOS DÉBITOS PARCELADOS, REFERENTE AO NÃO RECOLHIMENTO DE FGTS','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.1.99.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICACAO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.01.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','COMPREENDE OS VALORES RELATIVOS AS OBRIGAÇÕES COM REGIMES PRÓPRIOS DE PREVIDENCIA, NÃO IDENTIFICADOS COMO PREVIDENCIA PRIVADA OU COMPLEMENTAR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.2.99.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICACAO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.01.00','INSS A PAGAR','COMPREENDE OS VALORES RELATIVOS AS CONTRIBUIÇÕES A PREVIDENCIA SOCIAL, INCIDENTES SOBRE SALÁRIOS E REMUNERAÇÕES PAGOS E SOBRE SERVIÇOS DE TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.01.01','INSS - DÉBITO PARCELADO','REGISTRA OS VALORES DE DEBITO PARCELADO QUE SE REFEREM AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DA FOLHA DE PAGAMENTO JUNTO AO INSS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.3.99.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGAÇÕES PARA A ENTIDADE, CUJA CLASSIFICACAO NÃO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.4.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.1.4.5.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.0.0.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','Compreende as obrigações financeiras da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.1.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.3.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.4.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.01','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.02','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.01.98','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.02.00','EMPRÉSTIMOS INTERNOS - EM CONTRATOS','Compreende os valores das operações de crédito internas em contratos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.02.98','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.1.5.03.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.0.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.01.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','Compreende os valores das operações de crédito externas decorrentes da emissão de títulos.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.02.00','EMPRÉSTIMOS EXTERNOS  - EM CONTRATOS','Compreende os valores das operações de crédito externas decorrentes da emissão em contratos.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.2.1.03.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos a curto prazo - externo - não enquadrados nas classificações anteriores.','C','N','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.0.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a longo prazo.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a longo prazo, contraídos para aquisição de bens do ativo permanente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.02','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a longo prazo contraídos para construção de imóveis.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.03','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a longo prazo contraídos para o capital de giro.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.01.98','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a longo prazo para os quais não haja contas específicas.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.1.02.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','Registra as obrigações a longo prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.3.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.4.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.3.5.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.0.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.01.00','FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes de financiamentos externos a longo prazo.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.01.01','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos externos a longo prazo, contraídos para aquisição de bens do ativo permanente.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.01.02','FINANCIAMENTOS DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos externos a longo prazo contraídos para o capital de giro.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.4.1.02.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','Registra as obrigações a longo prazo referentes a financiamentos externos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos internos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos do exercício anterior.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.02.00','ENCARGOS - EMPRÉSTIMOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos do exercício anterior.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos internos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos internos do exercício anterior.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.04.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos internos do exercício anterior.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.3.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.4.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.5.5.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.0.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.01.00','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de empréstimos externos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.01.01','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos externos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.01.02','JUROS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos externos de exercícios anteriores.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.02.00','ENCARGOS - EMPRÉSTIMOS EXTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.02.01','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.02.02','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos externos de exercícios anteriores.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.03.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes dos juros de contratos de financiamentos externos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.03.01','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos externos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.03.02','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de financiamentos externos de exercícios anteriores.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.04.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.04.01','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos do exercício.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.6.1.04.02','ENCARGOS DE CONTRATOS - FINANCIAMENTOS EXTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de financiamentos externos de exercícios anteriores.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos internos.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS INTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos internos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.3.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - UNIÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.4.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFFS - ESTADO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.8.5.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS – MUNICÍPIO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.0.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.1.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – EXTERNO - CONSOLIDAÇÃO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.1.01.00','(-) ENCARGOS PREFIXADOS DE EMPRÉSTIMOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a empréstimos externos.','D','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.2.9.1.02.00','(-) ENCARGOS PREFIXADOS DE FINANCIAMENTOS EXTERNOS','Registra o valor dos encargos financeiros pré-estabelecidos em valores prefixados, referentes a financiamentos externos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.0.0.00.00','FORNECEDORES A LONGO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.0.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.01.00','FORNECEDORES NACIONAIS','Compreende os valores a pagar aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','Compreende as Obrigações referentes a Precatórios de Fornecedores Nacionais.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.01','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','Registra os valores dos Precatórios Judiciais relativos ao Regime Ordinário de Natureza não Alimentar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.02','PRECATÓRIOS DE FORNECEDORES NACONAIS DO EXERCÍCIO  - A PARTIR DE 05/05/2000','Registra a apropriação e movimentação de Precatórios de fornecedores a Pagar - anteriores a 05/05/2000, exigíveis a Longo Prazo.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.03','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO - ANTES DE 05/05/2000','Registra a apropriação e movimentação de Precatórios de Fornecedores a Pagar - a partir de 05/05/2000, exigíveis a Longo Prazo.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.04','PRECATORIOS DE FORNECEDORES NACIONAIS  - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao Regime Especial mensal de Natureza não alimentar, instituído pela emenda Constitucional 62/2009','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.1.1.02.05','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de fornecedores nacionais do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','D','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.0.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.01.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos fornecedores estrangeiros de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.01.01','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.01.02','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.01.03','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.3.2.1.01.99','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','N','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.0.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.01.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de longo prazo relativos a diferenças intertemporais (deliberação da CVM nº 273, de 20/08/98),correspondentes ao IRPJ e CSSL, bem como PIS/PASEP E COFINS (lei nº 9.718 de 27/11/1998).','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS ','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (IPI, IRPJ CSSL, PIS, PASEP e Outros).','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.3.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.3.01.00','PASSIVO FISCAL DIFERIDO','Registra os valores de débitos fiscais de longo prazo relativos a diferenças intertemporais (deliberação da CVM nº 273, de 20/08/98),correspondentes ao IRPJ e CSSL, bem como PIS/PASEP E COFINS (lei nº 9.718 de 27/11/1998).','C','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.3.02.00','TRIBUTOS FEDERAIS RENEGOCIADOS ','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (IPI, IRPJ CSSL, PIS, PASEP e Outros).','C','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.3.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.4.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - ESTADO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.1.5.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS – MUNICÍPIO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.2.01.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.2.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.0.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ISS, IPTU e Outros).','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.1.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.2.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.2.01.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ISS, IPTU e Outros).','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.4.3.2.99.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES MUNICIPAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.0.0.00.00','PROVISÕES A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.0.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.1.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.1.01.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','Registra os valores das provisões constituídas visando o pagamento de indenizações trabalhistas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.1.1.02.00','PROVISÃO PARA PAGAMENTO DE DISSÍDIOS COLETIVOS','Registra os valores das provisões constituídas visando o pagamento de dissídios coletivos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.0.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, comprobabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS   ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de benefício de prestação continuada.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.03','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO FINANCEIRO DO RPPS  ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos inativos, por prazo de vigência indeterminado, para financiar os benefíciosjá em fase de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS              ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos pensionistas, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11, da Portaria MPS nº 403/2008.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS     ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao fundo sob o regime de parcelamento de débitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.01.07','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das insuficiências financeiras futuras do plano financeiro considerando o §1º do artigo 2º da Lei nº 9.717/98.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER            ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente dos benefícios a serem concedidos aos integrantes da geração atual que ainda não estejam em gozo de benefícios de prestação continuada.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO FINANCEIRO DO RPPS ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, incidentes sobre as remunerações da geração atual.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS   ','Registra, de acordo com o resultado da avaliação atuarial, o somatório do valor presente das contribuições futuras dos servidores ativos, incidentes sobre as remunerações da geração atual.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO FINANCEIRO DO RPPS      ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11, da Portaria MPS nº 403/2008.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, considerando o parcelamento dos valores não recolhidos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.02.06','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA  ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das insuficiências financeiras futuras do plano financeiro, considerando o §1º do artigo 2º da Lei nº 9.717/98.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS            ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS CONCEDIDOS DO PLANO PREVIDENCIÁRIO DO RPPS ','Registra, de acordo com o resultado da avaliação atuaria, o valor presente das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de benefício de prestação continuada.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS                       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.03','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS          ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos inativos, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.04','(-) CONTRIBUIÇÕES DO PENSIONISTA PARA O PLANO PREVIDENCIÁRIO DO RPPS           ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos pensionistas, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.05','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS             ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11 da Portaria MPS nº 403/2008.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.03.06','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS DO PLANO PREVIDENCIÁRIO DO RPPS     ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, considerando o parcelamento de valores não recolhidos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER              ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.01','APOSENTADORIAS/PENSÕES/OUTROS BENEFÍCIOS A CONCEDER DO PLANO PREVIDENCIÁRIO DO RPPS ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente dos benefícios a serem concedidos aos integrantes da geração atual que ainda não estejam em gozo de benefícios de prestação continuada.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.02','(-) CONTRIBUIÇÕES DO ENTE PARA O PLANO PREVIDENCIÁRIO DO RPPS                        ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periódicos) futuras do ente, incidentes sobre as remunerações da geração atual.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.03','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS                        ','Registra, de acordo com o resultado da avaliação atuarial, o somatório do valor presente das contribuições futuras dos servidores ativos, incidentes sobre as remunerações da geração atual.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.04','(-) COMPENSAÇÃO PREVIDENCIÁRIA DO PLANO PREVIDENCIÁRIO DO RPPS       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciária conforme expressa o artigo 11 da Portaria MPS nº 403/2008.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.04.05','(-) PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, sob o regime de parcelamento de débitos.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.05.00',' PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO                            ','Compreende, de acordo com resultado da avaliação atuarial, o valor presente liquido dos direitos incorporados ao patrimônio do RPPS com base em legislação especifica, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrera na apresentação de uma nova reavaliação atuarial.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.05.98','(-) OUTROS CRÉDITOS DO PLANO DE AMORTIZAÇÃO   ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente líquido dos direitos incorporados ao patrimônio do RPPS com base em legislação específica, como exemplo: direitos sobre royalties, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrerá na apresentação de uma nova reavaliação atuarial.','D','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.06.00',' PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO      ','Compreende o somatório das provisões atuariais constituídas para ajustes do plano financeiro, conforme o resultado da avaliação atuarial.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.06.01','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS       ','Registra, de acordo com a nota técnica atuarial, a provisão atuarial correspondente a eventuais desvios dos compromissos esperados ou pela adoção de bases técnicas que não se adaptam ao plano.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.00',' PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO      ','Compreende o somatório das provisões atuariais constituídas para ajustes do plano previdenciário, conforme o resultado da avaliação atuarial.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.01','AJUSTE DE RESULTADO ATUARIAL SUPERAVITÁRIO   ','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar resultado superavitário, considerando o artigo 25 da Portaria MPS nº 403/2008.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.02','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar oscilação de riscos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.03','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar benefícios a regularizar.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.04','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano apresentar contingências.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.2.1.07.98','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciário quando o plano necessitar de outros ajustes.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.0.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.01.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','Compreende os valores das provisões para pagamento de autos de infração já lavrados e que se encontram na esfera administrativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.01.01','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade ainda não apresentou recurso administrativo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.01.02','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade apresentou recurso administrativo.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.02.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','Compreende os valores das provisões para pagamento de autuações fiscais que já se encontram na esfera judicial.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.02.01','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera judicial e que não estão em fase recursal.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.3.1.02.02','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera judicial em fase recursal.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.0.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.01.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','Registra os valores das provisões constituídas para o pagamento de indenizações cíveis.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.02.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS A LIQUIDAR','Registra os valores das provisões para pagamento de seguros referentes a sinistros a liquidar.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.03.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS CIENTIFICADOS','Registra os valores das provisões para pagamento de seguros referentes a sinistros já cientificados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.4.1.04.00','PROVISÃO PARA PAGAMENTO DE SEGUROS - SINISTROS NÃO CIENTIFICADOS','Registra os valores das provisões para pagamento de seguros, referentes a sinistros não cientificados.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.0.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.3.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.4.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.5.5.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.6.0.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.6.1.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO OFSS','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.0.00.00','OUTRAS PROVISÕES A LONGO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem após o término do exercício seguinte, não classificadas anteriormente neste plano de contas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem após o término do exercício seguinte, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.01.00','PROVISÃO PARA GARANTIAS','Registra os valores das provisões destinadas a cobrir despesas com a prestação de garantia relativas a produtos vendidos.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.02.00','PROVISÃO PARA REESTRUTURAÇÃO','Registra os valores das provisões destinadas a cobrir obrigações oriundas da venda ou extinção de uma linha de negócios, fechamento de fábricas ou locais de negócios, mudanças na estrutura da administração e reorganizações com efeito relevante na natureza e foco das operações da entidade.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.03.00','PROVISÕES DO FCVS','Compreende, de acordo com a nota técnica atuarial, os valores atuariais dos passivos do fundo de compensação e variações salariais.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.03.01','PROVISÕES DO FCVS - RISCOS EXPIRADOS','Registra os resíduos de contratos liquidados pelo mutuário com cobertura do FCVS, de acordo com a avaliação atuarial.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.03.02','PROVISÕES DO FCVS - RISCOS NÃO EXPIRADOS','Registra o montante de contratos com cobertura do FCVS em fase de pagamento pelos mutuários, de acordo com a avaliação atuarial.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.7.9.1.99.00','OUTRAS PROVISÕES A LONGO PRAZO','Registra os valores das provisões não classificáveis nas demais contas deste plano de contas.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.0.0.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.0.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.1.1.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.0.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','Compreende os valores exigíveis após o término do exercício seguinte, provenientes de danos a terceiros.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.2.1.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores exigíveis após o término do exercício seguinte, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.3.0.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.3.1.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO- CONSOLIDAÇÃO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.4.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.0.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.00','CONSIGNACOES ','COMPREENDE OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.01','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE SERVIDORES A SER RECOLHIDO AO RPPS DO SERVIDOR.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.02','INSS','REGISTRA O VALOR DAS RETENCOES PROCEDIDAS EM PAGAMENTOS DE EMPREGADOS REGIDOS PELA CONSOLIDACAO DAS LEIS DO TRABALHO (CLT) OU DE SERVIÇOS DE TERCEIROS, A SER RECOLHIDO AO INSTITUTO NACIONAL DO SEGURO SOCIAL/PREVIDENCIA SOCIAL.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.03',' ENCARGOS SOCIAIS - OUTRAS ENTIDADES','REGISTRA O VALOR A SER RECOLHIDO A OUTRAS ENTIDADES, EM FUNCAO DE DISPOSITIVOS LEGAIS COM AS QUAIS A ENTIDADE MANTENHA CONVENIO DE ARRECADACAO DIRETA. EXEMPLO: FNDE, INCRA, DPC, SENAI, SESI, SENAC, FAER, SEBRAE, SENAT, SESCOOP, SESC.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.04','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DO IMPOSTO SOBRE A RENDA, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS OU CREDITADAS A SERVIDORES OU EMPREGADOS, SOBRE AS QUAIS INCIDA O REFERIDO IMPOSTO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.05','INDENIZAÇÕES E RESTITUICOES','REGISTRA OS VALORES RELATIVOS AS INDENIZAÇÕES E RESTITUICOES DE TRIBUTOS COM AUTORIZAÇÕES CONCEDIDAS, POREM NÃO DEVOLVIDAS AOS LEGITIMOS CREDORES PELA ENTIDADE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.06','IMPOSTOS E CONTRIBUIÇÕES DIVERSOS','REGISTRA OS VALORES REFERENTES AS RETENCOES NA FONTE, PELA ENTIDADE, DE IMPOSTOS E CONTRIBUIÇÕES DIVERSOS, RELATIVAS AS IMPORTANCIAS PAGAS A TERCEIROS, SOBRE OS QUAIS INCIDAM OS REFERIDOS TRIBUTOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.07',' ICMS ','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVIÇOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNAÇÕES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.08',' ISS ','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVIÇOS RETIDOS EM CONSIGNAÇÕES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUAÇÕES QUE A ENTIDADE COMO PARTE CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.09','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.10','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.11','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.12','ASSISTENCIA A SAUDE - ADMINISTRAÇÃO PROPRIA','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.13','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.14','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUIÇÕES A PLANOS DE SEGURO DE VIDA EM GRUPO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.15','RETENCOES - EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.16','RETENÇÃO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERAÇÕES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.17','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.01.99','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.02.00','GARANTIAS','COMPREENDE A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.03.00','DEPOSITOS JUDICIAIS','COMPREENDE OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL E DEPOSITOS PARA RECURSOS JUDICIAIS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.03.01','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.03.02','DEPOSITOS PARA RECURSOS JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.00','DEPOSITOS NAO JUDICIAIS','COMPREENDE OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.01','DEPOSITOS E CAUCOES','REGISTRA OS VALORES DAS OBRIGACOES EXIGIVEIS CONTRAIDAS COM O RECEBIMENTO DE DEPOSITOS E/OU CAUCOES VINCULADOS A CONTRATOS OU OUTROS INSTRUMENTOS, PARA GARANTIAS DE OPERACOES ESPECIFICAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.02','DEPOSITOS ESPECIAIS','REGISTRA O VALOR RELATIVO A RETENCOES DE DEPOSITOS VINCULADOS A RESTITUIR NO CURSO DO EXERCICIO SEGUINTE A ENTIDADE TRANSFERIDORA, DECORRENTE DE CONTRATOS OU INSTRUMENTOS CONGENERES, CONVENCAO, ACORDO OU AJUSTE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.03','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPÓSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NÃO RECLAMADOS PELOS CREDORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.04','DEPOSITOS DE VEICULOS ALIENAVEIS','REGISTRA O VALOR DOS RECEBIMENTOS PROVENIENTES DA ALIENACAO DE VEICULOS REMOVIDOS, RECOLHIDOS OU APREENDIDOS DE ACORDO COM A RESOLUCAO DO CONTRAN Nº 178/2005, PENDENTES DE TRANSFERÊNCIAS DIVERSAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.05','DEPOSITOS A TRANSFERIR','REGISTRA OS VALORES DAS RETENCOES DE DEPOSITOS DE DIVERSAS ORIGENS RECEBIDOS POR UG CENTRAL CUJA DEVOLUCAO DEVE SER REALIZADA NO CURSO DO EXERCICIO SEGUINTE.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.06','DEPOSITOS DE TERCEIROS','REGISTRA OS VALORES RELATIVOS AOS DEPOSITOS DE TERCEIROS DE DIVERSAS ORIGENS, INCLUSIVE DESCONHECIDAS, NAO RECLAMADOS PELOS CREDORES.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.04.99','OUTROS DEPOSITOS','REGISTRA COMPROMISSOS EXIGIVEIS ATE O TERMINO DO EXERCICIO SEGUINTE, DECORRENTES DE RECEBIMENTOS A TITULO DE DEPOSITOS, PARA OS QUAIS NAO HAJA CONTAS ESPECIFICAS.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.8.1.99.00','OUTROS VALORES RESTITUIVEIS','COMPREENDE OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','N','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.0.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.8.9.1.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.0.0.00.00','RESULTADO DIFERIDO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.  Compreende também o saldo existente na antiga conta resultado de exercícios futuros em 31 de dezembro de 2008.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.1.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.0.00.00','(-) CUSTO DIFERIDO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.2.9.2.1.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.0.0.0.00.00','PATRIMÔNIO LIQUIDO','Compreende o valor residual dos ativos depois de deduzidos todos os passivos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.0.0.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','Compreende o patrimônio social das autarquias, fundações e fundos e o capital social das demais entidades da administração indireta.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.1.0.00.00','PATRIMÔNIO SOCIAL','Compreende o patrimônio das autarquias, fundações e fundos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.1.1.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','Compreende o patrimônio das autarquias, fundações e fundos, pertencentes ao orçamento fiscal e da seguridade social.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.0.00.00','CAPITAL SOCIAL REALIZADO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.1.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.2.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.3.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.4.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.1.2.5.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','Compreende o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.0.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.1.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.2.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.3.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.4.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.2.0.5.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS – MUNICÍPIO.','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.0.0.00.00','RESERVAS DE CAPITAL','Compreende os valores acrescidos ao patrimônio que não transitaram pelo resultado como variações patrimoniais aumentativas (VPA).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.0.00.00','ÁGIO NA EMISSÃO DE AÇÕES','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiárias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.1.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.2.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.3.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.4.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.1.5.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.0.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS','Compreende o produto da alienação de partes beneficiárias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.1.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.2.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.3.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.4.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.2.5.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','Compreende o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.0.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','Compreende o produto da alienação de bônus de subscrição.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.1.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.2.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.3.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.4.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.3.5.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','Compreende o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.0.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.1.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.2.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.3.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.4.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.4.5.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.0.00.00','OUTRAS RESERVAS DE CAPITAL','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','Registra os valores de prêmio na emissão de debêntures, que ocorrem quando o preço da emissão de debêntures for superior a seu valor nominal. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','Registra os valores de doações e subvenções para investimentos. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','Registra os valores do resultado da correção monetária especial, conforme o Decreto-lei nº 1.598/77.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.1.99.00','DEMAIS RESERVAS DE CAPITAL','Registra os valores das demais reservas de capital, não contabilizáveis em outras contas deste plano.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.01.00','PRÊMIO NA EMISSÃO DE DEBÊNTURES','Registra os valores de prêmio na emissão de debêntures, que ocorrem quando o preço da emissão de debêntures for superior a seu valor nominal. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.02.00','RESERVAS DE DOAÇÕES E SUBVENÇÕES PARA INVESTIMENTOS','Registra os valores de doações e subvenções para investimentos. Esta conta não consta mais dentre as rubricas de reservas de capital e assim deve ser utilizada apenas durante o período necessário para utilização dos saldos remanescentes nela.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.03.00','RESERVA DE CORREÇÃO MONETÁRIA ESPECIAL DEC. LEI 1.598/77','Registra os valores do resultado da correção monetária especial, conforme o Decreto-lei nº 1.598/77.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.2.99.00','DEMAIS RESERVAS DE CAPITAL','Registra os valores das demais reservas de capital, não contabilizáveis em outras contas deste plano.','C','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.3.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.4.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.3.9.5.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.0.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo e do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício em obediência ao regime de competência.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.1.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.1.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.2.0.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.4.2.1.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.0.0.00.00','RESERVAS DE LUCROS','Compreende as reservas constituídas com parcelas do lucro liquido das entidades para finalidades especificas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.0.00.00','RESERVA LEGAL','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.1.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.2.00.00','RESERVA LEGAL- INTRA OFSS','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.3.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.4.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.1.5.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.0.00.00','RESERVAS ESTATUTÁRIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.1.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.2.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.3.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.4.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.2.5.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.0.00.00','RESERVA PARA CONTINGENCIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.1.00.00','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.2.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.3.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.4.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.3.5.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.0.00.00','RESERVA DE INCENTIVOS FISCAIS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.1.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.2.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.3.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.4.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.4.5.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.0.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.1.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.2.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.3.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.4.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS –ESTADO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.5.5.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.0.00.00','RESERVA DE LUCROS A REALIZAR','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.1.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.2.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.3.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.4.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.6.5.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.0.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','Compreende a parcela do lucro líquido do exercício decorrente do prêmio na emissão de debêntures.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.1.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.2.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.3.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.4.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.7.5.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','Compreende a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.0.00.00','OUTRAS RESERVAS DE LUCRO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.1.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.2.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.3.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.4.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.5.9.5.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.0.0.00.00','DEMAIS RESERVAS','Compreende as demais reservas, não classificadas como reservas de capital ou de lucro, inclusive aquelas que terão seus saldos realizados por terem sido extintas pela legislação.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.0.00.00','RESERVA DE REAVALIAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.1.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.2.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.3.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.4.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.1.5.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.0.00.00','OUTRAS RESERVAS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.1.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.2.00.00','OUTRAS RESERVAS - INTRA OFSS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.3.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.4.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.6.9.5.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.0.0.00.00','RESULTADOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas e os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.0.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.1.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.2.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.3.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão Registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.4.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.01.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.02.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.1.5.04.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.0.00.00','LUCROS E PREJUÍZOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.02.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.03.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.1.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Compreende o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.02.00','LUCROS EPREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.2.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.3.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.4.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.01.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.02.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.03.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.04.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.05.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.7.2.5.06.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','S','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.0.0.00.00','(-) AÇÕES/COTAS EM TESOURARIA','Compreende o valor das ações ou cotas da entidade que foram adquiridas pela própria entidade.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.0.00.00','(-) AÇÕES EM TESOURARIA','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.1.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.2.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.3.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.4.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.1.5.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS – MUNICÍPIO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.0.00.00','(-) COTAS EM TESOURARIA','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.1.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.2.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.3.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.4.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '2.3.9.2.5.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','Compreende o decréscimo no beneficio econômico durante o período contábil sob a forma de saída de recurso ou redução de ativo ou incremento em passivo, que resulte em decréscimo do patrimônio liquido e que não seja proveniente de distribuição aos proprietários da entidade.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.0.0.0.00.00','PESSOAL E ENCARGOS','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas ou variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público. Compreende ainda, obrigações trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos órgãos e demais entidades do setor público, contribuições a entidades fechadas de previdência e benefícios eventuais a pessoal civil e militar, destacados os custos de pessoal e encargos inerentes as mercadorias e produtos vendidos e serviços prestados.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.0.0.00.00','REMUNERAÇÃO A PESSOAL','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público, bem como as com contratos de terceirização de mão de obra que se refiram à substituição de servidores e empregados públicos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','Compreende o somatorio dos valores com vencimentos e vantagens fixas do pessoal civil do tipo: gratificacao, representacao, adicional insalubridade, férias, 13 salário, licenca-premio, abono pecuniario, adicional noturno, etc.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.01','VENCIMENTOS E SALÁRIOS','Registra o valor da despesa com vencimentos e salários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.02','ADICIONAL NOTURNO','Registra o valor da despesa com adicional noturno r.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.03','INCORPORAÇÕES','Registra o valor da despesa com incorporações.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.04','ABONO DE PERMANÊNCIA','Registra o valor da despesa com abono de permanência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.05','ADICIONAL DE PERICULOSIDADE','Registra o valor da despesa com adicional de periculosidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.06','ADICIONAL DE INSALUBRIDADE','Registra o valor da despesa comadicional de insalubridade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.07','ADICIONAL DE ATIVIDADES PENOSAS','Registra o valor da despesa com adicional de atividades penosas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.08','INCENTIVO Á QUALIFICAÇÃO','Registra o valor da despesa com incentivo á qualificação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.09','REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE','Registra o valor da despesa com vremuneração de pessoal em disponibilidade','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.10','RETRIBUIÇÃO ADICIONAL VARIÁVEL E PRÓ-LABORE (LEI 7711/88)','Registra o valor da despesa com retribuição adicional variável e pró-labore (lei 7711/88)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.12','VANTAGEM PECUNIÁRIA INDIVIDUAL','Registra o valor da despesa com vantagem pecuniária individual','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.13','ABONO PROVISÓRIO – PESSOAL CIVIL','Registra o valor da despesa com abono provisório – pessoal civil','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.14','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','Registra o valor da despesa com gratificação por exercício de cargos','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.15','INCREMENTO PLANO DE CARGOS E SALÁRIOS DO PODER JUDICIÁRIO','Registra o valor da despesa com incremento plano de cargos e salários do poder judiciário','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.16','GRATIFICAÇÃO POR EXERCÍCIO DE FUNÇÕES','Registra o valor da despesa comgratificação por exercício de funções','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.17','INDENIZAÇÃO E LOCAÇÃO','Registra o valor da despesa com indenização e locação','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.18','GRATIFICAÇÃO DE TEMPO DE SERVIÇO','Registra o valor da despesa com gratificação de tempo de serviço','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.19','GRATIFICAÇÕES ESPECIAIS','Registra o valor da despesa comgratificações especiais','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.20','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','Registra o valor da despesa com gratificação por atividades expostas','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.21','FÉRIAS VENCIDAS E PROPORCIONAIS','Registra o valor da despesa com veférias vencidas e proporcionais','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.22','13. SALÁRIO','Registra o valor da despesa com 13. salário','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.23','FÉRIAS – ABONO PECUNIÁRIO','Registra o valor da despesa com férias – abono pecuniário','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.24','FÉRIAS – ABONO CONSTITUCIONAL','Registra o valor da despesa com férias – abono constitucional','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.25','LICENÇA-PRÊMIO','Registra o valor da despesa com licença-prêmio.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.26','LICENÇA CAPACITAÇÃO','Registra o valor da despesa com licença capacitação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.27','ADIANTAMENTO PECUNIÁRIO','Registra o valor da despesa com adiantamento pecuniário.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.28','REPRESENTAÇÃO MENSAL','Registra o valor da despesa com representação mensal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.29','COMPLEMENTAÇÃO SALARIAL','Registra o valor da despesa com complementação salarial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.30','ADICIONAL – TETO PARLAMENTAR','Registra o valor da despesa com adicional – teto parlamentar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.31','SUBSÍDIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a subsídios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','Registra o valor da despesa com gratificação por exercício de cargo em comissão.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor da despesa com vencimentos e salários prorrogação salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a férias - pagamento antecipado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.36','REMUN. PARTICIP. ÓRGÃOS DELIBERAÇÃO COLETIVA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a remun. particip. órgãos deliberação coletiva.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS – PESSOAL CIVIL RPPS','Registra o valor da despesa com voutros vencimentos e vantagens fixas – pessoal civil RPPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','Registra o valor de outras despesas variáveis - Pessoal Civil - RPPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.01','SUBSTITUIÇÕES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a substituicoes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.02','ADICIONAL VARIÁVEL','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional variavel sujeitos a incidencia de tributos e contribuicoes de acordo com a lei 10.973/04 - distribuicao de royalties.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.03','SERVIÇOS EXTRAORDINÁRIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a servicos extraordinarios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.04','GRATIFICAÇÃO POR EMBARQUE FLUVIAL','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificacao por embarque fluvial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.05','GRATIFICAÇÃO ELEITORAL','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificacao eleitoral.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.06','LICENÇA SEM REMUNERAÇÃO INCENTIVADA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a licenca sem remuneracao incentivada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.07','ADICIONAL POR PLANTÃO HOSPITALAR','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional por plantao hospitalar - aph devido aos servidores em efetivo exercicio de atividades hospitalares, desempenhadas em regime de plantao, nas areas indispensaveis ao funcionamento ininterrupto dos hospitais constantes no artigo 298 da lei 12.155, de 2009, que altera a lei 11.907, de 02 de fevereiro de 2009.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.08','CONVOCACAO EXTRAORDINARIA LEGISLATIVA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a convocacao extraordinaria legislativa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.09','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a participacao a empregados e administradores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.10','AUXILIO MORADIA                            ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a auxilio moradia..','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.11','INDENIZAÇÕES  E RESTITUIÇÕES TRABALHISTAS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com com indenizações trabalhistas, referente a indenizações e restituições trabalhistas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.12','INDENIZ. E RESTIT. DECORR. DE PLANOS DE DEMISSÃO VOLUNTÁRIA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com com indenizações trabalhistas, referente a indeniz. e restit. decorr. de planos de demissão voluntária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.13','RESSARCIMENTO DE DESP. DE PESSOAL REQUISITADO','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com resarcimento de despesas de pessoal requisitado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.02.99','OUTROS VENCIMENTOS E VANTAGENS VARIÁVEIS – PESSOAL CIVIL RPPS','Registra o valor da despesa com voutros vencimentos e vantagens variáveis – pessoal civil RPPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.1.1.03.00','SENTENCAS JUDICIAIS','Registra as variacoes patrimoniais diminutivas provenientes de sentencas judiciais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RGPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RGPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','COMPREENDE O SOMATORIO DOS VALORES COM VENCIMENTOS E VANTAGENS FIXAS DO PESSOAL CIVIL DO TIPO: GRATIFICACAO, REPRESENTACAO, ADICIONAL INSALUBRIDADE, FERIAS, 13 SALARIO, LICENCA-PREMIO, ABONO PECUNIARIO, ADICIONAL NOTURNO, ETC.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.01','VENCIMENTOS E SALARIOS  ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM VENCIMENTOS E SALARIOS DO PESSOAL CIVIL REGIDOS PELO REGIME GERAL DA PREVIDENCIA SOCIAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.02','ADICIONAL NOTURNO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACOES A EMPREGADOS EM ATIVIDADE NOTURNA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.03','INCORPORACOES    ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE VENCIMENTOS E VANTAGENS POR INCORPORACOES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.04','ABONO DE PERMANENCIA    ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM PAGAMENTO DO ABONO DE PERMANENCIA, DEVIDO AOS EMPREGADOS QUE TENDO COMPLETADO AS EXIGENCIAS PARA APOSENTADORIA VOLUNTARIA, OPTE POR PERMANECER EM ATIVIDADE. ','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.05','ADICIONAL DE PERICULOSIDADE    ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE EMPREGADOS QUE EXERCEM ATIVIDADES PERIGOSAS, CONFORME O § 1º , DO ARTIGO 193, DO DECRETOLEI N.º 5.452, DE 1º DE MAIO DE 1943 (CLT).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.06','ADICIONAL DE INSALUBRIDADE     ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE EMPREGADOS EM ATIVIDADE EM LOCAIS INSALUBRES, CONFORME ARTIGO 192, DO DECRETO-LEI N.º 5.452, DE 1º DE MAIO DE 1943 (CLT).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.07','REMUNERACAO PARTICIPANTES DE ORGAO DE DELIBERACAO COLETIVA ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHO CONSULTIVO, CONSELHO DE ADMINISTRACAO, CONSELHO FISCAL OU OUTROS ORGAOS COLEGIADOS), OBSERVADO O DISPOSTO NA LEI N. 7733, DE 14/02/89.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.08','INCENTIVO A QUALIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM INCENTIVO A QUALIFICACAO DE EMPREGADOS QUE POSSUIREM EDUCACAO FORMAL SUPERIOR AO EXIGIDO PELO EMPREGO/CARGO QUE OCUPAM, EM AREAS DE INTERESSE DO ORGAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.09','ADICIONAL DE TRANSFERÊNCIA - ART. 469/CLT    ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM REMUNERACAO DE SERVIDORES QUE EXERCEM FORAM TRANSFERIDOS CONFORME ART.469 DA CLT.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.10','RETR.ADIC.VARIAVEL E PRO-LABORE(LEI 7711/88) ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE RETRIBUICAO ADICIONAL VARIAVEL E PRO-LABORE DE EXITO CONFORME LEI 7.711/88, ARTIGOS TERCEIRO E QUINTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.11','REMUNERACAO DE DIRETORES','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE REMUNERACAO DE DIRETORES DE EMPRESAS PUBLICAS E DE ECONOMIA MISTA','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.12','VANTAGEM PECUNIARIA INDIVIDUAL ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM A VANTAGEM PECUNIARIA INDIVIDUAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.13','ABONO PROVISORIO - PESSOAL CIVIL      ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM ABONO PROVISORIO A PESSOAL CIVIL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.14','GRATIFICACAO POR EXERCICIO DE CARGOS  ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE CARGOS, COMO GAJ, ETC.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.15','INDENIZACAO A ANISTIADO POLITICO      ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE ANISTIADOS POLITICOS CONFORME A LEI 10.559/2002','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.16','GRATIFICACAO POR EXERCICIO DE FUNCOES ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO POR EXERCICIO DE FUNCOES, DE COORDENACAO, ASSESSORAMENTO, CHEFIA E ENCARGO DE ATIVIDADES ESPECIFICAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.17','INDENIZACAO DE LOCALIZACAO     ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS A TITULO DE INDENIZACAO DE LOCALIZACAO ESPECIFICA DETERMINADA POR LEI','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.18','GRATIFICACAO DE TEMPO DE  SERVICO     ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES ADQUIRIDAS EM FUNCAO DE CONTAGEM DE TEMPO DE SERVICO, PESSOAL CIVIL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.19','GRATIFICACOES ESPECIAIS ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES DE NATUREZA ESPECIAL CONCEDIDAS EM VIRTUDE DE LEI A PESSOAL CIVIL, TAIS COMO: GRATIFICACAO ESPECIAL DE LOCALIZACAO, ETC.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.20','GRATIFICACAO POR ATIVIDADES EXPOSTAS  ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GRATIFICACOES, QUANDO PELO EXERCICIO, EXPOE O SERVIDOR A RISCOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.21','FERIAS VENCIDAS E PROPORCIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM PAGAMENTO DE FERIAS VENCIDAS E PROPORCIONAIS NA RESCISAO DE CONTRATO DE TRABALHO OU DEMISSAO DO EMPREGADO','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.22','13. SALARIO      ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM GRATIFICACAO DE NATAL (13 SALARIO) DO PESSOAL CIVIL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.23','FERIAS - ABONO PECUNIARIO      ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE DESPESAS COM A CONVERSAO EM ABONO PECUNIARIO DE UM TERCO DO VALOR DA REMUNERACAO DEVIDA AO EMPREGADO NO PERIODO DE FERIAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.24','FERIAS - ABONO CONSTITUCIONAL  ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DO VALOR DO ABONO CONCEDIDO A TODOS EMPREGADOS COMO REMUNERACAO DO PERIODO DE FERIAS ANUAIS - UM TERCO A MAIS DO QUE O SALARIO NORMAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.25','LICENCA-PREMIO   ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA-PREMIO POR ASSIDUIDADE NO TRABALHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.26','LICENCA CAPACITACAO     ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM LICENCA PARA CAPACITACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.27','ADIANTAMENTO  PECUNIARIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM ADIANTAMENTO PECUNIARIO DEVIDOS AOS SERVIDORES EM DECORRENCIA DE DETERMINACAO LEGAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.28','REPRESENTACAO MENSAL    ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS REALIZADAS COM REPRESENTACAO MENSAL, POR EXEMPLO DO "DAS" E ETC.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.29','COMPLEMENTACAO SALARIAL ','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM COMPLEMENTACAO DE REMUNERACAO PAGA A PESSOAL CIVIL','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.30','ADICIONAL – TETO PARLAMENTAR   ','Registra as variações patrimoniais diminutivas com adicional – teto parlamentar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.31','SUBSÍDIOS ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a subsídios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.32','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO     ','Registra as variações patrimoniais diminutivas com gratificação por exercício de cargo em comissão.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.33','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE     ','Registra as variações patrimoniais diminutivas com vencimentos e salários prorrogação salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.35','FÉRIAS - PAGAMENTO ANTECIPADO  ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a férias - pagamento antecipado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.01.99','OUTROS VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','Registra as variações patrimoniais diminutivas com outros vencimentos e vantagens fixas – pessoal civil RGPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS  ','Registra o valor de outras VPD variáveis – pessoal civil RGPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.01','SUBSTITUICOES    ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a substituicoes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.02','ADICIONAL VARIAVEL      ','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional variavel sujeitos a incidencia de tributos e contribuicoes de acordo com a lei 10.973/04 - distribuicao de royalties.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.03','SERVICOS EXTRAORDINARIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a servicos extraordinarios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.04','GRATIFICACAO POR EMBARQUE FLUVIAL     ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificacao por embarque fluvial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.05','AVISO PREVIO     ','Registra as variações patrimoniais diminutivas com aviso prévio','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.06','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES  ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a participacao a empregados e administradores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.07','GRATIFICACAO ELEITORAL (RGPS)  ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificacao eleitoral.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.10','LICENCA SEM REMUNERACAO INCENTIVADA (RGPS)   ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a licenca sem remuneracao incentivada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.08','CONVOCACAO EXTRAORDINARIA LEGISLATIVA (RGPS) ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a convocacao extraordinaria legislativa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.09','AUXILIO MORADIA (RGPS)  ','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a auxilio moradia..','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.02.99','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL    ','Registra o valor de outras VPD variáveis – pessoal civil RGPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.03.00','SENTENCAS JUDICIAIS     ','Registra as variações patrimoniais diminutivas com sentenças judiciais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.00','CONTRATACAO POR TEMPO DETERMINADO     ','Registra as variações patrimoniais diminutivas com contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.01','SALARIO CONTRATO TEMPORARIO - LEI 8.745/93   ','Registra as variações patrimoniais diminutivas com salário por contrato temporário, de acordo com a Lei 8.745/93.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.02','ADICIONAL NOTURNO DE CONTRATO TEMPORARIO     ','Registra as variações patrimoniais diminutivas com adiconal noturno por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.03','ADICIONAL DE PERICULOSIDADE CONTR. TEMPORARIO','Registra as variações patrimoniais diminutivas com adicional de periculosidade por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.04',' ADICIONAL DE INSALUBRIDADE CONTRATO TEMPORARIO     ','Registra as variações patrimoniais diminutivas com adicional de insalubridade por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.05','ADICIONAL DE ATIVIDADES PENOSAS - CONTR. TEMPORARIO ','Registra as variações patrimoniais diminutivas com adiconal de atividades penosas contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.06','SERVICOS EVENTUAIS DE MEDICOS RESIDENTES     ','Registra as variações patrimoniais diminutivas com serviços eventuais de médicos residentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.07',' RESIDENCIA MULTIPROFISSIONAL  ','Registra as variações patrimoniais diminutivas com residência multiprofissional.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.08','ADICIONAL DE IRRADIACAO IONIZANTE CONT. TEMP.','Registra as variações patrimoniais diminutivas com adicional de irradiação ionizante por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.09','GRATIFICACAO DE RAIO-X CONTRATO TEMPORARIO   ','Registra as variações patrimoniais diminutivas com gratificação de raio-X por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.10','SERVICOS EXTRAORDINARIOS CONTRATO TEMPORARIO ','Registra as variações patrimoniais diminutivas com serviços extraordinários por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.11','SERVICOS EXTRAORDINARIOS NOTURNO CONT. TEMP. ','Registra as variações patrimoniais diminutivas com serviços extraordinários noturnos porcontratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.12','FERIAS VENCIDAS/PROPORCIONAIS CONT.TEMPORARIO','Registra as variações patrimoniais diminutivas com férias vencidas ou proporcionais por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.13','13º SALARIO CONTRATO TEMPORARIO','Registra as variações patrimoniais diminutivas com 13º salário por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.14','FERIAS - ABONO CONSTITUCIONAL  ','Registra as variações patrimoniais diminutivas com adicional de férias por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.15','FERIAS - PAGAMENTO ANTECIPADO  ','Registra as variações patrimoniais diminutivas com pagamento antecipado de férias por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.16','SERVICOS EVENTUAIS DE AUXILIARES CIVIS NO EXT','Registra as variações patrimoniais diminutivas com serviços eventuais de auxiliares civis no exterior por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.17','SERVICOS EVENTUAIS DE PROFESSORES     ','Registra as variações patrimoniais diminutivas com serviços eventuais de professores por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.18','SERVICOS EVENTUAIS DE ASSISTENCIA SOCIAL     ','Registra as variações patrimoniais diminutivas com serviços eventuais de assistência social por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.19','SERV EVENT ENFERMAG FISIOT TERAPIA OCUPAC    ','Registra as variações patrimoniais diminutivas com serviços eventuais de enfermagem e fisioterapia ocupacional por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.20','SERVICOS EVENTUAIS DE NATUREZA INDUSTRIAL    ','Registra as variações patrimoniais diminutivas com serviços eventuais de natureza industrial por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.21','SERVICOS EVENTUAIS DE AGENTES DE SAUDE','Registra as variações patrimoniais diminutivas com serviços eventuais de agentes de saúde por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.22','SERVICOS EVENTUAIS DE DENTISTAS E PSICOLOGOS ','Registra as variações patrimoniais diminutivas com serviços eventuais de dentistas e psicólogos por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.23','SERVICOS EVENTUAIS DE MAO-DE-OBRA     ','Registra as variações patrimoniais diminutivas com serviços eventuais de mão de obra por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.26','SERVIÇOS TEMPORÁRIOS DE AGENTES PRISIONAIS   ','Registra as variações patrimoniais diminutivas com salários de agentes prisionais por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.24','OBRIGACOES PATRONAIS    ','Registra as variações patrimoniais diminutivas com obrigações patronais por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.28','INSS PATRONAL    ','Registra as variações patrimoniais diminutivas com INSS patronal por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.29','FGTS      ','Registra as variações patrimoniais diminutivas com FGTS por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.2.1.04.25','OUTRAS CONTRATACOES POR TEMPO DETERMINADO    ','Registra as demais variações patrimoniais diminutivas por contratação por tempo determinado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.0.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR – ABRANGIDOS PELO  RPPS','Compreende a remuneração do pessoal ativo militar, abrangidos por regime próprio dos militares ou não, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.00.00','REMUNERAÇÃO A PESSOAL  ATIVO MILITAR – ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo militar, abrangidos por regime próprio dos militares ou não, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.00','VENCIMENTOS E VANTAGENS FIXAS - PES. MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.01','SOLDO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com soldo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.02','ADICIONAL DE PERMANENCIA','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de permanência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.03','ADICIONAL DE TEMPO DE SERVICO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional por tempo de serviço.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.04','ADICIONAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.05','ADICIONAL DE COMPENSACAO ORGANICA','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de compensação orgânica.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.06','ADICIONAL DE HABITACAO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de habitação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.07','GRATIFICACAO DE LOCALIDADE ESPECIAL','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com localidade especial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.08','GRATIFICACAO DE REPRESENTACAO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de representação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.09','GRATIFICACAO DE FUNCAO DE NATUREZA ESPECIAL','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de função de natureza especial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.10','GRATIFICACAO DE SERVICO VOLUNTARIO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de serviço voluntário.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.11','VANTAGEM PECUNIARIA ESPECIAL - VPE','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com vantagem pecuniária especial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.12','INDENIZACAO DE REPRESENTACAO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com indenização de representação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.13','GRATIFICACAO DE EXERCICIOS DE CARGOS','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com gratificação de exercícios de cargos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.14','FERIAS VENCIDAS E PROPORCIONAIS','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com férias vencidas e proporcionais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.15','ADICIONAL NATALINO','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional natalino.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.16','FERIAS - ABONO CONSTITUCIONAL','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional de férias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.17','COMPLEMENTACAO SALARIAL - PESSOAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com complementação salarial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.01.99','OUTRAS VPD FIXAS - PESSOAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório de outras variações patrimoniais diminutivas fixas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório de outras variações patrimoniais diminutivas variáveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.01','INDENIZACOES/MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com indenizações não especificadas em outros itens.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.02','ADICIONAL TAREFA TEMPO CERTO(ART. 23 MP 2131)','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional por tarefa por tempo certo (art. 23 da MP 2131).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.03','ADICIONAL NOTURNO - MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com adicional noturno.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.02.04','HORA-EXTRA, HORAS DE SOBREAVISO E PLANTÃO - MILITAR','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com hora extra, horas de sobreaviso e plantões.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.1.3.1.03.00','SENTENCAS JUDICIAIS','Registra a remuneração do pessoal ativo militar, correspondente ao somatório das variações patrimoniais diminutivas com sentenças judiciais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.0.0.00.00','ENCARGOS PATRONAIS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores e empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como contribuições a entidades fechadas de previdência e ainda outras contribuições patronais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.0.00.00','ENCARGOS PATRONAIS - RPPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS','Registra as variações patrimoniais diminutivas provenientes de contribuições patronais para custeio do plano de seguridade social do servidor.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.02.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas realizadas com encargos de pessoal requisitado de outros entes da federação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.1.2.99.00','OUTROS ENCARGOS PATRONAIS - RPPS','Registra as variações patrimoniais diminutivas realizadas com outras obrigações patronais ao RPPS, não classificáveis nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.0.00.00','ENCARGOS PATRONAIS - RGPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos, em cargo efetivo.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','Registra as variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.03.00','SEGURO DE ACIDENTE NO TRABALHO','Registra as variações patrimoniais diminutivas realizadas relativas a contribuições previdenciárias de seguro de acidentes do trabalho.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas realizadas com encargos de pessoal requisitado de outros entes da Federação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS referente a prorrogação do salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','Registra as variações patrimoniais diminutivas realizadas a título de contribuição para o PIS, determinada com base na folha de pagamento, a alíquota de 1%, pelas fundações públicas instituídas ou mantidas pelo Poder Público (MP 2.158-35/2001).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.1.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','Registra as variações patrimoniais diminutivas realizadas com outras obrigações patronais ao RGPS, não classificáveis nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.2.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.01.00','CONTRIBUIÇÕES PREVIDENCIÁRIAS - INSS','Registra as variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.03.00','SEGURO DE ACIDENTE NO TRABALHO','Registra as variações patrimoniais diminutivas realizadas relativas a contribuições previdenciárias de seguro de acidentes do trabalho.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.04.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas realizadas com encargos de pessoal requisitado de outros entes da Federação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.05.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS referente a prorrogação do salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.06.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','Registra as variações patrimoniais diminutivas realizadas a titulo de contribuição para o PIS, determinada com base na folha de pagamento, a alíquota de 1%, pelas fundações públicas instituídas ou mantidas pelo Poder Público (MP 2.158-35/2001).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.3.99.00','OUTROS ENCARGOS PATRONAIS - RGPS','Registra as variações patrimoniais diminutivas realizadas com outras obrigações patronais ao RGPS, não classificáveis nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.4.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.2.5.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.0.00.00','ENCARGOS PATRONAIS - FGTS','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.01.00','FGTS','Registra as variações patrimoniais diminutivas realizadas com obrigações relativas ao recolhimento do FGTS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.02.00','FGTS - PDV','Registra as variações patrimoniais diminutivas com FGTS de servidores que optaram pelo Plano de Demissão Voluntária - PDV.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.3.1.03.00','FGTS - PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra os valores das variações patrimoniais diminutivas realizadas com obrigações relativas ao recolhimento do FGTS referente a prorrogação do salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.0.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.01.00','SISTEMAS SOCIAIS AUTÔNOMOS -  ATIVO CIVIL','Registra as variações patrimoniais diminutivas realizadas com contribuições patronais para os Sistemas Sociais Autônomos, como SESI/SENAI, referente a pessoal ativo civil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.02.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO','Registra as variações patrimoniais diminutivas realizadas a titulo de contribuição de salário-educação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.03.00','CONTRIBUIÇÃO DE SALÁRIO EDUCAÇÃO REFERENTE A PRORROGAÇÃO DE SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas a titulo de contribuição de salário-educação referente a prorrogação do salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.4.1.99.00','OUTRAS CONSTRIBUIÇÕES SOCIAIS GERAIS','Registra as outras contribuições sociais gerais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.0.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.01.00','COMPLEMENTAÇÃO DE PREVIDÊNCIA','Registra as variações patrimoniais diminutivas com contribuições de responsabilidade das entidades patrocinadoras para atender plano de previdência complementar, administrado por suas instituições de seguridade social.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.02.00','SEGUROS','Registra as variações patrimoniais diminutivas com contribuições a entidades de previdência fechada, sob a modalidade de seguros, tais como: seguro de vida-pac.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.03.00','CONTRIBUIÇÃO PATRONAL PREVIDÊNCIA PRIVADA','Registra as variações patrimoniais diminutivas com contribuição patronal, devida a entidades de previdência privada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.04.00',' COMPLEMENTAÇÃO PREVIDENCIÁRIA REFERENTE A PRORROGAÇÃO SALÁRIO MATERNIDADE ','Registra as variações patrimoniais diminutivas com contribuições de responsabilidade das entidades patrocinadoras p/ atender plano de previdência complementar, administrado por suas instituições de seguridade social referente a prorrogação do salário maternidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.5.1.99.00','OUTRAS CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Registra as variações patrimoniais diminutivas com contribuições a entidades privadas não enquadradas nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.0.00.00','OUTROS ENCARGOS PATRONAIS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.1.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.2.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.3.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.01.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.02.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.03.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.04.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.05.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.4.06.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.2.9.5.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.0.0.00.00','BENEFÍCIOS A PESSOAL','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal civil e militar , tais como para o pessoal civil: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxilia-alimentação, auxilia-transporte bem como outros decorrentes de acordo ou convenção coletiva no que se refere aos empregados públicos. Para os militares: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo as despesas com vencimentos, soldos e quaisquer outras vantagens pecuniárias, bem como as despesas relacionadas aos benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.0.00.00','BENEFÍCIOS A PESSOAL - RPPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.1.1.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.0.00.00','BENEFÍCIOS A PESSOAL - RGPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídos deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.2.1.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídos ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.0.00.00','BENEFÍCIOS A PESSOAL - MILITAR','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.3.3.1.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.0.0.00.00','CUSTO DE PESSOAL E ENCARGOS','Compreende a variação patrimonial diminutiva relativa à pessoal e encargos utilizados na produção de bens ou serviços, sendo registrada apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS','Compreende as variações patrimoniais diminutivas relativas à pessoal e encargos apropriadas às mercadorias, sendo registradas apenas no momento da venda destas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO ','Compreende as variações patrimoniais diminutivas relativas a pessoal e encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.01.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL  ','Registra as variações patrimoniais diminutivas relativas a pessoal apropriadas as mercadorias, sendo registradas apenas no momento da venda destas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.1.1.02.00','CUSTO DE MERCADORIAS VENDIDAS – ENCARGOS  ','Registra as variações patrimoniais diminutivas relativas a encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.01.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL','Registra outras variações patrimoniais diminutivas relativas a pessoal , utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.2.1.02.00','CUSTO DE PRODUTOS VENDIDOS – ENCARGOS','Registra outras variações patrimoniais diminutivas relativas a encargos , utilizadas na produção de bens, sendo registradas apenas no momento da venda destes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registradas apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.01.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL ','Compreende outras variações patrimoniais diminutivas relativas a pessoal, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.8.3.1.02.00','CUSTO DE SERVIÇOS PRESTADOS –   ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas a encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.0.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.2.0.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS','Compreende as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.2.1.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.0.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.9.1.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.01.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL ','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.1.9.1.1.02.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.0.0.0.00.00','BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreendem as variações patrimoniais diminutivas relativas às aposentadorias, pensões, reformas, reserva remunerada e outros benefícios previdenciários de caráter contributivo, do regime próprio da previdência social - RPPS e do regime geral da previdência social – RGPS, bem como as ações de assistência social, que são políticas de seguridade social não contributiva, visando ao enfrentamento da pobreza, a garantia dos mínimos sociais, ao provimento de condições para atender contingencias sociais e a universalização dos direitos sociais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.0.0.00.00','APOSENTADORIAS E REFORMAS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.0.00.00','APOSENTADORIAS - RPPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.01.00','PROVENTOS - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas com Aposentadoria de Pessoal Civil concedidas. ','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.02.00','ABONO PROVISÓRIO','Registra as Variações Patrimoniais Diminutivas realizadas com Abono Provisório. ','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.03.00','APOSENTADORIAS PENDENTES DE APROVACAO - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas com Aposentadorias de Pessoal Civil Concedidas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.06.00','13º. SALARIO – PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de 13 Salário - Pessoal Civil','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.07.00','GRATIFICAÇÃO TEMPO DE SERVIÇO - ANUÊNIO CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Gratificação tempo de Serviço = Anuênio Civil','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.10.00','VANTAGENS INCORPORADAS - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Vantagens Incorporadas - Pessoal Civil','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.11.00','PROVENTOS ORIGINÁRIAS DE GRATIFICAÇÕES POR EXERCÍCIO DE FUNÇÕES','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Proventos Originárias de Gratificações por Exercício de Funções.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.12.00','PROVENTOS ORIGINÁRIAS DE GRATIFICAÇÕES POR EXERCÍCIO DE CARGO','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Proventos Originárias de Gratificações por Exercício de Cargo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.15.00','GRATIFICAÇÕES ESPECIAIS A APOSENTADOS','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Gratificações Especiais a Aposentados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.16.00','COMPLEMENTAÇÃO DE APOSENTADORIAS','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Complementação de Aposentadorias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.70.00','SENTENÇAS JUDICIAIS DE BENEFÍCIOS PREVIDENCIÁRIOS PESSOAL CIVIL - RPPS','Registra as Variações Patrimoniais Diminutivas realizadas a titulo de Sentenças Judiciais de Benefícios Previdenciários Pessoal Civil - RPPS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.1.1.99.00','OUTRAS APOSENTADORIAS','Registra as Variações Patrimoniais Diminutivas Realizadas com outras Aposentadorias não Classificáveis nos subitens anteriores, e/ou valores relativos a integração de Balancetes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.0.00.00','APOSENTADORIAS - RGPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RGPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.2.1.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidos pelo RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.0.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.01.00','PROVENTOS - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente proventos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.02.00','GRATIFICAÇÃO TEMPO DE SERVIÇO-ANUÊNIO MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Gratificação Tempo de Serviço - Anuênio Militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.04.00','AJUDA DE CUSTO (TRANSF. P/RESERVA REM.)','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Ajuda de Custo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.05.00','ADICIONAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Adicional Militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.06.00','COMPLEMENTAÇÃO APOSENTADORIA -  PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Complementação Aposentadoria - Pessoal Militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.07.00','VANTAGENS INCORPORADAS - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Vantagens Incorporadas - Pessoal Militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.08.00','AUXÍLIO-INVALIDEZ - PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Auxílio invalidez Pessoal Militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.09.00','13º. SALARIO PESSOAL MILITAR','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente 13 Salário Pessoal Militar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.70.00','SENTENÇAS JUDICIAIS DE BENEFÍCIOS PREVIDENCIÁRIOS PESSOAL MILITAR - RPPS','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente  Sentenças Judiciais Benefícios Previdenciários Pessoal Militar - RPPS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.3.1.99.00','OUTRAS REFORMAS','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares, especificamente Outras Reformas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.9.0.00.00','OUTRAS APOSENTADORIAS','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.1.9.1.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.0.0.00.00','PENSÕES','Compreendem os benefícios da previdência social que garantem uma renda aos dependentes do segurado falecido.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.0.00.00','PENSÕES - RPPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.1.1.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.0.00.00','PENSÕES - RGPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social –RGPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.2.1.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social - RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.0.00.00','PENSÕES - MILITAR','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.3.1.00.00','PENSÕES - MILITAR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.9.0.00.00','OUTRAS PENSÕES','Compreende as variações patrimoniais diminutivas provenientes de outras pensões.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.2.9.1.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de outras pensões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.0.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem os benefícios de prestação continuada','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Compreendem os benefícios de prestação continuada ao idoso e renda mensal vitalícia por idade.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada e renda mensal vitalícia por idade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.1.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Registra o benefício de prestação continuada que garante 1 (um) salário mínimo mensal ao idoso , que comprove não possuir meios de prover a própria manutenção e nem de tê-la provida por sua família.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.0.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia – invalidez','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.1.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia – invalidez. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.2.1.01.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Registra o beneficio de prestação continuada que garante 1 (um) salário mínimo mensal a pessoa portadora de deficiência, que comprove não possuir meios de prover a própria manutenção e nem de tê-la provida por sua família.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.9.0.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem outros benefícios de prestação continuada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.3.9.1.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','Registra outros benefícios de prestação continuada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.0.0.00.00','BENEFÍCIOS EVENTUAIS','Compreendem as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de nascimento, morte, situações de vulnerabilidade temporária e de calamidade pública. As provisões relativas a programas, projetos, serviços e benefícios diretamente vinculados ao campo da saúde, educação, integração nacional e das demais políticas setoriais não se incluem na modalidade de benefícios eventuais da assistência social.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.1.0.00.00','AUXÍLIO POR NATALIDADE','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.1.1.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.2.0.00.00','AUXÍLIO POR MORTE','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.2.1.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.3.0.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.3.1.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.0.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.4.1.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - COSOLIDAÇÃO','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar - lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.9.0.00.00','OUTROS BENEFÍCIOS EVENTUAIS','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.4.9.1.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.0.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiárias.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.5.0.1.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.0.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários ou assistenciais, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.01.00','AUXILIO FUNERAL ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL FALECIDO, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO SERVIDOR. TAMBEM SERA DEVIDO AUXILIO FUNERAL, EM CASO DE FALECIMENTO DE SERVIDOR EM SERVICO FORA DO LOCAL DE TRABALHO, INCLUSIVE NO EXTERIOR E AS DESPESAS DE TRANSPORTE DO CORPO (TRASLADO) CORRERAO A CONTA DOS RECURSOS DA UNIAO, AUTARQUIA OU FUNDACAO PUBLICA (ART. 228, LEI 8112/90)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.02.00','AUXILIO FUNERAL INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO INATIVO CIVIL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.03.00','AUXILIO NATALIDADE ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.04.00','AUXILIO NATALIDADE INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO CIVIL,DEVIDO, A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO E NASCIMENTO DE FILHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.05.00','AUXILIO RECLUSAO ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.06.00','AUXILIO RECLUSAO INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.07.00','AUXILIO FUNERAL PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.08.00','AUXILIO RECLUSAO PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.09.00','AUXILIO NATALIDADE PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE A PENSIONISTA CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.10.00','AUXILIO-DOENCA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO-DOENCA, DEVIDO AO SEGURADO QUE FICAR INCAPACITADO PARA O TRABALHO','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.11.00','SALARIO MATERNIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-MATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI 6.136/74, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.00','SALARIO-FAMILIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.01','SALARIO FAMILIA - ATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA - ATIVO PESSOAL CIVIL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.02','SALARIO FAMILIA-INATIVO PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDOS A INATIVOS PESSOAL CIVIL','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.1.1.12.03','SALARIO FAMILIA-PENSIONISTA PESSOAL CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA DEVIDO A PENSIONISTA PESSOAL CIVIL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.2.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.01.00','AUXILIO FUNERAL ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO EX-SERVIDOR.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.02.00','AUXILIO FUNERAL INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUITIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO MILITAR, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO INATIVO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.03.00','AUXILIO NATALIDADE ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE-ATIVO MILITAR DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.04.00','AUXILIO NATALIDADE INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE INATIVO MILITAR DEVIDO A SERVIDORA,CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.05.00','AUXILIO RECLUSAO ATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.06.00','AUXILIO RECLUSAO INATIVO MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.07.00','AUXILIO RECLUSAO PENSIONISTA MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO MILITAR, AFASTADO POR MOTIVO DE PRISAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.08.00','AUXILIO FUNERAL PENSIONISTA MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA MILITAR EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS DEVIDO TAMBEM A TERCEIRO E CUSTEAR COMPROVADAMENTE AS DESPESAS COM FUNERAL DO PENSIONISTA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.09.00','AUXILIO NATALIDADE PENSIONISTA MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE PENSIONISTA MILITAR DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO DO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.00','SALARIO-FAMILIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO-FAMILIA','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.01','SALARIO FAMILIA-ATIVO PESSOAL MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA-ATIVO PESSOAL MILITAR.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.02','SALARIO FAMILIA - INATIVO PESSOAL MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVASCOM SALARIO FAMILIA A INATIVOS MILITARES, QUANDO O PAGAMENTO FOR EFETUADO PELA ENTIDADE CONSTITUIDA PARA ADMINISTRAR O RPPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.3.1.10.03','SALARIO FAMILIA - PENSIONIOSTA PESS. MILITAR','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIO FAMILIA A PENSIONISTAS MILITARES, QUANDO O PAGAMENTO FOR EFETUADO PELA ENTIDADE CONSTITUIDA PARA ADMINISTRAR O RPPS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.9.0.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.2.9.9.1.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.0.0.0.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende o somatório das variações patrimoniais diminutivas com manutenção e operação da maquina pública, exceto despesas com pessoal e encargos que serão registradas em grupo específico (despesas de pessoal e encargos). Compreende: diárias, material de consumo, material de distribuição gratuita, passagens e despesas com locomoção, serviços de terceiros, arrendamento mercantil operacional, aluguel, depreciação, amortização, exaustão, entre outras.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.0.0.00.00','USO DE MATERIAL DE CONSUMO','Compreende as variações patrimoniais diminutivas provenientes da distribuição do material de consumo. Um material é considerado de consumo quando for de duração inferior a dois anos, frágil, perecível, incorporável, transformável ou cuja finalidade seja para consumo imediato ou para reposição.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.0.00.00','CONSUMO DE MATERIAL','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.01.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVOS','Registra as variações Patrimoniais Diminutivas provenientes da utilização de Combustíveis para motores a combustão interna de veículos rodoviários, tratores em geral, embarcações diversas e grupos geradores estacionados ou transportáveis, e todos os óleos lubrificantes destinados aos sistemas hidráulicos hidramáticos de caixa de transmissão de força e graxas grafitadas para altas e baixas temperaturas. aditivos - álcool hidratado - fluído para amortecedores - fluido para transmissão hidráulica - gasolina - graxas - óleo diesel - óleo para carter - óleo para freio e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.03.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','Registra as variações patrimoniais diminutivas provenientes da utilização de gás de uso industrial, de tratamento de água, de iluminação, de uso médico, bem como gases nobres para uso em laboratório cientifico, tais como: acetileno - carbônico freon - helio - hidrogênio - Liquefeito de petróleo - nitrogênio - oxigênio e outros. Registra, ainda, o valor das despesas com gás, pó químico, água pressurizadas e outros materiais utilizado nas recargas de Extintores de Incêndio.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.04.00','EXPLOSIVOS E MUNISSÕES','Registra as variações Patrimoniais Diminutivas provenientes da utilização de cargas de projeção em peças de artilharia, mísseis guiados e não guiados, capsulas ou estojos para recarga e explosivos de uso Militar e Paramilitar. balas e similares - estopim - explosivos, tais como: artefatos explosivos - artigos pirotécnicos - capsulas de detonação - dinamite - espoleta - fogos de artifício - granada - pólvora e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.05.00','ALIMENTOS PARA ANIMAIS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de alimentos destinados a gado bovino, equino, muar, e bufalino, caprinos, suínos, ovinos, aves de qualquer espécie, como também para animais silvestres em cativeiro (jardins zoológicos ou laboratórios) e outros. alfafa - alpiste - capim verde - farelo - farinhas em geral - fubá grosso - milho em grão - ração balanceada - sal mineral - suplementos vitamínicos e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.06.00','GENEROS ALIMENTACAO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de gêneros de alimentação ao natural, beneficiados ou conservados. açúcar - adoçante - água mineral - bebidas - café - carnes em geral - cereais - chás - condimentos - frutas - gelo - legumes - refrigerantes -sucos - temperos - verduras e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.07.00','ANIMAIS PARA PESQUISA E ABATE','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de animais para pesquisa e abate. Incluem-se nesta classificação os peixes e mariscos, todas as espécies de mamíferos, abelhas para estudos, pesquisa e produção de Mel, bem assim qualquer outro animal destinado a estudo genético ou alimentação. boi - cabrito - cobaias em geral - macaco - rato - rã e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.08.00','MATERIAL FARMACOLÓGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de medicamentos ou componentes destinados a manipulação de drogas medicamentosas. medicamentos - soro - vacinas e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.09.00','MATERIAL ODONTOLÓGICO','Registra as Variações Patronais Diminutivas provenientes da utilização de materiais para pacientes da área odontológica, bem como os utilizados indiretamente pelos protéticos na convecção de próteses diversas. agulhas - amalgama - anestésicos - broca - cimento odontológico - espátula odontológica - filmes para raio X - platina - resinas odontológicas - seringas - sugador e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.10.00','MATERIAL QUIMÍCO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os elementos ou compostos químicos destinados ao fabrico de Produtos químicos, análises laboratoriais, bem como aqueles destinados ao combate de pragas ou opizootias. ácidos - Inseticidas - produtos químicos para tratamento de água - reagentes químicos - sais - solventes - substâncias utilizadas para combater insetos, fungos e bactérias e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.11.00','MATERIAL DE COUDELARIA OU DE USO ZOOTÉCNICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais utilizados no arreamento de animais destinados a montaria, com exceção da sela, como também aqueles destinados ao adestramento de cães de guarda ou outro animal domestico. argolas de metal - arreamento - barrigueiras - bridões - cabrestos - cinchas - Cravos - escovas para animais - estribos - ferraduras - mantas de pano - material para apicultura - material de ferragem e contenção de animais - peitorais -raspadeiras e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.13.00','MATERIAL DE CAÇA E PESCA','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais de caça e pesca.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.14.00','MATERIAL EDUCATIVO E ESPORTIVO','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais consumidos diretamente nas atividades educativas e esportivas de crianças e adultos. apitos - bolas - bonés - botas especiais - brinquedos educativos - calções - camisas de malha – chuteiras – cordas – esteiras – joelheiras – luvas – materiais pedagógicos – meias – óculos para motociclistas – patins – quimonos – raquetes – redes para pratica de esportes – tênis e sapatilhas – tornozeleiras – touca para natação e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.15.00','MATERIAL PARA FESTIVIDADESE HOMENAGENS','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais de consumo utilizados em festividades e homenagens, incluindo artigos para decoração e Buffet. arranjos e coroas de flores - bebidas - doces - salgados - placas comemorativas (exceto as placas para distribuição gratuita) e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.16.00','MATERIAL DE EXPEDIENTE','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais aplicados diretamente nos trabalhos administrativos, nos escritórios públicos, nos centros de estudos e pesquisas, nas escolas, nas universidades etc. agenda - alfinete de aço - almofada p/carimbos - apagador - apontador de lápis - arquivo p/disquete - bandeja para papeis - bloco p/rascunho - bobina papel p/calculadoras - borracha - caderno - caneta -capa de processo - carimbos em geral - cartolina - classificador -clipe - cola - colchete - corretivo - envelope - espátula - estêncil -estilete - extrator de grampos - fita adesiva - fita p/maquina de escrever e calcular - giz - goma elástica - grafite - grampeador -grampos - guia p/arquivo - guia de endereçamento postal - impressos e formulários em geral - intercalador p/fichário - lacre - lápis -lapiseira - limpa tipos - livros de ata, de ponto e de protocolo -papeis - pastas em geral - percevejo - perfurador - pinça - placas de acrílico - plásticos - porta-lápis - registrador - régua - selos p/correspondência - tesoura - tintas - toner - transparências - etiquetas e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.17.00','MATERIAL DE PROCESSAMENTO DE DADOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de suprimentos de ti, inclusive pecas para reposição. cartuchos de tinta - capas plásticas protetoras para micros e impressoras - cd-rom virgem - disquetes - etiquetas em formulários - contínuos -leitora/smartcard - mouse e teclado (reposição) - mouse pad - pecas e acessórios para computadores e periféricos - recarga de cartuchos de tinta - toner para impressoras a laser - cartões magnéticos - reposição de leitora/token pen-drive/outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.18.00','MATERIAIS E MEDICAMENTOS P/USO VETERINÁRIO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais e medicamentos para uso veterinário. vacinas – medicamentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.19.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais aplicados diretamente nas preservações, acomodações ou embalagens de qualquer produto. arame - barbante - caixas plásticas, de madeira, papelão e isopor -cordas - engradados - fitas de aço ou metálicas - fitas gomadoras -garrafas e potes - linha - papel de embrulho - papelão - sacolas - sacos - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.20.00','MATERIAL DE CAMA, MESA E BANHO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais utilizados em dormitórios coletivos, residenciais, hotéis, restaurantes etc. cobertores - colchas - colchonetes - fronhas - guardanapos - lençóis -toalhas - travesseiros - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.21.00','MATERIAL DE COPA E COZINHA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para refeitórios de qualquer tipo, cozinhas residenciais, de hotéis, de hospitais, de escolas, de universidades, de fabricas etc. abridor de garrafa - açucareiros - artigos de vidro e plástico -bandejas - coadores - colheres - copos - ebulidores - facas - farinheiras - fósforos - frigideiras - garfos - garrafas térmicas -paliteiros - panelas - panos de cozinha - papel alumínio - pratos -recipientes para água - suportes de copos p/cafezinho - tigelas -velas - xícaras - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.22.00','MATERIAL DE LIMPEZA E PRODUTOS DE HIGIENIZACAO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais destinados a higienização pessoal, de ambientes de trabalho, de hospitais etc. álcool etílico - anticorrosivo - aparelho de barbear descartável -balde plástico - bomba p/inseticida - capacho - cera - cesto p/lixo- creme dental - desinfetante - desodorizante - detergente - escova de dentes - escova p/roupas e sapatos - espanador - esponja - estopa -flanela - inseticida - lustra-móveis - mangueira - naftalina - para lixo - palha de aço - panos p/limpeza - papel higiênico - pasta para limpeza de utensílios – porta - sabão - removedor - rodo - sabão -sabonete - saco p/lixo - saponáceo - soda caustica - toalha de papel- vassoura - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.23.00','UNIFORMES, TECIDOS E AVIAMENTOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de uniformes ou qualquer tecido ou material sintético que se destine a confecção de roupas, com linhas de qualquer espécie destinadas a costuras e outros materiais de consumo empregados direta ou indiretamente na confecção de roupas. agasalhos - artigos de costura - aventais - blusas - botões - cadarços- calcados - calcas - camisas - capas - chapéus - cintos - elásticos -gravatas - guarda-pós - linhas - macacões - meias - tecidos em geral -uniformes militares ou de uso civil - zíperes - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.24.00','MATERIAL P/MANUT. E BENS IMÓVEIS/INSTALAÇÕES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para aplicação, manutenção e reposição de qualquer bem publico. amianto - aparelhos sanitários - arames liso e farpado - areia -basculante - boca de lobo - boia - brita - brocha - cabo metálico -cal - cano - cerâmica - cimento - cola - condutores de fios - conexões- curvas - esquadrias - fechaduras - ferro - gaxetas - grades -impermeabilizantes - isolantes acústicos e térmicos - janelas -joelhos - ladrilhos - lavatórios - lixas - madeira - marcos de concreto - massa corrida - niple - papel de parede - parafusos - - pecas p/elevadores, portões elétricos, ar condicionado central, etc- pias- pigmentos - portas e portais - pregos - rolos solventes - sifão -tacos - tampa p/vaso - tampão de ferro - tanque - tela de estuque -telha - tijolo - tinta - torneira - trincha - tubo de concreto -válvulas - verniz - vidro - aquecedores a gás e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.25.00','MATERIAL PARA MANUTENCAO DE BENS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de componentes, pecas, acessórios e sobressalentes para aplicação, manutenção e reposição em bens moveis em geral. cabos - chaves - cilindros p/maquinas copiadoras - compressor p/ar condicionado - mangueira p/fogão - pecas de reposição de aparelhos e maquinas em geral - materiais de reposição para instrumentos musicais - vidro de mesa e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.26.00','MATERIAL ELETRICO E ELETRONICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para aplicação, manutenção e reposição dos sistemas, aparelhos e equipamentos elétricos e eletrônicos. benjamins - bocais - calhas - capacitores e resistores - chaves de ligação - circuitos eletrônicos - condutores - componentes de aparelho eletrônico - diodos - disjuntores - eletrodos - eliminador de pilhas -espelhos para interruptores - fios e cabos - fita isolante - fusíveis- interruptores - lâmpadas e luminárias - pilhas e baterias - pinos e plugs - placas de baquelita - reatores - receptáculos - resistências -starts - suportes - tomada de corrente - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.27.00','MATERIAL DE MANOBRA E PATRULHAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo utilizados em campanha militar ou paramilitar, em manobras de tropas, em treinamento ou em ação em patrulhamento ostensivo ou rodoviário, em campanha de saúde publica etc. binóculo - carta náutica - cantil - cordas - flâmulas e bandeiras desinalizacao - lanternas - medicamentos de pronto-socorro - mochilas -piquetes - sacolas - sacos de dormir - sinaleiros - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.28.00','MATERIAL DE PROTECAO E SEGURANCA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo utilizados diretamente na proteção de pessoas ou bens públicos, para socorro de pessoas e animais ou para socorro de veículos, aeronaves e embarcações, assim como qualquer outro item aplicado diretamente nas atividades de sobrevivência de pessoas, na selva, no mar ou em sinistros diversos. botas - cadeados - calcados especiais - capacetes - chaves - cintos -coletes - dedais - guarda-chuvas - lona - luvas - mangueira de lona -mascaras - passadeira antiderrapante - óculos - cabina de papelão e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.29.00','MATERIAL PARA AUDIO, VIDEO E FOTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo de emprego direto em filmagem e revelação, ampliações e reproduções de sons e imagens. aetze especial p/chapa de papel - álbuns p/retratos - alto-falantes- antenas - artigos para gravação em acetato - filmes virgens - fitas virgens de áudio e vídeo - lâmpadas especiais - material p/radiografia, microfilmagem e cinematografia - molduras - papel p/revelação de fotografias - pegadores - reveladores - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.30.00','MATERIAL PARA COMUNICACOES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para comunicações, assim como os componentes, circuitos impressos ou integrados, pecas ou acessórios de reposição, chips, e partes de equipamentos de comunicação materiais para instalações: radiofônicas, radiotelegráficas, telegráficas e outros. - bateria para telefone celular- bloqueador telefônico - chave comutadora para telefone - fio para telefone - tomada para telefone - materiais para instalações radiofônicas - radiotelegráficas - telegráficas - outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.31.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de qualquer tipo de semente destinada ao plantio e mudas de plantas frutíferas ou ornamentais, assim como todos os insumos utilizados para fertilização. adubos - argila - plantas ornamentais - borbulhas - bulbos - enxertos- fertilizantes - mudas envasadas ou com raízes nuas - sementes -terra - tubérculos - xaxim - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.32.00','SUPRIMENTO DE AVIAÇÃO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de suplementos para avaliação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.33.00','MATERIAL PARA PRODUÇÃO INDUSTRIAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de matérias-primas utilizadas na transformação, beneficiamento e industrialização de um produto final. borracha - couro - matérias-primas em geral - minérios - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.34.00','SUPRIMENTOS PARA MAQ. E MOTORES NAVIOS E EMBARCAÇÕES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material para manutenção e reparo de maquinas e motores de navios, inclusive da esquadra, e de embarcações em geral.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.35.00','MATERIAL LABORATORIAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os utensílios usados em analises laboratoriais. almofarizes - bastões - bico de gás - cálices - corantes - filtros de papel - fixadoras - frascos - funis - garra metálica - laminas de vidro p/microscópio - lâmpadas especiais - luvas de borracha - metáfise metaloides p/analise - pinças - rolhas - vidraria: balão volumétrico - becker - conta-gotas - erlemeyer - pipeta - proveta - termômetro- tubo de ensaio - material de laboratório didático e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.36.00','MATERIAL HOSPITALAR','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para área hospitalar ou ambulatorial. agulhas hipodérmicas - algodão - cânulas - cateteres - compressa de gaze - drenos - esparadrapo - fios cirúrgicos - laminas p/ bisturi -luvas - seringas - termômetro clinico - e outros. .','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.37.00','SUPRIMENTOS DE ARMAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Suprimentos de Armamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.38.00','SUPRIMENTO DE PROTEÇÃO AO VOO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Suprimentos de proteção ao Voo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.39.00','MATERIAL PARA MANUTENCAO DE VEICULOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para aplicação e manutenção de veículos rodoviários, viaturas blindadas e tratores em geral. água destilada - amortecedores - baterias - borrachas - buzina - cabos de acelerador - cabos de embreagem - camará de ar - carburador completo - cifa - colar de embreagem - condensador e platinado - correias- disco de embreagem - ignição - junta homocinetica - lâmpadas e lanternas p/veículos - lonas e pastilhas de freio - mangueiras -material utilizado em lanternagem e pintura - motor de reposição -para-brisa - para-choque - platô - pneus - reparos - retentores -retrovisores - rolamentos - tapetes - válvula da marcha lenta e termostática - velas - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.40.00','MATERIAL BIOLÓGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material Biológico.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.41.00','MATERIAL PARA UTILIZAÇÃO EM GRÁFICA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os materiais de consumo de uso gráfico, tais como: chapas de offset - clichês - cola - espirais - fotolitos - logotipos - papel - solventes - tinta - tipos - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.42.00','FERRAMENTAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os tipos de ferramentas utilizadas em oficinas, carpintarias, jardins etc. alicate - broca - caixa p/ferramentas - canivete - chaves em geral -enxada - espátulas - ferro de solda - foice - lamina de serra - lima -machado - martelo - pa - picareta - ponteira - prumo - serrote -tesoura de podar - trena - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.43.00','MATERIAL PARA REABILITAÇÃO PROFISSIONAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para programas de reabilitação profissional. bastões - bengalas - joelheiras - meias elásticas e assemelhados -óculos - orteses - pesos - próteses, instrumentos de trabalho e implementos profissionais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.44.00','MATERIAL DE SINALIZAÇÃO VISUAL E OUTROS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para identificação, sinalização visual, endereçamento e outros. placas de sinalização em geral, tais como, placas indicativas para o setores e seções, placas para veículos, plaquetas para tombamento de material, placas sinalizadoras de trânsito, cones sinalizadores de trânsito, crachás, botons identificadores para servidores e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.45.00','MATERIAL TÉCNICO PARA SELEÇÃO E TREINAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais técnicos utilizados em processos de seleção e treinamento pela própria unidade gestora ou para distribuição não gratuita, tais como: apostilas e similares - folhetos de orientação - livros - manuais explicativos para candidatos - e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.46.00','MATERIAL BIBLIOGRAFICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material bibliográfico tais como: jornais - revistas - periódicos em geral - anuários médicos - anuário estático - livros em geral e outros, podendo estar na forma de cd-rom e os materiais bibliográficos para bibliotecas publicas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.48.00','BENS MÓVEIS NÃO ATIVÁVEIS','Registra as Variações Patrimoniais Diminutivas provenientes da aquisição de bens moveis de natureza permanente não ativáveis, ou seja, aqueles considerados como despesa operacional, para fins de dedução de imposto de renda, desde que atenda as especificações contidas no artigo 301 do rir (regulamento de imposto de renda). esta conta é utilizada exclusivamente pelas unidades regidas pela lei 6404/76.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.49.00','BILHETES DE PASSAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de bilhetes de passagem para guarda em estoque.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.50.00','BANDEIRAS, FLÂMULAS E INSIGNIAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de bandeiras, flâmulas e insígnias, a saber: brasões, escudos, armas da republica, selo nacional e outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.51.00','DISCOTECAS E FILMOTECAS NÃO IMOBILIZÁVEL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de discotecas e filmotecas não imobilizável.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.52.00','MATERIAL DE CARÁTER SECRETO OU RESERVADO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material de caráter secreto ou reservado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.53.00','MATERIAL METEOROLÓGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material meteorológico, tais como: radiossondas, balão de látex, etc.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.54.00','MATERIAL P/MANUT.CON SERV.DE ESTRADAS E VIAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para reparos, recuperações e adaptações de estradas, ferrovias e rodovias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.55.00','SELOS PARA CONTROLE FISCAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de selos para controle fiscal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.56.00','MATERIAL DE MARCAÇÃO DA FAUNA SILVESTRE','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material de Marcação da Fauna Silvestre.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.57.00','MATERIAL DE CONSUMO - REPARTIÇÕES NO EXTERIOR','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material de Consumo - repartições no exterior.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.58.00','SOBRESSALENTES PARA MÁQUINAS E EQUP. PARA PRODUÇÃO INDUSTRIAL','Registra as Variações Patrimoniais Diminutivas provenientes de Sobressalentes para Máquinas e Equipamentos para Produção Industrial.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.70.00','AQUISIÇÃO DE SOFTWARES DE BASE','Registra as Variações Patrimoniais Diminutivas provenientes da aquisição de Softwares de Base.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.71.00','MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO','Registra as Variações Patrimoniais Diminutivas provenientes de Materiais para Conservação e Manutenção de Bens de uso Comum do Povo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.98.00','SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS','Registra as Variações Patrimoniais Diminutivas provenientes de Sentenças Judiciais de Fornecedores de Materiais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.1.1.99.00','OUTROS MATERIAIS DE CONSUMO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de outros materiais de consumo que não se enquadrem nas rubricas anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.0.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.01.00','MERCADORIAS DOADAS','Registra as variações patrimoniais diminutivas provenientes da utilização de produtos adquiridos com a finalidade de doação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.02.00','MATERIAL DESTINADO À ASSISTÊNCIA SOCIAL','Registra as variações patrimoniais diminutivas provenientes da utilização de mat.de saúde(farmacológico,odontológico,hospitalar,medicamentos,órtese e prótese),gêneros alimentícios, mater.de cama,mesa,copa,cozinha,limpeza,higienização, uniformes, tecidos, aviamentos,manut.mov/imov.,ferramentas e outros distinados a assistencia social.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.03.00','MATERIAL EDUCACIONAL E CULTURAL','Registra as variações patrimoniais diminutivas provenientes da utilização de material educacional,(material escolar, didático, técnico, material p/áudio, vídeo e foto)e material cultural (material religioso e esportivo).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.05.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATE.DE ACONDIC.E EMBALAGEM.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.04.00','MATERIAL PARA CERIMONIAL','Registra as variações patrimoniais diminutivas provenientes da aquisição de materiais oferecidos a autoridades a titulo de homenagem.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.06.00','MATERIAL PARA DIVULGAÇÃO','Registra as variações patrimoniais diminutivas provenientes da utilização de material para publicidade e divulgação de programas do governo, para conscientizacao social. ex: camisetas, bonés, chaveiros, canetas, botons, com logomarcas,folders,cartazes,cartilhas e manuais,etc.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.12.00','MATERIAL DESTINADO A CONTRIBUINTE','Registra as variações patrimoniais diminutivas provenientes da utilização de material (cd-rom, formulários, etc.) para distribuição aos contribuintes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.13.00','MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS','Registra as Variações Patrimoniais Diminutivas provenientes da distribuição de Material para Identificação de Beneficiários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.1.2.1.99.00','OUTROS MATERIAIS DE DISTRIBUIÇÃO GRATUITA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE MATERIAIS PARA DISTRIBUICAO GRATUITA, NÃO CONTEMPLADOS EM RUBRICAS ESPECIFICAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.0.0.00.00','SERVIÇOS','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços fornecidas à entidade governamental.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.0.00.00','DIÁRIAS','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.00.00','DIÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.01.00','DIARIAS  PESSOAL CIVIL','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DE PESSOAL CIVIL,COBRINDO ALIMENTACAO, POUSADA E LOCOMOCAO URBANA DO SERVIDOR PUBLICO OU CELETISTA QUE SE DESLOCAR DE SUA SEDE EM OBJETO DE SERVICO, EM CARATER EVENTUAL OU TRANSITORIO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.02.00','DIARIAS - PESSOAL MILITAR','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DECORRENTES DO DESLOCAMENTO DO MILITAR DA SEDE DE SUA UNIDADE POR MOTIVO DE SERVICO, DESTINADAS AA INDENIZACAO DAS DESPESAS DE ALIMENTACAO E POUSADA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.03.00','DIARIAS - COLABORADORES EVENTUAIS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS PAGAS A PRESTADORES DE SERVICOS DE CARATER EVENTUAL, SEM VINCULO COM A ADMINISTRACAO PUBLICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.1.1.04.00','DIARIAS A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS A MEMBROS DE ORGAOS DE DELIBERACAO COLETIVA (CONSELHOS).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.0.00.00','SERVIÇOS TERCEIROS - PF','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.01.00','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.02.00','PERICIAS','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.03.00','AUDITORIA EXTERNA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE AUDITORIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.04.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.05.00','SERVICOS MEDICOS E ODONTOLOGICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS MEDICOS E ODONTOLOGICOS PRESTADOS POR PESSOA FISICA, SEM VINCULO EMPREGATICIO. CONSULTAS - RAIO X - TRATAMENTO ODONTOLOGICO - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.06.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL E TREINAMENTO, POR PESSOA FISICA, INCLUSIVE A GRATIFICACAO POR ENCARGO DE CURSO OU CONCURSO, NORMATIZADA PELO ART. 76-A, DA LEI 8112/90 E O DECRETO 6114/2007, BOLSA SENIOR (SERVIDORES APOSENTADOS DO ORGAO) BOLSA DE MULTIPLICADORES (SERVIDORES DA ATIVA DO ORGAO).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.07.00','COMUNICACAO EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COMUNICACAO GERAL PRESTADOS POR PESSOA FISICA, TAIS COMO: CONFECCAO DE MATERIAL P/ COMUNICACAO VISUAL; GERACAO DE MATERIAS PARA DIVULGACAO POR MEIO DOS VEICULOS DE COMUNICACAO; E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.08.00','LIMPEZA E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LIMPEZA E CONSERVACAO DE BENS IMOVEIS. DEDETIZACAO - FAXINA - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.09.00','SERVICOS DOMESTICOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DOMESTICOS PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, TAIS COMO: COZINHA - LAVAGEM DE ROUPAS - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.10.00','VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.11.00','MANUTENCAO E CONSERVACAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.12.00','CONDOMINIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS CONDOMINIAIS A CONTA DO LOCATORIO, QUANDO PREVISTAS NO CONTRATO DE LOCACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.13.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR: CORRETORES - DESPACHANTES - LEILOEIROS - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.14.00','DIREITOS AUTORAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE DIREITOS AUTORAIS DE PROPRIEDADE DE TERCEIROS SOBRE OBRAS CIENTIFICAS, LITERARIAS, ETC, EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO. REGISTRA O VALOR REFERENTE A UTILIZACAO DE SERVICOS DECORRENTES DE INCENTIVOS AOS AUTORES A TITULO DE ROYALTIES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.15.00','SERVICOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PROFISSIONAIS TECNICOS, NAS SEGUINTES AREAS: ADMINISTRACAO - ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA -ENGENHARIA - ESTATISTICA E OUTRAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.16.00','ESTAGIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR ESTUDANTES NA CONDICAO DE ESTAGIARIOS OU MONITORES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.18.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NA MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.19.00','CONFERENCIAS, EXPOSICOES E ESPETACULOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR CONFERENCISTAS, EXPOSITORES E ARTISTAS PELOS SERVICOS PRESTADOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.20.00','ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ALUGUEL DE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, OS DISPENDIOS DE GARANTIA DOS ESTOQUES ARMAZENADOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.21.00','LOCACOES','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE LOCACAO DE BENS MOVEIS E IMOVEIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.22.00','FORNECIMENTO DE ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE REFEICOES PREPARADAS,INCLUSIVE LANCHES E SIMILARES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.23.00','SERVICOS DE CARATER SECRETO OU RESERVADO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE CARATER SIGILOSO CONSTANTES EM REGULAMENTO DO ORGAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.24.00','SERVICOS DE REABILITACAO PROFISSIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO, COMO OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE) OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE PROFISSIONAL PARA MINISTRAR CURSO PROFISSIONALIZANTE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.25.00','SERVICOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE ASSISTENCIA SOCIAL PRESTADOS POR PESSOA FISICA SEM VINCULO EMPREGATICIO A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES,TAIS COMO AJUDA DE CUSTO SUPLETIVA, GENEROS ALIMENTICIOS, DOCUMENTACAO, TRANSPORTE E SEPULTAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.26.00','SERV. DE APOIO ADMIN., TECNICO E OPERACIONAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA, TAIS COMO: ASSISTENCIA TECNICA - CAPINA - JARDINAGEM - OPERADORES DE MAQUINAS E MOTORISTAS - RECEPCIONISTAS - SERVICOS AUXILIARES - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.27.00','SERV. DE CONSERV. E REBENEFIC. DE MERCADORIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE NATUREZA EVENTUAL PRESTADOS POR PESSOA FISICA NA CONSERVACAO E REBENEFICIAMENTO DE MERCADORIAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.28.00','CONFECCAO DE MATERIAL DE ACONDIC. E EMBALAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA FISICA NA CONFECCAO DE: BOLSAS - CAIXAS - MOCHILAS - SACOLAS - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.29.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COSTUREIRAS, ALFAIATES E AFINS UTILIZADOS NA CONFECCAO DE UNIFORMES, BANDEIRAS, FLAMULAS, BRA-SOES E ESTANDARTES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.30.00','FRETES E TRANSPORTES DE ENCOMENDAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS POR PESSOA FISICA EM: FRETES E CARRETOS - REMESSA DE ENCOMENDAS - TRANSPORTE DE MERCADORIASE PRODUTOS - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.31.00','JETONS E GRATIFICACOES A CONSELHEIROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA PARTICIPACAO EM ORGAOS DE DELIBERACOES COLETIVAS(CONSELHOS).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.34.00','SERVICOS DE AUDIO, VIDEO E FOTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE FILMAGENS, GRAVACOES E FOTOGRAFIAS, PRESTADOS POR PESSOA FISICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.35.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E SERVICOS DE CARTORIO, QUANDO A NOTA E EMITIDA EM NOME DO TABELIAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.36.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.37.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS, A LOCAIS ONDE NAO EXISTEM ESBELECIMENTOS COMERCIAIS HABILITADOS EM PRESTAR ESSE TIPO DE SERVICOS, PAGOS DIRETAMENTE A PESSOAS FISICAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.38.00','DESPESAS COM LOCOMOCAO','COMPREENDE AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE MEIOS DE TRANSPORTES AEREOS,TERRESTRES, FLUVIAIS OU MARITIMAS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOAS E SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.39.00','SERVICOS GRAFICOS E EDITORIAIS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SERVICOS DE ARTES GRAFICAS PRESTADOS POR PESSOA FISICA, BEM COMO COM SERVICOS EDITORIAIS DIVERSOS.  - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVICOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVICOS EDITORIAIS DIVERSOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.2.1.99.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE OUTROS SERVICOS PRESTADOS POR PESSOA FISICA, NAO CONTEMPLADOS EM ITENS ESPECIFICOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.0.00.00','SERVIÇOS TERCEIROS - PJ','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.01.00','CONSULTORIA E ASSESSORIA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.02.00','PERICIAS','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.03.00','AUDITORIA EXTERNA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE AUDITORIA EXTERNA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.04.00','COMUNICAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.05.00','PUBLICIDADE','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE PUBLICIDADE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.06.00','MANUTENÇÃO E CONSERVAÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.07.00','SERVIÇOS DE APOIO','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PÚBLICOS, NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.08.00','SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.09.00','SERVIÇOS DE ALIMENTAÇÃO','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE FORNECIMENTO DE ALIMENTACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.10.00','LOCAÇÕES','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.11.00','SERVIÇOS RELACIONADOS A TECNOLOGIA DA INFORMAÇÃO','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.12.00','SERVIÇOS DE TRANSPORTE','COMPRENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.13.00','ARMAZENAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE ALUGUELDE GALPOES, SILOS E OUTROS LOCAIS DESTINADOS A ARMAZENAGEM DE MERCADORIAS E PRODUTOS. INCLUI, AINDA, AS VARIAÇÕES PROVENIENTESS DE GARANTIA DOS ESTOQUES ARMAZENADOS E A UTILIZACAO DE SERVICO ESPECIALIZADO NA SOLUCAO DE GESTAO DE ESTOQUE, INCLUINDO GESTAO DE MATERIAIS E TRANSPORTE DE MATERIAIS E EQUIPAMENTOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.14.00','ASSINATURAS DE PERIODICOS E ANUIDADES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE ASSINATURAS DE TV (TVA CABO), JORNAIS, INCLUSIVE DIARIO OFICIAL, REVISTAS, RECORTES DE PUBLICAÇÕES, SOFTWARE, PODENDO ESTAR NA FORMA DE DISQUETE, CD-ROM, BOLE-INS E OUTROS QUE NÃO SE DESTINEM A COLECOES OU BIBLIOTECAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.15.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.16.00','CLASSIFICAÇÃO DE PRODUTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE CLASSIFICACAO DE PRODUTOS DE ORIGEM ANIMAL, MINERAL E VEGETAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.17.00','COMISSOES E CORRETAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE VALOR REFERENTE A COMISSOES E CORRETAGENS DECORRENTES DE SERVIÇOS PRESTADOS POR EMPRESAS DE INTERMEDIACAO E REPRESENTACAO COMERCIAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.18.00','CONDOMINIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DAS TAXAS CONDOMINIAIS A CONTA DO PROPRIETARIO, OU DO LOCATARIO, CONFORME PREVISTO NO CONTRATO DE LOCACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.19.00','CONFECÇÃO DE MATERIAL DE ACONDIC. E EMBALAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE CONFECCAO DE MATERIAIS DESTINADOS A PRESERVACAO, ACOMODACAO OU EMBALAGEM DE PRODUTOS DIVERSOS, TAIS COMO: - BOLSAS - CAIXAS - MOCHILAS - SACOLAS E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.20.00','CONFECÇÃO DE UNIFORMES, BANDEIRAS E FLAMULAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE CONFECCAO DE:- BANDEIRAS - BRASOES - ESTANDARTES - FLAMULAS - UNIFORMES ( INCLUSIVEAS DESPESAS RELACIONADAS COM AUXÍLIO FARDAMENTO DESCRITOS NA LEI NUM.8237/91) E OUTROS. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.21.00','DIREITOS AUTORAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIREITOS AUTORAIS SOBRE OBRAS CIENTIFICAS, LITERARIAS OU EM QUE A DIVULGACAO SEJA DE INTERESSE DO GOVERNO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.22.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVIÇOS UTILIZADOS NA INSTALACAO E MANUTENCAO DE: CONFERENCIAS - REUNIOES TECNICAS - CONGRESSOS - EXPOSICOES - FEIRAS - FESTEJOS POPULARES - FESTIVAIS - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.23.00','FESTIVIDADES E HOMENAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVIÇOS UTILIZADOS NA ORGANIZACAO DE EVENTOS, TAIS COMO: COQUETEIS - FESTAS DE CONGRACAMENTO - RECEPCOES - E OUTRAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.24.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DOS HONORARIOS ADVOCATICIOS DECORRENTES DO ONUS DA SUCUMBENCIA, ENTENDIDO ESTE COMO O ONUS QUE RECAI SOBRE A PARTE VENCIDA NUMA ACAO, PARA PAGAMENTO DOS HONORARIOS ADVOCATICIOS A VENCEDORA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.25.00','HOSPEDAGENS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE HOSPEDAGENS E ALIMENTACAO DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS OFICIAIS PAGOS DIRETAMENTE A ESTABELECIMENTOS HOTELEIROS (QUANDO NÃO HOUVER PAGAMENTO DE DIARIAS).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.26.00','PATROCINIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE PATROCINIOS A ATIVIDADES OU EVENTOS, DE NATUREZA CULTURAL, ESPORTIVA, EDUCACIONAL, AMBIENTAL, CIENTIFICA,COMUNITARIA, PROMOCIONAL ETC. PARA INFLUENCIAR FAVORAVELMENTE O PUBLICO E/OU ATINGIR OUTROS OBJETIVOS RELACIONADOS COM A PROMOCAO DE ATOS, OBRAS, PLANOS, AÇÕES, BENS OU SERVIÇOS. NÃO INCLUI O PATROCINIO DE MIDIA, ASSIM CONSIDERADOS AQUELES EM QUE O PROPONENTE E UM VEICULO DE COMUNICACAO OU UM GESTOR DE MEIOS OU INSTALAÇÕES QUE FUNCIONEM COMO VEICULO DE MIDIA ALTERNATIVA E AQUELES EM QUE UM VEICULO DE COMUNICACAO E O UNICO OU O PRINCIPAL REALIZADOR DA ACAO PATROCINADA, AINDA QUE O PROPONENTE DO PROJETO E PROVEDOR DE CONTEUDO PARA A ACAO PATROCINADA NÃO SE ENQUADRE NA DEFINICAO DE VEICULO DE COMUNICACAO OU MEIO DE MIDIA ALTERNATIVA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.27.00','PRODUCOES JORNALISTICAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE EDICAO DE JORNAIS, REVISTAS, NOTICIARIOS E MATERIAIS JORNALISTICOS PARA VIDEOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.28.00','PROMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NÃO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PÚBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVIÇOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.29.00','SEGUROS EM GERAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE PRÊMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PRÊMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.30.00','SELEÇÃO E TREINAMENTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL(CONCURSO PUBLICO) E TREINAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.31.00','SERV.MEDICO-HOSPITALAR,ODONTOL.E LABORATORIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS MEDICO-HOSPITALARES, ODONTOLOGICOS E LABORATORIAIS, PRESTADOS POR PESSOAS JURIDICAS SEM VINCULO EMPREGATICIO, TAIS COMO: ANALISES CLINICAS - CIRURGIAS - CONSULTAS - ECOGRAFIAS - ENDOSCOPIAS -ENFERMAGEM - ESTERILIZACAO - EXAMES DE LABORATORIO - RAIO X -TOMOGRAFIAS - TRATAMENTO ODONTOLOGICO - ULTRASSONOGRAFIAS - E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.32.00','SERVIÇOS BANCARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA APROPRIACAO DE COMISSOES, TARIFAS E REMUNERAÇÕES DECORRENTES DE SERVIÇOS PRESTADOS POR BANCOS E OUTRAS INSTITUICOES FINANCEIRAS, BEM COMO DESPESAS COM AGUARDA/CUSTODIA DE VALORES (COFRES DE ALUGUEL).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.33.00','SERVIÇOS DE ANALISES E PESQUISA CIENTIFICAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE ANALISES FISICO-QUIMICAS E PESQUISAS CIENTIFICAS, NÃO RELACIONADAS COM APOIO AO ENSINO. - ANALISES MINERAIS - ANALISES DE SOLO - ANALISES QUIMICAS - COLETA DE DADOS EM EXPERIMENTOS - TRATAMENTO E DESTINACAO DE RESIDUOS E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.34.00','SERVIÇOS DE APOIO DO ENSINO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS COM O OBJETIVO DE PROPORCIONAR O DESENVOLVIMENTO E O APERFEICOAMENTO DO ENSINO, EM TODOS OS NIVEIS, INCLUSIVE PESQUISAS EXPERIENCIAS E ASSEMELHADOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.35.00','SERVIÇOS DE ASSISTENCIA SOCIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE SERVIÇOS DE ASSISTENCIA SOCIAL PRESTADA A SERVIDORES, SEGURADOS CARENTES, ABRIGADOS, INTERNADOS E A SEUS DEPENDENTES, TAIS COMO: - AJUDA DE CUSTO SUPLETIVA - GENEROS ALIMENTÍCIOS - DOCUMENTACAO -TRANSPORTE E SEPULTAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.36.00','SERVIÇOS DE AUDIO VIDEO E FOTO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE FILMAGENS, GRAVAÇÕES, REVELAÇÕES, AMPLIAÇÕES E REPRODUCOES DE SONS E IMAGENS. - CONFECCAO DE ALBUNS - CONFECCAO DE CRACHAS FUNCIONAIS POR FIRMAS ESPECIALIZADAS - EMOLDURAMENTO DE FOTOGRAFIAS - IMAGENS DE SATELITES- REVELACAO DE FILMES - MICROFILMAGEM E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.37.00','SERVIÇOS DE CONFECÇÃO SELOS CONTROLE FISCAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE CONFECCAO DE SELOS/CHANCELAS PARA CONTROLE FISCAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.38.00','SERVIÇOS DE CONSERV. E REBENEF. DE MERCADORIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.39.00','SERVIÇOS DE CONTROLE AMBIENTAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE CONTROLE AMBIENTAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.40.00','SERVIÇOS DE COPIAS E REPRODUÇÃO DE DOCUMENTOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE COPIAS XEROGRAFICAS, INCLUSIVE A LOCACAO E A MANUTENCAO DE EQUIPAMENTOS REPROGRÁFICOS, COPIASE REPRODUCOES DE DOCUMENTOS E PUBLICAÇÕES EM GERAL, INCLUSIVE POR MEIO MAGNETICO E DIGITALIZACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.41.00','SERVIÇOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS PRESTADOS POR ENTIDADES DE ASSISTENCIA SOCIAL PARA ATENDER OS DEPENDENTES DE SERVIDORES DO ORGAO, HABILITADOS A USUFRUIREM DESSE BENEFICIO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.42.00','SERVIÇOS DE INCINERAÇÃO/DESTRUIÇÃO DE MATERIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.43.00','SERVIÇOS DE PRODUÇÃO INDUSTRIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATÉRIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.44.00','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.45.00','SERVIÇOS FUNERARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE REMOCOES, SEPULTAMENTOS E TRANSLADAÇÕES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.46.00','SERVIÇOS GRÁFICOS E EDITORIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVIÇOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVIÇOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVIÇOS EDITORIAIS DIVERSOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.47.00','SERVIÇOS JUDICIARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE AÇÕES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALÁRIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVIÇOS DE CARTORIO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.51.00','SERVIÇOS TECNICOS PROFISSIONAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NAS SEGUINTES AREAS: ADVOCACIA - ARQUITETURA - CONTABILIDADE - ECONOMIA - ENGENHARIA -ESTATISTICA E OUTRAS. EXCETO OS SERVIÇOS DE CONSULTORIA QUE DEVEM SER CLASSIFICADOS EM CONTA ESPECIFICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.52.00','TAXA DE ADMINISTRAÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVIÇOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE ADMINISTRACAO PATRIMONIAL DAS CONTRIBUIÇÕES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.54.00','LOCAÇÃO DE MAO-DE-OBRA','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PÚBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.55.00','ARRENDAMENTO MERCANTIL OPERACIONAL','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.56.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','COMPREENDE AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.3.1.99.00','OUTROS SERVIÇOS TERCEIROS - PJ','Compreende as variações patrimoniais diminutivas provenientes das demais prestação de serviços por pessoa jurídica fornecida a entidade governamental.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.4.0.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA – ART. 18 § 1, LC 101/00','Compreende a apropriação das despesas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.2.4.1.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.0.0.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','Compreende o decréscimo no beneficio de um bem durante o período contábil decorrente de depreciação, amortização e exaustão.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.0.00.00','DEPRECIAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.1.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.1.01.00','DEPRECIAÇÃO DE IMOBILIZADO','Registra a redução do valor dos bens tangíveis, do ativo imobilizado, pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.1.01.01','DEPRECIAÇÃO DE BENS MÓVEIS','Registra a redução do valor dos bens móveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.1.1.01.02','DEPRECIAÇÃO DE BENS IMÓVEIS','Registra a redução do valor dos bens imóveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.0.00.00','AMORTIZAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.1.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.1.01.00','AMORTIZAÇÃO DE IMOBILIZADO','Registra a redução do valor aplicado na aquisição de direitos, do ativo imobilizado, com existência ou exercício de duração limitada, ou cujo objeto seja bem de utilização por prazo legal ou contratualmente limitado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.2.1.02.00','AMORTIZAÇÃO DE INTANGÍVEL','Registra a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.3.0.00.00','EXAUSTÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.3.1.00.00','EXAUSTÃO - CONSOLIDAÇÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.3.3.1.01.00','EXAUSTÃO DE IMOBILIZADO','Registra a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.0.0.00.00','CUSTO DE MATERIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende a variação patrimonial diminutiva relativa a materiais, serviços e consumo de capital fixo utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.01.00','CUSTO DE MERCADORIAS VENDIDAS – MATERIAIS E SERVIÇOS','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL E SERVIÇOS NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.1.1.02.00','CUSTO DE MERCADORIAS VENDIDAS –  CONSUMO DE CAPITAL FIXO ','REGISTRA A APROPRIACAO DE CONSUMO DE CAPITAL FIXO NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.01.00','CUSTO DE PRODUTOS VENDIDOS – MATERIAIS E SERVIÇOS','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL E SERVIÇOS NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.2.1.02.00','CUSTO DE PRODUTOS VENDIDOS – CONSUMO DE CAPITAL FIXO','REGISTRA A APROPRIACAO DE CONSUMO DE CAPITAL FIXO NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.01.00','CUSTO DE SERVIÇOS PRESTADOS – MATERIAIS E SERVIÇOS','REGISTRA A APROPRIACAO DE CONSUMO DE MATERIAL E SERVIÇOS NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.3.8.3.1.02.00','CUSTO DE SERVIÇOS PRESTADOS – CONSUMO DE CAPITAL FIXO','REGISTRA A APROPRIACAO DE CONSUMO DE CAPITAL FIXO NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas com operações financeiras, tais como: juros incorridos, descontos concedidos, comissões, despesas bancarias e correções monetárias.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos contraídos com pessoas jurídicas de direito público ou privado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.0.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.01.00','JUROS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.02.00','ENCARGOS DA DIVIDA CONTR.C/INSTIT.FINANCEIRAS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM INSTITUICOES FINANCEIRAS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.1.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.3.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.3.01.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM A UNIÃO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.3.02.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM A UNIÃO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.3.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.01.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS ESTADOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.02.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS ESTADOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.4.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.01.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS MUNICÍPIOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.02.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS MUNICÍPIOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.1.5.99.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.0.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.1.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.1.01.00','JUROS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.2.1.02.00','ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA CONTRATADA NO EXTERIOR COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.0.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.3.1.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.4.1.01.00','JUROS S/ ADIANTAMENTOS BANCARIOS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS INCIDENTES SOBRE ANTECIPACOES DE CREDITOS CONTRATADAS COM BANCOS E OUTROS AGENTES FINANCEIROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.3.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.4.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.8.5.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.9.0.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.1.9.1.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','Compreende o montante de variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos contratuais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.1.01.00','JUROS DE MORA ','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.1.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.3.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.3.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.4.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.4.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.5.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.1.5.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.1.01.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.2.1.02.00','ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA DECORRENTE DE ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E/OU NAO CUMPRIMENTO DOS PRAZOS CONTRATUAIS DOS EMPRESTIMOS E FINANCIAMENTOS INTERNOS CONTRAIDOS COM PESSOAS JURIDICAS DE DIREITO PUBLICO OU PRIVADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.00','JUROS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.01','JUROS DE  SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.02','JUROS DE SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.01.03','JUROS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.00','MULTAS DEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.01','MULTAS DEDUTIVEIS SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.02','MULTAS DEDUTIVEIS  SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.02.03','MULTAS DEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.00','MULTAS INDEDUTIVEIS','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.01','MULTAS INDEDUTIVEIS  SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA FISICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.02','MULTAS INDEDUTIVEIS SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOA JURIDICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.03.03','MULTAS INDEDUTIVEIS SOBRE FORNECIMENTOS DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.00','OUTROS ENCARGOS DE MORA','COMPREENDE A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.01','OUTROS ENCARGOS S/  SERVICOS TERCEIROS - PESSOA FISICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS FISICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.02','OUTROS ENCARGOS S/ SERVICOS TERCEIROS - PESSOA JURIDICA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS COM PESSOAS JURIDICAS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.3.1.99.03','OUTROS ENCARGOS S/  FONECIMENTO DE BENS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.01.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.02.00','MULTAS DEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.4.1.03.00','MULTAS INDEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.2.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.3.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - UNIÃO','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E A UNIÃO.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.4.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - ESTADO','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.2.9.5.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - MUNICIPIO','Compreende A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.1.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Registra a Variação Patrimonial Diminutiva proveniente de Variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a Dívida Contratual. Ressalte-se será tratada como variação monetária apenas a Correção Monetária Pós-Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.1.02.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Dívida Contratual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.3.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.4.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.1.5.01.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.1.01.00','VARIAÇÕES MONETÁRIAS DA DIVIDA CONTRATUAL EXTERNA ','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.2.1.02.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA ','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Divida Contratual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.3.1.01.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA MOBILIÁRIA','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.1.01.00','VARIAÇÕES MONETARIAS DE DIVIDA MOBILIARIA EXTERNA ','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.4.1.02.00','VARIAÇÕES CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Divida Contratual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.00','OUTRAS VARIAÇÕES MONETARIAS','Compreende a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Dedutíveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Indedutíveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Precatórios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.1.99.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.01.00','OUTRAS VARIAÇÕES MONETARIAS','Compreende a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.01.01','ENCARGOS FINANCEIROS DEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Dedutíveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.01.02','ENCARGOS FINANCEIROS INDEDUTÍVEIS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Encargos Financeiros Indedutíveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.01.70','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Precatórios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.01.71','ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Tributos Renegociados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.3.02.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.01.00','OUTRAS VARIAÇÕES MONETARIAS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.4.02.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.01.00','OUTRAS VARIAÇÕES MONETARIAS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.3.9.5.02.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a Variação Patrimonial Diminutiva proveniente de Variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a Divida Contratual e Mobiliaria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.0.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.4.0.1.00.00','DESCONTOS FINANCEIROS CONCEDIDOS  - CONSOLIDAÇÃO','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','Compreende outras variações patrimoniais diminutivas financeiras, não abrangidas nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.0.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.1.1.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.0.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.2.1.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.4.9.9.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','Compreende o somatório das variações patrimoniais diminutivas com transferências inter governamentais, transferências intragovernamentais, transferências a instituições multigovernamentais, transferências a instituições privadas com ou sem fins lucrativos, transferências a convênios, transferências ao exterior e execuções orçamentárias delegadas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA -  INTRA OFSS','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.01.00','COTA CONCEDIDA ','Registra variação patrimonial diminutiva relativa ao valor da concessão de cota do órgão central de programação financeira para órgão setorial correspondente ao orçamento anual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.02.00','REPASSE CONCEDIDO  ','Registra a variação patrimonial diminutiva relativa ao valor dos recursos concedidos a titulo de transferências financeiras entre órgãos diferentes da administração direta ou indireta, correspondentes ao orçamento anual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.03.00','SUB-REPASSE CONCEDIDO','Registra a variação patrimonial diminutiva relativa ao valor total dos sub-repasses concedidos por transferências financeiras entre UG de um mesmo órgão.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.04.00','RECURSOS ARRECADADOS - CONCEDIDOS ','Registra a variação patrimonial diminutiva relativa ao valor concedido para outra UG, referente a recursos que foram arrecadados (classificados como receita), para pagamento de variação patrimonial diminutiva na UG recebedora.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA ','Registra o valor da cota diferida no processo de baixa dos recursos diferidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','Registra o valor da cota diferida no processo de inscrição dos recursos diferidos. ','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.1.2.13.00','CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','Registra a apropriação da transferência de créditos internos entre UG de mesma gestão referentes a contas com saldos financeiras em rotinas contábeis orçamentárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.0.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras, de bens ou valores, concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.00.00','TRANSFERÊNCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores, concedidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS CONCEDIDAS   ','Registra o valor total das ordens de transferências concedidas referentes a recursos vinculados que deverão permanecer na UG beneficiada.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS NAO FINANCEIROS','Registra a apropriação da transferência de créditos internos entre UG de mesma gestão referentes a contas não financeiras.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A CRÉDITO - CORRESPONDÊNCIA DE CRÉDITOS - SALDOS FINANCEIROS','Registra a apropriação da transferência de créditos internos entre órgãos correspondentes a saldos financeiros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.04','MOVIMENTO DE FUNDOS A CRÉDITOS - MOVIMENTO DE FUNDOS PRÓPRIOS ','Registra o somatório dos saldos credores incorporados por integração de balancetes, fusão, cisão.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das demais transferências financeiras concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.00','TRANSFERÊNCIAS  NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Compreende o valor das transferências concedidas de bens ou valores independentes da execução orçamentária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.01','TRANSFERÊNCIAS CONCEDIDAS DE BENS IMÓVEIS','Registra o valor das transferências de bens imóveis entre unidades do mesmo órgão .','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.02','DOAÇÕES CONCEDIDAS DE BENS IMÓVEIS','Registra o valor de doações de bens imóveis entre unidades de órgãos diferentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.03','TRANFERÊNCIAS CONCEDIDAS DE BENS MÓVEIS ','Registra o valor dos bens móveis concedidos por unidade localizada no exterior para outra unidade, no pais ou no exterior, do mesmo órgão.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.04','DOAÇÕES CONCEDIDAS DE BENS MÓVEIS ','Registra o valor dos bens móveis concedidos por unidade localizada no país para outra unidade, no país ou no exterior, de órgãos diferentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES ','Registra o total dos títulos e valores em circulação concedidos por unidade decorrente de transferência a outra unidade de mesma gestão.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','Registra a transferência de títulos da dívida ativa de uma UG para a o órgão jurídico competente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS  NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das demais transferências concedidas de bens ou valores independentes da execução orçamentária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.0.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes., exceto os decorrentes de alíquota de contribuição suplementar.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes exceto os decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.01.00','PLANO FINANCEIRO','Compreende o valor total dos valores concedidos pelo RPPS para cobertura de insuficiências financeiras, formação de reserva e outras necessidades financeiras, no âmbito do plano financeiro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Registra os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pelo ente federativo ao RPPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','Registra o somatório de eventuais aportes de recursos no RPPS para outras necessidades financeiras que não a cobertura de insuficiências financeiras e formação de reservas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','Compreende o valor total concedido ao RPPS para cobertura de déficit financeiro ou atuarial e outros aportes, no âmbito do plano previdenciário.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','Registra o somatório dos recursos necessários ao equilíbrio financeiro do plano previdenciário, ou seja, à cobertura de déficit entre as receitas e despesas previdenciárias, referentes ao exercício atual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','Registra os recursos orçamentários alocados para cobertura de déficit atuarial no exercício de referência, desde que não definidos por lei como contribuições suplementares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','Registra outros aportes financeiros para o RPPS com outras finalidades previdenciárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.0.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS','Compreende o valor das transferências para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.2.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS  – INTRA OFSS','Compreende o valor das transferências para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Compreende os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','Registra o montante do orçamento da Seguridade Social realocado da Saúde ou da Assistência Social para a Previdência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','Registra os valores das receitas do orçamento fiscal destinados para cobrir os déficits financeiros da Previdência','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pela União ao RGPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','Registra o somatório de eventuais aportes de recursos para o RGPS para outras necessidades financeiras.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes de transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.0.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.1.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.3.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.4.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.01.00','ICMS','Registra as variações patrimoniais diminutivas por meio de transferências constitucionais de ICMS aos municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.02.00','IPVA','Registra as variações patrimoniais diminutivas por meio de transferências constitucionais de IPVA aos municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.03.00','IPI-EXPORTAÇÃO','Registra as variações patrimoniais diminutivas por meio de transferências constitucionais de IPI-Exportação aos municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra as variações patrimoniais diminutivas por meio de transferências constitucionais de da contribuição de intervenção no domínio econômico (Emenda Constitucional nº 42, de 19/12/2003) aos municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.05.00','TRANSFERÊNCIA DA COTA-PARTE DA COMPENSAÇÃO FINANCEIRA','Registra as variações patrimoniais diminutivas por meio de transferências constitucionais da transferência da cota-parte da compensação financeira proveniente da exploração de recursos naturais aos municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.1.5.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE – REPASSE FUNDO A FUNDO','Transferência de Recursos do Estado para Programas de Saúde – Repasse Fundo a Fundo Registra o valor de receita da ransferência de recursos do Sistema Único de Saúde oriundo do Fundo Estadual de Saúde para o Fundo Municipal de Saúde Ações Básicas de Vigilância Sanitária, Atenção à Saúde dos Povos Indígenas, Programa de Assistência Farmacêutica Básica, Programa de Combate às Carências Nutricionais, Programa de Saúde da Família, Programa de Agentes Comunitários, Programa Nacional de Vigilância Epidemiológica e Controle de Doenças e outros).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.0.00.00','TRANSFERÊNCIAS AO FUNDEB','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.2.4.00.00','TRANSFERÊNCIAS AO FUNDEB - INTER-OFSS – ESTADO ','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, bem como a demais entidades, de bens e/ou valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (A empresa independente não pertence ao OFSS, mas pertence ao conceito de governamental).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.3.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.3.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra o valor utilizado para as transferências voluntárias não classificadas nas contas anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – ESTADO ','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra o valor utilizado para as transferências voluntárias não classificadas nas contas anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – MUNICÍPIO ','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra o valor utilizado para as transferências voluntárias não classificadas nas contas anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras a instituições privadas, inclusive de bens e valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs, OSCIPS e OS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs,OSCIPS E OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.01.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.02.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.1.1.03.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos que não tenham vínculos com administração pública.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos, que não tenham vínculos com a administração pública. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.3.2.1.01.00','SUBVENÇÕES ECONÔMICAS','Registra as VPDS com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.0.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, da quais o ente transferidor não participe.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.4.0.1.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, das quais o ente transferidor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.0.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.5.0.1.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.0.00.00','TRANSFERÊNCIAS AO EXTERIOR','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.6.0.1.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal, Municípios ou consórcios públicos) para execução de ações de responsabilidade exclusiva do delegante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.01.00','DIÁRIAS ','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.3.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.01.00','DIÁRIAS ','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.4.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização a Estados para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.01.00','DIÁRIAS ','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.1.5.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização a municípios para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.01.00','DIÁRIAS ','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.5.7.2.1.07.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.0.0.0.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS','Compreende a variação patrimonial diminutiva com desvalorização e perdas de ativos, nos casos de reavaliação, redução a valor recuperável, provisões para perdas, perdas com alienação e perdas involuntárias.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.0.0.00.00','REAVALIAÇÃO, REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','Compreende as variações patrimoniais diminutivas relativas a reavaliação, redução a valor recuperável e ajuste para perdas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for inferior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis, quando esse for inferior ao valor liquido contábil.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para máquinas, ferramentas, aparelhos, equipamentos, acessórios etc, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes paraequipamentos de processamento de dados e sistemas aplicativos, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para mobiliário em geral e utensílios, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para transportes aéreos, aquáticos e terrestres, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis em andamento, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens permanentes a serem estocados em almoxarifado, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para armas que constituem objetos de defesa ou preparativos de guerra, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para demais bens móveis não classificados em grupos específicos, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens imóveis, quando esse for inferior ao valor liquido contábil.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os valores de bens imóveis em andamento, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para os demais bens imóveis não classificados anteriormente nesse plano de contas, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.3.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for inferior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.3.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.1.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.2.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.2.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.2.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.2.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.2.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.3.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.3.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.3.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.3.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.3.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.4.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.4.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.4.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.4.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.4.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.5.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.5.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.5.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.5.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.4.5.04.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo imobilizado, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo imobilizado, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de bens móveis, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.01','REDUÇÃO A VALOR RECUPERÁVEL DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.03','REDUÇÃO A VALOR RECUPERÁVEL DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de mobiliário em geral e utensílios, entre outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.04','REDUÇÃO A VALOR RECUPERÁVEL DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.05','REDUÇÃO A VALOR RECUPERÁVEL DE VEÍCULOS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de transportes aéreos, aquáticos e terrestres, entre outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.06','REDUÇÃO A VALOR RECUPERÁVEL DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.07','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens móveis em andamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.08','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens permanentes a serem estocados em almoxarifado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.09','REDUÇÃO A VALOR RECUPERÁVEL DE ARMAMENTOS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de armas que constituem objetos de defesa ou preparativos de guerra.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.10','REDUÇÃO A VALOR RECUPERÁVEL DE SEMOVENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.01.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais bens móveis não classificados em grupos específicos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de bens imóveis, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.01','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO ESPECIAL','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.02','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DOMINICAIS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.03','REDUÇÃO A VALOR RECUPERÁVEL DE BENS DE USO COMUM DO POVO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.04','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de valores de bens imóveis em andamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.05','REDUÇÃO A VALOR RECUPERÁVEL DE INSTALAÇÕES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.06','REDUÇÃO A VALOR RECUPERÁVEL DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.5.1.02.99','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS BENS IMÓVEIS','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de os demais bens imóveis não classificados anteriormente nesse plano de contas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.6.0.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.6.1.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.6.1.01.00','REDUÇÃO A VALOR RECUPERÁVEL DE SOFTWARES','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de softwares, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.6.1.02.00','REDUÇÃO A VALOR RECUPERÁVEL DE MARCAS, DIREITOS E PATÉNTES ','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.6.1.03.00','REDUÇÃO A VALOR RECUPERÁVEL DE DIREITO DE USO DE IMÓVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Por exemplo, a variação patrimonial diminutiva com ajuste para créditos de liquidação duvidosa e ajuste para créditos da divida ativa.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.01','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.02','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.03','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.04','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.05','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.06','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.07','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.08','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.09','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.10','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.11','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.12','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.13','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.14','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.15','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.16','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.17','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.18','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.19','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.20','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.21','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.22','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.23','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.24','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.25','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.26','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.27','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.05.28','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.1.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTRA OFSS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.01','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.02','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.03','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.04','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.05','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.06','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.07','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.08','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.09','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.10','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.11','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.12','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.13','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.14','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.15','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.16','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.17','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.18','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.19','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.20','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.21','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.22','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.23','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.24','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.25','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.26','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.27','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.05.28','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.2.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.01','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.02','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.03','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.04','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.05','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.06','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.07','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.08','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.09','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.10','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.11','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.12','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.13','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.14','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.15','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.16','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.17','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.18','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.19','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.20','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.21','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.22','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.23','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.24','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.25','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.26','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.27','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.05.28','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.3.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.01','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.02','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.03','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.04','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.05','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.06','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.07','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.08','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.09','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.10','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.11','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.12','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.13','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.14','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.15','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.16','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.17','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.18','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.19','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.20','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.21','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.22','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.23','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.24','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.25','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.26','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.27','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.05.28','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.4.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.01.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.02.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.03.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.04.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.01','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - PRINCIPAL','Registra os valores relativos ao cancelamento de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.02','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - MULTA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.03','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - JUROS','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.04','DIVIDA ATIVA TRIBUTARIA -CANCELAMENTO - ATUALIZACAO MONETARIA','Registra os valores relativos ao cancelamento dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.05','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - PRINCIPAL','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.06','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - MULTA','Registra os valores relativos a anistia/remissão dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.07','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - JUROS','Registra os valores relativos a anistia/remissão dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.08','DIVIDA ATIVA TRIBUTARIA -ANISTIA/REMISSAO - ATUALIZACAO MONETARIA','Registra os valores relativos as anistias/remissões dos créditos inscritos na dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.09','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - PRINCIPAL','Registra os valores relativos a adjudicação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.10','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - MULTA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.11','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - JUROS','Registra os valores relativos as adjudicações dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.12','DIVIDA ATIVA TRIBUTARIA -ADJUDICACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a adjudicação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.13','DIVIDA ATIVA TRIBUTARIA -ANULACAO - PRINCIPAL','Registra os valores relativos a anulação de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.14','DIVIDA ATIVA TRIBUTARIA -ANULACAO - MULTA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.15','DIVIDA ATIVA TRIBUTARIA -ANULACAO - JUROS','Registra os valores relativos as anulações dos créditos inscritos em divida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.16','DIVIDA ATIVA TRIBUTARIA -ANULACAO - ATUALIZACAO MONETARIA','Registra os valores relativos a anulação dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.17','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - PRINCIPAL','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.18','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - MULTA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.19','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE - JUROS','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.20','DIVIDA ATIVA TRIBUTARIA -PRESCRICAO INTERCORRENTE-ATUALIZACAO MONETARIA','Registra os valores relativos a prescrição intercorrente dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.21','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - PRINCIPAL','Registra os valores relativos a extinção de créditos inscritos em dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.22','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - MULTA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.23','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - JUROS','Registra os valores relativos as extinções dos créditos inscritos em dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.24','DIVIDA ATIVA TRIBUTARIA -EXTINCAO - ATUALIZACAO MONETARIA','Registra os valores relativos a extinção dos créditos inscritos em dívida ativa tributária - atualização monetária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.25','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - PRINCIPAL','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - principal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.26','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO - MULTA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - multa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.27','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - JUROS','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - juros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.05.28','DIVIDA ATIVA TRIBUTARIA -ABATIMENTO/DESCONTO  - ATUALIZ. MONETARIA','Registra os valores relativos ao abatimento/desconto dos créditos inscritos na dívida ativa tributária - atualizacao monetária','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.06.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.7.5.99.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste para perdas de estoques. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.01.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MERCADORIAS PARA REVENDA','Registra a variação patrimonial diminutiva com ajuste para perdas de mercadorias para revenda.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.02.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS ACABADOS','Registra a variação patrimonial diminutiva com ajuste para perdas de produtos e serviços acabados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.03.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Registra a variação patrimonial diminutiva com ajuste para perdas de produtos e serviços em elaboração.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.04.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATÉRIAS-PRIMAS','Registra a variação patrimonial diminutiva com ajuste para perdas de matérias-primas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.05.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE MATERIAIS EM TRÂNSITO','Registra a variação patrimonial diminutiva com ajuste para perdas de materiais em trânsito.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.06.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ALMOXARIFADO','Registra a variação patrimonial diminutiva com ajuste para perdas de almoxarifado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.07.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ADIANTAMENTOS A FORNECEDORES','Registra a variação patrimonial diminutiva com ajuste para perdas de adiantamentos a fornecedores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.1.8.1.08.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE OUTROS ESTOQUES','Registra a variação patrimonial diminutiva com ajuste para perdas de outros estoques.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.0.0.00.00','PERDAS COM ALIENAÇÃO ','Compreende a perda com alienação de ativos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.0.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.1.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.1.01.00','PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva de perdas com alienação de participações permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.1.02.00','PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva de perdas com alienação de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.1.03.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva de perdas com alienação de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.1.1.04.00','PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva de perdas com alienação de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.0.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.00','PERDAS COM ALIENAÇÃO DE BENS MOVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de bens móveis.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.01','PERDAS COM ALIENAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva de perdas com alienação de máquinas, aparelhos, equipamentos e ferramentas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.02','PERDAS COM ALIENAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva de perdas com alienação de bens de informática.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.03','PERDAS COM ALIENAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva de perdas com alienação de móveis e utensílios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.04','PERDAS COM ALIENAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva de perdas com alienação de materiais culturais, educacionais e de comunicação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.05','PERDAS COM ALIENAÇÃO DE VEÍCULOS','Registra a variação patrimonial diminutiva de perdas com alienação de veículos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.06','PERDAS COM ALIENAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva de perdas com alienação de peças e conjuntos de reposição.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.07','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva de perdas com alienação de móveis em andamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.08','PERDAS COM ALIENAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva de perdas com alienação de bens móveis em almoxarifado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.09','PERDAS COM ALIENAÇÃO DE ARMAMENTOS','Registra a variação patrimonial diminutiva de perdas com alienação de armamentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.10','PERDAS COM ALIENAÇÃO DE SEMOVENTES','Registra a variação patrimonial diminutiva de perdas com alienação de semoventes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.01.99','PERDAS COM ALIENAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de demais bens móveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.2.1.02.00','PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de bens imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.0.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.1.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.1.01.00','PERDAS COM ALIENAÇÃO DE SOFTWARES','Registra a variação patrimonial diminutiva de perdas com alienação de softwares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.1.02.00','PERDAS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','Registra a variação patrimonial diminutiva de perdas com alienação de marcas, direitos e patentes industriais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.2.3.1.03.00','PERDAS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de direito de uso de imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.0.0.00.00','PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário do bem, como o que resulta de sinistros como incêndio e inundações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.0.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','Compreendem o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','Compreende o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.00','PERDAS INVOLUNTÁRIAS DE BENS MOVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de bens móveis.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.01','PERDAS INVOLUNTÁRIAS DE  MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva com perdas involuntárias de máquinas, aparelhos, equipamentos e ferramentas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.02','PERDAS INVOLUNTÁRIAS DE  BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva com perdas involuntárias de bens de informática.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.03','PERDAS INVOLUNTÁRIAS DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva com perdas involuntárias de móveis e utensílios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.04','PERDAS INVOLUNTÁRIAS DE  MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva com perdas involuntárias de materiais culturais, educacionais e de comunicação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.05','PERDAS INVOLUNTÁRIAS DE VEÍCULOS','Registra a variação patrimonial diminutiva com perdas involuntárias de veículos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.06','PERDAS INVOLUNTÁRIAS DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva com perdas involuntárias de peças e conjuntos de reposição.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.07','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva com perdas involuntárias de bens móveis em andamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.08','PERDAS INVOLUNTÁRIAS DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva com perdas involuntárias de bens móveis em almoxarifado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.09','PERDAS INVOLUNTÁRIAS DE ARMAMENTOS','Registra a variação patrimonial diminutiva com perdas involuntárias de armamentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.10','PERDAS INVOLUNTÁRIAS DE SEMOVENTES','Registra a variação patrimonial diminutiva com perdas involuntárias de semoventes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.01.99','PERDAS INVOLUNTÁRIAS DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de demais bens móveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.1.1.02.00','PERDAS INVOLUNTÁRIAS DE BENS IMÓVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de bens imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.0.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','Compreendem o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.1.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.1.01.00','PERDAS INVOLUNTÁRIAS COM SOFTWARES','Registra a variação patrimonial diminutiva com perdas involuntárias com softwares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.1.02.00','PERDAS INVOLUNTÁRIAS COM MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','Registra a variação patrimonial diminutiva com perdas involuntárias com marcas, direitos e patentes industriais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.2.1.03.00','PERDAS INVOLUNTÁRIAS COM DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial diminutiva com perdas involuntárias de direitos de uso de imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.0.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','Compreendem o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.01.00','PERDAS INVOLUNTÁRIAS COM  MERCADORIAS PARA REVENDA','Registra a variação patrimonial diminutiva com perdas involuntárias de mercadorias para revendas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.02.00','PERDAS INVOLUNTÁRIAS COM  PRODUTOS E SERVIÇOS ACABADOS','Registra a variação patrimonial diminutiva com perdas involuntárias de produtos e serviços acabados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.03.00','PERDAS INVOLUNTÁRIAS COM  PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Registra a variação patrimonial diminutiva com perdas involuntárias de produtos e serviços em elboração.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.04.00','PERDAS INVOLUNTÁRIAS COM  MATÉRIAS-PRIMAS','Registra a variação patrimonial diminutiva com perdas involuntárias de matérias-primas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.05.00','PERDAS INVOLUNTÁRIAS COM  MATERIAIS EM TRÂNSITO','Registra a variação patrimonial diminutiva com perdas involuntárias de materiais em trânsito.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.06.00','PERDAS INVOLUNTÁRIAS COM  ALMOXARIFADO','Registra a variação patrimonial diminutiva com perdas involuntárias de almoxarifado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.07.00','PERDAS INVOLUNTÁRIAS COM  ADIANTAMENTOS A FORNECEDORES','Registra a variação patrimonial diminutiva com perdas involuntárias de adiantamentos a fornecedores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.3.1.99.00','PERDAS INVOLUNTÁRIAS COM  OUTROS ESTOQUES','Registra a variação patrimonial diminutiva com perdas involuntárias de outros estoques.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.9.0.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.6.3.9.1.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','Compreende o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.0.0.0.00.00','TRIBUTÁRIAS','Compreendem as variações patrimoniais diminutivas relativas aos impostos, taxas, contribuições de melhoria, contribuições sociais, contribuições econômicas e contribuições especiais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreendem as variações patrimoniais diminutivas relativas às obrigações relativas às prestações pecuniárias compulsórias, em moeda ou cujo valor nela possa se exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade vinculada. Como: impostos, taxas e contribuições de melhoria.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.0.00.00','IMPOSTOS','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência, e vinculados à atividade administrativa do contribuinte, definidos no CTN.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.00.00','IMPOSTOS- CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência e vinculados atividade administrativa do contribuinte, definidos no CTN. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.01.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra as variações patrimoniais diminutivas com Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.02.00','IPVA','Registra as variações patrimoniais diminutivas com Imposto sobre a Propriedade de Veículos Automotores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.03.00','ITCMD','Registra as variações patrimoniais diminutivas com Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.04.00','ICMS','Registra as variações patrimoniais diminutivas com Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.05.00','IPTU','Registra as variações patrimoniais diminutivas com Imposto sobre a Propriedade Predial e Territorial Urbana.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.06.00','ITBI','Registra as variações patrimoniais diminutivas com Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.07.00','ISS','Registra as variações patrimoniais diminutivas com Imposto Sobre Serviços de Qualquer Natureza.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.08.00','ITR','Registra as variações patrimoniais diminutivas com Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.09.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS - IPI','Registra as variações patrimoniais diminutivas, decorrentes do imposto, de competência da União, sobre produtos industrializados tem como fato gerador: i o seu desembaraço aduaneiro, quando de procedência estrangeira; ii a sua saída dos estabelecimentos a que se refere o parágrafo único do artigo 51 do CTN; iii a sua arrematação, quando apreendido ou abandonado e levado a leilão. para os efeitos deste imposto, considera se industrializado o produto que tenha sido submetido a qualquer operacao que lhe modifique a natureza ou a finalidade, ou o aperfeicoe para o consumo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.10.00','IMPOSTO S/ OPERACOES FINANCEIRAS - IOF','Registra as variações patrimoniais diminutivas com o imposto, de competência da união, sobre operações de crédito, câmbio e seguro, e sobre operações relativas a titulos e valores mobiliários que tem como fato gerador: i - quanto as operações de crédito, a sua efetivação pela entrega total ou parcial do montante ou do valor que constitua o objeto da obrigação, ou sua colocação a disposição do interessado; ii - quanto as operações de câmbio, a sua efetivação pela entrega de moeda nacional ou estrangeira, ou de documento que a represente, ou sua colocação a disposição do interessado em montante equivalente a moeda estrangeira ou nacional entregue ou posta a disposição por este; iii - quanto as operações de seguro, a sua efetivaçãopela emissão da apólice ou do documento equivalente, ou recebimento do prêmio, na forma da lei aplicável; iv - quanto as operações relativas a títulos e valores mobiliários, a emissão, transmissão, pagamento ou resgate destes, na forma da lei aplicável.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.11.00','IMPOSTO S/ IMPORTACAO - II','Registra as variações patrimoniais diminutivas, de competência da união, sobre a importação de produtos estrangeiros que tem como fato gerador a entrada destes no territorio nacional.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.1.1.99.00','OUTROS IMPOSTOS','Registra as variações patrimoniais diminutivas com outros impostos não abrangidos nas rubricas anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.0.00.00','TAXAS','Compreende as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.1.00.00','TAXAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.1.01.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra as variações patrimoniais diminutivas com taxas pelo exercício do poder de polícia.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.2.1.02.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra as variações patrimoniais diminutivas com taxas pela prestação de serviço.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.0.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende as variações patrimoniais diminutivas com tributo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou Municípios , amparadas em lei e limitadas ao total da despesa pública realizada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.1.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com titulo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou municípios, amparadas em lei e limitadas ao total da despesa pública realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.1.3.0.01.00','CONTRIBUIÇÕES DE MELHORIA','Registra as variações patrimoniais diminutivas com contribuições de melhoria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.0.0.00.00','CONTRIBUIÇÕES','Compreende as variações patrimoniais diminutivas com contribuições sociais, econômicas e outras, decorrentes da intervenção do estado (União, estados, distrito federal e municípios) no domínio econômico e de interesse da categoria de profissionais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.0.00.00','CONTRIBUIÇÕES SOCIAIS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo estado, entre elas o PIS/PASEP, CSLL e COFINS, etc.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS - ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.02.00','PIS/PASEP ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMÔNIO DO SERVIDOR PUBLICO(PASEP)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL - ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUIÇÕES PREVIDENCIARIAS SOBRE SERVIÇOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVIÇOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA - ','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUIÇÕES SOCIAIS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.01.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS - ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.02.00','PIS/PASEP ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA O PROGRAMA DE INTEGRACAO SOCIAL(PIS) OU PARA O PROGRAMA DE FORMACAO DO PATRIMÔNIO DO SERVIDOR PUBLICO(PASEP)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.03.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL - ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO SOCIAL INCIDENTE SOBRE O LUCRO DA PESSOA JURIDICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.04.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUIÇÕES PREVIDENCIARIAS SOBRE SERVIÇOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVIÇOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.05.00','OBRIGAÇÕES PATRONAIS S/ SERVIÇOS DE PESSOA JURIDICA - ','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.3.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','REGISTRA O VALOR DA VPD COM OUTRAS CONTRIBUIÇÕES SOCIAIS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP,CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.0.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio do serviço de iluminação pública (art.149-a da C.F.)','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.3.1.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio da iluminação pública (art.149-a da C.F.). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.0.00.00','OUTRAS CONTRIBUIÇÕES','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.9.1.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.1.01.00','CONTRIBUIÇÃO SINDICAL','REGISTRA O VALOR DA VARIAÇÃO PATRIMONIAL DIMINUTIVA COM ENCARGOS PATRONAIS RELATIVO A CONTRIBUICAO SINDICAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.2.2.1.99.00','DEMAIS CONTRIBUIÇÕES','Registra variação patrimonial diminutiva relativa ao valor da concessão de cota do órgão central de programação financeira para órgão setorial correspondente ao orçamento anual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.0.0.00.00','CUSTO COM TRIBUTOS','Compreende a variação patrimonial diminutiva relativa a tributos utilizados na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.01.00','CMV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.02.00','CMV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.03.00','CMV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.04.00','CMV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.05.00','CMV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.1.07.00','CMV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DAS MERCADORIAS VENDIDAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.2.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.3.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.4.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.1.5.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.01.00','CPV - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS PRODUTOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.02.00','CPV - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS PRODUTOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.03.00','CPV - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS PRODUTOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.04.00','CPV - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS PRODUTOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.05.00','CPV - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS PRODUTOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.1.07.00','CPV - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS PRODUTOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.2.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.3.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.4.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.2.5.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.01.00','CSP - IMPOSTOS','REGISTRA A APROPRIACAO DOS IMPOSTOS NO CUSTO DOS SERVICOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.02.00','CSP - TAXAS','REGISTRA A APROPRIACAO DAS TAXAS NO CUSTO DOS SERVICOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.03.00','CSP - CONTRIBUICAO DE MELHORIA','REGISTRA A APROPRIACAO DA CONTRIBUICAO DE MELHORIA NO CUSTO DOS SERVICOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.04.00','CSP - CONTRIBUICOES SOCIAIS','REGISTRA A APROPRIACAO DAS CONTRIBUICOES SOCIAIS NO CUSTO DOS SERVICOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.05.00','CSP - CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO','REGISTRA A APROPRIACAO DAS CONTRIBUICOES DE INTERVENCAO NO DOMINIO ECONOMICO NO CUSTO DOS SERVICOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.1.99.00','CSP - OUTRAS CONTRIBUICOES','REGISTRA A APROPRIACAO DE OUTRAS CONTRIBUICOES AO CUSTO DOS SERVICOS VENDIDOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.2.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS -INTRA OFSS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.3.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.4.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.7.8.3.5.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende o somatório das variações patrimoniais diminutivas não incluídas nos grupos anteriores. Compreende: premiações, incentivos, equalizações de preços e taxas, participações e contribuições, resultado negativo com participações, dentre outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.0.0.00.00','PREMIAÇÕES','Compreende as aquisições de prêmios, condecorações, medalhas, troféus, etc., bem como com o pagamento de prêmios em pecúnia, inclusive decorrentes de sorteios lotéricos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.0.00.00','PREMIAÇÕES CULTURAIS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.1.1.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.0.00.00','PREMIAÇÕES ARTÍSTICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.2.1.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.0.00.00','PREMIAÇÕES CIENTIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.3.1.00.00','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.0.00.00','PREMIAÇÕES DESPORTIVAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.4.1.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.0.00.00','ORDENS HONORIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.5.1.00.00','ORDENS HONORIFICAS - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.0.00.00','OUTRAS PREMIAÇÕES','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.1.9.1.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.0.0.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','Compreende a apropriação do resultado negativo de participações, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.0.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.1.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.2.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.3.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.4.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.2.1.5.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.0.0.00.00','INCENTIVOS','Compreende os incentivos financeiros concedidos relativos à educação, a ciência e a cultura','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.0.00.00','INCENTIVOS A EDUCAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.01.00','BOLSA DE ESTUDOS NO PAÍS','Registra as variações patrimoniais diminutivas realizadas com bolsas de estudo no país, a qualquer título, e demais auxílios financeiros a estudantes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.02.00','BOLSA DE ESTUDOS NO EXTERIOR','Registra as variações patrimoniais diminutivas realizadas com bolsas de estudo no exterior, a qualquer título.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.03.00','AUXÍLIOS PARA DESENV. DE ESTUDOS E PESQUISAS','Registra as variações patrimoniais diminutivas realizadas com concessão de auxílios financeiros a estudantes para desenvolvimento de estudos e pesquisas de natureza científica, observado o disposto no art. 26 da lei complementar n.101, de 2000.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.1.1.99.00','OUTROS INCENTIVOS A EDUCAÇÃO','Registra outras variações patrimoniais diminutivas com incentivos a educação não contemplados nos itens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.0.00.00','INCENTIVOS A CIÊNCIA','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.01.00','AUXÍLIO A PESQUISADORES','Registra as variações patrimoniais diminutivas com auxílio financeiro a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas científicas e tecnológicas, nas suas diversas modalidades.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.02.00','AUXÍLIO AS ATIVIDADES AUXILIARES DE PESQUISA','Registra as variações patrimoniais diminutivas com auxílio financeiro a pesquisadores relativo ao apoio as atividades auxiliares de pesquisa, em atendimento a resolução n° 08/06-COPLAD, editada pelo conselho de planejamento e administração da universidade federal do Paraná.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.2.1.99.00','OUTROS INCENTIVOS A CIÊNCIA','Registra as demais variações patrimoniais diminutivas com incentivos à ciência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.0.00.00','INCENTIVOS A CULTURA','Compreende os incentivos financeiros concedidos, visando à promoção da cultura.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.1.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','Compreende os incentivos financeiros concedidos, visando à promoção da cultura. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.1.01.00','INCENTIVOS A CULTURA - PESSOAS FÍSICAS','Registra os incentivos financeiros concedidos a pessoas físicas, visando a promoção da cultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.3.1.99.00','OUTROS INCENTIVOS A CULTURA','Registra os demais incentivos financeiros concedidos, visando a promoção da cultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.0.00.00','INCENTIVOS AO ESPORTE','Compreende os incentivos financeiros concedidos, visando à promoção do esporte.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.1.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','Compreende os incentivos financeiros concedidos, visando à promoção do esporte. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.1.01.00','INCENTIVOS AO ESPORTE - PESSOAS FÍSICAS','Registra os incentivos financeiros concedidos a pessoas físicas, visando a promoção do esporte.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.4.1.99.00','OUTROS INCENTIVOS AO ESPORTE','Registra as demais variações patrimoniais diminutivas com incentivos ao esporte.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.0.00.00','OUTROS INCENTIVOS','Compreende outros incentivos financeiros concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.4.9.1.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','Compreende os incentivos financeiros concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.0.00.00','SUBVENÇÕES ECONÔMICAS','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.01.00','CORREÇÃO MONETÁRIA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM CORRECAO MONETARIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.02.00','DIFERENCIAL DE JUROS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES COM DIFERENCIAL DE TAXAS DE JUROS, PREVISTO EM CONTRATO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.03.00','PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O PROGRAMA DE INVESTIMENTO RURAL AGROINDUSTRIAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.04.00','GARANTIA E SUSTENTAÇÃO DE PREÇOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM GARANTIA E SUSTENTACAO DE PRECOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.05.00','CUSTOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DE EQUALIZACOES REFEREN TES AOS CUSTOS ADMINISTRATIVOS PAGOS AOS AGENTES FINANCEIROS SOB A FORMA DE REMUNERACAO PREVISTO EM CONTRATO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.06.00','CUSTEIO AGROPECUÁRIO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS DO CUSTO DE CAPTCAO E APLICACAO DE RECURSOS NO PROGRAMA DE ASSENTAMENTO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.07.00','SUBVENÇÃO ECONOMICA AO PREMIO DE SEGURO GARANTIA','REGISTRA A SUBVENCAO ECONOMICA AO PREMIO DO SEGURO GARANTIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.08.00','AQUISIÇÃO E PRODUÇÃO DE BENS DE CAPITAL','REGISTRA O VALOR DE APROPRIACAO DE VARIACOES PATRIMONIAIS DIMINUTIVAS COM EQUALIZACAO DE TAXAS DE JUROS NAS OPERACOES DE FINANCIAMENTO DESTINADOS A AQUISICAO E PRODUCAO DE BENS DE CAPITAL E A INOVACAO TECNOLOGICA (MP 465, DE 2009).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.5.0.1.99.00','OUTRAS SUBVENÇÕES ECONÔMICAS','Registra as variações patrimoniais diminutivas com outras subvenções econômicas não descritas acima.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.0.0.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','Compreende as participações de terceiros nos lucros, não relativas ao investimento dos acionistas, tais como: participações de debêntures, empregados, administradores e partes beneficiárias, mesmo na forma de instrumentos financeiros, além da contribuição a instituições ou fundos de assistência ou previdência de empregados.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.0.00.00','PARTICIPAÇÕES DE DEBÊNTURES','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.1.1.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.2.0.00.00','PARTICIPAÇÕES DE EMPREGADOS','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.2.1.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.3.0.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.3.1.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.0.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.4.1.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.0.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido, para instituições ou fundos de assistência ou previdência de empregados.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.6.5.1.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro líquido, para instituições ou fundos de assistência ou previdência de empregados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.0.0.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','Compreende a constituição de provisões, entendidas como os passivos de vencimento ou montante incertos. Não se confundem com os passivos derivados de apropriação por competência, como férias e décimo - terceiro salário.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.1.0.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.1.1.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.2.0.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.2.1.00.00','VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.3.0.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.3.1.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS – CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.4.0.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.4.1.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS – CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamentos de indenizações a fornecedores e clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.5.0.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.5.5.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.6.0.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP ','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.6.1.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.9.0.00.00','VPD DE OUTRAS PROVISÕES ','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.7.9.1.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO ','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.0.0.00.00','CUSTO DE OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens ou serviços, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.0.00.00','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.1.1.00.00','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.0.00.00','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.2.1.00.00','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.0.00.00','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.8.3.1.00.00','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende outras variações patrimoniais diminutivas não classificadas em itens específicos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias.  ','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.0.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.1.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.2.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.3.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.4.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.4.5.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.1.01.00','PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS','Registra o valor das consituições das provisões matemáticas previdenciárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '3.9.9.9.1.02.00','HONRA DE AVAIS','Registra os valores que a administração é compelida a realizar em decorrencia de honra de avais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.0.0.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','Compreende o aumento no beneficio econômico durante o período contábil sob a forma de entrada de recurso ou aumento de ativo ou diminuição de passivo, que resulte em aumento do patrimônio liquido e que não sejam provenientes de aporte dos proprietários.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.0.0.0.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: impostos, taxas e contribuições de melhoria.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.0.0.00.00','IMPOSTOS','Compreende como imposto o tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal especifica, relativa ao contribuinte.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.0.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','Compreende os impostos sobre operações de comercio exterior, como por exemplo: impostos sobre a importação e imposto sobre a exportação.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.1.1.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','Compreende os impostos sobre operações de comercio exterior, como exemplo: impostos sobre a importação e imposto sobre a exportação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.0.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','Compreende os impostos sobre patrimônio e a renda, como por exemplo: imposto sobre a propriedade territorial rural, imposto sobre a propriedade predial e territorial urbana, imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e impostos sobre a renda e proventos de qualquer natureza.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','Compreende os impostos sobre patrimônio e a renda, como exemplo: imposto sobre a propriedade territorial rural,imposto sobre a propriedade predial e territorial urbana,imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e imposto sobre a renda e proventos de qualquer natureza. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.01.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','Registra a variação patrimonial aumentativa decorrente de imposto sobre propriedade territorial rural','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.02.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA','Registra a variação patrimonial aumentativa decorrente de imposto sobre a propriedade predial e territorial urbana.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.03.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Compreende a variação patrimonial aumentativa decorrente de imposto sobre a renda e proventos de qualquer natureza, retidos na fonte.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.03.01','IR - PESSOAS FISICAS','REGISTRA O VALOR TOTAL QUE INCIDE SOBRE OS RENDIMENTOS E GANHOS DE CAPITAL PERCEBIDOS PELAS PESSOAS FISICAS RESIDENTES OU DOMICILIADAS NO BRASIL. INTEGRAM O RENDIMENTO BRUTO SUJEITO A INCIDENCIA DESSE IMPOSTOO GANHO DE CAPITAL DECORRENTE DA ALIENACAO DE BENS E DIREITOS E OS GANHOS LIQUIDOS AUFERIDOS EM OPERACOES REALIZADAS NAS BOLSAS DE VALORES E ASSEMELHADAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.03.02','IR - PESSOAS JURIDICAS','REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.04.00','ITBI','Registra a variação patrimonial aumentativa decorrente de imposto sobre a transmissão intervivos de bens imóveis e direitos reais sobre imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.05.00','ITCMD','Registra a variação patrimonial aumentativa decorrente de imposto sobre transmissão causa mortis e doação de quaisquer bens ou direitos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.06.00','IPVA','Registra a variação patrimonial aumentativa decorrente de imposto sobre a propriedade de veículos automotores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.2.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de impostos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.0.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','Compreende os impostos sobre a produção e a circulação, como por exemplo: imposto sobre produtos industrializados; imposto sobre operações de credito, câmbio e seguro, e sobre operações relativas a títulos e valores mobiliários; imposto sobre serviços de qualquer natureza.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','Compreende os impostos sobre a produção e a circulação como, por exemplo, imposto sobre produtos industrializados;imposto sobre operações de crédito, cambio e seguro, e sobre operações relativas a títulos e valores mobiliários, imposto sobre serviços de qualquer natureza.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.01.00','ICMS','Registra a variação variação patrimonial aumentativa decorrente de ICMS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.02.00','ISS','Registra a variação variação patrimonial aumentativa decorrente de ISS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.3.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de ICMS e ISS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.0.00.00','IMPOSTOS EXTRAORDINÁRIOS','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos, gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.4.1.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos,gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.0.00.00','OUTROS IMPOSTOS','Compreende os demais impostos não classificados nos grupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.1.9.1.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','Compreende os demais impostos não classificados nos grupos anteriores. Compreende os valores de operações efetuadas entre uma unidade pertinente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.0.0.00.00','TAXAS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador o exercício regular do poder de policia, ou a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.0.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a prática de ato ou abstenção de fato, em razão de interesse público.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.11.00','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.11.01','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - SAÚDE','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária - Saúde.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.11.02','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - ANIMAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária - Animal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.14.00','TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Controle e Fiscalização Ambiental.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.15.00','TAXA DE SERVIÇOS ADMINISTRATIVO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços Administrativos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.15.01','ATOS DA ADMINISTRAÇÃO EM GERAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços de Atos Administração em Geral.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.15.02','ATOS DA SAÚDE PÚBLICA','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços de Atos da Saúde Pública.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.70.00','TAXA DE PREVENÇÃO CONTRA SINISTRO','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Prevenção Contra Sinistro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.71.00','TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Fiscalização sobre Serviços Públicos de Saneamento Básico.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.72.00','TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Regulação de Serviços de Gás Canalizado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.00','(-) DEDUÇÕES','Compreende as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.11','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado, referente a Taxa de Fiscalização de Vigilância Sanitária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.14','(-) DEDUÇÃO DA TAXA DE CONTROLE E FISCALIZAÇÃO AMBIENTAL','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado, referente a Taxa de Controle de Fiscalização Ambiental.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.15','(-) DEDUÇÃO TAXA DE SERVIÇOS ADMINISTRATIVOS','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado, referente a Taxa de Controle de Fiscalização Ambiental.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.70','(-) DEDUÇÃO TAXA DE PREVENÇÃO CONTRA SINISTRO','Registra as deduções de variações patrimoniais aumentativas, referente a Taxa de Prevenção contra Sinistros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.71','(-) DEDUÇÃO TAXA DE FISCALIZAÇÃO SOBRE SERVIÇOS PÚBLICOS DE SANEAMENTO BÁSICO - AGESAN','Registra as deduções de variações patrimoniais aumentativas, referente a Taxa de Fiscalização sobre Serviços Públicos de Saneamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.72','(-) DEDUÇÃO TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','Registra as deduções de variações patrimoniais aumentativas, referente a Taxa de Regularização de Serviços de Gás Canalizado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.1.1.97.98','(-) RENÚNCIA','Compreende as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.0.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível prestado ao contribuinte ou posto a sua disposição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.07.00','EMOLUMENTOS E CUSTAS JUDICIAIS','Registra as variações patrimoniais diminutivas com Emolumentos e Custas Judiciais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.09.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','Registra as variações patrimoniais diminutivas com Emolumentos e Custas Processuais Administrativas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.70.00','TAXA JUDICIÁRIA','Registra as variações patrimoniais diminutivas com Taxa Judiciária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.71.00','TAXA DE SEGURANÇA CONTRA INCÊNDIO','Registra as variações patrimoniais diminutivas com Taxa de Segurança Contra Incêndio.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.72.00','TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','Registra as variações patrimoniais diminutivas com Taxa de Segurança Ostensiva Contra Delitos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.73.00','TAXA DE SEGURANÇA PREVENTIVA','Registra as variações patrimoniais diminutivas com Taxa de Segurança Preventiva.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.74.00','TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','Registra as variações patrimoniais diminutivas com Taxa de Aposentados e Serventuários da Justiça.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.00','(-) DEDUÇÕES','Compreende as deduções diversas.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.07','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS JUDICIAIS','Registra as deduções de Emolumentos e Custas Judiciais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.09','(-) DEDUÇÃO EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','Registra as deduções de Emolumentos e Custas processuais Administrativas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.70','(-) DEDUÇÃO TAXA JUDICIÁRIA','Registra as deduções da Taxa Judiciária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.71','(-) DEDUÇÃO TAXA DE SEGURANÇA CONTRA INCÊNDIO','Registra as deduções da Taxa de Segurança Contra Incêndios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.72','(-) DEDUÇÃO TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','Registra as deduções da Taxa de Segurança Ostensiva contra delitos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.73','(-) DEDUÇÃO TAXA DE SEGURANÇA PREVENTIVA','Registra as deduções da Taxa de Segurança Preventiva.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.74','(-) DEDUÇÃO TAXA DE APOSENTADOS E SERVENTUÁRIOS DA JUSTIÇA','Registra as deduções da Taxa de Aposentados e Serventuários da Justiça.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.97.98','(-) RENÚNCIA','Registra os valores de Renúncia diversas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.2.2.1.99.00','OUTRAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra as variações patrimoniais diminutivas com Outras Taxas pela Prestação de Serviços.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.0.0.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende como contribuição de melhoria o tributo cobrado pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, sendo instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária, tendo como limite total a despesa realizada e como limite individual o acréscimo de valor que da obra resultar para cada imóvel beneficiado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de água potável e esgoto sanitário.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedade em função da pavimentação asiática, bem como pela colocação de guias, sarjetas e calcamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de água potável e esgoto sanitário.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.1.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de água potável e esgoto sanitário.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de iluminação pública na cidade.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública na cidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública na cidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.2.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública na cidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Compreende o valor da arrecadação de receita sobre a cobrança decorrente de valorização de propriedades em função da expansão da rede de iluminação pública rural.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública rural. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública rural.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.3.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela expansão da rede de iluminação pública rural.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.0.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.1.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.1.01.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Registra a variação patrimonial aumentativa decorrente de contribuição de melhoria pela pavimentação e obras complementares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.4.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de contribuição de melhoria pela pavimentação e obras complementares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.0.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.1.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.1.01.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Registra a variação patrimonial aumentativa decorrente de outras contribuições de melhoria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.1.3.9.1.97.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de outras contribuições de melhoria.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.0.0.0.00.00','CONTRIBUIÇÕES','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: contribuições.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.0.0.00.00','CONTRIBUIÇÕES SOCIAIS','Compreendem como contribuições sociais: a) as das empresas, incidentes sobre a remuneração paga ou creditada aos segurados a seu serviço; b) as dos empregadores domésticos; c) as dos trabalhadores, incidentes sobre o seu salário-de-contribuição; d) as sobre a receita e faturamento; e) as sobre o lucro; f) do importador de bens ou serviços do exterior; g) e outros','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.0.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuição patronal destinada ao custeio do Regime Próprio de Previdência Social.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.01.01','CONTRIB. PATRONAL DE SERVIDOR CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DOS ENTES PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.01.02','CONTR.PATRONAL - PAGAMENTO DE SENTENCAS JUDICIAIS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','Compreende a contribuição ao RPPS dos segurados, servidor ativo, servidor inativo e pensionista sobre a sua remuneração.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.01','CONTRIBUICAO DO SERVIDOR CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR ATIVO CIVIL SOBRE SUA REMUNERACAO.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.02','CONTRIBUICAO DO  APOSENTADO CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR INATIVO CIVIL.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.03','CONTRIBUICAO DE PENSIONISTA CIVIL - RPPS','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO PENSIONISTA CIVIL.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.04','CONTR.SERV. CIVIL-PAGTO SENT. JUDICIAIS','REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR CIVIL ATIVO, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.05','CONTR. APOSENTADO CIVIL - PAGTO SENT. JUDICIAIS','REGISTRA AVPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR INATIVO CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.02.06','CONTR.PENSIONISTA CIVIL-PAGTO SENT. JUDICIAIS','REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DE PENSIONISTA CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.03.00','CONTRIBUIÇÃO PREVIDENCIÁRIA PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL','Registra a VPA oriunda de contribuições previdenciárias para amortização do déficit atuarial.','X','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.04.00','CONTRIBUIÇÕES PARA CUSTEIO DAS PENSÕES MILITARES','Registra as VPA provenientes de contribuição para custeio das pensões militares, efetivadas por todos os militares, com valor correspondente a seu posto ou graduação, observando as exceções previstas na lei especifica. De competência da União e dos Estados.','X','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.97.00','(-) DEDUÇÕES','Compreendem as deduções das contribuições sociais – RPPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.97.10','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.1.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das VPA oriundas de contribuições previdenciárias não enquadradas nos subitens anteriores.','X','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuicao patronal destinada ao custeio do regime proprio de previdencia social.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA PCASP União, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA PCASP União, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.97.00','(-) DEDUÇÕES','Compreendem as deducoes das variacoes patrimoniais aumentativas.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.97.10','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.2.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.3.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS – UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuicao patronal destinada ao custeio do regime proprio de previdencia social.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.01.97','(-) DEDUÇÕES','Compreendem as deducoes das variacoes patrimoniais aumentativas.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.01.02','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.97.00','(-) DEDUÇÕES','Compreende as deducoes das variacoes patrimoniais aumentativas.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.97.10','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.4.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.01.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuicao patronal destinada ao custeio do regime proprio de previdencia social.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.01.01','CONTRIB. PATRONAL DE SERVIDOR AT.CIVIL - RPPS','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA PCASP União, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA PCASP União, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.01.02','CONTR.PATRONAL - PAGTO SENTENCAS JUDICIAIS - RPPS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.97.00','(-) DEDUÇÕES','Compreende as deducoes das variacoes patrimoniais aumentativas.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.97.10','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.1.5.99.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das vpa oriundas de contribuicoes previdenciarias nao en-quadradas nos subitens anteriores.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.0.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.1.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.2.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.3.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.4.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.2.5.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.0.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.3.1.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.0.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.4.1.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','Registra a contribuição do empregador,da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.0.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.5.1.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.0.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.6.1.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.0.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.1.9.1.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.0.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE-combustível.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.2.0.1.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE combustível. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.0.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.1.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.3.0.1.01.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA ','Registra as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.0.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.2.4.0.1.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.0.0.0.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','Compreende as variações patrimoniais aumentativas auferidas com a exploração e venda de bens, serviços e direitos, que resultem em aumento do patrimônio liquido, independentemente de ingresso, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.0.0.00.00','VENDA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda de mercadorias, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.0.00.00','VENDA BRUTA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.01.00','VENDA DE ESTOQUE PRÓPRIO - PAÍS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.11.00','VENDA DE ESTOQUE DE PRODUÇÃO VEGETAL','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.11.01','AGRICULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Agricultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.11.02','HORTA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Horta.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.11.03','POMAR','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Pomar.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.11.99','OUTRAS VPAS DE PRODUÇÃO VEGETAL','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque no Próprio País para a Produção Vegetal - Outras VPAS de Produção Vegetal.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.00','VENDA DE ESTOQUE DE PRODUÇÃO ANIMAL E DERIVADOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.01','GRANJA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Granja.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.02','PISCICULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Piscicultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.03','PECUÁRIA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Pecuária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.04','APICULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Apicultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.05','SUINOCULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Suinocultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.06','OVINOCULTURA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Ovinocultura.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.07','COELHOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Coelhos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.08','GADO LEITEIRO','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Gado Leiteiro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.09','EQÜINOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Equinos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.10','AVÍCOLA','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Avícola.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.12.99','OUTRAS VPAS DE PRODUÇÃO ANIMAL E DERIVADOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende as Vendas de Estoque de Produção animal e Derivados - Outras VPAS de Produção Animal e Derivados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.13.00','VENDA DE MEDICAMENTOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Medicamentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.00','VENDA DE LIVROS PERIOD. MAT. ESC. E PUBLICID.','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.01','VENDA DE LIVROS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Venda de Livros.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.02','PUBLICAÇÕES','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Publicações.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.03','VENDAS REVISTA RAC','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Vendas de Revistas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.04','PUBLICAÇÕES TÉCNICAS EPAGRI','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Publicações Técnicas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.14.05','DIVULGAÇÃO E PUBLICIDADE','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Livros periódicos e Material de Escritório e Publicidade - Divulgação e Publicidade.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.15.00','VENDA DE PRODUTOS AGROPECUÁRIOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Produtos Agropecuários.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.15.99','OUTRAS VPAS AGROPECUÁRIAS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende Outras VPAS Agropecuárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.1.1.16.00','VENDA DE FARDAMENTOS','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende a Vendas de Fardamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.0.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.00','(-) DEDUÇÕES DE VENDAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas Canceladas e Devoluções.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.02','(-) ABATIMENTOS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Abatimentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Descontos Incondicionais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.05','(-) ICMS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - ICMS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.06','(-) PIS/PASEP','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - PIS/PASEP.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.07','(-) COFINS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - COFINS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Ajuste a Valor Presente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.1.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Outras Dedução de Vendas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.0.0.00.00','VENDA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda de produtos, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.0.00.00','VENDA BRUTA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.1.1.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.0.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.00','(-) DEDUÇÕES DE VENDAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.01','(-) VENDAS CANCELADAS E DEVOLUÇÕES','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas Canceladas e Devoluções.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.02','(-) ABATIMENTOS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Abatimentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.03','(-) DESCONTOS INCONDICIONAIS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Descontos Incondicionais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.04','(-)IPI','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - IPI.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.05','(-) ICMS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - ICMS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.06','(-) PIS/PASEP','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - PIS/PASEP.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.07','(-) COFINS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - COFINS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.97.08','(-)AJUSTE A VALOR PRESENTE','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Dedução de Vendas - Ajuste a Valor Presente.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.2.9.1.99.00','(-) OUTRAS DEDUÇÕES DE VENDAS','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos. Outras Dedução de Vendas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.0.0.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.0.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.01.00','PRESTACAO DE SERVICOS DE TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.02.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','COMPREENDE O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.03.00','PRESTACAO DE SERVICOS DE LOCACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JA POSSUI RUBRICA PROPRIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.04.00','PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.05.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICO-SOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.06.00','PRESTACAO DE SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.07.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.08.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.09.00','PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.10.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.11.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.12.00','PRESTACAO DE SERVICOS CIENTIFICOS E TECNOLOGICOS NUCLEARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS QUE ENVOLVAM INFORMACAO CIENTIFICA E TECNOLOGICA, APLICACOES DE TECNICAS NUCLEARES E RADIOISOTOPOS, METROLOGIA CIENTIFICA E INDUSTRIAL, RADIOMETRIA E DOSIMETRIA, CONSULTORIAS ASSISTENCIA TECNICA, ANALISE DE PROJETOS, ESTUDOS, PESQUISAS E DESENVOLVIMENTO DA ENERGIA NUCLEAR.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.13.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR:  A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FAR-MACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.14.00','SERVICOS DE COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.15.00','PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.16.00','PRESTACAO DE SERVICOS COMPLEMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.17.00','PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.18.00','PRESTACAO DE SERVICOS RECEPCAO E EMBARQUE DE PRODUTOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE MOVIMENTACAO DOS PRODUTOS NOS ARMAZENS/CAMINHAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.19.00','PRESTACAO DE SERVICOS SERVICO DE TRANSBORDO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE TRANSBORDO DE MERCADORIAS DE TREM PARA CAMINHAO E VICE-VERSA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.20.00','FORNECIMENTO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.21.00','PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.22.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.23.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.24.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURAL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.25.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.26.00','OUTORGA DIREITOS DE EXPL. E PESQ. MINER','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMPENSACAO FINANCEIRA PELA EXPLORACAO DE RECURSOS MINERAIS DEVIDO POR TODAS AS EMPRESAS QUE REALIZAM O APROVEITAMENTO DE UMA JAZIDA MINERAL GARANTIDA A ESSAS A PROPRIEDADE DO PRODUTO DA LAVRA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.27.00','CONCESSAO FLORESTAL','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.28.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.29.00','COMPENSACOES FINANCEIRAS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA PCASP União, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA EXPLORACAO".','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.30.00','SERVICOS DE TRANSPORTE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE TRANSPORTE RODOVIARIO, FERROVIARIO, HIDROVIARIO, AEREO, ESPECIAIS E TARIFA DE PEDAGIO','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.31.00','SERVICOS PORTUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PORTUARIOS. ABRANGEM OS RECURSOS ORIUNDOS DA EXPLORACAO DOS PORTOS, TERMINAIS MARITIMOS, ATRACADOUROS E ANCORADOUROS, REFERENTES A ESTIVA, DESESTIVA, DRAGAGEM, ATRACACAO, SINALIZACAO, COMUNICACAO NAUTICA, DOCAGEM, ETC....','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.32.00','SERVICOS DE SOCORRO MARITIMO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICO DE SOCORRO MARITIMO PRESTADO. VPA DE SERVICOS DE SALVAMENTO, POR NAVIO DE SOCORRO OU EQUIPE DE SALVAMENTO DA MARINHA, DE EMBARCACAO E CARGAS PERIGO (DESENCALHE, MERGULHO, OUTROS SOCORROS), BEM COMO SERVICOS DE REBOQUE MARITIMO, DENTRE OUTROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.33.00','SERVICOS DE SAUDE','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO-ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC...','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.34.00','CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.35.00','SERVICOS DE METROLOGIA E CERTIFICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC..','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.36.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICO-SANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.37.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.38.00','SERVICOS DE METEOROLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METEOROLOGIA PRESTADOS. VPA PROPORCIONADA PELO FORNECIMENTO DE DADOS METEOROLOGICOS E DE PARECERES TECNICOS, BEM COMO CONSERTO, COMPARACAO E AFERICAO DE EQUIPAMENTOS DE METEOROLOGIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.39.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.40.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.41.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.42.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.43.00','SERVICOS REG. MARCAS,PAT.TRANSF.DE TECNOLOGIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DE MARCAS, PATENTES E TRANSFERENCIA DE TECNOLOGIAS. VPA CORRESPONDENTE AOS SERVICOS PREVISTOS NO CODIGO DA PROPRIEDADE INDUSTRIAL, PETICOES GERAIS, PEDIDOS E PETICOS RELATI-VAS A PRIVILEGIOS, PEDIDOS E PETICOES RELATIVAS A MARCAS E PATENTES,PEDIDOS E PETICOES RELATIVOS A CONTRATOS DE TRANSFERENCIA DE TECNOLOGIA E CORRELATOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.44.00','SERVICOS DE REGISTRO DO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.45.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES AA AMORTIZACAO DOS INVESTIMENTOS DA INFRA-ESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.46.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.47.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.48.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.49.00','TARIFA DE UTILIZACAO DE FAROIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA DE UTILIZACAO DE FAROIS. VPA PROVENIENTE DA EFETIVA UTILIZACAO, POR EMBARCACOES ESTRANGEIRAS, DOS SERVICOS DE SINALIZACAO NAUTICA DE PROTECAO A NAVEGACAO. O PRODUTO DA ARRECADACAO E DESTINADO INTEGRALMENTE AO FUNDO NAVAL PARA APLICACAO NOS SERVICOS QUE ENVOLVAM A MANUTENCAO E AMPLIACAO DA REDE DE BALIZAMENTO MARITIMO, FLUVIAL E LACUSTRE, A CARGO DA DIRETORIA DE HIDROGRAFIA E NAVEGACAO DO MINISTERIO DA MARINHA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.50.00','TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFA E ADICIONAL SOBRE TARIFA AEROPORTUARIA. VPA PROVENIENTES DE TARIFA E ADICIONAL COBRADOS POR EMBARQUE DE PASSAGEIROS, POUSO E PERMANENCIA DE AERONAVES NOS AEROPORTOS, ARMAZENAGEM DE MERCADORIAS EM ARMAZENS DE CARGA AEREA E UTI-LIZACAO DE SERVICOS RELATIVOS A MANUTENCAO E MANUSEIO DE MERCADORIAS EM ARMAZENS DE CARGA (TARIFA DE CAPATAZIA). VPA VINCULADA AO MINISTERIO DA AERONAUTICA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.51.00','SERVICOS DE CADASTRO DA ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE AUTORIZACAO DE PESQUISA MINERAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.52.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.53.00','SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.54.00','GARANTIAS E AVAIS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.55.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.56.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.57.00','CERTIFICACAO E HOMOLOGACAO ATIVIDADE MINERAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TAXA DE SERVICOS CADASTRAIS QUANDO DO REQUERIMENTO DE REGISTRO DE LICENCA E DO REGISTRO DE PERMISSAO DE LAVRA GARIMPEIRA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.58.00','SERV.INOV.A.PESQ.AMBIENT.PROD.-INST.CIEN.TEC.','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS VOLTADOS A INOVACAO E AA PESQUISA CIENTIFICA E TECNOLOGICA NO AMBIENTE PRODUTIVO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.59.00','SERVICOS FINANCEIROS','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.60.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATI','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.61.00','SERVIÇOS DE TURISMO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS DE TURISMO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.1.1.99.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NAO ENQUADRADOS NOS ITENS ANTERIORES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.0.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.01.00','(-) VENDAS CANCELADAS E DEVOLUCOES','REGISTRA O VALOR DA DEDUCAO DE VPA DE VENDAS DE SERVICOES REFERENTES A CANCELAMENTO DE VENDAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.02.00','(-) ABATIMENTOS','REGISTRA O VALOR DOS ABATIMENTOS DECORRENTES DE DEFEITOS DE QUALIDADE APRESENTADOS NOS SERVICOS ENTREGUES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.03.00','(-) DESCONTOS INCONDICIONAIS','REGISTRA OS DESCONTOS INCONDICIONAIS DECORRENTES DE REDUCOES DE PRECO DADAS NO MOMENTO DA VENDA, QUE SAO DEDUZIDAS DIRETAMENTE DAS NF.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.05.00','(-) ISS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ISS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.06.00','(-) ICMS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO ICMS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.07.00','(-) PIS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PIS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.08.00','(-) PASEP','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES AO PASEP.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.09.00','(-) COFINS','REGISTRA O VALOR DAS DEDUCOES DE IMPOSTOS INCIDENTES SOBRE AS VENDAS DE SERVICOS REFERENTES A COFINS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.10.00','(-) CONTRIBUIÇÕES PREVIDENCIARIAS - INSS PATRONAL','Registra o valor da contribuição patronal devida pelas empresas que prestam exclusivamente serviços de tecnologia da informação (TI) e de tecnologia da informação e comunicação (TIC), incidentes sobre o valor da receita bruta, excluidas as vendas canceladas e os descontos incondicionais concedidos, conforme dispoe o artigo 7º da lei 12.546/2011. A presente metodologia de calculo do INSS patronal terá vigencia ate 31/12/2014.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.3.3.9.1.99.00','(-) OUTRAS DEDUCOES DE VENDAS','REGISTRA O VALOR DE OUTRAS DEDUCOES DE VENDAS DE SERVICOS','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.0.0.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','Compreende o somatório das variações patrimoniais aumentativas com operações financeiras. Compreende: descontos obtidos, juros auferidos, prêmio de resgate de títulos e debêntures, entre outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.0.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas provenientes de juros e encargos de empréstimos e financiamentos concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.3.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.4.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.1.5.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.2.0.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.2.1.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.3.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.4.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.3.5.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.4.0.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.1.4.1.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.0.0.00.00','JUROS E ENCARGOS DE MORA','Compreende as variações patrimoniais aumentativas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação representando o resultado das aplicações impostas ao contribuinte.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.3.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.4.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.1.5.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.2.0.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.2.1.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.0.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.3.1.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.0.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.01.00','MULTAS E JUROS SOBRE IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.02.00','MULTAS E JUROS SOBRE IPVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade de Veículos Automotores.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.03.00','MULTAS E JUROS SOBRE ITCMD','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.04.00','MULTAS E JUROS SOBRE ICMS','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.05.00','MULTAS E JUROS SOBRE IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','X','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.06.00','MULTAS E JUROS SOBRE ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.07.00','MULTAS E JUROS SOBRE ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','X','S','N','p');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.08.00','MULTAS E JUROS SOBRE ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.09.00','MULTAS E JUROSTAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.10.00','MULTAS E JUROS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.11.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.12.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.13.00','MULTAS E JUROS DEMAIS CONTRIBUIÇÕES','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.14.00','MULTAS E JUROS CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988. ','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.15.00','MULTAS E JUROS CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.16.00','MULTAS E JUROS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores de multas e juros de dívida ativa tributária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.97.00','(-) DEDUÇÕES','Registra as deduções de juros e encargos de mora sobre créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.4.1.99.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CRÉDITOS TRIBUTÁRIOS','Registra os juros e encargos de mora sobre outros créditos tributários.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.0.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.2.9.1.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.0.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.1.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.2.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.2.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.3.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.4.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.3.5.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.4.0.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.4.1.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.0.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nos moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.1.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.3.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.4.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.3.9.5.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.0.00.00','DESCONTOS FINANCEIROS OBTIDOS','Compreende a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.4.0.1.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.0.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','Compreende o valor total das variações patrimoniais aumentativas decorrentes da remuneração do saldo diário dos depósitos da União existentes no banco central, bem como aplicação de recursos da conta única de acordo com a rentabilidade media intrínseca dos títulos do Tesouro.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.1.0.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.1.1.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.2.0.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.5.2.1.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.4.9.0.1.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.0.0.0.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','Compreende o somatório das variações patrimoniais aumentativas com transferências inter governamentais, transferências intragovernamentais, transferências de instituições multigovernamentais, transferências de instituições privadas com ou sem fins lucrativos, transferências de convênios, transferências do exterior e execuções orçamentárias delegadas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.0.0.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repasse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse).Não Inclui o valor repassado para aportes no RPPS ou RGPS.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.01.00','COTA RECEBIDA ','REGISTRA O VALOR DOS RECURSOS RECEBIDOS PELA ADMINISTRACAO DIRETA DECORRENTES DA PROGRAMACAO FINANCEIRA CORRESPONDENTE AO ORCAMENTO ANUAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.02.00','REPASSE RECEBIDO  ','REGISTRA O VALOR DOS RECURSOS RECEBIDOS DECORRENTES DE TRANSFERENCIAS FINANCEIRAS ENTRE ORGAOS DA ADMISTRACAO DIRETA E INDIRETA, CORRESPONDENTES AO ORCAMENTO ANUAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.04.00','RECURSOS ARRECADADOS - RECEBIDOS ','REGISTRA O VALOR RECEBIDO DE OUTRO ÓRGÃO OU ENTIDADE REFERENTE AO RECURSOS QUE FORAM ARRECADADOS (CLASSIFICADOS COMO RECEITA) PARA PAGAMENTO DE DESPESAS NA UNIDADE RECEBEDORA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.05.00','VALORES DIFERIDOS - BAIXA ','REGISTRA O VALOR DOS RECURSOS DIFERIDOS DECORRENTES DO PROCESSO DE BAIXA DE RECURSOS DIFERIDOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.1.2.08.00','VALORES DIFERIDOS - INSCRIÇÃO','COMPREENDE OS VALORES NO PROCESSO DE INSCRICAO DOS RECURSOS DIFERIDOS, SUBDIVIDINDO-SE EM: COTA E REPASSE DIFERIDOS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.0.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências, de bens ou valores, financeiras recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores, recebidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.00','TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.01','ORDEM DE TRANSFERÊNCIAS RECEBIDAS   ','COMPREENDE O VALOR DA ORDEM DE TRANSFERENCIA RECEBIDA - OTR A TITULO DE RECURSOS VINCULADOS QUE DEVERAO PERMANECER NA PROPRIA UNIDADE BENEFICIADA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.02','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITO - SALDOS NAO FINANCEIROS','REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE ORGAOS CORREPONDENTES A SALDOS NÃO FINANCEIROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.03','MOVIMENTO DE FUNDOS A DÉBITO - CORRESPONDÊNCIA DE DÉBITOS - SALDOS FINANCEIROS','REGISTRA A APROPRIACAO DA TRANSFERENCIA DE CREDITOS INTERNOS ENTRE ORGAOS CORREPONDENTES A SALDOS FINANCEIROS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.01.99','OUTRAS TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das demais transferências financeiras recebidas independentes da execução orçamentária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.00','TRANSFERÊNCIAS  NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Compreende o valor das transferências recebidas de bens ou valores independentes da execução orçamentária.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.01','TRANSFERÊNCIAS RECEBIDAS DE BENS IMÓVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES DO MESMO ORGAO .','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.02','DOAÇÕES RECEBIDAS DE BENS IMÓVEIS','REGISTRA O VALOR DAS TRANSFERENCIAS DE BENS IMOVEIS ENTRE UNIDADES ENTRE UG DE ORGAOS DIFERENTES','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.03','TRANFERÊNCIAS RECEBIDAS DE BENS MÓVEIS ','COMPREENDE O VALOR DOS BENS MOVEIS RECEBIDOS PELA UG DO PAIS OU EXTERIOR DECORRENTE DE TRANSFERENCIA DE OUTRA UG DO MESMO ORGAO, INDEPENDENTE DE EXECUCAO ORCAMENTARIA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.04','DOAÇÕES RECEBIDAS DE BENS MÓVEIS ','COMPREENDE O VALOR DOS BENS MOVEIS RECEBIDOS DE UNIDADE LOCALIZADA NO PAIS OU NO EXTERIOR POR OUTRA UNIDADE ,NO PAIS OU NO EXTERIOR, DE ORGAOS DIFERENTES.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.05','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS E VALORES ','REGISTRA O TOTAL DOS TITULOS E VALORES EM CIRCULACAO RECEBIDOS POR UNIDADE DECORRENTE DE TRANSFERENCIA DE OUTRA UNIDADE DE MESMA GESTAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.06','TRANSFERÊNCIAS CONCEDIDAS DE TÍTULOS DA DÍVIDA ATIVA','REGISTRA O RECEBIMENTO DE TITULOS DA DIVIDA ATIVA DE UMA UG PARA A PGFN OU ORGAO EQUIVALENTE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.2.2.02.99','OUTRAS TRANSFERÊNCIAS  NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das demais transferências recebidas de bens ou valores independentes da execução orçamentária.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.0.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes, exceto os decorrentes de alíquota de contribuição suplementar.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes exceto os decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.01.00','PLANO FINANCEIRO','Compreende o valor total dos valores recebidos pelo RPPS para cobertura de insuficiências financeiras, formação de reserva e outras necessidades financeiras, no âmbito do plano financeiro.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.01.01','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Registra os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.01.02','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pelo ente federativo ao RPPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.01.99','OUTROS APORTES PARA O RPPS','Registra o somatório do recebimento de eventuais aportes de recursos no RPPS para outras necessidades financeiras que não a cobertura de insuficiências financeiras e formação de reservas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.02.00','PLANO PREVIDENCIÁRIO','Compreende o valor total recebido pelo RPPS para cobertura de déficit financeiro ou atuarial e outros aportes, no âmbito do plano previdenciário.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.02.01','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','Registra o somatório dos recebimentos de recursos necessários ao equilíbrio financeiro do plano previdenciário, ou seja, à cobertura de déficit entre as receitas e despesas previdenciárias, referentes ao exercício atual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.02.02','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','Registra os recursos orçamentários alocados para cobertura de déficit atuarial no exercício de referência, desde que não definidos por lei como contribuições suplementares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.3.2.02.99','OUTROS APORTES PARA O RPPS','Registra outros aportes financeiros para o RPPS com outras finalidades previdenciárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.0.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS','Compreende o valor das transferências recebidas para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.2.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS  – INTRA OFSS','Compreende o valor das transferências recebidas para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.2.01.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Compreende os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.2.01.01','PROVENIENTES DO ORÇAMENTO DA SEGURIDADE SOCIAL','Registra o montante do orçamento da Seguridade Social realocado da Saúde ou da Assistência Social para a Previdência.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.2.01.02','PROVENIENTES DO ORÇAMENTO FISCAL','Registra os valores das receitas do orçamento fiscal destinados para cobrir os déficits financeiros da Previdência','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.2.02.00','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pela União ao RGPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.1.4.2.99.00','OUTROS APORTES PARA O RGPS','Registra o somatório do recebimento de eventuais aportes de recursos para o RGPS para outras necessidades financeiras.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.0.0.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes de transferências da União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.0.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.1.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS  DE RECEITAS- CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS – UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.01.00','COTA-PARTE FPE','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Fundo de Participação dos Estados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.02.00','COTA-PARTE FPM','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Fundo de Participação dos Municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.03.00','COTA-PARTE ITR','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto Territorial Rural.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.04.00','COTA-PARTE IPI','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto sobre Produtos Industrializados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.05.00','COTA-PARTE IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, OU RELATIVA A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZAÇÃO DO OURO','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto sobre Operações de Crédito, Câmbio e Seguro ou relativa a títulos ou valores mobiliários - comercialização do ouro.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.06.00','TRANSFERENCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Registra a variação patrimonial aumentativa decorrente da transferência da compensação financeira pela exploração dos recursos naturais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.07.00','TRANSFERÊNCIAS DE RECURSOS DO SUS ','Registra a variação patrimonial aumentativa decorrente da transferência de recursos do SUS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.08.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSITENCIA SOCIAL - FNAS','Registra a variação patrimonial aumentativa decorrente da transferência de recursos do Fundo Nacional de Assistência Social - FNAS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.09.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE','Registra a variação patrimonial aumentativa decorrente da transferência de transferências de recursos do Fundo Nacional do Desenvolvimento da Educação - FNDE.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.10.00','TRANSFERENCIA FINANCEIRA DO ICMS DESONERAÇÃO - LC 87/96 (LEI KANDIR)','Registra a variação patrimonial aumentativa decorrente da transferência da transferência financeira do ICMS Desoneração - LC 87/1996 (Lei Kandir).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.3.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DA UNIÃO ','Registra as outras variações patrimoniais aumentativas decorrentes da transferência de receitas da União, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é da União.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.01.00','COTA-PARTE ICMS','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte de ICMS.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.02.00','COTA-PARTE IPVA','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte de IPVA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.03.00','COTA-PARTE IPI-EXPORTAÇÃO','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte de IPI-Exportação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.04.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra o valor total das receitas recebidas pelos Municípios por meio de transferências constitucionais da contribuição de intervenção no domínio econômico (Emenda Constitucional nº 42, de 19/12/2003).','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.05.00','TRANSFERÊNCIA DA  COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Registra o valor da arrecadação de receita com a transferência da cota-parte da compensação financeira proveniente da exploração de recursos naturais','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.06.00','TRANSFERÊNCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAÚDE – REPASSE FUNDO A FUNDO','Registra o valor de receita da transferência de recursos do Sistema Único de Saúde oriundo do Fundo Estadual de Saúde para o Fundo Municipal de Saúde (Ações Básicas de Vigilância Sanitária, Atenção à Saúde dos Povos Indígenas, Programa de Assistência Farmacêutica Básica, Programa de Combate às Carências Nutricionais, Programa de Saúde da Família, Programa de Agentes Comunitários, Programa Nacional de Vigilância Epidemiológica e Controle de Doenças e outros)','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.1.4.99.00','OUTRAS PARTICIPAÇÕES NA RECEITA DOS ESTADOS','Compreendem as outras variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.2.0.00.00','TRANSFERÊNCIAS DO FUNDEB','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.2.3.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007, decorrentes de complementação da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.2.4.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.0.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.1.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.3.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.3.01.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.3.02.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.3.03.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.3.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.3.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.01.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.02.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.03.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.4.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.01.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.02.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.03.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.04.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.3.5.99.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.0.00.00','OUTRAS TRANSFERÊNCIAS','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.1.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.3.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.4.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.2.4.5.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas, inclusive de bens e valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para convênios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para combate à fome.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.1.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS ','Registra a variação patrimonial aumentativa decorrente de outras transferências financeiras das instituições privadas sem fins lucrativos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.01.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA CONVÊNIOS','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para convênios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.02.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS PARA COMBATE A FOME','Registra a variação patrimonial aumentativa decorrente das transferências financeiras das instituições privadas sem fins lucrativos para combate à fome.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.3.2.1.99.00','OUTRAS TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS ','Registra a variação patrimonial aumentativa decorrente de outras transferências financeiras das instituições privadas sem fins lucrativos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.0.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.1.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.1.01.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDEB','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Transferências de Recursos do FUNDEB.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.1.02.00','TRANSFERÊNCIAS DE RECURSOS DA COMPLEMENTAÇÃO DO FUNDEB','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Transferências de Recursos da Complementação do FUNDEB.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.4.0.1.99.00','OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Outras Transferências Multigovernamentais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.5.0.0.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.5.0.1.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.6.0.0.00.00','TRANSFERÊNCIAS DO EXTERIOR','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.6.0.1.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.0.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.01.00','DIÁRIAS ','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.3.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.01.00','DIÁRIAS ','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.4.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.01.00','DIÁRIAS ','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.1.5.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.0.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.01.00','DIÁRIAS ','Registra as variações patrimoniais aumentativas de diárias decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.02.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais aumentativas de passagens e despesas com locomoção decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.03.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais aumentativas de material de consumo decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.04.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA FÍSICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa física, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.05.00','OUTROS SERVIÇOS DE TERCEIRO PESSOA JURÍDICA','Registra as variações patrimoniais aumentativas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação à União ou descentralização para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.06.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais aumentativas de indenizações e restituições decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.7.2.1.99.00','DEMAIS VPAS COM DELEGAÇÕES','Registra as demais variações patrimoniais aumentativas decorrentes de delegação ou descentralização à União para execução de ações de responsabilidade exclusiva do delegante.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.8.0.0.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.5.8.0.1.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.0.0.0.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS','Compreende a variação patrimonial aumentativa com reavaliação e ganhos de ativos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.0.0.00.00','REAVALIAÇÃO DE ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo, quando esse for superior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.0.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.00','REAVALIAÇÃO DE BENS MÓVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis, quando esse for inferior ao valor liquido contábil.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.01','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para máquinas, ferramentas, aparelhos, equipamentos, acessórios etc, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.02','REAVALIAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes paraequipamentos de processamento de dados e sistemas aplicativos, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.03','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para mobiliário em geral e utensílios, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.04','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.05','REAVALIAÇÃO DE VEÍCULOS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para transportes aéreos, aquáticos e terrestres, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.06','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.07','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis em andamento, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.08','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens permanentes a serem estocados em almoxarifado, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.09','REAVALIAÇÃO DE ARMAMENTOS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para armas que constituem objetos de defesa ou preparativos de guerra, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.10','REAVALIAÇÃO DE SEMOVENTES','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.01.99','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para demais bens móveis não classificados em grupos específicos, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.00','REAVALIAÇÃO DE BENS IMÓVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens imóveis, quando esse for inferior ao valor liquido contábil.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.01','REAVALIAÇÃO DE BENS DE USO ESPECIAL','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.02','REAVALIAÇÃO DE BENS DOMINICAIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.03','REAVALIAÇÃO DE BENS DE USO COMUM DO POVO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.04','REAVALIAÇÃO DE BENS IMÓVEIS EM ANDAMENTO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os valores de bens imóveis em andamento, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.05','REAVALIAÇÃO DE INSTALAÇÕES','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.06','REAVALIAÇÃO DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.1.1.02.99','REAVALIAÇÃO DE DEMAIS BENS IMÓVEIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para os demais bens imóveis não classificados anteriormente nesse plano de contas, quando esse for inferior ao valor liquido contábil.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.2.0.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.2.1.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.9.0.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.1.9.1.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.0.0.00.00','GANHOS COM ALIENAÇÃO','Compreende o ganho com alienação de ativos, ou seja, quando o valor alienado do ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.0.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.1.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.1.01.00','GANHOS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial aumentativa de ganhos com alienação de participações permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.1.02.00','GANHOS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial aumentativa de ganhos com alienação de propriedades para investimento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.1.03.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial aumentativa de ganhos com alienação de investimentos do RPPS de longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.1.1.99.00','GANHOS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial aumentativa de ganhos com alienação de demais investimentos permanentes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.0.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Móveis.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.01','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Máquinas, Equipamentos e Ferramentas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.02','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS DE INFORMÁTICA','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens de Informática.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.03','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MÓVEIS E UTENSÍLIOS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Móveis e Utensílios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.04','GANHO LÍQUIDO COM A ALIENAÇÃO DE  MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Materiais Culturais, Educacionais e de Comunicação.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.05','GANHO LÍQUIDO COM A ALIENAÇÃO DE  VEÍCULOS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Veículos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.07','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Móveis em Andamento.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.08','GANHO LÍQUIDO COM A ALIENAÇÃO DE  BENS MÓVEIS EM ALMOXARIFADO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Móveis em Almoxarifado.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.09','GANHO LÍQUIDO COM A ALIENAÇÃO DE ARMAMENTOS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Armamentos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.10','GANHO LÍQUIDO COM A ALIENAÇÃO DE  SEMOVENTES','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Semoventes.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.01.99','GANHO LÍQUIDO COM A ALIENAÇÃO DE DEMAIS BENS MÓVEIS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Demais Bens Móveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.02.00','GANHO LÍQUIDO COM A ALIENAÇÃO DE BENS IMÓVEIS','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Ganho Líquido com a Alienação de Bens Imóveis.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.02.01','PRODUTO DE ALIENAÇÕES','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Produtos de Alienações.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.02.02','ALIENAÇÃO DE IMÓVEIS RURAIS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Alienação de Imóveis Rurais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.02.03','ALIENAÇÃO DE IMÓVEIS URBANOS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Alienação de Imóveis Urbanos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.02.99','ALIENAÇÃO DE OUTROS BENS IMÓVEIS','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho - Alienação de Outros Bens Imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.97.00','(-) DEDUÇÃO DOS GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende as deduções dos ganho com alienação de ativo imobilizado - Dedução dos Ganhos com Alienação de Imobilizado.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.97.01','(-) DEDUÇÃO ALIENAÇÃO DE BENS MÓVEIS','Registra as deduções dos ganho com alienação de ativo imobilizado - Dedução Alienação de Bens Móveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.2.1.97.02','(-) DEDUÇÃO ALIENAÇÃO DE BENS IMÓVEIS','Registra as deduções dos ganho com alienação de ativo imobilizado - Dedução Alienação de Bens Imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.0.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.1.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.1.01.00','GANHOS COM ALIENAÇÃO DE SOFTWARES','Registra a variação patrimonial aumentativa de ganhos com alienação de softwares.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.1.02.00','GANHOS COM ALIENAÇÃO DE MARCAS, DIREITOS E PATÉNTES INDUSTRIAIS','Registra a variação patrimonial aumentativa de ganhos com alienação de marcas, direitos e patentes industriais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.2.3.1.03.00','GANHOS COM ALIENAÇÃO DE DIREITO DE USO DE IMÓVEIS','Registra a variação patrimonial aumentativa de ganhos com alienação de direito de uso de imóveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.0.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de novos ativos descobertos, a contrapartida da incorporação de ativos semoventes nascidos, por exemplo.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.1.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.1.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.2.0.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.2.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.3.0.00.00','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','Compreende os ganhos  com a incorporação de valores apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.3.1.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','Compreende os ganhos  com a incorporação de ativos apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.9.0.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de outros novos ativos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.3.9.1.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','Compreende a contrapartida da incorporação de outros novos ativos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.4.0.0.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS','Compreende a contrapartida da desincorporação de passivos, inclusive as baixas de passivo decorrentes do cancelamento de restos a pagar.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.6.4.0.1.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','Compreende a contrapartida da desincorporação de passivos, inclusive as baixas de passivo decorrentes do cancelamento de restos a pagar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.0.0.0.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende o somatório das demais variações patrimoniais aumentativas não incluídas nos grupos anteriores, tais como: resultado positivo da equivalência patrimonial, dividendos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.1.01.00','VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRA OS VALORES REFERENTES A VARIACAO PATRIMONIAL AUMENTATIVAS DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS.','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.1.0.1.99.00','(-) DEDUCOES DA VARIACAO PATRIMONIAL AUMENTATIVA BRUTA A CLASSIFICAR','REGISTRAS OS VALORES REFERENTES AS DEDUCOES DAS VARIACAO PATRIMONIAL AUMENTATIVA DE DIVERSAS FONTES OU ORIGENS, QUE NAO TENHAM SIDO DEVIDAMENTE CLASSIFICADOS','X','S','N','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.0.0.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','Compreende o resultado positivo das participações de caráter permanente no capital social de sociedades investidas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.0.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.1.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.2.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.3.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.4.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.1.5.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.0.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.2.2.1.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.0.0.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões e ajustes de perdas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.0.00.00','REVERSÃO DE PROVISÕES','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.00.00','REVERSÃO DE PROVISÕES – CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.01.00','REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS','Registra a variação patrimonial aumentativa proveniente de reversão de provisão para riscos trabalhistas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.02.00','REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','Registra a variação patrimonial aumentativa proveniente de reversão de provisões matemáticas previdenciárias a longo prazo.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.03.00','REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS','Registra a variação patrimonial aumentativa proveniente de reversão de provisões para riscos fiscais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.04.00','REVERSÃO DE PROVISÕES PARA RISCOS CÍVEIS','Registra a variação patrimonial aumentativa proveniente de reversão de provisão riscos cíveis.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.05.00','REVERSÃO DE PROVISÕES REPARTIÇÃO DE CRÉDITO','Registra a variação patrimonial aumentativa proveniente de reversão de provisões por repartição de crédito.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.06.00','REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP','Registra a variação patrimonial aumentativa proveniente de reversão de provisões decorrentes de contratos de PPP.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.1.99.00','REVERSÃO DE OUTRAS PROVISÕES','Registra a variação patrimonial aumentativa proveniente de reversão de outras provisões.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.3.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.4.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - ESTADOS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.1.5.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - MUNICÍPIOS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.0.00.00','REVERSÃO DE AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.1.00.00','REVERSÃO DE AJUSTES DE PERDAS – CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.1.01.00','REVERSÃO DE AJUSTES DE PERDAS DE CRÉDITOS','Registra a variação patrimonial aumentativa proveniente de reversão de ajustes de perdas de créditos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.1.02.00','REVERSÃO DE AJUSTES DE PERDAS DE ESTOQUES','Registra a variação patrimonial aumentativa proveniente de reversão de ajustes de perdas de estoques.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.1.03.00','REVERSÃO DE AJUSTES DE INVESTIMENTOS E APLICAÇÕES','Registra a variação patrimonial aumentativa proveniente de reversão de ajustes de investimentos e aplicações.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.2.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS ','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.3.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – UNIÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.4.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – ESTADO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.7.2.5.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.0.0.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende outras variações patrimoniais aumentativas não classificadas em itens específicos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.2.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.1.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.0.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.3.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.4.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.2.5.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.0.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.3.1.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.0.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.1.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.2.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.3.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.4.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.4.5.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e município.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.0.00.00','MULTAS ADMINISTRATIVAS','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.5.1.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.0.00.00','INDENIZAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.00.00','INDENIZAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.01.00','INDENIZ. POR DANOS CAUSADOS AO PATR. PUBLICO','Registra a variação patrimonial aumentativa proveniente de indenizações por danos causados ao patrimônio público.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.02.00','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','Registra a variação patrimonial aumentativa proveniente de indenização por perda/quebra de mercadorias.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.03.00','INDENIZ. POSSE OU OCUPACAO ILIC. BENS ','Registra a variação patrimonial aumentativa proveniente de indenização por posse ou ocupação ilícita de bens.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.04.00','REPOSIÇÃO/INDENIZAÇÃO DE SERVIDORES/AGENTES PÚBLICOS','Registra a variação patrimonial aumentativa proveniente de reposição ou indenização por parte de servidores ou agentes públicos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.6.1.99.00','OUTRAS INDENIZACOES','Registra a variação patrimonial aumentativa proveniente de outras indenizações.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.0.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.01.00','VPA DE LEILOES DE MERCADORIAS APREENDIDAS','Registra as variações patrimoniais aumentativas geradas pela alienação em leilões de mercadorias apreendidas.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.02.00','VPA DE ALIENACAO DE BENS APREENDIDOS','Registra as variações patrimoniais aumentativas geradas pela alienação de bens apreendidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.03.00','VPA DE ALIEN.BENS APREE.TRAF.ILIC.ENT.DROG.AFINS','Registra as variações patrimoniais aumentativas geradas pela alienação de bens apreendidos por tráfico ilícito de entorpecentes, drogas e afins.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.70.00','RECEITA DE ALIENAÇÃO DE BENS CAUCIONADOS','Registra as variações patrimoniais aumentativas geradas pela alienação de Bens Caucionados.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.7.1.99.00','OUTRAS VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Registra as demais variações patrimoniais aumentativas geradas pela alienação de bens apreendidos.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.0.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '4.9.9.9.1.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.0.0.0.0.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registrar os atos e fatos ligados a execução orçamentária.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.0.0.0.00.00','PLANEJAMENTO APROVADO','Compreende o somatório dos valores monetários previstos para execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.1.0.0.00.00','PPA - APROVADO','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.1.1.0.00.00','APROVAÇÃO INICIAL DO PPA','Registra os valores monetários previstos inicialmente para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.1.2.0.00.00','REVISAO DO PPA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS REVISOES ANUAIS AUTORIZADAS DURANTE O PERIODO DE VIGENCIA DO PLANO PLURIANUAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.0.0.00.00','PLOA','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no projeto de lei orçamentária anual.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.1.0.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.1.1.00.00','PLOA INICIAL DA RECEITA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA PREVISAO DE RECEITA CONSTANTE DO PLOA INICIAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.1.2.00.00','ALTERACOES  DO PROJETO INICIAL DA LOA - RECEITA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A RECEITA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.2.0.00.00','PROJETO INICIAL DA LOA - DESPESA','COMPREENDE O SOMATORIO DOS VALORES MONETARIOS CONSTANTES DO PROJETO DA LEI ORCAMENTARIA ANUAL REMETIDO PELO PODER EXECUTIVO AO PODER LEGISLATIVO PARA APRECIACAO E APROVACAO.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.2.1.00.00','PLOA INICIAL DA DESPESA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DA FIXACAO DA DESPESA CONSTANTE DO PLOA INICIAL.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.1.2.2.2.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA','REGISTRA O SOMATORIO DAS ALTERACOES NO PROJETO INICIAL DA LOA EM RELACAO A DESPESA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.0.0.0.00.00','ORÇAMENTO APROVADO','Compreende o somatório dos valores relativos à previsão da receita, fixação da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.0.0.00.00','PREVISÃO DA RECEITA','Compreende o somatório dos valores relativos à previsão da receita pública aprovada pela lei orçamentária anual e suas alterações.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.0.00.00','PREVISÃO INICIAL DA RECEITA','Compreende o valor da receita previsão inicial da receita aprovado na LOA.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.1.00.00','PREVISAO INICIAL DA RECEITA  BRUTA','REGISTRA A PREVISÃO INICIAL DA RECEITA BRUTA APROVADA NA LOA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.2.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','Compreende a previsão de deduções da receita bruta aprovada na LOA.','X','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.2.01.00','(-) DEDUÇÕES  POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','Registra a previsão de dedução da receita aprovada na LOA por transferências constitucionais e legais.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.2.01.01','(-) FUNDEB','Registra a previsão de dedução da receita aprovada na LOA por transferências ao FUNDEB.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.2.01.02','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','Registra a previsão de dedução da receita aprovada na LOA por transferências constitucionais a municípios.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.2.02.00','(-) RENÚNCIA','Registra a previsão de renúncia da receita aprovada na LOA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.1.2.99.00','(-) OUTRAS DEDUÇÕES','Registra a previsão de outras deduções da receita aprovada na LOA.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.0.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','Compreende o valor dos créditos previstos após a aprovação do orçamento independente da autorização já concedida na lei orçamentária para abertura de credito suplementar.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.1.00.00','PREVISÃO ADICIONAL DA RECEITA','Compreende o valor adicional da receita para abertura de créditos adicionais.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.1.01.00','REESTIMATIVA','Registra o valor adicional da receita para abertura de créditos adicionais por motivo de reestimativa da receita.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.1.02.00','CORREÇÃO','Registra o valor adicional da receita para abertura de créditos adicionais por motivo de correção de erros ou omissões na estimativa da receita.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.1.2.9.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','Compreende o valor da anulação da receita prevista no orçamento, na gestão fundos e nas administrações direta e indireta.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.0.0.00.00','FIXAÇÃO DA DESPESA','Compreende o somatório dos valores relativos à fixação da despesa pública aprovada pela lei orçamentária e suas alterações.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.0.00.00','DOTAÇÃO ORÇAMENTÁRIA','Compreende o somatório dos valores monetários da dotação orçamentária inicial, adicional e seus cancelamentos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.00.00','DOTAÇÃO INICIAL','Compreende a dotação inicial autorizada na lei orçamentária anual.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.01.00','CREDITO INICIAL','COMPREENDE OS VALORES PERTINENTES AOS CREDITOS INICIALMENTE APROVADOS PARA DAR SUPORTE A EXECUCAO ORCAMENTARIA','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.02.00','CREDITOS ANTECIPADOS - LDO ','COMPREENDE OS VALORES RELATIVOS AS ANTECIPACOES DE CREDITOS DETERMINADOS PELA LEI DE DIRETRIZES ORCAMENTARIAS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.02.01','ANTECIPACAO - LDO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ANTECIPADOS PELA LEI DE DIRETRIZES ORCAMENTARIAS ATE QUE O ORCAMENTO SEJA APROVADO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.1.02.09','(-) ANULACAO DA ANTECIPACAO - LDO ','REGISTRA O VALOR REFERENTE AO CANCELAMENTO DE DOTACAO ANTECIPADA PREVISTA NA LEI DE DIRETRIZES ORCAMENTARIAS - LDO, APOS APROVACAO DO ORCAMENTO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CREDITO','Compreende o somatório dos valores monetários da dotação orçamentária decorrentes da abertura de créditos adicionais e seus cancelamentos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.01.00','CREDITO ADICIONAL – SUPLEMENTAR','Compreende o somatório dos valores relativos aos créditos adicionais suplementares com vista ao reforço da dotação orçamentária constante da lei orçamentária.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.00','CREDITO ADICIONAL - ESPECIAL','Compreende o somatório dos valores dos créditos adicionais especiais destinados a atender programas não contemplados na lei orçamentária anual.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.01','CRÉDITOS ESPECIAIS ABERTOS','Registra os valores referentes à abertura de créditos especiais autorizados em lei especifica.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.02','CRÉDITOS ESPECIAIS REABERTOS','Registra os valores referentes à reabertura de créditos especiais cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.02.03','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos especiais reabertos nos termos do § 2º do art. 167 da C.F./88.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.00','CREDITO ADICIONAL – EXTRAORDINÁRIO','Compreende o somatório dos valores referentes à abertura de créditos adicionais extraordinários destinados a despesas imprevisíveis e urgentes como as decorrentes de guerra, comoção interna ou calamidade pública.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.01','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','Registra os valores referentes aos créditos extraordinários abertos por decreto do poder executivo.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.02','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','Registra os valores referentes à reabertura de créditos extraordinários cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.2.03.03','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos extraordinários reabertos nos termos do § 2º do art. 168 da C.F./88.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.00.00','DOTAÇÃO ADICIONAL POR FONTE',' Compreende o somatório dos valores da dotação adicional por fonte de recursos para abertura do credito adicional.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.01.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR ','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.02.00','EXCESSO DE ARRECADACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.03.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.04.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.05.00','RESERVA DE CONTINGENCIA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA A RESERVA DE CONTINGENCIA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.06.00','DOTACAO TRANSFERIDA','REGISTRA OS VALORES DE ALTERACOES DA LEI ORCAMENTARIA COM CONTROLE POR ORIGEM DE CREDITO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.07.00','RECURSOS SEM DESPESAS CORRESPONDENTES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA OS RECURSOS QUE, EM DECORRENCIA DE VETO, EMENDA OU REJEICAO DO PROJETO DE LEI ORCAMENTARIA ANUAL, FICAREM SEM DESPESAS CORRESPONDENTES.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.09.00','(-) CANCELAMENTO DE DOTACOES','REGISTRA O CANCELAMENTO / REMANEJAMENTO DE DOTACOES PARA ABERTURA DE CREDITOS ADICIONAIS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.3.99.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','REGISTRA O VALOR DA CONTRAPARTIDA DOS LANCAMENTOS DAS DOTACOES ADICIONAIS POR ORIGEM DE CREDITO.','X','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','Compreende o somatório dos valores relativos aos créditos inicial, suplementar, especial e extraordinário cancelados ou remanejados, em casos regularmente previstos.','X','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.01.00','ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA ','COMPREENDE A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD (ELEMENTO DE DESPESA.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.01.01','ACRESCIMO','REGISTRA A MOVIMENTACAO DOS CREDITOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.01.09','(-)REDUCAO','REGISTRA A MOVIMENTACAO DOS CREDITOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESAS - QDD.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.02.00','ALTERACAO DA LEI ORCAMENTARIA ','COMPREENDE AS ALTERAÇÕES NA LEI ORÇAMENTÁRIA, INCLUSIVE AS DECORRENTES DE TRANSPOSIÇÃO, REMANEJAMENTO E TRANSFERÊNCIA DE DOTAÇÕES ORCAMENTÁRIAS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.02.01','ACRESCIMO','REGISTRA OS VALORES DOS ACRESCIMOS RESULTANTES DE ALTERACOES DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.02.09','(-)REDUCAO','REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI ORCAMENTARIA EM VIRTUDE DE REMANEJAMENTO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.1.9.04.00','(-)CANCELAMENTO DE DOTACOES','REGISTRA O VALOR DA REDUCAO DA DOTACAO DEVIDO A ALTERACAO DA LEI ORCAMENTARIA EM VIRTUDE DE CANCELAMENTO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','Compreende o somatório dos valores dos recebimentos de créditos orçamentários através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, recebidos ao longo do exercício.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.01.00','PROVISAO RECEBIDA','REGISTRA A PARCELA DE CREDITO RECEBIDA POR UMA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, DECORRENTE DA DESCENTRALIZACAO DO CREDITO ORCAMENTARIO OU ADICIONAL, DENTRO DO PROPRIO MINISTERIO OU ORGAO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.02.00','PROVISAO RECEBIDA - BLOQUEADA','REGISTRA A PARCELA DE CREDITOS ORCAMENTARIOS RECEBIDOS MEDIANTE PROVISAO E POSTERIORMENTE BLOQUEADOS, EM HIPOTESES ESPECIAIS, PELA UNIDADE CONCEDENTE.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO OU REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.09.01','ACRESCIMO ','REGISTRA O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.1.09.09','(-) REDUCAO','REGISTRA O VALOR DA MOVIMENTACAO DE CREDITOS ORCAMENTARIOS POR REDUCAO DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional recebido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.01.00','ADMINISTRACAO DIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.01.01','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO DIRETA DE OUTROS ORGAOS E ENTIDADES.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.01.09','(-) CREDITOS TRANSFERIDOS','REGISTRA A MOVIMENTACAO DE CREDITOS DE ENTIDADES DA ADMINISTRACAO INDIRETA OU ENTRE ORGAOS DA ADMINISTRACAO DIRETA DE UNIDADE ORCAMENTARIA DIFERENTE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.02.00','ADMINISTRACAO INDIRETA','COMPREENDE O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE RECEBIMENTO OU DE TRANSFERENCIA DE OUTROS ORGAOS E ENTIDADES DE IGUAL OU DE DIFERENTE UNIDADE ORCAMENTARIA.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.02.01','CREDITOS RECEBIDOS','REGISTRA O VALOR DOS CREDITOS RECEBIDOS PELA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA DO ORGAO EMITENTE.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.02.09','(-) CREDITOS TRANSFERIDOS','REGISTRA A MOVIMENTACAO DE CREDITOS DE ORGAOS DA ADMINISTRACAO DIRETA OU ENTRE ENTIDADES DA ADMINISTRACAO INDIRETA DE MESMA OU DE DIFERENTE UNIDADE ORCAMENTARIA, NAO FORMALIZADA A TERMO DE CONTRATO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA ALTERACAO DE CREDITOS ORCAMENTARIOS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.09.01','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA-QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.2.09.09','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DO CREDITO DISPONIVEL POR ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA-QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos recebidos por cisão, fusão, extinção, compensação e outras transações.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.9.01.00','CREDITOS EXT. RECEB. POR FUSAO/CISAO/EXTINCAO ','REGISTRA O VALOR DOS CREDITOS RECEBIDOS POR DESCENTRALIZACAO EXTERNA DECORRENTES DE FUSAO, CISAO OU EXTINCAO DE ORGAOS, ENTIDADES OU UG''S DURANTE O EXERCICIO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.2.9.02.00','CREDITOS INT. RECEB. POR FUSAO/CISAO/EXTINCAO ','REGISTRA O VALOR DOS CREDITOS RECEBIDOS POR DESCENTRALIZACAO INTERNA DECORRENTES DE FUSAO, CISAO OU EXTINCAO DE ORGAOS, ENTIDADES OU UG''S DURANTE O EXERCICIO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','Compreende o somatório relativos às dotações detalhadas relativas a cada ação orçamentária (projeto, atividade ou operações especiais).','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.3.1.00.00','CREDITOS A DETALHAR','COMPREENDE O VALOR DOS CREDITOS A DETALHAR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores das despesas pré-empenhadas e empenhadas por detalhamento específico.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.1.00.00','PRÉ-EMPENHOS DA DESPESA   ','COMPREENDE O CREDITO ORCAMENTARIO PRE-EMPENHADO, PARA ATENDER OBJETIVO ESPECIFICO, NOS CASOS EM QUE A DESPESA A SER REALIZADA, POR SUAS CARACTERISTICAS, EXIGE UM INTERVALO DE TEMPO DESDE A DECISAO DA REALIZACAO DA DESPESA ATE A EFETIVACAO DA EMISSAO DE NE.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.1.01.00','PRÉ-EMPENHOS EMITIDOS','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS PELA PROPRIA UNIDADE GESTORA DETENTORA PELO CREDITO DISPONIVEL.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.1.02.00','REFORÇO DE PRÉ-EMPENHO','Registra os valores de reforço de pré-empenho emitido pela própria unidade detentora do crédito disponível.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.1.03.00','ANULAÇÃO DE PRÉ-EMPENHO','Registra a anulação de pré-empenho emitido pela própria unidade detentora do crédito disponível.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.00.00','EMPENHOS POR EMISSÃO','REPRESENTA O SOMATÓRIO DOS VALORES DE EMPENHO EMITIDO POR ATO EMANADO DE AUTORIDADE COMPETENTE QUE CRIA PARA O PODER PÚBLICO A OBRIGAÇÃO DE PAGAR AS DESPESAS','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.00','EXECUÇÃO DA DESPESA POR NOTA DE EMPENHO','Compreende os valores executados da despesa, detalhados por nota de empenho.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.01','EMISSAO DE EMPENHOS','REGISTRA O VALOR DA EMISSÃO DE EMPENHO DA DESPESA, INCLUSIVE REFERENTE ÀQUELA DESPESA QUE JÁ SE ENCONTRA PRÉ-EMPENHADA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.02','REFORCO DE EMPENHOS','REGISTRA O VALOR DA EMISSÃO DE NOTA DE EMPENHO DE DESPESA VISANDO SUPLEMENTAR O ANTERIOR CUJO VALOR SEJA INSUFICIENTE.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.03','(-)ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSÃO TOTAL OU PARCIAL DE DESPESA À DOTAÇÃO INICIAL CORRESPONDENTE, ATRAVÉS DA "NOTA DE ANULAÇÃO" DA NE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.2.2.9.2.01.04','(-)CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','Registra o cancelamento de empenhos por falta de disponibilidade de caixa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.0.0.0.00.00','INSCRIÇÃO DE RESTOS A PAGAR','Compreende o somatório relativo ao valor da inscrição das despesas empenhadas e não pagas.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.0.0.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.1.0.00.00','RP NÃO PROCESSADOS INSCRITOS','Registra os valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas até o ultimo dia do exercício financeiro imediatamente anterior.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.2.0.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra o valor de restos a pagar não processados relativo a exercícios anteriores que não foram cancelados porque tiveram seu prazo de validade prorrogado.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.3.0.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','Registra o valor por restabelecimento de empenho de restos a pagar já cancelados em exercícios anteriores com base em ato normativo específico.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.6.0.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar não processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 531100000.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.0.0.00.00','INSCRIÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar processados.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.1.0.00.00','RP PROCESSADOS - INSCRITOS','Registra o somatório dos valores inscritos em restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro em que foi empenhado.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.2.0.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra os valores de restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro subseqüente.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.6.0.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '5.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 532100000.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.0.0.0.0.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de registra os atos e fatos ligados a execução orçamentária.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.0.0.0.00.00','EXECUÇÃO DO PLANEJAMENTO','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.0.0.00.00','EXECUÇÃO DO PPA','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.1.0.00.00','PPA A ALOCAR EM LEIS ORÇAMENTÁRIAS ANUAIS','Registra o somatório dos valores monetários do plano plurianual durante o seu período de vigência, detalhado por programas de trabalho a serem selecionados na elaboracao das leis orçamentárias anuais, nos quatro anos do PPA.','C','S ','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.2.0.00.00','PPA ALOCADO  EM LEIS ORÇAMENTÁRIAS ANUAIS','Registra o somatório dos valores monetários do plano plurianual aprovado, detalhado por programa de trabalho, alocado nas leis orçamentárias anuais ou relativos aos valores dos créditos antecipados pela LDO, dentro do período de vigência do PPA.','C','S ','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.1.3.0.00.00','PPA EXECUTADO ','Registra o somatório dos valores monetários empenhados do plano plurianual no seu período de vigência, detalhado por programa de trabalho, autorizado nas leis orçamentárias anuais.','C','S ','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.2.0.0.00.00','EXECUÇÃO DO PLOA','Compreende o somatório dos valores monetários de receitas e despesas previstos no projeto de lei orçamentária durante as suas fases de tramitação.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.2.1.0.00.00','PROCESSAMENTO DO PLOA -RECEITA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.1.2.2.0.00.00','PROCESSAMENTO DO PLOA -DESPESA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.0.0.0.00.00','EXECUÇÃO DO ORÇAMENTO','Compreende o somatório dos valores relativos à realização da receita, execução da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.0.0.00.00','EXECUÇÃO DA RECEITA','Compreende o somatório dos valores relativos à realização da receita pública aprovada pela lei orçamentária anual e suas alterações.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.1.0.00.00','RECEITA A REALIZAR','Registra o somatório dos valores relativos à receita pública aprovada pela lei orçamentária anual e suas alterações, detalhada por natureza da receita.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.2.0.00.00','RECEITA REALIZADA','Registra o somatório dos valores relativos às receitas realizadas, detalhada por natureza de receita.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.0.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','Compreende o somatório dos valores relativos às deduções de receitas realizadas (devoluções, restituições, e outras), detalhada por natureza de receita.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.1.00.00','(-) DEDUÇÕES  POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS, DETALHADA POR NATUREZA DE RECEITA.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.1.01.00','(-) FUNDEB','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS AO FUNDEB.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.1.02.00','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS AOS MUNICÍPIOS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.2.00.00','(-) RENÚNCIA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR RENUNCIA, DETALHADA POR NATUREZA DE RECEITA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.1.3.4.00.00','(-) OUTRAS DEDUCOES DA RECEITA REALIZADA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS OUTRAS DEDUCOES DE RECEITAS REALIZADAS, DETALHADA POR NATUREZA DE RECEITA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.0.0.00.00','EXECUÇÃO DA DESPESA','Compreende o somatório da disponibilidade de credito orçamentário e da execução da despesa em suas diversas etapas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.0.00.00','DISPONIBILIDADES DE CREDITO','Compreende o somatório da disponibilidade de credito orçamentário e suas alterações.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.1.00.00','CREDITO DISPONÍVEL','Registra o valor da disponibilidade de credito referente à dotação inicial e adicional aprovada no orçamento geral da União na loa ou lei especifica ou antecipada pela lei de diretrizes orçamentárias - LDO.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.00.00','CREDITO INDISPONÍVEL','Compreende o valor da indisponibilidade de credito orçamentário pelo seu contingenciamento ou liberação pendentes de autorização legislativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.01.00','BLOQUEIO DE CREDITO','REGISTRA O VALOR DA DISPONIBILIDADE DE CREDITOS ORCAMENTARIOS POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.02.00','CREDITO PRE-EMPENHADO ','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS PELA UNIDADE OU POR OUTRA UNIDADE GESTORA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.2.99.00','OUTRAS INDISPONIBILIDADES','REGISTRA O VALOR DAS INDISPONIBILIDADES DE CREDITOS ORCAMENTARIOS DE NATUREZA EVENTUAL, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.00.00','CREDITO UTILIZADO','Compreende o somatório dos valores referentes aos créditos orçamentários empenhados.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.01.00','CREDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.02.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.03.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.04.00','CREDITO EMPENHADO LIQUIDADO PAGO','Registra o valor da despesa empenhada liquidada paga.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.05.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','Registra o montante dos valores a liquidar inscritos em restos a pagar nao processados.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.06.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS','Registra o montante dos valores em liquidação inscritos em restos a pagar nao processados.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.07.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS','Registra o montante dos valores liquidados inscritos em restos a pagar processados.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.1.3.99.00','(-) OUTROS CRÉDITOS UTILIZADOS','Registra o somatório dos demais valores referentes aos créditos orçamentários empenhados.','D','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.0.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','Compreende o somatório dos valores dos créditos orçamentários concedidos através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, concedidos ao longo do exercício.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.01.00','PROVISAO CONCEDIDA','REGISTRA O CREDITO CONCEDIDO PELA UNIDADE ORCAMENTARIA A PARTIR DE SUA PROPRIA DOTACAO OU DE UM DESTAQUE A SEU FAVOR, PARA UNIDADE ADMINISTRATIVA OU ORCAMENTARIA, NO AMBITO DO PROPRIO MINISTERIO OU ORGAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.02.00','PROVISAO CONCEDIDA - BLOQUEADA ','REGISTRA O BLOQUEIO DOS CREDITOS ORCAMENTARIOS CONCEDIDOS MEDIANTE PROVISAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA VARIACAO DE CREDITOS ORCAMENTARIOS DISPONIVEIS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.09.01','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.1.09.09','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional concedido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.01.00','ADMINISTRACAO DIRETA','COMPREENDE O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.01.01','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO DIRETA TRANSFERIDORA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.02.00','ADMINISTRACAO INDIRETA','COMPREENDE O VALOR REFERENTE AO MOVIMENTO DE CREDITOS DECORRENTES DE CONCESSAO PELA UNIDADE ORCAMENTARIA DA ENTIDADE DA ADMINISTRACAO INDIRETA TRANSFERIDORA.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.02.01','CREDITOS CONCEDIDOS','REGISTRA O VALOR REFERENTE A MOVIMENTACAO DE CREDITOS DECORRENTES DE SUA CONCESSAO PELA UNIDADE ORCAMENTARIA DO ORGAO DA ADMINISTRACAO INDIRETA TRANSFERIDORA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.09.00','ALTERACAO DE CREDITOS MOVIMENTADOS','COMPREENDE O VALOR DA VARIACAO DE CREDITOS ORCAMENTARIOS DISPONIVEIS POR ACRESCIMO OU REDUCAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.09.01','ACRESCIMO','REGISTRA O VALOR DO ACRESCIMO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA - QDD, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.2.09.09','(-) REDUCAO','REGISTRA O VALOR DA REDUCAO DE CREDITO DISPONIVEL DECORRENTE DE ALTERACAO DO QUADRO DE DETALHAMENTO DE DESPESA, POR UG NAO PERTENCENTE AO ORGAO OU ENTIDADE DA UNIDADE ORCAMENTARIA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.2.9.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Compreende as movimentações de créditos concedidos por cisão, fusão, extinção, compensação e outras transações.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.3.0.00.00','DETALHAMENTO DE CREDITO','Compreende o detalhamento das dotações orçamentárias relativas a cada programa de trabalho.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.3.1.00.00','CREDITOS DETALHADOS','REGISTRA O VALOR DOS CREDITOS DETALHADOS POR FONTE DE RECURSOS, UG RESPONSAVEL E NATUREZA DE DESPESA (ELEMENTO DE DESPESA E / OU MODALIDADE DE APLICACAO).','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.0.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores executados das despesas pré-empenhadas e empenhadas por detalhamento específico.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.1.00.00','DESPESA PRE-EMPENHADA','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS PRE-EMPENHADAS PELA PROPRIA UNIDADE GESTORA, TRANSFERIDOS OU RECEBIDOS POR TRANSFERENCIA, POR DETALHAMENTO ESPECIFICO E SUAS RESPECTIVAS ANULACOES.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.1.01.00','PRE-EMPENHOS A EMPENHAR ','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS E/OU SEUS RESPECTIVOS REFORCOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.1.02.00','PRE-EMPENHOS EMPENHADOS ','REGISTRA OS VALORES DOS PRE-EMPENHOS E/OU SEUS RESPECTIVOS REFORCOS, EMITIDOS E EMPENHADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.00.00','EMISSAO DE EMPENHO','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS EMPENHADAS POR DETALHAMENTO ESPECIFICO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.00','EMPENHOS POR NOTA DE EMPENHO','COMPREENDE O VALOR DA EMISSAO DE DOCUMENTOS ATRAVES DOS QUAIS SAO REGISTRADOS OS ESTAGIOS DAS DESPESAS ORCAMENTARIAS REALIZADAS PELA ADMINISTRACAO PUBLICA.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.01','EMPENHOS A LIQUIDAR ','REGISTRA O VALOR DOS EMPENHOS DE DESPESAS PENDENTES DE LIQUIDACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.02','EMPENHOS EM LIQUIDACAO','REGISTRA O SOMATORIO DAS DESPESAS CUJO FATO GERADOR TENHA OCORRIDO, TENDO INICIADO E NAO CONCLUIDO O PROCESSO DE LIQUIDACAO DA DESPESA ORCAMENTARIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.03','EMPENHOS LIQUIDADOS A PAGAR ','REGISTRA O VALOR DOS EMPENHOS APOS VERIFICACAO DO DIREITO ADQUIRIDO PELO CREDOR OU ENTIDADE BENEFICIARIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.2.2.9.2.01.04','EMPENHOS LIQUIDADOS PAGOS','REGISTRA O MONTANTE DOS VALORES PAGOS, CONTROLADOS POR NOTA DE EMPENHO E SUBITEM.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.0.0.0.00.00','EXECUÇÃO DE RESTOS A PAGAR','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas e não pagas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.0.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.1.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.2.0.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.3.0.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.4.0.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.5.0.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.6.0.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.7.0.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Compreende o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.7.1.00.00','RP NAO PROCESSADOS A LIQUIDAR-  INSCRICAO NO EXERCICIO ','REGISTRA O VALOR DAS DESPESAS EMPENHADAS A LIQUIDAR INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631100000.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.7.2.00.00','RP NAO PROCESSADOS EM LIQUIDACAO -  INSCRICAO NO EXERCICIO ','REGISTRA O VALOR DAS DESPESAS EMPENHADAS EM LIQUIDACAO INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631200000.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.9.0.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.9.1.00.00',' CANCELAMENTOS POR INSUFICIENCIA DE RECURSOS','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.1.9.9.00.00','OUTROS CANCELAMENTOS DE RP   ','REGISTRA O VALOR DOS RESTOS A PAGAR NAO PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.0.0.00.00','EXECUÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.1.0.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.2.0.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.6.0.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.7.0.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.0.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.1.00.00','POR VALORES E/OU INSCRICOES INDEVIDAS','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO POR VALORES E/OU INSCRICOES.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '6.3.2.9.9.00.00','OUTROS CANCELAMENTOS DE RP','REGISTRA O VALOR DOS RESTOS A PAGAR PROCESSADOS CANCELADOS NOS EXERCICIOS SUBSEQUENTES AO DA SUA INSCRICAO, EXCETO OS CANCELADOS POR INSUFICIENCIA DE RECURSOS FINANCEIROS OU POR INSCRICAO INDEVIDA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.0.0.0.0.00.00','CONTROLES DEVEDORES','Compreende as contas em que são registrados atos potenciais e controles específicos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.0.0.0.00.00','ATOS POTENCIAIS','Compreende contas relacionadas às situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.0.0.00.00','ATOS POTENCIAIS ATIVOS','Compreende os atos e fatos que possam vir a aumentar o ativo da entidade governamental.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.0.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas recebidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.00','GARANTIAS RECEBIDAS NO PAÍS','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.02','FIANÇAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAÍS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NÃO CUMPRA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.03','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.04','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.05','CAUÇÕES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TÍTULOS, VALORES E BENS RECEBIDOS EM CAUÇÕES NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECÍFICA, NO PAÍS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO ÂMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.07','GARANTIAS DA DÍVIDA PÚBLICA','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DÍVIDA PÚBLICA, NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.08','APÓLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.01.99','OUTRAS GARANTIAS  RECEBIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS GARANTIAS RECEBIDAS, NÃO INCLUÍDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAÍDAS NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.00','GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO EXTERIOR.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.02','FIANÇAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NÃO CUMPRA, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.03','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.04','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.05','CAUÇÕES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TÍTULOS, VALORES E BENS RECEBIDOS EM CAUÇÕES NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECÍFICA, NO PAÍS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO ÂMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.07','GARANTIAS DA DÍVIDA PÚBLICA ','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DÍVIDA PÚBLICA, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.08','APÓLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS GARANTIAS RECEBIDAS, NÃO INCLUÍDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAÍDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.00','CONTRAGARANTIAS RECEBIDAS NO PAÍS','COMPREENDE O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.01','AVAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.02','FIANÇAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.01','AVAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.02','FIANÇAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS EM VIRTUDE DE GARANTIAS INSTITUI-DAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.0.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVÊNIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.01.00','DIREITOS CONVENIADOS ','REGISTRA O VALOR TOTAL FIRMADO DOS CONVÊNIOS FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.02.00','TERMO DE COOPERAÇÃO','REGISTRA VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERAÇÃO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES ','REGISTRA O VALOR TOTAL RECEBIDO DE OUTROS INSTRUMENTROS CONGÊNERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.0.00.00','DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de direitos contratuais, quando a administração pública participa como contratada.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.00.00','DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','REGISTRA O VALOR DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','REGISTRA O VALOR DO CONTRATO DE ALUGUÉIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGAÇÃO DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','Registra o valor por contrato das despesas derivadas de PPP contratadas pelo ente da Federação excluídas as empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados.Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','Registra o valor por contrato das despesas derivadas de PPP contratadas pelas empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados. Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','REGISTRA O VALOR DE OUTROS DIREITOS CONTRATUAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.1.9.0.00.00','OUTROS ATOS POTENCIAIS ATIVOS','Compreende os atos potenciais ativos não contemplados em contas especificas.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.0.0.00.00','ATOS POTENCIAIS PASSIVOS','Registra os atos e fatos que possam vir a aumentar o passivo ou diminuir o ativo da entidade governamental.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.0.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.00','GARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.02','FIANÇAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAÍS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NÃO CUMPRA.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.03','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.04','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.05','CAUÇÕES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TÍTULOS, VALORES E BENS RECEBIDOS EM CAUÇÕES NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECÍFICA, NO PAÍS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO ÂMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.01.99','OUTRAS GARANTIAS E CONTRAGARANTIAS RECEBIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUÍDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAÍDAS NO PAÍS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.00','GARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO EXTERIOR.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.01','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.02','FIANÇAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA POR ORGAOS E ENTIDADES PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NÃO CUMPRA, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.03','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.04','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.05','CAUÇÕES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TÍTULOS, VALORES E BENS RECEBIDOS EM CAUÇÕES NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.06','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECÍFICA, NO PAÍS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO ÂMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.02.99','OUTRAS GARANTIAS E CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUÍDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAÍDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.00','CONTRAGARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.01','AVAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.02','FIANÇAS','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.03.04','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.01','AVAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.02','FIANÇAS','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.03','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.0.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, do valor dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.00.00','OBRIGAÇÕES CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVÊNIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.01.00','OBRIGAÇÕES CONVENIADOS ','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVÊNIOS FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.02.00','TERMO DE COOPERAÇÃO','REGISTRA VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERAÇÃO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.2.1.99.00','OUTROS INSTRUMENTOS CONGÊNERES ','REGISTRA O VALOR TOTAL RECEBIDO DE OUTROS INSTRUMENTROS CONGÊNERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.0.00.00','OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de obrigações contratuais, quando a administração pública participa como contratante.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.00.00','OBRIGAÇÕES CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.01.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','REGISTRA O VALOR DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','REGISTRA O VALOR DO CONTRATO DE ALUGUÉIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGAÇÃO DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.06.00','CONTRATO DE GESTÃO','REGISTRA OS CONTRATOS DE GESTÃO, nos termos do artigo 37, par. 8º da CF/88.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.07.00','TERMO DE PARCERIA','REGISTRA O VALOR DE TERMO DE PARCERIA DE TERCEIROS COM ÓRGÃO/ENTIDADE','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.08.00','CONTRATOS DE PPP','Compreende o valor dos passivos decorrentes de contrato de PPP que devem abranger o valor presente da melhoria de um ativo não financeiro passível de transferência ao setor público e das prestações dos serviços objeto do contrato, incluindo a parcela variável condicionada à qualidade do serviço, e também aqueles decorrentes de riscos não provisionados, ou ainda outros valores que se entender necessários.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS','Registra o valor dos ativos contingentes referentes a contraprestações futuras devidas pelo ente ao Parceiro Privado','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.08.02','RISCOS NÃO PROVISIONADOS','Registra o valor dos passivos contingentes referentes a riscos assumidos em decorrência de garantias concedidas ao parceiro privado ou em seu benefício, que não tenham sido registradas com Provisões de PPP.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.08.03','OUTROS PASSIVOS CONTINGENTES','Registra o valor dos demais passivos contingentes referentes a PPP.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.3.1.99.00','OUTROS OBRIGAÇÕES CONTRATUAIS','REGISTRA O VALOR DE OUTRAS OBRIGAÇÕES CONTRATUAIS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.1.2.9.0.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','Compreende os atos potenciais passivos não contemplados em contas especificas.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.0.0.0.00.00','ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da programação financeira e de controle das disponibilidades.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.0.0.00.00','DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram os controles sobre as disponibilidades por destinação de recursos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.1.0.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram as disponibilidades de recursos recebidos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.1.1.00.00','RECURSOS ORDINÁRIOS','Registra as disponibilidades por destinação de recursos ordinários.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.1.2.00.00','RECURSOS VINCULADOS ','Registra as disponibilidades por destinação de recursos vinculados.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.1.3.00.00','RECURSOS EXTRAORÇAMENTÁRIOS','Registra as disponibilidades por destinação de recursos extraorçamentários.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.2.0.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','Compreende as contas que controlam a inscrição do limite de restos a pagar, classificados por destinação de recursos','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.1.3.0.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','Compreende as contas que controlam a inscrição dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.2.0.0.00.00','PROGRAMAÇÃO FINANCEIRA','Compreende as contas que registram as cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.3.0.0.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','Compreende as contas que controlam o limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que registram o valor da arrecadação liquida da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.0.0.0.00.00','DIVIDA ATIVA','Compreende o controle dos créditos a serem inscritos em divida ativa, dos que se encontram em processamento. Compreende as contas que controlam os créditos passiveis de serem encaminhados e inscritos em divida ativa o de inscrição e a tramitação dos créditos inscritos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.0.0.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Compreende os valores passiveis de serem encaminhados e inscritos em divida ativa.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.0.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  ','Compreende o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.1.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA ','Compreende o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa Tributária..','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.1.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa, referentes a impostos.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.1.02.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa, referentes a taxas','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.1.03.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa, referentes a contribuições de melhoria.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.2.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  NÃO-TRIBUTÁRIA','Compreende o montante dos créditos a encaminhar e encaminhados para inscrição em Dívida Ativa Não-Tributária..','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.1.1.2.01.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA  NÃO-TRIBUTÁRIA','Registra o montante dos créditos a encaminhar e encaminhados para inscrição em Dívida Ativa Não-Tributária..','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.2.0.0.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que controlam os créditos passiveis de serem inscritos em divida ativa pelo órgão responsável pela inscrição em divida ativa.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.2.1.0.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA ','Compreende os valores dos créditos passíveis de serem inscritos em dívida ativa pelo órgão responsável pela inscrição em dívida ativa.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.2.1.1.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende o valor dos créditos de origem tributária passíveis de serem inscritos em dívida ativa pelo órgão competente.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.3.2.1.2.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende o valor dos créditos de natureza não-tributára passíveis de serem inscritos em dívida ativa pelo órgão competente.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.0.0.0.00.00','RISCOS FISCAIS','Compreende as contas que controlam os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.0.0.00.00','CONTROLE DE PASSIVOS CONTINGENTES','Compreende as contas que registram o controle dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.0.00.00','PASSIVOS CONTINGENTES','Registra os riscos fiscais classificados como Passivos Contingentes.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.1.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes;c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.0.0.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','Compreende as contas que registram os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS ','COMPREENDE OS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','Registra a estimativa do montante de redução de arrecadação que apresenta probabilidade de vir a ocorrer no exercício, decorrente de, por exemplo, cenários macroeconômicos desfavoráveis não previstos na época da elaboração do Orçamento.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','Registra a estimativa do montante de devolução de tributos a maior que apresenta probabilidade de vir a ocorrer no exercício.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','Registra a estimativa do montante de redução no valor dos ingressos ou de aumento no valor dos desembolsos que apresentam probabilidade de vir a ocorrer no exercício, decorrentes de evolução desfavorável de indicadores econômicos empregados na época da elaboração do Orçamento, tais como: a) Taxa de crescimento econômico; b) Taxa de inflação; c) Taxa de câmbio; d) Taxa de juros; e) Salário mínimo; f) Outros indicadores.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de riscos fiscais.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.5.0.0.0.00.00','CONSÓRCIOS PÚBLICOS','Compreende as contas que controlam o registro de atos dos consórcios públicos (do ente consorciado e/ou do próprio consórcio), incluindo os controles do contrato de rateio, controle da prestação de contas, bem como as informações que serão consolidadas no ente consorciado para fins de elaboração dos demonstrativos dos consórcios, conforme Portaria STN 72/2012.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.5.1.0.0.00.00','CONTRATO DE RATEIO DE CONSÓRCIOS PÚBLICOS','Compreende contas relacionadas ao registro dos valores de obrigações contratuais decorrentes de Consórcios Públicos','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.5.2.0.0.00.00','PRESTAÇÃO DE CONTAS DE CONSÓRCIOS PÚBLICOS','Compreende contas relacionadas ao registro do controle da prestação de contas dos Consórcios Públicos.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO  DO CONSÓRCIO','Compreende as informações referentes aos Consórcios Públicos, atribuídas ao ente consorciado com base no contrato de rateio,que serão enviadas pelo consórcio para os entes consorciados para fins de elaboração dos demonstrativos fiscais ( Saúde, pessoal, educação e disponibilidade de caixa), em atendimento a Portaria STN n.º 72/2012. Conta para uso do ente consorciado.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.8.0.0.0.00.00','CUSTOS','Compreende as contas que controlam os custos de bens e serviços produzidos.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.0.0.0.00.00','OUTROS CONTROLES','Compreende de controles não especificados anteriormente nos grupos dessa classe.','D','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.0.0.00.00','RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.0.00.00','RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.0.00.00','RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','D','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.1.00.00','CONTROLE DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','REGISTRA OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.2.00.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','Registra o valor dos ativos produzidos por meio de Parcerias Público Privadas contabilizados na Sociedade de Propósito Específico.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.1.2.9.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '7.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','D','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.0.0.0.0.00.00','CONTROLES CREDORES','Compreende as contas em que são registradas a execução de atos potenciais e controles específicos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.0.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','Compreende contas relacionadas à execução de situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos e fatos que possa vir a afetar o ativo da entidade governamental.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidos no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDOS NO PAÍS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO PAÍS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEDIDOS NO PAÍS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.02','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.03','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.04','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.05','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.06','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.07','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.08','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.09','CAUÇÕES A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÕES PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.10','CAUÇÕES EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÕES NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS DA DÍVIDA PUBLICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DÍVIDA PUBLICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.15','APÓLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APÓLICES DE SEGUROS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.16','APÓLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APÓLICES DE SEGUROS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.98','OUTRAS GARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.01.99','OUTRAS GARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.00','EXECUÇÃO DE GARANTIAS   RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.02','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.03','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.04','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.05','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.06','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.07','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.08','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.09','CAUÇÕES A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÕES PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.10','CAUÇÕES EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÕES NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.11','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.12','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.13','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.14','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.15','APÓLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APÓLICES DE SEGUROS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.16','APÓLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APÓLICES DE SEGUROS, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.98','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.02.99','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO PAÍS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO PAÍS BEM COMO OUTRAS CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.02','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.03','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.04','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.03.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO OUTRAS CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.02','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.03','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.04','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.05','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.06','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.98','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.1.1.04.99','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.0.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGÊNERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.00','EXECUÇÃO DE CONVÊNIOS ','COMPREENDE A EXECUÇÃO DOS VALORES DE CONVÊNIOS PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.01','CONVÊNIOS A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.02','CONVÊNIOS A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.03','CONVÊNIOS A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.04','CONVÊNIOS APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.05','CONVÊNIOS IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVÊNIO FIRMADO, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.07','CONVÊNIO SEM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVÊNIO FIRMADO, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.08','CONVÊNIOS HOMOLOGADOS','REGISTRA A EXECUÇÃO DOS VALORES HOMOLOGADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.09','CONVÊNIOS CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVÊNIO FIRMADO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.10','CONVÊNIOS NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVÊNIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUÇÃO NR. 13.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.11','CONVÊNIOS ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVÊNIOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUIDO DE CONVÊNIO FIRMADO , APÓS A APROVAÇÃO TOTAL DA PRESTACAO DE CONTAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.00','TERMO DE COOPERAÇÃO ','COMPREENDE A EXECUÇÃO DOS VALORES DE TERMO DE COOPERAÇÃO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.01','TERMO DE COOPERAÇÃO A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.09','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.00','OUTROS INSTRUMENTOS CONGÊNERES ','COMPREENDE A EXECUÇÃO DOS VALORES DE OUTROS INSTRUMENTOS CONGÊNERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.01','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.2.1.03.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.0.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de direitos contratuais, quando a administração pública participa como contratada.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.01.01','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.01.02','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.02.00','CONTRATOS DE SERVIÇOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.02.01','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVIÇOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.02.02','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES REALIZADOS DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.03.00','CONTRATOS DE ALUGUÉIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE ALUGUÉIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.03.01','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUÉIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.03.02','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUÉIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.04.01','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.04.02','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUÇÃO EXECUÇÃO DE CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAÍDOS NO EXERCICIO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.05.01','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAÍDOS NO EXERCICIO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.05.02','EXECUTADOS','REGISTRA A EXECUÇÃO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAÍDOS NO EXERCICIO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.00','CONTRATOS DE PPP - DO ENTE FEDERADO','Compreende o valor por contrato das despesas derivadas de PPP contratadas pelo ente da Federação excluídas as empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados.Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.01','CONTRATOS DE PPP - DO ENTE FEDERADO - EC','Registra, por contrato, os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para o resto do ano.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.02','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 1','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 1º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.03','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 2','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 2º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.04','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 3','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 3º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.05','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 4','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 4º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.06','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 5','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 5º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.07','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 6','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 6º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.08','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 7','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 7º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.09','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 8','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 8º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.06.10','CONTRATOS DE PPP - DO ENTE FEDERADO - EC + 9','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 9º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','Compreende o valor por contrato das despesas derivadas de PPP contratadas pelas empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados. Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.01','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC','Registra, por contrato, os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para o resto do ano.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.02','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 1','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 1º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.03','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 2','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 2º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.04','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 3','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 3º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.05','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 4','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 4º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.06','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 5','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 5º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.07','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 6','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 6º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.08','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 7','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 7º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.09','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 8','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 8º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.07.10','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES - EC + 9','Registra, por contrato, os valores das despesas derivadas de contratos de PPP no 9º ano seguinte ao exercício corrente.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.99.00','OUTROS DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE OUTROS DIREITOS CONTRATUAIS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.99.01','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.3.1.99.02','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos potenciais ativos não contemplados em contas especificas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.1.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDAÇÃO','Compreende a execução dos atos potenciais ativos não contemplados em contas especificas. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.0.0.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','Registra a execução dos atos e fatos que possa vir a afetar o passivo da entidade governamental.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.0.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.00','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.04','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.06','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.13','CAUÇÕES A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÕES PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.15','CAUÇÕES EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÕES NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.19','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.01.21','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.00','EXECUÇÃO DE GARANTIAS E  CONCEDIDAS NO EXTERIOR','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR AVAL PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR AVAL NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.04','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR FIANÇAS PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.06','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.07','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.09','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.10','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO EXTERIOR','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.12','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.13','CAUÇÕES A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÕES PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.15','CAUÇÕES EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÕES NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.16','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.18','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.19','OUTRAS GARANTIAS CONCEDIDAS NO EXTERIOR A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO , NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.02.21','OUTRAS GARANTIAS RECEBIDAS NO EXTERIOR EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO EXTERIOR.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS , BEM COMO OUTRAS CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.04','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.06','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.10','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.03.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS , BEM COMO OUTRAS CONTRAGARANTIAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.01','AVAIS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.03','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.04','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.06','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.07','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.09','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.10','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.1.1.04.12','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS NO PAÍS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, da execução do valor dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGÊNERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.00','EXECUÇÃO DE CONVÊNIOS ','COMPREENDE A EXECUÇÃO DOS VALORES DE CONVÊNIOS PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.01','CONVÊNIOS A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.02','CONVÊNIOS A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.03','CONVÊNIOS A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.04','CONVÊNIOS APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.05','CONVÊNIOS IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.06','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVÊNIO FIRMADO, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.07','CONVÊNIOSEM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVÊNIO FIRMADO, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.08','CONVÊNIOS HOMOLOGADOS','REGISTRA A EXECUÇÃO DOS VALORES HOMOLOGADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.09','CONVÊNIOS CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVÊNIO FIRMADO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.10','CONVÊNIOS NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVÊNIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUÇÃO NR. 13.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.11','CONVÊNIOS ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVÊNIOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.01.12','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUIDO DE CONVÊNIO FIRMADO , APÓS A APROVAÇÃO TOTAL DA PRESTACAO DE CONTAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.00','TERMO DE COOPERAÇÃO ','COMPREENDE A EXECUÇÃO DOS VALORES DE TERMO DE COOPERAÇÃO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.01','TERMO DE COOPERAÇÃO A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.02','TERMO DE COOPERAÇÃO A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.03','TERMO DE COOPERAÇÃO A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.04','TERMO DE COOPERAÇÃO APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.05','TERMO DE COOPERAÇÃO IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.06','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.07','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.08','TERMO DE COOPERAÇÃO CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.09','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.02.10','TERMO DE COOPERAÇÃO CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.00','OUTROS INSTRUMENTOS CONGÊNERES ','COMPREENDE A EXECUÇÃO DOS VALORES DE OUTROS INSTRUMENTOS CONGÊNERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.01','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.02','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.03','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.04','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.05','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.06','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.07','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.08','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.09','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.2.1.03.10','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.0.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de obrigações contratuais, quando a administração pública participa como contratante.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.00.00','EXECUÇÃO DE OBRIGAÇÕES -CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.01.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.01.01','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.01.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.02.00','CONTRATOS DE SERVIÇOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUCAO DOS VALORES DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE .','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.02.01','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS A CONTRATOS DE SERVICOS, EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.02.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS DO CONTRATO DE SERVICOS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.03.00','CONTRATOS DE ALUGUÉIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.03.01','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.03.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.04.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.04.01','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.04.02','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.05.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.05.01','A EXECUTAR','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.05.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.00','CONTRATO DE GESTÃO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.01','A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.06.02','LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.07.00','TERMO DE PARCERIA','COMPREENDE VALORES RELACIONADOS A EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A TERMO DE PARCERIA','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.07.01','A EXECUTAR','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A TERMO DE PARCERIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.07.02','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A TERMO DE PARCERIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.00','CONTRATOS DE PPP','Compreende o valor dos passivos decorrentes de contrato de PPP que devem abranger o valor presente da melhoria de um ativo não financeiro passível de transferência ao setor público e das prestações dos serviços objeto do contrato, incluindo a parcela variável condicionada à qualidade do serviço, e também aqueles decorrentes de riscos não provisionados, ou ainda outros valores que se entender necessários.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.01','CONTRAPRESTAÇÕES FUTURAS - A EXECUTAR','Registra o valor dos ativos contingentes referentes a contraprestações futuras devidas pelo ente ao Parceiro Privado ainda não executadas.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.02','CONTRAPRESTAÇÕES FUTURAS - EXECUTADAS','Registra o valor dos ativos contingentes referentes a contraprestações futuras devidas pelo ente ao Parceiro Privado já executadas.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.03','RISCOS NÃO PROVISIONADOS - A EXECUTAR','Registra o valor dos passivos contingentes a executar referentes a riscos assumidos em decorrência de garantias concedidas ao parceiro privado ou em seu benefício, que não tenham sido registradas com Provisões de PPP.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.04','RISCOS NÃO PROVISIONADOS - EXECUTADOS','Registra o valor dos passivos contingentes executados referentes a riscos assumidos em decorrência de garantias concedidas ao parceiro privado ou em seu benefício, que não tenham sido registradas com Provisões de PPP.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.05','OUTROS PASSIVOS CONTINGENTES - A EXECUTAR','Registra o valor de outros passivos contingentes a executar.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.08.06','OUTROS PASSIVOS CONTIGENTES - EXECUTADOS','Registra o valor de outros passivos contingentes executados','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.99.00','OUTRAS OBRIGAÇÕES CONTRATUAIS','Registra os valores de outras obrigações contratuais de PPP.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.99.01','A EXECUTAR','Registra os valores de outras obrigações contratuais de PPP a executar.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.3.1.99.02','EXECUTADOS','Registra os valores de outras obrigações contratuais de PPP executados.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.0.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos potenciais passivos não contemplados em contas especificas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.1.2.9.1.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDAÇÃO','Compreende a execução dos atos potenciais passivos não contemplados em contas especificas. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.0.0.0.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da execução da programação financeira e de controle das disponibilidades.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.0.0.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que registram a execução dos controles das disponibilidades por destinação de recursos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.0.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram a execução das disponibilidades de recursos a utilizar, comprometidas e utilizadas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.1.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','Registra o valor das disponibilidades de recursos a utilizar.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.2.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','Registra o valor das disponibilidades de recursos comprometidas por ocasião do empenho e não liquidadas.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.3.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','Compreende o valor das disponibilidades de recursos comprometidas por ocasião da liquidação e de entradas compensatórias e não pagas/devolvidas.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.3.01.00','COMPROMETIDA POR LIQUIDAÇÃO','Registra o valor das disponibilidades de recursos comprometidas por ocasião da liquidação. O saldo desta conta representa o valor líquido dos empenhos a pagar.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.3.02.00','COMPROMETIDA POR CONSIGNAÇÕES/RETENÇÕES','Registra o valor das disponibilidades de recursos comprometidas por consignação/retenção.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.3.03.00','COMPROMETIDA POR ENTRADAS COMPENSATÓRIAS','Registra o valor das disponibilidades de recursos comprometidas por entradas compensatórias, como depósitos de cauções e outros','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.4.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','Registra o valor das disponibilidades de recursos utilizadas por meio de pagamento de despesa orçamentária, depósitos e/ou outros.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.1.5.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA','Registra o valor das disponibilidades de recursos comprometidas por programação financeira no órgão central de programação financeira.','C','S','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.2.0.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','Compreende as contas que registram a execução financeira do limite de restos a pagar.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.1.3.0.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','Compreende as contas que controlam a execução dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.2.0.0.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','Compreende as contas que registram a execução das cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.3.0.0.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','Compreende as contas que controlam a execução do limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.2.4.0.0.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que registram os valores discriminados da arrecadação da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.0.0.0.00.00','EXECUÇÃO DA DIVIDA ATIVA','Compreende as contas que controlam a execução dos créditos passiveis de serem encaminhados e inscritos em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.0.0.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem encaminhados e os já encaminhados para o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.0.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA','Compreende os valores a serem encaminhados para o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.1.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA','Compreende os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.1.01.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a impostos.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.1.02.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a taxas.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.1.03.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a contribuição de melhoria.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.2.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a créditos não-tributários.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.1.2.01.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','Registra os créditos a serem encaminhados para o órgão competente em inscrever em divida ativa, referentes a créditos não-tributários.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.0.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Compreende os valores encaminhados para o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.1.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA','Compreende os créditos referentes a tributos encaminhados para o órgão competente em inscrever em divida ativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.1.01.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra os créditos, referentes a impostos, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.1.02.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra os créditos, referentes à taxas, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.1.03.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra os créditos, referentes à contribuições de melhoria, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.2.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO TRIBUTÁRIA','Compreende os créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.2.2.01.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO TRIBUTÁRIA','Compreende os créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.0.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Compreende o cancelamento dos valores indevidamente encaminhados para o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.1.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA','Compreende o cancelamento dos créditos de natureza tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.1.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o cancelamento dos créditos de natureza tributária, referentes a impostos, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.1.02.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o cancelamento dos créditos de natureza tributária, referentes a taxas, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.1.03.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÃO DE MELHORIA','Registra o cancelamento dos créditos de natureza tributária, referentes a contribuição de melhoria, encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.2.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende o cancelamento dos créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.1.3.2.01.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA NÃO-TRIBUTÁRIA','Registra o cancelamento dos créditos de natureza não-tributária encaminhados para o órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.0.0.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.1.0.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA','Compreende os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.1.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA ','Registra os créditos a serem inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.1.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA ','Registra os créditos a serem inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.2.0.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA DEVOLVIDOS','Compreende os valores a serem inscritos em divida ativa que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.2.1.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA DEVOLVIDOS','Compreende os créditos a serem inscritos em divida ativa tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.2.2.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO TRIBUTÁRIA DEVOLVIDOS','Compreende os créditos a serem inscritos em divida ativa não tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.0.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA A RECEBER','Compreende os valores inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.1.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','Registra os créditos inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.1.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.1.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.2.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','Compreende os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.2.01.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','Registra os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.3.2.02.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Registra os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.0.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA RECEBIDOS','Compreende os valores recebidos relativos aos créditos anteriormente inscritos em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.1.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA ','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.1.01.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA ','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária, em fase administrativa de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.1.02.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária, em fase judicial de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.2.00.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA ','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.2.01.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária em fase administrativa de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.4.2.02.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária, em fase judicial de cobrança.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.0.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA','Compreende os valores relativos às baixas de créditos inscritos em divida ativa.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.1.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA','Compreende as baixas de créditos inscritos em divida ativa tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.1.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA ADMINISTRATIVA','Registra as baixas de créditos inscritos em divida ativa tributária, em cobrança administrativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.1.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA JUDICIAL','Registra as baixas de créditos inscritos em divida ativa tributária, em cobrança judicial.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.2.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende as baixas de créditos inscritos em divida ativa não-tributária.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.2.01.00','BAIXAS DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA ADMNISTRATIVA','Registra as baixas de créditos inscritos em divida ativa não-tributária, em cobrança administrativa.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.3.2.5.2.02.00','BAIXAS DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA NÃO-TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra as baixas de créditos inscritos em divida ativa não-tributária, em cobrança judicial.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.0.0.0.00.00','EXECUÇÃO DOS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.0.0.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.0.00.00','PASSIVOS CONTINGENTES PREVISTOS','Compreende a previsão dos riscos fiscais classificados como Passivos Contingentes.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.1.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes;c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais. ','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.4.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.5.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.1.9.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.0.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','Compreende a confirmação da previsão dos riscos fiscais classificados como Passivos Contingentes.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.1.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes;c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.2.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.3.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.4.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.5.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.1.2.9.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.0.0.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.1.0.00.00','DEMAIS RISCOS FISCAIS PREVISTOS ','COMPREENDE A PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.1.1.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','Registra a estimativa do montante de redução de arrecadação que apresenta probabilidade de vir a ocorrer no exercício, decorrente de, por exemplo, cenários macroeconômicos desfavoráveis não previstos na época da elaboração do Orçamento.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.1.2.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','Registra a estimativa do montante de devolução de tributos a maior que apresenta probabilidade de vir a ocorrer no exercício.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.1.3.00.00','DISCREPÂNCIA DE PROJEÇÕES:','Registra a estimativa do montante de redução no valor dos ingressos ou de aumento no valor dos desembolsos que apresentam probabilidade de vir a ocorrer no exercício, decorrentes de evolução desfavorável de indicadores econômicos empregados na época da elaboração do Orçamento, tais como: a) Taxa de crescimento econômico; b) Taxa de inflação; c) Taxa de câmbio; d) Taxa de juros; e) Salário mínimo; f) Outros indicadores.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.1.4.00.00','OUTROS RISCOS FISCAIS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de riscos fiscais.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.4.2.2.0.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','COMPREENDE A CONFIRMACAO DA PREVISAO DOS RISCOS FISCAIS NAO CLASSIFICADOS COMO PASSIVOS CONTINGENTES','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.0.0.0.00.00','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','Compreende as contas que controlam a execução dos consórcios públicos (do ente consorciado e/ou do próprio consórcio), incluindo os controles do contrato de rateio, controle da prestação de contas, bem como as informações que serão consolidadas no ente consorciado para fins de elaboração dos demonstrativos dos consórcios, conforme Portaria STN 72/2012.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.1.0.0.00.00','EXECUÇÃO DO CONTRATO DE RATEIO DE CONSÓRCIO PÚBLICO','Compreende contas relacionadas ao registro dos valores de obrigações contratuais decorrentes de Consórcios Públicos','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.1.1.0.00.00','CONTRATO DE RATEIO - EM EXECUÇÃO','Registra os valores de obrigações contratuais em execução decorrentes de Consórcios Públicos','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.1.2.0.00.00','CONTRATO DE RATEIO -  EXECUTADOS','Registra os valores de obrigações de obrigações contratuais executados decorrentes de Consórcios Públicos','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.2.0.0.00.00','EXECUÇÃO DA PRESTAÇÃO DE CONTAS DE CONSÓRCIO PÚBLICO','Compreende contas relacionadas ao registro da execução do controle da prestação de contas referentes aos valores transferidos dos Consórcios Públicos.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.2.1.0.00.00',' A COMPROVAR','Registra os valores transferidos dos Consórcios Públicos a comprovar.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.2.2.0.00.00','EM INADIMPLENCIA','Registra os valores transferidos dos Consórcios Públicos em que não houve prestação de contas dentro do prazo estipulado.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.2.3.0.00.00','A APROVAR','Registra os valores transferidos dos Consórcios Públicos a aprovar.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.2.4.0.00.00','APROVADOS','Registra os valores transferidos dos Consórcios Públicos aprovados.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.2.5.0.00.00','IMPUGNADOS','Registra os valores transferidos dos Consórcios Públicos impugnados.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.0.0.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','Compreende as informações referentes aos Consórcios Públicos, atribuídas ao ente consorciado com base no contrato de rateio,que serão enviadas pelo consórcio para os entes consorciados para fins de elaboração dos demonstrativos fiscais ( Saúde, pessoal, educação e disponibilidade de caixa), em atendimento a Portaria STN n.º 72/2012. Conta para uso do ente consorciado.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.1.0.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','Registra os valores repassados pelo ente para execução das despesas nos Consórcios Públicos, com base no Contrato de Rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.2.0.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','Compreende as despesas executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.2.1.00.00','CREDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.2.2.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.2.3.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.2.4.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','Demonstra o valor da despesa empenhada liquidada paga, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.0.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.1.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.2.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.3.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.4.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.5.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.6.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.7.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.3.8.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.4.0.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.4.1.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.4.2.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.4.3.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.4.4.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.4.5.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.5.3.5.0.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','Registra a parcela total da insuficiência de caixa gerada no consórcio público atribuída ao ente consorciado com base no contrato de rateio.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.8.0.0.0.00.00','APURAÇÃO DE CUSTOS','Compreende as contas que controlam a execução dos custos dos bens e serviços produzidos.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.0.0.0.00.00','OUTROS CONTROLES','Compreende as contas de controles da execução não especificados anteriormente nos grupos dessa classe.','C','N','S','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.0.0.00.00','EXECUÇÃO DE RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.0.00.00','EXECUÇÃO DE RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.1.00.00','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.2.00.00','DEPÓSITOS COMPULSÓRIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.1.3.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.0.00.00','EXECUÇÃO DE RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.00.00','EXECUÇÃO DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','COMPREENDE OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.01.00','ADIANTAMENTOS CONCEDIDOS A COMPROVAR','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS PENDENTES DE COMPROVACAO','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.02.00','ADIANTAMENTOS A APROVAR','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS COMPROVADOS PENDENTES DE APROVACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.03.00','ADIANTAMENTOS APROVADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS APROVADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.04.00','ADIANTAMENTOS IMPUGNADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS IMPUGNADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.05.00','ADIANTAMENTOS EM INDADIMPLENCIA','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS EM INADIMPLÊNCIA.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.1.06.00','ADIANTAMENTOS CANCELADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS CANCELADOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.00.00','EXECUÇÃO DE ATIVOS DE PPP CONTABILIZADOS NA SPE','Compreende o valor dos ativos produzidos por meio de Parcerias Público Privadas contabilizados na Sociedade de Propósito Específico.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.01.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.2.02.00','ATIVOS DE PPP CONTABILIZADOS NA SPE BAIXADOS','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.1.2.9.00.00','EXECUÇÃO DE OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.0.0.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','COMPREENDE AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.1.0.00.00','PAGAMENTOS INDEVIDOS','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, IN-CLUSIVE EM CASOS DE SUPERFATURAMENTO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.2.0.00.00','SALDOS NÃO RECOLHIDOS','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.3.0.00.00','DESFALQUES OU DESVIOS','REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE EN-TIDADES PUBLICAS, EM APURACAO,DECORRENTES DE PROCESSOS POR ACOES ADMI-NINISTRATIVAS, POLICIAIS OU JUDICIAIS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.4.0.00.00','DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADESEM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FA-SE DE APURACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.5.0.00.00','RESPONSÁVEIS POR DANOS OU PERDAS','REGISTRA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS ADMINISTRA-TIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDASCAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.6.0.00.00','PAGAMENTOS SEM RESPALDO ORÇAMENTÁRIO','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSI-FICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASE DE APURACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.7.0.00.00','CRÉDITOS ANTECIPADOS','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTE-CIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, EM FASE DE APURACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.8.0.00.00','FALTA OU IRREGULARIDADE DE COMPROVAÇÃO','REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTACAO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURACAO','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.0.00.00','OUTRAS RESPONSABILIDADES EM APURAÇÃO','COMPREENDE OUTRAS RESPONSABILIDADES EM APURAÇÃO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.00.00','MULTAS E JUROS','COMPREENDE OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, PO-REM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE APURA-CAO.','C','N','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.01.00','FALTA DE LICITAÇÃO','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NE-CESSARIA LICITACAO, INFRINGINDO A LEGISLACAO ESPECIFICA, EM PROCESSOSMOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, EM FASEDE APURACAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.02.00','FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIÁRIAS','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGA-MENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS,NAO PAGAMENTO DE OBRIGAC. PARA COM A UNIAO.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.04.00','DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMOVEL','REGISTRA OS DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMÓVEIS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.05.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','REGISTRA OS ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.06.00','FRAUDES EM BENEFÍCIOS','REGISTRA OS VALORES EM APURAÇÃO DE FRAUDES EM BENEFÍCIOS.','C','S','N','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (0, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0), 1), '8.9.2.9.1.99.00','DEMAIS RESPONSABILIDADES EM APURAÇÃO','REGISTRA RESPONSABILIDADES EM APURACAO NAO INDIVIDUALIZADAS NAS OUTRASCONTAS DESSE GRUPO.','C','S','N','');

UPDATE contabilidade.plano_conta_estrutura SET escrituracao = UPPER(escrituracao);

UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = ''  WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0);
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'P' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '1%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'P' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '2%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'P' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '3%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'P' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '4%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'O' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '5%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'O' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '6%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'C' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '7%';
UPDATE contabilidade.plano_conta_estrutura SET natureza_informacao = 'C' WHERE cod_uf = 0 AND cod_plano = (SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 0) AND escrituracao = 'S' AND codigo_estrutural ilike '8%';


-- PLANO TCE_RS 2014
INSERT INTO contabilidade.plano_conta_geral (cod_uf, cod_plano, versao, dt_versao) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23)+1, 1), '1.0 PCASP', '2013-06-01');

INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.0.0.0.0.00.00.00.00.00','ATIVO','Compreende os recursos controlados por uma entidade como consequência de eventos passados e dos quais se espera que fluam benefícios econômicos ou potencial de serviços futuros a unidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.0.0.0.00.00.00.00.00','ATIVO CIRCULANTE','Compreende os ativos que atendam a qualquer um dos seguintes critérios: sejam caixa ou equivalente de caixa; sejam realizáveis ou mantidos para venda ou consumo dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; sejam realizáveis no curto prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.0.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA ','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL','Compreende o somatório dos valores em caixa e em bancos, bem como equivalentes, que representam recursos com livre movimentação para aplicação nas operações da entidade e para os quais não haja restrições para uso imediato.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - CONSOLIDAÇÃO ','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.01.00.00.00.00','CAIXA','Registra o somatório de numerários em espécie e outros valores em tesouraria.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.02.00.00.00.00','CONTA ÚNICA','Registra os valores da Conta Única, exceto RPPS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.00.00.00.00','CONTA ÚNICA  - RPPS','Compreende os valores disponíveis na Conta Única do RPPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.01.00.00.00','BANCO CONTA MOVIMENTO - RPPS','Registra o somatório das disponibilidades bancarias agregadas nos itens conta única da previdência social e outras contas, agregadas nos agentes financeiros autorizados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.02.00.00.00','BANCO CONTA MOVIMENTO - PLANO FINANCEIRO','Registra a movimentação financeira dos recursos nas contas movimento do plano financeiro do RPPS através dos agentes financeiros credenciados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.03.00.00.00','BANCO CONTA MOVIMENTO - PLANO PREVIDENCIÁRIO','Registra a movimentação financeira dos recursos nas contas movimento do plano previdenciário do RPPS através dos agentes financeiros credenciados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.06.04.00.00.00','BANCO CONTA MOVIMENTO - TAXA DE ADMINISTRAÇÃO','Registra a movimentação financeira dos recursos nas contas movimento da taxa de administração do RPPS através dos agentes financeiros credenciados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.00.00.00.00','BANCOS CONTA MOVIMENTO - DEMAIS CONTAS','Compreende o somatório das disponibilidades existentes em outras contas bancárias, que não sejam a conta única, agregadas pelos subitens identificativos dos bancos correspondentes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.02.00.00.00','BANCO DO BRASIL','Registra o somatorio da movimentação financeira das contas existentes na instituição financeira Banco do Brasil.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.03.00.00.00','CAIXA ECONOMICA FEDERAL','Registra o somatorio da movimentação financeira das contas existentes na instituição financeira Caixa Econômica Federal.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.12.00.00.00','BANCO DO ESTADO DO RIO GRANDE DO SUL','Registra a movimentacao dos recursos da entidade arrecadados ou recebidos pelo Banco do Estado do Rio Grande do Sul.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.19.99.00.00.00','DEMAIS CONTAS BANCARIAS','Registra as arrecadações de receitas da entidade e de outros valores desta sob sua guarda ou responsabilidade, especificamente quando o banco não se encontra relacionado nas contas acima.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.30.00.00.00.00','REDE BANCARIA - ARRECADACAO','Registra o somatorio dos recursos referentes a receitas arrecadadas e não recolhidas.  ','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.00.00.00.00','APLICACOES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Compreende as aplicações financeiras de alta liquidez em moeda nacional, que são prontamente conversiveis em valores conhecidos de caixa e que estão sujeitas a um insignificante risco de mudanca de valor.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.01.00.00.00','TÍTULOS PÚBLICOS','Registra os valores das disponibildiades das instituições, entidades e unidades aplicadas em títulos públicos.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.02.00.00.00','POUPANÇA','Registra o valor das aplicações financeiras em poupanças e seus rendimentos (juros e atualização moentária) posteriores.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.03.00.00.00','FUNDOS DE INVESTIMENTO','Registra o valor das aplicações financeiras em fundo de investimento e seus rendimentos (juros e atualização) posteriores, conforme instrução CVM 409/2004.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.04.00.00.00','CDB','Registra os valores das disponibilidades das instituições, entidades ou unidades aplicadas em certificados de depósitos bancários (CDB).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.1.50.99.00.00.00','OUTRAS APLICAÇÕES FINANCEIRAS DE LIQUIDEZ IMEDIATA','Registra outras aplicações financeiras, não classificadas em itens anteriores, das disponibilidades financeiras das entidades, instituições ou unidades.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA NACIONAL - INTRA OFSS','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda nacional.   Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.00.00.00.00','CONTA ÚNICA RPPS','Compreende os valores disponíveis na Conta Única do RPPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.01.00.00.00','BANCOS CONTA MOVIMENTO – RPPS','Registra o somatório das disponibilidades bancarias agregadas nos itens conta única da previdência social e outras contas, agregadas nos agentes financeiros autorizados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.02.00.00.00','BANCOS CONTA MOVIMENTO – PLANO FINANCEIRO','Registra a movimentação financeira dos recursos nas contas movimento do plano financeiro do RPPS através dos agentes financeiros credenciados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.03.00.00.00','BANCOS CONTA MOVIMENTO – PLANO PREVIDENCIÁRIO','Registra a movimentação financeira dos recursos nas contas movimento do plano previdenciário do RPPS através dos agentes financeiros credenciados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.1.2.06.04.00.00.00','BANCOS CONTA MOVIMENTO – TAXA DE ADMINISTRAÇÃO','Registra a movimentação financeira dos recursos nas contas movimento da taxa de administração do RPPS através dos agentes financeiros credenciados.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.2.0.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA','Compreende o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.1.2.1.00.00.00.00.00','CAIXA E EQUIVALENTES DE CAIXA EM MOEDA ESTRANGEIRA - CONSOLIDAÇÃO','Registra o somatório dos valores de caixa e equivalentes de caixa em moeda estrangeira. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.0.0.00.00.00.00.00','CRÉDITOS A CURTO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos realizáveis no curso do exercício social subsequente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.0.00.00.00.00.00','CREDITOS TRIBUTARIOS A RECEBER','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.00.00.00.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.01.00.00.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.05.00.00.00','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do imposto sobre a propriedade predial e territorial urbana.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.06.00.00.00','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do imposto sobre transmissão "inter vivos" de bens imóveis e de direitos reais sobre imóveis','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.07.00.00.00','ISS','Registra os valores relativos aos créditos a receber, decorrentes do imposto sobre serviços de qualquer natureza.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.01.08.00.00.00','ITR','Registra os valores relativos aos créditos a receber, decorrentes do imposto sobre a propriedade territorial rural, devidos aos municípios ou ao distrito federal devido a convênios firmados com a União, conforme Inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.02.00.00.00.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.02.01.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos a créditos tributários de taxas pelo exercício do poder de polícia a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.02.02.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos a créditos tributários de taxas pela prestação de serviços a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.03.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.03.01.00.00.00','CONTRIBUIÇÃO DE MELHORIA','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das contribuições de melhoria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.04.00.00.00.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.04.01.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos municípios e o distrito federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149-a da constituição federal de 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.1.70.00.00.00.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de créditos tributários parcelados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.00.00.00.00.00','CREDITOS TRIBUTARIOS  A RECEBER - INTRA OFSS','Compreende os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias, realizáveis no curso do exercício social subsequente. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.00.00.00.00','IMPOSTOS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.01.00.00.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.05.00.00.00','IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.06.00.00.00','ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.07.00.00.00','ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.01.08.00.00.00','ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.02.00.00.00.00','TAXAS','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.02.01.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.02.02.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.03.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.04.00.00.00.00','DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, decorrentes da cobrança das demais contribuições.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.04.01.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149- A da Constituição Federal de 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.2.70.00.00.00.00','CRÉDITOS TRIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de créditos tributários parcelados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.3.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - UNIÃO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.4.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS – ESTADO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.1.5.00.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER - INTER OFSS - MUNICÍPIO','Registra os valores relativos a créditos a receber oriundos das variações patrimoniais aumentativas tributárias realizáveis no curso do exercício social subsequente.  Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.0.00.00.00.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorram no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.00.00.00.00.00','CLIENTES- CONSOLIDAÇÃO','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.01.00.00.00.00','FATURAS/DUPLICATAS A RECEBER  ','Registra os valores das faturas/duplicatas a receber não vencidas decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.02.00.00.00.00','(-) FATURAS/DUPLICATAS A RECEBER-DESCONTADAS','Registra a apropriação e movimentação das duplicatas descontadas provenientes do faturamento de vendas de mercadorias ou serviços.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.03.00.00.00.00','FATURAS/DUPLICATAS A RECEBER VENCIDAS ','Registra os valores duplicatas a receber decorrentes de faturas vencidas que ocorrem no curso normal das operações da entidade, representando um direito a cobrar de seus clientes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.2.1.04.00.00.00.00','(-) FATURAS/DUPLICATAS A RECEBER VENCIDAS - DESCONTADAS ','Registra a apropriação e movimentação das duplicatas descontadas vencidas provenientes do faturamento de vendas de mercadorias ou serviços.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.0.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios, consórcios públicos e outras instituições.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - CONSOLIDAÇÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.01.00.00.00.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE INSTITUIÇÕES PRIVADAS','Registra os recursos a receber pelo ente decorrentes de transferência de instituições privadas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.1.02.00.00.00.00','CRÉDITOS DE CONSÓRCIOS PÚBLICOS DECORRENTES DE CONTRATO DE RATEIO','Registra os recursos a receber pelo consórcio decorrente do contrato de rateio. Conta a ser utilizada pelo consórcio público.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS – UNIÃO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.00.00.00.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DA UNIÃO','Compreende os recursos a receber pelo estado por sua participação constitucional e legal em receitas arrecadadas pela União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.02.00.00.00','COTA-PARTE DO FPM','Registra a participação dos municípios no produto da arrecadação dos impostos sobre a renda e sobre produtos industrializados, conforme coeficientes fixados pelo Tribunal de Contas da União, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.03.00.00.00','COTA-PARTE DO IMPOSTO SOBRE A PROPRIEDADE TERRITORIAL RURAL','Registra a participação dos municípios no produto da arrecadação do imposto sobre a propriedade territorial rural, transferido pela União aos municípios onde estejam localizados os imóveis sobre os quais incida o imposto.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.04.00.00.00','COTA-PARTE DO IPI - ESTADOS EXPORTADORES DE PRODUTOS INDUSTRIALIZADOS','Registra a parcela do imposto sobre produtos industrializados destinada aos estados exportadores de produtos industrializados, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.01.05.00.00.00','COTA-PARTE DA CIDE','Registra a parcela da cota-parte da contribuição de intervenção no domínio econômico, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.02.00.00.00.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Compreende os recursos a receber pelo estado ou município decorrentes da exploração de recursos naturais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.02.01.00.00.00','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECUROS HÍDRICOS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos hídricos, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.02.02.00.00.00','COTA-PARTE DA COMPENSAÇÃO FINANCEIRA PELA UTILIZAÇÃO DE RECURSOS MINERAIS','Registra a parcela da cota-parte da compensação financeira pela utilização de recursos minerais, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.02.03.00.00.00','COTA-PARTE DO VALOR DO PETRÓLEO BRUTO DE PRODUÇÃO NACIONAL','Registra a parcela da cota-parte do valor do petróleo bruto de produção nacional, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.03.00.00.00.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO SUS','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Sistema Único de Saúde','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.04.00.00.00.00','CRÉDITOS DECORRENTES DO FNAS','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo Nacional de Assistência Social.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.05.00.00.00.00','CRÉDITOS DECORRENTES DE TRASNSFERÊNCIA DO FNDE','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo Nacional de Desenvolvimento da Educação.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.06.00.00.00.00','CRÉDITOS DECORRENTES DAS TRANSFERÊNCIAS DO ICMS - DESONERAÇÃO - LC 87/96','Registra as transferências financeiras do ICMS - Desoneração - Lei Complementar 87/96, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.07.00.00.00.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','Compreende os recursos a receber pelo estado ou município decorrentes de transferência multigovernamentais como por exemplo o fundeb.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.07.01.00.00.00','FUNDEB','Registra os recursos a receber pelo estado ou município decorrentes das transferências do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação (FUNDEB).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.08.00.00.00.00','CRÉDITOS DECORRENTES DE TRANSFERÊNCIAS DE CONVÊNIOS','Registra os recursos a receber pelo estado ou município decorrentes de convênios firmados com outro ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.3.09.00.00.00.00','CRÉDITOS DECORRENTES DE OUTRAS TRANSFERÊNCIAS','Registra os recursos a receber pelo estado ou municío decorrentes de transferências não especificadas nos itens acima.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - ESTADO','Compreende os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.01.00.00.00.00','CRÉDITOS DECORRENTES DA PARTICIPAÇÃO NAS RECEITAS DO ESTADO','Compreende os recursos a receber pelos municípios por sua participação constitucional e legal em receitas arrecadadas pelos estados.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.01.01.00.00.00','COTA-PARTE DO ICMS','Registra a parcela pertencente aos municípios, do imposto sobre operações relativas à circulação de mercadorias e sobre prestações de serviços de transporte interestadual e intermunicipal e de comunicação, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.4.01.02.00.00.00','COTA-PARTE DO IPVA','Registra a parcela pertencente aos municípios, do imposto sobre a propriedade de veículos automotores, a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.3.5.00.00.00.00.00','CRÉDITOS DE TRANSFERÊNCIAS A RECEBER - INTER OFSS - MUNICÍPIO','Registra os valores relativos a créditos a receber oriundos da variação patrimoniais aumentativas decorrentes de transferências da União, estados, Distrito Federal e municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS- CONSOLIDAÇÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.01.00.00.00.00','EMPRÉSTIMOS CONCEDIDOS','Registra o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.02.00.00.00.00','FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.03.00.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Compreende o somatório dos valores dos juros e encargos sobre empréstimos e financiamentos concedidos a receber.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.03.01.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Empréstimos  a Receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.03.02.00.00.00','JUROS E ENCARGOS SOBRE FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos Juros e Encargos sobre Financiamentos Concedidos a Receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.07.01.00.00.00','EMPRÉSTIMOS A RECEBER - RPPS','Registra os créditos a receber provenientes de empréstimos concedidos por meio de recursos previdenciários.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.07.02.00.00.00','FINANCIAMENTOS A RECEBER - RPPS','Registra os créditos a receber provenientes de financiamentos concedidos por meio de recursos previdenciários.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.07.03.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre empréstimos concedidos com recursos previdenciários.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.1.07.04.00.00.00','JUROS E ENCARGOS SOBRE FINANCIAMENTOS A RECEBER – RPPS','Registra o somatório dos valores dos Juros e Encargos sobre financiamentos concedidos com recursos previdenciários.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.3.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - UNIÃO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.3.01.00.00.00.00','EMPRÉSTIMOS CONCEDIDOS','Registra o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.3.02.00.00.00.00','FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.3.03.00.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos juros e encargos sobre empréstimos e financiamentos concedidos a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.3.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.                                          ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.4.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - ESTADO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.4.01.00.00.00.00','EMPRÉSTIMOS CONCEDIDOS','Registra o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.4.02.00.00.00.00','FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.4.03.00.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos juros e encargos sobre empréstimos e financiamentos concedidos a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.4.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.                                          ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.5.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS-INTER OFSS - MUNICÍPIO','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.5.01.00.00.00.00','EMPRÉSTIMOS CONCEDIDOS','Registra o somatório dos valores dos empréstimos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.5.02.00.00.00.00','FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores dos financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos, exceto os concedidos com recursos do RPPS.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.5.03.00.00.00.00','JUROS E ENCARGOS SOBRE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS A RECEBER','Registra o somatório dos valores dos juros e encargos sobre empréstimos e financiamentos concedidos a receber.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.4.5.07.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS COM RECURSOS PREVIDENCIÁRIOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.                                          ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.0.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.00.00.00.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.01.00.00.00','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Compreende os valores relativos a créditos a receber, decorrentes da cobrança do imposto sobre a renda e proventos de qualquer natureza','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.01.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos a receber, decorrentes da cobrança  administrativa do imposto sobre a renda e proventos de qualquer natureza','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.01.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos a receber, decorrentes da cobrança  judicial do imposto sobre a renda e proventos de qualquer natureza','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.05.00.00.00','DÍVIDA ATIVA DO IPTU','Compreende os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do imposto sobre a propriedade predial e territorial urbana.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.05.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa do imposto sobre a propriedade predial e territorial urbana.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.05.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial do imposto sobre a propriedade predial e territorial urbana.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.06.00.00.00','DÍVIDA ATIVA DO ITBI','Compreendeos valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do imposto sobre transmissão "inter vivos" de bens imóveis e de direitos reais sobre imóveis.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.06.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa do imposto sobre transmissão "inter vivos" de bens imóveis e de direitos reais sobre imóveis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.06.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial do imposto sobre transmissão "inter vivos" de bens imóveis e de direitos reais sobre imóveis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.07.00.00.00','DÍVIDA ATIVA DO ISS','Compreende os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança do imposto sobre serviços de qualquer natureza.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.07.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa do imposto sobre serviços de qualquer natureza.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.07.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial do imposto sobre serviços de qualquer natureza.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.08.00.00.00','DÍVIDA ATIVA DO ITR','Compreende os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança imposto sobre a propriedade territorial rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.08.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa do imposto sobre a propriedade territorial rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.01.08.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial do imposto sobre a propriedade territorial rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.00.00.00.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.01.00.00.00','DÍVIDA ATIVA DAS TAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.01.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa das taxas pelo exercício do poder de polícia.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.01.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial das taxas pelo exercício do poder de polícia.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.02.00.00.00','DÍVIDA ATIVA DAS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das taxas pela prestação de serviços.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.02.01.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa das taxas pela prestação de serviços.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.02.02.02.00.00','COBRANÇA JUDICIAL','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial das taxas pela prestação de serviços.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.03.00.00.00.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Compreende os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança das contribuições de melhoria.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.03.01.00.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança administrativa das contribuições de melhoria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.03.02.00.00.00','COBRANÇA JUDICIAL','Registra os valores relativos aos créditos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança judicial das contribuições de melhoria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.04.00.00.00.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.04.01.00.00.00','DÍVIDA ATIVA DA CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Compreende os valores relativos aos créditos a receber, inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública, conforme artigo 149-A da Constituição Federal de 1988.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.04.01.02.00.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos aos créditos a receber, em cobrança administrativa,inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública,  conforme artigo 149-A da Constituição Federal de 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.04.01.03.00.00','COBRANÇA JUDICIAL','Registra os valores relativos aos créditos a receber, em cobrança judicial,inscritos em dívida ativa de contribuição para o custeio do serviço de iluminação pública,  conforme artigo 149-A da Constituição Federal de 1988.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.1.05.00.00.00.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.2.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTRA OFSS ','Compreende os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.2.01.00.00.00.00','DIVIDA ATIVA TRIBUTARIA DOS IMPOSTOS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal específica relativa ao contribuinte.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.2.02.00.00.00.00','DIVIDA ATIVA TRIBUTARIA DAS TAXAS','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança da modalidade de tributo que tem como fato gerador o exercício regular do poder de polícia ou a utilização efetiva ou potencial de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.2.03.00.00.00.00','DÍVIDA ATIVA DAS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.2.04.00.00.00.00','DÍVIDA ATIVA DAS DEMAIS CONTRIBUIÇÕES','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes da cobrança dos valores decorrentes das demais contribuições.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.2.05.00.00.00.00','DEMAIS DÍVIDA ATÍVA TRIBUTÁRIA','Registra os valores relativos aos créditos a receber, inscritos em dívida ativa, decorrentes de outros tributos não detalhados acima.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.3.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - UNIÃO','Registra os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.4.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - ESTADO','Registra os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.5.5.00.00.00.00.00','DIVIDA ATIVA TRIBUTARIA - INTER OFSS - MUNICÍPIO','Registra os valores dos créditos de divida ativa tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.0.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA ','Compreende os valores dos créditos de divida ativa não tributaria inscritos, realizáveis no curto prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.00.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA - CONSOLIDAÇÃO','Compreende os valores dos créditos de divida ativa não tributaria inscritos, realizáveis no curso do exercício social subsequente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.01.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA','Compreende os valores dos créditos de divida ativa não tributaria tais como os provenientes de empréstimos compulsórios, contribuições estabelecidas em lei, multas de qualquer origem ou natureza (exceto as tributárias), foros, laudêmios, aluguéis, taxas de ocupação, custas processuais, preços de serviços prestados por estabelecimentos públicos e outros, exigíveis por transcurso de prazo para pagamento, inscritos na forma de legislação própria, após apurada sua liquidez e certeza.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.6.1.01.01.00.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','Registra os créditos de natureza não-tributária exigíveis a partir do recebimento, pela entidade, de certidão de decisão – título executivo, emitida pelo Tribunal de Contas do Estado com característica de liquidez e certeza, inscritos como dívida ativa não-tributária.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO- CONSOLIDAÇÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.01.00.00.00','(-) PERDAS ESTIMADAS EM IMPOSTOS','Compreende o ajuste para perdas estimadas com o não recebimento de impostos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.01.01.00.00','(-) PERDAS ESTIMADAS NO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra o ajuste para perdas estimadas com o não recebimento do Imposto sobre a Renda e Proventos de Qualquer Natureza.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.01.05.00.00','(-) PERDAS ESTIMADAS NO IPTU','Registra o ajuste para perdas estimadas com o não recebimento do IPTU','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.01.06.00.00','(-) PERDAS ESTIMADAS NO ITBI','Registra o ajuste para perdas estimadas com o não recebimento do ITBI','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.01.07.00.00','(-) PERDAS ESTIMADAS NO ISS','Registra o ajuste para perdas estimadas com o não recebimento do ISS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.01.08.00.00','(-) PERDAS ESTIMADAS NO ITR','Registra o ajuste para perdas estimadas com o não recebimento do ITR','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.02.00.00.00','(-) PERDAS ESTIMADAS EM TAXAS','Registra o ajuste para perdas estimadas com o não recebimento de taxas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.03.00.00.00','(-) PERDAS ESTIMADAS EM CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento de contribuições de melhoria.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.04.00.00.00','(-) PERDAS ESTIMADAS EM DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento de demais contribuições.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.01.70.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos tributários parcelados.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.02.00.00.00.00','(-) PERDAS ESTIMADAS EM CLIENTE','Compreende o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes de vendas de mercadorias ou da prestação de serviços.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.02.01.00.00.00','(-) PERDAS ESTIMADAS EM CLIENTE FATURAS/DUPLICATAS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da unidade, representando um direito a cobrar de seus clientes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.03.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.03.01.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS  CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos concedidos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.03.02.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de financiamentos concedidos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.01.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Compreende o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de impostos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.01.01.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes do imposto sobre a renda e proventos de qualquer natureza.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.01.05.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - IPTU','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes do iptu.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.01.06.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - ITBI','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes do itbi.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.01.07.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - ISS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes do iss.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.01.08.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - ITR','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes do itr.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.02.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA-TAXAS','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de taxas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.03.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - CONTRIBUIÇÕES DE MELHORIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de contribuições de melhoria.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.04.04.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA - DEMAIS CONTRIBUIÇÕES','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária decorrentes de demais contribuições.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.1.05.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTRA OFSS','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.01.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.04.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.2.05.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.01.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.04.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.3.05.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.01.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.04.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.4.05.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.00.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Compreende o ajuste para perdas estimadas com o não recebimento de valores referentes a créditos a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.01.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra o ajuste para perdas estimadas com o não recebimento dos créditos tributários','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.03.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o ajuste para perdas estimadas com o não recebimento de créditos de empréstimos e financiamentos concedidos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.04.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.2.9.5.05.00.00.00.00','(-) PERDAS ESTIMADAS EM CRÉDITOS DE DÍVIDA ATIVA NÃO TRIBUTÁRIA ','Registra o ajuste para perdas estimadas com o não recebimento dos créditos inscritos em dívida ativa não tributária.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.0.0.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende os valores a receber por demais transações realizáveis no curto prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.0.00.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.00.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS - CONSOLIDAÇÃO','Compreende as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL','Compreende os valores das antecipações concedidas a servidores e a dirigentes da unidade, tais como antecipações de salarios e ordenados, adiantamentos de 13º salario, adiantamentos de ferias e de gratificações natalinas, entre outras.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.01.00.00.00','SALÁRIOS E ORDENADOS - ADIANTAMENTOS','Registra o adiantamento a pessoal referente a salários e ordenados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.02.00.00.00','13 SALÁRIO - ADIANTAMENTO','Registra o adiantamento a pessoal referente ao 13 salário.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.03.00.00.00','FÉRIAS - ADIANTAMENTO','Registra o adiantamento a pessoal referente às férias, exceto o 1/3 de férias.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.04.00.00.00','1/3 DE FÉRIAS - ADIANTAMENTO','Registra o adiantamento a pessoal referente a 1/3 de férias.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.01.05.00.00.00','VIAGENS - ADIANTAMENTO','Registra o adiantamento a pessoal referente a viagens.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.02.00.00.00.00','SUPRIMENTO DE FUNDOS','Registra o adiantamento a servidor para despesas sujeitas a prestação de contas','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.1.1.99.00.00.00.00','ADIANTAMENTOS DIVERSOS CONCEDIDOS','Registra os outros valores entregues antecipadamente, não classificados em contas anteriores. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.2.0.00.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','Compreende o somatório dos valores dos tributos a recuperar/ compensar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.2.1.00.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR - CONSOLIDAÇÃO','Registra o somatório dos valores dos tributos a recuperar /compensar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.3.0.00.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Compreende os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.3.1.00.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS - CONSOLIDAÇÃO','Registra os créditos a receber decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta, como por meio de delegação, nas formas de concessão, inclusive parcerias público-privada - PPP, permissão ou autorização ao particular do direito de exploração de serviços públicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.0.00.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.00.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMONIO- CONSOLIDAÇÃO','Compreende os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em sindicância, prestação de contas, tomada de contas, processos judiciais e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.01.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMONIO DECORRENTES DE CRÉDITOS ADMINISTRATIVOS','Registra os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.02.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMONIO APURADOS EM  TOMADA DE CONTAS ESPECIAL','Registra os valores realizáveis no curto prazo, provenientes de direitos oriundos de danos ao patrimônio, apurados em Tomada de Contas Especial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.4.1.03.00.00.00.00','CREDITOS POR DANOS AO PATRIMONIO APURADOS EM PROCESSOS JUDICIAIS','Registra os valores realizaveis no curto prazo, provenientes de direitos oriundos de danos ao patrimonio, apurados em processos judiciais. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.0.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- CONSOLIDAÇÃO','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.01.00.00.00.00','DEPOSITOS  E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','Registra os valores relativos a depositos e caucoes, efetuados  por vinculacoes a contratos ou convencoes, para garantias de operacoes  especificas, realizaveis no curto prazo.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.02.00.00.00.00','DEPOSITOS JUDICIAIS','Registra os valores a receber decorrentes de depositos efetuados por determinacao judicial, realizaveis no curto prazo.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.03.00.00.00.00','DEPÓSITOS PARA INTERPOSIÇÃO DE RECURSOS','Registra os valores relativos aos depositos vinculados, decorrentes de interposicao de  recursos na esfera judicial ou administrativa.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.04.00.00.00.00','DEPOSITOS ESPECIAIS','Registra os valores relativos a outros depositos em contas bancarias, vinculados a obrigacoes contratuais, convencoes, acordos e ajustes.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.05.00.00.00.00','VALORES APREENDIDOS POR DECISÃO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizáveis no curto prazo.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.06.00.00.00.00','CONTA ESPECIAL - PRECATÓRIOS','Registra o valor depositado em conta especial do Tribunal de Justiça relacionado ao pagamento de precatórios.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.1.99.00.00.00.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depositos restituiveis e valores vinculados, realizaveis no curto prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.2.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- INTRA OFSS','Registra os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.3.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- INTRA OFSS UNIÃO','Registra os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.4.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- INTRA OFSS ESTADO','Registra os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.5.5.00.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS- INTRA OFSS MUNICÍPIO','Registra os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.0.00.00.00.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.00.00.00.00.00','OUTROS CRÉDITOS A RECEBER E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os outros créditos e valores realizáveis no curto prazo, provenientes de direitos obtidos junto a diversos devedores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.01.00.00.00.00','ALUGUEIS A RECEBER','Registra os valores a receber decorrentes de contratos de aluguel.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.02.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE PERMISSAO DE USO DE BENS PUBLICOS','Registra os valores a receber decorrentes de permissao de uso de bens publicos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.03.00.00.00.00','VALORES A RECUPERAR DECORRENTES DE INDENIZACOES POR SINISTROS PAGOS','Registra os valores a recuperar referentes a indenizacoes pelo pagamento de sinistros. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.04.00.00.00.00','VALES, TICKETS E BILHETES','Registra o valor de vales, tickets e bilhetes adquiridos para futura distribuicao aos servidores.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.06.00.00.00.00','VALORES EM TRANSITO REALIZAVEIS A CURTO PRAZO','Registra o somatorio dos valores contabilizados indevidamente em conta bancaria, guia de recebimento e ordens bancarias emitidas a compensar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.07.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE INFRACOES LEGAIS E CONTRATUAIS','Registra os recursos a receber provenientes da aplicacao de autos  de infracao, da aplicacao de multas por descumprimento de obrigacoes  acessorias (vinculadas a creditos tributarios) ou decorrentes de quebra de clausulas contratuais. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.08.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO FAMILIA PAGO','Registra os valores relativos ao salario-familia, incluidos em folhas de pagamento, pagos aos empregados (CLT), com filhos menores, a compensar com as contribuicoes devidas pelo empregador a previdencia social.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.09.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE SALARIO MATERNIDADE PAGO','Registra os salarios pagos as servidoras gestantes, regidas pela CLT no periodo que perdurar a licenca maternidade, prevista em lei, a deduzir das obrigacoes sociais devidas pelos orgaos e entidades.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.10.00.00.00.00','AUXILIO NATALIDADE PAGO A RECUPERAR','Registra os valores relativos a auxilio natalidade, pagos aos empregados regidos pela CLT, quando do nascimento de filhos destes, a recuperar, por se tratar de obrigacoes da previdencia social.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.11.00.00.00.00','CREDITOS A RECEBER POR REEMBOLSO DE AUXILIO DOENCA E ACIDENTES PAGOS','Registra os salarios pagos aos servidores, regidos pela clt, a  titulo de auxilio doenca/acidentes, previsto em lei, a serem reembolsados pelo INSS.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.12.00.00.00.00','CREDITOS A RECEBER POR CESSAO DE PESSOAL','Registra os valores de creditos a receber tais como: folha de pagamento, despesa de transporte, alimentacao e outras relativas a cessao de pessoal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.13.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE CESSAO DE AREAS PUBLICAS','Registra os valores a receber decorrentes da cessao de areas publicas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.14.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','Registra os valores dos creditos a receber decorrentes da alienacao de bens moveis ou imoveis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.15.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTO DE DESPESAS DE TERCEIROS','Registra os recursos a receber provenientes de pagamentos de despesas de terceiros decorrentes de clausulas contratuais, tais como: agua, luz, telefone,  instalacoes, transporte e alugueis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.16.00.00.00.00','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDORES E EX-SERVIDORES','Registra os valores dos créditos a receber decorrentes de acertos financeiros com servidores e ex-servidores do órgão, conforme disposto na lei 8.112/90.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.17.00.00.00.00','CREDITOS A RECEBER DECORRENTES DE  FOLHA DE PAGAMENTO','Registra os valores dos creditos a receber decorrentes de folha de pagamento.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.27.00.00.00.00','TITULOS A RECEBER','Registra os valores a receber a curto prazo representados por notas promissorias, letras de cambio e outros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.28.00.00.00.00','CREDITOS A RECEBER DE ENTIDADES FEDERAIS','Registra os valores a receber a curto prazo, decorrentes de direitos junto a entidades federais.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.29.00.00.00.00','CREDITOS A RECEBER DE ENTIDADES ESTADUAIS, DISTRITAIS E MUNICIPAIS','Registra os valores a receber a curto prazo, decorrentes de direitos junto a estados, df e municipios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.31.00.00.00.00','CRÉDITOS A RECEBER DE PARCELAMENTOS','Registra o crédito de origem fiscal ou não, se autorizado o parcelamento, excluídos os créditos tributários e previdenciários.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.8.1.99.00.00.00.00','OUTROS CREDITOS A  RECEBER E VALORES A CURTO PRAZO','Registra outros creditos a receber e valores a curto prazo, para os quais nao tenham contas especificas neste subgrupo de contas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos e valores a curto prazo, por inadimplência de terceiros e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.03.00.00.00.00','(-) AJUSTE  PARA PERDAS EM CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os valores dos ajustes para perdas em créditos a receber por descentralizações da prestação de serviços públicos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.04.00.00.00.00','(-)  AJUSTE DE PERDAS DE CREDITOS POR DANOS AO PATRIMONIO','Registra os valores das provisões para perdas de créditos por danos ao patrimônio, verificados em processos administrativos ou apurados em tomada de contas especial.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.06.00.00.00.00','(-)  AJUSTE DE PERDAS DE DIVIDA ATIVA NAO TRIBUTARIA - DEMAIS CREDITOS','Registra os valores referentes ao ajuste para perdas de divida ativa nao tributaria, exceto as derivadas de clientes de acordo com os criterios definidos no Manual de Procedimentos da Divida Ativa.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.3.9.1.99.00.00.00.00','(-) AJUSTE  PARA PERDAS DE DEMAIS CRÉDITOS E  VALORES A CURTO PRAZO','Registra o ajuste de perdas estimadas de  demais creditos e valores a curto prazo, nao classificadas anteriormente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.0.0.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A CURTO PRAZO','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo, alem das aplicações temporárias em metais preciosos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.0.00.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Compreendem as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.00.00.00.00.00','TÍTULOS E VALORES MOBILIARIOS- CONSOLIDAÇÃO','Compreende as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis até o final do exercício seguinte. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.01.00.00.00.00','TÍTULOS PÚBLICOS','Registra os valores relativos aos titulos públicos, emitidos e em circulacao, de posse da entidade pública.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.02.00.00.00.00','AÇÕES','Registra os valores das acoes representativas das participacoes dos orgaos e entidades no capital das sociedades por acoes havidas por aquisicoes, subscricoes, bonificacoes e doacoes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.03.00.00.00.00','DERIVATIVOS','Registra os créditos relativos a operações com derivativos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.00.00.00.00','APLICACOES EM SEGMENTO DE RENDA FIXA - RPPS','Compreende o somatório dos investimentos realizados pelo RPPS com recursos previdenciários, efetuados em conformidade com o art. 7º, da Resolução CMN n° 3.922/2010.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.01.00.00.00','TITULOS DE RESPONSABILIDADE DO TESOURO','Registra os investimentos realizados pelo RPPS, em títulos de emissão do Tesouro Nacional, efetuados em conformidade com o art. 7º, inciso I, alínea “a”(incluí operações compromissadas) da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.02.00.00.00','TITULOS DE RESPONSABILIDADE DO BANCO CENTRAL','Registra os investimentos realizados pelo RPPS, em titulos de emissao do Banco Central do Brasil; saldos remanescentes para resgates,   considerando que o BC nao emite mais titulos da divida publica- art 34 LC 101/2000.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.03.00.00.00','POUPANÇA','Registra os investimentos realizados pelo RPPS, em poupança, efetuados em conformidade com o art. 7º, inciso III, da Resolução CMN n° 3.506/2007','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.04.00.00.00','FUNDOS DE INVESTIMENTO EM RENDA FIXA','Registra os investimentos realizados pelos RPPS, em fundos de investimentos em renda fixa, efetuados em conformidade com o art. 7º, inciso IV,  da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.05.00.00.00','FUNDOS DE INVESTIMENTOS EM RENDA FIXA – CRÉDITO PRIVADO','Registra os investimentos realizados pelos RPPS, em fundos de investimentos em renda fixa - crédito privado, efetuados em conformidade com o art. 6º, inciso V, da Resolucao CMN n° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.06.00.00.00','FUNDOS DE INVESTIMENTOS REFERENCIADOS','Registra os investimentos realizados pelo RPPS, em  fundos de investimentos referenciados, efetuados em conformidade com o art. 7º, inciso III, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.07.00.00.00','FUNDOS DE INVESTIMENTOS EM DIREITOS CREDITORIOS ','Registra os investimentos realizados pelo RPPS, em  fundos de investimentos em direito creditório, efetuados em conformidade com o art. 7º, inciso VI e alínea “a” do inciso VII, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.08.00.00.00','FUNDOS DE INVESTIMENTOS EM TITULOS DO TESOURO','Registra os investimentos realizados pelo RPPS, em  fundos de investimentos em títulos do tesouro, efetuados em conformidade com o art. 7º, inciso I, alínea”b”,  da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.09.09.00.00.00','OPERACOES COMPROMISSADAS','Registra os investimentos realizados pelo RPPS, em  operações compromissadas, efetuados em conformidade com o art.  7º , inciso II, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.00.00.00.00','APLICACOES EM SEGMENTO DE RENDA VARIAVEL  - RPPS','Compreende o somatório dos investimentos realizados pelo RPPS com recursos previdenciários, efetuados em conformidade com o art. 7º, da Resolução CMN n° 3.922/2010.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.01.00.00.00','FUNDOS DE AÇÕES REFERENCIADOS','Registra os investimentos realizados pelo RPPS, em fundo de ações referenciados, efetuados em conformidade com o art. 7º, inciso III, da Resolucao CMN n° 3.790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.02.00.00.00','FUNDOS DE ACOES  ','Registra os investimentos realizados pelo RPPS, em fundo de ações, efetuados em conformidade com o art. 8º, inciso III, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.03.00.00.00','FUNDO MULTIMERCADO ','Registra os investimentos realizados pelo RPPS, em fundo de multimercado, efetuados em conformidade com o art. 8º, inciso IV, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.04.00.00.00','FUNDOS DE INDICES REFERENCIADOS EM ACOES','Registra os investimentos realizados pelo RPPS, em  fundos de índices referenciados em ações, efetuados em conformidade com o art. 8º, inciso II, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.05.00.00.00','FUNDOS DE INVESTIMENTOS EM PARTICIPACOES','Registra os investimentos realizados pelo RPPS, em  fundos de investimentos em participações, efetuados em conformidade com o art. 8º, inciso V, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.10.06.00.00.00','FUNDO DE INVESTIMENTOS IMOBILIÁRIOS','Registra os investimentos realizados pelo RPPS, em fundo de investimentos imobiliários, efetuados em conformidade com o art. 8º, inciso VI, da Resolução CMN n° 3.922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.11.00.00.00.00','APLICAÇÕES EM SEGMENTO IMOBILIÁRIO - RPPS','Compreende os investimentos realizados pelo RPPS, no segmento de imóveis efetuados em conformidade com o art. 8º da Resolução CMN n° 3.922/2010.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.11.01.00.00.00','FUNDOS DE INVESTIMENTO IMOBILIÁRIOS','Registra o somatório dos investimentos realizados pelo RPPS com recursos previdenciários em fundos de investimento imobiliários.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.12.00.00.00.00','APLICACOES EM ENQUADRAMENTO - RPPS','Compreende os investimentos realizados pelo rpps, em desacordo com as regras estabelecidas pela resolucao cmn nº 3790/2009, artigo 25.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.12.01.00.00.00','TÍTULOS E VALORES EM ENQUADRAMENTO','Registra os investimentos realizados pelo RPPS, em desacordo com as regras estabelecidas pela Resolução CMN nº 3790/2009, artigo 25. ','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.13.00.00.00.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO - RPPS','Compreende os investimentos realizados pelo rpps, em ativos nao sujeitos as regras da resolucao cmn nº 3790/2009.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.13.01.00.00.00','TITULOS E VALORES NAO SUJEITOS AO ENQUADRAMENTO','Registra os investimentos realizados pelo RPPS, em ativos não sujeitos as regras da resolução CMN nº 3790/2009.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.14.00.00.00.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','Compreende os investimentos realizados pelo RPPS, com recursos da taxa de administração, sujeitos às regras da Resolução CMN nº 3922/2010.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.1.1.14.01.00.00.00','APLICACOES COM A TAXA DE ADMINISTRACAO DO RPPS','Registra os investimentos realizados pelo RPPS, com recursos da taxa de administração, sujeitos às regras da Resolução CMN nº 3922/2010.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.2.0.00.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Compreende as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.2.1.00.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS- CONSOLIDAÇÃO','Registra as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS - CONSOLIDAÇÃO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.01.00.00.00.00','(-) AJUSTES DE PERDAS COM TÍTULOS E VALORES MOBILIÁRIOS ','Registra os valores de ajustes para perdas em titulos e valores mobiliarios a curto prazo. Inclusive os valores de ajustes para perdas em aplicações da carteira do RPPS e em investimentos com recursos da taxa de administração do RPPS, sujeitos às regras da Resolução do CMN nº 3922/2010.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.4.9.1.02.00.00.00.00','(-) AJUSTES PARA PERDAS EM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','Registra os valores de ajustes para perdas em aplicacoes em ouro e outros metais preciosos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.0.0.00.00.00.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.0.00.00.00.00.00','MERCADORIAS PARA REVENDA','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.00.00.00.00.00','MERCADORIAS PARA REVENDA - CONSOLIDAÇÃO','Compreende todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.1.1.01.00.00.00.00','MERCADORIAS PARA VENDA OU REVENDA','Registra o valor das mercadorias para venda ou revenda e doações relativas a estoques da entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.0.00.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS','Compreende os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.00.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS - CONSOLIDAÇÃO','Compreende os produtos já terminados oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.01.00.00.00.00','PRODUTOS ACABADOS','Registra o valor de produtos manufaturados ja terminados, oriundos da propria producao da entidade e disponiveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignacao.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.2.1.02.00.00.00.00','SERVIÇOS ACABADOS','Registra os valores pertinentes a serviços acabados que estao pendentes de faturamento ou de transferencia para outras contas do ativo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.0.00.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.00.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO - CONSOLIDAÇÃO','Compreende os produtos e serviços em andamento não concluídos na data do balanço. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.01.00.00.00.00','PRODUTOS EM ELABORAÇÃO  ','Registra a totalidade das matérias-primas  ja requisitadas que estao em processo de transformacao e o montante de custos diretos e indiretos relativos aos produtos em elaboracao  não concluidos na data do balanco patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.3.1.02.00.00.00.00','SERVIÇOS EM ELABORAÇÃO','Registra os custos diretos e indiretos relativos aos serviços em elaboracao não concluidos na data do balanco patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.0.00.00.00.00.00','MATÉRIAS-PRIMAS','Compreende o estoque de matérias-primas, que será utilizado no processo produtivo. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.4.1.00.00.00.00.00','MATÉRIAS-PRIMAS - CONSOLIDAÇÃO','Registra o estoque de matérias-primas, que será utilizado no processo produtivo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.5.0.00.00.00.00.00','MATÉRIAIS EM TRANSITO','Compreende o valor dos materiais em processo de transferência para outras unidades da entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.5.1.00.00.00.00.00','MATÉRIAIS EM TRANSITO - CONSOLIDAÇÃO','Registra o valor dos materiais em processo de transferência para outras unidades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.0.00.00.00.00.00','ALMOXARIFADO','Compreende o valor dos materiais destinados ao consumo interno da unidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.00.00.00.00.00','ALMOXARIFADO - CONSOLIDAÇÃO','Compreende o valor dos materiais destinados ao consumo interno da unidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.01.00.00.00.00','MATERIAL DE CONSUMO','Registrar os valores dos materiais de consumo adquiridos e estocados em almoxarifados, destinados a atender as necessidades da instituição e de outras unidades','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.02.00.00.00.00','GENEROS ALIMENTICIOS','Registra os valores dos generos alimenticios adquiridos e estocados em almoxarifados, destinados a atender as necessidades da entidade  e de outras unidades dessa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.03.00.00.00.00','MATERIAIS DE CONSTRUCAO','Registra os valores dos materiais de construcao adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade  e de outras unidades dessa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.04.00.00.00.00','AUTOPEÇAS','Registra os valores de autopeças adquiridas e estocadas em almoxarifados, destinadas a atender ao consumo interno da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.05.00.00.00.00','MEDICAMENTOS E MATERIAIS HOSPITALARES','Registra os valores dos medicamentos e materias hospitalares adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.06.00.00.00.00','MATERIAIS GRÁFICOS','Registra os valores dos materiais gráficos adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.08.00.00.00.00','MATERIAL DE EXPEDIENTE','Registra os valores dos materiais de expediente adquiridos e estocados em almoxarifados, destinados a atender ao consumo interno da unidade e de outras unidades dessa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.09.00.00.00.00','MATERIAIS A CLASSIFICAR','Registra os valores dos materiais estocados pendentes de classificacao e identificacao.                                                     ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.6.1.10.00.00.00.00','ESTOQUE SOBRESSALENTES A ALIENAR','Registra os valores de bens sobressalentes que estejam disponiveis para alienacao sob diversas formas (venda, leilão, etc).                                                                                                   ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.7.0.00.00.00.00.00','ADIANTAMENTOS A FORNECEDORES','Compreende os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.7.1.00.00.00.00.00','ADIANTAMENTOS A FORNECEDORES - CONSOLIDAÇÃO','Registra os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.0.00.00.00.00.00','OUTROS ESTOQUES','Compreende o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.8.1.00.00.00.00.00','OUTROS ESTOQUES - CONSOLIDAÇÃO','Registra o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.0.00.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.00.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Compreende o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro do ajuste  de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.01.00.00.00.00','(-) AJUSTE  PARA PERDAS EM ESTOQUES','Registra as perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferencas fisicas, quando tais perdas não puderem ser baixadas das proprias contas, pelo fato de não estarem identificados os itens especificos e por constituirem estimativas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.5.9.1.02.00.00.00.00','(-) AJUSTE DE PERDAS PARA REDUCAO AO VALOR DE MERCADO','Registra o ajuste de perdas para os estoque que tiverem o valor de mercado inferior ao seu custo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no curto prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.1.0.00.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Compreende os valores pagos a titulo de prêmios de seguro a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.1.1.00.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de prêmios de seguro a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.2.0.00.00.00.00.00','VPD FINANCEIRAS A APROPRIAR','Compreende os valores pagos, a título de VPD financeiras a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.2.1.00.00.00.00.00','VPD FINANCEIRAS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos, a título de VPD financeiras a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.3.0.00.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Compreende os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.3.1.00.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de assinaturas e anuidades a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.4.0.00.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de aluguel a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.4.1.00.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de aluguel a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.5.0.00.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR','Compreende os valores pagos a titulo de tributos a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.5.1.00.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de tributos a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.6.0.00.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Compreende os valores pagos a titulo de contribuições confederativas a apropriar','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.6.1.00.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de contribuições confederativas a apropriar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.7.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR','Compreende os valores pagos a titulo de beneficio a pessoal a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.7.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL A APROPRIAR - CONSOLIDAÇÃO','Registra os valores pagos a titulo de beneficio a pessoal a apropriar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.8.0.00.00.00.00.00','DEMAIS VPD A APROPRIAR','Compreende os demais valores pagos a apropriar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.1.9.8.1.00.00.00.00.00','DEMAIS VPD A APROPRIAR - CONSOLIDAÇÃO','Registra os demais valores pagos a apropriar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.0.0.0.00.00.00.00.00','ATIVO NÃO CIRCULANTE','Compreende o ativo não circulante: o ativo realizável a longo prazo, os investimentos, o imobilizado e o intangível.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.0.0.00.00.00.00.00','ATIVO REALIZÁVEL A LONGO PRAZO','Compreende os bens, direitos e despesas antecipadas realizáveis no longo prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.0.00.00.00.00.00','CRÉDITOS A LONGO PRAZO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos e com vencimento no longo prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Compreende os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.01.00.00.00','IMPOSTOS','Registra os créditos tributários a receber provenientes de impostos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.02.00.00.00','TAXAS','Registra os créditos tributários a receber provenientes de taxas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.03.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Registra os créditos tributários a receber provenientes de contribuições de melhoria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.04.00.00.00','DEMAIS CONTRIBUIÇÕES','Registra os créditos tributários a receber provenientes de contribuições especiais.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.01.70.00.00.00','CRÉDITOS TRIBUTÁRIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de créditos tributários parcelados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.02.00.00.00.00','CLIENTES','Compreende os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.02.01.00.00.00','FATURAS/DUPLICATAS A RECEBER ','Registra os valores provenientes dos faturamentos da venda de mercadorias/produtos e serviços do estoque da entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.01.00.00.00','EMPRÉSTIMOS CONCEDIDOS A RECEBER','Registra os valores dos creditos por emprestimos concedidos pelo municipio, por autorização legal ou vinculação a contrato ou acordo, com vencimento a longo prazo. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.02.00.00.00','FINANCIAMENTOS CONCEDIDOS A RECEBER ','Registra os valores relativos aos financiamentos concedidos pelo municipio, entidades e instituições municipais por autorizações legais ou vinculações a contratos e acordos, com retorno a longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.03.03.00.00.00','EMPRÉSTIMOS A RECEBER – RPPS','Registra os valores dos ativos relativos a empréstimos a longo prazo concedidos pelo RPPS com recursos previdenciários, quando não havia impedimento legal, realizáveis após o término do exercicio seguinte.                                                                                                 ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.00.00.00','CREDITOS NÃO PREVIDENCIÁRIOS INSCRITOS','Compreende os valores relativos a créditos inscritos de Dívida Ativa tributária não previdenciária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.01.00.00','DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Compreende os valores relativos a créditos inscritos de Dívida Ativa do imposto sobre renda e proventos de qualquer natureza.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.01.01.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos inscritos de Dívida Ativa do imposto sobre renda e proventos de qualquer natureza, em cobrança administrativa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.01.02.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos inscritos de Dívida Ativa do imposto sobre renda e proventos de qualquer natureza, em cobrança judicial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.05.00.00','DÍVIDA ATIVA DO IPTU','Compreende os valores relativos a créditos inscritos de Dívida Ativa do iptu.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.05.01.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos inscritos de Dívida Ativa do iptu, em cobrança administrativa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.05.02.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos inscritos de Dívida Ativa do iptu, em cobrança judicial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.06.00.00','DÍVIDA ATIVA DO ITBI','Compreende os valores relativos a créditos inscritos de Dívida Ativa do itbi.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.06.01.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos inscritos de Dívida Ativa do itbi, em cobrança administrativa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.06.02.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos inscritos de Dívida Ativa do itbi, em cobrança judicial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.07.00.00','DÍVIDA ATIVA DO ISS','Compreende os valores relativos a créditos inscritos de Dívida Ativa do iss.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.07.01.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos inscritos de Dívida Ativa do iss, em cobrança administrativa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.07.02.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos inscritos de Dívida Ativa do iss, em cobrança judicial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.08.00.00','DÍVIDA ATIVA DO ITR','Compreende os valores relativos a créditos inscritos de Dívida Ativa do itr.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.08.01.00','COBRANÇA ADMINISTRATIVA','Registra os valores relativos a créditos inscritos de Dívida Ativa do itr, em cobrança administrativa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.01.08.02.00','COBRANÇA JUDICIAL','Registra os valores relativos a créditos inscritos de Dívida Ativa do itr, em cobrança judicial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.04.02.00.00.00','CREDITOS PREVIDENCIÁRIOS INSCRITOS','Registra os valores relativos a créditos inscritos de Dívida Ativa tributária previdenciária.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA ','Compreende os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.05.30.00.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','Registra os créditos de natureza não-tributária exigíveis a partir do recebimento, pela entidade, de certidão de decisão – título executivo, emitida pelo Tribunal de Contas do Estado com característica de liquidez e certeza, podendo ser, facultativamente inscrita como divida ativa não tributaria','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.01.00.00.00','(-) AJUSTE PARA PERDAS DE CREDITOS TRIBUTARIOS','Registra o ajuste para cobrir as perdas estimadas nos creditos tributarios.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.02.00.00.00','(-) AJUSTE DE PERDAS DE CLIENTES','Registra o ajuste para cobertura de perdas estimadas na cobrança das contas a receber de clientes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.03.00.00.00','(-) AJUSTE DE PERDAS DE EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra os valores de ajustes para perdas de creditos relativos a emprestimos e financiamentos a longo prazo concedidos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.00.00.00','(-) AJUSTE PARA PERDAS DE DIVIDA ATIVA TRIBUTARIA','Compreende os valores referentes ao ajuste para perdas na divida ativa tributaria, de acordo com os criterios definidos no MCASP.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.01.00.00','(-)AJUSTE PARA PERDAS DA DÍVIDA ATIVA DO IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores referentes ao ajuste para perdas na divida ativa do imposto sobre a renda e proventos de qualquer natureza.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.05.00.00','(-)AJUSTE PARA PERDAS DA DÍVIDA ATIVA DO IPTU','Registra os valores referentes ao ajuste para perdas na divida ativa do iptu.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.06.00.00','(-)AJUSTE PARA PERDAS DA DÍVIDA ATIVA DO ITBI','Registra os valores referentes ao ajuste para perdas na divida ativa do itbi.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.07.00.00','(-)AJUSTE PARA PERDAS DA DÍVIDA ATIVA DO ISS','Registra os valores referentes ao ajuste para perdas na divida ativa do iss.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.04.08.00.00','(-)AJUSTE PARA PERDAS DA DÍVIDA ATIVA DO ITR','Registra os valores referentes ao ajuste para perdas na divida ativa do itr.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.1.99.05.00.00.00','(-) AJUSTE DE PERDAS  DE DIVIDA ATIVA NAO TRIBUTARIA','Registra os valores referentes ao ajuste para perdas de divida ativa nao tributaria, e derivados de clientes, de acordo com os criterios definidos no Manual de Procedimentos da Divida Ativa.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTRA OFSS','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.01.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos daw variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.02.00.00.00.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.03.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.04.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Compreende os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.04.01.00.00.00','CREDITOS NAO PREVIDENCIARIOS INSCRITOS','Registra os valores relativos a creditos inscritos de divida ativa tributaria não previdenciaria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.04.02.00.00.00','CREDITOS PREVIDENCIARIOS INSCRITOS','Registra os valores relativos a creditos inscritos de divida ativa tributaria  previdenciaria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.05.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.2.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra  os ajustes de perdas estimadas com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.01.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento após término exercício seguinte, oriundos da variação patrimonial aumentativa tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsório.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.02.00.00.00.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.03.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.04.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.05.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.3.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.01.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.02.00.00.00.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.03.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.04.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.05.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.4.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Compreende os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.00.00.00.00.00','CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Compreende os valores a receber por fornecimento de bens, serviços, créditos tributários, dívida ativa, transferências e empréstimos e financiamentos concedidos com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.01.00.00.00.00','CRÉDITOS TRIBUTÁRIOS A RECEBER','Registra os valores relativos a créditos a receber com vencimento no longo prazo, oriundos das variações patrimoniais aumentativas tributárias. Os tributos são: impostos, taxas, contribuições de melhoria, contribuições e empréstimos compulsórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.02.00.00.00.00','CLIENTES','Registra os valores das faturas/duplicatas a receber decorrentes das vendas a prazo de mercadorias ou serviços que ocorrem no curso normal das operações da entidade (com vencimento após término do exercício seguinte), representando um direito a cobrar de seus clientes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.03.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra o somatório dos valores de empréstimos e financiamentos concedidos por autorizações legais ou vinculações a contratos e acordos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.04.00.00.00.00','DIVIDA ATIVA TRIBUTARIA','Registra os valores dos créditos de divida ativa tributaria, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de públicação dos demonstrativos contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.05.00.00.00.00','DIVIDA ATIVA NÃO TRIBUTARIA','Registra os valores dos créditos de divida ativa não tributaria, em processo de inscrição e já inscritos, realizáveis no longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.1.5.99.00.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS A LONGO PRAZO','Registra os ajustes de perdas estimadas s com o não recebimento de valores referentes a créditos a longo prazo, por inadimplência de terceiros e outras.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.0.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende os valores a receber por demais transações, com vencimento no longo prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.00.00.00.00.00','DEMAIS CRÉDITOS E VALORES A LONGO PRAZO - CONSOLIDAÇÃO','Compreendeos valores a receber por demais transações, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A PESSOAL E A TERCEIROS','Registra as antecipações concedidas à pessoal, tais como antecipações de salários e ordenados, adiantamentos de 13º salário, adiantamentos de ferias e outros, alem da entrega de numerário a terceiros sem vinculação especifica ao fornecimento de bens ou serviços.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.02.00.00.00.00','TRIBUTOS A RECUPERAR / COMPENSAR','Registra o somatório dos valores dos tributos a recuperar / compensar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.03.00.00.00.00','CRÉDITOS A RECEBER POR DESCENTRALIZAÇÃO DA PRESTAÇÃO DE SERVIÇOS PÚBLICOS','Registra os créditos a receber com realização após os doze meses seguintes a data de públicação das demonstrações contábeis, decorrentes da descentralização de serviços públicos, tanto por meio de outorga a entidades da administração indireta como por meio de delegação, nas formas de concessão, permissão ou autorização ao particular do direito de exploração de serviços públicos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO PROVENIENTES DE CRÉDITOS ADMINISTRATIVOS','Compreende os valores realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em processos administrativos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE FOLHA DE PAGAMENTO','Registra o credito do ente correspondente a debitos administrativos  decorrentes de folha de pagamento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.02.00.00.00','CREDITOS A RECEBER DECORRENTES DE DANO AO PATRIMONIO','Registra o credito do ente correspondente a debito administrativo decorrentes de danos ao patrimonio publico.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE ERRO ADMINISTRATIVO','Registra o credito do ente correspondente a debito administrativo decorrentes de erro da administração.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.04.00.00.00','CREDITOS A RECEBER DECORRENTES DE DOLO, MA-FE OU FRAUDE','Registra o credito do ente correspondente a debito administrativo decorrentes de dolo, ma-fe ou fraude.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.05.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL','Registra os saldos dos valores entregues a funcionarios ou servidores, não devolvidos dentro dos prazos estabelecidos em normas legais ou determinação  administrativa ou seja, quando o produto a arrecadar não tenha sido recolhido no prazo legal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.06.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS','Registra os valores relativos as responsabilidades por irregularidades em prestação de servicos por terceiros, cujos processos foram apurados, com imputação da responsabilidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.07.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS','Registra os valores referentes a multas e juros pagos pelo órgão,  porém de responsabilidade de servidores, que foram apurados, com imputação da responsabilidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.10.00.00.00','CRÉDITOS A RECEBER POR PAGAMENTOS INDEVIDOS DE BENEFÍCIOS PREVIDENCIÁRIOS','Registra o crédito a receber por pagamentos indevidos de benefícios previdenciários.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.04.99.00.00.00','OUTROS CREDITOS ADMINISTRATIVOS','Registra o credito do ente correspondente a outros creditos administrativos que não se enquadram em rubricas especificas existentes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.00.00.00.00','CRÉDITOS POR DANOS AO PATRIMÔNIO APURADOS EM TOMADA DE CONTAS ESPECIAL','Compreende os valores realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis, provenientes de direitos oriundos de danos ao patrimônio, apurados em tomada de contas especial.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.01.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS INDEVIDOS -TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades imputadas a gestores e outros  responsaveis e co-responsaveis por pagamentos efetuados indevidamente,  inclusive em casos de super faturamento. (quando for instaurada tomada de conta especial)','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.02.00.00.00','CREDITOS A RECEBER DE SERVIDORES NAO RECOLHIDOS NO PRAZO LEGAL  - TOMADA DE CONTAS ESPECIAL','Registra os saldos dos valores entregues a funcionarios ou servidores, não devolvidos dentro dos prazos estabelecidos em normas legais ou determimanação  administrativa, ou seja, quando o produto a arrecadar não tenha sido recolhido no prazo legal.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.03.00.00.00','CREDITOS A RECEBER DECORRENTES DE DESFALQUES OU DESVIOS  - TOMADA DE CONTAS ESPECIAL','Registra os desfalques, desvios de bens e valores do municipio ou de entidades publicas, apuradas em processos por ações  administrativas e policial ou julgamento judicial.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.04.00.00.00','CREDITOS A RECEBER POR DEBITOS DE TERCEIROS EM PRESTACAO DE SERVICOS - TOMADA DE CONTAS ESPECIAL','Registra os valores relativos as responsabilidades por irregularidades em prestação de serviços por terceiros, cujos processos foram apurados, com imputação da responsabilidade. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.05.00.00.00','CREDITOS A RECEBER DE RESPONSAVEIS POR DANOS OU PERDAS - TOMADA DE CONTAS ESPECIAL','Registra as responsabilidades apuradas em inqueritos administrativo ou policial contra servidores ou terceiros, por danos e perdas causados a fazenda publica sendo apurados com imputação da responsabilidade. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.06.00.00.00','CREDITOS A RECEBER DECORRENTES DE PAGAMENTOS SEM RESPALDO ORCAMENTARIO  - TOMADA DE CONTAS ESPECIAL','Registra as despesas realizadas sem existencia de credito que as comporte, resultando em pagamento sem previo empenho ou ainda com classificação impropria (diferente daquela prevista no orcamento), apuradas, com imputação da responsabilidade             ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.07.00.00.00','CREDITOS A RECEBER DECORRENTES DE CREDITOS ANTECIPADOS  - TOMADA DE CONTAS ESPECIAL','Registra os valores pagos sobre dotações decorrentes de creditos antecipados não realizados até o fechamento do exercicio, apurados, com imputação da responsabilidade                                    ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.08.00.00.00','CREDITOS A RECEBER DECORRENTES DE FALTA OU IRREGULARIDADE DE COMPROVACAO  - TOMADA DE CONTAS ESPECIAL ','Registra os valores correspondentes a falta de documentação comprobatoria da execução da despesa, inclusive as apresentações fora do prazo legal, bem como a inadimplencia na comprovação de instrumentos de transferencia ou ainda irregularidade na documenta.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.09.00.00.00','CREDITOS  A RECEBER DECORRENTES DE FALTA DE LICITACAO  - TOMADA DE CONTAS ESPECIAL ','Registra os valores relativos a bens e servicos adquiridos sem a   necessaria licitação especifica, em processos motivados, por  determinações administrativas e ou inqueritos, apurados, com imputação da  responsabilidade. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.10.00.00.00','MULTAS E JUROS A RECEBER DE SERVIDORES RESPONSABILIZADOS - TOMADA DE CONTAS ESPECIAL ','Registra os valores referentes a multas e juros pagos pelo órgão,  porém de responsabilidade de servidores, que foram apurados, com imputação da responsabilidade .','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.11.00.00.00','CREDITOS A RECEBER DECORRENTES DE FALTA DE RECOLHIMENTO DE OBRIGACOES PECUNIARIAS  - TOMADA DE CONTAS ESPECIAL ','Registra os valores correspondentes a falta de recolhimento  ou  pagamento de obrigações pecuniarias, tais como:  parte  do  empregador  de obrigações patronais, valores descontados de terceiros e  não recolhidos, não pagamento de obrigações para com o ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.13.00.00.00','CREDITOS  A RECEBER DECORRENTES DE ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE   - TOMADA DE CONTAS ESPECIAL ','Registra as responsabilidades imputadas a gestores e outros  responsaveis e co-responsaveis por adiantamentos concedidos em desacordo com a legislação pertinente, tais como a fornecedores e empregados.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.05.99.00.00.00','OUTRAS CREDITOS A RECEBER APURADOS EM TOMADA DE CONTAS ESPECIAL ','Registra as responsabilidades diversas cujas classificações não  estejam definidas em contas proprias ou para as quais não hajam contas especificas. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.00.00.00.00','DEPÓSITOS RESTITUÍVEIS E VALORES VINCULADOS','Compreende os valores de depósitos e cauções efetuados e recebidos pela entidade para garantia de contratos, bem como para direito de uso, exploração temporária de bens ou de natureza judicial, depósitos compulsórios e demais recursos vinculados, realizáveis após os doze meses seguintes a data de públicação das demonstrações contábeis.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.01.00.00.00','DEPOSITOS  E CAUCOES RELATIVOS A CONTRATOS OU CONVENCOES','Registra os valores relativos a depositos e cauções, efetuados  por vinculações a contratos ou convenções, para garantias de operações  especificas, realizaveis após os doze meses seguintes a data de publicação das demonstrações contabeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.02.00.00.00','DEPOSITOS JUDICIAIS','Registra os valores a receber decorrentes de depositos efetuados por determinação judicial, realizaveis após os doze meses seguintes a data de publicação das demonstrações contabeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.03.00.00.00','DEPOSITOS PARA INTERPOSICAO DE RECURSOS','Registra os valores relativos aos depositos vinculados, decorrentes de interposição de  recursos na esfera judicial ou administrativa.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.04.00.00.00','DEPOSITOS ESPECIAIS','Registra os valores relativos a outros depositos em contas bancarias, vinculados a obrigações contratuais, convenções, acordos e ajustes.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.05.00.00.00','VALORES  APREENDIDOS POR DECISAO JUDICIAL','Registra os valores apreendidos por decisão judicial através de penhora ou arresto, realizaveis após os doze meses seguintes a data de publicação das demonstrações contabeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.07.00.00.00','DEPÓSITOS COMPULSÓRIOS','Registra os valores relativos a depósitos compulsórios, de acordo com a legislação em vigor.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.06.99.00.00.00','OUTROS DEPOSITOS RESTITUIVEIS E VALORES VINCULADOS','Registra os valores relativos a outros depositos restituiveis e valores vinculados, realizaveis após os doze meses seguintes a data de publicação das demonstrações contabeis','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.00.00.00.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','Compreende os outros créditos e valores realizáveis após os doze meses seguintes a data da publicação das demonstrações contábeis, provenientes de direitos obtidos junto a diversos devedores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.01.00.00.00','CRÉDITOS A RECEBER DE ENTIDADES FEDERAIS ','Registra os valores realizáveis apos o termino do exercicio seguinte decorrentes de debito de entidades federais com a União.                                                   ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.03.00.00.00','CREDITOS ORIUNDOS DE CONCESSOES DE DIREITOS DE USO E DE EXPLORACAO DE BENS','Registra o valor dos creditos oriundos das concessões de direitos de uso e de exploração de bens do ente, para terceiros ou para outras entidades governamentais, realizaveis a longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.04.00.00.00','CREDITOS A RECEBER DE DEVEDORES DE CONVENIOS','Registra os valores oriundos de creditos de convenios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.05.00.00.00','CREDITOS A RECEBER DECORRENTES DE ALIENACAO DE BENS MOVEIS E IMOVEIS','Registra os valores dos creditos a receber decorrentes da alienação de bens moveis e imoveis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.06.00.00.00','CRÉDITOS A RECEBER POR ACERTO FINANCEIRO COM SERVIDOR E EXSERVIDOR','Registra os valores, realizáveis após o término do exercício seguinte, dos créditos a receber decorrentes de acertos financeiros com servidores e exservidores do órgão.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.07.00.00.00','CREDITOS ADMINISTRATIVOS DECORRENTES DE AUTOS DE INFRACAO','Registra o valor dos creditos administrativos oriundos de autos de infração e outros.                                      ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.08.00.00.00','INDENIZACOES A RECEBER','Registra os valores das indenizações a receber a longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.99.00.00.00','OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','Compreende outros creditos a receber e valores a longo prazo, não classificaveis em outras contas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.98.99.01.00.00','INSCRICAO DE CERTIDAO DE DECISAO - TITULO EXECUTIVO DO TCE/RS','Registra os créditos exigíveis a partir do recebimento, pela entidade, de certidão de decisão – título executivo, emitida pelo Tribunal de Contas do Estado com característica de liquidez e certeza, podendo ser, facultativamente inscrita como divida ativa não tributaria','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE DEMAIS CRÉDITOS E VALORES A LONGO PRAZO','Compreende o ajuste de perdas estimadas com o não recebimento de valores referentes a demais créditos a longo prazo, por inadimplência de terceiros e outras.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.01.00.00.00','(-) AJUSTE DE PERDAS DE DIVIDA ATIVA NÃO TRIBUTÁRIA - DEMAIS CRÉDITOS','Registra o ajuste para perdas estimadas com o não recebimento de valores referentes a dívida ativa não tributária de longo prazo, exceto as derivadas de clientes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.02.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS ADMINISTRATIVOS','Registra os valores dos ajustes para perdas estimadas de creditos por danos ao patrimonio, verificados em processos administrativos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.03.00.00.00','(-) AJUSTE DE PERDAS DE CREDITOS  APURADOS EM TOMADA DE CONTAS ESPECIAL','Registra os valores  dos ajustes para perdas estimadas de creditos por danos ao patrimonio, apurados em tomada de contas especial.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.07.00.00.00','(-) AJUSTE DE PERDAS DE CRÉDITOS APURADOS EM DIVIDA ATIVA NÃO TRIBUTARIA - DEMAIS CRÉDITOS','Registra os valores dos ajustes para perdas estimadas de créditos de divida ativa não tributaria, exceto as derivadas de clientes, em processo de inscrição e já inscritos, realizáveis após os doze meses seguintes a data de publicação dos demonstrativos contábeis.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.2.1.99.98.00.00.00','(-) AJUSTE DE PERDAS DE OUTROS CREDITOS A RECEBER E VALORES A LONGO PRAZO','Registra os valores dos ajustes de perdas de outros creditos a receber e valores a longo prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.0.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.00.00.00.00.00','INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as aplicações de recursos em títulos, valores mobiliários e imobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.01.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS','Registra as aplicações de recursos em títulos e valores mobiliários, não destinadas à negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.02.00.00.00.00','APLICAÇÃO TEMPORÁRIA EM METAIS PRECIOSOS','Registra as aplicações de recursos em metais preciosos, não destinados a negociação e que não façam parte das atividades operacionais da entidade, resgatáveis após os doze meses seguintes a data da publicação das demonstrações contábeis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.03.00.00.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Registra os investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE INVESTIMENTOS E APLICAÇÕES TEMPORÁRIAS A LONGO PRAZO','Compreende a diferença entre o valor recuperável do ativo e seu valor contábil, quando o primeiro for menor.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.01.00.00.00','(-) AJUSTE DE PERDAS COM TITULOS E VALORES MOBILIARIOS ','Registra os valores de ajustes para perdas em títulos e valores mobiliários a longo prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.02.00.00.00','(-) AJUSTE DE PERDAS COM APLICACOES TEMPORARIAS EM METAIS PRECIOSOS','Registra os valores de ajustes para perdas em aplicações em ouro e outros metais preciosos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.3.1.99.03.00.00.00','(-) AJUSTE DE PERDAS COM APLICAÇÕES EM SEGMENTO DE IMÓVEIS','Registra os valores de ajustes para perdas em investimentos de longo prazo realizados em segmento de imóveis, realizáveis no longo prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.0.00.00.00.00.00','ESTOQUES','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade para utilização própria ou para venda, previstos para período posterior ao término do exercício seguinte.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.00.00.00.00.00','ESTOQUES - CONSOLIDAÇÃO','Compreende o valor dos bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.01.00.00.00.00','MERCADORIAS PARA REVENDA','Registra todos os produtos adquiridos de terceiros para revenda, que não sofrem nenhum processo de transformação na entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.02.00.00.00.00','PRODUTOS E SERVIÇOS ACABADOS','Registra os produtos já terminados e oriundos da própria produção da entidade e disponíveis para venda, estocados na fabrica, ou em depósitos, ou em filiais, ou ainda com terceiros em consignação e os serviços acabados. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.03.00.00.00.00','PRODUTOS E SERVIÇOS EM ELABORAÇÃO','Registra os produtos e serviços em andamento que não serão concluídos até o término do exercício subsequente a data do balanço patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.04.00.00.00.00','MATÉRIAS-PRIMAS','Registra o estoque de matérias-primas que será utilizado no processo produtivo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.05.00.00.00.00','MATÉRIAIS EM TRANSITO','Registra o valor dos materiais em processo de transferência para outras unidades da entidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.06.00.00.00.00','ALMOXARIFADO','Registra o valor dos materiais destinados ao consumo interno da unidade. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.07.00.00.00.00','ADIANTAMENTOS A FORNECEDORES','Registra os adiantamentos efetuados pela entidade a fornecedores, vinculados a compras especificas de materiais que serão incorporados aos estoques quando de seu efetivo recebimento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.98.00.00.00.00','OUTROS ESTOQUES','Registra o valor dos outros bens adquiridos, produzidos ou em processo de elaboração pela entidade com o objetivo de venda ou utilização própria no curso normal das atividades.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.4.1.99.00.00.00.00','(-) AJUSTE DE PERDAS DE ESTOQUES','Registra o registro das perdas conhecidas em estoques e calculadas por estimativa, relativas a estoques deteriorados ou obsoletos e para dar cobertura a diferenças físicas, quando tais perdas não puderem ser baixadas das próprias contas, pelo fato de não estarem identificados os itens específicos e por constituírem estimativas, bem como o registro de perdas estimadas para os estoque que tiverem o valor de mercado inferior ao seu custo. Conta a ser utilizada apenas para os estoques classificados no ativo realizável a longo prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço à entidade ocorrerão no longo prazo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PAGAS ANTECIPADAMENTE- CONSOLIDAÇÃO','Compreende pagamentos de variações patrimoniais diminutivas (VPD) antecipadas, cujos benefícios ou prestação de serviço a entidade ocorrerão no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.01.00.00.00.00','PRÊMIOS DE SEGUROS A APROPRIAR','Registra os valores pagos a titulo de prêmios de seguro a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.02.00.00.00.00','VPD FINANCEIRAS A APROPRIAR','Registra os valores pagos a título de VPD financeiras a apropriar.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.03.00.00.00.00','ASSINATURAS E ANUIDADES A APROPRIAR','Registra os valores pagos a titulo de assinaturas e anuidades a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.04.00.00.00.00','ALUGUEIS PAGOS A APROPRIAR','Registra os valores pagos a titulo de aluguel a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.05.00.00.00.00','TRIBUTOS PAGOS A APROPRIAR','Registra os valores pagos a titulo de tributos a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.06.00.00.00.00','CONTRIBUIÇÕES CONFEDERATIVAS A APROPRIAR','Registra os valores pagos a titulo de contribuições confederativas a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.07.00.00.00.00','BENEFÍCIOS A APROPRIAR','Registra os valores pagos a titulo de beneficio a pessoal a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.1.9.1.99.00.00.00.00','DEMAIS VPD A APROPRIAR','Registra os demais valores pagos a apropriar.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.0.0.00.00.00.00.00','INVESTIMENTOS','Compreende as participações permanentes em outras sociedades, bem como os bens e direitos não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção da atividade da entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.0.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - CONSOLIDAÇÃO','Compreende as participações permanentes da unidade em outras entidades em forma de ações ou cotas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.1.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTRA OFSS','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.2.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - UNIÃO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.3.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - ESTADO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.4.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.00.00.00.00.00','PARTICIPAÇÕES PERMANENTES - INTER OFSS - MUNICÍPIO','Compreende as participações permanentes da entidade em outras sociedades em forma de ações ou cotas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.01.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE EQUIVALÊNCIA PATRIMONIAL','Registra as participações permanentes da unidade em outras entidades em forma de ações ou cotas, avaliadas pelo método de equivalência patrimonial.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.1.5.02.00.00.00.00','PARTICIPAÇÕES AVALIADAS PELO MÉTODO DE CUSTO','Registra as participações permanentes da unidade em outras sociedades em forma de ações ou cotas, avaliadas pelo método de custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.0.00.00.00.00.00','PROPRIEDADES PARA INVESTIMENTO','Compreende a propriedade (terreno ou edifício – ou parte de edifício – ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.00.00.00.00.00','PROPRIEDADES PARA INVESTIMENTO - CONSOLIDAÇÃO','Compreende a propriedade (terreno ou edifício – ou parte de edifício – ou ambos) mantida (pelo proprietário ou pelo arrendatário em arrendamento financeiro) para auferir aluguel ou para valorização do capital ou para ambas, e não para: uso na produção ou fornecimento de bens ou serviços ou para finalidades administrativas; ou venda no curso ordinário do negócio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.01.00.00.00.00','BENS IMOVEIS PARA FUTURA UTILIZAÇÃO','Registra os valores de imoveis da unidade mantidos para futura utilização.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.02.00.00.00.00','BENS IMOVEIS NÃO DESTINADOS A USO','Registra os valores de imoveis da unidade mantidos para geração de renda.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.2.1.99.00.00.00.00','OUTRAS PROPRIEDADES PARA INVESTIMENTOS','Registra as outras propriedades para investimentos não abrangidas nas contas anteriores, avaliadas pelo método do custo.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.0.00.00.00.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.00.00.00.00.00','INVESTIMENTOS DO RPPS DE LONGO PRAZO - CONSOLIDAÇÃO','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social, em conformidade com a legislação que trata das aplicações e investimentos dos RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.00.00.00.00','TÍTULOS E VALORES MOBILIÁRIOS – RPPS ','Compreende os investimentos realizados pelo Regime Próprio da Previdência Social. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.01.00.00.00','APLICAÇÕES EM ATIVOS EM ENQUADRAMENTO – TÍTULOS E VALORES','Registra os investimentos realizados pelo RPPS, em desacordo com as regras estabelecidas pela Resolução CMN nº 3790/2009, artigo 25. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.01.02.00.00.00','APLICAÇÕES EM ATIVOS NÃO SUJEITOS À RESOLUÇÃO DO CMN – TÍTULOS E VALORES','Registra os investimentos realizados pelo RPPS, em ativos não sujeitos as regras da  Resolucao CMN nº 3790/2009. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.02.00.00.00.00','APLICAÇÕES EM SEGMENTO DE IMÓVEIS – RPPS','Compreende os investimentos realizados pelo RPPS, no segmento de imóveis efetuados em conformidade com o art. 8º da Resolução CMN n° 3.790/2009.','D','N','','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.3.1.02.01.00.00.00','IMÓVEIS – RPPS','Registra os investimentos realizados pelo RPPS, em imóveis sujeitos as regras da  resolução CMN nº 3790/2009. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.0.00.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES','Compreende os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.7.1.00.00.00.00.00','DEMAIS INVESTIMENTOS PERMANENTES - CONSOLIDAÇÃO','Registra os demais direitos de qualquer natureza não classificáveis no ativo circulante nem no ativo realizável a longo prazo e que não se destinem a manutenção das atividades da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.0.00.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS','Compreende a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.1.00.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreendea diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, como a depreciação das propriedades mantidas para investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.8.1.01.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INVESTIMENTOS – CONSOLIDAÇÃO - PROPRIEDADES PARA INVESTIMENTO','Registra a diminuição do valor dos elementos do ativo investimento devido a desgaste pelo uso, ação da natureza ou obsolescência, quando couber, das propriedades mantidas para investimento.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra os valores de ajuste ao valor recuperável de propriedades para investimento, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.03.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS','Registra os valores de ajuste ao valor recuperável de investimentos do RPPS, quando esse for inferior ao valor liquido contábil.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.1.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTRA OFSS','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.2.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - UNIÃO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. . Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.3.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - ESTADO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.4.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS-INTER OFSS - MUNICÍPIO','Compreende os valores de ajuste ao valor recuperável de investimentos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - PARTICIPAÇÕES PERMANENTES','Registra os valores de ajuste ao valor recuperável de participações permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.2.9.5.04.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INVESTIMENTOS - DEMAIS INVESTIMENTOS PERMANENTES','Registra os valores de ajuste ao valor recuperável de demais investimentos permanentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.0.0.00.00.00.00.00','IMOBILIZADO','Compreende os direitos que tenham por objeto bens corpóreos destinados a manutenção das atividades da entidade ou exercidos com essa finalidade, inclusive os decorrentes de operações que transfiram a ela os benefícios, os riscos e o controle desses bens.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.0.00.00.00.00.00','BENS MOVEIS','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.00.00.00.00.00','BENS MOVEIS- CONSOLIDAÇÃO','Compreende o valor da aquisição ou incorporação de bens corpóreos, que tem existência material e que podem ser transportados por movimento próprio ou removidos por forca alheia sem alteração da substancia ou da destinação economico-social, que constituam meio para a produção de outros bens ou serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.01.00.00.00.00','MAQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra o valor da aquisição ou incorporação de maquinas, ferramentas, aparelhos, equipamentos,  acessorios, etc.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.02.00.00.00.00','BENS DE INFORMATICA','Registra o valor da aquisição ou incorporação de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.03.00.00.00.00','MOVEIS E UTENSILIOS','Registra o valor da aquisicao ou incorporacao de mobiliario em geral e utensilios, entre outros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.04.00.00.00.00','MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICACAO','Registra o valor da aquisição ou incorporação de materiais bibliograficos, discotecas, filmotecas, de comunicação, entre outros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.05.00.00.00.00','VEICULOS','Registra o valor da aquisicao ou incorporacao de meios de transportes aereos, aquaticos e terrestres, entre outros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.06.00.00.00.00','PECAS E CONJUNTOS DE REPOSICAO','Registra o valor da aquisição ou incorporação de peças e conjuntos de reposição destinados a substituição em maquinas e equipamentos, aeronaves e embarcações, bens de seguranca e socorro, entre outros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.07.00.00.00.00','BENS MOVEIS EM ANDAMENTO','Registra os valores de bens moveis em andamento','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.08.00.00.00.00','BENS MOVEIS EM ALMOXARIFADO','Registra os valores de bens permanentes a serem estocados em almoxarifado.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.09.00.00.00.00','ARMAMENTOS','Registra os valores de armas que constituem objetos de defesa ou preparativos de guerra.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.10.00.00.00.00','SEMOVENTES','Registra os valores relativos aos animais destinados a produção, reprodução, engorda e aos serviços  utilitarios em geral.                            ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.1.1.99.00.00.00.00','DEMAIS BENS MOVEIS','Registra o valor da aquisição ou incorporação dos demais bens moveis não classificados em grupos especificos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.0.00.00.00.00.00','BENS IMÓVEIS','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.00.00.00.00.00','BENS IMOVEIS- CONSOLIDAÇÃO','Compreende o valor dos bens imóveis, os quais são bens vinculados ao solo e que não podem ser retirados sem destruição ou dano, destinados ao uso e que a entidade não esteja explorando comercialmente. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.00.00.00.00','BENS DE USO ESPECIAL','Compreende os bens, tais como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.01.00.00.00','IMÓVEIS RESIDENCIAIS','Registra os valores relativos aos imóveis residenciais dos estados ou municípios, como apartamentos; casas; residenciais; conjuntos. Os imóveis funcionais, os próprios residenciais e as vilas militares devem ser registrados nessa conta.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.02.00.00.00','IMÓVEIS COMERCIAIS','Registra os valores relativos aos imóveis comerciais dos estados ou municípios, como conjuntos; salas; e lojas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.03.00.00.00','EDIFÍCIOS','Registra os valores relativos aos seguintes imóveis dos estados ou municípios nas seguintes categorias: edifícios, prédios; conventos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.04.00.00.00','TERRENOS/GLEBAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: terrenos e glebas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.05.00.00.00','ARMAZÉNS/GALPÕES','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: armazéns e galpões.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.08.00.00.00','IMÓVEIS DE USO EDUCACIONAL','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: escolas; faculdades; universidades; bibliotecas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.09.00.00.00','REPRESAS/AÇUDES','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: açudes; represas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.10.00.00.00','FAZENDAS, PARQUES E RESERVAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios nas seguintes categorias: fazendas; parques; reservas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.11.00.00.00','IMÓVEIS DE USO RECREATIVO','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem nas seguintes categorias: clubes; estádios; teatros.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.12.00.00.00','FARÓIS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: faróis (faroletes). Os instrumentos de auxílio a navegação aérea também devem ser registrados nesta conta.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.13.00.00.00','MUSEUS/PALÁCIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: museus; palácios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.14.00.00.00','LABORATÓRIOS/OBSERVATÓRIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem nas seguintes categorias: laboratórios; observatórios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.15.00.00.00','HOSPITAIS E UNIDADES DE SAÚDE','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: hospitais e unidades de saúde.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.16.00.00.00','HOTÉIS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: hotéis.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.17.00.00.00','PRESÍDIOS/DELEGACIAS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: presídios; delegacias.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.20.00.00.00','CEMITÉRIOS','Registra os valores relativos aos seguintes imóveis dos estados e municípios: cemitérios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.21.00.00.00','ESTACIONAMENTOS E GARAGENS','Registra os valores relativos aos seguintes imóveis dos estados e municípios que se enquadrem na seguinte categoria: estacionamentos. Também devem ser registrados nesta conta as garagens.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.22.00.00.00','POSTOS DE FISCALIZAÇÃO','Registra os valores relativos aos seguintes imóveis dos estados e municípios: postos policiais. Também devem ser registrados nessa conta os demais postos de fiscalização.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.01.98.00.00.00','OUTROS BENS IMÓVEIS DE USO ESPECIAL','Registra os valores relativos aos seguintes imóveis dos estados e municípios que não se enquadrem em nenhuma outra categoria.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.00.00.00.00','BENS DOMINICAIS','Compreende os bens  que constituem o patrimônio das pessoas juridicas de direito publico, como objeto de direito pessoal, ou real. Compreende ainda, não dispondo a lei em contrario, os bens pertencentes as pessoas juridicas de direito publico a que se tenha dado estrutura de direito privado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.01.00.00.00','EDIFÍCIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem nas seguintes categorias: edifícios; prédios; conventos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.02.00.00.00','APARTAMENTOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: apartamentos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.03.00.00.00','ARMAZÉNS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: armazéns.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.04.00.00.00','CASAS','Registra os valores patrimoniais relativos aos imóveis dominicais união,estados e municípios que se enquadrem na seguinte categoria: casas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.05.00.00.00','CEMITÉRIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união,estados e municípios que se enquadrem na seguinte categoria: cemitérios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.06.00.00.00','EDIFÍCIOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: edifícios.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.07.00.00.00','GARAGENS E ESTACIONAMENTOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: garagens e estacionamentos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.08.00.00.00','FAZENDAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: fazendas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.09.00.00.00','GALPÕES','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: galpões.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.10.00.00.00','GLEBAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.11.00.00.00','LOJAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lojas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.12.00.00.00','SALAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: salas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.13.00.00.00','TERRENOS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: terrenos.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.14.00.00.00','LOTES','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lotes.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.15.00.00.00','LOTES INDUSTRIAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: lotes industriais.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.16.00.00.00','GLEBAS URBANAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas urbanas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.17.00.00.00','GLEBAS URBANIZADAS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas urbanizadas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.18.00.00.00','GLEBAS RURAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que se enquadrem na seguinte categoria: glebas rurais.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.04.99.00.00.00','OUTROS BENS DOMINICAIS','Registra os valores patrimoniais relativos aos imóveis dominicais união, estados e municípios que não se enquadrem em outras categorias.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.00.00.00.00','BENS DE USO COMUM DO POVO','Compreende os bens de uso comum do povo construidos ou adquiridos por pessoas juridicas de direito publico. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.01.00.00.00','RUAS','Registra os valores de ruas que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.02.00.00.00','PRAÇAS','Registra os valores de praças que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.03.00.00.00','ESTRADAS','Registra os valores de estradas que foram construídas utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.04.00.00.00','PONTES','Registra os valores de pontes que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.05.00.00.00','VIADUTOS','Registra os valores de viadutos que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.06.00.00.00','SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA','Registra os valores de SISTEMAS DE ESGOTO E/OU DE ABASTECIMENTO DE ÁGUA que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.07.00.00.00','SISTEMAS DE ABASTECIMETNO DE ENERGIA','Registra os valores de SISTEMAS DE ABASTECIMETNO DE ENERGIA que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.08.00.00.00','REDES DE TELECOMUNICAÇÕES','Registra os valores de REDES DE TELECOMUNICAÇÕES que foram construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.09.00.00.00','BENS DO PATRIMONIO CULTURAL','Registra os bens com significancia histórica, cultural ou ambiental tais como monumentos e prédios históricos, sítios arqueológicos, área de conservação e reservas naturais e obras de arte, quando passíveis de mensuração e avaliação.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.05.99.00.00.00','OUTROS BENS DE USO COMUM DO POVO','Registra os valores bens de uso comum, não classificados anteriormente neste plano de contas, que foram adquiridos, produzidos ou construídos utilizando-se recursos públicos e que estejam sob controle ou administração da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.06.00.00.00.00','BENS IMOVEIS EM ANDAMENTO','Registra os valores de bens imoveis em andamento','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.07.00.00.00.00','INSTALACOES','Registra equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edificios, devem ser segregadas das obras civis, como, por exemplo, as instalções eletricas, hidraulicas, sanitarias, de vapor, de ar comprimido, frigorificas, contra incendio, de comunicações, de climatização, para combustiveis, gases, de antipoluição, para cozinha, dentre outros.  E tambem aplicavel a construção de trechos ferroviarios. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.08.00.00.00.00','BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra construções em terrenos arrendados de tercerios e instalações e outras benfeitorias em predios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imovel e revertem ao proprietario do imovel ao final da locação. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.00.00.00.00','DEMAIS BENS IMOVEIS','Compreende os demais bens imoveis não classificados anteriormente nesse plano de contas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.01.00.00.00','BENS IMÓVEIS LOCADOS PARA TERCEIROS','Registra os demais bens imoveis não classificados anteriormente nesse plano de contas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.02.00.00.00','IMÓVEIS EM PODER DE TERCEIROS','Registra os imóveis concedidos a terceiros a título de empréstimo gratuito com prazo de devolução convencionado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.03.00.00.00','MATERIAIS TEMPORARIAMENTE SEPARADOS DE IMÓVEIS','Registra os materiais provisoriamente separados de um imóvel, para nele se reempregarem.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.05.00.00.00','BENS IMÓVEIS A CLASSIFICAR','Registra os bens imóveis, cuja classificação esteja pendente por algum motivo, geralmente por falta de identificação ou pendência de legalização ou registro.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.06.00.00.00','BENS IMÓVEIS A ALIENAR','Registra os valores relativos aos bens imóveis separados para alienação, quando considerados desnecessários, inservíveis ou por decisão administrativa da unidade.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.2.1.99.99.00.00.00','OUTROS BENS IMÓVEIS','Registra os valores relativos a outros bens imóveis, para os quais não tenham sido criadas contas próprias ou específicas neste plano de contas.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.0.00.00.00.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.00.00.00.00.00','(-) DEPRECIAÇÃO, EXAUSTÃO E AMORTIZAÇÃO ACUMULADAS - CONSOLIDAÇÃO','Compreende a diminuição do valor dos elementos do ativo imobilizado devido a desgaste pelo uso, ação da natureza ou obsolescência, bem como a perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração e a perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA – BENS MÓVEIS','Compreende a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.01.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a depreciação acumulada de máquinas, ferramentas, aparelhos, equipamentos, acessórios etc.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.02.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE INFORMÁTICA','Registra a depreciação acumulada de equipamentos de processamento de dados e sistemas aplicativos, entre outros.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.03.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE MÓVEIS E UTENSÍLIOS','Registra a depreciação acumulada de mobiliário em geral e utensílios, entre outros.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.04.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a depreciação acumulada de materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.05.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE VEÍCULOS','Registra a depreciação acumulada de transportes aéreos, aquáticos e terrestres, entre outros.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.06.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE PEÇAS E CONJUNTOS DE REPOSIÇÃO ','Registra a depreciação acumulada de peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.07.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ANDAMENTO','Registra a depreciação acumulada de bens móveis em andamento.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.08.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS MÓVEIS EM ALMOXARIFADO','Registra a depreciação acumulada de bens permanentes a serem estocados em almoxarifado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.09.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE ARMAMENTOS','Registra a depreciação acumulada de armas que constituem objetos de defesa ou preparativos de guerra.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.10.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE SEMOVENTES','Registra a depreciação acumulada de animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.01.99.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS MÓVEIS','Registra a depreciação acumulada de demais bens móveis não classificados em grupos específicos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.00.00.00.00','(-) DEPRECIAÇÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido a desgaste pelo uso, ação da natureza ou obsolescência.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.01.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO ESPECIAL','Compreende a depreciação acumulada de bens como edifícios ou terrenos destinados a serviço ou estabelecimento da administração estadual ou municipal, inclusive os de suas autarquias e fundações públicas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.02.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS DOMINICAIS','Registra a depreciação acumulada de bens que constituem o patrimônio das pessoas jurídicas de direito público, como objeto de direito pessoal, ou real, de cada uma dessas entidades. Compreende ainda, não dispondo a lei em contrário, os bens pertencentes as pessoas jurídicas de direito público a que se tenha dado estrutura de direito privado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.03.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS DE USO COMUM DO POVO','Registra a depreciação acumulada de bens de uso comum do povo construídos ou adquiridos por pessoas jurídicas de direito público.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.04.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENS IMÓVEIS EM ANDAMENTO','Registra a depreciação acumulada de valores de bens imóveis em andamento.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.05.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE INSTALAÇÕES','Registra a depreciação acumulada de equipamentos, materiais e custo de implantação de instalações que, não obstante integradas aos edifícios, devem ser segregadas das obras civis, como, por exemplo, as instalações elétricas, hidráulicas, sanitárias, de vapor, de ar comprimido, frigoríficas, contra incêndio, de comunicações, de climatização, para combustíveis, gases, de antipoluição, para cozinha, dentre outros. E também aplicável a construção de trechos ferroviários.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.06.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE BENFEITORIAS EM PROPRIEDADE DE TERCEIROS','Registra a depreciação acumulada de construções em terrenos arrendados de terceiros e instalações e outras benfeitorias em prédios alugados. São considerados somente os gastos com construção e instalação que se incorporam ao imóvel e revertem ao proprietário do imóvel ao final da locação.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.02.99.00.00.00','(-) DEPRECIAÇÃO ACUMULADA DE DEMAIS BENS IMÓVEIS','Registra a depreciação acumulada de os demais bens imóveis não classificados anteriormente nesse plano de contas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.03.00.00.00.00','(-) EXAUSTÃO ACUMULADA – BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.04.00.00.00.00','(-) EXAUSTÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens imóveis, devido à perda do valor, decorrente de sua exploração, de direitos cujo objeto sejam recursos minerais ou florestais ou bens aplicados nessa exploração.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.05.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA – BENS MÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens móveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.8.1.06.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA – BENS IMÓVEIS','Registra a diminuição do valor dos elementos do ativo imobilizado, bens Imóveis, devido à perda do valor do capital aplicado na aquisição de direitos de propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS MOVEIS','Registra os valores de ajuste ao valor recuperável de bens moveis, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.3.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE IMOBILIZADO - BENS IMÓVEIS','Registra os valores de ajuste ao valor recuperável de bens imóveis, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.0.0.00.00.00.00.00','INTANGÍVEL','Compreende os direitos que tenham por objeto bens incorpóreos destinados a manutenção da entidade ou exercidos com essa finalidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.1.0.00.00.00.00.00','SOFTWARES','Compreende os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.1.1.00.00.00.00.00','SOFTWARES- CONSOLIDAÇÃO','Registra os valores dos softwares pertencentes à entidade e não integrantes a um hardware, englobando os valores referentes à sua construção, implementação e instalação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.2.0.00.00.00.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS','Compreende os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação e direitos autorais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.2.1.00.00.00.00.00','MARCAS, DIREITOS E PATENTES INDUSTRIAIS- CONSOLIDAÇÃO','Registra os valores pertinentes a bens intangíveis, englobando os gastos com registro de marca, nome, invenções próprias, direitos de uso de comunicação, direitos autorais e direitos sobre recursos naturais, alem de desembolsos a terceiros por contratos de uso de marcas, patentes ou processos de fabricação (tecnologia). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.3.0.00.00.00.00.00','DIREITO DE USO DE IMÓVEIS','Compreende os valores pertinentes a bens intangíveis representados pela aquisição do direito de uso de imóveis.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.3.1.00.00.00.00.00','DIREITO DE USO DE IMOVEIS- CONSOLIDAÇÃO','Registra os valores pertinentes a bens intangíveis representados pela aquisição de direito de uso de imóveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.0.00.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.00.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA- CONSOLIDAÇÃO','Compreende a diminuição do valor do capital aplicado na aquisição de direitos da propriedade industrial ou comercial e quaisquer outros com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.01.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - SOFTWARES','Registra a diminuição do valor do capital aplicado em softwares, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.02.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - MARCAS, DIREITOS E PATENTES','Registra a diminuição do valor do capital aplicado em marcas, direitos e patentes, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.8.1.03.00.00.00.00','(-) AMORTIZAÇÃO ACUMULADA - DIREITO DE USO DE IMÓVEIS','Registra a diminuição do valor do capital aplicado em direito de uso de imóveis, pertencentes ao ativo intangível.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.0.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Conta de uso exclusivo para as empresas estatais. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.00.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - CONSOLIDAÇÃO','Compreende os valores de ajuste ao valor recuperável do ativo intangível, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.01.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - SOFTWARES','Registra os valores de ajuste ao valor recuperável do software pertencente ao ativo intangível, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.02.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL - MARCAS, DIREITOS E PATENTES','Registra os valores de ajuste ao valor recuperável das marcas, direitos e patentes, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '1.2.4.9.1.03.00.00.00.00','(-) REDUÇÃO AO VALOR RECUPERÁVEL DE INTANGÍVEL-DIREITO DE USO','Registra os valores de ajuste ao valor recuperável de direito de uso, quando esse for inferior ao valor liquido contábil. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.0.0.0.0.00.00.00.00.00','PASSIVO E PATRIMÔNIO LIQUIDO','Compreende as obrigações existentes da entidade oriundas de eventos passados de cuja liquidação se espera que resulte em fluxo de saída de recursos que incorporem benefícios econômicos ou serviços em potencial. Patrimônio líquido compreende a diferença entre o ativo e o passivo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.0.0.0.00.00.00.00.00','PASSIVO CIRCULANTE','Compreende as obrigações conhecidas e estimadas que atendam a qualquer um dos seguintes critérios: tenham prazos estabelecidos ou esperados dentro do ciclo operacional da entidade; sejam mantidos primariamente para negociação; tenham prazos estabelecidos ou esperados no curto prazo; sejam valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, independentemente do prazo de exigibilidade.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.0.0.00.00.00.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A CURTO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar,  benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.0.00.00.00.00.00','PESSOAL A PAGAR','Compreende as obrigações a curto prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.00.00.00.00.00','PESSOAL A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.00.00.00.00','PESSOAL A PAGAR DO EXERCICIO','Compreende as obrigações referentes a salarios ou remunerações, bem como beneficios aos quais o empregado ou servidor tenha direito, relativas ao exercicio atual.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.01.00.00.00','SALARIOS, REMUNERACOES E BENEFICIOS DO EXERCICIO','Registra as obrigações referentes a salarios ou remunerações, bem como beneficios aos quais o empregado ou servidor tenha direito, relativas ao exercicio atual.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.02.00.00.00','DÉCIMO TERCEIRO SALÁRIO','Registra as obrigações referentes ao décimo terceiro salário, geralmente apropriadas na base de 1/12 do valor bruto da folha de pagamento da unidade.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.03.00.00.00','FÉRIAS','Registra as obrigações referentes a férias, geralmente apropriadas como percentuais da folha de pagamento da unidade.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.04.00.00.00','LICENÇA- PRÊMIO','Registra os valores das obrigações constituídas com base em percentuais de salários, destinados ao pagamento de licença-prêmio.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.01.05.00.00.00','PARTICIPAÇÕES A EMPREGADOS','Registra os valores das obrigações do exercício constituídas para pagamento de participações a empregados.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.00.00.00.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','Compreende as obrigacoes referentes a salarios ou remuneracoes, bem como beneficios aos quais o empregado ou servidor tenha direito, relativas a exercicios anteriores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.01.00.00.00','SALÁRIOS, REMUNERAÇÕES E BENEFÍCIOS DE EXERCÍCIOS ANTERIORES','Registra as obrigações referentes a salários ou remunerações, bem como beneficios aos quais o empregado ou servidor tenha direito, relativas a exercicios anteriores.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.02.02.00.00.00','PARTICIPAÇÕES A EMPREGADOS - EXERC. ANTERIORES','Registra os valores das obrigações de exercícios anteriores constituídas para pagamento de participações a empregados.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.00.00.00.00','PRECATORIOS DE PESSOAL','Compreende os valores de precatorios de obrigações referentes a salarios ou remunerações, bem como a beneficios aos quais o empregado ou servidor tenha direito.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.01.00.00.00','PRECATORIOS DE PESSOAL DO EXERCICIO','Registra os valores de precatorios de obrigações referentes a salarios ou remunerações, bem como a beneficios aos quais o empregado ou servidor tenha direito, do exercicio.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.02.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  ANTES DE 05/05/2000','Registra os valores de precatorios de obrigações referentes a salarios ou remunerações, bem como a beneficios aos quais o empregado ou servidor tenha direito, anteriores a 05/05/2000 (LRF).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.03.00.00.00','PRECATÓRIOS DE PESSOAL DE EXERCÍCIOS ANTERIORES – A PARTIR DE 05/5/2000','Registra os valores de precatorios de obrigações referentes a salários ou remunerações, bem como a beneficios aos quais o empregado ou servidor tenha direito, de exercicios anteriores e a partir de 05/05/2000 (LRF).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.1.1.03.04.00.00.00','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de pessoal do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.0.00.00.00.00.00','BENEFICIOS PREVIDENCIARIOS A PAGAR','Compreende as obrigações a curto prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.01.00.00.00.00','BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas no exercicio.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.02.00.00.00.00','BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões, incorridas em exercicios anteriores.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.00.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','Compreende as obrigações referentes a precatorios de proventos de aposentadoria, reformas ou pensões.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.01.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DO EXERCICIO','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, do exercício.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.02.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTES DE 05/05/2000','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões, anteriores a 05/05/2000 (LRF).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.1.03.03.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','Registra as obrigações referentes a precatórios de proventos de aposentadoria, reformas ou pensões de exercícios anteriores e a partir de 05/05/2000 (LRF).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.2.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTRA','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) do mesmo ente.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.3.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER UNIÃO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.4.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER ESTADO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.2.5.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - INTER MUNICIPIO','Registra as obrigações referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.0.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a curto prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.01.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DO EXERCICIO','Registra as obrigações relativas aos benefícios assistenciais administrados pela previdência social liquidados no exercicio e ainda não pagos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.3.1.02.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','Registra os valores relativos aos benefícios assistenciais administrados pela previdência social, de exercícios anteriores.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.0.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a curto prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.07.00.00.00.00','CONTRIBUICAO A ENTIDADES DE PREVIDENCIA PRIVADA E COMPLEMENTAR','Registra as obrigações relativas à entidades de previdência privada e complementar, inclusive à entidades de previdência privada e assitência médico-odontologica.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.08.00.00.00.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.1.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - CONSOLIDAÇÃO','Registra os valores relativos aos encargos sociais de ocorrência permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação nao esteja prevista em contas especificas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.04.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','Registra os valores relativos as obrigações com regimes proprios de   previdência, não identificados como previdência privada ou complementar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.07.00.00.00.00','SALÁRIO EDUCAÇÃO','REGISTRA OS VALORES RELATIVOS AS OBRIGAÇÕES DAS EMPRESAS OU INSTITUIÇÕES, RESULTANTES DO CALCULO DO SALÁRIO EDUCAÇÃO, COM BASE NO MONTANTE DA FOLHA DE PAGAMENTO DE SALÁRIOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.08.00.00.00.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.00.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS','Compreende os valores relativos a obrigação de repasse para cobertura de deficit do RPPS não repassado dentro do mês de competencia.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.01.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS - DO EXERCICIO','Registra os valores relativos a obrigação de repasse para cobertura de deficit do RPPS referentes ao exercicio em curso, não repassado dentro do mês de competencia.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.21.02.00.00.00','OBRIGAÇÃO DE REPASSE PARA COBERTURA DE DEFICIT DO RPPS - DO EXERCICIO ANTERIOR','Registra os valores relativos a obrigação de repasse para cobertura de deficit do RPPS referentes ao exercicio anterior, não repassado dentro do mês de competencia.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.00.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO','Compreende os valores relativos a obrigação de repasse concedido ao RPPS para pagamento de aposentadorias e pensões de  responsabilidade da fonte tesouro não repassadas dentro do mês de competencia.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.01.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO - DO EXERCICIO','Registra os valores relativos a obrigação de repasse concedido ao RPPS para pagamento de aposentadorias e pensões de responsabilidade da fonte tesouro referentes ao exercicio, não repassadas dentro do mês de competencia.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.22.02.00.00.00','OBRIGAÇÃO DE REPASSE CONCEDIDO AO RPPS PARA PAGAMENTO DE APOSENTADORIAS E PENSOES DA FONTE TESOURO - DO EXERCICIO ANTERIOR','Registra os valores relativos a obrigação de repasse concedido ao RPPS para pagamento de aposentadorias e pensões de responsabilidade da fonte tesouro referentes ao exercicio anterior, não repassadas dentro do mês de competencia.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.00.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR','Compreende os valores das obrigações patronais devidas pelo ente para o   plano de seguridade social do servidor liquidadas e  ainda não pagas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.01.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR - DO EXERCICIO','Registra os valores das obrigações patronais devidas pelo ente para o plano de seguridade  social do servidor liquidadas e  ainda não pagas durante o exercicio.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.23.02.00.00.00','OBRIGAÇÕES PATRONAIS A RECOLHER - PLANO DE SEGURIDADE  SOCIAL DO SERVIDOR - DO EXERCICIO ANTERIOR','Registra os valores das obrigações patronais devidas pelo ente para o  plano de seguridade  social do servidor liquidadas e ainda não pagas referentes ao exercicio anterior.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.2.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTRA','Registra os valores relativos aos encargos sociais de ocorrencia permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas especificas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.00.00.00.00','INSS A PAGAR','Compreende os valores relativos as contribuições a previdencia social,  incidentes sobre salarios e remunerações pagos e sobre serviços de terceiros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.01.00.00.00','INSS - CONTRIBUIÇÃO SOBRE SALÁRIOS E REMUNERAÇÕES - DO EXERCICIO','Registra os valores relativos as contribuições incidentes sobre  salarios pagos ou creditados  devidos por encargos do empregador (unidade) a previdencia social. Referentes ao exercicio.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.02.00.00.00','INSS - DEBITO PARCELADO','Registra os valores de debito parcelado que se referem ao não recolhimento de obrigações da folha de pagamento junto ao INSS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.03.00.00.00','INSS - CONTRIBUICAO SOBRE SERVICOS DE TERCEIROS OU CONTRIBUINTES AVULSOS','Compreende os valores relativos as contribuições incidentes sobre serviços prestados por terceiros ou contribuintes avulsos.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.04.00.00.00','INSS – FUNDO DA PREVIDÊNCIA E ASSISTÊNCIA SOCIAL FPAS','REGISTRA OS COMPROMISSOS PERANTE O FUNDO DA PREVIDENCIA E ASSISTENCIA SOCIAL (FPAS).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.01.05.00.00.00','INSS - DE EXERCICIOS ANTERIORES','Registra os valores relativos as contribuições incidentes sobre  salarios pagos ou creditados  devidos por encargos do empregador (unidade) a previdencia social. Referentes a exercicios anteriores.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.04.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','Compreende os valores relativos as obrigações com Regimes Proprios de Previdencia, não identificados como previdencia privada ou complementar.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.04.02.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.06.00.00.00.00','FGTS','Compreende os valores dos encargos sociais a recolher ao FGTS, gerados por pagamentos de salarios.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.08.00.00.00.00','CONTRIBUICAO A ENTIDADES DE ASSISTENCIA MEDICO-ODONTOLOGICA','Compreende os valores dos encargos sociais a recolher representados pela contribuição patronal a entidades de assistencia medico-odontologica.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.3.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.04.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','Compreende os valores relativos as obrigações com Regimes Proprios de Previdencia, não identificados como previdencia privada ou complementar.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.04.02.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.06.00.00.00.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.08.00.00.00.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.4.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS - INTER ESTADO','Registra os valores relativos aos encargos sociais de ocorrencia permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificação não esteja prevista em contas especificas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Compreende as obrigações das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.04.00.00.00.00','CONTRIBUICAO A REGIME PROPRIO DE PREVIDENCIA (RPPS)','Compreende os valores relativos as obrigações com Regimes Proprios de Previdência, não identificados como previdencia privada ou complementar.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.04.02.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA – PESSOAL REQUISITADO DE OUTROS ENTES','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES COM REGIMES PROPRIOS DE PREVIDENCIA, DE PESSOAL REQUISITADO DE OUTROS ENTES DA FEDERACAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.05.00.00.00.00','PREVIDÊNCIA SOCIAL RURAL','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES DAS EMPRESAS OU INSTITUICOES, RESULTANTES DO CALCULO DA PREVIDENCIA SOCIAL RURAL.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.06.00.00.00.00','FGTS','REGISTRA OS VALORES DOS ENCARGOS SOCIAIS A RECOLHER AO FGTS, GERADOS POR PAGAMENTOS DE SALARIOS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.08.00.00.00.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS - DÉBITO PARCELADO','REGISTRA A APROPRIAÇÃO E MOVIMENTAÇÃO DO VALOR REFERENTE A DÉBITOS PARCELADOS JUNTO AO INSS OU ENTIDADE DE PREVIDÊNCIA, REFERENTE AO NÃO RECOLHIMENTO DE OBRIGAÇÕES DE FOLHA DE PAGAMENTO E OUTROS AFINS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.1.4.5.98.00.00.00.00','OUTROS ENCARGOS SOCIAIS','REGISTRA OS VALORES RELATIVOS AOS ENCARGOS SOCIAIS DE OCORRENCIA PERMANENTE OU EVENTUAL QUE TENHAM GERADO OBRIGACOES PARA A ENTIDADE, CUJA CLASSIFICACAO NAO ESTEJA PREVISTA EM CONTAS ESPECIFICAS.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.0.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO','Compreende as obrigações financeiras externas e internas da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.0.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.01.00.00.00.00','EMPRÉSTIMOS INTERNOS - EM TÍTULOS','Compreende os valores das operações de créditos internas decorrentes da emissão de titulos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.01.01.00.00.00','DÍVIDA MOBILIÁRIA','Registra os valores exigíveis, decorrentes da emissão de títulos da dívida mobiliária.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.01.02.00.00.00','(-) DESÁGIO DE TÍTULOS','Registra os valores relativos a deságio ocorridos em títulos.','D','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.01.98.00.00.00','OUTROS TÍTULOS - EMPRÉSTIMOS INTERNOS','Registra os valores decorrentes da colocação no mercado de títulos, para os quais não haja contas específicas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.02.00.00.00.00','EMPRESTIMOS INTERNOS -  EM CONTRATOS','Compreende os valores das operações de credito internas em contratos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.02.01.00.00.00','CONTRATOS DE EMPRÉSTIMOS INTERNOS ','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.02.05.00.00.00','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.02.98.00.00.00','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.1.03.00.00.00.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO – INTERNO - INTER OFSS - UNIÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','Registra o reconhecimento dos empréstimos decorrentes de títulos mobiliários com vencimento até o termino do exercício seguinte.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.02.00.00.00.00','EMPRESTIMOS INTERNOS -  EM CONTRATOS','Compreende os valores das operações de credito internas em contratos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.02.01.00.00.00','CONTRATOS DE EMPRÉSTIMOS INTERNOS ','Registra os valores em liquidação, decorrentes de contratos de empréstimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.02.05.00.00.00','ANTECIPAÇÃO DA RECEITA ORÇAMENTÁRIA','Registra os valores referentes a operações de crédito por antecipação de receita destinada a atender insuficiência de caixa durante o exercício financeiro, devendo cumprir as exigências mencionadas no art. 32 da lei complementar nº 101, publicada em 04/05/2000 e aquelas previstas no art. 38 da referida lei.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.02.98.00.00.00','OUTROS CONTRATOS - EMPRÉSTIMOS INTERNOS','Registra os valores das operações de crédito internas em contratos, para as quais não haja contas específicas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.3.03.00.00.00.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - INTERNO','Compreende os empréstimos a curto prazo - interno - não enquadrados nas classificações anteriores.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.4.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO - INTER OFSS - ESTADO','Registra os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.1.5.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Registra os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.0.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.00.00.00.00.00','EMPRÉSTIMOS A CURTO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.01.00.00.00.00','EMPRÉSTIMOS EXTERNOS  - EM TÍTULOS','Registra os valores das operações de crédito externas decorrentes da emissão de títulos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.02.00.00.00.00','EMPRESTIMOS EXTERNOS -  EM CONTRATOS','Registra os valores das operações de credito externas em contratos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.2.1.03.00.00.00.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Registra os demais valores das operações de credito externos em contratos não compreendidos nas contas acima.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.0.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.00.00.00.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.02.00.00.00','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.03.00.00.00','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.01.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.1.02.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e beneficios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.  ','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO- INTERNO -INTER OFSS - UNIÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.00.00.00.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.02.00.00.00','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.03.00.00.00','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.01.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.3.02.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e beneficios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.  ','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - ESTADO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.00.00.00.00','FINANCIAMENTOS INTERNOS','Compreende os valores exigíveis decorrentes de financiamentos internos a curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos internos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.02.00.00.00','FINANCIAMENTOS PARA CONSTRUÇÃO DE IMÓVEIS HABITACIONAIS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para construção de imóveis.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.03.00.00.00','FINANCIAMENTO DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo contraídos para o capital de giro.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.01.98.00.00.00','OUTROS FINANCIAMENTOS INTERNOS','Registra os valores exigíveis, decorrentes de financiamentos internos a curto prazo para os quais não haja contas específicas.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.4.02.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.3.5.00.00.00.00.00','FINANCIAMENTOS A CURTO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','Registra as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no curto prazo.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.0.00.00.00.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.00.00.00.00.00','FINANCIAMENTO A CURTO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no curto prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.01.00.00.00.00','FINANCIAMENTOS EXTERNOS','Compreende os valores exigíveis decorrentes de financiamentos externos a curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.01.01.00.00.00','FINANCIAMENTOS DO ATIVO PERMANENTE','Registra os valores exigíveis decorrentes de financiamentos externos a curto prazo, contraídos para aquisição de bens do ativo permanente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.01.02.00.00.00','FINANCIAMENTOS DE CAPITAL DE GIRO','Registra os valores exigíveis, decorrentes de financiamentos externos a curto prazo contraídos para o capital de giro.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.4.1.02.00.00.00.00','FINANCIAMENTOS EXTERNOS POR ARRENDAMENTO FINANCEIRO A CURTO PRAZO','Registra as obrigações a curto prazo referentes a financiamentos externos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de emprestimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de emprestimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de financiamentos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - UNIÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de emprestimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de emprestimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de financiamentos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.3.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - ESTADO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de emprestimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de emprestimos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de financiamentos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.4.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.5.5.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','Registra os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A CURTO PRAZO – EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a curto prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de emprestimos externos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS EXTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de emprestimos externos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de financiamentos externos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.6.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de financiamentos externos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO - CONSOLIDAÇÃO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.3.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - UNIÃO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.4.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFFS - ESTADO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.8.5.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS – MUNICÍPIO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.9.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.2.9.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR- CONSOLIDAÇÃO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a curto prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.0.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR A CURTO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR NACIONAIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.00.00.00.00','FORNECEDORES NACIONAIS','Compreende os valores a pagar aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.01.00.00.00','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.02.00.00.00','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.03.00.00.00','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.01.99.00.00.00','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.00.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS','Compreende as obrigações referentes a precatórios de fornecedores nacionais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.01.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','Registra as obrigações referentes a precatórios de fornecedores nacionais do exercicio.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.02.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – ANTERIORES A 05/5/2000','Registra os valores relativos a precatórios de contas a pagar a fornecedores nacionais de exercícios anteriores, anteriores a 05/05/2000 (lei de responsabilidde fiscal).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.03.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS DE EXERCÍCIOS ANTERIORES – A PARTIR DE 05/5/2000','Registra os valores relativos a precatórios de contas a pagar a fornecedores nacionais de exercícios anteriores, a partir de 05/05/2000 (lei de responsabilidde fiscal).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.02.04.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de fornecedores a pagar do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.00.00.00.00','CONTAS A PAGAR CREDORES NACIONAIS','Compreende os valores a pagar aos credores nacionais decorrentes do fornecimento de bens/materiais e da prestação de contas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.01.00.00.00','CONTAS NÃO FINANCIADAS A PAGAR','Registra os valores não financiados, ou seja, em uma única parcela, de contas a pagar','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.02.00.00.00','CONTAS FINANCIADS A PAGAR','Registra os valores financiados de contas a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.03.00.00.00','PARCELAMENTO DE CONTAS A PAGAR','Registra o parcelamento de dívidas com contas a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.03.99.00.00.00','DEMAIS CONTAS A PAGAR','Registra os valores de demais contas a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.00.00.00.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS','Compreende as obrigações referentes a precatórios de contas a pagar - credores nacionais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.01.00.00.00','PRECATÓRIOS DE  CONTAS A PAGAR - CREDORES NACIONAIS DO EXERCICIO','Registra as obrigações referentes a precatórios de contas a pagar a credores nacionais do exercício.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.02.00.00.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000 ','Registra os valores relativos a precatórios de contas a pagar a credores nacionais de exercícios anteriores, anteriores a 05/05/2000 (lei de responsabilidde fiscal).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.03.00.00.00','PRECATÓRIOS DE CONTAS A PAGAR - CREDORES NACIONAIS DE EXERCICIOS ANTERIORES - A PARTIR DE 05/05/2000 ','Registra os valores relativos a precatórios de contas a pagar a credores nacionais de exercícios anteriores, a partir de 05/05/2000 (lei de responsabilidde fiscal).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.1.1.04.04.00.00.00','PRECATÓRIOS DE CONTAS A PAGAR VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de contas a pagar do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.0.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.00.00.00.00.00','FORNECEDORES E CONTAS A PAGAR ESTRANGEIROS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, bem como as obrigações decorrentes do fornecimento de utilidades e da prestação de serviços, tais como de energia elétrica, água, telefone, propaganda, alugueis e todas as outras contas a pagar com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.00.00.00.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos fornecedores estrangeiros de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.01.00.00.00','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.02.00.00.00','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.03.00.00.00','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.01.99.00.00.00','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.00.00.00.00','CONTAS A PAGAR - CREDORES ESTRANGEIROS A CURTO PRAZO','Compreende os valores a pagar aos credores estrangeiros decorrentes do fornecimento de bens/materiais e da prestação de contas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.01.00.00.00','CONTAS NÃO FINANCIADAS A PAGAR','Registra os valores não financiados, ou seja, em uma única parcela, de contas a pagar','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.02.00.00.00','CONTAS FINANCIADS A PAGAR','Registra os valores financiados de contas a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.03.00.00.00','PARCELAMENTO DE CONTAS A PAGAR','Registra o parcelamento de dívidas com contas a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.3.2.1.02.99.00.00.00','DEMAIS CONTAS A PAGAR','Registra os valores de demais contas a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.0.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM A UNIÃO- CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.02.00.00.00.00','IRPJ A RECOLHER','Registra o valor das obrigações a recolher relativas ao imposto de renda pessoa juridica.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.11.00.00.00.00','PIS/PASEP A RECOLHER','Registra o valor das obrigações a recolher relativas ao programa de integração social (PIS) e programa de formacao do patrimonio do servidor publico (PASEP).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.12.00.00.00.00','TRIBUTOS FEDERAIS RENEGOCIADOS','Registra os valores exigiveis a curto prazo devidos pela entidade relativos a tributos federais que tenham sido renegociados.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.13.00.00.00.00','RECURSOS FISCAIS - DARF A EMITIR','Registra o valor dos creditos fiscais recebidos pelas entidades para posterior recolhimento ao tesouro nacional, ou seja, valores a serem recolhidos por meio de DARF. Registra os valores exigiveis a curto prazo provenientes da retencao de tributos e contribuições pelas entidades para posterior recolhimento ao tesouro nacional, por meio de documento de arrecadacao de receitas federais (DARF).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.1.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES FEDERAIS  A RECOLHER','Registra os valores exigiveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao tesouro nacional, para os quais não haja contas especificas.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS ESTADOS- CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência estadual com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.00.00.00.00','ICMS A RECOLHER','Compreende o valor das obrigações exigiveis em funcao das vendas de mercadorias e serviços sobre os quais incida imposto sobre a circulação de mercadorias e prestação de serviços (ICMS), sujeitos a compensações com os créditos obtidos em compras de mercadorias e serviços, conforme sistematica de apuração deste imposto ou sobre mercadorias de terceiros entregues para deposito.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.01.00.00.00','ICMS A RECOLHER - SOBRE MERCADORIAS PARA REVENDA','Registra o valor das obrigações exigiveis em funcao das vendas de mercadorias e serviços sobre os quais incida imposto sobre a circulacao de mercadorias e prestacao de serviços (ICMS), sujeitas a compensações com os créditos obtidos em compras de mercadorias e serviços, conforme sistematica de apuração deste imposto.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.01.02.00.00.00','ICMS A RECOLHER - SOBRE MERCADORIAS DE TERCEIROS PARA DEPOSITO ','Registra o valor das obrigações exigiveis em funcao da entrada de mercadorias de terceiros entregues a unidade para deposito em armazem.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.02.00.00.00.00','IPVA A RECOLHER','Registra o valor das obrigacoes exigiveis relativas ao imposto sobre a propriedade de veiculos automotores (IPVA).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.03.00.00.00.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos relativos a tributos que foram renegociados.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.05.00.00.00.00','TAXA DE ATENDIMENTO CONTRA INCÊNDIO','Registra o valor das Obrigações junto ao Governo Estadual, referente ao pagamento da Taxa de Atendimento Contra Incêndio.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.06.00.00.00.00','TAXA DE LICENCIAMENTO ANUAL DE VEICULOS','Registra o valor das obrigações junto ao governo estadual, referente ao pagamento da taxa de licenciamento anual de veiculos, decorrente do serviço de licenciamento de veiculos automotores.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.07.00.00.00.00','RECURSOS FISCAIS ESTADUAIS','Registra o valor dos creditos fiscais oriundos de recebimentos de tributos estaduais cujo recolhimento é realizado por meio de DAR. Registra os valores exigiveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao governo estadual, por meio de documento de arrecadacao (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.08.00.00.00.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigiveis a curto prazo referentes a taxa de licenciamento ambiental.                                                              ','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.2.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES ESTADUAIS A RECOLHER','Registra os compromissos exigiveis a curto prazo, decorrentes da incidencia de tributos para os quais não haja contas especificas. Registra os valores exigiveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao governo estadual, para os quais não haja contas especificas.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A CURTO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com os tributos de competência municipal com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.01.00.00.00.00','ISS A RECOLHER','Registra o valor das obrigações junto ao governo municipal, relativas ao imposto sobre serviços de qualquer natureza (ISS)  em que a propria unidade seja a prestadora  do serviço.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.02.00.00.00.00','IPTU/TLP A RECOLHER','Registra o valor  das obrigações junto ao governo municipal, relativas ao imposto sobre a propriedade predial e territorial urbana (IPTU) e taxa de limpeza publica (TLP).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.03.00.00.00.00','TRIBUTOS MUNICIPAIS RENEGOCIADOS','Registra os valores devidos pela unidade relativos a tributos que  foram renegociados.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.04.00.00.00.00','CONTRIBUICAO PARA O CUSTEIO DE ILUMINAÇÃO PUBLICA A RECOLHER','Registra o valor das obrigações junto ao governo municipal referentes a contribuição para custeio de iluminação publica.(art.149-A da Constituição Federal)','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.06.00.00.00.00','RECURSOS FISCAIS MUNICIPAIS','Registra os valores exigiveis a curto prazo provenientes da retenção de tributos e contribuições pelas entidades para posterior recolhimento ao governo municipal, por meio de documento de arrecadação (DAR).','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.07.00.00.00.00','TAXA DE LICENCIAMENTO AMBIENTAL','Registra os compromissos exigiveis a curto prazo referentes a taxa de licenciamento ambiental.                       ','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.08.00.00.00.00','TAXA DE INSPEÇÃO VEICULAR','Registra o valor das obrigações junto ao governo municipal referentes a taxa de inspeção veicular.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.4.3.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUICOES MUNICIPAIS A RECOLHER','Registra os compromissos exigiveis, decorrentes da incidencia de tributos para os quais não haja  contas especificas.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.0.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES','Compreende os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.3.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - UNIÃO','Registra os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.4.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - ESTADO','Registra os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.5.0.5.00.00.00.00.00','OBRIGAÇÕES DE REPARTIÇÃO A OUTROS ENTES - INTER OFSS - MUNICÍPIO','Registra os valores arrecadados de impostos e outras receitas a serem repartidos aos estados, Distrito Federal e Municípios. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.0.0.00.00.00.00.00','PROVISÕES A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.0.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no curto prazo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.01.00.00.00.00','PROVISAO PARA INDENIZAÇÕES TRABALHISTAS','Registra os valores das provisões constituidas visando o pagamento de indenizações trabalhistas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.1.1.02.00.00.00.00','PROVISAO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','Registra os valores das provisões constituidas visando o pagamento de dissidios coletivos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.0.00.00.00.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.00.00.00.00.00','PROVISÕES PARA RISCOS FISCAIS A CURTO PRAZO - CONSOLIDAÇÃO','Registra os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.00.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autos de infração.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.01.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO NÃO RECORRIDOS','Registra os valores relativos a provisão referente a autos de infração não recorridos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.01.02.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO RECORRIDOS','Registra os valores relativos a  provisão referente  a autos de infração recorridos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS – ESFERA JUDICIAL','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações ficais - esfera judicial.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.01.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','Registra os valores relativos a  provisão referente a autuações fiscais na esfera judicial não recorridas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.3.1.02.02.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','Registra os valores relativos a  provisão referente a autuações fiscais na esfera judicial recorridas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.0.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.1.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A CURTO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.4.1.01.00.00.00.00','PROVISÃO PARA INDENIZAÇÕES CÍVEIS','Registra os valores relativos a  provisão para  pagamento de indenizações cíveis.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.0.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.3.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - UNIÃO','Registra os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.4.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - ESTADO','Registra os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.5.5.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A CURTO PRAZO - INTER OFSS - MUNICÍPIO','Registra os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Na arrecadação, esta provisão será revertida em conta de passivo referente a obrigações de repartição a outros entes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município. Na arrecadação, esta provisão será revertida em conta específica de passivo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.6.0.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.6.1.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A CURTO PRAZO- CONSOLIDAÇÃO','Registra os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.9.0.00.00.00.00.00','OUTRAS PROVISÕES A CURTO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com prazo provável no curto prazo, não classificadas anteriormente neste plano de contas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.7.9.1.00.00.00.00.00','OUTRAS PROVISÕES A CURTO PRAZO - CONSOLIDAÇÃO','Registra os demais passivos de prazo ou de valor incertos, com prazo provável no curto prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.0.0.00.00.00.00.00','DEMAIS OBRIGAÇÕES A CURTO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, com vencimento no curto prazo, inclusive os precatórios decorrentes dessas obrigações, com vencimento no curto prazo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.1.0.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.1.1.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES- CONSOLIDAÇÃO','Registra as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.2.0.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS','Compreende os valores exigíveis no curto prazo, provenientes de danos a terceiros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.2.1.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS - CONSOLIDAÇÃO','Registra os valores exigíveis no curto prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.3.0.00.00.00.00.00','ARRENDAMENTO OPERACIONAL A PAGAR','Compreende as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.3.1.00.00.00.00.00','ARRENDAMENTO OPERACIONAL A PAGAR- CONSOLIDAÇÃO','Registra as obrigações a curto prazo referentes a arrendamentos mercantis, nos quais não são transferidos ao arrendador os riscos e benefícios inerentes a propriedade, não havendo a possibilidade de opção de compra do bem arrendado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.4.0.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.4.1.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A CURTO PRAZO- CONSOLIDAÇÃO','Registra os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.5.0.00.00.00.00.00','DIVIDENDOS A PAGAR','Compreende os dividendos aprovados pela assembleia geral a serem pagos aos acionistas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.5.1.00.00.00.00.00','DIVIDENDOS A PAGAR- CONSOLIDAÇÃO','Registra os dividendos aprovados pela assembleia geral a serem pagos aos acionistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.0.00.00.00.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.00.00.00.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no curto prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.00.00.00.00','CONSIGNACOES ','Compreende os valores entregues em confiança ou em consignações, geralmente retidos em folha de pagamento de empregados ou servidores ou nos pagamentos referentes a compras de bens e serviços. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.01.00.00.00','RPPS - RETENÇÕES SOBRE VENCIMENTOS E VANTAGENS','Registra o valor das retenções procedidas em pagamentos de servidores a ser recolhido ao RPPS do servidor.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.02.00.00.00','INSS','Registra o valor das retenções procedidas em pagamentos de empregados regidos pela consolidação das leis do trabalho (CLT) e agentes politicos ou de  serviços de terceiros, a ser recolhido ao instituto nacional do seguro social/previdencia social.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.03.00.00.00','ENCARGOS SOCIAIS - OUTRAS ENTIDADES','Registra o valor a ser recolhido a outras entidades, em  função de dispositivos legais com as quais a entidade  mantenha convenio de arrecadação direta.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.04.00.00.00','IMPOSTO SOBRE A RENDA RETIDO NA FONTE - IRRF','Compreende os valores referentes as retenções na fonte, pela entidade, do imposto sobre a renda, relativas as importancias pagas a terceiros  ou creditadas a servidores ou empregados, sobre as quais incida o referido imposto.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.05.00.00.00','INDENIZACOES E RESTITUICOES','Registra os valores relativos as indenizações e restituições de tributos com autorizações concedidas, porem não devolvidas aos legitimos credores pela unidade.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.06.00.00.00','IMPOSTOS E CONTRIBUICOES DIVERSOS','Registra os valores referentes as retenções na fonte, pela unidade, de impostos e contribuições diversos, relativas as importancias pagas   a terceiros, sobre os quais incidam os referidos tributos.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.07.00.00.00','ICMS','REGISTRA OS VALORES RELATIVOS AO IMPOSTO SOBRE A CIRCULACAO DE MERCADORIAS E SERVIÇOS RETIDOS POR FOCA DE LEGISLACAO OU POR ACORDO ENTRE AS PARTES ENVOLVIDAS NA TRANSACAO EM CONSIGNAÇÕES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.08.00.00.00','ISS','REGISTRA OS VALORES DO IMPOSTO SOBRE SERVIÇOS RETIDOS EM CONSIGNAÇÕES POR FORCA DE LEGISLACAO, CIRCUNSTANCIAS OU ACORDO ENTRE AS PARTES ENVOLVIDOS NA TRANSACAO, EM SITUAÇÕES QUE A ENTIDADE COMO PARTE  CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.09.00.00.00','OUTROS TRIBUTOS ESTADUAIS E MUNICIPAIS','REGISTRA OS VALORES EM CONSIGNACAO RELATIVOS A OUTROS TRIBUTOS A SEREM REPASSADOS AOS ESTADOS E MUNICIPIOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.10.00.00.00','PENSAO ALIMENTICIA','REGISTRA OS VALORES DAS RETENCOES EM FOLHA PROCEDIDAS EM PAGAMENTOS A EMPREGADOS OU A SERVIDORES, AUTORIZADOS POR ESSES OU POR DETERMINACAO JUDICIAL, A TITULO DE PENSAO ALIMENTICIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.11.00.00.00','PLANOS DE PREVIDENCIA E ASSISTENCIA MEDICA','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DO PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES DE PREVIDENCIA E ASSISTENCIA MEDICA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.12.00.00.00','ASSISTENCIA A SAUDE -ADMINISTRAÇÃO PROPRIA','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, QUE SERAO ADMINISTRADOS PELO PROPRIO ORGAO/ENTIDADE PARA ASSISTENCIA A SAUDE DE SEUS SERVIDORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.13.00.00.00','RETENCOES - ENTIDADES REPRESENTATIVAS DE CLASSES','REGISTRA OS DESCONTOS EFETUADOS EM FOLHAS DE PAGAMENTO DE PESSOAL PARA POSTERIOR RECOLHIMENTO A FAVOR DE INSTITUICOES REPRESENTATIVAS DE CLASSE.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.14.00.00.00','RETENCOES - PLANOS DE SEGUROS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES AS CONTRIBUIÇÕES A PLANOS DE SEGURO DE VIDA EM GRUPO.CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.15.00.00.00','RETENCOES - EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA OS VALORES DAS RETENCOES EFETUADAS EM FOLHA DE PAGAMENTO DOS SERVIDORES REFERENTES A EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS POR TERCEIROS, BEM COMO RETENCOES DE PARCELAS DE CONSORCIOS E SEGURADOS DO INSS.CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.16.00.00.00','RETENÇÃO RELATIVA A VALE TRANSPORTE','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM RE-PASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE VALE-TRANSPORTE. TRATA-SE DOS VALORES REFERENTES AOS 6% INSTITUIDOS PELO ARTIGO 9º DO DECRETO Nº 95.247/1987 E SUAS ALTERAÇÕES.CONTRATANTE, ATUE COMO SUBSTITUTA TRIBUTÁRIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.17.00.00.00','RETENÇÃO RELATIVA A VALE ALIMENTAÇÃO','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDAS PELA ENTIDADE A SEREM REPASSADOS PARA AS EMPRESAS PRESTADORAS DOS SERVIÇOS DE FORNECIMENTO DE CARTAO-ALIMENTACAO/REFEICAO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.01.99.00.00.00','OUTROS CONSIGNATARIOS','REGISTRA OS VALORES DAS CONSIGNAÇÕES RETIDOS PELA ENTIDADE, OU ENTREGUES A ESSA, EM CONFIANCA, POR DIVERSOS CONTRIBUINTES SUJEITOS A RECOLHIMENTOS E OU PAGAMENTOS AOS FAVORECIDOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.02.00.00.00.00','GARANTIAS','REGISTRA A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.00.00.00.00','DEPOSITOS JUDICIAIS','Compreende os valores de obrigacoes, decorrentes de depositos recebidos por determinacao judicial e depositos para recursos judiciais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.01.00.00.00','DEPOSITOS RECEBIDOS POR DETERMINACAO JUDICIAL','Registra os valores de obrigacoes decorrentes de depositos  a efetuar pela entidade por determinacao judicial.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.03.02.00.00.00','DEPOSITOS PARA RECURSOS JUDICIAIS','Registra os valores relativos as obrigações contraidas por depositos efetuados a favor da entidade destinados ao exercicio de direito de recurso junto a Justica e encontrados vinculados em contas bancarias.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.00.00.00.00','DEPOSITOS NAO JUDICIAIS','Compreende os valores de obrigacoes, decorrentes de depositos recebidos, exceto depositos judiciais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.01.00.00.00','DEPOSITOS E CAUCOES','Registra os valores das obrigacoes exigiveis referentes a depositos e/ou caucoes a efetuar pela entidade vinculados a contratos ou outros instrumentos, para garantias de operacoes especificas.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.02.00.00.00','DEPOSITOS ESPECIAIS','Registra o valor relativo a retenções de depositos vinculados a restituir no curso do exercicio seguinte a entidade transferidora, decorrente  de contratos ou  instrumentos congeneres, convenção, acordo ou ajuste.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.03.00.00.00','DEPOSITOS DE TERCEIROS','Registra o valor relativo a retenções de depositos vinculados a restituir no curso do exercicio seguinte a entidade transferidora, decorrente  de contratos ou  instrumentos congeneres, convenção, acordo ou ajuste.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.04.00.00.00','DEPOSITOS DE VEICULOS ALIENAVEIS','Registra o valor relativo a retenções de depositos vinculados a restituir no curso do exercicio seguinte a entidade transferidora, decorrente  de contratos ou  instrumentos congeneres, convenção, acordo ou ajuste.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.05.00.00.00','DEPOSITOS A TRANSFERIR','Registra o valor relativo a retenções de depositos vinculados a restituir no curso do exercicio seguinte a entidade transferidora, decorrente  de contratos ou  instrumentos congeneres, convenção, acordo ou ajuste.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.06.00.00.00','DEPOSITOS DE TERCEIROS','Registra os valores relativos aos depositos de terceiros  de  diversas origens, inclusive desconhecidas, não reclamados  pelos credores.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.04.99.00.00.00','OUTROS DEPOSITOS','Registra compromissos exigiveis ate o termino do  exercicio  seguinte, decorrentes de recebimentos a titulo de depositos, para os quais não haja contas especificas.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.8.1.99.00.00.00.00','OUTROS VALORES RESTITUIVEIS','Registra outros valores restituiveis em posse da entidade, no papel de fiel depositaria.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.0.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO - CONSOLIDAÇÃO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES','Compreende as obrigações relativas a indenizações e restituições.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.01.00.00.00','INDENIZACOES A SERVIDORES','Registra o valor das despesas a serem indenizadas decorrentes de liquidação de pagamentos efetuados com auxilio - alimentação bem como  reembolsos de gastos realizados pelos servidores custeados pelo programa de assistencia a saude e beneficios sociais do orgão responsavel.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.02.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DO EXERCICIO','Registra os valores relativos as diversas indenizações e restituições no exercicio.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.01.03.00.00.00','INDENIZACOES E RESTITUICOES DIVERSAS DE EXERCICIOS ANTERIORES','Registra os valores relativos as diversas indenizações e restituições de exercicios anteriores.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.02.00.00.00.00','DIARIAS A PAGAR','Registra os valores relativos as diarias a pagar.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.03.00.00.00.00','SUPRIMENTOS DE FUNDOS A PAGAR','Registra os valores relativos aos suprimentos de fundos a pagar.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.00.00.00.00','CONVENIOS A PAGAR','Compreende os valores a pagar retidos a titulo de convenio.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.01.00.00.00','CONVENIOS A PAGAR DO EXERCICIO','Registra os valores a pagar referentes a convenios firmados no  exercicio.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.05.02.00.00.00','CONVENIOS A PAGAR DE EXERCICIOS ANTERIORES','Registra os valores a pagar referentes a convenios firmados em  exercicios anteriores.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.09.00.00.00.00','TERMOS DE PARCERIA A PAGAR','COMPREENDE OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE PARCERIA, QUE E UM INSTRUMENTO JURIDICO DE FOMENTO E GESTAO DAS RELACOES DE PARCERIA ENTRE ORGANIZACOES DO TERCEIRO SETOR - QUALIFICADAS COMO ORGANIZACAO DA SOCIEDADE CIVIL DE INTERESSE PUBLICO - OSCIP, E O PODER PUBLICO, COM OBJETIVO DE IMPRIMIR MAIOR AGILIDADE GERENCIAL AOS PROJETOS, REDUZIR AS EXCESSIVAS EXIGENCIAS BUROCRATICAS E REALIZAR CONTROLE DOS RESULTADOS. O TERMO DE PARCERIA FOI INSTITUIDO E DISCIPLINADO PELA LEI 9.790/99, DE 23 DE MARCO DE 1999 E DECRETO Nº 3 100/99.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.09.01.00.00.00','TERMOS DE PARCERIA A PAGAR DO EXERCICIO','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS NO EXERCICIO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.09.02.00.00.00','TERMOS DE PARCERIA A PAGAR DE EXERCICIOS ANTERIORES','REGISTRA OS VALORES A PAGAR REFERENTES A TERMOS DE PARCERIA FIRMADOS EM EXERCICIOS ANTERIORES.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.10.00.00.00.00','TERMO DE COMPROMISSO A PAGAR','REGISTRA OS VALORES A PAGAR RETIDOS A TITULO DE TERMO DE COMPROMISSO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.11.00.00.00.00','CONTRATOS DE GESTAO A PAGAR','Registra as obrigações relativas aos contratos entre a administração publica e a iniciativa privada para gestão de atividades tipicas de governo.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.12.00.00.00.00','SUBVENCOES A PAGAR','Registra o somatorio das subvenções a pagar.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.1.14.00.00.00.00','CONSÓRCIOS A PAGAR','Registra a apropriação e movimentação dos valores a repassar a consórcios, em atendimento ao disposto na Portaria STN 72/2012.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.1.8.9.2.00.00.00.00.00','OUTRAS OBRIGAÇÕES A CURTO PRAZO-INTRA OFSS','Registra outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no curto prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.0.0.0.00.00.00.00.00','PASSIVO NAO-CIRCULANTE','Compreende as obrigações conhecidas e estimadas que não atendam a nenhum dos critérios para serem classificadas no passivo circulante.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.0.0.00.00.00.00.00','OBRIGAÇÕES TRABALHISTAS, PREVIDENCIÁRIAS E ASSISTENCIAIS A PAGAR A LONGO PRAZO','Compreende as obrigações referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, aposentadorias, reformas, pensões e encargos a pagar,  benefícios assistenciais, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.0.00.00.00.00.00','PESSOAL A PAGAR','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.00.00.00.00.00','PESSOAL A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a salários ou remunerações, bem como benefícios aos quais o empregado ou servidor tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.01.00.00.00.00','PESSOAL A PAGAR DE EXERCICIOS ANTERIORES','Registra os valores relativos a vencimentos e vantagens fixas e variaveis  devidas ao servidores, bem como as aposentadorias, reformas e pensões, relativas a exercicios anteriores.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.00.00.00.00','PRECATORIOS DE PESSOAL','Compreende os valores de precatorios de obrigações referentes a salarios ou remunerações, bem como a beneficios aos quais o empregado ou servidor tenha direito.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.01.00.00.00','PRECATORIOS DE PESSOAL - REGIME ORDINÁRIO','Registra os valores dos precatórios judiciais relativos ao regime ordinário de natureza alimentar.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.02.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','Registra os valores de precatorios para pagamento de pessoal, ate 05/05/2000, exigiveis no longo prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.03.00.00.00','PRECATORIOS DE PESSOAL DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000','Registra os valores de precatorios de obrigações referentes a salarios ou remunerações, bem como a beneficios aos quais o empregado ou servidor tenha direito, de exercicios anteriores e a partir de 05/05/2000 (LRF).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.04.00.00.00','PRECATORIOS DE PESSOAL - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao regime especial de natureza alimentar , instituído pela Emenda Constitucional 62/2009.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.1.1.02.05.00.00.00','PRECATÓRIOS DE PESSOAL VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de pessoal do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.0.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.00.00.00.00.00','BENEFÍCIOS PREVIDENCIÁRIOS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo referentes a proventos de aposentadoria, reformas ou pensões aos quais o aposentado, reformado ou pensionista tenha direito, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.00.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS','Compreende as obrigações referentes a precatorios de proventos de aposentadoria, reformas ou pensões.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.01.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ORDINÁRIO','Registra os valores dos precatórios judiciais relativos ao regime ordinário de natureza alimentar.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.02.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES - ANTERIORES A 05/05/2000','Registra as obrigações referentes a precatorios de proventos de aposentadoria, reformas ou pensões de exercicios anteriores e anteriores a 05/05/2000 (LRF).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.03.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIARIOS DE EXERCICIOS ANTERIORES -  A PARTIR DE 05/05/2000 ','Registra as obrigações referentes a precatorios de proventos de aposentadoria, reformas ou pensões de exercicios anteriores e a partir de 05/05/2000 (LRF).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.04.00.00.00','PRECATORIOS DE BENEFICIOS PREVIDENCIÁRIOS - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao regime especial de natureza alimentar , instituído pela Emenda Constitucional 62/2009.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.2.1.01.05.00.00.00','PRECATÓRIOS DE BENEFÍCIOS PREVIDENCIÁRIOS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de benefícios previdenciários do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.0.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.1.00.00.00.00.00','BENEFÍCIOS ASSISTENCIAIS A PAGAR - CONSOLIDAÇÃO','Compreende as obrigações a longo prazo relativas aos benefícios assistenciais administrados pela previdência social, quando pagos em data posterior a qual forem incorridos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.3.1.01.00.00.00.00','BENEFICIOS ASSISTENCIAIS A PAGAR DE EXERCICIOS ANTERIORES','Registra os valores relativos aos beneficios assistenciais administrados pela previdencia social, de exercicios anteriores.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.0.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR- CONSOLIDAÇÃO','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.01.00.00.00.00','CONTRIBUIÇÕES PREVIDÊNCIÁRIAS  - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor referente a débitos parcelados junto ao INSS ou entidade de previdência, referente ao não recolhimento de obrigações de folha de pagamento e outros afins.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.02.00.00.00.00','CONTRIBUICÕES SOCIAIS  - DÉBITOS PARCELADOS','Registra a apropriação e movimentação do valor dos débitos parcelados, referente ao não recolhimento de contribuições sociais','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.03.00.00.00.00','FGTS - DÉBITO PARCELADO','Registra a apropriação e movimentação do valor dos débitos parcelados, referente ao não recolhimento de FGTS','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.1.99.00.00.00.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrencia permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificacao não esteja prevista em contas especificas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTRA OFSS','Compreende as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.01.00.00.00.00','CONTRIBUIÇÃO A REGIME PRÓPRIO DE PREVIDÊNCIA (RPPS)','Registra os valores relativos as obrigações com Regimes Próprios de Previdencia, não identificados como Previdencia Privada ou Complementar.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.2.99.00.00.00.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrencia permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificacao não esteja prevista em contas especificas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - UNIÃO','Registra as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.01.00.00.00.00','INSS A PAGAR','Compreende os valores relativos as contribuições a previdencia social, incidentes sobre salários e remunerações pagos e sobre serviços de terceiros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.01.01.00.00.00','INSS - DÉBITO PARCELADO','Registra os valores de debito parcelado que se referem ao não recolhimento de obrigações da folha de pagamento junto ao INSS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.3.99.00.00.00.00','OUTROS ENCARGOS SOCIAIS','Registra os valores relativos aos encargos sociais de ocorrencia permanente ou eventual que tenham gerado obrigações para a entidade, cuja classificacao não esteja prevista em contas especificas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.4.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - ESTADO','Registra as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.1.4.5.00.00.00.00.00','ENCARGOS SOCIAIS A PAGAR-INTER OFSS - MUNICÍPIO','Registra as obrigações a longo prazo das unidades relativas a despesas incorridas e não pagas, em beneficio de seus servidores, empregados e familiares, compulsoriamente ou não, incluindo aquelas que se destinam ao financiamento da seguridade social de responsabilidade do poder público e as demais contribuições sociais. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.0.0.00.00.00.00.00','EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO','Compreende as obrigações financeiras da entidade a titulo de empréstimos, bem como as aquisições efetuadas diretamente com o fornecedor, com vencimentos no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.0.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','Registra os valores das operações de creditos internas decorrentes da emissão de titulos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.1.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','Registra os valores das operações de credito internas em contratos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO – INTERNO - INTER OFSS - UNIÃO','Compreendeos empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TITULOS','Registra os valores das operações de creditos internas decorrentes da emissão de titulos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','Registra os valores das operações de credito internas em contratos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.3.03.00.00.00.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Registra os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO - INTER OFSS - ESTADO','Compreende os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.01.00.00.00.00','EMPRESTIMOS INTERNOS - EM TÍTULOS','Registra os valores das operações de créditos internas decorrentes da emissão de titulos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.02.00.00.00.00','EMPRESTIMOS INTERNOS - EM CONTRATOS','Registra os valores das operações de credito internas em contratos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.4.03.00.00.00.00','OUTROS EMPRÉSTIMOS A LONGO PRAZO - INTERNO','Registra os empréstimos a longo prazo - interno - não enquadrados nas classificações anteriores.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.1.5.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - INTERNO-INTER OFSS - MUNICÍPIO','Registra os empréstimos contratuais ou mobiliários assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.0.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO - EXTERNO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.00.00.00.00.00','EMPRÉSTIMOS A LONGO PRAZO- EXTERNO CONSOLIDAÇÃO','Compreende os empréstimos contratuais ou mobiliários assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.01.00.00.00.00','EMPRÉSTIMOS EXTERNOS - EM TÍTULOS','Registra os valores das operações de crédito externas em títulos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.02.00.00.00.00','EMPRÉSTIMOS EXTERNOS - EM CONTRATOS','Registra os valores das operações de crédito externas em contratos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.2.1.03.00.00.00.00','OUTROS EMPRÉSTIMOS A CURTO PRAZO - EXTERNO','Registra  os empréstimos a curto prazo - externo - não enquadrados nas classificações anteriores.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.0.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.01.00.00.00.00','FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes de financiamentos internos a longo prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.1.02.00.00.00.00','FINANCIAMENTOS INTERNOS POR ARRENDAMENTO FINANCEIRO A LONGO PRAZO','Registra as obrigações a longo prazo referentes a financiamentos internos por arrendamento financeiro, onde são transferidos substancialmente ao arrendador todos os riscos e benefícios inerentes a propriedade, havendo a possibilidade de compra do bem arrendado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.3.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO- INTERNO -INTER OFSS - UNIÃO','Registra as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.4.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - ESTADO','Registra as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.3.5.00.00.00.00.00','FINANCIAMENTOS A LONGO PRAZO – INTERNO - INTER OFSS - MUNICÍPIO','Registra as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas dentro do país e transacionadas, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.0.00.00.00.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.1.00.00.00.00.00','FINANCIAMENTO A LONGO PRAZO - EXTERNO - CONSOLIDAÇÃO','Compreende as obrigações decorrentes de aquisições efetuadas diretamente com o fornecedor ou instituição financeira assumidas no exterior e transacionadas, em regra, em moeda estrangeira, com vencimento no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.4.1.01.00.00.00.00','FINANCIAMENTOS EXTERNOS','Registra os valores exigiveis decorrentes de financiamentos externos a curto prazo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - INTERNO - CONSOLIDAÇÃO','Compreendeos juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS INTERNOS','Compreende os valores exigiveis decorrentes dos juros de contratos de emprestimos internos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.01.01.00.00.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos do exercício.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.01.02.00.00.00','JUROS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos juros de contratos de empréstimos internos do exercício anterior.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS INTERNOS','Compreende os valores exigiveis decorrentes dos encargos de contratos de emprestimos internos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.02.01.00.00.00','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DO EXERCÍCIO','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos do exercício.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.02.02.00.00.00','ENCARGOS DE CONTRATOS - EMPRÉSTIMOS INTERNOS DE EXERCÍCIOS ANTERIORES','Registra os valores exigíveis decorrentes dos encargos de contratos de empréstimos internos do exercício anterior.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de financiamentos internos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS INTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de financiamentos internos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.3.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - UNIÃO','Registra os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.4.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - ESTADO','Registra os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.5.5.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – INTERNO -INTER OFSS - MUNICÍPIO','Registra os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos dentro do país e transacionados, em regra, em moeda nacional, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.0.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO - EXTERNO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.00.00.00.00.00','JUROS E ENCARGOS A PAGAR DE EMPRÉSTIMOS E FINANCIAMENTOS A LONGO PRAZO – EXTERNO - CONSOLIDAÇÃO','Compreende os juros e encargos financeiros referentes a empréstimos e financiamentos, reconhecidos pelo regime de competência e pagáveis a longo prazo, assumidos no exterior e transacionados, em regra, em moeda estrangeira, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.01.00.00.00.00','JUROS DE CONTRATOS - EMPRESTIMOS EXTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de emprestimos externos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.02.00.00.00.00','ENCARGOS - EMPRESTIMOS EXTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de emprestimos externos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.03.00.00.00.00','JUROS DE CONTRATOS - FINANCIAMENTOS EXTERNOS','Registra os valores exigiveis decorrentes dos juros de contratos de financiamentos externos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.6.1.04.00.00.00.00','ENCARGOS - FINANCIAMENTOS EXTERNOS','Registra os valores exigiveis decorrentes dos encargos de contratos de financiamentos externos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - INTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO - CONSOLIDAÇÃO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.3.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS - UNIÃO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.4.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFFS - ESTADO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.8.5.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – INTERNO – INTER OFSS – MUNICÍPIO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - interno, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.9.0.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR - EXTERNO','Compreende os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.2.9.1.00.00.00.00.00','(-) ENCARGOS FINANCEIROS A APROPRIAR – EXTERNO - CONSOLIDAÇÃO','Registra os encargos financeiros estabelecidos em valores prefixados, inclusos como contrapartida nas contas de empréstimo e de financiamento a longo prazo - externo, mas que ainda não transcorreram por não ter ocorrido ainda o fato gerador.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.0.0.00.00.00.00.00','FORNECEDORES A LONGO PRAZO','Compreende as obrigações junto a fornecedores de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.0.00.00.00.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.00.00.00.00.00','FORNECEDORES NACIONAIS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores nacionais de matérias-primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.00.00.00.00','FORNECEDORES NACIONAIS','Compreende os valores a pagar aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.01.00.00.00','FORNECEDORES NÃO FINANCIADOS A PAGAR','Registra os valores a pagar não financiados, ou seja, em uma única parcela, aos fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.02.00.00.00','FORNECEDORES FINANCIADOS A PAGAR','Registra os valores a pagar financiados diretamente com fornecedores nacionais de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.03.00.00.00','PARCELAMENTO DE FORNECEDORES A PAGAR','Registra o parcelamento de dívidas com fornecedores a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.01.99.00.00.00','DEMAIS FORNECEDORES A PAGAR','Registra os valores de demais fornecedores a pagar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.00.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS','Compreende as obrigações referentes a precatorios de fornecedores nacionais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.01.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO','Registra os valores dos Precatórios Judiciais relativos ao Regime Ordinário de Natureza não Alimentar.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.02.00.00.00','PRECATÓRIOS DE FORNECEDORES NACONAIS DO EXERCÍCIO  - A PARTIR DE 05/05/2000','Registra a apropriação e movimentação de Precatórios de fornecedores a Pagar - anteriores a 05/05/2000, exigíveis a Longo Prazo.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.03.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS DO EXERCÍCIO - ANTES DE 05/05/2000','Registra a apropriação e movimentação de Precatórios de Fornecedores a Pagar - a partir de 05/05/2000, exigíveis a Longo Prazo.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.04.00.00.00','PRECATORIOS DE FORNECEDORES NACIONAIS  - REGIME ESPECIAL','Registra os valores dos precatórios judiciais relativos ao Regime Especial mensal de Natureza não alimentar, instituído pela emenda Constitucional 62/2009','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.1.1.02.05.00.00.00','PRECATÓRIOS DE FORNECEDORES NACIONAIS VENCIDOS E NÃO PAGOS','Registra os valores de precatórios de fornecedores nacionais do exercício anterior e do exercício de referência até o quadrimestre correspondente, emitidos a partir de 5 de maio de 2000, inclusive, e não pagos durante a execução do orçamento em que houverem sido incluídos.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.0.00.00.00.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.00.00.00.00.00','FORNECEDORES ESTRANGEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende as obrigações junto a fornecedores estrangeiros de matérias primas, mercadorias e outros materiais utilizados nas atividades operacionais da entidade, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.3.2.1.01.00.00.00.00','FORNECEDORES ESTRANGEIROS A CURTO PRAZO','Registra os valores a pagar aos fornecedores estrangeiros de bens, materiais e serviços envolvidos com as atividades operacionais da entidade.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.0.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO','Compreende as obrigações das entidades com o governo relativas a impostos, taxas e contribuições com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - CONSOLIDAÇÃO','Registra as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTRA OFSS','Registra as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - UNIÃO','Compreende as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES FEDERAIS A RECOLHER','Compreende os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.99.01.00.00.00','PARCELAMENTOS DO FGTS','Registra os valores das obrigações, exigiveis a  longo  prazo,  decorrentes de parcelamentos do FGTS.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.3.99.02.00.00.00','PARCELAMENTOS DO PASEP','Registra os valores das obrigações, exigiveis a  longo  prazo,  decorrentes de parcelamentos do PASEP.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.4.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS - ESTADO','Registra as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.1.5.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM A UNIÃO - INTER OFSS – MUNICÍPIO','Registra as obrigações das entidades com o governo federal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - CONSOLIDAÇÃO','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.1.01.00.00.00.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.1.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS ESTADOS - INTRA OFSS','Compreende as obrigações das entidades com o governo estadual relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.2.01.00.00.00.00','TRIBUTOS ESTADUAIS RENEGOCIADOS','Registra os valores devidos pela entidade relativos a tributos que foram renegociados (ICMS, IPVA e Outros).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.2.2.99.00.00.00.00','OUTROS TRIBUTOS E CONTRIBUIÇÕES ESTADUAIS A RECOLHER','Registra os compromissos exigíveis a longo prazo, decorrentes da incidência de tributos para os quais não haja contas específicas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.0.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS','Compreende as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.1.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS - CONSOLIDAÇÃO','Registra as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.4.3.2.00.00.00.00.00','OBRIGAÇÕES FISCAIS A LONGO PRAZO COM OS MUNICÍPIOS-INTRA OFSS','Registra as obrigações das entidades com o governo municipal relativas a impostos, taxas e contribuições, com vencimento no longo prazo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.0.0.00.00.00.00.00','PROVISÕES A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.0.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.00.00.00.00.00','PROVISÃO PARA RISCOS TRABALHISTAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.01.00.00.00.00','PROVISÃO PARA INDENIZAÇÕES TRABALHISTAS','Registra os valores das provisões constituidas visando o pagamento de indenizações trabalhistas.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.1.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTO DE DISSIDIOS COLETIVOS','Registra os valores das provisões constituidas visando o pagamento de dissidios coletivos.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.0.00.00.00.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.00.00.00.00.00','PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Compreende os passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.00.00.00.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS CONCEDIDOS   ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.                            ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.01.00.00.00','APOSENTADORIAS/        PENSOES /OUTROS BENEFICIOS CONCEDIDOS DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das prestações futuras dos beneficios ja concedidos aos assistidos e beneficiarios em gozo de beneficio de prestação continuada.   ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS                       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periodicos) futuras do ente, por prazo de vigencia indeterminado, para financiar  os beneficios ja em fase de pagamento.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.03.00.00.00','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO FINANCEIRO DO RPPS  ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos inativos, por prazo de vigência indeterminado, para financiar os benefíciosjá em fase de pagamento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.04.00.00.00','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO FINANCEIRO DO RPPS              ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos pensionistas, por prazo de vigencia indeterminado, para financiar os beneficios ja em fase de pagamento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.05.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS                  ','Registrar, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciaria conforme expressa o artigo 11, da Portaria MPS nº 403/2008. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.06.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS     ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao fundo sob o regime de parcelamento de debitos.   ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.01.07.00.00.00','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das insuficiências financeiras futuras do plano financeiro considerando o §1º do artigo 2º da Lei nº 9.717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.00.00.00.00','PLANO FINANCEIRO - PROVISOES DE BENEFICIOS A CONCEDER            ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).                                                                 ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO FINANCEIRO DO RPPS','Registra, de acordo com o resultado da avaliação atuarial, o valor presente dos beneficios a serem concedidos aos integrantes da geração atual que ainda não estejam em gozo de beneficios de prestação continuada.  ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO FINANCEIRO DO RPPS                                             ','Registra, de acordo com o resultado da avaliação atuarial, o valor  presente das contribuições (normal, suplementar ou aportes periodicos) futuras do ente, incidentes sobre as remunerações da geração atual. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.03.00.00.00','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO FINANCEIRO DO RPPS   ','Registra, de acordo com o resultado da avaliação atuarial, o somatório do valor presente das contribuições futuras dos servidores ativos, incidentes sobre as remunerações da geração atual.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.04.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO FINANCEIRO DO RPPS                  ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciaria conforme expressa o artigo 11, da Portaria MPS nº 403/2008.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.05.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, considerando o parcelamento dos valores não recolhidos. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.02.06.00.00.00','(-) COBERTURA DE INSUFICIÊNCIA FINANCEIRA  ','Registra, de acordo com  o  resultado da avaliação atuarial, o  valor presente das insuficiencias financeiras futuras  do  plano financeiro, considerando o § 1º do artigo 2º da Lei 9717/98.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.00.00.00.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS CONCEDIDOS            ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios já concedidos aos assistidos e beneficiários em gozo de beneficio de prestação continuada.                            ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS CONCEDIDOS DO PLANO PREVIDENCIARIO DO RPPS ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das prestações futuras dos beneficios ja concedidos aos assistidos e beneficiarios em gozo de beneficio de prestação continuada. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS                       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periodicos)  futuras do ente, por prazo de vigencia indeterminado, para financiar os beneficios ja em fase de pagamento. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.03.00.00.00','(-) CONTRIBUIÇÕES DO INATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS          ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos inativos, por prazo de vigência indeterminado, para financiar os benefícios já em fase de pagamento.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.04.00.00.00','(-) CONTRIBUICOES DO PENSIONISTA PARA O PLANO PREVIDENCIARIO DO RPPS             ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições futuras dos pensionistas, por prazo de vigencia indeterminado, para financiar os beneficios ja em fase de pagamento.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.05.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS                 ','Registrar, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciaria conforme expressa o artigo 11 da Portaria MPS nº 403/2008. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.03.06.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS DO PLANO PREVIDENCIARIO DO RPPS     ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, considerando o parcelamento de valores nao recolhidos. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.00.00.00.00','PLANO PREVIDENCIARIO - PROVISOES DE BENEFICIOS A CONCEDER              ','Compreende, de acordo com o resultado da avaliação atuarial, a provisão matemática correspondente ao valor presente liquido das prestações futuras dos benefícios a conceder para a geração atual (servidores ativos).                                                                 ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.01.00.00.00','APOSENTADORIAS/PENSOES/OUTROS BENEFICIOS A CONCEDER DO PLANO PREVIDENCIARIO DO RPPS ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente dos beneficios a serem concedidos aos integrantes da geração atual que ainda não estejam em gozo de beneficios de prestação continuada. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.02.00.00.00','(-) CONTRIBUICOES DO ENTE PARA O PLANO PREVIDENCIARIO DO RPPS                        ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições (normal, suplementar ou aportes periodicos)  futuras do ente, incidentes sobre as remunerações da geração atual. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.03.00.00.00','(-) CONTRIBUIÇÕES DO ATIVO PARA O PLANO PREVIDENCIÁRIO DO RPPS                        ','Registra, de acordo com o resultado da avaliação atuarial, o somatório do valor presente das contribuições futuras dos servidores ativos, incidentes sobre as remunerações da geração atual.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.04.00.00.00','(-) COMPENSACAO PREVIDENCIARIA DO PLANO PREVIDENCIARIO DO RPPS                    ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente da compensação previdenciaria conforme expressa o artigo 11, da Portaria MPS nº 403/2008. ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.04.05.00.00.00','(-) PARCELAMENTO DE DEBITOS PREVIDENCIARIOS       ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente das contribuições não vertidas ao plano, sob o regime de parcelamento de debitos.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.05.00.00.00.00',' PLANO PREVIDENCIARIO - PLANO DE AMORTIZACAO                            ','Compreende, de acordo com resultado da avaliação atuarial, o valor presente liquido dos direitos incorporados ao patrimônio do RPPS com base em legislação especifica, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contábil das reservas matemáticas somente ocorrera na apresentação de uma nova reavaliação atuarial.                               ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.05.98.00.00.00','(-) OUTROS CREDITOS DO PLANO DE AMORTIZACAO                               ','Registra, de acordo com o resultado da avaliação atuarial, o valor presente liquido dos direitos incorporados ao patrimonio do RPPS com base em legislação especifica, como exemplo: direitos sobre royalties, bem como registro tempestivo do plano de amortização implementado em lei do ente federativo, considerando que o ajuste contabil das reservas matematicas somente ocorrera na apresentação de uma nova reavaliação atuarial.  ','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.06.00.00.00.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO FINANCEIRO      ','Compreende o somatório das provisões atuariais constituídas para ajustes do plano financeiro, conforme o resultado da avaliação atuarial.             ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.06.01.00.00.00','PROVISAO ATUARIAL PARA OSCILACAO DE RISCOS       ','Registra, de acordo com a nota tecnica atuarial, a provisão atuarial correspondente a eventuais desvios dos compromissos esperados ou pela adoção de bases tecnicas que não se adaptam ao plano. ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.00.00.00.00','PROVISOES ATUARIAIS PARA AJUSTES DO PLANO PREVIDENCIARIO      ','Compreende o somatório das provisões atuariais constituídas para ajustes do plano previdenciário, conforme o resultado da avaliação atuarial.             ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.01.00.00.00','AJUSTE DE RESULTADO ATUARIAL SUPERAVITARIO     ','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciario quando o plano apresentar resultado superavitario, considerando o artigo 25, da Portaria MPS 403/2008.                                                                ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.02.00.00.00','PROVISÃO ATUARIAL PARA OSCILAÇÃO DE RISCOS','Registra, de acordo com a nota tecnica atuarial, a provisão atuarial correspondente a eventuais desvios dos compromissos esperados ou pela adoção de bases tecnicas que não se adaptam ao plano.   ','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.03.00.00.00','PROVISÃO ATUARIAL PARA BENEFÍCIOS A REGULARIZAR','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciario quando o plano apresentar benefícios a regularizar.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.04.00.00.00','PROVISÃO ATUARIAL PARA CONTINGÊNCIAS DE BENEFÍCIOS','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciario quando o plano apresentar contingências.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.2.1.07.98.00.00.00','OUTRAS PROVISÕES ATUARIAIS PARA AJUSTES DO PLANO','Registra, de acordo com o resultado da avaliação atuarial, provisão atuarial para ajuste do plano previdenciario quando o plano necessitar de outros ajustes.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.0.00.00.00.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.00.00.00.00.00','PROVISÃO PARA RISCOS FISCAIS A LONGO PRAZO - CONSOLIDAÇÃO','Registra os passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.01.00.00.00.00','PROVISÃO PARA PAGAMENTOS REFERENTES A AUTOS DE INFRAÇÃO','Compreende os valores das provisões para pagamento de autos de infração já lavrados e que se encontram na esfera administrativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.01.01.00.00.00','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO NÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade ainda não apresentou recurso administrativo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.01.02.00.00.00','PROVISÃO PARA PAGAMENTO DE AUTOS DE INFRAÇÃO RECORRIDOS','Registra os valores das provisões para pagamento de autos de infração já lavrados, para os quais a unidade apresentou recurso administrativo.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.02.00.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS - ESFERA JUDICIAL','Compreende os valores das provisões para pagamento de autuações fiscais que já se encontram na esfera judicial.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.02.01.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL NÃO RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera judicial e que não estão em fase recursal.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.3.1.02.02.00.00.00','PROVISÃO PARA PAGAMENTOS DE AUTUAÇÕES FISCAIS NA ESFERA JUDICIAL RECORRIDAS','Registra os valores das provisões para pagamento de autuações fiscais que se encontram na esfera judicial em fase recursal.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.4.0.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.4.1.00.00.00.00.00','PROVISÃO PARA RISCOS CÍVEIS A LONGO PRAZO - CONSOLIDAÇÃO','Registra os passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes, com probabilidade de ocorrerem no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.0.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.3.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - UNIÃO','Registra os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.4.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - ESTADO','Registra os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.5.5.00.00.00.00.00','PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS A LONGO PRAZO - INTER OFSS - MUNICÍPIO','Registra os passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação, com probabilidade de ocorrerem no longo prazo. Na arrecadação, esta provisão será revertida em conta especifica de passivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.6.0.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO','Compreende os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.6.1.00.00.00.00.00','PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP A LONGO PRAZO - CONSOLIDAÇÃO ','Registra os passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.9.0.00.00.00.00.00','OUTRAS PROVISÕES A LONGO PRAZO','Compreende os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo, não classificadas anteriormente neste plano de contas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.7.9.1.00.00.00.00.00','OUTRAS PROVISÕES A LONGO PRAZO - CONSOLIDAÇÃO','Registra os demais passivos de prazo ou de valor incertos, com probabilidade de ocorrerem no longo prazo, não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.0.0.00.00.00.00.00','DEMAIS OBRIGAÇÕES A LONGO PRAZO','Compreende as obrigações da entidade junto a terceiros não inclusas nos subgrupos anteriores, inclusive os precatórios decorrentes dessas obrigações, com vencimento no longo prazo. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.1.0.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO','Compreende as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.1.1.00.00.00.00.00','ADIANTAMENTOS DE CLIENTES A LONGO PRAZO- CONSOLIDAÇÃO','Registra as antecipações recebidas por operações de fornecimento de bens ou prestação de serviços e que ensejem a devolução da quantia recebida, caso a operação não ocorra. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.2.0.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO','Compreende os valores exigíveis no longo prazo, provenientes de danos a terceiros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.2.1.00.00.00.00.00','OBRIGAÇÕES POR DANOS A TERCEIROS A LONGO PRAZO - CONSOLIDAÇÃO','Registra os valores exigíveis no longo prazo, provenientes de danos a terceiros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','X');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.3.0.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO','Compreende os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.3.1.00.00.00.00.00','DEBÊNTURES E OUTROS TÍTULOS DE DIVIDA A LONGO PRAZO- CONSOLIDAÇÃO','Registra os títulos emitidos pela entidade que conferirão aos seus titulares direito de credito contra ela, nas condições constantes da escritura de emissão do titulo, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.4.0.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.4.1.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.0.00.00.00.00.00','VALORES RESTITUÍVEIS','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositária, exigíveis no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.1.00.00.00.00.00','VALORES RESTITUÍVEIS - CONSOLIDAÇÃO','Compreende os valores de terceiros ou retenções em nome deles, quando a entidade do setor público for fiel depositaria, exigíveis no longo prazo.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.1.01.00.00.00.00','CONSIGNACOES ','REGISTRA OS VALORES ENTREGUES EM CONFIANCA OU EM CONSIGNACOES, GERALMENTE RETIDOS EM FOLHA DE PAGAMENTO DE EMPREGADOS OU SERVIDORES OU NOS PAGAMENTOS REFERENTES A COMPRAS DE BENS E SERVICOS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.1.02.00.00.00.00','GARANTIAS','REGISTRA A GARANTIA DO CUMPRIMENTO DE UMA OBRIGACAO, QUE SE EFETIVA COM O OFERECIMENTO DE BENS OU RECURSOS FINANCEIROS OU AINDA RETENCOES DE UM PERCENTUAL DO VALOR DO CONTRATO COMO GARANTIA DE CUMPRIMENTO DO MESMO.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.1.03.00.00.00.00','DEPOSITOS  JUDICIAIS','REGISTRA OS VALORES RELATIVOS AS OBRIGACOES CONTRAIDAS POR DEPOSITOS EFETUADOS A FAVOR DA ENTIDADE DESTINADOS AO EXERCICIO DE DIREITO DE RECURSO JUNTO A JUSTICA E ENCONTRADOS VINCULADOS EM CONTAS BANCARIAS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.1.04.00.00.00.00','DEPOSITOS  NÃO JUDICIAIS','REGISTRA OS VALORES DE OBRIGACOES, DECORRENTES DE DEPOSITOS RECEBIDOS, EXCETO DEPOSITOS JUDICIAIS.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.8.1.99.00.00.00.00','OUTROS VALORES RESTITUIVEIS','REGISTRA OUTROS VALORES RESTITUIVEIS EM POSSE DA ENTIDADE, NO PAPEL DE FIEL DEPOSITARIA.','C','S','P','F');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.0.00.00.00.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO','Compreende outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.8.9.1.00.00.00.00.00','OUTRAS OBRIGAÇÕES A LONGO PRAZO- CONSOLIDAÇÃO','Registra outras obrigações não classificáveis em grupos específicos deste plano de contas, com vencimento no longo prazo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.0.0.00.00.00.00.00','RESULTADO DIFERIDO','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.  Compreende também o saldo existente na antiga conta resultado de exercícios futuros em 31 de dezembro de 2008.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.1.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA (VPA) DIFERIDA','Compreende o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.1.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA DIFERIDA - CONSOLIDAÇÃO','Registra o valor das variações patrimoniais aumentativas já recebidas que efetivamente devem ser reconhecidas em resultados em anos futuros e que não haja qualquer tipo de obrigação de devolução por parte da entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.2.0.00.00.00.00.00','(-) CUSTO DIFERIDO','Compreende o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.2.9.2.1.00.00.00.00.00','(-) CUSTO DIFERIDO - CONSOLIDAÇÃO','Registra o custo relacionado às variações patrimoniais aumentativas (VPA) diferidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.0.0.0.00.00.00.00.00','PATRIMÔNIO LIQUIDO','Compreende o valor residual dos ativos depois de deduzidos todos os passivos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.0.0.00.00.00.00.00','PATRIMÔNIO SOCIAL E CAPITAL SOCIAL','Compreende o patrimônio social das autarquias, fundações e fundos e o capital social das demais entidades da administração indireta.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.1.0.00.00.00.00.00','PATRIMÔNIO SOCIAL','Compreende o patrimônio das autarquias, fundações e fundos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.1.1.00.00.00.00.00','PATRIMÔNIO SOCIAL - CONSOLIDAÇÃO','Registra o patrimônio das autarquias, fundações e fundos, pertencentes ao orçamento fiscal e da seguridade social.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.0.00.00.00.00.00','CAPITAL SOCIAL REALIZADO','Compreende o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.1.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - CONSOLIDAÇÃO','Registra o capital social subscrito das empresas públicas e sociedades de economia mista, deduzido da parcela ainda não realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.2.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTRA OFSS','Registra o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.3.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - UNIÃO','Registra o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.4.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - ESTADO','Registra o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.1.2.5.00.00.00.00.00','CAPITAL SOCIAL REALIZADO - INTER OFSS - MUNICÍPIO','Registra o capital social subscrito, deduzido da parcela ainda não realizada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.0.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL','Compreende os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.1.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - CONSOLIDAÇÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.2.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTRA OFSS','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.3.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - UNIÃO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.4.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS - ESTADO','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.2.0.5.00.00.00.00.00','ADIANTAMENTO PARA FUTURO AUMENTO DE CAPITAL - INTER OFSS – MUNICÍPIO.','Registra os recursos recebidos pela entidade de seus acionistas ou quotistas destinados a serem utilizados para aumento de capital, quando não haja a possibilidade de devolução destes recursos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.0.0.00.00.00.00.00','RESERVAS DE CAPITAL','Compreende os valores acrescidos ao patrimônio que não transitaram pelo resultado como variações patrimoniais aumentativas (VPA).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.0.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES','Compreende a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.1.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - CONSOLIDAÇÃO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.2.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTRA OFSS','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.3.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - UNIÃO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.4.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - ESTADO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.1.5.00.00.00.00.00','ÁGIO NA EMISSÃO DE AÇÕES - INTER OFSS - MUNICÍPIO','Registra a contribuição do subscritor de ações que ultrapassar o valor nominal e a parte do preço de emissão das ações sem valor nominal que ultrapassar a importância destinada à formação do capital social, inclusive nos casos de conversão em ações de debêntures ou partes beneficiarias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.0.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS','Compreende o produto da alienação de partes beneficiárias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.1.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.2.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTRA OFSS','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.3.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - UNIÃO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.4.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - ESTADO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.2.5.00.00.00.00.00','ALIENAÇÃO DE PARTES BENEFICIARIAS - INTER OFSS - MUNICÍPIO','Registra o produto da alienação de partes beneficiárias. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.0.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO','Compreende o produto da alienação de bônus de subscrição.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.1.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - CONSOLIDAÇÃO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.2.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTRA OFSS','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.3.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - UNIÃO','Registra o produto da alienação de bônus de subscrição.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.4.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - ESTADO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.3.5.00.00.00.00.00','ALIENAÇÃO DE BÔNUS DE SUBSCRIÇÃO - INTER OFSS - MUNICÍPIO','Registra o produto da alienação de bônus de subscrição. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.0.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO','Compreende o resultado da correção monetária do capital realizado, enquanto não capitalizado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.1.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - CONSOLIDAÇÃO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.2.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTRA OFSS','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.3.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - UNIÃO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.4.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - ESTADO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.4.5.00.00.00.00.00','CORREÇÃO MONETÁRIA DO CAPITAL REALIZADO - INTER OFSS - MUNICÍPIO','Registra o resultado da correção monetária do capital realizado, enquanto não capitalizado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.0.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL','Compreende os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.1.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - CONSOLIDAÇÃO','Registra os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.2.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTRA OFSS','Registra os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.3.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - UNIÃO','Registra os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.4.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - ESTADO','Registra os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.3.9.5.00.00.00.00.00','OUTRAS RESERVAS DE CAPITAL - INTER OFSS - MUNICÍPIO','Registra os valores das demais reservas de capital, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.0.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo e do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício em obediência ao regime de competência.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.1.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.1.1.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE ATIVOS - CONSOLIDAÇÃO','Registra as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do ativo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.2.0.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS','Compreende as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.4.2.1.00.00.00.00.00','AJUSTES DE AVALIAÇÃO PATRIMONIAL DE PASSIVOS - CONSOLIDAÇÃO','Registra as contrapartidas de aumentos ou diminuições de valor atribuídos a elementos do passivo em decorrência da sua avaliação a valor justo, nos casos previstos pela lei 6.404/76 ou em normas expedidas pela comissão de valores mobiliários, enquanto não computadas no resultado do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.0.0.00.00.00.00.00','RESERVAS DE LUCROS','Compreende as reservas constituídas com parcelas do lucro liquido das entidades para finalidades especificas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.0.00.00.00.00.00','RESERVA LEGAL','Compreende os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.                                                     ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.1.00.00.00.00.00','RESERVA LEGAL- CONSOLIDAÇÃO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.2.00.00.00.00.00','RESERVA LEGAL- INTRA OFSS','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.3.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - UNIÃO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.4.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - ESTADO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.1.5.00.00.00.00.00','RESERVA LEGAL- INTER OFSS - MUNICÍPIO','Registra os valores das reservas obrigatoriamente constituídas com 5% do lucro liquido do exercício, até atingir o limite de 20% do capital social realizado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.0.00.00.00.00.00','RESERVAS ESTATUTÁRIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.1.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - CONSOLIDAÇÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.2.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTRA OFSS','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.3.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - UNIÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.4.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - ESTADO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.2.5.00.00.00.00.00','RESERVAS ESTATUTÁRIAS - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a atender finalidades determinadas no estatuto. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.0.00.00.00.00.00','RESERVA PARA CONTINGENCIAS','Compreende as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.1.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - CONSOLIDAÇÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.2.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTRA OFSS','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.3.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - UNIÃO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.4.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - ESTADO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.3.5.00.00.00.00.00','RESERVA PARA CONTINGENCIAS - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parcelas do lucro liquido destinadas a compensar, em exercício futuro, a diminuição do lucro decorrente de perda julgada provável, cujo valor possa ser estimado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.0.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS','Compreende a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.1.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - CONSOLIDAÇÃO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.2.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTRA OFSS','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.3.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - UNIÃO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.4.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - ESTADO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.4.5.00.00.00.00.00','RESERVA DE INCENTIVOS FISCAIS - INTER OFSS - MUNICÍPIO','Registra a reserva constituída com parcela do lucro liquido decorrente de doações ou subvenções governamentais para investimentos, que poderá ser excluída da base de calculo do dividendo obrigatório. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.0.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO','Compreende as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.1.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - CONSOLIDAÇÃO','Registra as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.2.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTRA OFSS','Registra as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.3.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - UNIÃO','Registra as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.4.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS –ESTADO','Registra as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.5.5.00.00.00.00.00','RESERVAS DE LUCROS PARA EXPANSÃO - INTER OFSS - MUNICÍPIO','Registra as reservas constituídas com parte do lucro liquido, com o objetivo de atender a projetos de investimento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.0.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR','Compreende a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.1.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- CONSOLIDAÇÃO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.2.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTRA OFSS','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.3.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - UNIÃO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.4.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - ESTADO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.6.5.00.00.00.00.00','RESERVA DE LUCROS A REALIZAR- INTER OFSS - MUNICÍPIO','Registra a reserva constituída com o excesso entre o montante do dividendo obrigatório e a parcela realizada do lucro liquido do exercício.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.0.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES','Compreende a parcela do lucro líquido do exercício decorrente do prêmio na emissão de debêntures.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.1.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- CONSOLIDAÇÃO','Registra a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.2.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTRA OFSS','Registra a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.3.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - UNIÃO','Registra a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.4.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - ESTADO','Registra a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.7.5.00.00.00.00.00','RESERVA DE RETENÇÃO DE PREMIO NA EMISSÃO DE DEBÊNTURES- INTER OFSS - MUNICÍPIO','Registra a parcela do lucro líquido do exercício decorrente do premio na emissão de debêntures. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.0.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO','Compreende os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.1.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - CONSOLIDAÇÃO','Registra os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.2.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTRA OFSS','Registra os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.3.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - UNIÃO','Registra os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.4.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - ESTADO','Registra os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.5.9.5.00.00.00.00.00','OUTRAS RESERVAS DE LUCRO - INTER OFSS - MUNICÍPIO','Registra os valores das demais reservas de lucro, inclusive aquelas que terão seus saldos realizados por haverem sido extintas pela legislação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.0.0.00.00.00.00.00','DEMAIS RESERVAS','Compreende as demais reservas, não classificadas como reservas de capital ou de lucro, inclusive aquelas que terão seus saldos realizados por terem sido extintas pela legislação.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.0.00.00.00.00.00','RESERVA DE REAVALIAÇÃO','Compreende a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.1.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - CONSOLIDAÇÃO','Registra a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.2.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTRA OFSS','Registra a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.3.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - UNIÃO','Registra a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.4.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - ESTADO','Registra a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.1.5.00.00.00.00.00','RESERVA DE REAVALIAÇÃO - INTER OFSS - MUNICÍPIO','Registra a contrapartida dos acréscimos de valor atribuídos a elementos do ativo, apurados pela diferença entre o valor do laudo e o valor anterior (custo original mais eventuais reavaliações anteriores), nos casos permitidos pela legislação vigente.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.0.00.00.00.00.00','OUTRAS RESERVAS','Compreende outras reservas que não forem classificadas como reservas de capital ou de lucro','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.1.00.00.00.00.00','OUTRAS RESERVAS - CONSOLIDAÇÃO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.2.00.00.00.00.00','OUTRAS RESERVAS - INTRA OFSS','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.3.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - UNIÃO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.4.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - ESTADO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.6.9.5.00.00.00.00.00','OUTRAS RESERVAS - INTER OFSS - MUNICÍPIO','Registra outras reservas que não forem classificadas como reservas de capital ou de lucro. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.0.0.00.00.00.00.00','RESULTADOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas e os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.0.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - CONSOLIDAÇÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.1.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTRA OFSS','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.2.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - UNIÃO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.3.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - ESTADO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.4.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.00.00.00.00.00','SUPERÁVITS OU DÉFICITS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreendem os superávits ou déficits acumulados da administração direta, autarquias, fundações e fundos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.01.00.00.00.00','SUPERÁVITS OU DÉFICITS DO EXERCÍCIO','Registra os superávits ou déficits do exercício da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.02.00.00.00.00','SUPERAVITS OU DEFICITS DE EXERCICIOS ANTERIORES ','Registra os superávits ou déficits acumulados de exercícios anteriores da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. Serão registrados nesta conta os ajustes da administração direta, autarquias, fundações e fundos.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.1.5.04.00.00.00.00','SUPERÁVITS OU DÉFICITS RESULTANTES DE EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de unidade da administração direta, autarquias, fundações e fundos, ocorrida durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.0.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - CONSOLIDAÇÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.02.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS DE EXERCÍCIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.03.00.00.00.00','AJUSTES DE EXERCÍCIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.1.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTRA OFSS','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.02.00.00.00.00','LUCROS EPREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.2.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - UNIÃO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.3.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - ESTADO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.4.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.00.00.00.00.00','LUCROS E PREJUÍZOS ACUMULADOS - INTER OFSS - MUNICÍPIO','Compreende o saldo remanescente dos lucros ou prejuízos líquidos das empresas.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','X','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.01.00.00.00.00','LUCROS E PREJUÍZOS DO EXERCÍCIO','Registra o saldo dos lucros ou prejuízos líquidos das empresas no exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.02.00.00.00.00','LUCROS E PREJUIZOS ACUMULADOS DE EXERCICIOS ANTERIORES','Registra o saldo dos lucros e prejuízos acumulados nos exercícios anteriores das empresas. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.03.00.00.00.00','AJUSTES DE EXERCICIOS ANTERIORES','Registra o saldo decorrente de efeitos da mudança de critério contábil ou da retificação de erro imputável a determinado exercício anterior, e que não possam ser atribuídos a fatos subsequentes. ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.04.00.00.00.00','LUCROS A DESTINAR DO EXERCÍCIO','Registra o valor dos lucros do exercício pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.05.00.00.00.00','LUCROS A DESTINAR DE EXERCÍCIOS ANTERIORES','Registra o valor dos lucros de exercícios anteriores pendentes de destinação, até a aprovação da proposta pela assembleia geral.                ','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.7.2.5.06.00.00.00.00','RESULTADOS APURADOS POR EXTINÇÃO, FUSÃO E CISÃO','Registra o resultado apurado por extinção, cisão ou fusão de empresas durante o exercício.','X','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.0.0.00.00.00.00.00','(-) AÇÕES / COTAS EM TESOURARIA','Compreende o valor das ações ou cotas da entidade que foram adquiridas pela própria entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.0.00.00.00.00.00','(-) AÇÕES EM TESOURARIA','Compreende o valor das ações da entidade que foram adquiridas pela própria entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.1.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.2.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTRA OFSS','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.3.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.4.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.1.5.00.00.00.00.00','(-) AÇÕES EM TESOURARIA - INTER OFSS – MUNICÍPIO','Registra o valor das ações da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.0.00.00.00.00.00','(-) COTAS EM TESOURARIA','Compreende o valor das cotas da entidade que foram adquiridas pela própria entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.1.00.00.00.00.00','(-) COTAS EM TESOURARIA - CONSOLIDAÇÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.2.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTRA OFSS','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do mesmo ente.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.3.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - UNIÃO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.4.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - ESTADO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '2.3.9.2.5.00.00.00.00.00','(-) COTAS EM TESOURARIA - INTER OFSS - MUNICÍPIO','Registra o valor das cotas da entidade que foram adquiridas pela própria entidade. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','P');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.0.0.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA','Compreende o decréscimo no beneficio econômico durante o período contábil sob a forma de saída de recurso ou redução de ativo ou incremento em passivo, que resulte em decréscimo do patrimônio liquido e que não seja proveniente de distribuição aos proprietários da entidade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.0.0.0.00.00.00.00.00','PESSOAL E ENCARGOS','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas ou variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público. Compreende ainda, obrigações trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos órgãos e demais entidades do setor público, contribuições a entidades fechadas de previdência e benefícios eventuais a pessoal civil e militar, destacados os custos de pessoal e encargos inerentes as mercadorias e produtos vendidos e serviços prestados.   ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.0.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL','Compreende a remuneração do pessoal ativo civil ou militar, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos, soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo, emprego ou função de confiança no setor público, bem como as com contratos de terceirização de mão de obra que se refiram à substituição de servidores e empregados públicos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO RPPS  - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RPPS, correspondente ao somatório das variações patrimoniais diminutivas com subsídios, vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.00.00.00.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RPPS','Compreende o somatorio dos valores com vencimentos  e vantagens fixas do pessoal civil do tipo: gratificação, representação, adicional insalubridade, ferias, 13 salario, licença-premio, abono pecuniario, adicional noturno, etc.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.01.00.00.00','VENCIMENTOS E SALÁRIOS','Registra o valor da despesa com vencimentos e salários.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.02.00.00.00','ADICIONAL NOTURNO','Registra o valor da despesa com adicional noturno.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.03.00.00.00','INCORPORAÇÕES','Registra o valor da despesa com incorporações.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.04.00.00.00','ABONO DE PERMANÊNCIA','Registra o valor da despesa com abono de permanência.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.05.00.00.00','ADICIONAL DE PERICULOSIDADE','Registra o valor da despesa com adicional de periculosidade.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.06.00.00.00','ADICIONAL DE INSALUBRIDADE ','Registra o valor da despesa com adicional de insalubridade.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.07.00.00.00','ADICINAL DE ATIVIDADES PENOSAS','Registra o valor da despesa com adicional de atividades penosas.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.08.00.00.00','INCENTIVO À QUALIFICAÇÃO','Registra o valor da despesa com incentivo à qualificação.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.09.00.00.00','REMUNERAÇÃO DE PESSOAL EM DISPONIBILIDADE','Registra o valor da despesa com remuneração de pessoal em disponibilidade.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.12.00.00.00','VANTAGEM PECUNIÁRIA INDIVIDUAL','Registra o valor da despesa com vantagem pecuniária individual.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.13.00.00.00','ABONO PROVISÓRIO – PESSOAL CIVIL','Registra o valor da despesa com abono provisório.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.14.00.00.00','GRATIFICAÇÃO POR EXERCÍCIO DE CARGOS','Registra o valor da despesa com gratificação por exercício de cargos.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.16.00.00.00','GRATIFICAÇÃO POR EXERCÍCIO DE FUNÇÕES','Registra o valor da despesa com gratificação por exercício de funções.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.17.00.00.00','INDENIZAÇÃO E LOCAÇÃO','Registra o valor da despesa com indenização e locação.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.18.00.00.00','GRATIFICAÇÃO DE TEMPO DE SERVIÇO','Registra o valor da despesa com gratificação de tempo de serviço.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.19.00.00.00','GRATIFICAÇÕES ESPECIAIS','Registra o valor da despesa com gratificações especiais.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.20.00.00.00','GRATIFICAÇÃO POR ATIVIDADES EXPOSTAS','Registra o valor da despesa com gratificação por atividades expostas.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.21.00.00.00','FÉRIAS VENCIDAS E PROPORCIONAIS','Registra o valor da despesa com férias vencidas e proporcionais.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.22.00.00.00','13. SALÁRIO','Registra o valor da despesa com 13. salário.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.23.00.00.00','FÉRIAS – ABONO PECUNIÁRIO','Registra o valor da despesa com férias - abono pecuniário.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.24.00.00.00','FÉRIAS – ABONO CONSTITUCIONAL','Registra o valor da despesa com férias - abono constitucional.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.25.00.00.00','LICENÇA-PRÊMIO','Registra o valor da despesa com licença-prêmio.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.26.00.00.00','LICENÇA CAPACITAÇÃO','Registra o valor da despesa com licença capacitação.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.27.00.00.00','ADIANTAMENTO PECUNIÁRIO','Registra o valor da despesa com adiantamento pecuniário.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.28.00.00.00','REPRESENTAÇÃO MENSAL','Registra o valor da despesa com representação mensal.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.29.00.00.00','COMPLEMENTAÇÃO SALARIAL','Registra o valor da despesa com complementação salarial.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.31.00.00.00','SUBSÍDIOS','Registra o valor da despesa com subsídios.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.32.00.00.00','GRATIFICAÇÃO POR EXERCÍCIO DE CARGO EM COMISSÃO','Registra o valor da despesa com gratificação por exer´cicio de cargo em comissão.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.33.00.00.00','VENCIMENTOS E SALÁRIOS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor da despesa com prorrogação salário maternidade.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.35.00.00.00','FÉRIAS - PAGAMENTO ANTECIPADO','Registra o valor da despesa com férias - pagamento antecipado.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.36.00.00.00','REMUN. PARTICIP. ÓRGÃOS DELIBERAÇÃO COLETIVA','Registra o valor da despesa com remun. particip. Órgãos deliberação coletiva.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.01.99.00.00.00','OUTROS VENCIMENTOS E VANTAGENS FIXAS – PESSOAL CIVIL RPPS ','Registra o valor da despesa com outros vencimentos e vantagens fixas p pessoal civil RPPS','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.00.00.00.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL - RPPS','Compreende o valor das apropriações das variações patrimoniais diminutivas com outras despesas variaveis - pessoal civil abrangidos pelo regime proprio, relacionadas as atividades do cargo ou função do servidor e cujo pagamento só se realiza  em circustancias especiais.                                                            ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.01.00.00.00','SUBSTITUIÇÕES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a substituicoes.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.02.00.00.00','ADICIONAL VARIÁVEL','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional variavel sujeitos a incidencia de tributos e contribuicoes de acordo com a lei 10.973/04 - distribuicao de royalties.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.03.00.00.00','SERVIÇOS EXTRAORDINÁRIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a servicos extraordinarios.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.05.00.00.00','GRATIFICAÇÃO ELEITORAL','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificacao eleitoral.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.07.00.00.00','ADICIONAL POR PLANTÃO HOSPITALAR','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional por plantao hospitalar - aph devido aos servidores em efetivo exercicio de atividades hospitalares, desempenhadas em regime de plantao, nas areas indispensaveis ao funcionamento ininterrupto dos hospitais constantes no artigo 298 da lei 12.155, de 2009, que altera a lei 11.907, de 02 de fevereiro de 2009.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.08.00.00.00','CONVOCACAO EXTRAORDINARIA LEGISLATIVA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a  convocacao extraordinaria legislativa.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.09.00.00.00','PARTICIPACAO A EMPREGADOS E ADMINISTRADORES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a participacao a empregados e administradores.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.10.00.00.00','AUXILIO MORADIA','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a auxilio moradia.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.11.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com com indenizações trabalhistas, referente a indenizações e restituições trabalhistas.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.13.00.00.00','RESSARCIMENTO DE DESP. DE PESSOAL REQUISITADO','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com resarcimento de despesas de pessoal requisitado.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.02.99.00.00.00','OUTROS VENCIMENTOS E VANTAGENS VARIÁVEIS – PESSOAL CIVIL RPPS','Registra o valor da despesa com voutros vencimentos e vantagens variáveis – pessoal civil RPPS.','D ','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.1.1.03.00.00.00.00','SENTENCAS JUDICIAIS','Registra as variações patrimoniais diminutivas provenientes de sentenças judiciais','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO - RGPS','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO CIVIL – ABRANGIDOS PELO - RGPS - CONSOLIDAÇÃO','Compreende a remuneração do pessoal ativo civil abrangidos pelo RGPS, correspondente ao somatório das variações patrimoniais diminutivas com vencimentos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do emprego, inclusive os ocupantes de cargos em comissão não investidos em cargo efetivo, no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.01.00.00.00.00','VENCIMENTOS E VANTAGENS FIXAS - PESSOAL CIVIL - RGPS','Registra o valor das apropriações das variações patrimoniais diminutivas com vencimentos  e vantagens fixas do pessoal civil do tipo: gratificação, representação, adicional insalubridade, férias, 13 salário, licença-prêmio, abono pecuniario, adicional noturno, etc.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.00.00.00.00','OUTRAS VPD VARIAVEIS - PESSOAL CIVIL - RGPS','Compreende o valor das apropriações das variações patrimoniais diminutivas com outras despesas variaveis - pessoal civil abrangidos pelo regime geral, relacionadas as atividades do cargo ou função do empregado e cujo pagamento só se realiza  em circustancias especiais.                                                            ','D','N','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.01.00.00.00','SUBSTITUIÇÕES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a substituicoes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.02.00.00.00','ADICIONAL VARIÁVEL','Registra as variacoes patrimoniais diminutivas realizadas a titulo de adicional variavel sujeitos a incidencia de tributos e contribuicoes de acordo com a lei 10.973/04 - distribuicao de royalties.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.03.00.00.00','SERVIÇOS EXTRAORDINÁRIOS','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a servicos extraordinarios.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.05.00.00.00','AVISO PRÉVIO','Registra as variações patrimoniais diminutivas com aviso prévio.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.06.00.00.00','PARTICIPAÇÃO A EMPREGADOS E ADMINISTRADORES','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a participacao a empregados e administradores.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.07.00.00.00','GRATIFICAÇÃO ELEITORAL (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a gratificacao eleitoral.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.08.00.00.00','CONVOCACAO EXTRAORDINARIA LEGISLATIVA (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a convocacao extraordinaria legislativa.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.09.00.00.00','AUXILIO MORADIA (RGPS)','Registra as variações patrimoniais diminutivas ocorridas no patrimônio com despesas de pessoal, referente a auxilio moradia.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.02.99.00.00.00','OUTRAS DESPESAS VARIAVEIS - PESSOAL CIVIL','Registra o valor de outras VPD variáveis – pessoal civil RGPS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.03.00.00.00.00','SENTENCAS JUDICIAIS','Registra as variações patrimoniais diminutivas provenientes de sentencas judiciais','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.2.1.04.00.00.00.00','CONTRATACAO POR TEMPO DETERMINADO','Registra o valor das apropriações de variações patrimoniais diminutivas com a contratação de pessoal por tempo determinado para atender a necessidade temporaria de excepcional interesse publico, de acordo com legislação especifica de cada ente da federação, inclusive obrigações patronais e outras despesas variaveis, quando for o caso.                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.3.0.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR – ABRANGIDOS PELO RPPS','Compreende a remuneração do pessoal ativo militar, abrangido por regime prórpio dos militares ou não, corresponcente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efeitvo exercício do cargo ou função de confiança no setor público.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.1.3.1.00.00.00.00.00','REMUNERAÇÃO A PESSOAL ATIVO MILITAR – ABRANGIDOS PELO RPPS','Registra a remuneração do pessoal ativo militar, abrangidos por regime próprio dos militares ou não, correspondente ao somatório das variações patrimoniais diminutivas com soldos e vantagens pecuniárias fixas e variáveis estabelecidas em lei decorrentes do pagamento pelo efetivo exercício do cargo ou função de confiança no setor público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.0.0.00.00.00.00.00','ENCARGOS PATRONAIS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores e empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como contribuições a entidades fechadas de previdência e ainda outras contribuições patronais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.0.00.00.00.00.00','ENCARGOS PATRONAIS - RPPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.00.00.00.00.00','ENCARGOS PATRONAIS - RPPS - INTRA OFSS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos servidores públicos ativos, pertencentes aos órgãos e demais entidades do setor público.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.01.00.00.00.00','CONTRIBUICAO PATRONAL PARA O RPPS','Registra as variações patrimoniais diminutivas provenientes de contribuições patronais para custeio do plano de seguridade social do servidor.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.02.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas   realizadas com encargos de pessoal requisitado de outros entes da federação.                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.1.2.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RPPS','Registra as variações patrimoniais diminutivas   realizadas com outras obrigações patronais ao RPPS, não classificaveis nos subitens anteriores.                             ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.0.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos, em cargo efetivo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - CONSOLIDAÇÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.01.00.00.00.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','Registra as variações patrimoniais diminutivas   realizadas por orgãos, fundos ou entidades que não pertençam aos orcamentos fiscal e da seguridade social, relativas a contribuições previdenciarias ao INSS.                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.04.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas   realizadas com encargos de pessoal requisitado de outros entes da federação.                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.05.00.00.00.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS referente a prorrogação do salário maternidade.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.06.00.00.00.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','Registra as variações patrimoniais diminutivas realizadas a título de contribuição para o PIS, determinada com base na folha de pagamento, a alíquota de 1%, pelas fundações públicas instituídas ou mantidas pelo Poder Público (MP 2.158-35/2001).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.1.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RGPS','Registra as variações patrimoniais diminutivas   realizadas com outras obrigações patronais ao RGPS, não classificaveis nos subitens anteriores.                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.2.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTRA OFSS','Registra os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - UNIÃO','Compreende os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.01.00.00.00.00','CONTRIBUICOES PREVIDENCIARIAS - INSS','Registra as variações patrimoniais diminutivas   realizadas por orgãos, fundos ou entidades que não pertençam aos orcamentos fiscal e da seguridade social, relativas a contribuições previdenciarias ao INSS.                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.04.00.00.00.00','ENCARGOS DE PESSOAL REQUISITADO DE OUTROS ENTES','Registra as variações patrimoniais diminutivas   realizadas com encargos de pessoal requisitado de outros entes da federação.                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.05.00.00.00.00','CONTRIBUIÇÃO PREVIDENCIÁRIA INSS PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra o valor das variações patrimoniais diminutivas realizadas por órgãos, fundos ou entidades que não pertençam aos orçamentos fiscal e da seguridade social, relativas a contribuições previdenciárias ao INSS referente a prorrogação do salário maternidade.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.06.00.00.00.00','CONTRIBUIÇÃO PARA O PIS SOBRE FOLHA DE PAGAMENTO','Registra as variações patrimoniais diminutivas realizadas a título de contribuição para o PIS, determinada com base na folha de pagamento, a alíquota de 1%, pelas fundações públicas instituídas ou mantidas pelo Poder Público (MP 2.158-35/2001).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.3.99.00.00.00.00','OUTROS ENCARGOS PATRONAIS - RGPS','Registra as variações patrimoniais diminutivas   realizadas com outras obrigações patronais ao RGPS, não classificaveis nos subitens anteriores.                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.4.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - ESTADO','Registra os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investido em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.2.5.00.00.00.00.00','ENCARGOS PATRONAIS - RGPS - INTER OFSS - MUNICÍPIO','Registra os encargos trabalhistas de responsabilidade do empregador, incidentes sobre a folha de pagamento dos empregados ativos, pertencentes aos órgãos e demais entidades do setor público, bem como ocupantes de cargo em comissão não investidos em cargo efetivo. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.0.00.00.00.00.00','ENCARGOS PATRONAIS - FGTS','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos o','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.00.00.00.00.00','ENCARGOS PATRONAIS - FGTS - CONSOLIDAÇÃO','Compreende os valores recolhidos mensalmente pelos empregadores, em conta bancaria vinculada do trabalhador no FGTS, correspondente a percentual definido em lei sobre a remuneração paga ou devida, no mês anterior, a cada trabalhador, incluídas na remuneração as parcelas de que tratam os artigos. 457 e 458 da CLT e a gratificação de natal a que se refere à lei nº 4.090, de 13 de julho de 1962, com as modificações da lei nº 4.749, de 12 de agosto de 1965. Entende-se por empregador a pessoa física ou a pessoa jurídica de direito privado ou de direito público, da administração pública direta, indireta ou fundacional de qualquer dos poderes, da União, dos estados, do distrito federal e dos municípios, que admitir trabalhadores a seu serviço, bem assim aquele que, regido por legislação especial, encontrar-se nessa condição ou figurar como fornecedor ou tomador de mão de obra, independente da responsabilidade solidaria e/ou subsidiaria a que eventualmente venha obrigar-se. Considera-se trabalhador toda pessoa física que prestar serviços a empregador, a locador ou tomador de mão de obra, excluídos os eventuais, os autônomos e os servidores públicos civis e militares sujeitos a regime jurídico próprio. O recolhimento do FGTS e obrigatório também nos casos de afastamento para prestação do serviço militar obrigatório e licença por acidente do trabalho. Não se incluem na remuneração, para os fins desta lei, as parcelas elencadas no § 9º do art. 28 da lei nº 8.212, de 24 de julho de 1991. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.01.00.00.00.00','FGTS','Registra as variações patrimoniais diminutivas   realizadas com obrigações relativas ao recolhimento do FGTS.                                             ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.3.1.03.00.00.00.00','FGTS - PRORROGAÇÃO SALÁRIO MATERNIDADE','Registra os valores das variações patrimoniais diminutivas realizadas com obrigações relativas ao recolhimento do FGTS referente a prorrogação do salário maternidade.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.4.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS','Compreende os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.4.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS GERAIS - CONSOLIDAÇÃO','Registra os encargos patronais relativos ao salário educação e as contribuições compulsórias dos empregadores sobre a folha de salários, destinados as entidades privadas de serviço social e de formação profissional, vinculadas ao sistema sindical, tais como SESI, SENAI, SESC e SENAC. Compreende os saldos que não serão excluídos nos demonstrativos  consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.0.00.00.00.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA','Compreende o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.5.1.00.00.00.00.00','CONTRIBUIÇÕES A ENTIDADES FECHADAS DE PREVIDÊNCIA - CONSOLIDAÇÃO','Registra o valor total das variações patrimoniais diminutivas relacionadas ao regime de previdência privada, de caráter complementar, organizado de forma autônoma em relação ao regime geral de previdência social, de caráter facultativo, baseado na constituição de reservas que garantam o benefício, nos termos do caput do art. 202 da constituição federal. Entende-se por entidades fechadas aquelas acessíveis, na forma regulamentada pelo órgão regulador e fiscalizador, exclusivamente aos empregados de uma empresa ou grupo de empresas e aos servidores da União, dos estados, do distrito federal e dos municípios, entes denominados patrocinadores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.0.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuiçãopatronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.02.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.03.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.04.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR INATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor inativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.05.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a saúde do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.1.06.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO PENSIONISTA','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do pensionista, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTRA OFSS','Compreende outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O ATENDIMENTO A SAÚDE DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuiçãopatronal para o atendimento a saúde do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.2.02.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA A ASSISTÊNCIA SOCIAL DO SERVIDOR ATIVO','Registra as variações patrimoniais diminutivas executadas a titulo de contribuição patronal para o atendimento a assistência social do servidor ativo, as entidades da administração indireta e as unidades orçamentárias, constantes do orçamento integrado do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.3.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - UNIÃO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.4.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - ESTADO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.2.9.5.00.00.00.00.00','OUTROS ENCARGOS PATRONAIS - INTER OFSS - MUNICÍPIO','Registra outras variações patrimoniais diminutivas, relacionadas aos encargos patronais, não abrangidas nos grupos anteriores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.0.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal civil e militar , tais como para o pessoal civil: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxilia-alimentação, auxilia-transporte bem como outros decorrentes de acordo ou convenção coletiva no que se refere aos empregados públicos.  Para os militares: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo as despesas com vencimentos, soldos e quaisquer outras vantagens pecuniárias, bem como as despesas relacionadas aos benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RPPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RPPS - CONSOLIDAÇÃO','Compreende o valor total das  variações patrimoniais diminutivas com benefícios a servidor público, tais como: ajuda-de-custo, indenização de transporte, auxílio-moradia, auxílio-transporte,auxílio-alimentação e outros benefícios relativos ao local ou a natureza do trabalho. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias permanentes, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.01.00.00.00.00','AUXILIO ALIMENTACAO','Registra as variações patrimoniais diminutivas provenientes de  despesas com auxílio-alimentação pago/fornecido aos servidores ou empregados da administração pública direta e indireta, em pecunia.                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.02.00.00.00.00','AUXILIO TRANSPORTE','Registra as variações patrimoniais diminutivas   com auxilio-transporte pagas em forma de pecunia diretamente aos servidores, destinado ao custeio parcial das despesas realizadas com transporte coletivo municipal intermunicipal ou interestadual nos deslocamentos de suas residencias para os locais de trabalho e vice-versa, ou trabalho-trabalho nos casos de acumulação licita de cargos.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.1.1.04.00.00.00.00','AJUDA DE CUSTO  ','Registra as variações patrimoniais diminutivas realizadas a titulo de ajuda de custo de pessoal civil. ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RGPS','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídos deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídas ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizado e outras.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - RGPS - CONSOLIDAÇÃO','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos aos empregados públicos, e ainda outros relativos a acordo ou convenção coletiva. Estão excluídas deste grupo os vencimentos e quaisquer outras vantagens pecuniárias, bem como os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde. Estão excluídos ainda as indenizações e restituições trabalhistas decorrentes da perda da condição de servidor ou empregado, tais como ferias, aviso prévio indenizados e outras. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.01.00.00.00.00','AUXILIO ALIMENTACAO','Registra as variações patrimoniais diminutivas provenientes de  despesas com auxílio-alimentação pago/fornecido aos servidores ou empregados da administração pública direta e indireta, em pecunia.                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.2.1.02.00.00.00.00','AUXILIO TRANSPORTE','Registra as variações patrimoniais diminutivas   com auxilio-transporte pagas em forma de pecunia diretamente aos servidores, destinado ao custeio parcial das despesas realizadas com transporte coletivo municipal intermunicipal ou interestadual nos deslocamentos de suas residencias para os locais de trabalho e vice-versa, ou trabalho-trabalho nos casos de acumulação licita de cargos.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.3.0.00.00.00.00.00','BENEFÍCIOS A PESSOAL - MILITAR','Compreende o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílio-reclusão, auxílio-invalidez, assistência a saúde.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.3.3.1.00.00.00.00.00','BENEFÍCIOS A PESSOAL - MILITAR - CONSOLIDAÇÃO','Registra o valor total das variações patrimoniais diminutivas com benefícios devidos a pessoal militar, tais como: adicional de compensação orgânica não incorporada, gratificação de localidade especial, gratificação de representação, transporte, ajuda–de-custo, auxílio-fardamento, auxílio-alimentação e outros benefícios eventuais relativos ao local ou a natureza do trabalho. Estão excluídos deste grupo os soldos e quaisquer outras vantagens pecuniárias permanentes, bem como as os benefícios previdenciários ou assistenciais, tais como: aposentadoria, auxílio-natalidade, salário-família, licença para tratamento de saúde, licença a gestante, a adotante e licença-maternidade, licença por acidente em serviço, assistência a saúde, garantia de condições individuais e ambientais de trabalho satisfatórias, pensão vitalícia e temporária, auxílio-funeral, auxílioreclusão, auxílio-invalidez, assistência a saúde. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.0.0.00.00.00.00.00','CUSTO DE PESSOAL E ENCARGOS','Compreende a variação patrimonial diminutiva relativa à pessoal e encargos utilizados na produção de bens ou serviços, sendo Compreendeda apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS','Compreende as variações patrimoniais diminutivas relativas à pessoal e encargos apropriadas às mercadorias, sendo Compreendedas apenas no momento da venda destas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas a pessoal e encargos apropriadas as mercadorias, sendo registradas apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo Compreendedas apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas relativas à pessoal e encargos, utilizadas na produção de bens, sendo registradas apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo Compreendedas apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS – PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas relativas a pessoal e encargos, utilizadas na produção de serviços, sendo registrada apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores, tais como as indenizações e restituições trabalhistas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.0.00.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive férias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntário.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.00.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES TRABALHISTAS - CONSOLIDAÇÃO','Compreende o valor total com variações patrimoniais diminutivas resultante do pagamento efetuado a servidores públicos civis e empregados de entidades integrantes da administração pública, inclusive ferias e aviso prévio indenizados, multas e contribuições incidentes sobre os depósitos do fundo de garantia por tempo de serviço, etc., em função da perda da condição de servidor ou empregado, podendo ser em decorrência da participação em programa de desligamento voluntario. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.01.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - ATIVO CIVIL','Registra as variações patrimoniais diminutivas   referente a indenizações e  restituições trabalhistas do pessoal ativo civil, inclusive as despesas com programa de desligamento voluntario.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.1.1.03.00.00.00.00','INDENIZACOES E RESTITUICOES TRABALHISTAS - INATIVO CIVIL','Registra as variações patrimoniais diminutivas   referente a indenizações e restituições trabalhistas do pessoal  inativo civil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.2.0.00.00.00.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS','Compreende as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.2.1.00.00.00.00.00','PESSOAL REQUISITADO DE OUTROS ORGAOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas  com pessoal requisitado de outros órgãos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.9.0.00.00.00.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS','Compreende outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.1.9.9.1.00.00.00.00.00','OUTRAS VPD DE PESSOAL E ENCARGOS - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas, relacionadas com pessoal e encargos, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.0.0.0.00.00.00.00.00','BENEFICIOS PREVIDENCIARIOS E ASSISTENCIAIS','Compreendem as variações patrimoniais diminutivas relativas às aposentadorias, pensões, reformas, reserva remunerada e outros benefícios previdenciários de caráter contributivo, do regime próprio da previdência social - RPPS e do regime geral da previdência social – RGPS, bem como as ações de assistência social, que são políticas de seguridade social não contributiva, visando ao enfrentamento da pobreza, a garantia dos mínimos sociais, ao provimento de condições para atender contingencias sociais e a universalização dos direitos sociais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.0.0.00.00.00.00.00','APOSENTADORIAS E REFORMAS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.0.00.00.00.00.00','APOSENTADORIAS - RPPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.00.00.00.00.00','APOSENTADORIAS - RPPS - CONSOLIDAÇÃO','Compreende os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.01.00.00.00.00','PROVENTOS - PESSOAL CIVIL','Registra as Variações Patrimoniais Diminutivas   realizadas Aposentadoria de Pessoal Civil regidos pelo RPPS aprovada pelo Tribunal de Contas.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.06.00.00.00.00','13 SALARIO - PESSOAL CIVIL','Registra as variações patrimoniais diminutivas   realizadas a titulo de 13 salario - Pessoal Civil ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.1.1.99.00.00.00.00','OUTRAS APOSENTADORIAS','Registra as Variações Patrimoniais Diminutivas realizadas com outras Aposentadorias não classificaveis nos subitens anteriores e/ou valores relativos a integração de Balancetes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.2.0.00.00.00.00.00','APOSENTADORIAS - RGPS','Compreendem os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidas pelo RGPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.2.1.00.00.00.00.00','APOSENTADORIAS - RGPS - CONSOLIDAÇÃO','Registra os benefícios de prestação continuada assegurados pela previdência social com o objetivo de garantir meios indispensáveis de manutenção, por motivo de incapacidade, idade avançada e tempo de serviço, abrangidos pelo RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.3.0.00.00.00.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR','Compreende as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.3.1.00.00.00.00.00','RESERVA REMUNERADA E REFORMAS - MILITAR - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com reserva remunerada e reformas dos militares. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.9.0.00.00.00.00.00','OUTRAS APOSENTADORIAS','Compreende as variações patrimoniais diminutivas provenientes de outras aposentadorias','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.1.9.1.00.00.00.00.00','OUTRAS APOSENTADORIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outras aposentadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.0.0.00.00.00.00.00','PENSÕES','Compreendem os benefícios da previdência social que garantem uma renda aos dependentes do segurado falecido.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.0.00.00.00.00.00','PENSÕES - RPPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.1.1.00.00.00.00.00','PENSÕES - RPPS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, pelo regime próprio da previdência social - RPPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.2.0.00.00.00.00.00','PENSÕES - RGPS','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social –RGPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.2.1.00.00.00.00.00','PENSÕES - RGPS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos segurados, após seu óbito, regidos pelo regime geral da previdência social - RGPS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.3.0.00.00.00.00.00','PENSÕES - MILITAR','Compreende as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.3.1.00.00.00.00.00','PENSÕES - MILITAR - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com pagamento de pensões aos dependentes dos militares, após seu óbito, regidos pelo regime próprio. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.9.0.00.00.00.00.00','OUTRAS PENSÕES','Compreende as variações patrimoniais diminutivas provenientes de outras pensões.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.2.9.1.00.00.00.00.00','OUTRAS PENSÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outras pensões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.0.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem os benefícios de prestação continuada','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.1.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO','Compreendem os benefícios de prestação continuada ao idoso e renda mensal vitalícia por idade.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.1.1.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO IDOSO - CONSOLIDAÇÃO','Registra os benefícios de prestação continuada e renda mensal vitalícia por idade. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.2.0.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA','Compreendem os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia – invalidez','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.2.1.00.00.00.00.00','BENEFÍCIOS DE PRESTAÇÃO CONTINUADA AO PORTADOR DE DEFICIÊNCIA - CONSOLIDAÇÃO','Registra os benefícios de prestação continuada ao portador de deficiência e renda mensal vitalícia – invalidez. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA','Compreendem outros benefícios de prestação continuada.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.3.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS DE PRESTAÇÃO CONTINUADA - CONSOLIDAÇÃO','Registra outros benefícios de prestação continuada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.0.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS','Compreendem as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de nascimento, morte, situações de vulnerabilidade temporária e de calamidade pública. As provisões relativas a programas, projetos, serviços e benefícios diretamente vinculados ao campo da saúde, educação, integração nacional e das demais políticas setoriais não se incluem na modalidade de benefícios eventuais da assistência social.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.1.0.00.00.00.00.00','AUXÍLIO POR NATALIDADE','Compreende o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.1.1.00.00.00.00.00','AUXÍLIO POR NATALIDADE - CONSOLIDAÇÃO','Registra o beneficio eventual que visa o pagamento de auxílio por natalidade as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.2.0.00.00.00.00.00','AUXÍLIO POR MORTE','Compreende o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.2.1.00.00.00.00.00','AUXÍLIO POR MORTE - CONSOLIDAÇÃO','Registra o beneficio eventual que visa o pagamento de auxílio por morte as famílias cuja renda mensal per capita seja inferior a 1/4 (um quarto) do salário mínimo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.3.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA','Compreende as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.3.1.00.00.00.00.00','BENEFÍCIOS EVENTUAIS POR SITUAÇÕES DE VULNERABILIDADE TEMPORÁRIA - CONSOLIDAÇÃO','Registra as provisões suplementares e provisórias, prestadas aos cidadãos e as famílias em virtude de situações de vulnerabilidade temporária, com prioridade para a criança, a família, o idoso, a pessoa portadora de deficiência, a gestante e a nutriz. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.4.0.00.00.00.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA','Compreendem os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.4.1.00.00.00.00.00','BENEFÍCIOS EVENTUAIS EM CASO DE CALAMIDADE PÚBLICA - COSOLIDAÇÃO','Registra os benefícios para atendimento de vitimas de calamidade pública, de modo a assegurar - lhes a sobrevivência e a reconstrução de sua autonomia. Entende-se por estado de calamidade pública o reconhecimento pelo poder público de situação anormal, advinda de baixas ou altas temperaturas, tempestades, enchentes, inversão térmica, desabamentos, incêndios, epidemias, causando sérios danos à comunidade afetada, inclusive a incolumidade ou a vida de seus integrantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS EVENTUAIS','Compreende a variação patrimonial diminutiva proveniente de outros benefícios eventuais','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.4.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS EVENTUAIS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva proveniente de outros benefícios eventuais.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.5.0.0.00.00.00.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA','Compreende as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiárias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.5.0.1.00.00.00.00.00','POLÍTICAS PÚBLICAS DE TRANSFERÊNCIA DE RENDA - CONSOLIDAÇÃO','Registra as políticas públicas que visem contribuir para a redução da fome, da pobreza, da desigualdade e de outras formas de privação vividas pelas famílias mais excluídas, considerando três dimensões: o alivio imediato da pobreza, por meio da transferência de renda diretamente as famílias pobres e extremamente pobres; a contribuição para a redução da pobreza da geração seguinte, por meio do reforço do direito de acesso aos serviços de saúde e de educação, com o cumprimento das condicionalidades nestas áreas; e a articulação de ações complementares, de forma a desenvolver as capacidades das famílias beneficiarias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.0.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários ou assistenciais, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RPPS - CONSOLIDAÇÃO','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RPPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.01.00.00.00.00','AUXILIO FUNERAL ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL FALECIDO, ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.02.00.00.00.00','AUXILIO FUNERAL INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL FALECIDO, ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.05.00.00.00.00','AUXILIO RECLUSAO ATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR ATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.06.00.00.00.00','AUXILIO RECLUSAO INATIVO CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO RECLUSAO DEVIDO A FAMILIA DO SERVIDOR INATIVO CIVIL, AFASTADO POR MOTIVO DE PRISAO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.07.00.00.00.00','AUXILIO FUNERAL PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.08.00.00.00.00','AUXILIO RECLUSAO PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM O AUXILIO DEVIDO A FAMILIA DO SERVIDOR PENSIONISTA, EM VALOR EQUIVALENTE A UM MES DE REMUNERACAO OU PROVENTOS. DEVIDO TAMBEM A TERCEIRO QUE CUSTEAR COMPROVADAMENTE AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM FUNERAL DO PENSIONISTA.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.09.00.00.00.00','AUXILIO NATALIDADE PENSIONISTA CIVIL','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS DIMINUTIVAS COM AUXILIO NATALIDADE A PENSIONISTA CIVIL, DEVIDO A SERVIDORA, CONJUGE OU COMPANHEIRO SERVIDOR PUBLICO, POR MOTIVO DE NASCIMENTO DE FILHO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.10.00.00.00.00','AUXILIO-DOENCA','Registra as  variações patrimoniais diminutivas com auxilio-doença, devido ao segurado que  ficar incapacitado para o trabalho.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.11.00.00.00.00','SALARIO MATERNIDADE','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS COM SALARIOMATERNIDADE, DEVIDO A SEGURADA GESTANTE, NA FORMA DA LEI 6.136/74, DURANTE O PERIODO DE LICENCA GESTANTE PREVISTO EM LEI.                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.1.1.12.00.00.00.00','SALARIO-FAMILIA','Registra o valor das variações patrimoniais diminutivas com salario familia.                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.2.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.2.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - RGPS - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do RGPS, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.3.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR','Compreende outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.3.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS - MILITAR - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas, relacionadas com benefícios previdenciários do regime próprio dos militares, não abrangidas nos grupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.0.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS','Compreendem as variações patrimoniais diminutivas provenientes de outros benefícios previdenciários e assistenciais','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.2.9.9.1.00.00.00.00.00','OUTROS BENEFÍCIOS PREVIDENCIÁRIOS E ASSISTENCIAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de outros benefícios','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.0.0.0.00.00.00.00.00','USO DE BENS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende o somatório das variações patrimoniais diminutivas com manutenção e operação da maquina pública, exceto despesas com pessoal e encargos que serão Compreendedas em grupo específico (despesas de pessoal e encargos). Compreende: diárias, material de consumo, material de distribuição gratuita, passagens e despesas com locomoção, serviços de terceiros, arrendamento mercantil operacional, aluguel, depreciação, amortização, exaustão, entre outras.              ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.0.0.00.00.00.00.00','USO DE MATERIAL DE CONSUMO','Compreende as variações patrimoniais diminutivas provenientes da distribuição do material de consumo. Um material é considerado de consumo quando for de duração inferior a dois anos, frágil, perecível, incorporável, transformável ou cuja finalidade seja para consumo imediato ou para reposição.                                                    ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.0.00.00.00.00.00','CONSUMO DE MATERIAL','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.00.00.00.00.00','CONSUMO DE MATERIAL - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes de requisição de material de consumo para uso interno.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.01.00.00.00.00','COMBUSTIVEIS E LUBRIFICANTES AUTOMOTIVEIS','Registra as variações Patrimoniais Diminutivas provenientes da utilização de Combustíveis para motores a combustão interna de veículos rodoviários, tratores em geral, embarcações diversas e grupos geradores estacionados ou transportáveis, e todos os óleos lubrificantes destinados aos sistemas hidráulicos hidramáticos de caixa de transmissão de força e graxas grafitadas para altas e baixas temperaturas. aditivos - álcool hidratado - fluído para amortecedores - fluido para transmissão hidráulica - gasolina - graxas - óleo diesel - óleo para carter - óleo para freio e outros.                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.03.00.00.00.00','GAS E OUTROS MATERIAIS ENGARRAFADOS','Registra as variações patrimoniais diminutivas provenientes da utilização de gás de uso industrial, de tratamento de água, de iluminação, de uso médico, bem como gases nobres para uso em laboratório cientifico, tais como: acetileno - carbônico freon - helio - hidrogênio - Liquefeito de petróleo - nitrogênio - oxigênio e outros. Registra, ainda, o valor das despesas com gás, pó químico, água pressurizadas e outros materiais utilizado nas recargas de Extintores de Incêndio.   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.04.00.00.00.00','EXPLOSIVOS E MUNISSÕES','Registra as variações Patrimoniais Diminutivas provenientes da utilização de cargas de projeção em peças de artilharia, mísseis guiados e não guiados, capsulas ou estojos para recarga e explosivos de uso Militar e Paramilitar. balas e similares - estopim - explosivos, tais como: artefatos explosivos - artigos pirotécnicos - capsulas de detonação - dinamite - espoleta - fogos de artifício - granada - pólvora e outros.                                                                                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.05.00.00.00.00',' ALIMENTOS PARA ANIMAIS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de alimentos destinados a gado bovino, equino, muar, e bufalino, caprinos, suínos, ovinos, aves de qualquer espécie, como também para animais silvestres em cativeiro (jardins zoológicos ou laboratórios) e outros. alfafa - alpiste - capim verde - farelo - farinhas em geral - fubá grosso - milho em grão - ração balanceada - sal mineral - suplementos vitamínicos e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.06.00.00.00.00','GENEROS DE ALIMENTACAO','Registra as variações patrimoniais diminutivas provenientes da utilização de alimentos destinados a gado  bovino, equino, muar e bufalino, caprinos, suinos, ovinos,  aves  de  qualquer especie, como também para animais silvestres em cativeiro (jardins zoologicos ou laboratorios) e outros. Alfafa - alpiste - capim verde - farelo - farinhas em  geral  -  fuba grosso - milho em grão - ração balanceada - sal mineral - suplementos vitaminicos e outros.                                                 ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.07.00.00.00.00','ANIMAIS PARA PESQUISA E ABATE','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de animais para pesquisa e abate. Incluem-se nesta classificação os peixes e mariscos, todas as espécies de mamíferos, abelhas para estudos, pesquisa e produção de Mel, bem assim qualquer outro animal destinado a estudo genético ou alimentação. boi - cabrito - cobaias em geral - macaco - rato - rã e outros.    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.08.00.00.00.00','MATERIAL FARMACOLOGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de medicamentos ou componentes destinados a manipulação de drogas medicamentosas. medicamentos - soro - vacinas e outros.                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.09.00.00.00.00','MATERIAL ODONTOLOGICO','Registra as Variações Patronais Diminutivas provenientes da utilização de materiais para pacientes da área odontológica, bem como os utilizados indiretamente pelos protéticos na convecção de próteses diversas. agulhas - amalgama - anestésicos - broca - cimento odontológico - espátula odontológica - filmes para raio X - platina - resinas odontológicas - seringas - sugador e outros.                                                         ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.10.00.00.00.00',' MATERIAL QUIMICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os elementos ou compostos químicos destinados ao fabrico de Produtos químicos, análises laboratoriais, bem como aqueles destinados ao combate de pragas ou opizootias. ácidos - Inseticidas - produtos químicos para tratamento de água - reagentes químicos - sais - solventes - substâncias utilizadas para combater insetos, fungos e bactérias e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.11.00.00.00.00',' MATERIAL DE COUDELARIA OU DE USO ZOOTECNICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais utilizados no arreamento de animais destinados a montaria, com exceção da sela, como também aqueles destinados ao adestramento de cães de guarda ou outro animal domestico. argolas de metal - arreamento - barrigueiras - bridões - cabrestos - cinchas - Cravos - escovas para animais - estribos - ferraduras - mantas de pano - material para apicultura - material de ferragem e contenção de animais - peitorais -raspadeiras e outros.            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.13.00.00.00.00','MATERIAL DE CACA E PESCA','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais de caça e pesca.        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.14.00.00.00.00','MATERIAL EDUCATIVO E ESPORTIVO','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais consumidos diretamente nas atividades educativas e esportivas de crianças e adultos. apitos - bolas - bonés - botas especiais - brinquedos educativos - calções - camisas de malha – chuteiras – cordas – esteiras – joelheiras – luvas – materiais pedagógicos – meias – óculos para motociclistas – patins – quimonos – raquetes – redes para pratica de esportes – tênis e sapatilhas – tornozeleiras – touca para natação e outros.     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.15.00.00.00.00',' MATERIAL PARA  FESTIVIDADES E HOMENAGENS','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais de consumo utilizados em festividades e homenagens, incluindo artigos para decoração e Buffet. arranjos e coroas de flores - bebidas - doces - salgados - placas comemorativas (exceto as placas para distribuição gratuita) e outros.                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.16.00.00.00.00',' MATERIAL DE EXPEDIENTE','Registra as Variações Patrimoniais diminutivas provenientes da utilização de materiais aplicados diretamente nos trabalhos administrativos, nos escritórios públicos, nos centros de estudos e pesquisas, nas escolas, nas universidades etc. agenda - alfinete de aço - almofada p/carimbos - apagador - apontador de lápis - arquivo p/disquete - bandeja para papeis - bloco p/rascunho - bobina papel p/calculadoras - borracha - caderno - caneta -capa de processo - carimbos em geral - cartolina - classificador -clipe - cola - colchete - corretivo - envelope - espátula - estêncil -estilete - extrator de grampos - fita adesiva - fita p/maquina de escrever e calcular - giz - goma elástica - grafite - grampeador -grampos - guia p/arquivo - guia de endereçamento postal - impressos e formulários em geral - intercalador p/fichário - lacre - lápis -lapiseira - limpa tipos - livros de ata, de ponto e de protocolo -papeis - pastas em geral - percevejo - perfurador - pinça - placas de acrílico - plásticos - porta-lápis - registrador - régua - selos p/correspondência - tesoura - tintas - toner - transparências - etiquetas e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.17.00.00.00.00','MATERIAL DE PROCESSAMENTO DE DADOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de suprimentos de ti, inclusive pecas para reposição. cartuchos de tinta - capas plásticas protetoras para micros e impressoras - cd-rom virgem - disquetes - etiquetas em formulários - contínuos -leitora/smartcard - mouse e teclado (reposição) - mouse pad - pecas e acessórios para computadores e periféricos - recarga de cartuchos de tinta - toner para impressoras a laser - cartões magnéticos - reposição de leitora/token pen-drive/outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.18.00.00.00.00','MATERIAIS E MEDICAMENTOS P/ USO VETERINARIO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais e medicamentos para uso veterinário. vacinas – medicamentos.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.19.00.00.00.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais aplicados diretamente nas preservações, acomodações ou embalagens de qualquer produto. arame - barbante - caixas plásticas, de madeira, papelão e isopor -cordas - engradados - fitas de aço ou metálicas - fitas gomadoras -garrafas e potes - linha - papel de embrulho - papelão - sacolas - sacos - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.20.00.00.00.00','MATERIAL DE CAMA, MESA E BANHO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais utilizados em dormitórios coletivos, residenciais, hotéis, restaurantes etc. cobertores - colchas - colchonetes - fronhas - guardanapos - lençóis -toalhas - travesseiros - e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.21.00.00.00.00','MATERIAL DE COPA E COZINHA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para refeitórios de qualquer tipo, cozinhas residenciais, de hotéis, de hospitais, de escolas, de universidades, de fabricas etc. abridor de garrafa - açucareiros - artigos de vidro e plástico -bandejas - coadores - colheres - copos - ebulidores - facas - farinheiras - fósforos - frigideiras - garfos - garrafas térmicas - paliteiros - panelas - panos de cozinha - papel alumínio - pratos -recipientes para água - suportes de copos p/cafezinho - tigelas -velas - xícaras - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.22.00.00.00.00','MATERIAL DE LIMPEZA E PRODUTOS DE HIGIENIZACAO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais destinados a higienização pessoal, de ambientes de trabalho, de hospitais etc. álcool etílico - anticorrosivo - aparelho de barbear descartável -balde plástico - bomba p/inseticida - capacho - cera - cesto p/lixo- creme dental - desinfetante - desodorizante - detergente - escova de dentes - escova p/roupas e sapatos - espanador - esponja - estopa -flanela - inseticida - lustra-móveis - mangueira - naftalina - para lixo - palha de aço - panos p/limpeza - papel higiênico - pasta para Limpeza de utensílios – porta - sabão - removedor - rodo - sabão - sabonete - saco p/lixo - saponáceo - soda caustica - toalha de papel- vassoura - e outros.                                                                                                                                                                                                                                                                                                                                                                                                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.23.00.00.00.00','UNIFORMES, TECIDOS E AVIAMENTOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de uniformes ou qualquer tecido ou material sintético que se destine a confecção de roupas, com linhas de qualquer espécie destinadas a costuras e outros materiais de consumo empregados direta ou indiretamente na confecção de roupas. agasalhos - artigos de costura - aventais - blusas - botões - cadarços- calcados - calcas - camisas - capas - chapéus - cintos - elásticos -gravatas - guarda-pós - linhas - macacões - meias - tecidos em geral -uniformes militares ou de uso civil - zíperes - e outros.                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.24.00.00.00.00',' MATERIAL PARA MANUTENÇÃO DE BENS IMOVEIS/INSTALACOES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para aplicação, manutenção e reposição de qualquer bem publico. amianto - aparelhos sanitários - arames liso e farpado - areia -basculante - boca de lobo - boia - brita - brocha - cabo metálico -cal - cano - cerâmica - cimento - cola - condutores de fios - conexões- curvas - esquadrias - fechaduras - ferro - gaxetas - grades -impermeabilizantes - isolantes acústicos e térmicos - janelas - joelhos - ladrilhos - lavatórios - lixas - madeira - marcos de concreto - massa corrida - niple - papel de parede - parafusos - - pecas p/elevadores, portões elétricos, ar condicionado central, etc- pias- pigmentos - portas e portais - pregos - rolos solventes - sifão -tacos - tampa p/vaso - tampão de ferro - tanque - tela de estuque -telha - tijolo - tinta - torneira - trincha - tubo de concreto -válvulas - verniz - vidro - aquecedores a gás e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.25.00.00.00.00','MATERIAL PARA MANUTENCAO DE BENS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de componentes, pecas, acessórios e sobressalentes para aplicação, manutenção e reposição em bens moveis em geral. cabos - chaves - cilindros p/maquinas copiadoras - compressor p/ar condicionado - mangueira p/fogão - pecas de reposição de aparelhos e maquinas em geral - materiais de reposição para instrumentos musicais - vidro de mesa e outros.                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.26.00.00.00.00','MATERIAL ELETRICO E ELETRONICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para aplicação, manutenção e reposição dos sistemas, aparelhos e equipamentos elétricos e eletrônicos. benjamins - bocais - calhas - capacitores e resistores - chaves de ligação - circuitos eletrônicos - condutores - componentes de aparelho eletrônico - diodos - disjuntores - eletrodos - eliminador de pilhas -espelhos para interruptores - fios e cabos - fita isolante - fusíveis- interruptores - lâmpadas e luminárias - pilhas e baterias - pinos e plugs - placas de baquelita - reatores - receptáculos - resistências -starts - suportes - tomada de corrente - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.27.00.00.00.00',' MATERIAL DE MANOBRA E PATRULHAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo utilizados em campanha militar ou paramilitar, em manobras de tropas, em treinamento ou em ação em patrulhamento ostensivo ou rodoviário, em campanha de saúde publica etc. binóculo - carta náutica - cantil - cordas - flâmulas e bandeiras desinalizacao - lanternas - medicamentos de prontosocorro - mochilas -piquetes - sacolas - sacos de dormir - sinaleiros - e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.28.00.00.00.00','MATERIAL DE PROTECAO E SEGURANCA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo utilizados diretamente na proteção de pessoas ou bens públicos, para socorro de pessoas e animais ou para socorro de veículos, aeronaves e embarcações, assim como qualquer outro item aplicado diretamente nas atividades de sobrevivência de pessoas, na selva, no mar ou em sinistros diversos. botas - cadeados - calcados especiais - capacetes - chaves - cintos - coletes - dedais - guarda-chuvas - lona - luvas - mangueira de lona -mascaras - passadeira antiderrapante - óculos - cabina de papelão e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.29.00.00.00.00','MATERIAL PARA  AUDIO, VIDEO E FOTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo de emprego direto em filmagem e revelação, ampliações e reproduções de sons e imagens. aetze especial p/chapa de papel - álbuns p/retratos - alto-falantes- antenas - artigos para gravação em acetato - filmes virgens - fitas virgens de áudio e vídeo - lâmpadas especiais - material p/radiografia, microfilmagem e cinematografia - molduras - papel p/revelação de fotografias - pegadores - reveladores - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.30.00.00.00.00',' MATERIAL PARA COMUNICACOES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para comunicações, assim como os componentes, circuitos impressos ou integrados, pecas ou acessórios de reposição, chips, e partes de equipamentos de comunicação materiais para instalações: radiofônicas, radiotelegráficas, telegráficas e outros. - bateria para telefone celular- bloqueador telefônico - chave comutadora para telefone - fio para telefone - tomada para telefone - materiais para instalações radiofônicas - radiotelegráficas - telegráficas - outros.                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.31.00.00.00.00','SEMENTES, MUDAS DE PLANTAS E INSUMOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de qualquer tipo de semente destinada ao plantio e mudas de plantas frutíferas ou ornamentais, assim como todos os insumos utilizados para fertilização. adubos - argila - plantas ornamentais - borbulhas - bulbos - enxertos- fertilizantes - mudas envasadas ou com raízes nuas - sementes -terra - tubérculos - xaxim - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.32.00.00.00.00','SUPRIMENTO DE AVIACAO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de suplementos para avaliação.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.33.00.00.00.00','MATERIAL PARA PRODUCAO INDUSTRIAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de matérias-primas utilizadas na transformação, beneficiamento e industrialização de um produto final. borracha - couro - matérias-primas em geral - minérios - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.34.00.00.00.00','SUPRIMENTOS PARA MAQ.E MOTORES NAVIOS E EMBARCACOES','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material para manutenção e reparo de maquinas e motores de navios, inclusive da esquadra, e de embarcações em geral.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.35.00.00.00.00','MATERIAL LABORATORIAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os utensílios usados em analises laboratoriais. almofarizes - bastões - bico de gás - cálices - corantes - filtros de papel - fixadoras - frascos - funis - garra metálica - laminas de vidro p/microscópio - lâmpadas especiais - luvas de borracha - metáfise metaloides p/analise - pinças - rolhas - vidraria: balão volumétrico - becker - conta-gotas - erlemeyer - pipeta - proveta - termômetrotubo de ensaio - material de laboratório didático e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.36.00.00.00.00','MATERIAL HOSPITALAR','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais de consumo para área hospitalar ou ambulatorial. agulhas hipodérmicas - algodão - cânulas - cateteres - compressa de gaze - drenos - esparadrapo - fios cirúrgicos - laminas p/ bisturi -luvas - seringas - termômetro clinico - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.37.00.00.00.00','SUPRIMENTOS DE ARMAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Suprimentos de Armamento.                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.38.00.00.00.00','SUPRIMENTO DE PROTECAO AO VOO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Suprimentos de proteção ao Voo.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.39.00.00.00.00','MATERIAL PARA MANUTENCAO DE VEICULOS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para aplicação e manutenção de veículos rodoviários, viaturas blindadas e tratores em geral. água destilada - amortecedores - baterias - borrachas - buzina - cabos de acelerador - cabos de embreagem - camará de ar - carburador completo - cifa - colar de embreagem - condensador e platinado - correias- disco de embreagem - ignição - junta homocinetica - lâmpadas e lanternas p/veículos - lonas e pastilhas de freio - mangueiras -material utilizado em lanternagem e pintura - motor de reposição -para-brisa - para-choque - platô - pneus - reparos - retentores -retrovisores - rolamentos - tapetes - válvula da marcha lenta e termostática - velas - e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.40.00.00.00.00','MATERIAL BIOLOGICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de Material Biológico.                                                                                                                                                                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.41.00.00.00.00','MATERIAL PARA UTILIZACAO EM GRAFICA','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os materiais de consumo de uso gráfico, tais como: chapas de offset - clichês - cola - espirais - fotolitos - logotipos - papel - solventes - tinta - tipos - e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.42.00.00.00.00','FERRAMENTAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de todos os tipos de ferramentas utilizadas em oficinas, carpintarias, jardins etc. alicate - broca - caixa p/ferramentas - canivete - chaves em geral -enxada - espátulas - ferro de solda - foice - lamina de serra - lima -machado - martelo - pá - picareta - ponteira - prumo - serrote -tesoura de podar - trena - e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.43.00.00.00.00','MATERIAL PARA REABILITACAO PROFISSIONAL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para programas de reabilitação profissional. bastões - bengalas - joelheiras - meias elásticas e assemelhados -óculos - orteses - pesos - próteses, instrumentos de trabalho e implementos profissionais.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.44.00.00.00.00','MATERIAL DE SINALIZACAO VISUAL E OUTROS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para identificação, sinalização visual, endereçamento e outros. placas de sinalização em geral, tais como, placas indicativas para o setores e seções, placas para veículos, plaquetas para tombamento de material, placas sinalizadoras de trânsito, cones sinalizadores de trânsito, crachás, botons identificadores para servidores e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.45.00.00.00.00','MATERIAL TECNICO PARA SELECAO E TREINAMENTO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais técnicos utilizados em processos de seleção e treinamento pela própria unidade gestora ou para distribuição não gratuita, tais como: apostilas e similares - folhetos de orientação - livros - manuais explicativos para candidatos - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.46.00.00.00.00','MATERIAL BIBLIOGRAFICO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material bibliográfico tais como: jornais - revistas - periódicos em geral - anuários médicos - anuário estático - livros em geral e outros, podendo estar na forma de cd-rom e os materiais bibliográficos para bibliotecas publicas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.48.00.00.00.00','BENS MÓVEIS NÃO ATIVÁVEIS','Registra as Variações Patrimoniais Diminutivas provenientes da aquisição de bens moveis de natureza permanente não ativáveis, ou seja, aqueles considerados como despesa operacional, para fins de dedução de imposto de renda, desde que atenda as especificações contidas no artigo 301 do rir (regulamento de imposto de renda). esta conta é utilizada exclusivamente pelas unidades regidas pela lei 6404/76.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.49.00.00.00.00',' BILHETES DE PASSAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de bilhetes de passagem para guarda em estoque.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.50.00.00.00.00','BANDEIRAS, FLAMULAS E INSIGNIAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de bandeiras, flâmulas e insígnias, a saber: brasões, escudos, armas da republica, selo nacional e outros.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.51.00.00.00.00','DISCOTECAS E FILMOTECAS NAO IMOBILIZAVEL','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de discotecas e filmotecas não imobilizável.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.52.00.00.00.00','MATERIAL DE CARÁTER SECRETO OU RESERVADO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material de caráter secreto ou reservado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.54.00.00.00.00','MATERIAL PARA MANUTENÇÃO E CONSERVAÇÃO DE ESTRADAS E VIAS','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de materiais para reparos, recuperações e adaptações de estradas, ferrovias e rodovias.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.58.00.00.00.00','SOBRESSALENTES PARA MÁQUINAS E EQUP. PARA PRODUÇÃO INDUSTRIAL','Registra as Variações Patrimoniais Diminutivas provenientes de Sobressalentes para Máquinas e Equipamentos para Produção Industrial.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.70.00.00.00.00','AQUISIÇÃO DE SOFTWARES DE BASE','Registra as Variações Patrimoniais Diminutivas provenientes da aquisição de Softwares de Base.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.71.00.00.00.00','MATERIAIS PARA CONSERVAÇÃO E MANUTENÇÃO DE BENS DE USO COMUM DO POVO','Registra as Variações Patrimoniais Diminutivas provenientes de Materiais para Conservação e Manutenção de Bens de uso Comum do Povo.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.98.00.00.00.00','SENTENÇAS JUDICIAIS DE FORNECEDORES DE MATERIAIS','Registra as Variações Patrimoniais Diminutivas provenientes de Sentenças Judiciais de Fornecedores de Materiais.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.1.1.99.00.00.00.00','OUTROS MATERIAIS DE CONSUMO','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de outros materiais de consumo que não se enquadrem nas rubricas anteriores.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.0.00.00.00.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.00.00.00.00.00','DISTRIBUIÇÃO DE MATERIAL GRATUITO - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da distribuição de material gratuito. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.01.00.00.00.00','MERCADORIAS DOADAS','Registra as variações patrimoniais diminutivas provenientes da utilização de produtos adquiridos com a finalidade de doação.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.02.00.00.00.00','MATERIAL DESTINADO A ASSISTENCIA SOCIAL','Registra as variações patrimoniais diminutivas provenientes da utilização de mat.de saúde(farmacológico,odontológico,hospitalar,medicamentos,órtese e prótese),gêneros alimentícios, mater.de cama,mesa,copa,cozinha,limpeza,higienização, uniformes, tecidos, aviamentos,manut.mov/imov.,ferramentas e outros distinados a assistencia social.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.03.00.00.00.00','MATERIAL EDUCACIONAL E CULTURAL','Registra as variações patrimoniais diminutivas provenientes da utilização de material   educacional (material escolar, didatico, tecnico, material p/audio, video e  foto) e material cultural (material religioso e esportivo).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.04.00.00.00.00','MATERIAL PARA CERIMONIAL','Registra as variações patrimoniais diminutivas provenientes da aquisição de materiais oferecidos a autoridades a titulo de homenagem.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.05.00.00.00.00','MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as Variações Patrimoniais Diminutivas provenientes da utilização de material de acondicionamento e embalagem','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.06.00.00.00.00','MATERIAL PARA DIVULGACAO','Registra as variações patrimoniais diminutivas provenientes da utilização de material para publicidade e divulgação de programas do governo, para conscientizacao social. ex: camisetas, bonés, chaveiros, canetas, botons, com logomarcas,folders,cartazes,cartilhas e manuais,etc.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.12.00.00.00.00','MATERIAL DESTINADO A CONTRIBUINTE','Registra as variações patrimoniais diminutivas provenientes da utilização de material (cd-rom, formulários, etc.) para distribuição aos contribuintes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.13.00.00.00.00','MATERIAL P/ IDENTIFICACAO DE BENEFICIARIOS','Registra as Variações Patrimoniais Diminutivas provenientes da distribuição de Material para Identificação de Beneficiários.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.1.2.1.99.00.00.00.00','OUTROS MATERIAIS DE DISTRIBUICAO GRATUITA','Registra as variações patrimoniais diminutivas provenientes da utilização de materiais para distribuição gratuita, não contemplados em rubricas especificas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.0.0.00.00.00.00.00','SERVIÇOS','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços fornecidas à entidade governamental.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.0.00.00.00.00.00','DIÁRIAS','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.00.00.00.00.00','DIÁRIAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da utilização de diárias pagas aos servidores, empregados públicos e colaboradores eventuais, para fazer face a despesas com pousada, alimentação e locomoção urbana.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.01.00.00.00.00',' DIARIAS  PESSOAL CIVIL','Registra as variações patrimoniais diminutivas provenientes da utilização de diarias de  pessoal  civil, cobrindo alimentação, pousada e locomoção urbana do  servidor  publico ou celetista que se deslocar de sua sede em objeto de servico, em carater eventual ou transitorio.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.02.00.00.00.00','DIARIAS - PESSOAL MILITAR','Registra AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE DIARIAS DECORRENTES DO DESLOCAMENTO DO MILITAR DA SEDE DE SUA UNIDADE POR MOTIVO DE SERVICO, DESTINADAS AA INDENIZACAO DAS DESPESAS DE ALIMENTACAO E POUSADA.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.03.00.00.00.00','DIARIAS - COLABORADORES EVENTUAIS','Registra as variações patrimoniais diminutivas provenientes da utilização de diarias pagas a prestadores de  servicos de carater eventual, sem vinculo com a administração publica.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.1.1.04.00.00.00.00','DIARIAS A CONSELHEIROS','Registra as variações patrimoniais diminutivas provenientes da utilização de diarias a membros de orgãos de deliberação coletiva (conselhos).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.0.00.00.00.00.00','SERVIÇOS TERCEIROS - PF','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.00.00.00.00.00','SERVIÇOS TERCEIROS - PF - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa física fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.01.00.00.00.00','CONSULTORIA E ASSESSORIA','REGISTRA  AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVICOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.02.00.00.00.00','PERICIAS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE PERICIAS REALIZADAS POR PROFISSIONAIS TECNICOS.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.03.00.00.00.00','AUDITORIA EXTERNA','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de auditoria.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.04.00.00.00.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços advocaticios decorrentes do onus da sucumbencia, entendido este como o onus que recai sobre a parte vencida numa ação, para pagamento dos  honorarios advocaticios a vencedora.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.05.00.00.00.00','SERVICOS MEDICOS E ODONTOLOGICOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços medicos e odontologicos    prestados por pessoa fisica, sem vinculo empregaticio. consultas - raio x - tratamento odontologico – e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.06.00.00.00.00','SELECAO E TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NAS AREAS DE INSTRUCAO E ORIENTACAO PROFISSIONAL, RECRUTAMENTO E SELECAO DE PESSOAL E TREINAMENTO, POR PESSOA FISICA, INCLUSIVE A GRATIFICACAO POR ENCARGO DE CURSO OU CONCURSO, NORMATIZADA PELO ART. 76-A, DA LEI 8112/90 E O DECRETO 6114/2007, BOLSA SENIOR (SERVIDORES APOSENTADOS DO ORGAO) BOLSA DE MULTIPLICADORES (SERVIDORES DA ATIVA DO ORGAO).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.07.00.00.00.00','COMUNICACAO EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE COMUNICACAO GERAL PRESTADOS POR PESSOA FISICA, TAIS COMO: CONFECCAO DE MATERIAL P/ COMUNICACAO VISUAL; GERACAO DE MATERIAS PARA DIVULGACAO POR MEIO DOS VEICULOS DE COMUNICACAO; E OUTROS.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.08.00.00.00.00','LIMPEZA E CONSERVACAO','Registra as variações patrimoniais diminutivas proveniente da utilização de servicos de limpeza e conservação de bens imoveis - dedetização - faxina - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.09.00.00.00.00','SERVICOS DOMESTICOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços  domesticos  prestados  por pessoa fisica sem vinculo empregaticio, tais como: cozinha - lavagem de roupas – e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.10.00.00.00.00','VIGILANCIA OSTENSIVA','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE VIGILANCIA OSTENSIVA NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.11.00.00.00.00','MANUTENCAO E CONSERVACAO','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE MANUTENCAO E CONSERVACAO DE BENS MOVEIS E IMOVEIS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.12.00.00.00.00','CONDOMINIOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços condominiais a conta do locatorio, quando previstas no contrato de locação.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.13.00.00.00.00','COMISSOES E CORRETAGENS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por:  corretores - despachantes - leiloeiros - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.14.00.00.00.00','DIREITOS AUTORAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de direitos autorais de propriedade de terceiros sobre obras  cientificas, literarias, etc, em que a divulgação seja de interesse do governo.  Registra o valor referente a utilização de serviços decorrentes de incentivos aos autores  a titulo de royalties.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.15.00.00.00.00','SERVICOS TECNICOS PROFISSIONAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por profissionais tecnicos, nas seguintes areas: administração - advocacia - arquitetura - contabilidade -  economia  - engenharia - estatistica e outras.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.16.00.00.00.00','ESTAGIARIOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por estudantes na condição de estagiarios ou monitores.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.18.00.00.00.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS PRESTADOS NA MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.19.00.00.00.00','CONFERENCIAS, EXPOSICOES E ESPETACULOS','Registra as variações patrimoniais diminutivas proveniente da utilização de servicos prestados por conferencistas, expositores e artistas pelos serviços prestados.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.20.00.00.00.00','ARMAZENAGEM','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de  aluguel de galpões, silos e outros locais destinados a armazenagem de mercadorias e produtos. Inclui, ainda, os dispendios de garantia dos estoques armazenados.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.21.00.00.00.00','LOCACOES','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de  locação de bens moveis e imoveis.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.22.00.00.00.00','FORNECIMENTO DE ALIMENTACAO','Registra as variações patrimoniais diminutivas proveniente da utilização de refeições  preparadas, inclusive lanches e similares.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.24.00.00.00.00','SERVICOS DE REABILITACAO PROFISSIONAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de reabilitação profissional prestados por pessoa fisica sem vinculo empregaticio, como objetivo de proporcionar aos incapacitados (parcial ou totalmente)  os meios indicados para a reeducação e readaptação profissional e social, de modo que possam voltar a participar do mercado de trabalho.  Ex: contratação de profissional para ministrar curso profissionalizante.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.25.00.00.00.00','SERVICOS DE ASSISTENCIA SOCIAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços  de  assistencia social prestados por pessoa fisica sem vinculo empregaticio a servidores, segurados carentes, abrigados, internados e a  seus  dependentes, tais como ajuda de custo supletiva, generos  alimenticios, documentação, transporte e sepultamento.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.26.00.00.00.00','SERVIÇO DE APOIO ADMINISTRATIVO, TECNICO E OPERACIONAL','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de natureza eventual prestados por pessoa fisica, tais como: assistencia tecnica - capina - jardinagem - operadores de  maquinas  e motoristas - recepcionistas - serviços auxiliares - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.27.00.00.00.00','SERVIÇO DE CONSERVAÇÃO E REBENEFICIAMENTO DE MERCADORIAS','Registra as variações patrimoniais diminutivas proveniente da utilização  de serviços de natureza eventual  prestados por pessoa fisica na conservação e rebeneficiamento de  mercadorias.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.28.00.00.00.00','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as variações patrimoniais diminutivas proveniente da utilização  de serviços prestados por pessoa fisica na confecção de:  bolsas - caixas - mochilas - sacolas - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.29.00.00.00.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','Registra as variações patrimoniais diminutivas proveniente da utilização  de serviços de costureiras, alfaiates e afins utilizados na confecção de uniformes, bandeiras, flamulas,  brasões e estandartes.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.30.00.00.00.00','FRETES E TRANSPORTES DE ENCOMENDAS','Registra as variações patrimoniais diminutivas proveniente da utilização  de serviços  prestados por pessoa fisica em: fretes e carretos - remessa de encomendas - transporte de  mercadorias e produtos - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.31.00.00.00.00','JETONS E GRATIFICACOES A CONSELHEIROS','Registra as variações patrimoniais diminutivas proveniente da participação em orgãos de deliberações coletivas (conselhos).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.34.00.00.00.00','SERVICOS DE AUDIO, VIDEO E FOTO','Registra as variações patrimoniais diminutivas proveniente da utilização  de serviços de filmagens, gravações   e fotografias, prestados por pessoa fisica.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.35.00.00.00.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE ACOES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALARIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E SERVICOS DE CARTORIO, QUANDO A NOTA E EMITIDA EM NOME DO TABELIAO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.36.00.00.00.00','SEGUROS EM GERAL','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DAAPROPRIACAO DE PREMIOS PAGOS POR SEGUROS DE QUALQUER NATUREZA, INCLUSIVE COBERTURA DE DANOS CAUSADOS A PESSOAS OU BENS DE TERCEIROS, PREMIOS DE SEGUROS DE BENS DO ESTADO OU DE TERCEIROS, SEGURO OBRIGATORIO DE VEICULOS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.37.00.00.00.00','HOSPEDAGENS','REGISTRA AS VARIACOES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICOS DE HOSPEDAGENS DE SERVIDORES E CONVIDADOS DO GOVERNO EM VIAGENS, A LOCAIS ONDE NAO EXISTEM ESBELECIMENTOS COMERCIAIS HABILITADOS EM PRESTAR ESSE TIPO DE SERVICOS, PAGOS DIRETAMENTE A PESSOAS FISICAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.38.00.00.00.00','DESPESAS COM LOCOMOCAO','Registra as variações patrimoniais diminutivas proveniente da utilização de meios de transportes aereos, terrestres, fluviais ou maritimas,  locação ou uso de veiculos para transporte de pessoas e suas respectivas bagagens, inclusive quando ocorrer em   decorrencia de mudancas de domicilio no interesse da administração.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.39.00.00.00.00','SERVICOS GRAFICOS E EDITORIAIS','Registra as variações patrimoniais diminutivas com serviços de artes graficas prestados por pessoa fisica, bem como com serviços editoriais diversos. Confecção de impressos em geral - encadernação de livros jornais   e revistas  - impressão de jornais - boletins - encartes - folders e assemelhados - plastificação de impressos - serviços de  identificação de livros editados usando codigo de barras - serviços editoriais  diversos.                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.2.1.99.00.00.00.00','OUTROS SERVICOS PRESTADOS POR PESSOA FISICA','Registra as variações patrimoniais diminutivas provenientes da utilização de outros serviços prestados por pessoa fisica, não contemplados em itens especificos.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.0.00.00.00.00.00','SERVIÇOS TERCEIROS - PJ','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.00.00.00.00.00','SERVIÇOS TERCEIROS - PJ - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas provenientes da prestação de serviços por pessoa jurídica fornecida a entidade governamental. Na classificação da despesa de material por encomenda, a variação patrimonial diminutiva só devera ser classificada com serviços de terceiros se o próprio órgão ou entidade fornecer a matéria-prima. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.01.00.00.00.00','CONSULTORIA E ASSESSORIA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS NAS AREAS DE CONSULTORIAS E ASSESSORIAS TECNICAS, OU ASSEMELHADAS.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.02.00.00.00.00','PERICIAS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE PERICIAS REALIZADAS POR EMPRESAS ESPECIALIZADAS.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.03.00.00.00.00','AUDITORIA EXTERNA','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de auditoria externa.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.04.00.00.00.00','COMUNICACAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE COMUNICACAO, PRESTADOS POR PESSOA JURIDICA.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.05.00.00.00.00','PUBLICIDADE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE PUBLICIDADE.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.06.00.00.00.00','MANUTENCAO E CONSERVACAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE MANUTENCAO DE BENS MOVEIS E IMOVEIS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.07.00.00.00.00','SERVICOS DE APOIO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS PRESTADOS POR PESSOA JURIDICA A TITULO DE APOIO AS ATIVIDADES ADMINISTRATIVAS, TECNICAS E OPERACIONAIS DOS ORGAOS PÚBLICOS, NOS CASOS EM QUE O CONTRATO NÃO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.08.00.00.00.00','SERVICOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS E OUTROS.','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE AGUA E ESGOTO, ENERGIA ELETRICA, GAS EOUTROS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.09.00.00.00.00','SERVICOS DE ALIMENTACAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE FORNECIMENTO DE ALIMENTACAO.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.10.00.00.00.00','LOCACOES','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE LOCACAO DE BENS MOVEIS, IMOVEIS OU INTAGIVEIS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.11.00.00.00.00','SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE PROCESSAMENTO DE DADOS PRESTADOS POR EMPRESAS ESPECIALIZADAS NA AREA DE INFORMATICA; ATUALIZACAO E ADAPTACAO DE PROGRAMAS DE PROCESSAMENTO DE DADOS; SUPORTE TECNICO, REVISAO, CORRECAO DE PROBLEMAS OPERACIONAIS,ANALISE P/ACRESCENTAR NOVAS FUNCOES, HOSPEDAGEM DE SISTEMAS E OUTROS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.12.00.00.00.00','SERVICOS DE TRANSPORTE','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE TRANSPORTE DE SERVIDORES, TRABALHADORES DE UMA ENTIDADE OU DE MERCADORIAS E PRODUTOS DIVERSOS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.13.00.00.00.00','ARMAZENAGEM','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços  de  aluguel de galpões, silos e outros locais destinados a armazenagem de mercadorias e produtos. Inclui, ainda, as variações provenientess de garantia dos estoques armazenados e a utilização de serviço especializado na solução de gestão de estoque, incluindo gestão de materiais e transporte de materiais e equipamentos.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.14.00.00.00.00','ASSINATURAS DE PERIODICOS E ANUIDADES','Registra as variações patrimoniais diminutivas provenientes da utilização de assinaturas de tv  (tva cabo), jornais, inclusive diario oficial, revistas, recortes de  publicações, software, podendo estar na forma de disquete, cd-rom, boletins e  outros que não se destinem a coleções ou bibliotecas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.15.00.00.00.00','CAPATAZIA, ESTIVA E PESAGEM','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS DE MOVIMENTACAO E PESAGEM DE CARGAS(MERCADORIAS E PRODUTOS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.17.00.00.00.00','COMISSOES E CORRETAGENS','Registra as variações patrimoniais diminutivas provenientes da apropriação de valor referente a comissões e corretagens  decorrentes de serviços prestados por empresas de  intermediação  e  representação comercial.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.18.00.00.00.00','CONDOMINIOS','Registra as variações patrimoniais diminutivas provenientes da apropriação das taxas condominiais a conta do  proprietario, ou do locatario, conforme previsto no contrato de locação.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.19.00.00.00.00','CONFECCAO DE MATERIAL DE ACONDICIONAMENTO E EMBALAGEM','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços  de confecção  de materiais   destinados  a  preservação,  acomodação  ou  embalagem  de produtos diversos, tais como:- bolsas - caixas - mochilas - sacolas e outros. Somente serão classificados como serviços, caso a unidade forneça a materia-prima.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.20.00.00.00.00','CONFECCAO DE UNIFORMES, BANDEIRAS E FLAMULAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de confecção de:- bandeiras - brasões - estandartes - flamulas – uniformes e outros.  Somente serão classificados como serviços, caso a unidade forneça a materia-prima.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.21.00.00.00.00','DIREITOS AUTORAIS','Registra as variações patrimoniais diminutivas provenientes da utilização de direitos autorais sobre obras  cientificas, literarias ou em que a divulgação seja de interesse do governo.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.22.00.00.00.00','EXPOSICOES, CONGRESSOS, CONFERENCIAS E OUTROS','Registra as variações patrimoniais diminutivas provenientes de serviços utilizados na instalação  e manutenção de: conferencias - reuniões tecnicas - congressos - exposições - feiras - festejos populares - festivais - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.23.00.00.00.00','FESTIVIDADES E HOMENAGENS','Registra as variações patrimoniais diminutivas provenientes de serviços utilizados na  organização   de eventos, tais como: coqueteis - festas de congraçamento – recepções - e outras.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.24.00.00.00.00','HONORARIOS ADVOCATICIOS - ONUS DE SUCUMBENCIA','Registra as variações patrimoniais diminutivas provenientes da apropriação dos honorarios advocaticios decorrentes do onus da sucumbencia, entendido este como o onus que recai sobre a parte vencida numa ação, para pagamento dos  honorarios advocaticios a vencedora.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.25.00.00.00.00','HOSPEDAGENS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços  de  hospedagens  e alimentação de servidores e convidados do governo em viagens  oficiais pagos diretamente a  estabelecimentos  hoteleiros (quando  nao  houver   pagamento de diarias).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.26.00.00.00.00','PATROCINIO','Registra as variações patrimoniais diminutivas provenientes da utilização de patrocinios  a  atividades  ou  eventos, de natureza  cultural,  esportiva,  educacional,  ambiental,  cientifica, comunitaria,  promocional  etc.  Para  influenciar  favoravelmente   o publico e/ou atingir outros objetivos relacionados com a  promoção  de atos, obras, planos, ações, bens ou serviços. Não inclui o  patrocinio de midia, assim considerados aqueles em que o proponente e um veiculo de comunicação ou um gestor de meios ou instalações que funcionem como veiculo  de  midia  alternativa  e  aqueles  em  que  um  veiculo   de comunicação e o unico ou o principal realizador da ação  patrocinada, ainda que o proponente do projeto e provedor de conteudo para  a  ação patrocinada não se enquadre na definição de veiculo de comunicação  ou meio de midia alternativa.                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.27.00.00.00.00','PRODUCOES JORNALISTICAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços  de edição de jornais, revistas, noticiarios e materiais jornalisticos para videos.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.28.00.00.00.00','PROMOÇÃO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS REALIZADOS POR INTEGRANTES DO SICOM OU POR TERCEIROS, QUE EMPREGUEM RECURSOS DE NÃO-MIDIA, REALIZADAS COM OBJETIVO DE INCENTIVAR PÚBLICOS DE INTERESSE A CONHECEREM OU COMPRAREM PRODUTOS, SERVIÇOS, MARCAS, CONCEITOS OU POLITICAS PUBLICAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.29.00.00.00.00','SEGUROS EM GERAL','Registra as variações patrimoniais diminutivas provenientes da apropriação de  premios  pagos  por  seguros  de qualquer natureza, inclusive cobertura de danos causados a pessoas  ou bens de terceiros,  premios  de  seguros  de  bens  do  estado  ou  de terceiros, seguro obrigatorio de veiculos.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.30.00.00.00.00','SELECAO E TREINAMENTO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços prestados nas areas de instrução e orientação profissional, recrutamento e  seleção  de  pessoal (concurso publico) e treinamento.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.31.00.00.00.00','SERVIÇO MEDICO-HOSPITALAR,ODONTOLÓGICO E LABORATORIAL','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços medico-hospitalares,  odontologicos e laboratoriais, prestados por pessoas juridicas sem vinculo empregaticio, tais como:   analises clinicas - cirurgias - consultas - ecografias - endoscopias -enfermagem  -  esterilização  -  exames  de  laboratorio  -  raio x  - tomografias - tratamento odontologico - ultrassonografias - e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.32.00.00.00.00','SERVICOS BANCARIOS','Registra as variações patrimoniais diminutivas provenientes da apropriação de comissões,  tarifas  e  remunerações decorrentes de serviços prestados por  bancos  e  outras  instituições financeiras, bem como despesas com a guarda/custodia de valores (cofres de aluguel).                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.33.00.00.00.00','SERVICOS DE ANALISES E PESQUISA CIENTIFICAS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de analises fisico-quimicas e pesquisas cientificas, não relacionadas com apoio ao ensino - analises minerais - analises de solo - analises quimicas - coleta de dados em experimentos - tratamento e destinação de residuos e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.34.00.00.00.00','SERVICOS DE APOIO DO ENSINO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços com o objetivo de proporcionar o  desenvolvimento  e  o  aperfeiçoamento  do ensino,  em  todos  os  niveis,  inclusive  pesquisas  experiencias  e assemelhados.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.35.00.00.00.00','SERVICOS DE ASSISTENCIA SOCIAL','Registra as variações patrimoniais diminutivas provenientes de serviços  de  assistencia social   prestada  a   servidores,  segurados  carentes,  abrigados, internados e a seus dependentes, tais como:- ajuda de custo supletiva - generos  alimenticios  -  documentação - transporte e sepultamento.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.36.00.00.00.00','SERVICOS DE AUDIO VIDEO E FOTO','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços  de  filmagens,  gravações, revelações, ampliações e reproduções de sons e imagens - confecção de albuns - confecção de crachas funcionais   por   firmas especializadas - emolduramento de fotografias - imagens  de  satelites - revelação de filmes - microfilmagem e outros.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.38.00.00.00.00','SERVIÇOS DE CONSERV. E REBENEF. DE MERCADORIAS ','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DA UTILIZACAO DE SERVIÇOS UTILIZADOS NA CONSERVACAO E REBEFICIAMENTO DE MERCADORIAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.39.00.00.00.00','SERVICOS DE CONTROLE AMBIENTAL','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de controle ambiental.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.40.00.00.00.00','SERVICOS DE COPIAS E REPRODUCAO DE DOCUMENTOS','Registra as variações patrimoniais diminutivas provenientes da utilização de serviços de copias xerograficas, inclusive a locação e a manutenção de equipamentos reprograficos, copias e reproduções de documentos e publicações em geral, inclusive por meio magnetico e digitalização.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.41.00.00.00.00','SERVICOS DE CRECHE E ASSISTENCIA PRE ESCOLAR','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços  prestados  por  entidades de assistencia social para atender os dependentes de servidores do órgão, habilitados a usufruirem desse beneficio.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.42.00.00.00.00','SERVIÇOS DE INCINERAÇÃO/DESTRUI ÇÃO DE MATERIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVICO DE PROCESSO DE INCINERACAO E DESTRUICAO DE MATERIAIS, BEM COMO RESIDUOS INDUSTRIAIS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.43.00.00.00.00','SERVIÇOS DE PRODUÇÃO INDUSTRIAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE TRANSFORMACAO, BENEFICIAMENTO E INDUSTRIALIZACAO DE MATÉRIAS-PRIMAS QUE RESULTARAO EM UM PRODUTO FINAL. SOMENTE SERAO CLASSIFICADOS COMO SERVIÇOS, CASO A UNIDADE FORNECA A MATERIA-PRIMA.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.44.00.00.00.00','SERVIÇOS DE REABILITAÇÃO PROFISSIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE REABILITACAO PROFISSIONAL PRESTADOS POR PESSOA JURIDICA, COM O OBJETIVO DE PROPORCIONAR AOS INCAPACITADOS (PARCIAL OU TOTALMENTE), OS MEIOS INDICADOS PARA A REEDUCACAO E READAPTACAO PROFISSIONAL E SOCIAL, DE MODO QUE POSSAM VOLTAR A PARTICIPAR DO MERCADO DE TRABALHO. EX: CONTRATACAO DE EMPRESA PARA MINISTRAR CURSO PROFISSIONALIZANTE.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.45.00.00.00.00','SERVICOS FUNERARIOS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços de remoções,  sepultamentos e transladações.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.46.00.00.00.00','SERVIÇOS GRÁFICOS E EDITORIAIS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE ARTES GRAFICAS PRESTADOS POR PESSOA JURIDICA, BEM COMO COM SERVIÇOS EDITORIAIS DIVERSOS. - CONFECCAO DE IMPRESSOS EM GERAL - ENCADERNACAO DE LIVROS JORNAIS E REVISTAS - IMPRESSAO DE JORNAIS - BOLETINS - ENCARTES - FOLDERS E  ASSEMELHADOS - PLASTIFICACAO DE IMPRESSOS - SERVIÇOS DE IDENTIFICACAO DE LIVROS EDITADOS USANDO CODIGO DE BARRAS - SERVIÇOS EDITORIAIS DIVERSOS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.47.00.00.00.00','SERVICOS JUDICIARIOS','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA APROPRIACAO DE CUSTAS PROCESSUAIS DECORRENTES DE AÇÕES JUDICIAIS, DILIGENCIAS(INCLUSIVE CONDUCAO) SALÁRIOS E HONORARIOS DOS AVALIADORES, PERITOS JUDICIAIS E OFICIAIS DE JUSTICA E SERVIÇOS DE CARTORIO.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.51.00.00.00.00','SERVICOS TECNICOS PROFISSIONAIS','Registra as variações patrimoniais diminutivas proveniente da utilização de serviços prestados por empresas especializadas nas seguintes areas:   advocacia - arquitetura - contabilidade - economia - engenharia - estatistica e outras. Exceto os serviços de consultoria que devem ser classificados em conta especifica .                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.52.00.00.00.00','TAXA DE ADMINISTRACAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS DE ORGANIZACAO E ADMINISTRACAO PRESTADOS POR PESSOA JURIDICA, TAIS COMO: - TAXA DE ADMINISTRACAO PAGA AO INSTITUTO EUVALDO LODI IEL E AO CEN-TRO DE INTEGRACAO EMPRESA-ESCOLA - CIEE, DECORRENTE DOS SERVIÇOS DE SELECAO E RECRUTAMENTO DE ESTUDANTES, TENDO COMO OBJETIVO O INGRESSO AO MERCADO DE TRABALHO E PROGRAMAS DE ESTAGIO; - TAXA DE  ADMINISTRACAO PATRIMONIAL DAS CONTRIBUIÇÕES DO BANCO CENTRALDO BRASIL, NA QUALIDADE DE PATROCINADOR, DESTINADO AO CUSTEIO DAS APOSENTADORIAS E PENSOES CONCEDIDAS COM BASE NA LEI 8.112/1990, E OUTROS.                                                                                                                                                                                                                                                                                                                                        ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.54.00.00.00.00','LOCACAO DE MAO-DE-OBRA','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS PARA ORGAOS PÚBLICOS, TAIS COMO LIMPEZA E HIGIENE, VIGILANCIA OSTENSIVA E OUTROS, NOS CASOS EM QUE O CONTRATO ESPECIFIQUE O QUANTITATIVO FISICO DO PESSOAL A SER UTILIZADO.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.55.00.00.00.00','ARRENDAMENTO MERCANTIL OPERACIONAL','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTES DE ARRENDAMENTO MERCANTIL OPERACIONAL','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.56.00.00.00.00','PASSAGENS E DESPESAS COM LOCOMOCAO','REGISTRA AS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS PROVENIENTE DA UTILIZACAO DE PASSAGENS (AEREAS,TERRESTRES, FLUVIAIS OU MARITIMAS), TAXAS DE EMBARQUE, SEGUROS, FRETAMENTO, PEDAGIOS, LOCACAO OU USO DE VEICULOS PARA TRANSPORTE DE PESSOASE SUAS RESPECTIVAS BAGAGENS, INCLUSIVE QUANDO OCORRER EM DECORRENCIA DE MUDANCAS DE DOMICILIO NO INTERESSE DA ADMINISTRACAO.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.3.1.99.00.00.00.00','OUTROS SERVICOS PRESTADOS POR PESSOA JURIDICA','Registra as variações patrimoniais diminutivas provenientes das demais prestação de serviços por pessoa jurídica fornecida a entidade governamental.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.4.0.00.00.00.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA – ART. 18 § 1, LC 101/00','Compreende a apropriação das despesas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.2.4.1.00.00.00.00.00','CONTRATO DE TERCEIRIZAÇÃO POR SUBSTITUIÇÃO DE MÃO DE OBRA - ART. 18 § 1, LC 101/00 - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas à mão de obra, constantes dos contratos de terceirização, classificáveis no grupo de despesa com pessoal e encargos em obediência ao disposto no artigo 18, § 1º, da lei complementar nº 101, de 2000. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.0.0.00.00.00.00.00','DEPRECIAÇÃO, AMORTIZAÇÃO E EXAUSTÃO','Compreende o decréscimo no beneficio de um bem durante o período contábil decorrente de depreciação, amortização e exaustão.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.0.00.00.00.00.00','DEPRECIAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.00.00.00.00.00','DEPRECIAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor dos bens tangíveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.01.00.00.00.00','DEPRECIACAO DE IMOBILIZADO','Compreende a redução do valor dos bens tangiveis, do ativo imobilizado, pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.01.01.00.00.00','DEPRECIAÇÃO DE BENS MÓVEIS','Registra a redução do valor dos bens móveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.1.1.01.02.00.00.00','DEPRECIAÇÃO DE BENS IMÓVEIS','Registra a redução do valor dos bens imóveis pelo desgaste ou perda de utilidade por uso, ação da natureza ou obsolescência.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.0.00.00.00.00.00','AMORTIZAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.00.00.00.00.00','AMORTIZAÇÃO - CONSOLIDAÇÃO','Compreende a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangíveis, com existência ou exercício de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.01.00.00.00.00','AMORTIZACAO DE IMOBILIZADO','Registra a redução do valor aplicado na aquisição de direitos, do ativo imobilizado, com existência ou exercicio de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.2.1.02.00.00.00.00','AMORTIZACAO DE INTANGIVEL','Registra a redução do valor aplicado na aquisição de direitos de propriedade e quaisquer outros, inclusive ativos intangiveis, com existencia ou exercicio de duração limitada, ou cujo objeto sejam bens de utilização por prazo legal ou contratualmente limitado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.0.00.00.00.00.00','EXAUSTÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.1.00.00.00.00.00','EXAUSTÃO - CONSOLIDAÇÃO','Compreende a redução do valor decorrente da exploração dos recursos minerais, florestais e outros recursos naturais esgotáveis. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.3.3.1.01.00.00.00.00','EXAUSTAO DE IMOBILIZADO','Registra a redução do valor, decorrente da exploração, dos recursos minerais, florestais e outros recursos naturais esgotaveis.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.0.0.00.00.00.00.00','CUSTO DE MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende a variação patrimonial diminutiva relativa a materiais, serviços e consumo de capital fixo utilizados na produção de bens ou serviços, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo Compreendedo apenas no momento da venda destas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo apropriadas as mercadorias, sendo registrado apenas no momento da venda destas.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de bens, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO','Compreende outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.3.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS – MATÉRIAIS, SERVIÇOS E CONSUMO DE CAPITAL FIXO - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas relativas a materiais, serviços e consumo de capital fixo utilizadas na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.0.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas com operações financeiras, tais como: juros incorridos, descontos concedidos, comissões, despesas bancarias e correções monetárias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.0.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos contraídos com pessoas jurídicas de direito público ou privado.                      ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.                ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA COM INSTITUIÇÕES FINANCEIRAS','Registra a variação patrimonial diminutiva com juros da divida publica derivada de obrigações assumidas com instituições financeiras com vistas a execução de obras, fornecimento de bens ou prestação de servicos, ou da celebração de contratos de financiamento.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATUAL COM INSTITUIÇÕES FINANCEIRAS','Registra a variação patrimonial diminutiva com encargos da divida publica derivada de obrigações assumidas com instituições financeiras com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.1.99.00.00.00.00','JUROS E ENCARGOS DE OUTRAS  DIVIDAS CONTRATUAIS','Registra a variação patrimonial diminutiva provenientes de juros e encargos de outras dividas contratadas.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.01.00.00.00.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM A UNIÃO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.02.00.00.00.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - UNIÃO ','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM A UNIÃO COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.3.99.00.00.00.00','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.01.00.00.00.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS ESTADOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.02.00.00.00.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - ESTADO ','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS ESTADOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.4.99.00.00.00.00','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública interna derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.01.00.00.00.00','JUROS DA DIVIDA CONTR. INTERNA INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS MUNICÍPIOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.                                                ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.02.00.00.00.00','ENCARGOS DA DIVIDA CONTR.INTERNA INTER OFSS - MUNICÍPIO ','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM ENCARGOS DA DIVIDA PUBLICA DERIVADA DE OBRIGACOES ASSUMIDAS COM OS MUNICÍPIOS COM VISTAS A EXECUCAO DE OBRAS, FORNECIMENTO DE BENS OU PRESTACAO DE SERVICOS, OU DA CELEBRACAO DE CONTRATOS DE FINANCIAMENTO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.1.5.99.00.00.00.00','JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATUAIS - INTERNA INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA PROVENIENTES DE JUROS E ENCARGOS DE OUTRAS DIVIDAS CONTRATADAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública externa derivada de obrigações assumidas com pessoas jurídicas de direito público ou privado com vistas à execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.01.00.00.00.00','JUROS DA DIVIDA CONTRATADA NO EXTERIOR','Registra a variação patrimonial diminutiva com juros da divida publica contratada no exterior  com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.2.1.02.00.00.00.00','ENCARGOS DA DIVIDA CONTRATADA NO EXTERIOR','Registra a variação patrimonial diminutiva com encargos da divida publica contratada no exterior  com vistas a execução de obras, fornecimento de bens ou prestação de serviços, ou da celebração de contratos de financiamento.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.0.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.3.1.00.00.00.00.00','JUROS E ENCARGOS DA DIVIDA MOBILIARIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos da divida pública representada por títulos emitidos pelo governo. São considerados encargos da divida mobiliaria: comissões, corretagens, seguros, deságio e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS POR ANTECIPAÇÃO DE RECEITA ORÇAMENTÁRIA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos sobre empréstimos contraídos por antecipação de receita orçamentária para atender insuficiência de caixa durante o exercício financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.4.1.01.00.00.00.00','JUROS S/ ADIANTAMENTOS BANCARIOS','Registra a variação patrimonial diminutiva decorrente de juros incidentes sobre antecipações de créditos contratadas com bancos e outros agentes financeiros.','D','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.3.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.4.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.8.5.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos internos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS','Compreende a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.1.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos de empréstimos e financiamentos externos que não sejam referentes a divida contratual, a divida mobiliaria e a por antecipação de receita orçamentária. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).               ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.0.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA','Compreende o montante de variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos contratuais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.01.00.00.00.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.1.02.00.00.00.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.01.00.00.00.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.3.02.00.00.00.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.01.00.00.00.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.4.02.00.00.00.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS OBTIDOS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos internos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.01.00.00.00.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.1.5.02.00.00.00.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos emprestimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS OBTIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos externos contraídos com pessoas jurídicas de direito público ou privado. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.01.00.00.00.00','JUROS DE MORA','Registra a variação patrimonial diminutiva decorrente de juros a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.2.1.02.00.00.00.00','ENCARGOS DE MORA','Registra a variação patrimonial diminutiva decorrente de encargos a titulo de penalidade em virtude de atrasos e/ou não cumprimento dos prazos contratuais dos empréstimos e financiamentos contraidos com pessoas juridicas de direito publico ou privado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE AQUISIÇÃO DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos dos contratos de prestação de serviços e aquisição de bens. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.01.00.00.00.00','JUROS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.02.00.00.00.00','MULTAS DEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM DEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.03.00.00.00.00','MULTAS INDEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS, QUE SEJAM INDEDUTIVEIS NA DETERMINACAO DO LUCRO REAL PELA LEGISLACAO,REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.3.1.99.00.00.00.00','OUTROS ENCARGOS DE MORA','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM OUTROS ENCARGOS REFERENTES A PENALIDADE EM VIRTUDE DE ATRASOS E NÃO CUMPRIMENTO DOS PRAZOS DOS CONTRATOS DE PRESTACAO DE SERVICOS E AQUISICAO DE BENS, QUE NAO SE ENQUADREM NOS ITENS ANTERIORES.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA DE OBRIGAÇÕES TRIBUTÁRIAS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos de obrigações tributárias devidas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.01.00.00.00.00','JUROS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS DE OBRIGACOES TRIBUTARIAS DEVIDAS.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.02.00.00.00.00','MULTAS DEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS DEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, APENAS AS MULTAS POR INFRACOES FISCAIS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 - RIR/99).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.4.1.03.00.00.00.00','MULTAS INDEDUTIVEIS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM MULTAS RESULTANTES DO PAGAMENTO COM ATRASO DAS OBRIGACOES TRIBUTARIAS , COMO TAMBEM AS MULTAS PAGAS PELO DESCUMPRIMENTO DE OBRIGACOES ACESSORIAS EXIGIDAS PELA LEGISLACAO TRIBUTARIA.AS MULTAS PAGAS PELA ADMINISTRACAO PUBLICA ESTAO SUJEITAS AO DIREITO DE REGRESSO CONTRA AQUELES QUE LHES DERAM CAUSA. ESTA CONTA REGISTRA AS MULTAS CONSIDERADAS INDEDUTIVEIS PELA LEGISLACAO NA DETERMINACAO DO LUCRO REAL, OU SEJA, TODAS AS MULTAS POR INFRACOES FISCAIS, SALVO AS DE NATUREZA COMPENSATORIA E AS IMPOSTAS POR INFRACOES DE QUE NAO RESULTEM FALTA OU INSUFICIENCIA DE PAGAMENTO DE TRIBUTO (ART. 344., §5º DO DECRETO 3.000, DE 26 DE MARCO DE 1999 -RIR/99).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com juros e encargos a titulo de penalidade em virtude de atrasos e não cumprimento dos prazos em situações não compreendidas nas classificações anteriores.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.2.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTRA OFSS','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DO ENTE. ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.3.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - UNIÃO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E A UNIÃO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.4.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - ESTADO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM ESTADO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.2.9.5.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - INTER OFSS - MUNICÍPIO','REGISTRA A VARIACAO PATRIMONIAL DIMINUTIVA COM JUROS E ENCARGOS A TITULO DE PENALIDADE EM VIRTUDE DE ATRASOS E NAO CUMPRIMENTO DOS PRAZOS EM SITUACOES NAO COMPREENDIDAS NAS CLASSIFICACOES ANTERIORES. COMPREENDE OS SALDOS QUE SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS) DE ENTES PUBLICOS DISTINTOS, RESULTANTES DAS TRANSACOES ENTRE O ENTE E UM MUNICIPIO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.0.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.01.00.00.00.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Registra a Variação Patrimonial Diminutiva proveniente de Variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a Dívida Contratual. Ressalte-se será tratada como variação monetária apenas a Correção Monetária Pós-Fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - CONSOLIDAÇÃO','Registra a Variação Patrimonial Diminutiva proveniente de variações do valor da nossa moeda em relação as moedas estrangeiras referentes a Dívida Contratual.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.3.01.00.00.00.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - UNIÃO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.4.01.00.00.00.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - ESTADO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Compreendea variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.1.5.01.00.00.00.00','VARIAÇÕES MONETARIAS DE DIVIDA CONTRATUAL INTERNA - INTER OFSS - MUNICÍPIO','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida contratual externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.01.00.00.00.00','VARIAÇÕES MONETÁRIAS DA DIVIDA CONTRATUAL EXTERNA ','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual referentes a divida contratual. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.2.1.02.00.00.00.00','VARIAÇÕES CAMBIAIS DE DIVIDA CONTRATUAL EXTERNA ','Registra a variação patrimonial diminutiva proveniente de  variações do valor da nossa moeda em relação as moedas estrangeiras referentes a divida contratual.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA INTERNA - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria interna. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.3.1.01.00.00.00.00','VARIAÇÕES MONETÁRIAS DE DÍVIDA MOBILIÁRIA','Registra a variação patrimonial diminutiva proveniente de  variações da nossa propria moeda em relação aos indices ou coeficientes aplicaveis por dispositivo legal ou contratual referentes a divida mobiliaria. Ressalte-se será tratada como variação monetaria apenas  a correção monetaria pós-fixada','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.4.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.4.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE DIVIDA MOBILIARIA EXTERNA - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes a divida mobiliaria externa. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.1.99.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a variação patrimonial diminutiva proveniente de variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a divida contratual e mobiliaria.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS','Compreende a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.01.70.00.00.00','ATUALIZAÇÃO MONETÁRIA DE PRECATÓRIOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Precatórios.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.01.71.00.00.00','ATUALIZAÇÃO MONETÁRIA DE TRIBUTOS RENEGOCIADOS','Registra a Variação Patrimonial Diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se será tratada como Variação Monetária apenas a Correção Monetária Pós - Fixada - Atualização Monetária de Tributos Renegociados.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.3.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS - INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva proveniente de variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a divida contratual e mobiliaria.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS','Registra a variação patrimonial diminutiva proveniente de  variações da nossa propria moeda em relação aos indices ou coeficientes aplicaveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se sera tratada como variação monetaria apenas  a correção monetaria pós-fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.4.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a variação patrimonial diminutiva proveniente de variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a divida contratual e mobiliaria.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Compreende a variação patrimonial diminutiva proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção a divida contratual e mobiliaria. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.01.00.00.00.00','OUTRAS VARIAÇÕES MONETARIAS','Registra a variação patrimonial diminutiva proveniente de  variações da nossa propria moeda em relação aos indices ou coeficientes aplicaveis por dispositivo legal ou contratual, com exceção a divida contratual e mobiliaria. Ressalte-se sera tratada como variação monetaria apenas  a correção monetaria pós-fixada.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.3.9.5.02.00.00.00.00','OUTRAS VARIAÇÕES CAMBIAIS','Registra a variação patrimonial diminutiva proveniente de variação do valor da nossa moeda em relação as moedas estrangeiras, com exceção a divida contratual e mobiliaria.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.4.0.0.00.00.00.00.00','DESCONTOS FINANCEIROS CONCEDIDOS','Compreende o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.4.0.1.00.00.00.00.00','DESCONTOS FINANCEIROS CONCEDIDOS - CONSOLIDAÇÃO','Registra o valor da variação patrimonial diminutiva com descontos financeiros concedidos a clientes por pagamentos antecipados de duplicatas e outros títulos. Não se confundem com descontos nos preços de venda concedidos incondicionalmente, ou abatimentos de preços, que são deduções da receita.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS - FINANCEIRAS','Compreende outras variações patrimoniais diminutivas financeiras, não abrangidas nos grupos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.0.00.00.00.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS','Compreende os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.1.1.00.00.00.00.00','JUROS E ENCARGOS EM SENTENÇAS JUDICIAIS - CONSOLIDAÇÃO','Registra os juros e encargos resultantes de pagamento de precatórios e de sentenças judiciais transitadas em julgado.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.0.00.00.00.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES','Compreende as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.2.1.00.00.00.00.00','JUROS E ENCARGOS EM INDENIZAÇÕES E RESTITUIÇÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com indenizações e restituições referentes a juros e encargos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS','Compreende as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.4.9.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS FINANCEIRAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de operações financeiras não compreendidas nas contas anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.0.0.0.00.00.00.00.00 ','TRANSFERÊNCIAS E DELEGAÇÕES CONCEDIDAS','Compreende o somatório das variações patrimoniais diminutivas com transferências intergovernamentais, transferências intragovernamentais, transferências a instituições multigovernamentais, transferências a instituições privadas com ou sem fins lucrativos, transferências a convênios, transferências ao exterior e execuções orçamentárias delegadas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA A EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA A   EXECUÇÃO ORÇAMENTARIA – INTRA OFSS','Compreende o valor das transferências financeiras concedidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Não Inclui o valor repassado para aportes no RPPS ou RGPS.. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.02.00.00.00.00','REPASSE CONCEDIDO               ','Registra a variação patrimonial diminutiva relativa ao valor dos recursos concedidos a titulo de  transferencias financeiras entre orgãos diferentes da administração direta ou indireta, correspondentes ao orçamento anual.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.1.2.04.00.00.00.00','RECURSOS ARRECADADOS - CONCEDIDOS','Registra a variação patrimonial diminutiva relativa ao valor concedido para outra UG, referente a recursos que foram arrecadados (classificados como receita), para pagamento de variação patrimonial diminutiva na UG recebedora.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA','Compreende o valor das transferências financeiras, de bens ou valores concedidas para restos a pagar e outras finalidades independentes da execução orçamentária. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORCAMENTARIA – INTRA OFSS','Compreende o valor das transferências financeiras, de bens ou valores concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.01.00.00.00.00','TRANSFERÊNCIAS FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das transferências financeiras concedidas para restos a pagar e outras finalidades independentes da execução orçamentária.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.02.00.00.00.00','TRANSFERÊNCIAS NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Compreende o valor das transferências concedidas de bens ou valores independentes da execução orçamentária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.02.01.00.00.00','TRANSFERENCIAS CONCEDIDAS DE BENS IMOVEIS','Registra o valor das transferencias de bens imoveis entre unidades  do mesmo orgão.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.02.02.00.00.00','DOACOES CONCEDIDAS DE BENS IMOVEIS','Registra o valor de doações de bens imoveis entre unidades de orgãos diferentes','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.02.03.00.00.00','TRANFERENCIAS CONCEDIDAS DE BENS MOVEIS ','Registra o valor dos bens moveis para outra unidade, no pais ou no exterior, do mesmo orgão.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.02.04.00.00.00','DOACOES CONCEDIDAS DE BENS MOVEIS ','Registra o valor dos bens moveis  concedidos  por unidade localizada no  pais  para outra unidade, no pais ou no exterior, de orgãos diferentes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.2.2.02.99.00.00.00','OUTRAS TRANSFERÊNCIAS NÃO FINANCEIRAS CONCEDIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das demais transferências concedidas de bens ou valores independentes da execução orçamentária.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.0.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS ','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes, exceto os decorrentes de alíquota de contribuição suplementar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.00.00.00.00.00','TRANSFERENCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes exceto os decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.01.00.00.00.00','PLANO FINANCEIRO','Compreende o valor total dos valores concedidos pelo RPPS para cobertura de insuficiências financeiras, formação de reserva e outras necessidades financeiras, no âmbito do plano financeiro.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.01.01.00.00.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Registra os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.01.02.00.00.00','RECURSOS PARA FORMAÇÃO DE RESERVA ','Registra os recursos transferidos pelo ente federativo ao RPPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.01.09.00.00.00','OUTROS APORTES PARA O RPPS','Registra o somatório de eventuais aportes de recursos no RPPS para outras necessidades financeiras que não a cobertura de insuficiências financeiras e formação de reservas.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.02.00.00.00.00','PLANO PREVIDENCIÁRIO','Compreende o valor total concedido ao RPPS para cobertura de déficit financeiro ou atuarial e outros aportes, no âmbito do plano previdenciário.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.02.01.00.00.00','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','Registra o somatório dos recursos necessários ao equilíbrio financeiro do plano previdenciário, ou seja, à cobertura de déficit entre as receitas e despesas previdenciárias, referentes ao exercício atual.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.02.02.00.00.00','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','Registra os recursos orçamentários alocados para cobertura de déficit atuarial no exercício de referência, desde que não definidos por lei como contribuições suplementares.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.3.2.02.99.00.00.00','OUTROS APORTES PARA O RPPS','Registra outros aportes financeiros para o RPPS com outras finalidades previdenciárias.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.4.0.00.00.00.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS','Compreende o valor das transferências para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.1.4.2.00.00.00.00.00','TRANSFERÊNCIAS CONCEDIDAS PARA APORTES DE RECURSOS PARA O RGPS – INTRA OFSS','Registra o valor das transferências para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.0.0.00.00.00.00.00 ','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes de transferências a União, Estados, Distrito Federal, Municípios, inclusive as entidades vinculadas, de bens e/ou valores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.0.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS','Compreende as variações patrimoniais diminutivas  decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.1.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.3.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) de entes públicos distintos, para permitir a consolidação nacional realizada pelo Poder Executivo da União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - ESTADO','Compreende as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.01.00.00.00.00','CONTRIBUIÇÃO PATRONAL PARA O RPPS DO ESTADO REFERENTE A PESSOAL REQUISITADO','Registra o valor das variações patrimoniais diminutivas realizadas com pagamento de contribuição patronal quando o servidor é contribuinte do RPPS do Estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.02.00.00.00.00','PROGRAMA TROCA-TROCA','Registra o valor das variações patrimoniais diminutivas que o município tem que repassar para o Estado referente ao programa troca-troca.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.03.00.00.00.00','TRANSFERENCIAS PARA GRUPAMENTOS DE INCENDIO','Registra o valor das variações patrimoniais diminutivas que o município tem que repassar para os grupamentos de incêndio.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.04.00.00.00.00','RESTITUICAO DE TRANSFERENCIAS E CONVENIOS RECEBIDOS DO ESTADO','Registra o valor das variações patrimoniais diminutivas com restituições de convênios e transferências recebidas do Estado, como, por exemplo: saldo de juros de aplicações financeiras; saldos de valores não utilizados.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.4.05.00.00.00.00','RESTITUICAO DE IPVA','Registra o valor das variações patrimoniais diminutivas com restituições de IPVA.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.1.5.00.00.00.00.00','DISTRIBUIÇÃO CONSTITUCIONAL OU LEGAL DE RECEITAS – INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas decorrentes da transferência a outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.2.0.00.00.00.00.00','TRANSFERÊNCIAS AO FUNDEB','Compreende as variações patrimoniais diminutivas decorrentes da transferência de recursos dos entes, incluindo a complementação da União, para a composição do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.2.4.00.00.00.00.00','TRANSFERÊNCIAS AO FUNDEB -  INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.0.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreende as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, bem como a demais entidades, de bens e/ou valores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.1.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Por exemplo, empresa independente de um ente recebendo transferência de outro ente. (A empresa independente não pertence ao OFSS, mas pertence ao conceito de governamental).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.3.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.4.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – ESTADO ','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.3.5.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER-OFSS – MUNICÍPIO ','Registra as variações patrimoniais diminutivas decorrentes de transferências voluntárias de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.0.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS','Compreende as variações patrimoniais diminutivas decorrentes de demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.1.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.3.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.4.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.2.4.5.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas decorrentes demais transferências a União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.0.0.00.00.00.00.00 ','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais diminutivas decorrentes das transferências financeiras a instituições privadas, inclusive de bens e valores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs, OSCIPS e OS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas sem fins lucrativos que não tenham vinculo com a administração pública, exemplo: ONGs,OSCIPS E OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.01.00.00.00.00','CONTRIBUIÇÕES','Registra o valor utilizado para transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;                                                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.02.00.00.00.00','AUXÍLIOS','Registra o valor utilizado para transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.1.1.03.00.00.00.00','SUBVENÇÕES SOCIAIS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.2.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos que não tenham vínculos com administração pública.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.3.2.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes das transferências de bens e valores a instituições privadas com fins lucrativos, que não tenham vínculos com a administração pública. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.4.0.0.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, da quais o ente transferidor não participe.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.4.0.1.00.00.00.00.00','TRANSFERÊNCIAS A INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes das transferências a instituições multigovernamentais, das quais o ente transferidor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.5.0.0.00.00.00.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.5.0.1.00.00.00.00.00','TRANSFERÊNCIAS A CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes das transferências a consórcios públicos, dos quais o ente transferidor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.6.0.0.00.00.00.00.00 ','TRANSFERÊNCIAS AO EXTERIOR','Compreende as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.6.0.1.00.00.00.00.00','TRANSFERÊNCIAS AO EXTERIOR - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes de transferências a organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.0.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.3.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.4.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.1.5.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A ENTES – INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA A CONSÓRCIOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização aos Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os valores de operações efetuadas entre uma unidade pertencente ao orçamento fiscal e da seguridade social (OFSS) com unidade que não pertença ao OFSS de ente público.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.01.00.00.00.00','DIÁRIAS','Registra as variações patrimoniais diminutivas de diárias decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.02.00.00.00.00','PASSAGENS E DESPESAS COM LOCOMOÇÃO','Registra as variações patrimoniais diminutivas de passagens e despesas com locomoção decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.03.00.00.00.00','MATERIAL DE CONSUMO','Registra as variações patrimoniais diminutivas de material de consumo decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.04.00.00.00.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA FÍSICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa física, decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.05.00.00.00.00','OUTROS SERVIÇOS DE TERCEIRO - PESSOA JURÍDICA','Registra as variações patrimoniais diminutivas de outros serviços de terceiro, pessoa jurídica, decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.06.00.00.00.00','INDENIZAÇÕES E RESTITUIÇÕES','Registra as variações patrimoniais diminutivas de indenizações e restituições decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.5.7.2.1.07.00.00.00.00','DEMAIS VPD COM DELEGAÇÃO','Registra as demais variações patrimoniais diminutivas decorrentes de delegação ou descentralização aos consórcios públicos para execução de ações de responsabilidade exclusiva do delegante.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.0.0.0.00.00.00.00.00','DESVALORIZAÇÃO E PERDA DE ATIVOS','Compreende a variação patrimonial diminutiva com desvalorização e perdas de ativos, nos casos de reavaliação, redução a valor recuperável, com provisões para perdas, perdas com alienação e perdas involuntárias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.0.0.00.00.00.00.00','REAVALIAÇÃO, REDUÇÃO A VALOR RECUPERÁVEL E AJUSTE PARA PERDAS','Compreende as variações patrimoniais diminutivas relativas a reavaliação, redução a valor recuperável e ajuste para perdas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.0.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for inferior ao valor liquido contábil.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.00.00.00.00','REAVALIAÇÃO DE BENS MÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis, quando esse for inferior ao valor liquido contábil.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.01.00.00.00','REAVALIAÇÃO DE MÁQUINAS, APARELHOS, EQUIPAMENTOS E FERRAMENTAS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para máquinas, ferramentas, aparelhos, equipamentos, acessórios etc, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.02.00.00.00','REAVALIAÇÃO DE BENS DE INFORMÁTICA','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes paraequipamentos de processamento de dados e sistemas aplicativos, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.03.00.00.00','REAVALIAÇÃO DE MÓVEIS E UTENSÍLIOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para mobiliário em geral e utensílios, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.04.00.00.00','REAVALIAÇÃO DE MATERIAIS CULTURAIS, EDUCACIONAIS E DE COMUNICAÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para materiais bibliográficos, discotecas, filmotecas, de comunicação, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.05.00.00.00','REAVALIAÇÃO DE VEÍCULOS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para transportes aéreos, aquáticos e terrestres, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.06.00.00.00','REAVALIAÇÃO DE PEÇAS E CONJUNTOS DE REPOSIÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para peças e conjuntos de reposição destinados a substituição em máquinas e equipamentos, aeronaves e embarcações, bens de segurança e socorro, entre outros, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.07.00.00.00','REAVALIAÇÃO DE BENS MÓVEIS EM ANDAMENTO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis em andamento, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.08.00.00.00','REAVALIAÇÃO DE BENS MÓVEIS EM ALMOXARIFADO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens permanentes a serem estocados em almoxarifado, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.10.00.00.00','REAVALIAÇÃO DE SEMOVENTES','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para animais destinados a produção, reprodução, engorda e aos serviços utilitários em geral, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.01.99.00.00.00','REAVALIAÇÃO DE DEMAIS BENS MÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para demais bens móveis não classificados em grupos específicos, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.1.1.02.00.00.00.00','REAVALIAÇÃO DE BENS IMÓVEIS','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para bens imóveis, quando esse for inferior ao valor liquido contábil.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.2.0.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.2.1.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.3.0.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for inferior ao valor liquido contábil.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.3.1.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for inferior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.01.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de participações permanentes em outras entidades.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.02.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de propriedades para investimento.ributaria.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.03.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de investimentos do RPPS de longo prazo.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.1.04.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva relativa à redução a valor recuperável de demais investimentos permanentes.      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.2.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTRA OFSS','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.3.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.4.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.4.5.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um investimento, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo imobilizado, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo imobilizado, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.1.01.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS MÓVEIS','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de bens móveis, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.5.1.02.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE BENS IMÓVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de bens imóveis, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.6.0.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS','Compreende a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio  na sua utilidade além do reconhecimento sistemático por meio da depreciação.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.6.1.00.00.00.00.00','REDUÇÃO A VALOR RECUPERÁVEL DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com a redução nos benefícios econômicos futuros ou no potencial de serviços de um ativo intangível, que reflete um declínio na sua utilidade além do reconhecimento sistemático por meio da depreciação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Por exemplo, a variação patrimonial diminutiva com ajuste para créditos de liquidação duvidosa e ajuste para créditos da divida ativa.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.01.00.00.00.00','AJUSTE PARA PERDAS EM CRÉDITOS TRIBUTÁRIOS','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos tributários.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.02.00.00.00.00','AJUSTE PARA PERDAS EM CLIENTES','Registra a variação patrimonial diminutiva com ajuste para perdas créditos relativos a clientes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.03.00.00.00.00','AJUSTE PARA PERDAS EM CRÉDITOS DE TRANSFERÊNCIAS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos de transferências a receber.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.04.00.00.00.00','AJUSTE PARA PERDAS EM EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Registra a variação patrimonial diminutiva com ajuste para perdas em empréstimos e financiamentos concedidos.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.05.00.00.00.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em créditos da divida ativa tributária.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.06.00.00.00.00','AJUSTE PARA PERDAS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra a variação patrimonial diminutiva com ajuste para perdas em dívida ativa não tributária','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.1.99.00.00.00.00','AJUSTE PARA PERDAS DE DEMAIS CRÉDITOS A RECEBER','Registra a variação patrimonial diminutiva com ajuste para perdas em outros créditos, não especificados acima, por inadimplência ou outros fatores que impossibilitam o recebimento de créditos, por exemplo, ajuste para créditos de liquidação duvidosa.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.2.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTRA OFSS','Registra a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.3.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - UNIÃO','Registra a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.4.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.7.5.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com ajuste de perdas de créditos por inadimplência ou outros fatores que impossibilitam o recebimento de créditos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.8.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES','Compreende a variação patrimonial diminutiva com ajuste para redução a valor de mercado de estoques.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.1.8.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM AJUSTE DE PERDAS DE ESTOQUES - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com ajuste para perdas de estoques. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.0.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO','Compreende a perda com alienação de ativos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Compreende a perda com alienação de investimentos, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.01.00.00.00.00','PERDAS COM ALIENAÇÃO DE PARTICIPAÇÕES PERMANENTES','Registra a variação patrimonial diminutiva de perdas com alienação de participações permanentes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.02.00.00.00.00','PERDAS COM ALIENAÇÃO DE PROPRIEDADES PARA INVESTIMENTO','Registra a variação patrimonial diminutiva de perdas com alienação de propriedades para investimento.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.03.00.00.00.00','PERDAS COM ALIENAÇÃO DE INVESTIMENTOS DO RPPS DE LONGO PRAZO','Registra a variação patrimonial diminutiva de perdas com alienação de investimentos do RPPS de longo prazo.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.1.1.04.00.00.00.00','PERDAS COM ALIENAÇÃO DE DEMAIS INVESTIMENTOS PERMANENTES','Registra a variação patrimonial diminutiva de perdas com alienação de demais investimentos permanentes.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a perda com alienação de ativos imobilizados, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.1.01.00.00.00.00','PERDAS COM ALIENAÇÃO DE BENS MOVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de bens móveis.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.2.1.02.00.00.00.00','PERDAS COM ALIENAÇÃO DE BENS IMÓVEIS','Registra a variação patrimonial diminutiva de perdas com alienação de bens imóveis.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.3.0.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.2.3.1.00.00.00.00.00','PERDAS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a perda com alienação de ativos intangíveis, ou seja, quando o valor alienado do ativo e menor que o seu valor contábil, de maneira que a diferença compreende a perda. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.0.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário do bem, como o que resulta de sinistros como incêndio e inundações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.1.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO','Compreendem o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.1.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM IMOBILIZADO - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo imobilizado, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.2.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS','Compreendem o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.2.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM INTANGÍVEIS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do ativo intangível, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.3.0.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES','Compreendem o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.3.1.00.00.00.00.00','PERDAS INVOLUNTÁRIAS COM ESTOQUES - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de bem do estoque, como o que resulta de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.9.0.00.00.00.00.00','OUTRAS PERDAS INVOLUNTÁRIAS','Compreendem o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.6.3.9.1.00.00.00.00.00','OUTRAS PERDAS INVOLUNTÁRIAS - CONSOLIDAÇÃO','Registra o desfazimento físico involuntário de outros bens, como as que resultam de sinistros como incêndio e inundações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.0.0.0.00.00.00.00.00','TRIBUTÁRIAS','Compreendem as variações patrimoniais diminutivas relativas aos impostos, taxas, contribuições de melhoria, contribuições sociais, contribuições econômicas e contribuições especiais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.0.0.00.00.00.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreendem as variações patrimoniais diminutivas relativas às obrigações relativas às prestações pecuniárias compulsórias, em moeda ou cujo valor nela possa se exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade vinculada. Como: impostos, taxas e contribuições de melhoria.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.0.00.00.00.00.00','IMPOSTOS','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência, e vinculados à atividade administrativa do contribuinte, definidos no CTN.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.00.00.00.00.00','IMPOSTOS- CONSOLIDAÇÃO','Compreende as variações patrimoniais diminutivas com impostos, apurados no período de competência e vinculados atividade administrativa do contribuinte, definidos no CTN. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.01.00.00.00.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra as variações patrimoniais diminutivas com Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.02.00.00.00.00','IPVA','Registra as variações patrimoniais diminutivas com Imposto sobre a Propriedade de Veículos Automotores.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.03.00.00.00.00','ITCMD','Registra as variações patrimoniais diminutivas com Imposto sobre Transmissão "Causa Mortis" e Doação de Bens e Direitos.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.04.00.00.00.00','ICMS','Registra as variações patrimoniais diminutivas com Imposto sobre Operações Relativas a circulação de Mercadorias e sobre Prestação de Serviços de Transporte Interestadual e Intermunicipal e de Comunicação.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.05.00.00.00.00','IPTU','Registra as variações patrimoniais diminutivas com Imposto sobre a Propriedade Predial e Territorial Urbana.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.06.00.00.00.00','ITBI','Registra as variações patrimoniais diminutivas com Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.07.00.00.00.00','ISS','Registra as variações patrimoniais diminutivas com Imposto Sobre Serviços de Qualquer Natureza.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.08.00.00.00.00','ITR','Registra as variações patrimoniais diminutivas com Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.09.00.00.00.00','IMPOSTO S/ PRODUTOS INDUSTRIALIZADOS - IPI','Registra as variações patrimoniais diminutivas, decorrentes do imposto, de competência da União, sobre produtos industrializados tem como fato gerador: i o seu desembaraço aduaneiro, quando de procedência estrangeira; ii a sua saída dos estabelecimentos a que se refere o parágrafo único do artigo 51 do CTN; iii a sua arrematação, quando apreendido ou abandonado e levado a leilão. para os efeitos deste imposto, considera se industrializado o produto que tenha sido submetido a qualquer operacao que lhe modifique a natureza ou a finalidade, ou o aperfeicoe para o consumo.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.10.00.00.00.00','IMPOSTO S/ OPERACOES FINANCEIRAS - IOF','Registra as variações patrimoniais diminutivas com o imposto, de competência da união, sobre operações de crédito, câmbio e seguro, e sobre operações relativas a titulos e valores mobiliários que tem como fato gerador: i - quanto as operações de crédito, a sua efetivação pela entrega total ou parcial do montante ou do valor que constitua o objeto da obrigação, ou sua colocação a disposição do interessado; ii - quanto as operações de câmbio, a sua efetivação pela entrega de moeda nacional ou estrangeira, ou de documento que a represente, ou sua colocação a disposição do interessado em montante equivalente a moeda estrangeira ou nacional entregue ou posta a disposição por este; iii - quanto as operações de seguro, a sua efetivaçãopela emissão da apólice ou do documento equivalente, ou recebimento do prêmio, na forma da lei aplicável; iv - quanto as operações relativas a títulos e valores mobiliários, a emissão, transmissão, pagamento ou resgate destes, na forma da lei aplicável.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.11.00.00.00.00','IMPOSTO S/ IMPORTACAO - II','Registra as variações patrimoniais diminutivas, de competência da união, sobre a importação de produtos estrangeiros que tem como fato gerador a entrada destes no territorio nacional.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.1.1.99.00.00.00.00','OUTROS IMPOSTOS','Registra as variações patrimoniais diminutivas com outros impostos não abrangidos nas rubricas anteriores.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.2.0.00.00.00.00.00','TAXAS','Compreende as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.2.1.00.00.00.00.00','TAXAS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com taxas cobradas pela União, Estados, Distrito Federal ou Municípios, no âmbito de suas respectivas contribuições, decorrentes da contraprestação de serviços públicos ao contribuinte postos a sua disposição, inclusive o exercício de poder de policia. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.3.0.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende as variações patrimoniais diminutivas com tributo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou Municípios , amparadas em lei e limitadas ao total da despesa pública realizada.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.1.3.1.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas com titulo cuja obrigação tem por fato gerador um beneficio especial auferido pelo contribuinte que por consequência promove uma valorização imobiliária e patrimonial decorrente de obra pública de competência da União, Estados, Distrito Federal ou municípios, amparadas em lei e limitadas ao total da despesa pública realizada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.0.0.00.00.00.00.00','CONTRIBUIÇÕES','Compreende as variações patrimoniais diminutivas com contribuições sociais, econômicas e outras, decorrentes da intervenção do estado (União, estados, distrito federal e municípios) no domínio econômico e de interesse da categoria de profissionais. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo estado, entre elas o PIS/PASEP, CSLL e COFINS, etc.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.01.00.00.00.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.02.00.00.00.00','PIS/PASEP','Registra o valor da  VPD  com  contribuição  para  o  programa  de integracao social - PIS ou para o programa de formacao do patrimonio do servidor publico – PASEP.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.03.00.00.00.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL ','Registra o valor da VPD com contribuição social incidente sobre  o lucro da pessoa juridica.  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.04.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUIÇÕES PREVIDENCIARIAS SOBRE SERVIÇOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVIÇOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.05.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.1.99.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','Registra o valor da VPD com outras contribuições sociais.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTRA OFSS','Registra a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - UNIÃO','Compreende a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.01.00.00.00.00','CONTRIBUIÇÃO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL - COFINS ','REGISTRA O VALOR DA VPD COM CONTRIBUICAO PARA FINANCIAMENTO DA SEGURIDADE SOCIAL','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.02.00.00.00.00','PIS/PASEP','Registra o valor da  VPD  com  contribuição  para  o  programa  de integracao social - PIS ou para o programa de formacao do patrimonio do servidor publico – PASEP.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.03.00.00.00.00','CONTRIBUIÇÃO SOCIAL S/ LUCRO LIQUIDO - CSLL ','Registra o valor da VPD com contribuição social incidente sobre  o lucro da pessoa juridica.  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.04.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA FISICA','REGISTRA O VALOR DA VPD COM CONTRIBUIÇÕES PREVIDENCIARIAS SOBRE SERVIÇOS DE TERCEIROS PESSOAS FISICAS CONTRATADAS PARA A EXECUCAO DE SERVIÇOS, SEM VINCULO COM A ADMINISTRACAO, CONFORME PARECER SOF/DESOC 101 DE 17/12/1997.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.05.00.00.00.00','OBRIGACOES PATRONAIS S/ SERVICOS DE PESSOA JURIDICA','REGISTRA O VALOR DA VPD COM ENCARGOS INCIDENTES SOBRE SERVIÇOS PRESTADOS POR PESSOAS JURIDICAS, TAIS COMO: - INSS (LEI 9876/99)','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.3.99.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','Registra o valor da VPD com outras contribuições sociais.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - ESTADO','Registra a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP, CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.1.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial diminutiva com contribuições sociais constituídas por ordem social e profissional, instituídas pelo Estado, entre elas o PIS/PASEP,CSLL e COFINS, etc. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreende a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.2.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com contribuições de intervenção no domínio econômico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.3.0.00.00.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP','Compreende o valor da variação patrimonial diminutiva com a contribuição para custeio do serviço de iluminação pública (art.149-a da C.F.)','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.3.1.00.00.00.00.00','CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA - COSIP - CONSOLIDAÇÃO','Registra o valor da variação patrimonial diminutiva com a contribuição para custeio da iluminação pública (art.149-a da C.F.). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES','Compreende a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.2.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com contribuições que não se enquadram na condição de sociais e econômicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.0.0.00.00.00.00.00','CUSTO COM TRIBUTOS','Compreende a variação patrimonial diminutiva relativa a tributos utilizados na produção de bens ou serviços, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo Compreendedo apenas no momento da venda destas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - CONSOLIDAÇÃO','Registra as variações diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).          ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.2.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTRA OFSS','Registra as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.3.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.4.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.1.5.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS - TRIBUTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas relativas a tributos apropriados as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo Compreendedo apenas no momento da venda destes.','D','N','','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.2.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTRA OFSS','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente. ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.3.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.4.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.2.5.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de bens,sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS','Compreende as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.2.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS -TRIBUTOS -INTRA OFSS','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.3.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.4.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.7.8.3.5.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS-TRIBUTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas relativas a tributos utilizados na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.0.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende o somatório das variações patrimoniais diminutivas não incluídas nos grupos anteriores. Compreende: premiações, incentivos, equalizações de preços e taxas, participações e contribuições, resultado negativo com participações, dentre outros.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.0.0.00.00.00.00.00','PREMIAÇÕES','Compreende as aquisições de prêmios, condecorações, medalhas, troféus, etc., bem como com o pagamento de prêmios em pecúnia, inclusive decorrentes de sorteios lotéricos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.1.0.00.00.00.00.00','PREMIAÇÕES CULTURAIS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.1.1.00.00.00.00.00','PREMIAÇÕES CULTURAIS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cultural.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.2.0.00.00.00.00.00','PREMIAÇÕES ARTÍSTICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.2.1.00.00.00.00.00','PREMIAÇÕES ARTÍSTICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter artístico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.3.0.00.00.00.00.00','PREMIAÇÕES CIENTIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.3.1.00.00.00.00.00','PREMIAÇÕES CIENTIFICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter cientifico. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                    ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.4.0.00.00.00.00.00','PREMIAÇÕES DESPORTIVAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.4.1.00.00.00.00.00','PREMIAÇÕES DESPORTIVAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., de caráter desportivo. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.5.0.00.00.00.00.00','ORDENS HONORIFICAS','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.5.1.00.00.00.00.00','ORDENS HONORIFICAS - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, insígnias etc., relativo a ordens honorificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.9.0.00.00.00.00.00','OUTRAS PREMIAÇÕES','Compreende o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.1.9.1.00.00.00.00.00','OUTRAS PREMIAÇÕES - CONSOLIDAÇÃO','Registra o valor gasto com prêmios, condecorações, medalhas, troféus, etc., para finalidades diferentes das previstas nos detalhamentos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.0.0.00.00.00.00.00','RESULTADO NEGATIVO DE PARTICIPAÇÕES','Compreende a apropriação do resultado negativo de participações, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.0.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.1.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                  ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.2.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.                 ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.3.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.4.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.2.1.5.00.00.00.00.00','RESULTADO NEGATIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Registra a apropriação do resultado negativo da equivalência patrimonial, oriundo de prejuízos apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.      ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.0.0.00.00.00.00.00','INCENTIVOS','Compreende os incentivos financeiros concedidos relativos à educação, a ciência e a cultura.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.0.00.00.00.00.00','INCENTIVOS A EDUCAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.00.00.00.00.00','INCENTIVOS A EDUCAÇÃO - CONSOLIDAÇÃO','Compreende a ajuda financeira concedida pelo estado a estudantes comprovadamente carentes, e concessão de auxílio para o desenvolvimento de estudos e pesquisas de natureza cientifica realizadas por pessoas físicas na condição de estudante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.01.00.00.00.00','BOLSA DE ESTUDOS NO PAIS','Registra as variações patrimoniais diminutivas realizadas com bolsas de estudo no pais, a qualquer titulo, e demais auxilios financeiros a estudantes. ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.02.00.00.00.00','BOLSA DE ESTUDOS NO EXTERIOR','Registra as  variações patrimoniais diminutivas realizadas com bolsas de estudo   no  exterior, a qualquer titulo.     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.1.1.99.00.00.00.00','OUTROS INCENTIVOS À EDUCACAO','Registra outras variações patrimoniais diminutivas com incentivos a educação não contemplados nos itens anteriores.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.0.00.00.00.00.00','INCENTIVOS A CIÊNCIA','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.00.00.00.00.00','INCENTIVOS A CIÊNCIA - CONSOLIDAÇÃO','Compreende o apoio financeiro concedido a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnológicas, nas suas mais diversas modalidades. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.01.00.00.00.00','AUXILIO A PESQUISADORES','Registra as variações patrimoniais diminutivas com auxilio financeiro a pesquisadores, individual ou coletivamente, exceto na condição de estudante, no desenvolvimento de pesquisas cientificas e tecnologicas, nas  suas diversas modalidades. ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.2.1.99.00.00.00.00','OUTROS INCENTIVOS A CIENCIA','Registra outras variações patrimoniais diminutivas com incentivos a cultura não contemplados nos itens anteriores. ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.3.0.00.00.00.00.00','INCENTIVOS A CULTURA','Compreende os incentivos financeiros concedidos, visando à promoção da cultura.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.3.1.00.00.00.00.00','INCENTIVOS A CULTURA - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos, visando à promoção da cultura.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                     ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.4.0.00.00.00.00.00','INCENTIVOS AO ESPORTE','Compreende os incentivos financeiros concedidos, visando à promoção do esporte.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.4.1.00.00.00.00.00','INCENTIVOS AO ESPORTE - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos, visando à promoção do esporte.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                   ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.9.0.00.00.00.00.00','OUTROS INCENTIVOS','Compreende outros incentivos financeiros concedidos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.4.9.1.00.00.00.00.00','OUTROS INCENTIVOS - CONSOLIDAÇÃO','Registra os incentivos financeiros concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.5.0.0.00.00.00.00.00','SUBVENÇÕES ECONÔMICAS','Compreende a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.5.0.1.00.00.00.00.00','SUBVENÇÕES ECONÔMICAS - CONSOLIDAÇÃO','Registra a variação patrimonial diminutiva com o pagamento de subvenções econômicas, a qualquer título, autorizadas em leis específicas, tais como: ajuda financeira a entidades privadas com fins lucrativos; concessão de bonificações a produtores, distribuidores e vendedores; cobertura, direta ou indireta, de parcela de encargos de empréstimos e financiamentos e dos custos de aquisição, de produção, de escoamento, de distribuição, de venda e de manutenção de bens, produtos e serviços em geral; e, ainda, outras operações com características semelhantes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.0.0.00.00.00.00.00','PARTICIPAÇÕES E CONTRIBUIÇÕES','Compreende as participações de terceiros nos lucros, não relativas ao investimento dos acionistas, tais como: participações de debêntures, empregados, administradores e partes beneficiárias, mesmo na forma de instrumentos financeiros, além da contribuição a instituições ou fundos de assistência ou previdência de empregados.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.1.0.00.00.00.00.00','PARTICIPAÇÕES DE DEBÊNTURES','Compreende as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.1.1.00.00.00.00.00','PARTICIPAÇÕES DE DEBÊNTURES - CONSOLIDAÇÃO','Registra as participações de debêntures incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.2.0.00.00.00.00.00','PARTICIPAÇÕES DE EMPREGADOS','Compreende as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.2.1.00.00.00.00.00','PARTICIPAÇÕES DE EMPREGADOS - CONSOLIDAÇÃO','Registra as participações de empregados incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.3.0.00.00.00.00.00','PARTICIPAÇÕES DE ADMINISTRADORES','Compreende as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.3.1.00.00.00.00.00','PARTICIPAÇÕES DE ADMINISTRADORES - CONSOLIDAÇÃO','Registra as participações de administradores incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.4.0.00.00.00.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS','Compreende as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.4.1.00.00.00.00.00','PARTICIPAÇÕES DE PARTES BENEFICIARIAS - CONSOLIDAÇÃO','Registra as participações de partes beneficiarias incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.5.0.00.00.00.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS','Compreende as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro liquido, para instituições ou fundos de assistência ou previdência de empregados.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.6.5.1.00.00.00.00.00','PARTICIPAÇÕES DE INSTITUIÇÕES OU FUNDOS DE ASSISTÊNCIA OU PREVIDÊNCIA DE EMPREGADOS - CONSOLIDAÇÃO','Registra as contribuições da empresa, incidentes sobre o lucro após imposto de renda e contribuição social sobre o lucro líquido, para instituições ou fundos de assistência ou previdência de empregados. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.0.0.00.00.00.00.00','VPD DE CONSTITUIÇÃO DE PROVISÕES','Compreende a constituição de provisões, entendidas como os passivos de vencimento ou montante incertos. Não se confundem com os passivos derivados de apropriação por competência, como férias e décimo - terceiro salário. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.1.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS','Compreende os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.1.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS TRABALHISTAS - CONSOLIDAÇÃO','Registra os passivos de prazo ou de valor incertos, relacionados a pagamento de reclamações trabalhistas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.2.0.00.00.00.00.00',' VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.2.1.00.00.00.00.00',' VPD DE PROVISÕES MATEMÁTICAS PREVIDÊNCIÁRIAS A LONGO PRAZO - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a futuros benefícios previdenciários a serem pagos aos contribuintes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.3.0.00.00.00.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.3.1.00.00.00.00.00','VPD DE PROVISÕES PARA RISCOS FISCAIS – CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados ao pagamento de autuações fiscais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.4.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS','Compreende a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamento de indenizações a fornecedores e clientes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.4.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS CÍVEIS – CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valor incertos, relacionados a pagamentos de indenizações a fornecedores e clientes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.0.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS','Registraa constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. ','D','N',' ','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.5.5.00.00.00.00.00','VPD DE PROVISÃO PARA REPARTIÇÃO DE CRÉDITOS - INTER OFSS - MUNICÍPIO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos créditos tributários e não tributários reconhecidos no lançamento por parte do agente arrecadador, a serem repartidos com outros entes da federação. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.6.0.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP ','Compreende a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.6.1.00.00.00.00.00','VPD DE PROVISÃO PARA RISCOS DECORRENTES DE CONTRATOS DE PPP - CONSOLIDAÇÃO','Registra a constituição de provisões de passivos de prazo ou de valores incertos relacionados aos riscos de demanda, construção, disponibilidade ou outros riscos decorrentes de contratos de PPP. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.9.0.00.00.00.00.00','VPD DE OUTRAS PROVISÕES ','Compreende a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.7.9.1.00.00.00.00.00','VPD DE OUTRAS PROVISÕES - CONSOLIDAÇÃO ','Registra a constituição de provisões de passivos de prazo ou de valor incertos não classificadas anteriormente neste plano de contas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.0.0.00.00.00.00.00','CUSTO DE OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens ou serviços, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.1.0.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo Compreendedo apenas no momento da venda destas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.1.1.00.00.00.00.00','CUSTO DE MERCADORIAS VENDIDAS – OUTRAS VPD - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas apropriadas as mercadorias, sendo registrado apenas no momento da venda destas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.2.0.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.2.1.00.00.00.00.00','CUSTO DE PRODUTOS VENDIDOS – OUTRAS VPD - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas apropriadas na produção de bens, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.3.0.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD','Compreende outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo Compreendedo apenas no momento da venda destes.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.8.3.1.00.00.00.00.00','CUSTO DE SERVIÇOS PRESTADOS – OUTRAS VPD - CONSOLIDAÇÃO','Registra outras variações patrimoniais diminutivas apropriadas na produção de serviços, sendo registrado apenas no momento da venda destes. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.0.0.00.00.00.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS DIMINUTIVAS','Compreende outras variações patrimoniais diminutivas não classificadas em itens específicos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.1.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.2.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.3.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.3.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL DIMINUTIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de bonificações concedidas na venda de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.0.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.1.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.2.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTRA OFSS','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.3.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compeende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.4.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.4.5.00.00.00.00.00','AMORTIZAÇÃO DE ÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais diminutivas provenientes de amortização de ágio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais diminutivas decorrentes de fatos geradores diversos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '3.9.9.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS DIMINUTIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Registra as variações patrimoniais diminutivas decorrentes de fatos geradores diversos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.0.0.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA','Compreende o aumento no beneficio econômico durante o período contábil sob a forma de entrada de recurso ou aumento de ativo ou diminuição de passivo, que resulte em aumento do patrimônio liquido e que não sejam provenientes de aporte dos proprietários.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.0.0.0.00.00.00.00.00','IMPOSTOS, TAXAS E CONTRIBUIÇÕES DE MELHORIA','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: impostos, taxas e contribuições de melhoria.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.0.0.00.00.00.00.00','IMPOSTOS','Compreende como imposto o tributo cuja obrigação tem por fato gerador uma situação independente de qualquer atividade estatal especifica, relativa ao contribuinte.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.1.0.00.00.00.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR','Compreende os impostos sobre operações de comercio exterior, como por exemplo: impostos sobre a importação e imposto sobre a exportação.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.1.1.00.00.00.00.00','IMPOSTOS SOBRE COMERCIO EXTERIOR - CONSOLIDAÇÃO','Registra os impostos sobre operações de comercio exterior, como exemplo: impostos sobre a importação e imposto sobre a exportação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.0.00.00.00.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA','Compreende os impostos sobre patrimônio e a renda, como por exemplo: imposto sobre a propriedade territorial rural, imposto sobre a propriedade predial e territorial urbana, imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e impostos sobre a renda e proventos de qualquer natureza.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.00.00.00.00.00','IMPOSTOS SOBRE PATRIMÔNIO E A RENDA - CONSOLIDAÇÃO','Compreende os impostos sobre patrimônio e a renda, como exemplo: imposto sobre a propriedade territorial rural,imposto sobre a propriedade predial e territorial urbana,imposto sobre a transmissão de bens imóveis e de direitos a eles relativos e imposto sobre a renda e proventos de qualquer natureza. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.01.00.00.00.00','IMPOSTO S/ PROPRIEDADE TERRITORIAL RURAL','Registra a variação patrimonial aumentativa decorrente de imposto sobre propriedade territorial rural','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.02.00.00.00.00','IMPOSTO SOBRE A PROPRIEDADE PREDIAL E TERRITORIAL URBANA','Registra a variação patrimonial aumentativa decorrente de imposto sobre a propriedade predial e territorial urbana.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.03.00.00.00.00','IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Compreende a variação patrimonial aumentativa decorrente de imposto sobre a renda e proventos de qualquer natureza, retidos na fonte.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.03.01.00.00.00','IR - PESSOAS FISICAS','REGISTRA O VALOR TOTAL QUE INCIDE SOBRE OS RENDIMENTOS E GANHOS DE CAPITAL PERCEBIDOS PELAS PESSOAS  ISICAS RESIDENTES OU DOMICILIADAS NO BRASIL. INTEGRAM O RENDIMENTO BRUTO SUJEITO A INCIDENCIA DESSE  MPOSTO O GANHO DE CAPITAL DECORRENTE DA ALIENACAO DE BENS E DIREITOS E OS GANHOS LIQUIDOS AUFERIDOS EM OPERACOES REALIZADAS NAS BOLSAS DE VALORES E ASSEMELHADAS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.03.02.00.00.00','IR - PESSOAS JURÍDICAS','REGISTRA O VALOR DA VPA COM O IMPOSTO DE RENDA DAS PESSOAS JURIDICAS','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.04.00.00.00.00','ITBI','Registra a variação patrimonial aumentativa decorrente de imposto sobre a transmissão intervivos de bens imóveis e direitos reais sobre imóveis.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.05.00.00.00.00','ITCMD','Registra a variação patrimonial aumentativa decorrente de imposto sobre transmissão causa mortis e doação de quaisquer bens ou direitos.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.06.00.00.00.00','IPVA','Registra a variação patrimonial aumentativa decorrente de imposto sobre a propriedade de veículos automotores.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.2.1.97.00.00.00.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de impostos.','D','s','p','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.0.00.00.00.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO','Compreende os impostos sobre a produção e a circulação, como por exemplo: imposto sobre produtos industrializados; imposto sobre operações de credito, câmbio e seguro, e sobre operações relativas a títulos e valores mobiliários; imposto sobre serviços de qualquer natureza. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.00.00.00.00.00','IMPOSTOS SOBRE A PRODUÇÃO E A CIRCULAÇÃO - CONSOLIDAÇÃO','Compreende os impostos sobre a produção e a circulação como, por exemplo, imposto sobre produtos industrializados;imposto sobre operações de credito, cambio e seguro, e sobre operações relativas a títulos e valores mobiliários, imposto sobre serviços de qualquer natureza.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                        ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.01.00.00.00.00','ICMS','Registra a variação variação patrimonial aumentativa decorrente de ICMS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.02.00.00.00.00','ISS','Registra a variação variação patrimonial aumentativa decorrente de ISS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.3.1.97.00.00.00.00','(-) DEDUÇÃO','Registra a dedução de variação patrimonial aumentativa decorrente de ICMS e ISS.','D','s','p','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.4.0.00.00.00.00.00','IMPOSTOS EXTRAORDINÁRIOS','Compreende os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos, gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.4.1.00.00.00.00.00','IMPOSTOS EXTRAORDINÁRIOS - CONSOLIDAÇÃO','Registra os impostos instituídos pela União, temporariamente, na iminência ou no caso de guerra externa, suprimidos,gradativamente, no prazo Maximo de cinco anos, contados da celebração da paz.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.9.0.00.00.00.00.00','OUTROS IMPOSTOS','Compreende os demais impostos não classificados nos grupos anteriores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.1.9.1.00.00.00.00.00','OUTROS IMPOSTOS - CONSOLIDAÇÃO','Registra os demais impostos não classificados nos grupos anteriores.  Compreende os valores de operações efetuadas entre uma unidade pertinente ao orçamento fiscal e da seguridade social (OFSS) com pessoa ou unidade que não pertença ao OFSS de ente público, alem dos demais fatos que não compreendem transações entre partes.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.0.0.00.00.00.00.00','TAXAS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador o exercício regular do poder de policia, ou a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.0.00.00.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a prática de ato ou abstenção de fato, em razão de interesse público.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.00.00.00.00.00','TAXAS PELO EXERCÍCIO DO PODER DE POLICIA - CONSOLIDAÇÃO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.03.00.00.00.00','TAXA DE LICENCA PARA FUNCIONAMENTO DE ESTABELECIMENTOS COMERCIAIS,  INDUSTRIAIS E PRESTADORA DE SERVIÇOS','Registra o valor da VPA de taxa de fiscalização da localização de estabelecimentos comerciais, industrias e de prestação de serviços, instituída pela legislação do uso e ocupação do solo urbano às posturas municipais relativas à segurança, ordem e tranqüilidade públicas. Ex: taxa de fiscalização ou vistoria em estabelecimentos de qualquer natureza.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.04.00.00.00.00','TAXA DE PUBLICIDADE COMERCIAL','Registra o valor da VPA de receita de taxa de utilização de espaço público destinado para divulgação de produtos do comércio.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.05.00.00.00.00','TAXA DE APREENSAO E DEPOSITO','Registra o valor da VPA  de taxa de apreensão e depósito de bens oriundos de irregularidades apresentadas quando da fiscalização.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.06.00.00.00.00','TAXA DE FUNCIONAMENTO DE ESTABELECIMENTOS EM HORARIO ESPECIAL','Registra o valor da VPA de taxa de funcionamento de estabelecimentos em horário especial. A respectiva taxa é destinada a bares, boates, barracas por ocasião de festas carnavalescas, podendo funcionar a qualquer hora.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.07.00.00.00.00','TAXA DE LICENCA PARA EXECUCAO DE OBRAS','Registra o valor da VPA de taxa de licença para execução de obras. A respectiva taxa é cobrada do responsável pela execução das obras em observância aos critérios descritos em lei.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.08.00.00.00.00','TAXA DE AUTORIZACAO DE FUNCIONAMENTO DE TRANSPORTE','Registra o valor da VPA de taxa de autorização de funcionamento de transporte, caracterizada pela autorização aos proprietários de veículos que prestam serviços à comunidade de transporte de passageiros tais como: transporte escolar, de funcionários e outros passageiros. Ex: taxa de fiscalização de veículos de uso coletivo','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.09.00.00.00.00','TAXA DE UTILIZACAO DE AREA DE DOMINIO PUBLICO','Registra o valor da VPA de taxa de utilização de área de domínio público, referente a espaço ocupado por balcões, barracas, mesas, tabuleiros e semelhantes, nas feiras, vias e logradouros públicos ou como depósito de materiais ou estacionamento de veículos em locais designados pela prefeitura.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.10.00.00.00.00','TAXA DE APROVACAO DO PROJETO DE CONSTRUCAO CIVIL','Registra o valor da VPA da taxa de licença e aprovação do projeto de construção civil correspondente a certificação das condições de utilização de prédios e residências.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.11.00.00.00.00','TAXA DE FISCALIZACAO DE VIGILANCIA SANITARIA','Compreende a VPA com  taxa pela fiscalização de vigilancia sanitaria exercida pela agência nacional de vigilancia  sanitaria sobre as pessoas fisicas e juridicas que exercam atividades   de fabricação, distribuição e venda de produtos e a prestação de servicos mencionados no artigo 8°   da Lei 9782/99. Os recursos são vinculados  a agencia nacional de vigilancia sanitaria. Inclui-se aqui o registro da VPA da divida ativa.                                ','C','N','','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.11.01.00.00.00','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - SAÚDE','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária - Saúde. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.11.02.00.00.00','TAXA DE FISCALIZAÇÃO DE VIGILÂNCIA SANITÁRIA - ANIMAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou  isciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Fiscalização de Vigilância Sanitária - Animal.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.12.00.00.00.00','TAXA DE ALINHAMENTO E NIVELAMENTO','Registra o valor da VPA da taxa de fiscalização da metragem no tocante ao alinhamento e nivelamento de áreas ou terrenos.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.13.00.00.00.00','TAXA DE APREENSAO, DEPOSITO OU LIBERACAO DE ANIMAIS','Registra o valor da VPA da taxa de apreensão, depósito ou liberação de animais recolhidos em ruas em função de riscos causados à população.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.14.00.00.00.00','TAXA DE CONTROLE E FISCALIZACAO AMBIENTAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxa de Controle e Fiscalização Ambiental.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.15.00.00.00.00','TAXA DE SERVIÇOS ADMINISTRATIVO','Compreende as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que,  limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços Administrativos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.15.01.00.00.00','ATOS DA ADMINISTRAÇÃO EM GERAL','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços de Atos Administração em Geral.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.15.02.00.00.00','ATOS DA SAÚDE PÚBLICA','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Serviços de Atos da Saúde Pública.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.16.00.00.00.00','TAXA DE FISCALIZACAO DE APARELHOS DE TRANSPORTE','Registra o valor da VPA da taxa de fiscalização exercida em instalações (conservação e funcionamento) de elevadores de passageiros e de cargas, de alçapões, escadas rolantes, planos inclinados móveis e outros de natureza especial, em observância a legislação específica.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.70.00.00.00.00','TAXA DE PREVENÇÃO CONTRA SINISTRO','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Prevenção Contra Sinistro.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.72.00.00.00.00','TAXA DE REGULAÇÃO DE SERVIÇOS DE GÁS CANALIZADO','Registra as taxas pelo poder de policia aquelas decorrentes das atividades da administração pública que, limitando ou disciplinando direito, interesse ou liberdade, regula a pratica de ato ou abstenção de fato em razão de interesse público. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) - Taxas de Regulação de Serviços de Gás Canalizado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.1.1.97.00.00.00.00','(-) DEDUCOES ','Registra as deduções por renuncia de variações patrimoniais aumentativas como por exemplo: a anistia, a remissão, o subsidio, o crédito presumido, a concessão de isenção em caráter não geral, a alteração de alíquota ou modificação de base de cálculo que implique redução discriminada de tributos ou contribuições e outros benefícios que correspondam a tratamento diferenciado.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.0.00.00.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível, prestado ao contribuinte ou posto a sua disposição.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.00.00.00.00.00','TAXAS PELA PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as taxas cobradas pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições tem como fato gerador a utilização, efetiva ou potencial, de serviço público específico e divisível prestado ao contribuinte ou posto a sua disposição. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.02.00.00.00.00','TAXAS DE SERVICOS CADASTRAIS','Registra a VPA proveniente das taxas de serviços  cadastrais, tendo como fato gerador a  apuração, inscrição e cobrança da divida ativa, da taxa de serviços cadastrais.                                ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.03.00.00.00.00','TAXA DE CEMITERIO','Registra o valor da arrecadação de VPA de taxa de prestação de serviços de administração de cemitérios referentes a utilização de necrotério e ocupação da sala mortuária, bem como matrículas, entrada e saída de ossos.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.04.00.00.00.00','EMOLUMENTOS E CUSTAS EXTRAJUDICIAIS','Registra o valor da VPA da taxa de serviços extrajudciais referentes aos atos praticados em razão do ofício. Serventias extrajudiciais, atividades praticadas pelos serviços notariais e de registro: lançamento em livros, certidões, trans','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.05.00.00.00.00','TAXA DE LIMPEZA PUBLICA','Registra o valor da VPA recebida pela utilização efetiva ou potencial do serviço pelo proprietário de imóvel edificado ou não, situado em logradouro beneficiado pela coleta do lixo.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.06.00.00.00.00','TAXA DE REGISTRO/INSPECAO DE PRODUTOS AGROPECUARIOS','Registra o valor da VPA da taxa de registro e inspeção de produtos agropecuários.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.07.00.00.00.00','EMOLUMENTOS E CUSTAS JUDICIAIS','Registra as variações patrimoniais diminutivas com Emolumentos e Custas Judiciais.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.08.00.00.00.00','TAXA DE REGISTRO NO CADASTRO TECNICO AMBIENTAL MUNICIPAL','Registra o valor da vpa da taxa de registro no cadastro técnico ambiental municipal.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.09.00.00.00.00','EMOLUMENTOS E CUSTAS PROCESSUAIS ADMINISTRATIVAS','Registra as variações patrimoniais diminutivas com Emolumentos e Custas Processuais Administrativas.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.10.00.00.00.00','TAXA DE AGUA SOBRE TERRENOS BALDIOS','Registra o valor da VPA da taxa de água sobre terrenos baldios.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.11.00.00.00.00','TAXA DE EMISSAO DE CERTIDOES','Registra o valor da VPA da taxa de emissão de certidões.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.70.00.00.00.00','TAXA JUDICIÁRIA','Registra as variações patrimoniais diminutivas com Taxa Judiciária.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.71.00.00.00.00','TAXA DE SEGURANÇA CONTRA INCÊNDIO','Registra as variações patrimoniais diminutivas com Taxa de Segurança Contra Incêndio.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.72.00.00.00.00','TAXA DE SEGURANÇA OSTENSIVA CONTRA DELITOS','Registra as variações patrimoniais diminutivas com Taxa de Segurança Ostensiva Contra Delitos.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.73.00.00.00.00','TAXA DE SEGURANÇA PREVENTIVA','Registra as variações patrimoniais diminutivas com Taxa de Segurança Preventiva.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.97.00.00.00.00','(-) DEDUCOES','Registra as deduções diversas.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.2.2.1.99.00.00.00.00','OUTRAS TAXAS PELA PRESTACAO DE SERVICOS','Registra as variações patrimoniais diminutivas com Outras Taxas pela Prestação de Serviços.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE MELHORIA','Compreende como contribuição de melhoria o tributo cobrado pela União, pelos estados, pelo distrito federal ou pelos municípios, no âmbito de suas respectivas atribuições, sendo instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária, tendo como limite total a despesa realizada e como limite individual o acréscimo de valor que da obra resultar para cada imóvel beneficiado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.1.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de água potável e esgoto sanitário.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.1.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ÁGUA POTÁVEL E ESGOTO SANITÁRIO - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedade em função da pavimentação asiática, bem como pela colocação de guias, sarjetas e calcamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.2.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede de iluminação pública na cidade.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.2.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DA REDE DE ILUMINAÇÃO PÚBLICA NA CIDADE - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública na cidade.   Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.3.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL','Compreende o valor da arrecadação de receita sobre a cobrança decorrente de valorização de propriedades em função da expansão da rede de iluminação pública rural.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.3.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA EXPANSÃO DE REDE DE ILUMINAÇÃO PÚBLICA RURAL - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da expansão da rede iluminação pública rural.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.4.0.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES','Compreende o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.4.1.00.00.00.00.00','CONTRIBUIÇÃO DE MELHORIA PELA PAVIMENTAÇÃO E OBRAS COMPLEMENTARES - CONSOLIDAÇÃO','Registra o valor da arrecadação de receita de contribuição de melhoria decorrente de valorização de propriedades em função da pavimentação asfáltica, bem como pela colocação de guias, sarjetas e calçamento. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).     ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA','Compreende o valor de outras contribuições de melhorias, não classificadas em itens específicos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.1.3.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES DE MELHORIA - CONSOLIDAÇÃO','Registra o valor de outras contribuições de melhorias, não classificadas em itens específicos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). ','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.0.0.0.00.00.00.00.00','CONTRIBUIÇÕES','Compreende toda prestação pecuniária compulsória, em moeda ou cujo valor nela se possa exprimir, que não constitua sanção de ato ilícito, instituída em lei e cobrada mediante atividade administrativa plenamente vinculada. Como: contribuições.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.0.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS','Compreendem como contribuições sociais: a) as das empresas, incidentes sobre a remuneração paga ou creditada aos segurados a seu serviço; b) as dos empregadores domésticos; c) as dos trabalhadores, incidentes sobre o seu salário-de-contribuição; d) as sobre a receita e faturamento; e) as sobre o lucro; f) do importador de bens ou serviços do exterior; g) e outros                                                                                                       ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - CONSOLIDAÇÃO','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.   Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).           ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS ','Registra a contribuição patronal destinada ao custeio do Regime Próprio de Previdência Social.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.00.00.00.00','CONTRIBUIÇÃO DO SEGURADO AO RPPS','Compreende a contribuição ao RPPS dos segurados, servidor ativo, servidor inativo e pensionista sobre a sua remuneração.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.01.00.00.00','CONTRIBUIÇÃO DO SERVIDOR CIVIL – RPPS ','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR ATIVO CIVIL SOBRE SUA REMUNERACAO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.02.00.00.00','CONTRIBUIÇÃO DO APOSENTADO CIVIL – RPPS ','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO SERVIDOR INATIVO CIVIL.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.03.00.00.00','CONTRIBUIÇÃO DE PENSIONISTA CIVIL – RPPS ','REGISTRA A VPA PROVENIENTE DA CONTRIBUICAO AO RPPS DO PENSIONISTA CIVIL.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.04.00.00.00','CONTRIBUIÇÃO DE SERVIDOR CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR CIVIL ATIVO, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.05.00.00.00','CONTRIBUIÇÃO DE APOSENTADO CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA AVPA ORIUNDA DE RECOLHIMENTO DA CONTRIBUICAO DO SERVIDOR INATIVO CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.02.06.00.00.00','CONTRIBUIÇÃO DE PENSIONISTA CIVIL – PAGAMENTO DE SENTENÇAS JUDICIAIS','EGISTRA A VPA ORIUNDA DE RECOLHIMENTO DE PENSIONISTA CIVIL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.03.00.00.00.00','CONTRIBUIÇÃO PREVIDENCIÁRIA  PARA AMORTIZAÇÃO DO DÉFICIT ATUARIAL ','Registra a VPA oriunda de contribuições previdenciárias para amortização do déficit atuarial.  ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.04.00.00.00.00','CONTRIBUIÇÕES PARA  CUSTEIO DAS PENSÕES  MILITARES','Registra as VPA provenientes de contribuição para custeio das pensões militares, efetivadas por todos os militares, com valor correspondente a seu posto ou graduação, observando as exceções previstas na lei especifica. De competência da União e dos Estados.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.97.00.00.00.00','(-) DEDUCOES ','Compreendem as deduções das contribuições sociais – RPPS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.97.10.00.00.00','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.1.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES  SOCIAIS - RPPS','Registra o valor das VPA oriundas de contribuições previdenciárias não enquadradas nos subitens anteriores.   ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTRA OFSS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.     ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.00.00.00.00','CONTRIBUIÇÕES PATRONAIS AO RPPS','Compreende a contribuição patronal destinada ao custeio do regime proprio de previdencia social.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.01.00.00.00','CONTRIBUIÇÃO PATRONAL DE SERVIDOR CIVIL – RPPS ','REGISTRA A VPA ORIUNDA DA PARTICIPACAO DA PCASP UNIÃO, AUTARQUIAS E FUNDACOES PUBLICAS FEDERAIS PARA O CUSTEIO DO PLANO DE SEGURIDADE SOCIAL DO SERVIDOR, SOBRE A REMUNERACAO MENSAL DOS SERVIDORES PUBLICOS ATIVOS CIVIS DA PCASP União, DAS AUTARQUIAS, INCLUSIVE AS EM REGIME ESPECIAL, E DAS FUNDACOES PUBLICAS FEDERAIS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.01.02.00.00.00','CONTRIBUIÇÃO PATRONAL – PAGAMENTO DE SENTENÇAS JUDICIAIS','REGISTRA A VPA DE RECOLHIMENTO DA CONTRIBUICAO PATRONAL, ORIUNDA DO PAGAMENTO DE SENTENCAS JUDICIAIS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.97.00.00.00.00','(-) DEDUCOES ','Compreendem as deducoes das variacoes patrimoniais aumentativas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.97.10.00.00.00','(-) RENÚNCIA','REGISTRA A DEDUCAO POR RENUNCIA DE VARIACOES PATRIMONIAIS AUMENTATIVAS COMO, POR EXEMPLO, A ANISTIA, A REMISSAO, O SUBSIDIO, O CREDITO PRESUMIDO, A CONCESSAO DE ISENCAO EM CARATER NAO GERAL, A ALTERACAO DE ALIQUOTA OU MODIFICACAO DE BASE DE CALCULO QUE IMPLIQUE REDUCAO DISCRIMINADA DE TRIBUTOS OU CONTRIBUICOES, E OUTROS BENEFICIOS QUE CORRESPONDAM A TRATAMENTO DIFERENCIADO.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.2.99.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - RPPS','Registra o valor das VPA oriundas de contribuições previdenciarias não enquadradas nos subitens anteriores.                                    ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS – UNIÃO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social.    Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.     ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - ESTADO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.         ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.1.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RPPS - INTER OFSS - MUNICÍPIO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime próprio de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.     ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.0.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS','Compreende a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.1.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - CONSOLIDAÇÃO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).               ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.2.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTRA OFSS','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.3.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - UNIÃO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.    ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.4.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - ESTADO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.     ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.2.5.00.00.00.00.00','CONTRIBUIÇÕES SOCIAIS - RGPS - INTER OFSS - MUNICÍPIO','Registra a contribuição patronal e a contribuição do segurado destinada ao custeio do regime geral de previdência social. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.   ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.3.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.3.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE A RECEITA OU O FATURAMENTO - CONSOLIDAÇÃO','Registra a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre a receita ou o faturamento, como por exemplo: COFINS, PIS/PASEP.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.4.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE O LUCRO','Compreende a contribuição do empregador, da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.4.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE O LUCRO - CONSOLIDAÇÃO','Registra a contribuição do empregador,da empresa e da entidade a ela equiparada na forma da lei, incidentes sobre o lucro, como por exemplo: CSLL.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.5.0.00.00.00.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO','Compreende a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.5.1.00.00.00.00.00','CONTRIBUIÇÃO SOBRE RECEITA DE CONCURSO DE PROGNOSTICO - CONSOLIDAÇÃO','Registra a contribuição sobre a receita de concursos de prognósticos, que são todos e quaisquer concursos de sorteios de números, loterias, apostas, inclusive as realizadas em reuniões hípicas, nos âmbitos federal, estadual, do Distrito Federal e municipais.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.6.0.00.00.00.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR','Compreende a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.6.1.00.00.00.00.00','CONTRIBUIÇÃO DO IMPORTADOR DE BENS OU SERVIÇOS DO EXTERIOR - CONSOLIDAÇÃO','Registra a contribuição social paga pelo importador de bens ou serviços do exterior, ou de quem a lei a ele equiparar.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.0.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS','Compreende o valor de outras contribuições sociais, não classificadas em itens específicos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.00.00.00.00.00','OUTRAS CONTRIBUIÇÕES SOCIAIS - CONSOLIDAÇÃO','Registra o valor de outras contribuições sociais, não classificadas em itens específicos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                                             ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.00.00.00.00','CONTRIBUIÇÃO SOCIAL PARA O FINANCIAMENTO DA SEGURIDADE SOCIAL','Compreende o somatório das contribuições para o financiamento da  seguridade social recebidas dos servidores municipais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.01.00.00.00','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTENCIA SOCIAL DO SERVIDOR','Registra o valor total da contribuição do servidor ativo para a assistência social do servidor','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.02.00.00.00','CONTRIBUICAO SERVIDORES INATIVOS E PENSIONISTAS PARA A ASSISTENCIA SOCIAL DO SERVIDOR','Registra o valor total da contribuição do servidor inativo e pensionistas para a assistência social do servidor.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.03.00.00.00','CONTRIBUICAO DOS SERVIDORES ATIVOS PARA A ASSISTENCIA MEDICA DO SERVIDOR','Registra o valor total da contribuição do servidor ativo para a assistência medica do servidor','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.04.00.00.00','CONTRIBUICAO DOS SERVIDORES INATIVOS PARA A ASSISTENCIA MEDICA DO SERVIDOR','Registra o valor total da contribuição do servidor inativo para a assistência medica do servidor','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.01.05.00.00.00','CONTRIBUICAO DOS PENSIONISTAS PARA A ASSISTENCIA MEDICA DO SERVIDOR','Registra o valor total da contribuição do pensionista para a assistência medica do servidor','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.96.00.00.00.00','OUTRAS CONTRIBUICOES SOCIAIS','Registra o valor das VPA oriundas de contribuições sociais não enquadradas nos subitens anteriores.                                    ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.1.9.1.97.00.00.00.00','(-) DEDUÇÕES DE OUTRAS CONTRIBUIÇÕES SOCIAIS ','Registra  as deduções das variações patrimoniais aumentativas com outras contribuições sociais','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Compreendem as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE-combustível.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.2.0.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO - CONSOLIDAÇÃO','Registra as contribuições de intervenção no domínio econômico, como por exemplo, a CIDE combustível. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.3.0.0.00.00.00.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA','Compreende as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.3.0.1.00.00.00.00.00','CONTRIBUIÇÃO DE ILUMINAÇÃO PÚBLICA - CONSOLIDAÇÃO','Registra as contribuições de iluminação pública, nos termos do artigo 149-a da constituição federal, acrescentado pela emenda constitucional n.ºª 39/02, sendo facultada a cobrança da contribuição na fatura de consumo de energia elétrica. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.4.0.0.00.00.00.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATÉGORIAS PROFISSIONAIS','Compreende as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.2.4.0.1.00.00.00.00.00','CONTRIBUIÇÕES DE INTERESSE DAS CATEGORIAS PROFISSIONAIS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de contribuições de interesse das categorias profissionais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                           ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.0.0.0.00.00.00.00.00','EXPLORAÇÃO E VENDA DE BENS, SERVIÇOS E DIREITOS','Compreende as variações patrimoniais aumentativas auferidas com a exploração e venda de bens, serviços e direitos, que resultem em aumento do patrimônio liquido, independentemente de ingresso, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.0.0.00.00.00.00.00','VENDA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda de mercadorias, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.1.0.00.00.00.00.00','VENDA BRUTA DE MERCADORIAS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.1.1.00.00.00.00.00','VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de mercadorias, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.9.0.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS','Compreende as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.1.9.1.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE MERCADORIAS - CONSOLIDAÇÃO','Registra as deduções das vendas de mercadorias, como devoluções, abatimentos e descontos comerciais concedidos.    Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.0.0.00.00.00.00.00','VENDA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda de produtos, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.1.0.00.00.00.00.00','VENDA BRUTA DE PRODUTOS','Compreende as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.1.1.00.00.00.00.00','VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas auferidas com a venda bruta de produtos, que resultem em aumento do patrimônio liquido, independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                            ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.9.0.00.00.00.00.00','(-) DEDUÇÕES DE VENDA BRUTA DE PRODUTOS','Compreende as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.2.9.1.00.00.00.00.00','(-) DEDUÇÕES DA VENDA BRUTA DE PRODUTOS - CONSOLIDAÇÃO','Registra as deduções das vendas de produtos, como devoluções, abatimentos e descontos comerciais concedidos.    Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                       ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.0.0.00.00.00.00.00','EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, segregando-se a venda bruta das deduções como devoluções, abatimentos e descontos comerciais concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.0.00.00.00.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS E DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido, independentemente de ingresso.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.00.00.00.00.00','VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas auferidas com a prestação de serviços, que resultem em aumento do patrimônio liquido independentemente de ingresso. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                                           ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.01.00.00.00.00','PRESTACAO DE SERVICOS DE TREINAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE INSTRUCAO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.02.00.00.00.00','EXPLORACAO DO PATRIMONIO IMOBILIARIO','REGISTRA O VALOR DAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO, POR TERCEIROS, DE BENS IMOVEIS PERTENCENTES AO SETOR PUBLICO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.03.00.00.00.00','PRESTACAO DE SERVICOS DE LOCACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ALUGUEIS, EXCETO ALUGUEIS DE IMOVEIS, QUE JÁ POSSUI RUBRICA PROPRIA.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.04.00.00.00.00','PRESTACAO DE SERVICOS DE PESQUISAS E ANALISES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE PESQUISAS E ANALISE.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.05.00.00.00.00','SERVICOS DE ESTUDOS E PESQUISAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PESQUISAS E ESTUDOS TECNICOSOCIAIS, ECONOMICOS, CIENTIFICOS, CULTURAIS ETC., REALIZADAS SOB CONTRATO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.06.00.00.00.00','PRESTACAO DE SERVICOS DE CONSULTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ASSESSORIA E CONSULTORIA.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.07.00.00.00.00','SERVICOS CONSULT.ASSIST.TEC. ANALISE PROJETOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE CONSULTORIA, ASSISTENCIA TECNICA E ANALISE DE PROJETOS PRESTADOS. VPA PROPORCIONADA POR CONSULTORIAS TECNICO-FINANCEIRAS, ASSESSORIA, ORGANIZACAO E ADMINISTRACAO DE EMPRESAS, AUDITORIA, CONTABILIDADE E ESCRITURACAO,PERICIAS CONTABEIS, ANALISE DE PROJETOS, ETC.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.08.00.00.00.00','PRESTACAO DE SERVICOS RELACIONADOS A T.I','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS RELACIONADOS A TECNOLOGIA DA INFORMACAO','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.09.00.00.00.00','PRESTACAO DE SERVICOS DE ADM. DE REDE DE COMUNIC. DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO SERVICOS DE  GERENCIAMENTO DE REDES DE COMUNICACAO DE DADOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.10.00.00.00.00','SERVICOS DE PROCESSAMENTO DE DADOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE PROCESSAMENTOS DE DADOS PRESTADOS. VPA DECORRENTE DE PRESTACAO DE SERVICOS DE PROCESSAMENTO DE DADOS PARA TERCEIROS: PREPARO DE PROGRAMA, ANALISE DE SISTEMAS, DIGITACAO, CONFERENCIA, ETC..','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.11.00.00.00.00','SERVICO DE INFORMACOES CIENTIFICAS E TECNOLOGICAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INFORMACOES CIENTIFICAS E TECNOLOGICAS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.13.00.00.00.00','SERVICOS DE TECNOLOGIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS TECNOLOGICOS PRESTADOS.VPA PROPORCIONADA POR: A) ANALISES QUIMICAS, ENSAIOS FISICOS E MECANICOS, CONTROLE  E EXPERI-MENTACAO QUALITATIVA DE MATERIAS-PRIMAS, INSUMOS E PRODUTOS FABRICADOS; PADRONIZACAO E ESPECIFICACAO DE PRODUTOS; AJUSTES DOS PROCESSOS ETECNICAS DE PRODUCAO INDUSTRIAL (SISTEMA DE TECNOLOGIA) B) ESPECIFICACAO E CONTROLE DE QUALIDADE DE MEDICAMENTOS, INSUMOS FARMACEUTICOS, DROGAS, COSMETICOS, PRODUTOS QUIMICOS, ALIMENTOS, E OUTROS, POR MEIO DE PROVAS ESPECIFICAS DE  IDENTIFICACAO, DE PUREZA E DETESTES DE CONTAMINACAO MICROBIOLOGICA.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.14.00.00.00.00','SERVICOS DE COMUNICACAO','COMPREENDE AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE COMUNICACAO, CONFORME DESCRICAO ABAIXO: A) SERVICO POSTAL, DE ENTREGA E TRANSPORTE DE VOLUMES E CORRESPONDENCIAS; B) SERVICO DE COMUNICACAO TELEFONICA LOCAL, INTERURBANA E INTERNACIONAL E DE TRANSMISSAO DE DADOS; C) SERVICO DE RADIODIFUSAO E DE AGENCIAMENTO DE PUBLICIDADE.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.15.00.00.00.00','PRESTACAO DE SERVICOS RELACIONADOS A ARMAZENAGEM','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE ARMAZENAGEM.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.16.00.00.00.00','PRESTACAO DE SERVICOS COMPLEMENTARES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS COMPLEMENTARES QUANDO DA ESTOCAGEM EM ARMAZENAGEM.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.17.00.00.00.00','PRESTACAO DE SERVICOS RELACIONADOS AO BENEFICIAMENTO DE GRAOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE BENEFICIAMENTO DE GRAOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.20.00.00.00.00','FORNECIMENTO DE MAO-DE-OBRA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO FORNECIMENTO DE MAO-DE-OBRA','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.21.00.00.00.00','PRESTACAO DE SERVICOS DE DISTRIB. DE GENEROS ALIMENTICIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE DISTRIBUICAO DE GENEROS ALIMENTICIOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.22.00.00.00.00','SERVICOS DE HOSPEDAGEM E ALIMENTACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE HOSPEDAGEM E ALIMENTACAO PRESTADOS. VPA PROPORCIONADA POR HOSPEDAGEM, COM OU SEM ALIMENTACAO, FORNECIMENTO DE REFEICOES, LANCHES E BEBIDAS PARA CONSUMO IMEDIATO. EXCLUEM AS VPA PROVENIENTES DE EMPRESAS FORNECEDORAS DE ALIMENTOS PREPARADOS PARA HOSPITAIS, FABRICAS, ETC... QUE SE CLASSIFICAM EM VPA DE PRODUTOS ALIMENTARES.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.23.00.00.00.00','CONCESSAO E PERMISSAO - SERV. DE TRANSPORT','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS ASSOCIADAS A OUTORGA DOS SERVICOS PUBLICOS DE TRANSPORTE A INICIATIVA PRIVADA, PROVENIENTE DA ATUACAO DA FISCALIZACAO, DA NORMATIZACAO E DO CONTROLE DOS SERVICOS CONCEDIDOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.24.00.00.00.00','OUTORGA SERV. EXPL. PROD PETR. GAS NATURAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO, DESENVOLVIMENTO E PRODUCAO DE PETROLEO E GAS NATURAL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.25.00.00.00.00','OUTORGA DE DIREITOS DE USO DE REC. HIDR.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE OUTORGA A PARTICULARES DE DIREITOS DE USO DA AGUA.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.27.00.00.00.00','CONCESSAO FLORESTAL','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE ATIVIDADES DE EXPLORACAO E GESTAO DE DIREITOS DE USO DE FLORESTAS PUBLICAS, RECURSOS FLORESTAIS, PRODUTOS E SERVICOS DELAS DECORRENTES, PARA PRODUCAO SUSTENTAVEL, EXERCIDAS MEDIANTE CONTRATOS DE CONCESSAO, A PARTICULARES QUE ESTEJAM EM CONDICOES DE ATENDER AS EXIGENCIAS DO RESPECTIVO EDITAL DE LICITACAO E QUE DEMONSTREM CAPACIDADE PARA SEU DESEMPENHO, POR SUA CONTA E RISCO E PRAZO DETERMINADO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.28.00.00.00.00','CONCESSAO E PERMISSAO. - DIR. USO DE BENS PUB','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA UTILIZACAO E EXPLORACAO DE BENS PUBLICOS POR TERCEIROS','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.29.00.00.00.00','COMPENSACOES FINANCEIRAS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DOS RECURSOS DECORRENTES DO ARTIGO 20, PARAGRAFO 1º DA CONSTITUICAO FEDERAL, O QUAL DISPOE: "E ASSEGURADA, NOS TERMOS DA LEI, AOS ESTADOS, AO DISTRI-TO FEDERAL E AOS MUNICIPIOS, BEM COMO AOS ORGAOS DA ADMINISTRACAO DIRETA DA PCASP União, PARTICIPACAO NO RESULTADO DA EXPLORACAO DE PETROLEO OU GAS NATURAL, DE RECURSOS HIDRICOS PARA FINS DE GERACAO DE ENERGIA ELETRICA E DE OUTROS RECURSOS MINERAIS NO RESPECTIVO TERRITORIO, PLATAFORMA CONTINENTAL, MAR TERRITORIAL OU ZONA ECONOMIA EXCLUSIVA, OU COMPENSACAO FINANCEIRA POR ESSA  EXPLORACAO".','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.33.00.00.00.00','SERVICOS DE SAUDE','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE SERVICOS DE SAUDE: HOSPITALARES GERAIS OU ESPECIALIZADOS, MATERNIDADE, CENTRO DE REABILITACAO, ASSISTENCIA MEDICO- ODONTOLOGICA (INCLUSIVE AMBULATORIAL), SAUDE PUBLICA, ETC...','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.34.00.00.00.00','CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE CERTIFICACAO E HOMOLOGACAO DE PROD. TELECOM.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.35.00.00.00.00','SERVICOS DE METROLOGIA E CERTIFICACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE METROLOGIA E CERTIFICACAO PRESTADOS.VPA DE SERVICOS METROLOGICOS EM GERAL, TAIS COMO AFERICAO DE MEDIDAS E INSTRUMENTOS DE MEDIR, SERVICOS DE ARQUEACAO DE TANQUES PARA ARMAZENAGEM, ETC..','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.36.00.00.00.00','SERVICOS DE INSPECAO E FISCALIZACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE INSPECAO E FISCALIZACAO PRESTADOS. VPA PROPORCIONADA PELA CONSTATACAO DAS CONDICOES HIGIENICOSANITARIAS E TECNICAS DE PRODUTOS OU ESTABELECIMENTOS, OU RESULTANTES DE ACAO EXTERNA E DIRETA DOS ORGAOS DO PODER PUBLICO DESTINADA A VERIFICACAO DO CUMPRIMENTO DA LEGISLACAO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.37.00.00.00.00','SERVICOS ADMINISTRATIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS ADMINISTRATIVOS PRESTADOS, DAS ATIVIDADES DE APOIO ADMINSITRATIVO EXECUTADAS EM ORGANIZACOES DE QUALQUER NATUREZA, TAIS COMO: A)TAXAS DE EXPEDICAO DE CERTIFICADOS; B)TAXAS DE REGISTRO, RENOVACAO, VISTORIA, LICENCA, CADASTRAMENTO, ETC. C)DATILOGRAFIA, MICROFILMAGEM, COPIAS XEROGRAFICAS, HELIOGRAFICAS,FOTOSTATICAS, ETC.. D)TAXAS DE INSCRICAO EM CONCURSOS. E)TAXA DE ADMINISTRACAO DE SERVICOS. F)VENDA DE EDITAIS. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.39.00.00.00.00','SERVICOS EDUCACIONAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DAS ATIVIDADES DO SISTEMA EDUCACIONAL, CUJA NATUREZA ESTEJA DIRETAMENTE RELACIONADA A FORMACAO DO EDUCANDO (MATRICULAS, ANUIDADES, ETC...). AS VPA DE ATIVIDADES AUXILIARES, DE APOIO OU DERIVADAS DOS SERVICOS EDUCACIONAIS PROPRIAMENTE DITOS, DEVEM SER CLASSIFICADAS NOS TITULOS APROPRIADOS. EXEMPLOS: MATRICULAS E ANUIDADES, SERVICOS EDUCACIONAIS, TAXAS DE EXPEDICAO DE DOCUMENTOS, COPIAS XEROGRAFICAS, HELIOGRAFICAS, ETC.., SERVICO DE CREDENCIAMENTO, AUTORIZACAO E RECONHECIMENTO DE CURSOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.40.00.00.00.00','SERVICOS AGROPECUARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS AGROPECUARIO: A)PREPARO E CORRECAO DE SOLOS (DESTOCAMENTO,ARACAO,GRADEACAO, CALAGEM,ADUBACAO, DRENAGEM, IRRIGACAO, CAPINA, DESMATAMENTO, ETC.); B)SEMEADURA E PLANTIO; C)COMBATE A PRAGAS (PULVERIZACAO, DEDETIZACAO); D)COLHEITA E PREPARACAO DE PRODUTOS AGRICOLAS; E)INSEMINACAO ARTIFICIAL; F)INCUBACAO DE OVOS; G)VACINACAO DE ANIMAIS; H)OUTROS SERVICOS AUXILIARES DE AGRICULTURA E PECUARIA.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.41.00.00.00.00','SERVICOS DE REPARACAO,MANUTENCAO E INSTALACAO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REPARACAO, MANUTENCAO E INSTALACAO PRESTADOS. VPA DE SERVICOS DE REPARACAO DE ARTEFATOS DE METAL; REPARACAO E MANUTENCAO DE MAQUINAS E APARELHOS DE USO DOMESTICO; REPARACAO, MANUTENCAO E INSTALACAO DE MAQUINAS E  APARELHOS ELETRICOS E ELETRONICOS E DE COMUNICACAO; REPARACAO E MANUTENCAO DE INSTALACOES ELETRICAS, DE GAS, DE AGUA, ETC...INCLUEM-SE TAMBEM, NESSE TITULO, OS SERVICOS DE CONFECCAO SOB MEDIDA. NAO SAO CONSIDERADOS NESSE TITULO, CLASSIFICANDO-SE EM VPA INDUSTRIAL: REPARACAO E MANUTENCAO DE VEICULOS FERROVIARIOS, EMBARCACOES E AERONAVES (INDUSTRIA DE MATERIAL DE TRANSPORTE).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.42.00.00.00.00','SERVICOS RECREATIVOS E CULTURAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS RECREATIVOS E CULTURAIS PRESTADOS. VPA PROPORCIONADA PELA EXPLORACAO DE INSTALACOES PARA RECREACAO, PRATICA DESPORTIVA E CULTURAL ( CINEMAS,TEATROS, SALOES PARA RECITAIS, CONCERTOS, CONFERENCIAS, PLANETARIOS,ESTADIOS DESPORTIVOS, AUTODROMOS, MUSEUS, BIBLIOTECAS, PROMOCAO E/OUPRODUCAO DE ESPETACULOS ARTISTICOS CULTURAIS E ESPORTIVOS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.44.00.00.00.00','SERVICOS DE REGISTRO DO COMERCIO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS DE REGISTRO DO COMERCIO PRESTADOS. VPA ADVINDA DA PRESTACAO DE SERVICOS DE REGISTRO DO COMERCIO E ATIVIDADES AFINS, TRATANDO-SE DE: A) SERVICOS PRESTADOS PELA JUNTA COMERCIAL DO DISTRITO FEDERAL; B) SERVICOS CONSTANTES DO CADASTRO NACIONAL DE EMPRESA, DEVIDOS NO AMBITO DAS JUNTAS COMERCIAIS DOS ESTADOS E DO DISTRITO FEDERAL; C) REMUNERACAO DE SERVICOS PRESTADOS PELO DEPARTAMENTO NACIONAL DE REGISTRO DO COMERCIO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.45.00.00.00.00','SERVICOS DE FORNECIMENTO DE AGUA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE FORNECIMENTO DE AGUA AOS IRRIGANTES, A AMORTIZACAO DOS INVESTIMENTOS DA INFRAESTRUTURA DE IRRIGACAO DOS PROJETOS PUBLICOS, CONFORME DEC.89.496, DE 29.03DE 84, RELATIVOS A TARIFAS K-1 E K-2.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.46.00.00.00.00','SERVICOS DE PERFURACAO E INSTALACAO DE POCOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS DE PERFURACAO EINSTALACAO DE POCOS TUBULARES PROFUNDOS, POCOS ARTESIANOS OU SIMILARES.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.47.00.00.00.00','SERVICOS DE GEOPROCESSAMENTO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS PRESTADOS A TERCEIROS DE INTERPRETACAO DE IMAGEM AEROFOTOGRAMETRICA,EXECUCAO DE MAPAS DIGITALIZADOS DIVERSOS, VENDA DE CARTAS E IMAGENS DE SATELITES, VIDEOGRAFICAS E SIMILARES.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.48.00.00.00.00','SERVICOS DE CADASTRAMENTO DE FORNECEDORES','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS DE CADASTRAMENTO DE EMPRESAS FORNECEDORAS DE BENS E SERVICOS AO GOVERNO FEDERAL.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.52.00.00.00.00','TAR.INSCR.CONCURSOS E PROCESSOS SELETIVOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE TARIFAS DE INSCRICAO EM CONCURSOS E PROCESSOS SELETIVOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.53.00.00.00.00','SERVICO DE COMPENSACAO DE VARIACOES SALARIAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COBRANCA DE CONTRIBUICOES SOBRE O VALOR DAS PRESTACOES PAGAS PELOS MUTUARIOS DO SISTEMA FINANCEIRO DE HABITACAO-SFH E SOBRE O SALDO DOS FINANCIAMENTOS IMOBILIARIOS CONCEDIDOS PELOS AGENTES FINANCEIROS DO SFH,COM COBERTURA DO FCVS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.54.00.00.00.00','GARANTIAS E AVAIS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE GARANTIAS E AVAIS NAS OPERACOES DE CREDITO. FATO GERADOR: CONCESSAO DE GARANTIAS E AVAIS, DE NATUREZA NAO-FINANCEIRAS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.55.00.00.00.00','CREDENCIAMENTO EMP.PREST.SERVICOS DE VISTORIA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DO VALOR A SER PAGO POR EMPRESAS NA OBTENCAO DE CREDENCIAMENTO PARA PRESTACAO DE SERVICOS DE VISTORIA. - DESTINACAO LEGAL: ORGAO ARRECADADOR; - AMPARO LEGAL: RESOLUCAO CONTRAN 282, DE 26 DE JUNHO DE 2008.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.56.00.00.00.00','SERVICOS VETERINARIOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE SERVICOS VETERINARIOS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.59.00.00.00.00','SERVICOS FINANCEIROS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS FINANCEIROS','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.60.00.00.00.00','SERV.COMERCIAIS DE PROD.DADOS E MAT.INFORMATICA','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA COMERCIALIZACAO DE PRODUTOS, DADOS E MATERIAIS DE INFORMATICA, TAIS COMO DISQUETES,SOFTWARES, PROGRAMAS, CD-ROM, FITAS MAGNETICAS E ASSEMELHADOS, BEM COMO INFORMACOES EM REDES E SISTEMAS DE DADOS DISPONIVEIS EM MEIO DE HARDWARE.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.61.00.00.00.00','SERVIÇOS DE TURISMO','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS COM SERVICOS DE TURISMO.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.1.1.99.00.00.00.00','OUTRAS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DE PRESTACAO DE SERVICOS','REGISTRA AS VARIACOES PATRIMONIAIS AUMENTATIVAS PROVENIENTES DA PRESTACAO DE OUTROS SERVICOS NÃO ENQUADRADOS NOS ITENS ANTERIORES.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.9.0.00.00.00.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS','Compreende as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.3.3.9.1.00.00.00.00.00','(-) DEDUÇÕES DO VALOR BRUTO DE EXPLORAÇÃO DE BENS, DIREITOS E PRESTAÇÃO DE SERVIÇOS - CONSOLIDAÇÃO','Registra as deduções das prestações de serviços, como devoluções, abatimentos e descontos comerciais concedidos.     Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).                                            ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.0.0.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS FINANCEIRAS','Compreende o somatório das variações patrimoniais aumentativas com operações financeiras. Compreende: descontos obtidos, juros auferidos, prêmio de resgate de títulos e debêntures, entre outros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.0.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS E FINANCIAMENTOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas provenientes de juros e encargos de empréstimos e financiamentos concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.3.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.4.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS -ESTADO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.1.5.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.2.0.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.2.1.00.00.00.00.00','JUROS E ENCARGOS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas à aplicação das taxas de juros aplicadas a empréstimos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.0.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.1.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.3.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.4.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.3.5.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos internos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.4.0.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.1.4.1.00.00.00.00.00','JUROS E ENCARGOS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas relativas a juros sobre os valores de financiamentos externos concedidos pela União, entidades e instituições, por autorizações legais ou vinculações a contratos e acordos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.0.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA','Compreende as variações patrimoniais aumentativas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação representando o resultado das aplicações impostas ao contribuinte.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.3.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.4.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.1.5.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos internos concedidos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.2.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.2.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE EMPRÉSTIMOS E FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a empréstimos e financiamentos externos concedidos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTOS DE BENS E SERVIÇOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação relativa a fornecimento de bens e serviços. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.05.00.00.00.00','JUROS E ENCARGOS DE MORA DA DIVIDA ATIVA DO PROGRAMA TROCA-TROCA','Registra o valor da arrecadação de VPA de multas e juros de mora da dívida ativa do programa troca-troca.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.06.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DA PRESTACAO DE SERVICOS','Registra o valor da arrecadação de VPA de multas e juros de mora da dívida ativa da prestação de serviços.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.07.00.00.00.00','MULTAS E JUROS DE MORA DA DIVIDA ATIVA DOS AUTOS DE INFRACAO','Registra o valor da arrecadação de VPA de multas e juros de mora da dívida ativa dos autos de infração.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.3.1.99.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA SOBRE FORNECIMENTO DE BENS E SERVICOS','Registra a variação patrimonial aumentativa proveniente de outros juros e encargos de mora sobre fornecimento de bens e servicos','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.0.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.00.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE CRÉDITOS TRIBUTÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa com juros e encargos a titulo de penalidade aplicada em virtude de atrasos e não cumprimento dos prazos de créditos tributários. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.01.00.00.00.00','MULTAS E JUROS SOBRE IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Renda e Proventos de Qualquer Natureza retidos na fonte.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.05.00.00.00.00','MULTAS E JUROS SOBRE IPTU','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre a Propriedade Predial e Territorial Urbana.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.06.00.00.00.00','MULTAS E JUROS SOBRE ITBI','Registra os valores relativos a créditos a receber, decorrentes da cobrança do Imposto sobre Transmissão "Inter Vivos" de Bens Imóveis e de Direitos Reais sobre Imóveis','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.07.00.00.00.00','MULTAS E JUROS SOBRE ISS','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre Serviços de Qualquer Natureza.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.08.00.00.00.00','MULTAS E JUROS SOBRE ITR','Registra os valores relativos aos créditos a receber, decorrentes do Imposto Sobre a Propriedade Territorial Rural, devidos aos municípios ou ao Distrito Federal devido a convênios firmados com a União, conforme inciso III, parágrafo 4º do artigo 153 da Constituição Federal.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.09.00.00.00.00','MULTAS E JUROSTAXAS PELO EXERCÍCIO DO PODER DE POLÍCIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pelo exercício do poder de polícia.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.10.00.00.00.00','MULTAS E JUROS TAXAS PELA PRESTAÇÃO DE SERVIÇOS','Registra os valores relativos aos créditos a receber, decorrentes da cobrança das taxas pela prestação de serviços.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.11.00.00.00.00','MULTAS E JUROS CONTRIBUIÇÕES DE MELHORIA','Registra os valores relativos aos créditos a receber, decorrentes da cobrança dos valores decorrentes da contribuição instituída para fazer face ao custo de obras públicas de que decorra valorização imobiliária.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.13.00.00.00.00','MULTAS E JUROS DEMAIS CONTRIBUIÇÕES','Registra os valores relativos aos créditos aos créditos a receber, decorrentes da cobrança das demais contribuições.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.14.00.00.00.00','MULTAS E JUROS CONTRIBUIÇÃO PARA O CUSTEIO DO SERVIÇO DE ILUMINAÇÃO PÚBLICA','Registra os valores relativos aos crédtios a receber dos Municípios e o Distrito Federal que instituirem contribuição, na forma das respectivas leis, para o custeio do serviço de iluminação pública, conforme artigo 149- A da Constituição Federal de 1988.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.15.00.00.00.00','MULTAS E JUROS CRÉDITOS RIBUTARIOS PARCELADOS','Registra os valores relativos aos créditos aos créditos a receber, decorrentes de Créditos Tributários Parcelados.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.16.00.00.00.00','MULTAS E JUROS DE DÍVIDA ATIVA TRIBUTÁRIA','Registra os valores de multas e juros de dívida ativa tributária.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.97.00.00.00.00','(-) DEDUCOES','Registra as deduções de juros e encargos de mora sobre créditos tributários.','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.4.1.99.00.00.00.00','JUROS E ENCARGOS DE MORA SOBRE OUTROS CRÉDITOS TRIBUTÁRIOS','Registra os juros e encargos de mora sobre outros créditos tributários.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.0.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA','Compreende as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.2.9.1.00.00.00.00.00','OUTROS JUROS E ENCARGOS DE MORA - CONSOLIDAÇÃO','Registra as outras variações patrimoniais aumentativas decorrentes de juros e multas com penalidades pecuniárias decorrentes da inobservância de normas e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.0.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.1.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.2.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.2.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE EMPRÉSTIMOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos empréstimos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.3.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - UNIÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.4.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - ESTADO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.3.5.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS INTERNOS CONCEDIDOS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos internos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.4.0.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.4.1.00.00.00.00.00','VARIAÇÕES MONETÁRIAS E CAMBIAIS DE FINANCIAMENTOS EXTERNOS CONCEDIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras referentes aos financiamentos externos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.0.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS','Compreende a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nos moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.1.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.3.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - UNIÃO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.4.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - ESTADO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.3.9.5.00.00.00.00.00','OUTRAS VARIAÇÕES MONETÁRIAS E CAMBIAIS - INTER OFSS - MUNICÍPIO','Registra a variação patrimonial aumentativa proveniente de variações da nossa própria moeda em relação aos índices ou coeficientes aplicáveis por dispositivo legal ou contratual e a variação do valor da nossa moeda em relação às moedas estrangeiras, com exceção de empréstimos e financiamentos concedidos. Ressalte-se que será tratada como variação monetária apenas a correção monetária pós-fixada. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.4.0.0.00.00.00.00.00','DESCONTOS FINANCEIROS OBTIDOS','Compreende a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.4.0.1.00.00.00.00.00','DESCONTOS FINANCEIROS OBTIDOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa decorrente de descontos financeiros obtidos em virtude de liquidação antecipada de obrigações. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.0.0.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS E APLICAÇÕES FINANCEIRAS','Compreende o valor total das variações patrimoniais aumentativas decorrentes da remuneração do saldo diário dos depósitos da União existentes no banco central, bem como aplicação de recursos da conta única de acordo com a rentabilidade media intrínseca dos títulos do tesouro.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.0.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.00.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS BANCÁRIOS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa decorrente da remuneração dos depósitos bancários do ente existentes no agente financeiro. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.01.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS VINCULADOS','Registra o valor da VPA proveniente da remuneração de depositos bancarios de recursos vinculados, tais como: royalties, FUNDEB, fundo de saúde, regime próprio de previdência social dos servidores, manutenção e desenvolvimento do ensino, ações e serviços públicos de saúde (ASPS), fundetur, etc. da remuneração de aplicações financeiras de recursos vinculados, tais como: royalties, FUNDEB, fundo de saúde, regime próprio de previdência social dos servidores, manutenção e desenvolvimento do ensino, ASPS, etc.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.02.00.00.00.00','REMUNERAÇÃO DE DEPÓSITOS DE RECURSOS NÃO VINCULADOS','Registra o valor da VPA proveniente da remuneração de depósitos bancários de recursos não vinculados, inclusive recursos próprios. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.03.00.00.00.00','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','Registra o somatório das VPA decorrentes de remuneração da carteira de investimentos dos RPPS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.96.00.00.00.00','REMUNERACAO DE OUTROS DEPOSITOS BANCARIOS  ','Registra a variação patrimonial aumentativa decorrente da remuneração de outros depositos bancarios do ente existentes no agente financeiro não relacionados nas contas acima.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.1.1.97.00.00.00.00','(-) DEDUÇÕES  ','Registra as deduções de VPA ocorridas nas contas acima ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.0.00.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.00.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa proveniente da remuneração de depósitos bancários, recursos oriundos de aplicações de entidades da administração pública no mercado financeiro, autorizadas por lei, em caderneta de poupança, fundo de investimento, contas remuneradas e outros. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.01.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS VINCULADOS','Registra o valor da VPA proveniente da remuneração de aplicações financeiras de recursos vinculados, tais como: royalties, FUNDEB, fundo de saúde, regime próprio de previdência social dos servidores, manutenção e desenvolvimento do ensino, ações e serviços públicos de saúde (ASPS), fundetur, etc. da remuneração de aplicações financeiras de recursos vinculados, tais como: royalties, FUNDEB, fundo de saúde, regime próprio de previdência social dos servidores, manutenção e desenvolvimento do ensino, ASPS, etc.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.02.00.00.00.00','REMUNERAÇÃO DE APLICAÇÕES FINANCEIRAS DE RECURSOS NÃO VINCULADOS','Registra o valor da VPA proveniente da remuneração de aplicações financeiras de recursos não vinculados, inclusive recursos próprios. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.03.00.00.00.00','REMUNERAÇÃO DOS INVESTIMENTOS DO REGIME PRÓPRIO DE PREVIDÊNCIA SOCIAL','Registra o valor da VPA decorrentes de remuneração da carteira de investimentos dos RPPS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.96.00.00.00.00','REMUNERACAO DE OUTRAS APLICAÇÕES FINANCEIRAS ','Registra a variação patrimonial aumentativa decorrente da remuneração de outras aplicações financeiras do ente existentes no agente financeiro não relacionados nas contas acima.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.5.2.1.97.00.00.00.00','(-) DEDUÇÕES  ','Registra as deduções de VPA ocorridas nas contas acima ','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.9.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS','Compreende as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.4.9.0.1.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS – FINANCEIRAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de operações financeiras não compreendidas nos subgrupos anteriores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.0.0.0.00.00.00.00.00','TRANSFERÊNCIAS E DELEGAÇÕES RECEBIDAS','Compreende o somatório das variações patrimoniais aumentativas com transferências inter governamentais, transferências intragovernamentais, transferências de instituições multigovernamentais, transferências de instituições privadas com ou sem fins lucrativos, transferências de convênios, transferências do exterior e execuções orçamentárias delegadas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTRAGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras relativas à execução orçamentária, e de bens e valores, referentes às transações intragovernamentais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repasse e sub-repasse). Não Inclui o valor repassado  para aportes no RPPS ou RGPS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA A EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreendeo valor das transferências financeiras recebidas e correspondência de créditos em virtude da execução orçamentária (cota, repassse e sub-repasse). Inclui também o valor repassado para a cobertura do déficit financeiro do RPPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.02.00.00.00.00','REPASSE RECEBIDO              ','Compreende o valor dos recursos recebidos decorrentes de transferencias financeiras entre orgãos da admistração direta e indireta, correspondentes ao orçamento anual .                                    ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.1.2.04.00.00.00.00','RECURSOS ARRECADADOS - RECEBIDOS','REGISTRA O VALOR RECEBIDO DE OUTRO ÓRGÃO OU ENTIDADE REFERENTE AO RECURSOS QUE FORAM ARRECADADOS (CLASSIFICADOS COMO RECEITA) PARA PAGAMENTO DE DESPESAS NA UNIDADE RECEBEDORA.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA','Compreende o valor das transferências financeiras, de bens ou valores recebidas para restos a pagar e outras finalidades independentes da execução orçamentária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS INDEPENDENTES DE EXECUÇÃO ORÇAMENTÁRIA - INTRA OFSS','Compreende o valor das transferências financeiras de bens ou valores recebidas para restos a pagar e outras finalidades independentes da execução orçamentária. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.01.00.00.00.00','TRANSFERÊNCIAS FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor da transferencia de OTR`s liberadas pelas   setoriais de programação financeira de cada orgão para suas subordinadas,  não vinculadas ao orçamento.  ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.2.2.02.00.00.00.00','TRANSFERÊNCIAS NÃO FINANCEIRAS RECEBIDAS - INDEPENDENTES DE EXECUCAO ORÇAMENTÁRIA','Registra o valor das transferências recebidas de bens ou valores independentes da execução orçamentária.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.0.00.00.00.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS','Compreende o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes., exceto os decorrentes de alíquota de contribuição suplementar.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.00.00.00.00.00','TRANSFERENCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RPPS – INTRA OFSS','Registra o valor das transferências para aportes financeiros do ente para cobertura de insuficiências financeiras, formação de reserva, e cobertura de déficits financeiros ou atuariais do RPPS e outros aportes, exceto os decorrentes de alíquota de contribuição suplementar. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.01.00.00.00.00','PLANO FINANCEIRO','Compreende o valor total dos valores recebidos pelo RPPS para cobertura de insuficiências financeiras, formação de reserva e outras necessidades financeiras, no âmbito do plano financeiro.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.01.01.00.00.00','RECURSOS PARA COBERTURA DE INSUFICIÊNCIAS FINANCEIRAS','Registra os recursos orçamentários efetivamente utilizados para a cobertura de insuficiências financeiras entre as receitas e despesas previdenciárias no exercício de referência.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.01.02.00.00.00','RECURSOS PARA FORMAÇÃO DE RESERVA','Registra os recursos transferidos pelo ente federativo ao RPPS para formação de reserva espontânea, para futuros pagamentos de benefícios do plano financeiro.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.01.99.00.00.00','OUTROS APORTES PARA O RPPS','Registra o somatório do recebimento de eventuais aportes de recursos no RPPS para outras necessidades financeiras que não a cobertura de insuficiências financeiras e formação de reservas.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.02.00.00.00.00','PLANO PREVIDENCIÁRIO','Compreende o valor total recebido pelo RPPS para cobertura de déficit financeiro ou atuarial e outros aportes, no âmbito do plano previdenciário.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.02.01.00.00.00','RECURSOS PARA COBERTURA DE DÉFICIT FINANCEIRO','Registra o somatório dos recebimentos de recursos necessários ao equilíbrio financeiro do plano previdenciário, ou seja, à cobertura dedéficit entre as receitas e despesas previdenciárias, referentes ao exercício atual.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.02.02.00.00.00','RECURSOS PARA COBERTURA DE DÉFICIT ATUARIAL','Registra os recursos orçamentários alocados para cobertura de déficit atuarial no exercício de referência, desde que não definidos por lei como contribuições suplementares.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.3.2.02.99.00.00.00','OUTROS APORTES PARA O RPPS','Registra outros aportes financeiros para o RPPS com outras finalidades previdenciárias.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.4.0.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS','Compreende o valor das transferências recebidas para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.1.4.2.00.00.00.00.00','TRANSFERÊNCIAS RECEBIDAS PARA APORTES DE RECURSOS PARA O RGPS  – INTRA OFSS','Registra o valor das transferências recebidas para os aportes financeiros da União para a cobertura de déficits financeiros ou atuariais do RGPS. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.0.0.00.00.00.00.00','TRANSFERÊNCIAS INTER GOVERNAMENTAIS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências da União, estados, distrito federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.0.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS','Compreendem as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.1.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  Por exemplo, empresa independente de um ente recebendo transferência de outro ente (a empresa independente não pertence ao OFSS mas pertence ao conceito de governamental).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS – UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.02.00.00.00.00','COTA-PARTE FPM','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Fundo de Participação dos Municípios.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.03.00.00.00.00','COTA-PARTE ITR','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto Territorial Rural.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.04.00.00.00.00','COTA-PARTE IPI','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto sobre Produtos Industrializados.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.05.00.00.00.00','COTA-PARTE IMPOSTO SOBRE OPERAÇÕES DE CRÉDITO, CAMBIO E SEGURO, OU RELATIVA A TITULOS OU VALORES MOBILIARIOS - COMERCIALIZAÇÃO DO OURO','Registra a variação patrimonial aumentativa decorrente da transferência da cota-parte do Imposto sobre Operações de Crédito, Câmbio e Seguro ou relativa a títulos ou valores mobiliários - comercialização do ouro.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.06.00.00.00.00','TRANSFERENCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Registra a variação patrimonial aumentativa decorrente da transferência da compensação financeira pela exploração dos recursos naturais.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.07.00.00.00.00','TRANSFERÊNCIAS DE RECURSOS DO SUS','Registra a variação patrimonial aumentativa decorrente da transferência de recursos do SUS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.08.00.00.00.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DE ASSITENCIA SOCIAL - FNAS','Registra a variação patrimonial aumentativa decorrente da transferência de recursos do Fundo Nacional de Assistência Social - FNAS.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.09.00.00.00.00','TRANSFERÊNCIAS DE RECURSOS DO FUNDO NACIONAL DO DESENVOLVIMENTO DA EDUCAÇÃO - FNDE','Registra a variação patrimonial aumentativa decorrente da transferência de transferências de recursos do Fundo Nacional do Desenvolvimento da Educação - FNDE.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.10.00.00.00.00','TRANSFERENCIA FINANCEIRA DO ICMS DESONERAÇÃO - LC 87/96 (LEI KANDIR)','Registra a variação patrimonial aumentativa decorrente da transferência da transferência financeira do ICMS Desoneração - LC 87/1996 (Lei Kandir).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.11.00.00.00.00','TRANSFERENCIA DA UNIAO - PASEP','Registra a VPA recebida da união referente ao PASEP.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.12.00.00.00.00','AUXÍLIO FINANCEIRO – ESFORÇO EXPORTADOR (MP N° 193/04)','Registra o valor da transferencia recebida da uniao referente ao auxilio exportador - CEX (registra o valor da arrecadação de receita de transferência da compensação financeira.), instituida pela Medida Provisoria 193.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.13.00.00.00.00','FPM - APOIO FINANCEIRO (MP 462/2009)','Registra o valor da prestação de apoio financeiro pela união aos entes federados que recebem recursos do fundo de participação dos municípios - FPM, no exercício de 2009, com o objetivo de superar dificuldades financeiras emergenciais. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.14.00.00.00.00','FPM - APOIO FINANCEIRO (MP 480/2010)','Registra o valor da prestação de apoio financeiro pela união aos entes federados que recebem recursos do fundo de participação dos municípios - FPM, no exercício de 2010, com o objetivo de superar dificuldades financeiras emergenciais. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.15.00.00.00.00','FPM - APOIO FINANCEIRO (Lei Federal nº 12.859/2013)','Registra o valor da prestação de apoio financeiro pela união aos entes federados que recebem recursos do fundo de participação dos municípios - FPM, nos exercícios de 2013 e 2014, com o objetivo de incentivar a melhoria da qualidade dos serviços públicos municipais. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.16.00.00.00.00','TRANSFERENCIAS DE CONVENIOS DA UNIAO E DE SUAS ENTIDADES','Registra o valor total dos recursos oriundos de convênios firmados, com ou sem contraprestações de serviços, com a união ou com suas entidades, para realização de objetivos de interesse comum dos partícipes, e destinados a custear despesas correntes. Ex: para o sistema unico de saude - SUS, convenios da união destinadas a programas de educação, convenios da união destinadas a programas de assistencia social, convenios da união destinadas a programas de combate a fome, destinadas a programas de saneamento basico além de outras transferencias de convenios da união.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.3.99.00.00.00.00','OUTRAS PARTICIPAÇÕES NA RECEITA DA UNIÃO','Registra as outras variações patrimoniais aumentativas decorrentes da transferência de receitas da União, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é da União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.00.00.00.00.00','TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS DE RECEITAS - INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é do órgão transferidor. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.01.00.00.00.00','COTA-PARTE DO ICMS','Registra o valor da arrecadação de VPA de transferência da participação de municípios na arrecadação do imposto sobre a circulação de mercadorias e prestação de serviços – ICMS, pelo Estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.02.00.00.00.00','COTA-PARTE DO IPVA','Registra o valor da arrecadação de VPA de transferência da participação de municípios na arrecadação do imposto sobre a propriedade de veículos automotores – IPVA, pelo Estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.03.00.00.00.00','COTA-PARTE DO IPI SOBRE EXPORTACAO','Registra o valor da arrecadação de VPA de transferência da participação de municípios na arrecadação do imposto sobre a produtos industrializados – IPI, para exportação.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.04.00.00.00.00','COTA-PARTE DA CONTRIBUIÇÃO DE INTERVENÇÃO NO DOMÍNIO ECONÔMICO','Registra o valor total das receitas recebidas pelos Municípios por meio de transferências constitucionais da contribuição de intervenção no domínio econômico (Emenda Constitucional nº 42, de 19/12/2003).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.05.00.00.00.00','TRANSFERÊNCIA DA COMPENSAÇÃO FINANCEIRA PELA EXPLORAÇÃO DE RECURSOS NATURAIS','Registra o valor da arrecadação de receita com a transferência da cotaparte da compensação financeira proveniente da exploração de recursos naturais.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.06.00.00.00.00','TRANSFERENCIA DE RECURSOS DO ESTADO PARA PROGRAMAS DE SAUDE - REPASSE FUNDO A FUNDO','Registra o valor de receita da transferência de recursos do Sistema Único de Saúde oriundo do Fundo Estadual de Saúde para o Fundo Municipal de Saúde (Ações Básicas de Vigilância Sanitária, Atenção à Saúde dos Povos Indígenas, Programa de Assistência Farmacêutica Básica, Programa de Combate às Carências Nutricionais, Programa de Saúde da Família, Programa de Agentes Comunitários, Programa Nacional de Vigilância Epidemiológica e Controle de Doenças e outros)','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.07.00.00.00.00','COTA-PARTE DA MULTA DE TRANSITO','Registra o valor total das VPA recebidas através de cota-parte da multa de trânsito transferida pelo Estado e executadas como recurso livre até 30 de junho de 2009.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.08.00.00.00.00','TRANSFERENCIAS DE CONVENIOS DOS ESTADOS E DO DISTRITO FEDERAL E DE SUAS ENTIDADES','Registra o valor total dos recursos oriundos de convênios firmados, com ou sem contraprestações de serviços com estados ou com o distrito federal e respectivas entidades públicas, para realização de objetivos de interesse comum dos partícipes, e destinados a custear despesas correntes. Ex: convenios dos estados para o sistema unico de saude - SUS, convenios dos estados destinadas a programas de educação, programa de abrigagem a população adulta de rua, revisão de beneficios de prestação continuada - BPC, programa de atendimento a criança, programa de apoio a pessoa portadora de deficiencia, programa de atenção a pessoa idosa, programa asema-apoio socio-educativo em meio aberto, programa OASF - orientação e apoio socio-familiar, programa de abrigo as crianças e adolescentes, transferencias relativas ao PROSAN além de outras transferencias de convenios dos estados.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.97.00.00.00.00','(-) DEDUÇÕES','Registra as deduções das VPA de transferencia inter governamental','D','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.1.4.99.00.00.00.00','OUTRAS PARTICIPAÇÕES NA RECEITA DOS ESTADOS','Registra as outras variações patrimoniais aumentativas decorrentes da transferência de outras esferas de governo de receitas tributárias, de contribuições e de outras receitas vinculadas, prevista na Constituição ou em leis específicas, cuja competência de arrecadação é ,do órgão transferidor.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.0.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB','Compreende as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.3.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas decorrentes de recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007, decorrentes de complementação da União. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.2.4.00.00.00.00.00','TRANSFERÊNCIAS DO FUNDEB - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas decorrentes da recursos recebidos do Fundo de Manutenção e Desenvolvimento da Educação Básica e de Valorização dos Profissionais da Educação, instituído pela E.C. n.º 53/2006 e regulamentado pela lei 11.494/2007. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.0.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS','Compreendem as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.1.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).  ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.01.00.00.00.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.02.00.00.00.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.03.00.00.00.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.04.00.00.00.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.3.99.00.00.00.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS – INTER OFSS - ESTADO','Compreende as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.01.00.00.00.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.02.00.00.00.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.03.00.00.00.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.04.00.00.00.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.4.99.00.00.00.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.00.00.00.00.00','TRANSFERÊNCIAS VOLUNTÁRIAS - INTER OFSS - MUNICÍPIO','Compreende as variações patrimoniais aumentativas decorrentes de transferências voluntárias da União, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, bem como as demais entidades, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.01.00.00.00.00','CONTRIBUIÇÕES','Registra a variação patrimonial aumentativa decorrente de transferências correntes e de capital aos entes da Federação e a entidades privadas sem fins lucrativos, exceto para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.02.00.00.00.00','AUXÍLIOS','Registra a variação patrimonial aumentativa decorrente de transferências de capital aos entes da Federação e a entidades privadas sem fins lucrativos;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.03.00.00.00.00','SUBVENÇÕES SOCIAIS','Registra a variação patrimonial aumentativa decorrente de transferências às entidades privadas sem fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.04.00.00.00.00','SUBVENÇÕES ECONÔMICAS','Registra o valor utilizado para transferências correntes às entidades públicas ou privadas com fins lucrativos para os serviços essenciais de assistência social, médica e educacional;','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.3.5.99.00.00.00.00','DEMAIS TRANSFERÊNCIAS VOLUNTÁRIAS','Registra a variação patrimonial aumentativa decorrente das demais transferências voluntárias.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.0.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS','Compreendem as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive as entidades vinculadas, de bens e/ou valores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.1.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.3.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.4.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.2.4.5.00.00.00.00.00','OUTRAS TRANSFERÊNCIAS – INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas decorrentes de demais transferências da união, estados, Distrito Federal, municípios, inclusive das entidades vinculadas, de bens e/ou valores. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.0.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas, inclusive de bens e valores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.1.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.1.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS SEM FINS LUCRATIVOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas sem fins lucrativos, inclusive de bens e valores. Exemplo: ONGs, OSCIPS e OS. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.2.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.3.2.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES PRIVADAS COM FINS LUCRATIVOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências financeiras das instituições privadas com fins lucrativos, inclusive de bens e valores. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.0.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.00.00.00.00.00','TRANSFERÊNCIAS DAS INSTITUIÇÕES MULTIGOVERNAMENTAIS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.01.00.00.00.00','TRANSFERENCIAS DE RECURSOS DO FUNDEB','Registra o valor total dos recursos de transferências recebidos diretamente do FUNDEB, pelos estados, distrito federal e municípios, independente do valor que foi deduzido no ente para formação do FUNDEB.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.02.00.00.00.00','TRANSFERÊNCIAS DE RECURSOS DA COMPLEMENTAÇÃO DO FUNDEB','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Transferências de Recursos da Complementação do FUNDEB.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.4.0.1.99.00.00.00.00','OUTRAS TRANSFERÊNCIAS MULTIGOVERNAMENTAIS','Registra as variações patrimoniais aumentativas decorrentes das transferências das instituições multigovernamentais, das quais o ente recebedor não participe - Outras Transferências Multigovernamentais.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.5.0.0.00.00.00.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS','Compreende as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.5.0.1.00.00.00.00.00','TRANSFERÊNCIAS DE CONSÓRCIOS PÚBLICOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes das transferências de consórcios públicos, dos quais o ente recebedor participe. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.6.0.0.00.00.00.00.00','TRANSFERÊNCIAS DO EXTERIOR','Compreende as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.6.0.1.00.00.00.00.00','TRANSFERÊNCIAS DO EXTERIOR - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de transferências de organismos e fundos internacionais, de governos estrangeiros e instituições privadas com ou sem fins lucrativos no exterior. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.0.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) ou Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.3.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.4.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.1.5.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE ENTES – INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização dos Entes (União, Estados, Distrito Federal ou Municípios) para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.2.0.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS','Compreende as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.7.2.1.00.00.00.00.00','EXECUÇÃO ORÇAMENTÁRIA DELEGADA DE CONSÓRCIOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de transferência de recursos financeiros, decorrentes de delegação ou descentralização de Consórcios Públicos para execução de ações de responsabilidade exclusiva do delegante. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.8.0.0.00.00.00.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS','Compreende as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.5.8.0.1.00.00.00.00.00','TRANSFERÊNCIAS DE PESSOAS FÍSICAS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas decorrentes de contribuições e doações a governos e entidades da administração descentralizada realizadas por pessoas físicas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.0.0.0.00.00.00.00.00','VALORIZAÇÃO E GANHOS COM ATIVOS','Compreende a variação patrimonial aumentativa com reavaliação e ganhos de ativos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.0.0.00.00.00.00.00','REAVALIAÇÃO DE ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo, quando esse for superior ao valor liquido contábil.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.0.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.1.00.00.00.00.00','REAVALIAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens do ativo imobilizado, quando esse for superior ao valor liquido contábil.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.1.01.00.00.00.00','REAVALIAÇÃO DE BENS MÓVEIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens móveis, quando esse for inferior ao valor liquido contábil.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.1.1.02.00.00.00.00','REAVALIAÇÃO DE BENS IMÓVEIS','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para bens imóveis, quando esse for inferior ao valor liquido contábil.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.2.0.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.2.1.00.00.00.00.00','REAVALIAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para ativos intangíveis, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.9.0.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS','Compreende a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.1.9.1.00.00.00.00.00','REAVALIAÇÃO DE OUTROS ATIVOS - CONSOLIDAÇÃO','Registra a variação patrimonial aumentativa relativa à adoção do valor de mercado ou de consenso entre as partes para outros ativos, quando esse for superior ao valor liquido contábil. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.0.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO','Compreende o ganho com alienação de ativos, ou seja, quando o valor alienado do ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.1.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS','Compreende o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.1.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INVESTIMENTOS - CONSOLIDAÇÃO','Registra o ganho com alienação de investimentos, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.2.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO','Compreende o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.2.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE IMOBILIZADO - CONSOLIDAÇÃO','Registra o ganho com alienação de ativo imobilizado, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.3.0.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS','Compreende o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.2.3.1.00.00.00.00.00','GANHOS COM ALIENAÇÃO DE INTANGÍVEIS - CONSOLIDAÇÃO','Registra o ganho com alienação de ativos intangíveis, ou seja, quando o valor alienado do referido ativo e maior que o seu valor contábil, de maneira que a diferença compreende o ganho. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.0.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de novos ativos descobertos, a contrapartida da incorporação de ativos semoventes nascidos, por exemplo.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.1.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS','Compreende os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.1.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR DESCOBERTAS - CONSOLIDAÇÃO','Registra os ganhos com a incorporação de novos ativos descobertos, como por exemplo, descoberta de jazidas de recursos naturais. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.2.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS','Compreende os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.2.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS POR NASCIMENTOS - CONSOLIDAÇÃO','Registra os ganhos com a incorporação de semoventes nascidos, como por exemplo, nascimento de bovinos e aves. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.0.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE VALORES APREENDIDOS','Compreende os ganhos  com a incorporação de valores apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.3.1.00.00.00.00.00','GANHOS COM INCORPORAÇÃO DE ATIVOS APREENDIDOS - CONSOLIDAÇÃO','Registra os ganhos  com a incorporação de ativos apreendidos, como por exemplo, os valores apreendidos associados ao trafico ilícito de entorpecentes e drogas afins. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.9.0.00.00.00.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS','Compreende a contrapartida da incorporação de outros novos ativos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.3.9.1.00.00.00.00.00','OUTROS GANHOS COM INCORPORAÇÃO DE ATIVOS - CONSOLIDAÇÃO','Registra a contrapartida da incorporação de outros novos ativos.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.4.0.0.00.00.00.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS','Compreende a contrapartida da desincorporação de passivos, inclusive as baixas de passivo decorrentes do cancelamento de restos a pagar.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.6.4.0.1.00.00.00.00.00','GANHOS COM DESINCORPORAÇÃO DE PASSIVOS - CONSOLIDAÇÃO','Registra a contrapartida da desincorporação de passivos, inclusive as baixas de passivo decorrentes do cancelamento de restos a pagar. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.0.0.0.00.00.00.00.00','OUTRAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende o somatório das demais variações patrimoniais aumentativas não incluídas nos grupos anteriores, tais como: resultado positivo da equivalência patrimonial, dividendos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.1.0.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR','Compreende os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.1.0.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA A CLASSIFICAR - CONSOLIDAÇÃO','Registra os recursos referentes à variação patrimonial aumentativa recebidas e não classificadas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.0.0.00.00.00.00.00','RESULTADO POSITIVO DE PARTICIPAÇÕES','Compreende o resultado positivo das participações de caráter permanente no capital social de sociedades investidas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.0.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL','Compreende a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.1.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - CONSOLIDAÇÃO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.  Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.2.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTRA OFSS','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros.   Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.3.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - UNIÃO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.4.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - ESTADO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.1.5.00.00.00.00.00','RESULTADO POSITIVO DE EQUIVALÊNCIA PATRIMONIAL - INTER OFSS - MUNICÍPIO','Registra a apropriação do resultado positivo da equivalência patrimonial, oriundo de lucros apurados nas empresas controladas e coligadas, dentre outros. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.2.0.00.00.00.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS','Compreende as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.2.2.1.00.00.00.00.00','DIVIDENDOS E RENDIMENTOS DE OUTROS INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações aumentativas oriundas de lucros apurados em outros investimentos não avaliados pelo método da equivalência patrimonial. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.0.0.00.00.00.00.00','REVERSÃO DE PROVISÕES E AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões e ajustes de perdas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.0.00.00.00.00.00','REVERSÃO DE PROVISÕES','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.00.00.00.00.00','REVERSÃO DE PROVISÕES – CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.01.00.00.00.00','REVERSÃO DE PROVISÃO PARA RISCOS TRABALHISTAS','Registra a variação patrimonial aumentativa proveniente de reversão de provisão para riscos trabalhistas.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.02.00.00.00.00','REVERSÃO DE PROVISÕES MATEMÁTICAS PREVIDENCIÁRIAS A LONGO PRAZO','Registra a variação patrimonial aumentativa proveniente de reversão de provisões matemáticas previdenciárias a longo prazo.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.03.00.00.00.00','REVERSÃO DE PROVISÕES PARA RISCOS FISCAIS','Registra a variação patrimonial aumentativa proveniente de reversão de provisões para riscos fiscais.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.04.00.00.00.00','REVERSÃO DE PROVISÕES PARA RISCOS CÍVEIS','Registra a variação patrimonial aumentativa proveniente de reversão de provisão riscos cíveis.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.05.00.00.00.00','REVERSÃO DE PROVISÕES REPARTIÇÃO DE CRÉDITO','Registra a variação patrimonial aumentativa proveniente de reversão de provisões por repartição de crédito.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.06.00.00.00.00','REVERSÃO DE PROVISÕES DECORRENTES DE CONTRATOS DE PPP','Registra a variação patrimonial aumentativa proveniente de reversão de provisões decorrentes de contratos de PPP.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.1.99.00.00.00.00','REVERSÃO DE OUTRAS PROVISÕES','Registra a variação patrimonial aumentativa proveniente de reversão de outras provisões.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.3.00.00.00.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.4.00.00.00.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - ESTADOS','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.1.5.00.00.00.00.00','REVERSÃO DE PROVISÕES – INTER OFSS - MUNICÍPIOS','Registra as variações patrimoniais aumentativas provenientes de reversões de provisões. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.0.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS','Compreende as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.1.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS – CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.2.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS - INTRA OFSS ','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.3.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – UNIÃO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.4.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS – ESTADO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.7.2.5.00.00.00.00.00','REVERSÃO DE AJUSTES DE PERDAS –INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes de reversões de ajustes de perdas. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um Município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.0.0.00.00.00.00.00','DIVERSAS VARIAÇÕES PATRIMONIAIS AUMENTATIVAS','Compreende outras variações patrimoniais aumentativas não classificadas em itens específicos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.2.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - UNIÃO','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.01.00.00.00.00','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES – PRINCIPAL','Registra a VPA decorrente de compensações financeiras entre o regime geral e os regimes próprios de previdência dos servidores – principal','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.3.02.00.00.00.00','COMPENSAÇÕES FINANCEIRAS ENTRE O REGIME GERAL E OS REGIMES PRÓPRIOS DE PREVIDÊNCIA DOS SERVIDORES – PARCELAMENTOS','Registra a VPA decorrente de compensações financeiras entre o regime geral e os regimes próprios de previdência dos servidores – parcelamentos','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.1.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE RGPS/RPPS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre o regime geral de previdência social e os regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.0.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS','Compreende as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.3.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.4.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.2.5.00.00.00.00.00','COMPENSAÇÃO FINANCEIRA ENTRE REGIMES PRÓPRIOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes da compensação financeira entre regimes próprios de previdência social dos servidores da União, dos estados, do distrito federal e dos municípios na hipótese de contagem recíproca de tempo de contribuição (não concomitante). Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.3.0.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.3.1.00.00.00.00.00','VARIAÇÃO PATRIMONIAL AUMENTATIVA COM BONIFICAÇÕES - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de bonificações recebidas nas aquisições de mercadorias. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.0.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS','Compreende as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.1.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - CONSOLIDAÇÃO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.2.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTRA OFSS','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos.  Compreende os saldos que serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS) do ente.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.3.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - UNIÃO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e a União.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.4.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - ESTADO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e um estado.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.4.5.00.00.00.00.00','AMORTIZAÇÃO DE DESÁGIO EM INVESTIMENTOS - INTER OFSS - MUNICÍPIO','Registra as variações patrimoniais aumentativas provenientes de amortização de deságio em investimentos. Compreende os saldos que serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS) de entes públicos distintos, resultantes das transações entre o ente e município.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.0.00.00.00.00.00','MULTAS ADMINISTRATIVAS','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.00.00.00.00.00','MULTAS ADMINISTRATIVAS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de penalidades pecuniárias decorrentes da inobservância de normas, e com rendimentos destinados a indenização pelo atraso no cumprimento da obrigação. Representa o resultado das aplicações impostas ao contribuinte faltoso, como sanção legal no campo tributário (impostos, taxas e contribuição de melhoria) e não-tributário (contribuições sociais e econômicas, patrimoniais, industriais, serviços e diversas) e de natureza administrativa, por infrações a regulamentos. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.03.00.00.00.00','MULTA DE POLUICAO DE AGUAS','Registra as variações patrimoniais  aumentativas provenientes de penalidades pecuniarias destinadas a punir o infrator  pela  poluiçao  de  aguas.  Multas   dev.  lancamento   oleos,produtos oleosos e substancias quimicas toxicas nas aguas publicas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.07.00.00.00.00','MULTAS PREVISTAS NA LEGISLAÇÃO SANITARIA','Registra as variações patrimoniais  aumentativas provenientes de multas  aplicadas  com o fim de punir a quem transgride o disposto na legislação sanitaria. Devidas quando da infração, fraude, falsificação e adulteração das   materias-primas e produtos farmaceuticos, bem como quaisquer produtos ou  insumos que interessem a saude publica.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.08.00.00.00.00','MULTAS PREVISTAS LEGISLAÇÃO DE REGISTRO COMERCIO','Registra as variações patrimoniais  aumentativas provenientes de multas aplicadas  com  o fim de punir a quem infringe as leis ou regulamentos que disciplinam as atividades de agentes auxiliares do comercio, de armazens gerais e  outros sujeitos ao controle e fiscalização dos orgaos de registro do comercio.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.11.00.00.00.00','MULTAS PREVISTAS NA LEGISLAÇÃO DE TRANSITO','Registra as variações patrimoniais  aumentativas provenientes de multas  aplicadas  com o fim de punir a quem transgride a legislação referente a transito.  Constituem VPA vinculada ao ministerio da justica.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.14.00.00.00.00','MULTAS E JUROS PREVISTOS EM CONTRATOS','Registra as variações patrimoniais  aumentativas provenientes de  multas e juros previstos em contratos                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.21.00.00.00.00','MULTAS POR DANOS AO MEIO AMBIENTE','Registra as variações patrimoniais  aumentativas provenientes de  multas por danos ao meio ambiente. Amparo legal: Lei 9 605 de 12 fev1998 .                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.25.00.00.00.00','MULTAS APLICADAS PELOS TRIBUNAIS DE CONTAS','Registra as variações patrimoniais  aumentativas provenientes de aplicação de penas pecuniarias incidentes sobre as multas aplicadas pelos tribunais de contas,  pelo não cumprimento a decisão dos mesmos.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.27.00.00.00.00','MULTAS POR AUTOS DE INFRACAO','Registra as variações patrimoniais  aumentativas provenientes de multas punitivas  aplicadas pelo não cumprimento nos casos previstos nos regulamentos ou nos contratos, ou pela reincidencia em fatos que tenham gerado advertencia.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.28.00.00.00.00','MULTA POR INFRAÇÃO À LEGISLAÇÃO DE LICITAÇÃO','Registra o valor da arrecadação de VPA de multas aplicadas por infrações praticadas em inobservância à legislação aplicada aos procedimentos de licitação.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.5.1.99.00.00.00.00','OUTRAS MULTAS ADMINISTRATIVAS','Registra as variações patrimoniais  aumentativas provenientes de outras multas administrativas nao enquadradas nas contas anteriores.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.0.00.00.00.00.00','INDENIZAÇÕES','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.00.00.00.00.00','INDENIZAÇÕES - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas provenientes de indenizações diversas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.01.00.00.00.00','INDENIZACOES POR DANOS CAUSADOS AO PATRIMONIO PUBLICO','Registra as variações patrimoniais  aumentativas provenientes de indenização por     danos causados ao patrimonio publico.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.02.00.00.00.00','INDENIZACAO POR PERDA/QUEBRA DE MERCADORIAS','Registra a variação patrimonial aumentativa proveniente de indenização por perda/quebra de mercadorias.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.03.00.00.00.00','INDENIZ. POSSE OU OCUPACAO ILIC. BENS','Registra a variação patrimonial aumentativa proveniente de indenização por posse ou ocupação ilícita de bens.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.04.00.00.00.00','REPOSIÇÃO/INDENIZAÇÃO DE SERVIDORES/AGENTES PÚBLICOS','Registra a variação patrimonial aumentativa proveniente de reposição ou indenização por parte de servidores ou agentes públicos.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.6.1.99.00.00.00.00','OUTRAS INDENIZACOES','Registra as variações patrimoniais  aumentativas provenientes de indenizações que não se enquadram nos itens anteriores.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.0.00.00.00.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99)','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.1.00.00.00.00.00','VPA DECORRENTE ALIENAÇÃO BENS APREENDIDOS - CONSOLIDAÇÃO','Compreende o somatório das variações patrimoniais aumentativas geradas pela alienação de mercadorias, objeto da pena de perdimento. O produto da arrecadação tem a seguinte destinação: 60% ao fundo especial de desenvolvimento e aperfeiçoamento das atividades de fiscalização - fundão e 40% ao fundo nacional de assistência social - Ministério da Previdência e Assistência Social ao fundo nacional antidroga - FUNAD, para aplicação conforme legislação em vigor, quando da apreensão de bens, direitos e valores objeto do crime de trafico ilícito de substancias entorpecentes ou drogas afins. (lei 6368 de 21/10/76, lei 7460 de 19/12/86 e lei 9804 de 30/06/99). Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.7.1.01.00.00.00.00','VPA DE ALIENAÇÃO DE BENS E/OU MERCADORIAS APREENDIDAS','Registra as variações patrimoniais  aumentativas provenientes de alienação de bens e/ou de mercadorias apreendidas.                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.0.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.00.00.00.00.00','VARIAÇÕES PATRIMONIAIS AUMENTATIVAS DECORRENTES DE FATOS GERADORES DIVERSOS - CONSOLIDAÇÃO','Compreende as variações patrimoniais aumentativas decorrentes de fatos geradores diversos.Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.01.00.00.00.00','VPA DE ONUS SUCUMBENCIA DE ACOES JUDICIAIS','Registra a variação patrimonial aumentativa decorrente de custas do processo de apuração, inscrição e cobrança da divida ativa do municipio, bem como pela defesa judicial da fazenda municipal, paga pelo devedor da ação. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.02.00.00.00.00',' "TERCEIRIZAÇÃO" DA FOLHA DE PAGAMENTO DOS AGENTES PUBLICOS','Registra a variação patrimonial aumentativa proveniente da terceirização da folha  de pagamento dos agentes publicos como contrapartida da prestação de serviços de disponibilização de creditos em contas correntes e da concessão de emprestimos e financiamentos com amortização consignada em folha de pagamento. ','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.03.00.00.00.00','OUTRAS RECEITAS DIRETAMENTE ARRECADADAS PELO RPPS','Registra o valor total das demais vpas correntes arrecadadas diretamente pelo regime próprio de previdência','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.04.00.00.00.00','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTENCIA SOCIAL DOS SERVIDORES','Registra o valor total das VPA correntes arrecadadas diretamente pelo fundo de assistência social dos servidores','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.05.00.00.00.00','RECEITAS DIRETAMENTE ARRECADADAS PELO FUNDO DE ASSISTENCIA A SAUDE DOS SERVIDORES','Registra o valor total das VPA correntes arrecadadas diretamente pelo fundo de assistência a saúde dos servidores','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.06.00.00.00.00','RECEITAS DECORRENTES DA COMPRA DE DOSES DE SEMEN DE ANIMAIS PELOS PRODUTORES','Registra o valor total da VPA decorrente da compra pelos produtos de sêmen de animais.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.07.00.00.00.00','RECEITAS DECORRENTES DO RECEBIMENTO DE CERTIDÃO - TÍTULO EXECUTIVO DO TCE/RS','Registra a VPA decorrentes do recebimento total ou parcial  de certidão - título executivo emitido pelo  TCE/RS o qual foi registrado no ativo como créditos a receber e não como divida ativa não-tributária','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.08.00.00.00.00','PROGRAMA TROCA-TROCA','Registra o valor total da VPA proveniente do pagamento pelos agricultores do valor que lhes foi entregue em sementes pelo município. Inclusive a VPA da divida ativa.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.09.00.00.00.00','RESTITUICOES DETERMINADAS PELO TCE','Registra a VPA proveniente de créditos exigíveis a partir do recebimento, pelo credor, de certidão de decisão – título executivo, emitida pelo TCE/RS, com característica de liquidez e certeza, cuja inscrição do direito deu-se, fa','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.10.00.00.00.00','RESTITUICAO PELO USO DE BENS DO MUNICIPIO','Registra o valor total da arrecadação da VPA proveniente da utilização de bens do município. Ex: telefone móvel.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.11.00.00.00.00','RESTITUICAO PELO PAGAMENTO INDEVIDO','Registra o valor da restituição proveniente de pagamento indevido.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '4.9.9.9.1.12.00.00.00.00','RESTITUICAO DE AUXILIOS','Registra a arrecadação de recursos provenientes da devolução de saldos de auxílios.','C','S','P','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.0.0.0.0.00.00.00.00.00','CONTROLES DA APROVAÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de Compreender os atos e fatos ligados a execução orçamentária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.0.0.0.00.00.00.00.00','PLANEJAMENTO APROVADO','Compreende o somatório dos valores monetários previstos para execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.0.0.00.00.00.00.00','PPA - APROVADO','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.1.0.00.00.00.00.00','APROVAÇÃO INICIAL DO PPA','Registra os valores monetários previstos inicialmente para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.1.2.0.00.00.00.00.00','REVISAO DO PPA','Registra o somatorio dos valores monetarios das revisões anuais autorizadas durante o periodo de vigencia do plano plurianual, detalhado por programa de trabalho.','X','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.0.0.00.00.00.00.00','PLOA','Compreende o somatório dos valores monetários previstos para a execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no projeto de lei orçamentária anual.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.0.00.00.00.00.00','PROJETO INICIAL DA LEI ORCAMENTARIA  - RECEITA','Compreende o somatorio dos valores monetarios constantes do projeto da lei orçamentaria anual remetido pelo poder executivo ao poder legislativo para apreciação e aprovação.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.1.00.00.00.00.00','PLOA INICIAL DA RECEITA','Registra o somatorio dos valores monetarios da previsão de receita constante do PLOA inicial.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.1.2.00.00.00.00.00','ALTERACOES  DO PROJETO INICIAL DA LOA - RECEITA','Registra o somatorio das alterações no projeto inicial da LOA em relação a receita.','X','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.0.00.00.00.00.00','PROJETO INICIAL DA LOA - DESPESA','Compreende o somatorio dos valores monetarios constantes do projeto da lei orçamentaria anual remetido pelo poder executivo ao poder legislativo para apreciação e aprovação.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.1.00.00.00.00.00','PLOA INICIAL DA DESPESA','Registra o somatorio dos valores monetarios da fixação da despesa constante do PLOA inicial.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.1.2.2.2.00.00.00.00.00','ALTERACOES DO PROJETO INICIAL DA LOA - DESPESA','Registra o somatorio das alterações no projeto inicial da LOA em relação a despesa.','X','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.0.0.0.00.00.00.00.00','ORÇAMENTO APROVADO','Compreende o somatório dos valores relativos à previsão da receita, fixação da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.0.0.00.00.00.00.00','PREVISÃO DA RECEITA','Compreende o somatório dos valores relativos à previsão da receita pública aprovada pela lei orçamentária anual e suas alterações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.0.00.00.00.00.00','PREVISÃO INICIAL DA RECEITA','Compreende o valor da receita previsão inicial da receita aprovado na LOA.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.1.00.00.00.00.00','PREVISAO INICIAL DA RECEITA  BRUTA','Registra o valor bruto da receita previsão inicial da receita .','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.2.00.00.00.00.00','(-) PREVISÃO DE DEDUÇÕES DA RECEITA','Compreende a previsão de deduções da receita bruta aprovada na LOA.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.2.01.00.00.00.00','(-) DEDUÇÕES POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','Compreende a previsão de dedução da receita aprovada na LOA por transferências constitucionais e legais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.2.01.01.00.00.00','(-) FUNDEB','Registra a previsão de dedução da receita aprovada na LOA por transferências ao FUNDEB.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.2.01.02.00.00.00','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','Registra a previsão de dedução da receita aprovada na LOA por transferências constitucionais a municípios.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.2.02.00.00.00.00','(-) RENÚNCIA','Registra a previsão de renúncia da receita aprovada na LOA.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.1.2.99.00.00.00.00','(-) OUTRAS DEDUÇÕES','Registra a previsão de outras deduções da receita aprovada na LOA.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.0.00.00.00.00.00','ALTERAÇÃO DA PREVISÃO DA RECEITA','Compreende o valor dos créditos previstos após a aprovação do orçamento independente da autorização já concedida na lei orçamentária para abertura de credito suplementar.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.1.00.00.00.00.00','PREVISÃO ADICIONAL DA RECEITA','Compreende o valor adicional da receita para abertura de créditos adicionais.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.1.01.00.00.00.00','REESTIMATIVA','Registra o valor adicional da receita para abertura de créditos adicionais por motivo de reestimativa da receita.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.1.02.00.00.00.00','CORREÇÃO','Registra o valor adicional da receita para abertura de créditos adicionais por motivo de correção de erros ou omissões na estimativa da receita.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.1.2.9.00.00.00.00.00','(-) ANULAÇÃO DA PREVISÃO DA RECEITA','Registra o valor da anulação da receita prevista no orçamento, na gestão fundos e nas administrações direta e indireta.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.0.0.00.00.00.00.00','FIXAÇÃO DA DESPESA','Compreende o somatório dos valores relativos à fixação da despesa pública aprovada pela lei orçamentária e suas alterações.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.0.00.00.00.00.00','DOTAÇÃO ORÇAMENTÁRIA','Compreende o somatório dos valores monetários da dotação orçamentária inicial, adicional e seus cancelamentos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.00.00.00.00.00','DOTAÇÃO INICIAL','Compreende a dotação inicial autorizada na lei orçamentária anual.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.1.01.00.00.00.00','CREDITO INICIAL','Registra os valores pertinentes aos creditos inicialmente aprovados para dar suporte a execução orçamentaria','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.00.00.00.00.00','DOTAÇÃO ADICIONAL POR TIPO DE CREDITO','Compreende o somatório dos valores monetários da dotação orçamentária decorrentes da abertura de créditos adicionais e seus cancelamentos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.01.00.00.00.00','CREDITO ADICIONAL – SUPLEMENTAR','Registra o somatório dos valores relativos aos créditos adicionais suplementares com vista ao reforço da dotação orçamentária constante da lei orçamentária.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.00.00.00.00','CREDITO ADICIONAL - ESPECIAL','Compreende o somatório dos valores dos créditos adicionais especiais destinados a atender programas não contemplados na lei orçamentária anual.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.01.00.00.00','CRÉDITOS ESPECIAIS ABERTOS','Registra os valores referentes à abertura de créditos especiais autorizados em lei especifica.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.02.00.00.00','CRÉDITOS ESPECIAIS REABERTOS','Registra os valores referentes à reabertura de créditos especiais cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.02.03.00.00.00','CRÉDITOS ESPECIAIS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos especiais reabertos nos termos do § 2º do art. 167 da C.F./88.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.00.00.00.00','CREDITO ADICIONAL – EXTRAORDINÁRIO','Compreende o somatório dos valores referentes à abertura de créditos adicionais extraordinários destinados a despesas imprevisíveis e urgentes como as decorrentes de guerra, comoção interna ou calamidade pública.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.01.00.00.00','CRÉDITOS EXTRAORDINÁRIOS ABERTOS','Registra os valores referentes aos créditos extraordinários abertos por decreto do poder executivo.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.02.00.00.00','CRÉDITOS EXTRAORDINÁRIOS REABERTOS','Registra os valores referentes à reabertura de créditos extraordinários cujo ato de autorização foi promulgado nos últimos quatro meses do exercício anterior.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.2.03.03.00.00.00','CRÉDITOS EXTRAORDINÁRIOS REABERTOS - SUPLEMENTAÇÃO','Registra os valores referentes à suplementação de créditos extraordinários reabertos nos termos do § 2º do art. 168 da C.F./88.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.00.00.00.00.00','DOTAÇÃO ADICIONAL POR FONTE','Compreende o somatório dos valores da dotação adicional por fonte de recursos para abertura do credito adicional.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.01.00.00.00.00','SUPERAVIT FINANCEIRO DE EXERCICIO ANTERIOR','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA SUPERAVIT FINANCEIRO APURADO NO BALANCO PATRIMONIAL DO EXERCICIO ANTERIOR.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.02.00.00.00.00','EXCESSO DE ARRECADACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA EXCESSO DE ARRECADACAO.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.03.00.00.00.00','ANULACAO DE DOTACAO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA A ANULACAO PARCIAL OU TOTAL DE DOTACOES ORCAMENTARIAS OU CREDITOS ADICIONAIS, AUTORIZADOS EM LEI.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.04.00.00.00.00','OPERACOES DE CREDITO','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA OPERACOES DE CREDITO AUTORIZADAS.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.05.00.00.00.00','RESERVA DE CONTINGENCIA','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA A RESERVA DE CONTINGENCIA.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.06.00.00.00.00','DOTACAO TRANSFERIDA','REGISTRA OS VALORES DE ALTERACOES DA LEI ORCAMENTARIA COM CONTROLE POR ORIGEM DE CREDITO.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.07.00.00.00.00','RECURSOS SEM DESPESAS CORRESPONDENTES','REGISTRA OS VALORES PERTINENTES AOS CREDITOS ADICIONAIS ABERTOS CUJA ORIGEM DE RECURSOS SEJA OS RECURSOS QUE, EM DECORRENCIA DE VETO, EMENDA OU REJEICAO DO PROJETO DE LEI ORCAMENTARIA ANUAL, FICAREM SEM DESPESAS CORRESPONDENTES.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.09.00.00.00.00','(-) CANCELAMENTO DE DOTACOES','Registra o cancelamento / remanejamento de dotações para abertura de creditos adicionais.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.3.99.00.00.00.00','VALOR GLOBAL DA DOTACAO ADICIONAL POR FONTE','Registra o valor da contrapartida dos lançamentos das dotações adicionais por origem de credito.','X','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.00.00.00.00.00','CANCELAMENTO/REMANEJAMENTO DE DOTAÇÃO','Compreende o somatório dos valores relativos aos créditos inicial, suplementar, especial e extraordinário cancelados ou remanejados, em casos regularmente previstos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.00.00.00.00','ALTERACAO DO QUADRO DE DETALHAMENTO DA DESPESA ','Compreende  a movimentação dos creditos por acrescimo ou redução decorrente de alteração do quadro de detalhamento de despesas - QDD.       ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.01.00.00.00','ACRESCIMO','Registra  a movimentação dos creditos por acrescimo decorrente de alteração do quadro de detalhamento de despesas - QDD.       ','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.01.09.00.00.00','(-) REDUCAO','Registra  a movimentação dos creditos por redução decorrente de alteração do quadro de detalhamento de despesas - QDD.       ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.00.00.00.00','ALTERACAO DA LEI ORCAMENTARIA ','Compreende os valores dos creditos orçamentarios indisponiveis para execução da despesa, por medida de veto, contingenciamento ou  contenção, e posteriormente canceladas, nos casos regularmente previstos. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.01.00.00.00','ACRESCIMO','Registra os valores dos acrescimos  resultantes de alterações  da lei orçamentaria em virtude de remanejamento.                                                      ','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.02.09.00.00.00','(-) REDUCAO','Registra o valor da redução da dotação devido a alteração da lei  orçamentaria em virtude de remanejamento.                                               ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.1.9.04.00.00.00.00','(-) CANCELAMENTO DE DOTACOES','Registra o valor da redução da dotação devido a alteração da lei  orçamentaria em virtude de cancelamento.        ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.0.00.00.00.00.00','MOVIMENTAÇÃO DE CRÉDITOS RECEBIDOS','Compreende o somatório dos valores dos recebimentos de créditos orçamentários através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','D','N','O','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.1.00.00.00.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, recebidos ao longo do exercício.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.1.01.00.00.00.00','PROVISAO RECEBIDA            ','Registra a parcela de credito recebida por uma unidade  administrativa ou orçamentaria, decorrente da descentralização do  credito orçamentario ou adicional, dentro do proprio orgão.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.00.00.00.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional recebido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.00.00.00.00','ADMINISTRACAO DIRETA                ','Compreende o valor referente a movimentação de creditos decorrentes  de recebimento ou de transferencia de outros orgãos e entidades  de   igual ou de diferente unidade orçamentaria.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.01.00.00.00','CREDITOS RECEBIDOS ','Registra o valor dos creditos recebidos pela administração direta de outros orgãos e entidades.    ','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.01.09.00.00.00','(-) CREDITOS TRANSFERIDOS              ','Registra a movimentação de creditos de entidades da administração indireta ou entre orgãos da administração direta de unidade orçamentaria diferente.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.00.00.00.00','ADMINISTRACAO INDIRETA                 ','Compreende o valor referente a movimentação de creditos decorrentes   de recebimento ou de transferencia de outros orgãos e entidades de   igual ou de diferente unidade orçamentaria.                          ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.01.00.00.00','CREDITOS RECEBIDOS','Registra o valor dos creditos recebidos pela administração indireta de mesma ou de diferente unidade orçamentaria do orgão emitente.         ','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.2.02.09.00.00.00','(-) CREDITOS TRANSFERIDOS              ','Registra a movimentação de creditos de orgãos da administração direta ou entre entidades da administração indireta de mesma ou de   diferente unidade orçamentaria, não formalizada a termo de contrato.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.2.9.00.00.00.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Registra as movimentações de créditos recebidos por cisão, fusão, extinção, compensação e outras transações.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.3.0.00.00.00.00.00','DETALHAMENTO DE CREDITO','Registra o somatório relativos às dotações detalhadas relativas a cada ação orçamentária (projeto, atividade ou operações especiais).','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.0.00.00.00.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores das despesas pré-empenhadas e empenhadas por detalhamento específico.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.00.00.00.00.00','PRÉ-EMPENHOS DA DESPESA  ','COMPREENDE O CREDITO ORCAMENTARIO PRE-EMPENHADO, PARA ATENDER OBJETIVO ESPECIFICO, NOS CASOS EM QUE A DESPESA A SER REALIZADA, POR SUAS CARACTERISTICAS, EXIGE UM INTERVALO DE TEMPO DESDE A DECISAO DA REALIZACAO DA DESPESA ATE A EFETIVACAO DA EMISSAO DE NE.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.01.00.00.00.00','PRÉ-EMPENHOS EMITIDOS','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS PELA PROPRIA UNIDADE GESTORA DETENTORA PELO CREDITO DISPONIVEL.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.02.00.00.00.00','REFORÇO DE PRÉ-EMPENHO','Registra os valores de reforço de pré-empenho emitido pela própria unidade detentora do crédito disponível.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.1.03.00.00.00.00','ANULAÇÃO DE PRÉ-EMPENHO','Registra a anulação de pré-empenho emitido pela própria unidade detentora do crédito disponível.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.00.00.00.00.00','EMPENHOS POR EMISSAO                             ','Compreende o somatorio dos valores empenhados por detalhamento especifico.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.00.00.00.00','EXECUÇÃO DA DESPESA POR NOTA DE EMPENHO             ','Compreende o controle dos empenhos emitidos, reforçados e transferidos, que envolvam despesas orçamentarias realizadas pela administração publica.                    ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.01.00.00.00','EMISSAO DE EMPENHOS       ','Registra o valor da emissão de empenho da despesa, inclusive aquelas que foram objeto de pre-empenho.                                 ','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.03.00.00.00','(-)ANULACAO DE EMPENHOS','REGISTRA O VALOR REFERENTE A REVERSÃO TOTAL OU PARCIAL DE DESPESA À DOTAÇÃO INICIAL CORRESPONDENTE, ATRAVÉS DA "NOTA DE ANULAÇÃO" DA NE.','C','S',0,'N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.2.2.9.2.01.04.00.00.00','(-)CANCEL. DE EMPENHO POR FALTA DE DISPON. CAIXA','Registra o cancelamento de empenhos por falta de disponibilidade de caixa.','C','S',0,'N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.0.0.0.00.00.00.00.00','INSCRIÇÃO DE RESTOS A PAGAR','Compreende o somatório relativo ao valor da inscrição das despesas empenhadas e não pagas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.0.0.00.00.00.00.00','INSCRIÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.1.0.00.00.00.00.00','RP NÃO PROCESSADOS INSCRITOS','Registra os valores inscritos em restos a pagar não-processados relativos às despesas empenhadas e não liquidadas até o ultimo dia do exercício financeiro.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.2.0.00.00.00.00.00','RP NÃO PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra o valor de restos a pagar não processados relativo a exercícios anteriores que não foram cancelados porque tiveram seu prazo de validade prorrogado.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.3.0.00.00.00.00.00','RP NÃO PROCESSADOS RESTABELECIDOS','Registra o valor por restabelecimento de empenho de restos a pagar já cancelados em exercícios anteriores com base em ato normativo específico.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.6.0.00.00.00.00.00','RP NÃO PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar não processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.1.7.0.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 531100000.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.0.0.00.00.00.00.00','INSCRIÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores inscritos em restos a pagar processados.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.1.0.00.00.00.00.00','RP PROCESSADOS - INSCRITOS','Registra o somatório dos valores inscritos em restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro em que foi empenhado.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.2.0.00.00.00.00.00','RP PROCESSADOS - EXERCÍCIOS ANTERIORES','Registra os valores de restos a pagar processados relativos às despesas empenhadas, liquidadas e não pagas no exercício financeiro subseqüente.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.6.0.00.00.00.00.00','RP PROCESSADOS RECEBIDOS POR TRANSFERÊNCIA','Registra o valor da transferência de restos a pagar processados decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '5.3.2.7.0.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 532100000.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.0.0.0.0.00.00.00.00.00','CONTROLES DA EXECUÇÃO DO PLANEJAMENTO E ORÇAMENTO','Compreende as contas com função de Compreende os atos e fatos ligados a execução orçamentária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.0.0.0.00.00.00.00.00','EXECUÇÃO DO PLANEJAMENTO','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual e projeto de lei orçamentária anual.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.0.0.00.00.00.00.00','EXECUÇÃO DO PPA','Compreende o somatório dos valores monetários relativos à execução dos programas e ações (projetos, atividades e operações especiais) estabelecidos no plano plurianual.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.1.0.00.00.00.00.00','PPA A ALOCAR EM LEIS ORÇAMENTÁRIAS ANUAIS','Registra o somatório dos valores monetários do plano plurianual durante o seu período de vigência, detalhado por programas de trabalho a serem selecionados na elaboracao das leis orçamentárias anuais, nos quatro anos do PPA.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.2.0.00.00.00.00.00','PPA ALOCADO EM LEIS ORÇAMENTÁRIAS ANUAIS ','Registra o somatório dos valores monetários do plano plurianual aprovado, detalhado por programa de trabalho, alocado nas leis orçamentárias anuais ou relativos aos valores dos créditos antecipados pela LDO, dentro do período de vigência do PPA.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.1.3.0.00.00.00.00.00','PPA EXECUTADO ','Registra o somatório dos valores monetários empenhados do plano plurianual no seu período de vigência, detalhado por programa de trabalho, autorizado nas leis orçamentárias anuais.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.0.0.00.00.00.00.00','EXECUÇÃO DO PLOA','Compreende o somatório dos valores monetários de receitas e despesas previstos no projeto de lei orçamentária durante as suas fases de tramitação.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.1.0.00.00.00.00.00','PROCESSAMENTO DO PLOA -RECEITA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS DAS RECEITAS PREVISTAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.1.2.2.0.00.00.00.00.00','PROCESSAMENTO DO PLOA -DESPESA','REGISTRA O SOMATORIO DOS VALORES MONETARIOS FIXADOS PARA AS DESPESAS NO PROJETO DE LEI ORCAMENTARIA DURANTE AS SUAS FASES DE TRAMITACAO.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.0.0.0.00.00.00.00.00','EXECUÇÃO DO ORÇAMENTO','Compreende o somatório dos valores relativos à realização da receita, execução da despesa e suas alterações no orçamento geral da União durante o exercício financeiro.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.0.0.00.00.00.00.00','EXECUÇÃO DA RECEITA','Compreende o somatório dos valores relativos à realização da receita pública aprovada pela lei orçamentária anual e suas alterações.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.1.0.00.00.00.00.00','RECEITA A REALIZAR','Registra o somatório dos valores relativos à receita pública aprovada pela lei orçamentária anual e suas alterações, detalhada por natureza da receita.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.2.0.00.00.00.00.00','RECEITA REALIZADA','Registra o somatório dos valores relativos às receitas realizadas, detalhada por natureza de receita.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.0.00.00.00.00.00','(-) DEDUÇÕES DA RECEITA ORÇAMENTÁRIA','Registra o somatório dos valores relativos às deduções de receitas realizadas (devoluções, restituições, e outras), detalhada por natureza de receita.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.1.00.00.00.00.00','(-) DEDUÇÕES POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS','COMPREENDE O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS, DETALHADA POR NATUREZA DE RECEITA.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.1.01.00.00.00.00','(-) FUNDEB','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.1.02.00.00.00.00','(-) TRANSFERÊNCIAS CONSTITUCIONAIS A MUNICÍPIOS','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.2.00.00.00.00.00','(-) RENÚNCIA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR RENUNCIA, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.1.3.4.00.00.00.00.00','(-) OUTRAS DEDUCOES DA RECEITA REALIZADA','REGISTRA O SOMATORIO DOS VALORES RELATIVOS AS DEDUCOES DE RECEITAS REALIZADAS POR TRANSFERÊNCIAS CONSTITUCIONAIS E LEGAIS, DETALHADA POR NATUREZA DE RECEITA.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.0.0.00.00.00.00.00','EXECUÇÃO DA DESPESA','Compreende o somatório da disponibilidade de credito orçamentário e da execução da despesa em suas diversas etapas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.0.00.00.00.00.00','DISPONIBILIDADES DE CREDITO','Compreende o somatório da disponibilidade de credito orçamentário e suas alterações.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.1.00.00.00.00.00','CREDITO DISPONÍVEL','Registra o valor da disponibilidade de credito referente à dotação inicial e adicional aprovada no orçamento geral da União na loa ou lei especifica ou antecipada pela lei de diretrizes orçamentárias - LDO.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.00.00.00.00.00','CREDITO INDISPONÍVEL','Compreende o valor da indisponibilidade de credito orçamentário pelo seu contingenciamento ou liberação pendentes de autorização legislativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.01.00.00.00.00','BLOQUEIO DE CREDITO                             ','REGISTRA O VALOR DA DISPONIBILIDADE DE CREDITOS ORCAMENTARIOS POR CONTENCAO OU CONTINGENCIAMENTO PELA SETORIAL ORCAMENTARIA, SOF E OUTROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.02.00.00.00.00','CREDITO PRE-EMPENHADO','REGISTRA OS VALORES DOS PRE-EMPENHOS EMITIDOS PELA UNIDADE OU POR OUTRA UNIDADE GESTORA.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.2.99.00.00.00.00','OUTRAS INDISPONIBILIDADES','Registra o valor das indisponibilidades de creditos orçamentarios de natureza eventual, para as quais não há contas especificas.           ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.00.00.00.00.00','CREDITO UTILIZADO','Compreende o somatório dos valores referentes aos créditos orçamentários empenhados.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.01.00.00.00.00','CREDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.02.00.00.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.03.00.00.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.04.00.00.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','Registra o valor da despesa empenhada liquidada paga.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.05.00.00.00.00','EMPENHOS A LIQUIDAR INSCRITOS EM RESTOS A PAGAR NÃO PROCESSADOS ','Registra o montante dos valores a liquidar inscritos em restos a pagar nao processados.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.06.00.00.00.00','EMPENHOS EM LIQUIDACAO INSCRITOS EM RESTOS A PAGAR NAO PROCESSADOS ','Registra o montante dos valores em liquidação inscritos em restos a pagar nao processados. ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.07.00.00.00.00','EMPENHOS LIQUIDADOS INSCRITOS EM RESTOS A PAGAR PROCESSADOS ','Registra o montante dos valores liquidados inscritos em restos a pagar processados.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.1.3.99.00.00.00.00','(-) OUTROS CRÉDITOS UTILIZADOS','Registra o somatório dos demais valores referentes aos créditos orçamentários empenhados.','D','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.0.00.00.00.00.00','MOVIMENTAÇÃO DE CRÉDITOS CONCEDIDOS','Compreende o somatório dos valores dos créditos orçamentários concedidos através de destaque, provisão ou por fusão, cisão ou extinção de unidades.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.1.00.00.00.00.00','DESCENTRALIZAÇÃO INTERNA DE CRÉDITOS - PROVISÃO','Compreende os valores dos créditos descentralizados das unidades orçamentárias para as unidades administrativas sob sua jurisdição ou entre estas, no âmbito do próprio ministério, secretaria ou órgão equivalente, concedidos ao longo do exercício.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.1.01.00.00.00.00','PROVISAO CONCEDIDA             ','Registra o credito concedido pela unidade orçamentaria a partir de sua propria dotação ou de um destaque a seu favor, para unidade administrativa ou orçamentaria, no ambito do proprio ministerio ou orgão. ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.00.00.00.00.00','DESCENTRALIZAÇÃO EXTERNA DE CRÉDITOS - DESTAQUE','Compreende a descentralização do credito inicial ou adicional concedido de unidades ou órgãos pertencentes a ministérios, secretarias e órgãos equivalentes distintos ou entre estes e entidades da administração indireta.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.01.00.00.00.00','ADMINISTRACAO DIRETA         ','Compreende o valor referente ao movimento de creditos decorrentes de concessão pela unidade orçamentaria do orgão da administração direta transferidora.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.01.01.00.00.00','CREDITOS CONCEDIDOS','Registra o valor referente a movimentação de creditos decorrentes   de concessão pela unidade orçamentaria do orgão da administração direta  transferidora.  ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.02.00.00.00.00','ADMINISTRACAO INDIRETA                    ','Compreende o valor referente ao movimento de creditos decorrentes de concessão pela unidade orçamentaria da entidade da administração indireta transferidora. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.2.02.01.00.00.00','CREDITOS CONCEDIDOS','Registra o valor referente a movimentação de creditos decorrentes   de sua concessão pela unidade orçamentaria do orgão da administração  indireta transferidora.     ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.2.9.00.00.00.00.00','OUTRAS DESCENTRALIZAÇÕES DE CRÉDITOS','Registra as movimentações de créditos concedidos por cisão, fusão, extinção, compensação e outras transações.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.3.0.00.00.00.00.00','DETALHAMENTO DE CREDITO','Registra o detalhamento das dotações orçamentárias relativas a cada programa de trabalho.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.0.00.00.00.00.00','OUTROS CONTROLES DA DESPESA ORÇAMENTÁRIA','Compreende o somatório dos valores executados das despesas pré-empenhadas e empenhadas por detalhamento específico.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.1.00.00.00.00.00','DESPESA PRE-EMPENHADA','COMPREENDE O SOMATORIO DOS VALORES EXECUTADOS DAS DESPESAS PRE-EMPENHADAS PELA PROPRIA UNIDADE GESTORA, TRANSFERIDOS OU RECEBIDOS POR TRANSFERENCIA, POR DETALHAMENTO ESPECIFICO E SUAS RESPECTIVAS ANULACOES.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.00.00.00.00.00','EMISSAO DE EMPENHO','Compreende o somatorio dos valores executados das despesas empenhadas por detalhamento especifico.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.00.00.00.00','EMPENHOS POR NOTA DE EMPENHO','Compreende o valor da emissão de documentos atraves dos quais são Compreendedos os estagios das despesas orçamentarias realizadas pela administração publica.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.01.00.00.00','EMPENHOS A LIQUIDAR ','Registra o valor dos empenhos de despesas pendentes de  liquidação.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.02.00.00.00','EMPENHOS EM LIQUIDACAO','Registra o somatorio das despesas  cujo fato gerador tenha ocorrido, tendo iniciado e não concluido o processo de liquidação da despesa orçamentaria.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.03.00.00.00','EMPENHOS LIQUIDADOS A PAGAR ','Registra o valor dos empenhos após verificação do direito adquirido pelo credor ou entidade beneficiaria.   ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.2.2.9.2.01.04.00.00.00','EMPENHOS LIQUIDADOS PAGOS','Registra o montante dos valores pagos, controlados por nota de empenho e subitem. ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.0.0.0.00.00.00.00.00','EXECUÇÃO DE RESTOS A PAGAR','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas e não pagas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.0.0.00.00.00.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.1.0.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.2.0.00.00.00.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.3.0.00.00.00.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.4.0.00.00.00.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.5.0.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.6.0.00.00.00.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.7.0.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.7.1.00.00.00.00.00','RP NAO PROCESSADOS A LIQUIDARINSCRICAO NO EXERCICIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS A LIQUIDAR INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631100000.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.7.2.00.00.00.00.00','RP NAO PROCESSADOS EM LIQUIDACAO - INSCRICAO NO EXERCICIO','REGISTRA O VALOR DAS DESPESAS EMPENHADAS EM LIQUIDACAO INSCRITAS NO EXERCICIO COMO RESTOS A PAGAR NAO PROCESSADOS, A SER TRANSFERIDO PARA O EXERCICIO SEGUINTE PARA A CONTA 631200000.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.0.00.00.00.00.00','RP NÃO PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.1.00.00.00.00.00','CANCELAMENTOSPOR INSUFICIENCIA DE RECURSOS','Registra o valor dos restos a pagar não processados cancelados nos exercicios subsequentes ao da sua inscrição por insuficiencia de recursos financeiros.    ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.1.9.9.00.00.00.00.00','OUTROS CANCELAMENTOS DE RP   ','Registra o valor dos restos a pagar não processados cancelados nos exercicios subsequentes ao da sua inscrição, exceto os cancelados por insuficiencia de recursos financeiros. ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.0.0.00.00.00.00.00','EXECUÇÃO DE RP PROCESSADOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.1.0.00.00.00.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.2.0.00.00.00.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.6.0.00.00.00.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.7.0.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.0.00.00.00.00.00','RP PROCESSADOS CANCELADOS','Compreende o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.1.00.00.00.00.00','POR VALORES E/OU INSCRICOES INDEVIDAS','Registra o valor dos restos a pagar processados  cancelados nos exercicios subsequentes ao da sua inscrição por valores e/ou inscrições.','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '6.3.2.9.9.00.00.00.00.00','OUTROS CANCELAMENTOS DE RP','Registra o valor dos restos a pagar processados  cancelados nos exercicios subsequentes ao da sua inscrição, exceto os cancelados por insuficiencia de recursos financeiros ou por inscrição indevida. ','C','S','O','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.0.0.0.0.00.00.00.00.00','CONTROLES DEVEDORES','Compreende as contas em que são Compreendedos atos potenciais e controles específicos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.0.0.0.00.00.00.00.00','ATOS POTENCIAIS','Compreende contas relacionadas às situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.0.0.00.00.00.00.00','ATOS POTENCIAIS ATIVOS','Compreende os atos e fatos que possam vir a aumentar o ativo da entidade governamental.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.0.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas recebidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','Compreende o valor recebido de compromisso de adimplência de obrigação  financeira ou contratual assumido por ente da federação ou entidade a ele vinculada, no Pais. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.00.00.00.00','GARANTIAS RECEBIDAS NO PAÍS','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.01.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, DADA POR TERCEIROS, NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.02.00.00.00','FIANÇAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA RECEBIDA NO PAÍS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NÃO CUMPRA.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.03.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS RECEBIDAS NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.04.00.00.00','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS RECEBIDOS NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.05.00.00.00','CAUÇÕES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TÍTULOS, VALORES E BENS RECEBIDOS EM CAUÇÕES NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.06.00.00.00','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR REFERENTE A GARANTIAS RECEBIDAS NA FORMA PREVISTA EM LEI ESPECÍFICA, NO PAÍS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO ÂMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.07.00.00.00','GARANTIAS DA DÍVIDA PÚBLICA','REGISTRA O TOTAL DAS GARANTIAS RECEBIDAS DA DÍVIDA PÚBLICA, NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.08.00.00.00','APÓLICES DE SEGUROS','REGISTRA OS VALORES RELATIVOS A GARANTIA OFERECIDA POR SEGURADORAS NA COBERTURA DO ATIVO DA UNIDADE EM CASOS DE SINISTROS, ACIDENTES ETC.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.01.99.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS GARANTIAS RECEBIDAS, NÃO INCLUÍDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAÍDAS NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.02.00.00.00.00','GARANTIAS RECEBIDAS NO EXTERIOR','COMPREENDE O VALOR RECEBIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO EXTERIOR.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.00.00.00.00','CONTRAGARANTIAS RECEBIDAS NO PAÍS','COMPREENDE O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.01.00.00.00','AVAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.02.00.00.00','FIANÇAS','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS TERCEIROS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.03.00.00.00','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS DECORRENTES DAS CONCESSOES DE FIANCAS AVAIS POR OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.03.04.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS RECEBIDAS, NÃO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.1.1.04.00.00.00.00','CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.0.00.00.00.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.1.00.00.00.00.00','DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVÊNIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.1.01.00.00.00.00','DIREITOS CONVENIADOS','REGISTRA O VALOR TOTAL FIRMADO DOS CONVÊNIOS FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.1.02.00.00.00.00','TERMO DE COOPERAÇÃO','REGISTRA VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERAÇÃO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.2.1.99.00.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES','REGISTRA O VALOR TOTAL RECEBIDO DE OUTROS INSTRUMENTROS CONGÊNERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.0.00.00.00.00.00','DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de direitos contratuais, quando a administração pública participa como contratada.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.00.00.00.00.00','DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','REGISTRA O VALOR DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.02.00.00.00.00','CONTRATOS DE SERVIÇOS','REGISTRA O VALOR DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.03.00.00.00.00','CONTRATOS DE ALUGUÉIS','REGISTRA O VALOR DO CONTRATO DE ALUGUÉIS EM QUE O PODER PÚBLICO SEJA O LOCADOR DO BEM.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.05.00.00.00.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGAÇÃO DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.06.00.00.00.00','CONTRATOS DE PPP - DO ENTE FEDERADO','Registra o valor por contrato das despesas derivadas de PPP contratadas pelo ente da Federação excluídas as empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados.Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.07.00.00.00.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','Registra o valor por contrato das despesas derivadas de PPP contratadas pelas empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados. Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.3.1.99.00.00.00.00','OUTROS DIREITOS CONTRATUAIS','REGISTRA O VALOR DE OUTROS DIREITOS CONTRATUAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.0.00.00.00.00.00','OUTROS ATOS POTENCIAIS ATIVOS','Compreende os atos potenciais ativos não contemplados em contas especificas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.1.00.00.00.00.00','PLANO DE AMORTIZAÇÃO DO DÉFICIT ATUARIAL','Registra, a título de controle, os valores relativos ao plano de amortização do déficit atuarial do RPPS pelo ente público que o instituiu.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.1.9.2.00.00.00.00.00','PARCELAMENTO DE DÉBITOS PREVIDENCIÁRIOS','Registra, a título de controle, os valores relativos às parcelas de débitos previdenciários do RPPS devidas pelo ente público.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.0.0.00.00.00.00.00','ATOS POTENCIAIS PASSIVOS','Compreende os atos e fatos que possam vir a aumentar o passivo ou diminuir o ativo da entidade governamental.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.0.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.00.00.00.00.00','GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','COMPREENDE O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.00.00.00.00','GARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO PAÍS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.01.00.00.00','AVAIS','REGISTRA O VALOR DA GARANTIA DE PAGAMENTO DE TITULO DE CRÉDITO EXCLUSIVAMENTE, DE NATUREZA PESSOAL, CONCEDIDA DE TERCEIROS, NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.02.00.00.00','FIANÇAS','REGISTRA O VALOR DA OBRIGACAO ACESSORIA CONCEDIDA NO PAÍS, POR ORGAOS E ENTIDADES, PELO CUMPRIMENTO DA OBRIGACAO DO DEVEDOR, CASO ESSE NÃO CUMPRA.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.03.00.00.00','HIPOTECAS','REGISTRA O TOTAL DAS GARANTIAS DE VALORES POR HIPOTECAS CONCEDIDAS NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.04.00.00.00','SEGUROS-GARANTIA','REGISTRA A GARANTIA DE VALORES POR SEGUROS CONCEDIDOS NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.05.00.00.00','CAUÇÕES','REGISTRA A RESPONSABILIDADE DA UNIDADE POR TÍTULOS, VALORES E BENS CONCEDIDOS EM CAUÇÕES NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.06.00.00.00','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR REFERENTE A GARANTIAS CONCEDIDAS NA FORMA PREVISTA EM LEI ESPECÍFICA, NO PAÍS E NO EXTERIOR. ESTA CATEGORIA INCLUI AS GARANTIAS OU RISCOS ASSUMIDOS EM OPERAÇÕES REALIZADAS NO ÂMBITO DE FUNDOS, PROGRAMAS E OPERAÇÕES ESPECIAIS, NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.01.99.00.00.00','OUTRAS GARANTIAS E CONTRAGARANTIAS CONCEDIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS, NÃO INCLUÍDAS NOS ITENS ANTERIORES, SOBRE OBRIGAÇÕES CONTRAÍDAS NO PAÍS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.02.00.00.00.00','GARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR CONCEDIDO DE COMPROMISSO DE ADIMPLÊNCIA DE OBRIGAÇÃO FINANCEIRA OU CONTRATUAL, NO EXTERIOR.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.00.00.00.00','CONTRAGARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.01.00.00.00','AVAIS','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE AVAIS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.02.00.00.00','FIANÇAS','REGISTRA O VALOR DAS CONTRAGARANTIAS DECORRENTES DAS CONCESSOES DE FIANCAS POR OBRIGACOES CONTRAIDAS, NO PAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.03.00.00.00','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA','REGISTRA O VALOR DAS CONTRAGARANTIAS EM VIRTUDE DE GARANTIAS INSTIT UIDAS EM LEI ESPECIFICA CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO PAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.03.04.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAIS, NAO INCLUIDAS NOS ITENS ANTERIORES.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.1.1.04.00.00.00.00','CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA O VALOR DAS CONTRAGARANTIAS CONCEDIDAS REFERENTES AS CONCESSOES DE GARANTIAS CONCEDIDAS SOBRE OBRIGACOES CONTRAIDAS NO EXTERIOR.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.0.00.00.00.00.00','OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, do valor dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.1.00.00.00.00.00','OBRIGAÇÕES CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE , DOS CONVÊNIOS FIRMADOS ENTRE ENTIDADES OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.1.01.00.00.00.00','OBRIGAÇÕES CONVENIADAS','REGISTRA O VALOR TOTAL RECEBIDO DOS CONVÊNIOS FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.1.02.00.00.00.00','TERMO DE COOPERAÇÃO','REGISTRA VALOR TOTAL RECEBIDO DOS TERMOS DE COOPERAÇÃO FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.2.1.99.00.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES','REGISTRA O VALOR TOTAL RECEBIDO DE OUTROS INSTRUMENTROS CONGÊNERES FIRMADOS MANTENDO-O ORIGINALMENTE MESMO APÓS A SUA FASE DE APROVAÇÃO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.0.00.00.00.00.00','OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro dos valores de obrigações contratuais, quando a administração pública participa como contratante.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.00.00.00.00.00','OBRIGAÇÕES CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DOS VALORES DE OBRIGAÇÕES CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','Registra o valor do contrato de seguros em que a administração publica participa como contratante do instrumento contratual com terceiros.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.02.00.00.00.00','CONTRATOS DE SERVICOS','REGISTRA O VALOR DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATANTE NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.03.00.00.00.00','CONTRATOS DE ALUGUEIS','REGISTRA O VALOR DO CONTRATO DE ALUGUÉIS EM QUE O PODER PÚBLICO SEJA O LOCATÁRIO DO BEM.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','REGISTRA O VALOR DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.05.00.00.00.00','CONTRATOS DE EMPRESTIMOS E FINANCIAMENTOS','REGISTRA O VALOR DO CONTRATO DE OBRIGAÇÃO DA ENTIDADE PÚBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAIDOS NO EXERCICIO. ','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.06.00.00.00.00','CONTRATO DE GESTAO','REGISTRA OS CONTRATOS DE GESTÃO, nos termos do artigo 37, par. 8º da CF/88.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.07.00.00.00.00','TERMO DE PARCERIA','REGISTRA O VALOR DE TERMO DE PARCERIA DE TERCEIROS COM ÓRGÃO/ENTIDADE','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.08.00.00.00.00','CONTRATOS DE PPP','Registra o valor dos passivos decorrentes de contrato de PPP que devem abranger o valor presente da melhoria de um ativo não financeiro passível de transferência ao setor público e das prestações dos serviços objeto do contrato, incluindo a parcela variável condicionada à qualidade do serviço, e também aqueles decorrentes de riscos não provisionados, ou ainda outros valores que se entender necessários.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.3.1.99.00.00.00.00','OUTROS OBRIGAÇÕES CONTRATUAIS','REGISTRA O VALOR DE OUTRAS OBRIGAÇÕES CONTRATUAIS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.0.00.00.00.00.00','OUTROS ATOS POTENCIAIS PASSIVOS','Compreende os atos potenciais passivos não contemplados em contas especificas.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.1.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO ANTERIOR E INCLUÍDOS NO ORÇAMENTO PARA PAGAMENTO ATÉ O FINAL DO EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.1.2.9.2.00.00.00.00.00','BENEFICIARIOS DE SENTENCAS JUDICIAIS AINDA NAO INCLUIDAS NO ORCAMENTO','REGISTRA OS PRECATÓRIOS, RECEBIDOS NO EXERCÍCIO E QUE SERÃO INCLUÍDOS NO ORÇAMENTO SEGUINTE PARA PAGAMENTO ATÉ O FINAL DAQUELE EXERCÍCIO. PODE SE MANTER O CONTROLE  NESTE GRUPO POR BENEFICIÁRIO','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.0.0.0.00.00.00.00.00','ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da programação financeira e de controle das disponibilidades.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.0.0.00.00.00.00.00','DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que Compreendem os controles sobre as disponibilidades por destinação de recursos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.0.00.00.00.00.00','CONTROLE DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que Compreendem as disponibilidades de recursos recebidos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.1.00.00.00.00.00','DISPONIBILIDADE DE RECURSOS','Compreende as contas que registram as disponibilidades de recursos recebidos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.1.01.00.00.00.00','RECURSOS ORDINÁRIOS','Registra as disponibilidades por destinação de recursos ordinários.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.1.02.00.00.00.00','RECURSOS VINCULADOS','Registra as disponibilidades por destinação de recursos vinculados.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.1.3.00.00.00.00.00','RECURSOS EXTRAORÇAMENTÁRIOS','Registra as disponibilidades por destinação de recursos extraorçamentários.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.2.0.00.00.00.00.00','LIMITE DE RESTOS A PAGAR POR DESTINAÇÃO','Registra as contas que controlam a inscrição do limite de restos a pagar, classificados por destinação de recursos','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.1.3.0.00.00.00.00.00','RECURSO DIFERIDO POR DESTINAÇÃO','Registra as contas que controlam a inscrição dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.0.0.00.00.00.00.00','PROGRAMAÇÃO FINANCEIRA','Compreende as contas que Compreendem as cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.1.0.00.00.00.00.00','CONCESSAO DE RECURSOS FINANCEIROS','REGISTRA AS CONTAS QUE REGISTRAM A CONCESSAO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.2.2.0.00.00.00.00.00','RECEBIMENTO DE RECURSOS FINANCEIROS','REGISTRA AS CONTAS QUE REGISTRAM O RECEBIMENTO DAS COTAS, REPASSES E SUB-REPASSES PARA ATENDER A DESPESAS ORCAMENTARIAS, RESTOS A PAGAR AUTORIZADOS E DEMAIS DISPENDIOS EXTRA-ORCAMENTARIOS','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.3.0.0.00.00.00.00.00','INSCRIÇÃO DO LIMITE ORÇAMENTÁRIO','Registra as contas que controlam o limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.0.0.00.00.00.00.00','CONTROLES DA ARRECADAÇÃO','Compreende as contas que Compreendem o valor da arrecadação liquida da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.0.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO','COMPREENDE AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.1.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE RECEITA','REGISTRA AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE RECEITA.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.2.4.1.3.00.00.00.00.00','CONTROLES DE DOCUMENTOS DE ARRECADAÇÃO POR CODIGO DE DESTINACAO VINCULADA','REGISTRA AS CONTAS QUE REGISTRAM O VALOR DA ARRECADACAO LIQUIDA DA RECEITA ORCAMENTARIA, POR MEIO DE DOCUMENTOS DE ARRECADAÇÃO, CLASSIFICADA POR CODIGO DE DESTINACAO VINCULADA.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.0.0.0.00.00.00.00.00','DIVIDA ATIVA','Compreende o controle dos créditos a serem inscritos em divida ativa, dos que se encontram em processamento. Compreende as contas que controlam os créditos passiveis de serem encaminhados e inscritos em divida ativa o de inscrição e a tramitação dos créditos inscritos.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.0.0.00.00.00.00.00','CONTROLE DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Compreende os valores passiveis de serem encaminhados e inscritos em divida ativa.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.0.00.00.00.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA','Compreende o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.1.00.00.00.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa Tributária.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.1.01.00.00.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa Tributária de Impostos.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.1.02.00.00.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa Tributária de Taxas.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.1.1.2.00.00.00.00.00','ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DÍVIDA ATIVA NÃO TRIBUTÁRIA','Registra o montante dos créditos passíveis de serem encaminhados para inscrição em Dívida Ativa Não Tributária..','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.0.0.00.00.00.00.00','CONTROLE DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que controlam os créditos passiveis de serem inscritos em divida ativa pelo órgão responsável pela inscrição em divida ativa.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.0.00.00.00.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA','Compreende os valores dos creditos passiveis de serem inscritos em divida ativa pelo orgão responsavel pela inscrição em divida ativa. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.1.00.00.00.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende o valor dos créditos de origem tributária passíveis de serem inscritos em dívida ativa pelo órgão competente.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.1.01.00.00.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA - IMPOSTOS','Registra o valor dos créditos de origem tributária de impostos passíveis de serem inscritos em dívida ativa  pelo órgão competente.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.1.02.00.00.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA TRIBUTÁRIA - TAXAS','Registra o valor dos créditos de origem tributária de taxas passíveis de serem inscritos em dívida ativa  pelo órgão competente.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.3.2.1.2.00.00.00.00.00','INSCRIÇÃO DE CRÉDITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra o valor dos créditos de natureza não-tributária passíveis de serem inscritos em dívida ativa pelo órgão competente.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.0.0.0.00.00.00.00.00','RISCOS FISCAIS','Compreende as contas que controlam os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.0.0.00.00.00.00.00','CONTROLE DE PASSIVOS CONTINGENTES','Compreende as contas que Compreendem o controle dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.0.00.00.00.00.00','PASSIVOS CONTINGENTES','Compreende os riscos fiscais classificados como passivos contingentes','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.1.00.00.00.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas estatais dependentes; c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais..','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.2.00.00.00.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.3.00.00.00.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.4.00.00.00.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.5.00.00.00.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.1.1.9.00.00.00.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.0.0.00.00.00.00.00','CONTROLE DOS DEMAIS RISCOS FISCAIS','Compreende as contas que Compreendem os riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS ','Compreende os riscos fiscais não classificados como passivos contingentes. ','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.1.00.00.00.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','Registra a estimativa do montante de redução de arrecadação que apresenta probabilidade de vir a ocorrer no exercício, decorrente de, por exemplo, cenários macroeconômicos desfavoráveis não previstos na época da elaboração do Orçamento.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.2.00.00.00.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','Registra a estimativa do montante de devolução de tributos a maior que apresenta probabilidade de vir a ocorrer no exercício.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.3.00.00.00.00.00','DISCREPÂNCIA DE PROJEÇÕES','Registra a estimativa do montante de redução no valor dos ingressos ou de aumento no valor dos desembolsos que apresentam probabilidade de vir a ocorrer no exercício, decorrentes de evolução desfavorável de indicadores econômicos empregados na época da elaboração do Orçamento, tais como: a) Taxa de crescimento econômico; b) Taxa de inflação; c) Taxa de câmbio; d) Taxa de juros; e) Salário mínimo; f) Outros indicadores. ','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.4.2.1.4.00.00.00.00.00','OUTROS RISCOS FISCAIS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de riscos fiscais.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.5.0.0.0.00.00.00.00.00','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','Compreende as contas que controlam o registro de atos dos consórcios públicos (do ente consorciado e/ou do próprio consórcio), incluindo os controles do contrato de rateio, controle da prestação de contas, bem como as informações que serão consolidadas no ente consorciado para fins de elaboração dos demonstrativos dos consórcios, conforme Portaria STN 72/2012.','D','N','C','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.5.1.0.0.00.00.00.00.00','CONTRATO DE RATEIO DE CONSÓRCIOS PÚBLICOS','Registra contas relacionadas ao registro dos valores de obrigações contratuais decorrentes de Consórcios Públicos','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.5.2.0.0.00.00.00.00.00','PRESTAÇÃO DE CONTAS DE CONSÓRCIOS PÚBLICOS','Registra contas relacionadas ao registro do controle da prestação de contas dos Consórcios Públicos.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.5.3.0.0.00.00.00.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','Registra as informações referentes aos Consórcios Públicos, atribuídas ao ente consorciado com base no contrato de rateio,que serão enviadas pelo consórcio para os entes consorciados para fins de elaboração dos demonstrativos fiscais ( Saúde, pessoal, educação e disponibilidade de caixa), em atendimento a Portaria STN n.º 72/2012. Conta para uso do ente consorciado.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.8.0.0.0.00.00.00.00.00','CUSTOS','Registra as contas que controlam os custos de bens e serviços produzidos.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.0.0.0.00.00.00.00.00','OUTROS CONTROLES','Compreende as contas de controles não especificadas anteriormente nos grupos dessa classe.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.0.0.00.00.00.00.00','RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.1.0.00.00.00.00.00','RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.1.1.00.00.00.00.00','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.1.2.00.00.00.00.00','DEPÓSITOS COMPULSÓRIOS','REGISTRA CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.1.3.00.00.00.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NÃO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.2.0.00.00.00.00.00','RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE RESPONSABILIDADES COM TERCEIROS, NÃO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','D','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.2.1.00.00.00.00.00','CONTROLE DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','REGISTRA OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.2.2.00.00.00.00.00','ATIVOS DE PPP CONTABILIZADOS NA SPE','Registra o valor dos ativos produzidos por meio de Parcerias Público Privadas contabilizados na Sociedade de Propósito Específico.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.1.2.9.00.00.00.00.00','OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA O VALOR DE OUTRAS RESPONSABILIDADES DE TERCEIROS, DE NATUREZA EVENTUAL, POR TITULOS, VALORES E BENS, PARA AS QUAIS NAO HA CONTAS ESPECIFICAS.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '7.9.2.0.0.00.00.00.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','REGISTRA AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','D','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.0.0.0.0.00.00.00.00.00','CONTROLES CREDORES','Compreende as contas em que são registradas a execução de atos potenciais e controles específicos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.0.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS','Compreende contas relacionadas à execução de situações não compreendidas no patrimônio, mas que, direta ou indiretamente, possam vir à afeta-lo, exclusive as que dizem respeito a atos e fatos ligados a execução orçamentária e financeira e as contas com função precípua de controle.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos e fatos que possa vir a afetar o ativo da entidade governamental.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.0.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS','Compreende as contas relacionadas ao registro da execução de avais, fianças e hipotecas recebidos no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS RECEBIDAS - CONSOLIDAÇÃO','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDOS NO PAÍS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.00.00.00.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO PAÍS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEDIDOS NO PAÍS , BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.01.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.02.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.03.00.00.00','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.04.00.00.00','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.05.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.06.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.07.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.08.00.00.00','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.09.00.00.00','CAUÇÕES A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÕES PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.10.00.00.00','CAUÇÕES EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÕES NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.11.00.00.00','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.12.00.00.00','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.13.00.00.00','GARANTIAS DA DÍVIDA PUBLICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS DA DÍVIDA PUBLICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.14.00.00.00','GARANTIAS DA DÍVIDA PUBLICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS DA DÍVIDA PUBLICA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.15.00.00.00','APÓLICES DE SEGUROS A EXECUTAR','REGISTRA O VALOR DAS DAS APÓLICES DE SEGUROS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.16.00.00.00','APÓLICES DE SEGUROS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS APÓLICES DE SEGUROS, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.98.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.01.99.00.00.00','OUTRAS GARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.02.00.00.00.00','EXECUÇÃO DE GARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.00.00.00.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO PAÍS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO PAÍS BEM COMO OUTRAS CONTRAGARANTIAS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.01.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.02.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.03.00.00.00','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.04.00.00.00','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.05.00.00.00','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.06.00.00.00','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.98.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.03.99.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS NO PAÍS','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.1.1.04.00.00.00.00','EXECUÇÃO DE CONTRAGARANTIAS RECEBIDAS NO EXTERIOR','REGISTRA CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS RECEBIDAS NO EXTERIOR, BEM COMO OUTRAS CONTRAGARANTIAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.0.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no convenente, da execução dos convênios firmados entre entidades, objetivando o cumprimento de finalidades comuns.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS INSTRUMENTOS CONGÊNERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.00.00.00.00','EXECUÇÃO DE CONVÊNIOS','COMPREENDE A EXECUÇÃO DOS VALORES DE CONVÊNIOS PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.01.00.00.00','CONVÊNIOS A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.02.00.00.00','CONVÊNIOS A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.03.00.00.00','CONVÊNIOS A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.04.00.00.00','CONVÊNIOS APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.05.00.00.00','CONVÊNIOS IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.06.00.00.00','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVÊNIO FIRMADO, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.07.00.00.00','CONVÊNIO EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVÊNIO FIRMADO, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.08.00.00.00','CONVÊNIOS HOMOLOGADOS','REGISTRA A EXECUÇÃO DOS VALORES HOMOLOGADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.09.00.00.00','CONVÊNIOS CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVÊNIO FIRMADO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.10.00.00.00','CONVÊNIOS NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVÊNIO. O VALOR CITADO E REGISTRADO POR MEIO DA TRANSACAO EXCCONV, TIPO DE EXECUÇÃO NR. 13.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.11.00.00.00','CONVÊNIOS ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVÊNIOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.01.12.00.00.00','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUIDO DE CONVÊNIO FIRMADO , APÓS A APROVAÇÃO TOTAL DA PRESTACAO DE CONTAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.00.00.00.00','TERMO DE COOPERAÇÃO','COMPREENDE A EXECUÇÃO DOS VALORES DE TERMO DE COOPERAÇÃO PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.01.00.00.00','TERMO DE COOPERAÇÃO A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.02.00.00.00','TERMO DE COOPERAÇÃO A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.03.00.00.00','TERMO DE COOPERAÇÃO A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.04.00.00.00','TERMO DE COOPERAÇÃO APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.05.00.00.00','TERMO DE COOPERAÇÃO IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.06.00.00.00','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.07.00.00.00','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.08.00.00.00','TERMO DE COOPERAÇÃO CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.09.00.00.00','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.02.10.00.00.00','TERMO DE COOPERAÇÃO CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.00.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES','COMPREENDE A EXECUÇÃO DOS VALORES DE OUTROS INSTRUMENTOS CONGÊNERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.01.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.02.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.03.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.04.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.05.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.06.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.07.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.08.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.09.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.2.1.03.10.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.0.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de direitos contratuais, quando a administração pública participa como contratada. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONTRATUAIS - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.01.00.00.00','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.01.02.00.00.00','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.00.00.00.00','CONTRATOS DE SERVIÇOS','COMPREENDE CONTAS RELACIONADAS AO REGISTO DA EXECUÇÃO DOS VALORES DO CONTRATO DE SERVIÇOS EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.01.00.00.00','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS A PRESTACAO DE SERVIÇOS, CONFORME INSTRUMENTO CONTRATUAL EM QUE A ADMINISTRAÇÃO PÚBLICA SEJA A CONTRATADA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.02.02.00.00.00','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.00.00.00.00','CONTRATOS DE ALUGUÉIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE DIREITOS CONTRATUAIS, QUANDO A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.01.00.00.00','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS CONTRATOS ALUGUÉIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.03.02.00.00.00','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUÉIS EM QUE O PODER PUBLICO SEJA O LOCADOR DO BEM.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.01.00.00.00','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.04.02.00.00.00','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRAÇÃO PÚBLICA A TERCEIROS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.00.00.00.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUÇÃO EXECUÇÃO DE CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAÍDOS NO EXERCICIO.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.01.00.00.00','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAÍDOS NO EXERCICIO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.05.02.00.00.00','EXECUTADOS','REGISTRA A EXECUÇÃO DE VALORES LIBERADOS RELATIVOS A CONTRATOS DE OBRIGAÇÕES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRÉSTIMOS E FINANCIAMENTOS CONTRAÍDOS NO EXERCICIO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.06.00.00.00.00','CONTRATOS DE PPP - DO ENTE FEDERADO','Registra o valor por contrato das despesas derivadas de PPP contratadas pelo ente da Federação excluídas as empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados.Inclui os valores das despesas derivadas de contratos de PPP que já foram  liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.07.00.00.00.00','CONTRATOS DE PPP - DAS ESTATAIS NÃO DEPENDENTES','Compreende o valor por contrato das despesas derivadas de PPP contratadas pelas empresas estatais não dependentes. Devem abranger as despesas com a parcela fixa da contraprestação pecuniária, com a parcela variável vinculada ao desempenho do parceiro privado e com os diferentes riscos provisionados. Inclui os valores das despesas derivadas de contratos de PPP que já foram liquidadas no exercício atual, bem como as previsões de despesas de PPP para os próximos 9 anos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.99.00.00.00.00','OUTROS DIREITOS CONTRATUAIS','COMPREENDE CONTAS RELACIONAS AO REGISTRO DA EXECUÇÃO DOS VALORES DE OUTROS DIREITOS CONTRATUAIS EM QUE A ADMINISTRAÇÃO PÚBLICA PARTICIPA COMO CONTRATADA NO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.99.01.00.00.00','EM EXECUÇÃO','REGISTRA A EXECUÇÃO DOS VALORES A APROPRIAR RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.3.1.99.02.00.00.00','EXECUTADOS','REGISTRA A EXECUÇÃO DOS VALORES APROPRIADOS RELATIVOS AOS SERVIÇOS DE SEGUROS , CONFORME PREVISÃO CONTRATUAL.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.0.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS','Compreende a execução dos atos potenciais ativos não contemplados em contas especificas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.1.9.1.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS ATIVOS - CONSOLIDAÇÃO','Registra a execução dos atos potenciais ativos não contemplados em contas especificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do orçamento fiscal e da seguridade social (OFSS).','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.0.0.00.00.00.00.00','EXECUÇÃO DOS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos e fatos que possa vir a afetar o passivo da entidade governamental.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.0.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS','Compreende contas relacionadas ao registro da execução de avais, fianças e hipotecas concedidas no pais e no exterior, bem como emolumentos consulares e outras garantias e contragarantias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.00.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.00.00.00.00','EXECUÇÃO DE GARANTIAS E CONTRAGARANTIAS CONCEDIDAS - CONSOLIDAÇÃO','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS E NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS. COMPREENDE OS SALDOS QUE NÃO SERAO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.01.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.03.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.04.00.00.00','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.06.00.00.00','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR FIANÇAS, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.07.00.00.00','HIPOTECAS A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR HIPOTECA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.09.00.00.00','HIPOTECAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR HIPOTECA NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.10.00.00.00','SEGUROS-GARANTIA A EXECUTAR','REGISTRA O VALOR DOS SEGUROS-GARANTIA PENDENTES DE EXECUÇÃO, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.12.00.00.00','SEGUROS-GARANTIA EXECUTADAS','REGISTRA O VALOR RECEBIDO DOS SEGUROS-GARANTIA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.13.00.00.00','CAUÇÕES A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS POR CAUÇÕES PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.15.00.00.00','CAUÇÕES EXECUTADA','REGISTRA O VALOR RECEBIDO DAS GARANTIAS POR CAUÇÕES NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.16.00.00.00','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.18.00.00.00','GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS GARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.19.00.00.00','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS GARANTIAS PENDENTES DE EXECUÇÃO, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.01.21.00.00.00','OUTRAS GARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS GARANTIAS NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.02.00.00.00.00','EXECUÇÃO DE GARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO EXTERIOR, BEM COMO EMOLUMENTOS CONSULARES E OUTRAS GARANTIAS E CONTRAGARANTIAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.00.00.00.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO PAÍS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS , BEM COMO OUTRAS CONTRAGARANTIAS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.01.00.00.00','AVAIS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR AVAL PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.03.00.00.00','AVAIS EXECUTADOS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS RECEBIDAS POR AVAL NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.04.00.00.00','FIANÇAS A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS RECEBIDAS POR FIANÇAS, PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.06.00.00.00','FIANÇAS EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS POR FIANÇAS, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.07.00.00.00','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA A EXECUTAR','REGISTRA O VALOR DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.09.00.00.00','CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA EXECUTADAS','REGISTRA O VALOR RECEBIDO DAS CONTRAGARANTIAS INSTITUÍDAS POR LEI ESPECÍFICA, NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.10.00.00.00','OUTRAS CONTRAGARANTIAS RECEBIDAS NO PAÍS A EXECUTAR','REGISTRA O VALOR DE OUTRAS CONTRAGARANTIAS PENDENTES DE EXECUÇÃO , NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.03.12.00.00.00','OUTRAS CONTRAGARANTIAS CONCEDIDAS NO PAÍS EXECUTADAS','REGISTRA O VALOR RECEBIDO DE OUTRAS CONTRAGARANTIAS NO PAÍS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.1.1.04.00.00.00.00','EXECUÇÃO DE CONTRAGARANTIAS CONCEDIDAS NO EXTERIOR','REGISTRA AS CONTAS RELACIONADAS AO REGISTRO DA EXECUÇÃO DE AVAIS, FIANÇAS E HIPOTECAS CONCEDIDOS NO PAÍS , BEM COMO OUTRAS CONTRAGARANTIAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.0.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES CONVENIADAS E OUTROS INSTRUMENTOS CONGÊNERES','Compreende contas relacionadas ao registro, no concedente, da execução do valor dos convênios e outros instrumentos congêneres firmados entre entidades, objetivando o cumprimento de finalidades comuns.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.00.00.00.00.00','EXECUÇÃO DE DIREITOS CONVENIADOS E OUTROS INSTRUMENTOS CONGÊNERES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO, NO CONVENENTE, DA EXECUÇÃO DOS CONVÊNIOS E OUTROS  INSTRUMENTOS CONGÊNERES FIRMADOS ENTRE ENTIDADES, OBJETIVANDO O CUMPRIMENTO DE FINALIDADES COMUNS. COMPREENDE OS SALDOS QUE NÃO SERÃO EXCLUÍDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORÇAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.00.00.00.00','EXECUÇÃO DE CONVÊNIOS','COMPREENDE A EXECUÇÃO DOS VALORES DE CONVÊNIOS PARA ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.01.00.00.00','CONVÊNIOS A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.02.00.00.00','CONVÊNIOS A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE CONVÊNIOS FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.03.00.00.00','CONVÊNIOS A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE CONVÊNIOS DE  ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.04.00.00.00','CONVÊNIOS APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.05.00.00.00','CONVÊNIOS IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.06.00.00.00','CONVÊNIOS EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DO CONVÊNIO FIRMADO, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.07.00.00.00','CONVÊNIOS EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE CONVÊNIO FIRMADO, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.08.00.00.00','CONVÊNIOS HOMOLOGADOS','REGISTRA A EXECUÇÃO DOS VALORES HOMOLOGADOS DE CONVÊNIOS DE ENTRADA DE RECURSOS FIRMADO COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.09.00.00.00','CONVÊNIOS CANCELADOS','REGISTRA O VALOR CANCELADO DO CONVÊNIO FIRMADO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.10.00.00.00','CONVÊNIOS NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DO CONVÊNIO. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.11.00.00.00','CONVÊNIOS ARQUIVADOS','REGISTRA O VALOR ARQUIVADO DE CONVÊNIOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.01.12.00.00.00','CONVÊNIOS E INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUIDO DE CONVÊNIO FIRMADO , APÓS A APROVAÇÃO TOTAL DA PRESTACAO DE CONTAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.00.00.00.00','TERMO DE COOPERAÇÃO','Compreende a execução dos valores  a comprovar de convenios e outros instrumentos congeneres para saida de recursos firmado com outras entidades, após a liberação das parcelas de recursos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.01.00.00.00','TERMO DE COOPERAÇÃO A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.02.00.00.00','TERMO DE COOPERAÇÃO A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.03.00.00.00','TERMO DE COOPERAÇÃO A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.04.00.00.00','TERMO DE COOPERAÇÃO APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.05.00.00.00','TERMO DE COOPERAÇÃO IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.06.00.00.00','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.07.00.00.00','TERMO DE COOPERAÇÃO EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.08.00.00.00','TERMO DE COOPERAÇÃO CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.09.00.00.00','TERMO DE COOPERAÇÃO NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.02.10.00.00.00','TERMO DE COOPERAÇÃO CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.00.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES','COMPREENDE A EXECUÇÃO DOS VALORES DE OUTROS INSTRUMENTOS CONGÊNERES PARA ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.01.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES A RECEBER','REGISTRA A EXECUÇÃO DOS VALORES DAS PARCELAS A RECEBER DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES COM A FINALIDADE DE ATINGIR OBJETIVOS COMUNS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.02.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES A COMPROVAR','REGISTRA A EXECUÇÃO DOS VALORES A COMPROVAR DE TERMOS DE COOPERAÇÃO FIRMADOS COM OUTRAS ENTIDADES, APÓS O RECEBIMENTO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.03.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES A APROVAR','REGISTRA A EXECUÇÃO DOS VALORES A APROVAR DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.04.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES APROVADOS','REGISTRA A EXECUÇÃO DOS VALORES APROVADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A APROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.05.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES IMPUGNADOS','REGISTRA A EXECUÇÃO DOS VALORES IMPUGNADOS DE TERMOS DE COOPERAÇÃO DE ENTRADA DE RECURSOS FIRMADOS COM OUTRAS ENTIDADES, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS .','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.06.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA EFETIVA','REGISTRA O VALOR INADIMPLENTE DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A COMPROVAÇÃO DAS PARCELAS DE RECURSOS','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.07.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES EM INADIMPLÊNCIA SUSPENSA','REGISTRA O VALOR INADIMPLENTE SUSPENSO DE TERMOS DE COOPERAÇÃO FIRMADOS, APÓS A DECISÃO JUDICIAL OU ADMINISTRATIVA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.08.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES CANCELADOS','REGISTRA O VALOR CANCELADO DE TERMOS DE COOPERAÇÃO FIRMADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.09.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES NÃO RECEBIDOS','REGISTRA O VALOR NÃO RECEBIDO RELATIVO AO TOTAL FIRMADO DE TERMOS DE COOPERAÇÃO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.2.1.03.10.00.00.00','OUTROS INSTRUMENTOS CONGÊNERES CONCLUÍDOS','REGISTRA O VALOR CONCLUÍDO DE TERMOS DE COOPERAÇÃO FIRMADOS , APÓS A APROVAÇÃO TOTAL DA PRESTAÇÃO DE CONTAS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.0.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES CONTRATUAIS','Compreende contas relacionadas ao registro da execução dos valores de obrigações contratuais, quando a administração pública participa como contratante.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.00.00.00.00.00','EXECUÇÃO DE OBRIGAÇÕES - CONSOLIDAÇÃO','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DE OBRIGACOES CONTRATUAIS, QUANDO A ADMINISTRACAO PUBLICA PARTICIPA COMO CONTRATANTE. COMPREENDE OS SALDOS QUE NAO SERAO EXCLUIDOS NOS DEMONSTRATIVOS CONSOLIDADOS DO ORCAMENTO FISCAL E DA SEGURIDADE SOCIAL (OFSS).','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.01.00.00.00.00','CONTRATOS DE SEGUROS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE SEGUROS EM QUE A ADMINISTRACAO PUBLICA SEJA A CONTRATANTE DO INSTRUMENTO CONTRATUAL COM TERCEIROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.01.01.00.00.00','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.01.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVO A CONTRATOS DE SEGUROS , EM QUE ADMINISTRACAO SEJA A CONTRATANTE.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.02.00.00.00.00','CONTRATOS DE SERVIÇOS','Compreende a execução dos valores a apropriados relativo a contratos de  seguros, em que  administração seja a contratante. ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.02.01.00.00.00','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVO A CONTRATOS DE SERVIÇOS , EM QUE ADMINISTRACAO PÚBLICA SEJA A CONTRATANTE.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.02.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS RELATIVO A CONTRATOS DE SERVIÇOS , EM QUE ADMINISTRACAO PÚBLICA SEJA A CONTRATANTE.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.03.00.00.00.00','CONTRATOS DE ALUGUÉIS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.03.01.00.00.00','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A APROPRIAR RELATIVOS AOSCONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.03.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES A APROPRIADOS RELATIVOS AOS CONTRATOS ALUGUEIS EM QUE O PODER PUBLICO SEJA O LOCATARIO DO BEM.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.04.00.00.00.00','CONTRATOS DE FORNECIMENTO DE BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA EXECUCAO DOS VALORES DO CONTRATO DE FORNECIMENTO DE BENS PELA ADMINISTRACAO PUBLICA A TERCEIROS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.04.01.00.00.00','A EXECUTAR','REGISTRA A EXECUCAO DOS VALORES A REALIZAR RELATIVOS AOS CONTRATOS DE FORNECIMENTO DE BENS POR TERCEIROS A ADMINISTRACAO PUBLICA. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.04.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DOS VALORES REALIZADOS REALTIVOS AOS CONTRATO DE FORNECIMENTO DE BENS POR ADMINISTRACAO A PUBLICA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.05.00.00.00.00','CONTRATOS DE EMPRÉSTIMOS E FINANCIAMENTOS','COMPREENDE VALORES RELACIONADOS A EXECUCAO EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.05.01.00.00.00','A EXECUTAR','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.05.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A EMPRESTIMOS E FINANCIAMENTOS CONCEDIDOS NO EXERCICIO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.06.00.00.00.00','CONTRATO DE GESTÃO','COMPREENDE AS CONTAS DE REGISTRO DA EXECUCAO DOS CONTRATOS DE GESTAO.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.06.01.00.00.00','A LIQUIDAR','REGISTRA O VALOR DO CONTRATO A LIQUIDAR ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.06.02.00.00.00','LIQUIDADOS','REGISTRA O VALOR DO CONTRATO LIQUIDADO ENTRE A ADMINISTRACAO PUBLICA E PRIVADA PARA GESTAO DE ATIVIDADES TIPICAS DE GOVERNO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.07.00.00.00.00','TERMO DE PARCERIA','COMPREENDE VALORES RELACIONADOS A EXECUCAO DE CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A TERMO DE PARCERIA','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.07.01.00.00.00','A EXECUTAR','REGISTRA A EXECUCAO DE VALORES A LIBERAR RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM  TERCEIROS REFERENTE A TERMO DE PARCERIA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.07.02.00.00.00','EXECUTADOS','REGISTRA A EXECUCAO DE VALORES A LIBERAREDOS RELATIVOS A CONTRATOS DE OBRIGACOES DA ENTIDADE PUBLICA COM TERCEIROS REFERENTE A TERMO DE PARCERIA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.08.00.00.00.00','CONTRATOS DE PPP','Registra o valor dos passivos decorrentes de contrato de PPP que devem abranger o valor presente da melhoria de um ativo não financeiro passível de transferência ao setor público e das prestações dos serviços objeto do contrato, incluindo a parcela variável condicionada à qualidade do serviço, e também aqueles decorrentes de riscos não provisionados, ou ainda outros valores que se entender necessários.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.99.00.00.00.00','OUTRAS OBRIGAÇÕES CONTRATUAIS','Compreende os valores de outras obrigações contratuais.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.99.01.00.00.00','A EXECUTAR','Registra os valores de outras obrigações contratuais a executar.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.3.1.99.02.00.00.00','EXECUTADOS','Registra os valores de outras obrigações contratuais executados.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.0.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS','Compreende a execução dos atos potenciais passivos não contemplados em contas especificas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.1.2.9.1.00.00.00.00.00','EXECUÇÃO DE OUTROS ATOS POTENCIAIS PASSIVOS - CONSOLIDAÇÃO','Registra a execução dos atos potenciais passivos não contemplados em contas especificas. Compreende os saldos que não serão excluídos nos demonstrativos consolidados do Orçamento Fiscal e da Seguridade Social (OFSS).','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.0.0.0.00.00.00.00.00','EXECUÇÃO DA ADMINISTRAÇÃO FINANCEIRA','Compreende as contas de registro da execução da programação financeira e de controle das disponibilidades.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.0.0.00.00.00.00.00','EXECUÇÃO DAS DISPONIBILIDADES POR DESTINAÇÃO','Compreende as contas que Compreendem a execução dos controles das disponibilidades por destinação de recursos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.0.00.00.00.00.00','EXECUÇÃO DA DISPONIBILIDADE DE RECURSOS','Compreende as contas que Compreendem a execução das disponibilidades de recursos a utilizar, comprometidas e utilizadas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.1.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS','Registra o valor das disponibilidades de recursos a utilizar.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.2.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR EMPENHO','Registra o valor das disponibilidades de recursos comprometidas por ocasião do empenho e não liquidadas.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.3.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR LIQUIDAÇÃO E ENTRADAS COMPENSATÓRIAS','Compreende o valor das disponibilidades de recursos comprometidas por ocasião da liquidação e de entradas compensatórias e não pagas/devolvidas.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.3.01.00.00.00.00','COMPROMETIDA POR LIQUIDAÇÃO','Registra o valor das disponibilidades de recursos comprometidas por ocasião da liquidação. O saldo desta conta representa o valor líquido dos empenhos a pagar.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.3.02.00.00.00.00','COMPROMETIDA POR CONSIGNAÇÕES/RETENÇÕES','Registra o valor das disponibilidades de recursos comprometidas por consignação/retenção.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.3.03.00.00.00.00','COMPROMETIDA POR ENTRADAS COMPENSATÓRIAS','Registra o valor das disponibilidades de recursos comprometidas por entradas compensatórias.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.4.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS UTILIZADA','Registra o valor das disponibilidades de recursos utilizadas por meio de pagamento de despesa orçamentária, depósitos e/ou outros.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.1.5.00.00.00.00.00','DISPONIBILIDADE POR DESTINAÇÃO DE RECURSOS COMPROMETIDA POR PROGRAMAÇÃO FINANCEIRA','Registra o valor das disponibilidades de recursos comprometidas por programação financeira no órgão central de programação financeira.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.2.0.00.00.00.00.00','EXECUÇÃO FINANCEIRA DO LIMITE DE RESTOS A PAGAR','Registra as contas que Compreendem a execução financeira do limite de restos a pagar. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.1.3.0.00.00.00.00.00','EXECUÇÃO DO RECURSO DIFERIDO POR DESTINAÇÃO','Registra as contas que controlam a execução dos recursos diferidos. Recursos diferidos são as sobras de recursos financeiros ao final do exercício (recurso diferido), que deveriam ser devolvidas a conta única, porem, ao invés disso, essas sobras são liberadas para uso (apenas no exercício seguinte) através de descontos das transferências financeiras (cota, repasse e sub-repasse) do exercício seguinte.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.2.0.0.00.00.00.00.00','EXECUÇÃO DA PROGRAMAÇÃO FINANCEIRA','Registra as contas que registram a execução das cotas, repasses e sub-repasses para atender a despesas orçamentárias, restos a pagar autorizados e demais dispêndios extra orçamentários.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.3.0.0.00.00.00.00.00','EXECUÇÃO DO LIMITE ORÇAMENTÁRIO','Registra as contas que controlam a execução do limite de empenho e movimentação de créditos orçamentários, conforme estabelecidos em ato próprio dos poderes e ministério público.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.2.4.0.0.00.00.00.00.00','CONTROLES DA ARRECADAÇÃO','Registra as contas que registram os valores discriminados da arrecadação da receita orçamentária, por meio de documentos de arrecadação como DARF, GRU, DAR, entre outros.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.0.0.0.00.00.00.00.00','EXECUÇÃO DA DIVIDA ATIVA','Compreende as contas que controlam a execução dos créditos passiveis de serem encaminhados e inscritos em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.0.0.00.00.00.00.00','EXECUÇÃO DO ENCAMINHAMENTO DE CRÉDITOS PARA INSCRIÇÃO EM DIVIDA ATIVA','Compreende as contas que Compreendem os valores a serem encaminhados e os já encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.0.00.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA','Compreende os valores a serem encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.00.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA','Compreende os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.01.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - IMPOSTOS','Compreende os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária de impostos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.01.01.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - IMPOSTO SOBRE BENS E RENDAS DE QUALQUER NATUREZA','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária de impostos sobre a renda e proventos de qualquer natureza,','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.01.05.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - IPTU','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária do IPTU.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.01.06.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - ITBI','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária do ITBI.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.01.07.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - ISS','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária do ISS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.01.08.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - ITR','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária do ITR.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.1.02.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - TRIBUTÁRIA - TAXAS','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária de taxas.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.1.2.00.00.00.00.00','CRÉDITOS A ENCAMINHAR PARA A DIVIDA ATIVA - NÃO TRIBUTÁRIA','Registra os valores a serem encaminhados para o órgão competente em inscrever em divida ativa tributária não tributária.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.0.00.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Compreende os valores encaminhados para o órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.00.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA','Compreende os valores encaminhados para o órgão competente em inscrever em divida ativa tributária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.01.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - IMPOSTOS','Compreende os valores encaminhados para o órgão competente em inscrever em divida ativa tributária de impostos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.01.01.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - IMPOSTO SOBRE BENS E RENDAS DE QUALQUER NATUREZA','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa tributária de impostos sobre a renda e proventos de qualquer natureza,','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.01.05.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - IPTU','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa tributária do IPTU.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.01.06.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - ITBI','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa tributária do ITBI.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.01.07.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - ISS','Registra os valore encaminhados para o órgão competente em inscrever em divida ativa tributária do ISS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.01.08.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - ITR','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa tributária do ITR.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.1.02.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - TRIBUTÁRIA - TAXAS','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa tributária de taxas.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.2.2.00.00.00.00.00','CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA - NÃO TRIBUTÁRIA','Registra os valores encaminhados para o órgão competente em inscrever em divida ativa tributária não tributária.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.1.3.0.00.00.00.00.00','CANCELAMENTO DE CRÉDITOS ENCAMINHADOS PARA A DIVIDA ATIVA','Registra o cancelamento dos valores indevidamente encaminhados para o órgão competente em inscrever em divida ativa.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.0.0.00.00.00.00.00','EXECUÇÃO DA INSCRIÇÃO DE CRÉDITOS EM DIVIDA ATIVA','Compreende as contas que registram os valores a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.0.00.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA','Compreende os créditos a serem inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.00.00.00.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende os créditos a serem inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.01.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - IMPOSTOS','Compreende os créditos a serem inscritos em divida ativa tributária de impostos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.01.01.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - IMPOSTO SOBRE BENS E RENDAS DE QUALQUER NATUREZA','Registra os créditos a serem inscritos em divida ativa tributária de impostos sobre a renda e proventos de qualquer natureza,','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.01.05.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - IPTU','Registra os créditos a serem inscritos em divida ativa tributária do IPTU.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.01.06.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - ITBI','Registra os créditos a serem inscritos em divida ativa tributária do ITBI.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.01.07.00.00.00','CRÉDITOSA INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - ISS','Registra os créditos a serem inscritos em divida ativa tributária do ISS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.01.08.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - ITR','Registra os créditos a serem inscritos em divida ativa tributária do ITR.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.1.02.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA - TRIBUTÁRIA - TAXAS','Registra os créditos a serem inscritos em divida ativa tributária de taxas.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.1.2.00.00.00.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Registra os créditos a serem inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.2.0.00.00.00.00.00','CRÉDITOS A INSCREVER EM DIVIDA ATIVA DEVOLVIDOS','Compreende os valores a serem inscritos em divida ativa que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.2.1.00.00.00.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA TRIBUTÁRIA DEVOLVIDOS','Registra os créditos a serem inscritos em divida ativa tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.2.2.00.00.00.00.00','CRÉDITOS A INSCREVER EM DÍVIDA ATIVA NÃO TRIBUTÁRIA DEVOLVIDOS','Registra os créditos a serem inscritos em divida ativa não-tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.0.00.00.00.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA A RECEBER','Compreende os valores inscritos em divida ativa pelo o órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.00.00.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER','Compreende os créditos inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.00.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','Compreende  os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.01.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA ADMINISTRATIVA','Compreende  os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.01.01.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA ADMINISTRATIVA - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança - imposto sobre a renda e proventos de qualquer natureza.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.01.05.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA ADMINISTRATIVA - IPTU','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança - iptu.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.01.06.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA ADMINISTRATIVA - ITBI','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança - itbi.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.01.07.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA ADMINISTRATIVA - ISS','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança - iss','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.01.08.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA ADMINISTRATIVA - ITR','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança - itr.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.01.02.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE TAXAS A RECEBER EM COBRANÇA ADMINISTRATIVA','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.00.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Compreende os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.01.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Compreende  os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.01.01.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA JUDICIAL - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança - imposto sobre a renda e proventos de qualquer natureza.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.01.05.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA JUDICIAL - IPTU','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança - iptu.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.01.06.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA JUDICIAL - ITBI','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança -itbi.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.01.07.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA JUDICIAL - ISS','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança - iss.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.01.08.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS A RECEBER EM COBRANÇA JUDICIAL - ITR','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança - itr.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.1.02.02.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE TAXAS A RECEBER EM COBRANÇA JUDICIAL - TAXAS','Registra os créditos a receber, inscritos em divida ativa tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança - taxas.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.2.00.00.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER','Compreende os créditos a serem inscritos em divida ativa não-tributária que foram devolvidos pelo órgão competente, por incorreções na formalização do processo de encaminhamento.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.2.01.00.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA ADMINISTRATIVA','Registra os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase administrativa de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.3.2.02.00.00.00.00','CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA A RECEBER EM COBRANÇA JUDICIAL','Registra os créditos a receber, inscritos em divida ativa não-tributária pelo órgão competente em inscrever em divida ativa, em fase judicial de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.0.00.00.00.00.00','CRÉDITOS INSCRITOS EM DIVIDA ATIVA RECEBIDOS','Compreende os valores recebidos relativos aos créditos anteriormente inscritos em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.00.00.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.00.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária, em fase administrativa de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.01.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA ADMINISTRATIVA','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase administrativa de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.01.01.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA ADMINISTRATIVA - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase administrativa de cobrança - imposto sobre a renda e proventos de qualquer natureza.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.01.05.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA ADMINISTRATIVA - IPTU','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase administrativa de cobrança - iptu.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.01.06.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA ADMINISTRATIVA - ITBI','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase administrativa de cobrança - itbi.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.01.07.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA ADMINISTRATIVA - ISS','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase administrativa de cobrança - iss.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.01.08.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA ADMINISTRATIVA - ITR','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase administrativa de cobrança - itr.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.01.02.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE TAXAS EM COBRANÇA ADMINISTRATIVA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de taxas, em fase administrativa de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.00.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA EM COBRANÇA JUDICIAL','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária, em fase judicial de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.01.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA JUDICIAL','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase judicial de cobrança.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.01.01.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA JUDICIAL - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase judicial de cobrança - imposto sobre a renda e proventos de qualquer natureza.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.01.05.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA JUDICIAL - IPTU','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase judicial de cobrança - iptu.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.01.06.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA JUDICIAL - ITBI','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase judicial de cobrança - itbi.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.01.07.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA JUDICIAL - ISS','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase judicial de cobrança - iss.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.01.08.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE IMPOSTOS EM COBRANÇA JUDICIAL - ITR','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de impostos, em fase judicial de cobrança - itr.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.1.02.02.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA DE TAXAS EM COBRANÇA JUDICIAL','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa tributária de taxas, em fase judicial de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.2.00.00.00.00.00','RECEBIMENTOS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO-TRIBUTÁRIA','Compreende o recebimento dos valores referentes aos créditos inscritos em divida ativa não-tributária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.2.01.00.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA EM COBRANÇA ADMINISTRATIVA','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa não tributária, em fase administrativa de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.4.2.02.00.00.00.00','RECEBIMENTO DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA EM COBRANÇA JUDICIAL','Registra o recebimento dos valores referentes aos créditos inscritos em divida ativa não tributária, em fase judicial de cobrança.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.0.00.00.00.00.00','BAIXA DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA','Compreende os valores relativos às baixas de créditos inscritos em divida ativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.00.00.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA TRIBUTÁRIA','Compreende as baixas de créditos inscritos em divida ativa tributária.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.00.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA ADMINISTRATIVA','Compreende as baixas de créditos inscritos em divida ativa tributária, em cobrança administrativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.01.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA ADMINISTRATIVA','Compreende as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.01.01.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA ADMINISTRATIVA - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - imposto sobre a renda e proventos de qualquer natureza.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.01.05.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA ADMINISTRATIVA - IPTU','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - iptu.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.01.06.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA ADMINISTRATIVA - ITBI','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - itbi.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.01.07.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA ADMINISTRATIVA - ISS','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - iss.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.01.08.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA ADMINISTRATIVA - ITR','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - itr.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.01.02.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE TAXAS- COBRANÇA ADMINISTRATIVA','Registra as baixas de créditos inscritos em divida ativa tributária de taxas, em cobrança administrativa.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.00.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA - COBRANÇA JUDICIAL','Compreende as baixas de créditos inscritos em divida ativa tributária, em cobrança judicial.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.01.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA JUDICIAL','Compreende as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança judicial.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.01.01.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA JUDICIAL - IMPOSTO SOBRE A RENDA E PROVENTOS DE QUALQUER NATUREZA','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - imposto sobre a renda e proventos de qualquer natureza.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.01.05.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA JUDICIAL - IPTU','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - iptu.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.01.06.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA JUDICIAL - ITBI','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - itbi.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.01.07.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA JUDICIAL - ISS','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - iss.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.01.08.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE IMPOSTOS- COBRANÇA JUDICIAL - ITR','Registra as baixas de créditos inscritos em divida ativa tributária de impostos, em cobrança administrativa - itr.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.1.02.02.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA TRIBUTÁRIA  DE TAXAS- COBRANÇA JUDICIAL','Registra as baixas de créditos inscritos em divida ativa tributária de taxas, em cobrança administrativa.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.2.00.00.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DIVIDA ATIVA NÃO TRIBUTÁRIA','Registra as baixas de créditos inscritos em divida ativa não-tributária.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.2.01.00.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA - COBRANÇA ADMINISTRATIVA','Registra as baixas de créditos inscritos em divida ativa não tributária, em cobrança administrativa.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.3.2.5.2.02.00.00.00.00','BAIXAS DE CRÉDITOS INSCRITOS EM DÍVIDA ATIVA NÃO TRIBUTÁRIA - COBRANÇA JUDICIAL','Registra as baixas de créditos inscritos em divida ativa não tributária, em cobrança judicial.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.0.0.0.00.00.00.00.00','EXECUÇÃO DOS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.0.0.00.00.00.00.00','EXECUÇÃO DE PASSIVOS CONTINGENTES','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.0.00.00.00.00.00','PASSIVOS CONTINGENTES PREVISTOS','Compreende a previsão dos riscos fiscais classificados como passivos contingentes ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.1.00.00.00.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas  estatais dependentes;c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.2.00.00.00.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.3.00.00.00.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.4.00.00.00.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.5.00.00.00.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.1.9.00.00.00.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.0.00.00.00.00.00','PASSIVOS CONTINGENTES CONFIRMADOS','Compreende a confirmação da previsão dos riscos fiscais classificados como passivos contingentes ','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.1.00.00.00.00.00','DEMANDAS JUDICIAIS','Registra a estimativa do montante relativo a ações judiciais em andamento contra o ente federativo nas quais haja a probabilidade de que o ganho de causa venha a ser da outra parte. Ao fazer a estimativa, considerar os principais tipos de ação judicial, tais como: a) Demandas judiciais contra a atividade reguladora do Estado: Indexação e controles de preços; De ordem tributária e previdenciária; Outras demandas judiciais; b) Demandas judiciais contra empresas  estatais dependentes;c) Demandas judiciais contra a administração direta e indireta: Privatizações, liquidação ou extinção de órgãos ou empresas; Reajustes salariais; d) Demandas trabalhistas contra o ente federativo; e) Outras demandas judiciais. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.2.00.00.00.00.00','DÍVIDAS EM PROCESSO DE RECONHECIMENTO','Registra as Dívidas ainda não assumidas formalmente que apresentam probabilidade de serem incorporadas ao passivo devido, por exemplo, a decisões judiciais.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.3.00.00.00.00.00','AVAIS E GARANTIAS CONCEDIDAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo para honrar fianças e avais concedidos em operações de crédito direta ou indiretamente pelo ente federativo a favor de outros entes federativos e entidades dos setores público e privado, inclusive com recursos de fundos de aval, a assunção de risco creditício em linhas de crédito, o seguro de crédito à exportação e outras garantias de natureza semelhante que representem compromisso de adimplência de obrigação financeira ou contratual.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.4.00.00.00.00.00','ASSUNÇÃO DE PASSIVOS','Registra a estimativa do montante que apresenta probabilidade de vir a ser gasto pelo ente federativo com o objetivo de proteger o cidadão ou sistemas importantes do Mercado contra inadimplências, falências, altos prejuízos, ou garantir a credibilidade desses sistemas frente a fatores agudos adversos. Ao fazer a estimativa, considerar os principais tipos de situações que podem advir: a) de órgãos da administração direta ou indireta; b) de entidades privadas; c) de Regime Próprio de Previdência Social dos Servidores Públicos; d) de Entes da Federação; e) do Regime Geral de Previdência Social; f) do Banco Central; e g) da assunção de outros passivos.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.5.00.00.00.00.00','ASSISTÊNCIAS DIVERSAS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo com o objetivo de fazer frente a calamidades públicas e que, por não serem recorrentes, não foram planejados. Recomenda-se que o ente federativo explicite o tipo de assistência emergencial que ele está prevendo, por exemplo, se é assistência contra seca, enchentes, catástrofes, epidemias etc. ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.1.2.9.00.00.00.00.00','OUTROS PASSIVOS CONTINGENTES','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de passivos contingentes.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.0.0.00.00.00.00.00','EXECUÇÃO DOS DEMAIS RISCOS FISCAIS','Compreende as contas que controlam a execução dos riscos fiscais que não preencham os requisitos para reconhecimento como passivo, não classificados como passivos contingentes, conforme identificados no anexo de riscos fiscais da lei de diretrizes orçamentárias.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS PREVISTOS ','Compreende a previsão dos riscos fiscais não classificados como passivos contingentes','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.1.00.00.00.00.00','FRUSTRAÇÃO DE ARRECADAÇÃO','Registra a previsão dos riscos fiscais não classificados como passivos contingentes','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.2.00.00.00.00.00','RESTITUIÇÃO DE TRIBUTOS A MAIOR','Registra a previsão dos riscos fiscais não classificados como passivos contingentes','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.3.00.00.00.00.00','DISCREPÂNCIA DE PROJEÇÕES','Registra a estimativa do montante de redução no valor dos ingressos ou de aumento no valor dos desembolsos que apresentam probabilidade de vir a ocorrer no exercício, decorrentes de evolução desfavorável de  indicadoresCeconômicos empregados na época da elaboração do Orçamento, tais como: a) Taxa de crescimento econômico; b) Taxa de inflação; c) Taxa de câmbio; d) Taxa de juros; e) Salário mínimo; f) Outros indicadores.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.1.4.00.00.00.00.00','OUTROS RISCOS FISCAIS','Registra a estimativa do montante que apresenta probabilidade de vir a ser empregado pelo ente federativo para fazer frente a outros tipos de riscos fiscais.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.4.2.2.0.00.00.00.00.00','DEMAIS RISCOS FISCAIS CONFIRMADOS','Registra a confirmação da previsão dos riscos fiscais não classificados como passivos contingentes ','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.0.0.0.00.00.00.00.00','EXECUÇÃO DOS CONSÓRCIOS PÚBLICOS','Compreende as contas que controlam a execução dos consórcios públicos (do ente consorciado e/ou do próprio consórcio), incluindo os controle do contrato de rateio, controle da prestação de contas, bem como as informações que serão consolidadas no ente consorciado para fins de elaboração dos demonstrativos dos consórcios, conforme Portaria STN 72/2012.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.1.0.0.00.00.00.00.00','EXECUÇÃO DO CONTRATO DE RATEIO DE CONSÓRCIO PÚBLICO','Compreende contas relacionadas ao registro dos valores de obrigações contratuais decorrentes de Consórcios Públicos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.1.1.0.00.00.00.00.00','CONTRATO DE RATEIO - EM EXECUÇÃO','Registra os valores de obrigações contratuais em execução decorrentes de Consórcios Públicos','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.1.2.0.00.00.00.00.00','CONTRATO DE RATEIO - EXECUTADOS','Registra os valores de obrigações de obrigações contratuais executados decorrentes de Consórcios Públicos','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.2.0.0.00.00.00.00.00','EXECUÇÃO DA PRESTAÇÃO DE CONTAS DE CONSÓRCIO PÚBLICO','Compreende contas relacionadas ao registro da execução do controle da prestação de contas referentes aos valores transferidos dos Consórcios Públicos.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.2.1.0.00.00.00.00.00','A COMPROVAR','Registra os valores transferidos dos Consórcios Públicos a comprovar.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.2.2.0.00.00.00.00.00','EM INADIMPLENCIA','Registra os valores transferidos dos Consórcios Públicos em que não houve prestação de contas dentro do prazo estipulado.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.2.3.0.00.00.00.00.00','A APROVAR','Registra os valores transferidos dos Consórcios Públicos a aprovar.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.2.4.0.00.00.00.00.00','APROVADOS','Registra os valores transferidos dos Consórcios Públicos aprovados.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.2.5.0.00.00.00.00.00','IMPUGNADOS','Registra os valores transferidos dos Consórcios Públicos impugnados.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.0.0.00.00.00.00.00','CONSOLIDAÇÃO DA EXECUÇÃO DO CONSÓRCIO','Compreende as informações referentes aos Consórcios Públicos, atribuídas ao ente consorciado com base no contrato de rateio,que serão enviadas pelo consórcio para os entes consorciados para fins de elaboração dos demonstrativos fiscais ( Saúde, pessoal, educação e disponibilidade de caixa), em atendimento a Portaria STN n.º 72/2012. Conta para uso do ente consorciado.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.1.0.00.00.00.00.00','VALORES TRANSFERIDOS POR CONTRATO DE RATEIO','Registra os valores repassados pelo ente para execução das despesas nos Consórcios Públicos, com base no Contrato de Rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.0.00.00.00.00.00','DESPESAS EXECUTADAS EM CONSÓRCIOS PÚBLICOS','Registra as despesas executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.1.00.00.00.00.00','CREDITO EMPENHADO A LIQUIDAR','Registra o valor da despesa empenhada a ser liquidada executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.2.00.00.00.00.00','CREDITO EMPENHADO EM LIQUIDAÇÃO','Registra o valor da despesa cujo fato gerador já ocorreu, mas que ainda não foram conferidos o objeto, e o valor, ou seja, não houve a liquidação, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.3.00.00.00.00.00','CREDITO EMPENHADO LIQUIDADO A PAGAR','Registra o valor da apropriação das despesas empenhadas com posterior verificação de sua regularidade por constituição do direto do credor, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.00.00.00.00.00','CREDITO EMPENHADO LIQUIDADO PAGO','Compreende o valor da despesa empenhada liquidada paga, executadas em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.01.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ANTERIOR','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ANTERIOR UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.01.01.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - MAIO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE MAIO A DEZEMBRO DO EXERCICIO ANTERIOR (CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.01.02.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - JULHO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE JULHO A DEZEMBRO DO EXERCICIO ANTERIOR (CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.01.03.00.00.00','DESPESA COM PESSOAL - EXERCICIO ANTERIOR - SETEMBRO A DEZEMBRO','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO PERIODO DE SETEMBRO A DEZEMBRO DO EXERCICIO ANTERIOR (CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL','COMPREENDE A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NOS PERIODOS DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.01.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 1º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 1º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE - CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.02.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 2º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 2º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE - CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.03.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 3º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 3º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE - CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.04.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 4º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 4º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE)(CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.05.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 5º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 5º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE - CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.02.06.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM PESSOAL - EXERCICIO ATUAL - 6º BIMESTRE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM PESSOAL NO 6º BIMESTRE DO EXERCICIO ATUAL UTILIZADOS PARA CONSOLIDAÇÃO COMPONDO ASSIM A PERIODICIDADE DO RGF DE CADA ENTE CONSORCIADO (QUADRIMESTRE OU SEMESTRE - CONTAS NÃO ACUMULATIVAS)','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.03.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM ASPS','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM AÇÕES E SERVIÇOS PÚBLICOS DE SAÚDE - ASPS. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM SAUDE PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 40.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.04.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM MDE','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM MANUTENÇÃO E DESENVOLVIMENTO DO ENSINO - MDE. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO EM EDUCAÇÃO PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 20.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.05.00.00.00.00','INFORMAÇÃO DA EXECUÇÃO DO CONSORCIO PARA CONSOLIDAÇÃO - DESPESA COM FUNDEB','REGISTRA A INFORMAÇÃO ENVIADA PELO CONSORCIO REFERENTE A APLICAÇÃO DAS TRANSFERENCIAS RECEBIDAS DO ENTE CONSORCIADO PARA PAGAMENTO DE DESPESA COM O FUNDEB. ESTA CONTA DEVERÁ SER ACUMULADA NOS BIMESTRES E TRAZER APENAS A APLICAÇÃO NO FUNDEB PARA FINS DE CONSOLIDAÇÃO DO MÍNIMO CONSTITUCIONAL, OU SEJA TRANSFERÊNCIAS AO CONSÓRCIO COM RECURSO VINCULADO 31.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.06.00.00.00.00','INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PUBLICO','REGISTRA A INFORMAÇÃO DA INSUFICIÊNCIA DE CAIXA DO CONSORCIO PÚBLICO  PARA FINS DE ANALISE DO CUMPRIMENTO DO ART. 42 DA LRF, CONFORME ART. 11, § 2º DA PORTARIA STN Nº 72/2012.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.07.00.00.00.00','OPERAÇÕES DE CREDITO IRREGULARES','REGISTRA AS OPERAÇÕES DE CREDITO NÃO AUTORIZADAS POR RESOLUÇÃO DO SENADO FEDERAL,  AS VEDADAS E OUTRAS IRREGULARMENTE REALIZADAS E QUE DEVERÃO SER CONSOLIDADAS NOS DEMONSTRATIVOS DE OPERAÇÃO DE CREDITO E DIVIDA CONSOLIDADA LIQUIDA DO ENTE CONSORCIADO EM ATENDIMENTO AO ART. 18, PARÁGRAFO ÚNICO DA PORTARIA STN N° 72/2012..','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.2.4.08.00.00.00.00','INFORMAÇÃO DO ATENDIMENTO AO ART. 25 DA LC 141/2012','REGISTRA A APLICAÇÃO DIRETA EEXECUTADA PELO CONSORCIO PUBLICO À CONTA DOS RECURSOS REFERENTES À DIFERENÇA DA APLICAÇÃO MÍNIMA EM ASPS QUE DEIXOU DE SER APLICADA EM EXERCICIOS ANTERIORES. ATENDIMENTO AO ART. 25 DA LEI COMPLEMENTAR 141/2012 E PARÁGRAFO ÚNICO DO ART. 10 DA PORTARIA STN Nº 72/2012. O CONSORCIO DEVERÁ EXECUTAR ESTA DESPESA NA MODALIDADE DE APLICAÇÃO 96.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.0.00.00.00.00.00','EXECUÇÃO DE RP NÃO PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, não liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.1.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR','Registra o valor dos RP não processados ainda não liquidados, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.2.00.00.00.00.00','RP NÃO PROCESSADOS EM LIQUIDAÇÃO','Registra o valor dos RP não processados ainda não liquidados cujo fato gerador já ocorreu em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.3.00.00.00.00.00','RP NÃO PROCESSADOS LIQUIDADOS A PAGAR','Registra o valor dos RP não processados, liquidados após sua inscrição e ainda não pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.4.00.00.00.00.00','RP NÃO PROCESSADOS PAGOS','Registra o valor dos RP não processados, liquidados após sua inscrição e pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.5.00.00.00.00.00','RP NÃO PROCESSADOS A LIQUIDAR BLOQUEADOS','Registra o valor de restos a pagar não processados a liquidar, bloqueado por decreto em consórcios públicos atribuídas ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.6.00.00.00.00.00','RP NÃO PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar não processados pela desincorporação de saldos decorrentes de transformação, cisão, fusão e extinção de órgãos ou UG.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.7.00.00.00.00.00','RP NÃO PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar não processados, a ser transferido no exercício seguinte para a conta 631100000 e 631200000, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.3.8.00.00.00.00.00','RP NÃO PROCESSADOS CANCELADOS','Registra o cancelamento de restos a pagar não processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.4.0.00.00.00.00.00','EXECUÇÃO DE RP PROCESSADOS EM CONSÓRCIOS PÚBLICOS','Compreende o somatório dos valores relativos à transferência, liquidação e pagamento das despesas empenhadas, liquidadas no exercício financeiro de sua inscrição e não pagas, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.4.1.00.00.00.00.00','RP PROCESSADOS A PAGAR','Registra o valor dos RP processados e não pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','s','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.4.2.00.00.00.00.00','RP PROCESSADOS PAGOS','Registra o valor dos RP processados pagos em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.4.3.00.00.00.00.00','RP PROCESSADOS TRANSFERIDOS','Registra o valor da transferência de restos a pagar pela desincorporação de saldos decorrente de transformação, cisão, fusão e extinção de órgãos ou UG em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.4.4.00.00.00.00.00','RP PROCESSADOS - INSCRIÇÃO NO EXERCÍCIO','Registra o valor das despesas empenhadas inscritas no exercício como restos a pagar processados, a ser transferido no exercício seguinte para a conta 632100000, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.4.5.00.00.00.00.00','RP PROCESSADOS CANCELADOS','Registra o cancelamento de restos a pagar processados por insuficiência de recursos, pela inscrição indevida ou para atender dispositivo legal, em consórcios públicos atribuídos ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.5.3.5.0.00.00.00.00.00','INSUFICIÊNCIA DE CAIXA DO CONSÓRCIO PÚBLICO','Registra a parcela total da insuficiência de caixa gerada no consórcio público atribuída ao ente consorciado com base no contrato de rateio.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.8.0.0.0.00.00.00.00.00','APURAÇÃO DE CUSTOS','Registra as contas que controlam a execução dos custos dos bens e serviços produzidos.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.0.0.0.00.00.00.00.00','OUTROS CONTROLES','Compreende as contas de controles da execução não especificados anteriormente nos grupos dessa classe.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.0.0.00.00.00.00.00','EXECUÇÃO DE RESPONSABILIDADE POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DAS RESPONSABILIDADES POR VALORES, TITULOS E BENS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.1.0.00.00.00.00.00','EXECUÇÃO DE RESPONSABILIDADE COM TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE AS CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DA ADMINISTRACAO PUBLICA COM TERCEIROS POR TITULOS, VALORES E BENS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.1.1.00.00.00.00.00','DEPÓSITOS JUDICIAIS','REGISTRA OS DEPOSITOS JUDICIAIS EFETUADOS POR TERCEIROS EM TITULOS, EM CONTA VINCULADA ETC, SOB A RESPONSABILIDADE DA UNIDADE, OU DEPOSITADOS POR ESTA PARA TERCEIROS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.1.2.00.00.00.00.00','DEPÓSITOS COMPULSÓRIOS','REGISTRA O SOMATÓRIO DOS VALORES DOS DEPÓSITOS COMPULSÓRIOS REALIZADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.1.3.00.00.00.00.00','OUTRAS RESPONSABILIDADES COM TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NÃO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.0.00.00.00.00.00','EXECUÇÃO DE RESPONSABILIDADE DE TERCEIROS POR VALORES, TÍTULOS E BENS','COMPREENDE CONTAS RELACIONADAS AO REGISTRO DA RESPONSABILIDADE DE TERCEIROS COM A ADMINISTRACAO PUBLICA POR TITULOS, VALORES E BENS.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.00.00.00.00.00','EXECUÇÃO DE ADIANTAMENTOS/SUPRIMENTOS DE FUNDOS CONCEDIDOS','COMPREENDE OS VALORES CONCEDIDOS A SERVIDOR RESPONSAVEL PARA ATENDER DESPESAS QUE NAO POSSAM SUBORDINAR-SE AO PROCESSO NORMAL DE APLICACAO,ATE A SUA PRESTACAO DE CONTAS','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.01.00.00.00.00','ADIANTAMENTOS CONCEDIDOS A COMPROVAR','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS PENDENTES DE COMPROVACAO','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.02.00.00.00.00','ADIANTAMENTOS A APROVAR','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS COMPROVADOS PENDENTES DE APROVACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.03.00.00.00.00','ADIANTAMENTOS APROVADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS APROVADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.04.00.00.00.00','ADIANTAMENTOS IMPUGNADOS','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS IMPUGNADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.05.00.00.00.00','ADIANTAMENTOS EM INDADIMPLENCIA','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS EM INADIMPLÊNCIA.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.1.06.00.00.00.00','ADIANTAMENTOS CANCELADOS ','REGISTRA OS VALORES DOS ADIANTAMENTOS CONCEDIDOS CANCELADOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.2.00.00.00.00.00','EXECUÇÃO DE ATIVOS DE PPP CONTABILIZADOS NA SPE','Registra o valor dos ativos produzidos por meio de Parcerias Público Privadas contabilizados na Sociedade de Propósito Específico.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.1.2.9.00.00.00.00.00','EXECUÇÃO DE OUTRAS RESPONSABILIDADES DE TERCEIROS','REGISTRA RESPONSABILIDADES COM TERCEIROS, NÃO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.0.0.00.00.00.00.00','DIVERSOS RESPONSÁVEIS EM APURAÇÃO','COMPREENDE AS RESPONSABILIDADES EM FASE DE APURACAO DECORRENTES DE ATOSPRATICADOS POR GESTORES, SERVIDORES OU TERCEIROS QUE POSSAM RESULTAREM PREJUIZOS PARA A FAZENDA NACIONAL.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.1.0.00.00.00.00.00','PAGAMENTOS INDEVIDOS','REGISTRA AS RESPONSABILIDADES EM APURACAO DE GESTORES E OUTROS RESPON-SAVEIS E CO-RESPONSAVEIS POR PAGAMENTOS EFETUADOS INDEVIDAMENTE, IN-CLUSIVE EM CASOS DE SUPERFATURAMENTO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.2.0.00.00.00.00.00','SALDOS NÃO RECOLHIDOS','REGISTRA OS SALDOS DOS VALORES ENTREGUES A FUNCIONARIOS OU SERVIDORES,NAO RECOLHIDOS DENTRO DOS PRAZOS ESTABELECIDOS EM NORMAS LEGAIS OU AD-MINISTRATIVAS CUJOS PROCESSOS ESTEJAM EM FASE DE APURACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.3.0.00.00.00.00.00','DESFALQUES OU DESVIOS','REGISTRA OS DESFALQUES OU DESVIOS DE BENS E VALORES DA UNIAO OU DE EN-TIDADES PUBLICAS, EM APURACAO,DECORRENTES DE PROCESSOS POR ACOES ADMI-NINISTRATIVAS, POLICIAIS OU JUDICIAIS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.4.0.00.00.00.00.00','DÉBITOS DE TERCEIROS EM PRESTAÇÃO DE SERVIÇOS','REGISTRA OS VALORES RELATIVOS AS RESPONSABILIDADES POR IRREGULARIDADESEM PRESTACAO DE SERVICOS POR TERCEIROS, CUJOS PROCESSOS ESTEJAM EM FA-SE DE APURACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.5.0.00.00.00.00.00','RESPONSÁVEIS POR DANOS OU PERDAS','REGISTRA AO REGISTRO DAS RESPONSABILIDADES EM INQUERITOS ADMINISTRA-TIVOS OU POLICIAIS CONTRA SERVIDORES OU TERCEIROS, POR DANOS E PERDASCAUSADOS A FAZENDA NACIONAL, E QUE ESTEJAM EM FASE DE APURACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.6.0.00.00.00.00.00','PAGAMENTOS SEM RESPALDO ORÇAMENTÁRIO','REGISTRA AS DESPESAS REALIZADAS SEM EXISTENCIA DE CREDITO QUE AS COM-PORTE, RESULTANDO EM PAGAMENTO SEM PREVIO EMPENHO OU AINDA COM CLASSI-FICACAO IMPROPRIA (DIFERENTE DAQUELA PREVISTA NO ORCAMENTO), EM FASE DE APURACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.7.0.00.00.00.00.00','CRÉDITOS ANTECIPADOS','REGISTRA OS VALORES PAGOS SOBRE DOTACOES DECORRENTES DE CREDITOS ANTE-CIPADOS NAO REALIZADOS ATE O FECHAMENTO DO EXERCICIO, EM FASE DE APURACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.8.0.00.00.00.00.00','FALTA OU IRREGULARIDADE DE COMPROVAÇÃO','REGISTRA OS VALORES CORRESPOND.A FALTA DE DOCUMENTACAO COMPROBAT.DA E-XECUCAO DA DESPESA, INCLUSIVE AS APRESENT.FORA DO PRAZOLEGAL, BEM CO-MO A INADIMPLENCIA NA COMPROV.DE INSTRUMENT.DE TRANSFER.OU AINDA IRRE-GULARID. NA DOCUMENT., EM FASE DE APURACAO','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.0.00.00.00.00.00','OUTRAS RESPONSABILIDADES EM APURAÇÃO','COMPREENDE OUTRAS RESPONSABILIDADES EM APURAÇÃO.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.00.00.00.00.00','MULTAS E JUROS','COMPREENDE OS VALORES REFERENTES A MULTAS E JUROS PAGOS PELO ORGAO, PO-REM DE RESPONSABILIDADE DE SERVIDORES E QUE ESTEJAM EM FASE DE APURA-CAO.','C','N','','');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.01.00.00.00.00','FALTA DE LICITAÇÃO','REGISTRA OS VALORES RELATIVOS A BENS E SERVICOS ADQUIRIDOS SEM A NE-CESSARIA LICITACAO, INFRINGINDO A LEGISLACAO ESPECIFICA, EM PROCESSOSMOTIVADOS, POR DETERMINACOES ADMINISTRATIVAS E OU INQUERITOS, EM FASEDE APURACAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.02.00.00.00.00','FALTA DE RECOLHIMENTO DE OBRIGAÇÕES PECUNIÁRIAS','REGISTRA OS VALORES CORRESPONDENTES A FALTA DE RECOLHIMENTO OU PAGA-MENTO DE OBRIGACOES PECUNIARIAS, TAIS COMO: PARTE DO EMPREGADOR DEOBRIG. PATRONAIS, VALORES DESCONTADOS DE TERCEIROS E NAO RECOLHIDOS,NAO PAGAMENTO DE OBRIGAC. PARA COM A UNIAO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.04.00.00.00.00','DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMOVEL','REGISTRA OS DÉBITOS ORIUNDOS DE USO OU ALUGUEL DE IMÓVEIS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.05.00.00.00.00','ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','REGISTRA OS ADIANTAMENTOS CONCEDIDOS IRREGULARMENTE','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.06.00.00.00.00','FRAUDES EM BENEFÍCIOS','REGISTRA OS VALORES EM APURAÇÃO DE FRAUDES EM BENEFÍCIOS.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.2.9.1.09.00.00.00.00','DEMAIS RESPONSABILIDADES EM APURAÇÃO','REGISTRA RESPONSABILIDADES EM APURACAO NAO INDIVIDUALIZADAS NAS OUTRAS CONTAS DESSE GRUPO.','C','S','C','N');
INSERT INTO contabilidade.plano_conta_estrutura (cod_uf, cod_plano, codigo_estrutural, titulo, funcao, natureza_saldo, escrituracao, natureza_informacao, indicador_superavit) VALUES (23, COALESCE((SELECT MAX(cod_plano) FROM contabilidade.plano_conta_geral WHERE cod_uf = 23), 1), '8.9.9.9.0.00.00.00.00.00','DEMAIS CONTROLES ','Registra as contas referentes aos demais controles não especificados nos titulos deste subgrupo.','C','S','C','N');

----------------
-- Ticket #20364
----------------

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2899
  , 61
  , 'FLAberturaRestosAPagar.php'
  , 'incluir'
  , 9
  , ''
  , 'Abertura Restos a Pagar'
  , TRUE
  );

INSERT
  INTO administracao.acao
  ( cod_acao
  , cod_funcionalidade
  , nom_arquivo
  , parametro
  , ordem
  , complemento_acao
  , nom_acao
  , ativo
  )
  VALUES
  ( 2900
  , 56
  , 'FMConfigurarContaContabilRestosAPagarNP.php'
  , 'incluir'
  , 15
  , ''
  , 'Configurar Conta Contábil Restos a Pagar NP'
  , TRUE
  );


CREATE TABLE contabilidade.conta_contabil_rp_np(
    cod_conta       INTEGER   NOT NULL,
    exercicio       CHAR(4)   NOT NULL,
    cod_entidade    INTEGER   NOT NULL,
    CONSTRAINT pk_conta_contabil_rp_np    PRIMARY KEY                          (cod_conta, exercicio),
    CONSTRAINT fk_conta_contabil_rp_np_1  FOREIGN KEY                          (cod_conta, exercicio)
                                          REFERENCES contabilidade.plano_conta (cod_conta, exercicio),
    CONSTRAINT fk_conta_contabil_rp_np_2  FOREIGN KEY                          (cod_entidade, exercicio)
                                          REFERENCES orcamento.entidade        (cod_entidade, exercicio)
);
GRANT ALL ON contabilidade.conta_contabil_rp_np TO urbem;


